/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/extpath","vs/base/common/map","vs/base/common/uuid","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],oe=function(Q){for(var e=[],n=0,R=Q.length;n<R;n++)e[n]=se[Q[n]];return e};define(se[136],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=n,e.findLastIdx=R,e.findLastMonotonous=I,e.findLastIdxMonotonous=A,e.findFirstMonotonous=k,e.findFirstIdxMonotonousOrArrLen=P,e.findFirstIdxMonotonous=h,e.findFirstMax=f,e.findLastMax=S,e.findFirstMin=b,e.findMaxIdx=g,e.mapFindFirst=d;function n(y,w){const m=R(y,w);if(m!==-1)return y[m]}function R(y,w,m=y.length-1){for(let c=m;c>=0;c--){const v=y[c];if(w(v))return c}return-1}function I(y,w){const m=A(y,w);return m===-1?void 0:y[m]}function A(y,w,m=0,c=y.length){let v=m,E=c;for(;v<E;){const a=Math.floor((v+E)/2);w(y[a])?v=a+1:E=a}return v-1}function k(y,w){const m=P(y,w);return m===y.length?void 0:y[m]}function P(y,w,m=0,c=y.length){let v=m,E=c;for(;v<E;){const a=Math.floor((v+E)/2);w(y[a])?E=a:v=a+1}return v}function h(y,w,m=0,c=y.length){const v=P(y,w,m,c);return v===y.length?-1:v}class l{static{this.assertInvariants=!1}constructor(w){this._array=w,this._findLastMonotonousLastIdx=0}findLastMonotonous(w){if(l.assertInvariants){if(this._prevFindLastPredicate){for(const c of this._array)if(this._prevFindLastPredicate(c)&&!w(c))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=w}const m=A(this._array,w,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=m+1,m===-1?void 0:this._array[m]}}e.MonotonousArray=l;function f(y,w){if(y.length===0)return;let m=y[0];for(let c=1;c<y.length;c++){const v=y[c];w(v,m)>0&&(m=v)}return m}function S(y,w){if(y.length===0)return;let m=y[0];for(let c=1;c<y.length;c++){const v=y[c];w(v,m)>=0&&(m=v)}return m}function b(y,w){return f(y,(m,c)=>-w(m,c))}function g(y,w){if(y.length===0)return-1;let m=0;for(let c=1;c<y.length;c++){const v=y[c];w(v,y[m])>0&&(m=c)}return m}function d(y,w){for(const m of y){const c=w(m);if(c!==void 0)return c}}}),define(se[137],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.groupBy=n,e.diffSets=R,e.diffMaps=I,e.intersection=A;function n(k,P){const h=Object.create(null);for(const l of k){const f=P(l);let S=h[f];S||(S=h[f]=[]),S.push(l)}return h}function R(k,P){const h=[],l=[];for(const f of k)P.has(f)||h.push(f);for(const f of P)k.has(f)||l.push(f);return{removed:h,added:l}}function I(k,P){const h=[],l=[];for(const[f,S]of k)P.has(f)||h.push(S);for(const[f,S]of P)k.has(f)||l.push(S);return{removed:h,added:l}}function A(k,P){const h=new Set;for(const l of P)k.has(l)&&h.add(l);return h}}),define(se[138],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function n(P,h){const l=Math.pow(10,h);return Math.round(P*l)/l}class R{constructor(h,l,f,S=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,f))|0,this.a=n(Math.max(Math.min(1,S),0),3)}static equals(h,l){return h.r===l.r&&h.g===l.g&&h.b===l.b&&h.a===l.a}}e.RGBA=R;class I{constructor(h,l,f,S){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=n(Math.max(Math.min(1,l),0),3),this.l=n(Math.max(Math.min(1,f),0),3),this.a=n(Math.max(Math.min(1,S),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.l===l.l&&h.a===l.a}static fromRGBA(h){const l=h.r/255,f=h.g/255,S=h.b/255,b=h.a,g=Math.max(l,f,S),d=Math.min(l,f,S);let y=0,w=0;const m=(d+g)/2,c=g-d;if(c>0){switch(w=Math.min(m<=.5?c/(2*m):c/(2-2*m),1),g){case l:y=(f-S)/c+(f<S?6:0);break;case f:y=(S-l)/c+2;break;case S:y=(l-f)/c+4;break}y*=60,y=Math.round(y)}return new I(y,w,m,b)}static _hue2rgb(h,l,f){return f<0&&(f+=1),f>1&&(f-=1),f<1/6?h+(l-h)*6*f:f<1/2?l:f<2/3?h+(l-h)*(2/3-f)*6:h}static toRGBA(h){const l=h.h/360,{s:f,l:S,a:b}=h;let g,d,y;if(f===0)g=d=y=S;else{const w=S<.5?S*(1+f):S+f-S*f,m=2*S-w;g=I._hue2rgb(m,w,l+1/3),d=I._hue2rgb(m,w,l),y=I._hue2rgb(m,w,l-1/3)}return new R(Math.round(g*255),Math.round(d*255),Math.round(y*255),b)}}e.HSLA=I;class A{constructor(h,l,f,S){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=n(Math.max(Math.min(1,l),0),3),this.v=n(Math.max(Math.min(1,f),0),3),this.a=n(Math.max(Math.min(1,S),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.v===l.v&&h.a===l.a}static fromRGBA(h){const l=h.r/255,f=h.g/255,S=h.b/255,b=Math.max(l,f,S),g=Math.min(l,f,S),d=b-g,y=b===0?0:d/b;let w;return d===0?w=0:b===l?w=((f-S)/d%6+6)%6:b===f?w=(S-l)/d+2:w=(l-f)/d+4,new A(Math.round(w*60),y,b,h.a)}static toRGBA(h){const{h:l,s:f,v:S,a:b}=h,g=S*f,d=g*(1-Math.abs(l/60%2-1)),y=S-g;let[w,m,c]=[0,0,0];return l<60?(w=g,m=d):l<120?(w=d,m=g):l<180?(m=g,c=d):l<240?(m=d,c=g):l<300?(w=d,c=g):l<=360&&(w=g,c=d),w=Math.round((w+y)*255),m=Math.round((m+y)*255),c=Math.round((c+y)*255),new R(w,m,c,b)}}e.HSVA=A;class k{static fromHex(h){return k.Format.CSS.parseHex(h)||k.red}static equals(h,l){return!h&&!l?!0:!h||!l?!1:h.equals(l)}get hsla(){return this._hsla?this._hsla:I.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:A.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof R)this.rgba=h;else if(h instanceof I)this._hsla=h,this.rgba=I.toRGBA(h);else if(h instanceof A)this._hsva=h,this.rgba=A.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&R.equals(this.rgba,h.rgba)&&I.equals(this.hsla,h.hsla)&&A.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=k._relativeLuminanceForComponent(this.rgba.r),l=k._relativeLuminanceForComponent(this.rgba.g),f=k._relativeLuminanceForComponent(this.rgba.b),S=.2126*h+.7152*l+.0722*f;return n(S,4)}static _relativeLuminanceForComponent(h){const l=h/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(h){const l=this.getRelativeLuminance(),f=h.getRelativeLuminance();return l>f?(l+.05)/(f+.05):(f+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const l=this.getRelativeLuminance(),f=h.getRelativeLuminance();return l>f}isDarkerThan(h){const l=this.getRelativeLuminance(),f=h.getRelativeLuminance();return l<f}lighten(h){return new k(new I(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new k(new I(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:l,g:f,b:S,a:b}=this.rgba;return new k(new R(l,f,S,b*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new k(new R(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const l=h.rgba,f=this.rgba.a,S=l.a,b=f+S*(1-f);if(b<1e-6)return k.transparent;const g=this.rgba.r*f/b+l.r*S*(1-f)/b,d=this.rgba.g*f/b+l.g*S*(1-f)/b,y=this.rgba.b*f/b+l.b*S*(1-f)/b;return new k(new R(g,d,y,b))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:l,g:f,b:S,a:b}=this.rgba;return new k(new R(h.rgba.r-b*(h.rgba.r-l),h.rgba.g-b*(h.rgba.g-f),h.rgba.b-b*(h.rgba.b-S),1))}flatten(...h){const l=h.reduceRight((f,S)=>k._flatten(S,f));return k._flatten(this,l)}static _flatten(h,l){const f=1-h.rgba.a;return new k(new R(f*l.rgba.r+h.rgba.a*h.rgba.r,f*l.rgba.g+h.rgba.a*h.rgba.g,f*l.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this._toString||(this._toString=k.Format.CSS.format(this)),this._toString}static getLighterColor(h,l,f){if(h.isLighterThan(l))return h;f=f||.5;const S=h.getRelativeLuminance(),b=l.getRelativeLuminance();return f=f*(b-S)/b,h.lighten(f)}static getDarkerColor(h,l,f){if(h.isDarkerThan(l))return h;f=f||.5;const S=h.getRelativeLuminance(),b=l.getRelativeLuminance();return f=f*(S-b)/S,h.darken(f)}static{this.white=new k(new R(255,255,255,1))}static{this.black=new k(new R(0,0,0,1))}static{this.red=new k(new R(255,0,0,1))}static{this.blue=new k(new R(0,0,255,1))}static{this.green=new k(new R(0,255,0,1))}static{this.cyan=new k(new R(0,255,255,1))}static{this.lightgrey=new k(new R(211,211,211,1))}static{this.transparent=new k(new R(0,0,0,0))}}e.Color=k,function(P){let h;(function(l){let f;(function(S){function b(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:P.Format.CSS.formatRGBA(t)}S.formatRGB=b;function g(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}S.formatRGBA=g;function d(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(t)}S.formatHSL=d;function y(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}S.formatHSLA=y;function w(t){const s=t.toString(16);return s.length!==2?"0"+s:s}function m(t){return`#${w(t.rgba.r)}${w(t.rgba.g)}${w(t.rgba.b)}`}S.formatHex=m;function c(t,s=!1){return s&&t.rgba.a===1?P.Format.CSS.formatHex(t):`#${w(t.rgba.r)}${w(t.rgba.g)}${w(t.rgba.b)}${w(Math.round(t.rgba.a*255))}`}S.formatHexA=c;function v(t){return t.isOpaque()?P.Format.CSS.formatHex(t):P.Format.CSS.formatRGBA(t)}S.format=v;function E(t){const s=t.length;if(s===0||t.charCodeAt(0)!==35)return null;if(s===7){const r=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),o=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new P(new R(r,i,o,1))}if(s===9){const r=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),o=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),u=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new P(new R(r,i,o,u/255))}if(s===4){const r=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),o=a(t.charCodeAt(3));return new P(new R(16*r+r,16*i+i,16*o+o))}if(s===5){const r=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),o=a(t.charCodeAt(3)),u=a(t.charCodeAt(4));return new P(new R(16*r+r,16*i+i,16*o+o,(16*u+u)/255))}return null}S.parseHex=E;function a(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(f=l.CSS||(l.CSS={}))})(h=P.Format||(P.Format={}))}(k||(e.Color=k={}))}),define(se[51],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=R,e.debounce=I,e.throttle=A;function n(k){return(P,h,l)=>{let f=null,S=null;if(typeof l.value=="function"?(f="value",S=l.value):typeof l.get=="function"&&(f="get",S=l.get),!S)throw new Error("not supported");l[f]=k(S,h)}}function R(k,P,h){let l=null,f=null;if(typeof h.value=="function"?(l="value",f=h.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(l="get",f=h.get),!f)throw new Error("not supported");const S=`$memoize$${P}`;h[l]=function(...b){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,b)}),this[S]}}function I(k,P,h){return n((l,f)=>{const S=`$debounce$${f}`,b=`$debounce$result$${f}`;return function(...g){this[b]||(this[b]=h?h():void 0),clearTimeout(this[S]),P&&(this[b]=P(this[b],...g),g=[this[b]]),this[S]=setTimeout(()=>{l.apply(this,g),this[b]=h?h():void 0},k)}})}function A(k,P,h){return n((l,f)=>{const S=`$throttle$timer$${f}`,b=`$throttle$result$${f}`,g=`$throttle$lastRun$${f}`,d=`$throttle$pending$${f}`;return function(...y){if(this[b]||(this[b]=h?h():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),P&&(this[b]=P(this[b],...y)),this[d])return;const w=this[g]+k;w<=Date.now()?(this[g]=Date.now(),l.apply(this,[this[b]]),this[b]=h?h():void 0):(this[d]=!0,this[S]=setTimeout(()=>{this[d]=!1,this[g]=Date.now(),l.apply(this,[this[b]]),this[b]=h?h():void 0},w-Date.now()))}})}}),define(se[15],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=R,e.isSigPipeError=I,e.onUnexpectedError=A,e.onUnexpectedExternalError=k,e.transformErrorForSerialization=P,e.isCancellationError=l,e.canceled=S,e.illegalArgument=b,e.illegalState=g,e.getErrorMessage=y;class n{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?v.isErrorNoTelemetry(t)?new v(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=n,e.errorHandler=new n;function R(a){e.errorHandler.setUnexpectedErrorHandler(a)}function I(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function A(a){l(a)||e.errorHandler.onUnexpectedError(a)}function k(a){l(a)||e.errorHandler.onUnexpectedExternalError(a)}function P(a){if(a instanceof Error){const{name:t,message:s}=a,r=a.stacktrace||a.stack;return{$isError:!0,name:t,message:s,stack:r,noTelemetry:v.isErrorNoTelemetry(a)}}return a}const h="Canceled";function l(a){return a instanceof f?!0:a instanceof Error&&a.name===h&&a.message===h}class f extends Error{constructor(){super(h),this.name=this.message}}e.CancellationError=f;function S(){const a=new Error(h);return a.name=a.message,a}function b(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}function g(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}class d extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=d;function y(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}class w extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=w;class m extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=m;class c extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=c;class v extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof v)return t;const s=new v;return s.message=t.message,s.stack=t.stack,s}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=v;class E extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.BugIndicatingError=E}),define(se[22],oe([0,1,15,136]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=I,e.tail2=A,e.equals=k,e.removeFastWithoutKeepingOrder=P,e.binarySearch=h,e.binarySearch2=l,e.quickSelect=f,e.groupBy=S,e.groupAdjacentBy=b,e.forEachAdjacent=g,e.forEachWithNeighbors=d,e.sortedDiff=y,e.delta=w,e.top=m,e.topAsync=c,e.coalesce=E,e.coalesceInPlace=a,e.move=t,e.isFalsyOrEmpty=s,e.isNonEmptyArray=r,e.distinct=i,e.uniqueFilter=o,e.firstOrDefault=u,e.lastOrDefault=p,e.commonPrefixLength=C,e.flatten=M,e.range=D,e.index=W,e.insert=O,e.remove=_,e.arrayInsert=F,e.shuffle=x,e.pushToStart=z,e.pushToEnd=ue,e.pushMany=ee,e.mapArrayOrNot=le,e.asArray=Y,e.getRandomElement=G,e.insertInto=B,e.splice=T,e.compareBy=ae,e.tieBreakComparators=V,e.reverseOrder=L;function I(K,H=0){return K[K.length-(1+H)]}function A(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}function k(K,H,j=(q,re)=>q===re){if(K===H)return!0;if(!K||!H||K.length!==H.length)return!1;for(let q=0,re=K.length;q<re;q++)if(!j(K[q],H[q]))return!1;return!0}function P(K,H){const j=K.length-1;H<j&&(K[H]=K[j]),K.pop()}function h(K,H,j){return l(K.length,q=>j(K[q],H))}function l(K,H){let j=0,q=K-1;for(;j<=q;){const re=(j+q)/2|0,he=H(re);if(he<0)j=re+1;else if(he>0)q=re-1;else return re}return-(j+1)}function f(K,H,j){if(K=K|0,K>=H.length)throw new TypeError("invalid index");const q=H[Math.floor(H.length*Math.random())],re=[],he=[],me=[];for(const pe of H){const ye=j(pe,q);ye<0?re.push(pe):ye>0?he.push(pe):me.push(pe)}return K<re.length?f(K,re,j):K<re.length+me.length?me[0]:f(K-(re.length+me.length),he,j)}function S(K,H){const j=[];let q;for(const re of K.slice(0).sort(H))!q||H(q[0],re)!==0?(q=[re],j.push(q)):q.push(re);return j}function*b(K,H){let j,q;for(const re of K)q!==void 0&&H(q,re)?j.push(re):(j&&(yield j),j=[re]),q=re;j&&(yield j)}function g(K,H){for(let j=0;j<=K.length;j++)H(j===0?void 0:K[j-1],j===K.length?void 0:K[j])}function d(K,H){for(let j=0;j<K.length;j++)H(j===0?void 0:K[j-1],K[j],j+1===K.length?void 0:K[j+1])}function y(K,H,j){const q=[];function re(pe,ye,Ee){if(ye===0&&Ee.length===0)return;const Pe=q[q.length-1];Pe&&Pe.start+Pe.deleteCount===pe?(Pe.deleteCount+=ye,Pe.toInsert.push(...Ee)):q.push({start:pe,deleteCount:ye,toInsert:Ee})}let he=0,me=0;for(;;){if(he===K.length){re(he,0,H.slice(me));break}if(me===H.length){re(he,K.length-he,[]);break}const pe=K[he],ye=H[me],Ee=j(pe,ye);Ee===0?(he+=1,me+=1):Ee<0?(re(he,1,[]),he+=1):Ee>0&&(re(he,0,[ye]),me+=1)}return q}function w(K,H,j){const q=y(K,H,j),re=[],he=[];for(const me of q)re.push(...K.slice(me.start,me.start+me.deleteCount)),he.push(...me.toInsert);return{removed:re,added:he}}function m(K,H,j){if(j===0)return[];const q=K.slice(0,j).sort(H);return v(K,H,q,j,K.length),q}function c(K,H,j,q,re){return j===0?Promise.resolve([]):new Promise((he,me)=>{(async()=>{const pe=K.length,ye=K.slice(0,j).sort(H);for(let Ee=j,Pe=Math.min(j+q,pe);Ee<pe;Ee=Pe,Pe=Math.min(Pe+q,pe)){if(Ee>j&&await new Promise(We=>setTimeout(We)),re&&re.isCancellationRequested)throw new n.CancellationError;v(K,H,ye,Ee,Pe)}return ye})().then(he,me)})}function v(K,H,j,q,re){for(const he=j.length;q<re;q++){const me=K[q];if(H(me,j[he-1])<0){j.pop();const pe=(0,R.findFirstIdxMonotonousOrArrLen)(j,ye=>H(me,ye)<0);j.splice(pe,0,me)}}}function E(K){return K.filter(H=>!!H)}function a(K){let H=0;for(let j=0;j<K.length;j++)K[j]&&(K[H]=K[j],H+=1);K.length=H}function t(K,H,j){K.splice(j,0,K.splice(H,1)[0])}function s(K){return!Array.isArray(K)||K.length===0}function r(K){return Array.isArray(K)&&K.length>0}function i(K,H=j=>j){const j=new Set;return K.filter(q=>{const re=H(q);return j.has(re)?!1:(j.add(re),!0)})}function o(K){const H=new Set;return j=>{const q=K(j);return H.has(q)?!1:(H.add(q),!0)}}function u(K,H){return K.length>0?K[0]:H}function p(K,H){return K.length>0?K[K.length-1]:H}function C(K,H,j=(q,re)=>q===re){let q=0;for(let re=0,he=Math.min(K.length,H.length);re<he&&j(K[re],H[re]);re++)q++;return q}function M(K){return[].concat(...K)}function D(K,H){let j=typeof H=="number"?K:0;typeof H=="number"?j=K:(j=0,H=K);const q=[];if(j<=H)for(let re=j;re<H;re++)q.push(re);else for(let re=j;re>H;re--)q.push(re);return q}function W(K,H,j){return K.reduce((q,re)=>(q[H(re)]=j?j(re):re,q),Object.create(null))}function O(K,H){return K.push(H),()=>_(K,H)}function _(K,H){const j=K.indexOf(H);if(j>-1)return K.splice(j,1),H}function F(K,H,j){const q=K.slice(0,H),re=K.slice(H);return q.concat(j,re)}function x(K,H){let j;if(typeof H=="number"){let q=H;j=()=>{const re=Math.sin(q++)*179426549;return re-Math.floor(re)}}else j=Math.random;for(let q=K.length-1;q>0;q-=1){const re=Math.floor(j()*(q+1)),he=K[q];K[q]=K[re],K[re]=he}}function z(K,H){const j=K.indexOf(H);j>-1&&(K.splice(j,1),K.unshift(H))}function ue(K,H){const j=K.indexOf(H);j>-1&&(K.splice(j,1),K.push(H))}function ee(K,H){for(const j of H)K.push(j)}function le(K,H){return Array.isArray(K)?K.map(H):H(K)}function Y(K){return Array.isArray(K)?K:[K]}function G(K){return K[Math.floor(Math.random()*K.length)]}function B(K,H,j){const q=U(K,H),re=K.length,he=j.length;K.length=re+he;for(let me=re-1;me>=q;me--)K[me+he]=K[me];for(let me=0;me<he;me++)K[me+q]=j[me]}function T(K,H,j,q){const re=U(K,H);let he=K.splice(re,j);return he===void 0&&(he=[]),B(K,re,q),he}function U(K,H){return H<0?Math.max(H+K.length,0):Math.min(H,K.length)}var $;(function(K){function H(he){return he<0}K.isLessThan=H;function j(he){return he<=0}K.isLessThanOrEqual=j;function q(he){return he>0}K.isGreaterThan=q;function re(he){return he===0}K.isNeitherLessOrGreaterThan=re,K.greaterThan=1,K.lessThan=-1,K.neitherLessOrGreaterThan=0})($||(e.CompareResult=$={}));function ae(K,H){return(j,q)=>H(K(j),K(q))}function V(...K){return(H,j)=>{for(const q of K){const re=q(H,j);if(!$.isNeitherLessOrGreaterThan(re))return re}return $.neitherLessOrGreaterThan}}const ce=(K,H)=>K-H;e.numberComparator=ce;const X=(K,H)=>(0,e.numberComparator)(K?1:0,H?1:0);e.booleanComparator=X;function L(K){return(H,j)=>-K(H,j)}class N{constructor(H){this.items=H,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(H){let j=this.firstIdx;for(;j<this.items.length&&H(this.items[j]);)j++;const q=j===this.firstIdx?null:this.items.slice(this.firstIdx,j);return this.firstIdx=j,q}takeFromEndWhile(H){let j=this.lastIdx;for(;j>=0&&H(this.items[j]);)j--;const q=j===this.lastIdx?null:this.items.slice(j+1,this.lastIdx+1);return this.lastIdx=j,q}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const H=this.items[this.firstIdx];return this.firstIdx++,H}removeLast(){const H=this.items[this.lastIdx];return this.lastIdx--,H}takeCount(H){const j=this.items.slice(this.firstIdx,this.firstIdx+H);return this.firstIdx+=H,j}}e.ArrayQueue=N;class Z{static{this.empty=new Z(H=>{})}constructor(H){this.iterate=H}forEach(H){this.iterate(j=>(H(j),!0))}toArray(){const H=[];return this.iterate(j=>(H.push(j),!0)),H}filter(H){return new Z(j=>this.iterate(q=>H(q)?j(q):!0))}map(H){return new Z(j=>this.iterate(q=>j(H(q))))}some(H){let j=!1;return this.iterate(q=>(j=H(q),!j)),j}findFirst(H){let j;return this.iterate(q=>H(q)?(j=q,!1):!0),j}findLast(H){let j;return this.iterate(q=>(H(q)&&(j=q),!0)),j}findLastMaxBy(H){let j,q=!0;return this.iterate(re=>((q||$.isGreaterThan(H(re,j)))&&(q=!1,j=re),!0)),j}}e.CallbackIterable=Z;class ne{constructor(H){this._indexMap=H}static createSortPermutation(H,j){const q=Array.from(H.keys()).sort((re,he)=>j(H[re],H[he]));return new ne(q)}apply(H){return H.map((j,q)=>H[this._indexMap[q]])}inverse(){const H=this._indexMap.slice();for(let j=0;j<this._indexMap.length;j++)H[this._indexMap[j]]=j;return new ne(H)}}e.Permutation=ne}),define(se[139],oe([0,1,15]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=R,e.assertNever=I,e.assert=A,e.softAssert=k,e.assertFn=P,e.checkAdjacentItems=h;function R(l,f){if(!l)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}function I(l,f="Unreachable"){throw new Error(f)}function A(l){if(!l)throw new n.BugIndicatingError("Assertion Failed")}function k(l){l||(0,n.onUnexpectedError)(new n.BugIndicatingError("Soft Assertion Failed"))}function P(l){if(!l()){debugger;l(),(0,n.onUnexpectedError)(new n.BugIndicatingError("Assertion Failed"))}}function h(l,f){let S=0;for(;S<l.length-1;){const b=l[S],g=l[S+1];if(!f(b,g))return!1;S++}return!0}}),define(se[86],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=n;function n(R,I){const A=this;let k=!1,P;return function(){if(k)return P;if(k=!0,I)try{P=R.apply(A,arguments)}finally{I()}else P=R.apply(A,arguments);return P}}}),define(se[71],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(R){function I(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}R.is=I;const A=Object.freeze([]);function k(){return A}R.empty=k;function*P(t){yield t}R.single=P;function h(t){return I(t)?t:P(t)}R.wrap=h;function l(t){return t||A}R.from=l;function*f(t){for(let s=t.length-1;s>=0;s--)yield t[s]}R.reverse=f;function S(t){return!t||t[Symbol.iterator]().next().done===!0}R.isEmpty=S;function b(t){return t[Symbol.iterator]().next().value}R.first=b;function g(t,s){for(const r of t)if(s(r))return!0;return!1}R.some=g;function d(t,s){for(const r of t)if(s(r))return r}R.find=d;function*y(t,s){for(const r of t)s(r)&&(yield r)}R.filter=y;function*w(t,s){let r=0;for(const i of t)yield s(i,r++)}R.map=w;function*m(...t){for(const s of t)yield*s}R.concat=m;function c(t,s,r){let i=r;for(const o of t)i=s(i,o);return i}R.reduce=c;function*v(t,s,r=t.length){for(s<0&&(s+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);s<r;s++)yield t[s]}R.slice=v;function E(t,s=Number.POSITIVE_INFINITY){const r=[];if(s===0)return[r,t];const i=t[Symbol.iterator]();for(let o=0;o<s;o++){const u=i.next();if(u.done)return[r,R.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return i}}]}R.consume=E;async function a(t){const s=[];for await(const r of t)s.push(r);return Promise.resolve(s)}R.asyncToArray=a})(n||(e.Iterable=n={}))}),define(se[42],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=k,e.getLocation=S,e.parse=b,e.parseTree=g,e.findNodeAtLocation=d,e.getNodePath=y,e.getNodeValue=w,e.contains=m,e.findNodeAtOffset=c,e.visit=v,e.stripComments=E,e.getNodeType=a;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function k(t,s=!1){let r=0;const i=t.length;let o="",u=0,p=16,C=0;function M(z){let ue=0,ee=0;for(;ue<z;){const le=t.charCodeAt(r);if(le>=48&&le<=57)ee=ee*16+le-48;else if(le>=65&&le<=70)ee=ee*16+le-65+10;else if(le>=97&&le<=102)ee=ee*16+le-97+10;else break;r++,ue++}return ue<z&&(ee=-1),ee}function D(z){r=z,o="",u=0,p=16,C=0}function W(){const z=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&l(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&l(t.charCodeAt(r)))for(r++;r<t.length&&l(t.charCodeAt(r));)r++;else return C=3,t.substring(z,r);let ue=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&l(t.charCodeAt(r))){for(r++;r<t.length&&l(t.charCodeAt(r));)r++;ue=r}else C=3;return t.substring(z,ue)}function O(){let z="",ue=r;for(;;){if(r>=i){z+=t.substring(ue,r),C=2;break}const ee=t.charCodeAt(r);if(ee===34){z+=t.substring(ue,r),r++;break}if(ee===92){if(z+=t.substring(ue,r),r++,r>=i){C=2;break}switch(t.charCodeAt(r++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const Y=M(4);Y>=0?z+=String.fromCharCode(Y):C=4;break}default:C=5}ue=r;continue}if(ee>=0&&ee<=31)if(h(ee)){z+=t.substring(ue,r),C=2;break}else C=6;r++}return z}function _(){if(o="",C=0,u=r,r>=i)return u=i,p=17;let z=t.charCodeAt(r);if(P(z)){do r++,o+=String.fromCharCode(z),z=t.charCodeAt(r);while(P(z));return p=15}if(h(z))return r++,o+=String.fromCharCode(z),z===13&&t.charCodeAt(r)===10&&(r++,o+=`
`),p=14;switch(z){case 123:return r++,p=1;case 125:return r++,p=2;case 91:return r++,p=3;case 93:return r++,p=4;case 58:return r++,p=6;case 44:return r++,p=5;case 34:return r++,o=O(),p=10;case 47:{const ue=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!h(t.charCodeAt(r));)r++;return o=t.substring(ue,r),p=12}if(t.charCodeAt(r+1)===42){r+=2;const ee=i-1;let le=!1;for(;r<ee;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,le=!0;break}r++}return le||(r++,C=1),o=t.substring(ue,r),p=13}return o+=String.fromCharCode(z),r++,p=16}case 45:if(o+=String.fromCharCode(z),r++,r===i||!l(t.charCodeAt(r)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=W(),p=11;default:for(;r<i&&F(z);)r++,z=t.charCodeAt(r);if(u!==r){switch(o=t.substring(u,r),o){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return o+=String.fromCharCode(z),r++,p=16}}function F(z){if(P(z)||h(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let z;do z=_();while(z>=12&&z<=15);return z}return{setPosition:D,getPosition:()=>r,scan:s?x:_,getToken:()=>p,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>r-u,getTokenError:()=>C}}function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var f;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(f||(f={}));function S(t,s){const r=[],i=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function C(M,D,W,O){u.value=M,u.offset=D,u.length=W,u.type=O,u.colonOffset=void 0,o=u}try{v(t,{onObjectBegin:(M,D)=>{if(s<=M)throw i;o=void 0,p=s>M,r.push("")},onObjectProperty:(M,D,W)=>{if(s<D||(C(M,D,W,"property"),r[r.length-1]=M,s<=D+W))throw i},onObjectEnd:(M,D)=>{if(s<=M)throw i;o=void 0,r.pop()},onArrayBegin:(M,D)=>{if(s<=M)throw i;o=void 0,r.push(0)},onArrayEnd:(M,D)=>{if(s<=M)throw i;o=void 0,r.pop()},onLiteralValue:(M,D,W)=>{if(s<D||(C(M,D,W,a(M)),s<=D+W))throw i},onSeparator:(M,D,W)=>{if(s<=D)throw i;if(M===":"&&o&&o.type==="property")o.colonOffset=D,p=!1,o=void 0;else if(M===","){const O=r[r.length-1];typeof O=="number"?r[r.length-1]=O+1:(p=!0,r[r.length-1]=""),o=void 0}}})}catch(M){if(M!==i)throw M}return{path:r,previousNode:o,isAtPropertyKey:p,matches:M=>{let D=0;for(let W=0;D<M.length&&W<r.length;W++)if(M[D]===r[W]||M[D]==="*")D++;else if(M[D]!=="**")return!1;return D===M.length}}}function b(t,s=[],r=A.DEFAULT){let i=null,o=[];const u=[];function p(M){Array.isArray(o)?o.push(M):i!==null&&(o[i]=M)}return v(t,{onObjectBegin:()=>{const M={};p(M),u.push(o),o=M,i=null},onObjectProperty:M=>{i=M},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const M=[];p(M),u.push(o),o=M,i=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:p,onError:(M,D,W)=>{s.push({error:M,offset:D,length:W})}},r),o[0]}function g(t,s=[],r=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(M){i.type==="property"&&(i.length=M-i.offset,i=i.parent)}function u(M){return i.children.push(M),M}v(t,{onObjectBegin:M=>{i=u({type:"object",offset:M,length:-1,parent:i,children:[]})},onObjectProperty:(M,D,W)=>{i=u({type:"property",offset:D,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:M,offset:D,length:W,parent:i})},onObjectEnd:(M,D)=>{i.length=M+D-i.offset,i=i.parent,o(M+D)},onArrayBegin:(M,D)=>{i=u({type:"array",offset:M,length:-1,parent:i,children:[]})},onArrayEnd:(M,D)=>{i.length=M+D-i.offset,i=i.parent,o(M+D)},onLiteralValue:(M,D,W)=>{u({type:a(M),offset:D,length:W,parent:i,value:M}),o(D+W)},onSeparator:(M,D,W)=>{i.type==="property"&&(M===":"?i.colonOffset=D:M===","&&o(D))},onError:(M,D,W)=>{s.push({error:M,offset:D,length:W})}},r);const C=i.children[0];return C&&delete C.parent,C}function d(t,s){if(!t)return;let r=t;for(const i of s)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let o=!1;for(const u of r.children)if(Array.isArray(u.children)&&u.children[0].value===i){r=u.children[1],o=!0;break}if(!o)return}else{const o=i;if(r.type!=="array"||o<0||!Array.isArray(r.children)||o>=r.children.length)return;r=r.children[o]}return r}function y(t){if(!t.parent||!t.parent.children)return[];const s=y(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}function w(t){switch(t.type){case"array":return t.children.map(w);case"object":{const s=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(s[r.children[0].value]=w(i))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function m(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}function c(t,s,r=!1){if(m(t,s,r)){const i=t.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=s;o++){const u=c(i[o],s,r);if(u)return u}return t}}function v(t,s,r=A.DEFAULT){const i=k(t,!1);function o(ae){return ae?()=>ae(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(ae){return ae?V=>ae(V,i.getTokenOffset(),i.getTokenLength()):()=>!0}const p=o(s.onObjectBegin),C=u(s.onObjectProperty),M=o(s.onObjectEnd),D=o(s.onArrayBegin),W=o(s.onArrayEnd),O=u(s.onLiteralValue),_=u(s.onSeparator),F=o(s.onComment),x=u(s.onError),z=r&&r.disallowComments,ue=r&&r.allowTrailingComma;function ee(){for(;;){const ae=i.scan();switch(i.getTokenError()){case 4:le(14);break;case 5:le(15);break;case 3:le(13);break;case 1:z||le(11);break;case 2:le(12);break;case 6:le(16);break}switch(ae){case 12:case 13:z?le(10):F();break;case 16:le(1);break;case 15:case 14:break;default:return ae}}}function le(ae,V=[],ce=[]){if(x(ae),V.length+ce.length>0){let X=i.getToken();for(;X!==17;){if(V.indexOf(X)!==-1){ee();break}else if(ce.indexOf(X)!==-1)break;X=ee()}}}function Y(ae){const V=i.getTokenValue();return ae?O(V):C(V),ee(),!0}function G(){switch(i.getToken()){case 11:{let ae=0;try{ae=JSON.parse(i.getTokenValue()),typeof ae!="number"&&(le(2),ae=0)}catch{le(2)}O(ae);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return ee(),!0}function B(){return i.getToken()!==10?(le(3,[],[2,5]),!1):(Y(!1),i.getToken()===6?(_(":"),ee(),$()||le(4,[],[2,5])):le(5,[],[2,5]),!0)}function T(){p(),ee();let ae=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ae||le(4,[],[]),_(","),ee(),i.getToken()===2&&ue)break}else ae&&le(6,[],[]);B()||le(4,[],[2,5]),ae=!0}return M(),i.getToken()!==2?le(7,[2],[]):ee(),!0}function U(){D(),ee();let ae=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ae||le(4,[],[]),_(","),ee(),i.getToken()===4&&ue)break}else ae&&le(6,[],[]);$()||le(4,[],[4,5]),ae=!0}return W(),i.getToken()!==4?le(8,[4],[]):ee(),!0}function $(){switch(i.getToken()){case 3:return U();case 1:return T();case 10:return Y(!0);default:return G()}}return ee(),i.getToken()===17?r.allowEmptyContent?!0:(le(4,[],[]),!1):$()?(i.getToken()!==17&&le(9,[],[]),!0):(le(4,[],[]),!1)}function E(t,s){const r=k(t),i=[];let o,u=0,p;do switch(p=r.getPosition(),o=r.scan(),o){case 12:case 13:case 17:u!==p&&i.push(t.substring(u,p)),s!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,s)),u=r.getPosition();break}while(o!==17);return i.join("")}function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(se[140],oe([0,1,42]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.format=R,e.toFormattedString=I,e.getEOL=P,e.isEOL=h;function R(l,f,S){let b,g,d,y,w;if(f){for(y=f.offset,w=y+f.length,d=y;d>0&&!h(l,d-1);)d--;let p=w;for(;p<l.length&&!h(l,p);)p++;g=l.substring(d,p),b=k(g,S)}else g=l,b=0,d=0,y=0,w=l.length;const m=P(S,l);let c=!1,v=0,E;S.insertSpaces?E=A(" ",S.tabSize||4):E="	";const a=(0,n.createScanner)(g,!1);let t=!1;function s(){return m+A(E,b+v)}function r(){let p=a.scan();for(c=!1;p===15||p===14;)c=c||p===14,p=a.scan();return t=p===16||a.getTokenError()!==0,p}const i=[];function o(p,C,M){!t&&C<w&&M>y&&l.substring(C,M)!==p&&i.push({offset:C,length:M-C,content:p})}let u=r();if(u!==17){const p=a.getTokenOffset()+d,C=A(E,b);o(C,d,p)}for(;u!==17;){let p=a.getTokenOffset()+a.getTokenLength()+d,C=r(),M="";for(;!c&&(C===12||C===13);){const W=a.getTokenOffset()+d;o(" ",p,W),p=a.getTokenOffset()+a.getTokenLength()+d,M=C===12?s():"",C=r()}if(C===2)u!==1&&(v--,M=s());else if(C===4)u!==3&&(v--,M=s());else{switch(u){case 3:case 1:v++,M=s();break;case 5:case 12:M=s();break;case 13:c?M=s():M=" ";break;case 6:M=" ";break;case 10:if(C===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:C===12||C===13?M=" ":C!==5&&C!==17&&(t=!0);break;case 16:t=!0;break}c&&(C===12||C===13)&&(M=s())}const D=a.getTokenOffset()+d;o(M,p,D),u=C}return i}function I(l,f){const S=JSON.stringify(l,void 0,f.insertSpaces?f.tabSize||4:"	");return f.eol!==void 0?S.replace(/\r\n|\r|\n/g,f.eol):S}function A(l,f){let S="";for(let b=0;b<f;b++)S+=l;return S}function k(l,f){let S=0,b=0;const g=f.tabSize||4;for(;S<l.length;){const d=l.charAt(S);if(d===" ")b++;else if(d==="	")b+=g;else break;S++}return Math.floor(b/g)}function P(l,f){for(let S=0;S<f.length;S++){const b=f.charAt(S);if(b==="\r")return S+1<f.length&&f.charAt(S+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return l&&l.eol||`
`}function h(l,f){return`\r
`.indexOf(l.charAt(f))!==-1}}),define(se[103],oe([0,1,42,140]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeProperty=I,e.setProperty=A,e.withFormatting=k,e.applyEdit=P,e.applyEdits=h;function I(l,f,S){return A(l,f,void 0,S)}function A(l,f,S,b,g){const d=f.slice(),y=[],w=(0,n.parseTree)(l,y);let m,c;for(;d.length>0&&(c=d.pop(),m=(0,n.findNodeAtLocation)(w,d),m===void 0&&S!==void 0);)typeof c=="string"?S={[c]:S}:S=[S];if(m)if(m.type==="object"&&typeof c=="string"&&Array.isArray(m.children)){const v=(0,n.findNodeAtLocation)(m,[c]);if(v!==void 0)if(S===void 0){if(!v.parent)throw new Error("Malformed AST");const E=m.children.indexOf(v.parent);let a,t=v.parent.offset+v.parent.length;if(E>0){const s=m.children[E-1];a=s.offset+s.length}else a=m.offset+1,m.children.length>1&&(t=m.children[1].offset);return k(l,{offset:a,length:t-a,content:""},b)}else return k(l,{offset:v.offset,length:v.length,content:JSON.stringify(S)},b);else{if(S===void 0)return[];const E=`${JSON.stringify(c)}: ${JSON.stringify(S)}`,a=g?g(m.children.map(s=>s.children[0].value)):m.children.length;let t;if(a>0){const s=m.children[a-1];t={offset:s.offset+s.length,length:0,content:","+E}}else m.children.length===0?t={offset:m.offset+1,length:0,content:E}:t={offset:m.offset+1,length:0,content:E+","};return k(l,t,b)}}else if(m.type==="array"&&typeof c=="number"&&Array.isArray(m.children))if(S!==void 0){const v=`${JSON.stringify(S)}`;let E;if(m.children.length===0||c===0)E={offset:m.offset+1,length:0,content:m.children.length===0?v:v+","};else{const a=c===-1||c>m.children.length?m.children.length:c,t=m.children[a-1];E={offset:t.offset+t.length,length:0,content:","+v}}return k(l,E,b)}else{const v=c,E=m.children[v];let a;if(m.children.length===1)a={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===v){const t=m.children[v-1],s=t.offset+t.length,r=m.offset+m.length;a={offset:s,length:r-2-s,content:""}}else a={offset:E.offset,length:m.children[v+1].offset-E.offset,content:""};return k(l,a,b)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${m.type}`);else return S===void 0?[]:k(l,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(S)},b)}function k(l,f,S){let b=P(l,f),g=f.offset,d=f.offset+f.content.length;if(f.length===0||f.content.length===0){for(;g>0&&!(0,R.isEOL)(b,g-1);)g--;for(;d<b.length&&!(0,R.isEOL)(b,d);)d++}const y=(0,R.format)(b,{offset:g,length:d-g},S);for(let m=y.length-1;m>=0;m--){const c=y[m];b=P(b,c),g=Math.min(g,c.offset),d=Math.max(d,c.offset+c.length),d+=c.content.length-c.length}const w=l.length-(b.length-d)-g;return[{offset:g,length:w,content:b.substring(g,d)}]}function P(l,f){return l.substring(0,f.offset)+f.content+l.substring(f.offset+f.length)}function h(l,f){const S=f.slice(0).sort((g,d)=>{const y=g.offset-d.offset;return y===0?g.length-d.length:y});let b=l.length;for(let g=S.length-1;g>=0;g--){const d=S[g];if(d.offset+d.length<=b)l=P(l,d);else throw new Error("Overlapping edit");b=d.offset}return l}}),define(se[62],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class n{constructor(I){this.executor=I,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=n}),define(se[104],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class n{static{this.Undefined=new n(void 0)}constructor(A){this.element=A,this.next=n.Undefined,this.prev=n.Undefined}}class R{constructor(){this._first=n.Undefined,this._last=n.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===n.Undefined}clear(){let A=this._first;for(;A!==n.Undefined;){const k=A.next;A.prev=n.Undefined,A.next=n.Undefined,A=k}this._first=n.Undefined,this._last=n.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,k){const P=new n(A);if(this._first===n.Undefined)this._first=P,this._last=P;else if(k){const l=this._last;this._last=P,P.prev=l,l.next=P}else{const l=this._first;this._first=P,P.next=l,l.prev=P}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(P))}}shift(){if(this._first!==n.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==n.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==n.Undefined&&A.next!==n.Undefined){const k=A.prev;k.next=A.next,A.next.prev=k}else A.prev===n.Undefined&&A.next===n.Undefined?(this._first=n.Undefined,this._last=n.Undefined):A.next===n.Undefined?(this._last=this._last.prev,this._last.next=n.Undefined):A.prev===n.Undefined&&(this._first=this._first.next,this._first.prev=n.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==n.Undefined;)yield A.element,A=A.next}}e.LinkedList=R}),define(se[32],oe([0,1]),function(Q,e){"use strict";var n,R,I;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=A,e.mapToString=k,e.setToString=P,e.mapsStrictEqualIgnoreOrder=E;function A(a,t,s){let r=a.get(t);return r===void 0&&(r=s,a.set(t,r)),r}function k(a){const t=[];return a.forEach((s,r)=>{t.push(`${r} => ${s}`)}),`Map(${a.size}) {${t.join(", ")}}`}function P(a){const t=[];return a.forEach(s=>{t.push(s)}),`Set(${a.size}) {${t.join(", ")}}`}class h{constructor(t,s){this.uri=t,this.value=s}}function l(a){return Array.isArray(a)}class f{static{this.defaultToKey=t=>t.toString()}constructor(t,s){if(this[n]="ResourceMap",t instanceof f)this.map=new Map(t.map),this.toKey=s??f.defaultToKey;else if(l(t)){this.map=new Map,this.toKey=s??f.defaultToKey;for(const[r,i]of t)this.set(r,i)}else this.map=new Map,this.toKey=t??f.defaultToKey}set(t,s){return this.map.set(this.toKey(t),new h(t,s)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,s){typeof s<"u"&&(t=t.bind(s));for(const[r,i]of this.map)t(i.value,i.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=f;class S{constructor(t,s){this[R]="ResourceSet",!t||typeof t=="function"?this._map=new f(t):(this._map=new f(s),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,s){this._map.forEach((r,i)=>t.call(s,i,i,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=S;var b;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class g{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,s=0){const r=this._map.get(t);if(r)return s!==0&&this.touch(r,s),r.value}set(t,s,r=0){let i=this._map.get(t);if(i)i.value=s,r!==0&&this.touch(i,r);else{switch(i={key:t,value:s,next:void 0,previous:void 0},r){case 0:this.addItemLast(i);break;case 1:this.addItemFirst(i);break;case 2:this.addItemLast(i);break;default:this.addItemLast(i);break}this._map.set(t,i),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this._map.get(t);if(s)return this._map.delete(t),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,s){const r=this._state;let i=this._head;for(;i;){if(s?t.bind(s)(i.value,i.key,this):t(i.value,i.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const t=this,s=this._state;let r=this._head;const i={[Symbol.iterator](){return i},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const o={value:r.key,done:!1};return r=r.next,o}else return{value:void 0,done:!0}}};return i}values(){const t=this,s=this._state;let r=this._head;const i={[Symbol.iterator](){return i},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const o={value:r.value,done:!1};return r=r.next,o}else return{value:void 0,done:!0}}};return i}entries(){const t=this,s=this._state;let r=this._head;const i={[Symbol.iterator](){return i},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const o={value:[r.key,r.value],done:!1};return r=r.next,o}else return{value:void 0,done:!0}}};return i}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this._head,r=this.size;for(;s&&r>t;)this._map.delete(s.key),s=s.next,r--;this._head=s,this._size=r,s&&(s.previous=void 0),this._state++}trimNew(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this._tail,r=this.size;for(;s&&r>t;)this._map.delete(s.key),s=s.previous,r--;this._tail=s,this._size=r,s&&(s.next=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const s=t.next,r=t.previous;if(!s||!r)throw new Error("Invalid list");s.previous=r,r.next=s}t.next=void 0,t.previous=void 0,this._state++}touch(t,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(t===this._head)return;const r=t.next,i=t.previous;t===this._tail?(i.next=void 0,this._tail=i):(r.previous=i,i.next=r),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(s===2){if(t===this._tail)return;const r=t.next,i=t.previous;t===this._head?(r.previous=void 0,this._head=r):(r.previous=i,i.next=r),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((s,r)=>{t.push([r,s])}),t}fromJSON(t){this.clear();for(const[s,r]of t)this.set(s,r)}}e.LinkedMap=g;class d extends g{constructor(t,s=1){super(),this._limit=t,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,s=2){return super.get(t,s)}peek(t){return super.get(t,0)}set(t,s){return super.set(t,s,2),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class y extends d{constructor(t,s=1){super(t,s)}trim(t){this.trimOld(t)}set(t,s){return super.set(t,s),this.checkTrim(),this}}e.LRUCache=y;class w extends d{constructor(t,s=1){super(t,s)}trim(t){this.trimNew(t)}set(t,s){return this._limit<=this.size&&!this.has(t)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(t,s),this}}e.MRUCache=w;class m{constructor(){this.map=new Map}add(t){return this.map.set(t,(this.map.get(t)||0)+1),this}delete(t){let s=this.map.get(t)||0;return s===0?!1:(s--,s===0?this.map.delete(t):this.map.set(t,s),!0)}has(t){return this.map.has(t)}}e.CounterSet=m;class c{constructor(t){if(this._m1=new Map,this._m2=new Map,t)for(const[s,r]of t)this.set(s,r)}clear(){this._m1.clear(),this._m2.clear()}set(t,s){this._m1.set(t,s),this._m2.set(s,t)}get(t){return this._m1.get(t)}getKey(t){return this._m2.get(t)}delete(t){const s=this._m1.get(t);return s===void 0?!1:(this._m1.delete(t),this._m2.delete(s),!0)}forEach(t,s){this._m1.forEach((r,i)=>{t.call(s,r,i,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=c;class v{constructor(){this.map=new Map}add(t,s){let r=this.map.get(t);r||(r=new Set,this.map.set(t,r)),r.add(s)}delete(t,s){const r=this.map.get(t);r&&(r.delete(s),r.size===0&&this.map.delete(t))}forEach(t,s){const r=this.map.get(t);r&&r.forEach(s)}get(t){const s=this.map.get(t);return s||new Set}}e.SetMap=v;function E(a,t){if(a===t)return!0;if(a.size!==t.size)return!1;for(const[s,r]of a)if(!t.has(s)||t.get(s)!==r)return!1;for(const[s]of t)if(!a.has(s))return!1;return!0}}),define(se[2],oe([0,1,22,137,32,86,71]),function(Q,e,n,R,I,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=f,e.trackDisposable=S,e.markAsDisposed=b,e.markAsSingleton=y,e.isDisposable=w,e.dispose=m,e.disposeIfDisposable=c,e.combinedDisposable=v,e.toDisposable=E,e.disposeOnReturn=M;const P=!1;let h=null;class l{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(O){let _=this.livingDisposables.get(O);return _||(_={parent:null,source:null,isSingleton:!1,value:O,idx:l.idx++},this.livingDisposables.set(O,_)),_}trackDisposable(O){const _=this.getDisposableData(O);_.source||(_.source=new Error().stack)}setParent(O,_){const F=this.getDisposableData(O);F.parent=_}markAsDisposed(O){this.livingDisposables.delete(O)}markAsSingleton(O){this.getDisposableData(O).isSingleton=!0}getRootParent(O,_){const F=_.get(O);if(F)return F;const x=O.parent?this.getRootParent(this.getDisposableData(O.parent),_):O;return _.set(O,x),x}getTrackedDisposables(){const O=new Map;return[...this.livingDisposables.entries()].filter(([,F])=>F.source!==null&&!this.getRootParent(F,O).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(O=10,_){let F;if(_)F=_;else{const le=new Map,Y=[...this.livingDisposables.values()].filter(B=>B.source!==null&&!this.getRootParent(B,le).isSingleton);if(Y.length===0)return;const G=new Set(Y.map(B=>B.value));if(F=Y.filter(B=>!(B.parent&&G.has(B.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function x(le){function Y(B,T){for(;B.length>0&&T.some(U=>typeof U=="string"?U===B[0]:B[0].match(U));)B.shift()}const G=le.source.split(`
`).map(B=>B.trim().replace("at ","")).filter(B=>B!=="");return Y(G,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),G.reverse()}const z=new I.SetMap;for(const le of F){const Y=x(le);for(let G=0;G<=Y.length;G++)z.add(Y.slice(0,G).join(`
`),le)}F.sort((0,n.compareBy)(le=>le.idx,n.numberComparator));let ue="",ee=0;for(const le of F.slice(0,O)){ee++;const Y=x(le),G=[];for(let B=0;B<Y.length;B++){let T=Y[B];T=`(shared with ${z.get(Y.slice(0,B+1).join(`
`)).size}/${F.length} leaks) at ${T}`;const $=z.get(Y.slice(0,B).join(`
`)),ae=(0,R.groupBy)([...$].map(V=>x(V)[B]),V=>V);delete ae[Y[B]];for(const[V,ce]of Object.entries(ae))G.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${V}`);G.unshift(T)}ue+=`


==================== Leaking disposable ${ee}/${F.length}: ${le.value.constructor.name} ====================
${G.join(`
`)}
============================================================

`}return F.length>O&&(ue+=`


... and ${F.length-O} more leaking disposables

`),{leaks:F,details:ue}}}e.DisposableTracker=l;function f(W){h=W}if(P){const W="__is_disposable_tracked__";f(new class{trackDisposable(O){const _=new Error("Potentially leaked disposable").stack;setTimeout(()=>{O[W]||console.log(_)},3e3)}setParent(O,_){if(O&&O!==t.None)try{O[W]=!0}catch{}}markAsDisposed(O){if(O&&O!==t.None)try{O[W]=!0}catch{}}markAsSingleton(O){}})}function S(W){return h?.trackDisposable(W),W}function b(W){h?.markAsDisposed(W)}function g(W,O){h?.setParent(W,O)}function d(W,O){if(h)for(const _ of W)h.setParent(_,O)}function y(W){return h?.markAsSingleton(W),W}function w(W){return typeof W=="object"&&W!==null&&typeof W.dispose=="function"&&W.dispose.length===0}function m(W){if(k.Iterable.is(W)){const O=[];for(const _ of W)if(_)try{_.dispose()}catch(F){O.push(F)}if(O.length===1)throw O[0];if(O.length>1)throw new AggregateError(O,"Encountered errors while disposing of store");return Array.isArray(W)?[]:W}else if(W)return W.dispose(),W}function c(W){for(const O of W)w(O)&&O.dispose();return[]}function v(...W){const O=E(()=>m(W));return d(W,O),O}function E(W){const O=S({dispose:(0,A.createSingleCallFunction)(()=>{b(O),W()})});return O}class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,S(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{m(this._toDispose)}finally{this._toDispose.clear()}}add(O){if(!O)return O;if(O===this)throw new Error("Cannot register a disposable on itself!");return g(O,this),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(O),O}delete(O){if(O){if(O===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(O),O.dispose()}}deleteAndLeak(O){O&&this._toDispose.has(O)&&(this._toDispose.delete(O),g(O,null))}}e.DisposableStore=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new a,S(this),g(this._store,this)}dispose(){b(this),this._store.dispose()}_register(O){if(O===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(O)}}e.Disposable=t;class s{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(O){this._isDisposed||O===this._value||(this._value?.dispose(),O&&g(O,this),this._value=O)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const O=this._value;return this._value=void 0,O&&g(O,null),O}}e.MutableDisposable=s;class r{constructor(O){this._disposable=new s,this._isDisposed=!1,this._disposable.value=O}get value(){return this._disposable.value}set value(O){this._isDisposed||O===this._disposable.value||(this._disposable.value=O)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=r;class i{constructor(O){this._disposable=O,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=i;class o{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(O){let _=O;return this.unset=()=>_=void 0,this.isset=()=>_!==void 0,this.dispose=()=>{_&&(_(),_=void 0,b(this))},this}}e.SafeDisposable=o;class u{constructor(){this.references=new Map}acquire(O,..._){let F=this.references.get(O);F||(F={counter:0,object:this.createReferencedObject(O,..._)},this.references.set(O,F));const{object:x}=F,z=(0,A.createSingleCallFunction)(()=>{--F.counter===0&&(this.destroyReferencedObject(O,F.object),this.references.delete(O))});return F.counter++,{object:x,dispose:z}}}e.ReferenceCollection=u;class p{constructor(O){this.referenceCollection=O}async acquire(O,..._){const F=this.referenceCollection.acquire(O,..._);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(x){throw F.dispose(),x}}}e.AsyncReferenceCollection=p;class C{constructor(O){this.object=O}dispose(){}}e.ImmortalReference=C;function M(W){const O=new a;try{W(O)}finally{O.dispose()}}class D{constructor(){this._store=new Map,this._isDisposed=!1,S(this)}dispose(){b(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{m(this._store.values())}finally{this._store.clear()}}has(O){return this._store.has(O)}get size(){return this._store.size}get(O){return this._store.get(O)}set(O,_,F=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this._store.get(O)?.dispose(),this._store.set(O,_)}deleteAndDispose(O){this._store.get(O)?.dispose(),this._store.delete(O)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=D}),define(se[72],oe([0,1,32]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=I,e.normalizeNFD=k;const R=new n.LRUCache(1e4);function I(l){return h(l,"NFC",R)}const A=new n.LRUCache(1e4);function k(l){return h(l,"NFD",A)}const P=/[^\u0000-\u0080]/;function h(l,f,S){if(!l)return l;const b=S.get(l);if(b)return b;let g;return P.test(l)?g=l.normalize(f):g=l,S.set(l,g),g}e.removeAccents=function(){const l=/[\u0300-\u036f]/g;return function(f){return k(f).replace(l,"")}}()}),define(se[141],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=n,e.rot=R;function n(P,h,l){return Math.min(Math.max(P,h),l)}function R(P,h){return(h+P%h)%h}class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class A{constructor(){this._n=1,this._val=0}update(h){return this._val=this._val+(h-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class k{constructor(h){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(h),this._values.fill(0,0,h)}update(h){const l=this._values[this._index];return this._values[this._index]=h,this._index=(this._index+1)%this._values.length,this._sum-=l,this._sum+=h,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=k}),function(){function Q(I){const A=[];typeof I=="number"&&A.push("code/timeOrigin",I);function k(h){A.push(h,Date.now())}function P(){const h=[];for(let l=0;l<A.length;l+=2)h.push({name:A[l],startTime:A[l+1]});return h}return{mark:k,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const k of performance.getEntriesByType("mark"))A.push({name:k.name,startTime:Math.round(I+k.startTime)});return A}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function n(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=n(R))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var R in n)(typeof exports=="object"?exports:Q)[R]=n[R]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function n(R){if(e[R])return e[R].exports;var I=e[R]={i:R,l:!1,exports:{}};return Q[R].call(I.exports,I,I.exports,n),I.l=!0,I.exports}return n.m=Q,n.c=e,n.d=function(R,I,A){n.o(R,I)||Object.defineProperty(R,I,{enumerable:!0,get:A})},n.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},n.t=function(R,I){if(1&I&&(R=n(R)),8&I||4&I&&typeof R=="object"&&R&&R.__esModule)return R;var A=Object.create(null);if(n.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:R}),2&I&&typeof R!="string")for(var k in R)n.d(A,k,function(P){return R[P]}.bind(null,k));return A},n.n=function(R){var I=R&&R.__esModule?function(){return R.default}:function(){return R};return n.d(I,"a",I),I},n.o=function(R,I){return Object.prototype.hasOwnProperty.call(R,I)},n.p="",n(n.s=0)}([function(Q,e,n){(function(R){var I;e=Q.exports=ce,I=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],h=e.src=[],l=0,f=l++;h[f]="0|[1-9]\\d*";var S=l++;h[S]="[0-9]+";var b=l++;h[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=l++;h[g]="("+h[f]+")\\.("+h[f]+")\\.("+h[f]+")";var d=l++;h[d]="("+h[S]+")\\.("+h[S]+")\\.("+h[S]+")";var y=l++;h[y]="(?:"+h[f]+"|"+h[b]+")";var w=l++;h[w]="(?:"+h[S]+"|"+h[b]+")";var m=l++;h[m]="(?:-("+h[y]+"(?:\\."+h[y]+")*))";var c=l++;h[c]="(?:-?("+h[w]+"(?:\\."+h[w]+")*))";var v=l++;h[v]="[0-9A-Za-z-]+";var E=l++;h[E]="(?:\\+("+h[v]+"(?:\\."+h[v]+")*))";var a=l++,t="v?"+h[g]+h[m]+"?"+h[E]+"?";h[a]="^"+t+"$";var s="[v=\\s]*"+h[d]+h[c]+"?"+h[E]+"?",r=l++;h[r]="^"+s+"$";var i=l++;h[i]="((?:<|>)?=?)";var o=l++;h[o]=h[S]+"|x|X|\\*";var u=l++;h[u]=h[f]+"|x|X|\\*";var p=l++;h[p]="[v=\\s]*("+h[u]+")(?:\\.("+h[u]+")(?:\\.("+h[u]+")(?:"+h[m]+")?"+h[E]+"?)?)?";var C=l++;h[C]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[c]+")?"+h[E]+"?)?)?";var M=l++;h[M]="^"+h[i]+"\\s*"+h[p]+"$";var D=l++;h[D]="^"+h[i]+"\\s*"+h[C]+"$";var W=l++;h[W]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=l++;h[O]="(?:~>?)";var _=l++;h[_]="(\\s*)"+h[O]+"\\s+",P[_]=new RegExp(h[_],"g");var F=l++;h[F]="^"+h[O]+h[p]+"$";var x=l++;h[x]="^"+h[O]+h[C]+"$";var z=l++;h[z]="(?:\\^)";var ue=l++;h[ue]="(\\s*)"+h[z]+"\\s+",P[ue]=new RegExp(h[ue],"g");var ee=l++;h[ee]="^"+h[z]+h[p]+"$";var le=l++;h[le]="^"+h[z]+h[C]+"$";var Y=l++;h[Y]="^"+h[i]+"\\s*("+s+")$|^$";var G=l++;h[G]="^"+h[i]+"\\s*("+t+")$|^$";var B=l++;h[B]="(\\s*)"+h[i]+"\\s*("+s+"|"+h[p]+")",P[B]=new RegExp(h[B],"g");var T=l++;h[T]="^\\s*("+h[p]+")\\s+-\\s+("+h[p]+")\\s*$";var U=l++;h[U]="^\\s*("+h[C]+")\\s+-\\s+("+h[C]+")\\s*$";var $=l++;h[$]="(<|>)?=?\\s*\\*";for(var ae=0;ae<35;ae++)I(ae,h[ae]),P[ae]||(P[ae]=new RegExp(h[ae]));function V(J,de){if(J instanceof ce)return J;if(typeof J!="string"||J.length>A||!(de?P[r]:P[a]).test(J))return null;try{return new ce(J,de)}catch{return null}}function ce(J,de){if(J instanceof ce){if(J.loose===de)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof ce))return new ce(J,de);I("SemVer",J,de),this.loose=de;var ge=J.trim().match(de?P[r]:P[a]);if(!ge)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(ke){if(/^[0-9]+$/.test(ke)){var Ae=+ke;if(Ae>=0&&Ae<k)return Ae}return ke}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=V,e.valid=function(J,de){var ge=V(J,de);return ge?ge.version:null},e.clean=function(J,de){var ge=V(J.trim().replace(/^[=v]+/,""),de);return ge?ge.version:null},e.SemVer=ce,ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ce.prototype.toString=function(){return this.version},ce.prototype.compare=function(J){return I("SemVer.compare",this.version,this.loose,J),J instanceof ce||(J=new ce(J,this.loose)),this.compareMain(J)||this.comparePre(J)},ce.prototype.compareMain=function(J){return J instanceof ce||(J=new ce(J,this.loose)),L(this.major,J.major)||L(this.minor,J.minor)||L(this.patch,J.patch)},ce.prototype.comparePre=function(J){if(J instanceof ce||(J=new ce(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var de=0;do{var ge=this.prerelease[de],ke=J.prerelease[de];if(I("prerelease compare",de,ge,ke),ge===void 0&&ke===void 0)return 0;if(ke===void 0)return 1;if(ge===void 0)return-1;if(ge!==ke)return L(ge,ke)}while(++de)},ce.prototype.inc=function(J,de){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,de,ge,ke){typeof ge=="string"&&(ke=ge,ge=void 0);try{return new ce(J,ge).inc(de,ke).version}catch{return null}},e.diff=function(J,de){if(K(J,de))return null;var ge=V(J),ke=V(de);if(ge.prerelease.length||ke.prerelease.length){for(var Ae in ge)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&ge[Ae]!==ke[Ae])return"pre"+Ae;return"prerelease"}for(var Ae in ge)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&ge[Ae]!==ke[Ae])return Ae},e.compareIdentifiers=L;var X=/^[0-9]+$/;function L(J,de){var ge=X.test(J),ke=X.test(de);return ge&&ke&&(J=+J,de=+de),ge&&!ke?-1:ke&&!ge?1:J<de?-1:J>de?1:0}function N(J,de,ge){return new ce(J,ge).compare(new ce(de,ge))}function Z(J,de,ge){return N(J,de,ge)>0}function ne(J,de,ge){return N(J,de,ge)<0}function K(J,de,ge){return N(J,de,ge)===0}function H(J,de,ge){return N(J,de,ge)!==0}function j(J,de,ge){return N(J,de,ge)>=0}function q(J,de,ge){return N(J,de,ge)<=0}function re(J,de,ge,ke){var Ae;switch(de){case"===":typeof J=="object"&&(J=J.version),typeof ge=="object"&&(ge=ge.version),Ae=J===ge;break;case"!==":typeof J=="object"&&(J=J.version),typeof ge=="object"&&(ge=ge.version),Ae=J!==ge;break;case"":case"=":case"==":Ae=K(J,ge,ke);break;case"!=":Ae=H(J,ge,ke);break;case">":Ae=Z(J,ge,ke);break;case">=":Ae=j(J,ge,ke);break;case"<":Ae=ne(J,ge,ke);break;case"<=":Ae=q(J,ge,ke);break;default:throw new TypeError("Invalid operator: "+de)}return Ae}function he(J,de){if(J instanceof he){if(J.loose===de)return J;J=J.value}if(!(this instanceof he))return new he(J,de);I("comparator",J,de),this.loose=de,this.parse(J),this.semver===me?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(J,de){return L(de,J)},e.major=function(J,de){return new ce(J,de).major},e.minor=function(J,de){return new ce(J,de).minor},e.patch=function(J,de){return new ce(J,de).patch},e.compare=N,e.compareLoose=function(J,de){return N(J,de,!0)},e.rcompare=function(J,de,ge){return N(de,J,ge)},e.sort=function(J,de){return J.sort(function(ge,ke){return e.compare(ge,ke,de)})},e.rsort=function(J,de){return J.sort(function(ge,ke){return e.rcompare(ge,ke,de)})},e.gt=Z,e.lt=ne,e.eq=K,e.neq=H,e.gte=j,e.lte=q,e.cmp=re,e.Comparator=he;var me={};function pe(J,de){if(J instanceof pe)return J.loose===de?J:new pe(J.raw,de);if(J instanceof he)return new pe(J.value,de);if(!(this instanceof pe))return new pe(J,de);if(this.loose=de,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function ye(J){return!J||J.toLowerCase()==="x"||J==="*"}function Ee(J,de,ge,ke,Ae,Be,Te,Fe,$e,He,Ke,xe,te){return((de=ye(ge)?"":ye(ke)?">="+ge+".0.0":ye(Ae)?">="+ge+"."+ke+".0":">="+de)+" "+(Fe=ye($e)?"":ye(He)?"<"+(+$e+1)+".0.0":ye(Ke)?"<"+$e+"."+(+He+1)+".0":xe?"<="+$e+"."+He+"."+Ke+"-"+xe:"<="+Fe)).trim()}function Pe(J,de){for(var ge=0;ge<J.length;ge++)if(!J[ge].test(de))return!1;if(de.prerelease.length){for(ge=0;ge<J.length;ge++)if(I(J[ge].semver),J[ge].semver!==me&&J[ge].semver.prerelease.length>0){var ke=J[ge].semver;if(ke.major===de.major&&ke.minor===de.minor&&ke.patch===de.patch)return!0}return!1}return!0}function We(J,de,ge){try{de=new pe(de,ge)}catch{return!1}return de.test(J)}function ve(J,de,ge,ke){var Ae,Be,Te,Fe,$e;switch(J=new ce(J,ke),de=new pe(de,ke),ge){case">":Ae=Z,Be=q,Te=ne,Fe=">",$e=">=";break;case"<":Ae=ne,Be=j,Te=Z,Fe="<",$e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(We(J,de,ke))return!1;for(var He=0;He<de.set.length;++He){var Ke=de.set[He],xe=null,te=null;if(Ke.forEach(function(fe){fe.semver===me&&(fe=new he(">=0.0.0")),xe=xe||fe,te=te||fe,Ae(fe.semver,xe.semver,ke)?xe=fe:Te(fe.semver,te.semver,ke)&&(te=fe)}),xe.operator===Fe||xe.operator===$e||(!te.operator||te.operator===Fe)&&Be(J,te.semver)||te.operator===$e&&Te(J,te.semver))return!1}return!0}he.prototype.parse=function(J){var de=this.loose?P[Y]:P[G],ge=J.match(de);if(!ge)throw new TypeError("Invalid comparator: "+J);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new ce(ge[2],this.loose):this.semver=me},he.prototype.toString=function(){return this.value},he.prototype.test=function(J){return I("Comparator.test",J,this.loose),this.semver===me||(typeof J=="string"&&(J=new ce(J,this.loose)),re(J,this.operator,this.semver,this.loose))},he.prototype.intersects=function(J,de){if(!(J instanceof he))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new pe(J.value,de),We(this.value,ge,de);if(J.operator==="")return ge=new pe(this.value,de),We(J.semver,ge,de);var ke=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),Ae=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Be=this.semver.version===J.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Fe=re(this.semver,"<",J.semver,de)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),$e=re(this.semver,">",J.semver,de)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return ke||Ae||Be&&Te||Fe||$e},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(J){var de=this.loose;J=J.trim(),I("range",J,de);var ge=de?P[U]:P[T];J=J.replace(ge,Ee),I("hyphen replace",J),J=J.replace(P[B],"$1$2$3"),I("comparator trim",J,P[B]),J=(J=(J=J.replace(P[_],"$1~")).replace(P[ue],"$1^")).split(/\s+/).join(" ");var ke=de?P[Y]:P[G],Ae=J.split(" ").map(function(Be){return function(Te,Fe){return I("comp",Te),Te=function($e,He){return $e.trim().split(/\s+/).map(function(Ke){return function(xe,te){I("caret",xe,te);var fe=te?P[le]:P[ee];return xe.replace(fe,function(we,be,Ce,Oe,Ue){var Ge;return I("caret",xe,we,be,Ce,Oe,Ue),ye(be)?Ge="":ye(Ce)?Ge=">="+be+".0.0 <"+(+be+1)+".0.0":ye(Oe)?Ge=be==="0"?">="+be+"."+Ce+".0 <"+be+"."+(+Ce+1)+".0":">="+be+"."+Ce+".0 <"+(+be+1)+".0.0":Ue?(I("replaceCaret pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ge=be==="0"?Ce==="0"?">="+be+"."+Ce+"."+Oe+Ue+" <"+be+"."+Ce+"."+(+Oe+1):">="+be+"."+Ce+"."+Oe+Ue+" <"+be+"."+(+Ce+1)+".0":">="+be+"."+Ce+"."+Oe+Ue+" <"+(+be+1)+".0.0"):(I("no pr"),Ge=be==="0"?Ce==="0"?">="+be+"."+Ce+"."+Oe+" <"+be+"."+Ce+"."+(+Oe+1):">="+be+"."+Ce+"."+Oe+" <"+be+"."+(+Ce+1)+".0":">="+be+"."+Ce+"."+Oe+" <"+(+be+1)+".0.0"),I("caret return",Ge),Ge})}(Ke,He)}).join(" ")}(Te,Fe),I("caret",Te),Te=function($e,He){return $e.trim().split(/\s+/).map(function(Ke){return function(xe,te){var fe=te?P[x]:P[F];return xe.replace(fe,function(we,be,Ce,Oe,Ue){var Ge;return I("tilde",xe,we,be,Ce,Oe,Ue),ye(be)?Ge="":ye(Ce)?Ge=">="+be+".0.0 <"+(+be+1)+".0.0":ye(Oe)?Ge=">="+be+"."+Ce+".0 <"+be+"."+(+Ce+1)+".0":Ue?(I("replaceTilde pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ge=">="+be+"."+Ce+"."+Oe+Ue+" <"+be+"."+(+Ce+1)+".0"):Ge=">="+be+"."+Ce+"."+Oe+" <"+be+"."+(+Ce+1)+".0",I("tilde return",Ge),Ge})}(Ke,He)}).join(" ")}(Te,Fe),I("tildes",Te),Te=function($e,He){return I("replaceXRanges",$e,He),$e.split(/\s+/).map(function(Ke){return function(xe,te){xe=xe.trim();var fe=te?P[D]:P[M];return xe.replace(fe,function(we,be,Ce,Oe,Ue,Ge){I("xRange",xe,we,be,Ce,Oe,Ue,Ge);var Je=ye(Ce),Xe=Je||ye(Oe),Ye=Xe||ye(Ue);return be==="="&&Ye&&(be=""),Je?we=be===">"||be==="<"?"<0.0.0":"*":be&&Ye?(Xe&&(Oe=0),Ye&&(Ue=0),be===">"?(be=">=",Xe?(Ce=+Ce+1,Oe=0,Ue=0):Ye&&(Oe=+Oe+1,Ue=0)):be==="<="&&(be="<",Xe?Ce=+Ce+1:Oe=+Oe+1),we=be+Ce+"."+Oe+"."+Ue):Xe?we=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Ye&&(we=">="+Ce+"."+Oe+".0 <"+Ce+"."+(+Oe+1)+".0"),I("xRange return",we),we})}(Ke,He)}).join(" ")}(Te,Fe),I("xrange",Te),Te=function($e,He){return I("replaceStars",$e,He),$e.trim().replace(P[$],"")}(Te,Fe),I("stars",Te),Te}(Be,de)}).join(" ").split(/\s+/);return this.loose&&(Ae=Ae.filter(function(Be){return!!Be.match(ke)})),Ae=Ae.map(function(Be){return new he(Be,de)})},pe.prototype.intersects=function(J,de){if(!(J instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(ke){return J.set.some(function(Ae){return Ae.every(function(Be){return ke.intersects(Be,de)})})})})},e.toComparators=function(J,de){return new pe(J,de).set.map(function(ge){return ge.map(function(ke){return ke.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new ce(J,this.loose));for(var de=0;de<this.set.length;de++)if(Pe(this.set[de],J))return!0;return!1},e.satisfies=We,e.maxSatisfying=function(J,de,ge){var ke=null,Ae=null;try{var Be=new pe(de,ge)}catch{return null}return J.forEach(function(Te){Be.test(Te)&&(ke&&Ae.compare(Te)!==-1||(Ae=new ce(ke=Te,ge)))}),ke},e.minSatisfying=function(J,de,ge){var ke=null,Ae=null;try{var Be=new pe(de,ge)}catch{return null}return J.forEach(function(Te){Be.test(Te)&&(ke&&Ae.compare(Te)!==1||(Ae=new ce(ke=Te,ge)))}),ke},e.validRange=function(J,de){try{return new pe(J,de).range||"*"}catch{return null}},e.ltr=function(J,de,ge){return ve(J,de,"<",ge)},e.gtr=function(J,de,ge){return ve(J,de,">",ge)},e.outside=ve,e.prerelease=function(J,de){var ge=V(J,de);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(J,de,ge){return J=new pe(J,ge),de=new pe(de,ge),J.intersects(de)},e.coerce=function(J){if(J instanceof ce)return J;if(typeof J!="string")return null;var de=J.match(P[W]);return de==null?null:V((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,n(1))},function(Q,e){var n,R,I=Q.exports={};function A(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function P(w){if(n===setTimeout)return setTimeout(w,0);if((n===A||!n)&&setTimeout)return n=setTimeout,setTimeout(w,0);try{return n(w,0)}catch{try{return n.call(null,w,0)}catch{return n.call(this,w,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:A}catch{n=A}try{R=typeof clearTimeout=="function"?clearTimeout:k}catch{R=k}})();var h,l=[],f=!1,S=-1;function b(){f&&h&&(f=!1,h.length?l=h.concat(l):S=-1,l.length&&g())}function g(){if(!f){var w=P(b);f=!0;for(var m=l.length;m;){for(h=l,l=[];++S<m;)h&&h[S].run();S=-1,m=l.length}h=null,f=!1,function(c){if(R===clearTimeout)return clearTimeout(c);if((R===k||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(c);try{R(c)}catch{try{return R.call(null,c)}catch{return R.call(this,c)}}}(w)}}function d(w,m){this.fun=w,this.array=m}function y(){}I.nextTick=function(w){var m=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)m[c-1]=arguments[c];l.push(new d(w,m)),l.length!==1||f||P(g)},d.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=y,I.addListener=y,I.once=y,I.off=y,I.removeListener=y,I.removeAllListeners=y,I.emit=y,I.prependListener=y,I.prependOnceListener=y,I.listeners=function(w){return[]},I.binding=function(w){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(w){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(se[142],oe([0,1]),function(Q,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class R{constructor(P,h,l){this.level=P,this.key=h,this.value=l,this.forward=[]}}const I=void 0;class A{constructor(P,h=2**16){this.comparator=P,this[n]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(h)|0),this._header=new R(this._maxLevel,I,I)}get size(){return this._size}clear(){this._header=new R(this._maxLevel,I,I),this._size=0}has(P){return!!A._search(this,P,this.comparator)}get(P){return A._search(this,P,this.comparator)?.value}set(P,h){return A._insert(this,P,h,this.comparator)&&(this._size+=1),this}delete(P){const h=A._delete(this,P,this.comparator);return h&&(this._size-=1),h}forEach(P,h){let l=this._header.forward[0];for(;l;)P.call(h,l.value,l.key,this),l=l.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",h=this._header.forward[0];for(;h;)P+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return P}static _search(P,h,l){let f=P._header;for(let S=P._level-1;S>=0;S--)for(;f.forward[S]&&l(f.forward[S].key,h)<0;)f=f.forward[S];if(f=f.forward[0],f&&l(f.key,h)===0)return f}static _insert(P,h,l,f){const S=[];let b=P._header;for(let g=P._level-1;g>=0;g--){for(;b.forward[g]&&f(b.forward[g].key,h)<0;)b=b.forward[g];S[g]=b}if(b=b.forward[0],b&&f(b.key,h)===0)return b.value=l,!1;{const g=A._randomLevel(P);if(g>P._level){for(let d=P._level;d<g;d++)S[d]=P._header;P._level=g}b=new R(g,h,l);for(let d=0;d<g;d++)b.forward[d]=S[d].forward[d],S[d].forward[d]=b;return!0}}static _randomLevel(P,h=.5){let l=1;for(;Math.random()<h&&l<P._maxLevel;)l+=1;return l}static _delete(P,h,l){const f=[];let S=P._header;for(let b=P._level-1;b>=0;b--){for(;S.forward[b]&&l(S.forward[b].key,h)<0;)S=S.forward[b];f[b]=S}if(S=S.forward[0],!S||l(S.key,h)!==0)return!1;for(let b=0;b<P._level&&f[b].forward[b]===S;b++)f[b].forward[b]=S.forward[b];for(;P._level>0&&P._header.forward[P._level-1]===I;)P._level-=1;return!0}}e.SkipList=A}),define(se[73],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(A){return new R(A)}constructor(A){this._now=n&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=R}),define(se[3],oe([0,1,15,86,2,104,73]),function(Q,e,n,R,I,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=g;const P=!1,h=!1,l=!1;var f;(function(_){_.None=()=>I.Disposable.None;function F(pe){if(l){const{onDidAddListener:ye}=pe,Ee=y.create();let Pe=0;pe.onDidAddListener=()=>{++Pe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ee.print()),ye?.()}}}function x(pe,ye){return $(pe,()=>{},0,void 0,!0,void 0,ye)}_.defer=x;function z(pe){return(ye,Ee=null,Pe)=>{let We=!1,ve;return ve=pe(J=>{if(!We)return ve?ve.dispose():We=!0,ye.call(Ee,J)},null,Pe),We&&ve.dispose(),ve}}_.once=z;function ue(pe,ye,Ee){return T((Pe,We=null,ve)=>pe(J=>Pe.call(We,ye(J)),null,ve),Ee)}_.map=ue;function ee(pe,ye,Ee){return T((Pe,We=null,ve)=>pe(J=>{ye(J),Pe.call(We,J)},null,ve),Ee)}_.forEach=ee;function le(pe,ye,Ee){return T((Pe,We=null,ve)=>pe(J=>ye(J)&&Pe.call(We,J),null,ve),Ee)}_.filter=le;function Y(pe){return pe}_.signal=Y;function G(...pe){return(ye,Ee=null,Pe)=>{const We=(0,I.combinedDisposable)(...pe.map(ve=>ve(J=>ye.call(Ee,J))));return U(We,Pe)}}_.any=G;function B(pe,ye,Ee,Pe){let We=Ee;return ue(pe,ve=>(We=ye(We,ve),We),Pe)}_.reduce=B;function T(pe,ye){let Ee;const Pe={onWillAddFirstListener(){Ee=pe(We.fire,We)},onDidRemoveLastListener(){Ee?.dispose()}};ye||F(Pe);const We=new a(Pe);return ye?.add(We),We.event}function U(pe,ye){return ye instanceof Array?ye.push(pe):ye&&ye.add(pe),pe}function $(pe,ye,Ee=100,Pe=!1,We=!1,ve,J){let de,ge,ke,Ae=0,Be;const Te={leakWarningThreshold:ve,onWillAddFirstListener(){de=pe($e=>{Ae++,ge=ye(ge,$e),Pe&&!ke&&(Fe.fire(ge),ge=void 0),Be=()=>{const He=ge;ge=void 0,ke=void 0,(!Pe||Ae>1)&&Fe.fire(He),Ae=0},typeof Ee=="number"?(clearTimeout(ke),ke=setTimeout(Be,Ee)):ke===void 0&&(ke=0,queueMicrotask(Be))})},onWillRemoveListener(){We&&Ae>0&&Be?.()},onDidRemoveLastListener(){Be=void 0,de.dispose()}};J||F(Te);const Fe=new a(Te);return J?.add(Fe),Fe.event}_.debounce=$;function ae(pe,ye=0,Ee){return _.debounce(pe,(Pe,We)=>Pe?(Pe.push(We),Pe):[We],ye,void 0,!0,void 0,Ee)}_.accumulate=ae;function V(pe,ye=(Pe,We)=>Pe===We,Ee){let Pe=!0,We;return le(pe,ve=>{const J=Pe||!ye(ve,We);return Pe=!1,We=ve,J},Ee)}_.latch=V;function ce(pe,ye,Ee){return[_.filter(pe,ye,Ee),_.filter(pe,Pe=>!ye(Pe),Ee)]}_.split=ce;function X(pe,ye=!1,Ee=[],Pe){let We=Ee.slice(),ve=pe(ge=>{We?We.push(ge):de.fire(ge)});Pe&&Pe.add(ve);const J=()=>{We?.forEach(ge=>de.fire(ge)),We=null},de=new a({onWillAddFirstListener(){ve||(ve=pe(ge=>de.fire(ge)),Pe&&Pe.add(ve))},onDidAddFirstListener(){We&&(ye?setTimeout(J):J())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return Pe&&Pe.add(de),de.event}_.buffer=X;function L(pe,ye){return(Pe,We,ve)=>{const J=ye(new Z);return pe(function(de){const ge=J.evaluate(de);ge!==N&&Pe.call(We,ge)},void 0,ve)}}_.chain=L;const N=Symbol("HaltChainable");class Z{constructor(){this.steps=[]}map(ye){return this.steps.push(ye),this}forEach(ye){return this.steps.push(Ee=>(ye(Ee),Ee)),this}filter(ye){return this.steps.push(Ee=>ye(Ee)?Ee:N),this}reduce(ye,Ee){let Pe=Ee;return this.steps.push(We=>(Pe=ye(Pe,We),Pe)),this}latch(ye=(Ee,Pe)=>Ee===Pe){let Ee=!0,Pe;return this.steps.push(We=>{const ve=Ee||!ye(We,Pe);return Ee=!1,Pe=We,ve?We:N}),this}evaluate(ye){for(const Ee of this.steps)if(ye=Ee(ye),ye===N)break;return ye}}function ne(pe,ye,Ee=Pe=>Pe){const Pe=(...de)=>J.fire(Ee(...de)),We=()=>pe.on(ye,Pe),ve=()=>pe.removeListener(ye,Pe),J=new a({onWillAddFirstListener:We,onDidRemoveLastListener:ve});return J.event}_.fromNodeEventEmitter=ne;function K(pe,ye,Ee=Pe=>Pe){const Pe=(...de)=>J.fire(Ee(...de)),We=()=>pe.addEventListener(ye,Pe),ve=()=>pe.removeEventListener(ye,Pe),J=new a({onWillAddFirstListener:We,onDidRemoveLastListener:ve});return J.event}_.fromDOMEventEmitter=K;function H(pe){return new Promise(ye=>z(pe)(ye))}_.toPromise=H;function j(pe){const ye=new a;return pe.then(Ee=>{ye.fire(Ee)},()=>{ye.fire(void 0)}).finally(()=>{ye.dispose()}),ye.event}_.fromPromise=j;function q(pe,ye,Ee){return ye(Ee),pe(Pe=>ye(Pe))}_.runAndSubscribe=q;class re{constructor(ye,Ee){this._observable=ye,this._counter=0,this._hasChanged=!1;const Pe={onWillAddFirstListener:()=>{ye.addObserver(this)},onDidRemoveLastListener:()=>{ye.removeObserver(this)}};Ee||F(Pe),this.emitter=new a(Pe),Ee&&Ee.add(this.emitter)}beginUpdate(ye){this._counter++}handlePossibleChange(ye){}handleChange(ye,Ee){this._hasChanged=!0}endUpdate(ye){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function he(pe,ye){return new re(pe,ye).emitter.event}_.fromObservable=he;function me(pe){return(ye,Ee,Pe)=>{let We=0,ve=!1;const J={beginUpdate(){We++},endUpdate(){We--,We===0&&(pe.reportChanges(),ve&&(ve=!1,ye.call(Ee)))},handlePossibleChange(){},handleChange(){ve=!0}};pe.addObserver(J),pe.reportChanges();const de={dispose(){pe.removeObserver(J)}};return Pe instanceof I.DisposableStore?Pe.add(de):Array.isArray(Pe)&&Pe.push(de),de}}_.fromObservableLight=me})(f||(e.Event=f={}));class S{static{this.all=new Set}static{this._idPool=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${S._idPool++}`,S.all.add(this)}start(F){this._stopWatch=new k.StopWatch,this.listenerCount=F}stop(){if(this._stopWatch){const F=this._stopWatch.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=S;let b=-1;function g(_){const F=b;return b=_,{dispose(){b=F}}}class d{constructor(F,x=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=x,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(F,x){const z=this.threshold;if(z<=0||x<z)return;this._stacks||(this._stacks=new Map);const ue=this._stacks.get(F.value)||0;if(this._stacks.set(F.value,ue+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=z*.5;let ee,le=0;for(const[Y,G]of this._stacks)(!ee||le<G)&&(ee=Y,le=G);console.warn(`[${this.name}] potential listener LEAK detected, having ${x} listeners already. MOST frequent listener (${le}):`),console.warn(ee)}return()=>{const ee=this._stacks.get(F.value)||0;this._stacks.set(F.value,ee-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class m{constructor(F){this.value=F,this.id=w++}}const c=2,v=(_,F)=>{if(_ instanceof m)F(_);else for(let x=0;x<_.length;x++){const z=_[x];z&&F(z)}},E=P?new FinalizationRegistry(_=>{typeof _=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(_))}):void 0;class a{constructor(F){this._size=0,this._options=F,this._leakageMon=b>0||this._options?.leakWarningThreshold?new d(this._options?.leakWarningThreshold??b):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(h){const F=this._listeners;queueMicrotask(()=>{v(F,x=>x.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(F,x,z)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),I.Disposable.None;if(this._disposed)return I.Disposable.None;x&&(F=F.bind(x));const ue=new m(F);let ee,le;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(ue.stack=y.create(),ee=this._leakageMon.check(ue.stack,this._size+1)),h&&(ue.stack=le??y.create()),this._listeners?this._listeners instanceof m?(this._deliveryQueue??=new s,this._listeners=[this._listeners,ue]):this._listeners.push(ue):(this._options?.onWillAddFirstListener?.(this),this._listeners=ue,this._options?.onDidAddFirstListener?.(this)),this._size++;const Y=(0,I.toDisposable)(()=>{E?.unregister(Y),ee?.(),this._removeListener(ue)});if(z instanceof I.DisposableStore?z.add(Y):Array.isArray(z)&&z.push(Y),E){const G=new Error().stack.split(`
`).slice(2).join(`
`).trim();E.register(Y,G,Y)}return Y},this._event}_removeListener(F){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const x=this._listeners,z=x.indexOf(F);if(z===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,x[z]=void 0;const ue=this._deliveryQueue.current===this;if(this._size*c<=x.length){let ee=0;for(let le=0;le<x.length;le++)x[le]?x[ee++]=x[le]:ue&&(this._deliveryQueue.end--,ee<this._deliveryQueue.i&&this._deliveryQueue.i--);x.length=ee}}_deliver(F,x){if(!F)return;const z=this._options?.onListenerError||n.onUnexpectedError;if(!z){F.value(x);return}try{F.value(x)}catch(ue){z(ue)}}_deliverQueue(F){const x=F.current._listeners;for(;F.i<F.end;)this._deliver(x[F.i++],F.value);F.reset()}fire(F){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof m)this._deliver(this._listeners,F);else{const x=this._deliveryQueue;x.enqueue(this,F,this._listeners.length),this._deliverQueue(x)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=a;const t=()=>new s;e.createEventDeliveryQueue=t;class s{constructor(){this.i=-1,this.end=0}enqueue(F,x,z){this.i=0,this.end=z,this.current=F,this.value=x}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends a{async fireAsync(F,x,z){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList),v(this._listeners,ue=>this._asyncDeliveryQueue.push([ue.value,F]));this._asyncDeliveryQueue.size>0&&!x.isCancellationRequested;){const[ue,ee]=this._asyncDeliveryQueue.shift(),le=[],Y={...ee,token:x,waitUntil:G=>{if(Object.isFrozen(le))throw new Error("waitUntil can NOT be called asynchronous");z&&(G=z(G,ue)),le.push(G)}};try{ue(Y)}catch(G){(0,n.onUnexpectedError)(G);continue}Object.freeze(le),await Promise.allSettled(le).then(G=>{for(const B of G)B.status==="rejected"&&(0,n.onUnexpectedError)(B.reason)})}}}e.AsyncEmitter=r;class i extends a{get isPaused(){return this._isPaused!==0}constructor(F){super(F),this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=F?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const F=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(F))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(F){this._size&&(this._isPaused!==0?this._eventQueue.push(F):super.fire(F))}}e.PauseableEmitter=i;class o extends i{constructor(F){super(F),this._delay=F.delay??100}fire(F){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(F)}}e.DebounceEmitter=o;class u extends a{constructor(F){super(F),this._queuedEvents=[],this._mergeFn=F?.merge}fire(F){this.hasListeners()&&(this._queuedEvents.push(F),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(x=>super.fire(x)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=u;class p{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new a({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(F){const x={event:F,listener:null};this.events.push(x),this.hasListeners&&this.hook(x);const z=()=>{this.hasListeners&&this.unhook(x);const ue=this.events.indexOf(x);this.events.splice(ue,1)};return(0,I.toDisposable)((0,R.createSingleCallFunction)(z))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(F=>this.hook(F))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(F=>this.unhook(F))}hook(F){F.listener=F.event(x=>this.emitter.fire(x))}unhook(F){F.listener?.dispose(),F.listener=null}dispose(){this.emitter.dispose();for(const F of this.events)F.listener?.dispose();this.events=[]}}e.EventMultiplexer=p;class C{constructor(F,x,z,ue){this._store=new I.DisposableStore;const ee=this._store.add(new p),le=this._store.add(new I.DisposableMap);function Y(G){le.set(G,ee.add(ue(G)))}for(const G of F)Y(G);this._store.add(x(G=>{Y(G)})),this._store.add(z(G=>{le.deleteAndDispose(G)})),this.event=ee.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=C;class M{constructor(){this.buffers=[]}wrapEvent(F){return(x,z,ue)=>F(ee=>{const le=this.buffers[this.buffers.length-1];le?le.push(()=>x.call(z,ee)):x.call(z,ee)},void 0,ue)}bufferEvents(F){const x=[];this.buffers.push(x);const z=F();return this.buffers.pop(),x.forEach(ue=>ue()),z}}e.EventBufferer=M;class D{constructor(){this.listening=!1,this.inputEvent=f.None,this.inputEventListener=I.Disposable.None,this.emitter=new a({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(F){this.inputEvent=F,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=F(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=D;class W{static const(F){return new O(F)}constructor(F){this._value=F,this._onDidChange=new a,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(F){F!==this._value&&(this._value=F,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=W;class O{constructor(F){this.value=F,this.onDidChange=f.None}}}),define(se[23],oe([0,1,3]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=P;const R=Object.freeze(function(h,l){const f=setTimeout(h.bind(l),0);return{dispose(){clearTimeout(f)}}});var I;(function(h){function l(f){return f===h.None||f===h.Cancelled||f instanceof A?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}h.isCancellationToken=l,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(I||(e.CancellationToken=I={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new n.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(l){this._token=void 0,this._parentListener=void 0,this._parentListener=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=I.Cancelled}dispose(l=!1){l&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=k;function P(h){const l=new k;return h.add({dispose(){l.cancel()}}),l.token}}),define(se[143],oe([0,1,23]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=I;class R{constructor(h){this.task=h,this.result=null}get(){if(this.result)return this.result;const h=new n.CancellationTokenSource,l=this.task(h.token);return this.result={promise:l,dispose:()=>{this.result=null,h.cancel(),h.dispose()}},this.result}}e.Cache=R;function I(P){return P}class A{constructor(h,l){this.lastCache=void 0,this.lastArgKey=void 0,typeof h=="function"?(this._fn=h,this._computeKey=I):(this._fn=l,this._computeKey=h.getCacheKey)}get(h){const l=this._computeKey(h);return this.lastArgKey!==l&&(this.lastArgKey=l,this.lastCache=this._fn(h)),this.lastCache}}e.LRUCachedFunction=A;class k{get cachedValues(){return this._map}constructor(h,l){this._map=new Map,this._map2=new Map,typeof h=="function"?(this._fn=h,this._computeKey=I):(this._fn=l,this._computeKey=h.getCacheKey)}get(h){const l=this._computeKey(h);if(this._map2.has(l))return this._map2.get(l);const f=this._fn(h);return this._map.set(h,f),this._map2.set(l,f),f}}e.CachedFunction=k}),define(se[63],oe([0,1,15,2]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=I,e.isReadableStream=A,e.isReadableBufferedStream=k,e.newWriteableStream=P,e.consumeReadable=l,e.peekReadable=f,e.consumeStream=S,e.listenStream=b,e.peekStream=g,e.toStream=d,e.emptyStream=y,e.toReadable=w,e.transform=m,e.prefixedReadable=c,e.prefixedStream=v;function I(E){const a=E;return a?typeof a.read=="function":!1}function A(E){const a=E;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}function k(E){const a=E;return a?A(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}function P(E,a){return new h(E,a)}class h{constructor(a,t){this.reducer=a,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a<"u"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(t=>t(a))}emitError(a){this.listeners.error.length===0?(0,n.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(t=>t(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,t){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(a,t){if(this.state.destroyed)return;let s;switch(a){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const r=s.indexOf(t);r>=0&&s.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(E,a){const t=[];let s;for(;(s=E.read())!==null;)t.push(s);return a(t)}function f(E,a,t){const s=[];let r;for(;(r=E.read())!==null&&s.length<t;)s.push(r);return r===null&&s.length>0?a(s):{read:()=>{if(s.length>0)return s.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return E.read()}}}function S(E,a){return new Promise((t,s)=>{const r=[];b(E,{onData:i=>{a&&r.push(i)},onError:i=>{a?s(i):t(void 0)},onEnd:()=>{t(a?a(r):void 0)}})})}function b(E,a,t){E.on("error",s=>{t?.isCancellationRequested||a.onError(s)}),E.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),E.on("data",s=>{t?.isCancellationRequested||a.onData(s)})}function g(E,a){return new Promise((t,s)=>{const r=new R.DisposableStore,i=[],o=C=>{if(i.push(C),i.length>a)return r.dispose(),E.pause(),t({stream:E,buffer:i,ended:!1})},u=C=>(r.dispose(),s(C)),p=()=>(r.dispose(),t({stream:E,buffer:i,ended:!0}));r.add((0,R.toDisposable)(()=>E.removeListener("error",u))),E.on("error",u),r.add((0,R.toDisposable)(()=>E.removeListener("end",p))),E.on("end",p),r.add((0,R.toDisposable)(()=>E.removeListener("data",o))),E.on("data",o)})}function d(E,a){const t=P(a);return t.end(E),t}function y(){const E=P(()=>{throw new Error("not supported")});return E.end(),E}function w(E){let a=!1;return{read:()=>a?null:(a=!0,E)}}function m(E,a,t){const s=P(t);return b(E,{onData:r=>s.write(a.data(r)),onError:r=>s.error(a.error?a.error(r):r),onEnd:()=>s.end()}),s}function c(E,a,t){let s=!1;return{read:()=>{const r=a.read();return s?r:(s=!0,r!==null?t([E,r]):E)}}}function v(E,a,t){let s=!1;const r=P(t);return b(a,{onData:i=>s?r.write(i):(s=!0,r.write(t([E,i]))),onError:i=>r.error(i),onEnd:()=>{s||(s=!0,r.write(E)),r.end()}}),r}}),define(se[17],oe([0,1,62,63]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=l,e.readUInt16LE=f,e.writeUInt16LE=S,e.readUInt32BE=b,e.writeUInt32BE=g,e.readUInt32LE=d,e.writeUInt32LE=y,e.readUInt8=w,e.writeUInt8=m,e.readableToBuffer=c,e.bufferToReadable=v,e.streamToBuffer=E,e.bufferedStreamToBuffer=a,e.bufferToStream=t,e.streamToBufferReadableStream=s,e.newWriteableBufferStream=r,e.prefixedBufferReadable=i,e.prefixedBufferStream=o,e.decodeBase64=u,e.encodeBase64=M;const I=typeof Buffer<"u",A=new n.Lazy(()=>new Uint8Array(256));let k,P;class h{static alloc(W){return I?new h(Buffer.allocUnsafe(W)):new h(new Uint8Array(W))}static wrap(W){return I&&!Buffer.isBuffer(W)&&(W=Buffer.from(W.buffer,W.byteOffset,W.byteLength)),new h(W)}static fromString(W,O){return!(O?.dontUseNodeBuffer||!1)&&I?new h(Buffer.from(W)):(k||(k=new TextEncoder),new h(k.encode(W)))}static fromByteArray(W){const O=h.alloc(W.length);for(let _=0,F=W.length;_<F;_++)O.buffer[_]=W[_];return O}static concat(W,O){if(typeof O>"u"){O=0;for(let x=0,z=W.length;x<z;x++)O+=W[x].byteLength}const _=h.alloc(O);let F=0;for(let x=0,z=W.length;x<z;x++){const ue=W[x];_.set(ue,F),F+=ue.byteLength}return _}constructor(W){this.buffer=W,this.byteLength=this.buffer.byteLength}clone(){const W=h.alloc(this.byteLength);return W.set(this),W}toString(){return I?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(W,O){return new h(this.buffer.subarray(W,O))}set(W,O){if(W instanceof h)this.buffer.set(W.buffer,O);else if(W instanceof Uint8Array)this.buffer.set(W,O);else if(W instanceof ArrayBuffer)this.buffer.set(new Uint8Array(W),O);else if(ArrayBuffer.isView(W))this.buffer.set(new Uint8Array(W.buffer,W.byteOffset,W.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(W){return b(this.buffer,W)}writeUInt32BE(W,O){g(this.buffer,W,O)}readUInt32LE(W){return d(this.buffer,W)}writeUInt32LE(W,O){y(this.buffer,W,O)}readUInt8(W){return w(this.buffer,W)}writeUInt8(W,O){m(this.buffer,W,O)}indexOf(W,O=0){return l(this.buffer,W instanceof h?W.buffer:W,O)}}e.VSBuffer=h;function l(D,W,O=0){const _=W.byteLength,F=D.byteLength;if(_===0)return 0;if(_===1)return D.indexOf(W[0]);if(_>F-O)return-1;const x=A.value;x.fill(W.length);for(let le=0;le<W.length;le++)x[W[le]]=W.length-le-1;let z=O+W.length-1,ue=z,ee=-1;for(;z<F;)if(D[z]===W[ue]){if(ue===0){ee=z;break}z--,ue--}else z+=Math.max(W.length-ue,x[D[z]]),ue=W.length-1;return ee}function f(D,W){return D[W+0]<<0>>>0|D[W+1]<<8>>>0}function S(D,W,O){D[O+0]=W&255,W=W>>>8,D[O+1]=W&255}function b(D,W){return D[W]*2**24+D[W+1]*2**16+D[W+2]*2**8+D[W+3]}function g(D,W,O){D[O+3]=W,W=W>>>8,D[O+2]=W,W=W>>>8,D[O+1]=W,W=W>>>8,D[O]=W}function d(D,W){return D[W+0]<<0>>>0|D[W+1]<<8>>>0|D[W+2]<<16>>>0|D[W+3]<<24>>>0}function y(D,W,O){D[O+0]=W&255,W=W>>>8,D[O+1]=W&255,W=W>>>8,D[O+2]=W&255,W=W>>>8,D[O+3]=W&255}function w(D,W){return D[W]}function m(D,W,O){D[O]=W}function c(D){return R.consumeReadable(D,W=>h.concat(W))}function v(D){return R.toReadable(D)}function E(D){return R.consumeStream(D,W=>h.concat(W))}async function a(D){return D.ended?h.concat(D.buffer):h.concat([...D.buffer,await E(D.stream)])}function t(D){return R.toStream(D,W=>h.concat(W))}function s(D){return R.transform(D,{data:W=>typeof W=="string"?h.fromString(W):h.wrap(W)},W=>h.concat(W))}function r(D){return R.newWriteableStream(W=>h.concat(W),D)}function i(D,W){return R.prefixedReadable(D,W,O=>h.concat(O))}function o(D,W){return R.prefixedStream(D,W,O=>h.concat(O))}function u(D){let W=0,O=0,_=0;const F=new Uint8Array(Math.floor(D.length/4*3)),x=ue=>{switch(O){case 3:F[_++]=W|ue,O=0;break;case 2:F[_++]=W|ue>>>2,W=ue<<6,O=3;break;case 1:F[_++]=W|ue>>>4,W=ue<<4,O=2;break;default:W=ue<<2,O=1}};for(let ue=0;ue<D.length;ue++){const ee=D.charCodeAt(ue);if(ee>=65&&ee<=90)x(ee-65);else if(ee>=97&&ee<=122)x(ee-97+26);else if(ee>=48&&ee<=57)x(ee-48+52);else if(ee===43||ee===45)x(62);else if(ee===47||ee===95)x(63);else{if(ee===61)break;throw new SyntaxError(`Unexpected base64 character ${D[ue]}`)}}const z=_;for(;O>0;)x(0);return h.wrap(F).slice(0,z)}const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function M({buffer:D},W=!0,O=!1){const _=O?C:p;let F="";const x=D.byteLength%3;let z=0;for(;z<D.byteLength-x;z+=3){const ue=D[z+0],ee=D[z+1],le=D[z+2];F+=_[ue>>>2],F+=_[(ue<<4|ee>>>4)&63],F+=_[(ee<<2|le>>>6)&63],F+=_[le&63]}if(x===1){const ue=D[z+0];F+=_[ue>>>2],F+=_[ue<<4&63],W&&(F+="==")}else if(x===2){const ue=D[z+0],ee=D[z+1];F+=_[ue>>>2],F+=_[(ue<<4|ee>>>4)&63],F+=_[ee<<2&63],W&&(F+="=")}return F}}),define(se[25],oe([0,1,143,62]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=I,e.format=k,e.format2=h,e.htmlAttributeEncodeValue=l,e.escape=f,e.escapeRegExpCharacters=S,e.count=b,e.truncate=g,e.truncateMiddle=d,e.trim=y,e.ltrim=w,e.rtrim=m,e.convertSimple2RegExpPattern=c,e.stripWildcards=v,e.createRegExp=E,e.regExpLeadsToEndlessLoop=a,e.splitLines=t,e.splitLinesIncludeSeparators=s,e.firstNonWhitespaceIndex=r,e.getLeadingWhitespace=i,e.lastNonWhitespaceIndex=o,e.replaceAsync=u,e.compare=p,e.compareSubstring=C,e.compareIgnoreCase=M,e.compareSubstringIgnoreCase=D,e.isAsciiDigit=W,e.isLowerAsciiLetter=O,e.isUpperAsciiLetter=_,e.equalsIgnoreCase=F,e.startsWithIgnoreCase=x,e.commonPrefixLength=z,e.commonSuffixLength=ue,e.isHighSurrogate=ee,e.isLowSurrogate=le,e.computeCodePoint=Y,e.getNextCodePoint=G,e.nextCharLength=$,e.prevCharLength=ae,e.getCharContainingOffset=V,e.charCount=ce,e.containsRTL=N,e.isBasicASCII=ne,e.containsUnusualLineTerminators=K,e.isFullWidthCharacter=H,e.isEmojiImprecise=j,e.lcut=q,e.forAnsiStringParts=he,e.removeAnsiEscapeCodes=me,e.startsWithUTF8BOM=pe,e.stripUTF8BOM=ye,e.fuzzyContains=Ee,e.containsUppercaseCharacter=Pe,e.uppercaseFirstLetter=We,e.getNLines=ve,e.singleLetterHash=J,e.getGraphemeBreakType=de,e.getLeftDeleteOffset=Te;function I(te){return!te||typeof te!="string"?!0:te.trim().length===0}const A=/{(\d+)}/g;function k(te,...fe){return fe.length===0?te:te.replace(A,function(we,be){const Ce=parseInt(be,10);return isNaN(Ce)||Ce<0||Ce>=fe.length?we:fe[Ce]})}const P=/{([^}]+)}/g;function h(te,fe){return Object.keys(fe).length===0?te:te.replace(P,(we,be)=>fe[be]??we)}function l(te){return te.replace(/[<>"'&]/g,fe=>{switch(fe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return fe})}function f(te){return te.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}function S(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function b(te,fe){let we=0;const be=fe.charCodeAt(0);for(let Ce=te.length-1;Ce>=0;Ce--)te.charCodeAt(Ce)===be&&we++;return we}function g(te,fe,we="\u2026"){return te.length<=fe?te:`${te.substr(0,fe)}${we}`}function d(te,fe,we="\u2026"){if(te.length<=fe)return te;const be=Math.ceil(fe/2)-we.length/2,Ce=Math.floor(fe/2)-we.length/2;return`${te.substr(0,be)}${we}${te.substr(te.length-Ce)}`}function y(te,fe=" "){const we=w(te,fe);return m(we,fe)}function w(te,fe){if(!te||!fe)return te;const we=fe.length;if(we===0||te.length===0)return te;let be=0;for(;te.indexOf(fe,be)===be;)be=be+we;return te.substring(be)}function m(te,fe){if(!te||!fe)return te;const we=fe.length,be=te.length;if(we===0||be===0)return te;let Ce=be,Oe=-1;for(;Oe=te.lastIndexOf(fe,Ce-1),!(Oe===-1||Oe+we!==Ce);){if(Oe===0)return"";Ce=Oe}return te.substring(0,Ce)}function c(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function v(te){return te.replace(/\*/g,"")}function E(te,fe,we={}){if(!te)throw new Error("Cannot create regex from empty string");fe||(te=S(te)),we.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let be="";return we.global&&(be+="g"),we.matchCase||(be+="i"),we.multiline&&(be+="m"),we.unicode&&(be+="u"),new RegExp(te,be)}function a(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}function t(te){return te.split(/\r\n|\r|\n/)}function s(te){const fe=[],we=te.split(/(\r\n|\r|\n)/);for(let be=0;be<Math.ceil(we.length/2);be++)fe.push(we[2*be]+(we[2*be+1]??""));return fe}function r(te){for(let fe=0,we=te.length;fe<we;fe++){const be=te.charCodeAt(fe);if(be!==32&&be!==9)return fe}return-1}function i(te,fe=0,we=te.length){for(let be=fe;be<we;be++){const Ce=te.charCodeAt(be);if(Ce!==32&&Ce!==9)return te.substring(fe,be)}return te.substring(fe,we)}function o(te,fe=te.length-1){for(let we=fe;we>=0;we--){const be=te.charCodeAt(we);if(be!==32&&be!==9)return we}return-1}function u(te,fe,we){const be=[];let Ce=0;for(const Oe of te.matchAll(fe)){if(be.push(te.slice(Ce,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");Ce=Oe.index+Oe[0].length,be.push(we(Oe[0],...Oe.slice(1),Oe.index,te,Oe.groups))}return be.push(te.slice(Ce)),Promise.all(be).then(Oe=>Oe.join(""))}function p(te,fe){return te<fe?-1:te>fe?1:0}function C(te,fe,we=0,be=te.length,Ce=0,Oe=fe.length){for(;we<be&&Ce<Oe;we++,Ce++){const Je=te.charCodeAt(we),Xe=fe.charCodeAt(Ce);if(Je<Xe)return-1;if(Je>Xe)return 1}const Ue=be-we,Ge=Oe-Ce;return Ue<Ge?-1:Ue>Ge?1:0}function M(te,fe){return D(te,fe,0,te.length,0,fe.length)}function D(te,fe,we=0,be=te.length,Ce=0,Oe=fe.length){for(;we<be&&Ce<Oe;we++,Ce++){let Je=te.charCodeAt(we),Xe=fe.charCodeAt(Ce);if(Je===Xe)continue;if(Je>=128||Xe>=128)return C(te.toLowerCase(),fe.toLowerCase(),we,be,Ce,Oe);O(Je)&&(Je-=32),O(Xe)&&(Xe-=32);const Ye=Je-Xe;if(Ye!==0)return Ye}const Ue=be-we,Ge=Oe-Ce;return Ue<Ge?-1:Ue>Ge?1:0}function W(te){return te>=48&&te<=57}function O(te){return te>=97&&te<=122}function _(te){return te>=65&&te<=90}function F(te,fe){return te.length===fe.length&&D(te,fe)===0}function x(te,fe){const we=fe.length;return fe.length>te.length?!1:D(te,fe,0,we)===0}function z(te,fe){const we=Math.min(te.length,fe.length);let be;for(be=0;be<we;be++)if(te.charCodeAt(be)!==fe.charCodeAt(be))return be;return we}function ue(te,fe){const we=Math.min(te.length,fe.length);let be;const Ce=te.length-1,Oe=fe.length-1;for(be=0;be<we;be++)if(te.charCodeAt(Ce-be)!==fe.charCodeAt(Oe-be))return be;return we}function ee(te){return 55296<=te&&te<=56319}function le(te){return 56320<=te&&te<=57343}function Y(te,fe){return(te-55296<<10)+(fe-56320)+65536}function G(te,fe,we){const be=te.charCodeAt(we);if(ee(be)&&we+1<fe){const Ce=te.charCodeAt(we+1);if(le(Ce))return Y(be,Ce)}return be}function B(te,fe){const we=te.charCodeAt(fe-1);if(le(we)&&fe>1){const be=te.charCodeAt(fe-2);if(ee(be))return Y(be,we)}return we}class T{get offset(){return this._offset}constructor(fe,we=0){this._str=fe,this._len=fe.length,this._offset=we}setOffset(fe){this._offset=fe}prevCodePoint(){const fe=B(this._str,this._offset);return this._offset-=fe>=65536?2:1,fe}nextCodePoint(){const fe=G(this._str,this._len,this._offset);return this._offset+=fe>=65536?2:1,fe}eol(){return this._offset>=this._len}}e.CodePointIterator=T;class U{get offset(){return this._iterator.offset}constructor(fe,we=0){this._iterator=new T(fe,we)}nextGraphemeLength(){const fe=Ae.getInstance(),we=this._iterator,be=we.offset;let Ce=fe.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Oe=we.offset,Ue=fe.getGraphemeBreakType(we.nextCodePoint());if(ge(Ce,Ue)){we.setOffset(Oe);break}Ce=Ue}return we.offset-be}prevGraphemeLength(){const fe=Ae.getInstance(),we=this._iterator,be=we.offset;let Ce=fe.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Oe=we.offset,Ue=fe.getGraphemeBreakType(we.prevCodePoint());if(ge(Ue,Ce)){we.setOffset(Oe);break}Ce=Ue}return be-we.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=U;function $(te,fe){return new U(te,fe).nextGraphemeLength()}function ae(te,fe){return new U(te,fe).prevGraphemeLength()}function V(te,fe){fe>0&&le(te.charCodeAt(fe))&&fe--;const we=fe+$(te,fe);return[we-ae(te,we),we]}function ce(te){const fe=new U(te);let we=0;for(;!fe.eol();)we++,fe.nextGraphemeLength();return we}let X;function L(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(te){return X||(X=L()),X.test(te)}const Z=/^[\t\n\r\x20-\x7E]*$/;function ne(te){return Z.test(te)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function K(te){return e.UNUSUAL_LINE_TERMINATORS.test(te)}function H(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}function j(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}function q(te,fe,we=""){const be=te.trimStart();if(be.length<fe)return be;const Ce=/\b/g;let Oe=0;for(;Ce.test(be)&&!(be.length-Ce.lastIndex<fe);)Oe=Ce.lastIndex,Ce.lastIndex+=1;return Oe===0?be:we+be.substring(Oe).trimStart()}const re=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*he(te){let fe=0;for(const we of te.matchAll(re))fe!==we.index&&(yield{isCode:!1,str:te.substring(fe,we.index)}),yield{isCode:!0,str:we[0]},fe=we.index+we[0].length;fe!==te.length&&(yield{isCode:!1,str:te.substring(fe)})}function me(te){return te&&(te=te.replace(re,"")),te}e.UTF8_BOM_CHARACTER="\uFEFF";function pe(te){return!!(te&&te.length>0&&te.charCodeAt(0)===65279)}function ye(te){return pe(te)?te.substr(1):te}function Ee(te,fe){if(!te||!fe||te.length<fe.length)return!1;const we=fe.length,be=te.toLowerCase();let Ce=0,Oe=-1;for(;Ce<we;){const Ue=be.indexOf(fe[Ce],Oe+1);if(Ue<0)return!1;Oe=Ue,Ce++}return!0}function Pe(te,fe=!1){return te?(fe&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}function We(te){return te.charAt(0).toUpperCase()+te.slice(1)}function ve(te,fe=1){if(fe===0)return"";let we=-1;do we=te.indexOf(`
`,we+1),fe--;while(fe>0&&we>=0);return we===-1?te:(te[we-1]==="\r"&&we--,te.substr(0,we))}function J(te){return te=te%(2*26),te<26?String.fromCharCode(97+te):String.fromCharCode(65+te-26)}function de(te){return Ae.getInstance().getGraphemeBreakType(te)}function ge(te,fe){return te===0?fe!==5&&fe!==7:te===2&&fe===3?!1:te===4||te===2||te===3||fe===4||fe===2||fe===3?!0:!(te===8&&(fe===8||fe===9||fe===11||fe===12)||(te===11||te===9)&&(fe===9||fe===10)||(te===12||te===10)&&fe===10||fe===5||fe===13||fe===7||te===1||te===13&&fe===14||te===6&&fe===6)}var ke;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(ke||(e.GraphemeBreakType=ke={}));class Ae{static{this._INSTANCE=null}static getInstance(){return Ae._INSTANCE||(Ae._INSTANCE=new Ae),Ae._INSTANCE}constructor(){this._data=Be()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const we=this._data,be=we.length/3;let Ce=1;for(;Ce<=be;)if(fe<we[3*Ce])Ce=2*Ce;else if(fe>we[3*Ce+1])Ce=2*Ce+1;else return we[3*Ce+2];return 0}}function Be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(te,fe){if(te===0)return 0;const we=Fe(te,fe);if(we!==void 0)return we;const be=new T(fe,te);return be.prevCodePoint(),be.offset}function Fe(te,fe){const we=new T(fe,te);let be=we.prevCodePoint();for(;$e(be)||be===65039||be===8419;){if(we.offset===0)return;be=we.prevCodePoint()}if(!j(be))return;let Ce=we.offset;return Ce>0&&we.prevCodePoint()===8205&&(Ce=we.offset),Ce}function $e(te){return 127995<=te&&te<=127999}var He;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(He||(He={})),e.noBreakWhitespace="\xA0";class Ke{static{this.ambiguousCharacterData=new R.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new n.LRUCachedFunction({getCacheKey:JSON.stringify},fe=>{function we(Ye){const rt=new Map;for(let it=0;it<Ye.length;it+=2)rt.set(Ye[it],Ye[it+1]);return rt}function be(Ye,rt){const it=new Map(Ye);for(const[ot,at]of rt)it.set(ot,at);return it}function Ce(Ye,rt){if(!Ye)return rt;const it=new Map;for(const[ot,at]of Ye)rt.has(ot)&&it.set(ot,at);return it}const Oe=this.ambiguousCharacterData.value;let Ue=fe.filter(Ye=>!Ye.startsWith("_")&&Ye in Oe);Ue.length===0&&(Ue=["_default"]);let Ge;for(const Ye of Ue){const rt=we(Oe[Ye]);Ge=Ce(Ge,rt)}const Je=we(Oe._common),Xe=be(Je,Ge);return new Ke(Xe)})}static getInstance(fe){return Ke.cache.get(Array.from(fe))}static{this._locales=new R.Lazy(()=>Object.keys(Ke.ambiguousCharacterData.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return Ke._locales.value}constructor(fe){this.confusableDictionary=fe}isAmbiguous(fe){return this.confusableDictionary.has(fe)}getPrimaryConfusable(fe){return this.confusableDictionary.get(fe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ke;class xe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(xe.getRawData())),this._data}static isInvisibleCharacter(fe){return xe.getData().has(fe)}static get codePoints(){return xe.getData()}}e.InvisibleCharacters=xe}),define(se[46],oe([0,1,25]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=R,e.doHash=I,e.numberHash=A,e.stringHash=P,e.toHexString=y;function R(m){return I(m,0)}function I(m,c){switch(typeof m){case"object":return m===null?A(349,c):Array.isArray(m)?h(m,c):l(m,c);case"string":return P(m,c);case"boolean":return k(m,c);case"number":return A(m,c);case"undefined":return A(937,c);default:return A(617,c)}}function A(m,c){return(c<<5)-c+m|0}function k(m,c){return A(m?433:863,c)}function P(m,c){c=A(149417,c);for(let v=0,E=m.length;v<E;v++)c=A(m.charCodeAt(v),c);return c}function h(m,c){return c=A(104579,c),m.reduce((v,E)=>I(E,v),c)}function l(m,c){return c=A(181387,c),Object.keys(m).sort().reduce((v,E)=>(v=P(E,v),I(m[E],v)),c)}class f{constructor(){this._value=0}get value(){return this._value}hash(c){return this._value=I(c,this._value),this._value}}e.Hasher=f;var S;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function b(m,c,v=32){const E=v-c,a=~((1<<E)-1);return(m<<c|(a&m)>>>E)>>>0}function g(m,c=0,v=m.byteLength,E=0){for(let a=0;a<v;a++)m[c+a]=E}function d(m,c,v="0"){for(;m.length<c;)m=v+m;return m}function y(m,c=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(v=>v.toString(16).padStart(2,"0")).join(""):d((m>>>0).toString(16),c/4)}class w{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const v=c.length;if(v===0)return;const E=this._buff;let a=this._buffLen,t=this._leftoverHighSurrogate,s,r;for(t!==0?(s=t,r=-1,t=0):(s=c.charCodeAt(0),r=0);;){let i=s;if(n.isHighSurrogate(s))if(r+1<v){const o=c.charCodeAt(r+1);n.isLowSurrogate(o)?(r++,i=n.computeCodePoint(s,o)):i=65533}else{t=s;break}else n.isLowSurrogate(s)&&(i=65533);if(a=this._push(E,a,i),r++,r<v)s=c.charCodeAt(r);else break}this._buffLen=a,this._leftoverHighSurrogate=t}_push(c,v,E){return E<128?c[v++]=E:E<2048?(c[v++]=192|(E&1984)>>>6,c[v++]=128|(E&63)>>>0):E<65536?(c[v++]=224|(E&61440)>>>12,c[v++]=128|(E&4032)>>>6,c[v++]=128|(E&63)>>>0):(c[v++]=240|(E&1835008)>>>18,c[v++]=128|(E&258048)>>>12,c[v++]=128|(E&4032)>>>6,c[v++]=128|(E&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,c[0]=c[64],c[1]=c[65],c[2]=c[66]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=w._bigBlock32,v=this._buffDV;for(let p=0;p<64;p+=4)c.setUint32(p,v.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)c.setUint32(p,b(c.getUint32(p-12,!1)^c.getUint32(p-32,!1)^c.getUint32(p-56,!1)^c.getUint32(p-64,!1),1),!1);let E=this._h0,a=this._h1,t=this._h2,s=this._h3,r=this._h4,i,o,u;for(let p=0;p<80;p++)p<20?(i=a&t|~a&s,o=1518500249):p<40?(i=a^t^s,o=1859775393):p<60?(i=a&t|a&s|t&s,o=2400959708):(i=a^t^s,o=3395469782),u=b(E,5)+i+r+o+c.getUint32(p*4,!1)&4294967295,r=s,s=t,t=b(a,30),a=E,E=u;this._h0=this._h0+E&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=w}),define(se[74],oe([0,1,25]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(R||(R={})),function(I){const A="error",k="warning",P="warn",h="info",l="ignore";function f(b){return b?n.equalsIgnoreCase(A,b)?I.Error:n.equalsIgnoreCase(k,b)||n.equalsIgnoreCase(P,b)?I.Warning:n.equalsIgnoreCase(h,b)?I.Info:I.Ignore:I.Ignore}I.fromValue=f;function S(b){switch(b){case I.Error:return A;case I.Warning:return k;case I.Info:return h;default:return l}}I.toString=S}(R||(R={})),e.default=R}),define(se[144],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(se[59],oe([0,1,22,25]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class I{constructor(){this._value="",this._pos=0}reset(g){return this._value=g,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(g){const d=g.charCodeAt(0),y=this._value.charCodeAt(this._pos);return d-y}value(){return this._value[this._pos]}}e.StringIterator=I;class A{constructor(g=!0){this._caseSensitive=g}reset(g){return this._value=g,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let g=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(g)this._from++;else break;else g=!1;return this}cmp(g){return this._caseSensitive?(0,R.compareSubstring)(g,this._value,0,g.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(g,this._value,0,g.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class k{constructor(g=!0,d=!0){this._splitOnBackslash=g,this._caseSensitive=d}reset(g){this._from=0,this._to=0,this._value=g,this._valueLen=g.length;for(let d=g.length-1;d>=0;d--,this._valueLen--){const y=this._value.charCodeAt(d);if(!(y===47||this._splitOnBackslash&&y===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let g=!0;for(;this._to<this._valueLen;this._to++){const d=this._value.charCodeAt(this._to);if(d===47||this._splitOnBackslash&&d===92)if(g)this._from++;else break;else g=!1}return this}cmp(g){return this._caseSensitive?(0,R.compareSubstring)(g,this._value,0,g.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(g,this._value,0,g.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=k;var P;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(P||(P={}));class h{constructor(g,d){this._ignorePathCasing=g,this._ignoreQueryAndFragment=d,this._states=[],this._stateIdx=0}reset(g){return this._value=g,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new k(!1,!this._ignorePathCasing(g)),this._pathIterator.reset(g.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(g)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(g){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(g,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(g,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(g);if(this._states[this._stateIdx]===4)return(0,R.compare)(g,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(g,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const g=this.right;return this.right=g.left,g.left=this,this.updateHeight(),g.updateHeight(),g}rotateRight(){const g=this.left;return this.left=g.right,g.right=this,this.updateHeight(),g.updateHeight(),g}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(f||(f={}));class S{static forUris(g=()=>!1,d=()=>!1){return new S(new h(g,d))}static forPaths(g=!1){return new S(new k(void 0,!g))}static forStrings(){return new S(new I)}static forConfigKeys(){return new S(new A)}constructor(g){this._iter=g}clear(){this._root=void 0}fill(g,d){if(d){const y=d.slice(0);(0,n.shuffle)(y);for(const w of y)this.set(w,g)}else{const y=g.slice(0);(0,n.shuffle)(y);for(const w of y)this.set(w[0],w[1])}}set(g,d){const y=this._iter.reset(g);let w;this._root||(this._root=new l,this._root.segment=y.value());const m=[];for(w=this._root;;){const v=y.cmp(w.segment);if(v>0)w.left||(w.left=new l,w.left.segment=y.value()),m.push([-1,w]),w=w.left;else if(v<0)w.right||(w.right=new l,w.right.segment=y.value()),m.push([1,w]),w=w.right;else if(y.hasNext())y.next(),w.mid||(w.mid=new l,w.mid.segment=y.value()),m.push([0,w]),w=w.mid;else break}const c=w.value;w.value=d,w.key=g;for(let v=m.length-1;v>=0;v--){const E=m[v][1];E.updateHeight();const a=E.balanceFactor();if(a<-1||a>1){const t=m[v][0],s=m[v+1][0];if(t===1&&s===1)m[v][1]=E.rotateLeft();else if(t===-1&&s===-1)m[v][1]=E.rotateRight();else if(t===1&&s===-1)E.right=m[v+1][1]=m[v+1][1].rotateRight(),m[v][1]=E.rotateLeft();else if(t===-1&&s===1)E.left=m[v+1][1]=m[v+1][1].rotateLeft(),m[v][1]=E.rotateRight();else throw new Error;if(v>0)switch(m[v-1][0]){case-1:m[v-1][1].left=m[v][1];break;case 1:m[v-1][1].right=m[v][1];break;case 0:m[v-1][1].mid=m[v][1];break}else this._root=m[0][1]}}return c}get(g){return this._getNode(g)?.value}_getNode(g){const d=this._iter.reset(g);let y=this._root;for(;y;){const w=d.cmp(y.segment);if(w>0)y=y.left;else if(w<0)y=y.right;else if(d.hasNext())d.next(),y=y.mid;else break}return y}has(g){const d=this._getNode(g);return!(d?.value===void 0&&d?.mid===void 0)}delete(g){return this._delete(g,!1)}deleteSuperstr(g){return this._delete(g,!0)}_delete(g,d){const y=this._iter.reset(g),w=[];let m=this._root;for(;m;){const c=y.cmp(m.segment);if(c>0)w.push([-1,m]),m=m.left;else if(c<0)w.push([1,m]),m=m.right;else if(y.hasNext())y.next(),w.push([0,m]),m=m.mid;else break}if(m){if(d?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const c=this._min(m.right);if(c.key){const{key:v,value:E,segment:a}=c;this._delete(c.key,!1),m.key=v,m.value=E,m.segment=a}}else{const c=m.left??m.right;if(w.length>0){const[v,E]=w[w.length-1];switch(v){case-1:E.left=c;break;case 0:E.mid=c;break;case 1:E.right=c;break}}else this._root=c}for(let c=w.length-1;c>=0;c--){const v=w[c][1];v.updateHeight();const E=v.balanceFactor();if(E>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),w[c][1]=v.rotateLeft()):E<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),w[c][1]=v.rotateRight()),c>0)switch(w[c-1][0]){case-1:w[c-1][1].left=w[c][1];break;case 1:w[c-1][1].right=w[c][1];break;case 0:w[c-1][1].mid=w[c][1];break}else this._root=w[0][1]}}}_min(g){for(;g.left;)g=g.left;return g}findSubstr(g){const d=this._iter.reset(g);let y=this._root,w;for(;y;){const m=d.cmp(y.segment);if(m>0)y=y.left;else if(m<0)y=y.right;else if(d.hasNext())d.next(),w=y.value||w,y=y.mid;else break}return y&&y.value||w}findSuperstr(g){return this._findSuperstrOrElement(g,!1)}_findSuperstrOrElement(g,d){const y=this._iter.reset(g);let w=this._root;for(;w;){const m=y.cmp(w.segment);if(m>0)w=w.left;else if(m<0)w=w.right;else if(y.hasNext())y.next(),w=w.mid;else return w.mid?this._entries(w.mid):d?w.value:void 0}}hasElementOrSubtree(g){return this._findSuperstrOrElement(g,!0)!==void 0}forEach(g){for(const[d,y]of this)g(y,d)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(g){const d=[];return this._dfsEntries(g,d),d[Symbol.iterator]()}_dfsEntries(g,d){g&&(g.left&&this._dfsEntries(g.left,d),g.value&&d.push([g.key,g.value]),g.mid&&this._dfsEntries(g.mid,d),g.right&&this._dfsEntries(g.right,d))}_isBalanced(){const g=d=>{if(!d)return!0;const y=d.balanceFactor();return y<-1||y>1?!1:g(d.left)&&g(d.right)};return g(this._root)}}e.TernarySearchTree=S}),define(se[12],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=n,e.isStringArray=R,e.isObject=I,e.isTypedArray=A,e.isNumber=k,e.isIterable=P,e.isBoolean=h,e.isUndefined=l,e.isDefined=f,e.isUndefinedOrNull=S,e.assertType=b,e.assertIsDefined=g,e.assertAllDefined=d,e.isEmptyObject=w,e.isFunction=m,e.areFunctions=c,e.validateConstraints=v,e.validateConstraint=E;function n(a){return typeof a=="string"}function R(a){return Array.isArray(a)&&a.every(t=>n(t))}function I(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}function A(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}function k(a){return typeof a=="number"&&!isNaN(a)}function P(a){return!!a&&typeof a[Symbol.iterator]=="function"}function h(a){return a===!0||a===!1}function l(a){return typeof a>"u"}function f(a){return!S(a)}function S(a){return l(a)||a===null}function b(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function g(a){if(S(a))throw new Error("Assertion Failed: argument is undefined or null");return a}function d(...a){const t=[];for(let s=0;s<a.length;s++){const r=a[s];if(S(r))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(r)}return t}const y=Object.prototype.hasOwnProperty;function w(a){if(!I(a))return!1;for(const t in a)if(y.call(a,t))return!1;return!0}function m(a){return typeof a=="function"}function c(...a){return a.length>0&&a.every(m)}function v(a,t){const s=Math.min(a.length,t.length);for(let r=0;r<s;r++)E(a[r],t[r])}function E(a,t){if(n(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(m(t)){try{if(a instanceof t)return}catch{}if(!S(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(se[105],oe([0,1,12]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.register=I,e.getCodiconFontCharacters=A;const R=Object.create(null);function I(k,P){if((0,n.isString)(P)){const h=R[P];if(h===void 0)throw new Error(`${k} references an unknown codicon: ${P}`);P=h}return R[k]=P,{id:k}}function A(){return R}}),define(se[145],oe([0,1,105]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.codiconsLibrary=void 0,e.codiconsLibrary={add:(0,n.register)("add",6e4),plus:(0,n.register)("plus",6e4),gistNew:(0,n.register)("gist-new",6e4),repoCreate:(0,n.register)("repo-create",6e4),lightbulb:(0,n.register)("lightbulb",60001),lightBulb:(0,n.register)("light-bulb",60001),repo:(0,n.register)("repo",60002),repoDelete:(0,n.register)("repo-delete",60002),gistFork:(0,n.register)("gist-fork",60003),repoForked:(0,n.register)("repo-forked",60003),gitPullRequest:(0,n.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.register)("git-pull-request-abandoned",60004),recordKeys:(0,n.register)("record-keys",60005),keyboard:(0,n.register)("keyboard",60005),tag:(0,n.register)("tag",60006),gitPullRequestLabel:(0,n.register)("git-pull-request-label",60006),tagAdd:(0,n.register)("tag-add",60006),tagRemove:(0,n.register)("tag-remove",60006),person:(0,n.register)("person",60007),personFollow:(0,n.register)("person-follow",60007),personOutline:(0,n.register)("person-outline",60007),personFilled:(0,n.register)("person-filled",60007),gitBranch:(0,n.register)("git-branch",60008),gitBranchCreate:(0,n.register)("git-branch-create",60008),gitBranchDelete:(0,n.register)("git-branch-delete",60008),sourceControl:(0,n.register)("source-control",60008),mirror:(0,n.register)("mirror",60009),mirrorPublic:(0,n.register)("mirror-public",60009),star:(0,n.register)("star",60010),starAdd:(0,n.register)("star-add",60010),starDelete:(0,n.register)("star-delete",60010),starEmpty:(0,n.register)("star-empty",60010),comment:(0,n.register)("comment",60011),commentAdd:(0,n.register)("comment-add",60011),alert:(0,n.register)("alert",60012),warning:(0,n.register)("warning",60012),search:(0,n.register)("search",60013),searchSave:(0,n.register)("search-save",60013),logOut:(0,n.register)("log-out",60014),signOut:(0,n.register)("sign-out",60014),logIn:(0,n.register)("log-in",60015),signIn:(0,n.register)("sign-in",60015),eye:(0,n.register)("eye",60016),eyeUnwatch:(0,n.register)("eye-unwatch",60016),eyeWatch:(0,n.register)("eye-watch",60016),circleFilled:(0,n.register)("circle-filled",60017),primitiveDot:(0,n.register)("primitive-dot",60017),closeDirty:(0,n.register)("close-dirty",60017),debugBreakpoint:(0,n.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.register)("debug-breakpoint-disabled",60017),debugHint:(0,n.register)("debug-hint",60017),terminalDecorationSuccess:(0,n.register)("terminal-decoration-success",60017),primitiveSquare:(0,n.register)("primitive-square",60018),edit:(0,n.register)("edit",60019),pencil:(0,n.register)("pencil",60019),info:(0,n.register)("info",60020),issueOpened:(0,n.register)("issue-opened",60020),gistPrivate:(0,n.register)("gist-private",60021),gitForkPrivate:(0,n.register)("git-fork-private",60021),lock:(0,n.register)("lock",60021),mirrorPrivate:(0,n.register)("mirror-private",60021),close:(0,n.register)("close",60022),removeClose:(0,n.register)("remove-close",60022),x:(0,n.register)("x",60022),repoSync:(0,n.register)("repo-sync",60023),sync:(0,n.register)("sync",60023),clone:(0,n.register)("clone",60024),desktopDownload:(0,n.register)("desktop-download",60024),beaker:(0,n.register)("beaker",60025),microscope:(0,n.register)("microscope",60025),vm:(0,n.register)("vm",60026),deviceDesktop:(0,n.register)("device-desktop",60026),file:(0,n.register)("file",60027),fileText:(0,n.register)("file-text",60027),more:(0,n.register)("more",60028),ellipsis:(0,n.register)("ellipsis",60028),kebabHorizontal:(0,n.register)("kebab-horizontal",60028),mailReply:(0,n.register)("mail-reply",60029),reply:(0,n.register)("reply",60029),organization:(0,n.register)("organization",60030),organizationFilled:(0,n.register)("organization-filled",60030),organizationOutline:(0,n.register)("organization-outline",60030),newFile:(0,n.register)("new-file",60031),fileAdd:(0,n.register)("file-add",60031),newFolder:(0,n.register)("new-folder",60032),fileDirectoryCreate:(0,n.register)("file-directory-create",60032),trash:(0,n.register)("trash",60033),trashcan:(0,n.register)("trashcan",60033),history:(0,n.register)("history",60034),clock:(0,n.register)("clock",60034),folder:(0,n.register)("folder",60035),fileDirectory:(0,n.register)("file-directory",60035),symbolFolder:(0,n.register)("symbol-folder",60035),logoGithub:(0,n.register)("logo-github",60036),markGithub:(0,n.register)("mark-github",60036),github:(0,n.register)("github",60036),terminal:(0,n.register)("terminal",60037),console:(0,n.register)("console",60037),repl:(0,n.register)("repl",60037),zap:(0,n.register)("zap",60038),symbolEvent:(0,n.register)("symbol-event",60038),error:(0,n.register)("error",60039),stop:(0,n.register)("stop",60039),variable:(0,n.register)("variable",60040),symbolVariable:(0,n.register)("symbol-variable",60040),array:(0,n.register)("array",60042),symbolArray:(0,n.register)("symbol-array",60042),symbolModule:(0,n.register)("symbol-module",60043),symbolPackage:(0,n.register)("symbol-package",60043),symbolNamespace:(0,n.register)("symbol-namespace",60043),symbolObject:(0,n.register)("symbol-object",60043),symbolMethod:(0,n.register)("symbol-method",60044),symbolFunction:(0,n.register)("symbol-function",60044),symbolConstructor:(0,n.register)("symbol-constructor",60044),symbolBoolean:(0,n.register)("symbol-boolean",60047),symbolNull:(0,n.register)("symbol-null",60047),symbolNumeric:(0,n.register)("symbol-numeric",60048),symbolNumber:(0,n.register)("symbol-number",60048),symbolStructure:(0,n.register)("symbol-structure",60049),symbolStruct:(0,n.register)("symbol-struct",60049),symbolParameter:(0,n.register)("symbol-parameter",60050),symbolTypeParameter:(0,n.register)("symbol-type-parameter",60050),symbolKey:(0,n.register)("symbol-key",60051),symbolText:(0,n.register)("symbol-text",60051),symbolReference:(0,n.register)("symbol-reference",60052),goToFile:(0,n.register)("go-to-file",60052),symbolEnum:(0,n.register)("symbol-enum",60053),symbolValue:(0,n.register)("symbol-value",60053),symbolRuler:(0,n.register)("symbol-ruler",60054),symbolUnit:(0,n.register)("symbol-unit",60054),activateBreakpoints:(0,n.register)("activate-breakpoints",60055),archive:(0,n.register)("archive",60056),arrowBoth:(0,n.register)("arrow-both",60057),arrowDown:(0,n.register)("arrow-down",60058),arrowLeft:(0,n.register)("arrow-left",60059),arrowRight:(0,n.register)("arrow-right",60060),arrowSmallDown:(0,n.register)("arrow-small-down",60061),arrowSmallLeft:(0,n.register)("arrow-small-left",60062),arrowSmallRight:(0,n.register)("arrow-small-right",60063),arrowSmallUp:(0,n.register)("arrow-small-up",60064),arrowUp:(0,n.register)("arrow-up",60065),bell:(0,n.register)("bell",60066),bold:(0,n.register)("bold",60067),book:(0,n.register)("book",60068),bookmark:(0,n.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.register)("briefcase",60076),broadcast:(0,n.register)("broadcast",60077),browser:(0,n.register)("browser",60078),bug:(0,n.register)("bug",60079),calendar:(0,n.register)("calendar",60080),caseSensitive:(0,n.register)("case-sensitive",60081),check:(0,n.register)("check",60082),checklist:(0,n.register)("checklist",60083),chevronDown:(0,n.register)("chevron-down",60084),chevronLeft:(0,n.register)("chevron-left",60085),chevronRight:(0,n.register)("chevron-right",60086),chevronUp:(0,n.register)("chevron-up",60087),chromeClose:(0,n.register)("chrome-close",60088),chromeMaximize:(0,n.register)("chrome-maximize",60089),chromeMinimize:(0,n.register)("chrome-minimize",60090),chromeRestore:(0,n.register)("chrome-restore",60091),circleOutline:(0,n.register)("circle-outline",60092),circle:(0,n.register)("circle",60092),debugBreakpointUnverified:(0,n.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.register)("terminal-decoration-incomplete",60092),circleSlash:(0,n.register)("circle-slash",60093),circuitBoard:(0,n.register)("circuit-board",60094),clearAll:(0,n.register)("clear-all",60095),clippy:(0,n.register)("clippy",60096),closeAll:(0,n.register)("close-all",60097),cloudDownload:(0,n.register)("cloud-download",60098),cloudUpload:(0,n.register)("cloud-upload",60099),code:(0,n.register)("code",60100),collapseAll:(0,n.register)("collapse-all",60101),colorMode:(0,n.register)("color-mode",60102),commentDiscussion:(0,n.register)("comment-discussion",60103),creditCard:(0,n.register)("credit-card",60105),dash:(0,n.register)("dash",60108),dashboard:(0,n.register)("dashboard",60109),database:(0,n.register)("database",60110),debugContinue:(0,n.register)("debug-continue",60111),debugDisconnect:(0,n.register)("debug-disconnect",60112),debugPause:(0,n.register)("debug-pause",60113),debugRestart:(0,n.register)("debug-restart",60114),debugStart:(0,n.register)("debug-start",60115),debugStepInto:(0,n.register)("debug-step-into",60116),debugStepOut:(0,n.register)("debug-step-out",60117),debugStepOver:(0,n.register)("debug-step-over",60118),debugStop:(0,n.register)("debug-stop",60119),debug:(0,n.register)("debug",60120),deviceCameraVideo:(0,n.register)("device-camera-video",60121),deviceCamera:(0,n.register)("device-camera",60122),deviceMobile:(0,n.register)("device-mobile",60123),diffAdded:(0,n.register)("diff-added",60124),diffIgnored:(0,n.register)("diff-ignored",60125),diffModified:(0,n.register)("diff-modified",60126),diffRemoved:(0,n.register)("diff-removed",60127),diffRenamed:(0,n.register)("diff-renamed",60128),diff:(0,n.register)("diff",60129),diffSidebyside:(0,n.register)("diff-sidebyside",60129),discard:(0,n.register)("discard",60130),editorLayout:(0,n.register)("editor-layout",60131),emptyWindow:(0,n.register)("empty-window",60132),exclude:(0,n.register)("exclude",60133),extensions:(0,n.register)("extensions",60134),eyeClosed:(0,n.register)("eye-closed",60135),fileBinary:(0,n.register)("file-binary",60136),fileCode:(0,n.register)("file-code",60137),fileMedia:(0,n.register)("file-media",60138),filePdf:(0,n.register)("file-pdf",60139),fileSubmodule:(0,n.register)("file-submodule",60140),fileSymlinkDirectory:(0,n.register)("file-symlink-directory",60141),fileSymlinkFile:(0,n.register)("file-symlink-file",60142),fileZip:(0,n.register)("file-zip",60143),files:(0,n.register)("files",60144),filter:(0,n.register)("filter",60145),flame:(0,n.register)("flame",60146),foldDown:(0,n.register)("fold-down",60147),foldUp:(0,n.register)("fold-up",60148),fold:(0,n.register)("fold",60149),folderActive:(0,n.register)("folder-active",60150),folderOpened:(0,n.register)("folder-opened",60151),gear:(0,n.register)("gear",60152),gift:(0,n.register)("gift",60153),gistSecret:(0,n.register)("gist-secret",60154),gist:(0,n.register)("gist",60155),gitCommit:(0,n.register)("git-commit",60156),gitCompare:(0,n.register)("git-compare",60157),compareChanges:(0,n.register)("compare-changes",60157),gitMerge:(0,n.register)("git-merge",60158),githubAction:(0,n.register)("github-action",60159),githubAlt:(0,n.register)("github-alt",60160),globe:(0,n.register)("globe",60161),grabber:(0,n.register)("grabber",60162),graph:(0,n.register)("graph",60163),gripper:(0,n.register)("gripper",60164),heart:(0,n.register)("heart",60165),home:(0,n.register)("home",60166),horizontalRule:(0,n.register)("horizontal-rule",60167),hubot:(0,n.register)("hubot",60168),inbox:(0,n.register)("inbox",60169),issueReopened:(0,n.register)("issue-reopened",60171),issues:(0,n.register)("issues",60172),italic:(0,n.register)("italic",60173),jersey:(0,n.register)("jersey",60174),json:(0,n.register)("json",60175),kebabVertical:(0,n.register)("kebab-vertical",60176),key:(0,n.register)("key",60177),law:(0,n.register)("law",60178),lightbulbAutofix:(0,n.register)("lightbulb-autofix",60179),linkExternal:(0,n.register)("link-external",60180),link:(0,n.register)("link",60181),listOrdered:(0,n.register)("list-ordered",60182),listUnordered:(0,n.register)("list-unordered",60183),liveShare:(0,n.register)("live-share",60184),loading:(0,n.register)("loading",60185),location:(0,n.register)("location",60186),mailRead:(0,n.register)("mail-read",60187),mail:(0,n.register)("mail",60188),markdown:(0,n.register)("markdown",60189),megaphone:(0,n.register)("megaphone",60190),mention:(0,n.register)("mention",60191),milestone:(0,n.register)("milestone",60192),gitPullRequestMilestone:(0,n.register)("git-pull-request-milestone",60192),mortarBoard:(0,n.register)("mortar-board",60193),move:(0,n.register)("move",60194),multipleWindows:(0,n.register)("multiple-windows",60195),mute:(0,n.register)("mute",60196),noNewline:(0,n.register)("no-newline",60197),note:(0,n.register)("note",60198),octoface:(0,n.register)("octoface",60199),openPreview:(0,n.register)("open-preview",60200),package:(0,n.register)("package",60201),paintcan:(0,n.register)("paintcan",60202),pin:(0,n.register)("pin",60203),play:(0,n.register)("play",60204),run:(0,n.register)("run",60204),plug:(0,n.register)("plug",60205),preserveCase:(0,n.register)("preserve-case",60206),preview:(0,n.register)("preview",60207),project:(0,n.register)("project",60208),pulse:(0,n.register)("pulse",60209),question:(0,n.register)("question",60210),quote:(0,n.register)("quote",60211),radioTower:(0,n.register)("radio-tower",60212),reactions:(0,n.register)("reactions",60213),references:(0,n.register)("references",60214),refresh:(0,n.register)("refresh",60215),regex:(0,n.register)("regex",60216),remoteExplorer:(0,n.register)("remote-explorer",60217),remote:(0,n.register)("remote",60218),remove:(0,n.register)("remove",60219),replaceAll:(0,n.register)("replace-all",60220),replace:(0,n.register)("replace",60221),repoClone:(0,n.register)("repo-clone",60222),repoForcePush:(0,n.register)("repo-force-push",60223),repoPull:(0,n.register)("repo-pull",60224),repoPush:(0,n.register)("repo-push",60225),report:(0,n.register)("report",60226),requestChanges:(0,n.register)("request-changes",60227),rocket:(0,n.register)("rocket",60228),rootFolderOpened:(0,n.register)("root-folder-opened",60229),rootFolder:(0,n.register)("root-folder",60230),rss:(0,n.register)("rss",60231),ruby:(0,n.register)("ruby",60232),saveAll:(0,n.register)("save-all",60233),saveAs:(0,n.register)("save-as",60234),save:(0,n.register)("save",60235),screenFull:(0,n.register)("screen-full",60236),screenNormal:(0,n.register)("screen-normal",60237),searchStop:(0,n.register)("search-stop",60238),server:(0,n.register)("server",60240),settingsGear:(0,n.register)("settings-gear",60241),settings:(0,n.register)("settings",60242),shield:(0,n.register)("shield",60243),smiley:(0,n.register)("smiley",60244),sortPrecedence:(0,n.register)("sort-precedence",60245),splitHorizontal:(0,n.register)("split-horizontal",60246),splitVertical:(0,n.register)("split-vertical",60247),squirrel:(0,n.register)("squirrel",60248),starFull:(0,n.register)("star-full",60249),starHalf:(0,n.register)("star-half",60250),symbolClass:(0,n.register)("symbol-class",60251),symbolColor:(0,n.register)("symbol-color",60252),symbolConstant:(0,n.register)("symbol-constant",60253),symbolEnumMember:(0,n.register)("symbol-enum-member",60254),symbolField:(0,n.register)("symbol-field",60255),symbolFile:(0,n.register)("symbol-file",60256),symbolInterface:(0,n.register)("symbol-interface",60257),symbolKeyword:(0,n.register)("symbol-keyword",60258),symbolMisc:(0,n.register)("symbol-misc",60259),symbolOperator:(0,n.register)("symbol-operator",60260),symbolProperty:(0,n.register)("symbol-property",60261),wrench:(0,n.register)("wrench",60261),wrenchSubaction:(0,n.register)("wrench-subaction",60261),symbolSnippet:(0,n.register)("symbol-snippet",60262),tasklist:(0,n.register)("tasklist",60263),telescope:(0,n.register)("telescope",60264),textSize:(0,n.register)("text-size",60265),threeBars:(0,n.register)("three-bars",60266),thumbsdown:(0,n.register)("thumbsdown",60267),thumbsup:(0,n.register)("thumbsup",60268),tools:(0,n.register)("tools",60269),triangleDown:(0,n.register)("triangle-down",60270),triangleLeft:(0,n.register)("triangle-left",60271),triangleRight:(0,n.register)("triangle-right",60272),triangleUp:(0,n.register)("triangle-up",60273),twitter:(0,n.register)("twitter",60274),unfold:(0,n.register)("unfold",60275),unlock:(0,n.register)("unlock",60276),unmute:(0,n.register)("unmute",60277),unverified:(0,n.register)("unverified",60278),verified:(0,n.register)("verified",60279),versions:(0,n.register)("versions",60280),vmActive:(0,n.register)("vm-active",60281),vmOutline:(0,n.register)("vm-outline",60282),vmRunning:(0,n.register)("vm-running",60283),watch:(0,n.register)("watch",60284),whitespace:(0,n.register)("whitespace",60285),wholeWord:(0,n.register)("whole-word",60286),window:(0,n.register)("window",60287),wordWrap:(0,n.register)("word-wrap",60288),zoomIn:(0,n.register)("zoom-in",60289),zoomOut:(0,n.register)("zoom-out",60290),listFilter:(0,n.register)("list-filter",60291),listFlat:(0,n.register)("list-flat",60292),listSelection:(0,n.register)("list-selection",60293),selection:(0,n.register)("selection",60293),listTree:(0,n.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.register)("debug-stackframe-active",60297),circleSmallFilled:(0,n.register)("circle-small-filled",60298),debugStackframeDot:(0,n.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.register)("terminal-decoration-mark",60298),debugStackframe:(0,n.register)("debug-stackframe",60299),debugStackframeFocused:(0,n.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.register)("debug-breakpoint-unsupported",60300),symbolString:(0,n.register)("symbol-string",60301),debugReverseContinue:(0,n.register)("debug-reverse-continue",60302),debugStepBack:(0,n.register)("debug-step-back",60303),debugRestartFrame:(0,n.register)("debug-restart-frame",60304),debugAlt:(0,n.register)("debug-alt",60305),callIncoming:(0,n.register)("call-incoming",60306),callOutgoing:(0,n.register)("call-outgoing",60307),menu:(0,n.register)("menu",60308),expandAll:(0,n.register)("expand-all",60309),feedback:(0,n.register)("feedback",60310),gitPullRequestReviewer:(0,n.register)("git-pull-request-reviewer",60310),groupByRefType:(0,n.register)("group-by-ref-type",60311),ungroupByRefType:(0,n.register)("ungroup-by-ref-type",60312),account:(0,n.register)("account",60313),gitPullRequestAssignee:(0,n.register)("git-pull-request-assignee",60313),bellDot:(0,n.register)("bell-dot",60314),debugConsole:(0,n.register)("debug-console",60315),library:(0,n.register)("library",60316),output:(0,n.register)("output",60317),runAll:(0,n.register)("run-all",60318),syncIgnored:(0,n.register)("sync-ignored",60319),pinned:(0,n.register)("pinned",60320),githubInverted:(0,n.register)("github-inverted",60321),serverProcess:(0,n.register)("server-process",60322),serverEnvironment:(0,n.register)("server-environment",60323),pass:(0,n.register)("pass",60324),issueClosed:(0,n.register)("issue-closed",60324),stopCircle:(0,n.register)("stop-circle",60325),playCircle:(0,n.register)("play-circle",60326),record:(0,n.register)("record",60327),debugAltSmall:(0,n.register)("debug-alt-small",60328),vmConnect:(0,n.register)("vm-connect",60329),cloud:(0,n.register)("cloud",60330),merge:(0,n.register)("merge",60331),export:(0,n.register)("export",60332),graphLeft:(0,n.register)("graph-left",60333),magnet:(0,n.register)("magnet",60334),notebook:(0,n.register)("notebook",60335),redo:(0,n.register)("redo",60336),checkAll:(0,n.register)("check-all",60337),pinnedDirty:(0,n.register)("pinned-dirty",60338),passFilled:(0,n.register)("pass-filled",60339),circleLargeFilled:(0,n.register)("circle-large-filled",60340),circleLarge:(0,n.register)("circle-large",60341),circleLargeOutline:(0,n.register)("circle-large-outline",60341),combine:(0,n.register)("combine",60342),gather:(0,n.register)("gather",60342),table:(0,n.register)("table",60343),variableGroup:(0,n.register)("variable-group",60344),typeHierarchy:(0,n.register)("type-hierarchy",60345),typeHierarchySub:(0,n.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.register)("git-pull-request-create",60348),runAbove:(0,n.register)("run-above",60349),runBelow:(0,n.register)("run-below",60350),notebookTemplate:(0,n.register)("notebook-template",60351),debugRerun:(0,n.register)("debug-rerun",60352),workspaceTrusted:(0,n.register)("workspace-trusted",60353),workspaceUntrusted:(0,n.register)("workspace-untrusted",60354),workspaceUnknown:(0,n.register)("workspace-unknown",60355),terminalCmd:(0,n.register)("terminal-cmd",60356),terminalDebian:(0,n.register)("terminal-debian",60357),terminalLinux:(0,n.register)("terminal-linux",60358),terminalPowershell:(0,n.register)("terminal-powershell",60359),terminalTmux:(0,n.register)("terminal-tmux",60360),terminalUbuntu:(0,n.register)("terminal-ubuntu",60361),terminalBash:(0,n.register)("terminal-bash",60362),arrowSwap:(0,n.register)("arrow-swap",60363),copy:(0,n.register)("copy",60364),personAdd:(0,n.register)("person-add",60365),filterFilled:(0,n.register)("filter-filled",60366),wand:(0,n.register)("wand",60367),debugLineByLine:(0,n.register)("debug-line-by-line",60368),inspect:(0,n.register)("inspect",60369),layers:(0,n.register)("layers",60370),layersDot:(0,n.register)("layers-dot",60371),layersActive:(0,n.register)("layers-active",60372),compass:(0,n.register)("compass",60373),compassDot:(0,n.register)("compass-dot",60374),compassActive:(0,n.register)("compass-active",60375),azure:(0,n.register)("azure",60376),issueDraft:(0,n.register)("issue-draft",60377),gitPullRequestClosed:(0,n.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.register)("git-pull-request-draft",60379),debugAll:(0,n.register)("debug-all",60380),debugCoverage:(0,n.register)("debug-coverage",60381),runErrors:(0,n.register)("run-errors",60382),folderLibrary:(0,n.register)("folder-library",60383),debugContinueSmall:(0,n.register)("debug-continue-small",60384),beakerStop:(0,n.register)("beaker-stop",60385),graphLine:(0,n.register)("graph-line",60386),graphScatter:(0,n.register)("graph-scatter",60387),pieChart:(0,n.register)("pie-chart",60388),bracket:(0,n.register)("bracket",60175),bracketDot:(0,n.register)("bracket-dot",60389),bracketError:(0,n.register)("bracket-error",60390),lockSmall:(0,n.register)("lock-small",60391),azureDevops:(0,n.register)("azure-devops",60392),verifiedFilled:(0,n.register)("verified-filled",60393),newline:(0,n.register)("newline",60394),layout:(0,n.register)("layout",60395),layoutActivitybarLeft:(0,n.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.register)("layout-panel-left",60398),layoutPanelCenter:(0,n.register)("layout-panel-center",60399),layoutPanelJustify:(0,n.register)("layout-panel-justify",60400),layoutPanelRight:(0,n.register)("layout-panel-right",60401),layoutPanel:(0,n.register)("layout-panel",60402),layoutSidebarLeft:(0,n.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.register)("layout-sidebar-right",60404),layoutStatusbar:(0,n.register)("layout-statusbar",60405),layoutMenubar:(0,n.register)("layout-menubar",60406),layoutCentered:(0,n.register)("layout-centered",60407),target:(0,n.register)("target",60408),indent:(0,n.register)("indent",60409),recordSmall:(0,n.register)("record-small",60410),errorSmall:(0,n.register)("error-small",60411),terminalDecorationError:(0,n.register)("terminal-decoration-error",60411),arrowCircleDown:(0,n.register)("arrow-circle-down",60412),arrowCircleLeft:(0,n.register)("arrow-circle-left",60413),arrowCircleRight:(0,n.register)("arrow-circle-right",60414),arrowCircleUp:(0,n.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.register)("layout-sidebar-left-off",60418),blank:(0,n.register)("blank",60419),heartFilled:(0,n.register)("heart-filled",60420),map:(0,n.register)("map",60421),mapHorizontal:(0,n.register)("map-horizontal",60421),foldHorizontal:(0,n.register)("fold-horizontal",60421),mapFilled:(0,n.register)("map-filled",60422),mapHorizontalFilled:(0,n.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.register)("fold-horizontal-filled",60422),circleSmall:(0,n.register)("circle-small",60423),bellSlash:(0,n.register)("bell-slash",60424),bellSlashDot:(0,n.register)("bell-slash-dot",60425),commentUnresolved:(0,n.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.register)("search-fuzzy",60429),commentDraft:(0,n.register)("comment-draft",60430),send:(0,n.register)("send",60431),sparkle:(0,n.register)("sparkle",60432),insert:(0,n.register)("insert",60433),mic:(0,n.register)("mic",60434),thumbsdownFilled:(0,n.register)("thumbsdown-filled",60435),thumbsupFilled:(0,n.register)("thumbsup-filled",60436),coffee:(0,n.register)("coffee",60437),snake:(0,n.register)("snake",60438),game:(0,n.register)("game",60439),vr:(0,n.register)("vr",60440),chip:(0,n.register)("chip",60441),piano:(0,n.register)("piano",60442),music:(0,n.register)("music",60443),micFilled:(0,n.register)("mic-filled",60444),repoFetch:(0,n.register)("repo-fetch",60445),copilot:(0,n.register)("copilot",60446),lightbulbSparkle:(0,n.register)("lightbulb-sparkle",60447),robot:(0,n.register)("robot",60448),sparkleFilled:(0,n.register)("sparkle-filled",60449),diffSingle:(0,n.register)("diff-single",60450),diffMultiple:(0,n.register)("diff-multiple",60451),surroundWith:(0,n.register)("surround-with",60452),share:(0,n.register)("share",60453),gitStash:(0,n.register)("git-stash",60454),gitStashApply:(0,n.register)("git-stash-apply",60455),gitStashPop:(0,n.register)("git-stash-pop",60456),vscode:(0,n.register)("vscode",60457),vscodeInsiders:(0,n.register)("vscode-insiders",60458),codeOss:(0,n.register)("code-oss",60459),runCoverage:(0,n.register)("run-coverage",60460),runAllCoverage:(0,n.register)("run-all-coverage",60461),coverage:(0,n.register)("coverage",60462),githubProject:(0,n.register)("github-project",60463),mapVertical:(0,n.register)("map-vertical",60464),foldVertical:(0,n.register)("fold-vertical",60464),mapVerticalFilled:(0,n.register)("map-vertical-filled",60465),foldVerticalFilled:(0,n.register)("fold-vertical-filled",60465),goToSearch:(0,n.register)("go-to-search",60466),percentage:(0,n.register)("percentage",60467),sortPercentage:(0,n.register)("sort-percentage",60467)}}),define(se[75],oe([0,1,105,145]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.codiconsDerived=void 0,e.getAllCodicons=I;function I(){return Object.values(e.Codicon)}e.codiconsDerived={dialogError:(0,n.register)("dialog-error","error"),dialogWarning:(0,n.register)("dialog-warning","warning"),dialogInfo:(0,n.register)("dialog-info","info"),dialogClose:(0,n.register)("dialog-close","close"),treeItemExpanded:(0,n.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.register)("tree-filter-clear","close"),treeItemLoading:(0,n.register)("tree-item-loading","loading"),menuSelection:(0,n.register)("menu-selection","check"),menuSubmenu:(0,n.register)("menu-submenu","chevron-right"),menuBarMore:(0,n.register)("menubar-more","more"),scrollbarButtonLeft:(0,n.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.register)("toolbar-more","more"),quickInputBack:(0,n.register)("quick-input-back","arrow-left"),dropDownButton:(0,n.register)("drop-down-button",60084),symbolCustomColor:(0,n.register)("symbol-customcolor",60252),exportIcon:(0,n.register)("export",60332),workspaceUnspecified:(0,n.register)("workspace-unspecified",60355),newLine:(0,n.register)("newline",60394),thumbsDownFilled:(0,n.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.register)("thumbsup-filled",60436),gitFetch:(0,n.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.register)("debug-breakpoint-pending",60377)},e.Codicon={...R.codiconsLibrary,...e.codiconsDerived}}),define(se[35],oe([0,1,12]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=R,e.deepFreeze=I,e.cloneAndChange=k,e.mixin=h,e.equals=l,e.safeStringify=f,e.distinct=S,e.getCaseInsensitive=b,e.filter=g,e.getAllPropertyNames=d,e.getAllMethodNames=y,e.createProxyObject=w;function R(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const c=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([v,E])=>{c[v]=E&&typeof E=="object"?R(E):E}),c}function I(m){if(!m||typeof m!="object")return m;const c=[m];for(;c.length>0;){const v=c.shift();Object.freeze(v);for(const E in v)if(A.call(v,E)){const a=v[E];typeof a=="object"&&!Object.isFrozen(a)&&!(0,n.isTypedArray)(a)&&c.push(a)}}return m}const A=Object.prototype.hasOwnProperty;function k(m,c){return P(m,c,new Set)}function P(m,c,v){if((0,n.isUndefinedOrNull)(m))return m;const E=c(m);if(typeof E<"u")return E;if(Array.isArray(m)){const a=[];for(const t of m)a.push(P(t,c,v));return a}if((0,n.isObject)(m)){if(v.has(m))throw new Error("Cannot clone recursive data-structure");v.add(m);const a={};for(const t in m)A.call(m,t)&&(a[t]=P(m[t],c,v));return v.delete(m),a}return m}function h(m,c,v=!0){return(0,n.isObject)(m)?((0,n.isObject)(c)&&Object.keys(c).forEach(E=>{E in m?v&&((0,n.isObject)(m[E])&&(0,n.isObject)(c[E])?h(m[E],c[E],v):m[E]=c[E]):m[E]=c[E]}),m):c}function l(m,c){if(m===c)return!0;if(m==null||c===null||c===void 0||typeof m!=typeof c||typeof m!="object"||Array.isArray(m)!==Array.isArray(c))return!1;let v,E;if(Array.isArray(m)){if(m.length!==c.length)return!1;for(v=0;v<m.length;v++)if(!l(m[v],c[v]))return!1}else{const a=[];for(E in m)a.push(E);a.sort();const t=[];for(E in c)t.push(E);if(t.sort(),!l(a,t))return!1;for(v=0;v<a.length;v++)if(!l(m[a[v]],c[a[v]]))return!1}return!0}function f(m){const c=new Set;return JSON.stringify(m,(v,E)=>{if((0,n.isObject)(E)||Array.isArray(E)){if(c.has(E))return"[Circular]";c.add(E)}return typeof E=="bigint"?`[BigInt ${E.toString()}]`:E})}function S(m,c){const v=Object.create(null);return!m||!c||Object.keys(c).forEach(a=>{const t=m[a],s=c[a];l(t,s)||(v[a]=s)}),v}function b(m,c){const v=c.toLowerCase(),E=Object.keys(m).find(a=>a.toLowerCase()===v);return E?m[E]:m[c]}function g(m,c){const v=Object.create(null);for(const[E,a]of Object.entries(m))c(E,a)&&(v[E]=a);return v}function d(m){let c=[];for(;Object.prototype!==m;)c=c.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return c}function y(m){const c=[];for(const v of d(m))typeof m[v]=="function"&&c.push(v);return c}function w(m,c){const v=a=>function(){const t=Array.prototype.slice.call(arguments,0);return c(a,t)},E={};for(const a of m)E[a]=v(a);return E}}),define(se[106],oe([0,1,75]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.themeColorFromId=I;var R;(function(k){function P(h){return h&&typeof h=="object"&&typeof h.id=="string"}k.isThemeColor=P})(R||(e.ThemeColor=R={}));function I(k){return{id:k}}var A;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function h(c){const v=P.exec(c.id);if(!v)return h(n.Codicon.error);const[,E,a]=v,t=["codicon","codicon-"+E];return a&&t.push("codicon-modifier-"+a.substring(1)),t}k.asClassNameArray=h;function l(c){return h(c).join(" ")}k.asClassName=l;function f(c){return"."+h(c).join(".")}k.asCSSSelector=f;function S(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||R.isThemeColor(c.color))}k.isThemeIcon=S;const b=new RegExp(`^\\$\\((${k.iconNameExpression}(?:${k.iconModifierExpression})?)\\)$`);function g(c){const v=b.exec(c);if(!v)return;const[,E]=v;return{id:E}}k.fromString=g;function d(c){return{id:c}}k.fromId=d;function y(c,v){let E=c.id;const a=E.lastIndexOf("~");return a!==-1&&(E=E.substring(0,a)),v&&(E=`${E}~${v}`),{id:E}}k.modify=y;function w(c){const v=c.id.lastIndexOf("~");if(v!==-1)return c.id.substring(v+1)}k.getModifier=w;function m(c,v){return c.id===v.id&&c.color?.id===v.color?.id}k.isEqual=m})(A||(e.ThemeIcon=A={}))}),define(se[33],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=R;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(I){return n.test(I)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(P){for(let h=0;h<P.length;h++)P[h]=Math.floor(Math.random()*256);return P};const A=new Uint8Array(16),k=[];for(let P=0;P<256;P++)k.push(P.toString(16).padStart(2,"0"));return function(){I(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let h=0,l="";return l+=k[A[h++]],l+=k[A[h++]],l+=k[A[h++]],l+=k[A[h++]],l+="-",l+=k[A[h++]],l+=k[A[h++]],l+="-",l+=k[A[h++]],l+=k[A[h++]],l+="-",l+=k[A[h++]],l+=k[A[h++]],l+="-",l+=k[A[h++]],l+=k[A[h++]],l+=k[A[h++]],l+=k[A[h++]],l+=k[A[h++]],l+=k[A[h++]],l}}()}),define(se[146],oe([0,1,87,43,86]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=A;async function A(k,P){if(await new Promise((f,S)=>{const b=R.createReadStream(k),g=n.createHash("sha256");b.pipe(g);const d=(0,I.createSingleCallFunction)((y,w)=>{b.removeAllListeners(),g.removeAllListeners(),y?S(y):f(w)});b.once("error",d),b.once("end",d),g.once("error",d),g.once("data",y=>d(void 0,y.toString("hex")))})!==P)throw new Error("Hash mismatch")}}),define(se[147],oe([0,1,26]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=A;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function I(k){const P=k.replace(/\-/g,":").toLowerCase();return!R.has(P)}function A(){const k=(0,n.networkInterfaces)();for(const P in k){const h=k[P];if(h){for(const{mac:l}of h)if(I(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(se[107],oe([0,1,88]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BROWSER_RESTRICTED_PORTS=void 0,e.findFreePort=R,e.findFreePortFaster=A;function R(P,h,l,f=1){let S=!1;return new Promise(b=>{const g=setTimeout(()=>{if(!S)return S=!0,b(0)},l);I(P,h,f,d=>{if(!S)return S=!0,clearTimeout(g),b(d)})})}function I(P,h,l,f){if(h===0)return f(0);const S=new n.Socket;S.once("connect",()=>(k(S),I(P+l,h-1,l,f))),S.once("data",()=>{}),S.once("error",b=>(k(S),b.code!=="ECONNREFUSED"?I(P+l,h-1,l,f):f(P))),S.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(P,h,l,f="127.0.0.1"){let S=!1,b,g=1;const d=n.createServer({pauseOnConnect:!0});function y(w,m){S||(S=!0,d.removeAllListeners(),d.close(),b&&clearTimeout(b),m(w))}return new Promise(w=>{b=setTimeout(()=>{y(0,w)},l),d.on("listening",()=>{y(P,w)}),d.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&g<h?(P++,g++,d.listen(P,f)):y(0,w)}),d.on("close",()=>{y(0,w)}),d.listen(P,f)})}function k(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(h){console.error(h)}}}),function(){function Q(){function e(){return process.uncHostAllowlist}function n(h){const l=new Set;if(Array.isArray(h))for(const f of h)typeof f=="string"&&l.add(f);return Array.from(l)}function R(){const h=e();return h?Array.from(h):[]}function I(h){if(process.platform!=="win32")return;const l=e();if(l)if(typeof h=="string")l.add(h.toLowerCase());else for(const f of n(h))I(f)}function A(h){if(typeof h!="string")return;const l=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let f;for(const S of l){if(h.indexOf(S)!==0)continue;const g=h.indexOf("\\",S.length);if(g===-1)continue;const d=h.substring(S.length,g);if(d){f=d;break}}return f}function k(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:R,addUNCHostToAllowlist:I,getUNCHost:A,disableUNCAccessRestrictions:k,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return Q()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=Q():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(se[148],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(se[149],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class n{constructor(I,A){this.sender=I,this.onMessage=A}send(I){try{this.sender.send("vscode:message",I.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=n}),define(se[150],oe([11,10]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(se[151],oe([0,1,150]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=l,e.getDurationString=f,e.toLocalISOString=S;const R=60,I=R*60,A=I*24,k=A*7,P=A*30,h=A*365;function l(b,g,d,y){typeof b!="number"&&(b=b.getTime());const w=Math.round((new Date().getTime()-b)/1e3);if(w<-30)return(0,n.localize)(0,null,l(new Date().getTime()+w*1e3,!1));if(!y&&w<30)return(0,n.localize)(1,null);let m;return w<R?(m=w,g?m===1?d?(0,n.localize)(2,null,m):(0,n.localize)(3,null,m):d?(0,n.localize)(4,null,m):(0,n.localize)(5,null,m):m===1?d?(0,n.localize)(6,null,m):(0,n.localize)(7,null,m):d?(0,n.localize)(8,null,m):(0,n.localize)(9,null,m)):w<I?(m=Math.floor(w/R),g?m===1?d?(0,n.localize)(10,null,m):(0,n.localize)(11,null,m):d?(0,n.localize)(12,null,m):(0,n.localize)(13,null,m):m===1?d?(0,n.localize)(14,null,m):(0,n.localize)(15,null,m):d?(0,n.localize)(16,null,m):(0,n.localize)(17,null,m)):w<A?(m=Math.floor(w/I),g?m===1?d?(0,n.localize)(18,null,m):(0,n.localize)(19,null,m):d?(0,n.localize)(20,null,m):(0,n.localize)(21,null,m):m===1?d?(0,n.localize)(22,null,m):(0,n.localize)(23,null,m):d?(0,n.localize)(24,null,m):(0,n.localize)(25,null,m)):w<k?(m=Math.floor(w/A),g?m===1?(0,n.localize)(26,null,m):(0,n.localize)(27,null,m):m===1?(0,n.localize)(28,null,m):(0,n.localize)(29,null,m)):w<P?(m=Math.floor(w/k),g?m===1?d?(0,n.localize)(30,null,m):(0,n.localize)(31,null,m):d?(0,n.localize)(32,null,m):(0,n.localize)(33,null,m):m===1?d?(0,n.localize)(34,null,m):(0,n.localize)(35,null,m):d?(0,n.localize)(36,null,m):(0,n.localize)(37,null,m)):w<h?(m=Math.floor(w/P),g?m===1?d?(0,n.localize)(38,null,m):(0,n.localize)(39,null,m):d?(0,n.localize)(40,null,m):(0,n.localize)(41,null,m):m===1?d?(0,n.localize)(42,null,m):(0,n.localize)(43,null,m):d?(0,n.localize)(44,null,m):(0,n.localize)(45,null,m)):(m=Math.floor(w/h),g?m===1?d?(0,n.localize)(46,null,m):(0,n.localize)(47,null,m):d?(0,n.localize)(48,null,m):(0,n.localize)(49,null,m):m===1?d?(0,n.localize)(50,null,m):(0,n.localize)(51,null,m):d?(0,n.localize)(52,null,m):(0,n.localize)(53,null,m))}function f(b,g){const d=Math.abs(b/1e3);return d<1?g?(0,n.localize)(54,null,b):(0,n.localize)(55,null,b):d<R?g?(0,n.localize)(56,null,Math.round(b)/1e3):(0,n.localize)(57,null,Math.round(b)/1e3):d<I?g?(0,n.localize)(58,null,Math.round(b/(1e3*R))):(0,n.localize)(59,null,Math.round(b/(1e3*R))):d<A?g?(0,n.localize)(60,null,Math.round(b/(1e3*I))):(0,n.localize)(61,null,Math.round(b/(1e3*I))):(0,n.localize)(62,null,Math.round(b/(1e3*A)))}function S(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(se[152],oe([11,10]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(se[47],oe([0,1,22,12,152]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=h,e.isErrorWithActions=l,e.createErrorWithActions=f;function A(S,b){return b&&(S.stack||S.stacktrace)?I.localize(0,null,P(S),k(S.stack)||k(S.stacktrace)):P(S)}function k(S){return Array.isArray(S)?S.join(`
`):S}function P(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?I.localize(1,null,S.message):S.message||I.localize(2,null)}function h(S=null,b=!1){if(!S)return I.localize(3,null);if(Array.isArray(S)){const g=n.coalesce(S),d=h(g[0],b);return g.length>1?I.localize(4,null,d,g.length):d}if(R.isString(S))return S;if(S.detail){const g=S.detail;if(g.error)return A(g.error,b);if(g.exception)return A(g.exception,b)}return S.stack?A(S,b):S.message?S.message:I.localize(5,null)}function l(S){const b=S;return b instanceof Error&&Array.isArray(b.actions)}function f(S,b){let g;return typeof S=="string"?g=new Error(S):g=S,g.actions=b,g}}),define(se[153],oe([11,10]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(se[154],oe([0,1,153]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=R;function R(I){switch(I){case 1:return(0,n.localize)(0,null);case 2:return(0,n.localize)(1,null);case 3:return(0,n.localize)(2,null);case 4:return(0,n.localize)(3,null);case 5:return(0,n.localize)(4,null);case 6:return(0,n.localize)(5,null);case 7:return(0,n.localize)(6,null);case 8:return(0,n.localize)(7,null);case 9:return(0,n.localize)(8,null);default:return""}}}),define(se[155],oe([11,10]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(se[4],oe([0,1,155]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=s,e.isLittleEndian=C,e.isBigSurOrNewer=M,e.LANGUAGE_DEFAULT="en";let R=!1,I=!1,A=!1,k=!1,P=!1,h=!1,l=!1,f=!1,S=!1,b=!1,g,d=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT,w,m;const c=globalThis;let v;typeof c.vscode<"u"&&typeof c.vscode.process<"u"?v=c.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(v=process);const E=typeof v?.versions?.electron=="string",a=E&&v?.type==="renderer";if(typeof v=="object"){R=v.platform==="win32",I=v.platform==="darwin",A=v.platform==="linux",k=A&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,l=E,S=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=e.LANGUAGE_DEFAULT,d=e.LANGUAGE_DEFAULT;const D=v.env.VSCODE_NLS_CONFIG;if(D)try{const W=JSON.parse(D),O=W.availableLanguages["*"];g=W.locale,y=W.osLocale,d=O||e.LANGUAGE_DEFAULT,w=W._translationsConfigFile}catch{}P=!0}else typeof navigator=="object"&&!a?(m=navigator.userAgent,R=m.indexOf("Windows")>=0,I=m.indexOf("Macintosh")>=0,f=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=m.indexOf("Linux")>=0,b=m?.indexOf("Mobi")>=0,h=!0,g=n.getConfiguredDefaultLocale(n.localize(0,null))||e.LANGUAGE_DEFAULT,d=g,y=navigator.language):console.error("Unable to resolve platform.");var t;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(t||(e.Platform=t={}));function s(D){switch(D){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let r=0;I?r=1:R?r=3:A&&(r=2),e.isWindows=R,e.isMacintosh=I,e.isLinux=A,e.isLinuxSnap=k,e.isNative=P,e.isElectron=l,e.isWeb=h,e.isWebWorker=h&&typeof c.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?c.origin:void 0,e.isIOS=f,e.isMobile=b,e.isCI=S,e.platform=r,e.userAgent=m,e.language=d;var i;(function(D){function W(){return e.language}D.value=W;function O(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}D.isDefaultVariant=O;function _(){return e.language==="en"}D.isDefault=_})(i||(e.Language=i={})),e.locale=g,e.platformLocale=y,e.translationsConfigFile=w,e.setTimeout0IsFaster=typeof c.postMessage=="function"&&!c.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const D=[];c.addEventListener("message",O=>{if(O.data&&O.data.vscodeScheduleAsyncWork)for(let _=0,F=D.length;_<F;_++){const x=D[_];if(x.id===O.data.vscodeScheduleAsyncWork){D.splice(_,1),x.callback();return}}});let W=0;return O=>{const _=++W;D.push({id:_,callback:O}),c.postMessage({vscodeScheduleAsyncWork:_},"*")}}return D=>setTimeout(D)})();var o;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(o||(e.OperatingSystem=o={})),e.OS=I||f?2:R?1:3;let u=!0,p=!1;function C(){if(!p){p=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,u=new Uint16Array(D.buffer)[0]===513}return u}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function M(D){return parseFloat(D)>=20}}),define(se[36],oe([0,1,4]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let R;const I=globalThis.vscode;if(typeof I<"u"&&typeof I.process<"u"){const A=I.process;R={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return n.isWindows?"win32":n.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.arch=R.arch}),define(se[9],oe([0,1,36]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,I=97,A=90,k=122,P=46,h=47,l=92,f=58,S=63;class b extends Error{constructor(s,r,i){let o;typeof r=="string"&&r.indexOf("not ")===0?(o="must not be",r=r.replace(/^not /,"")):o="must be";const u=s.indexOf(".")!==-1?"property":"argument";let p=`The "${s}" ${u} ${o} of type ${r}`;p+=`. Received type ${typeof i}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function g(t,s){if(t===null||typeof t!="object")throw new b(s,"Object",t)}function d(t,s){if(typeof t!="string")throw new b(s,"string",t)}const y=n.platform==="win32";function w(t){return t===h||t===l}function m(t){return t===h}function c(t){return t>=R&&t<=A||t>=I&&t<=k}function v(t,s,r,i){let o="",u=0,p=-1,C=0,M=0;for(let D=0;D<=t.length;++D){if(D<t.length)M=t.charCodeAt(D);else{if(i(M))break;M=h}if(i(M)){if(!(p===D-1||C===1))if(C===2){if(o.length<2||u!==2||o.charCodeAt(o.length-1)!==P||o.charCodeAt(o.length-2)!==P){if(o.length>2){const W=o.lastIndexOf(r);W===-1?(o="",u=0):(o=o.slice(0,W),u=o.length-1-o.lastIndexOf(r)),p=D,C=0;continue}else if(o.length!==0){o="",u=0,p=D,C=0;continue}}s&&(o+=o.length>0?`${r}..`:"..",u=2)}else o.length>0?o+=`${r}${t.slice(p+1,D)}`:o=t.slice(p+1,D),u=D-p-1;p=D,C=0}else M===P&&C!==-1?++C:C=-1}return o}function E(t,s){g(s,"pathObject");const r=s.dir||s.root,i=s.base||`${s.name||""}${s.ext||""}`;return r?r===s.root?`${r}${i}`:`${r}${t}${i}`:i}e.win32={resolve(...t){let s="",r="",i=!1;for(let o=t.length-1;o>=-1;o--){let u;if(o>=0){if(u=t[o],d(u,"path"),u.length===0)continue}else s.length===0?u=n.cwd():(u=n.env[`=${s}`]||n.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==s.toLowerCase()&&u.charCodeAt(2)===l)&&(u=`${s}\\`));const p=u.length;let C=0,M="",D=!1;const W=u.charCodeAt(0);if(p===1)w(W)&&(C=1,D=!0);else if(w(W))if(D=!0,w(u.charCodeAt(1))){let O=2,_=O;for(;O<p&&!w(u.charCodeAt(O));)O++;if(O<p&&O!==_){const F=u.slice(_,O);for(_=O;O<p&&w(u.charCodeAt(O));)O++;if(O<p&&O!==_){for(_=O;O<p&&!w(u.charCodeAt(O));)O++;(O===p||O!==_)&&(M=`\\\\${F}\\${u.slice(_,O)}`,C=O)}}}else C=1;else c(W)&&u.charCodeAt(1)===f&&(M=u.slice(0,2),C=2,p>2&&w(u.charCodeAt(2))&&(D=!0,C=3));if(M.length>0)if(s.length>0){if(M.toLowerCase()!==s.toLowerCase())continue}else s=M;if(i){if(s.length>0)break}else if(r=`${u.slice(C)}\\${r}`,i=D,D&&s.length>0)break}return r=v(r,!i,"\\",w),i?`${s}\\${r}`:`${s}${r}`||"."},normalize(t){d(t,"path");const s=t.length;if(s===0)return".";let r=0,i,o=!1;const u=t.charCodeAt(0);if(s===1)return m(u)?"\\":t;if(w(u))if(o=!0,w(t.charCodeAt(1))){let C=2,M=C;for(;C<s&&!w(t.charCodeAt(C));)C++;if(C<s&&C!==M){const D=t.slice(M,C);for(M=C;C<s&&w(t.charCodeAt(C));)C++;if(C<s&&C!==M){for(M=C;C<s&&!w(t.charCodeAt(C));)C++;if(C===s)return`\\\\${D}\\${t.slice(M)}\\`;C!==M&&(i=`\\\\${D}\\${t.slice(M,C)}`,r=C)}}}else r=1;else c(u)&&t.charCodeAt(1)===f&&(i=t.slice(0,2),r=2,s>2&&w(t.charCodeAt(2))&&(o=!0,r=3));let p=r<s?v(t.slice(r),!o,"\\",w):"";return p.length===0&&!o&&(p="."),p.length>0&&w(t.charCodeAt(s-1))&&(p+="\\"),i===void 0?o?`\\${p}`:p:o?`${i}\\${p}`:`${i}${p}`},isAbsolute(t){d(t,"path");const s=t.length;if(s===0)return!1;const r=t.charCodeAt(0);return w(r)||s>2&&c(r)&&t.charCodeAt(1)===f&&w(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,r;for(let u=0;u<t.length;++u){const p=t[u];d(p,"path"),p.length>0&&(s===void 0?s=r=p:s+=`\\${p}`)}if(s===void 0)return".";let i=!0,o=0;if(typeof r=="string"&&w(r.charCodeAt(0))){++o;const u=r.length;u>1&&w(r.charCodeAt(1))&&(++o,u>2&&(w(r.charCodeAt(2))?++o:i=!1))}if(i){for(;o<s.length&&w(s.charCodeAt(o));)o++;o>=2&&(s=`\\${s.slice(o)}`)}return e.win32.normalize(s)},relative(t,s){if(d(t,"from"),d(s,"to"),t===s)return"";const r=e.win32.resolve(t),i=e.win32.resolve(s);if(r===i||(t=r.toLowerCase(),s=i.toLowerCase(),t===s))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===l;)o++;let u=t.length;for(;u-1>o&&t.charCodeAt(u-1)===l;)u--;const p=u-o;let C=0;for(;C<s.length&&s.charCodeAt(C)===l;)C++;let M=s.length;for(;M-1>C&&s.charCodeAt(M-1)===l;)M--;const D=M-C,W=p<D?p:D;let O=-1,_=0;for(;_<W;_++){const x=t.charCodeAt(o+_);if(x!==s.charCodeAt(C+_))break;x===l&&(O=_)}if(_!==W){if(O===-1)return i}else{if(D>W){if(s.charCodeAt(C+_)===l)return i.slice(C+_+1);if(_===2)return i.slice(C+_)}p>W&&(t.charCodeAt(o+_)===l?O=_:_===2&&(O=3)),O===-1&&(O=0)}let F="";for(_=o+O+1;_<=u;++_)(_===u||t.charCodeAt(_)===l)&&(F+=F.length===0?"..":"\\..");return C+=O,F.length>0?`${F}${i.slice(C,M)}`:(i.charCodeAt(C)===l&&++C,i.slice(C,M))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.win32.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===l){if(s.charCodeAt(1)===l){const r=s.charCodeAt(2);if(r!==S&&r!==P)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(c(s.charCodeAt(0))&&s.charCodeAt(1)===f&&s.charCodeAt(2)===l)return`\\\\?\\${s}`;return t},dirname(t){d(t,"path");const s=t.length;if(s===0)return".";let r=-1,i=0;const o=t.charCodeAt(0);if(s===1)return w(o)?t:".";if(w(o)){if(r=i=1,w(t.charCodeAt(1))){let C=2,M=C;for(;C<s&&!w(t.charCodeAt(C));)C++;if(C<s&&C!==M){for(M=C;C<s&&w(t.charCodeAt(C));)C++;if(C<s&&C!==M){for(M=C;C<s&&!w(t.charCodeAt(C));)C++;if(C===s)return t;C!==M&&(r=i=C+1)}}}}else c(o)&&t.charCodeAt(1)===f&&(r=s>2&&w(t.charCodeAt(2))?3:2,i=r);let u=-1,p=!0;for(let C=s-1;C>=i;--C)if(w(t.charCodeAt(C))){if(!p){u=C;break}}else p=!1;if(u===-1){if(r===-1)return".";u=r}return t.slice(0,u)},basename(t,s){s!==void 0&&d(s,"ext"),d(t,"path");let r=0,i=-1,o=!0,u;if(t.length>=2&&c(t.charCodeAt(0))&&t.charCodeAt(1)===f&&(r=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let p=s.length-1,C=-1;for(u=t.length-1;u>=r;--u){const M=t.charCodeAt(u);if(w(M)){if(!o){r=u+1;break}}else C===-1&&(o=!1,C=u+1),p>=0&&(M===s.charCodeAt(p)?--p===-1&&(i=u):(p=-1,i=C))}return r===i?i=C:i===-1&&(i=t.length),t.slice(r,i)}for(u=t.length-1;u>=r;--u)if(w(t.charCodeAt(u))){if(!o){r=u+1;break}}else i===-1&&(o=!1,i=u+1);return i===-1?"":t.slice(r,i)},extname(t){d(t,"path");let s=0,r=-1,i=0,o=-1,u=!0,p=0;t.length>=2&&t.charCodeAt(1)===f&&c(t.charCodeAt(0))&&(s=i=2);for(let C=t.length-1;C>=s;--C){const M=t.charCodeAt(C);if(w(M)){if(!u){i=C+1;break}continue}o===-1&&(u=!1,o=C+1),M===P?r===-1?r=C:p!==1&&(p=1):r!==-1&&(p=-1)}return r===-1||o===-1||p===0||p===1&&r===o-1&&r===i+1?"":t.slice(r,o)},format:E.bind(null,"\\"),parse(t){d(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const r=t.length;let i=0,o=t.charCodeAt(0);if(r===1)return w(o)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(w(o)){if(i=1,w(t.charCodeAt(1))){let O=2,_=O;for(;O<r&&!w(t.charCodeAt(O));)O++;if(O<r&&O!==_){for(_=O;O<r&&w(t.charCodeAt(O));)O++;if(O<r&&O!==_){for(_=O;O<r&&!w(t.charCodeAt(O));)O++;O===r?i=O:O!==_&&(i=O+1)}}}}else if(c(o)&&t.charCodeAt(1)===f){if(r<=2)return s.root=s.dir=t,s;if(i=2,w(t.charCodeAt(2))){if(r===3)return s.root=s.dir=t,s;i=3}}i>0&&(s.root=t.slice(0,i));let u=-1,p=i,C=-1,M=!0,D=t.length-1,W=0;for(;D>=i;--D){if(o=t.charCodeAt(D),w(o)){if(!M){p=D+1;break}continue}C===-1&&(M=!1,C=D+1),o===P?u===-1?u=D:W!==1&&(W=1):u!==-1&&(W=-1)}return C!==-1&&(u===-1||W===0||W===1&&u===C-1&&u===p+1?s.base=s.name=t.slice(p,C):(s.name=t.slice(p,u),s.base=t.slice(p,C),s.ext=t.slice(u,C))),p>0&&p!==i?s.dir=t.slice(0,p-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(y){const t=/\\/g;return()=>{const s=n.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>n.cwd()})();e.posix={resolve(...t){let s="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const o=i>=0?t[i]:a();d(o,"path"),o.length!==0&&(s=`${o}/${s}`,r=o.charCodeAt(0)===h)}return s=v(s,!r,"/",m),r?`/${s}`:s.length>0?s:"."},normalize(t){if(d(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===h,r=t.charCodeAt(t.length-1)===h;return t=v(t,!s,"/",m),t.length===0?s?"/":r?"./":".":(r&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return d(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let s;for(let r=0;r<t.length;++r){const i=t[r];d(i,"path"),i.length>0&&(s===void 0?s=i:s+=`/${i}`)}return s===void 0?".":e.posix.normalize(s)},relative(t,s){if(d(t,"from"),d(s,"to"),t===s||(t=e.posix.resolve(t),s=e.posix.resolve(s),t===s))return"";const r=1,i=t.length,o=i-r,u=1,p=s.length-u,C=o<p?o:p;let M=-1,D=0;for(;D<C;D++){const O=t.charCodeAt(r+D);if(O!==s.charCodeAt(u+D))break;O===h&&(M=D)}if(D===C)if(p>C){if(s.charCodeAt(u+D)===h)return s.slice(u+D+1);if(D===0)return s.slice(u+D)}else o>C&&(t.charCodeAt(r+D)===h?M=D:D===0&&(M=0));let W="";for(D=r+M+1;D<=i;++D)(D===i||t.charCodeAt(D)===h)&&(W+=W.length===0?"..":"/..");return`${W}${s.slice(u+M)}`},toNamespacedPath(t){return t},dirname(t){if(d(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===h;let r=-1,i=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===h){if(!i){r=o;break}}else i=!1;return r===-1?s?"/":".":s&&r===1?"//":t.slice(0,r)},basename(t,s){s!==void 0&&d(s,"ext"),d(t,"path");let r=0,i=-1,o=!0,u;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let p=s.length-1,C=-1;for(u=t.length-1;u>=0;--u){const M=t.charCodeAt(u);if(M===h){if(!o){r=u+1;break}}else C===-1&&(o=!1,C=u+1),p>=0&&(M===s.charCodeAt(p)?--p===-1&&(i=u):(p=-1,i=C))}return r===i?i=C:i===-1&&(i=t.length),t.slice(r,i)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===h){if(!o){r=u+1;break}}else i===-1&&(o=!1,i=u+1);return i===-1?"":t.slice(r,i)},extname(t){d(t,"path");let s=-1,r=0,i=-1,o=!0,u=0;for(let p=t.length-1;p>=0;--p){const C=t.charCodeAt(p);if(C===h){if(!o){r=p+1;break}continue}i===-1&&(o=!1,i=p+1),C===P?s===-1?s=p:u!==1&&(u=1):s!==-1&&(u=-1)}return s===-1||i===-1||u===0||u===1&&s===i-1&&s===r+1?"":t.slice(s,i)},format:E.bind(null,"/"),parse(t){d(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const r=t.charCodeAt(0)===h;let i;r?(s.root="/",i=1):i=0;let o=-1,u=0,p=-1,C=!0,M=t.length-1,D=0;for(;M>=i;--M){const W=t.charCodeAt(M);if(W===h){if(!C){u=M+1;break}continue}p===-1&&(C=!1,p=M+1),W===P?o===-1?o=M:D!==1&&(D=1):o!==-1&&(D=-1)}if(p!==-1){const W=u===0&&r?1:u;o===-1||D===0||D===1&&o===p-1&&o===u+1?s.base=s.name=t.slice(W,p):(s.name=t.slice(W,o),s.base=t.slice(W,p),s.ext=t.slice(o,p))}return u>0?s.dir=t.slice(0,u-1):r&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y?e.win32.normalize:e.posix.normalize,e.isAbsolute=y?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y?e.win32.join:e.posix.join,e.resolve=y?e.win32.resolve:e.posix.resolve,e.relative=y?e.win32.relative:e.posix.relative,e.dirname=y?e.win32.dirname:e.posix.dirname,e.basename=y?e.win32.basename:e.posix.basename,e.extname=y?e.win32.extname:e.posix.extname,e.format=y?e.win32.format:e.posix.format,e.parse=y?e.win32.parse:e.posix.parse,e.toNamespacedPath=y?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y?e.win32.sep:e.posix.sep,e.delimiter=y?e.win32.delimiter:e.posix.delimiter}),define(se[31],oe([0,1,9,4,25,12]),function(Q,e,n,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=k,e.toSlashes=P,e.toPosixPath=h,e.getRoot=l,e.isUNC=f,e.isValidBasename=d,e.isEqual=y,e.isEqualOrParent=w,e.isWindowsDriveLetter=m,e.sanitizeFilePath=c,e.removeTrailingPathSeparator=v,e.isRootOrDriveLetter=E,e.hasDriveLetter=a,e.getDriveLetter=t,e.indexOfPath=s,e.parseLineAndColumnAware=r,e.randomPath=u;function k(p){return p===47||p===92}function P(p){return p.replace(/[\\/]/g,n.posix.sep)}function h(p){return p.indexOf("/")===-1&&(p=P(p)),/^[a-zA-Z]:(\/|$)/.test(p)&&(p="/"+p),p}function l(p,C=n.posix.sep){if(!p)return"";const M=p.length,D=p.charCodeAt(0);if(k(D)){if(k(p.charCodeAt(1))&&!k(p.charCodeAt(2))){let O=3;const _=O;for(;O<M&&!k(p.charCodeAt(O));O++);if(_!==O&&!k(p.charCodeAt(O+1))){for(O+=1;O<M;O++)if(k(p.charCodeAt(O)))return p.slice(0,O+1).replace(/[\\/]/g,C)}}return C}else if(m(D)&&p.charCodeAt(1)===58)return k(p.charCodeAt(2))?p.slice(0,2)+C:p.slice(0,2);let W=p.indexOf("://");if(W!==-1){for(W+=3;W<M;W++)if(k(p.charCodeAt(W)))return p.slice(0,W+1)}return""}function f(p){if(!R.isWindows||!p||p.length<5)return!1;let C=p.charCodeAt(0);if(C!==92||(C=p.charCodeAt(1),C!==92))return!1;let M=2;const D=M;for(;M<p.length&&(C=p.charCodeAt(M),C!==92);M++);return!(D===M||(C=p.charCodeAt(M+1),isNaN(C)||C===92))}const S=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(p,C=R.isWindows){const M=C?S:b;return!(!p||p.length===0||/^\s+$/.test(p)||(M.lastIndex=0,M.test(p))||C&&g.test(p)||p==="."||p===".."||C&&p[p.length-1]==="."||C&&p.length!==p.trim().length||p.length>255)}function y(p,C,M){const D=p===C;return!M||D?D:!p||!C?!1:(0,I.equalsIgnoreCase)(p,C)}function w(p,C,M,D=n.sep){if(p===C)return!0;if(!p||!C||C.length>p.length)return!1;if(M){if(!(0,I.startsWithIgnoreCase)(p,C))return!1;if(C.length===p.length)return!0;let O=C.length;return C.charAt(C.length-1)===D&&O--,p.charAt(O)===D}return C.charAt(C.length-1)!==D&&(C+=D),p.indexOf(C)===0}function m(p){return p>=65&&p<=90||p>=97&&p<=122}function c(p,C){return R.isWindows&&p.endsWith(":")&&(p+=n.sep),(0,n.isAbsolute)(p)||(p=(0,n.join)(C,p)),p=(0,n.normalize)(p),v(p)}function v(p){return R.isWindows?(p=(0,I.rtrim)(p,n.sep),p.endsWith(":")&&(p+=n.sep)):(p=(0,I.rtrim)(p,n.sep),p||(p=n.sep)),p}function E(p){const C=(0,n.normalize)(p);return R.isWindows?p.length>3?!1:a(C)&&(p.length===2||C.charCodeAt(2)===92):C===n.posix.sep}function a(p,C=R.isWindows){return C?m(p.charCodeAt(0))&&p.charCodeAt(1)===58:!1}function t(p,C=R.isWindows){return a(p,C)?p[0]:void 0}function s(p,C,M){return C.length>p.length?-1:p===C?0:(M&&(p=p.toLowerCase(),C=C.toLowerCase()),p.indexOf(C))}function r(p){const C=p.split(":");let M,D,W;for(const O of C){const _=Number(O);(0,A.isNumber)(_)?D===void 0?D=_:W===void 0&&(W=_):M=M?[M,O].join(":"):O}if(!M)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:M,line:D!==void 0?D:void 0,column:W!==void 0?W:D!==void 0?1:void 0}}const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function u(p,C,M=8){let D="";for(let O=0;O<M;O++){let _;O===0&&R.isWindows&&!C&&(M===3||M===4)?_=o:_=i,D+=_.charAt(Math.floor(Math.random()*_.length))}let W;return C?W=`${C}-${D}`:W=D,p?(0,n.join)(p,W):W}}),define(se[76],oe([0,1,4]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=A,e.removeDangerousEnvVariables=k;var R;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(R||(e.Source=R={}));var I;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(I||(e.TerminateResponseCode=I={}));function A(P,...h){const l=h.reduce((b,g)=>(b[g]=!0,b),{}),f=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(b=>!l[b]).forEach(b=>{for(let g=0;g<f.length;g++)if(b.search(f[g])!==-1){delete P[b];break}})}function k(P){P&&(delete P.DEBUG,n.isMacintosh&&delete P.DYLD_LIBRARY_PATH,n.isLinux&&delete P.LD_PRELOAD)}}),define(se[7],oe([0,1,9,4]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=d,e.uriToFsPath=E;const I=/^\w[\w\d+.-]*$/,A=/^\//,k=/^\/\//;function P(i,o){if(!i.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!I.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,o){return!i&&!o?"file":i}function l(i,o){switch(i){case"https":case"http":case"file":o?o[0]!==S&&(o=S+o):o=S;break}return o}const f="",S="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(o){return o instanceof g?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,u,p,C,M,D=!1){typeof o=="object"?(this.scheme=o.scheme||f,this.authority=o.authority||f,this.path=o.path||f,this.query=o.query||f,this.fragment=o.fragment||f):(this.scheme=h(o,D),this.authority=u||f,this.path=l(this.scheme,p||f),this.query=C||f,this.fragment=M||f,P(this,D))}get fsPath(){return E(this,!1)}with(o){if(!o)return this;let{scheme:u,authority:p,path:C,query:M,fragment:D}=o;return u===void 0?u=this.scheme:u===null&&(u=f),p===void 0?p=this.authority:p===null&&(p=f),C===void 0?C=this.path:C===null&&(C=f),M===void 0?M=this.query:M===null&&(M=f),D===void 0?D=this.fragment:D===null&&(D=f),u===this.scheme&&p===this.authority&&C===this.path&&M===this.query&&D===this.fragment?this:new w(u,p,C,M,D)}static parse(o,u=!1){const p=b.exec(o);return p?new w(p[2]||f,r(p[4]||f),r(p[5]||f),r(p[7]||f),r(p[9]||f),u):new w(f,f,f,f,f)}static file(o){let u=f;if(R.isWindows&&(o=o.replace(/\\/g,S)),o[0]===S&&o[1]===S){const p=o.indexOf(S,2);p===-1?(u=o.substring(2),o=S):(u=o.substring(2,p),o=o.substring(p)||S)}return new w("file",u,o,f,f)}static from(o,u){return new w(o.scheme,o.authority,o.path,o.query,o.fragment,u)}static joinPath(o,...u){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return R.isWindows&&o.scheme==="file"?p=g.file(n.win32.join(E(o,!0),...u)).path:p=n.posix.join(o.path,...u),o.with({path:p})}toString(o=!1){return a(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof g)return o;{const u=new w(o);return u._formatted=o.external??null,u._fsPath=o._sep===y?o.fsPath??null:null,u}}else return o}}e.URI=g;function d(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}const y=R.isWindows?1:void 0;class w extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(o=!1){return o?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=y),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const m={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function c(i,o,u){let p,C=-1;for(let M=0;M<i.length;M++){const D=i.charCodeAt(M);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||o&&D===47||u&&D===91||u&&D===93||u&&D===58)C!==-1&&(p+=encodeURIComponent(i.substring(C,M)),C=-1),p!==void 0&&(p+=i.charAt(M));else{p===void 0&&(p=i.substr(0,M));const W=m[D];W!==void 0?(C!==-1&&(p+=encodeURIComponent(i.substring(C,M)),C=-1),p+=W):C===-1&&(C=M)}}return C!==-1&&(p+=encodeURIComponent(i.substring(C))),p!==void 0?p:i}function v(i){let o;for(let u=0;u<i.length;u++){const p=i.charCodeAt(u);p===35||p===63?(o===void 0&&(o=i.substr(0,u)),o+=m[p]):o!==void 0&&(o+=i[u])}return o!==void 0?o:i}function E(i,o){let u;return i.authority&&i.path.length>1&&i.scheme==="file"?u=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?o?u=i.path.substr(1):u=i.path[1].toLowerCase()+i.path.substr(2):u=i.path,R.isWindows&&(u=u.replace(/\//g,"\\")),u}function a(i,o){const u=o?v:c;let p="",{scheme:C,authority:M,path:D,query:W,fragment:O}=i;if(C&&(p+=C,p+=":"),(M||C==="file")&&(p+=S,p+=S),M){let _=M.indexOf("@");if(_!==-1){const F=M.substr(0,_);M=M.substr(_+1),_=F.lastIndexOf(":"),_===-1?p+=u(F,!1,!1):(p+=u(F.substr(0,_),!1,!1),p+=":",p+=u(F.substr(_+1),!1,!0)),p+="@"}M=M.toLowerCase(),_=M.lastIndexOf(":"),_===-1?p+=u(M,!1,!0):(p+=u(M.substr(0,_),!1,!0),p+=M.substr(_))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const _=D.charCodeAt(1);_>=65&&_<=90&&(D=`/${String.fromCharCode(_+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const _=D.charCodeAt(0);_>=65&&_<=90&&(D=`${String.fromCharCode(_+32)}:${D.substr(2)}`)}p+=u(D,!0,!1)}return W&&(p+="?",p+=u(W,!1,!1)),O&&(p+="#",p+=o?O:c(O,!1,!1)),p}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(s)?i.replace(s,o=>t(o)):i}}),define(se[156],oe([0,1,7]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=R,e.parse=I,e.getFirstFrame=A,e.log=P;function R(l){const f=l;return f&&typeof f.type=="string"&&typeof f.severity=="string"}function I(l){const f=[];let S;try{const b=JSON.parse(l.arguments),g=b[b.length-1];g&&g.__$stack&&(b.pop(),S=g.__$stack),f.push(...b)}catch{f.push("Unable to log remote console arguments",l.arguments)}return{args:f,stack:S}}function A(l){if(typeof l!="string")return A(I(l).stack);const f=l;if(f){const S=k(f),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(b&&b.length===4)return{uri:n.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}function k(l){if(!l)return l;const f=l.indexOf(`
`);return f===-1?l:l.substring(0,f)}function P(l,f){const{args:S,stack:b}=I(l),g=typeof S[0]=="string"&&S.length===1;let d=k(b);d&&(d=`(${d.trim()})`);let y=[];if(typeof S[0]=="string"?d&&g?y=[`%c[${f}] %c${S[0]} %c${d}`,h("blue"),h(""),h("grey")]:y=[`%c[${f}] %c${S[0]}`,h("blue"),h(""),...S.slice(1)]:y=[`%c[${f}]%`,h("blue"),...S],d&&!g&&y.push(d),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,y)}function h(l){return`color: ${l}`}}),define(se[77],oe([0,1,17,7]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=I,e.parse=A,e.revive=P;function I(h){return JSON.stringify(h,k)}function A(h){let l=JSON.parse(h);return l=P(l),l}function k(h,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function P(h,l=0){if(!h||l>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return R.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof n.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let f=0;f<h.length;++f)h[f]=P(h[f],l+1);else for(const f in h)Object.hasOwnProperty.call(h,f)&&(h[f]=P(h[f],l+1))}return h}}),define(se[13],oe([0,1,15,4,25,7,9]),function(Q,e,n,R,I,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=h,e.matchesSomeScheme=l,e.getServerRootPath=S;var P;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(P||(e.Schemas=P={}));function h(d,y){return A.URI.isUri(d)?(0,I.equalsIgnoreCase)(d.scheme,y):(0,I.startsWithIgnoreCase)(d,y+":")}function l(d,...y){return y.some(w=>h(d,w))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class f{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}setServerRootPath(y,w){this._serverRootPath=S(y,w)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return k.posix.join(this._serverRootPath,P.vscodeRemoteResource)}set(y,w,m){this._hosts[y]=w,this._ports[y]=m}setConnectionToken(y,w){this._connectionTokens[y]=w}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(y){if(this._delegate)try{return this._delegate(y)}catch(a){return n.onUnexpectedError(a),y}const w=y.authority;let m=this._hosts[w];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const c=this._ports[w],v=this._connectionTokens[w];let E=`path=${encodeURIComponent(y.path)}`;return typeof v=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),A.URI.from({scheme:R.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${m}:${c}`,path:this._remoteResourcesPath,query:E})}}e.RemoteAuthorities=new f;function S(d,y){return k.posix.join(y??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class b{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(y){const w=this.toUri(y,Q);return this.uriToBrowserUri(w)}uriToBrowserUri(y){return y.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===P.file&&(R.isNative||R.webWorkerOrigin===`${P.vscodeFileResource}://${b.FALLBACK_AUTHORITY}`)?y.with({scheme:P.vscodeFileResource,authority:y.authority||b.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(y){const w=this.toUri(y,Q);return this.uriToFileUri(w)}uriToFileUri(y){return y.scheme===P.vscodeFileResource?y.with({scheme:P.file,authority:y.authority!==b.FALLBACK_AUTHORITY?y.authority:null,query:null,fragment:null}):y}toUri(y,w){return A.URI.isUri(y)?y:A.URI.parse(w.toUrl(y))}}e.FileAccess=new b;var g;(function(d){const y=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(y.get("3"));const w="vscode-coi";function m(v){let E;typeof v=="string"?E=new URL(v).searchParams:v instanceof URL?E=v.searchParams:A.URI.isUri(v)&&(E=new URL(v.toString(!0)).searchParams);const a=E?.get(w);if(a)return y.get(a)}d.getHeadersFromQuery=m;function c(v,E,a){if(!globalThis.crossOriginIsolated)return;const t=E&&a?"3":a?"2":"1";v instanceof URLSearchParams?v.set(w,t):v[w]=t}d.addSearchParam=c})(g||(e.COI=g={}))}),define(se[19],oe([0,1,31,13,9,4,25,7]),function(Q,e,n,R,I,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=h,e.distinctParents=f,e.toLocalResource=b;function h(g){return(0,P.uriToFsPath)(g,!0)}class l{constructor(d){this._ignorePathCasing=d}compare(d,y,w=!1){return d===y?0:(0,k.compare)(this.getComparisonKey(d,w),this.getComparisonKey(y,w))}isEqual(d,y,w=!1){return d===y?!0:!d||!y?!1:this.getComparisonKey(d,w)===this.getComparisonKey(y,w)}getComparisonKey(d,y=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,y,w=!1){if(d.scheme===y.scheme){if(d.scheme===R.Schemas.file)return n.isEqualOrParent(h(d),h(y),this._ignorePathCasing(d))&&d.query===y.query&&(w||d.fragment===y.fragment);if((0,e.isEqualAuthority)(d.authority,y.authority))return n.isEqualOrParent(d.path,y.path,this._ignorePathCasing(d),"/")&&d.query===y.query&&(w||d.fragment===y.fragment)}return!1}joinPath(d,...y){return P.URI.joinPath(d,...y)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return I.posix.basename(d.path)}extname(d){return I.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let y;return d.scheme===R.Schemas.file?y=P.URI.file(I.dirname(h(d))).path:(y=I.posix.dirname(d.path),d.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),y="/")),d.with({path:y})}normalizePath(d){if(!d.path.length)return d;let y;return d.scheme===R.Schemas.file?y=P.URI.file(I.normalize(h(d))).path:y=I.posix.normalize(d.path),d.with({path:y})}relativePath(d,y){if(d.scheme!==y.scheme||!(0,e.isEqualAuthority)(d.authority,y.authority))return;if(d.scheme===R.Schemas.file){const c=I.relative(h(d),h(y));return A.isWindows?n.toSlashes(c):c}let w=d.path||"/";const m=y.path||"/";if(this._ignorePathCasing(d)){let c=0;for(const v=Math.min(w.length,m.length);c<v&&!(w.charCodeAt(c)!==m.charCodeAt(c)&&w.charAt(c).toLowerCase()!==m.charAt(c).toLowerCase());c++);w=m.substr(0,c)+w.substr(c)}return I.posix.relative(w,m)}resolvePath(d,y){if(d.scheme===R.Schemas.file){const w=P.URI.file(I.resolve(h(d),y));return d.with({authority:w.authority,path:w.path})}return y=n.toPosixPath(y),d.with({path:I.posix.resolve(d.path,y)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,y){return d===y||d!==void 0&&y!==void 0&&(0,k.equalsIgnoreCase)(d,y)}hasTrailingPathSeparator(d,y=I.sep){if(d.scheme===R.Schemas.file){const w=h(d);return w.length>n.getRoot(w).length&&w[w.length-1]===y}else{const w=d.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,y=I.sep){return(0,e.hasTrailingPathSeparator)(d,y)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,y=I.sep){let w=!1;if(d.scheme===R.Schemas.file){const m=h(d);w=m!==void 0&&m.length===n.getRoot(m).length&&m[m.length-1]===y}else{y="/";const m=d.path;w=m.length===1&&m.charCodeAt(m.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(d,y)?d.with({path:d.path+"/"}):d}}e.ExtUri=l,e.extUri=new l(()=>!1),e.extUriBiasedIgnorePathCase=new l(g=>g.scheme===R.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new l(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function f(g,d){const y=[];for(let w=0;w<g.length;w++){const m=d(g[w]);g.some((c,v)=>v===w?!1:(0,e.isEqualOrParent)(m,d(c)))||y.push(g[w])}return y}var S;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function d(y){const w=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(v=>{const[E,a]=v.split(":");E&&a&&w.set(E,a)});const c=y.path.substring(0,y.path.indexOf(";"));return c&&w.set(g.META_DATA_MIME,c),w}g.parseMetaData=d})(S||(e.DataUri=S={}));function b(g,d,y){if(d){let w=g.path;return w&&w[0]!==I.posix.sep&&(w=I.posix.sep+w),g.with({scheme:y,authority:d,path:w})}return g.with({scheme:y})}}),define(se[8],oe([0,1,23,15,3,2,19,4,144,62]),function(Q,e,n,R,I,A,k,P,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=f,e.createCancelablePromise=S,e.raceCancellation=b,e.raceCancellationError=g,e.raceCancellablePromises=d,e.raceTimeout=y,e.asPromise=w,e.promiseWithResolvers=m,e.timeout=u,e.disposableTimeout=p,e.sequence=C,e.first=M,e.firstParallel=D,e.retry=T,e.createCancelableAsyncIterable=K;function f(j){return!!j&&typeof j.then=="function"}function S(j){const q=new n.CancellationTokenSource,re=j(q.token),he=new Promise((me,pe)=>{const ye=q.token.onCancellationRequested(()=>{ye.dispose(),pe(new R.CancellationError)});Promise.resolve(re).then(Ee=>{ye.dispose(),q.dispose(),me(Ee)},Ee=>{ye.dispose(),q.dispose(),pe(Ee)})});return new class{cancel(){q.cancel(),q.dispose()}then(me,pe){return he.then(me,pe)}catch(me){return this.then(void 0,me)}finally(me){return he.finally(me)}}}function b(j,q,re){return new Promise((he,me)=>{const pe=q.onCancellationRequested(()=>{pe.dispose(),he(re)});j.then(he,me).finally(()=>pe.dispose())})}function g(j,q){return new Promise((re,he)=>{const me=q.onCancellationRequested(()=>{me.dispose(),he(new R.CancellationError)});j.then(re,he).finally(()=>me.dispose())})}async function d(j){let q=-1;const re=j.map((he,me)=>he.then(pe=>(q=me,pe)));try{return await Promise.race(re)}finally{j.forEach((he,me)=>{me!==q&&he.cancel()})}}function y(j,q,re){let he;const me=setTimeout(()=>{he?.(void 0),re?.()},q);return Promise.race([j.finally(()=>clearTimeout(me)),new Promise(pe=>he=pe)])}function w(j){return new Promise((q,re)=>{const he=j();f(he)?he.then(q,re):q(he)})}function m(){let j,q;return{promise:new Promise((he,me)=>{j=he,q=me}),resolve:j,reject:q}}class c{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(q){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=q,!this.queuedPromise){const re=()=>{if(this.queuedPromise=null,this.isDisposed)return;const he=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,he};this.queuedPromise=new Promise(he=>{this.activePromise.then(re,re).then(he)})}return new Promise((re,he)=>{this.queuedPromise.then(re,he)})}return this.activePromise=q(),new Promise((re,he)=>{this.activePromise.then(me=>{this.activePromise=null,re(me)},me=>{this.activePromise=null,he(me)})})}dispose(){this.isDisposed=!0}}e.Throttler=c;class v{constructor(){this.current=Promise.resolve(null)}queue(q){return this.current=this.current.then(()=>q(),()=>q())}}e.Sequencer=v;class E{constructor(){this.promiseMap=new Map}queue(q,re){const me=(this.promiseMap.get(q)??Promise.resolve()).catch(()=>{}).then(re).finally(()=>{this.promiseMap.get(q)===me&&this.promiseMap.delete(q)});return this.promiseMap.set(q,me),me}}e.SequencerByKey=E;const a=(j,q)=>{let re=!0;const he=setTimeout(()=>{re=!1,q()},j);return{isTriggered:()=>re,dispose:()=>{clearTimeout(he),re=!1}}},t=j=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,j())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class s{constructor(q){this.defaultDelay=q,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(q,re=this.defaultDelay){this.task=q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((me,pe)=>{this.doResolve=me,this.doReject=pe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const me=this.task;return this.task=null,me()}}));const he=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=re===h.MicrotaskDelay?t(he):a(re,he),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new R.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=s;class r{constructor(q){this.delayer=new s(q),this.throttler=new c}trigger(q,re){return this.delayer.trigger(()=>this.throttler.queue(q),re)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=r;class i{constructor(){this._isOpen=!1,this._promise=new Promise((q,re)=>{this._completePromise=q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class o extends i{constructor(q){super(),this._timeout=setTimeout(()=>this.open(),q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function u(j,q){return q?new Promise((re,he)=>{const me=setTimeout(()=>{pe.dispose(),re()},j),pe=q.onCancellationRequested(()=>{clearTimeout(me),pe.dispose(),he(new R.CancellationError)})}):S(re=>u(j,re))}function p(j,q=0,re){const he=setTimeout(()=>{j(),re&&me.dispose()},q),me=(0,A.toDisposable)(()=>{clearTimeout(he),re?.deleteAndLeak(me)});return re?.add(me),me}function C(j){const q=[];let re=0;const he=j.length;function me(){return re<he?j[re++]():null}function pe(ye){ye!=null&&q.push(ye);const Ee=me();return Ee?Ee.then(pe):Promise.resolve(q)}return Promise.resolve(null).then(pe)}function M(j,q=he=>!!he,re=null){let he=0;const me=j.length,pe=()=>{if(he>=me)return Promise.resolve(re);const ye=j[he++];return Promise.resolve(ye()).then(Pe=>q(Pe)?Promise.resolve(Pe):pe())};return pe()}function D(j,q=he=>!!he,re=null){if(j.length===0)return Promise.resolve(re);let he=j.length;const me=()=>{he=-1;for(const pe of j)pe.cancel?.()};return new Promise((pe,ye)=>{for(const Ee of j)Ee.then(Pe=>{--he>=0&&q(Pe)?(me(),pe(Pe)):he===0&&pe(re)}).catch(Pe=>{--he>=0&&(me(),ye(Pe))})})}class W{constructor(q){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=q,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new I.Emitter}whenIdle(){return this.size>0?I.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(q){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((re,he)=>{this.outstandingPromises.push({factory:q,c:re,e:he}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const q=this.outstandingPromises.shift();this.runningPromises++;const re=q.factory();re.then(q.c,q.e),re.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=W;class O extends W{constructor(){super(1)}}e.Queue=O;class _{constructor(){this.sequentializer=new U,this.tasks=0}queue(q){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,q())):this.sequentializer.run(this.tasks++,q())}}e.LimitedQueue=_;class F{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const q=new V;return this.drainers.add(q),q.p}isDrained(){for(const[,q]of this.queues)if(q.size>0)return!1;return!0}queueSize(q,re=k.extUri){const he=re.getComparisonKey(q);return this.queues.get(he)?.size??0}queueFor(q,re,he=k.extUri){const me=he.getComparisonKey(q);let pe=this.queues.get(me);if(!pe){pe=new O;const ye=this.drainListenerCount++,Ee=I.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.queues.delete(me),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(ye),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new A.DisposableMap),this.drainListeners.set(ye,Ee),this.queues.set(me,pe)}return pe.queue(re)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const q of this.drainers)q.complete();this.drainers.clear()}dispose(){for(const[,q]of this.queues)q.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=F;class x{constructor(q,re){this._token=-1,typeof q=="function"&&typeof re=="number"&&this.setIfNotSet(q,re)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(q,re){this.cancel(),this._token=setTimeout(()=>{this._token=-1,q()},re)}setIfNotSet(q,re){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,q()},re))}}e.TimeoutTimer=x;class z{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(q,re,he=globalThis){this.cancel();const me=he.setInterval(()=>{q()},re);this.disposable=(0,A.toDisposable)(()=>{he.clearInterval(me),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=z;class ue{constructor(q,re){this.timeoutToken=-1,this.runner=q,this.timeout=re,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,q)}get delay(){return this.timeout}set delay(q){this.timeout=q}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=ue;class ee{constructor(q,re){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.runner=q,this.timeout=re,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(q=this.timeout){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(q/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=ee;class le extends ue{constructor(q,re){super(q,re),this.units=[]}work(q){this.units.push(q),this.isScheduled()||this.schedule()}doRun(){const q=this.units;this.units=[],this.runner?.(q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=le;class Y extends A.Disposable{constructor(q,re){super(),this.options=q,this.handler=re,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(q){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+q.length>this.options.maxBufferedWork)return!1}else if(this.pending+q.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const re of q)this.pendingWork.push(re);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ue(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Y,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(j,q)=>{(0,P.setTimeout0)(()=>{if(re)return;const he=Date.now()+15;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e._runWhenIdle=(j,q,re)=>{const he=j.requestIdleCallback(q,typeof re=="number"?{timeout:re}:void 0);let me=!1;return{dispose(){me||(me=!0,j.cancelIdleCallback(he))}}},e.runWhenGlobalIdle=j=>(0,e._runWhenIdle)(globalThis,j)}();class G{constructor(q,re){this._didRun=!1,this._executor=()=>{try{this._value=re()}catch(he){this._error=he}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(q,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=G;class B extends G{constructor(q){super(globalThis,q)}}e.GlobalIdleValue=B;async function T(j,q,re){let he;for(let me=0;me<re;me++)try{return await j()}catch(pe){he=pe,await u(q)}throw he}class U{isRunning(q){return typeof q=="number"?this._running?.taskId===q:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(q,re,he){return this._running={taskId:q,cancel:()=>he?.(),promise:re},re.then(()=>this.doneRunning(q),()=>this.doneRunning(q)),re}doneRunning(q){this._running&&q===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const q=this._queued;this._queued=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}queue(q){if(this._queued)this._queued.run=q;else{const{promise:re,resolve:he,reject:me}=m();this._queued={run:q,promise:re,promiseResolve:he,promiseReject:me}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=U;class ${constructor(q,re=()=>Date.now()){this.interval=q,this.nowFn=re,this.lastIncrementTime=0,this.value=0}increment(){const q=this.nowFn();return q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=q,this.value=0),this.value++,this.value}}e.IntervalCounter=$;var ae;(function(j){j[j.Resolved=0]="Resolved",j[j.Rejected=1]="Rejected"})(ae||(ae={}));class V{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((q,re)=>{this.completeCallback=q,this.errorCallback=re})}complete(q){return new Promise(re=>{this.completeCallback(q),this.outcome={outcome:0,value:q},re()})}error(q){return new Promise(re=>{this.errorCallback(q),this.outcome={outcome:1,value:q},re()})}cancel(){return this.error(new R.CancellationError)}}e.DeferredPromise=V;var ce;(function(j){async function q(he){let me;const pe=await Promise.all(he.map(ye=>ye.then(Ee=>Ee,Ee=>{me||(me=Ee)})));if(typeof me<"u")throw me;return pe}j.settled=q;function re(he){return new Promise(async(me,pe)=>{try{await he(me,pe)}catch(ye){pe(ye)}})}j.withAsyncBody=re})(ce||(e.Promises=ce={}));class X{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(q){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=q.then(re=>(this._value=re,this._isResolved=!0,re),re=>{throw this._error=re,this._isResolved=!0,re})}requireValue(){if(!this._isResolved)throw new R.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=X;class L{constructor(q){this._compute=q,this._promise=new l.Lazy(()=>new X(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=L;var N;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(N||(N={}));class Z{static fromArray(q){return new Z(re=>{re.emitMany(q)})}static fromPromise(q){return new Z(async re=>{re.emitMany(await q)})}static fromPromises(q){return new Z(async re=>{await Promise.all(q.map(async he=>re.emitOne(await he)))})}static merge(q){return new Z(async re=>{await Promise.all(q.map(async he=>{for await(const me of he)re.emitOne(me)}))})}static{this.EMPTY=Z.fromArray([])}constructor(q,re){this._state=0,this._results=[],this._error=null,this._onReturn=re,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const he={emitOne:me=>this.emitOne(me),emitMany:me=>this.emitMany(me),reject:me=>this.reject(me)};try{await Promise.resolve(q(he)),this.resolve()}catch(me){this.reject(me)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(q<this._results.length)return{done:!1,value:this._results[q++]};if(this._state===1)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(q,re){return new Z(async he=>{for await(const me of q)he.emitOne(re(me))})}map(q){return Z.map(this,q)}static filter(q,re){return new Z(async he=>{for await(const me of q)re(me)&&he.emitOne(me)})}filter(q){return Z.filter(this,q)}static coalesce(q){return Z.filter(q,re=>!!re)}coalesce(){return Z.coalesce(this)}static async toPromise(q){const re=[];for await(const he of q)re.push(he);return re}toPromise(){return Z.toPromise(this)}emitOne(q){this._state===0&&(this._results.push(q),this._onStateChanged.fire())}emitMany(q){this._state===0&&(this._results=this._results.concat(q),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(q){this._state===0&&(this._state=2,this._error=q,this._onStateChanged.fire())}}e.AsyncIterableObject=Z;class ne extends Z{constructor(q,re){super(re),this._source=q}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ne;function K(j){const q=new n.CancellationTokenSource,re=j(q.token);return new ne(q,async he=>{const me=q.token.onCancellationRequested(()=>{me.dispose(),q.dispose(),he.reject(new R.CancellationError)});try{for await(const pe of re){if(q.token.isCancellationRequested)return;he.emitOne(pe)}me.dispose(),q.dispose()}catch(pe){me.dispose(),q.dispose(),he.reject(pe)}})}class H{constructor(q){this._deferred=new V,this._asyncIterable=new Z(me=>{if(re){me.reject(re);return}return he&&me.emitMany(he),this._errorFn=pe=>me.reject(pe),this._emitFn=pe=>me.emitOne(pe),this._deferred.p},q);let re,he;this._emitFn=me=>{he||(he=[]),he.push(me)},this._errorFn=me=>{re||(re=me)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(q){this._errorFn(q),this._deferred.complete()}emitOne(q){this._emitFn(q)}}e.AsyncIterableSource=H}),define(se[108],oe([0,1,22,8,31,32,9,4,25]),function(Q,e,n,R,I,A,k,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=l,e.splitGlobAware=d,e.match=O,e.parse=_,e.isRelativePattern=F,e.getBasenameTerms=x,e.getPathTerms=z,e.patternsEquals=Y;function l(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const f="[/\\\\]",S="[^/\\\\]",b=/\//g;function g(G,B){switch(G){case 0:return"";case 1:return`${S}*?`;default:return`(?:${f}|${S}+${f}${B?`|${f}${S}+`:""})*?`}}function d(G,B){if(!G)return[];const T=[];let U=!1,$=!1,ae="";for(const V of G){switch(V){case B:if(!U&&!$){T.push(ae),ae="";continue}break;case"{":U=!0;break;case"}":U=!1;break;case"[":$=!0;break;case"]":$=!1;break}ae+=V}return ae&&T.push(ae),T}function y(G){if(!G)return"";let B="";const T=d(G,e.GLOB_SPLIT);if(T.every(U=>U===e.GLOBSTAR))B=".*";else{let U=!1;T.forEach(($,ae)=>{if($===e.GLOBSTAR){if(U)return;B+=g(2,ae===T.length-1)}else{let V=!1,ce="",X=!1,L="";for(const N of $){if(N!=="}"&&V){ce+=N;continue}if(X&&(N!=="]"||!L)){let Z;N==="-"?Z=N:(N==="^"||N==="!")&&!L?Z="^":N===e.GLOB_SPLIT?Z="":Z=(0,h.escapeRegExpCharacters)(N),L+=Z;continue}switch(N){case"{":V=!0;continue;case"[":X=!0;continue;case"}":{const ne=`(?:${d(ce,",").map(K=>y(K)).join("|")})`;B+=ne,V=!1,ce="";break}case"]":{B+="["+L+"]",X=!1,L="";break}case"?":B+=S;continue;case"*":B+=g(1);continue;default:B+=(0,h.escapeRegExpCharacters)(N)}}ae<T.length-1&&(T[ae+1]!==e.GLOBSTAR||ae+2<T.length)&&(B+=f)}U=$===e.GLOBSTAR})}return B}const w=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),s=function(){return!1},r=function(){return null};function i(G,B){if(!G)return r;let T;typeof G!="string"?T=G.pattern:T=G,T=T.trim();const U=`${T}_${!!B.trimForExclusions}`;let $=t.get(U);if($)return o($,G);let ae;return w.test(T)?$=p(T.substr(4),T):(ae=m.exec(u(T,B)))?$=C(ae[1],T):(B.trimForExclusions?v:c).test(T)?$=M(T,B):(ae=E.exec(u(T,B)))?$=D(ae[1].substr(1),T,!0):(ae=a.exec(u(T,B)))?$=D(ae[1],T,!1):$=W(T),t.set(U,$),o($,G)}function o(G,B){if(typeof B=="string")return G;const T=function(U,$){return(0,I.isEqualOrParent)(U,B.base,!P.isLinux)?G((0,h.ltrim)(U.substr(B.base.length),k.sep),$):null};return T.allBasenames=G.allBasenames,T.allPaths=G.allPaths,T.basenames=G.basenames,T.patterns=G.patterns,T}function u(G,B){return B.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function p(G,B){return function(T,U){return typeof T=="string"&&T.endsWith(G)?B:null}}function C(G,B){const T=`/${G}`,U=`\\${G}`,$=function(V,ce){return typeof V!="string"?null:ce?ce===G?B:null:V===G||V.endsWith(T)||V.endsWith(U)?B:null},ae=[G];return $.basenames=ae,$.patterns=[B],$.allBasenames=ae,$}function M(G,B){const T=le(G.slice(1,-1).split(",").map(ce=>i(ce,B)).filter(ce=>ce!==r),G),U=T.length;if(!U)return r;if(U===1)return T[0];const $=function(ce,X){for(let L=0,N=T.length;L<N;L++)if(T[L](ce,X))return G;return null},ae=T.find(ce=>!!ce.allBasenames);ae&&($.allBasenames=ae.allBasenames);const V=T.reduce((ce,X)=>X.allPaths?ce.concat(X.allPaths):ce,[]);return V.length&&($.allPaths=V),$}function D(G,B,T){const U=k.sep===k.posix.sep,$=U?G:G.replace(b,k.sep),ae=k.sep+$,V=k.posix.sep+G;let ce;return T?ce=function(X,L){return typeof X=="string"&&(X===$||X.endsWith(ae)||!U&&(X===G||X.endsWith(V)))?B:null}:ce=function(X,L){return typeof X=="string"&&(X===$||!U&&X===G)?B:null},ce.allPaths=[(T?"*/":"./")+G],ce}function W(G){try{const B=new RegExp(`^${y(G)}$`);return function(T){return B.lastIndex=0,typeof T=="string"&&B.test(T)?G:null}}catch{return r}}function O(G,B,T){return!G||typeof B!="string"?!1:_(G)(B,void 0,T)}function _(G,B={}){if(!G)return s;if(typeof G=="string"||F(G)){const T=i(G,B);if(T===r)return s;const U=function($,ae){return!!T($,ae)};return T.allBasenames&&(U.allBasenames=T.allBasenames),T.allPaths&&(U.allPaths=T.allPaths),U}return ue(G,B)}function F(G){const B=G;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}function x(G){return G.allBasenames||[]}function z(G){return G.allPaths||[]}function ue(G,B){const T=le(Object.getOwnPropertyNames(G).map(ce=>ee(ce,G[ce],B)).filter(ce=>ce!==r)),U=T.length;if(!U)return r;if(!T.some(ce=>!!ce.requiresSiblings)){if(U===1)return T[0];const ce=function(N,Z){let ne;for(let K=0,H=T.length;K<H;K++){const j=T[K](N,Z);if(typeof j=="string")return j;(0,R.isThenable)(j)&&(ne||(ne=[]),ne.push(j))}return ne?(async()=>{for(const K of ne){const H=await K;if(typeof H=="string")return H}return null})():null},X=T.find(N=>!!N.allBasenames);X&&(ce.allBasenames=X.allBasenames);const L=T.reduce((N,Z)=>Z.allPaths?N.concat(Z.allPaths):N,[]);return L.length&&(ce.allPaths=L),ce}const $=function(ce,X,L){let N,Z;for(let ne=0,K=T.length;ne<K;ne++){const H=T[ne];H.requiresSiblings&&L&&(X||(X=(0,k.basename)(ce)),N||(N=X.substr(0,X.length-(0,k.extname)(ce).length)));const j=H(ce,X,N,L);if(typeof j=="string")return j;(0,R.isThenable)(j)&&(Z||(Z=[]),Z.push(j))}return Z?(async()=>{for(const ne of Z){const K=await ne;if(typeof K=="string")return K}return null})():null},ae=T.find(ce=>!!ce.allBasenames);ae&&($.allBasenames=ae.allBasenames);const V=T.reduce((ce,X)=>X.allPaths?ce.concat(X.allPaths):ce,[]);return V.length&&($.allPaths=V),$}function ee(G,B,T){if(B===!1)return r;const U=i(G,T);if(U===r)return r;if(typeof B=="boolean")return U;if(B){const $=B.when;if(typeof $=="string"){const ae=(V,ce,X,L)=>{if(!L||!U(V,ce))return null;const N=$.replace("$(basename)",()=>X),Z=L(N);return(0,R.isThenable)(Z)?Z.then(ne=>ne?G:null):Z?G:null};return ae.requiresSiblings=!0,ae}}return U}function le(G,B){const T=G.filter(ce=>!!ce.basenames);if(T.length<2)return G;const U=T.reduce((ce,X)=>{const L=X.basenames;return L?ce.concat(L):ce},[]);let $;if(B){$=[];for(let ce=0,X=U.length;ce<X;ce++)$.push(B)}else $=T.reduce((ce,X)=>{const L=X.patterns;return L?ce.concat(L):ce},[]);const ae=function(ce,X){if(typeof ce!="string")return null;if(!X){let N;for(N=ce.length;N>0;N--){const Z=ce.charCodeAt(N-1);if(Z===47||Z===92)break}X=ce.substr(N)}const L=U.indexOf(X);return L!==-1?$[L]:null};ae.basenames=U,ae.patterns=$,ae.allBasenames=U;const V=G.filter(ce=>!ce.basenames);return V.push(ae),V}function Y(G,B){return(0,n.equals)(G,B,(T,U)=>typeof T=="string"&&typeof U=="string"?T===U:typeof T!="string"&&typeof U!="string"?T.base===U.base&&T.pattern===U.pattern:!1)}}),define(se[48],oe([0,1,22,31,9,4,19,25]),function(Q,e,n,R,I,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathLabel=h,e.normalizeDriveLetter=f,e.tildify=b,e.untildify=g,e.shorten=m,e.template=v,e.mnemonicMenuLabel=E,e.mnemonicButtonLabel=a,e.unmnemonicLabel=t,e.splitRecentLabel=s;function h(i,o){const{os:u,tildify:p,relative:C}=o;if(C){const W=l(i,C,u);if(typeof W=="string")return W}let M=i.fsPath;if(u===1&&!A.isWindows?M=M.replace(/\//g,"\\"):u!==1&&A.isWindows&&(M=M.replace(/\\/g,"/")),u!==1&&p?.userHome){const W=p.userHome.fsPath;let O;i.scheme!==p.userHome.scheme&&i.path[0]===I.posix.sep&&i.path[1]!==I.posix.sep?O=p.userHome.with({path:i.path}).fsPath:O=M,M=b(O,W,u)}return(u===1?I.win32:I.posix).normalize(f(M,u===1))}function l(i,o,u){const p=u===1?I.win32:I.posix,C=u===3?k.extUri:k.extUriIgnorePathCase,M=o.getWorkspace(),D=(0,n.firstOrDefault)(M.folders);if(!D)return;i.scheme!==D.uri.scheme&&i.path[0]===I.posix.sep&&i.path[1]!==I.posix.sep&&(i=D.uri.with({path:i.path}));const W=o.getWorkspaceFolder(i);if(!W)return;let O;if(C.isEqual(W.uri,i)?O="":O=C.relativePath(W.uri,i)??"",O&&(O=p.normalize(O)),M.folders.length>1&&!o.noPrefix){const _=W.name?W.name:C.basenameOrAuthority(W.uri);O=O?`${_} \u2022 ${O}`:_}return O}function f(i,o=A.isWindows){return(0,R.hasDriveLetter)(i,o)?i.charAt(0).toUpperCase()+i.slice(1):i}let S=Object.create(null);function b(i,o,u=A.OS){if(u===1||!i||!o)return i;let p=S.original===o?S.normalized:void 0;p||(p=o,A.isWindows&&(p=(0,R.toSlashes)(p)),p=`${(0,P.rtrim)(p,I.posix.sep)}${I.posix.sep}`,S={original:o,normalized:p});let C=i;return A.isWindows&&(C=(0,R.toSlashes)(C)),(u===3?C.startsWith(p):(0,P.startsWithIgnoreCase)(C,p))?`~/${C.substr(p.length)}`:i}function g(i,o){return i.replace(/^~($|\/|\\)/,`${o}$1`)}const d="\u2026",y="\\\\",w="~";function m(i,o=I.sep){const u=new Array(i.length);let p=!1;for(let C=0;C<i.length;C++){const M=i[C];if(M===""){u[C]=`.${o}`;continue}if(!M){u[C]=M;continue}p=!0;let D="",W=M;W.indexOf(y)===0?(D=W.substr(0,W.indexOf(y)+y.length),W=W.substr(W.indexOf(y)+y.length)):W.indexOf(o)===0?(D=W.substr(0,W.indexOf(o)+o.length),W=W.substr(W.indexOf(o)+o.length)):W.indexOf(w)===0&&(D=W.substr(0,W.indexOf(w)+w.length),W=W.substr(W.indexOf(w)+w.length));const O=W.split(o);for(let _=1;p&&_<=O.length;_++)for(let F=O.length-_;p&&F>=0;F--){p=!1;let x=O.slice(F,F+_).join(o);for(let z=0;!p&&z<i.length;z++)if(z!==C&&i[z]&&i[z].indexOf(x)>-1){const ue=F+_===O.length,ee=F>0&&i[z].indexOf(o)>-1?o+x:x,le=i[z].endsWith(ee);p=!ue||le}if(!p){let z="";(O[0].endsWith(":")||D!=="")&&(F===1&&(F=0,_++,x=O[0]+o+x),F>0&&(z=O[0]+o),z=D+z),F>0&&(z=z+d+o),z=z+x,F+_<O.length&&(z=z+o+d),u[C]=z}}p&&(u[C]=M)}return u}var c;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function v(i,o=Object.create(null)){const u=[];let p=!1,C="";for(const M of i)if(M==="$"||p&&M==="{")C&&u.push({value:C,type:c.TEXT}),C="",p=!0;else if(M==="}"&&p){const D=o[C];if(typeof D=="string")D.length&&u.push({value:D,type:c.VARIABLE});else if(D){const W=u[u.length-1];(!W||W.type!==c.SEPARATOR)&&u.push({value:D.label,type:c.SEPARATOR})}C="",p=!1}else C+=M;return C&&!p&&u.push({value:C,type:c.TEXT}),u.filter((M,D)=>{if(M.type===c.SEPARATOR){const W=u[D-1],O=u[D+1];return[W,O].every(_=>_&&(_.type===c.VARIABLE||_.type===c.TEXT)&&_.value.length>0)}return!0}).map(M=>M.value).join("")}function E(i,o){return A.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):i.replace(/&&|&/g,u=>u==="&"?"&&":"&")}function a(i,o){return A.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,""):A.isWindows?i.replace(/&&|&/g,u=>u==="&"?"&&":"&"):i.replace(/&&/g,"_")}function t(i){return i.replace(/&/g,"&&")}function s(i){if(i.endsWith("]")){const o=i.lastIndexOf(" [",i.length-2);if(o!==-1){const u=r(i.substring(0,o)),p=i.substring(o);return{name:u.name+p,parentPath:u.parentPath}}}return r(i)}function r(i){const o=i.indexOf("/")!==-1?I.posix:I.win32,u=o.basename(i),p=o.dirname(i);return u.length?{name:u,parentPath:p}:{name:p,parentPath:""}}}),define(se[157],oe([0,1,17,7]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=P,e.transformIncomingURIs=l,e.transformAndReviveIncomingURIs=f;function I(S){return S.toJSON()}class A{constructor(b){this._uriTransformer=b}transformIncoming(b){const g=this._uriTransformer.transformIncoming(b);return g===b?b:I(R.URI.from(g))}transformOutgoing(b){const g=this._uriTransformer.transformOutgoing(b);return g===b?b:I(R.URI.from(g))}transformOutgoingURI(b){const g=this._uriTransformer.transformOutgoing(b);return g===b?b:R.URI.from(g)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function k(S,b,g){if(!S||g>200)return null;if(typeof S=="object"){if(S instanceof R.URI)return b.transformOutgoing(S);for(const d in S)if(Object.hasOwnProperty.call(S,d)){const y=k(S[d],b,g+1);y!==null&&(S[d]=y)}}return null}function P(S,b){const g=k(S,b,0);return g===null?S:g}function h(S,b,g,d){if(!S||d>200)return null;if(typeof S=="object"){if(S.$mid===1)return g?R.URI.revive(b.transformIncoming(S)):b.transformIncoming(S);if(S instanceof n.VSBuffer)return null;for(const y in S)if(Object.hasOwnProperty.call(S,y)){const w=h(S[y],b,g,d+1);w!==null&&(S[y]=w)}}return null}function l(S,b){const g=h(S,b,!1,0);return g===null?S:g}function f(S,b){const g=h(S,b,!0,0);return g===null?S:g}}),define(se[89],oe([0,1,26,59,33,147,4]),function(Q,e,n,R,I,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.virtualMachineHint=void 0,e.getMachineId=h,e.getSqmMachineId=S,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(b){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(b)}value(){if(this._value===void 0){let b=0,g=0;const d=(0,n.networkInterfaces)();for(const y in d){const w=d[y];if(w)for(const{mac:m,internal:c}of w)c||(g+=1,this._isVirtualMachineMacAddress(m.toUpperCase())&&(b+=1))}this._value=g>0?b/g:0}return this._value}};let P;async function h(b){return P||(P=(async()=>await l(b)||I.generateUuid())()),P}async function l(b){try{const g=await new Promise((y,w)=>{Q(["crypto"],y,w)}),d=(0,A.getMac)();return g.createHash("sha256").update(d,"utf8").digest("hex")}catch(g){b(g);return}}const f="Software\\Microsoft\\SQMClient";async function S(b){if(k.isWindows){const g=await new Promise((d,y)=>{Q(["@vscode/windows-registry"],d,y)});try{return g.GetStringRegKey("HKEY_LOCAL_MACHINE",f,"MachineId")||""}catch(d){return b(d),""}}return""}}),define(se[21],oe([0,1,43,26,158,8,31,72,9,4,19,7]),function(Q,e,n,R,I,A,k,P,h,l,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=w,e.readdirSync=v,e.whenDeleted=t,e.configureFlushOnWrite=u,e.writeFileSync=C;var b;(function(ee){ee[ee.UNLINK=0]="UNLINK",ee[ee.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function g(ee,le=b.UNLINK,Y){if((0,k.isRootOrDriveLetter)(ee))throw new Error("rimraf - will refuse to recursively delete root");return le===b.UNLINK?y(ee):d(ee,Y)}async function d(ee,le=(0,k.randomPath)((0,R.tmpdir)())){try{try{await n.promises.rename(ee,le)}catch(Y){return Y.code==="ENOENT"?void 0:y(ee)}y(le).catch(Y=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function y(ee){return(0,I.promisify)(n.rm)(ee,{recursive:!0,force:!0,maxRetries:3})}function w(ee){if((0,k.isRootOrDriveLetter)(ee))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(ee,{recursive:!0,force:!0,maxRetries:3})}async function m(ee,le){return E(await(le?c(ee):(0,I.promisify)(n.readdir)(ee)))}async function c(ee){try{return await(0,I.promisify)(n.readdir)(ee,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const le=[],Y=await m(ee);for(const G of Y){let B=!1,T=!1,U=!1;try{const $=await e.Promises.lstat((0,h.join)(ee,G));B=$.isFile(),T=$.isDirectory(),U=$.isSymbolicLink()}catch($){console.warn("[node.js fs] unexpected error from lstat after readdir: ",$)}le.push({name:G,isFile:()=>B,isDirectory:()=>T,isSymbolicLink:()=>U})}return le}function v(ee){return E(n.readdirSync(ee))}function E(ee){return ee.map(le=>typeof le=="string"?l.isMacintosh?(0,P.normalizeNFC)(le):le:(le.name=l.isMacintosh?(0,P.normalizeNFC)(le.name):le.name,le))}async function a(ee){const le=await m(ee),Y=[];for(const G of le)await s.existsDirectory((0,h.join)(ee,G))&&Y.push(G);return Y}function t(ee,le=1e3){return new Promise(Y=>{let G=!1;const B=setInterval(()=>{G||(G=!0,n.access(ee,T=>{G=!1,T&&(clearInterval(B),Y(void 0))}))},le)})}var s;(function(ee){async function le(B){let T;try{if(T=await e.Promises.lstat(B),!T.isSymbolicLink())return{stat:T}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:T?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};if(l.isWindows&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch($){if($.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};throw $}throw U}}ee.stat=le;async function Y(B){try{const{stat:T,symbolicLink:U}=await ee.stat(B);return T.isFile()&&U?.dangling!==!0}catch{}return!1}ee.existsFile=Y;async function G(B){try{const{stat:T,symbolicLink:U}=await ee.stat(B);return T.isDirectory()&&U?.dangling!==!0}catch{}return!1}ee.existsDirectory=G})(s||(e.SymlinkSupport=s={}));const r=new A.ResourceQueue;function i(ee,le,Y){return r.queueFor(S.URI.file(ee),()=>{const G=M(Y);return new Promise((B,T)=>p(ee,le,G,U=>U?T(U):B()))},f.extUriBiasedIgnorePathCase)}let o=!0;function u(ee){o=ee}function p(ee,le,Y,G){if(!o)return n.writeFile(ee,le,{mode:Y.mode,flag:Y.flag},G);n.open(ee,Y.flag,Y.mode,(B,T)=>{if(B)return G(B);n.writeFile(T,le,U=>{if(U)return n.close(T,()=>G(U));n.fdatasync(T,$=>($&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",$),u(!1)),n.close(T,ae=>G(ae))))})})}function C(ee,le,Y){const G=M(Y);if(!o)return n.writeFileSync(ee,le,{mode:G.mode,flag:G.flag});const B=n.openSync(ee,G.flag,G.mode);try{n.writeFileSync(B,le);try{n.fdatasyncSync(B)}catch(T){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",T),u(!1)}}finally{n.closeSync(B)}}function M(ee){return ee?{mode:typeof ee.mode=="number"?ee.mode:438,flag:typeof ee.flag=="string"?ee.flag:"w"}:{mode:438,flag:"w"}}async function D(ee,le,Y=6e4){if(ee!==le)try{l.isWindows&&typeof Y=="number"?await W(ee,le,Date.now(),Y):await(0,I.promisify)(n.rename)(ee,le)}catch(G){if(ee.toLowerCase()!==le.toLowerCase()&&G.code==="EXDEV"||ee.endsWith("."))await O(ee,le,{preserveSymlinks:!1}),await g(ee,b.MOVE);else throw G}}async function W(ee,le,Y,G,B=0){try{return await(0,I.promisify)(n.rename)(ee,le)}catch(T){if(T.code!=="EACCES"&&T.code!=="EPERM"&&T.code!=="EBUSY")throw T;if(Date.now()-Y>=G)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${T}`),T;if(B===0){let U=!1;try{const{stat:$}=await s.stat(le);$.isFile()||(U=!0)}catch{}if(U)throw T}return await(0,A.timeout)(Math.min(100,B*10)),W(ee,le,Y,G,B+1)}}async function O(ee,le,Y){return F(ee,le,{root:{source:ee,target:le},options:Y,handledSourcePaths:new Set})}const _=511;async function F(ee,le,Y){if(Y.handledSourcePaths.has(ee))return;Y.handledSourcePaths.add(ee);const{stat:G,symbolicLink:B}=await s.stat(ee);if(B){if(Y.options.preserveSymlinks)try{return await ue(ee,le,Y)}catch{}if(B.dangling)return}return G.isDirectory()?x(ee,le,G.mode&_,Y):z(ee,le,G.mode&_)}async function x(ee,le,Y,G){await e.Promises.mkdir(le,{recursive:!0,mode:Y});const B=await m(ee);for(const T of B)await F((0,h.join)(ee,T),(0,h.join)(le,T),G)}async function z(ee,le,Y){await e.Promises.copyFile(ee,le),await e.Promises.chmod(le,Y)}async function ue(ee,le,Y){let G=await e.Promises.readlink(ee);(0,k.isEqualOrParent)(G,Y.root.source,!l.isLinux)&&(G=(0,h.join)(Y.root.target,G.substr(Y.root.source.length+1))),await e.Promises.symlink(G,le)}e.Promises=new class{get access(){return(0,I.promisify)(n.access)}get stat(){return(0,I.promisify)(n.stat)}get lstat(){return(0,I.promisify)(n.lstat)}get utimes(){return(0,I.promisify)(n.utimes)}get read(){return(ee,le,Y,G,B)=>new Promise((T,U)=>{n.read(ee,le,Y,G,B,($,ae,V)=>$?U($):T({bytesRead:ae,buffer:V}))})}get readFile(){return(0,I.promisify)(n.readFile)}get write(){return(ee,le,Y,G,B)=>new Promise((T,U)=>{n.write(ee,le,Y,G,B,($,ae,V)=>$?U($):T({bytesWritten:ae,buffer:V}))})}get appendFile(){return(0,I.promisify)(n.appendFile)}get fdatasync(){return(0,I.promisify)(n.fdatasync)}get truncate(){return(0,I.promisify)(n.truncate)}get copyFile(){return(0,I.promisify)(n.copyFile)}get open(){return(0,I.promisify)(n.open)}get close(){return(0,I.promisify)(n.close)}get symlink(){return(0,I.promisify)(n.symlink)}get readlink(){return(0,I.promisify)(n.readlink)}get chmod(){return(0,I.promisify)(n.chmod)}get mkdir(){return(0,I.promisify)(n.mkdir)}get unlink(){return(0,I.promisify)(n.unlink)}get rmdir(){return(0,I.promisify)(n.rmdir)}get realpath(){return(0,I.promisify)(n.realpath)}async exists(ee){try{return await e.Promises.access(ee),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return a}get writeFile(){return i}get rm(){return g}get rename(){return D}get copy(){return O}}}),define(se[109],oe([0,1,43,9,4,25,21]),function(Q,e,n,R,I,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=P,e.realcase=h,e.realpath=l,e.realpathSync=f;function P(b){if(I.isLinux)return b;const g=(0,R.dirname)(b);if(b===g)return b;const d=((0,R.basename)(b)||b).toLowerCase();try{const w=(0,k.readdirSync)(g).filter(m=>m.toLowerCase()===d);if(w.length===1){const m=P(g);if(m)return(0,R.join)(m,w[0])}else if(w.length>1){const m=w.indexOf(d);if(m>=0){const c=P(g);if(c)return(0,R.join)(c,w[m])}}}catch{}return null}async function h(b,g){if(I.isLinux)return b;const d=(0,R.dirname)(b);if(b===d)return b;const y=((0,R.basename)(b)||b).toLowerCase();try{if(g?.isCancellationRequested)return null;const m=(await k.Promises.readdir(d)).filter(c=>c.toLowerCase()===y);if(m.length===1){const c=await h(d,g);if(c)return(0,R.join)(c,m[0])}else if(m.length>1){const c=m.indexOf(y);if(c>=0){const v=await h(d,g);if(v)return(0,R.join)(v,m[c])}}}catch{}return null}async function l(b){try{return await k.Promises.realpath(b)}catch{const d=S(b);return await k.Promises.access(d,n.constants.R_OK),d}}function f(b){try{return n.realpathSync(b)}catch{const d=S(b);return n.accessSync(d,n.constants.R_OK),d}}function S(b){return(0,A.rtrim)((0,R.normalize)(b),R.sep)}}),define(se[110],oe([0,1,26,9,21]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.enumeratePowerShellInstallations=c,e.getFirstAvailablePowerShellInstallation=v;const A=/^\d+$/,k=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var h;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(h||(h={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let f;process.env.PROCESSOR_ARCHITEW6432?f=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?f=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?f=1:f=0;class S{constructor(a,t,s){this.exePath=a,this.displayName=t,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await I.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function b({useAlternateBitness:E=!1}={}){return E?l===0?process.env["ProgramFiles(x86)"]||null:f===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:E=!1,findPreview:a=!1}={}){const t=b({useAlternateBitness:E});if(!t)return null;const s=R.join(t,"PowerShell");if(!await I.SymlinkSupport.existsDirectory(s))return null;let r=-1,i=null;for(const p of await I.Promises.readdir(s)){let C=-1;if(a){const D=p.indexOf("-");if(D<0)continue;const W=p.substring(0,D);if(!A.test(W)||p.substring(D+1)!=="preview")continue;C=parseInt(W,10)}else{if(!A.test(p))continue;C=parseInt(p,10)}if(C<=r)continue;const M=R.join(s,p,"pwsh.exe");await I.SymlinkSupport.existsFile(M)&&(i=M,r=C)}if(!i)return null;const o=t.includes("x86")?" (x86)":"",u=a?" Preview":"";return new S(i,`PowerShell${u}${o}`,!0)}async function d({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const a=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await I.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=E?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const r of await I.Promises.readdir(a))if(t.test(r)){const i=R.join(a,r,"pwsh.exe");return new S(i,s)}return null}function y(){const E=R.join(n.homedir(),".dotnet","tools","pwsh.exe");return new S(E,".NET Core PowerShell Global Tool")}function w(){const E=R.join(process.env.windir,l===1&&f!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new S(E,"Windows PowerShell",!0)}async function*m(){let E=await g();E&&(yield E),E=await g({useAlternateBitness:!0}),E&&(yield E),E=await d(),E&&(yield E),E=y(),E&&(yield E),E=await g({findPreview:!0}),E&&(yield E),E=await d({findPreview:!0}),E&&(yield E),E=await g({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=w(),E&&(yield E)}async function*c(){for await(const E of m())await E.exists()&&(yield E)}async function v(){for await(const E of c())return E;return null}}),define(se[90],oe([0,1,9,4,36,76,12,21]),function(Q,e,n,R,I,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=h,e.createQueuedSender=l,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function h(S=I.env){return S.comspec||"cmd.exe"}function l(S){let b=[],g=!1;const d=function(y){if(g){b.push(y);return}(!S.send(y,m=>{if(m&&console.error(m),g=!1,b.length>0){const c=b.slice(0);b=[],c.forEach(v=>d(v))}})||R.isWindows)&&(g=!0)};return{send:d}}var f;(function(S){async function b(g,d,y){if(n.isAbsolute(g))return g;if(d===void 0&&(d=I.cwd()),n.dirname(g)!=="."||(y===void 0&&k.isString(I.env.PATH)&&(y=I.env.PATH.split(n.delimiter)),y===void 0||y.length===0))return n.join(d,g);async function m(c){if(await P.Promises.exists(c)){let v;try{v=await P.Promises.stat(c)}catch(E){E.message.startsWith("EACCES")&&(v=await P.Promises.lstat(c))}return v?!v.isDirectory():!1}return!1}for(const c of y){let v;if(n.isAbsolute(c)?v=n.join(c,g):v=n.join(d,c,g),await m(v))return v;let E=v+".com";if(await m(E)||(E=v+".exe",await m(E)))return E}return n.join(d,g)}S.findExecutable=b})(f||(e.win32=f={}))}),define(se[111],oe([0,1,49,13]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=I;function I(k){return new Promise((P,h)=>{let l;const f=new Map;function S(g,d,y,w,m){const c=f.get(d);if(g===k||c){const v={name:b(y),cmd:y,pid:g,ppid:d,load:w,mem:m};f.set(g,v),g===k&&(l=v),c&&(c.children||(c.children=[]),c.children.push(v),c.children.length>1&&(c.children=c.children.sort((E,a)=>E.pid-a.pid)))}}function b(g){const d=/--utility-sub-type=network/i,y=/--crashes-directory/i,w=/\\pipe\\winpty-control/i,m=/conhost\.exe.+--headless/i,c=/--type=([a-zA-Z-]+)/;if(y.exec(g))return"electron-crash-reporter";if(w.exec(g))return"winpty-agent";if(m.exec(g))return"conpty-agent";let v=c.exec(g);if(v&&v.length===2)return v[1]==="renderer"?"window":v[1]==="utility"?d.exec(g)?"utility-network-service":"utility-process":v[1]==="extensionHost"?"extension-host":v[1];const E=/[a-zA-Z-]+\.js/g;let a="";do v=E.exec(g),v&&(a+=v+" ");while(v);return a&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron-nodejs (${a})`:g}if(process.platform==="win32"){const g=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substring(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substring(5):d;new Promise((d,y)=>{Q(["@vscode/windows-process-tree"],d,y)}).then(d=>{d.getProcessList(k,y=>{if(!y){h(new Error(`Root process ${k} not found`));return}d.getProcessCpuUsage(y,w=>{const m=new Map;w.forEach(c=>{const v=g(c.commandLine||"");m.set(c.pid,{name:b(v),cmd:v,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),l=m.get(k),l?(m.forEach(c=>{const v=m.get(c.ppid);v&&(v.children||(v.children=[]),v.children.push(c))}),m.forEach(c=>{c.children&&(c.children=c.children.sort((v,E)=>v.pid-E.pid))}),P(l)):h(new Error(`Root process ${k} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let g=function(){let d=[l];const y=[];for(;d.length;){const m=d.shift();m&&(y.push(m.pid),m.children&&(d=d.concat(m.children)))}let w=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+y.join(" "),(0,n.exec)(w,{},(m,c,v)=>{if(m||v)h(m||new Error(v.toString()));else{const E=c.toString().split(`
`);for(let a=0;a<y.length;a++){const t=f.get(y[a]);t.load=parseFloat(E[a])}if(!l){h(new Error(`Root process ${k} not found`));return}P(l)}})};(0,n.exec)("which ps",{},(d,y,w)=>{if(d||w)if(process.platform!=="linux")h(d||new Error(w.toString()));else{const m=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)(m,{},(c,v,E)=>{c||E?h(c||new Error(E.toString())):(A(v,S),g())})}else{const m=y.toString().trim();(0,n.exec)(`${m} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,E,a)=>{v||a&&!a.includes("screen size is bogus")?h(v||new Error(a.toString())):(A(E,S),process.platform==="linux"?g():l?P(l):h(new Error(`Root process ${k} not found`)))})}})}})}function A(k,P){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=k.toString().split(`
`);for(const f of l){const S=h.exec(f.trim());S&&S.length===6&&P(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}}),define(se[112],oe([0,1,26,4,110,90]),function(Q,e,n,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=k;async function k(S,b){return S===1?R.isWindows?f():A.getWindowsShell(b):h(S,b)}let P=null;function h(S,b){if(R.isLinux&&S===2||R.isMacintosh&&S===3)return"/bin/bash";if(!P){let g;if(R.isWindows)g="/bin/bash";else{if(g=b.SHELL,!g)try{g=(0,n.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}P=g}return P}let l=null;async function f(){return l||(l=(await(0,I.getFirstAvailablePowerShellInstallation)()).exePath),l}});var Ie=this&&this.__decorate||function(Q,e,n,R){var I=arguments.length,A=I<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,n):R,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(Q,e,n,R);else for(var P=Q.length-1;P>=0;P--)(k=Q[P])&&(A=(I<3?k(A):I>3?k(e,n,A):k(e,n))||A);return I>3&&A&&Object.defineProperty(e,n,A),A};define(se[44],oe([0,1,22,8,17,23,51,15,3,2,77,25,12]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=u,e.deserialize=p,e.getDelayedChannel=_,e.getNextTickChannel=F;var g;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(g||(g={}));function d(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(y||(y={}));function w(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(m||(m={}));function c(B){let T=0;for(let U=0;;U+=7){const $=B.read(1);if(T|=($.buffer[0]&127)<<U,!($.buffer[0]&128))return T}}const v=r(0);function E(B,T){if(T===0){B.write(v);return}let U=0;for(let ae=T;ae!==0;ae=ae>>>7)U++;const $=I.VSBuffer.alloc(U);for(let ae=0;T!==0;ae++)$.buffer[ae]=T&127,T=T>>>7,T>0&&($.buffer[ae]|=128);B.write($)}class a{constructor(T){this.buffer=T,this.pos=0}read(T){const U=this.buffer.slice(this.pos,this.pos+T);return this.pos+=U.byteLength,U}}e.BufferReader=a;class t{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(T){this.buffers.push(T)}}e.BufferWriter=t;var s;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(s||(s={}));function r(B){const T=I.VSBuffer.alloc(1);return T.writeUInt8(B,0),T}const i={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object),Uint:r(s.Int)},o=typeof Buffer<"u";function u(B,T){if(typeof T>"u")B.write(i.Undefined);else if(typeof T=="string"){const U=I.VSBuffer.fromString(T);B.write(i.String),E(B,U.byteLength),B.write(U)}else if(o&&Buffer.isBuffer(T)){const U=I.VSBuffer.wrap(T);B.write(i.Buffer),E(B,U.byteLength),B.write(U)}else if(T instanceof I.VSBuffer)B.write(i.VSBuffer),E(B,T.byteLength),B.write(T);else if(Array.isArray(T)){B.write(i.Array),E(B,T.length);for(const U of T)u(B,U)}else if(typeof T=="number"&&(T|0)===T)B.write(i.Uint),E(B,T);else{const U=I.VSBuffer.fromString(JSON.stringify(T));B.write(i.Object),E(B,U.byteLength),B.write(U)}}function p(B){switch(B.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return B.read(c(B)).toString();case s.Buffer:return B.read(c(B)).buffer;case s.VSBuffer:return B.read(c(B));case s.Array:{const U=c(B),$=[];for(let ae=0;ae<U;ae++)$.push(p(B));return $}case s.Object:return JSON.parse(B.read(c(B)).toString());case s.Int:return c(B)}}class C{constructor(T,U,$=null,ae=1e3){this.protocol=T,this.ctx=U,this.logger=$,this.timeoutDelay=ae,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(V=>this.onRawMessage(V)),this.sendResponse({type:200})}registerChannel(T,U){this.channels.set(T,U),setTimeout(()=>this.flushPendingRequests(T),0)}sendResponse(T){switch(T.type){case 200:{const U=this.send([T.type]);this.logger?.logOutgoing(U,0,1,w(T.type));return}case 201:case 202:case 204:case 203:{const U=this.send([T.type,T.id],T.data);this.logger?.logOutgoing(U,T.id,1,w(T.type),T.data);return}}}send(T,U=void 0){const $=new t;return u($,T),u($,U),this.sendBuffer($.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch{return 0}}onRawMessage(T){const U=new a(T),$=p(U),ae=p(U),V=$[0];switch(V){case 100:return this.logger?.logIncoming(T.byteLength,$[1],1,`${d(V)}: ${$[2]}.${$[3]}`,ae),this.onPromise({type:V,id:$[1],channelName:$[2],name:$[3],arg:ae});case 102:return this.logger?.logIncoming(T.byteLength,$[1],1,`${d(V)}: ${$[2]}.${$[3]}`,ae),this.onEventListen({type:V,id:$[1],channelName:$[2],name:$[3],arg:ae});case 101:return this.logger?.logIncoming(T.byteLength,$[1],1,`${d(V)}`),this.disposeActiveRequest({type:V,id:$[1]});case 103:return this.logger?.logIncoming(T.byteLength,$[1],1,`${d(V)}`),this.disposeActiveRequest({type:V,id:$[1]})}}onPromise(T){const U=this.channels.get(T.channelName);if(!U){this.collectPendingRequest(T);return}const $=new A.CancellationTokenSource;let ae;try{ae=U.call(this.ctx,T.name,T.arg,$.token)}catch(X){ae=Promise.reject(X)}const V=T.id;ae.then(X=>{this.sendResponse({id:V,data:X,type:201})},X=>{X instanceof Error?this.sendResponse({id:V,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.sendResponse({id:V,data:X,type:203})}).finally(()=>{ce.dispose(),this.activeRequests.delete(T.id)});const ce=(0,l.toDisposable)(()=>$.cancel());this.activeRequests.set(T.id,ce)}onEventListen(T){const U=this.channels.get(T.channelName);if(!U){this.collectPendingRequest(T);return}const $=T.id,V=U.listen(this.ctx,T.name,T.arg)(ce=>this.sendResponse({id:$,data:ce,type:204}));this.activeRequests.set(T.id,V)}disposeActiveRequest(T){const U=this.activeRequests.get(T.id);U&&(U.dispose(),this.activeRequests.delete(T.id))}collectPendingRequest(T){let U=this.pendingRequests.get(T.channelName);U||(U=[],this.pendingRequests.set(T.channelName,U));const $=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.sendResponse({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);U.push({request:T,timeoutTimer:$})}flushPendingRequests(T){const U=this.pendingRequests.get(T);if(U){for(const $ of U)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(T)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=C;var M;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(M||(e.RequestInitiator=M={}));class D{constructor(T,U=null){this.protocol=T,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=U}getChannel(T){const U=this;return{call($,ae,V){return U.isDisposed?Promise.reject(new P.CancellationError):U.requestPromise(T,$,ae,V)},listen($,ae){return U.isDisposed?h.Event.None:U.requestEvent(T,$,ae)}}}requestPromise(T,U,$,ae=A.CancellationToken.None){const V=this.lastRequestId++,X={id:V,type:100,channelName:T,name:U,arg:$};if(ae.isCancellationRequested)return Promise.reject(new P.CancellationError);let L;return new Promise((Z,ne)=>{if(ae.isCancellationRequested)return ne(new P.CancellationError);const K=()=>{const re=he=>{switch(he.type){case 201:this.handlers.delete(V),Z(he.data);break;case 202:{this.handlers.delete(V);const me=new Error(he.data.message);me.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,me.name=he.data.name,ne(me);break}case 203:this.handlers.delete(V),ne(he.data);break}};this.handlers.set(V,re),this.sendRequest(X)};let H=null;this.state===m.Idle?K():(H=(0,R.createCancelablePromise)(re=>this.whenInitialized()),H.then(()=>{H=null,K()}));const j=()=>{H?(H.cancel(),H=null):this.sendRequest({id:V,type:101}),ne(new P.CancellationError)},q=ae.onCancellationRequested(j);L=(0,l.combinedDisposable)((0,l.toDisposable)(j),q),this.activeRequests.add(L)}).finally(()=>{L.dispose(),this.activeRequests.delete(L)})}requestEvent(T,U,$){const ae=this.lastRequestId++,ce={id:ae,type:102,channelName:T,name:U,arg:$};let X=null;const L=new h.Emitter({onWillAddFirstListener:()=>{X=(0,R.createCancelablePromise)(Z=>this.whenInitialized()),X.then(()=>{X=null,this.activeRequests.add(L),this.sendRequest(ce)})},onDidRemoveLastListener:()=>{X?(X.cancel(),X=null):(this.activeRequests.delete(L),this.sendRequest({id:ae,type:103}))}}),N=Z=>L.fire(Z.data);return this.handlers.set(ae,N),L.event}sendRequest(T){switch(T.type){case 100:case 102:{const U=this.send([T.type,T.id,T.channelName,T.name],T.arg);this.logger?.logOutgoing(U,T.id,0,`${d(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const U=this.send([T.type,T.id]);this.logger?.logOutgoing(U,T.id,0,d(T.type));return}}}send(T,U=void 0){const $=new t;return u($,T),u($,U),this.sendBuffer($.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch{return 0}}onBuffer(T){const U=new a(T),$=p(U),ae=p(U),V=$[0];switch(V){case 200:return this.logger?.logIncoming(T.byteLength,0,0,w(V)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(T.byteLength,$[1],0,w(V),ae),this.onResponse({type:$[0],id:$[1],data:ae})}}onResponse(T){if(T.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}this.handlers.get(T.id)?.(T)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=D,Ie([k.memoize],D.prototype,"onDidInitializePromise",null);class W{get connections(){const T=[];return this._connections.forEach(U=>T.push(U)),T}constructor(T,U,$){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new l.DisposableStore,this.disposables.add(T(({protocol:ae,onDidClientDisconnect:V})=>{const ce=h.Event.once(ae.onMessage);this.disposables.add(ce(X=>{const L=new a(X),N=p(L),Z=new C(ae,N,U,$),ne=new D(ae,U);this.channels.forEach((H,j)=>Z.registerChannel(j,H));const K={channelServer:Z,channelClient:ne,ctx:N};this._connections.add(K),this._onDidAddConnection.fire(K),this.disposables.add(V(()=>{Z.dispose(),ne.dispose(),this._connections.delete(K),this._onDidRemoveConnection.fire(K)}))}))}))}getChannel(T,U){const $=this;return{call(ae,V,ce){let X;if((0,b.isFunction)(U)){const N=(0,n.getRandomElement)($.connections.filter(U));X=N?Promise.resolve(N):h.Event.toPromise(h.Event.filter($.onDidAddConnection,U))}else X=U.routeCall($,ae,V);const L=X.then(N=>N.channelClient.getChannel(T));return _(L).call(ae,V,ce)},listen(ae,V){if((0,b.isFunction)(U))return $.getMulticastEvent(T,U,ae,V);const ce=U.routeEvent($,ae,V).then(X=>X.channelClient.getChannel(T));return _(ce).listen(ae,V)}}}getMulticastEvent(T,U,$,ae){const V=this;let ce;const X=new h.Emitter({onWillAddFirstListener:()=>{ce=new l.DisposableStore;const L=new h.EventMultiplexer,N=new Map,Z=K=>{const j=K.channelClient.getChannel(T).listen($,ae),q=L.add(j);N.set(K,q)},ne=K=>{const H=N.get(K);H&&(H.dispose(),N.delete(K))};V.connections.filter(U).forEach(Z),h.Event.filter(V.onDidAddConnection,U)(Z,void 0,ce),V.onDidRemoveConnection(ne,void 0,ce),L.event(X.fire,X,ce),ce.add(L)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return X.event}registerChannel(T,U){this.channels.set(T,U);for(const $ of this._connections)$.channelServer.registerChannel(T,U)}dispose(){this.disposables.dispose();for(const T of this._connections)T.channelClient.dispose(),T.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=W;class O{constructor(T,U,$=null){const ae=new t;u(ae,U),T.send(ae.buffer),this.channelClient=new D(T,$),this.channelServer=new C(T,U,$)}getChannel(T){return this.channelClient.getChannel(T)}registerChannel(T,U){this.channelServer.registerChannel(T,U)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function _(B){return{call(T,U,$){return B.then(ae=>ae.call(T,U,$))},listen(T,U){const $=new h.Relay;return B.then(ae=>$.input=ae.listen(T,U)),$.event}}}function F(B){let T=!1;return{call(U,$,ae){return T?B.call(U,$,ae):(0,R.timeout)(0).then(()=>T=!0).then(()=>B.call(U,$,ae))},listen(U,$){if(T)return B.listen(U,$);const ae=new h.Relay;return(0,R.timeout)(0).then(()=>T=!0).then(()=>ae.input=B.listen(U,$)),ae.event}}}class x{constructor(T){this.fn=T}routeCall(T){return this.route(T)}routeEvent(T){return this.route(T)}async route(T){for(const U of T.connections)if(await Promise.resolve(this.fn(U.ctx)))return Promise.resolve(U);return await h.Event.toPromise(T.onDidAddConnection),await this.route(T)}}e.StaticRouter=x;var z;(function(B){function T(V,ce,X){const L=V,N=X&&X.disableMarshalling,Z=new Map;for(const ne in L)$(ne)&&Z.set(ne,h.Event.buffer(L[ne],!0,void 0,ce));return new class{listen(ne,K,H){const j=Z.get(K);if(j)return j;const q=L[K];if(typeof q=="function"){if(ae(K))return q.call(L,H);if($(K))return Z.set(K,h.Event.buffer(L[K],!0,void 0,ce)),Z.get(K)}throw new P.ErrorNoTelemetry(`Event not found: ${K}`)}call(ne,K,H){const j=L[K];if(typeof j=="function"){if(!N&&Array.isArray(H))for(let re=0;re<H.length;re++)H[re]=(0,f.revive)(H[re]);let q=j.apply(L,H);return q instanceof Promise||(q=Promise.resolve(q)),q}throw new P.ErrorNoTelemetry(`Method not found: ${K}`)}}}B.fromService=T;function U(V,ce){const X=ce&&ce.disableMarshalling;return new Proxy({},{get(L,N){if(typeof N=="string")return ce?.properties?.has(N)?ce.properties.get(N):ae(N)?function(Z){return V.listen(N,Z)}:$(N)?V.listen(N):async function(...Z){let ne;ce&&!(0,b.isUndefinedOrNull)(ce.context)?ne=[ce.context,...Z]:ne=Z;const K=await V.call(N,ne);return X?K:(0,f.revive)(K)};throw new P.ErrorNoTelemetry(`Property not found: ${String(N)}`)}})}B.toService=U;function $(V){return V[0]==="o"&&V[1]==="n"&&S.isUpperAsciiLetter(V.charCodeAt(2))}function ae(V){return/^onDynamic/.test(V)&&S.isUpperAsciiLetter(V.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ee(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const T=B.toString();if(T!=="[object Object]")return T}return B}function le(B){return Array.isArray(B)?B.map(ee):ee(B)}function Y(B,T,U,$,ae,V,ce){ce=le(ce);const X=ue[ae],L=X[$%X.length];let N=[`%c[${B}]%c[${String(T).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String($).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${L}`];/\($/.test(V)?(N=N.concat(ce),N.push(")")):N.push(ce),console.log.apply(console,N)}class G{constructor(T,U){this._outgoingPrefix=T,this._incomingPrefix=U,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(T,U,$,ae,V){this._totalOutgoing+=T,Y(this._outgoingPrefix,this._totalOutgoing,T,U,$,ae,V)}logIncoming(T,U,$,ae,V){this._totalIncoming+=T,Y(this._incomingPrefix,this._totalIncoming,T,U,$,ae,V)}}e.IPCLogger=G}),define(se[159],oe([0,1,17,3,44]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(h){this.port=h,this.onMessage=R.Event.fromDOMEventEmitter(this.port,"message",l=>l.data?n.VSBuffer.wrap(l.data):n.VSBuffer.alloc(0)),h.start()}send(h){this.port.postMessage(h.buffer)}disconnect(){this.port.close()}}e.Protocol=A;class k extends I.IPCClient{constructor(h,l){const f=new A(h);super(f,l),this.protocol=f}dispose(){this.protocol.disconnect(),super.dispose()}}e.Client=k}),define(se[113],oe([0,1,17,3,2,44]),function(Q,e,n,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(k||(e.SocketDiagnosticsEventType=k={}));var P;(function(i){i.enableDiagnostics=!1,i.records=[];const o=new WeakMap;let u=0;function p(M,D){if(!o.has(M)){const W=String(++u);o.set(M,W)}return o.get(M)}function C(M,D,W,O){if(!i.enableDiagnostics)return;const _=p(M,D);if(O instanceof n.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const F=n.VSBuffer.alloc(O.byteLength);F.set(O),i.records.push({timestamp:Date.now(),id:_,label:D,type:W,buff:F})}else i.records.push({timestamp:Date.now(),id:_,label:D,type:W,data:O})}i.traceSocketEvent=C})(P||(e.SocketDiagnostics=P={}));var h;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h||(e.SocketCloseEventType=h={}));let l=null;function f(){return l||(l=n.VSBuffer.alloc(0)),l}class S{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,u){if(o===0)return f();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const D=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=o),D}if(this._chunks[0].byteLength>o){const D=this._chunks[0].slice(0,o);return u&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),D}const p=n.VSBuffer.alloc(o);let C=0,M=0;for(;o>0;){const D=this._chunks[M];if(D.byteLength>o){const W=D.slice(0,o);p.set(W,C),C+=o,u&&(this._chunks[M]=D.slice(o),this._totalLength-=o),o-=o}else p.set(D,C),C+=D.byteLength,u?(this._chunks.shift(),this._totalLength-=D.byteLength):M++,o-=D.byteLength}return p}}e.ChunkStream=S;var b;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(b||(b={}));function g(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(d||(e.ProtocolConstants=d={}));class y{constructor(o,u,p,C){this.type=o,this.id=u,this.ack=p,this.data=C,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends I.Disposable{constructor(o){super(),this._onMessage=this._register(new R.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new S,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:g(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const p=this._state.messageType,C=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",u),this._onMessage.fire(new y(p,C,M,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=n.VSBuffer.alloc(13);u.writeUInt8(o.type,0),u.writeUInt32BE(o.id,1),u.writeUInt32BE(o.ack,5),u.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:g(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(u,o.data)}_bufferAdd(o,u){const p=this._totalLength===0;return this._data.push(o,u),this._totalLength+=o.byteLength+u.byteLength,p}_bufferTake(){const o=n.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,u){this._bufferAdd(o,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class c extends I.Disposable{constructor(o){super(),this._onMessage=new R.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new y(1,0,0,o))}}e.Protocol=c;class v extends A.IPCClient{static fromSocket(o,u){return new v(new c(o),u)}get onDidDispose(){return this.protocol.onDidDispose}constructor(o,u,p=null){super(o,u,p),this.protocol=o}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=v;class E{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new R.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=E;class a{constructor(o){this.data=o,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let o=0,u=this._first;for(;u;)u=u.next,o++;return o}peek(){return this._first?this._first.data:null}toArray(){const o=[];let u=0,p=this._first;for(;p;)o[u++]=p.data,p=p.next;return o}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const u=new a(o);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class s{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}constructor(){this.lastRuns=[];const o=Date.now();for(let u=0;u<s._HISTORY_LENGTH;u++)this.lastRuns[u]=o-1e3*u;setInterval(()=>{for(let u=s._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}load(){const o=Date.now(),u=(1+s._HISTORY_LENGTH)*1e3;let p=0;for(let C=0;C<s._HISTORY_LENGTH;C++)o-this.lastRuns[C]<=u&&p++;return 1-p/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class r{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(o){this._onControlMessage=new E,this.onControlMessage=this._onControlMessage.event,this._onMessage=new E,this.onMessage=this._onMessage.event,this._onDidDispose=new E,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new E,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new E,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o.loadEstimator??s.getInstance(),this._shouldSendKeepAlive=o.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new I.DisposableStore,this._socket=o.socket,this._socketWriter=this._socketDisposables.add(new m(this._socket)),this._socketReader=this._socketDisposables.add(new w(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.add(this._socket.onClose(u=>this._onSocketClose.fire(u))),o.initialChunk&&this._socketReader.acceptChunk(o.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new y(5,0,0,f());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new y(7,0,0,f());this._socketWriter.write(o)}sendResume(){const o=new y(8,0,0,f());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,u){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new I.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=this._socketDisposables.add(new m(this._socket)),this._socketReader=this._socketDisposables.add(new w(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(p=>this._receiveMessage(p))),this._socketDisposables.add(this._socket.onClose(p=>this._onSocketClose.fire(p))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new y(3,0,this._incomingAckId,f());this._socketWriter.write(o);const u=this._outgoingUnackMsg.toArray();for(let p=0,C=u.length;p<C;p++)this._socketWriter.write(u[p]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new y(6,0,0,f())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const u=this._outgoingUnackMsg.toArray();for(let p=0,C=u.length;p<C;p++)this._socketWriter.write(u[p]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const p=new y(1,u,this._incomingAckId,o);this._outgoingUnackMsg.push(p),this._isReconnecting||(this._socketWriter.write(p),this._recvAckCheck())}sendControl(o){const u=new y(2,0,0,o);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),u=Date.now()-o.writtenTime,p=Date.now()-this._socketReader.lastReadTime,C=Date.now()-this._lastSocketTimeoutTime;if(u>=2e4&&p>=2e4&&C>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:p});return}const M=Math.max(2e4-u,2e4-p,2e4-C,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},M)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new y(3,0,this._incomingAckId,f());this._socketWriter.write(o)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const o=new y(9,0,this._incomingAckId,f());this._socketWriter.write(o)}}e.PersistentProtocol=r}),define(se[37],oe([0,1,14,15,13]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class A{constructor(){this.mapListenerToWrapper=new WeakMap}on(P,h){const l=(f,...S)=>{this.validateEvent(P,f)&&h(f,...S)};return this.mapListenerToWrapper.set(h,l),n.ipcMain.on(P,l),this}once(P,h){return n.ipcMain.once(P,(l,...f)=>{this.validateEvent(P,l)&&h(l,...f)}),this}handle(P,h){return n.ipcMain.handle(P,(l,...f)=>this.validateEvent(P,l)?h(l,...f):Promise.reject(`Invalid channel '${P}' or sender for ipcMain.handle() usage.`)),this}removeHandler(P){return n.ipcMain.removeHandler(P),this}removeListener(P,h){const l=this.mapListenerToWrapper.get(h);return l&&(n.ipcMain.removeListener(P,l),this.mapListenerToWrapper.delete(h)),this}validateEvent(P,h){if(!P||!P.startsWith("vscode:"))return(0,R.onUnexpectedError)(`Refused to handle ipcMain event for channel '${P}' because the channel is unknown.`),!1;const l=h.senderFrame,f=l.url;if(!f||f==="about:blank")return!0;let S="unknown";try{S=new URL(f).host}catch{return(0,R.onUnexpectedError)(`Refused to handle ipcMain event for channel '${P}' because of a malformed URL '${f}'.`),!1}return S!==I.VSCODE_AUTHORITY?((0,R.onUnexpectedError)(`Refused to handle ipcMain event for channel '${P}' because of a bad origin of '${S}'.`),!1):l.parent!==null?((0,R.onUnexpectedError)(`Refused to handle ipcMain event for channel '${P}' because sender of origin '${S}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new A}),define(se[160],oe([0,1,14,37,148]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=A;function A(){R.validatedIpcMain.on(I.CONTEXT_MENU_CHANNEL,(P,h,l,f,S)=>{const b=k(P,f,l);b.popup({x:S?S.x:void 0,y:S?S.y:void 0,positioningItem:S?S.positioningItem:void 0,callback:()=>{b&&P.sender.send(I.CONTEXT_MENU_CLOSE_CHANNEL,h)}})})}function k(P,h,l){const f=new n.Menu;return l.forEach(S=>{let b;S.type==="separator"?b=new n.MenuItem({type:S.type}):Array.isArray(S.submenu)?b=new n.MenuItem({submenu:k(P,h,S.submenu),label:S.label}):b=new n.MenuItem({label:S.label,type:S.type,accelerator:S.accelerator,checked:S.checked,enabled:S.enabled,visible:S.visible,click:(g,d,y)=>P.sender.send(h,S.id,y)}),f.append(b)}),f}}),define(se[161],oe([0,1,37,17,3,2,44,149]),function(Q,e,n,R,I,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function h(f,S){const b=I.Event.fromNodeEventEmitter(n.validatedIpcMain,S,(d,y)=>({event:d,message:y})),g=I.Event.filter(b,({event:d})=>d.sender.id===f);return I.Event.map(g,({message:d})=>d&&R.VSBuffer.wrap(d))}class l extends k.IPCServer{static{this.Clients=new Map}static getOnDidClientConnect(){const S=I.Event.fromNodeEventEmitter(n.validatedIpcMain,"vscode:hello",({sender:b})=>b);return I.Event.map(S,b=>{const g=b.id;l.Clients.get(g)?.dispose();const y=new I.Emitter;l.Clients.set(g,(0,A.toDisposable)(()=>y.fire()));const w=h(g,"vscode:message"),m=I.Event.any(I.Event.signal(h(g,"vscode:disconnect")),y.event);return{protocol:new P.Protocol(b,w),onDidClientDisconnect:m}})}constructor(){super(l.getOnDidClientConnect())}}e.Server=l}),define(se[114],oe([0,1,37,3,33,159]),function(Q,e,n,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=void 0,e.connect=P;class k extends A.Client{constructor(l,f){super({addEventListener:(S,b)=>l.addListener(S,b),removeEventListener:(S,b)=>l.removeListener(S,b),postMessage:S=>l.postMessage(S),start:()=>l.start(),close:()=>l.close()},f)}}e.Client=k;async function P(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,I.generateUuid)();h.webContents.send("vscode:createMessageChannel",l);const f=R.Event.fromNodeEventEmitter(n.validatedIpcMain,"vscode:createMessageChannelResult",(b,g)=>({nonce:g,port:b.ports[0]})),{port:S}=await R.Event.toPromise(R.Event.once(R.Event.filter(f,b=>b.nonce===l)));return S}}),define(se[162],oe([0,1,49,8,17,23,156,15,3,2,35,90,76,44]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends g.ChannelServer{constructor(m){super({send:c=>{try{process.send?.(c.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",c=>I.VSBuffer.wrap(Buffer.from(c,"base64")))},m),process.once("disconnect",()=>this.dispose())}}e.Server=d;class y{constructor(m,c){this.modulePath=m,this.options=c,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=c&&c.timeout?c.timeout:6e4;this.disposeDelayer=new R.Delayer(v),this.child=null,this._client=null}getChannel(m){const c=this;return{call(v,E,a){return c.requestPromise(m,v,E,a)},listen(v,E){return c.requestEvent(m,v,E)}}}requestPromise(m,c,v,E=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(m),t=(0,R.createCancelablePromise)(i=>a.call(c,v,i)),s=E.onCancellationRequested(()=>t.cancel()),r=(0,l.toDisposable)(()=>t.cancel());return this.activeRequests.add(r),t.finally(()=>{s.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(m,c,v){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let E;const a=new h.Emitter({onWillAddFirstListener:()=>{E=this.getCachedChannel(m).listen(c,v)(a.fire,a),this.activeRequests.add(E)},onDidRemoveLastListener:()=>{this.activeRequests.delete(E),E.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],c=Object.create(null);c.env={...(0,f.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(c.env={...c.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(c.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,b.removeDangerousEnvVariables)(c.env),this.child=(0,n.fork)(this.modulePath,m,c);const v=new h.Emitter,a=h.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if((0,k.isRemoteConsoleLog)(u)){(0,k.log)(u,`IPC Library: ${this.options.serverName}`);return}v.fire(I.VSBuffer.wrap(Buffer.from(u,"base64")))}),t=this.options.useQueue?(0,S.createQueuedSender)(this.child):this.child,s=u=>this.child&&this.child.connected&&t.send(u.buffer.toString("base64")),r=v.event,i={send:s,onMessage:r};this._client=new g.ChannelClient(i);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,p)=>{process.removeListener("exit",o),a.dispose(),this.activeRequests.forEach(C=>(0,l.dispose)(C)),this.activeRequests.clear(),u!==0&&p!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+p),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:p})})}return this._client}getCachedChannel(m){let c=this.channels.get(m);return c||(c=this.client.getChannel(m),this.channels.set(m,c)),c}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(se[115],oe([0,1,8,3,2,77,12]),function(Q,e,n,R,I,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=h;var P;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function h(b){const g=b;return g?.changed instanceof Map||g?.deleted instanceof Set}var l;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(l||(e.StorageState=l={}));class f extends I.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(g,d=Object.create(null)){super(),this.database=g,this.options=d,this._onDidChangeStorage=this._register(new R.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=this._register(new n.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){this._onDidChangeStorage.pause();try{g.changed?.forEach((d,y)=>this.acceptExternal(y,d)),g.deleted?.forEach(d=>this.acceptExternal(d,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(g,d){if(this.state===l.Closed)return;let y=!1;(0,k.isUndefinedOrNull)(d)?y=this.cache.delete(g):this.cache.get(g)!==d&&(this.cache.set(g,d),y=!0),y&&this._onDidChangeStorage.fire({key:g,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,d){const y=this.cache.get(g);return(0,k.isUndefinedOrNull)(y)?d:y}getBoolean(g,d){const y=this.get(g);return(0,k.isUndefinedOrNull)(y)?d:y==="true"}getNumber(g,d){const y=this.get(g);return(0,k.isUndefinedOrNull)(y)?d:parseInt(y,10)}getObject(g,d){const y=this.get(g);return(0,k.isUndefinedOrNull)(y)?d:(0,A.parse)(y)}async set(g,d,y=!1){if(this.state===l.Closed)return;if((0,k.isUndefinedOrNull)(d))return this.delete(g,y);const w=(0,k.isObject)(d)||Array.isArray(d)?(0,A.stringify)(d):String(d);if(this.cache.get(g)!==w)return this.cache.set(g,w),this.pendingInserts.set(g,w),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire({key:g,external:y}),this.doFlush()}async delete(g,d=!1){if(!(this.state===l.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire({key:g,external:d}),this.doFlush()}async optimize(){if(this.state!==l.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(g){if(this.hasPending)return this.doFlush(g)}async doFlush(g){return this.options.hint===P.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),g)}async whenFlushed(){if(this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}isInMemory(){return this.options.hint===P.STORAGE_IN_MEMORY}}e.Storage=f;class S{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert?.forEach((d,y)=>this.items.set(y,d)),g.delete?.forEach(d=>this.items.delete(d))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=S}),define(se[163],oe([0,1,8,3,32,9,21]),function(Q,e,n,R,I,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class P{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return R.Event.None}static{this.BUSY_OPEN_TIMEOUT=2e3}static{this.MAX_HOST_PARAMETERS=256}constructor(f,S=Object.create(null)){this.path=f,this.options=S,this.name=(0,A.basename)(this.path),this.logger=new h(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const f=await this.whenConnected,S=new Map;return(await this.all(f,"SELECT * FROM ItemTable")).forEach(g=>S.set(g.key,g.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${S.size} rows`),S}async updateItems(f){const S=await this.whenConnected;return this.doUpdateItems(S,f)}doUpdateItems(f,S){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${S.insert?(0,I.mapToString)(S.insert):"0"}), delete(${S.delete?(0,I.setToString)(S.delete):"0"})`),this.transaction(f,()=>{const b=S.insert,g=S.delete;if(b&&b.size>0){const d=[];d.push([]);let y=0;b.forEach((w,m)=>{let c=d[y];c.length>P.MAX_HOST_PARAMETERS&&(y++,c=[],d.push(c)),c.push(m,w)}),d.forEach(w=>{this.prepare(f,`INSERT INTO ItemTable VALUES ${new Array(w.length/2).fill("(?,?)").join(",")}`,m=>m.run(w),()=>{const m=[];let c=0;return b.forEach((v,E)=>{m.push(E),c+=v.length}),`Keys: ${m.join(", ")} Length: ${c}`})})}if(g&&g.size){const d=[];d.push([]);let y=0;g.forEach(w=>{let m=d[y];m.length>P.MAX_HOST_PARAMETERS&&(y++,m=[],d.push(m)),m.push(w)}),d.forEach(w=>{this.prepare(f,`DELETE FROM ItemTable WHERE key IN (${new Array(w.length).fill("?").join(",")})`,m=>m.run(w),()=>{const m=[];return g.forEach(c=>{m.push(c)}),`Keys: ${m.join(", ")}`})})}})}async optimize(){this.logger.trace(`[storage ${this.name}] vacuum()`);const f=await this.whenConnected;return this.exec(f,"VACUUM")}async close(f){this.logger.trace(`[storage ${this.name}] close()`);const S=await this.whenConnected;return this.doClose(S,f)}doClose(f,S){return new Promise((b,g)=>{f.db.close(d=>(d&&this.handleSQLiteError(f,`[storage ${this.name}] close(): ${d}`),this.path===P.IN_MEMORY_PATH?b():!f.isErroneous&&!f.isInMemory?this.backup().then(b,y=>(this.logger.error(`[storage ${this.name}] backup(): ${y}`),b())):typeof S=="function"?k.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(y=>{const w=()=>this.doClose(y,void 0);return this.doUpdateItems(y,{insert:S()}).then(()=>w(),m=>(w(),Promise.reject(m)))})).then(b,g):g(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const f=this.toBackupPath(this.path);return k.Promises.copy(this.path,f,{preserveSymlinks:!1})}toBackupPath(f){return`${f}.backup`}async checkIntegrity(f){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${f})`);const S=await this.whenConnected,b=await this.get(S,f?"PRAGMA integrity_check":"PRAGMA quick_check"),g=f?b.integrity_check:b.quick_check;return S.isErroneous?`${g} (last error: ${S.lastError})`:S.isInMemory?`${g} (in-memory!)`:g}async connect(f,S=!0){this.logger.trace(`[storage ${this.name}] open(${f}, retryOnBusy: ${S})`);try{return await this.doConnect(f)}catch(b){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&S)return await(0,n.timeout)(P.BUSY_OPEN_TIMEOUT),this.connect(f,!1);try{await k.Promises.unlink(f);try{await k.Promises.rename(this.toBackupPath(f),f,!1)}catch{}return await this.doConnect(f)}catch(g){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${g}`),this.doConnect(P.IN_MEMORY_PATH)}}}handleSQLiteError(f,S){f.isErroneous=!0,f.lastError=S,this.logger.error(S)}doConnect(f){return new Promise((S,b)=>{new Promise((g,d)=>{Q(["@vscode/sqlite3"],g,d)}).then(g=>{const d={db:new(this.logger.isTracing?g.verbose().Database:g.Database)(f,y=>y?d.db&&y.code!=="SQLITE_CANTOPEN"?d.db.close(()=>b(y)):b(y):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>S(d),w=>d.db.close(()=>b(w)))),isInMemory:f===P.IN_MEMORY_PATH};d.db.on("error",y=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${y}`)),this.logger.isTracing&&d.db.on("trace",y=>this.logger.trace(`[storage ${this.name}] Trace (event): ${y}`))},b)})}exec(f,S){return new Promise((b,g)=>{f.db.exec(S,d=>d?(this.handleSQLiteError(f,`[storage ${this.name}] exec(): ${d}`),g(d)):b())})}get(f,S){return new Promise((b,g)=>{f.db.get(S,(d,y)=>d?(this.handleSQLiteError(f,`[storage ${this.name}] get(): ${d}`),g(d)):b(y))})}all(f,S){return new Promise((b,g)=>{f.db.all(S,(d,y)=>d?(this.handleSQLiteError(f,`[storage ${this.name}] all(): ${d}`),g(d)):b(y))})}transaction(f,S){return new Promise((b,g)=>{f.db.serialize(()=>{f.db.run("BEGIN TRANSACTION"),S(),f.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(f,`[storage ${this.name}] transaction(): ${d}`),g(d)):b())})})}prepare(f,S,b,g){const d=f.db.prepare(S),y=w=>{this.handleSQLiteError(f,`[storage ${this.name}] prepare(): ${w} (${S}). Details: ${g()}`)};d.on("error",y),b(d),d.finalize(w=>{w&&y(w),d.removeListener("error",y)})}}e.SQLiteStorageDatabase=P;class h{static{this.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}constructor(f){f&&typeof f.logTrace=="function"&&process.env[h.VSCODE_TRACE_STORAGE]&&(this.logTrace=f.logTrace),f&&typeof f.logError=="function"&&(this.logError=f.logError)}get isTracing(){return!!this.logTrace}trace(f){this.logTrace?.(f)}error(f){this.logError?.(f)}}}),define(se[164],oe([11,10]),function(Q,e){return Q.create("vs/code/electron-main/app",e)}),define(se[165],oe([11,10]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(se[166],oe([11,10]),function(Q,e){return Q.create("vs/platform/contextkey/common/contextkey",e)}),define(se[167],oe([11,10]),function(Q,e){return Q.create("vs/platform/contextkey/common/scanner",e)}),define(se[168],oe([11,10]),function(Q,e){return Q.create("vs/platform/dialogs/common/dialogs",e)}),define(se[169],oe([11,10]),function(Q,e){return Q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(se[170],oe([11,10]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(se[171],oe([11,10]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(se[172],oe([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(se[173],oe([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(se[174],oe([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(se[175],oe([11,10]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(se[176],oe([11,10]),function(Q,e){return Q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(se[177],oe([11,10]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(se[178],oe([11,10]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(se[179],oe([11,10]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(se[180],oe([11,10]),function(Q,e){return Q.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(se[181],oe([11,10]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(se[182],oe([11,10]),function(Q,e){return Q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(se[183],oe([11,10]),function(Q,e){return Q.create("vs/platform/log/common/log",e)}),define(se[184],oe([11,10]),function(Q,e){return Q.create("vs/platform/menubar/electron-main/menubar",e)}),define(se[185],oe([11,10]),function(Q,e){return Q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(se[186],oe([11,10]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(se[187],oe([11,10]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(se[188],oe([11,10]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(se[189],oe([11,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(se[190],oe([11,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(se[191],oe([11,10]),function(Q,e){return Q.create("vs/platform/update/common/update.config.contribution",e)}),define(se[192],oe([11,10]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(se[193],oe([11,10]),function(Q,e){return Q.create("vs/platform/windows/electron-main/windowImpl",e)}),define(se[194],oe([11,10]),function(Q,e){return Q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(se[195],oe([11,10]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(se[196],oe([11,10]),function(Q,e){return Q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(se[197],oe([11,10]),function(Q,e){return Q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(se[198],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isFolderBackupInfo=n,e.isWorkspaceBackupInfo=R;function n(I){return I&&I.hasOwnProperty("folderUri")}function R(I){return I&&I.hasOwnProperty("workspace")}}),define(se[199],oe([0,1,7]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=R,e.deserializeWorkspaceInfos=I,e.deserializeFolderInfos=A;function R(k){return typeof k?.backupFolder=="string"}function I(k){let P=[];try{Array.isArray(k.workspaces)&&(P=k.workspaces.map(h=>({workspace:{id:h.id,configPath:n.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return P}function A(k){let P=[];try{Array.isArray(k.folders)&&(P=k.folders.map(h=>({folderUri:n.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return P}}),define(se[200],oe([0,1,15,167]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var I;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(I||(e.TokenType=I={}));function A(...l){switch(l.length){case 1:return(0,R.localize)(0,null,l[0]);case 2:return(0,R.localize)(1,null,l[0],l[1]);case 3:return(0,R.localize)(2,null,l[0],l[1],l[2]);default:return}}const k=(0,R.localize)(3,null),P=(0,R.localize)(4,null);class h{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(f){switch(f.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return f.isTripleEq?"===":"==";case 4:return f.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return f.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return f.lexeme;case 18:return f.lexeme;case 19:return f.lexeme;case 20:return"EOF";default:throw(0,n.illegalState)(`unhandled token type: ${JSON.stringify(f)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(f=>f.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(f){return this._input=f,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const S=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:S})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const S=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:S})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(f){return this._isAtEnd()||this._input.charCodeAt(this._current)!==f?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(f){this._tokens.push({type:f,offset:this._start})}_error(f){const S=this._start,b=this._input.substring(this._start,this._current),g={type:19,offset:this._start,lexeme:b};this._errors.push({offset:S,lexeme:b,additionalInfo:f}),this._tokens.push(g)}_string(){this.stringRe.lastIndex=this._start;const f=this.stringRe.exec(this._input);if(f){this._current=this._start+f[0].length;const S=this._input.substring(this._start,this._current),b=h._keywords.get(S);b?this._addToken(b):this._tokens.push({type:17,lexeme:S,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(k);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let f=this._current,S=!1,b=!1;for(;;){if(f>=this._input.length){this._current=f,this._error(P);return}const d=this._input.charCodeAt(f);if(S)S=!1;else if(d===47&&!b){f++;break}else d===91?b=!0:d===92?S=!0:d===93&&(b=!1);f++}for(;f<this._input.length&&h._regexFlags.has(this._input.charCodeAt(f));)f++;this._current=f;const g=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:g,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=h}),define(se[201],oe([0,1,3,2]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class I{constructor(){this._onCloseEmitter=new n.Emitter,this._onReloadEmitter=new n.Emitter,this._onTerminateEmitter=new n.Emitter,this._onAttachEmitter=new n.Emitter}static{this.ChannelName="extensionhostdebugservice"}call(P,h,l){switch(h){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(P,h,l){switch(h){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=I;class A extends R.Disposable{constructor(P){super(),this.channel=P}reload(P){this.channel.call("reload",[P])}get onReload(){return this.channel.listen("reload")}close(P){this.channel.call("close",[P])}get onClose(){return this.channel.listen("close")}attachSession(P,h,l){this.channel.call("attach",[P,h,l])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(P,h){this.channel.call("terminate",[P,h])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(P,h){return this.channel.call("openExtensionDevelopmentHostWindow",[P,h])}}e.ExtensionHostDebugChannelClient=A}),define(se[202],oe([0,1,151,51,13,9,36,19,7]),function(Q,e,n,R,I,A,k,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=f,e.parseDebugParams=S,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,A.dirname)(I.FileAccess.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:I.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const g=(0,n.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",g)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(h.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=k.env.VSCODE_PORTABLE;return g?h.URI.file((0,A.join)(g,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,A.resolve)(g):(0,A.normalize)((0,A.join)(I.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?h.URI.file((0,A.resolve)(g)):h.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,A.resolve)(g);const d=k.env.VSCODE_EXTENSIONS;if(d)return d;const y=k.env.VSCODE_PORTABLE;return y?(0,A.join)(y,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(d=>/^[^:/?#]+?:\/\//.test(d)?h.URI.parse(d):h.URI.file((0,A.normalize)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?h.URI.parse(g):h.URI.file((0,A.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return f(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(g))}get extensionLogLevel(){const g=[];for(const d of this.args.log||[]){const y=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(d);y&&y[1]&&y[2]&&g.push([y[1],y[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=k.env.VSCODE_PORTABLE;return g?h.URI.file((0,A.join)(g,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this._args}constructor(g,d,y){this._args=g,this.paths=d,this.productService=y,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=l,Ie([R.memoize],l.prototype,"appRoot",null),Ie([R.memoize],l.prototype,"userHome",null),Ie([R.memoize],l.prototype,"userDataPath",null),Ie([R.memoize],l.prototype,"appSettingsHome",null),Ie([R.memoize],l.prototype,"tmpDir",null),Ie([R.memoize],l.prototype,"cacheHome",null),Ie([R.memoize],l.prototype,"stateResource",null),Ie([R.memoize],l.prototype,"userRoamingDataHome",null),Ie([R.memoize],l.prototype,"userDataSyncHome",null),Ie([R.memoize],l.prototype,"sync",null),Ie([R.memoize],l.prototype,"machineSettingsResource",null),Ie([R.memoize],l.prototype,"workspaceStorageHome",null),Ie([R.memoize],l.prototype,"localHistoryHome",null),Ie([R.memoize],l.prototype,"keyboardLayoutResource",null),Ie([R.memoize],l.prototype,"argvResource",null),Ie([R.memoize],l.prototype,"isExtensionDevelopment",null),Ie([R.memoize],l.prototype,"untitledWorkspacesHome",null),Ie([R.memoize],l.prototype,"builtinExtensionsPath",null),Ie([R.memoize],l.prototype,"extensionsPath",null),Ie([R.memoize],l.prototype,"extensionDevelopmentLocationURI",null),Ie([R.memoize],l.prototype,"extensionDevelopmentKind",null),Ie([R.memoize],l.prototype,"extensionTestsLocationURI",null),Ie([R.memoize],l.prototype,"debugExtensionHost",null),Ie([R.memoize],l.prototype,"logLevel",null),Ie([R.memoize],l.prototype,"extensionLogLevel",null),Ie([R.memoize],l.prototype,"serviceMachineIdResource",null),Ie([R.memoize],l.prototype,"disableTelemetry",null),Ie([R.memoize],l.prototype,"disableWorkspaceTrust",null),Ie([R.memoize],l.prototype,"useInMemorySecretStorage",null),Ie([R.memoize],l.prototype,"policyFile",null);function f(b,g){return S(b["inspect-extensions"],b["inspect-brk-extensions"],5870,g,b.debugId,b.extensionEnvironment)}function S(b,g,d,y,w,m){const v=Number(g||b)||(y?null:d),E=v?!!g:!1;let a;if(m)try{a=JSON.parse(m)}catch{}return{port:v,break:E,debugId:w,env:a}}}),define(se[116],oe([0,1,313,4,170]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0,e.parseArgs=P,e.formatOptions=l,e.buildHelpMessage=g,e.buildVersionMessage=d;const A={o:(0,I.localize)(0,null),e:(0,I.localize)(1,null),t:(0,I.localize)(2,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,I.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,I.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,I.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,I.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,I.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,I.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,I.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,I.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,I.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,I.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,I.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,I.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,I.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,I.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,I.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,I.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,I.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,I.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,I.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,I.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,I.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,I.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,I.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,I.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,I.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,I.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,I.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,I.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,I.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,I.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,I.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,I.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,I.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,I.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,I.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(y,w,m=k){const c=y.find(u=>u.length>0&&u[0]!=="-"),v={},E=["_"],a=[],t={};let s;for(const u in w){const p=w[u];p.type==="subcommand"?u===c&&(s=p):(p.alias&&(v[u]=p.alias),p.type==="string"||p.type==="string[]"?(E.push(u),p.deprecates&&E.push(...p.deprecates)):p.type==="boolean"&&(a.push(u),p.deprecates&&a.push(...p.deprecates)),p.global&&(t[u]=p))}if(s&&c){const u=t;for(const D in s.options)u[D]=s.options[D];const p=y.filter(D=>D!==c),C=m.getSubcommandReporter?m.getSubcommandReporter(c):void 0,M=P(p,u,C);return{[c]:M,_:[]}}const r=n(y,{string:E,boolean:a,alias:v}),i={},o=r;i._=r._.map(u=>String(u)).filter(u=>u.length>0),delete o._;for(const u in w){const p=w[u];if(p.type==="subcommand")continue;p.alias&&delete o[p.alias];let C=o[u];if(p.deprecates)for(const M of p.deprecates)o.hasOwnProperty(M)&&(C||(C=o[M],C&&m.onDeprecatedOption(M,p.deprecationMessage||(0,I.localize)(38,null,u))),delete o[M]);if(typeof C<"u"){if(p.type==="string[]"){if(Array.isArray(C)||(C=[C]),!p.allowEmptyValue){const M=C.filter(D=>D.length>0);M.length!==C.length&&(m.onEmptyValue(u),C=M.length>0?M:void 0)}}else p.type==="string"&&(Array.isArray(C)?(C=C.pop(),m.onMultipleValues(u,C)):!C&&!p.allowEmptyValue&&(m.onEmptyValue(u),C=void 0));i[u]=C,p.deprecationMessage&&m.onDeprecatedOption(u,p.deprecationMessage)}delete o[u]}for(const u in o)m.onUnknownOption(u);return i}function h(y,w){let m="";return w.args&&(Array.isArray(w.args)?m=` <${w.args.join("> <")}>`:m=` <${w.args}>`),w.alias?`-${w.alias} --${y}${m}`:`--${y}${m}`}function l(y,w){const m=[];for(const c in y){const v=y[c],E=h(c,v);m.push([E,v.description])}return f(m,w)}function f(y,w){const c=y.reduce((a,t)=>Math.max(a,t[0].length),12)+2+1;if(w-c<25)return y.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const v=w-c-1,E=[];for(const a of y){const t=a[0],s=b(a[1],v),r=S(c-t.length-2);E.push("  "+t+r+s[0]);for(let i=1;i<s.length;i++)E.push(S(c)+s[i])}return E}function S(y){return" ".repeat(y)}function b(y,w){const m=[];for(;y.length;){const c=y.length<w?y.length:y.lastIndexOf(" ",w),v=y.slice(0,c).trim();y=y.slice(c),m.push(v)}return m}function g(y,w,m,c,v){const E=process.stdout.isTTY&&process.stdout.columns||80,a=v?.noInputFiles!==!0?`[${(0,I.localize)(39,null)}...]`:"",t=[`${y} ${m}`];t.push(""),t.push(`${(0,I.localize)(40,null)}: ${w} [${(0,I.localize)(41,null)}]${a}`),t.push(""),v?.noPipe!==!0&&(R.isWindows?t.push((0,I.localize)(42,null,w)):t.push((0,I.localize)(43,null,w)),t.push(""));const s={},r=[];for(const i in c){const o=c[i];if(o.type==="subcommand")o.description&&r.push({command:i,description:o.description});else if(o.description&&o.cat){let u=s[o.cat];u||(s[o.cat]=u={}),u[i]=o}}for(const i in s){const o=i,u=s[o];u&&(t.push(A[o]),t.push(...l(u,E)),t.push(""))}return r.length&&(t.push((0,I.localize)(44,null)),t.push(...f(r.map(i=>[i.command,i.description]),E)),t.push("")),t.join(`
`)}function d(y,w){return`${y||(0,I.localize)(45,null)}
${w||(0,I.localize)(46,null)}
${process.arch}`}}),define(se[203],oe([0,1,88,201,116]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class A extends R.ExtensionHostDebugBroadcastChannel{constructor(P){super(),this.windowsMainService=P}call(P,h,l){return h==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(l[0],l[1]):super.call(P,h,l)}async openExtensionDevelopmentHostWindow(P,h){const l=(0,I.parseArgs)(P,I.OPTIONS);l.debugRenderer=h;const f=l.extensionDevelopmentPath;if(!f)return{success:!1};const[S]=await this.windowsMainService.openExtensionDevelopmentHostWindow(f,{context:5,cli:l,forceProfile:l.profile,forceTempProfile:l["profile-temp"]});if(!h)return{success:!0};const b=S.win;if(!b)return{success:!0};const g=b.webContents.debugger;let d=g.isAttached()?1/0:0;const y=(0,n.createServer)(w=>{d++===0&&g.attach();let m=!1;const c=a=>{m||w.write(JSON.stringify(a)+"\0")},v=(a,t,s,r)=>c({method:t,params:s,sessionId:r});b.on("close",()=>{g.removeListener("message",v),w.end(),m=!0}),g.addListener("message",v);let E=Buffer.alloc(0);w.on("data",a=>{E=Buffer.concat([E,a]);for(let t=E.indexOf(0);t!==-1;t=E.indexOf(0)){let s;try{const r=E.slice(0,t).toString("utf8");E=E.slice(t+1),s=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}g.sendCommand(s.method,s.params,s.sessionId).then(r=>c({id:s.id,sessionId:s.sessionId,result:r})).catch(r=>c({id:s.id,sessionId:s.sessionId,error:{code:0,message:r.message}}))}}),w.on("error",a=>{console.error("error on cdp pipe:",a)}),w.on("close",()=>{m=!0,--d===0&&g.detach()})});return await new Promise(w=>y.listen(0,w)),b.on("close",()=>y.close()),{rendererDebugPort:y.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=A}),define(se[64],oe([0,1,314,171,116]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseMainProcessArgv=P,e.parseCLIProcessArgv=h,e.addArg=l,e.isLaunchedFromCli=f;function A(S,b){const g=(v,E)=>{console.warn((0,R.localize)(0,null,v,E))},d=v=>{console.warn((0,R.localize)(1,null,v))},y=(v,E)=>{console.warn((0,R.localize)(2,null,v,E))},w=v=>({onUnknownOption:E=>{I.NATIVE_CLI_COMMANDS.includes(v)||console.warn((0,R.localize)(3,null,E,v))},onMultipleValues:g,onEmptyValue:d,onDeprecatedOption:y,getSubcommandReporter:I.NATIVE_CLI_COMMANDS.includes(v)?w:void 0}),m={onUnknownOption:v=>{console.warn((0,R.localize)(4,null,v))},onMultipleValues:g,onEmptyValue:d,onDeprecatedOption:y,getSubcommandReporter:w},c=(0,I.parseArgs)(S,I.OPTIONS,b?m:void 0);return c.goto&&c._.forEach(v=>n(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(v),(0,R.localize)(5,null))),c}function k(S){const b=S.findIndex(g=>!/^-/.test(g));if(b>-1)return[...S.slice(0,b),...S.slice(b+1)]}function P(S){let[,...b]=S;process.env.VSCODE_DEV&&(b=k(b)||[]);const g=!f(process.env);return A(b,g)}function h(S){let[,,...b]=S;return process.env.VSCODE_DEV&&(b=k(b)||[]),A(b,!0)}function l(S,...b){const g=S.indexOf("--");return g===-1?S.push(...b):S.splice(g,0,...b),S}function f(S){return S.VSCODE_CLI==="1"}}),function(){"use strict";function Q(e,n,R){function I(k,P){const h=A(k,P),l=[h];return e.isAbsolute(h)||l.unshift(R),e.resolve(...l)}function A(k,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,P);const f=k["user-data-dir"];if(f)return f;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(S,"AppData","Roaming")}break;case"darwin":l=e.join(n.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,P)}return{getUserDataPath:I}}if(typeof define=="function")define(se[204],oe([117,26,36]),function(e,n,R){return Q(e,n,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=Q(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(se[91],oe([0,1,26,202,204]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=k,e.parseSharedProcessDebugPort=P;class A extends R.AbstractNativeEnvironmentService{constructor(l,f){super(l,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,I.getUserDataPath)(l,f.nameShort)},f)}}e.NativeEnvironmentService=A;function k(h,l){return(0,R.parseDebugParams)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,l,h.extensionEnvironment)}function P(h,l){return(0,R.parseDebugParams)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,l,h.extensionEnvironment)}}),define(se[205],oe([0,1,43,26,31]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=A;function A(k){const P=(0,I.randomPath)((0,R.tmpdir)());try{return(0,n.writeFileSync)(P,""),k&&console.log(`Marker file for --wait created: ${P}`),P}catch(h){k&&console.error(`Failed to create marker file for --wait: ${h}`);return}}}),define(se[206],oe([0,1,12,173]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=I;function I(k,P,h,l){try{A(k,P,h,l)}catch(f){k.error(f?.message??f)}return P}function A(k,P,h,l){const f=(S,b,g)=>{const d=S[b];if((0,n.isString)(d)){const y=d,w=y.length;if(w>1&&y[0]==="%"&&y[w-1]==="%"){const m=y.substr(1,w-2);let c=h[m];c===void 0&&l&&(c=l[m]);const v=typeof c=="string"?c:c?.message,E=l?.[m],a=typeof E=="string"?E:E?.message;if(!v){a||k.warn(`[${P.name}]: ${(0,R.localize)(0,null,m)}`);return}if(g&&(b==="title"||b==="category")&&a&&a!==v){const t={value:v,original:a};S[b]=t}else S[b]=v}}else if((0,n.isObject)(d))for(const y in d)d.hasOwnProperty(y)&&(y==="commands"?f(d,y,!0):f(d,y,g));else if(Array.isArray(d))for(let y=0;y<d.length;y++)f(d,y,g)};for(const S in P)P.hasOwnProperty(S)&&f(P,S)}}),define(se[207],oe([0,1,19,74,175,208]),function(Q,e,n,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=h,e.parseVersion=l,e.normalizeVersion=f,e.isValidVersion=S,e.validateExtensionManifest=b,e.isValidExtensionVersion=g,e.isEngineValid=d;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function h(m){return m=m.trim(),m==="*"||k.test(m)}function l(m){if(!h(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=m.match(k);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}function f(m){if(!m)return null;const c=m.majorBase,v=m.majorMustEqual,E=m.minorBase;let a=m.minorMustEqual;const t=m.patchBase;let s=m.patchMustEqual;m.hasCaret&&(c===0||(a=!1),s=!1);let r=0;if(m.preRelease){const i=P.exec(m.preRelease);if(i){const[,o,u,p]=i;r=Date.UTC(Number(o),Number(u)-1,Number(p))}}return{majorBase:c,majorMustEqual:v,minorBase:E,minorMustEqual:a,patchBase:t,patchMustEqual:s,isMinimum:m.hasGreaterEquals,notBefore:r}}function S(m,c,v){let E;typeof m=="string"?E=f(l(m)):E=m;let a;c instanceof Date?a=c.getTime():typeof c=="string"&&(a=new Date(c).getTime());let t;if(typeof v=="string"?t=f(l(v)):t=v,!E||!t)return!1;const s=E.majorBase,r=E.minorBase,i=E.patchBase;let o=t.majorBase,u=t.minorBase,p=t.patchBase;const C=t.notBefore;let M=t.majorMustEqual,D=t.minorMustEqual,W=t.patchMustEqual;return t.isMinimum?s>o?!0:s<o?!1:r>u?!0:r<u||a&&a<C?!1:i>=p:(s===1&&o===0&&(!M||!D||!W)&&(o=1,u=0,p=0,M=!0,D=!1,W=!1),s<o?!1:s>o?!M:r<u?!1:r>u?!D:i<p?!1:i>p?!W:!(a&&a<C))}function b(m,c,v,E,a){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([R.default.Error,I.localize(0,null)]),t;if(typeof E.name!="string")return t.push([R.default.Error,I.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([R.default.Error,I.localize(2,null,"version")]),t;if(!E.engines)return t.push([R.default.Error,I.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([R.default.Error,I.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!w(E.extensionDependencies))return t.push([R.default.Error,I.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!w(E.activationEvents))return t.push([R.default.Error,I.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([R.default.Error,I.localize(7,null,"activationEvents","main","browser")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([R.default.Warning,I.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([R.default.Error,I.localize(9,null,"main")]),t;{const i=(0,n.joinPath)(v,E.main);(0,n.isEqualOrParent)(i,v)||t.push([R.default.Warning,I.localize(10,null,i.path,v.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([R.default.Error,I.localize(11,null,"browser")]),t;{const i=(0,n.joinPath)(v,E.browser);(0,n.isEqualOrParent)(i,v)||t.push([R.default.Warning,I.localize(12,null,i.path,v.path)])}}if(!A.valid(E.version))return t.push([R.default.Error,I.localize(13,null)]),t;const s=[];if(!g(m,c,E,a,s))for(const i of s)t.push([R.default.Error,i]);return t}function g(m,c,v,E,a){return E||typeof v.main>"u"&&typeof v.browser>"u"?!0:y(m,c,v.engines.vscode,a)}function d(m,c,v){return m==="*"||y(c,v,m)}function y(m,c,v,E=[]){const a=f(l(v));if(!a)return E.push(I.localize(14,null,v)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return E.push(I.localize(15,null,v)),!1}else if(!a.majorMustEqual)return E.push(I.localize(16,null,v)),!1;return S(m,c,a)?!0:(E.push(I.localize(17,null,m,v)),!1)}function w(m){if(!Array.isArray(m))return!1;for(let c=0,v=m.length;c<v;c++)if(typeof m[c]!="string")return!1;return!0}}),define(se[209],oe([0,1,17,33]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=I;async function I(A,k,P){let h=P&&P.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const f=(await k.readFile(A.serviceMachineIdResource)).value.toString();h=(0,R.isUUID)(f)?f:null}catch{h=null}if(!h){h=(0,R.generateUuid)();try{await k.writeFile(A.serviceMachineIdResource,n.VSBuffer.fromString(h))}catch{}}return P?.store("storage.serviceMachineId",h,-1,1),h}}),define(se[78],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class n{constructor(I,A=[],k=!1){this.ctor=I,this.staticArguments=A,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=n}),define(se[210],oe([0,1,78]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=A,e.getSingletonServiceDescriptors=k;const R=[];var I;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function A(P,h,l){h instanceof n.SyncDescriptor||(h=new n.SyncDescriptor(h,[],!!l)),R.push([P,h])}function k(){return R}}),define(se[211],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class n{constructor(A,k){this.key=A,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.Node=n;class R{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const k of this._nodes.values())k.outgoing.size===0&&A.push(k);return A}insertEdge(A,k){const P=this.lookupOrInsertNode(A),h=this.lookupOrInsertNode(k);P.outgoing.set(h.key,h),h.incoming.set(P.key,P)}removeNode(A){const k=this._hashFn(A);this._nodes.delete(k);for(const P of this._nodes.values())P.outgoing.delete(k),P.incoming.delete(k)}lookupOrInsertNode(A){const k=this._hashFn(A);let P=this._nodes.get(k);return P||(P=new n(k,A),this._nodes.set(k,P)),P}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[k,P]of this._nodes)A.push(`${k}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,k]of this._nodes){const P=new Set([A]),h=this._findCycle(k,P);if(h)return h}}_findCycle(A,k){for(const[P,h]of A.outgoing){if(k.has(P))return[...k,P].join(" -> ");k.add(P);const l=this._findCycle(h,k);if(l)return l;k.delete(P)}}}e.Graph=R}),define(se[6],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=I,e.refineServiceDecorator=A;var n;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function P(h){return h[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=P})(n||(e._util=n={})),e.IInstantiationService=I("instantiationService");function R(k,P,h){P[n.DI_TARGET]===P?P[n.DI_DEPENDENCIES].push({id:k,index:h}):(P[n.DI_DEPENDENCIES]=[{id:k,index:h}],P[n.DI_TARGET]=P)}function I(k){if(n.serviceIds.has(k))return n.serviceIds.get(k);const P=function(h,l,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(P,h,f)};return P.toString=()=>k,n.serviceIds.set(k,P),P}function A(k){return k}}),define(se[79],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuxiliaryWindowsMainService=void 0,e.IAuxiliaryWindowsMainService=(0,n.createDecorator)("auxiliaryWindowsMainService")}),define(se[65],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,n.createDecorator)("backupMainService")}),define(se[18],oe([0,1,12,7,6]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=A,e.isConfigurationUpdateOverrides=k,e.ConfigurationTargetToString=h,e.isConfigured=l,e.toValuesTree=f,e.addToValueTree=S,e.removeFromValueTree=b,e.getConfigurationValue=d,e.merge=y,e.getLanguageTagSettingPlainKey=w,e.IConfigurationService=(0,I.createDecorator)("configurationService");function A(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof R.URI)}function k(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof R.URI)}var P;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function h(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function l(m){return m.applicationValue!==void 0||m.userValue!==void 0||m.userLocalValue!==void 0||m.userRemoteValue!==void 0||m.workspaceValue!==void 0||m.workspaceFolderValue!==void 0}function f(m,c){const v=Object.create(null);for(const E in m)S(v,E,m[E],c);return v}function S(m,c,v,E){const a=c.split("."),t=a.pop();let s=m;for(let r=0;r<a.length;r++){const i=a[r];let o=s[i];switch(typeof o){case"undefined":o=s[i]=Object.create(null);break;case"object":if(o===null){E(`Ignoring ${c} as ${a.slice(0,r+1).join(".")} is null`);return}break;default:E(`Ignoring ${c} as ${a.slice(0,r+1).join(".")} is ${JSON.stringify(o)}`);return}s=o}if(typeof s=="object"&&s!==null)try{s[t]=v}catch{E(`Ignoring ${c} as ${a.join(".")} is ${JSON.stringify(s)}`)}else E(`Ignoring ${c} as ${a.join(".")} is ${JSON.stringify(s)}`)}function b(m,c){const v=c.split(".");g(m,v)}function g(m,c){const v=c.shift();if(c.length===0){delete m[v];return}if(Object.keys(m).indexOf(v)!==-1){const E=m[v];typeof E=="object"&&!Array.isArray(E)&&(g(E,c),Object.keys(E).length===0&&delete m[v])}}function d(m,c,v){function E(s,r){let i=s;for(const o of r){if(typeof i!="object"||i===null)return;i=i[o]}return i}const a=c.split("."),t=E(m,a);return typeof t>"u"?v:t}function y(m,c,v){Object.keys(c).forEach(E=>{E!=="__proto__"&&(E in m?n.isObject(m[E])&&n.isObject(c[E])?y(m[E],c[E],v):v&&(m[E]=c[E]):m[E]=c[E])})}function w(m){return m.replace(/[\[\]]/g,"")}}),define(se[118],oe([0,1,4,25,200,6,166,15]),function(Q,e,n,R,I,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=l,e.validateWhenClauses=s,e.expressionsAreEqualWithConstantSubstitution=r,e.implies=ae;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",n.isMacintosh),h.set("isLinux",n.isLinux),h.set("isWindows",n.isWindows),h.set("isWeb",n.isWeb),h.set("isMacNative",n.isMacintosh&&!n.isWeb),h.set("isEdge",n.isEdge),h.set("isFirefox",n.isFirefox),h.set("isChrome",n.isChrome),h.set("isSafari",n.isSafari);function l(X,L){if(h.get(X)!==void 0)throw(0,P.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(X,L)}const f=Object.prototype.hasOwnProperty;var S;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const b={regexParsingWithErrorRecovery:!0},g=(0,k.localize)(0,null),d=(0,k.localize)(1,null),y=(0,k.localize)(2,null),w=(0,k.localize)(3,null),m=(0,k.localize)(4,null),c=(0,k.localize)(5,null),v=(0,k.localize)(6,null),E=(0,k.localize)(7,null);class a{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(L=b){this._config=L,this._scanner=new I.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(L){if(L===""){this._parsingErrors.push({message:g,offset:0,lexeme:"",additionalInfo:d});return}this._tokens=this._scanner.reset(L).scan(),this._current=0,this._parsingErrors=[];try{const N=this._expr();if(!this._isAtEnd()){const Z=this._peek(),ne=Z.type===17?c:void 0;throw this._parsingErrors.push({message:m,offset:Z.offset,lexeme:I.Scanner.getLexeme(Z),additionalInfo:ne}),a._parseError}return N}catch(N){if(N!==a._parseError)throw N;return}}_expr(){return this._or()}_or(){const L=[this._and()];for(;this._matchOne(16);){const N=this._and();L.push(N)}return L.length===1?L[0]:t.or(...L)}_and(){const L=[this._term()];for(;this._matchOne(15);){const N=this._term();L.push(N)}return L.length===1?L[0]:t.and(...L)}_term(){if(this._matchOne(2)){const L=this._peek();switch(L.type){case 11:return this._advance(),o.INSTANCE;case 12:return this._advance(),u.INSTANCE;case 0:{this._advance();const N=this._expr();return this._consume(1,w),N?.negate()}case 17:return this._advance(),O.create(L.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",L)}}return this._primary()}_primary(){const L=this._peek();switch(L.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const N=this._expr();return this._consume(1,w),N}case 17:{const N=L.lexeme;if(this._advance(),this._matchOne(9)){const ne=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),ne.type!==10)throw this._errExpectedButGot("REGEX",ne);const K=ne.lexeme,H=K.lastIndexOf("/"),j=H===K.length-1?void 0:this._removeFlagsGY(K.substring(H+1));let q;try{q=new RegExp(K.substring(1,H),j)}catch{throw this._errExpectedButGot("REGEX",ne)}return ee.create(N,q)}switch(ne.type){case 10:case 19:{const K=[ne.lexeme];this._advance();let H=this._peek(),j=0;for(let pe=0;pe<ne.lexeme.length;pe++)ne.lexeme.charCodeAt(pe)===40?j++:ne.lexeme.charCodeAt(pe)===41&&j--;for(;!this._isAtEnd()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:j++;break;case 1:j--;break;case 10:case 18:for(let pe=0;pe<H.lexeme.length;pe++)H.lexeme.charCodeAt(pe)===40?j++:ne.lexeme.charCodeAt(pe)===41&&j--}if(j<0)break;K.push(I.Scanner.getLexeme(H)),this._advance(),H=this._peek()}const q=K.join(""),re=q.lastIndexOf("/"),he=re===q.length-1?void 0:this._removeFlagsGY(q.substring(re+1));let me;try{me=new RegExp(q.substring(1,re),he)}catch{throw this._errExpectedButGot("REGEX",ne)}return t.regex(N,me)}case 18:{const K=ne.lexeme;this._advance();let H=null;if(!(0,R.isFalsyOrWhitespace)(K)){const j=K.indexOf("/"),q=K.lastIndexOf("/");if(j!==q&&j>=0){const re=K.slice(j+1,q),he=K[q+1]==="i"?"i":"";try{H=new RegExp(re,he)}catch{throw this._errExpectedButGot("REGEX",ne)}}}if(H===null)throw this._errExpectedButGot("REGEX",ne);return ee.create(N,H)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,y);const ne=this._value();return t.notIn(N,ne)}switch(this._peek().type){case 3:{this._advance();const ne=this._value();if(this._previous().type===18)return t.equals(N,ne);switch(ne){case"true":return t.has(N);case"false":return t.not(N);default:return t.equals(N,ne)}}case 4:{this._advance();const ne=this._value();if(this._previous().type===18)return t.notEquals(N,ne);switch(ne){case"true":return t.not(N);case"false":return t.has(N);default:return t.notEquals(N,ne)}}case 5:return this._advance(),z.create(N,this._value());case 6:return this._advance(),ue.create(N,this._value());case 7:return this._advance(),F.create(N,this._value());case 8:return this._advance(),x.create(N,this._value());case 13:return this._advance(),t.in(N,this._value());default:return t.has(N)}}case 20:throw this._parsingErrors.push({message:v,offset:L.offset,lexeme:"",additionalInfo:E}),a._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const L=this._peek();switch(L.type){case 17:case 18:return this._advance(),L.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(L){return L.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(L){return this._check(L)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(L,N){if(this._check(L))return this._advance();throw this._errExpectedButGot(N,this._peek())}_errExpectedButGot(L,N,Z){const ne=(0,k.localize)(8,null,L,I.Scanner.getLexeme(N)),K=N.offset,H=I.Scanner.getLexeme(N);return this._parsingErrors.push({message:ne,offset:K,lexeme:H,additionalInfo:Z}),a._parseError}_check(L){return this._peek().type===L}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=a;class t{static false(){return o.INSTANCE}static true(){return u.INSTANCE}static has(L){return p.create(L)}static equals(L,N){return C.create(L,N)}static notEquals(L,N){return W.create(L,N)}static regex(L,N){return ee.create(L,N)}static in(L,N){return M.create(L,N)}static notIn(L,N){return D.create(L,N)}static not(L){return O.create(L)}static and(...L){return G.create(L,null,!0)}static or(...L){return B.create(L,null,!0)}static greater(L,N){return F.create(L,N)}static greaterEquals(L,N){return x.create(L,N)}static smaller(L,N){return z.create(L,N)}static smallerEquals(L,N){return ue.create(L,N)}static{this._parser=new a({regexParsingWithErrorRecovery:!1})}static deserialize(L){return L==null?void 0:this._parser.parse(L)}}e.ContextKeyExpr=t;function s(X){const L=new a({regexParsingWithErrorRecovery:!1});return X.map(N=>(L.parse(N),L.lexingErrors.length>0?L.lexingErrors.map(Z=>({errorMessage:Z.additionalInfo?(0,k.localize)(9,null,Z.additionalInfo):(0,k.localize)(10,null),offset:Z.offset,length:Z.lexeme.length})):L.parsingErrors.length>0?L.parsingErrors.map(Z=>({errorMessage:Z.additionalInfo?`${Z.message}. ${Z.additionalInfo}`:Z.message,offset:Z.offset,length:Z.lexeme.length})):[]))}function r(X,L){const N=X?X.substituteConstants():void 0,Z=L?L.substituteConstants():void 0;return!N&&!Z?!0:!N||!Z?!1:N.equals(Z)}function i(X,L){return X.cmp(L)}class o{static{this.INSTANCE=new o}constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return u.INSTANCE}}e.ContextKeyFalseExpr=o;class u{static{this.INSTANCE=new u}constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return o.INSTANCE}}e.ContextKeyTrueExpr=u;class p{static create(L,N=null){const Z=h.get(L);return typeof Z=="boolean"?Z?u.INSTANCE:o.INSTANCE:new p(L,N)}constructor(L,N){this.key=L,this.negated=N,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:U(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=h.get(this.key);return typeof L=="boolean"?L?u.INSTANCE:o.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.negated||(this.negated=O.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=p;class C{static create(L,N,Z=null){if(typeof N=="boolean")return N?p.create(L,Z):O.create(L,Z);const ne=h.get(L);return typeof ne=="boolean"?N===(ne?"true":"false")?u.INSTANCE:o.INSTANCE:new C(L,N,Z)}constructor(L,N,Z){this.key=L,this.value=N,this.negated=Z,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:$(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=h.get(this.key);if(typeof L=="boolean"){const N=L?"true":"false";return this.value===N?u.INSTANCE:o.INSTANCE}return this}evaluate(L){return L.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(L){return L.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=W.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=C;class M{static create(L,N){return new M(L,N)}constructor(L,N){this.key=L,this.valueKey=N,this.type=10,this.negated=null}cmp(L){return L.type!==this.type?this.type-L.type:$(this.key,this.valueKey,L.key,L.valueKey)}equals(L){return L.type===this.type?this.key===L.key&&this.valueKey===L.valueKey:!1}substituteConstants(){return this}evaluate(L){const N=L.getValue(this.valueKey),Z=L.getValue(this.key);return Array.isArray(N)?N.includes(Z):typeof Z=="string"&&typeof N=="object"&&N!==null?f.call(N,Z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(L){return L.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=D.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=M;class D{static create(L,N){return new D(L,N)}constructor(L,N){this.key=L,this.valueKey=N,this.type=11,this._negated=M.create(L,N)}cmp(L){return L.type!==this.type?this.type-L.type:this._negated.cmp(L._negated)}equals(L){return L.type===this.type?this._negated.equals(L._negated):!1}substituteConstants(){return this}evaluate(L){return!this._negated.evaluate(L)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(L){return L.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=D;class W{static create(L,N,Z=null){if(typeof N=="boolean")return N?O.create(L,Z):p.create(L,Z);const ne=h.get(L);return typeof ne=="boolean"?N===(ne?"true":"false")?o.INSTANCE:u.INSTANCE:new W(L,N,Z)}constructor(L,N,Z){this.key=L,this.value=N,this.negated=Z,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:$(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=h.get(this.key);if(typeof L=="boolean"){const N=L?"true":"false";return this.value===N?o.INSTANCE:u.INSTANCE}return this}evaluate(L){return L.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(L){return L.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=W;class O{static create(L,N=null){const Z=h.get(L);return typeof Z=="boolean"?Z?o.INSTANCE:u.INSTANCE:new O(L,N)}constructor(L,N){this.key=L,this.negated=N,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:U(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=h.get(this.key);return typeof L=="boolean"?L?o.INSTANCE:u.INSTANCE:this}evaluate(L){return!L.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(L){return L.mapNot(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=O;function _(X,L){if(typeof X=="string"){const N=parseFloat(X);isNaN(N)||(X=N)}return typeof X=="string"||typeof X=="number"?L(X):o.INSTANCE}class F{static create(L,N,Z=null){return _(N,ne=>new F(L,ne,Z))}constructor(L,N,Z){this.key=L,this.value=N,this.negated=Z,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:$(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=ue.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=F;class x{static create(L,N,Z=null){return _(N,ne=>new x(L,ne,Z))}constructor(L,N,Z){this.key=L,this.value=N,this.negated=Z,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:$(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=z.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=x;class z{static create(L,N,Z=null){return _(N,ne=>new z(L,ne,Z))}constructor(L,N,Z){this.key=L,this.value=N,this.negated=Z,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:$(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=z;class ue{static create(L,N,Z=null){return _(N,ne=>new ue(L,ne,Z))}constructor(L,N,Z){this.key=L,this.value=N,this.negated=Z,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:$(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=ue;class ee{static create(L,N){return new ee(L,N)}constructor(L,N){this.key=L,this.regexp=N,this.type=7,this.negated=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.key<L.key)return-1;if(this.key>L.key)return 1;const N=this.regexp?this.regexp.source:"",Z=L.regexp?L.regexp.source:"";return N<Z?-1:N>Z?1:0}equals(L){if(L.type===this.type){const N=this.regexp?this.regexp.source:"",Z=L.regexp?L.regexp.source:"";return this.key===L.key&&N===Z}return!1}substituteConstants(){return this}evaluate(L){const N=L.getValue(this.key);return this.regexp?this.regexp.test(N):!1}serialize(){const L=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${L}`}keys(){return[this.key]}map(L){return L.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=le.create(this)),this.negated}}e.ContextKeyRegexExpr=ee;class le{static create(L){return new le(L)}constructor(L){this._actual=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(L){return new le(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=le;function Y(X){let L=null;for(let N=0,Z=X.length;N<Z;N++){const ne=X[N].substituteConstants();if(X[N]!==ne&&L===null){L=[];for(let K=0;K<N;K++)L[K]=X[K]}L!==null&&(L[N]=ne)}return L===null?X:L}class G{static create(L,N,Z){return G._normalizeArr(L,N,Z)}constructor(L,N){this.expr=L,this.negated=N,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let N=0,Z=this.expr.length;N<Z;N++){const ne=i(this.expr[N],L.expr[N]);if(ne!==0)return ne}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let N=0,Z=this.expr.length;N<Z;N++)if(!this.expr[N].equals(L.expr[N]))return!1;return!0}return!1}substituteConstants(){const L=Y(this.expr);return L===this.expr?this:G.create(L,this.negated,!1)}evaluate(L){for(let N=0,Z=this.expr.length;N<Z;N++)if(!this.expr[N].evaluate(L))return!1;return!0}static _normalizeArr(L,N,Z){const ne=[];let K=!1;for(const H of L)if(H){if(H.type===1){K=!0;continue}if(H.type===0)return o.INSTANCE;if(H.type===6){ne.push(...H.expr);continue}ne.push(H)}if(ne.length===0&&K)return u.INSTANCE;if(ne.length!==0){if(ne.length===1)return ne[0];ne.sort(i);for(let H=1;H<ne.length;H++)ne[H-1].equals(ne[H])&&(ne.splice(H,1),H--);if(ne.length===1)return ne[0];for(;ne.length>1;){const H=ne[ne.length-1];if(H.type!==9)break;ne.pop();const j=ne.pop(),q=ne.length===0,re=B.create(H.expr.map(he=>G.create([he,j],null,Z)),null,q);re&&(ne.push(re),ne.sort(i))}if(ne.length===1)return ne[0];if(Z){for(let H=0;H<ne.length;H++)for(let j=H+1;j<ne.length;j++)if(ne[H].negate().equals(ne[j]))return o.INSTANCE;if(ne.length===1)return ne[0]}return new G(ne,N)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const N of this.expr)L.push(...N.keys());return L}map(L){return new G(this.expr.map(N=>N.map(L)),null)}negate(){if(!this.negated){const L=[];for(const N of this.expr)L.push(N.negate());this.negated=B.create(L,this,!0)}return this.negated}}e.ContextKeyAndExpr=G;class B{static create(L,N,Z){return B._normalizeArr(L,N,Z)}constructor(L,N){this.expr=L,this.negated=N,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let N=0,Z=this.expr.length;N<Z;N++){const ne=i(this.expr[N],L.expr[N]);if(ne!==0)return ne}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let N=0,Z=this.expr.length;N<Z;N++)if(!this.expr[N].equals(L.expr[N]))return!1;return!0}return!1}substituteConstants(){const L=Y(this.expr);return L===this.expr?this:B.create(L,this.negated,!1)}evaluate(L){for(let N=0,Z=this.expr.length;N<Z;N++)if(this.expr[N].evaluate(L))return!0;return!1}static _normalizeArr(L,N,Z){let ne=[],K=!1;if(L){for(let H=0,j=L.length;H<j;H++){const q=L[H];if(q){if(q.type===0){K=!0;continue}if(q.type===1)return u.INSTANCE;if(q.type===9){ne=ne.concat(q.expr);continue}ne.push(q)}}if(ne.length===0&&K)return o.INSTANCE;ne.sort(i)}if(ne.length!==0){if(ne.length===1)return ne[0];for(let H=1;H<ne.length;H++)ne[H-1].equals(ne[H])&&(ne.splice(H,1),H--);if(ne.length===1)return ne[0];if(Z){for(let H=0;H<ne.length;H++)for(let j=H+1;j<ne.length;j++)if(ne[H].negate().equals(ne[j]))return u.INSTANCE;if(ne.length===1)return ne[0]}return new B(ne,N)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const N of this.expr)L.push(...N.keys());return L}map(L){return new B(this.expr.map(N=>N.map(L)),null)}negate(){if(!this.negated){const L=[];for(const N of this.expr)L.push(N.negate());for(;L.length>1;){const N=L.shift(),Z=L.shift(),ne=[];for(const K of ce(N))for(const H of ce(Z))ne.push(G.create([K,H],null,!1));L.unshift(B.create(ne,null,!1))}this.negated=B.create(L,this,!0)}return this.negated}}e.ContextKeyOrExpr=B;class T extends p{static{this._info=[]}static all(){return T._info.values()}constructor(L,N,Z){super(L,null),this._defaultValue=N,typeof Z=="object"?T._info.push({...Z,key:L}):Z!==!0&&T._info.push({key:L,description:Z,type:N!=null?typeof N:void 0})}bindTo(L){return L.createKey(this.key,this._defaultValue)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return C.create(this.key,L)}notEqualsTo(L){return W.create(this.key,L)}}e.RawContextKey=T,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function U(X,L){return X<L?-1:X>L?1:0}function $(X,L,N,Z){return X<N?-1:X>N?1:L<Z?-1:L>Z?1:0}function ae(X,L){if(X.type===0||L.type===1)return!0;if(X.type===9)return L.type===9?V(X.expr,L.expr):!1;if(L.type===9){for(const N of L.expr)if(ae(X,N))return!0;return!1}if(X.type===6){if(L.type===6)return V(L.expr,X.expr);for(const N of X.expr)if(ae(N,L))return!0;return!1}return X.equals(L)}function V(X,L){let N=0,Z=0;for(;N<X.length&&Z<L.length;){const ne=X[N].cmp(L[Z]);if(ne<0)return!1;ne===0&&N++,Z++}return N===X.length}function ce(X){return X.type===9?X.expr:[X]}}),define(se[92],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.IDiagnosticsService=e.ID=void 0,e.isRemoteDiagnosticError=R,e.ID="diagnosticsService",e.IDiagnosticsService=(0,n.createDecorator)(e.ID);function R(A){return!!A.hostName&&!!A.errorMessage}class I{async getPerformanceInfo(k,P){return{}}async getSystemInfo(k,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,P){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}e.NullDiagnosticsService=I}),define(se[119],oe([0,1,19,74,168,6,48,4,35]),function(Q,e,n,R,I,A,k,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.getFileNamesMessage=g,e.massageMessageBoxOptions=d,e.IDialogService=(0,A.createDecorator)("dialogService");var l;(function(y){y[y.Confirmation=1]="Confirmation",y[y.Prompt=2]="Prompt",y[y.Input=3]="Input"})(l||(l={}));class f{getConfirmationButtons(w){return this.getButtons(w,l.Confirmation)}getPromptButtons(w){return this.getButtons(w,l.Prompt)}getInputButtons(w){return this.getButtons(w,l.Input)}getButtons(w,m){const c=[];switch(m){case l.Confirmation:{const v=w;v.primaryButton?c.push(v.primaryButton):c.push((0,I.localize)(0,null)),v.cancelButton?c.push(v.cancelButton):c.push((0,I.localize)(1,null));break}case l.Prompt:{const v=w;Array.isArray(v.buttons)&&v.buttons.length>0&&c.push(...v.buttons.map(E=>E.label)),v.cancelButton&&(v.cancelButton===!0?c.push((0,I.localize)(2,null)):typeof v.cancelButton=="string"?c.push(v.cancelButton):v.cancelButton.label?c.push(v.cancelButton.label):c.push((0,I.localize)(3,null))),c.length===0&&c.push((0,I.localize)(4,null));break}case l.Input:{const v=w;v.primaryButton?c.push(v.primaryButton):c.push((0,I.localize)(5,null)),v.cancelButton?c.push(v.cancelButton):c.push((0,I.localize)(6,null));break}}return c}getDialogType(w){if(typeof w=="string")return w;if(typeof w=="number")return w===R.default.Info?"info":w===R.default.Error?"error":w===R.default.Warning?"warning":"none"}getPromptResult(w,m,c){const v=[...w.buttons??[]];w.cancelButton&&typeof w.cancelButton!="string"&&typeof w.cancelButton!="boolean"&&v.push(w.cancelButton);let E=v[m]?.run({checkboxChecked:c});return E instanceof Promise||(E=Promise.resolve(E)),{result:E,checkboxChecked:c}}}e.AbstractDialogHandler=f,e.IFileDialogService=(0,A.createDecorator)("fileDialogService");var S;(function(y){y[y.SAVE=0]="SAVE",y[y.DONT_SAVE=1]="DONT_SAVE",y[y.CANCEL=2]="CANCEL"})(S||(e.ConfirmResult=S={}));const b=10;function g(y){const w=[];return w.push(...y.slice(0,b).map(m=>typeof m=="string"?m:(0,n.basename)(m))),y.length>b&&(y.length-b===1?w.push((0,I.localize)(7,null)):w.push((0,I.localize)(8,null,y.length-b))),w.push(""),w.join(`
`)}function d(y,w){const m=(0,h.deepClone)(y);let c=(m.buttons??[]).map(t=>(0,k.mnemonicButtonLabel)(t)),v=(y.buttons||[]).map((t,s)=>s),E=0,a=m.cancelId??c.length-1;if(c.length>1){const t=typeof a=="number"?c[a]:void 0;if(P.isLinux||P.isMacintosh){if(typeof t=="string"&&c.length>1&&a!==1){c.splice(a,1),c.splice(1,0,t);const s=v[a];v.splice(a,1),v.splice(1,0,s),a=1}P.isLinux&&c.length>1&&(c=c.reverse(),v=v.reverse(),E=c.length-1,typeof t=="string"&&(a=E-1))}else if(P.isWindows&&typeof t=="string"&&c.length>1&&a!==c.length-1){c.splice(a,1),c.push(t);const s=v[a];v.splice(a,1),v.push(s),a=c.length-1}}return m.buttons=c,m.defaultId=E,m.cancelId=a,m.noLink=!0,m.title=m.title||w.nameLong,{options:m,buttonIndeces:v}}}),define(se[120],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.IEncryptionMainService=e.IEncryptionService=void 0,e.isKwallet=A,e.isGnome=k,e.IEncryptionService=(0,n.createDecorator)("encryptionService"),e.IEncryptionMainService=(0,n.createDecorator)("encryptionMainService");var R;(function(P){P.kwallet="kwallet",P.kwallet5="kwallet5",P.gnomeLibsecret="gnome-libsecret",P.basic="basic"})(R||(e.PasswordStoreCLIOption=R={}));var I;(function(P){P.unknown="unknown",P.basicText="basic_text",P.gnomeAny="gnome_any",P.gnomeLibsecret="gnome_libsecret",P.gnomeKeyring="gnome_keyring",P.kwallet="kwallet",P.kwallet5="kwallet5",P.kwallet6="kwallet6",P.dplib="dpapi",P.keychainAccess="keychain_access"})(I||(e.KnownStorageProvider=I={}));function A(P){return P==="kwallet"||P==="kwallet5"||P==="kwallet6"}function k(P){return P==="gnome_any"||P==="gnome_libsecret"||P==="gnome_keyring"}}),define(se[38],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,n.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,n.refineServiceDecorator)(e.IEnvironmentService)}),define(se[121],oe([0,1,172,6]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=I,e.toTargetPlatform=A,e.getTargetPlatform=k,e.isNotWebExtensionInWebTargetPlatform=P,e.isTargetPlatformCompatible=h,e.isIExtensionIdentifier=l,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function I(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PowerPC";case"linux-riscv64":return"Linux RISC-V 64";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function A(c){switch(c){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"linux-riscv64":return"linux-riscv64";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function k(c,v){switch(c){case 3:return v==="x64"?"win32-x64":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":v==="ppc64le"?"linux-ppc64le":v==="riscv64"?"linux-riscv64":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function P(c,v){return v==="web"&&!c.includes("web")}function h(c,v,E){return P(v,E)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===E}function l(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}var f;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(f||(e.SortBy=f={}));var S;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var b;(function(c){c.Install="install",c.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var g;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var d;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.DownloadSignature="DownloadSignature",c.UpdateMetadata="UpdateMetadata",c.Extract="Extract",c.Scanning="Scanning",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.NotAllowed="NotAllowed",c.Gallery="Gallery",c.Cancelled="Cancelled",c.Unknown="Unknown",c.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));class y extends Error{constructor(v,E){super(v),this.code=E,this.name=E}}e.ExtensionManagementError=y;var w;(function(c){c.Timeout="Timeout",c.Cancelled="Cancelled",c.Failed="Failed"})(w||(e.ExtensionGalleryErrorCode=w={}));class m extends Error{constructor(v,E){super(v),this.code=E,this.name=E}}e.ExtensionGalleryError=m,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,n.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,n.localize2)(1,"Preferences")}),define(se[212],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,n.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(se[213],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,n.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(se[214],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=void 0,e.IExternalTerminalMainService=(0,n.createDecorator)("externalTerminal")}),define(se[215],oe([0,1,49,51,13,9,4,76,21,90,176,213]),function(Q,e,n,R,I,A,k,P,h,l,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const b=f.localize(0,null);class g{async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends g{static{this.CMD="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(n,a,l.getWindowsShell(),t)}spawnTerminal(a,t,s,r){const i=t.windowsExec||d.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const o=A.basename(i,".exe").toLowerCase();if(o==="cmder")return a.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return i.indexOf(" ")>=0&&u.push('""'),u.push(i),o==="wt"&&u.push("-d ."),new Promise((p,C)=>{const M=m(process),D=a.spawn(s,u,{cwd:r,env:M,detached:!0});D.on("error",C),D.on("exit",()=>p())})}async runInTerminal(a,t,s,r,i){const o="windowsExec"in i&&i.windowsExec?i.windowsExec:d.getDefaultTerminalWindows(),u=await d.getWtExePath();return new Promise((p,C)=>{const M=`"${t} - ${b}"`,D=`"${s.join('" "')}" & pause`,W=Object.assign({},m(process),r);Object.keys(W).filter(z=>W[z]===null).forEach(z=>delete W[z]);const O={cwd:t,env:W,windowsVerbatimArguments:!0};let _,F;A.basename(o,".exe")==="wt"?(_=o,F=["-d",".",d.CMD,"/c",D]):u?(_=u,F=["-d",".",o,"/c",D]):(_=d.CMD,F=["/c","start",M,"/wait",o,"/c",`"${D}"`]),n.spawn(_,F,O).on("error",z=>{C(c(z))}),p(void 0)})}static getDefaultTerminalWindows(){if(!d._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return d._DEFAULT_TERMINAL_WINDOWS}static async getWtExePath(){try{const a=await l.win32.findExecutable("wt");return await h.Promises.exists(a)?a:void 0}catch{return}}}e.WindowsExternalTerminalService=d,Ie([R.memoize],d,"getWtExePath",null);class y extends g{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,s,r,i){const o=i.osxExec||S.DEFAULT_TERMINAL_OSX;return new Promise((u,p)=>{if(o===S.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const C=o===S.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",D=[I.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${C}.scpt`).fsPath,"-t",a||b,"-w",t];for(const _ of s)D.push("-a"),D.push(_);if(r){const _=Object.assign({},m(process),r);for(const F in _){const x=_[F];x===null?(D.push("-u"),D.push(F)):(D.push("-e"),D.push(`${F}=${x}`))}}let W="";const O=n.spawn(y.OSASCRIPT,D);O.on("error",_=>{p(c(_))}),O.stderr.on("data",_=>{W+=_.toString()}),O.on("exit",_=>{if(_===0)u(void 0);else if(W){const F=W.split(`
`,1);p(new Error(F[0]))}else p(new Error(f.localize(1,null,C,_)))})}else p(new Error(f.localize(2,null,o)))})}spawnTerminal(a,t,s){const r=t.osxExec||S.DEFAULT_TERMINAL_OSX;return new Promise((i,o)=>{const u=["-a",r];s&&u.push(s);const p=m(process),C=a.spawn("/usr/bin/open",u,{cwd:s,env:p});C.on("error",o),C.on("exit",()=>i())})}}e.MacExternalTerminalService=y;class w extends g{static{this.WAIT_MESSAGE=f.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,s,r,i){const o=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((u,p)=>{const C=[];o.then(M=>{M.indexOf("gnome-terminal")>=0?C.push("-x"):C.push("-e"),C.push("bash"),C.push("-c");const D=`${v(s)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;C.push(`''${D}''`);const W=Object.assign({},m(process),r);Object.keys(W).filter(x=>W[x]===null).forEach(x=>delete W[x]);const O={cwd:t,env:W};let _="";const F=n.spawn(M,C,O);F.on("error",x=>{p(c(x))}),F.stderr.on("data",x=>{_+=x.toString()}),F.on("exit",x=>{if(x===0)u(void 0);else if(_){const z=_.split(`
`,1);p(new Error(z[0]))}else p(new Error(f.localize(4,null,M,x)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!k.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await h.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,t,s){const r=t.linuxExec?Promise.resolve(t.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,o)=>{r.then(u=>{const p=m(process),C=a.spawn(u,[],{cwd:s,env:p});C.on("error",o),C.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=w;function m(E){const a={...E.env};return(0,P.sanitizeProcessEnvironment)(a),a}function c(E){return"errno"in E&&E.errno==="ENOENT"&&"path"in E&&typeof E.path=="string"?new Error(f.localize(5,null,E.path)):E}function v(E){let a="";for(const t of E)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(se[16],oe([0,1,59,9,25,12,7,178,6,4,13,62]),function(Q,e,n,R,I,A,k,P,h,l,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=b,e.isFileSystemWatcher=w,e.hasReadWriteCapability=c,e.hasFileFolderCopyCapability=v,e.hasFileCloneCapability=E,e.hasOpenReadWriteCloseCapability=a,e.hasFileReadStreamCapability=t,e.hasFileAtomicReadCapability=s,e.hasFileAtomicWriteCapability=r,e.hasFileAtomicDeleteCapability=i,e.hasReadonlyCapability=o,e.createFileSystemProviderError=C,e.ensureFileSystemProviderError=M,e.markAsFileSystemProviderError=D,e.toFileSystemProviderErrorCode=W,e.toFileOperationResult=O,e.isParent=ue,e.etag=T,e.whenProviderRegistered=U,e.getLargeFileConfirmationLimit=ae,e.IFileService=(0,h.createDecorator)("fileService");function b(V){return V.create===!0}var g;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(g||(e.FileType=g={}));var d;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var y;(function(V){V[V.UPDATED=2]="UPDATED",V[V.ADDED=4]="ADDED",V[V.DELETED=8]="DELETED"})(y||(e.FileChangeFilter=y={}));function w(V){const ce=V;return!!ce&&typeof ce.onDidChange=="function"}var m;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function c(V){return!!(V.capabilities&2)}function v(V){return!!(V.capabilities&8)}function E(V){return!!(V.capabilities&131072)}function a(V){return!!(V.capabilities&4)}function t(V){return!!(V.capabilities&16)}function s(V){return c(V)?!!(V.capabilities&16384):!1}function r(V){return c(V)?!!(V.capabilities&32768):!1}function i(V){return!!(V.capabilities&65536)}function o(V){return!!(V.capabilities&2048)}var u;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(u||(e.FileSystemProviderErrorCode=u={}));class p extends Error{static create(ce,X){const L=new p(ce.toString(),X);return D(L,X),L}constructor(ce,X){super(ce),this.code=X}}e.FileSystemProviderError=p;function C(V,ce){return p.create(V,ce)}function M(V){return V||C((0,P.localize)(0,null),u.Unknown)}function D(V,ce){return V.name=ce?`${ce} (FileSystemError)`:"FileSystemError",V}function W(V){if(!V)return u.Unknown;if(V instanceof p)return V.code;const ce=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!ce)return u.Unknown;switch(ce[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}function O(V){if(V instanceof ee)return V.fileOperationResult;switch(W(V)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 9;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileTooLarge:return 7;default:return 10}}var _;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(_||(e.FileOperation=_={}));class F{constructor(ce,X,L){this.resource=ce,this.operation=X,this.target=L}isOperation(ce){return this.operation===ce}}e.FileOperationEvent=F;var x;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(x||(e.FileChangeType=x={}));class z{static{this.MIXED_CORRELATION=null}constructor(ce,X){this.ignorePathCasing=X,this.correlationId=void 0,this.added=new S.Lazy(()=>{const L=n.TernarySearchTree.forUris(()=>this.ignorePathCasing);return L.fill(this.rawAdded.map(N=>[N,!0])),L}),this.updated=new S.Lazy(()=>{const L=n.TernarySearchTree.forUris(()=>this.ignorePathCasing);return L.fill(this.rawUpdated.map(N=>[N,!0])),L}),this.deleted=new S.Lazy(()=>{const L=n.TernarySearchTree.forUris(()=>this.ignorePathCasing);return L.fill(this.rawDeleted.map(N=>[N,!0])),L}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const L of ce){switch(L.type){case 1:this.rawAdded.push(L.resource);break;case 0:this.rawUpdated.push(L.resource);break;case 2:this.rawDeleted.push(L.resource);break}this.correlationId!==z.MIXED_CORRELATION&&(typeof L.cId=="number"?this.correlationId===void 0?this.correlationId=L.cId:this.correlationId!==L.cId&&(this.correlationId=z.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=z.MIXED_CORRELATION))}}contains(ce,...X){return this.doContains(ce,{includeChildren:!1},...X)}affects(ce,...X){return this.doContains(ce,{includeChildren:!0},...X)}doContains(ce,X,...L){if(!ce)return!1;const N=L.length>0;return!!((!N||L.includes(1))&&(this.added.value.get(ce)||X.includeChildren&&this.added.value.findSuperstr(ce))||(!N||L.includes(0))&&(this.updated.value.get(ce)||X.includeChildren&&this.updated.value.findSuperstr(ce))||(!N||L.includes(2))&&(this.deleted.value.findSubstr(ce)||X.includeChildren&&this.deleted.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.correlationId===ce}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=z;function ue(V,ce,X){return!V||!ce||V===ce||ce.length>V.length?!1:(ce.charAt(ce.length-1)!==R.sep&&(ce+=R.sep),X?(0,I.startsWithIgnoreCase)(V,ce):V.indexOf(ce)===0)}class ee extends Error{constructor(ce,X,L){super(ce),this.fileOperationResult=X,this.options=L}}e.FileOperationError=ee;class le extends ee{constructor(ce,X,L,N){super(ce,X,N),this.fileOperationResult=X,this.size=L}}e.TooLargeFileOperationError=le;class Y extends ee{constructor(ce,X,L){super(ce,2,L),this.stat=X}}e.NotModifiedSinceFileOperationError=Y;var G;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(G||(e.FileOperationResult=G={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var B;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(B||(e.FileKind=B={})),e.ETAG_DISABLED="";function T(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}async function U(V,ce){if(!ce.hasProvider(k.URI.from({scheme:V.scheme})))return new Promise(X=>{const L=ce.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===V.scheme&&N.added&&(L.dispose(),X())})})}class ${static{this.KB=1024}static{this.MB=$.KB*$.KB}static{this.GB=$.MB*$.KB}static{this.TB=$.GB*$.KB}static formatSize(ce){return(0,A.isNumber)(ce)||(ce=0),ce<$.KB?(0,P.localize)(1,null,ce.toFixed(0)):ce<$.MB?(0,P.localize)(2,null,(ce/$.KB).toFixed(2)):ce<$.GB?(0,P.localize)(3,null,(ce/$.MB).toFixed(2)):ce<$.TB?(0,P.localize)(4,null,(ce/$.GB).toFixed(2)):(0,P.localize)(5,null,(ce/$.TB).toFixed(2))}}e.ByteSize=$;function ae(V){const ce=typeof V=="string"||V?.scheme===f.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===f.Schemas.file?1024*$.MB:ce?10*$.MB:l.isWeb?50*$.MB:1024*$.MB}}),define(se[122],oe([0,1,17,15,179,16]),function(Q,e,n,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=k;async function k(f,S,b,g,d,y){let w;try{await P(f,S,b,g,d,y)}catch(m){w=m}finally{w&&d.errorTransformer&&(w=d.errorTransformer(w)),typeof w<"u"&&b.error(w),b.end()}}async function P(f,S,b,g,d,y){h(y);const w=await f.open(S,{create:!1});try{h(y);let m=0,c=0,v=d&&typeof d.length=="number"?d.length:void 0,E=n.VSBuffer.alloc(Math.min(d.bufferSize,typeof v=="number"?v:d.bufferSize)),a=d&&typeof d.position=="number"?d.position:0,t=0;do c=await f.read(w,a,E.buffer,t,E.byteLength-t),a+=c,t+=c,m+=c,typeof v=="number"&&(v-=c),t===E.byteLength&&(await b.write(g(E)),E=n.VSBuffer.alloc(Math.min(d.bufferSize,typeof v=="number"?v:d.bufferSize)),t=0);while(c>0&&(typeof v!="number"||v>0)&&h(y)&&l(m,d));if(t>0){let s=t;typeof v=="number"&&(s=Math.min(t,v)),b.write(g(E.slice(0,s)))}}catch(m){throw(0,A.ensureFileSystemProviderError)(m)}finally{await f.close(w)}}function h(f){if(f.isCancellationRequested)throw(0,R.canceled)();return!0}function l(f,S){if(typeof S?.limits?.size=="number"&&f>S.limits.size)throw(0,A.createFileSystemProviderError)((0,I.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(se[60],oe([0,1,108,2,9,4,7,16]),function(Q,e,n,R,I,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=h,e.isRecursiveWatchRequest=l,e.reviveFileChanges=g,e.coalesceEvents=d,e.normalizeWatcherPattern=y,e.parseWatcherPatterns=w,e.isFiltered=c,e.requestFilterToString=v;function h(E){return typeof E.correlationId=="number"}function l(E){return E.recursive===!0}class f extends R.Disposable{static{this.MAX_RESTARTS=5}constructor(a,t,s,r){super(),this.onFileChanges=a,this.onLogMessage=t,this.verboseLogging=s,this.options=r,this.watcherDisposables=this._register(new R.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const a=new R.DisposableStore;this.watcherDisposables.value=a,this.watcher=this.createWatcher(a),this.watcher.setVerboseLogging(this.verboseLogging),a.add(this.watcher.onDidChangeFile(t=>this.onFileChanges(t))),a.add(this.watcher.onDidLogMessage(t=>this.onLogMessage(t))),a.add(this.watcher.onDidError(t=>this.onError(t)))}onError(a){this.options.restartOnError?this.restartCounter<f.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${a}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${a}`):this.error(a)}restart(a){this.restartCounter++,this.init(),this.watch(a)}async watch(a){this.requests=a,await this.watcher?.watch(a)}async setVerboseLogging(a){this.verboseLogging=a,await this.watcher?.setVerboseLogging(a)}error(a){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${a}`})}trace(a){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${a}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=f;class S extends f{constructor(a,t,s){super(a,t,s,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=S;class b extends f{constructor(a,t,s){super(a,t,s,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function g(E){return E.map(a=>({type:a.type,resource:k.URI.revive(a.resource),cId:a.cId}))}function d(E){const a=new m;for(const t of E)a.processEvent(t);return a.coalesce()}function y(E,a){return typeof a=="string"&&!a.startsWith(n.GLOBSTAR)&&!(0,I.isAbsolute)(a)?{base:E,pattern:a}:a}function w(E,a){const t=[];for(const s of a)t.push((0,n.parse)(y(E,s)));return t}class m{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(a){return A.isLinux?a.resource.fsPath:a.resource.fsPath.toLowerCase()}processEvent(a){const t=this.mapPathToChange.get(this.toKey(a));let s=!1;if(t){const r=t.type,i=a.type;t.resource.fsPath!==a.resource.fsPath&&(a.type===2||a.type===1)?s=!0:r===1&&i===2?(this.mapPathToChange.delete(this.toKey(a)),this.coalesced.delete(t)):r===2&&i===1?t.type=0:r===1&&i===0||(t.type=i)}else s=!0;s&&(this.coalesced.add(a),this.mapPathToChange.set(this.toKey(a),a))}coalesce(){const a=[],t=[];return Array.from(this.coalesced).filter(s=>s.type!==2?(a.push(s),!1):!0).sort((s,r)=>s.resource.fsPath.length-r.resource.fsPath.length).filter(s=>t.some(r=>(0,P.isParent)(s.resource.fsPath,r,!A.isLinux))?!1:(t.push(s.resource.fsPath),!0)).concat(a)}}function c(E,a){if(typeof a=="number")switch(E.type){case 1:return(a&4)===0;case 2:return(a&8)===0;case 0:return(a&2)===0}return!1}function v(E){if(typeof E=="number"){const a=[];return E&4&&a.push("Added"),E&8&&a.push("Deleted"),E&2&&a.push("Updated"),a.length===0?"<all>":`[${a.join(", ")}]`}return"<none>"}}),define(se[216],oe([0,1,17,47,15,3,2,63,33,16,60]),function(Q,e,n,R,I,A,k,P,h,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class S extends k.Disposable{constructor(g,d){super(),this.channel=g,this.extraCapabilities=d,this.onDidChangeCapabilities=A.Event.None,this._onDidChange=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,h.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(g){return this.channel.call("stat",[g])}readdir(g){return this.channel.call("readdir",[g])}async readFile(g,d){const{buffer:y}=await this.channel.call("readFile",[g,d]);return y}readFileStream(g,d,y){const w=(0,P.newWriteableStream)(c=>n.VSBuffer.concat(c.map(v=>n.VSBuffer.wrap(v))).buffer),m=new k.DisposableStore;return m.add(this.channel.listen("readFileStream",[g,d])(c=>{if(c instanceof n.VSBuffer)w.write(c.buffer);else{if(c==="end")w.end();else{let v;if(c instanceof Error)v=c;else{const E=c;v=(0,l.createFileSystemProviderError)(E.message??(0,R.toErrorMessage)(E),E.code??l.FileSystemProviderErrorCode.Unknown)}w.error(v),w.end()}m.dispose()}})),m.add(y.onCancellationRequested(()=>{w.error((0,I.canceled)()),w.end(),m.dispose()})),w}writeFile(g,d,y){return this.channel.call("writeFile",[g,n.VSBuffer.wrap(d),y])}open(g,d){return this.channel.call("open",[g,d])}close(g){return this.channel.call("close",[g])}async read(g,d,y,w,m){const[c,v]=await this.channel.call("read",[g,d,m]);return y.set(c.buffer.slice(0,v),w),v}write(g,d,y,w,m){return this.channel.call("write",[g,d,n.VSBuffer.wrap(y),w,m])}mkdir(g){return this.channel.call("mkdir",[g])}delete(g,d){return this.channel.call("delete",[g,d])}rename(g,d,y){return this.channel.call("rename",[g,d,y])}copy(g,d,y){return this.channel.call("copy",[g,d,y])}cloneFile(g,d){return this.channel.call("cloneFile",[g,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(g=>{if(Array.isArray(g)){const d=g;this._onDidChange.fire((0,f.reviveFileChanges)(d))}else{const d=g;this._onDidWatchError.fire(d)}}))}watch(g,d){const y=(0,h.generateUuid)();return this.channel.call("watch",[this.sessionId,y,g,d]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,y]))}}e.DiskFileSystemProviderClient=S}),define(se[217],oe([0,1,43,2,60,3,7,8]),function(Q,e,n,R,I,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class h extends R.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new A.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new A.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new R.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new P.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(f=>this.handleDidWatchFail(f)))}handleDidWatchFail(f){this.isCorrelated(f)&&this.suspendWatchRequest(f)}isCorrelated(f){return(0,I.isWatchRequestWithCorrelation)(f)}async watch(f){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new P.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const S of f)this.isCorrelated(S)?this.allCorrelatedWatchRequests.set(S.correlationId,S):this.allNonCorrelatedWatchRequests.add(S);for(const[S]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(S)||(this.suspendedWatchRequests.deleteAndDispose(S),this.suspendedWatchRequestsWithPolling.delete(S));return await this.updateWatchers()}finally{this.joinWatch.complete()}}updateWatchers(){return this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(f=>!this.suspendedWatchRequests.has(f.correlationId))])}isSuspended(f){return typeof f.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(f.correlationId)?"polling":this.suspendedWatchRequests.has(f.correlationId)}async suspendWatchRequest(f){if(this.suspendedWatchRequests.has(f.correlationId))return;const S=new R.DisposableStore;this.suspendedWatchRequests.set(f.correlationId,S),await this.joinWatch.p,!S.isDisposed&&(this.monitorSuspendedWatchRequest(f,S),this.updateWatchers())}resumeWatchRequest(f){this.suspendedWatchRequests.deleteAndDispose(f.correlationId),this.suspendedWatchRequestsWithPolling.delete(f.correlationId),this.updateWatchers()}monitorSuspendedWatchRequest(f,S){this.doMonitorWithExistingWatcher(f,S)?(this.trace(`reusing an existing recursive watcher to monitor ${f.path}`),this.suspendedWatchRequestsWithPolling.delete(f.correlationId)):(this.doMonitorWithNodeJS(f,S),this.suspendedWatchRequestsWithPolling.add(f.correlationId))}doMonitorWithExistingWatcher(f,S){const b=this.recursiveWatcher?.subscribe(f.path,(g,d)=>{S.isDisposed||(g?this.monitorSuspendedWatchRequest(f,S):d?.type===1&&this.onMonitoredPathAdded(f))});return b?(S.add(b),!0):!1}doMonitorWithNodeJS(f,S){let b=!1;const g=(d,y)=>{if(S.isDisposed)return;const w=this.isPathNotFound(d),m=this.isPathNotFound(y),c=b;b=w,!w&&(m||c)&&this.onMonitoredPathAdded(f)};this.trace(`starting fs.watchFile() on ${f.path} (correlationId: ${f.correlationId})`);try{(0,n.watchFile)(f.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},g)}catch(d){this.warn(`fs.watchFile() failed with error ${d} on path ${f.path} (correlationId: ${f.correlationId})`)}S.add((0,R.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${f.path} (correlationId: ${f.correlationId})`);try{(0,n.unwatchFile)(f.path,g)}catch(d){this.warn(`fs.unwatchFile() failed with error ${d} on path ${f.path} (correlationId: ${f.correlationId})`)}}))}onMonitoredPathAdded(f){this.trace(`detected ${f.path} exists again, resuming watcher (correlationId: ${f.correlationId})`);const S={resource:k.URI.file(f.path),type:1,cId:f.correlationId};this._onDidChangeFile.fire([S]),this.traceEvent(S,f),this.resumeWatchRequest(f)}isPathNotFound(f){return f.ctimeMs===0&&f.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(f,S){if(this.verboseLogging){const b=` >> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`;this.traceWithCorrelation(b,S)}}traceWithCorrelation(f,S){this.verboseLogging&&this.trace(`${f}${typeof S.correlationId=="number"?` <${S.correlationId}> `:""}`)}requestToString(f){return`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, filter: ${(0,I.requestFilterToString)(f.filter)}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`}async setVerboseLogging(f){this.verboseLogging=f}}e.BaseWatcher=h}),define(se[218],oe([0,1,43,8,23,31,2,72,9,4,19,7,109,21,60]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=w;class y extends k.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}get isReusingRecursiveWatcher(){return this._isReusingRecursiveWatcher}get failed(){return this.didFail}constructor(c,v,E,a,t,s){super(),this.request=c,this.recursiveWatcher=v,this.onDidFilesChange=E,this.onDidWatchFail=a,this.onLogMessage=t,this.verboseLogging=s,this.throttledFileChangesEmitter=this._register(new R.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},r=>this.onDidFilesChange(r))),this.fileChangesAggregator=this._register(new R.RunOnceWorker(r=>this.handleFileChanges(r),y.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,d.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,d.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.filter=(0,d.isWatchRequestWithCorrelation)(this.request)?this.request.filter:void 0,this.cts=new I.CancellationTokenSource,this.ready=this.watch(),this._isReusingRecursiveWatcher=!1,this.didFail=!1}async watch(){try{const c=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const v=await g.Promises.stat(c);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(c,v.isDirectory()))}catch(c){c.code!=="ENOENT"?this.error(c):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${c})`),this.notifyWatchFailed()}}notifyWatchFailed(){this.didFail=!0,this.onDidWatchFail?.()}async normalizePath(c){let v=c.path;try{v=await g.Promises.realpath(c.path),c.path===v&&(v=await(0,b.realcase)(c.path,this.cts.token)??c.path),c.path!==v&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${v})`)}catch{}return v}async doWatch(c,v){const E=new k.DisposableStore;return this.doWatchWithExistingWatcher(c,v,E)?(this.trace(`reusing an existing recursive watcher for ${this.request.path}`),this._isReusingRecursiveWatcher=!0):(this._isReusingRecursiveWatcher=!1,await this.doWatchWithNodeJS(c,v,E)),E}doWatchWithExistingWatcher(c,v,E){if(v)return!1;const a=S.URI.file(this.request.path),t=this.recursiveWatcher?.subscribe(this.request.path,async(s,r)=>{if(!E.isDisposed)if(s){const i=await this.doWatch(c,v);E.isDisposed?i.dispose():E.add(i)}else r&&(typeof r.cId=="number"||typeof this.request.correlationId=="number")&&this.onFileChange({resource:a,type:r.type,cId:this.request.correlationId},!0)});return t?(E.add(t),!0):!1}async doWatchWithNodeJS(c,v,E){if(l.isMacintosh&&(0,A.isEqualOrParent)(c,"/Volumes/",!0)){this.error(`Refusing to watch ${c} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const a=new I.CancellationTokenSource(this.cts.token);E.add((0,k.toDisposable)(()=>a.dispose(!0)));const t=new k.DisposableStore;E.add(t);try{const s=S.URI.file(this.request.path),r=(0,h.basename)(c),i=(0,n.watch)(c);t.add((0,k.toDisposable)(()=>{i.removeAllListeners(),i.close()})),this.trace(`Started watching: '${c}'`);const o=new Set;if(v)try{for(const p of await g.Promises.readdir(c))o.add(p)}catch(p){this.error(p)}if(a.token.isCancellationRequested)return;const u=new Map;t.add((0,k.toDisposable)(()=>{for(const[,p]of u)p.dispose();u.clear()})),i.on("error",(p,C)=>{a.token.isCancellationRequested||(this.error(`Failed to watch ${c} for changes using fs.watch() (${p}, ${C})`),this.notifyWatchFailed())}),i.on("change",(p,C)=>{if(a.token.isCancellationRequested)return;this.verboseLogging&&this.traceWithCorrelation(`[raw] ["${p}"] ${C}`);let M="";if(C&&(M=C.toString(),l.isMacintosh&&(M=(0,P.normalizeNFC)(M))),!(!M||p!=="change"&&p!=="rename"))if(v)if(p==="rename"){u.get(M)?.dispose();const D=setTimeout(async()=>{if(u.delete(M),M===r&&!await g.Promises.exists(c)){this.onWatchedPathDeleted(s);return}if(a.token.isCancellationRequested)return;const W=await this.existsChildStrictCase((0,h.join)(c,M));if(a.token.isCancellationRequested)return;let O;W?o.has(M)?O=0:(O=1,o.add(M)):(o.delete(M),O=2),this.onFileChange({resource:(0,f.joinPath)(s,M),type:O,cId:this.request.correlationId})},y.FILE_DELETE_HANDLER_DELAY);u.set(M,(0,k.toDisposable)(()=>clearTimeout(D)))}else{let D;o.has(M)?D=0:(D=1,o.add(M)),this.onFileChange({resource:(0,f.joinPath)(s,M),type:D,cId:this.request.correlationId})}else if(p==="rename"||M!==r){const D=setTimeout(async()=>{const W=await g.Promises.exists(c);a.token.isCancellationRequested||(W?(this.onFileChange({resource:s,type:0,cId:this.request.correlationId},!0),t.add(await this.doWatch(c,!1))):this.onWatchedPathDeleted(s))},y.FILE_DELETE_HANDLER_DELAY);t.clear(),t.add((0,k.toDisposable)(()=>clearTimeout(D)))}else this.onFileChange({resource:s,type:0,cId:this.request.correlationId},!0)})}catch(s){a.token.isCancellationRequested||this.error(`Failed to watch ${c} for changes using fs.watch() (${s.toString()})`),this.notifyWatchFailed()}}onWatchedPathDeleted(c){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:c,type:2,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.notifyWatchFailed()}onFileChange(c,v=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.traceWithCorrelation(`${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`),!v&&this.excludes.some(E=>E(c.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (excluded) ${c.resource.fsPath}`):!v&&this.includes&&this.includes.length>0&&!this.includes.some(E=>E(c.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${c.resource.fsPath}`):this.fileChangesAggregator.work(c))}handleFileChanges(c){const v=(0,d.coalesceEvents)(c),E=[];for(const t of v){if((0,d.isFiltered)(t,this.filter)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${t.resource.fsPath}`);continue}E.push(t)}if(E.length===0)return;if(this.verboseLogging)for(const t of E)this.traceWithCorrelation(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.throttledFileChangesEmitter.work(E)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${E[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${E.length}, most recent change: ${E[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async existsChildStrictCase(c){if(l.isLinux)return g.Promises.exists(c);try{const v=(0,h.basename)(c);return(await g.Promises.readdir((0,h.dirname)(c))).some(a=>a===v)}catch(v){return this.trace(v),!1}}setVerboseLogging(c){this.verboseLogging=c}error(c){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${c}`})}warn(c){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${c}`})}trace(c){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${c}`})}traceWithCorrelation(c){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.trace(`${c}${typeof this.request.correlationId=="number"?` <${this.request.correlationId}> `:""}`)}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y;async function w(m,c,v,E,a=512){const t=await g.Promises.open(m,"r"),s=Buffer.allocUnsafe(a),r=new I.CancellationTokenSource(E);let i,o=!1;const u={path:m,excludes:[],recursive:!1},p=new y(u,void 0,C=>{(async()=>{for(const{type:M}of C)if(M===0){if(o)return;o=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:D}=await g.Promises.read(t,s,0,a,null);if(!D||r.token.isCancellationRequested)break;c(s.slice(0,D))}}catch(D){i=new Error(D),r.dispose(!0)}finally{o=!1}}})()});return await p.ready,v(),new Promise((C,M)=>{r.token.onCancellationRequested(async()=>{p.dispose();try{await g.Promises.close(t)}catch(D){i=new Error(D)}i?M(i):C()})})}}),define(se[219],oe([0,1,3,108,217,4,218,31]),function(Q,e,n,R,I,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class h extends I.BaseWatcher{constructor(f){super(),this.recursiveWatcher=f,this.onDidError=n.Event.None,this.watchers=new Set}async doWatch(f){f=this.removeDuplicateRequests(f);const S=[],b=new Set(Array.from(this.watchers));for(const g of f){const d=this.findWatcher(g);d&&(0,R.patternsEquals)(d.request.excludes,g.excludes)&&(0,R.patternsEquals)(d.request.includes,g.includes)?b.delete(d):S.push(g)}S.length&&this.trace(`Request to start watching: ${S.map(g=>this.requestToString(g)).join(",")}`),b.size&&this.trace(`Request to stop watching: ${Array.from(b).map(g=>this.requestToString(g.request)).join(",")}`);for(const g of b)this.stopWatching(g);for(const g of S)this.startWatching(g)}findWatcher(f){for(const S of this.watchers)if(typeof f.correlationId=="number"||typeof S.request.correlationId=="number"){if(S.request.correlationId===f.correlationId)return S}else if((0,P.isEqual)(S.request.path,f.path,!A.isLinux))return S}startWatching(f){const S=new k.NodeJSFileWatcherLibrary(f,this.recursiveWatcher,g=>this._onDidChangeFile.fire(g),()=>this._onDidWatchFail.fire(f),g=>this._onDidLogMessage.fire(g),this.verboseLogging),b={request:f,instance:S};this.watchers.add(b)}async stop(){await super.stop();for(const f of this.watchers)this.stopWatching(f)}stopWatching(f){this.trace("stopping file watcher",f),this.watchers.delete(f),f.instance.dispose()}removeDuplicateRequests(f){const S=new Map;for(const b of f){const g=A.isLinux?b.path:b.path.toLowerCase();let d=S.get(b.correlationId);d||(d=new Map,S.set(b.correlationId,d)),d.has(g)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(b)}`),d.set(g,b)}return Array.from(S.values()).map(b=>Array.from(b.values())).flat()}async setVerboseLogging(f){super.setVerboseLogging(f);for(const S of this.watchers)S.instance.setVerboseLogging(f)}trace(f,S){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(f,S)})}warn(f){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(f)})}toMessage(f,S){return S?`[File Watcher (node.js)] ${f} (${this.requestToString(S.request)})`:`[File Watcher (node.js)] ${f}`}}e.NodeJSWatcher=h}),define(se[220],oe([0,1,60,219]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class I extends n.AbstractNonRecursiveWatcherClient{constructor(k,P,h){super(k,P,h),this.init()}createWatcher(k){return k.add(new R.NodeJSWatcher(void 0))}}e.NodeJSWatcherClient=I}),define(se[221],oe([0,1,13,44,162,60]),function(Q,e,n,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends A.AbstractUniversalWatcherClient{constructor(h,l,f){super(h,l,f),this.init()}createWatcher(h){const l=h.add(new I.Client(n.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(l.onDidProcessExit(({code:f,signal:S})=>this.onError(`terminated by itself with code ${f}, signal: ${S} (ETERM)`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(se[93],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class n{constructor(...I){this._entries=new Map;for(const[A,k]of I)this.set(A,k)}set(I,A){const k=this._entries.get(I);return this._entries.set(I,A),k}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=n}),define(se[222],oe([0,1,8,15,2,78,211,6,93,104]),function(Q,e,n,R,I,A,k,P,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const f=!1;class S extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class b{constructor(w=new h.ServiceCollection,m=!1,c,v=f){this._services=w,this._strict=m,this._parent=c,this._enableTracing=v,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=v?c?._globalGraph??new k.Graph(E=>E):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,I.dispose)(this._children),this._children.clear();for(const w of this._servicesToMaybeDispose)(0,I.isDisposable)(w)&&w.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(w){this._throwIfDisposed();const m=new class extends b{dispose(){this._children.delete(m),super.dispose()}}(w,this._strict,this,this._enableTracing);return this._children.add(m),m}invokeFunction(w,...m){this._throwIfDisposed();const c=d.traceInvocation(this._enableTracing,w);let v=!1;try{return w({get:a=>{if(v)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(a,c);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...m)}finally{v=!0,c.stop()}}createInstance(w,...m){this._throwIfDisposed();let c,v;return w instanceof A.SyncDescriptor?(c=d.traceCreation(this._enableTracing,w.ctor),v=this._createInstance(w.ctor,w.staticArguments.concat(m),c)):(c=d.traceCreation(this._enableTracing,w),v=this._createInstance(w,m,c)),c.stop(),v}_createInstance(w,m=[],c){const v=P._util.getServiceDependencies(w).sort((t,s)=>t.index-s.index),E=[];for(const t of v){const s=this._getOrCreateServiceInstance(t.id,c);s||this._throwIfStrict(`[createInstance] ${w.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(s)}const a=v.length>0?v[0].index:m.length;if(m.length!==a){console.trace(`[createInstance] First service dependency of ${w.name} at position ${a+1} conflicts with ${m.length} static arguments`);const t=a-m.length;t>0?m=m.concat(new Array(t)):m=m.slice(0,a)}return Reflect.construct(w,m.concat(E))}_setCreatedServiceInstance(w,m){if(this._services.get(w)instanceof A.SyncDescriptor)this._services.set(w,m);else if(this._parent)this._parent._setCreatedServiceInstance(w,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(w){const m=this._services.get(w);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(w):m}_getOrCreateServiceInstance(w,m){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(w));const c=this._getServiceInstanceOrDescriptor(w);return c instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(w,c,m.branch(w,!0)):(m.branch(w,!1),c)}_safeCreateAndCacheServiceInstance(w,m,c){if(this._activeInstantiations.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this._activeInstantiations.add(w);try{return this._createAndCacheServiceInstance(w,m,c)}finally{this._activeInstantiations.delete(w)}}_createAndCacheServiceInstance(w,m,c){const v=new k.Graph(t=>t.id.toString());let E=0;const a=[{id:w,desc:m,_trace:c}];for(;a.length;){const t=a.pop();if(v.lookupOrInsertNode(t),E++>1e3)throw new S(v);for(const s of P._util.getServiceDependencies(t.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(s.id);if(r||this._throwIfStrict(`[createInstance] ${w} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),r instanceof A.SyncDescriptor){const i={id:s.id,desc:r,_trace:t._trace.branch(s.id,!0)};v.insertEdge(t,i),a.push(i)}}}for(;;){const t=v.roots();if(t.length===0){if(!v.isEmpty())throw new S(v);break}for(const{data:s}of t){if(this._getServiceInstanceOrDescriptor(s.id)instanceof A.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setCreatedServiceInstance(s.id,i)}v.removeNode(s)}}return this._getServiceInstanceOrDescriptor(w)}_createServiceInstanceWithOwner(w,m,c=[],v,E){if(this._services.get(w)instanceof A.SyncDescriptor)return this._createServiceInstance(w,m,c,v,E,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(w,m,c,v,E);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(w,m,c=[],v,E,a){if(v){const t=new b(void 0,this._strict,this,this._enableTracing);t._globalGraphImplicitDependency=String(w);const s=new Map,r=new n.GlobalIdleValue(()=>{const i=t._createInstance(m,c,E);for(const[o,u]of s){const p=i[o];if(typeof p=="function")for(const C of u)C.disposable=p.apply(i,C.listener)}return s.clear(),a.add(i),i});return new Proxy(Object.create(null),{get(i,o){if(!r.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let C=s.get(o);return C||(C=new l.LinkedList,s.set(o,C)),(D,W,O)=>{if(r.isInitialized)return r.value[o](D,W,O);{const _={listener:[D,W,O],disposable:void 0},F=C.push(_);return(0,I.toDisposable)(()=>{F(),_.disposable?.dispose()})}}}if(o in i)return i[o];const u=r.value;let p=u[o];return typeof p!="function"||(p=p.bind(u),i[o]=p),p},set(i,o,u){return r.value[o]=u,!0},getPrototypeOf(i){return m.prototype}})}else{const t=this._createInstance(m,c,E);return a.add(t),t}}_throwIfStrict(w,m){if(m&&console.warn(w),this._strict)throw new Error(w)}}e.InstantiationService=b;var g;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(g||(g={}));class d{static{this.all=new Set}static{this._None=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,m){return w?new d(2,m.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d._None}static traceCreation(w,m){return w?new d(1,m.name):d._None}static{this._totals=0}constructor(w,m){this.type=w,this.name=m,this._start=Date.now(),this._dep=[]}branch(w,m){const c=new d(3,w.toString());return this._dep.push([w,m,c]),c}stop(){const w=Date.now()-this._start;d._totals+=w;let m=!1;function c(E,a){const t=[],s=new Array(E+1).join("	");for(const[r,i,o]of a._dep)if(i&&o){m=!0,t.push(`${s}CREATES -> ${r}`);const u=c(E+1,o);u&&t.push(u)}else t.push(`${s}uses -> ${r}`);return t.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(w>2||m)&&d.all.add(v.join(`
`))}}e.Trace=d}),define(se[223],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IIssueMainService=e.IssueSource=e.IssueType=void 0;var R;(function(A){A[A.Bug=0]="Bug",A[A.PerformanceIssue=1]="PerformanceIssue",A[A.FeatureRequest=2]="FeatureRequest"})(R||(e.IssueType=R={}));var I;(function(A){A.VSCode="vscode",A.Extension="extension",A.Marketplace="marketplace"})(I||(e.IssueSource=I={})),e.IIssueMainService=(0,n.createDecorator)("issueService")}),define(se[5],oe([0,1,183,47,3,46,2,32,4,19,12,7,118,6]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=y,e.log=m,e.getLogLevel=p,e.LogLevelToString=C,e.LogLevelToLocalizedString=M,e.parseLogLevel=D,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function d(){return new Date().toISOString()}function y(W){return(0,f.isNumber)(W)}var w;(function(W){W[W.Off=0]="Off",W[W.Trace=1]="Trace",W[W.Debug=2]="Debug",W[W.Info=3]="Info",W[W.Warning=4]="Warning",W[W.Error=5]="Error"})(w||(e.LogLevel=w={})),e.DEFAULT_LOG_LEVEL=w.Info;function m(W,O,_){switch(O){case w.Trace:W.trace(_);break;case w.Debug:W.debug(_);break;case w.Info:W.info(_);break;case w.Warning:W.warn(_);break;case w.Error:W.error(_);break;case w.Off:break;default:throw new Error(`Invalid log level ${O}`)}}function c(W,O=!1){let _="";for(let F=0;F<W.length;F++){let x=W[F];if(x instanceof Error&&(x=(0,R.toErrorMessage)(x,O)),typeof x=="object")try{x=JSON.stringify(x)}catch{}_+=(F>0?" ":"")+x}return _}class v extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(O){this.level!==O&&(this.level=O,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(O){return this.level!==w.Off&&this.level<=O}}e.AbstractLogger=v;class E extends v{constructor(O){super(),this.logAlways=O}checkLogLevel(O){return this.logAlways||super.checkLogLevel(O)}trace(O,..._){this.checkLogLevel(w.Trace)&&this.log(w.Trace,c([O,..._],!0))}debug(O,..._){this.checkLogLevel(w.Debug)&&this.log(w.Debug,c([O,..._]))}info(O,..._){this.checkLogLevel(w.Info)&&this.log(w.Info,c([O,..._]))}warn(O,..._){this.checkLogLevel(w.Warning)&&this.log(w.Warning,c([O,..._]))}error(O,..._){if(this.checkLogLevel(w.Error))if(O instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=O.stack,this.log(w.Error,c(F))}else this.log(w.Error,c([O,..._]))}flush(){}}e.AbstractMessageLogger=E;class a extends v{constructor(O=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(O),this.useColors=!h.isWindows}trace(O,..._){this.checkLogLevel(w.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,O,..._):console.log(`[main ${d()}]`,O,..._))}debug(O,..._){this.checkLogLevel(w.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,O,..._):console.log(`[main ${d()}]`,O,..._))}info(O,..._){this.checkLogLevel(w.Info)&&(this.useColors?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,O,..._):console.log(`[main ${d()}]`,O,..._))}warn(O,..._){this.checkLogLevel(w.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,O,..._):console.warn(`[main ${d()}]`,O,..._))}error(O,..._){this.checkLogLevel(w.Error)&&(this.useColors?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,O,..._):console.error(`[main ${d()}]`,O,..._))}flush(){}}e.ConsoleMainLogger=a;class t extends v{constructor(O=e.DEFAULT_LOG_LEVEL,_=!0){super(),this.useColors=_,this.setLevel(O)}trace(O,..._){this.checkLogLevel(w.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",O,..._):console.log(O,..._))}debug(O,..._){this.checkLogLevel(w.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",O,..._):console.log(O,..._))}info(O,..._){this.checkLogLevel(w.Info)&&(this.useColors?console.log("%c INFO","color: #33f",O,..._):console.log(O,..._))}warn(O,..._){this.checkLogLevel(w.Warning)&&(this.useColors?console.log("%c WARN","color: #993",O,..._):console.log(O,..._))}error(O,..._){this.checkLogLevel(w.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",O,..._):console.error(O,..._))}flush(){}}e.ConsoleLogger=t;class s extends v{constructor(O,_=e.DEFAULT_LOG_LEVEL){super(),this.adapter=O,this.setLevel(_)}trace(O,..._){this.checkLogLevel(w.Trace)&&this.adapter.log(w.Trace,[this.extractMessage(O),..._])}debug(O,..._){this.checkLogLevel(w.Debug)&&this.adapter.log(w.Debug,[this.extractMessage(O),..._])}info(O,..._){this.checkLogLevel(w.Info)&&this.adapter.log(w.Info,[this.extractMessage(O),..._])}warn(O,..._){this.checkLogLevel(w.Warning)&&this.adapter.log(w.Warning,[this.extractMessage(O),..._])}error(O,..._){this.checkLogLevel(w.Error)&&this.adapter.log(w.Error,[this.extractMessage(O),..._])}extractMessage(O){return typeof O=="string"?O:(0,R.toErrorMessage)(O,this.checkLogLevel(w.Trace))}flush(){}}e.AdapterLogger=s;class r extends v{constructor(O){super(),this.loggers=O,O.length&&this.setLevel(O[0].getLevel())}setLevel(O){for(const _ of this.loggers)_.setLevel(O);super.setLevel(O)}trace(O,..._){for(const F of this.loggers)F.trace(O,..._)}debug(O,..._){for(const F of this.loggers)F.debug(O,..._)}info(O,..._){for(const F of this.loggers)F.info(O,..._)}warn(O,..._){for(const F of this.loggers)F.warn(O,..._)}error(O,..._){for(const F of this.loggers)F.error(O,..._)}flush(){for(const O of this.loggers)O.flush()}dispose(){for(const O of this.loggers)O.dispose();super.dispose()}}e.MultiplexLogger=r;class i extends k.Disposable{constructor(O,_,F){if(super(),this.logLevel=O,this.logsHome=_,this._loggers=new P.ResourceMap,this._onDidChangeLoggers=this._register(new I.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new I.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,F)for(const x of F)this._loggers.set(x.resource,{logger:void 0,info:x})}getLoggerEntry(O){return(0,f.isString)(O)?[...this._loggers.values()].find(_=>_.info.id===O):this._loggers.get(O)}getLogger(O){return this.getLoggerEntry(O)?.logger}createLogger(O,_){const F=this.toResource(O),x=(0,f.isString)(O)?O:_?.id??(0,A.hash)(F.toString()).toString(16);let z=this._loggers.get(F)?.logger;const ue=_?.logLevel==="always"?w.Trace:_?.logLevel;z||(z=this.doCreateLogger(F,ue??this.getLogLevel(F)??this.logLevel,{..._,id:x}));const ee={logger:z,info:{resource:F,id:x,logLevel:ue,name:_?.name,hidden:_?.hidden,extensionId:_?.extensionId,when:_?.when}};return this.registerLogger(ee.info),this._loggers.set(F,ee),z}toResource(O){return(0,f.isString)(O)?(0,l.joinPath)(this.logsHome,`${O}.log`):O}setLogLevel(O,_){if(S.URI.isUri(O)){const F=O,x=_,z=this._loggers.get(F);z&&x!==z.info.logLevel&&(z.info.logLevel=x===this.logLevel?void 0:x,z.logger?.setLevel(x),this._loggers.set(z.info.resource,z),this._onDidChangeLogLevel.fire([F,x]))}else{this.logLevel=O;for(const[F,x]of this._loggers.entries())this._loggers.get(F)?.info.logLevel===void 0&&x.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(O,_){const F=this.getLoggerEntry(O);F&&_!==!F.info.hidden&&(F.info.hidden=!_,this._loggers.set(F.info.resource,F),this._onDidChangeVisibility.fire([F.info.resource,_]))}getLogLevel(O){let _;return O&&(_=this._loggers.get(O)?.info.logLevel),_??this.logLevel}registerLogger(O){const _=this._loggers.get(O.resource);_?_.info.hidden!==O.hidden&&this.setVisibility(O.resource,!O.hidden):(this._loggers.set(O.resource,{info:O,logger:void 0}),this._onDidChangeLoggers.fire({added:[O],removed:[]}))}deregisterLogger(O){const _=this._loggers.get(O);_&&(_.logger&&_.logger.dispose(),this._loggers.delete(O),this._onDidChangeLoggers.fire({added:[],removed:[_.info]}))}*getRegisteredLoggers(){for(const O of this._loggers.values())yield O.info}getRegisteredLogger(O){return this._loggers.get(O)?.info}dispose(){this._loggers.forEach(O=>O.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=i;class o{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(O){}getLevel(){return w.Info}trace(O,..._){}debug(O,..._){}info(O,..._){}warn(O,..._){}error(O,..._){}critical(O,..._){}dispose(){}flush(){}}e.NullLogger=o;class u extends o{}e.NullLogService=u;function p(W){if(W.verbose)return w.Trace;if(typeof W.logLevel=="string"){const O=D(W.logLevel.toLowerCase());if(O!==void 0)return O}return e.DEFAULT_LOG_LEVEL}function C(W){switch(W){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}function M(W){switch(W){case w.Trace:return{original:"Trace",value:n.localize(0,null)};case w.Debug:return{original:"Debug",value:n.localize(1,null)};case w.Info:return{original:"Info",value:n.localize(2,null)};case w.Warning:return{original:"Warning",value:n.localize(3,null)};case w.Error:return{original:"Error",value:n.localize(4,null)};case w.Off:return{original:"Off",value:n.localize(5,null)}}}function D(W){switch(W){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.CONTEXT_LOG_LEVEL=new b.RawContextKey("logLevel",C(w.Info))});var ie=this&&this.__param||function(Q,e){return function(n,R){e(n,R,Q)}};define(se[224],oe([0,1,14,4,5]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;const A=n.safeStorage;let k=class{constructor(h){this.logService=h,n.app.commandLine.getSwitchValue("password-store")==="basic"&&A.setUsePlainTextEncryption?.(!0)}async encrypt(h){this.logService.trace("[EncryptionMainService] Encrypting value.");try{const l=JSON.stringify(A.encryptString(h));return this.logService.trace("[EncryptionMainService] Encrypted value."),l}catch(l){throw this.logService.error(l),l}}async decrypt(h){let l;try{if(l=JSON.parse(h),!l.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${h}`);const f=Buffer.from(l.data);this.logService.trace("[EncryptionMainService] Decrypting value.");const S=A.decryptString(f);return this.logService.trace("[EncryptionMainService] Decrypted value."),S}catch(f){throw this.logService.error(f),f}}isEncryptionAvailable(){return Promise.resolve(A.isEncryptionAvailable())}getKeyStorageProvider(){if(R.isWindows)return Promise.resolve("dpapi");if(R.isMacintosh)return Promise.resolve("keychain_access");if(A.getSelectedStorageBackend)try{const h=A.getSelectedStorageBackend();return Promise.resolve(h)}catch(h){this.logService.error(h)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(R.isWindows)throw new Error("Setting plain text encryption is not supported on Windows.");if(R.isMacintosh)throw new Error("Setting plain text encryption is not supported on macOS.");if(!A.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");A.setUsePlainTextEncryption(!0)}};e.EncryptionMainService=k,e.EncryptionMainService=k=Ie([ie(0,I.ILogService)],k)}),define(se[225],oe([0,1,22,8,15,3,31,2,9,60,5]),function(Q,e,n,R,I,A,k,P,h,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class S extends P.Disposable{constructor(g,d){super(),this.logService=g,this.options=d,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalWatchRequests=[],this.universalWatchRequestDelayer=this._register(new R.ThrottledDelayer(0)),this.nonRecursiveWatchRequests=[],this.nonRecursiveWatchRequestDelayer=this._register(new R.ThrottledDelayer(0))}watch(g,d){return d.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(g,d):this.watchNonRecursive(g,d)}watchUniversal(g,d){const y={path:this.toWatchPath(g),excludes:d.excludes,includes:d.includes,recursive:d.recursive,filter:d.filter,correlationId:d.correlationId},w=(0,n.insert)(this.universalWatchRequests,y);return this.refreshUniversalWatchers(),(0,P.toDisposable)(()=>{w(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(g=>(0,I.onUnexpectedError)(g))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(d=>this._onDidChangeFile.fire((0,l.reviveFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)})));const g=this.options?.watcher?.recursive?.usePolling;if(g===!0)for(const d of this.universalWatchRequests)(0,l.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const d of this.universalWatchRequests)(0,l.isRecursiveWatchRequest)(d)&&g.includes(d.path)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalWatchRequests)}watchNonRecursive(g,d){const y={path:this.toWatchPath(g),excludes:d.excludes,includes:d.includes,recursive:!1,filter:d.filter,correlationId:d.correlationId},w=(0,n.insert)(this.nonRecursiveWatchRequests,y);return this.refreshNonRecursiveWatchers(),(0,P.toDisposable)(()=>{w(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(g=>(0,I.onUnexpectedError)(g))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(g=>this._onDidChangeFile.fire((0,l.reviveFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursiveWatchRequests)}onWatcherLogMessage(g){g.type==="error"&&this._onDidWatchError.fire(g.message),this.logWatcherMessage(g)}logWatcherMessage(g){this.logService[g.type](g.message)}toFilePath(g){return(0,h.normalize)(g.fsPath)}toWatchPath(g){const d=this.toFilePath(g);return(0,k.removeTrailingPathSeparator)(d)}}e.AbstractDiskFileSystemProvider=S}),define(se[226],oe([0,1,22,8,17,23,3,46,71,2,59,13,66,19,63,177,16,122,5,15]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y,w,m,c,v){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let a=class extends l.Disposable{static{E=this}constructor(s){super(),this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new k.Emitter),this._onDidUncorrelatedFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new R.ResourceQueue)}registerProvider(s,r){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${s}`);const i=new l.DisposableStore;return this.provider.set(s,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:r}),i.add(r.onDidChangeFile(o=>{const u=new w.FileChangesEvent(o,!this.isPathCaseSensitive(r));this.internalOnDidFilesChange.fire(u),u.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(u)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(o=>this._onDidWatchError.fire(new Error(o)))),i.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:s}))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:r}),this.provider.delete(s),(0,l.dispose)(i)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(i){r.push(i)}}),!this.provider.has(s)&&await R.Promises.settled(r)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,r){const i=this.provider.get(s.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return h.Iterable.map(this.provider,([s,r])=>({scheme:s,capabilities:r.capabilities}))}async withProvider(s){if(!(0,g.isAbsolutePath)(s))throw new w.FileOperationError((0,y.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const r=this.provider.get(s.scheme);if(!r){const i=new v.ErrorNoTelemetry;throw i.message=(0,y.localize)(1,null,s.toString()),i}return r}async withReadProvider(s){const r=await this.withProvider(s);if((0,w.hasOpenReadWriteCloseCapability)(r)||(0,w.hasReadWriteCapability)(r)||(0,w.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const r=await this.withProvider(s);if((0,w.hasOpenReadWriteCloseCapability)(r)||(0,w.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,r){try{return await this.doResolveFile(s,r)}catch(i){throw(0,w.toFileSystemProviderErrorCode)(i)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,y.localize)(2,null,this.resourceForError(s)),1):(0,w.ensureFileSystemProviderError)(i)}}async doResolveFile(s,r){const i=await this.withProvider(s),o=this.isPathCaseSensitive(i),u=r?.resolveTo,p=r?.resolveSingleChildDescendants,C=r?.resolveMetadata,M=await i.stat(s);let D;return this.toFileStat(i,s,M,void 0,!!C,(W,O)=>(D||(D=f.TernarySearchTree.forUris(()=>!o),D.set(s,!0),u&&D.fill(!0,u)),D.get(W.resource)||D.findSuperstr(W.resource.with({query:null,fragment:null}))?!0:W.isDirectory&&p?O===1:!1))}async toFileStat(s,r,i,o,u,p){const{providerExtUri:C}=this.getExtUri(s),M={resource:r,name:C.basename(r),isFile:(i.type&w.FileType.File)!==0,isDirectory:(i.type&w.FileType.Directory)!==0,isSymbolicLink:(i.type&w.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&w.FilePermission.Readonly)||!!(s.capabilities&2048),locked:!!((i.permissions??0)&w.FilePermission.Locked),etag:(0,w.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(M.isDirectory&&p(M,o)){try{const D=await s.readdir(r),W=await R.Promises.settled(D.map(async([O,_])=>{try{const F=C.joinPath(r,O),x=u?await s.stat(F):{type:_};return await this.toFileStat(s,F,x,D.length,u,p)}catch(F){return this.logService.trace(F),null}}));M.children=(0,n.coalesce)(W)}catch(D){this.logService.trace(D),M.children=[]}return M}return M}async resolveAll(s){return R.Promises.settled(s.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async stat(s){const r=await this.withProvider(s),i=await r.stat(s);return this.toFileStat(r,s,i,void 0,!0,()=>!1)}async exists(s){const r=await this.withProvider(s);try{return!!await r.stat(s)}catch{return!1}}async canCreateFile(s,r){try{await this.doValidateCreateFile(s,r)}catch(i){return i}return!0}async doValidateCreateFile(s,r){if(!r?.overwrite&&await this.exists(s))throw new w.FileOperationError((0,y.localize)(3,null,this.resourceForError(s)),3,r)}async createFile(s,r=I.VSBuffer.fromString(""),i){await this.doValidateCreateFile(s,i);const o=await this.writeFile(s,r);return this._onDidRunOperation.fire(new w.FileOperationEvent(s,0,o)),o}async writeFile(s,r,i){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:u}=this.getExtUri(o);let p=i;if((0,w.hasFileAtomicWriteCapability)(o)&&!p?.atomic){const C=o.enforceAtomicWriteFile?.(s);C&&(p={...i,atomic:C})}try{await this.validateWriteFile(o,s,p)||await this.mkdirp(o,u.dirname(s));let M;if((0,w.hasReadWriteCapability)(o)&&!(r instanceof I.VSBuffer))if((0,d.isReadableStream)(r)){const D=await(0,d.peekStream)(r,3);D.ended?M=I.VSBuffer.concat(D.buffer):M=D}else M=(0,d.peekReadable)(r,D=>I.VSBuffer.concat(D),3);else M=r;!(0,w.hasOpenReadWriteCloseCapability)(o)||(0,w.hasReadWriteCapability)(o)&&M instanceof I.VSBuffer||(0,w.hasReadWriteCapability)(o)&&(0,w.hasFileAtomicWriteCapability)(o)&&p?.atomic?await this.doWriteUnbuffered(o,s,p,M):await this.doWriteBuffered(o,s,p,M instanceof I.VSBuffer?(0,I.bufferToReadable)(M):M),this._onDidRunOperation.fire(new w.FileOperationEvent(s,4))}catch(C){throw new w.FileOperationError((0,y.localize)(4,null,this.resourceForError(s),(0,w.ensureFileSystemProviderError)(C).toString()),(0,w.toFileOperationResult)(C),p)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,r,i){const o=!!i?.unlock;if(o&&!(s.capabilities&8192))throw new Error((0,y.localize)(5,null,this.resourceForError(r)));if(!!i?.atomic){if(!(s.capabilities&32768))throw new Error((0,y.localize)(6,null,this.resourceForError(r)));if(!(s.capabilities&2))throw new Error((0,y.localize)(7,null,this.resourceForError(r)));if(o)throw new Error((0,y.localize)(8,null,this.resourceForError(r)))}let p;try{p=await s.stat(r)}catch{return}if(p.type&w.FileType.Directory)throw new w.FileOperationError((0,y.localize)(9,null,this.resourceForError(r)),0,i);if(this.throwIfFileIsReadonly(r,p),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==w.ETAG_DISABLED&&typeof p.mtime=="number"&&typeof p.size=="number"&&i.mtime<p.mtime&&i.etag!==(0,w.etag)({mtime:i.mtime,size:p.size}))throw new w.FileOperationError((0,y.localize)(10,null),3,i);return p}async readFile(s,r,i){const o=await this.withReadProvider(s);return r?.atomic?this.doReadFileAtomic(o,s,r,i):this.doReadFile(o,s,r,i)}async doReadFileAtomic(s,r,i,o){return new Promise((u,p)=>{this.writeQueue.queueFor(r,async()=>{try{const C=await this.doReadFile(s,r,i,o);u(C)}catch(C){p(C)}},this.getExtUri(s).providerExtUri)})}async doReadFile(s,r,i,o){const u=await this.doReadFileStream(s,r,{...i,preferUnbuffered:!0},o);return{...u,value:await(0,I.streamToBuffer)(u.value)}}async readFileStream(s,r,i){const o=await this.withReadProvider(s);return this.doReadFileStream(o,s,r,i)}async doReadFileStream(s,r,i,o){const u=new A.CancellationTokenSource(o);let p=i;(0,w.hasFileAtomicReadCapability)(s)&&s.enforceAtomicReadFile?.(r)&&(p={...i,atomic:!0});const C=this.validateReadFile(r,p).then(D=>D,D=>{throw u.dispose(!0),D});let M;try{return typeof p?.etag=="string"&&p.etag!==w.ETAG_DISABLED&&await C,p?.atomic&&(0,w.hasFileAtomicReadCapability)(s)||!((0,w.hasOpenReadWriteCloseCapability)(s)||(0,w.hasFileReadStreamCapability)(s))||(0,w.hasReadWriteCapability)(s)&&p?.preferUnbuffered?M=this.readFileUnbuffered(s,r,p):(0,w.hasFileReadStreamCapability)(s)?M=this.readFileStreamed(s,r,u.token,p):M=this.readFileBuffered(s,r,u.token,p),M.on("end",()=>u.dispose()),M.on("error",()=>u.dispose()),{...await C,value:M}}catch(D){throw M&&await(0,d.consumeStream)(M),this.restoreReadError(D,r,p)}}restoreReadError(s,r,i){const o=(0,y.localize)(11,null,this.resourceForError(r),(0,w.ensureFileSystemProviderError)(s).toString());return s instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(o,s.stat,i):s instanceof w.TooLargeFileOperationError?new w.TooLargeFileOperationError(o,s.fileOperationResult,s.size,s.options):new w.FileOperationError(o,(0,w.toFileOperationResult)(s),i)}readFileStreamed(s,r,i,o=Object.create(null)){const u=s.readFileStream(r,o,i);return(0,d.transform)(u,{data:p=>p instanceof I.VSBuffer?p:I.VSBuffer.wrap(p),error:p=>this.restoreReadError(p,r,o)},p=>I.VSBuffer.concat(p))}readFileBuffered(s,r,i,o=Object.create(null)){const u=(0,I.newWriteableBufferStream)();return(0,m.readFileIntoStream)(s,r,u,p=>p,{...o,bufferSize:this.BUFFER_SIZE,errorTransformer:p=>this.restoreReadError(p,r,o)},i),u}readFileUnbuffered(s,r,i){const o=(0,d.newWriteableStream)(u=>I.VSBuffer.concat(u));return(async()=>{try{let u;i?.atomic&&(0,w.hasFileAtomicReadCapability)(s)?u=await s.readFile(r,{atomic:!0}):u=await s.readFile(r),typeof i?.position=="number"&&(u=u.slice(i.position)),typeof i?.length=="number"&&(u=u.slice(0,i.length)),this.validateReadFileLimits(r,u.byteLength,i),o.end(I.VSBuffer.wrap(u))}catch(u){o.error(u),o.end()}})(),o}async validateReadFile(s,r){const i=await this.resolve(s,{resolveMetadata:!0});if(i.isDirectory)throw new w.FileOperationError((0,y.localize)(12,null,this.resourceForError(s)),0,r);if(typeof r?.etag=="string"&&r.etag!==w.ETAG_DISABLED&&r.etag===i.etag)throw new w.NotModifiedSinceFileOperationError((0,y.localize)(13,null),i,r);return this.validateReadFileLimits(s,i.size,r),i}validateReadFileLimits(s,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new w.TooLargeFileOperationError((0,y.localize)(14,null,this.resourceForError(s)),7,r,i)}async canMove(s,r,i){return this.doCanMoveCopy(s,r,"move",i)}async canCopy(s,r,i){return this.doCanMoveCopy(s,r,"copy",i)}async doCanMoveCopy(s,r,i,o){if(s.toString()!==r.toString())try{const u=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),p=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(u,s,p,r,i,o)}catch(u){return u}return!0}async move(s,r,i){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),p=await this.doMoveCopy(o,s,u,r,"move",!!i),C=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(s,p==="move"?2:3,C)),C}async copy(s,r,i){const o=await this.withReadProvider(s),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),p=await this.doMoveCopy(o,s,u,r,"copy",!!i),C=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(s,p==="copy"?3:2,C)),C}async doMoveCopy(s,r,i,o,u,p){if(r.toString()===o.toString())return u;const{exists:C,isSameResourceWithDifferentPathCase:M}=await this.doValidateMoveCopy(s,r,i,o,u,p);if(C&&!M&&p&&await this.del(o,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(o)),u==="copy"){if(s===i&&(0,w.hasFileFolderCopyCapability)(s))await s.copy(r,o,{overwrite:p});else{const D=await this.resolve(r);D.isDirectory?await this.doCopyFolder(s,D,i,o):await this.doCopyFile(s,r,i,o)}return u}else return s===i?(await s.rename(r,o,{overwrite:p}),u):(await this.doMoveCopy(s,r,i,o,"copy",p),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(s,r,i,o){if((0,w.hasOpenReadWriteCloseCapability)(s)&&(0,w.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(s,r,i,o);if((0,w.hasOpenReadWriteCloseCapability)(s)&&(0,w.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(s,r,i,o);if((0,w.hasReadWriteCapability)(s)&&(0,w.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(s,r,i,o);if((0,w.hasReadWriteCapability)(s)&&(0,w.hasReadWriteCapability)(i))return this.doPipeUnbuffered(s,r,i,o)}async doCopyFolder(s,r,i,o){await i.mkdir(o),Array.isArray(r.children)&&await R.Promises.settled(r.children.map(async u=>{const p=this.getExtUri(i).providerExtUri.joinPath(o,u.name);return u.isDirectory?this.doCopyFolder(s,await this.resolve(u.resource),i,p):this.doCopyFile(s,u.resource,i,p)}))}async doValidateMoveCopy(s,r,i,o,u,p){let C=!1;if(s===i){const{providerExtUri:D,isPathCaseSensitive:W}=this.getExtUri(s);if(W||(C=D.isEqual(r,o)),C&&u==="copy")throw new Error((0,y.localize)(15,null,this.resourceForError(r),this.resourceForError(o)));if(!C&&D.isEqualOrParent(o,r))throw new Error((0,y.localize)(16,null,this.resourceForError(r),this.resourceForError(o)))}const M=await this.exists(o);if(M&&!C){if(!p)throw new w.FileOperationError((0,y.localize)(17,null,this.resourceForError(r),this.resourceForError(o)),4);if(s===i){const{providerExtUri:D}=this.getExtUri(s);if(D.isEqualOrParent(r,o))throw new Error((0,y.localize)(18,null,this.resourceForError(r),this.resourceForError(o)))}}return{exists:M,isSameResourceWithDifferentPathCase:C}}getExtUri(s){const r=this.isPathCaseSensitive(s);return{providerExtUri:r?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(r,s);const i=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(s,0,i)),i}async mkdirp(s,r){const i=[],{providerExtUri:o}=this.getExtUri(s);for(;!o.isEqual(r,o.dirname(r));)try{if(!((await s.stat(r)).type&w.FileType.Directory))throw new Error((0,y.localize)(19,null,this.resourceForError(r)));break}catch(u){if((0,w.toFileSystemProviderErrorCode)(u)!==w.FileSystemProviderErrorCode.FileNotFound)throw u;i.push(o.basename(r)),r=o.dirname(r)}for(let u=i.length-1;u>=0;u--){r=o.joinPath(r,i[u]);try{await s.mkdir(r)}catch(p){if((0,w.toFileSystemProviderErrorCode)(p)!==w.FileSystemProviderErrorCode.FileExists)throw p}}}async canDelete(s,r){try{await this.doValidateDelete(s,r)}catch(i){return i}return!0}async doValidateDelete(s,r){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s),o=!!r?.useTrash;if(o&&!(i.capabilities&4096))throw new Error((0,y.localize)(20,null,this.resourceForError(s)));const u=r?.atomic;if(u&&!(i.capabilities&65536))throw new Error((0,y.localize)(21,null,this.resourceForError(s)));if(o&&u)throw new Error((0,y.localize)(22,null,this.resourceForError(s)));let p;try{p=await i.stat(s)}catch{}if(p)this.throwIfFileIsReadonly(s,p);else throw new w.FileOperationError((0,y.localize)(23,null,this.resourceForError(s)),1);if(!!!r?.recursive){const M=await this.resolve(s);if(M.isDirectory&&Array.isArray(M.children)&&M.children.length>0)throw new Error((0,y.localize)(24,null,this.resourceForError(s)))}return i}async del(s,r){const i=await this.doValidateDelete(s,r);let o=r;if((0,w.hasFileAtomicDeleteCapability)(i)&&!o?.atomic){const M=i.enforceAtomicDelete?.(s);M&&(o={...r,atomic:M})}const u=!!o?.useTrash,p=!!o?.recursive,C=o?.atomic??!1;await i.delete(s,{recursive:p,useTrash:u,atomic:C}),this._onDidRunOperation.fire(new w.FileOperationEvent(s,1))}async cloneFile(s,r){const i=await this.withProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);if(!(i===o&&this.getExtUri(i).providerExtUri.isEqual(s,r)))return i===o&&(0,w.hasFileCloneCapability)(i)?i.cloneFile(s,r):(await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(r)),i===o&&(0,w.hasFileFolderCopyCapability)(i)?this.writeQueue.queueFor(s,()=>i.copy(s,r,{overwrite:!0}),this.getExtUri(i).providerExtUri):this.writeQueue.queueFor(s,()=>this.doCopyFile(i,s,o,r),this.getExtUri(i).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(s,r){return this.watch(s,{...r,correlationId:E.WATCHER_CORRELATION_IDS++})}watch(s,r={recursive:!1,excludes:[]}){const i=new l.DisposableStore;let o=!1,u=()=>{o=!0};i.add((0,l.toDisposable)(()=>u())),(async()=>{try{const C=await this.doWatch(s,r);o?(0,l.dispose)(C):u=()=>(0,l.dispose)(C)}catch(C){this.logService.error(C)}})();const p=r.correlationId;if(typeof p=="number"){const C=i.add(new k.Emitter);return i.add(this.internalOnDidFilesChange.event(D=>{D.correlates(p)&&C.fire(D)})),{onDidChange:C.event,dispose:()=>i.dispose()}}return i}async doWatch(s,r){const i=await this.withProvider(s),o=(0,P.hash)([this.getExtUri(i).providerExtUri.getComparisonKey(s),r]);let u=this.activeWatchers.get(o);return u||(u={count:0,disposable:i.watch(s,r)},this.activeWatchers.set(o,u)),u.count+=1,(0,l.toDisposable)(()=>{u&&(u.count--,u.count===0&&((0,l.dispose)(u.disposable),this.activeWatchers.delete(o)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,l.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,r,i,o){return this.writeQueue.queueFor(r,async()=>{const u=await s.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,d.isReadableStream)(o)||(0,d.isReadableBufferedStream)(o)?await this.doWriteStreamBufferedQueued(s,u,o):await this.doWriteReadableBufferedQueued(s,u,o)}catch(p){throw(0,w.ensureFileSystemProviderError)(p)}finally{await s.close(u)}},this.getExtUri(s).providerExtUri)}async doWriteStreamBufferedQueued(s,r,i){let o=0,u;if((0,d.isReadableBufferedStream)(i)){if(i.buffer.length>0){const p=I.VSBuffer.concat(i.buffer);await this.doWriteBuffer(s,r,p,p.byteLength,o,0),o+=p.byteLength}if(i.ended)return;u=i.stream}else u=i;return new Promise((p,C)=>{(0,d.listenStream)(u,{onData:async M=>{u.pause();try{await this.doWriteBuffer(s,r,M,M.byteLength,o,0)}catch(D){return C(D)}o+=M.byteLength,setTimeout(()=>u.resume())},onError:M=>C(M),onEnd:()=>p()})})}async doWriteReadableBufferedQueued(s,r,i){let o=0,u;for(;(u=i.read())!==null;)await this.doWriteBuffer(s,r,u,u.byteLength,o,0),o+=u.byteLength}async doWriteBuffer(s,r,i,o,u,p){let C=0;for(;C<o;){const M=await s.write(r,u+C,i.buffer,p+C,o-C);C+=M}}async doWriteUnbuffered(s,r,i,o){return this.writeQueue.queueFor(r,()=>this.doWriteUnbufferedQueued(s,r,i,o),this.getExtUri(s).providerExtUri)}async doWriteUnbufferedQueued(s,r,i,o){let u;o instanceof I.VSBuffer?u=o:(0,d.isReadableStream)(o)?u=await(0,I.streamToBuffer)(o):(0,d.isReadableBufferedStream)(o)?u=await(0,I.bufferedStreamToBuffer)(o):u=(0,I.readableToBuffer)(o),await s.writeFile(r,u.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async doPipeBuffered(s,r,i,o){return this.writeQueue.queueFor(o,()=>this.doPipeBufferedQueued(s,r,i,o),this.getExtUri(i).providerExtUri)}async doPipeBufferedQueued(s,r,i,o){let u,p;try{u=await s.open(r,{create:!1}),p=await i.open(o,{create:!0,unlock:!1});const C=I.VSBuffer.alloc(this.BUFFER_SIZE);let M=0,D=0,W=0;do W=await s.read(u,M,C.buffer,D,C.byteLength-D),await this.doWriteBuffer(i,p,C,W,M,D),M+=W,D+=W,D===C.byteLength&&(D=0);while(W>0)}catch(C){throw(0,w.ensureFileSystemProviderError)(C)}finally{await R.Promises.settled([typeof u=="number"?s.close(u):Promise.resolve(),typeof p=="number"?i.close(p):Promise.resolve()])}}async doPipeUnbuffered(s,r,i,o){return this.writeQueue.queueFor(o,()=>this.doPipeUnbufferedQueued(s,r,i,o),this.getExtUri(i).providerExtUri)}async doPipeUnbufferedQueued(s,r,i,o){return i.writeFile(o,await s.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(s,r,i,o){return this.writeQueue.queueFor(o,()=>this.doPipeUnbufferedToBufferedQueued(s,r,i,o),this.getExtUri(i).providerExtUri)}async doPipeUnbufferedToBufferedQueued(s,r,i,o){const u=await i.open(o,{create:!0,unlock:!1});try{const p=await s.readFile(r);await this.doWriteBuffer(i,u,I.VSBuffer.wrap(p),p.byteLength,0,0)}catch(p){throw(0,w.ensureFileSystemProviderError)(p)}finally{await i.close(u)}}async doPipeBufferedToUnbuffered(s,r,i,o){const u=await(0,I.streamToBuffer)(this.readFileBuffered(s,r,A.CancellationToken.None));await this.doWriteUnbuffered(i,o,void 0,u)}throwIfFileSystemIsReadonly(s,r){if(s.capabilities&2048)throw new w.FileOperationError((0,y.localize)(25,null,this.resourceForError(r)),6);return s}throwIfFileIsReadonly(s,r){if((r.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,y.localize)(26,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===S.Schemas.file?s.fsPath:s.toString(!0)}};e.FileService=a,e.FileService=a=E=Ie([ie(0,c.ILogService)],a)}),define(se[94],oe([0,1,43,315,8,32,17,3,31,2,9,4,19,63,21,181,16,122,225,47,221,220]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y,w,m,c,v,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(n)}catch(s){console.error(`Error enabling graceful-fs: ${(0,v.toErrorMessage)(s)}`)}})();class t extends c.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new A.ResourceMap(o=>b.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,S.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:i,symbolicLink:o}=await d.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(i,o),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:w.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await d.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),o=[];return await Promise.all(i.map(async u=>{try{let p;u.isSymbolicLink()?p=(await this.stat((0,b.joinPath)(r,u.name))).type:p=this.toType(u),o.push([u.name,p])}catch(p){this.logService.trace(p)}})),o}catch(i){throw this.toFileSystemProviderError(i)}}toType(r,i){let o;return i?.dangling?o=w.FileType.Unknown:r.isFile()?o=w.FileType.File:r.isDirectory()?o=w.FileType.Directory:o=w.FileType.Unknown,i&&(o|=w.FileType.SymbolicLink),o}async createResourceLock(r){const i=this.toFilePath(r);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let o;for(;o=this.resourceLocks.get(r);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await o.wait();const u=new I.Barrier;return this.resourceLocks.set(r,u),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,l.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(r)===u&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(r)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),u.open()})}async readFile(r,i){let o;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(r)})`),o=await this.createResourceLock(r));const u=this.toFilePath(r);return await d.Promises.readFile(u)}catch(u){throw this.toFileSystemProviderError(u)}finally{o?.dispose()}}traceLock(r){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(r)}readFileStream(r,i,o){const u=(0,g.newWriteableStream)(p=>k.VSBuffer.concat(p.map(C=>k.VSBuffer.wrap(C))).buffer);return(0,m.readFileIntoStream)(this,r,u,p=>p.buffer,{...i,bufferSize:256*1024},o),u}async writeFile(r,i,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.canWriteFileAtomic(r)?this.doWriteFileAtomic(r,(0,b.joinPath)((0,b.dirname)(r),`${(0,b.basename)(r)}${o.atomic.postfix}`),i,o):this.doWriteFile(r,i,o)}async canWriteFileAtomic(r){try{const i=this.toFilePath(r),{symbolicLink:o}=await d.SymlinkSupport.stat(i);if(o)return!1}catch{}return!0}async doWriteFileAtomic(r,i,o,u){const p=new l.DisposableStore;try{p.add(await this.createResourceLock(r)),p.add(await this.createResourceLock(i)),await this.doWriteFile(i,o,u,!0);try{await this.rename(i,r,{overwrite:!0})}catch(C){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw C}}finally{p.dispose()}}async doWriteFile(r,i,o,u){let p;try{const C=this.toFilePath(r);if(!o.create||!o.overwrite){if(await d.Promises.exists(C)){if(!o.overwrite)throw(0,w.createFileSystemProviderError)((0,y.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,w.createFileSystemProviderError)((0,y.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(r,{create:!0,unlock:o.unlock},u),await this.write(p,0,i,0,i.byteLength)}catch(C){throw await this.toFileSystemProviderWriteError(r,C)}finally{typeof p=="number"&&await this.close(p)}}static{this.canFlush=!0}static configureFlushOnWrite(r){t.canFlush=r}async open(r,i,o){const u=this.toFilePath(r);let p;(0,w.isFileOpenForWriteOptions)(i)&&!o&&(p=await this.createResourceLock(r));let C;try{if((0,w.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:D}=await d.SymlinkSupport.stat(u);D.mode&128||await d.Promises.chmod(u,D.mode|128)}catch(D){D.code!=="ENOENT"&&this.logService.trace(D)}let M;if((0,w.isFileOpenForWriteOptions)(i)){if(S.isWindows)try{await d.Promises.truncate(u,0),M="r+"}catch(D){D.code!=="ENOENT"&&this.logService.trace(D)}M||(M="w")}else M="r";C=await d.Promises.open(u,M)}catch(M){throw p?.dispose(),(0,w.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(r,M):this.toFileSystemProviderError(M)}if(this.mapHandleToPos.set(C,0),(0,w.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(C,r),p){const M=this.mapHandleToLock.get(C);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${C} (${u})`),this.mapHandleToLock.set(C,p),M&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${C} (${u})`),M.dispose())}return C}async close(r){const i=this.mapHandleToLock.get(r);try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&t.canFlush)try{await d.Promises.fdatasync(r)}catch(o){t.configureFlushOnWrite(!1),this.logService.error(o)}return await d.Promises.close(r)}catch(o){throw this.toFileSystemProviderError(o)}finally{i&&(this.mapHandleToLock.get(r)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.mapHandleToLock.delete(r)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,o,u,p){const C=this.normalizePos(r,i);let M=null;try{M=(await d.Promises.read(r,o,u,p,C)).bytesRead}catch(D){throw this.toFileSystemProviderError(D)}finally{this.updatePos(r,C,M)}return M}normalizePos(r,i){return i===this.mapHandleToPos.get(r)?null:i}updatePos(r,i,o){const u=this.mapHandleToPos.get(r);typeof u=="number"&&(typeof i=="number"||(typeof o=="number"?this.mapHandleToPos.set(r,u+o):this.mapHandleToPos.delete(r)))}async write(r,i,o,u,p){return(0,I.retry)(()=>this.doWrite(r,i,o,u,p),100,3)}async doWrite(r,i,o,u,p){const C=this.normalizePos(r,i);let M=null;try{M=(await d.Promises.write(r,o,u,p,C)).bytesWritten}catch(D){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),D)}finally{this.updatePos(r,C,M)}return M}async mkdir(r){try{await d.Promises.mkdir(this.toFilePath(r))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(r,i){try{const o=this.toFilePath(r);if(i.recursive){let u;i?.atomic!==!1&&i.atomic.postfix&&(u=(0,f.join)((0,f.dirname)(o),`${(0,f.basename)(o)}${i.atomic.postfix}`)),await d.Promises.rm(o,d.RimRafMode.MOVE,u)}else try{await d.Promises.unlink(o)}catch(u){if(u.code==="EPERM"||u.code==="EISDIR"){let p=!1;try{const{stat:C,symbolicLink:M}=await d.SymlinkSupport.stat(o);p=C.isDirectory()&&!M}catch{}if(p)await d.Promises.rmdir(o);else throw u}else throw u}}catch(o){throw this.toFileSystemProviderError(o)}}async rename(r,i,o){const u=this.toFilePath(r),p=this.toFilePath(i);if(u!==p)try{await this.validateMoveCopy(r,i,"move",o.overwrite),await d.Promises.rename(u,p)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,y.localize)(2,null,(0,f.basename)(u),(0,f.basename)((0,f.dirname)(p)),C.toString()))),this.toFileSystemProviderError(C)}}async copy(r,i,o){const u=this.toFilePath(r),p=this.toFilePath(i);if(u!==p)try{await this.validateMoveCopy(r,i,"copy",o.overwrite),await d.Promises.copy(u,p,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,y.localize)(3,null,(0,f.basename)(u),(0,f.basename)((0,f.dirname)(p)),C.toString()))),this.toFileSystemProviderError(C)}}async validateMoveCopy(r,i,o,u){const p=this.toFilePath(r),C=this.toFilePath(i);let M=!1;if(!!(this.capabilities&1024)||(M=(0,h.isEqual)(p,C,!0)),M){if(o==="copy")throw(0,w.createFileSystemProviderError)((0,y.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const W=await this.statIgnoreError(r);if(!W)throw(0,w.createFileSystemProviderError)((0,y.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const O=await this.statIgnoreError(i);if(O){if(!u)throw(0,w.createFileSystemProviderError)((0,y.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);W.type&w.FileType.File&&O.type&w.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.doCloneFile(r,i,!1)}async doCloneFile(r,i,o){const u=this.toFilePath(r),p=this.toFilePath(i),C=!!(this.capabilities&1024);if((0,h.isEqual)(u,p,!C))return;const M=new l.DisposableStore;try{M.add(await this.createResourceLock(r)),M.add(await this.createResourceLock(i)),o&&await d.Promises.mkdir((0,f.dirname)(p),{recursive:!0}),await d.Promises.copyFile(u,p)}catch(D){if(D.code==="ENOENT"&&!o)return this.doCloneFile(r,i,!0);throw this.toFileSystemProviderError(D)}finally{M.dispose()}}createUniversalWatcher(r,i,o){return new E.UniversalWatcherClient(u=>r(u),u=>i(u),o)}createNonRecursiveWatcher(r,i,o){return new a.NodeJSWatcherClient(u=>r(u),u=>i(u),o)}toFileSystemProviderError(r){if(r instanceof w.FileSystemProviderError)return r;let i=r,o;switch(r.code){case"ENOENT":o=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=w.FileSystemProviderErrorCode.Unknown;break;default:o=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(i,o)}async toFileSystemProviderWriteError(r,i){let o=this.toFileSystemProviderError(i);if(r&&o.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await d.SymlinkSupport.stat(this.toFilePath(r));u.mode&128||(o=(0,w.createFileSystemProviderError)(i,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return o}}e.DiskFileSystemProvider=t}),define(se[227],oe([0,1,3,94,2,17,63,23]),function(Q,e,n,R,I,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class h extends I.Disposable{constructor(S,b){super(),this.provider=S,this.logService=b,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(S,b,g){const d=this.getUriTransformer(S);switch(b){case"stat":return this.stat(d,g[0]);case"readdir":return this.readdir(d,g[0]);case"open":return this.open(d,g[0],g[1]);case"close":return this.close(g[0]);case"read":return this.read(g[0],g[1],g[2]);case"readFile":return this.readFile(d,g[0],g[1]);case"write":return this.write(g[0],g[1],g[2],g[3],g[4]);case"writeFile":return this.writeFile(d,g[0],g[1],g[2]);case"rename":return this.rename(d,g[0],g[1],g[2]);case"copy":return this.copy(d,g[0],g[1],g[2]);case"cloneFile":return this.cloneFile(d,g[0],g[1]);case"mkdir":return this.mkdir(d,g[0]);case"delete":return this.delete(d,g[0],g[1]);case"watch":return this.watch(d,g[0],g[1],g[2],g[3]);case"unwatch":return this.unwatch(g[0],g[1])}throw new Error(`IPC Command ${b} not found`)}listen(S,b,g){const d=this.getUriTransformer(S);switch(b){case"fileChange":return this.onFileChange(d,g[0]);case"readFileStream":return this.onReadFileStream(d,g[0],g[1])}throw new Error(`Unknown event ${b}`)}stat(S,b){const g=this.transformIncoming(S,b,!0);return this.provider.stat(g)}readdir(S,b){const g=this.transformIncoming(S,b);return this.provider.readdir(g)}async readFile(S,b,g){const d=this.transformIncoming(S,b,!0),y=await this.provider.readFile(d,g);return A.VSBuffer.wrap(y)}onReadFileStream(S,b,g){const d=this.transformIncoming(S,b,!0),y=new P.CancellationTokenSource,w=new n.Emitter({onDidRemoveLastListener:()=>{y.cancel()}}),m=this.provider.readFileStream(d,g,y.token);return(0,k.listenStream)(m,{onData:c=>w.fire(A.VSBuffer.wrap(c)),onError:c=>w.fire(c),onEnd:()=>{w.fire("end"),w.dispose(),y.dispose()}}),w.event}writeFile(S,b,g,d){const y=this.transformIncoming(S,b);return this.provider.writeFile(y,g.buffer,d)}open(S,b,g){const d=this.transformIncoming(S,b,!0);return this.provider.open(d,g)}close(S){return this.provider.close(S)}async read(S,b,g){const d=A.VSBuffer.alloc(g),w=await this.provider.read(S,b,d.buffer,0,g);return[d,w]}write(S,b,g,d,y){return this.provider.write(S,b,g.buffer,d,y)}mkdir(S,b){const g=this.transformIncoming(S,b);return this.provider.mkdir(g)}delete(S,b,g){const d=this.transformIncoming(S,b);return this.provider.delete(d,g)}rename(S,b,g,d){const y=this.transformIncoming(S,b),w=this.transformIncoming(S,g);return this.provider.rename(y,w,d)}copy(S,b,g,d){const y=this.transformIncoming(S,b),w=this.transformIncoming(S,g);return this.provider.copy(y,w,d)}cloneFile(S,b,g){const d=this.transformIncoming(S,b),y=this.transformIncoming(S,g);return this.provider.cloneFile(d,y)}onFileChange(S,b){const g=new n.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(b,this.createSessionFileWatcher(S,g))},onDidRemoveLastListener:()=>{(0,I.dispose)(this.sessionToWatcher.get(b)),this.sessionToWatcher.delete(b)}});return g.event}async watch(S,b,g,d,y){const w=this.sessionToWatcher.get(b);if(w){const m=this.transformIncoming(S,d),c=w.watch(g,m,y);this.watchRequests.set(b+g,c)}}async unwatch(S,b){const g=S+b,d=this.watchRequests.get(g);d&&((0,I.dispose)(d),this.watchRequests.delete(g))}dispose(){super.dispose();for(const[,S]of this.watchRequests)S.dispose();this.watchRequests.clear();for(const[,S]of this.sessionToWatcher)S.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=h;class l extends I.Disposable{constructor(S,b,g,d){super(),this.uriTransformer=S,this.logService=g,this.environmentService=d,this.watcherRequests=new Map,this.fileWatcher=this._register(new R.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(b)}registerListeners(S){const b=this._register(new n.Emitter);this._register(b.event(g=>{S.fire(g.map(d=>({resource:this.uriTransformer.transformOutgoingURI(d.resource),type:d.type,cId:d.cId})))})),this._register(this.fileWatcher.onDidChangeFile(g=>b.fire(g))),this._register(this.fileWatcher.onDidWatchError(g=>S.fire(g)))}getRecursiveWatcherOptions(S){}getExtraExcludes(S){}watch(S,b,g){const d=this.getExtraExcludes(this.environmentService);return Array.isArray(d)&&(g.excludes=[...g.excludes,...d]),this.watcherRequests.set(S,this.fileWatcher.watch(b,g)),(0,I.toDisposable)(()=>{(0,I.dispose)(this.watcherRequests.get(S)),this.watcherRequests.delete(S)})}dispose(){for(const[,S]of this.watcherRequests)S.dispose();this.watcherRequests.clear(),super.dispose()}}e.AbstractSessionFileWatcher=l}),define(se[228],oe([0,1,14,180,4,7,16,9,227,157,47]),function(Q,e,n,R,I,A,k,P,h,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class S extends h.AbstractDiskFileSystemProviderChannel{constructor(d,y,w){super(d,y),this.environmentService=w}getUriTransformer(d){return l.DefaultURITransformer}transformIncoming(d,y){return A.URI.revive(y)}async delete(d,y,w){if(!w.useTrash)return super.delete(d,y,w);const m=this.transformIncoming(d,y),c=(0,P.normalize)(m.fsPath);try{await n.shell.trashItem(c)}catch(v){throw(0,k.createFileSystemProviderError)(I.isWindows?(0,R.localize)(0,null,(0,P.basename)(c),(0,f.toErrorMessage)(v)):(0,R.localize)(1,null,(0,P.basename)(c),(0,f.toErrorMessage)(v)),k.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(d,y){return new b(d,y,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=S;class b extends h.AbstractSessionFileWatcher{watch(d,y,w){if(w.recursive)throw(0,k.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",k.FileSystemProviderErrorCode.Unavailable);return super.watch(d,y,w)}}}),define(se[229],oe([0,1,5]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class R extends n.AbstractMessageLogger{constructor(A=n.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(A),this._register(this.onDidChangeLogLevel(k=>{this._logger?.setLevel(k)}))}set logger(A){this._logger=A;for(const{level:k,message:P}of this.buffer)(0,n.log)(A,k,P);this.buffer=[]}log(A,k){this._logger?(0,n.log)(this._logger,A,k):this.getLevel()<=A&&this.buffer.push({level:A,message:k})}dispose(){this._logger?.dispose(),super.dispose()}flush(){this._logger?.flush()}}e.BufferLogger=R}),define(se[230],oe([0,1,7,3,5,2]),function(Q,e,n,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class k extends I.AbstractLoggerService{constructor(S,b,g,d,y){super(b,g,d),this.windowId=S,this.channel=y,this._register(y.listen("onDidChangeLogLevel",S)(w=>{(0,I.isLogLevel)(w)?super.setLogLevel(w):super.setLogLevel(n.URI.revive(w[0]),w[1])})),this._register(y.listen("onDidChangeVisibility",S)(([w,m])=>super.setVisibility(n.URI.revive(w),m))),this._register(y.listen("onDidChangeLoggers",S)(({added:w,removed:m})=>{for(const c of w)super.registerLogger({...c,resource:n.URI.revive(c.resource)});for(const c of m)super.deregisterLogger(c.resource)}))}createConsoleMainLogger(){return new I.AdapterLogger({log:(S,b)=>{this.channel.call("consoleLog",[S,b])}})}registerLogger(S){super.registerLogger(S),this.channel.call("registerLogger",[S,this.windowId])}deregisterLogger(S){super.deregisterLogger(S),this.channel.call("deregisterLogger",[S,this.windowId])}setLogLevel(S,b){super.setLogLevel(S,b),this.channel.call("setLogLevel",[S,b])}setVisibility(S,b){super.setVisibility(S,b),this.channel.call("setVisibility",[this.toResource(S),b])}doCreateLogger(S,b,g){return new P(this.channel,S,b,g,this.windowId)}static setLogLevel(S,b,g){return S.call("setLogLevel",[b,g])}}e.LoggerChannelClient=k;class P extends I.AbstractMessageLogger{constructor(S,b,g,d,y){super(d?.logLevel==="always"),this.channel=S,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(g),this.channel.call("createLogger",[b,d,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,b){const g=[[S,b]];this.isLoggerCreated?this.doLog(g):this.buffer.push(...g)}doLog(S){this.channel.call("log",[this.file,S])}}class h{constructor(S,b){this.loggerService=S,this.getUriTransformer=b}listen(S,b){const g=this.getUriTransformer(S);switch(b){case"onDidChangeLoggers":return R.Event.map(this.loggerService.onDidChangeLoggers,d=>({added:[...d.added].map(y=>this.transformLogger(y,g)),removed:[...d.removed].map(y=>this.transformLogger(y,g))}));case"onDidChangeVisibility":return R.Event.map(this.loggerService.onDidChangeVisibility,d=>[g.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return R.Event.map(this.loggerService.onDidChangeLogLevel,d=>(0,I.isLogLevel)(d)?d:[g.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${b}`)}async call(S,b,g){const d=this.getUriTransformer(S);switch(b){case"setLogLevel":return(0,I.isLogLevel)(g[0])?this.loggerService.setLogLevel(g[0]):this.loggerService.setLogLevel(n.URI.revive(d.transformIncoming(g[0][0])),g[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(y=>this.transformLogger(y,d)))}throw new Error(`Call not found: ${b}`)}transformLogger(S,b){return{...S,resource:b.transformOutgoingURI(S.resource)}}}e.LoggerChannel=h;class l extends A.Disposable{constructor(S,b){super(),b.call("setLogLevel",[S.getLogLevel()]),this._register(S.onDidChangeLogLevel(g=>b.call("setLogLevel",[g]))),b.call("getRegisteredLoggers").then(g=>{for(const d of g)S.registerLogger({...d,resource:n.URI.revive(d.resource)})}),this._register(b.listen("onDidChangeVisibility")(([g,d])=>S.setVisibility(n.URI.revive(g),d))),this._register(b.listen("onDidChangeLoggers")(({added:g,removed:d})=>{for(const y of g)S.registerLogger({...y,resource:n.URI.revive(y.resource)});for(const y of d)S.deregisterLogger(y.resource)}))}}e.RemoteLoggerChannelClient=l}),define(se[231],oe([0,1,2,5]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class I extends n.Disposable{constructor(k,P=[]){super(),this.logger=new R.MultiplexLogger([k,...P]),this._register(k.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(k){this.logger.setLevel(k)}getLevel(){return this.logger.getLevel()}trace(k,...P){this.logger.trace(k,...P)}debug(k,...P){this.logger.debug(k,...P)}info(k,...P){this.logger.info(k,...P)}warn(k,...P){this.logger.warn(k,...P)}error(k,...P){this.logger.error(k,...P)}flush(){this.logger.flush()}}e.LogService=I}),define(se[232],oe([0,1,32,7,5]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class A{constructor(P){this.loggerService=P,this.loggers=new n.ResourceMap}listen(P,h,l){switch(h){case"onDidChangeLoggers":return l?this.loggerService.getOnDidChangeLoggersEvent(l):this.loggerService.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.loggerService.getOnDidChangeLogLevelEvent(l):this.loggerService.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.loggerService.getOnDidChangeVisibilityEvent(l):this.loggerService.onDidChangeVisibility}throw new Error(`Event not found: ${h}`)}async call(P,h,l){switch(h){case"createLogger":this.createLogger(R.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.log(R.URI.revive(l[0]),l[1]);case"consoleLog":return this.consoleLog(l[0],l[1]);case"setLogLevel":return(0,I.isLogLevel)(l[0])?this.loggerService.setLogLevel(l[0]):this.loggerService.setLogLevel(R.URI.revive(l[0]),l[1]);case"setVisibility":return this.loggerService.setVisibility(R.URI.revive(l[0]),l[1]);case"registerLogger":return this.loggerService.registerLogger({...l[0],resource:R.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.loggerService.deregisterLogger(R.URI.revive(l[0]))}throw new Error(`Call not found: ${h}`)}createLogger(P,h,l){this.loggers.set(P,this.loggerService.createLogger(P,h,l))}consoleLog(P,h){let l=console.log;switch(P){case I.LogLevel.Error:l=console.error;break;case I.LogLevel.Warning:l=console.warn;break;case I.LogLevel.Info:l=console.info;break}l.call(console,...h)}log(P,h){const l=this.loggers.get(P);if(!l)throw new Error("Create the logger before logging");for(const[f,S]of h)(0,I.log)(l,f,S)}}e.LoggerChannel=A}),define(se[233],oe([0,1,16,5]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var I;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(I||(I={}));async function A(l,f,S,b,g){try{const d=await new Promise((w,m)=>{Q(["@vscode/spdlog"],w,m)});d.setFlushOn(I.Trace);const y=await d.createAsyncRotatingLogger(l,f,S,b);return g?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(d){console.error(d)}return null}function k(l,f,S){switch(f){case R.LogLevel.Trace:l.trace(S);break;case R.LogLevel.Debug:l.debug(S);break;case R.LogLevel.Info:l.info(S);break;case R.LogLevel.Warning:l.warn(S);break;case R.LogLevel.Error:l.error(S);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${f}`)}}function P(l,f){switch(f){case R.LogLevel.Trace:l.setLevel(I.Trace);break;case R.LogLevel.Debug:l.setLevel(I.Debug);break;case R.LogLevel.Info:l.setLevel(I.Info);break;case R.LogLevel.Warning:l.setLevel(I.Warning);break;case R.LogLevel.Error:l.setLevel(I.Error);break;case R.LogLevel.Off:l.setLevel(I.Off);break;default:throw new Error(`Invalid log level ${f}`)}}class h extends R.AbstractMessageLogger{constructor(f,S,b,g,d){super(),this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(f,S,b,g),this._register(this.onDidChangeLogLevel(y=>{this._logger&&P(this._logger,y)}))}async _createSpdLogLogger(f,S,b,g){const d=b?6:1,y=30/d*n.ByteSize.MB,w=await A(f,S,y,d,g);if(w){this._logger=w,P(this._logger,this.getLevel());for(const{level:m,message:c}of this.buffer)k(this._logger,m,c);this.buffer=[]}}log(f,S){this._logger?k(this._logger,f,S):this.getLevel()<=f&&this.buffer.push({level:f,message:S})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=h}),define(se[234],oe([0,1,33,5,233]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class A extends R.AbstractLoggerService{doCreateLogger(P,h,l){return new I.SpdLogLogger((0,n.generateUuid)(),P.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,h)}}e.LoggerService=A}),define(se[67],oe([0,1,32,3,6,5,234]),function(Q,e,n,R,I,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,I.refineServiceDecorator)(A.ILoggerService);class P extends k.LoggerService{constructor(){super(...arguments),this.loggerResourcesByWindow=new n.ResourceMap}createLogger(l,f,S){S!==void 0&&this.loggerResourcesByWindow.set(this.toResource(l),S);try{return super.createLogger(l,f)}catch(b){throw this.loggerResourcesByWindow.delete(this.toResource(l)),b}}registerLogger(l,f){f!==void 0&&this.loggerResourcesByWindow.set(l.resource,f),super.registerLogger(l)}deregisterLogger(l){this.loggerResourcesByWindow.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const f=[];for(const S of super.getRegisteredLoggers())l===this.loggerResourcesByWindow.get(S.resource)&&f.push(S);return f}getOnDidChangeLogLevelEvent(l){return R.Event.filter(this.onDidChangeLogLevel,f=>(0,A.isLogLevel)(f)||this.isInterestedLoggerResource(f[0],l))}getOnDidChangeVisibilityEvent(l){return R.Event.filter(this.onDidChangeVisibility,([f])=>this.isInterestedLoggerResource(f,l))}getOnDidChangeLoggersEvent(l){return R.Event.filter(R.Event.map(this.onDidChangeLoggers,f=>({added:[...f.added].filter(b=>this.isInterestedLoggerResource(b.resource,l)),removed:[...f.removed].filter(b=>this.isInterestedLoggerResource(b.resource,l))})),f=>f.added.length>0||f.removed.length>0)}deregisterLoggers(l){for(const[f,S]of this.loggerResourcesByWindow)S===l&&this.deregisterLogger(f)}isInterestedLoggerResource(l,f){const S=this.loggerResourcesByWindow.get(l);return S===void 0||S===f}dispose(){super.dispose(),this.loggerResourcesByWindow.clear()}}e.LoggerMainService=P}),define(se[235],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemSubmenu=n,e.isMenubarMenuItemSeparator=R,e.isMenubarMenuItemRecentAction=I,e.isMenubarMenuItemAction=A;function n(k){return k.submenu!==void 0}function R(k){return k.id==="vscode.menubar.separator"}function I(k){return k.uri!==void 0}function A(k){return!n(k)&&!R(k)&&!I(k)}}),define(se[39],oe([0,1,3,71,2,6]),function(Q,e,n,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class k extends I.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(l){const f=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...l,...this.policyDefinitions},f!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(l),R.Iterable.reduce(this.policies.entries(),(S,[b,g])=>({...S,[b]:g}),{})}getPolicyValue(l){return this.policies.get(l)}serialize(){return R.Iterable.reduce(Object.entries(this.policyDefinitions),(l,[f,S])=>({...l,[f]:{definition:S,value:this.policies.get(f)}}),{})}}e.AbstractPolicyService=k;class P{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(se[236],oe([0,1,8,3,71,12,16,5,39]),function(Q,e,n,R,I,A,k,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function l(S,b){const g=[];for(const d of new Set(I.Iterable.concat(S.keys(),b.keys())))S.get(d)!==b.get(d)&&g.push(d);return g}let f=class extends h.AbstractPolicyService{constructor(b,g,d){super(),this.file=b,this.fileService=g,this.logService=d,this.throttledDelayer=this._register(new n.ThrottledDelayer(500));const y=R.Event.filter(g.onDidFilesChange,w=>w.affects(b));this._register(g.watch(b)),this._register(y(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const b=new Map;try{const g=await this.fileService.readFile(this.file),d=JSON.parse(g.value.toString());if(!(0,A.isObject)(d))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(d))this.policyDefinitions[y]&&b.set(y,d[y])}catch(g){g.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",g)}return b}async refresh(){const b=await this.read(),g=l(this.policies,b);this.policies=b,g.length>0&&this._onDidChange.fire(g)}};e.FilePolicyService=f,e.FilePolicyService=f=Ie([ie(1,k.IFileService),ie(2,P.ILogService)],f)}),define(se[237],oe([0,1,3,2,39]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(h){this.service=h,this.disposables=new R.DisposableStore}listen(h,l){switch(l){case"onDidChange":return n.Event.map(this.service.onDidChange,f=>f.reduce((S,b)=>({...S,[b]:this.service.getPolicyValue(b)??null}),{}),this.disposables)}throw new Error(`Event not found: ${l}`)}call(h,l,f){switch(l){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(f)}throw new Error(`Call not found: ${l}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=A;class k extends I.AbstractPolicyService{constructor(h,l){super(),this.channel=l;for(const f in h){const{definition:S,value:b}=h[f];this.policyDefinitions[f]=S,b!==void 0&&this.policies.set(f,b)}this.channel.listen("onDidChange")(f=>{for(const S in f){const b=f[S];b===null?this.policies.delete(S):this.policies.set(S,b)}this._onDidChange.fire(Object.keys(f))})}async _updatePolicyDefinitions(h){const l=await this.channel.call("updatePolicyDefinitions",h);for(const f in l)this.policies.set(f,l[f])}}e.PolicyChannelClient=k}),define(se[238],oe([0,1,39,8,2,5]),function(Q,e,n,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let k=class extends n.AbstractPolicyService{constructor(h,l){super(),this.logService=h,this.productName=l,this.throttler=new R.Throttler,this.watcher=this._register(new I.MutableDisposable)}async _updatePolicyDefinitions(h){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`);const{createWatcher:l}=await new Promise((f,S)=>{Q(["@vscode/policy-watcher"],f,S)});await this.throttler.queue(()=>new Promise((f,S)=>{try{this.watcher.value=l(this.productName,h,b=>{this._onDidPolicyChange(b),f()})}catch(b){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",b),S(b)}}))}_onDidPolicyChange(h){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const l in h){const f=h[l];f===void 0?this.policies.delete(l):this.policies.set(l,f)}this._onDidChange.fire(Object.keys(h))}};e.NativePolicyService=k,e.NativePolicyService=k=Ie([ie(0,A.ILogService)],k)}),define(se[80],oe([0,1,36]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;const I=globalThis.vscode;if(typeof I<"u"&&typeof I.context<"u"){const A=I.context.configuration();if(A)R=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){R=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:A,searchUrl:k,itemUrl:P,controlUrl:h}=R.extensionsGallery||{};Object.assign(R,{extensionsGallery:{serviceUrl:n.env.VSCODE_GALLERY_SERVICE_URL||A,searchUrl:n.env.VSCODE_GALLERY_SEARCH_URL||k,itemUrl:n.env.VSCODE_GALLERY_ITEM_URL||P,controlUrl:n.env.VSCODE_GALLERY_CONTROL_URL||h}});try{const l=(...S)=>S.reduce((b,g)=>(Object.keys(g).forEach(d=>{Array.isArray(b[d])&&Array.isArray(g[d])?b[d]=g[d]:typeof b[d]=="object"&&typeof g[d]=="object"?b[d]=l(b[d],g[d]):b[d]=g[d]}),b),{}),f=globalThis._VSCODE_USER_PRODUCT_JSON||{};R=l(R,f)}catch{}if(n.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`,serverDataFolderName:R.serverDataFolderName?`${R.serverDataFolderName}-dev`:void 0}),!R.version){const l=globalThis._VSCODE_PACKAGE_JSON;Object.assign(R,{version:l.version,release:l.release})}}else R={},Object.keys(R).length===0&&Object.assign(R,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=R}),define(se[27],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,n.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(se[239],oe([0,1,8,5]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let I=class{constructor(k,P,h){this._window=k,this._sessionId=P,this._logService=h}async inspect(k){await this._connect();const P=this._window.webContents.debugger;await P.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,n.timeout)(k);const h=await P.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),h.profile}async _connect(){const k=this._window.webContents.debugger;k.attach(),await k.sendCommand("Profiler.enable")}async _disconnect(){const k=this._window.webContents.debugger;await k.sendCommand("Profiler.disable"),k.detach()}};e.WindowProfiler=I,e.WindowProfiler=I=Ie([ie(2,R.ILogService)],I)}),define(se[81],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,n.createDecorator)("protocolMainService")}),define(se[45],oe([0,1,139,12]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(k,P){n.ok(R.isString(k)),n.ok(R.isObject(P)),n.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,P)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new I}),define(se[240],oe([0,1,3,45]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this._onDidChangeSchema=new n.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,l){this.schemasById[I(h)]=l,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new A;R.Registry.add(e.Extensions.JSONContribution,k)}),define(se[52],oe([0,1,22,3,12,165,18,240,45]),function(Q,e,n,R,I,A,k,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=y,e.keyFromOverrideIdentifiers=w,e.getDefaultValue=m,e.validateProperty=v,e.getScopes=E;var l;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.Extensions={Configuration:"base.contributions.configuration"};var f;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f||(e.ConfigurationScope=f={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=h.Registry.as(P.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const r=new Set;this.doRegisterConfigurations(t,s,r),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(t){const s=new Set;this.doDeregisterConfigurations(t,s),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:t,remove:s}){const r=new Set;this.doDeregisterConfigurations(s,r),this.doRegisterConfigurations(t,!1,r),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}registerDefaultConfigurations(t){const s=new Set;this.doRegisterDefaultConfigurations(t,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,s){const r=[];for(const{overrides:i,source:o}of t)for(const u in i)if(s.add(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const p=this.configurationDefaultsOverrides.get(u),C=p?.valuesSources??new Map;if(o)for(const O of Object.keys(i[u]))C.set(O,o);const M={...p?.value||{},...i[u]};this.configurationDefaultsOverrides.set(u,{source:o,value:M,valuesSources:C});const D=(0,k.getLanguageTagSettingPlainKey)(u),W={type:"object",default:M,description:A.localize(1,null,D),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:I.isString(o)?void 0:o,defaultValueSource:o};r.push(...y(u)),this.configurationProperties[u]=W,this.defaultLanguageConfigurationOverridesNode.properties[u]=W}else{this.configurationDefaultsOverrides.set(u,{value:i[u],source:o});const p=this.configurationProperties[u];p&&(this.updatePropertyDefaultValue(u,p),this.updateSchema(u,p))}this.doRegisterOverrideIdentifiers(r)}deregisterDefaultConfigurations(t){const s=new Set;this.doDeregisterDefaultConfigurations(t,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,s){for(const{overrides:r,source:i}of t)for(const o in r){const u=this.configurationDefaultsOverrides.get(o),p=I.isString(i)?i:i?.id,C=I.isString(u?.source)?u?.source:u?.source?.id;if(p===C)if(s.add(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const M=this.configurationProperties[o];M&&(this.updatePropertyDefaultValue(o,M),this.updateSchema(o,M))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let s=!1;const r=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,r),s=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,r),s=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,r),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const s of t)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,s,r){t.forEach(i=>{this.validateAndRegisterProperties(i,s,i.extensionInfo,i.restrictedProperties,void 0,r),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(t,s){const r=i=>{if(i.properties)for(const o in i.properties){s.add(o);const u=this.configurationProperties[o];u?.policy?.name&&this.policyConfigurations.delete(u.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,i.properties[o])}i.allOf?.forEach(o=>r(o))};for(const i of t){r(i);const o=this.configurationContributors.indexOf(i);o!==-1&&this.configurationContributors.splice(o,1)}}validateAndRegisterProperties(t,s=!0,r,i,o=3,u){o=I.isUndefinedOrNull(t.scope)?o:t.scope;const p=t.properties;if(p)for(const M in p){const D=p[M];if(s&&v(M,D)){delete p[M];continue}if(D.source=r,D.defaultDefaultValue=p[M].default,this.updatePropertyDefaultValue(M,D),e.OVERRIDE_PROPERTY_REGEX.test(M)?D.scope=void 0:(D.scope=I.isUndefinedOrNull(D.scope)?o:D.scope,D.restricted=I.isUndefinedOrNull(D.restricted)?!!i?.includes(M):D.restricted),p[M].hasOwnProperty("included")&&!p[M].included){this.excludedConfigurationProperties[M]=p[M],delete p[M];continue}else this.configurationProperties[M]=p[M],p[M].policy?.name&&this.policyConfigurations.set(p[M].policy.name,M);!p[M].deprecationMessage&&p[M].markdownDeprecationMessage&&(p[M].deprecationMessage=p[M].markdownDeprecationMessage),u.add(M)}const C=t.allOf;if(C)for(const M of C)this.validateAndRegisterProperties(M,s,r,i,o,u)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const s=r=>{const i=r.properties;if(i)for(const u in i)this.updateSchema(u,i[u]);r.allOf?.forEach(s)};s(t)}updateSchema(t,s){switch(e.allSettings.properties[t]=s,s.scope){case 1:e.applicationSettings.properties[t]=s;break;case 2:e.machineSettings.properties[t]=s;break;case 6:e.machineOverridableSettings.properties[t]=s;break;case 3:e.windowSettings.properties[t]=s;break;case 4:e.resourceSettings.properties[t]=s;break;case 5:e.resourceSettings.properties[t]=s,this.resourceLanguageSettingsSchema.properties[t]=s;break}}removeFromSchema(t,s){switch(delete e.allSettings.properties[t],s.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const s=`[${t}]`,r={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,r),e.allSettings.properties[s]=r,e.applicationSettings.properties[s]=r,e.machineSettings.properties[s]=r,e.machineOverridableSettings.properties[s]=r,e.windowSettings.properties[s]=r,e.resourceSettings.properties[s]=r}}registerOverridePropertyPatternKey(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,s){const r=this.configurationDefaultsOverrides.get(t);let i=r?.value,o=r?.source;I.isUndefined(i)&&(i=s.defaultDefaultValue,o=void 0),I.isUndefined(i)&&(i=m(s.type)),s.default=i,s.defaultValueSource=o}}const g="\\[([^\\]]+)\\]",d=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(a){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let s=d.exec(a);for(;s?.length;){const r=s[1].trim();r&&t.push(r),s=d.exec(a)}}return(0,n.distinct)(t)}function w(a){return a.reduce((t,s)=>`${t}[${s}]`,"")}function m(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const c=new b;h.Registry.add(e.Extensions.Configuration,c);function v(a,t){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?A.localize(7,null,a):c.getConfigurationProperties()[a]!==void 0?A.localize(8,null,a):t.policy?.name&&c.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,a,t.policy?.name,c.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}function E(){const a=[],t=c.getConfigurationProperties();for(const s of Object.keys(t))a.push([s,t[s].scope]);return a.push(["launch",4]),a.push(["task",4]),a}}),define(se[123],oe([0,1,22,3,42,2,32,35,12,7,18,52,45]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=v;function g(s){return Object.isFrozen(s)?s:P.deepFreeze(s)}class d{static createEmptyModel(r){return new d({},[],[],void 0,r)}constructor(r,i,o,u,p){this._contents=r,this._keys=i,this._overrides=o,this.raw=u,this.logService=p,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof d)return i;const o=new y("",this.logService);return o.parseRaw(i),o.configurationModel});this._rawConfiguration=r.reduce((i,o)=>o===i?o:i.merge(o),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,f.getConfigurationValue)(this.contents,r):this.contents}inspect(r,i){const o=this;return{get value(){return g(o.rawConfiguration.getValue(r))},get override(){return i?g(o.rawConfiguration.getOverrideValue(r,i)):void 0},get merged(){return g(i?o.rawConfiguration.override(i).getValue(r):o.rawConfiguration.getValue(r))},get overrides(){const u=[];for(const{contents:p,identifiers:C,keys:M}of o.rawConfiguration.overrides){const D=new d(p,M,[],void 0,o.logService).getValue(r);D!==void 0&&u.push({identifiers:C,value:D})}return u.length?g(u):void 0}}}getOverrideValue(r,i){const o=this.getContentsForOverrideIdentifer(i);return o?r?(0,f.getConfigurationValue)(o,r):o:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const o of this.overrides)o.identifiers.includes(r)&&i.push(...o.keys);return n.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return n.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=P.deepClone(this.contents),o=P.deepClone(this.overrides),u=[...this.keys],p=this.raw?.length?[...this.raw]:[this];for(const C of r)if(p.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.mergeContents(i,C.contents);for(const M of C.overrides){const[D]=o.filter(W=>n.equals(W.identifiers,M.identifiers));D?(this.mergeContents(D.contents,M.contents),D.keys.push(...M.keys),D.keys=n.distinct(D.keys)):o.push(P.deepClone(M))}for(const M of C.keys)u.indexOf(M)===-1&&u.push(M)}return new d(i,u,o,p.every(C=>C instanceof d)?void 0:p,this.logService)}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const o={};for(const u of n.distinct([...Object.keys(this.contents),...Object.keys(i)])){let p=this.contents[u];const C=i[u];C&&(typeof p=="object"&&typeof C=="object"?(p=P.deepClone(p),this.mergeContents(p,C)):p=C),o[u]=p}return new d(o,this.keys,this.overrides,void 0,this.logService)}mergeContents(r,i){for(const o of Object.keys(i)){if(o in r&&h.isObject(r[o])&&h.isObject(i[o])){this.mergeContents(r[o],i[o]);continue}r[o]=P.deepClone(i[o])}}getContentsForOverrideIdentifer(r){let i=null,o=null;const u=p=>{p&&(o?this.mergeContents(o,p):o=P.deepClone(p))};for(const p of this.overrides)p.identifiers.length===1&&p.identifiers[0]===r?i=p.contents:p.identifiers.includes(r)&&u(p.contents);return u(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.updateValue(r,i,!0)}setValue(r,i){this.updateValue(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,f.removeFromValueTree)(this.contents,r),S.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(o=>n.equals(o.identifiers,(0,S.overrideIdentifiersFromKey)(r))),1))}updateValue(r,i,o){(0,f.addToValueTree)(this.contents,r,i,u=>this.logService.error(u)),o=o||this.keys.indexOf(r)===-1,o&&this.keys.push(r),S.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,S.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,f.toValuesTree)(this.contents[r],u=>this.logService.error(u))})}}e.ConfigurationModel=d;class y{constructor(r,i){this._name=r,this.logService=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||d.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!h.isUndefinedOrNull(r)){const o=this.doParseContent(r);this.parseRaw(o,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:o,keys:u,overrides:p,restricted:C,hasExcludedProperties:M}=this.doParseRaw(r,i);this._configurationModel=new d(o,u,p,M?[r]:void 0,this.logService),this._restrictedConfigurations=C||[]}doParseContent(r){let i={},o=null,u=[];const p=[],C=[];function M(W){Array.isArray(u)?u.push(W):o!==null&&(u[o]=W)}const D={onObjectBegin:()=>{const W={};M(W),p.push(u),u=W,o=null},onObjectProperty:W=>{o=W},onObjectEnd:()=>{u=p.pop()},onArrayBegin:()=>{const W=[];M(W),p.push(u),u=W,o=null},onArrayEnd:()=>{u=p.pop()},onLiteralValue:M,onError:(W,O,_)=>{C.push({error:W,offset:O,length:_})}};if(r)try{I.visit(r,D),i=u[0]||{}}catch(W){this.logService.error(`Error while parsing settings file ${this._name}: ${W}`),this._parseErrors=[W]}return i}doParseRaw(r,i){const o=b.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),u=this.filter(r,o,!0,i);r=u.raw;const p=(0,f.toValuesTree)(r,D=>this.logService.error(`Conflict in settings file ${this._name}: ${D}`)),C=Object.keys(r),M=this.toOverrides(r,D=>this.logService.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:p,keys:C,overrides:M,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}filter(r,i,o,u){let p=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:p};const C={},M=[];for(const D in r)if(S.OVERRIDE_PROPERTY_REGEX.test(D)&&o){const W=this.filter(r[D],i,!1,u);C[D]=W.raw,p=p||W.hasExcludedProperties,M.push(...W.restricted)}else{const W=i[D],O=W?typeof W.scope<"u"?W.scope:3:void 0;W?.restricted&&M.push(D),!u.exclude?.includes(D)&&(u.include?.includes(D)||(O===void 0||u.scopes===void 0||u.scopes.includes(O))&&!(u.skipRestricted&&W?.restricted))?C[D]=r[D]:p=!0}return{raw:C,restricted:M,hasExcludedProperties:p}}toOverrides(r,i){const o=[];for(const u of Object.keys(r))if(S.OVERRIDE_PROPERTY_REGEX.test(u)){const p={};for(const C in r[u])p[C]=r[u][C];o.push({identifiers:(0,S.overrideIdentifiersFromKey)(u),keys:Object.keys(p),contents:(0,f.toValuesTree)(p,i)})}return o}}e.ConfigurationModelParser=y;class w extends A.Disposable{constructor(r,i,o,u,p){super(),this.userSettingsResource=r,this.parseOptions=i,this.fileService=u,this.logService=p,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString(),p),this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.any(R.Event.filter(this.fileService.onDidFilesChange,C=>C.contains(this.userSettingsResource)),R.Event.filter(this.fileService.onDidRunOperation,C=>(C.isOperation(0)||C.isOperation(3)||C.isOperation(1)||C.isOperation(4))&&o.isEqual(C.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return d.createEmptyModel(this.logService)}}reparse(r){return r&&(this.parseOptions=r),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class m{constructor(r,i,o,u,p,C,M,D,W,O,_,F,x){this.key=r,this.overrides=i,this._value=o,this.overrideIdentifiers=u,this.defaultConfiguration=p,this.policyConfiguration=C,this.applicationConfiguration=M,this.userConfiguration=D,this.localUserConfiguration=W,this.remoteUserConfiguration=O,this.workspaceConfiguration=_,this.folderConfigurationModel=F,this.memoryConfigurationModel=x}get value(){return g(this._value)}toInspectValue(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class c{constructor(r,i,o,u,p,C,M,D,W,O){this._defaultConfiguration=r,this._policyConfiguration=i,this._applicationConfiguration=o,this._localUserConfiguration=u,this._remoteUserConfiguration=p,this._workspaceConfiguration=C,this._folderConfigurations=M,this._memoryConfiguration=D,this._memoryConfigurationByResource=W,this.logService=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(r,i,o){return this.getConsolidatedConfigurationModel(r,i,o).getValue(r)}updateValue(r,i,o={}){let u;o.resource?(u=this._memoryConfigurationByResource.get(o.resource),u||(u=d.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(o.resource,u))):u=this._memoryConfiguration,i===void 0?u.removeValue(r):u.setValue(r,i),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,o){const u=this.getConsolidatedConfigurationModel(r,i,o),p=this.getFolderConfigurationModelForResource(i.resource,o),C=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,M=new Set;for(const D of u.overrides)for(const W of D.identifiers)u.getOverrideValue(r,W)!==void 0&&M.add(W);return new m(r,i,u.getValue(r),M.size?[...M]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this._workspaceConfiguration:void 0,p||void 0,C)}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const o=[];if(!i){const{added:u,updated:p,removed:C}=a(this._defaultConfiguration,r);i=[...u,...p,...C]}for(const u of i)for(const p of(0,S.overrideIdentifiersFromKey)(u)){const C=this._defaultConfiguration.getKeysForOverrideIdentifier(p),M=r.getKeysForOverrideIdentifier(p),D=[...M.filter(W=>C.indexOf(W)===-1),...C.filter(W=>M.indexOf(W)===-1),...C.filter(W=>!P.equals(this._defaultConfiguration.override(p).getValue(W),r.override(p).getValue(W)))];o.push([p,D])}return this.updateDefaultConfiguration(r),{keys:i,overrides:o}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:o,removed:u}=a(this._policyConfiguration,r),p=[...i,...o,...u];return p.length&&this.updatePolicyConfiguration(r),{keys:p,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:o,removed:u,overrides:p}=a(this.applicationConfiguration,r),C=[...i,...o,...u];return C.length&&this.updateApplicationConfiguration(r),{keys:C,overrides:p}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:o,removed:u,overrides:p}=a(this.localUserConfiguration,r),C=[...i,...o,...u];return C.length&&this.updateLocalUserConfiguration(r),{keys:C,overrides:p}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:o,removed:u,overrides:p}=a(this.remoteUserConfiguration,r),C=[...i,...o,...u];return C.length&&this.updateRemoteUserConfiguration(r),{keys:C,overrides:p}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:o,removed:u,overrides:p}=a(this.workspaceConfiguration,r),C=[...i,...o,...u];return C.length&&this.updateWorkspaceConfiguration(r),{keys:C,overrides:p}}compareAndUpdateFolderConfiguration(r,i){const o=this.folderConfigurations.get(r),{added:u,updated:p,removed:C,overrides:M}=a(o,i),D=[...u,...p,...C];return(D.length||!o)&&this.updateFolderConfiguration(r,i),{keys:D,overrides:M}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:o,updated:u,removed:p,overrides:C}=a(i,void 0);return{keys:[...o,...u,...p],overrides:C}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,i,o){let u=this.getConsolidatedConfigurationModelForResource(i,o);return i.overrideIdentifier&&(u=u.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(u=u.merge(this._policyConfiguration)),u}getConsolidatedConfigurationModelForResource({resource:r},i){let o=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const u=i.getFolder(r);u&&(o=this.getFolderConsolidatedConfiguration(u.uri)||o);const p=this._memoryConfigurationByResource.get(r);p&&(o=o.merge(p))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const o=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(r);u?(i=o.merge(u),this._foldersConsolidatedConfigurations.set(r,i)):i=o}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const o=i.getFolder(r);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:o,overrides:u,keys:p}=this._folderConfigurations.get(i);return r.push([i,{contents:o,overrides:u,keys:p}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this._workspaceConfiguration.keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(o=>r.add(o))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(o=>r.add(o))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(r).forEach(u=>i.add(u))),[...i.values()]}static parse(r,i){const o=this.parseConfigurationModel(r.defaults,i),u=this.parseConfigurationModel(r.policy,i),p=this.parseConfigurationModel(r.application,i),C=this.parseConfigurationModel(r.user,i),M=this.parseConfigurationModel(r.workspace,i),D=r.folders.reduce((W,O)=>(W.set(l.URI.revive(O[0]),this.parseConfigurationModel(O[1],i)),W),new k.ResourceMap);return new c(o,u,p,C,d.createEmptyModel(i),M,D,d.createEmptyModel(i),new k.ResourceMap,i)}static parseConfigurationModel(r,i){return new d(r.contents,r.keys,r.overrides,void 0,i)}}e.Configuration=c;function v(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,i=new Map;for(const u of s)u.keys.forEach(p=>r.add(p)),u.overrides.forEach(([p,C])=>{const M=(0,k.getOrSet)(i,p,new Set);C.forEach(D=>M.add(D))});const o=[];return i.forEach((u,p)=>o.push([p,[...u.values()]])),{keys:[...r.values()],overrides:o}}class E{constructor(r,i,o,u,p){this.change=r,this.previous=i,this.currentConfiguraiton=o,this.currentWorkspace=u,this.logService=p,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const C of r.keys)this.affectedKeys.add(C);for(const[,C]of r.overrides)for(const M of C)this.affectedKeys.add(M);this._affectsConfigStr=this._marker;for(const C of this.affectedKeys)this._affectsConfigStr+=C+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=c.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(r,i){const o=this._marker+r,u=this._affectsConfigStr.indexOf(o);if(u<0)return!1;const p=u+o.length;if(p>=this._affectsConfigStr.length)return!1;const C=this._affectsConfigStr.charCodeAt(p);if(C!==this._markerCode1&&C!==this._markerCode2)return!1;if(i){const M=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,D=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!P.equals(M,D)}return!0}}e.ConfigurationChangeEvent=E;function a(s,r){const{added:i,removed:o,updated:u}=t(r?.rawConfiguration,s?.rawConfiguration),p=[],C=s?.getAllOverrideIdentifiers()||[],M=r?.getAllOverrideIdentifiers()||[];if(r){const D=M.filter(W=>!C.includes(W));for(const W of D)p.push([W,r.getKeysForOverrideIdentifier(W)])}if(s){const D=C.filter(W=>!M.includes(W));for(const W of D)p.push([W,s.getKeysForOverrideIdentifier(W)])}if(r&&s){for(const D of C)if(M.includes(D)){const W=t({contents:s.getOverrideValue(void 0,D)||{},keys:s.getKeysForOverrideIdentifier(D)},{contents:r.getOverrideValue(void 0,D)||{},keys:r.getKeysForOverrideIdentifier(D)});p.push([D,[...W.added,...W.removed,...W.updated]])}}return{added:i,removed:o,updated:u,overrides:p}}function t(s,r){const i=s?r?s.keys.filter(p=>r.keys.indexOf(p)===-1):[...s.keys]:[],o=r?s?r.keys.filter(p=>s.keys.indexOf(p)===-1):[...r.keys]:[],u=[];if(s&&r){for(const p of r.keys)if(s.keys.indexOf(p)!==-1){const C=(0,f.getConfigurationValue)(r.contents,p),M=(0,f.getConfigurationValue)(s.contents,p);P.equals(C,M)||u.push(p)}}return{added:i,removed:o,updated:u}}}),define(se[241],oe([0,1,22,3,2,35,12,123,52,5,39,45]),function(Q,e,n,R,I,A,k,P,h,l,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class b extends I.Disposable{get configurationModel(){return this._configurationModel}constructor(w){super(),this.logService=w,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=P.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.resetConfigurationModel(),this._register(S.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:m})=>this.onDidUpdateConfiguration(Array.from(w),m))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(w,m){this.updateConfigurationModel(w,S.Registry.as(h.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:w})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=P.ConfigurationModel.createEmptyModel(this.logService);const w=S.Registry.as(h.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(w),w)}updateConfigurationModel(w,m){const c=this.getConfigurationDefaultOverrides();for(const v of w){const E=c[v],a=m[v];E!==void 0?this._configurationModel.addValue(v,E):a?this._configurationModel.addValue(v,a.default):this._configurationModel.removeValue(v)}}}e.DefaultConfiguration=b;class g{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=P.ConfigurationModel.createEmptyModel(new l.NullLogService)}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=g;let d=class extends I.Disposable{get configurationModel(){return this._configurationModel}constructor(w,m,c){super(),this.defaultConfiguration=w,this.policyService=m,this.logService=c,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=P.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(w=>this.onDidChangePolicies(w))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:w})=>this.update(await this.updatePolicyDefinitions(w),!0))),this._configurationModel}async updatePolicyDefinitions(w){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",w);const m={},c=[],v=S.Registry.as(h.Extensions.Configuration).getConfigurationProperties();for(const E of w){const a=v[E];if(!a){c.push(E);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.logService.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}c.push(E),m[a.policy.name]={type:a.type}}}return(0,k.isEmptyObject)(m)||await this.policyService.updatePolicyDefinitions(m),c}onDidChangePolicies(w){this.logService.trace("PolicyConfiguration#onDidChangePolicies",w);const m=S.Registry.as(h.Extensions.Configuration).getPolicyConfigurations(),c=(0,n.coalesce)(w.map(v=>m.get(v)));this.update(c,!0)}update(w,m){this.logService.trace("PolicyConfiguration#update",w);const c=S.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),v=[],E=this._configurationModel.isEmpty();for(const a of w){const t=c[a]?.policy?.name;if(t){const s=this.policyService.getPolicyValue(t);(E?s!==void 0:!(0,A.equals)(this._configurationModel.getValue(a),s))&&v.push([a,s])}else this._configurationModel.getValue(a)!==void 0&&v.push([a,void 0])}if(v.length){this.logService.trace("PolicyConfiguration#changed",v);const a=this._configurationModel;this._configurationModel=P.ConfigurationModel.createEmptyModel(this.logService);for(const t of a.keys)this._configurationModel.setValue(t,a.getValue(t));for(const[t,s]of v)s===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,s);m&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=d,e.PolicyConfiguration=d=Ie([ie(1,f.IPolicyService),ie(2,l.ILogService)],d)}),define(se[242],oe([0,1,22,8,17,3,42,103,2,32,35,4,19,18,123,52,241,39]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class c extends h.Disposable{constructor(a,t,s,r){super(),this.settingsResource=a,this.logService=r,this._onDidChangeConfiguration=this._register(new A.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new w.DefaultConfiguration(r)),this.policyConfiguration=s instanceof m.NullPolicyService?new w.NullPolicyConfiguration:this._register(new w.PolicyConfiguration(this.defaultConfiguration,s,r)),this.userConfiguration=this._register(new d.UserSettings(this.settingsResource,{},b.extUriBiasedIgnorePathCase,t,r)),this.configuration=new d.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,d.ConfigurationModel.createEmptyModel(r),d.ConfigurationModel.createEmptyModel(r),d.ConfigurationModel.createEmptyModel(r),d.ConfigurationModel.createEmptyModel(r),new l.ResourceMap,d.ConfigurationModel.createEmptyModel(r),new l.ResourceMap,r),this.configurationEditing=new v(a,t,this),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:i,properties:o})=>this.onDidDefaultConfigurationChange(i,o))),this._register(this.policyConfiguration.onDidChangeConfiguration(i=>this.onDidPolicyConfigurationChange(i))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[a,t,s]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new d.Configuration(a,t,d.ConfigurationModel.createEmptyModel(this.logService),s,d.ConfigurationModel.createEmptyModel(this.logService),d.ConfigurationModel.createEmptyModel(this.logService),new l.ResourceMap,d.ConfigurationModel.createEmptyModel(this.logService),new l.ResourceMap,this.logService)}getConfigurationData(){return this.configuration.toData()}getValue(a,t){const s=typeof a=="string"?a:void 0,r=(0,g.isConfigurationOverrides)(a)?a:(0,g.isConfigurationOverrides)(t)?t:{};return this.configuration.getValue(s,r,void 0)}async updateValue(a,t,s,r,i){const o=(0,g.isConfigurationUpdateOverrides)(s)?s:(0,g.isConfigurationOverrides)(s)?{resource:s.resource,overrideIdentifiers:s.overrideIdentifier?[s.overrideIdentifier]:void 0}:void 0,u=o?r:s;if(u!==void 0&&u!==3&&u!==2)throw new Error(`Unable to write ${a} to target ${u}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,n.distinct)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const p=this.inspect(a,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(p.policyValue!==void 0)throw new Error(`Unable to write ${a} because it is configured in system policy.`);if((0,f.equals)(t,p.defaultValue)&&(t=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const M=o.overrideIdentifiers.sort(),D=this.configuration.localUserConfiguration.overrides.find(W=>(0,n.equals)([...W.identifiers].sort(),M));D&&(o.overrideIdentifiers=D.identifiers)}const C=o?.overrideIdentifiers?.length?[(0,y.keyFromOverrideIdentifiers)(o.overrideIdentifiers),a]:[a];await this.configurationEditing.write(C,t),await this.reloadConfiguration()}inspect(a,t={}){return this.configuration.inspect(a,t,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const a=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(a)}onDidChangeUserConfiguration(a){const t=this.configuration.toData(),s=this.configuration.compareAndUpdateLocalUserConfiguration(a);this.trigger(s,t,2)}onDidDefaultConfigurationChange(a,t){const s=this.configuration.toData(),r=this.configuration.compareAndUpdateDefaultConfiguration(a,t);this.trigger(r,s,7)}onDidPolicyConfigurationChange(a){const t=this.configuration.toData(),s=this.configuration.compareAndUpdatePolicyConfiguration(a);this.trigger(s,t,7)}trigger(a,t,s){const r=new d.ConfigurationChangeEvent(a,{data:t},this.configuration,void 0,this.logService);r.source=s,this._onDidChangeConfiguration.fire(r)}}e.ConfigurationService=c;class v{constructor(a,t,s){this.settingsResource=a,this.fileService=t,this.configurationService=s,this.queue=new R.Queue}write(a,t){return this.queue.queue(()=>this.doWriteConfiguration(a,t))}async doWriteConfiguration(a,t){let s;try{s=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(o){if(o.fileOperationResult===1)s="{}";else throw o}const r=[];if((0,k.parse)(s,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const i=this.getEdits(s,a,t);s=(0,P.applyEdits)(s,i),await this.fileService.writeFile(this.settingsResource,I.VSBuffer.fromString(s))}getEdits(a,t,s){const{tabSize:r,insertSpaces:i,eol:o}=this.formattingOptions;if(!t.length){const u=JSON.stringify(s,null,i?" ".repeat(r):"	");return[{content:u,length:u.length,offset:0}]}return(0,P.setProperty)(a,t,s,{tabSize:r,insertSpaces:i,eol:o})}get formattingOptions(){if(!this._formattingOptions){let a=S.OS===3||S.OS===2?`
`:`\r
`;const t=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(a=t),this._formattingOptions={eol:a,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(se[243],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeRemoteResourceRouter=e.NODE_REMOTE_RESOURCE_CHANNEL_NAME=e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME=void 0,e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME="request",e.NODE_REMOTE_RESOURCE_CHANNEL_NAME="remoteResourceHandler";class n{async routeCall(I,A,k){if(A!==e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME)throw new Error(`Call not found: ${A}`);const P=k[0];if(P?.authority){const h=I.connections.find(l=>l.ctx===P.authority);if(h)return h}throw new Error("Caller not found")}routeEvent(I,A){throw new Error(`Event not found: ${A}`)}}e.NodeRemoteResourceRouter=n}),define(se[244],oe([0,1,15,6]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=l,e.IRemoteAuthorityResolverService=(0,R.createDecorator)("remoteAuthorityResolverService");var I;(function(f){f[f.WebSocket=0]="WebSocket",f[f.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class A{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=A;class k{constructor(S,b){this.host=S,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=k;var P;(function(f){f.Unknown="Unknown",f.NotAvailable="NotAvailable",f.TemporarilyNotAvailable="TemporarilyNotAvailable",f.NoResolverFound="NoResolverFound",f.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class h extends n.ErrorNoTelemetry{static isNotAvailable(S){return S instanceof h&&S._code===P.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof h&&S._code===P.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof h&&S._code===P.NoResolverFound}static isInvalidAuthority(S){return S instanceof h&&S._code===P.InvalidAuthority}static isHandled(S){return S instanceof h&&S.isHandled}constructor(S,b=P.Unknown,g){super(S),this._message=S,this._code=b,this._detail=g,this.isHandled=b===P.NotAvailable&&g===!0,Object.setPrototypeOf(this,h.prototype)}}e.RemoteAuthorityResolverError=h;function l(f){const S=f.indexOf("+");return S===-1?f:f.substring(0,S)}}),define(se[245],oe([0,1,8,17,23,15,3,2,13,66,73,33,113,244]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.connectRemoteAgentManagement=C,e.connectRemoteAgentExtensionHost=M,e.connectRemoteAgentTunnel=W;const d=30*1e3;var y;(function(X){X[X.Management=1]="Management",X[X.ExtensionHost=2]="ExtensionHost",X[X.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function w(X){switch(X){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function m(X){const L=new I.CancellationTokenSource;return setTimeout(()=>L.cancel(),X),L.token}function c(X,L){if(X.isCancellationRequested||L.isCancellationRequested)return I.CancellationToken.Cancelled;const N=new I.CancellationTokenSource;return X.onCancellationRequested(()=>N.cancel()),L.onCancellationRequested(()=>N.cancel()),N.token}class v{get didTimeout(){return this._state==="timedout"}constructor(L){this._state="pending",this._disposables=new P.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,n.promiseWithResolvers)(),L.isCancellationRequested?this._timeout():this._disposables.add(L.onCancellationRequested(()=>this._timeout()))}registerDisposable(L){this._state==="pending"?this._disposables.add(L):L.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const L=new Error("Time limit reached");return L.code="ETIMEDOUT",L.syscall="connect",L}resolve(L){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(L))}reject(L){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(L))}}function E(X,L){const N=new v(L);return N.registerDisposable(X.onControlMessage(Z=>{const ne=JSON.parse(Z.toString()),K=T(ne);K?N.reject(K):N.resolve(ne)})),N.promise}function a(X,L,N,Z,ne,K,H,j){const q=new v(j),re=f.StopWatch.create(!1);return X.info(`Creating a socket (${H})...`),l.mark(`code/willCreateSocket/${K}`),L.connect(N,Z,ne,H).then(he=>{q.didTimeout?(l.mark(`code/didCreateSocketError/${K}`),X.info(`Creating a socket (${H}) finished after ${re.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(l.mark(`code/didCreateSocketOK/${K}`),X.info(`Creating a socket (${H}) was successful after ${re.elapsed()} ms.`),q.resolve(he))},he=>{l.mark(`code/didCreateSocketError/${K}`),X.info(`Creating a socket (${H}) returned an error after ${re.elapsed()} ms.`),X.error(he),q.reject(he)}),q.promise}function t(X,L){const N=new v(L);return X.then(Z=>{N.didTimeout||N.resolve(Z)},Z=>{N.didTimeout||N.reject(Z)}),N.promise}async function s(X,L,N,Z){const ne=V(X,L);X.logService.trace(`${ne} 1/6. invoking socketFactory.connect().`);let K;try{K=await a(X.logService,X.remoteSocketFactoryService,X.connectTo,h.RemoteAuthorities.getServerRootPath(),`reconnectionToken=${X.reconnectionToken}&reconnection=${X.reconnectionProtocol?"true":"false"}`,w(L),`renderer-${w(L)}-${X.reconnectionToken}`,Z)}catch(he){throw X.logService.error(`${ne} socketFactory.connect() failed or timed out. Error:`),X.logService.error(he),he}X.logService.trace(`${ne} 2/6. socketFactory.connect() was successful.`);let H,j;X.reconnectionProtocol?(X.reconnectionProtocol.beginAcceptReconnection(K,null),H=X.reconnectionProtocol,j=!1):(H=new b.PersistentProtocol({socket:K}),j=!0),X.logService.trace(`${ne} 3/6. sending AuthRequest control message.`);const q=await t(X.signService.createNewMessage((0,S.generateUuid)()),Z),re={type:"auth",auth:X.connectionToken||"00000000000000000000",data:q.data};H.sendControl(R.VSBuffer.fromString(JSON.stringify(re)));try{const he=await E(H,c(Z,m(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(X.logService.trace(`${ne} 4/6. received SignRequest control message.`),!await t(X.signService.validate(q,he.signedData),Z)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const pe=await t(X.signService.sign(he.data),Z),ye={type:"connectionType",commit:X.commit,signedData:pe,desiredConnectionType:L};return N&&(ye.args=N),X.logService.trace(`${ne} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(R.VSBuffer.fromString(JSON.stringify(ye))),{protocol:H,ownsProtocol:j}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(X.logService.error(`${ne} the handshake timed out. Error:`),X.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(X.logService.error(`${ne} received error control message when negotiating connection. Error:`),X.logService.error(he)),j&&B(H),he}}async function r(X,L,N,Z){const ne=Date.now(),K=V(X,L),{protocol:H,ownsProtocol:j}=await s(X,L,N,Z),q=new v(Z);return q.registerDisposable(H.onControlMessage(re=>{const he=JSON.parse(re.toString()),me=T(he);me?(X.logService.error(`${K} received error control message when negotiating connection. Error:`),X.logService.error(me),j&&B(H),q.reject(me)):(X.reconnectionProtocol?.endAcceptReconnection(),X.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${ce(ne)}!`),q.resolve({protocol:H,firstMessage:he}))})),q.promise}async function i(X,L){const{protocol:N}=await r(X,1,void 0,L);return{protocol:N}}async function o(X,L,N){const{protocol:Z,firstMessage:ne}=await r(X,2,L,N),K=ne&&ne.debugPort;return{protocol:Z,debugPort:K}}async function u(X,L,N){const Z=Date.now(),ne=V(X,3),{protocol:K}=await s(X,3,L,N);return X.logService.trace(`${ne} 6/6. handshake finished, connection is up and running after ${ce(Z)}!`),K}async function p(X,L,N){const{connectTo:Z,connectionToken:ne}=await X.addressProvider.getAddress();return{commit:X.commit,quality:X.quality,connectTo:Z,connectionToken:ne,reconnectionToken:L,reconnectionProtocol:N,remoteSocketFactoryService:X.remoteSocketFactoryService,signService:X.signService,logService:X.logService}}async function C(X,L,N){return D(X,async Z=>{const{protocol:ne}=await i(Z,I.CancellationToken.None);return new Y(X,L,N,Z.reconnectionToken,ne)})}async function M(X,L){return D(X,async N=>{const{protocol:Z,debugPort:ne}=await o(N,L,I.CancellationToken.None);return new G(X,L,N.reconnectionToken,Z,ne)})}async function D(X,L){for(let Z=1;;Z++)try{const ne=(0,S.generateUuid)(),K=await p(X,ne,null);return await L(K)}catch(ne){if(Z<5)X.logService.error(`[remote-connection][attempt ${Z}] An error occurred in initial connection! Will retry... Error:`),X.logService.error(ne);else throw X.logService.error(`[remote-connection][attempt ${Z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),X.logService.error(ne),le.triggerPermanentFailure(0,0,g.RemoteAuthorityResolverError.isHandled(ne)),ne}}async function W(X,L,N){const Z=await p(X,(0,S.generateUuid)(),null);return await u(Z,{host:L,port:N},I.CancellationToken.None)}function O(X){return(0,n.createCancelablePromise)(L=>new Promise((N,Z)=>{const ne=setTimeout(N,X*1e3);L.onCancellationRequested(()=>{clearTimeout(ne),N()})}))}var _;(function(X){X[X.ConnectionLost=0]="ConnectionLost",X[X.ReconnectionWait=1]="ReconnectionWait",X[X.ReconnectionRunning=2]="ReconnectionRunning",X[X.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",X[X.ConnectionGain=4]="ConnectionGain"})(_||(e.PersistentConnectionEventType=_={}));class F{constructor(L,N){this.reconnectionToken=L,this.millisSinceLastIncomingData=N,this.type=0}}e.ConnectionLostEvent=F;class x{constructor(L,N,Z,ne){this.reconnectionToken=L,this.millisSinceLastIncomingData=N,this.durationSeconds=Z,this.cancellableTimer=ne,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=x;class z{constructor(L,N,Z){this.reconnectionToken=L,this.millisSinceLastIncomingData=N,this.attempt=Z,this.type=2}}e.ReconnectionRunningEvent=z;class ue{constructor(L,N,Z){this.reconnectionToken=L,this.millisSinceLastIncomingData=N,this.attempt=Z,this.type=4}}e.ConnectionGainEvent=ue;class ee{constructor(L,N,Z,ne){this.reconnectionToken=L,this.millisSinceLastIncomingData=N,this.attempt=Z,this.handled=ne,this.type=3}}e.ReconnectionPermanentFailureEvent=ee;class le extends P.Disposable{static triggerPermanentFailure(L,N,Z){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=L,this._permanentFailureAttempt=N,this._permanentFailureHandled=Z,this._instances.forEach(ne=>ne._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(L=>L._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(L=>L._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||le._permanentFailure}constructor(L,N,Z,ne,K){super(),this._connectionType=L,this._options=N,this.reconnectionToken=Z,this.protocol=ne,this._reconnectionFailureIsFatal=K,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new ue(this.reconnectionToken,0,0)),this._register(ne.onSocketClose(H=>{const j=ae(this._connectionType,this.reconnectionToken,!0);H?H.type===0?(this._options.logService.info(`${j} received socket close event (hadError: ${H.hadError}).`),H.error&&this._options.logService.error(H.error)):(this._options.logService.info(`${j} received socket close event (wasClean: ${H.wasClean}, code: ${H.code}, reason: ${H.reason}).`),H.event&&this._options.logService.error(H.event)):this._options.logService.info(`${j} received socket close event.`),this._beginReconnecting()})),this._register(ne.onSocketTimeout(H=>{const j=ae(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${j} received socket timeout event (unacknowledgedMsgCount: ${H.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${H.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${H.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),le._instances.push(this),this._register((0,P.toDisposable)(()=>{const H=le._instances.indexOf(this);H>=0&&le._instances.splice(H,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(le._permanentFailureMillisSinceLastIncomingData,le._permanentFailureAttempt,le._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const L=ae(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${L} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let Z=-1;do{Z++;const ne=Z<N.length?N[Z]:N[N.length-1];try{if(ne>0){const H=O(ne);this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ne,H)),this._options.logService.info(`${L} waiting for ${ne} seconds before reconnecting...`);try{await H}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${L} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z+1)),this._options.logService.info(`${L} resolving connection...`);const K=await p(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${L} connecting to ${K.connectTo}...`),await this._reconnect(K,m(d)),this._options.logService.info(`${L} reconnected!`),this._onDidStateChange.fire(new ue(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z+1));break}catch(K){if(K.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${L} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(K),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Z+1,!1);break}if(Z>360){this._options.logService.error(`${L} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(K),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Z+1,!1);break}if(g.RemoteAuthorityResolverError.isTemporarilyNotAvailable(K)){this._options.logService.info(`${L} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(K);continue}if((K.code==="ETIMEDOUT"||K.code==="ENETUNREACH"||K.code==="ECONNREFUSED"||K.code==="ECONNRESET")&&K.syscall==="connect"){this._options.logService.info(`${L} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(K);continue}if((0,A.isCancellationError)(K)){this._options.logService.info(`${L} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(K);continue}if(K instanceof g.RemoteAuthorityResolverError){this._options.logService.error(`${L} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(K),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Z+1,g.RemoteAuthorityResolverError.isHandled(K));break}this._options.logService.error(`${L} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(K),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Z+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(L,N,Z){this._reconnectionFailureIsFatal?le.triggerPermanentFailure(L,N,Z):this._gotoPermanentFailure(L,N,Z)}_gotoPermanentFailure(L,N,Z){this._onDidStateChange.fire(new ee(this.reconnectionToken,L,N,Z)),B(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=le;class Y extends le{constructor(L,N,Z,ne,K){super(1,L,ne,K,!0),this.client=this._register(new b.Client(K,{remoteAuthority:N,clientId:Z},L.ipcLogger))}async _reconnect(L,N){await i(L,N)}}e.ManagementPersistentConnection=Y;class G extends le{constructor(L,N,Z,ne,K){super(2,L,Z,ne,!1),this._startArguments=N,this.debugPort=K}async _reconnect(L,N){await o(L,this._startArguments,N)}}e.ExtensionHostPersistentConnection=G;function B(X){try{X.acceptDisconnect();const L=X.getSocket();X.dispose(),L.dispose()}catch(L){(0,A.onUnexpectedError)(L)}}function T(X){if(X&&X.type==="error"){const L=new Error(`Connection error: ${X.reason}`);return L.code="VSCODE_CONNECTION_ERROR",L}return null}function U(X,L){for(;X.length<L;)X+=" ";return X}function $(X,L){return`[remote-connection][${U(w(X),13)}][${L.substr(0,5)}\u2026]`}function ae(X,L,N){return`${$(X,L)}[${N?"reconnect":"initial"}]`}function V(X,L){return`${ae(L,X.reconnectionToken,!!X.reconnectionProtocol)}[${X.connectTo}]`}function ce(X){return`${Date.now()-X} ms`}}),define(se[68],oe([0,1,13]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=R,e.getRemoteName=I,e.parseAuthorityWithPort=A,e.parseAuthorityWithOptionalPort=k;function R(h){return h.scheme===n.Schemas.vscodeRemote?h.authority:void 0}function I(h){if(!h)return;const l=h.indexOf("+");return l<0?h:h.substr(0,l)}function A(h){const{host:l,port:f}=P(h);if(typeof f>"u")throw new Error(`Invalid remote authority: ${h}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:f}}function k(h,l){let{host:f,port:S}=P(h);return typeof S>"u"&&(S=l),{host:f,port:S}}function P(h){const l=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const f=h.match(/^(\[[0-9a-z:]+\])$/);if(f)return{host:f[1],port:void 0};const S=h.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:h,port:void 0}}}),define(se[124],oe([0,1,25,6,68]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=A,e.isApplicationScopedExtension=S,e.isLanguagePackExtension=b,e.isAuthenticationProviderExtension=g,e.isResolverExtension=d,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var k;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(k||(e.ExtensionType=k={}));var P;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.LINUX_PPC64LE="linux-ppc64le",y.LINUX_RISCV64="linux-riscv64",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class h{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,m){if(typeof w>"u"||w===null)return typeof m>"u"||m===null;if(typeof m>"u"||m===null)return!1;if(typeof w=="string"||typeof m=="string"){const c=typeof w=="string"?w:w.value,v=typeof m=="string"?m:m.value;return n.equalsIgnoreCase(c,v)}return w._lower===m._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.ExtensionIdentifier=h;class l{get size(){return this._set.size}constructor(w){if(this._set=new Set,w)for(const m of w)this.add(m)}add(w){this._set.add(h.toKey(w))}delete(w){return this._set.delete(h.toKey(w))}has(w){return this._set.has(h.toKey(w))}}e.ExtensionIdentifierSet=l;class f{constructor(){this._map=new Map}clear(){this._map.clear()}delete(w){this._map.delete(h.toKey(w))}get(w){return this._map.get(h.toKey(w))}has(w){return this._map.has(h.toKey(w))}set(w,m){this._map.set(h.toKey(w),m)}values(){return this._map.values()}forEach(w){this._map.forEach(w)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=f;function S(y){return b(y)}function b(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}function g(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}function d(y,w){if(w){const m=`onResolveRemoteAuthority:${(0,I.getRemoteName)(w)}`;return!!y.activationEvents?.includes(m)}return!1}e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(se[246],oe([0,1,2,6]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,R.createDecorator)("remoteSocketFactoryService");class I{constructor(){this.factories={}}register(k,P){return this.factories[k]??=[],this.factories[k].push(P),(0,n.toDisposable)(()=>{const h=this.factories[k]?.indexOf(P);typeof h=="number"&&h>=0&&this.factories[k]?.splice(h,1)})}getSocketFactory(k){return(this.factories[k.type]||[]).find(h=>h.supports(k))}connect(k,P,h,l){const f=this.getSocketFactory(k);if(!f)throw new Error(`No socket factory found for ${k}`);return f.connect(k,P,h,l)}}e.RemoteSocketFactoryService=I}),define(se[247],oe([0,1,26,49,21,117]),function(Q,e,n,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=P;let k;async function P(g=!1){return(k===void 0||g)&&(k=h()),k}async function h(){const g=l();if(g===void 0)return!1;if(g>=22e3){const d=S();if(d)return new Promise(y=>{R.execFile(d,["--status"],w=>y(!w))})}else{const d=b();if(d)try{if((await I.Promises.stat(d)).isFile())return!0}catch{}}return!1}function l(){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());if(g)return parseInt(g[3])}function f(g){const d=process.env.SystemRoot;if(d){const y=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return A.join(d,y?"Sysnative":"System32",g)}}function S(){return f("wsl.exe")}function b(){return f("lxss\\LxssManager.dll")}}),define(se[53],oe([0,1,17,15,2,186,52,6,5,45]),function(Q,e,n,R,I,A,k,P,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=b,e.hasNoContent=g,e.asText=d,e.asTextOrError=y,e.asJson=w,e.updateProxyConfigurationsScope=m,e.IRequestService=(0,P.createDecorator)("requestService");class f{constructor(a){this.original=a}toJSON(){if(!this.headers){const a=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?a[t]="*****":a[t]=this.original[t];this.headers=a}return this.headers}}class S extends I.Disposable{constructor(a){super(),this.counter=0,this.logger=a.createLogger("network",{name:(0,A.localize)(0,null),when:h.CONTEXT_LOG_LEVEL.isEqualTo((0,h.LogLevelToString)(h.LogLevel.Trace)).serialize()})}async logAndRequest(a,t,s){const r=`${a} #${++this.counter}: ${t.url}`;this.logger.trace(`${r} - begin`,t.type,new f(t.headers??{}));try{const i=await s();return this.logger.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.logger.error(`${r} - error`,t.type,(0,R.getErrorMessage)(i)),i}}}e.AbstractRequestService=S;function b(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}function g(E){return E.res.statusCode===204}async function d(E){return g(E)?null:(await(0,n.streamToBuffer)(E.stream)).toString()}async function y(E){if(!b(E))throw new Error("Server returned "+E.res.statusCode);return d(E)}async function w(E){if(!b(E))throw new Error("Server returned "+E.res.statusCode);if(g(E))return null;const t=(await(0,n.streamToBuffer)(E.stream)).toString();try{return JSON.parse(t)}catch(s){throw s.message+=`:
`+t,s}}function m(E){v(E)}let c;function v(E){const a=l.Registry.as(k.Extensions.Configuration),t=c;c={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[c],remove:t?[t]:[]})}v(1)}),define(se[248],oe([0,1,17,23]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class I{constructor(P){this.service=P}listen(P,h){throw new Error("Invalid listen")}call(P,h,l,f=R.CancellationToken.None){switch(h){case"request":return this.service.request(l[0],f).then(async({res:S,stream:b})=>{const g=await(0,n.streamToBuffer)(b);return[{statusCode:S.statusCode,headers:S.headers},g]});case"resolveProxy":return this.service.resolveProxy(l[0]);case"loadCertificates":return this.service.loadCertificates()}throw new Error("Invalid call")}}e.RequestChannel=I;class A{constructor(P){this.channel=P}async request(P,h){const[l,f]=await this.channel.call("request",[P],h);return{res:l,stream:(0,n.bufferToStream)(f)}}async resolveProxy(P){return this.channel.call("resolveProxy",[P])}async loadCertificates(){return this.channel.call("loadCertificates")}}e.RequestChannelClient=A}),define(se[249],oe([0,1,250,12]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=A;function I(k,P){return k.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:k.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function A(k,P,h={}){const l=(0,n.parse)(k),f=h.proxyUrl||I(l,P);if(!f)return null;const S=(0,n.parse)(f);if(!/^https?:$/.test(S.protocol||""))return null;const b={host:S.hostname||"",port:(S.port?+S.port:0)||(S.protocol==="https"?443:80),auth:S.auth,rejectUnauthorized:(0,R.isBoolean)(h.strictSSL)?h.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((g,d)=>{Q(["http-proxy-agent"],g,d)})).HttpProxyAgent(f,b):new(await new Promise((g,d)=>{Q(["https-proxy-agent"],g,d)})).HttpsProxyAgent(f,b)}}),define(se[251],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(se[95],oe([0,1,49,9,187,23,47,15,4,33,112,64,8,141]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=y;let d;async function y(m,c,v,E){return v["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.isLaunchedFromCli)(E)&&!v["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.isLaunchedFromCli)(E)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=b.Promises.withAsyncBody(async(a,t)=>{const s=new A.CancellationTokenSource;let r=1e4;const i=m.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,g.clamp)(i,1,120)*1e3);const o=setTimeout(()=>{s.dispose(!0),t(new Error((0,I.localize)(0,null)))},r);try{a(await w(c,s.token))}catch(u){!(0,P.isCancellationError)(u)&&!s.token.isCancellationRequested?t(new Error((0,I.localize)(1,null,(0,k.toErrorMessage)(u)))):a({})}finally{clearTimeout(o),s.dispose()}})),d)}async function w(m,c){const v=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",v);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",E);const a=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"({.*})"+a),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};m.trace("getUnixShellEnvironment#env",s);const r=await(0,f.getSystemShell)(h.OS,s);return m.trace("getUnixShellEnvironment#shell",r),new Promise((i,o)=>{if(c.isCancellationRequested)return o(new P.CancellationError);const u=(0,R.basename)(r);let p,C;const M="";/^pwsh(-preview)?$/.test(u)?(p=`& '${process.execPath}' ${M} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,C=["-Login","-Command"]):u==="nu"?(p=`^'${process.execPath}' ${M} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,C=["-i","-l","-c"]):u==="xonsh"?(p=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,C=["-i","-l","-c"]):(p=`'${process.execPath}' ${M} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,u==="tcsh"||u==="csh"?C=["-ic"]:C=["-i","-l","-c"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(C),p);const D=(0,n.spawn)(r,[...C,p],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});c.onCancellationRequested(()=>(D.kill(),o(new P.CancellationError))),D.on("error",_=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(_)),o(_)});const W=[];D.stdout.on("data",_=>W.push(_));const O=[];D.stderr.on("data",_=>O.push(_)),D.on("close",(_,F)=>{const x=Buffer.concat(W).toString("utf8");m.trace("getUnixShellEnvironment#raw",x);const z=Buffer.concat(O).toString("utf8");if(z.trim()&&m.trace("getUnixShellEnvironment#stderr",z),_||F)return o(new Error((0,I.localize)(2,null,_,F)));const ue=t.exec(x),ee=ue?ue[1]:"{}";try{const le=JSON.parse(ee);v?le.ELECTRON_RUN_AS_NODE=v:delete le.ELECTRON_RUN_AS_NODE,E?le.ELECTRON_NO_ATTACH_CONSOLE=E:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",le),i(le)}catch(le){m.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(le)),o(le)}})})}}),define(se[252],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class n{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(I){try{const A=await this.getValidator();if(A){const k=String(n._nextId++);return this.validators.set(k,A),{id:k,data:A.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,A){if(!I.id)return!0;const k=this.validators.get(I.id);if(!k)return!1;this.validators.delete(I.id);try{return k.validate(A)==="ok"}catch{return!1}finally{k.dispose?.()}}async sign(I){try{return await this.signValue(I)}catch{}return I}}e.AbstractSignService=n}),define(se[96],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,n.createDecorator)(e.SIGN_SERVICE_ID)}),define(se[253],oe([0,1,252]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class R extends n.AbstractSignService{getValidator(){return this.vsda().then(A=>new A.validator)}signValue(A){return this.vsda().then(k=>new k.signer().sign(A))}vsda(){return new Promise((A,k)=>Q(["vsda"],A,k))}}e.SignService=R}),define(se[34],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,n.createDecorator)("stateReadService"),e.IStateService=(0,n.createDecorator)("stateService")}),define(se[125],oe([0,1,8,17,2,12,38,16,5]),function(Q,e,n,R,I,A,k,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var l;(function(g){g[g.IMMEDIATE=0]="IMMEDIATE",g[g.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class f extends I.Disposable{constructor(d,y,w,m){super(),this.storagePath=d,this.saveStrategy=y,this.logService=w,this.fileService=m,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=this._register(new n.ThrottledDelayer(this.saveStrategy===0?0:100)),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(d){d.fileOperationResult!==1&&this.logService.error(d)}}getItem(d,y){const w=this.storage[d];return(0,A.isUndefinedOrNull)(w)?y:w}setItem(d,y){this.setItems([{key:d,data:y}])}setItems(d){let y=!1;for(const{key:w,data:m}of d)this.storage[w]!==m&&((0,A.isUndefinedOrNull)(m)?(0,A.isUndefined)(this.storage[w])||(this.storage[w]=void 0,y=!0):(this.storage[w]=m,y=!0));y&&this.save()}removeItem(d){(0,A.isUndefined)(this.storage[d])||(this.storage[d]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const d=JSON.stringify(this.storage,null,4);if(d!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,R.VSBuffer.fromString(d),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=d}catch(y){this.logService.error(y)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=f;let S=class extends I.Disposable{constructor(d,y,w,m){super(),this.fileStorage=this._register(new f(y.stateResource,d,w,m))}async init(){await this.fileStorage.init()}getItem(d,y){return this.fileStorage.getItem(d,y)}};e.StateReadonlyService=S,e.StateReadonlyService=S=Ie([ie(1,k.IEnvironmentService),ie(2,h.ILogService),ie(3,P.IFileService)],S);class b extends S{setItem(d,y){this.fileStorage.setItem(d,y)}setItems(d){this.fileStorage.setItems(d)}removeItem(d){this.fileStorage.removeItem(d)}close(){return this.fileStorage.close()}}e.StateService=b}),define(se[126],oe([0,1,4,36,33]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=k,e.verifyMicrosoftInternalDomain=P;function A(h){if(n.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function k(h,l,f,S,b,g,d,y,w){const m=Object.create(null);m["common.machineId"]=g,m["common.sqmId"]=d,m.sessionID=(0,I.generateUuid)()+Date.now(),m.commitHash=S,m.version=b,m["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,n.PlatformToString)(n.platform),m["common.nodePlatform"]=R.platform,m["common.nodeArch"]=f,m["common.product"]=w||"desktop",y&&(m["common.msftInternal"]=y);let c=0;const v=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),n.isLinuxSnap&&(m["common.snap"]="true");const E=A(l);return E&&(m["common.platformDetail"]=E),m}function P(h){const l=R.env.USERDNSDOMAIN;if(!l)return!1;const f=l.toLowerCase();return h.some(S=>f===S)}}),define(se[28],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,n.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,n.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var I;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(se[254],oe([0,1,26,8,42,13,9,4,7,89,21,111,92,16,27,28]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=void 0,e.collectWorkspaceStats=m,e.getMachineInfo=v,e.collectLaunchConfigs=E;const w=new Map;async function m(t,s){const r=`${t}::${s.join(":")}`,i=w.get(r);if(i)return i;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,p=new Map,C=2e4;function M(W,O,_,F){const x=O.substring(W.length+1);return R.Promises.withAsyncBody(async z=>{let ue;try{ue=await f.Promises.readdir(O,{withFileTypes:!0})}catch{z();return}if(F.count>=C){F.count+=ue.length,F.maxReached=!0,z();return}let ee=ue.length;if(ee===0){z();return}let le=ue;F.count+ue.length>C&&(F.maxReached=!0,ee=C-F.count,le=ue.slice(0,ee)),F.count+=ue.length;for(const Y of le)if(Y.isDirectory()){if(_.includes(Y.name)||await M(W,(0,k.join)(O,Y.name),_,F),--ee===0){z();return}}else{const G=Y.name.lastIndexOf(".");if(G>=0){const B=Y.name.substring(G+1);B&&u.set(B,(u.get(B)??0)+1)}for(const B of o)B.relativePathPattern?.test(x)!==!1&&B.filePattern.test(Y.name)&&p.set(B.tag,(p.get(B.tag)??0)+1);if(--ee===0){z();return}}})}const D=R.Promises.withAsyncBody(async W=>{const O={count:0,maxReached:!1};await M(t,t,s,O);const _=await E(t);W({configFiles:c(p),fileTypes:c(u),fileCount:O.count,maxFilesReached:O.maxReached,launchConfigFiles:_})});return w.set(r,D),D}function c(t){return Array.from(t.entries(),([s,r])=>({name:s,count:r})).sort((s,r)=>r.count-s.count)}function v(){const t={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(n.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(l.virtualMachineHint.value()*100)}%`},s=n.cpus();return s&&s.length>0&&(t.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),t}async function E(t){try{const s=new Map,r=(0,k.join)(t,".vscode","launch.json"),i=await f.Promises.readFile(r),o=[],u=(0,I.parse)(i.toString(),o);if(o.length)return console.log(`Unable to parse ${r}`),[];if((0,I.getNodeType)(u)==="object"&&u.configurations)for(const p of u.configurations){const C=p.type;C&&(s.has(C)?s.set(C,s.get(C)+1):s.set(C,1))}return c(s)}catch{return[]}}let a=class{constructor(s,r){this.telemetryService=s,this.productService=r}formatMachineInfo(s){const r=[];return r.push(`OS Version:       ${s.os}`),r.push(`CPUs:             ${s.cpus}`),r.push(`Memory (System):  ${s.memory}`),r.push(`VM:               ${s.vmHint}`),r.join(`
`)}formatEnvironment(s){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const i=n.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(n.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(n.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||r.push(`Load (avg):       ${n.loadavg().map(o=>Math.round(o)).join(", ")}`),r.push(`VM:               ${Math.round(l.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${s.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(s.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(s,r){return Promise.all([(0,S.listProcesses)(s.mainPID),this.formatWorkspaceMetadata(s)]).then(async i=>{let[o,u]=i,p=this.formatProcessList(s,o);return r.forEach(C=>{if((0,b.isRemoteDiagnosticError)(C))p+=`
${C.errorMessage}`,u+=`
${C.errorMessage}`;else if(p+=`

Remote: ${C.hostName}`,C.processes&&(p+=`
${this.formatProcessList(s,C.processes)}`),C.workspaceMetadata){u+=`
|  Remote: ${C.hostName}`;for(const M of Object.keys(C.workspaceMetadata)){const D=C.workspaceMetadata[M];let W=`${D.fileCount} files`;D.maxFilesReached&&(W=`more than ${W}`),u+=`|    Folder (${M}): ${W}`,u+=this.formatWorkspaceStats(D)}}}),{processInfo:p,workspaceInfo:u}})}async getSystemInfo(s,r){const{memory:i,vmHint:o,os:u,cpus:p}=v(),C={os:u,memory:i,cpus:p,vmHint:o,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:r};return P.isWindows||(C.load=`${n.loadavg().map(M=>Math.round(M)).join(", ")}`),P.isLinux&&(C.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(C)}async getDiagnostics(s,r){const i=[];return(0,S.listProcesses)(s.mainPID).then(async o=>(i.push(""),i.push(this.formatEnvironment(s)),i.push(""),i.push(this.formatProcessList(s,o)),s.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(s))),r.forEach(u=>{if((0,b.isRemoteDiagnosticError)(u))i.push(`
${u.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${u.hostName}`),i.push(this.formatMachineInfo(u.machineInfo)),u.processes&&i.push(this.formatProcessList(s,u.processes)),u.workspaceMetadata)for(const p of Object.keys(u.workspaceMetadata)){const C=u.workspaceMetadata[p];let M=`${C.fileCount} files`;C.maxFilesReached&&(M=`more than ${M}`),i.push(`Folder (${p}): ${M}`),i.push(this.formatWorkspaceStats(C))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(s){const r=[];let o=0;const u=(D,W)=>{const O=` ${D}(${W})`;o+O.length>60?(r.push(p),p="|                 ",o=p.length):o+=O.length,p+=O};let p="|      File types:";const C=10,M=s.fileTypes.length>C?C:s.fileTypes.length;for(let D=0;D<M;D++){const W=s.fileTypes[D];u(W.name,W.count)}if(r.push(p),s.configFiles.length>=0&&(p="|      Conf files:",o=0,s.configFiles.forEach(D=>{u(D.name,D.count)}),r.push(p)),s.launchConfigFiles.length>0){let D="|      Launch Configs:";s.launchConfigFiles.forEach(W=>{const O=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`;D+=O}),r.push(D)}return r.join(`
`)}expandGPUFeatures(s){const r=Math.max(...Object.keys(s).map(i=>i.length));return Object.keys(s).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${s[i]}`).join(`
                  `)}formatWorkspaceMetadata(s){const r=[],i=[];return s.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(r.push(`|  Window (${o.title})`),o.folderURIs.forEach(u=>{const p=h.URI.revive(u);if(p.scheme===A.Schemas.file){const C=p.fsPath;i.push(m(C,["node_modules",".git"]).then(M=>{let D=`${M.fileCount} files`;M.maxFilesReached&&(D=`more than ${D}`),r.push(`|    Folder (${(0,k.basename)(C)}): ${D}`),r.push(this.formatWorkspaceStats(M))}).catch(M=>{r.push(`|      Error: Unable to collect workspace stats for folder ${C} (${M.toString()})`)}))}else r.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(o=>r.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(s,r){const i=new Map;s.windows.forEach(u=>i.set(u.pid,`window [${u.id}] (${u.title})`)),s.pidToNames.forEach(({pid:u,name:p})=>i.set(u,p));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(s.mainPID,i,o,r,0),o.join(`
`)}formatProcessItem(s,r,i,o,u){const p=u===0;let C;p?C=o.pid===s?`${this.productService.applicationName} main`:"remote agent":r.has(o.pid)?C=r.get(o.pid):C=`${"  ".repeat(u)} ${o.name}`;const M=process.platform==="win32"?o.mem:n.totalmem()*(o.mem/100);i.push(`${o.load.toFixed(0).padStart(5," ")}	${(M/g.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${C}`),Array.isArray(o.children)&&o.children.forEach(D=>this.formatProcessItem(s,r,i,D,u+1))}async getWorkspaceFileExtensions(s){const r=new Set;for(const{uri:i}of s.folders){const o=h.URI.revive(i);if(o.scheme!==A.Schemas.file)continue;const u=o.fsPath;try{(await m(u,["node_modules",".git"])).fileTypes.forEach(C=>r.add(C.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(s){for(const{uri:r}of s.folders){const i=h.URI.revive(r);if(i.scheme!==A.Schemas.file)continue;const o=i.fsPath;try{const u=await m(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),u.fileTypes.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:p.name,count:p.count})}),u.launchConfigFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:p.name,count:p.count})}),u.configFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};e.DiagnosticsService=a,e.DiagnosticsService=a=Ie([ie(0,y.ITelemetryService),ie(1,d.IProductService)],a)}),define(se[255],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class n{constructor(A){this.appenders=A}listen(A,k){throw new Error(`Event not found: ${k}`)}call(A,k,{eventName:P,data:h}){return this.appenders.forEach(l=>l.log(P,h)),Promise.resolve(null)}}e.TelemetryAppenderChannel=n;class R{constructor(A){this.channel=A}log(A,k){return this.channel.call("log",{eventName:A,data:k}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=R}),define(se[54],oe([0,1,35,12,68,126,28]),function(Q,e,n,R,I,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=f,e.isLoggingOnly=S,e.getTelemetryLevel=b,e.validateTelemetryData=g,e.cleanRemoteAuthority=y,e.isInternalTelemetry=m,e.getPiiPathsFromEnvironment=c,e.cleanData=a;class P{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=P;class h{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=h,e.NullTelemetryService=new h;class l{async publicLog(s,r,i){}async publicLogError(s,r,i){}}e.NullEndpointTelemetryService=l,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(t,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!t.enableTelemetry)}function S(t,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function b(t){const s=t.getValue(k.TELEMETRY_SETTING_ID),r=t.getValue(k.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function g(t){const s={},r={},i={};w(t,i);for(let o in i){o=o.length>150?o.substr(o.length-149):o;const u=i[o];typeof u=="number"?r[o]=u:typeof u=="boolean"?r[o]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${u.length}`),s[o]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(s[o]=u)}return{properties:s,measurements:r}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function y(t){if(!t)return"none";const s=(0,I.getRemoteName)(t);return d.has(s)?s:"other"}function w(t,s,r=0,i){if(t)for(const o of Object.getOwnPropertyNames(t)){const u=t[o],p=i?i+o:o;Array.isArray(u)?s[p]=(0,n.safeStringify)(u):u instanceof Date?s[p]=u.toISOString():(0,R.isObject)(u)?r<2?w(u,s,r+1,p+"."):s[p]=(0,n.safeStringify)(u):s[p]=u}}function m(t,s){const r=t.msftInternalDomains||[],i=s.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(r)||i}function c(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function v(t,s){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const i=[];for(const C of s)for(;;){const M=C.exec(t);if(!M)break;i.push([M.index,C.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(r="";;){const C=u.exec(t);if(!C)break;const M=i.some(([D,W])=>C.index<W&&D<u.lastIndex);!o.test(C[0])&&!M&&(r+=t.substring(p,C.index)+"<REDACTED: user-file-path>",p=u.lastIndex)}return p<t.length&&(r+=t.substr(p)),r}function E(t){if(!t)return t;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of s)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function a(t,s){return(0,n.cloneAndChange)(t,r=>{if(r instanceof P||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let i=r.replaceAll("%20"," ");i=v(i,s);for(const o of s)i=i.replace(o,"");return i=E(i),i}})}}),define(se[127],oe([0,1,25,121,124,4,7,15,36,54]),function(Q,e,n,R,I,A,k,P,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=f,e.getIdAndVersion=d,e.getExtensionId=y,e.adoptToGalleryExtensionId=w,e.getGalleryExtensionId=m,e.groupByExtension=c,e.getLocalExtensionTelemetryData=v,e.getGalleryExtensionTelemetryData=E,e.getExtensionDependencies=a,e.computeTargetPlatform=s;function f(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,n.compareIgnoreCase)(r.id,i.id)===0}const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(i){const o=i.manifest?i.manifest.version:i.version,u=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,o,u)}static parse(i){const o=S.exec(i);return o&&o[1]&&o[2]?new b({id:o[1]},o[2],o[4]||void 0):null}constructor(i,o,u="undefined"){this.version=o,this.targetPlatform=u,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?f(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=b;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(r){const i=g.exec(r);return i&&i[1]?[w(i[1]),i[2]]:[w(r),void 0]}function y(r,i){return`${r}.${i}`}function w(r){return r.toLowerCase()}function m(r,i){return w(y(r??I.UNDEFINED_PUBLISHER,i))}function c(r,i){const o=[],u=p=>{for(const C of o)if(C.some(M=>f(i(M),i(p))))return C;return null};for(const p of r){const C=u(p);C?C.push(p):o.push([p])}return o}function v(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function E(r){return{id:new l.TelemetryTrustedValue(r.identifier.id),name:new l.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function a(r,i){const o=[],u=i.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const p=u.shift();if(p&&o.every(C=>!f(C.identifier,{id:p}))){const C=r.filter(M=>f(M.identifier,{id:p}));C.length===1&&(o.push(C[0]),u.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}async function t(r,i){if(!A.isLinux)return!1;let o;try{o=(await r.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await r.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){i.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(p))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(r,i){const o=await t(r,i),u=(0,R.getTargetPlatform)(o?"alpine":A.platform,h.arch);return i.debug("ComputeTargetPlatform:",u),u}}),define(se[256],oe([0,1,209,54]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=I;async function I(A,k,P,h,l,f,S){const b={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${k.nameShort})`};if((0,R.supportsTelemetry)(k,P)&&(0,R.getTelemetryLevel)(h)===3){const g=await(0,n.getServiceMachineId)(P,l,f);b["X-Market-User-Id"]=g,b["VSCode-SessionId"]=S.machineId||g}return b}}),define(se[257],oe([0,1,2,35,4,25,188,18,52,80,27,45,28,54]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let d=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(m,c,v){this._configurationService=c,this._productService=v,this._experimentProperties={},this._disposables=new n.DisposableStore,this._cleanupPatterns=[],this._appenders=m.appenders,this._commonProperties=m.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=m.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!m.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(E),"gi")),E.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(E.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(E=>{(E.affectsConfiguration(b.TELEMETRY_SETTING_ID)||E.affectsConfiguration(b.TELEMETRY_OLD_SETTING_ID)||E.affectsConfiguration(b.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(m,c){this._experimentProperties[m]=c}_updateTelemetryLevel(){let m=(0,g.getTelemetryLevel)(this._configurationService);const c=this._productService.enabledTelemetryLevels;if(c){this._sendErrorTelemetry=this.sendErrorTelemetry?c.error:!1;const v=c.usage?3:c.error?2:0;m=Math.min(m,v)}this._telemetryLevel=m}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(m,c,v){this._telemetryLevel<c||(v=(0,R.mixin)(v,this._experimentProperties),v=(0,g.cleanData)(v,this._cleanupPatterns),v=(0,R.mixin)(v,this._commonProperties),this._appenders.forEach(E=>E.log(m,v)))}publicLog(m,c){this._log(m,3,c)}publicLog2(m,c){this.publicLog(m,c)}publicLogError(m,c){this._sendErrorTelemetry&&this._log(m,2,c)}publicLogError2(m,c){this.publicLogError(m,c)}};e.TelemetryService=d,e.TelemetryService=d=Ie([ie(1,P.IConfigurationService),ie(2,f.IProductService)],d);function y(){const w=(0,k.localize)(0,null,l.default.nameLong),m=l.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=I.isWeb?"":(0,k.localize)(3,null),v=(0,k.localize)(4,null),E=(0,k.localize)(5,null),a=(0,k.localize)(6,null),t=(0,k.localize)(7,null),s=`
|       | ${v} | ${E} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,k.localize)(8,null);return`
${w} ${m} ${c}

&nbsp;

${t}
${s}

&nbsp;

${r}
`}S.Registry.as(h.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,k.localize)(9,null),properties:{[b.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:y(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(h.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[b.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,k.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,k.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${b.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(se[258],oe([0,1,4,89,28]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=A,e.resolveSqmId=k;async function A(P,h){let l=P.getItem(I.machineIdKey);return(typeof l!="string"||n.isMacintosh&&l==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(l=await(0,R.getMachineId)(h.error.bind(h))),l}async function k(P,h){let l=P.getItem(I.sqmIdKey);return typeof l!="string"&&(l=await(0,R.getSqmMachineId)(h.error.bind(h))),l}}),define(se[259],oe([0,1,28,258]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=I,e.resolveSqmId=A;async function I(k,P){const h=await(0,R.resolveMachineId)(k,P);return k.setItem(n.machineIdKey,h),h}async function A(k,P){const h=await(0,R.resolveSqmId)(k,P);return k.setItem(n.sqmIdKey,h),h}}),define(se[128],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(se[260],oe([0,1,4,128]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const I=new Map([[R.EnvironmentVariableMutatorType.Append,"APPEND"],[R.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[R.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class A{constructor(f){this.collections=f,this.map=new Map,this.descriptionMap=new Map,f.forEach((S,b)=>{this.populateDescriptionMap(S,b);const g=S.map.entries();let d=g.next();for(;!d.done;){const y=d.value[1],w=d.value[0];let m=this.map.get(w);if(m||(m=[],this.map.set(w,m)),m.length>0&&m[0].type===R.EnvironmentVariableMutatorType.Replace){d=g.next();continue}const c={extensionIdentifier:b,value:y.value,type:y.type,scope:y.scope,variable:y.variable,options:y.options};c.scope||delete c.scope,m.unshift(c),d=g.next()}})}async applyToProcessEnvironment(f,S,b){let g;n.isWindows&&(g={},Object.keys(f).forEach(d=>g[d.toLowerCase()]=d));for(const[d,y]of this.getVariableMap(S)){const w=n.isWindows&&g[d.toLowerCase()]||d;for(const m of y){const c=b?await b(m.value):m.value;if(m.options?.applyAtProcessCreation??!0)switch(m.type){case R.EnvironmentVariableMutatorType.Append:f[w]=(f[w]||"")+c;break;case R.EnvironmentVariableMutatorType.Prepend:f[w]=c+(f[w]||"");break;case R.EnvironmentVariableMutatorType.Replace:f[w]=c;break}if(m.options?.applyAtShellIntegration??!1){const v=`VSCODE_ENV_${I.get(m.type)}`;f[v]=(f[v]?f[v]+":":"")+d+"="+this._encodeColons(c)}}}}_encodeColons(f){return f.replaceAll(":","\\x3a")}diff(f,S){const b=new Map,g=new Map,d=new Map;if(f.getVariableMap(S).forEach((y,w)=>{const m=this.getVariableMap(S).get(w),c=P(y,m);c&&b.set(w,c)}),this.getVariableMap(S).forEach((y,w)=>{const m=f.getVariableMap(S).get(w),c=P(y,m);c&&d.set(w,c)}),this.getVariableMap(S).forEach((y,w)=>{const m=f.getVariableMap(S).get(w),c=h(y,m);c&&g.set(w,c)}),!(b.size===0&&g.size===0&&d.size===0))return{added:b,changed:g,removed:d}}getVariableMap(f){const S=new Map;for(const b of this.map.values()){const g=b.filter(d=>k(d,f));g.length>0&&S.set(g[0].variable,g)}return S}getDescriptionMap(f){const S=new Map;for(const b of this.descriptionMap.values()){const g=b.filter(d=>k(d,f,!0));for(const d of g)S.set(d.extensionIdentifier,d.description)}return S}populateDescriptionMap(f,S){if(!f.descriptionMap)return;const b=f.descriptionMap.entries();let g=b.next();for(;!g.done;){const d=g.value[1],y=g.value[0];let w=this.descriptionMap.get(y);w||(w=[],this.descriptionMap.set(y,w));const m={extensionIdentifier:S,scope:d.scope,description:d.description};m.scope||delete m.scope,w.push(m),g=b.next()}}}e.MergedEnvironmentVariableCollection=A;function k(l,f,S=!1){return l.scope?!!(l.scope.workspaceFolder&&f?.workspaceFolder&&l.scope.workspaceFolder.index===f.workspaceFolder.index):S?f===l.scope:!0}function P(l,f){if(!f)return l;const S=new Set;f.forEach(g=>S.add(g.extensionIdentifier));const b=[];return l.forEach(g=>{S.has(g.extensionIdentifier)||b.push(g)}),b.length===0?void 0:b}function h(l,f){if(!f)return;const S=new Map;f.forEach(g=>S.set(g.extensionIdentifier,g));const b=[];return l.forEach(g=>{const d=S.get(g.extensionIdentifier);d&&(g.type!==d.type||g.value!==d.value||g.scope?.workspaceFolder?.index!==d.scope?.workspaceFolder?.index)&&b.push(d)}),b.length===0?void 0:b}}),define(se[261],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=n,e.serializeEnvironmentDescriptionMap=R,e.deserializeEnvironmentVariableCollection=I,e.deserializeEnvironmentDescriptionMap=A,e.serializeEnvironmentVariableCollections=k,e.deserializeEnvironmentVariableCollections=P;function n(h){return[...h.entries()]}function R(h){return h?[...h.entries()]:[]}function I(h){return new Map(h)}function A(h){return new Map(h??[])}function k(h){return Array.from(h.entries()).map(l=>[l[0],n(l[1].map),R(l[1].descriptionMap)])}function P(h){return new Map(h.map(l=>[l[0],{map:I(l[1]),descriptionMap:A(l[2])}]))}}),define(se[262],oe([0,1,8,23,3,2,5]),function(Q,e,n,R,I,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends A.Disposable{constructor(l,f){super(),this._logService=f,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new I.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=l===void 0?15e3:l,this._register((0,A.toDisposable)(()=>{for(const S of this._pendingRequestDisposables.values())(0,A.dispose)(S)}))}createRequest(l){return new Promise((f,S)=>{const b=++this._lastRequestId;this._pendingRequests.set(b,f),this._onCreateRequest.fire({requestId:b,...l});const g=new R.CancellationTokenSource;(0,n.timeout)(this._timeout,g.token).then(()=>S(`Request ${b} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(b,[(0,A.toDisposable)(()=>g.cancel())])})}acceptReply(l,f){const S=this._pendingRequests.get(l);S?(this._pendingRequests.delete(l),(0,A.dispose)(this._pendingRequestDisposables.get(l)||[]),this._pendingRequestDisposables.delete(l),S(f)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.RequestStore=P,e.RequestStore=P=Ie([ie(1,k.ILogService)],P)}),define(se[129],oe([0,1,6,118,45]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new R.RawContextKey("terminalTabFocusMode",!1,!0);var A;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(A||(e.TerminalSettingPrefix=A={}));var k;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.MiddleClickBehavior="terminal.integrated.middleClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.EnableVisualBell="terminal.integrated.enableVisualBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",a.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",a.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",a.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",a.MouseWheelZoom="terminal.integrated.mouseWheelZoom",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(k||(e.TerminalSettingId=k={}));var P;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh",a.Python="python"})(P||(e.PosixShellType=P={}));var h;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash",a.Python="python"})(h||(e.WindowsShellType=h={}));var l;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var f;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(f||(e.TerminalIpcChannels=f={}));var S;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(S||(e.ProcessPropertyType=S={})),e.IPtyService=(0,n.createDecorator)("ptyService");var b;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b||(e.HeartbeatConstants=b={}));var g;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(g||(e.TerminalLocation=g={}));var d;(function(a){a.TerminalView="view",a.Editor="editor"})(d||(e.TerminalLocationString=d={}));var y;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(y||(e.LocalReconnectConstants=y={}));var w;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(w||(e.FlowControlConstants=w={}));var m;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(m||(e.ProfileSource=m={}));var c;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(c||(e.ShellIntegrationStatus=c={}));var v;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(v||(e.TerminalExitReason=v={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(t){const s=this._sanitizeRemoteAuthority(t.remoteAuthority);if(this._backends.has(s))throw new Error(`A terminal backend with remote authority '${s}' was already registered.`);this._backends.set(s,t)}getTerminalBackend(t){return this._backends.get(this._sanitizeRemoteAuthority(t))}_sanitizeRemoteAuthority(t){return t?.toLowerCase()??""}}I.Registry.add(e.TerminalExtensions.Backend,new E),e.ILocalPtyService=(0,n.createDecorator)("localPtyService"),e.ITerminalLogService=(0,n.createDecorator)("terminalLogService")}),define(se[263],oe([0,1,75,7,190,106]),function(Q,e,n,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=k,e.terminalProfileArgsMatch=l,e.terminalIconsEqual=f,e.isUriComponents=S;function k(b,g){const d=[{name:null,description:(0,I.localize)(0,null)}];return d.push(...b.map(y=>({name:y.profileName,description:P(y)}))),g&&d.push(...g.map(y=>({name:y.title,description:h(y)}))),{values:d.map(y=>y.name),markdownDescriptions:d.map(y=>y.description)}}function P(b){let g=`$(${A.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:n.Codicon.terminal.id}) ${b.profileName}
- path: ${b.path}`;return b.args&&(typeof b.args=="string"?g+=`
- args: "${b.args}"`:g+=`
- args: [${b.args.length===0?"":`'${b.args.join("','")}'`}]`),b.overrideName!==void 0&&(g+=`
- overrideName: ${b.overrideName}`),b.color&&(g+=`
- color: ${b.color}`),b.env&&(g+=`
- env: ${JSON.stringify(b.env)}`),g}function h(b){return`$(${A.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:n.Codicon.terminal.id}) ${b.title}
- extensionIdentifier: ${b.extensionIdentifier}`}function l(b,g){if(!b&&!g)return!0;if(typeof b=="string"&&typeof g=="string")return b===g;if(Array.isArray(b)&&Array.isArray(g)){if(b.length!==g.length)return!1;for(let d=0;d<b.length;d++)if(b[d]!==g[d])return!1;return!0}return!1}function f(b,g){if(!b&&!g)return!0;if(!b||!g)return!1;if(A.ThemeIcon.isThemeIcon(b)&&A.ThemeIcon.isThemeIcon(g))return b.id===g.id&&b.color===g.color;if(typeof b=="object"&&"light"in b&&"dark"in b&&typeof g=="object"&&"light"in g&&"dark"in g){const d=b,y=g;if((R.URI.isUri(d.light)||S(d.light))&&(R.URI.isUri(d.dark)||S(d.dark))&&(R.URI.isUri(y.light)||S(y.light))&&(R.URI.isUri(y.dark)||S(y.dark)))return d.light.path===y.light.path&&d.dark.path===y.dark.path}if(R.URI.isUri(b)&&R.URI.isUri(g)||S(b)||S(g)){const d=b,y=g;return d.path===y.path&&d.scheme===y.scheme}return!1}function S(b){return b?typeof b.path=="string"&&typeof b.scheme=="string":!1}}),define(se[264],oe([0,1,75,4,189,52,45,263]),function(Q,e,n,R,I,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.terminalIconSchema=e.terminalColorSchema=void 0,e.registerTerminalPlatformConfiguration=g,e.registerTerminalDefaultProfileConfiguration=y,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,n.getAllCodicons)(),w=>w.id),markdownEnumDescriptions:Array.from((0,n.getAllCodicons)(),w=>`$(${w.id})`)};const h={args:{description:(0,I.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,I.localize)(1,null),type:"boolean"},icon:{description:(0,I.localize)(2,null),...e.terminalIconSchema},color:{description:(0,I.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,I.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},l={type:"object",required:["path"],properties:{path:{description:(0,I.localize)(5,null),type:["string","array"],items:{type:"string"}},...h}},f={type:"object",required:["path"],properties:{path:{description:(0,I.localize)(6,null),type:["string"],items:{type:"string"}},...h}};function S(w){const m=w===2?"linux":w===1?"osx":"windows";return(0,I.localize)(7,null,(0,R.PlatformToString)(w),'```json\n"terminal.integrated.profile.'+m+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const b={id:"terminal",order:100,title:(0,I.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,I.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},f],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,I.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},f],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,I.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},f],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:S(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,I.localize)(12,null),enum:["PowerShell","Git Bash"]},...h}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,I.localize)(13,null),type:"string"},id:{description:(0,I.localize)(14,null),type:"string"},title:{description:(0,I.localize)(15,null),type:"string"},...h}},{type:"null"},l]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:S(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,I.localize)(16,null),type:"string"},id:{description:(0,I.localize)(17,null),type:"string"},title:{description:(0,I.localize)(18,null),type:"string"},...h}},{type:"null"},l]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:S(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,I.localize)(19,null),type:"string"},id:{description:(0,I.localize)(20,null),type:"string"},title:{description:(0,I.localize)(21,null),type:"string"},...h}},{type:"null"},l]}},"terminal.integrated.useWslProfiles":{description:(0,I.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,I.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,I.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,I.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,I.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function g(){k.Registry.as(A.Extensions.Configuration).registerConfiguration(b),y()}let d;function y(w,m){const c=k.Registry.as(A.Extensions.Configuration);let v;w&&(v=(0,P.createProfileSchemaEnums)(w?.profiles,m));const E=d;d={id:"terminal",order:100,title:(0,I.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,I.localize)(28,null),type:["string","null"],default:null,enum:w?.os===3?v?.values:void 0,markdownEnumDescriptions:w?.os===3?v?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,I.localize)(29,null),type:["string","null"],default:null,enum:w?.os===2?v?.values:void 0,markdownEnumDescriptions:w?.os===2?v?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,I.localize)(30,null),type:["string","null"],default:null,enum:w?.os===1?v?.values:void 0,markdownEnumDescriptions:w?.os===1?v?.markdownDescriptions:void 0}}},c.updateConfigurations({add:[d],remove:E?[E]:[]})}}),define(se[265],oe([0,1,26,13,35,9,4,36,25,12,21,128,261,260]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsBuildNumber=d,e.findExecutable=y,e.getShellIntegrationInjection=w;function d(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let p=0;return u&&u.length===4&&(p=parseInt(u[3])),p}async function y(u,p,C,M=P.env,D=f.Promises.exists){if(A.isAbsolute(u))return await D(u)?u:void 0;if(p===void 0&&(p=P.cwd()),A.dirname(u)!=="."){const F=A.join(p,u);return await D(F)?F:void 0}const O=(0,I.getCaseInsensitive)(M,"PATH");if(C===void 0&&(0,l.isString)(O)&&(C=O.split(A.delimiter)),C===void 0||C.length===0){const F=A.join(p,u);return await D(F)?F:void 0}for(const F of C){let x;if(A.isAbsolute(F)?x=A.join(F,u):x=A.join(p,F,u),await D(x))return x;if(k.isWindows){let z=x+".com";if(await D(z)||(z=x+".exe",await D(z)))return z}}const _=A.join(p,u);return await D(_)?_:void 0}function w(u,p,C,M,D){const W=k.isWindows&&(!p.windowsEnableConpty||d()<18309);if(!p.shellIntegration.enabled||!u.executable||u.isFeatureTerminal&&!u.forceShellIntegration||u.ignoreShellIntegration||W)return;const O=u.args,_=P.platform==="win32"?A.basename(u.executable).toLowerCase():A.basename(u.executable),F=A.dirname(R.FileAccess.asFileUri("").fsPath);let x;const z={VSCODE_INJECTION:"1"};if(p.shellIntegration.nonce&&(z.VSCODE_NONCE=p.shellIntegration.nonce),k.isWindows){if(_==="pwsh.exe"||_==="powershell.exe")return!O||i(O)?x=v.get(c.WindowsPwsh):r(O)&&(x=v.get(c.WindowsPwshLogin)),x?(x=[...x],x[x.length-1]=(0,h.format)(x[x.length-1],F,""),p.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),{newArgs:x,envMixin:z}):void 0;if(_==="bash.exe")return!O||O.length===0?x=v.get(c.Bash):o(O)&&(z.VSCODE_SHELL_LOGIN="1",m(p,z),x=v.get(c.Bash)),x?(x=[...x],x[x.length-1]=(0,h.format)(x[x.length-1],F),{newArgs:x,envMixin:z}):void 0;M.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args);return}switch(_){case"bash":return!O||O.length===0?x=v.get(c.Bash):o(O)&&(z.VSCODE_SHELL_LOGIN="1",m(p,z),x=v.get(c.Bash)),x?(x=[...x],x[x.length-1]=(0,h.format)(x[x.length-1],F),{newArgs:x,envMixin:z}):void 0;case"fish":{const ue=C?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ee=A.join(F,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return z.XDG_DATA_DIRS=`${ue}:${ee}`,m(p,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!O||i(O)?x=v.get(c.Pwsh):r(O)&&(x=v.get(c.PwshLogin)),x?(p.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),x=[...x],x[x.length-1]=(0,h.format)(x[x.length-1],F,""),{newArgs:x,envMixin:z}):void 0;case"zsh":{if(!O||O.length===0?x=v.get(c.Zsh):o(O)?(x=v.get(c.ZshLogin),m(p,z)):(O===v.get(c.Zsh)||O===v.get(c.ZshLogin))&&(x=O),!x)return;x=[...x],x[x.length-1]=(0,h.format)(x[x.length-1],F);let ue;try{ue=n.userInfo().username}catch{ue="unknown"}const ee=A.join(n.tmpdir(),`${ue}-${D.applicationName}-zsh`);z.ZDOTDIR=ee;const le=C?.ZDOTDIR??n.homedir()??"~";z.USER_ZDOTDIR=le;const Y=[];return Y.push({source:A.join(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.join(ee,".zshrc")}),Y.push({source:A.join(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.join(ee,".zprofile")}),Y.push({source:A.join(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.join(ee,".zshenv")}),Y.push({source:A.join(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.join(ee,".zlogin")}),{newArgs:x,envMixin:z,filesToCopy:Y}}}M.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args)}function m(u,p){if(k.isMacintosh&&u.environmentVariableCollections){const C=(0,b.deserializeEnvironmentVariableCollections)(u.environmentVariableCollections),D=new g.MergedEnvironmentVariableCollection(C).getVariableMap({workspaceFolder:u.workspaceFolder}).get("PATH"),W=[];if(D)for(const O of D)O.type===S.EnvironmentVariableMutatorType.Prepend&&W.push(O.value);W.length>0&&(p.VSCODE_PATH_PREFIX=W.join(""))}}var c;(function(u){u.WindowsPwsh="windows-pwsh",u.WindowsPwshLogin="windows-pwsh-login",u.Pwsh="pwsh",u.PwshLogin="pwsh-login",u.Zsh="zsh",u.ZshLogin="zsh-login",u.Bash="bash"})(c||(c={}));const v=new Map;v.set(c.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(c.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(c.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),v.set(c.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),v.set(c.Zsh,["-i"]),v.set(c.ZshLogin,["-il"]),v.set(c.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],a=["--login","-l"],t=["-i","--interactive"],s=["-nol","-nologo"];function r(u){return typeof u=="string"?E.includes(u.toLowerCase()):u.length===1&&E.includes(u[0].toLowerCase())||u.length===2&&(E.includes(u[0].toLowerCase())||E.includes(u[1].toLowerCase()))&&(s.includes(u[0].toLowerCase())||s.includes(u[1].toLowerCase()))}function i(u){return typeof u=="string"?s.includes(u.toLowerCase()):u.length===0||u?.length===1&&s.includes(u[0].toLowerCase())}function o(u){return typeof u!="string"&&(u=u.filter(p=>!t.includes(p.toLowerCase()))),u==="string"&&a.includes(u.toLowerCase())||typeof u!="string"&&u.length===1&&a.includes(u[0].toLowerCase())}}),define(se[266],oe([0,1,49,75,9,4,12,21,110,265,117]),function(Q,e,n,R,I,A,k,P,h,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=d;var S;(function(u){u.UnixShellsPath="/etc/shells"})(S||(S={}));let b,g=!0;function d(u,p,C,M,D=process.env,W,O,_,F){return W=W||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},A.isWindows?y(C,W,D,O,M.getValue("terminal.integrated.useWslProfiles")!==!1,u&&typeof u=="object"?{...u}:M.getValue("terminal.integrated.profiles.windows"),typeof p=="string"?p:M.getValue("terminal.integrated.defaultProfile.windows"),F,_):r(W,O,C,u&&typeof u=="object"?{...u}:M.getValue(A.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof p=="string"?p:M.getValue(A.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,_,D)}async function y(u,p,C,M,D,W,O,_,F){const x=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),z=`${process.env.windir}\\${x?"Sysnative":"System32"}`;let ue=!1;(0,l.getWindowsBuildNumber)()>=16299&&(ue=!0),await v(_);const ee=new Map;if(u){ee.set("PowerShell",{source:"PowerShell",icon:R.Codicon.terminalPowershell,isAutoDetected:!0}),ee.set("Windows PowerShell",{path:`${z}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.Codicon.terminalPowershell,isAutoDetected:!0}),ee.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ee.set("Command Prompt",{path:`${z}\\cmd.exe`,icon:R.Codicon.terminalCmd,isAutoDetected:!0}),ee.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ee.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:R.Codicon.terminalBash,isAutoDetected:!0});const Y=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ee.set("Cmder",{path:`${z}\\cmd.exe`,args:["/K",Y],requiresPath:process.env.CMDER_ROOT?Y:{path:Y,isUnsafe:!0},isAutoDetected:!0})}i(W,ee);const le=await w(ee.entries(),O,p,C,M,F);if(u&&D)try{const Y=await t(`${z}\\${ue?"wsl":"bash"}.exe`,O);for(const G of Y)(!W||!(G.profileName in W))&&le.push(G)}catch{g&&(M?.trace("WSL is not installed, so could not detect WSL profiles"),g=!1)}return le}async function w(u,p,C,M=process.env,D,W){const O=[];for(const[_,F]of u)O.push(m(_,F,p,C,M,D,W));return(await Promise.all(O)).filter(_=>!!_)}async function m(u,p,C,M,D=process.env,W,O){if(p===null)return;let _,F,x;if("source"in p&&!("path"in p)){const le=b?.get(p.source);if(!le)return;_=le.paths,F=p.args||le.args,p.icon?x=c(p.icon):le.icon&&(x=le.icon)}else _=Array.isArray(p.path)?p.path:[p.path],F=A.isWindows||Array.isArray(p.args)?p.args:void 0,x=c(p.icon);let z;if(O){const le=_.map(G=>typeof G=="string"?G:G.path),Y=await O(le);z=new Array(_.length);for(let G=0;G<_.length;G++)typeof _[G]=="string"?z[G]=Y[G]:z[G]={path:Y[G],isUnsafe:!0}}else z=_.slice();let ue;if(p.requiresPath){let le;if((0,k.isString)(p.requiresPath)?le=p.requiresPath:(le=p.requiresPath.path,p.requiresPath.isUnsafe&&(ue=le)),!await M.existsFile(le))return}const ee=await o(u,C,z,M,D,F,p.env,p.overrideName,p.isAutoDetected,ue);if(!ee){W?.debug("Terminal profile not validated",u,_);return}return ee.isAutoDetected=p.isAutoDetected,ee.icon=x,ee.color=p.color,ee}function c(u){return typeof u=="string"?{id:u}:u}async function v(u){if(b&&!u)return;const[p,C]=await Promise.all([E(),u||a()]);b=new Map,b.set("Git Bash",{profileName:"Git Bash",paths:p,args:["--login","-i"]}),b.set("PowerShell",{profileName:"PowerShell",paths:C,icon:R.Codicon.terminalPowershell})}async function E(){const u=new Set,p=await(0,l.findExecutable)("git.exe");if(p){const D=(0,f.dirname)(p);u.add((0,f.resolve)(D,"../.."))}function C(D,W){W&&D.add(W)}C(u,process.env.ProgramW6432),C(u,process.env.ProgramFiles),C(u,process.env["ProgramFiles(X86)"]),C(u,`${process.env.LocalAppData}\\Program`);const M=[];for(const D of u)M.push(`${D}\\Git\\bin\\bash.exe`,`${D}\\Git\\usr\\bin\\bash.exe`,`${D}\\usr\\bin\\bash.exe`);return M.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),M.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),M}async function a(){const u=[];for await(const p of(0,h.enumeratePowerShellInstallations)())u.push(p.exePath);return u}async function t(u,p){const C=[],M=await new Promise((O,_)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,x)=>{if(F)return _("Problem occurred when getting wsl distros");O(x)})});if(!M)return[];const D=new RegExp(/[\r?\n]/),W=M.split(D).filter(O=>O.trim().length>0&&O!=="");for(const O of W){if(O===""||O.startsWith("docker-desktop"))continue;const _=`${O} (WSL)`,F={profileName:_,path:u,args:["-d",`${O}`],isDefault:_===p,icon:s(O),isAutoDetected:!1};C.push(F)}return C}function s(u){return u.includes("Ubuntu")?R.Codicon.terminalUbuntu:u.includes("Debian")?R.Codicon.terminalDebian:R.Codicon.terminalLinux}async function r(u,p,C,M,D,W,O,_){const F=new Map;if(C&&await u.existsFile("/etc/shells")){const x=(await u.readFile("/etc/shells")).toString(),z=(W||x.split(`
`)).map(ee=>{const le=ee.indexOf("#");return le===-1?ee:ee.substring(0,le)}).filter(ee=>ee.trim().length>0),ue=new Map;for(const ee of z){let le=(0,I.basename)(ee),Y=ue.get(le)||0;Y++,Y>1&&(le=`${le} (${Y})`),ue.set(le,Y),F.set(le,{path:ee,isAutoDetected:!0})}}return i(M,F),await w(F.entries(),D,u,_,p,O)}function i(u,p){if(u)for(const[C,M]of Object.entries(u))M===null||typeof M!="object"||!("path"in M)&&!("source"in M)?p.delete(C):(M.icon=M.icon||p.get(C)?.icon,p.set(C,M))}async function o(u,p,C,M,D,W,O,_,F,x){if(C.length===0)return Promise.resolve(void 0);const z=C.shift();if(z==="")return o(u,p,C,M,D,W,O,_,F);const ue=typeof z!="string"&&z.isUnsafe,ee=typeof z=="string"?z:z.path,le={profileName:u,path:ee,args:W,env:O,overrideName:_,isAutoDetected:F,isDefault:u===p,isUnsafePath:ue,requiresUnsafePath:x};if((0,I.basename)(ee)===ee){const G=D.PATH?D.PATH.split(I.delimiter):void 0,B=await(0,l.findExecutable)(ee,void 0,G,void 0,M.existsFile);return B?(le.path=B,le.isFromPath=!0,le):o(u,p,C,M,D,W)}return await M.existsFile((0,I.normalize)(ee))?le:o(u,p,C,M,D,W,O,_,F)}}),define(se[267],oe([0,1,3,2,4,44,18,5,230,95,262,129,264,266,112,73]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var w;(function(c){c[c.MaxRestarts=5]="MaxRestarts"})(w||(w={}));let m=class extends R.Disposable{get _connection(){return this._ensurePtyHost(),this.__connection}get _proxy(){return this._ensurePtyHost(),this.__proxy}get _optionalProxy(){return this.__proxy}_ensurePtyHost(){this.__connection||this._startPtyHost()}constructor(v,E,a,t){super(),this._ptyHostStarter=v,this._configurationService=E,this._logService=a,this._loggerService=t,this._wasQuitRequested=!1,this._restartCount=0,this._isResponsive=!0,this._onPtyHostExit=this._register(new n.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new n.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new n.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new n.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new n.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new n.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new n.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new n.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new n.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new n.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new n.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new n.Emitter),this.onProcessExit=this._onProcessExit.event,(0,b.registerTerminalPlatformConfiguration)(),this._register(this._ptyHostStarter),this._register((0,R.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new f.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),this._ptyHostStarter.onRequestConnection&&n.Event.once(this._ptyHostStarter.onRequestConnection)(()=>this._ensurePtyHost()),this._ptyHostStarter.onWillShutdown?.(()=>this._wasQuitRequested=!0)}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._optionalProxy?.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(I.isWindows)return process.env;try{return await(0,l.getResolvedShellEnv)(this._configurationService,this._logService,{_:[]},process.env)}catch(v){return this._logService.error("ptyHost was unable to resolve shell environment",v),{}}}_startPtyHost(){const v=this._ptyHostStarter.start(),E=v.client;this._logService.getLevel()===P.LogLevel.Trace&&this._logService.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),A.ProxyChannel.toService(E.getChannel(S.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(!0),this._register(v.onDidProcessExit(s=>{this._onPtyHostExit.fire(s.code),!this._wasQuitRequested&&!this._store.isDisposed&&(this._restartCount<=w.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}, giving up`))}));const t=A.ProxyChannel.toService(E.getChannel(S.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(s=>this._onProcessData.fire(s))),this._register(t.onProcessReady(s=>this._onProcessReady.fire(s))),this._register(t.onProcessExit(s=>this._onProcessExit.fire(s))),this._register(t.onDidChangeProperty(s=>this._onDidChangeProperty.fire(s))),this._register(t.onProcessReplay(s=>this._onProcessReplay.fire(s))),this._register(t.onProcessOrphanQuestion(s=>this._onProcessOrphanQuestion.fire(s))),this._register(t.onDidRequestDetach(s=>this._onDidRequestDetach.fire(s))),this._register(new h.RemoteLoggerChannelClient(this._loggerService,E.getChannel(S.TerminalIpcChannels.Logger))),this.__connection=v,this.__proxy=t,this._onPtyHostStart.fire(),this._register(this._configurationService.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()})),this._refreshIgnoreProcessNames(),[v,t]}async createProcess(v,E,a,t,s,r,i,o,u,p,C){const M=setTimeout(()=>this._handleUnresponsiveCreateProcess(),S.HeartbeatConstants.CreateProcessTimeout),D=await this._proxy.createProcess(v,E,a,t,s,r,i,o,u,p,C);return clearTimeout(M),D}updateTitle(v,E,a){return this._proxy.updateTitle(v,E,a)}updateIcon(v,E,a,t){return this._proxy.updateIcon(v,E,a,t)}attachToProcess(v){return this._proxy.attachToProcess(v)}detachFromProcess(v,E){return this._proxy.detachFromProcess(v,E)}shutdownAll(){return this._proxy.shutdownAll()}listProcesses(){return this._proxy.listProcesses()}async getPerformanceMarks(){return this._optionalProxy?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this._optionalProxy?.reduceConnectionGraceTime()}start(v){return this._proxy.start(v)}shutdown(v,E){return this._proxy.shutdown(v,E)}input(v,E){return this._proxy.input(v,E)}processBinary(v,E){return this._proxy.processBinary(v,E)}resize(v,E,a){return this._proxy.resize(v,E,a)}clearBuffer(v){return this._proxy.clearBuffer(v)}acknowledgeDataEvent(v,E){return this._proxy.acknowledgeDataEvent(v,E)}setUnicodeVersion(v,E){return this._proxy.setUnicodeVersion(v,E)}getInitialCwd(v){return this._proxy.getInitialCwd(v)}getCwd(v){return this._proxy.getCwd(v)}async getLatency(){const v=new y.StopWatch,E=await this._proxy.getLatency();return v.stop(),[{label:"ptyhostservice<->ptyhost",latency:v.elapsed()},...E]}orphanQuestionReply(v){return this._proxy.orphanQuestionReply(v)}installAutoReply(v,E){return this._proxy.installAutoReply(v,E)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(v){return this._proxy.uninstallAutoReply(v)}getDefaultSystemShell(v){return this._optionalProxy?.getDefaultSystemShell(v)??(0,d.getSystemShell)(v??I.OS,process.env)}async getProfiles(v,E,a,t=!1){const s=await this._resolveShellEnv();return(0,g.detectAvailableProfiles)(E,a,t,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,v))}async getEnvironment(){return this.__proxy?this._proxy.getEnvironment():{...process.env}}getWslPath(v,E){return this._proxy.getWslPath(v,E)}getRevivedPtyNewId(v,E){return this._proxy.getRevivedPtyNewId(v,E)}setTerminalLayoutInfo(v){return this._proxy.setTerminalLayoutInfo(v)}async getTerminalLayoutInfo(v){return this._optionalProxy?.getTerminalLayoutInfo(v)}async requestDetachInstance(v,E){return this._proxy.requestDetachInstance(v,E)}async acceptDetachInstanceReply(v,E){return this._proxy.acceptDetachInstanceReply(v,E)}async freePortKillProcess(v){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(v)}async serializeTerminalState(v){return this._proxy.serializeTerminalState(v)}async reviveTerminalProcesses(v,E,a){return this._proxy.reviveTerminalProcesses(v,E,a)}async refreshProperty(v,E){return this._proxy.refreshProperty(v,E)}async updateProperty(v,E,a){return this._proxy.updateProperty(v,E,a)}async restartPtyHost(){this._disposePtyHost(),this._isResponsive=!0,this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll(),this._connection.store.dispose()}_handleHeartbeat(v){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),v?S.HeartbeatConstants.ConnectingBeatInterval:S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier+S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${S.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(v,E){return this._resolveVariablesRequestStore.createRequest({workspaceId:v,originalText:E})}async acceptPtyHostResolvedVariables(v,E){this._resolveVariablesRequestStore.acceptReply(v,E)}};e.PtyHostService=m,e.PtyHostService=m=Ie([ie(1,k.IConfigurationService),ie(2,P.ILogService),ie(3,P.ILoggerService)],m)}),define(se[69],oe([0,1,14,3,2,4,18,6,34]),function(Q,e,n,R,I,A,k,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const l="#FFFFFF",f="#1E1E1E",S="#000000",b="#FFFFFF",g="theme",d="themeBackground",y="windowSplash";var w;(function(c){c.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",c.SYSTEM_COLOR_THEME="window.systemColorTheme"})(w||(w={})),e.IThemeMainService=(0,P.createDecorator)("themeMainService");let m=class extends I.Disposable{constructor(v,E){super(),this.stateService=v,this.configurationService=E,this._onDidChangeColorScheme=this._register(new R.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,A.isLinux||this._register(this.configurationService.onDidChangeConfiguration(a=>{(a.affectsConfiguration(w.SYSTEM_COLOR_THEME)||a.affectsConfiguration(w.DETECT_COLOR_SCHEME))&&this.updateSystemColorTheme()})),this.updateSystemColorTheme(),this._register(R.Event.fromNodeEventEmitter(n.nativeTheme,"updated")(()=>this._onDidChangeColorScheme.fire(this.getColorScheme())))}updateSystemColorTheme(){if(A.isLinux||this.configurationService.getValue(w.DETECT_COLOR_SCHEME))n.nativeTheme.themeSource="system";else switch(this.configurationService.getValue(w.SYSTEM_COLOR_THEME)){case"dark":n.nativeTheme.themeSource="dark";break;case"light":n.nativeTheme.themeSource="light";break;case"auto":switch(this.getBaseTheme()){case"vs":n.nativeTheme.themeSource="light";break;case"vs-dark":n.nativeTheme.themeSource="dark";break;default:n.nativeTheme.themeSource="system"}break;default:n.nativeTheme.themeSource="system";break}}getColorScheme(){if(A.isWindows){if(n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(A.isMacintosh){if(n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(A.isLinux&&n.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const v=this.getColorScheme();if(v.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return v.dark?S:b;let E=this.stateService.getItem(d,null);if(!E)switch(this.getBaseTheme()){case"vs":E=l;break;case"hc-black":E=S;break;case"hc-light":E=b;break;default:E=f}return A.isMacintosh&&E.toUpperCase()===f&&(E="#171717"),E}getBaseTheme(){switch(this.stateService.getItem(g,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(v,E){this.stateService.setItems([{key:g,data:E.baseTheme},{key:d,data:E.colorInfo.background},{key:y,data:E}]),typeof v=="number"&&this.updateBackgroundColor(v,E),this.updateSystemColorTheme()}updateBackgroundColor(v,E){for(const a of n.BrowserWindow.getAllWindows())if(a.id===v){a.setBackgroundColor(E.colorInfo.background);break}}getWindowSplash(){return this.stateService.getItem(y)}};e.ThemeMainService=m,e.ThemeMainService=m=Ie([ie(0,h.IStateService),ie(1,k.IConfigurationService)],m)}),define(se[130],oe([0,1,3,7,18,6,5]),function(Q,e,n,R,I,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=l,e.extractLocalHostUriMetaDataForPortMapping=S,e.extractQueryLocalHostUriMetaDataForPortMapping=b,e.isLocalhost=g,e.isAllInterfaces=d,e.isPortPrivileged=y,e.ITunnelService=(0,A.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,A.createDecorator)("sharedTunnelsService");var P;(function(c){c.Http="http",c.Https="https"})(P||(e.TunnelProtocol=P={}));var h;(function(c){c.ConstantPrivate="constantPrivate",c.Private="private",c.Public="public"})(h||(e.TunnelPrivacyId=h={}));function l(c){return!!c.forwardPort}var f;(function(c){c[c.Notify=1]="Notify",c[c.OpenBrowser=2]="OpenBrowser",c[c.OpenPreview=3]="OpenPreview",c[c.Silent=4]="Silent",c[c.Ignore=5]="Ignore",c[c.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function S(c){if(c.scheme!=="http"&&c.scheme!=="https")return;const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(c.authority);if(v)return{address:v[1],port:+v[2]}}function b(c){if(c.scheme!=="http"&&c.scheme!=="https"||!c.query)return;const v=c.query.split("&");for(const E of v){const a=E.split("=")[1];if(/^https?:/.exec(a)){const t=S(R.URI.parse(a));if(t)return t}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function g(c){return e.LOCALHOST_ADDRESSES.indexOf(c)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function d(c){return e.ALL_INTERFACES_ADDRESSES.indexOf(c)>=0}function y(c,v,E,a){if(E===1)return!1;if(E===2&&d(v)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(t?.length===4&&parseInt(t[1])>=18)return!1}return c<1024}class w{constructor(v,E,a){this.remoteAddress=v,this.localAddress=E,this._dispose=a,this._onDispose=new n.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=w;let m=class{constructor(v,E){this.logService=v,this.configurationService=E,this._onTunnelOpened=new n.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new n.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new n.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const v=this.configurationService.getValue("remote.localPortHost");return!v||v==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(v){return this._tunnelProvider=v,v?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(v){this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions,this._canChangeProtocol=v.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const v=[],E=Array.from(this._tunnels.values());for(const a of E){const t=Array.from(a.values());for(const s of t){const r=await s.value;r&&typeof r!="string"&&v.push(r)}}return v}async dispose(){for(const v of this._tunnels.values()){for(const{value:E}of v.values())await E.then(a=>typeof a!="string"?a?.dispose():void 0);v.clear()}this._tunnels.clear()}setEnvironmentTunnel(v,E,a,t,s){this.addTunnelToMap(v,E,Promise.resolve({tunnelRemoteHost:v,tunnelRemotePort:E,localAddress:a,privacy:t,protocol:s,dispose:()=>Promise.resolve()}))}async getExistingTunnel(v,E){(d(v)||g(v))&&(v=e.LOCALHOST_ADDRESSES[0]);const a=this.getTunnelFromMap(v,E);if(a)return++a.refcount,a.value}openTunnel(v,E,a,t,s,r=!1,i,o){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${E}:${a} on local port ${s}.`);const u=this._tunnelProvider??v;if(!u)return;if(E||(E="localhost"),t||(t=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(a)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const p=this.retainOrCreateTunnel(u,E,a,t,s,r,i,o);return p?p.then(C=>{if(C){if(typeof C=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(E,a),C}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(E,a);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const M=this.makeTunnel(C);return(C.tunnelRemoteHost!==E||C.tunnelRemotePort!==a)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),i&&C.privacy!==i&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(M),M}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),p)}makeTunnel(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,privacy:v.privacy,protocol:v.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemoteHost}:${v.tunnelRemotePort} `);const E=this._tunnels.get(v.tunnelRemoteHost);if(E){const a=E.get(v.tunnelRemotePort);a&&(a.refcount--,await this.tryDisposeTunnel(v.tunnelRemoteHost,v.tunnelRemotePort,a))}}}}async tryDisposeTunnel(v,E,a){if(a.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${E}.`);const t=a.value.then(async s=>{s&&typeof s!="string"&&(await s.dispose(!0),this._onTunnelClosed.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this._tunnels.has(v)&&this._tunnels.get(v).delete(E),t}}async closeTunnel(v,E){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${v}:${E} `);const a=this._tunnels.get(v);if(a&&a.has(E)){const t=a.get(E);t.refcount=0,await this.tryDisposeTunnel(v,E,t)}}addTunnelToMap(v,E,a){this._tunnels.has(v)||this._tunnels.set(v,new Map),this._tunnels.get(v).set(E,{refcount:1,value:a})}async removeEmptyOrErrorTunnelFromMap(v,E){const a=this._tunnels.get(v);if(a){const t=a.get(E),s=t?await t.value:void 0;(!s||typeof s=="string")&&a.delete(E),a.size===0&&this._tunnels.delete(v)}}getTunnelFromMap(v,E){const a=[v];g(v)?(a.push(...e.LOCALHOST_ADDRESSES),a.push(...e.ALL_INTERFACES_ADDRESSES)):d(v)&&a.push(...e.ALL_INTERFACES_ADDRESSES);const t=a.map(s=>this._tunnels.get(s));for(const s of t){const r=s?.get(E);if(r)return r}}canTunnel(v){return!!S(v)}createWithProvider(v,E,a,t,s,r,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${E}:${a} on local port ${t}.`);const o=a;this._factoryInProgress.add(o);const u=t===void 0?a:t,p={elevationRequired:s?this.isPortPrivileged(u):!1},C={remoteAddress:{host:E,port:a},localAddressPort:t,privacy:r,public:r?r!==h.Private:void 0,protocol:i},M=v.forwardPort(C,p);return M?(this.addTunnelToMap(E,a,M),M.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),M}};e.AbstractTunnelService=m,e.AbstractTunnelService=m=Ie([ie(0,k.ILogService),ie(1,I.IConfigurationService)],m)}),define(se[50],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.DisablementReason=e.UpdateType=e.StateType=void 0;var R;(function(k){k.Uninitialized="uninitialized",k.Idle="idle",k.Disabled="disabled",k.CheckingForUpdates="checking for updates",k.AvailableForDownload="available for download",k.Downloading="downloading",k.Downloaded="downloaded",k.Updating="updating",k.Ready="ready"})(R||(e.StateType=R={}));var I;(function(k){k[k.Setup=0]="Setup",k[k.Archive=1]="Archive",k[k.Snap=2]="Snap",k[k.WindowsInstaller=3]="WindowsInstaller"})(I||(e.UpdateType=I={}));var A;(function(k){k[k.NotBuilt=0]="NotBuilt",k[k.DisabledByEnvironment=1]="DisabledByEnvironment",k[k.ManuallyDisabled=2]="ManuallyDisabled",k[k.MissingConfiguration=3]="MissingConfiguration",k[k.InvalidConfiguration=4]="InvalidConfiguration",k[k.RunningAsAdmin=5]="RunningAsAdmin"})(A||(e.DisablementReason=A={})),e.State={Uninitialized:{type:"uninitialized"},Disabled:k=>({type:"disabled",reason:k}),Idle:(k,P)=>({type:"idle",updateType:k,error:P}),CheckingForUpdates:k=>({type:"checking for updates",explicit:k}),AvailableForDownload:k=>({type:"available for download",update:k}),Downloading:{type:"downloading"},Downloaded:k=>({type:"downloaded",update:k}),Updating:k=>({type:"updating",update:k}),Ready:k=>({type:"ready",update:k})},e.IUpdateService=(0,n.createDecorator)("updateService")}),define(se[268],oe([0,1,4,191,52,45]),function(Q,e,n,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),A.Registry.as(I.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,R.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,R.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null),(0,R.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,R.localize)(6,null),deprecationMessage:(0,R.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,R.localize)(8,null),description:(0,R.localize)(9,null),included:n.isWindows&&!n.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,R.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(se[269],oe([0,1,3,50]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class I{constructor(P){this.service=P}listen(P,h){switch(h){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${h}`)}call(P,h,l){switch(h){case"checkForUpdates":return this.service.checkForUpdates(l);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(l)}throw new Error(`Call not found: ${h}`)}}e.UpdateChannel=I;class A{get state(){return this._state}set state(P){this._state=P,this._onStateChange.fire(P)}constructor(P){this.channel=P,this._onStateChange=new n.Emitter,this.onStateChange=this._onStateChange.event,this._state=R.State.Uninitialized,this.channel.listen("onStateChange")(h=>this.state=h),this.channel.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(P){return this.channel.call("checkForUpdates",P)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(P){return this.channel.call("_applySpecificUpdate",P)}}e.UpdateChannelClient=A}),define(se[40],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,n.createDecorator)("IUriIdentityService")}),define(se[270],oe([0,1,40,210,16,19,142,3,2]),function(Q,e,n,R,I,A,k,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class l{static{this._clock=0}constructor(b){this.uri=b,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let f=class{constructor(b){this._fileService=b,this._dispooables=new h.DisposableStore,this._limit=2**16;const g=new Map,d=y=>{let w=g.get(y.scheme);return w===void 0&&(w=b.hasProvider(y)&&!this._fileService.hasCapability(y,1024),g.set(y.scheme,w)),w};this._dispooables.add(P.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(y=>{g.delete(y.scheme)})),this.extUri=new A.ExtUri(d),this._canonicalUris=new k.SkipList((y,w)=>this.extUri.compare(y,w,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(b){this._fileService.hasProvider(b)&&(b=(0,A.normalizePath)(b));const g=this._canonicalUris.get(b);return g?g.touch().uri.with({fragment:b.fragment}):(this._canonicalUris.set(b,new l(b)),this._checkTrim(),b)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const b=[...this._canonicalUris.entries()].sort((d,y)=>d[1].time<y[1].time?1:d[1].time>y[1].time?-1:0);l._clock=0,this._canonicalUris.clear();const g=this._limit*.5;for(let d=0;d<g;d++)this._canonicalUris.set(b[d][0],b[d][1].touch())}};e.UriIdentityService=f,e.UriIdentityService=f=Ie([ie(0,I.IFileService)],f),(0,R.registerSingleton)(n.IUriIdentityService,f,1)}),define(se[131],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,n.createDecorator)("urlService")}),define(se[271],oe([0,1,7]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class R{constructor(P){this.handler=P}listen(P,h){throw new Error(`Event not found: ${h}`)}call(P,h,l){switch(h){case"handleURL":return this.handler.handleURL(n.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${h}`)}}e.URLHandlerChannel=R;class I{constructor(P){this.channel=P}handleURL(P,h){return this.channel.call("handleURL",[P.toJSON(),h])}}e.URLHandlerChannelClient=I;class A{constructor(P,h){this.next=P,this.logService=h}async routeCall(P,h,l,f){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(Array.isArray(l)&&l.length>0){const S=n.URI.revive(l[0]);if(this.logService.trace("URLHandlerRouter#routeCall() with URI argument",S.toString(!0)),S.query){const b=/\bwindowId=(\d+)/.exec(S.query);if(b){const g=b[1];this.logService.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${g}"`,S.toString(!0));const d=new RegExp(`window:${g}`),y=P.connections.find(w=>(this.logService.trace("URLHandlerRouter#routeCall(): testing connection",w.ctx),d.test(w.ctx)));if(y)return this.logService.trace("URLHandlerRouter#routeCall(): found a connection to route",S.toString(!0)),y;this.logService.trace("URLHandlerRouter#routeCall(): did not find a connection to route",S.toString(!0))}else this.logService.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",S.toString(!0))}}else this.logService.trace("URLHandlerRouter#routeCall() without URI argument");return this.next.routeCall(P,h,l,f)}routeEvent(P,h){throw new Error(`Event not found: ${h}`)}}e.URLHandlerRouter=A}),define(se[272],oe([0,1,8,2,7,27]),function(Q,e,n,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class k extends R.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(l,f){const S=[...this.handlers.values()];return(0,n.first)(S.map(b=>()=>b.handleURL(l,f)),void 0,!1).then(b=>b||!1)}registerHandler(l){return this.handlers.add(l),(0,R.toDisposable)(()=>this.handlers.delete(l))}}e.AbstractURLService=k;let P=class extends k{constructor(l){super(),this.productService=l}create(l){let{authority:f,path:S,query:b,fragment:g}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return f&&S&&S.indexOf("/")!==0&&(S=`/${S}`),I.URI.from({scheme:this.productService.urlProtocol,authority:f,path:S,query:b,fragment:g})}};e.NativeURLService=P,e.NativeURLService=P=Ie([ie(0,A.IProductService)],P)}),define(se[273],oe([0,1,14,8,3,2,4,7]),function(Q,e,n,R,I,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class h extends A.Disposable{constructor(f,S,b,g,d,y){if(super(),this.urlService=S,this.logService=y,this.uris=[],this.retryCount=0,f&&(y.trace("ElectronURLListener initialUrisToHandle:",f.map(c=>c.originalUrl)),this.uris=f),k.isWindows){const c=g.isBuilt?[]:[`"${g.appRoot}"`];c.push("--open-url","--"),n.app.setAsDefaultProtocolClient(d.urlProtocol,process.execPath,c)}const w=I.Event.map(I.Event.fromNodeEventEmitter(n.app,"open-url",(c,v)=>({event:c,url:v})),({event:c,url:v})=>(c.preventDefault(),v));this._register(w(c=>{const v=this.uriFromRawUrl(c);v&&this.urlService.open(v,{originalUrl:c})})),b.getWindows().filter(c=>c.isReady).length>0?(y.trace("ElectronURLListener: window is ready to handle URLs"),this.flush()):(y.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this._register(I.Event.once(b.onDidSignalReadyWindow)(()=>this.flush())))}uriFromRawUrl(f){try{return P.URI.parse(f)}catch{return}}async flush(){if(this.retryCount++>10){this.logService.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.logService.trace("ElectronURLListener#flush(): flushing URLs");const f=[];for(const S of this.uris)await this.urlService.open(S.uri,{originalUrl:S.originalUrl})?this.logService.trace("ElectronURLListener#flush(): URL was handled",S.originalUrl):(this.logService.trace("ElectronURLListener#flush(): URL was not yet handled",S.originalUrl),f.push(S));f.length!==0&&(this.uris=f,(0,R.disposableTimeout)(()=>this.flush(),500,this._store))}}e.ElectronURLListener=h}),define(se[274],oe([0,1,3,2,16,59,32]),function(Q,e,n,R,I,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends R.Disposable{constructor(l,f,S,b,g,d){super(),this.fileSystemScheme=l,this.fileSystemProvider=f,this.userDataScheme=S,this.userDataProfilesService=b,this.uriIdentityService=g,this.logService=d,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new k.ResourceSet(y=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(y))),this.updateAtomicReadWritesResources(),this._register(b.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(y=>this.handleFileChanges(y)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const l of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(l.settingsResource),this.atomicReadWriteResources.add(l.keybindingsResource),this.atomicReadWriteResources.add(l.tasksResource),this.atomicReadWriteResources.add(l.extensionsResource)}open(l,f){return this.fileSystemProvider.open(this.toFileSystemResource(l),f)}close(l){return this.fileSystemProvider.close(l)}read(l,f,S,b,g){return this.fileSystemProvider.read(l,f,S,b,g)}write(l,f,S,b,g){return this.fileSystemProvider.write(l,f,S,b,g)}watch(l,f){this.watchResources.set(l,l);const S=this.fileSystemProvider.watch(this.toFileSystemResource(l),f);return(0,R.toDisposable)(()=>{this.watchResources.delete(l),S.dispose()})}stat(l){return this.fileSystemProvider.stat(this.toFileSystemResource(l))}mkdir(l){return this.fileSystemProvider.mkdir(this.toFileSystemResource(l))}rename(l,f,S){return this.fileSystemProvider.rename(this.toFileSystemResource(l),this.toFileSystemResource(f),S)}readFile(l,f){return this.fileSystemProvider.readFile(this.toFileSystemResource(l),f)}readFileStream(l,f,S){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(l),f,S)}readdir(l){return this.fileSystemProvider.readdir(this.toFileSystemResource(l))}enforceAtomicReadFile(l){return this.atomicReadWriteResources.has(l)}writeFile(l,f,S){return this.fileSystemProvider.writeFile(this.toFileSystemResource(l),f,S)}enforceAtomicWriteFile(l){return this.atomicReadWriteResources.has(l)?{postfix:".vsctmp"}:!1}delete(l,f){return this.fileSystemProvider.delete(this.toFileSystemResource(l),f)}copy(l,f,S){if((0,I.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(l),this.toFileSystemResource(f),S);throw new Error("copy not supported")}cloneFile(l,f){if((0,I.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(l),this.toFileSystemResource(f));throw new Error("clone not supported")}handleFileChanges(l){const f=[];for(const S of l){if(S.resource.scheme!==this.fileSystemScheme)continue;const b=this.toUserDataResource(S.resource);this.watchResources.findSubstr(b)&&f.push({resource:b,type:S.type,cId:S.cId})}f.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(f))}toFileSystemResource(l){return l.with({scheme:this.fileSystemScheme})}toUserDataResource(l){return l.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=P}),define(se[275],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(se[276],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,n.createDecorator)("webviewManagerService")}),define(se[277],oe([0,1,14,2,13,7]),function(Q,e,n,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class k extends R.Disposable{static{this.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const h=this.handleWebviewRequest.bind(this);n.protocol.registerFileProtocol(I.Schemas.vscodeWebview,h)}handleWebviewRequest(h,l){try{const f=A.URI.parse(h.url),S=k.validWebviewFilePaths.get(f.path);if(typeof S=="string"){const b=`vs/workbench/contrib/webview/browser/pre/${S}`,g=I.FileAccess.asFileUri(b);return l({path:g.fsPath,headers:{...I.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.WebviewProtocolProvider=k}),define(se[55],oe([0,1,4]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.WindowMinimumSize=void 0,e.isOpenedAuxiliaryWindow=R,e.isWorkspaceToOpen=I,e.isFolderToOpen=A,e.isFileToOpen=k,e.getMenuBarVisibility=P,e.hasCustomTitlebar=S,e.hasNativeTitlebar=b,e.getTitleBarStyle=g,e.useWindowControlsOverlay=d,e.useNativeFullScreen=y,e.zoomLevelToZoomFactor=w,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(m){return typeof m.parentId=="number"}function I(m){return!!m.workspaceUri}function A(m){return!!m.folderUri}function k(m){return!!m.fileUri}function P(m){const c=b(m),v=m.getValue("window.menuBarVisibility");return v==="default"||c&&v==="compact"||n.isMacintosh&&n.isNative?"classic":v}var h;(function(m){m.TITLE_BAR_STYLE="window.titleBarStyle",m.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(h||(e.TitleBarSetting=h={}));var l;(function(m){m.NATIVE="native",m.CUSTOM="custom"})(l||(e.TitlebarStyle=l={}));var f;(function(m){m.AUTO="auto",m.WINDOWED="windowed",m.NEVER="never"})(f||(e.CustomTitleBarVisibility=f={}));function S(m,c){return!0}function b(m,c){return c||(c=g(m)),c==="native"}function g(m){if(n.isWeb)return"custom";const c=m.getValue("window");if(c){if(n.isMacintosh&&c.nativeTabs===!0||n.isMacintosh&&c.nativeFullScreen===!1)return"native";const a=c.titleBarStyle;if(a==="native"||a==="custom")return a}return n.isLinux?"native":"custom"}function d(m){return!(!n.isWindows||n.isWeb||b(m))}function y(m){const c=m.getValue("window");return!c||typeof c.nativeFullScreen!="boolean"||c.nativeTabs?!0:c.nativeFullScreen!==!1}function w(m=0){return Math.pow(1.2,m)}}),define(se[82],oe([0,1,14]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultAuxWindowState=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var R;(function(l){l[l.INITIAL=1]="INITIAL",l[l.LOAD=2]="LOAD",l[l.RELOAD=3]="RELOAD"})(R||(e.LoadReason=R={}));var I;(function(l){l[l.CLOSE=1]="CLOSE",l[l.QUIT=2]="QUIT",l[l.RELOAD=3]="RELOAD",l[l.LOAD=4]="LOAD"})(I||(e.UnloadReason=I={}));const A=function(l=1){return{width:1024,height:768,mode:l}};e.defaultWindowState=A;const k=function(){const S=n.screen.getPrimaryDisplay().workArea,b=Math.max(S.x+S.width/2-800/2,0),g=Math.max(S.y+S.height/2-600/2,0);return{x:b,y:g,width:800,height:600,mode:1}};e.defaultAuxWindowState=k;var P;(function(l){l[l.Maximized=0]="Maximized",l[l.Normal=1]="Normal",l[l.Minimized=2]="Minimized",l[l.Fullscreen=3]="Fullscreen"})(P||(e.WindowMode=P={}));var h;(function(l){l[l.UNRESPONSIVE=1]="UNRESPONSIVE",l[l.PROCESS_GONE=2]="PROCESS_GONE",l[l.LOAD=3]="LOAD"})(h||(e.WindowError=h={}))}),define(se[278],oe([0,1,8,3,2]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends I.Disposable{constructor({onDidOpenMainWindow:P,onDidFocusMainWindow:h,getActiveWindowId:l}){super(),this.disposables=this._register(new I.DisposableStore),R.Event.latch(R.Event.any(P,h))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,n.createCancelablePromise)(()=>l()),(async()=>{try{const S=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:S}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=A}),define(se[30],oe([0,1,195,9,59,19,7,6,13]),function(Q,e,n,R,I,A,k,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=l,e.isEmptyWorkspaceIdentifier=f,e.toWorkspaceIdentifier=S,e.isWorkspaceIdentifier=b,e.reviveIdentifier=g,e.isWorkspace=y,e.isWorkspaceFolder=w,e.toWorkspaceFolder=v,e.isUntitledWorkspace=E,e.isTemporaryWorkspace=a,e.isStandaloneEditorWorkspace=t,e.isSavedWorkspace=s,e.hasWorkspaceFileExtension=r,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function l(i){const o=i;return typeof o?.id=="string"&&k.URI.isUri(o.uri)}function f(i){return typeof i?.id=="string"&&!l(i)&&!b(i)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function S(i,o){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.basename)(i)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const u=i;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}function b(i){const o=i;return typeof o?.id=="string"&&k.URI.isUri(o.configPath)}function g(i){const o=i;if(o?.uri)return{id:o.id,uri:k.URI.revive(o.uri)};const u=i;if(u?.configPath)return{id:u.id,configPath:k.URI.revive(u.configPath)};if(i?.id)return{id:i.id}}var d;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function y(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}function w(i){const o=i;return!!(o&&typeof o=="object"&&k.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}class m{constructor(o,u,p,C,M){this._id=o,this._transient=p,this._configuration=C,this._ignorePathCasing=M,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=u}update(o){this._id=o.id,this._configuration=o.configuration,this._transient=o.transient,this._ignorePathCasing=o._ignorePathCasing,this.folders=o.folders}get folders(){return this._folders}set folders(o){this._folders=o,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(o){this._configuration=o}getFolder(o){return o&&this._foldersMap.findSubstr(o)||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const o of this.folders)this._foldersMap.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=m;class c{constructor(o,u){this.raw=u,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,A.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=c;function v(i){return new c({uri:i,index:0,name:(0,A.basenameOrAuthority)(i)},{uri:i.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,n.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(i,o){return A.extUriBiasedIgnorePathCase.isEqualOrParent(i,o.untitledWorkspacesHome)}function a(i){let o;return k.URI.isUri(i)?o=i:o=i.configuration,o?.scheme===h.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function s(i,o){return!E(i,o)&&!a(i)}function r(i){return(typeof i=="string"?(0,R.extname)(i):(0,A.extname)(i))===e.WORKSPACE_SUFFIX}}),define(se[56],oe([0,1,14,8,46,48,2,72,4,21,169,119,6,5,27,30]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,b.createDecorator)("dialogMainService");let w=class{constructor(c,v){this.logService=c,this.productService=v,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new R.Queue}pickFileFolder(c,v){return this.doPick({...c,pickFolders:!0,pickFiles:!0,title:(0,f.localize)(0,null)},v)}pickFolder(c,v){return this.doPick({...c,pickFolders:!0,title:(0,f.localize)(1,null)},v)}pickFile(c,v){return this.doPick({...c,pickFiles:!0,title:(0,f.localize)(2,null)},v)}pickWorkspace(c,v){const E=(0,f.localize)(3,null),a=(0,A.mnemonicButtonLabel)((0,f.localize)(4,null)),t=y.WORKSPACE_FILTER;return this.doPick({...c,pickFiles:!0,title:E,filters:t,buttonLabel:a},v)}async doPick(c,v){const E={title:c.title,buttonLabel:c.buttonLabel,filters:c.filters,defaultPath:c.defaultPath};(typeof c.pickFiles=="boolean"||typeof c.pickFolders=="boolean")&&(E.properties=void 0,c.pickFiles&&c.pickFolders&&(E.properties=["multiSelections","openDirectory","openFile","createDirectory"])),E.properties||(E.properties=["multiSelections",c.pickFolders?"openDirectory":"openFile","createDirectory"]),h.isMacintosh&&E.properties.push("treatPackageAsDirectory");const a=await this.showOpenDialog(E,(v||n.BrowserWindow.getFocusedWindow())??void 0);if(a&&a.filePaths&&a.filePaths.length>0)return a.filePaths}getWindowDialogQueue(c){if(c){let v=this.windowDialogQueues.get(c.id);return v||(v=new R.Queue,this.windowDialogQueues.set(c.id,v)),v}else return this.noWindowDialogueQueue}showMessageBox(c,v){return this.getWindowDialogQueue(v).queue(async()=>{const{options:E,buttonIndeces:a}=(0,S.massageMessageBoxOptions)(c,this.productService);let t;return v?t=await n.dialog.showMessageBox(v,E):t=await n.dialog.showMessageBox(E),{response:a[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(c,v){const E=this.acquireFileDialogLock(c,v);if(!E)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(v).queue(async()=>{let a;return v?a=await n.dialog.showSaveDialog(v,c):a=await n.dialog.showSaveDialog(c),a.filePath=this.normalizePath(a.filePath),a})}finally{(0,k.dispose)(E)}}normalizePath(c){return c&&h.isMacintosh&&(c=(0,P.normalizeNFC)(c)),c}normalizePaths(c){return c.map(v=>this.normalizePath(v))}async showOpenDialog(c,v){c.defaultPath&&(await l.Promises.exists(c.defaultPath)||(c.defaultPath=void 0));const E=this.acquireFileDialogLock(c,v);if(!E)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(v).queue(async()=>{let a;return v?a=await n.dialog.showOpenDialog(v,c):a=await n.dialog.showOpenDialog(c),a.filePaths=this.normalizePaths(a.filePaths),a})}finally{(0,k.dispose)(E)}}acquireFileDialogLock(c,v){if(!v)return k.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",c);let E=this.windowFileDialogLocks.get(v.id);E||(E=new Set,this.windowFileDialogLocks.set(v.id,E));const a=(0,I.hash)(c);if(!E.has(a))return this.logService.trace("[DialogMainService]: new file dialog lock created",c),E.add(a),(0,k.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",c),E?.delete(a),E?.size===0&&this.windowFileDialogLocks.delete(v.id)})}};e.DialogMainService=w,e.DialogMainService=w=Ie([ie(0,g.ILogService),ie(1,d.IProductService)],w)}),define(se[279],oe([0,1,3,2,77,30]),function(Q,e,n,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class k extends R.Disposable{static{this.STORAGE_CHANGE_DEBOUNCE_TIME=100}constructor(h,l){super(),this.logService=h,this.storageMainService=l,this.onDidChangeApplicationStorageEmitter=this._register(new n.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(l.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(h,l){this._register(n.Event.debounce(h.onDidChangeStorage,(f,S)=>(f?f.push(S):f=[S],f),k.STORAGE_CHANGE_DEBOUNCE_TIME)(f=>{f.length&&l.fire(this.serializeStorageChangeEvents(f,h))}))}serializeStorageChangeEvents(h,l){const f=new Map,S=new Set;return h.forEach(b=>{const g=l.get(b.key);typeof g=="string"?f.set(b.key,g):S.add(b.key)}),{changed:Array.from(f.entries()),deleted:Array.from(S.values())}}listen(h,l,f){switch(l){case"onDidChangeStorage":{const S=f.profile?(0,I.revive)(f.profile):void 0;if(!S)return this.onDidChangeApplicationStorageEmitter.event;let b=this.mapProfileToOnDidChangeProfileStorageEmitter.get(S.id);return b||(b=this._register(new n.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(S),b),this.mapProfileToOnDidChangeProfileStorageEmitter.set(S.id,b)),b.event}}throw new Error(`Event not found: ${l}`)}async call(h,l,f){const S=f.profile?(0,I.revive)(f.profile):void 0,b=(0,A.reviveIdentifier)(f.workspace),g=await this.withStorageInitialized(S,b);switch(l){case"getItems":return Array.from(g.items.entries());case"updateItems":{const d=f;if(d.insert)for(const[y,w]of d.insert)g.set(y,w);d.delete?.forEach(y=>g.delete(y));break}case"optimize":return g.optimize();case"isUsed":{const d=f.payload;if(typeof d=="string")return this.storageMainService.isUsed(d)}default:throw new Error(`Call not found: ${l}`)}}async withStorageInitialized(h,l){let f;l?f=this.storageMainService.workspaceStorage(l):h?f=this.storageMainService.profileStorage(h):f=this.storageMainService.applicationStorage;try{await f.init()}catch(S){this.logService.error(`StorageIPC#init: Unable to init ${l?"workspace":h?"profile":"application"} storage due to ${S}`)}return f}}e.StorageDatabaseChannel=k}),define(se[41],oe([0,1,46,3,2,19,7,192,38,16,6,5,30,32,40,8,33,25,12]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y,w,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=E,e.reviveProfile=a,e.toUserDataProfile=t;var v;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(v||(e.ProfileResourceType=v={}));function E(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&typeof o.isDefault=="boolean"&&typeof o.name=="string"&&k.URI.isUri(o.location)&&k.URI.isUri(o.globalStorageHome)&&k.URI.isUri(o.settingsResource)&&k.URI.isUri(o.keybindingsResource)&&k.URI.isUri(o.tasksResource)&&k.URI.isUri(o.snippetsHome)&&k.URI.isUri(o.extensionsResource))}e.IUserDataProfilesService=(0,f.createDecorator)("IUserDataProfilesService");function a(i,o){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:k.URI.revive(i.location).with({scheme:o}),globalStorageHome:k.URI.revive(i.globalStorageHome).with({scheme:o}),settingsResource:k.URI.revive(i.settingsResource).with({scheme:o}),keybindingsResource:k.URI.revive(i.keybindingsResource).with({scheme:o}),tasksResource:k.URI.revive(i.tasksResource).with({scheme:o}),snippetsHome:k.URI.revive(i.snippetsHome).with({scheme:o}),extensionsResource:k.URI.revive(i.extensionsResource).with({scheme:o}),cacheHome:k.URI.revive(i.cacheHome).with({scheme:o}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function t(i,o,u,p,C,M){return{id:i,name:o,location:u,isDefault:!1,shortName:C?.shortName,icon:C?.icon,globalStorageHome:M&&C?.useDefaultFlags?.globalState?M.globalStorageHome:(0,A.joinPath)(u,"globalStorage"),settingsResource:M&&C?.useDefaultFlags?.settings?M.settingsResource:(0,A.joinPath)(u,"settings.json"),keybindingsResource:M&&C?.useDefaultFlags?.keybindings?M.keybindingsResource:(0,A.joinPath)(u,"keybindings.json"),tasksResource:M&&C?.useDefaultFlags?.tasks?M.tasksResource:(0,A.joinPath)(u,"tasks.json"),snippetsHome:M&&C?.useDefaultFlags?.snippets?M.snippetsHome:(0,A.joinPath)(u,"snippets"),extensionsResource:M&&C?.useDefaultFlags?.extensions?M.extensionsResource:(0,A.joinPath)(u,"extensions.json"),cacheHome:(0,A.joinPath)(p,i),useDefaultFlags:C?.useDefaultFlags,isTransient:C?.transient}}let s=class extends I.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(o,u,p,C){super(),this.environmentService=o,this.fileService=u,this.uriIdentityService=p,this.logService=C,this.enabled=!0,this._onDidChangeProfiles=this._register(new R.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new R.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new R.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new R.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new g.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,A.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(o){this.enabled!==o&&(this._profilesObject=void 0,this.enabled=o)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const o=this.createDefaultProfile(),u=[o];if(this.enabled)try{for(const M of this.getStoredProfiles()){if(!M.name||!(0,c.isString)(M.name)||!M.location){this.logService.warn("Skipping the invalid stored profile",M.location||M.name);continue}u.push(t((0,A.basename)(M.location),M.name,M.location,this.profilesCacheHome,{shortName:M.shortName,icon:M.icon,useDefaultFlags:M.useDefaultFlags},o))}}catch(M){this.logService.error(M)}const p=new g.ResourceMap,C=new Map;if(u.length)try{const M=this.getStoredProfileAssociations();if(M.workspaces)for(const[D,W]of Object.entries(M.workspaces)){const O=k.URI.parse(D),_=u.find(F=>F.id===W);_&&p.set(O,_)}if(M.emptyWindows)for(const[D,W]of Object.entries(M.emptyWindows)){const O=u.find(_=>_.id===W);O&&C.set(D,O)}}catch(M){this.logService.error(M)}this._profilesObject={profiles:u,workspaces:p,emptyWindows:C}}return this._profilesObject}createDefaultProfile(){const o=t("__default__profile__",(0,P.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...o,extensionsResource:this.getDefaultProfileExtensionsLocation()??o.extensionsResource,isDefault:!0}}async createTransientProfile(o){const u="Temp",p=new RegExp(`${(0,m.escapeRegExpCharacters)(u)}\\s(\\d+)`);let C=0;for(const D of this.profiles){const W=p.exec(D.name),O=W?parseInt(W[1]):0;C=O>C?O:C}const M=`${u} ${C+1}`;return this.createProfile((0,n.hash)((0,w.generateUuid)()).toString(16),M,{transient:!0},o)}async createNamedProfile(o,u,p){return this.createProfile((0,n.hash)((0,w.generateUuid)()).toString(16),o,u,p)}async createProfile(o,u,p,C){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const M=await this.doCreateProfile(o,u,p);return C&&await this.setProfileForWorkspace(C,M),M}async doCreateProfile(o,u,p){if(!(0,c.isString)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let C=this.profileCreationPromises.get(u);return C||(C=(async()=>{try{if(this.profiles.find(O=>O.name===u||O.id===o))throw new Error(`Profile with ${u} name already exists`);const D=t(o,u,(0,A.joinPath)(this.profilesHome,o),this.profilesCacheHome,p,this.defaultProfile);await this.fileService.createFolder(D.location);const W=[];return this._onWillCreateProfile.fire({profile:D,join(O){W.push(O)}}),await y.Promises.settled(W),this.updateProfiles([D],[],[]),D}finally{this.profileCreationPromises.delete(u)}})(),this.profileCreationPromises.set(u,C)),C}async updateProfile(o,u){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let p=this.profiles.find(C=>C.id===o.id);if(!p)throw new Error(`Profile '${o.name}' does not exist`);return p=t(p.id,u.name??p.name,p.location,this.profilesCacheHome,{shortName:u.shortName??p.shortName,icon:u.icon===null?void 0:u.icon??p.icon,transient:u.transient??p.isTransient,useDefaultFlags:u.useDefaultFlags??p.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[p]),p}async removeProfile(o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(o.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(C=>C.id===o.id);if(!u)throw new Error(`Profile '${o.name}' does not exist`);const p=[];this._onWillRemoveProfile.fire({profile:u,join(C){p.push(C)}});try{await Promise.allSettled(p)}catch(C){this.logService.error(C)}for(const C of[...this.profilesObject.emptyWindows.keys()])u.id===this.profilesObject.emptyWindows.get(C)?.id&&this.profilesObject.emptyWindows.delete(C);for(const C of[...this.profilesObject.workspaces.keys()])u.id===this.profilesObject.workspaces.get(C)?.id&&this.profilesObject.workspaces.delete(C);this.updateStoredProfileAssociations(),this.updateProfiles([],[u],[]);try{await this.fileService.del(u.cacheHome,{recursive:!0})}catch(C){(0,l.toFileOperationResult)(C)!==1&&this.logService.error(C)}}async setProfileForWorkspace(o,u){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const p=this.profiles.find(C=>C.id===u.id);if(!p)throw new Error(`Profile '${u.name}' does not exist`);this.updateWorkspaceAssociation(o,p)}unsetWorkspace(o,u){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(o,void 0,u)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const o=await this.fileService.resolve(this.profilesHome);await Promise.all((o.children||[]).filter(u=>u.isDirectory&&this.profiles.every(p=>!this.uriIdentityService.extUri.isEqual(p.location,u.resource))).map(u=>this.fileService.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const o=this.transientProfilesObject.profiles.filter(u=>!this.isProfileAssociatedToWorkspace(u));await Promise.allSettled(o.map(u=>this.removeProfile(u)))}getProfileForWorkspace(o){const u=this.getWorkspace(o);return k.URI.isUri(u)?this.transientProfilesObject.workspaces.get(u)??this.profilesObject.workspaces.get(u):this.transientProfilesObject.emptyWindows.get(u)??this.profilesObject.emptyWindows.get(u)}getWorkspace(o){return(0,b.isSingleFolderWorkspaceIdentifier)(o)?o.uri:(0,b.isWorkspaceIdentifier)(o)?o.configPath:o.id}isProfileAssociatedToWorkspace(o){return!!([...this.transientProfilesObject.emptyWindows.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,o.location))||[...this.transientProfilesObject.workspaces.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,o.location))||[...this.profilesObject.emptyWindows.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,o.location))||[...this.profilesObject.workspaces.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,o.location)))}updateProfiles(o,u,p){const C=[...this.profiles,...o],M=[];this.transientProfilesObject.profiles=[];for(let D of C)D.isDefault||u.some(W=>D.id===W.id)||(D=p.find(W=>D.id===W.id)??D,D.isTransient?this.transientProfilesObject.profiles.push(D):M.push({location:D.location,name:D.name,shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags}));this.saveStoredProfiles(M),this._profilesObject=void 0,this.triggerProfilesChanges(o,u,p)}triggerProfilesChanges(o,u,p){this._onDidChangeProfiles.fire({added:o,removed:u,updated:p,all:this.profiles})}updateWorkspaceAssociation(o,u,p){p=u?.isTransient?!0:p,p||this.updateWorkspaceAssociation(o,void 0,!0);const C=this.getWorkspace(o),M=p?this.transientProfilesObject:this.profilesObject;k.URI.isUri(C)?(M.workspaces.delete(C),u&&M.workspaces.set(C,u)):(M.emptyWindows.delete(C),u&&M.emptyWindows.set(C,u)),p||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const o={};for(const[p,C]of this.profilesObject.workspaces.entries())o[p.toString()]=C.id;const u={};for(const[p,C]of this.profilesObject.emptyWindows.entries())u[p.toString()]=C.id;this.saveStoredProfileAssociations({workspaces:o,emptyWindows:u}),this._profilesObject=void 0}migrateStoredProfileAssociations(o){const u={},p=this.createDefaultProfile();if(o.workspaces)for(const[M,D]of Object.entries(o.workspaces)){const W=k.URI.parse(D);u[M]=this.uriIdentityService.extUri.isEqual(W,p.location)?p.id:this.uriIdentityService.extUri.basename(W)}const C={};if(o.emptyWindows)for(const[M,D]of Object.entries(o.emptyWindows)){const W=k.URI.parse(D);C[M]=this.uriIdentityService.extUri.isEqual(W,p.location)?p.id:this.uriIdentityService.extUri.basename(W)}return{workspaces:u,emptyWindows:C}}getStoredProfiles(){return[]}saveStoredProfiles(o){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(o){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=s,e.UserDataProfilesService=s=Ie([ie(0,h.IEnvironmentService),ie(1,l.IFileService),ie(2,d.IUriIdentityService),ie(3,S.ILogService)],s);class r extends s{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(o){this.storedProfiles=o}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(o){this.storedProfileAssociations=o}}e.InMemoryUserDataProfilesService=r}),define(se[83],oe([0,1,8,17,2,3,32,7,121,127,16,6,5,41,40,12,15,28]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var c;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(c||(e.ExtensionsProfileScanningErrorCode=c={}));class v extends Error{constructor(r,i){super(r),this.code=i}}e.ExtensionsProfileScanningError=v,e.IExtensionsProfileScannerService=(0,S.createDecorator)("IExtensionsProfileScannerService");let E=class extends I.Disposable{constructor(r,i,o,u,p,C){super(),this.extensionsLocation=r,this.fileService=i,this.userDataProfilesService=o,this.uriIdentityService=u,this.telemetryService=p,this.logService=C,this._onAddExtensions=this._register(new A.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new A.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new A.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new A.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new k.ResourceMap}scanProfileExtensions(r,i){return this.withProfileExtensions(r,void 0,i)}async addExtensionsToProfile(r,i,o){const u=[],p=[];try{return await this.withProfileExtensions(i,C=>{const M=[];if(o)M.push(...C);else for(const D of C)r.some(([W])=>(0,l.areSameExtensions)(W.identifier,D.identifier)&&W.manifest.version!==D.version)?u.push(D):M.push(D);for(const[D,W]of r){const O=M.findIndex(F=>(0,l.areSameExtensions)(F.identifier,D.identifier)&&F.version===D.manifest.version),_={identifier:D.identifier,version:D.manifest.version,location:D.location,metadata:W};O===-1?(p.push(_),M.push(_)):M.splice(O,1,_)}return p.length&&this._onAddExtensions.fire({extensions:p,profileLocation:i}),u.length&&this._onRemoveExtensions.fire({extensions:u,profileLocation:i}),M}),p.length&&this._onDidAddExtensions.fire({extensions:p,profileLocation:i}),u.length&&this._onDidRemoveExtensions.fire({extensions:u,profileLocation:i}),p}catch(C){throw p.length&&this._onDidAddExtensions.fire({extensions:p,error:C,profileLocation:i}),u.length&&this._onDidRemoveExtensions.fire({extensions:u,error:C,profileLocation:i}),C}}async updateMetadata(r,i){const o=[];return await this.withProfileExtensions(i,u=>{const p=[];for(const C of u){const M=r.find(([D])=>(0,l.areSameExtensions)(D.identifier,C.identifier)&&D.manifest.version===C.version);M&&(C.metadata={...C.metadata,...M[1]},o.push(C)),p.push(C)}return p}),o}async removeExtensionFromProfile(r,i){const o=[];try{await this.withProfileExtensions(i,u=>{const p=[];for(const C of u)(0,l.areSameExtensions)(C.identifier,r.identifier)?o.push(C):p.push(C);return o.length&&this._onRemoveExtensions.fire({extensions:o,profileLocation:i}),p}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,profileLocation:i})}catch(u){throw o.length&&this._onDidRemoveExtensions.fire({extensions:o,error:u,profileLocation:i}),u}}async withProfileExtensions(r,i,o){return this.getResourceAccessQueue(r).queue(async()=>{let u=[],p;try{const C=await this.fileService.readFile(r);p=JSON.parse(C.value.toString().trim()||"[]")}catch(C){if((0,f.toFileOperationResult)(C)!==1)throw C;if(this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)&&(p=await this.migrateFromOldDefaultProfileExtensionsLocation()),!p&&o?.bailOutWhenFileNotFound)throw new v((0,w.getErrorMessage)(C),"ERROR_PROFILE_NOT_FOUND")}if(p){Array.isArray(p)||this.reportAndThrowInvalidConentError(r);let C=!1;for(const M of p){a(M)||this.reportAndThrowInvalidConentError(r);let D;if((0,y.isString)(M.relativeLocation)&&M.relativeLocation)D=this.resolveExtensionLocation(M.relativeLocation);else if((0,y.isString)(M.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${M.location}`);continue}else{D=P.URI.revive(M.location);const W=this.toRelativePath(D);W&&(C=!0,M.relativeLocation=W)}(0,y.isUndefined)(M.metadata?.hasPreReleaseVersion)&&M.metadata?.preRelease&&(C=!0,M.metadata.hasPreReleaseVersion=!0),u.push({identifier:M.identifier,location:D,version:M.version,metadata:M.metadata})}C&&await this.fileService.writeFile(r,R.VSBuffer.fromString(JSON.stringify(p)))}if(i){u=i(u);const C=u.map(M=>({identifier:M.identifier,version:M.version,location:M.location.toJSON(),relativeLocation:this.toRelativePath(M.location),metadata:M.metadata}));await this.fileService.writeFile(r,R.VSBuffer.fromString(JSON.stringify(C)))}return u})}reportAndThrowInvalidConentError(r){const i=new v(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}toRelativePath(r){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(r),this.extensionsLocation)?this.uriIdentityService.extUri.basename(r):void 0}resolveExtensionLocation(r){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,r)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const r=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),i=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let o;try{o=(await this.fileService.readFile(r)).value.toString()}catch(p){if((0,f.toFileOperationResult)(p)===1)return;throw p}this.logService.info("Migrating extensions from old default profile location",r.toString());let u;try{const p=JSON.parse(o);Array.isArray(p)&&p.every(C=>a(C))?u=p:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",p)}catch(p){this.logService.error(p)}if(u)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify(u)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",r.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(p){if((0,f.toFileOperationResult)(p)===3)this.logService.info("Migration from old default profile location to new location is done by another window",r.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw p}try{await this.fileService.del(r)}catch(p){(0,f.toFileOperationResult)(p)!==1&&this.logService.error(p)}try{await this.fileService.del(i)}catch(p){(0,f.toFileOperationResult)(p)!==1&&this.logService.error(p)}return u})()),this._migrationPromise}getResourceAccessQueue(r){let i=this.resourcesAccessQueueMap.get(r);return i||(i=new n.Queue,this.resourcesAccessQueueMap.set(r,i)),i}};e.AbstractExtensionsProfileScannerService=E,e.AbstractExtensionsProfileScannerService=E=Ie([ie(1,f.IFileService),ie(2,g.IUserDataProfilesService),ie(3,d.IUriIdentityService),ie(4,m.ITelemetryService),ie(5,b.ILogService)],E);function a(s){return(0,y.isObject)(s)&&(0,h.isIExtensionIdentifier)(s.identifier)&&(t(s.location)||(0,y.isString)(s.location)&&s.location)&&((0,y.isUndefined)(s.relativeLocation)||(0,y.isString)(s.relativeLocation))&&s.version&&(0,y.isString)(s.version)}function t(s){return s?(0,y.isString)(s.path)&&(0,y.isString)(s.scheme):!1}}),define(se[132],oe([0,1,22,8,35,17,15,42,154,2,13,9,4,19,208,74,12,7,174,38,127,124,207,16,6,5,27,3,77,83,41,40,206]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y,w,m,c,v,E,a,t,s,r,i,o,u,p,C,M,D,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0,e.toExtensionDescription=ue;var O;(function(le){function Y(G,B){if(G===B)return!0;const T=Object.keys(G),U=new Set;for(const $ of Object.keys(B))U.add($);if(T.length!==U.size)return!1;for(const $ of T){if(G[$]!==B[$])return!1;U.delete($)}return U.size===0}le.equals=Y})(O||(e.Translations=O={})),e.IExtensionsScannerService=(0,r.createDecorator)("IExtensionsScannerService");let _=class extends l.Disposable{constructor(Y,G,B,T,U,$,ae,V,ce,X,L,N){super(),this.systemExtensionsLocation=Y,this.userExtensionsLocation=G,this.extensionsControlLocation=B,this.currentProfile=T,this.userDataProfilesService=U,this.extensionsProfileScannerService=$,this.fileService=ae,this.logService=V,this.environmentService=ce,this.productService=X,this.uriIdentityService=L,this.instantiationService=N,this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,g.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(z,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(z,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(x,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,E.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(Y,G,B){const[T,U]=await Promise.all([this.scanSystemExtensions(Y),this.scanUserExtensions(G)]),$=B?await this.scanExtensionsUnderDevelopment(Y,[...T,...U]):[];return this.dedupExtensions(T,U,$,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Y){const G=[];G.push(this.scanDefaultSystemExtensions(!!Y.useCache,Y.language)),G.push(this.scanDevSystemExtensions(Y.language,!!Y.checkControlFile));const[B,T]=await Promise.all(G);return this.applyScanOptions([...B,...T],0,Y,!1)}async scanUserExtensions(Y){const G=Y.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",G);const B=this.uriIdentityService.extUri.isEqual(Y.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,T=await this.createExtensionScannerInput(G,!!Y.profileLocation,1,!Y.includeUninstalled,Y.language,!0,B,Y.productVersion??this.getProductVersion()),U=Y.useCache&&!T.devMode&&T.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let $;try{$=await U.scanExtensions(T)}catch(ae){if(ae instanceof C.ExtensionsProfileScanningError&&ae.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),$=await U.scanExtensions(T);else throw ae}return $=await this.applyScanOptions($,1,Y,!0),this.logService.trace("Scanned user extensions:",$.length),$}async scanExtensionsUnderDevelopment(Y,G){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const B=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(T=>T.scheme===f.Schemas.file).map(async T=>{const U=await this.createExtensionScannerInput(T,!1,1,!0,Y.language,!1,void 0,Y.productVersion??this.getProductVersion());return(await this.extensionsScanner.scanOneOrMultipleExtensions(U)).map(ae=>(ae.type=G.find(V=>(0,E.areSameExtensions)(V.identifier,ae.identifier))?.type??ae.type,this.extensionsScanner.validate(ae,U)))}))).flat();return this.applyScanOptions(B,"development",Y,!0)}return[]}async scanExistingExtension(Y,G,B){const T=await this.createExtensionScannerInput(Y,!1,G,!0,B.language,!0,void 0,B.productVersion??this.getProductVersion()),U=await this.extensionsScanner.scanExtension(T);return!U||!B.includeInvalid&&!U.isValid?null:U}async scanOneOrMultipleExtensions(Y,G,B){const T=await this.createExtensionScannerInput(Y,!1,G,!0,B.language,!0,void 0,B.productVersion??this.getProductVersion()),U=await this.extensionsScanner.scanOneOrMultipleExtensions(T);return this.applyScanOptions(U,G,B,!0)}async scanMultipleExtensions(Y,G,B){const T=[];return await Promise.all(Y.map(async U=>{const $=await this.scanOneOrMultipleExtensions(U,G,B);T.push(...$)})),this.applyScanOptions(T,G,B,!0)}async scanMetadata(Y){const G=(0,g.joinPath)(Y,"package.json"),B=(await this.fileService.readFile(G)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(Y,G){const B=(0,g.joinPath)(Y,"package.json"),T=(await this.fileService.readFile(B)).value.toString(),U=JSON.parse(T);G.isMachineScoped===!1&&delete G.isMachineScoped,G.isBuiltin===!1&&delete G.isBuiltin,U.__metadata={...U.__metadata,...G},await this.fileService.writeFile((0,g.joinPath)(Y,"package.json"),A.VSBuffer.fromString(JSON.stringify(U,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Y){if(Y instanceof C.ExtensionsProfileScanningError&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw Y}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Y=await this.scanUserExtensions({includeInvalid:!0});if(Y.length)await this.extensionsProfileScannerService.addExtensionsToProfile(Y.map(G=>[G,G.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(G){(0,s.toFileOperationResult)(G)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,k.getErrorMessage)(G))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Y){this.logService.error(Y)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(Y,G,B,T){return B.includeAllVersions||(Y=this.dedupExtensions(G===0?Y:void 0,G===1?Y:void 0,G==="development"?Y:void 0,await this.getTargetPlatform(),T)),B.includeInvalid||(Y=Y.filter(U=>U.isValid)),Y.sort((U,$)=>{const ae=S.basename(U.location.fsPath),V=S.basename($.location.fsPath);return ae<V?-1:ae>V?1:0})}dedupExtensions(Y,G,B,T,U){const $=(V,ce,X)=>{if(V.isValid&&!ce.isValid)return!1;if(V.isValid===ce.isValid){if(U&&d.gt(V.manifest.version,ce.manifest.version))return this.logService.debug(`Skipping extension ${ce.location.path} with lower version ${ce.manifest.version} in favour of ${V.location.path} with version ${V.manifest.version}`),!1;if(d.eq(V.manifest.version,ce.manifest.version)){if(V.type===0)return this.logService.debug(`Skipping extension ${ce.location.path} in favour of system extension ${V.location.path} with same version`),!1;if(V.targetPlatform===T)return this.logService.debug(`Skipping extension ${ce.location.path} from different target platform ${ce.targetPlatform}`),!1}}return X?this.logService.warn(`Overwriting user extension ${V.location.path} with ${ce.location.path}.`):this.logService.debug(`Overwriting user extension ${V.location.path} with ${ce.location.path}.`),!0},ae=new a.ExtensionIdentifierMap;return Y?.forEach(V=>{const ce=ae.get(V.identifier.id);(!ce||$(ce,V,!1))&&ae.set(V.identifier.id,V)}),G?.forEach(V=>{const ce=ae.get(V.identifier.id);if(!ce&&Y&&V.type===0){this.logService.debug(`Skipping obsolete system extension ${V.location.path}.`);return}(!ce||$(ce,V,!1))&&ae.set(V.identifier.id,V)}),B?.forEach(V=>{const ce=ae.get(V.identifier.id);(!ce||$(ce,V,!0))&&ae.set(V.identifier.id,V),ae.set(V.identifier.id,V)}),[...ae.values()]}async scanDefaultSystemExtensions(Y,G){this.logService.trace("Started scanning system extensions");const B=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,G,!0,void 0,this.getProductVersion()),U=await(Y&&!B.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(B);return this.logService.trace("Scanned system extensions:",U.length),U}async scanDevSystemExtensions(Y,G){const B=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!B?.length)return[];this.logService.trace("Started scanning dev system extensions");const T=G?await this.getBuiltInExtensionControl():{},U=[],$=m.URI.file(S.normalize(S.join(f.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const V of B){const ce=T[V.name]||"marketplace";switch(ce){case"disabled":break;case"marketplace":U.push((0,g.joinPath)($,V.name));break;default:U.push(m.URI.file(ce));break}}const ae=await Promise.all(U.map(async V=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(V,!1,0,!0,Y,!0,void 0,this.getProductVersion()))));return this.logService.trace("Scanned dev system extensions:",ae.length),(0,n.coalesce)(ae)}async getBuiltInExtensionControl(){try{const Y=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(Y.value.toString())}catch{return{}}}async createExtensionScannerInput(Y,G,B,T,U,$,ae,V){const ce=await this.getTranslations(U??b.language),X=await this.getMtime(Y),L=G&&!this.uriIdentityService.extUri.isEqual(Y,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,N=L?await this.getMtime(L):void 0;return new F(Y,X,L,N,G,ae,B,T,$,V.version,V.date,this.productService.commit,!this.environmentService.isBuilt,U,ce)}async getMtime(Y){try{const G=await this.fileService.stat(Y);if(typeof G.mtime=="number")return G.mtime}catch{}}getProductVersion(){return{version:this.productService.version,date:this.productService.date}}};e.AbstractExtensionsScannerService=_,e.AbstractExtensionsScannerService=_=Ie([ie(4,M.IUserDataProfilesService),ie(5,C.IExtensionsProfileScannerService),ie(6,s.IFileService),ie(7,i.ILogService),ie(8,v.IEnvironmentService),ie(9,o.IProductService),ie(10,D.IUriIdentityService),ie(11,r.IInstantiationService)],_);class F{constructor(Y,G,B,T,U,$,ae,V,ce,X,L,N,Z,ne,K){this.location=Y,this.mtime=G,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=T,this.profile=U,this.profileScanOptions=$,this.type=ae,this.excludeObsolete=V,this.validate=ce,this.productVersion=X,this.productDate=L,this.productCommit=N,this.devMode=Z,this.language=ne,this.translations=K}static createNlsConfiguration(Y){return{language:Y.language,pseudo:Y.language==="pseudo",devMode:Y.devMode,translations:Y.translations}}static equals(Y,G){return(0,g.isEqual)(Y.location,G.location)&&Y.mtime===G.mtime&&(0,g.isEqual)(Y.applicationExtensionslocation,G.applicationExtensionslocation)&&Y.applicationExtensionslocationMtime===G.applicationExtensionslocationMtime&&Y.profile===G.profile&&I.equals(Y.profileScanOptions,G.profileScanOptions)&&Y.type===G.type&&Y.excludeObsolete===G.excludeObsolete&&Y.validate===G.validate&&Y.productVersion===G.productVersion&&Y.productDate===G.productDate&&Y.productCommit===G.productCommit&&Y.devMode===G.devMode&&Y.language===G.language&&O.equals(Y.translations,G.translations)}}e.ExtensionScannerInput=F;let x=class extends l.Disposable{constructor(Y,G,B,T,U){super(),this.obsoleteFile=Y,this.extensionsProfileScannerService=G,this.uriIdentityService=B,this.fileService=T,this.logService=U}async scanExtensions(Y){const G=Y.profile?await this.scanExtensionsFromProfile(Y):await this.scanExtensionsFromLocation(Y);let B={};if(Y.excludeObsolete&&Y.type===1)try{const T=(await this.fileService.readFile(this.obsoleteFile)).value.toString();B=JSON.parse(T)}catch{}return(0,w.isEmptyObject)(B)?G:G.filter(T=>!B[E.ExtensionKey.create(T).toString()])}async scanExtensionsFromLocation(Y){const G=await this.fileService.resolve(Y.location);if(!G.children?.length)return[];const B=await Promise.all(G.children.map(async T=>{if(!T.isDirectory||Y.type===1&&(0,g.basename)(T.resource).indexOf(".")===0)return null;const U=new F(T.resource,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.profileScanOptions,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(U)}));return(0,n.coalesce)(B).sort((T,U)=>T.location.path<U.location.path?-1:1)}async scanExtensionsFromProfile(Y){let G=await this.scanExtensionsFromProfileResource(Y.location,()=>!0,Y);if(Y.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(Y.location,Y.applicationExtensionslocation)){G=G.filter(T=>!T.metadata?.isApplicationScoped);const B=await this.scanExtensionsFromProfileResource(Y.applicationExtensionslocation,T=>!!T.metadata?.isBuiltin||!!T.metadata?.isApplicationScoped,Y);G.push(...B)}return G}async scanExtensionsFromProfileResource(Y,G,B){const T=await this.extensionsProfileScannerService.scanProfileExtensions(Y,B.profileScanOptions);if(!T.length)return[];const U=await Promise.all(T.map(async $=>{if(G($)){const ae=new F($.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(ae,$.metadata)}return null}));return(0,n.coalesce)(U)}async scanOneOrMultipleExtensions(Y){try{if(await this.fileService.exists((0,g.joinPath)(Y.location,"package.json"))){const G=await this.scanExtension(Y);return G?[G]:[]}else return await this.scanExtensions(Y)}catch(G){return this.logService.error(`Error scanning extensions at ${Y.location.path}:`,(0,k.getErrorMessage)(G)),[]}}async scanExtension(Y,G){try{let B=await this.scanExtensionManifest(Y.location);if(B){B.publisher||(B.publisher=a.UNDEFINED_PUBLISHER),G=G??B.__metadata,delete B.__metadata;const T=(0,E.getGalleryExtensionId)(B.publisher,B.name),U=G?.id?{id:T,uuid:G.id}:{id:T},$=G?.isSystem?0:Y.type,ae=$===0||!!G?.isBuiltin;B=await this.translateManifest(Y.location,B,F.createNlsConfiguration(Y));const V={type:$,identifier:U,manifest:B,location:Y.location,isBuiltin:ae,targetPlatform:G?.targetPlatform??"undefined",publisherDisplayName:G?.publisherDisplayName,metadata:G,isValid:!0,validations:[]};return Y.validate?this.validate(V,Y):V}}catch(B){Y.type!==0&&this.logService.error(B)}return null}validate(Y,G){let B=!0;const T=(0,t.validateExtensionManifest)(G.productVersion,G.productDate,G.location,Y.manifest,Y.isBuiltin);for(const[U,$]of T)U===y.default.Error&&(B=!1,this.logService.error(this.formatMessage(G.location,$)));return Y.isValid=B,Y.validations=T,Y}async scanExtensionManifest(Y){const G=(0,g.joinPath)(Y,"package.json");let B;try{B=(await this.fileService.readFile(G)).value.toString()}catch(U){return(0,s.toFileOperationResult)(U)!==1&&this.logService.error(this.formatMessage(Y,(0,c.localize)(0,null,G.path,U.message))),null}let T;try{T=JSON.parse(B)}catch{const $=[];(0,P.parse)(B,$);for(const ae of $)this.logService.error(this.formatMessage(Y,(0,c.localize)(1,null,G.path,ae.offset,ae.length,(0,h.getParseErrorMessage)(ae.error))));return null}return(0,P.getNodeType)(T)!=="object"?(this.logService.error(this.formatMessage(Y,(0,c.localize)(2,null,G.path))),null):T}async translateManifest(Y,G,B){const T=await this.getLocalizedMessages(Y,G,B);if(T)try{const U=[],$=await this.resolveOriginalMessageBundle(T.default,U);if(U.length>0)return U.forEach(V=>{this.logService.error(this.formatMessage(Y,(0,c.localize)(3,null,T.default?.path,(0,h.getParseErrorMessage)(V.error))))}),G;if((0,P.getNodeType)(T)!=="object")return this.logService.error(this.formatMessage(Y,(0,c.localize)(4,null,T.default?.path))),G;const ae=T.values||Object.create(null);return(0,W.localizeManifest)(this.logService,G,ae,$)}catch{}return G}async getLocalizedMessages(Y,G,B){const T=(0,g.joinPath)(Y,"package.nls.json"),U=(ce,X)=>{X.forEach(L=>{this.logService.error(this.formatMessage(Y,(0,c.localize)(5,null,ce?.path,(0,h.getParseErrorMessage)(L.error))))})},$=ce=>{this.logService.error(this.formatMessage(Y,(0,c.localize)(6,null,ce?.path)))},ae=`${G.publisher}.${G.name}`,V=B.translations[ae];if(V)try{const ce=m.URI.file(V),X=(await this.fileService.readFile(ce)).value.toString(),L=[],N=(0,P.parse)(X,L);return L.length>0?(U(ce,L),{values:void 0,default:T}):(0,P.getNodeType)(N)!=="object"?($(ce),{values:void 0,default:T}):{values:N.contents?N.contents.package:void 0,default:T}}catch{return{values:void 0,default:T}}else{if(!await this.fileService.exists(T))return;let X;try{X=await this.findMessageBundles(Y,B)}catch{return}if(!X.localized)return{values:void 0,default:X.original};try{const L=(await this.fileService.readFile(X.localized)).value.toString(),N=[],Z=(0,P.parse)(L,N);return N.length>0?(U(X.localized,N),{values:void 0,default:X.original}):(0,P.getNodeType)(Z)!=="object"?($(X.localized),{values:void 0,default:X.original}):{values:Z,default:X.original}}catch{return{values:void 0,default:X.original}}}}async resolveOriginalMessageBundle(Y,G){if(Y)try{const B=(await this.fileService.readFile(Y)).value.toString();return(0,P.parse)(B,G)}catch{}}findMessageBundles(Y,G){return new Promise((B,T)=>{const U=$=>{const ae=(0,g.joinPath)(Y,`package.nls.${$}.json`);this.fileService.exists(ae).then(V=>{V&&B({localized:ae,original:(0,g.joinPath)(Y,"package.nls.json")});const ce=$.lastIndexOf("-");ce===-1?B({localized:(0,g.joinPath)(Y,"package.nls.json"),original:null}):($=$.substring(0,ce),U($))})};if(G.devMode||G.pseudo||!G.language)return B({localized:(0,g.joinPath)(Y,"package.nls.json"),original:null});U(G.language)})}formatMessage(Y,G){return`[${Y.path}]: ${G}`}};x=Ie([ie(1,C.IExtensionsProfileScannerService),ie(2,D.IUriIdentityService),ie(3,s.IFileService),ie(4,i.ILogService)],x);let z=class extends x{constructor(Y,G,B,T,U,$,ae){super(G,T,U,$,ae),this.currentProfile=Y,this.userDataProfilesService=B,this.cacheValidatorThrottler=this._register(new R.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(Y){const G=this.getCacheFile(Y),B=await this.readExtensionCache(G);if(this.input=Y,B&&B.input&&F.equals(B.input,this.input))return this.logService.debug("Using cached extensions scan result",Y.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),B.result.map(U=>(U.location=m.URI.revive(U.location),U));const T=await super.scanExtensions(Y);return await this.writeExtensionCache(G,{input:Y,result:T}),T}async readExtensionCache(Y){try{const G=await this.fileService.readFile(Y),B=JSON.parse(G.value.toString());return{result:B.result,input:(0,p.revive)(B.input)}}catch(G){this.logService.debug("Error while reading the extension cache file:",Y.path,(0,k.getErrorMessage)(G))}return null}async writeExtensionCache(Y,G){try{await this.fileService.writeFile(Y,A.VSBuffer.fromString(JSON.stringify(G)))}catch(B){this.logService.debug("Error while writing the extension cache file:",Y.path,(0,k.getErrorMessage)(B))}}async validateCache(){if(!this.input)return;const Y=this.getCacheFile(this.input),G=await this.readExtensionCache(Y);if(!G)return;const B=G.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!I.equals(T,B))try{this.logService.info("Invalidating Cache",B,T),await this.fileService.del(Y),this._onDidChangeCache.fire()}catch(U){this.logService.error(U)}}getCacheFile(Y){const G=this.getProfile(Y);return this.uriIdentityService.extUri.joinPath(G.cacheHome,Y.type===0?a.BUILTIN_MANIFEST_CACHE_FILE:a.USER_MANIFEST_CACHE_FILE)}getProfile(Y){return Y.type===0?this.userDataProfilesService.defaultProfile:Y.profile?this.uriIdentityService.extUri.isEqual(Y.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(G=>this.uriIdentityService.extUri.isEqual(Y.location,G.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};z=Ie([ie(2,M.IUserDataProfilesService),ie(3,C.IExtensionsProfileScannerService),ie(4,D.IUriIdentityService),ie(5,s.IFileService),ie(6,i.ILogService)],z);function ue(le,Y){const G=(0,E.getExtensionId)(le.manifest.publisher,le.manifest.name);return{id:G,identifier:new a.ExtensionIdentifier(G),isBuiltin:le.type===0,isUserBuiltin:le.type===1&&le.isBuiltin,isUnderDevelopment:Y,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,publisherDisplayName:le.publisherDisplayName,...le.manifest}}class ee extends _{constructor(Y,G,B,T,U,$,ae,V,ce,X,L,N){super(Y,G,(0,g.joinPath)(B,".vscode-oss-dev","extensions","control.json"),T,U,$,ae,V,ce,X,L,N),this.translationsPromise=(async()=>{if(b.translationsConfigFile)try{const Z=await this.fileService.readFile(m.URI.file(b.translationsConfigFile));return JSON.parse(Z.value.toString())}catch{}return Object.create(null)})()}getTranslations(Y){return this.translationsPromise}}e.NativeExtensionsScannerService=ee}),define(se[280],oe([0,1,5,41,40,28,83,16,38,7]),function(Q,e,n,R,I,A,k,P,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let f=class extends k.AbstractExtensionsProfileScannerService{constructor(b,g,d,y,w,m){super(l.URI.file(b.extensionsPath),g,d,y,w,m)}};e.ExtensionsProfileScannerService=f,e.ExtensionsProfileScannerService=f=Ie([ie(0,h.INativeEnvironmentService),ie(1,P.IFileService),ie(2,R.IUserDataProfilesService),ie(3,I.IUriIdentityService),ie(4,A.ITelemetryService),ie(5,n.ILogService)],f)}),define(se[281],oe([0,1,7,38,83,132,16,6,5,27,40,41]),function(Q,e,n,R,I,A,k,P,h,l,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let b=class extends A.NativeExtensionsScannerService{constructor(d,y,w,m,c,v,E,a){super(n.URI.file(c.builtinExtensionsPath),n.URI.file(c.extensionsPath),c.userHome,d.defaultProfile,d,y,w,m,c,v,E,a)}};e.ExtensionsScannerService=b,e.ExtensionsScannerService=b=Ie([ie(0,S.IUserDataProfilesService),ie(1,I.IExtensionsProfileScannerService),ie(2,k.IFileService),ie(3,h.ILogService),ie(4,R.INativeEnvironmentService),ie(5,l.IProductService),ie(6,f.IUriIdentityService),ie(7,P.IInstantiationService)],b)}),define(se[282],oe([0,1,14,2,13,9,4,59,7,33,37,38,5,41]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let d=class extends R.Disposable{constructor(w,m,c){super(),this.environmentService=w,this.logService=c,this.validRoots=P.TernarySearchTree.forPaths(!k.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(w.appRoot),this.addValidFileRoot(w.extensionsPath),this.addValidFileRoot(m.defaultProfile.globalStorageHome.with({scheme:I.Schemas.file}).fsPath),this.addValidFileRoot(w.workspaceStorageHome.with({scheme:I.Schemas.file}).fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:w}=n.session;w.protocol.registerFileProtocol(I.Schemas.vscodeFileResource,(m,c)=>this.handleResourceRequest(m,c)),w.protocol.interceptFileProtocol(I.Schemas.file,(m,c)=>this.handleFileRequest(m,c)),this._register((0,R.toDisposable)(()=>{w.protocol.unregisterProtocol(I.Schemas.vscodeFileResource),w.protocol.uninterceptProtocol(I.Schemas.file)}))}addValidFileRoot(w){const m=(0,A.normalize)(w);return this.validRoots.get(m)?R.Disposable.None:(this.validRoots.set(m,!0),(0,R.toDisposable)(()=>this.validRoots.delete(m)))}handleFileRequest(w,m){const c=h.URI.parse(w.url);return this.logService.error(`Refused to load resource ${c.fsPath} from ${I.Schemas.file}: protocol (original URL: ${w.url})`),m({error:-3})}handleResourceRequest(w,m){const c=this.requestToNormalizedFilePath(w);let v;return this.environmentService.crossOriginIsolated&&((0,A.basename)(c)==="workbench.html"||(0,A.basename)(c)==="workbench-dev.html"?v=I.COI.CoopAndCoep:v=I.COI.getHeadersFromQuery(w.url)),this.validRoots.findSubstr(c)?m({path:c,headers:v}):this.validExtensions.has((0,A.extname)(c).toLowerCase())?m({path:c}):(this.logService.error(`${I.Schemas.vscodeFileResource}: Refused to load resource ${c} from ${I.Schemas.vscodeFileResource}: protocol (original URL: ${w.url})`),m({error:-3}))}requestToNormalizedFilePath(w){const m=h.URI.parse(w.url),c=I.FileAccess.uriToFileUri(m);return(0,A.normalize)(c.fsPath)}createIPCObjectUrl(){let w;const m=h.URI.from({scheme:"vscode",path:(0,l.generateUuid)()}),c=m.toString(),v=async()=>w;return f.validatedIpcMain.handle(c,v),this.logService.trace(`IPC Object URL: Registered new channel ${c}.`),{resource:m,update:E=>w=E,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${c}.`),f.validatedIpcMain.removeHandler(c)}}}};e.ProtocolMainService=d,e.ProtocolMainService=d=Ie([ie(0,S.INativeEnvironmentService),ie(1,g.IUserDataProfilesService),ie(2,b.ILogService)],d)}),define(se[97],oe([0,1,8,3,2,66,12,115,6,41]),function(Q,e,n,R,I,A,k,P,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=g,e.isProfileUsingDefaultStorage=y,e.logStorage=m,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,h.createDecorator)("storageService");var f;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(f||(e.WillSaveStateReason=f={}));var S;(function(c){c[c.APPLICATION=-1]="APPLICATION",c[c.PROFILE=0]="PROFILE",c[c.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var b;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function g(c){const v=c.get(e.TARGET_KEY);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}class d extends I.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(v={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super(),this.options=v,this._onDidChangeValue=this._register(new R.PauseableEmitter),this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new n.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new I.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(v,E,a){return R.Event.filter(this._onDidChangeValue.event,t=>t.scope===v&&(E===void 0||t.key===E),a)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,n.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,I.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,E){const{key:a,external:t}=E;if(a===e.TARGET_KEY){switch(v){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:v})}else this._onDidChangeValue.fire({scope:v,key:a,target:this.getKeyTargets(v)[a],external:t})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,E,a){return this.getStorage(E)?.get(v,a)}getBoolean(v,E,a){return this.getStorage(E)?.getBoolean(v,a)}getNumber(v,E,a){return this.getStorage(E)?.getNumber(v,a)}getObject(v,E,a){return this.getStorage(E)?.getObject(v,a)}storeAll(v,E){this.withPausedEmitters(()=>{for(const a of v)this.store(a.key,a.value,a.scope,a.target,E)})}store(v,E,a,t,s=!1){if((0,k.isUndefinedOrNull)(E)){this.remove(v,a,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,a,t),this.getStorage(a)?.set(v,E,s)})}remove(v,E,a=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(v,E,void 0),this.getStorage(E)?.delete(v,a)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,E){const a=[],t=this.getKeyTargets(v);for(const s of Object.keys(t))t[s]===E&&a.push(s);return a}updateKeyTarget(v,E,a,t=!1){const s=this.getKeyTargets(E);typeof a=="number"?s[v]!==a&&(s[v]=a,this.getStorage(E)?.set(e.TARGET_KEY,JSON.stringify(s),t)):typeof s[v]=="number"&&(delete s[v],this.getStorage(E)?.set(e.TARGET_KEY,JSON.stringify(s),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(v){switch(v){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(v){const E=this.getStorage(v);return E?g(E):Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=f.NONE){this._onWillSaveState.fire({reason:v});const E=this.getStorage(-1),a=this.getStorage(0),t=this.getStorage(1);switch(v){case f.NONE:await n.Promises.settled([E?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case f.SHUTDOWN:await n.Promises.settled([E?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.getStorage(-1)?.items??new Map,E=this.getStorage(0)?.items??new Map,a=this.getStorage(1)?.items??new Map;return m(v,E,a,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(v){return await this.flush(),this.getStorage(v)?.optimize()}async switch(v,E){return this.emitWillSaveState(f.NONE),(0,l.isUserDataProfile)(v)?this.switchToProfile(v,E):this.switchToWorkspace(v,E)}canSwitchProfile(v,E){return!(v.id===E.id||y(E)&&y(v))}switchData(v,E,a){this.withPausedEmitters(()=>{const t=new Set;for(const[s,r]of v)t.add(s),E.get(s)!==r&&this.emitDidChangeValue(a,{key:s,external:!0});for(const[s]of E.items)t.has(s)||this.emitDidChangeValue(a,{key:s,external:!0})})}}e.AbstractStorageService=d;function y(c){return c.isDefault||!!c.useDefaultFlags?.globalState}class w extends d{constructor(){super(),this.applicationStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.profileStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),this._register(this.applicationStorage.onDidChangeStorage(v=>this.emitDidChangeValue(-1,v)))}getStorage(v){switch(v){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(v){switch(v){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(v){return!1}}e.InMemoryStorageService=w;async function m(c,v,E,a,t,s){const r=O=>{try{return JSON.parse(O)}catch{return O}},i=new Map,o=new Map;c.forEach((O,_)=>{i.set(_,O),o.set(_,r(O))});const u=new Map,p=new Map;v.forEach((O,_)=>{u.set(_,O),p.set(_,r(O))});const C=new Map,M=new Map;E.forEach((O,_)=>{C.set(_,O),M.set(_,r(O))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const D=[];if(i.forEach((O,_)=>{D.push({key:_,value:O})}),console.table(D),console.groupEnd(),console.log(o),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const O=[];u.forEach((_,F)=>{O.push({key:F,value:_})}),console.table(O),console.groupEnd(),console.log(p)}console.group(`Storage: Workspace (path: ${s})`);const W=[];C.forEach((O,_)=>{W.push({key:_,value:O})}),console.table(W),console.groupEnd(),console.log(M)}}),define(se[283],oe([0,1,22,8,3,2,9,73,7,21,115,163,5,97,28,30,13]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class m extends A.Disposable{static{this.LOG_SLOW_CLOSE_THRESHOLD=2e3}get storage(){return this._storage}constructor(r,i){super(),this.logService=r,this.fileService=i,this._onDidChangeStorage=this._register(new I.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new I.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=this._register(new f.Storage(new f.InMemoryStorageDatabase,{hint:f.StorageHint.STORAGE_IN_MEMORY})),this.initializePromise=void 0,this.whenInitPromise=new R.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=f.StorageState.None}isInMemory(){return this._storage.isInMemory()}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===f.StorageState.None)try{const r=this._register(await this.doCreate());this._storage.dispose(),this._storage=r,this._register(r.onDidChangeStorage(o=>this._onDidChangeStorage.fire(o))),await this.doInit(r);const i=r.getBoolean(g.IS_NEW_KEY);i===void 0?r.set(g.IS_NEW_KEY,!0):i&&r.set(g.IS_NEW_KEY,!1)}catch(r){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.state=f.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===b.LogLevel.Trace?r=>this.logService.trace(r):void 0,logError:r=>this.logService.error(r)}}doInit(r){return r.init()}get items(){return this._storage.items}get(r,i){return this._storage.get(r,i)}set(r,i){return this._storage.set(r,i)}delete(r){return this._storage.delete(r)}optimize(){return this._storage.optimize()}async close(){const r=new P.StopWatch(!1);await this.doClose(),r.stop(),r.elapsed()>m.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(r),this._onDidCloseStorage.fire()}async logSlowClose(r){if(this.path)try{const i=(0,n.top)(Array.from(this._storage.items.entries()).map(([u,p])=>({key:u,length:p.length})),(u,p)=>p.length-u.length,5).map(u=>`${u.key}:${u.length}`).join(", "),o=(await this.fileService.stat(h.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${o}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=f.StorageState.Closed,await this._storage.close()}}class c extends m{static{this.STORAGE_NAME="state.vscdb"}get path(){if(!this.options.useInMemoryStorage)return(0,k.join)(this.profile.globalStorageHome.with({scheme:w.Schemas.file}).fsPath,c.STORAGE_NAME)}constructor(r,i,o,u){super(o,u),this.profile=r,this.options=i}async doCreate(){return new f.Storage(new S.SQLiteStorageDatabase(this.path??S.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}),this.path?void 0:{hint:f.StorageHint.STORAGE_IN_MEMORY})}}class v extends c{constructor(r,i,o,u){super(r,i,o,u)}}e.ProfileStorageMain=v;class E extends c{constructor(r,i,o,u){super(i.defaultProfile,r,o,u)}async doInit(r){await super.doInit(r),this.updateTelemetryState(r)}updateTelemetryState(r){r.get(d.firstSessionDateStorageKey,void 0)===void 0&&r.set(d.firstSessionDateStorageKey,new Date().toUTCString());const o=r.get(d.currentSessionDateStorageKey,void 0),u=new Date().toUTCString();r.set(d.lastSessionDateStorageKey,typeof o>"u"?null:o),r.set(d.currentSessionDateStorageKey,u)}}e.ApplicationStorageMain=E;class a extends m{static{this.WORKSPACE_STORAGE_NAME="state.vscdb"}static{this.WORKSPACE_META_NAME="workspace.json"}get path(){if(!this.options.useInMemoryStorage)return(0,k.join)(this.environmentService.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.workspace.id,a.WORKSPACE_STORAGE_NAME)}constructor(r,i,o,u,p){super(o,p),this.workspace=r,this.options=i,this.environmentService=u}async doCreate(){const{storageFilePath:r,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new f.Storage(new S.SQLiteStorageDatabase(r,{logging:this.createLoggingOptions()}),{hint:this.options.useInMemoryStorage?f.StorageHint.STORAGE_IN_MEMORY:i?f.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:S.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const r=(0,k.join)(this.environmentService.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.workspace.id),i=(0,k.join)(r,a.WORKSPACE_STORAGE_NAME);return await l.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await l.Promises.mkdir(r,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(r),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(r){let i;if((0,y.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,y.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const o=(0,k.join)(r,a.WORKSPACE_META_NAME);await l.Promises.exists(o)||await l.Promises.writeFile(o,JSON.stringify(i,void 0,2))}catch(o){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${o}`)}}}e.WorkspaceStorageMain=a;class t extends m{get path(){}async doCreate(){return new f.Storage(new f.InMemoryStorageDatabase,{hint:f.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=t}),define(se[284],oe([0,1,3,2,97]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class A extends R.Disposable{constructor(P,h,l){super(),this.storageMainService=P,this.userDataProfilesService=h,this.logService=l;const f=this._register(new R.MutableDisposable);this._onDidChange=this._register(new n.Emitter({onWillAddFirstListener:()=>f.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>f.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new R.DisposableStore;return P.add(n.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(h,l)=>(h?h.push(l.key):h=[l.key],h),100)(h=>this.onDidChangeApplicationStorage(h))),P.add(n.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(h,l)=>{h||(h=new Map);let f=h.get(l.profile.id);return f||h.set(l.profile.id,f={profile:l.profile,keys:[],storage:l.storage}),f.keys.push(l.key),h},100)(h=>this.onDidChangeProfileStorage(h))),P}onDidChangeApplicationStorage(P){const h=P.includes(I.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],l=[];if(P=P.filter(f=>f!==I.TARGET_KEY),P.length){const f=(0,I.loadKeyTargets)(this.storageMainService.applicationStorage.storage);l.push({profile:this.userDataProfilesService.defaultProfile,changes:P.map(S=>({key:S,scope:0,target:f[S]}))})}this.triggerEvents(h,l)}onDidChangeProfileStorage(P){const h=[],l=new Map;for(const[f,S]of P.entries()){S.keys.includes(I.TARGET_KEY)&&h.push(S.profile);const b=S.keys.filter(g=>g!==I.TARGET_KEY);if(b.length){const g=(0,I.loadKeyTargets)(S.storage.storage);l.set(f,{profile:S.profile,changes:b.map(d=>({key:d,scope:0,target:g[d]}))})}}this.triggerEvents(h,[...l.values()])}triggerEvents(P,h){(P.length||h.length)&&this._onDidChange.fire({valueChanges:h,targetChanges:P})}listen(P,h,l){switch(h){case"onDidChange":return this._onDidChange.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${h}`)}async call(P,h){throw new Error(`Call not found: ${h}`)}}e.ProfileStorageChangesListenerChannel=A}),define(se[285],oe([0,1,7,38,16,5,34,40,41,12,125]),function(Q,e,n,R,I,A,k,P,h,l,f){"use strict";var S,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let g=class extends h.UserDataProfilesService{static{S=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(m,c,v,E,a){super(v,E,c,a),this.stateReadonlyService=m,this.nativeEnvironmentService=v}getStoredProfiles(){return this.stateReadonlyService.getItem(S.PROFILES_KEY,[]).map(c=>({...c,location:(0,l.isString)(c.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,c.location):n.URI.revive(c.location)}))}getStoredProfileAssociations(){const m=this.stateReadonlyService.getItem(S.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(S.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?m:this.migrateStoredProfileAssociations(m)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(n.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=g,e.UserDataProfilesReadonlyService=g=S=Ie([ie(0,k.IStateReadService),ie(1,P.IUriIdentityService),ie(2,R.INativeEnvironmentService),ie(3,I.IFileService),ie(4,A.ILogService)],g);let d=b=class extends g{constructor(m,c,v,E,a){super(m,c,v,E,a),this.stateService=m}saveStoredProfiles(m){m.length?this.stateService.setItem(b.PROFILES_KEY,m.map(c=>({...c,location:this.uriIdentityService.extUri.basename(c.location)}))):this.stateService.removeItem(b.PROFILES_KEY)}getStoredProfiles(){const m=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(m),this.stateService.setItem("userDataProfilesMigration",!0)),m}saveStoredProfileAssociations(m){m.emptyWindows||m.workspaces?this.stateService.setItem(b.PROFILE_ASSOCIATIONS_KEY,m):this.stateService.removeItem(b.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const m="workspaceAndProfileInfo",c=this.stateService.getItem(m,void 0);if(c){this.stateService.removeItem(m);const E=c.reduce((a,{workspace:t,profile:s})=>(a[n.URI.revive(t).toString()]=n.URI.revive(s).toString(),a),{});this.stateService.setItem(b.PROFILE_ASSOCIATIONS_KEY,{workspaces:E})}const v=super.getStoredProfileAssociations();return this.stateService.getItem(b.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(v),this.stateService.setItem(b.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),v}};e.UserDataProfilesService=d,e.UserDataProfilesService=d=b=Ie([ie(0,k.IStateService),ie(1,P.IUriIdentityService),ie(2,R.INativeEnvironmentService),ie(3,I.IFileService),ie(4,A.ILogService)],d);let y=class extends d{constructor(m,c,v,E){super(new f.StateService(0,c,E,v),m,c,v,E)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=y,e.ServerUserDataProfilesService=y=Ie([ie(0,P.IUriIdentityService),ie(1,R.INativeEnvironmentService),ie(2,I.IFileService),ie(3,A.ILogService)],y)}),define(se[57],oe([0,1,38,16,6,5,40,41,285,34]),function(Q,e,n,R,I,A,k,P,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,I.refineServiceDecorator)(P.IUserDataProfilesService);let f=class extends h.UserDataProfilesService{constructor(b,g,d,y,w){super(b,g,d,y,w)}getAssociatedEmptyWindows(){const b=[];for(const g of this.profilesObject.emptyWindows.keys())b.push({id:g});return b}};e.UserDataProfilesMainService=f,e.UserDataProfilesMainService=f=Ie([ie(0,l.IStateService),ie(1,k.IUriIdentityService),ie(2,n.INativeEnvironmentService),ie(3,R.IFileService),ie(4,A.ILogService)],f)}),define(se[133],oe([0,1,19,7,30]),function(Q,e,n,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnFile=A,e.findWindowOnWorkspaceOrFolder=k,e.findWindowOnExtensionDevelopmentPath=P;async function A(h,l,f){for(const b of h){const g=b.openedWorkspace;if((0,I.isWorkspaceIdentifier)(g)){const d=await f(g);if(d){if(d.folders.some(y=>n.extUriBiasedIgnorePathCase.isEqualOrParent(l,y.uri)))return b}else if(n.extUriBiasedIgnorePathCase.isEqualOrParent(l,g.configPath))return b}}const S=h.filter(b=>(0,I.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&n.extUriBiasedIgnorePathCase.isEqualOrParent(l,b.openedWorkspace.uri));if(S.length)return S.sort((b,g)=>-(b.openedWorkspace.uri.path.length-g.openedWorkspace.uri.path.length))[0]}function k(h,l){for(const f of h)if((0,I.isWorkspaceIdentifier)(f.openedWorkspace)&&n.extUriBiasedIgnorePathCase.isEqual(f.openedWorkspace.configPath,l)||(0,I.isSingleFolderWorkspaceIdentifier)(f.openedWorkspace)&&n.extUriBiasedIgnorePathCase.isEqual(f.openedWorkspace.uri,l))return f}function P(h,l){const f=S=>l.some(b=>n.extUriBiasedIgnorePathCase.isEqual(R.URI.file(b),R.URI.file(S)));for(const S of h)if(S.config?.extensionDevelopmentPath?.some(b=>f(b)))return S}}),define(se[98],oe([0,1,31,42,103,48,13,9,4,19,7,6,68,30]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkspacesService=void 0,e.isRecentWorkspace=d,e.isRecentFolder=y,e.isRecentFile=w,e.isStoredWorkspaceFolder=m,e.getStoredWorkspaceFolder=E,e.toWorkspaceFolders=t,e.rewriteWorkspaceFileForNewLocation=s,e.restoreRecentlyOpened=p,e.toStoreData=C,e.IWorkspacesService=(0,S.createDecorator)("workspacesService");function d(M){return M.hasOwnProperty("workspace")}function y(M){return M.hasOwnProperty("folderUri")}function w(M){return M.hasOwnProperty("fileUri")}function m(M){return c(M)||v(M)}function c(M){const D=M;return typeof D?.path=="string"&&(!D.name||typeof D.name=="string")}function v(M){const D=M;return typeof D?.uri=="string"&&(!D.name||typeof D.name=="string")}function E(M,D,W,O,_){if(M.scheme!==O.scheme)return{name:W,uri:M.toString(!0)};let F=D?void 0:_.relativePath(O,M);if(F!==void 0)F.length===0?F=".":h.isWindows&&(F=a(F));else if(M.scheme===k.Schemas.file)F=M.fsPath,h.isWindows&&(F=a(F));else if(_.isEqualAuthority(M.authority,O.authority))F=M.path;else return{name:W,uri:M.toString(!0)};return{name:W,path:F}}function a(M){return M=(0,A.normalizeDriveLetter)(M),(0,n.isUNC)(M)||(M=(0,n.toSlashes)(M)),M}function t(M,D,W){const O=[],_=new Set,F=W.dirname(D);for(const x of M){let z;if(c(x))x.path&&(z=W.resolvePath(F,x.path));else if(v(x))try{z=f.URI.parse(x.uri),z.path[0]!==P.posix.sep&&(z=z.with({path:P.posix.sep+z.path}))}catch(ue){console.warn(ue)}if(z){const ue=W.getComparisonKey(z);if(!_.has(ue)){_.add(ue);const ee=x.name||W.basenameOrAuthority(z);O.push(new g.WorkspaceFolder({uri:z,name:ee,index:O.length},x))}}}return O}function s(M,D,W,O,_){const F=r(D,M),x=_.dirname(D),z=_.dirname(O),ue=[];for(const G of F.folders){const B=c(G)?_.resolvePath(x,G.path):f.URI.parse(G.uri);let T;W?T=!1:T=!c(G)||(0,P.isAbsolute)(G.path),ue.push(E(B,T,G.name,z,_))}const ee={insertSpaces:!1,tabSize:4,eol:h.isLinux||h.isMacintosh?`
`:`\r
`},le=I.setProperty(M,["folders"],ue,ee);let Y=I.applyEdits(M,le);return(0,l.isEqualAuthority)(F.remoteAuthority,(0,b.getRemoteAuthority)(O))&&(Y=I.applyEdits(Y,I.removeProperty(Y,["remoteAuthority"],ee))),Y}function r(M,D){const W=R.parse(D);if(W&&Array.isArray(W.folders))W.folders=W.folders.filter(O=>m(O));else throw new Error(`${M} looks like an invalid workspace file.`);return W}function i(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function o(M){return typeof M.folderUri=="string"}function u(M){return typeof M.fileUri=="string"}function p(M,D){const W={workspaces:[],files:[]};if(M){const O=function(F,x){for(let z=0;z<F.length;z++)try{x(F[z],z)}catch(ue){D.warn(`Error restoring recent entry ${JSON.stringify(F[z])}: ${ue.toString()}. Skip entry.`)}},_=M;Array.isArray(_.entries)&&O(_.entries,F=>{const x=F.label,z=F.remoteAuthority;i(F)?W.workspaces.push({label:x,remoteAuthority:z,workspace:{id:F.workspace.id,configPath:f.URI.parse(F.workspace.configPath)}}):o(F)?W.workspaces.push({label:x,remoteAuthority:z,folderUri:f.URI.parse(F.folderUri)}):u(F)&&W.files.push({label:x,remoteAuthority:z,fileUri:f.URI.parse(F.fileUri)})})}return W}function C(M){const D={entries:[]};for(const W of M.workspaces)y(W)?D.entries.push({folderUri:W.folderUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority}):D.entries.push({workspace:{id:W.workspace.id,configPath:W.workspace.configPath.toString()},label:W.label,remoteAuthority:W.remoteAuthority});for(const W of M.files)D.entries.push({fileUri:W.fileUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority});return D}}),define(se[99],oe([0,1,87,13,4,19]),function(Q,e,n,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.getWorkspaceIdentifier=k,e.getSingleFolderWorkspaceIdentifier=P,e.createEmptyWorkspaceIdentifier=h,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function k(l){function f(){let S=l.scheme===R.Schemas.file?(0,A.originalFSPath)(l):l.toString();return I.isLinux||(S=S.toLowerCase()),(0,n.createHash)("md5").update(S).digest("hex")}return{id:f(),configPath:l}}function P(l,f){function S(){if(l.scheme!==R.Schemas.file)return(0,n.createHash)("md5").update(l.toString()).digest("hex");if(!f)return;let g;return I.isLinux?g=f.ino:I.isMacintosh?g=f.birthtime.getTime():I.isWindows&&(typeof f.birthtimeMs=="number"?g=Math.floor(f.birthtimeMs):g=f.birthtime.getTime()),(0,n.createHash)("md5").update(l.fsPath).update(g?String(g):"").digest("hex")}const b=S();if(typeof b=="string")return{id:b,uri:l}}function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(se[100],oe([0,1,87,88,26,286,17,15,3,2,9,4,33,44,113]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0,e.createRandomIPCHandle=r,e.createStaticIPCHandle=i,e.serve=p,e.connect=C;class y{traceSocketEvent(D,W){d.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,D,W)}constructor(D,W=""){this._canWrite=!0,this.debugLabel=W,this.socket=D,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,P.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener),this._closeListener=O=>{this.traceSocketEvent("close",{hadError:O}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(D){const W=O=>{this.traceSocketEvent("read",O),D(k.VSBuffer.wrap(O))};return this.socket.on("data",W),{dispose:()=>this.socket.off("data",W)}}onClose(D){const W=O=>{D({type:0,hadError:O,error:void 0})};return this.socket.on("close",W),{dispose:()=>this.socket.off("close",W)}}onEnd(D){const W=()=>{D()};return this.socket.on("end",W),{dispose:()=>this.socket.off("end",W)}}write(D){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",D),this.socket.write(D.buffer,W=>{if(W){if(W.code==="EPIPE")return;(0,P.onUnexpectedError)(W)}})}catch(W){if(W.code==="EPIPE")return;(0,P.onUnexpectedError)(W)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((D,W)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),D();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),D()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=y;var w;(function(M){M[M.MinHeaderByteSize=2]="MinHeaderByteSize",M[M.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var m;(function(M){M[M.PeekHeader=1]="PeekHeader",M[M.ReadHeader=2]="ReadHeader",M[M.ReadBody=3]="ReadBody",M[M.Fin=4]="Fin"})(m||(m={}));class c extends l.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(D,W){this.socket.traceSocketEvent(D,W)}constructor(D,W,O,_){super(),this._onData=this._register(new h.Emitter),this._onClose=this._register(new h.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=D,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:W,inflateBytesLength:O?.byteLength||0,recordInflateBytes:_}),this._flowManager=this._register(new v(this,W,O,_,this._onData,(F,x)=>this._write(F,x))),this._register(this._flowManager.onError(F=>{console.error(F),(0,P.onUnexpectedError)(F),this._onClose.fire({type:0,hadError:!0,error:F})})),this._incomingData=new d.ChunkStream,this._register(this.socket.onData(F=>this._acceptChunk(F))),this._register(this.socket.onClose(async F=>{this._flowManager.isProcessingReadQueue()&&await h.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(F)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(D){return this._onData.event(D)}onClose(D){return this._onClose.event(D)}onEnd(D){return this.socket.onEnd(D)}write(D){let W=0;for(;W<D.byteLength;)this._flowManager.writeMessage(D.slice(W,Math.min(W+262144,D.byteLength)),{compressed:!0,opcode:2}),W+=262144}_write(D,{compressed:W,opcode:O}){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",D);let _=2;D.byteLength<126?_+=0:D.byteLength<2**16?_+=2:_+=8;const F=k.VSBuffer.alloc(_),x=W?64:0,z=O&15;if(F.writeUInt8(128|x|z,0),D.byteLength<126)F.writeUInt8(D.byteLength,1);else if(D.byteLength<2**16){F.writeUInt8(126,1);let ue=1;F.writeUInt8(D.byteLength>>>8&255,++ue),F.writeUInt8(D.byteLength>>>0&255,++ue)}else{F.writeUInt8(127,1);let ue=1;F.writeUInt8(0,++ue),F.writeUInt8(0,++ue),F.writeUInt8(0,++ue),F.writeUInt8(0,++ue),F.writeUInt8(D.byteLength>>>24&255,++ue),F.writeUInt8(D.byteLength>>>16&255,++ue),F.writeUInt8(D.byteLength>>>8&255,++ue),F.writeUInt8(D.byteLength>>>0&255,++ue)}this.socket.write(k.VSBuffer.concat([F,D]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(D){if(D.byteLength!==0){for(this._incomingData.acceptChunk(D);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const W=this._incomingData.peek(this._state.readLen),O=W.readUInt8(0),_=(O&128)>>>7,F=(O&64)>>>6,x=O&15,z=W.readUInt8(1),ue=(z&128)>>>7,ee=z&127;this._state.state=2,this._state.readLen=2+(ue?4:0)+(ee===126?2:0)+(ee===127?8:0),this._state.fin=_,this._state.firstFrameOfMessage&&(this._state.compressed=!!F),this._state.firstFrameOfMessage=!!_,this._state.mask=0,this._state.opcode=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===2){const W=this._incomingData.read(this._state.readLen),O=W.readUInt8(1),_=(O&128)>>>7;let F=O&127,x=1;F===126?F=W.readUInt8(++x)*2**8+W.readUInt8(++x):F===127&&(F=W.readUInt8(++x)*0+W.readUInt8(++x)*0+W.readUInt8(++x)*0+W.readUInt8(++x)*0+W.readUInt8(++x)*2**24+W.readUInt8(++x)*2**16+W.readUInt8(++x)*2**8+W.readUInt8(++x));let z=0;_&&(z=W.readUInt8(++x)*2**24+W.readUInt8(++x)*2**16+W.readUInt8(++x)*2**8+W.readUInt8(++x)),this._state.state=3,this._state.readLen=F,this._state.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===3){const W=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",W),t(W,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",W),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(W,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(W,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await h.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=c;class v extends l.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:k.VSBuffer.alloc(0)}constructor(D,W,O,_,F,x){super(),this._tracer=D,this._onData=F,this._writeFn=x,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new h.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new h.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,W?(this._zlibInflateStream=this._register(new E(this._tracer,_,O,{windowBits:15})),this._zlibDeflateStream=this._register(new a(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(z=>this._onError.fire(z))),this._register(this._zlibDeflateStream.onError(z=>this._onError.fire(z)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(D,W){this._writeQueue.push({data:D,options:W}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:D,options:W}=this._writeQueue.shift();if(this._zlibDeflateStream&&W.compressed){const O=await this._deflateMessage(this._zlibDeflateStream,D);this._writeFn(O,W)}else this._writeFn(D,{...W,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(D,W){return new Promise((O,_)=>{D.write(W),D.flush(F=>O(F))})}acceptFrame(D,W,O){this._readQueue.push({data:D,isCompressed:W,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const D=this._readQueue.shift();if(this._zlibInflateStream&&D.isCompressed){const W=await this._inflateFrame(this._zlibInflateStream,D.data,D.isLastFrameOfMessage);this._onData.fire(W)}else this._onData.fire(D.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(D,W,O){return new Promise((_,F)=>{D.write(W),O&&D.write(k.VSBuffer.fromByteArray([0,0,255,255])),D.flush(x=>_(x))})}}class E extends l.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.concat(this._recordedInflateBytes):k.VSBuffer.alloc(0)}constructor(D,W,O,_){super(),this._tracer=D,this._recordInflateBytes=W,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,A.createInflateRaw)(_),this._zlibInflate.on("error",F=>{this._tracer.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibInflate.on("data",F=>{this._tracer.traceSocketEvent("zlibInflateData",F),this._pendingInflateData.push(k.VSBuffer.wrap(F))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(D){this._recordInflateBytes&&this._recordedInflateBytes.push(D.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",D),this._zlibInflate.write(D.buffer)}flush(D){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const W=k.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,D(W)})}}class a extends l.Disposable{constructor(D,W){super(),this._tracer=D,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,A.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(k.VSBuffer.wrap(O))})}write(D){this._tracer.traceSocketEvent("zlibDeflateWrite",D.buffer),this._zlibDeflate.write(D.buffer)}flush(D){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let W=k.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,W=W.slice(0,W.byteLength-4),D(W)})}}function t(M,D){if(D===0)return;const W=M.byteLength>>>2;for(let ue=0;ue<W;ue++){const ee=M.readUInt32BE(ue*4);M.writeUInt32BE(ee^D,ue*4)}const O=W*4,_=M.byteLength-O,F=D>>>24&255,x=D>>>16&255,z=D>>>8&255;_>=1&&M.writeUInt8(M.readUInt8(O)^F,O),_>=2&&M.writeUInt8(M.readUInt8(O+1)^x,O+1),_>=3&&M.writeUInt8(M.readUInt8(O+2)^z,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const s={2:107,1:103};function r(){const M=(0,b.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${M}-sock`;const D=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,I.tmpdir)(),W=(0,f.join)(D,`vscode-ipc-${M}.sock`);return o(W),W}function i(M,D,W){const _=(0,n.createHash)("sha256").update(M).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${_}-${W}-${D}-sock`;const F=W.substr(0,4),x=D.substr(0,6);let z;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?z=(0,f.join)(e.XDG_RUNTIME_DIR,`vscode-${_}-${F}-${x}.sock`):z=(0,f.join)(M,`${F}-${x}.sock`),o(z),z}function o(M){const D=s[S.platform];typeof D=="number"&&M.length>=D&&console.warn(`WARNING: IPC handle "${M}" is longer than ${D} chars, try a shorter --user-data-dir`)}class u extends g.IPCServer{static toClientConnectionEvent(D){const W=h.Event.fromNodeEventEmitter(D,"connection");return h.Event.map(W,O=>({protocol:new d.Protocol(new y(O,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(O,"close"))}))}constructor(D){super(u.toClientConnectionEvent(D)),this.server=D}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=u;function p(M){return new Promise((D,W)=>{const O=(0,R.createServer)();O.on("error",W),O.listen(M,()=>{O.removeListener("error",W),D(new u(O))})})}function C(M,D){return new Promise((W,O)=>{const _=(0,R.createConnection)(M,()=>{_.removeListener("error",O),W(d.Client.fromSocket(new y(_,`ipc-client${D}`),D))});_.once("error",O)})}}),define(se[24],oe([0,1,51,9,4,100,38,91,6]),function(Q,e,n,R,I,A,k,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,h.refineServiceDecorator)(k.IEnvironmentService);class l extends P.NativeEnvironmentService{constructor(){super(...arguments),this._snapEnv={}}get cachedLanguagesPath(){return(0,R.join)(this.userDataPath,"clp")}get backupHome(){return(0,R.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,A.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,R.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(I.isLinux){for(const S in process.env)if(S.endsWith("_VSCODE_SNAP_ORIG")){const b=S.slice(0,-17);if(this._snapEnv[b])continue;process.env[b]&&(this._snapEnv[b]=process.env[b]),process.env[S]?process.env[b]=process.env[S]:delete process.env[b]}}}restoreSnapExportedVariables(){if(I.isLinux)for(const S in this._snapEnv)process.env[S]=this._snapEnv[S],delete this._snapEnv[S]}}e.EnvironmentMainService=l,Ie([n.memoize],l.prototype,"cachedLanguagesPath",null),Ie([n.memoize],l.prototype,"backupHome",null),Ie([n.memoize],l.prototype,"mainIPCHandle",null),Ie([n.memoize],l.prototype,"mainLockfile",null),Ie([n.memoize],l.prototype,"disableUpdates",null),Ie([n.memoize],l.prototype,"crossOriginIsolated",null),Ie([n.memoize],l.prototype,"codeCachePath",null),Ie([n.memoize],l.prototype,"useCodeCache",null)}),define(se[287],oe([0,1,87,31,13,9,4,19,21,199,18,24,34,16,5,198,30,99]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y,w,m){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class{static{c=this}static{this.backupWorkspacesMetadataStorageKey="backupWorkspaces"}constructor(a,t,s,r){this.environmentMainService=a,this.configurationService=t,this.logService=s,this.stateService=r,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=P.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,o)=>(0,R.isEqual)(i,o,!k.isLinux)}}async initialize(){const a=this.stateService.getItem(c.backupWorkspacesMetadataStorageKey)??{workspaces:[],folders:[],emptyWindows:[]};this.emptyWindows=await this.validateEmptyWorkspaces(a.emptyWindows),this.workspaces=await this.validateWorkspaces((0,l.deserializeWorkspaceInfos)(a)),this.folders=await this.validateFolders((0,l.deserializeFolderInfos)(a)),this.storeWorkspacesMetadata()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==g.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===g.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||g.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(a,t){this.workspaces.some(r=>a.workspace.id===r.workspace.id)||(this.workspaces.push(a),this.storeWorkspacesMetadata());const s=(0,A.join)(this.backupHome,a.workspace.id);return t?this.moveBackupFolder(s,t).then(()=>s):s}async moveBackupFolder(a,t){if(await h.Promises.exists(a)&&await this.convertToEmptyWindowBackup(a),await h.Promises.exists(t))try{await h.Promises.rename(t,a,!1)}catch(s){this.logService.error(`Backup: Could not move backup folder to new location: ${s.toString()}`)}}registerFolderBackup(a){return this.folders.some(t=>this.backupUriComparer.isEqual(a.folderUri,t.folderUri))||(this.folders.push(a),this.storeWorkspacesMetadata()),(0,A.join)(this.backupHome,this.getFolderHash(a))}registerEmptyWindowBackup(a){return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a.backupFolder))||(this.emptyWindows.push(a),this.storeWorkspacesMetadata()),(0,A.join)(this.backupHome,a.backupFolder)}async validateWorkspaces(a){if(!Array.isArray(a))return[];const t=new Set,s=[];for(const r of a){const i=r.workspace;if(!(0,w.isWorkspaceIdentifier)(i))return[];if(!t.has(i.id)){t.add(i.id);const o=(0,A.join)(this.backupHome,i.id);await this.doHasBackups(o)?i.configPath.scheme!==I.Schemas.file||await h.Promises.exists(i.configPath.fsPath)?s.push(r):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return s}async validateFolders(a){if(!Array.isArray(a))return[];const t=[],s=new Set;for(const r of a){const i=r.folderUri,o=this.backupUriComparer.getComparisonKey(i);if(!s.has(o)){s.add(o);const u=(0,A.join)(this.backupHome,this.getFolderHash(r));await this.doHasBackups(u)?i.scheme!==I.Schemas.file||await h.Promises.exists(i.fsPath)?t.push(r):await this.convertToEmptyWindowBackup(u):await this.deleteStaleBackup(u)}}return t}async validateEmptyWorkspaces(a){if(!Array.isArray(a))return[];const t=[],s=new Set;for(const r of a){const i=r.backupFolder;if(typeof i!="string")return[];if(!s.has(i)){s.add(i);const o=(0,A.join)(this.backupHome,i);await this.doHasBackups(o)?t.push(r):await this.deleteStaleBackup(o)}}return t}async deleteStaleBackup(a){try{await h.Promises.rm(a,h.RimRafMode.MOVE)}catch(t){this.logService.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}prepareNewEmptyWindowBackup(){let a=(0,m.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a.id));)a=(0,m.createEmptyWorkspaceIdentifier)();return{backupFolder:a.id}}async convertToEmptyWindowBackup(a){const t=this.prepareNewEmptyWindowBackup(),s=(0,A.join)(this.backupHome,t.backupFolder);try{await h.Promises.rename(a,s,!1)}catch(r){return this.logService.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.emptyWindows.push(t),!0}async getDirtyWorkspaces(){const a=[];for(const t of this.workspaces)await this.hasBackups(t)&&a.push(t);for(const t of this.folders)await this.hasBackups(t)&&a.push(t);return a}hasBackups(a){let t;return(0,l.isEmptyWindowBackupInfo)(a)?t=(0,A.join)(this.backupHome,a.backupFolder):(0,y.isFolderBackupInfo)(a)?t=(0,A.join)(this.backupHome,this.getFolderHash(a)):t=(0,A.join)(this.backupHome,a.workspace.id),this.doHasBackups(t)}async doHasBackups(a){try{const t=await h.Promises.readdir(a);for(const s of t)try{if((await h.Promises.readdir((0,A.join)(a,s))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const a={workspaces:this.workspaces.map(({workspace:t,remoteAuthority:s})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return s&&(r.remoteAuthority=s),r}),folders:this.folders.map(({folderUri:t,remoteAuthority:s})=>{const r={folderUri:t.toString()};return s&&(r.remoteAuthority=s),r}),emptyWindows:this.emptyWindows.map(({backupFolder:t,remoteAuthority:s})=>{const r={backupFolder:t};return s&&(r.remoteAuthority=s),r})};this.stateService.setItem(c.backupWorkspacesMetadataStorageKey,a)}getFolderHash(a){const t=a.folderUri;let s;return t.scheme===I.Schemas.file?s=k.isLinux?t.fsPath:t.fsPath.toLowerCase():s=t.toString().toLowerCase(),(0,n.createHash)("md5").update(s).digest("hex")}};e.BackupMainService=v,e.BackupMainService=v=c=Ie([ie(0,S.IEnvironmentMainService),ie(1,f.IConfigurationService),ie(2,d.ILogService),ie(3,b.IStateService)],v)}),define(se[20],oe([0,1,14,37,8,3,2,4,36,12,6,5,34,24]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,f.createDecorator)("lifecycleMainService");var y;(function(c){c[c.QUIT=1]="QUIT",c[c.KILL=2]="KILL"})(y||(e.ShutdownReason=y={}));var w;(function(c){c[c.Starting=1]="Starting",c[c.Ready=2]="Ready",c[c.AfterWindowOpen=3]="AfterWindowOpen",c[c.Eventually=4]="Eventually"})(w||(e.LifecycleMainPhase=w={}));let m=class extends k.Disposable{static{d=this}static{this.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart"}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(v,E,a){super(),this.logService=v,this.stateService=E,this.environmentMainService=a,this._onBeforeShutdown=this._register(new A.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new A.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new A.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new A.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.relaunchHandler=void 0,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateService.getItem(d.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateService.removeItem(d.QUIT_AND_RESTART_KEY)}registerListeners(){const v=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),P.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};n.app.addListener("before-quit",v);const E=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!P.isMacintosh)&&n.app.quit()};n.app.addListener("window-all-closed",E),n.app.once("will-quit",a=>{this.trace("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.trace("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.resolvePendingQuitPromise(!1),n.app.removeListener("before-quit",v),n.app.removeListener("window-all-closed",E),this.trace("Lifecycle#app.on(will-quit) - calling app.quit()"),n.app.quit()})})}fireOnWillShutdown(v){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;const E=this.logService;this.trace("Lifecycle#onWillShutdown.fire()");const a=[];return this._onWillShutdown.fire({reason:v,join(t,s){E.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(s.finally(()=>{E.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.pendingWillShutdownPromise=(async()=>{try{await I.Promises.settled(a)}catch(t){this.logService.error(t)}try{await this.stateService.close()}catch(t){this.logService.error(t)}})(),this.pendingWillShutdownPromise}set phase(v){if(v<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===v)return;this.trace(`lifecycle (main): phase changed (value: ${v})`),this._phase=v;const E=this.phaseWhen.get(this._phase);E&&(E.open(),this.phaseWhen.delete(this._phase))}async when(v){if(v<=this._phase)return;let E=this.phaseWhen.get(v);E||(E=new I.Barrier,this.phaseWhen.set(v,E)),await E.wait()}registerWindow(v){const E=new k.DisposableStore;this.windowCounter++,E.add(v.onWillLoad(t=>this._onWillLoadWindow.fire({window:v,workspace:t.workspace,reason:t.reason})));const a=(0,l.assertIsDefined)(v.win);E.add(A.Event.fromNodeEventEmitter(a,"close")(t=>{const s=v.id;if(this.windowToCloseRequest.has(s)){this.windowToCloseRequest.delete(s);return}this.trace(`Lifecycle#window.on('close') - window ID ${v.id}`),t.preventDefault(),this.unload(v,1).then(r=>{if(r){this.windowToCloseRequest.delete(s);return}this.windowToCloseRequest.add(s),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${s}`),this._onBeforeCloseWindow.fire(v),v.close()})})),E.add(A.Event.fromNodeEventEmitter(a,"closed")(()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${v.id}`),this.windowCounter--,E.dispose(),this.windowCounter===0&&(!P.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)}))}registerAuxWindow(v){const E=(0,l.assertIsDefined)(v.win),a=new k.DisposableStore;a.add(A.Event.fromNodeEventEmitter(E,"close")(t=>{this.trace(`Lifecycle#auxWindow.on('close') - window ID ${v.id}`),this._quitRequested&&(this.trace("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),t.preventDefault())})),a.add(A.Event.fromNodeEventEmitter(E,"closed")(()=>{this.trace(`Lifecycle#auxWindow.on('closed') - window ID ${v.id}`),a.dispose()}))}async reload(v,E){await this.unload(v,3)||v.reload(E)}unload(v,E){const a=this.mapWindowIdToPendingUnload.get(v.id);if(a)return a;const t=this.doUnload(v,E).finally(()=>{this.mapWindowIdToPendingUnload.delete(v.id)});return this.mapWindowIdToPendingUnload.set(v.id,t),t}async doUnload(v,E){if(!v.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${v.id}`);const a=this._quitRequested?2:E,t=await this.onBeforeUnloadWindowInRenderer(v,a);return t?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${v.id})`),this.handleWindowUnloadVeto(t)):(await this.onWillUnloadWindowInRenderer(v,a),!1)}handleWindowUnloadVeto(v){return v?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(v){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(v),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(v,E){return new Promise(a=>{const t=this.oneTimeListenerTokenGenerator++,s=`vscode:ok${t}`,r=`vscode:cancel${t}`;R.validatedIpcMain.once(s,()=>{a(!1)}),R.validatedIpcMain.once(r,()=>{a(!0)}),v.send("vscode:onBeforeUnload",{okChannel:s,cancelChannel:r,reason:E})})}onWillUnloadWindowInRenderer(v,E){return new Promise(a=>{const s=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;R.validatedIpcMain.once(s,()=>a()),v.send("vscode:onWillUnload",{replyChannel:s,reason:E})})}quit(v){return this.doQuit(v).then(E=>{if(!E&&v)try{if(P.isWindows){const a=(0,h.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}return E})}doQuit(v){return this.trace(`Lifecycle#quit() - begin (willRestart: ${v})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(v&&this.stateService.setItem(d.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(E=>{this.pendingQuitPromiseResolve=E,this.trace("Lifecycle#quit() - calling app.quit()"),n.app.quit()}),this.pendingQuitPromise)}trace(v){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(v):this.logService.trace(v)}setRelaunchHandler(v){this.relaunchHandler=v}async relaunch(v){this.trace("Lifecycle#relaunch()");const E=process.argv.slice(1);if(v?.addArgs&&E.push(...v.addArgs),v?.removeArgs)for(const s of v.removeArgs){const r=E.indexOf(s);r>=0&&E.splice(r,1)}const a=()=>{this.relaunchHandler?.handleRelaunch(v)||(this.trace("Lifecycle#relaunch() - calling app.relaunch()"),n.app.relaunch({args:E}))};n.app.once("quit",a),await this.quit(!0)&&n.app.removeListener("quit",a)}async kill(v){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,I.timeout)(1e3),(async()=>{for(const E of n.BrowserWindow.getAllWindows())if(E&&!E.isDestroyed()){let a;E.webContents&&!E.webContents.isDestroyed()?a=new Promise(t=>E.once("closed",t)):a=Promise.resolve(),E.destroy(),await a}})()]),n.app.exit(v)}};e.LifecycleMainService=m,e.LifecycleMainService=m=d=Ie([ie(0,S.ILogService),ie(1,b.IStateService),ie(2,g.IEnvironmentMainService)],m)}),define(se[288],oe([0,1,4,3,2,6,20]),function(Q,e,n,R,I,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,A.createDecorator)("keyboardLayoutMainService");let P=class extends I.Disposable{constructor(f){super(),this._onDidChangeKeyboardLayout=this._register(new R.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,f.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const f=await new Promise((S,b)=>{Q(["native-keymap"],S,b)});this._keyboardLayoutData=h(f),n.isCI||f.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=h(f),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};e.KeyboardLayoutMainService=P,e.KeyboardLayoutMainService=P=Ie([ie(0,k.ILifecycleMainService)],P);function h(l){const f=l.getKeyMap(),S=l.getCurrentKeyboardLayout();return{keyboardMapping:f,keyboardLayoutInfo:S}}}),define(se[289],oe([0,1,250,8,17,15,12,18,38,95,5,53,249,286]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0,e.nodeRequest=w;let d=class extends S.AbstractRequestService{constructor(c,v,E,a){super(a),this.configurationService=c,this.environmentService=v,this.logService=E,this.configure(),this._register(c.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.configure()}))}configure(){const c=this.configurationService.getValue("http");this.proxyUrl=c?.proxy,this.strictSSL=!!c?.proxyStrictSSL,this.authorization=c?.proxyAuthorization}async request(c,v){const{proxyUrl:E,strictSSL:a}=this;let t;try{t=await(0,l.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(i){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,A.getErrorMessage)(i)))}const s={...process.env,...t},r=c.agent?c.agent:await(0,b.getProxyAgent)(c.url||"",s,{proxyUrl:E,strictSSL:a});return c.agent=r,c.strictSSL=a,this.authorization&&(c.headers={...c.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(c.isChromiumNetwork?"electron":"node",c,()=>w(c,v))}async resolveProxy(c){}async loadCertificates(){return(await new Promise((v,E)=>{Q(["@vscode/proxy-agent"],v,E)})).loadSystemCertificates({log:this.logService})}};e.RequestService=d,e.RequestService=d=Ie([ie(0,P.IConfigurationService),ie(1,h.INativeEnvironmentService),ie(2,f.ILogService),ie(3,f.ILoggerService)],d);async function y(m){return((0,n.parse)(m.url).protocol==="https:"?await new Promise((E,a)=>{Q(["https"],E,a)}):await new Promise((E,a)=>{Q(["http"],E,a)})).request}async function w(m,c){return R.Promises.withAsyncBody(async(v,E)=>{const a=(0,n.parse)(m.url),t=m.getRawRequest?m.getRawRequest(m):await y(m),s={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,k.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(s.auth=m.user+":"+m.password);const r=t(s,i=>{const o=(0,k.isNumber)(m.followRedirects)?m.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&o>0&&i.headers.location)w({...m,url:i.headers.location,followRedirects:o-1},c).then(v,E);else{let u=i;!m.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(u=i.pipe((0,g.createGunzip)())),v({res:i,stream:(0,I.streamToBufferReadableStream)(u)})}});r.on("error",E),m.timeout&&r.setTimeout(m.timeout),m.isChromiumNetwork&&r.removeHeader("Content-Length"),m.data&&typeof m.data=="string"&&r.write(m.data),r.end(),c.onCancellationRequested(()=>{r.abort(),E(new A.CancellationError)})})}}),define(se[290],oe([0,1,14,289]),function(Q,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function I(k){return n.net.request}class A extends R.RequestService{request(P,h){return super.request({...P||{},getRawRequest:I,isChromiumNetwork:!0},h)}}e.RequestMainService=A}),define(se[84],oe([0,1,7,3,2,38,16,6,20,5,97,283,41,57,40,13]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,P.createDecorator)("storageMainService");let w=class extends I.Disposable{constructor(v,E,a,t,s,r){super(),this.logService=v,this.environmentService=E,this.userDataProfilesService=a,this.lifecycleMainService=t,this.fileService=s,this.uriIdentityService=r,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new R.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this._register(this.createApplicationStorage()),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(v=>{v.window.profile&&this.profileStorage(v.window.profile).init(),v.workspace&&this.workspaceStorage(v.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(v=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=v.reason,v.join("applicationStorage",this.applicationStorage.close());for(const[,E]of this.mapProfileToStorage)v.join("profileStorage",E.close());for(const[,E]of this.mapWorkspaceToStorage)v.join("workspaceStorage",E.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(v=>{v.join((async()=>{await this.fileService.exists(v.profile.globalStorageHome)||await this.fileService.createFolder(v.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(v=>{const E=this.mapProfileToStorage.get(v.profile.id);E&&v.join(E.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const v=new S.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return this._register(R.Event.once(v.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")})),v}profileStorage(v){if((0,f.isProfileUsingDefaultStorage)(v))return this.applicationStorage;let E=this.mapProfileToStorage.get(v.id);if(!E){this.logService.trace(`StorageMainService: creating profile storage (${v.name})`),E=this._register(this.createProfileStorage(v)),this.mapProfileToStorage.set(v.id,E);const a=this._register(E.onDidChangeStorage(t=>this._onDidChangeProfileStorage.fire({...t,storage:E,profile:v})));this._register(R.Event.once(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${v.name})`),this.mapProfileToStorage.delete(v.id),a.dispose()}))}return E}createProfileStorage(v){return this.shutdownReason===2?new S.InMemoryStorageMain(this.logService,this.fileService):new S.ProfileStorageMain(v,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(v){let E=this.mapWorkspaceToStorage.get(v.id);return E||(this.logService.trace(`StorageMainService: creating workspace storage (${v.id})`),E=this._register(this.createWorkspaceStorage(v)),this.mapWorkspaceToStorage.set(v.id,E),this._register(R.Event.once(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${v.id})`),this.mapWorkspaceToStorage.delete(v.id)}))),E}createWorkspaceStorage(v){return this.shutdownReason===2?new S.InMemoryStorageMain(this.logService,this.fileService):new S.WorkspaceStorageMain(v,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(v){const E=n.URI.file(v);for(const a of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(a.path&&this.uriIdentityService.extUri.isEqualOrParent(n.URI.file(a.path),E))return!0;return!1}};e.StorageMainService=w,e.StorageMainService=w=Ie([ie(0,l.ILogService),ie(1,A.IEnvironmentService),ie(2,g.IUserDataProfilesMainService),ie(3,h.ILifecycleMainService),ie(4,k.IFileService),ie(5,d.IUriIdentityService)],w),e.IApplicationStorageMainService=(0,P.createDecorator)("applicationStorageMainService");let m=class extends f.AbstractStorageService{constructor(v,E){super(),this.userDataProfilesService=v,this.storageMainService=E,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(v){if(v===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(v){if(v===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.with({scheme:y.Schemas.file}).fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.ApplicationStorageMainService=m,e.ApplicationStorageMainService=m=Ie([ie(0,b.IUserDataProfilesService),ie(1,e.IStorageMainService)],m)}),define(se[291],oe([0,1,88,26,107,100,8,2,4,18,5,27,245,246,96,130,17]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function m(t,s,r,i,o){let u;for(let p=3;p&&(u?.dispose(),u=await new c(t,s,r,i,o).waitForReady(),!(o&&I.BROWSER_RESTRICTED_PORTS[o]||!I.BROWSER_RESTRICTED_PORTS[u.tunnelLocalPort]));p--);return u}class c extends P.Disposable{constructor(s,r,i,o,u){super(),this.defaultTunnelHost=r,this.suggestedLocalPort=u,this.privacy=y.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=s,this._server=n.createServer(),this._barrier=new k.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=p=>this._onConnection(p),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=o,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(r=>{r()})}async waitForReady(){const s=this.suggestedLocalPort??this.tunnelRemotePort,r=(0,y.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let i=await(0,I.findFreePortFaster)(s,2,1e3,r),o=null;return this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),o=this._server.address(),o||(i=0,this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),o=this._server.address()),this.tunnelLocalPort=o.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${o.port}`,this}async _onConnection(s){s.pause();const r=(0,y.isLocalhost)(this.tunnelRemoteHost)||(0,y.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,b.connectRemoteAgentTunnel)(this._options,r,this.tunnelRemotePort),o=i.getSocket(),u=i.readEntireBuffer();i.dispose(),u.byteLength>0&&s.write(u.buffer),s.on("end",()=>{s.localAddress&&this._socketsDispose.delete(s.localAddress),o.end()}),s.on("close",()=>o.end()),s.on("error",()=>{s.localAddress&&this._socketsDispose.delete(s.localAddress),o instanceof A.NodeSocket?o.socket.destroy():o.end()}),o instanceof A.NodeSocket?this._mirrorNodeSocket(s,o):this._mirrorGenericSocket(s,o),s.localAddress&&this._socketsDispose.set(s.localAddress,()=>{s.end(),o.end()})}_mirrorGenericSocket(s,r){r.onClose(()=>s.destroy()),r.onEnd(()=>s.end()),r.onData(i=>s.write(i.buffer)),s.on("data",i=>r.write(w.VSBuffer.wrap(i))),s.resume()}_mirrorNodeSocket(s,r){const i=r.socket;i.on("end",()=>s.end()),i.on("close",()=>s.end()),i.on("error",()=>{s.destroy()}),i.pipe(s),s.pipe(i)}}e.NodeRemoteTunnel=c;let v=class extends y.AbstractTunnelService{constructor(s,r,i,o,u){super(r,u),this.remoteSocketFactoryService=s,this.signService=i,this.productService=o}isPortPrivileged(s){return(0,y.isPortPrivileged)(s,this.defaultTunnelHost,h.OS,R.release())}retainOrCreateTunnel(s,r,i,o,u,p,C,M){const D=this.getTunnelFromMap(r,i);if(D)return++D.refcount,D.value;if((0,y.isTunnelProvider)(s))return this.createWithProvider(s,r,i,u,p,C,M);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${u}.`);const W={commit:this.productService.commit,quality:this.productService.quality,addressProvider:s,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},O=m(W,o,r,i,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(r,i,O),O}}};e.BaseTunnelService=v,e.BaseTunnelService=v=Ie([ie(0,g.IRemoteSocketFactoryService),ie(1,f.ILogService),ie(2,d.ISignService),ie(3,S.IProductService),ie(4,l.IConfigurationService)],v);let E=class extends v{constructor(s,r,i,o,u){super(s,r,i,o,u)}};e.TunnelService=E,e.TunnelService=E=Ie([ie(0,g.IRemoteSocketFactoryService),ie(1,f.ILogService),ie(2,d.ISignService),ie(3,S.IProductService),ie(4,l.IConfigurationService)],E);let a=class extends P.Disposable{constructor(s,r,i,o,u){super(),this.remoteSocketFactoryService=s,this.logService=r,this.productService=i,this.signService=o,this.configurationService=u,this._tunnelServices=new Map}async openTunnel(s,r,i,o,u,p,C,M,D){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${o} on local port ${p}.`),!this._tunnelServices.has(s)){const W=new E(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(W),this._tunnelServices.set(s,W),W.onTunnelClosed(async()=>{(await W.tunnels).length===0&&(W.dispose(),this._tunnelServices.delete(s))})}return this._tunnelServices.get(s).openTunnel(r,i,o,u,p,C,M,D)}};e.SharedTunnelsService=a,e.SharedTunnelsService=a=Ie([ie(0,g.IRemoteSocketFactoryService),ie(1,f.ILogService),ie(2,S.IProductService),ie(3,d.ISignService),ie(4,l.IConfigurationService)],a)}),define(se[101],oe([0,1,8,23,3,18,24,20,5,27,53,50]),function(Q,e,n,R,I,A,k,P,h,l,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=void 0,e.createUpdateURL=b;function b(d,y,w){return`${w.updateUrl}/api/update/${d}/${y}/${w.commit}`}let g=class{get state(){return this._state}setState(y){this.logService.info("update#setState",y.type),this._state=y,this._onStateChange.fire(y)}constructor(y,w,m,c,v,E){this.lifecycleMainService=y,this.configurationService=w,this.environmentMainService=m,this.requestService=c,this.logService=v,this.productService=E,this._state=S.State.Uninitialized,this._onStateChange=new I.Emitter,this.onStateChange=this._onStateChange.event,y.when(3).finally(()=>this.initialize())}async initialize(){if(!this.environmentMainService.isBuilt){this.setState(S.State.Disabled(0));return}if(this.environmentMainService.disableUpdates){this.setState(S.State.Disabled(1)),this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.setState(S.State.Disabled(3)),this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const y=this.configurationService.getValue("update.mode"),w=this.getProductQuality(y);if(!w){this.setState(S.State.Disabled(2)),this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(w),!this.url){this.setState(S.State.Disabled(4)),this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.configurationService.getValue("_update.prss")){const m=new URL(this.url);m.searchParams.set("prss","true"),this.url=m.toString()}if(this.setState(S.State.Idle(this.getUpdateType())),y==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}y==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,m=>this.logService.error(m))}getProductQuality(y){return y==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(y=60*60*1e3){return(0,n.timeout)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(y){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(y)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(y){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(y=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.url)return;if(this.configurationService.getValue("update.mode")==="none")return!1;try{return(await this.requestService.request({url:this.url},R.CancellationToken.None)).res.statusCode===204}catch(w){this.logService.error("update#isLatestVersion(): failed to check for updates"),this.logService.error(w);return}}async _applySpecificUpdate(y){}getUpdateType(){return 1}doQuitAndInstall(){}};e.AbstractUpdateService=g,e.AbstractUpdateService=g=Ie([ie(0,P.ILifecycleMainService),ie(1,A.IConfigurationService),ie(2,k.IEnvironmentMainService),ie(3,f.IRequestService),ie(4,h.ILogService),ie(5,l.IProductService)],g)}),define(se[292],oe([0,1,14,51,3,46,2,18,24,20,5,27,53,28,50,101]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let w=class extends y.AbstractUpdateService{get onRawError(){return I.Event.fromNodeEventEmitter(n.autoUpdater,"error",(c,v)=>v)}get onRawUpdateNotAvailable(){return I.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return I.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get onRawUpdateDownloaded(){return I.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",(c,v,E,a)=>({version:E,productVersion:E,timestamp:a}))}constructor(c,v,E,a,t,s,r){super(c,v,a,t,s,r),this.telemetryService=E,this.disposables=new k.DisposableStore,c.setRelaunchHandler(this)}handleRelaunch(c){return c?.addArgs||c?.removeArgs||this.state.type!=="ready"?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(c){this.telemetryService.publicLog2("update:error",{messageHash:String((0,A.hash)(String(c)))}),this.logService.error("UpdateService error:",c);const v=this.state.type==="checking for updates"&&this.state.explicit?c:void 0;this.setState(d.State.Idle(1,v))}buildUpdateFeedUrl(c){let v;this.productService.darwinUniversalAssetId?v=this.productService.darwinUniversalAssetId:v=process.arch==="x64"?"darwin":"darwin-arm64";const E=(0,y.createUpdateURL)(v,c,this.productService);try{n.autoUpdater.setFeedURL({url:E})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return E}doCheckForUpdates(c){this.setState(d.State.CheckingForUpdates(c)),n.autoUpdater.checkForUpdates()}onUpdateAvailable(){this.state.type==="checking for updates"&&this.setState(d.State.Downloading)}onUpdateDownloaded(c){this.state.type==="downloading"&&(this.setState(d.State.Downloaded(c)),this.telemetryService.publicLog2("update:downloaded",{version:c.version}),this.setState(d.State.Ready(c)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(d.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};e.DarwinUpdateService=w,Ie([R.memoize],w.prototype,"onRawError",null),Ie([R.memoize],w.prototype,"onRawUpdateNotAvailable",null),Ie([R.memoize],w.prototype,"onRawUpdateAvailable",null),Ie([R.memoize],w.prototype,"onRawUpdateDownloaded",null),e.DarwinUpdateService=w=Ie([ie(0,l.ILifecycleMainService),ie(1,P.IConfigurationService),ie(2,g.ITelemetryService),ie(3,h.IEnvironmentMainService),ie(4,b.IRequestService),ie(5,f.ILogService),ie(6,S.IProductService)],w)}),define(se[293],oe([0,1,49,43,8,3,9,24,20,5,28,50]),function(Q,e,n,R,I,A,k,P,h,l,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let b=class{get state(){return this._state}setState(y){this.logService.info("update#setState",y.type),this._state=y,this._onStateChange.fire(y)}constructor(y,w,m){if(this.lifecycleMainService=y,this.logService=m,this._state=S.State.Uninitialized,this._onStateChange=new A.Emitter,this.onStateChange=this._onStateChange.event,w.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(S.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,c=>this.logService.error(c))}scheduleCheckForUpdates(y=60*60*1e3){return(0,I.timeout)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(y){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(y)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(y){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(y=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(y){}};b=Ie([ie(0,h.ILifecycleMainService),ie(1,P.IEnvironmentMainService),ie(2,l.ILogService)],b);let g=class extends b{constructor(y,w,m,c,v,E){super(m,c,v),this.snap=y,this.snapRevision=w,this.telemetryService=E;const a=(0,R.watch)(k.dirname(this.snap)),t=A.Event.fromNodeEventEmitter(a,"change",(o,u)=>u),s=A.Event.filter(t,o=>o==="current"),i=A.Event.debounce(s,(o,u)=>u,2e3)(()=>this.checkForUpdates(!1));m.onWillShutdown(()=>{i.dispose(),a.close()})}doCheckForUpdates(){this.setState(S.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(y=>{y?this.setState(S.State.Ready({version:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2)))},y=>{this.logService.error(y),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2,y.message||y))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+k.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const y=await new Promise((m,c)=>(0,R.realpath)(`${k.dirname(this.snap)}/current`,(v,E)=>v?c(v):m(E))),w=k.basename(y);return this.snapRevision!==w}isLatestVersion(){return this.isUpdateAvailable().then(void 0,y=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.SnapUpdateService=g,e.SnapUpdateService=g=Ie([ie(2,h.ILifecycleMainService),ie(3,P.IEnvironmentMainService),ie(4,l.ILogService),ie(5,f.ITelemetryService)],g)}),define(se[29],oe([0,1,14,4,6,82,55,69,27,18,24,9,138]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.IWindowsMainService=void 0,e.defaultBrowserWindowOptions=d,e.getLastFocused=y,e.IWindowsMainService=(0,I.createDecorator)("windowsMainService");var g;(function(m){m[m.CLI=0]="CLI",m[m.DOCK=1]="DOCK",m[m.MENU=2]="MENU",m[m.DIALOG=3]="DIALOG",m[m.DESKTOP=4]="DESKTOP",m[m.API=5]="API"})(g||(e.OpenContext=g={}));function d(m,c,v){const E=m.get(P.IThemeMainService),a=m.get(h.IProductService),t=m.get(l.IConfigurationService),s=m.get(f.IEnvironmentMainService),r=t.getValue("window"),i={backgroundColor:E.getBackgroundColor(),minWidth:k.WindowMinimumSize.WIDTH,minHeight:k.WindowMinimumSize.HEIGHT,title:a.nameLong,show:c.mode!==0&&c.mode!==3,x:c.x,y:c.y,width:c.width,height:c.height,webPreferences:{...v,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,k.zoomLevelToZoomFactor)(c.zoomLevel??r?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(R.isLinux?i.icon=(0,S.join)(s.appRoot,"resources/linux/code.png"):R.isWindows&&!s.isBuilt&&(i.icon=(0,S.join)(s.appRoot,"resources/win32/code_150x150.png")),R.isMacintosh&&(i.acceptFirstMouse=!0,r?.clickThroughInactive===!1&&(i.acceptFirstMouse=!1)),R.isMacintosh&&!(0,k.useNativeFullScreen)(t)&&(i.fullscreenable=!1),R.isMacintosh&&r?.nativeTabs===!0&&(i.tabbingIdentifier=a.nameShort),!(0,k.hasNativeTitlebar)(t)&&(i.titleBarStyle="hidden",R.isMacintosh||(i.frame=!1),(0,k.useWindowControlsOverlay)(t))){const p=E.getWindowSplash()?.colorInfo.titleBarBackground??E.getBackgroundColor(),C=b.Color.fromHex(p).isDarker()?"#FFFFFF":"#000000";i.titleBarOverlay={height:29,color:p,symbolColor:C}}return i}function y(m){let c,v=Number.MIN_VALUE;for(const E of m)E.lastFocusTime>v&&(v=E.lastFocusTime,c=E);return c}var w;(function(m){function c(E,a,t=n.screen.getAllDisplays()){if(E.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,a),typeof a.x!="number"||typeof a.y!="number"||typeof a.width!="number"||typeof a.height!="number"){E.trace("window#validateWindowState: unexpected type of state values");return}if(a.width<=0||a.height<=0){E.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const i=v(t[0]);if(E.trace("window#validateWindowState: single monitor working area",i),i){let o=function(){!a||typeof a.x!="number"||typeof a.y!="number"||!i||(a.x<i.x&&(a.x=i.x),a.y<i.y&&(a.y=i.y))};o(),a.width>i.width&&(a.width=i.width),a.height>i.height&&(a.height=i.height),a.x>i.x+i.width-128&&(a.x=i.x+i.width-a.width),a.y>i.y+i.height-128&&(a.y=i.y+i.height-a.height),o()}return a}if(a.display&&a.mode===3){const i=t.find(o=>o.id===a.display);if(i&&typeof i.bounds?.x=="number"&&typeof i.bounds?.y=="number"){E.trace("window#validateWindowState: restoring fullscreen to previous display");const o=(0,A.defaultWindowState)(3);return o.x=i.bounds.x,o.y=i.bounds.y,o}}let s,r;try{s=n.screen.getDisplayMatching({x:a.x,y:a.y,width:a.width,height:a.height}),r=v(s),E.trace("window#validateWindowState: multi-monitor working area",r)}catch(i){E.error("window#validateWindowState: error finding display for window state",i)}if(s&&r&&a.x+a.width>r.x&&a.y+a.height>r.y&&a.x<r.x+r.width&&a.y<r.y+r.height)return a;E.trace("window#validateWindowState: state is outside of the multi-monitor working area")}m.validateWindowState=c;function v(E){if(E.workArea.width>0&&E.workArea.height>0)return E.workArea;if(E.bounds.width>0&&E.bounds.height>0)return E.bounds}})(w||(e.WindowStateValidator=w={}))}),define(se[294],oe([0,1,14,23,3,46,2,33,120,5,84,29]),function(Q,e,n,R,I,A,k,P,h,l,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var b;(function(d){d[d.Initial=1]="Initial",d[d.StoredCredentialsUsed=2]="StoredCredentialsUsed",d[d.LoginDialogShown=3]="LoginDialogShown"})(b||(b={}));let g=class extends k.Disposable{constructor(y,w,m,c){super(),this.logService=y,this.windowsMainService=w,this.encryptionMainService=m,this.applicationStorageMainService=c,this.PROXY_CREDENTIALS_SERVICE_KEY="proxy-credentials://",this.pendingProxyResolve=void 0,this.state=b.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const y=I.Event.fromNodeEventEmitter(n.app,"login",(w,m,c,v,E)=>({event:w,webContents:m,req:c,authInfo:v,callback:E}));this._register(y(this.onLogin,this))}async onLogin({event:y,authInfo:w,req:m,callback:c}){if(!w.isProxy)return;if(!this.pendingProxyResolve&&this.state===b.LoginDialogShown&&m.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}y.preventDefault();let v;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),v=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(w);try{v=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}c(v?.username,v?.password)}async resolveProxyCredentials(y){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.doResolveProxyCredentials(y);if(w)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(y){this.logService.trace("auth#doResolveProxyCredentials - enter",y);const w=String((0,A.hash)({scheme:y.scheme,host:y.host,port:y.port}));let m,c;try{const t=this.applicationStorageMainService.get(this.PROXY_CREDENTIALS_SERVICE_KEY+w,-1);if(t){const s=JSON.parse(await this.encryptionMainService.decrypt(t));m=s.username,c=s.password}}catch(t){this.logService.error(t)}if(this.state!==b.StoredCredentialsUsed&&typeof m=="string"&&typeof c=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=b.StoredCredentialsUsed,{username:m,password:c};const v=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!v){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${v.id} to handle proxy login`);const E={authInfo:y,username:this.sessionCredentials?.username??m,password:this.sessionCredentials?.password??c,replyChannel:`vscode:proxyAuthResponse:${(0,P.generateUuid)()}`};v.sendWhenReady("vscode:openProxyAuthenticationDialog",R.CancellationToken.None,E),this.state=b.LoginDialogShown;const a=await new Promise(t=>{const s=async(r,i,o)=>{if(i===E.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${v.id}`),v.win?.webContents.off("ipc-message",s),o){const u={username:o.username,password:o.password};try{if(o.remember){const p=await this.encryptionMainService.encrypt(JSON.stringify(u));this.applicationStorageMainService.store(this.PROXY_CREDENTIALS_SERVICE_KEY+w,p,-1,1)}else this.applicationStorageMainService.remove(this.PROXY_CREDENTIALS_SERVICE_KEY+w,-1)}catch(p){this.logService.error(p)}t({username:u.username,password:u.password})}else t(void 0)};v.win?.webContents.on("ipc-message",s)});return this.sessionCredentials=a,a}};e.ProxyAuthHandler=g,e.ProxyAuthHandler=g=Ie([ie(0,l.ILogService),ie(1,S.IWindowsMainService),ie(2,h.IEncryptionMainService),ie(3,f.IApplicationStorageMainService)],g)}),define(se[295],oe([0,1,14,22,4,7,21,18,64,6,5,131,29]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,l.createDecorator)(e.ID);let g=class{constructor(y,w,m,c){this.logService=y,this.windowsMainService=w,this.urlService=m,this.configurationService=c}async start(y,w){this.logService.trace("Received data from other instance: ",y,w),I.isMacintosh&&n.app.focus({steal:!0});const m=this.parseOpenUrl(y);if(m.length){let c=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const v=(0,R.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));v&&(c=v.ready())}c.then(()=>{for(const{uri:v,originalUrl:E}of m)this.urlService.open(v,{originalUrl:E})})}else return this.startOpenWindow(y,w)}parseOpenUrl(y){return y["open-url"]&&y._urls&&y._urls.length>0?(0,R.coalesce)(y._urls.map(w=>{try{return{uri:A.URI.parse(w),originalUrl:w}}catch{return null}})):[]}async startOpenWindow(y,w){const m=(0,h.isLaunchedFromCli)(w)?0:4;let c=[];const v=y.wait&&y.waitMarkerFilePath?A.URI.file(y.waitMarkerFilePath):void 0,E=y.remote||void 0,a={context:m,cli:y,userEnv:y["preserve-env"]||m===0?w:void 0,waitMarkerFileURI:v,remoteAuthority:E,forceProfile:y.profile,forceTempProfile:y["profile-temp"]};if(y.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(y.extensionDevelopmentPath,a);else if(!y._.length&&!y["folder-uri"]&&!y["file-uri"]){let t=!1;if(y["new-window"]||a.forceProfile||a.forceTempProfile)t=!0;else if(y["reuse-window"])t=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!I.isMacintosh}if(t)c=await this.windowsMainService.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const s=this.windowsMainService.getLastActiveWindow();s?(this.windowsMainService.openExistingWindow(s,a),c=[s]):c=await this.windowsMainService.open({...a,forceEmpty:!0})}}else c=await this.windowsMainService.open({...a,forceNewWindow:y["new-window"],preferNewWindow:!y["reuse-window"]&&!y.wait,forceReuseWindow:y["reuse-window"],diffMode:y.diff,mergeMode:y.merge,addMode:y.add,noRecentEntry:!!y["skip-add-to-recently-opened"],gotoLineMode:y.goto});if(v&&c.length===1&&c[0])return Promise.race([c[0].whenClosedOrLoaded,(0,k.whenDeleted)(v.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};e.LaunchMainService=g,e.LaunchMainService=g=Ie([ie(0,f.ILogService),ie(1,b.IWindowsMainService),ie(2,S.IURLService),ie(3,P.IConfigurationService)],g)}),define(se[296],oe([0,1,2,20,57,30,8,29]),function(Q,e,n,R,I,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let h=class extends n.Disposable{constructor(f,S,b){super(),this.userDataProfilesService=S,this.windowsMainService=b,this._register(f.onWillLoadWindow(g=>{g.reason===2&&this.unsetProfileForWorkspace(g.window)})),this._register(f.onBeforeCloseWindow(g=>this.unsetProfileForWorkspace(g))),this._register(new k.RunOnceScheduler(()=>this.cleanUpEmptyWindowAssociations(),30*1e3)).schedule()}async unsetProfileForWorkspace(f){const S=this.getWorkspace(f),b=this.userDataProfilesService.getProfileForWorkspace(S);b?.isTransient&&(this.userDataProfilesService.unsetWorkspace(S,b.isTransient),b.isTransient&&await this.userDataProfilesService.cleanUpTransientProfiles())}getWorkspace(f){return f.openedWorkspace??(0,A.toWorkspaceIdentifier)(f.backupPath,f.isExtensionDevelopmentHost)}cleanUpEmptyWindowAssociations(){const f=this.userDataProfilesService.getAssociatedEmptyWindows();if(f.length===0)return;const S=this.windowsMainService.getWindows().map(b=>this.getWorkspace(b));for(const b of f)S.some(g=>g.id===b.id)||this.userDataProfilesService.unsetWorkspace(b,!1)}};e.UserDataProfilesHandler=h,e.UserDataProfilesHandler=h=Ie([ie(0,R.ILifecycleMainService),ie(1,I.IUserDataProfilesMainService),ie(2,P.IWindowsMainService)],h)}),define(se[61],oe([0,1,14,2,3,5,316,8,13,29,74,28,20,76,35,4,102]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y,w){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;function c(a){return typeof a.responseWindowId=="number"}let v=class extends R.Disposable{static{m=this}static{this.ID_COUNTER=0}static{this.all=new Map}static getAll(){return Array.from(m.all.values())}constructor(t,s,r){super(),this.logService=t,this.telemetryService=s,this.lifecycleMainService=r,this.id=String(++m.ID_COUNTER),this._onStdout=this._register(new I.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new I.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new I.Emitter),this.onMessage=this._onMessage.event,this._onSpawn=this._register(new I.Emitter),this.onSpawn=this._onSpawn.event,this._onExit=this._register(new I.Emitter),this.onExit=this._onExit.event,this._onCrash=this._register(new I.Emitter),this.onCrash=this._onCrash.event,this.process=void 0,this.processPid=void 0,this.configuration=void 0,this.killed=!1}log(t,s){let r;switch(this.configuration?.correlationId?r=`[UtilityProcess id: ${this.configuration?.correlationId}, type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${t}`,s){case f.default.Error:this.logService.error(r);break;case f.default.Warning:this.logService.warn(r);break;case f.default.Info:this.logService.trace(r);break}}validateCanStart(){return this.process?(this.log("Cannot start utility process because it is already running...",f.default.Error),!1):!0}start(t){const s=this.doStart(t);return s&&t.payload&&this.postMessage(t.payload)&&this.log("payload sent via postMessage()",f.default.Info),s}doStart(t){if(!this.validateCanStart())return!1;this.configuration=t;const s=`${this.configuration.type}-${this.id}`,r=h.FileAccess.asFileUri("bootstrap-fork.js").fsPath,i=this.configuration.args??[],o=this.configuration.execArgv??[],u=this.configuration.allowLoadingUnsignedLibraries,p=this.configuration.forceAllocationsToV8Sandbox,C="pipe",M=this.createEnv(t);return this.log("creating new...",f.default.Info),this.process=n.utilityProcess.fork(r,i,{serviceName:s,env:M,execArgv:o,allowLoadingUnsignedLibraries:u,forceAllocationsToV8Sandbox:p,stdio:C}),this.registerListeners(this.process,this.configuration,s),!0}createEnv(t){const s=t.env?{...t.env}:{...(0,d.deepClone)(process.env)};s.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(s.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),s.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,y.isWindows&&((0,w.isUNCAccessRestrictionsDisabled)()?s.NODE_DISABLE_UNC_ACCESS_CHECKS="1":s.NODE_UNC_HOST_ALLOWLIST=(0,w.getUNCHostAllowlist)().join("\\")),(0,g.removeDangerousEnvVariables)(s);for(const r of Object.keys(s))s[r]=String(s[r]);return s}registerListeners(t,s,r){if(t.stdout){const i=new k.StringDecoder("utf-8");this._register(I.Event.fromNodeEventEmitter(t.stdout,"data")(o=>this._onStdout.fire(typeof o=="string"?o:i.write(o))))}if(t.stderr){const i=new k.StringDecoder("utf-8");this._register(I.Event.fromNodeEventEmitter(t.stderr,"data")(o=>this._onStderr.fire(typeof o=="string"?o:i.write(o))))}this._register(I.Event.fromNodeEventEmitter(t,"message")(i=>this._onMessage.fire(i))),this._register(I.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.processPid=t.pid,typeof t.pid=="number"&&m.all.set(t.pid,{pid:t.pid,name:c(s)?`${s.type} [${s.responseWindowId}]`:s.type}),this.log("successfully created",f.default.Info),this._onSpawn.fire(t.pid)})),this._register(I.Event.fromNodeEventEmitter(t,"exit")(i=>{const o=this.isNormalExit(i)?0:i;this.log(`received exit event with code ${o}`,f.default.Info),this._onExit.fire({pid:this.processPid,code:o,signal:"unknown"}),this.onDidExitOrCrashOrKill()})),this._register(I.Event.fromNodeEventEmitter(n.app,"child-process-gone",(i,o)=>({event:i,details:o}))(({details:i})=>{i.type==="Utility"&&i.name===r&&!this.isNormalExit(i.exitCode)&&(this.log(`crashed with code ${i.exitCode} and reason '${i.reason}'`,f.default.Error),this.telemetryService.publicLog2("utilityprocesscrash",{type:s.type,reason:i.reason,code:i.exitCode}),this._onCrash.fire({pid:this.processPid,code:i.exitCode,reason:i.reason}),this.onDidExitOrCrashOrKill())}))}once(t,s){const r=this._register(this._onMessage.event(i=>{i===t&&(r.dispose(),s())}))}postMessage(t,s){return this.process?(this.process.postMessage(t,s),!0):!1}connect(t){const{port1:s,port2:r}=new n.MessageChannelMain;return this.postMessage(t,[r]),s}enableInspectPort(){if(!this.process||typeof this.processPid!="number")return!1;this.log("enabling inspect port",f.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.processPid),!0):!1}kill(){if(!this.process)return;this.log("attempting to kill the process...",f.default.Info),this.process.kill()?(this.log("successfully killed the process",f.default.Info),this.killed=!0,this.onDidExitOrCrashOrKill()):this.log("unable to kill the process",f.default.Warning)}isNormalExit(t){return t===0?!0:this.killed&&t===15}onDidExitOrCrashOrKill(){typeof this.processPid=="number"&&m.all.delete(this.processPid),this.process=void 0}async waitForExit(t){this.process&&(this.log("waiting to exit...",f.default.Info),await Promise.race([I.Event.toPromise(this.onExit),(0,P.timeout)(t)]),this.process&&(this.log(`did not exit within ${t}ms, will kill it now...`,f.default.Info),this.kill()))}};e.UtilityProcess=v,e.UtilityProcess=v=m=Ie([ie(0,A.ILogService),ie(1,S.ITelemetryService),ie(2,b.ILifecycleMainService)],v);let E=class extends v{constructor(t,s,r,i){super(t,r,i),this.windowsMainService=s}start(t){const s=this.windowsMainService.getWindowById(t.responseWindowId);if(!s?.win||s.win.isDestroyed()||s.win.webContents.isDestroyed())return this.log("Refusing to start utility process because requesting window cannot be found or is destroyed...",f.default.Error),!0;if(!super.doStart(t))return!1;this.registerWindowListeners(s.win,t);const i=this.connect(t.payload);return s.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}registerWindowListeners(t,s){s.windowLifecycleBound&&(this._register(I.Event.filter(this.lifecycleMainService.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this._register(I.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.WindowUtilityProcess=E,e.WindowUtilityProcess=E=Ie([ie(0,A.ILogService),ie(1,l.IWindowsMainService),ie(2,S.ITelemetryService),ie(3,b.ILifecycleMainService)],E)}),define(se[297],oe([0,1,15,3,5,20,8,61,29,28]),function(Q,e,n,R,I,A,k,P,h,l){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let S=class{static{f=this}static{this._lastId=0}constructor(g,d,y,w){this._logService=g,this._lifecycleMainService=d,this._windowsMainService=y,this._telemetryService=w,this._extHosts=new Map,this._shutdown=!1,this._lifecycleMainService.onWillShutdown(m=>{this._shutdown=!0,m.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}_getExtHost(g){const d=this._extHosts.get(g);if(!d)throw new Error("Unknown extension host!");return d}onDynamicStdout(g){return this._getExtHost(g).onStdout}onDynamicStderr(g){return this._getExtHost(g).onStderr}onDynamicMessage(g){return this._getExtHost(g).onMessage}onDynamicExit(g){return this._getExtHost(g).onExit}async createExtensionHost(){if(this._shutdown)throw(0,n.canceled)();const g=String(++f._lastId),d=new P.WindowUtilityProcess(this._logService,this._windowsMainService,this._telemetryService,this._lifecycleMainService);return this._extHosts.set(g,d),d.onExit(({pid:y,code:w,signal:m})=>{this._logService.info(`Extension host with pid ${y} exited with code: ${w}, signal: ${m}.`),setTimeout(()=>{d.dispose(),this._extHosts.delete(g)}),setTimeout(()=>{try{process.kill(y,0),this._logService.error(`Extension host with pid ${y} still exists, forcefully killing it...`),process.kill(y)}catch{}},1e3)}),{id:g}}async start(g,d){if(this._shutdown)throw(0,n.canceled)();const y=this._getExtHost(g);return y.start({...d,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:d.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:g}),{pid:await R.Event.toPromise(y.onSpawn)}}async enableInspectPort(g){if(this._shutdown)throw(0,n.canceled)();const d=this._extHosts.get(g);return d?d.enableInspectPort():!1}async kill(g){if(this._shutdown)throw(0,n.canceled)();const d=this._extHosts.get(g);d&&d.kill()}async _killAllNow(){for(const[,g]of this._extHosts)g.kill()}async _waitForAllExit(g){const d=[];for(const[,y]of this._extHosts)d.push(y.waitForExit(g));return k.Promises.settled(d).then(()=>{})}};e.ExtensionHostStarter=S,e.ExtensionHostStarter=S=f=Ie([ie(0,I.ILogService),ie(1,A.ILifecycleMainService),ie(2,h.IWindowsMainService),ie(3,l.ITelemetryService)],S)}),define(se[298],oe([0,1,37,8,2,24,20,5,41,39,67,61,54,91,12,251]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let w=class extends I.Disposable{constructor(c,v,E,a,t,s,r,i){super(),this.machineId=c,this.sqmId=v,this.environmentMainService=E,this.userDataProfilesService=a,this.lifecycleMainService=t,this.logService=s,this.loggerMainService=r,this.policyService=i,this.firstWindowConnectionBarrier=new R.Barrier,this.utilityProcess=void 0,this.utilityProcessLogListener=void 0,this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){n.validatedIpcMain.on(y.SharedProcessChannelConnection.request,(c,v)=>this.onWindowConnection(c,v,y.SharedProcessChannelConnection.response)),n.validatedIpcMain.on(y.SharedProcessRawConnection.request,(c,v)=>this.onWindowConnection(c,v,y.SharedProcessRawConnection.response)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(c,v,E){this.logService.trace(`[SharedProcess] onWindowConnection for: ${E}`),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect(E);if(c.sender.isDestroyed())return a.close();c.sender.postMessage(E,v,[a])}onWillShutdown(){this.logService.trace("[SharedProcess] onWillShutdown"),this.utilityProcess?.postMessage(y.SharedProcessLifecycle.exit),this.utilityProcess=void 0}whenReady(){return this._whenReady||(this._whenReady=(async()=>{await this.whenIpcReady;const c=new R.DeferredPromise;this.utilityProcess?.once(y.SharedProcessLifecycle.initDone,()=>c.complete()),await c.p,this.utilityProcessLogListener?.dispose(),this.logService.trace("[SharedProcess] Overall ready")})()),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createUtilityProcess();const c=new R.DeferredPromise;this.utilityProcess?.once(y.SharedProcessLifecycle.ipcReady,()=>c.complete()),await c.p,this.logService.trace("[SharedProcess] IPC ready")})()),this._whenIpcReady}createUtilityProcess(){this.utilityProcess=this._register(new S.UtilityProcess(this.logService,b.NullTelemetryService,this.lifecycleMainService)),this.utilityProcessLogListener=this.utilityProcess.onMessage(E=>{typeof E.warning=="string"?this.logService.warn(E.warning):typeof E.error=="string"&&this.logService.error(E.error)});const c=(0,g.parseSharedProcessDebugPort)(this.environmentMainService.args,this.environmentMainService.isBuilt);let v;c.port&&(v=["--nolazy"],c.break?v.push(`--inspect-brk=${c.port}`):v.push(`--inspect=${c.port}`)),this.utilityProcess.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.createSharedProcessConfiguration(),execArgv:v})}createSharedProcessConfiguration(){return{machineId:this.machineId,sqmId:this.sqmId,codeCachePath:this.environmentMainService.codeCachePath,profiles:{home:this.userDataProfilesService.profilesHome,all:this.userDataProfilesService.profiles},args:this.environmentMainService.args,logLevel:this.loggerMainService.getLogLevel(),loggers:this.loggerMainService.getRegisteredLoggers(),policiesData:this.policyService.serialize()}}async connect(c){return await this.whenIpcReady,(0,d.assertIsDefined)(this.utilityProcess).connect(c)}};e.SharedProcess=w,e.SharedProcess=w=Ie([ie(2,A.IEnvironmentMainService),ie(3,h.IUserDataProfilesService),ie(4,k.ILifecycleMainService),ie(5,P.ILogService),ie(6,f.ILoggerMainService),ie(7,l.IPolicyService)],w)}),define(se[299],oe([0,1,24,91,20,5,54,61,114,37,2,3,35,18,13]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronPtyHostStarter=void 0;let y=class extends f.Disposable{constructor(m,c,v,E,a){super(),this._reconnectConstants=m,this._configurationService=c,this._environmentMainService=v,this._lifecycleMainService=E,this._logService=a,this.utilityProcess=void 0,this._onRequestConnection=new S.Emitter,this.onRequestConnection=this._onRequestConnection.event,this._onWillShutdown=new S.Emitter,this.onWillShutdown=this._onWillShutdown.event,this._lifecycleMainService.onWillShutdown(()=>this._onWillShutdown.fire()),l.validatedIpcMain.on("vscode:createPtyHostMessageChannel",(t,s)=>this._onWindowConnection(t,s)),this._register((0,f.toDisposable)(()=>{l.validatedIpcMain.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.utilityProcess=new P.UtilityProcess(this._logService,k.NullTelemetryService,this._lifecycleMainService);const m=(0,R.parsePtyHostDebugPort)(this._environmentMainService.args,this._environmentMainService.isBuilt),c=m.port?["--nolazy",`--inspect${m.break?"-brk":""}=${m.port}`]:void 0;this.utilityProcess.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:c,args:["--logsPath",this._environmentMainService.logsHome.with({scheme:d.Schemas.file}).fsPath],env:this._createPtyHostConfiguration()});const v=this.utilityProcess.connect(),E=new h.Client(v,"ptyHost"),a=new f.DisposableStore;return a.add(E),a.add((0,f.toDisposable)(()=>{this.utilityProcess?.kill(),this.utilityProcess?.dispose(),this.utilityProcess=void 0})),{client:E,store:a,onDidProcessExit:this.utilityProcess.onExit}}_createPtyHostConfiguration(){this._environmentMainService.unsetSnapExportedVariables();const m={...(0,b.deepClone)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this._reconnectConstants.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this._reconnectConstants.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this._reconnectConstants.scrollback)},c=this._configurationService.getValue("terminal.integrated.developer.ptyHost.latency");c&&typeof c=="number"&&(m.VSCODE_LATENCY=String(c));const v=this._configurationService.getValue("terminal.integrated.developer.ptyHost.startupDelay");return v&&typeof v=="number"&&(m.VSCODE_STARTUP_DELAY=String(v)),this._environmentMainService.restoreSnapExportedVariables(),m}_onWindowConnection(m,c){this._onRequestConnection.fire();const v=this.utilityProcess.connect();if(m.sender.isDestroyed()){v.close();return}m.sender.postMessage("vscode:createPtyHostMessageChannelResult",c,[v])}};e.ElectronPtyHostStarter=y,e.ElectronPtyHostStarter=y=Ie([ie(1,g.IConfigurationService),ie(2,n.IEnvironmentMainService),ie(3,I.ILifecycleMainService),ie(4,A.ILogService)],y)}),define(se[300],oe([0,1,2,6,5,29,61,28,46,3,8,20]),function(Q,e,n,R,I,A,k,P,h,l,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,R.createDecorator)("utilityProcessWorker");let b=class extends n.Disposable{constructor(y,w,m,c){super(),this.logService=y,this.windowsMainService=w,this.telemetryService=m,this.lifecycleMainService=c,this.workers=new Map}async createWorker(y){const w=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.logService.trace(`[UtilityProcessWorker]: createWorker(${w})`);const m=this.hash(y);this.workers.has(m)&&(this.logService.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${w})`),this.disposeWorker(y));const c=new g(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService,y);if(!c.spawn())return{reason:{code:1,signal:"EINVALID"}};this.workers.set(m,c);const v=new f.DeferredPromise;return l.Event.once(c.onDidTerminate)(E=>{E.code===0?this.logService.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.logService.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.workers.delete(m),v.complete({reason:E})}),v.p}hash(y){return(0,h.hash)({moduleId:y.process.moduleId,windowId:y.reply.windowId})}async disposeWorker(y){const w=this.hash(y),m=this.workers.get(w);m&&(this.logService.trace(`[UtilityProcessWorker]: disposeWorker(window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),m.kill(),this.workers.delete(w))}};e.UtilityProcessWorkerMainService=b,e.UtilityProcessWorkerMainService=b=Ie([ie(0,I.ILogService),ie(1,A.IWindowsMainService),ie(2,P.ITelemetryService),ie(3,S.ILifecycleMainService)],b);let g=class extends n.Disposable{constructor(y,w,m,c,v){super(),this.logService=y,this.windowsMainService=w,this.telemetryService=m,this.lifecycleMainService=c,this.configuration=v,this._onDidTerminate=this._register(new l.Emitter),this.onDidTerminate=this._onDidTerminate.event,this.utilityProcess=new k.WindowUtilityProcess(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService),this.registerListeners()}registerListeners(){this._register(this.utilityProcess.onExit(y=>this._onDidTerminate.fire({code:y.code,signal:y.signal}))),this._register(this.utilityProcess.onCrash(y=>this._onDidTerminate.fire({code:y.code,signal:"ECRASH"})))}spawn(){const w=this.windowsMainService.getWindowById(this.configuration.reply.windowId)?.win?.webContents.getOSProcessId();return this.utilityProcess.start({type:this.configuration.process.type,entryPoint:this.configuration.process.moduleId,parentLifecycleBound:w,windowLifecycleBound:!0,correlationId:`${this.configuration.reply.windowId}`,responseWindowId:this.configuration.reply.windowId,responseChannel:this.configuration.reply.channel,responseNonce:this.configuration.reply.nonce})}kill(){this.utilityProcess.kill()}};g=Ie([ie(0,I.ILogService),ie(1,A.IWindowsMainService),ie(2,P.ITelemetryService),ie(3,S.ILifecycleMainService)],g)}),define(se[301],oe([0,1,14,3,2,277,29]),function(Q,e,n,R,I,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let P=class extends I.Disposable{constructor(l){super(),this.windowsMainService=l,this._onFoundInFrame=this._register(new R.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new A.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(l,f){let S;if(typeof l.windowId=="number"){const{windowId:b}=l,g=this.windowsMainService.getWindowById(b);if(!g?.win)throw new Error(`Invalid windowId: ${b}`);S=g.win.webContents}else{const{webContentsId:b}=l;if(S=n.webContents.fromId(b),!S)throw new Error(`Invalid webContentsId: ${b}`)}S.isDestroyed()||S.setIgnoreMenuShortcuts(f)}async findInFrame(l,f,S,b){const d=this.getFrameByName(l,f);if(typeof d.findInFrame=="function"){d.findInFrame(S,{findNext:b.findNext,forward:b.forward});const y=(w,m)=>{m.finalUpdate&&(this._onFoundInFrame.fire(m),d.removeListener("found-in-frame",y))};d.on("found-in-frame",y)}}async stopFindInFrame(l,f,S){const g=this.getFrameByName(l,f);typeof g.stopFindInFrame=="function"&&g.stopFindInFrame(S.keepSelection?"keepSelection":"clearSelection")}getFrameByName(l,f){const S=this.windowsMainService.getWindowById(l.windowId);if(!S?.win)throw new Error(`Invalid windowId: ${l}`);const b=S.win.webContents.mainFrame.framesInSubtree.find(g=>g.name===f);if(!b)throw new Error(`Unknown frame: ${f}`);return b}};e.WebviewMainService=P,e.WebviewMainService=P=Ie([ie(0,k.IWindowsMainService)],P)}),define(se[302],oe([0,1,14,2,4,19,7,18,20,5,34,29,82,30]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsStateHandler=void 0,e.restoreWindowsState=w,e.getWindowsStateStoreData=c;let y=class extends R.Disposable{static{d=this}static{this.windowsStateStorageKey="windowsState"}get state(){return this._state}constructor(a,t,s,r,i){super(),this.windowsMainService=a,this.stateService=t,this.lifecycleMainService=s,this.logService=r,this.configurationService=i,this._state=w(this.stateService.getItem(d.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){n.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(a=>this.onBeforeCloseWindow(a)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(a=>{a.newCount-a.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(a=>this.onBeforeCloseWindow(a))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const a=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!t.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(o=>!o.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.toWindowState(i),t.lastActiveWindow.uiState.mode===3&&a.add(t.lastActiveWindow.uiState.display))}const s=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);s&&(t.lastPluginDevelopmentHostWindow=this.toWindowState(s),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(a.has(t.lastPluginDevelopmentHostWindow.uiState.display)?I.isMacintosh&&!s.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):a.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(t.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const o=this.toWindowState(i);return o.uiState.mode===3&&(a.has(o.uiState.display)?I.isMacintosh&&o.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(o.uiState.mode=1):a.add(o.uiState.display)),o}));const r=c(t);this.stateService.setItem(d.windowsStateStorageKey,r),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",r)}onBeforeCloseWindow(a){if(this.lifecycleMainService.quitRequested)return;const t=this.toWindowState(a);a.isExtensionDevelopmentHost&&!a.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=t:!a.isExtensionDevelopmentHost&&a.openedWorkspace&&this._state.openedWindows.forEach(s=>{const r=(0,g.isWorkspaceIdentifier)(a.openedWorkspace)&&s.workspace?.id===a.openedWorkspace.id,i=(0,g.isSingleFolderWorkspaceIdentifier)(a.openedWorkspace)&&s.folderUri&&A.extUriBiasedIgnorePathCase.isEqual(s.folderUri,a.openedWorkspace.uri);(r||i)&&(s.uiState=t.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=t)}toWindowState(a){return{windowId:a.id,workspace:(0,g.isWorkspaceIdentifier)(a.openedWorkspace)?a.openedWorkspace:void 0,folderUri:(0,g.isSingleFolderWorkspaceIdentifier)(a.openedWorkspace)?a.openedWorkspace.uri:void 0,backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.serializeWindowState()}}getNewWindowState(a){const t=this.doGetNewWindowState(a),s=this.configurationService.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(s?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(s.newWindowDimensions)>=0):r=!!(this.lifecycleMainService.wasRestarted||s?.restoreFullscreen),r||(t.mode=1)}return t}doGetNewWindowState(a){const t=this.windowsMainService.getLastActiveWindow();if(!a.extensionTestsPath){if(a.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const p=a.workspace;if((0,g.isWorkspaceIdentifier)(p)){const M=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===p.id).map(D=>D.uiState);if(M.length)return M[0]}if((0,g.isSingleFolderWorkspaceIdentifier)(p)){const M=this.state.openedWindows.filter(D=>D.folderUri&&A.extUriBiasedIgnorePathCase.isEqual(D.folderUri,p.uri)).map(D=>D.uiState);if(M.length)return M[0]}else if(a.backupPath){const M=this.state.openedWindows.filter(D=>D.backupPath===a.backupPath).map(D=>D.uiState);if(M.length)return M[0]}const C=this.lastClosedState||this.state.lastActiveWindow;if(!t&&C)return C.uiState}let s;const r=n.screen.getAllDisplays();if(r.length===1)s=r[0];else{if(I.isMacintosh){const p=n.screen.getCursorScreenPoint();s=n.screen.getDisplayNearestPoint(p)}!s&&t&&(s=n.screen.getDisplayMatching(t.getBounds())),s||(s=n.screen.getPrimaryDisplay()||r[0])}let i=(0,b.defaultWindowState)();i.x=Math.round(s.bounds.x+s.bounds.width/2-i.width/2),i.y=Math.round(s.bounds.y+s.bounds.height/2-i.height/2);const o=this.configurationService.getValue("window");let u=!0;if(o?.newWindowDimensions){if(o.newWindowDimensions==="maximized")i.mode=0,u=!1;else if(o.newWindowDimensions==="fullscreen")i.mode=3,u=!1;else if((o.newWindowDimensions==="inherit"||o.newWindowDimensions==="offset")&&t){const p=t.serializeWindowState();p.mode===3?i.mode=3:i={...p,zoomLevel:void 0},u=i.mode!==3&&o.newWindowDimensions==="offset"}}return u&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(a){if(this.windowsMainService.getWindows().length===0)return a;a.x=typeof a.x=="number"?a.x:0,a.y=typeof a.y=="number"?a.y:0;const t=this.windowsMainService.getWindows().map(s=>s.getBounds());for(;t.some(s=>s.x===a.x||s.y===a.y);)a.x+=30,a.y+=30;return a}};e.WindowsStateHandler=y,e.WindowsStateHandler=y=d=Ie([ie(0,S.IWindowsMainService),ie(1,f.IStateService),ie(2,h.ILifecycleMainService),ie(3,l.ILogService),ie(4,P.IConfigurationService)],y);function w(E){const a={openedWindows:[]},t=E||{openedWindows:[]};return t.lastActiveWindow&&(a.lastActiveWindow=m(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(a.lastPluginDevelopmentHostWindow=m(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(a.openedWindows=t.openedWindows.map(s=>m(s))),a}function m(E){const a={uiState:E.uiState};return E.backupPath&&(a.backupPath=E.backupPath),E.remoteAuthority&&(a.remoteAuthority=E.remoteAuthority),E.folder&&(a.folderUri=k.URI.parse(E.folder)),E.workspaceIdentifier&&(a.workspace={id:E.workspaceIdentifier.id,configPath:k.URI.parse(E.workspaceIdentifier.configURIPath)}),a}function c(E){return{lastActiveWindow:E.lastActiveWindow&&v(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&v(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(a=>v(a))}}function v(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}}),define(se[58],oe([0,1,14,3,42,2,13,9,19,21,197,65,56,24,6,5,57,133,30,98,99]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y,w,m,c,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,d.createDecorator)("workspacesManagementMainService");let a=class extends A.Disposable{constructor(s,r,i,o,u){super(),this.environmentMainService=s,this.logService=r,this.userDataProfilesMainService=i,this.backupMainService=o,this.dialogMainService=u,this._onDidDeleteUntitledWorkspace=this._register(new R.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new R.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const s=(await l.Promises.readdir(this.untitledWorkspacesHome.with({scheme:k.Schemas.file}).fsPath)).map(r=>(0,h.joinPath)(this.untitledWorkspacesHome,r,c.UNTITLED_WORKSPACE_NAME));for(const r of s){const i=(0,E.getWorkspaceIdentifier)(r),o=await this.resolveLocalWorkspace(r);o?this.untitledWorkspaces.push({workspace:i,remoteAuthority:o.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(s){s.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${s}).`)}}resolveLocalWorkspace(s){return this.doResolveLocalWorkspace(s,r=>l.Promises.readFile(r,"utf8"))}doResolveLocalWorkspace(s,r){if(this.isWorkspacePath(s)&&s.scheme===k.Schemas.file)try{const i=r(s.fsPath);return i instanceof Promise?i.then(o=>this.doResolveWorkspace(s,o),o=>{}):this.doResolveWorkspace(s,i)}catch{return}}isWorkspacePath(s){return(0,c.isUntitledWorkspace)(s,this.environmentMainService)||(0,c.hasWorkspaceFileExtension)(s)}doResolveWorkspace(s,r){try{const i=this.doParseStoredWorkspace(s,r),o=(0,E.getWorkspaceIdentifier)(s);return{id:o.id,configPath:o.configPath,folders:(0,v.toWorkspaceFolders)(i.folders,o.configPath,h.extUriBiasedIgnorePathCase),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.logService.warn(i.toString())}}doParseStoredWorkspace(s,r){const i=(0,I.parse)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(o=>(0,v.isStoredWorkspaceFolder)(o));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(s,r){const{workspace:i,storedWorkspace:o}=this.newUntitledWorkspace(s,r),u=i.configPath.fsPath;return await l.Promises.mkdir((0,P.dirname)(u),{recursive:!0}),await l.Promises.writeFile(u,JSON.stringify(o,null,"	")),this.untitledWorkspaces.push({workspace:i,remoteAuthority:r}),i}newUntitledWorkspace(s=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),o=(0,h.joinPath)(this.untitledWorkspacesHome,i),u=(0,h.joinPath)(o,c.UNTITLED_WORKSPACE_NAME),p=[];for(const C of s)p.push((0,v.getStoredWorkspaceFolder)(C.uri,!0,C.name,o,h.extUriBiasedIgnorePathCase));return{workspace:(0,E.getWorkspaceIdentifier)(u),storedWorkspace:{folders:p,remoteAuthority:r}}}async getWorkspaceIdentifier(s){return(0,E.getWorkspaceIdentifier)(s)}isUntitledWorkspace(s){return(0,c.isUntitledWorkspace)(s.configPath,this.environmentMainService)}async deleteUntitledWorkspace(s){this.isUntitledWorkspace(s)&&(await this.doDeleteUntitledWorkspace(s),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(s),this._onDidDeleteUntitledWorkspace.fire(s))}async doDeleteUntitledWorkspace(s){const r=(0,h.originalFSPath)(s.configPath);try{await l.Promises.rm((0,P.dirname)(r));const i=(0,P.join)(this.environmentMainService.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath,s.id);await l.Promises.exists(i)&&await l.Promises.writeFile((0,P.join)(i,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(o=>o.workspace.id!==s.id)}catch(i){this.logService.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(s,r,i){if(!s||!s.win||!s.isReady||!await this.isValidTargetWorkspacePath(s,r,i))return;const u=await this.doEnterWorkspace(s,(0,E.getWorkspaceIdentifier)(i));if(u)return this._onDidEnterWorkspace.fire({window:s,workspace:u.workspace}),u}async isValidTargetWorkspacePath(s,r,i){return i?(0,c.isWorkspaceIdentifier)(s.openedWorkspace)&&h.extUriBiasedIgnorePathCase.isEqual(s.openedWorkspace.configPath,i)?!1:(0,m.findWindowOnWorkspaceOrFolder)(r,i)?(await this.dialogMainService.showMessageBox({type:"info",buttons:[(0,f.localize)(0,null)],message:(0,f.localize)(1,null,(0,h.basename)(i)),detail:(0,f.localize)(2,null)},n.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async doEnterWorkspace(s,r){if(!s.config)return;s.focus();let i;return s.config.extensionDevelopmentPath||(s.config.backupPath?i=await this.backupMainService.registerWorkspaceBackup({workspace:r,remoteAuthority:s.remoteAuthority},s.config.backupPath):i=this.backupMainService.registerWorkspaceBackup({workspace:r,remoteAuthority:s.remoteAuthority})),(0,c.isWorkspaceIdentifier)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&await this.deleteUntitledWorkspace(s.openedWorkspace),s.config.workspace=r,s.config.backupPath=i,{workspace:r,backupPath:i}}};e.WorkspacesManagementMainService=a,e.WorkspacesManagementMainService=a=Ie([ie(0,g.IEnvironmentMainService),ie(1,y.ILogService),ie(2,w.IUserDataProfilesMainService),ie(3,S.IBackupMainService),ie(4,b.IDialogMainService)],a)}),define(se[134],oe([0,1,14,37,23,6,29,30,58,12,5,61]),function(Q,e,n,R,I,A,k,P,h,l,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,A.createDecorator)(e.ID);let b=class{constructor(d,y,w){this.windowsMainService=d,this.workspacesManagementMainService=y,this.logService=w}async getRemoteDiagnostics(d){const y=this.windowsMainService.getWindows();return(await Promise.all(y.map(async m=>{const c=m.remoteAuthority;if(!c)return;const v=`vscode:getDiagnosticInfoResponse${m.id}`,E={includeProcesses:d.includeProcesses,folders:d.includeWorkspaceMetadata?await this.getFolderURIs(m):void 0};return new Promise(a=>{m.sendWhenReady("vscode:getDiagnosticInfo",I.CancellationToken.None,{replyChannel:v,args:E}),R.validatedIpcMain.once(v,(t,s)=>{s||a({hostName:c,errorMessage:`Unable to resolve connection to '${c}'.`}),a(s)}),setTimeout(()=>{a({hostName:c,errorMessage:`Connection to '${c}' could not be established`})},5e3)})}))).filter(m=>!!m)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const d=[];for(const w of n.BrowserWindow.getAllWindows()){const m=this.windowsMainService.getWindowById(w.id);m?d.push(await this.codeWindowToInfo(m)):d.push(this.browserWindowToInfo(w))}const y=[];for(const{pid:w,name:m}of S.UtilityProcess.getAll())y.push({pid:w,name:m});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:d,pidToNames:y,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async codeWindowToInfo(d){const y=await this.getFolderURIs(d),w=(0,l.assertIsDefined)(d.win);return this.browserWindowToInfo(w,y,d.remoteAuthority)}browserWindowToInfo(d,y=[],w){return{id:d.id,pid:d.webContents.getOSProcessId(),title:d.getTitle(),folderURIs:y,remoteAuthority:w}}async getFolderURIs(d){const y=[],w=d.openedWorkspace;if((0,P.isSingleFolderWorkspaceIdentifier)(w))y.push(w.uri);else if((0,P.isWorkspaceIdentifier)(w)){const m=await this.workspacesManagementMainService.resolveLocalWorkspace(w.configPath);m&&m.folders.forEach(v=>{y.push(v.uri)})}return y}};e.DiagnosticsMainService=b,e.DiagnosticsMainService=b=Ie([ie(0,k.IWindowsMainService),ie(1,h.IWorkspacesManagementMainService),ie(2,f.ILogService)],b)}),define(se[70],oe([0,1,49,14,26,158,51,3,2,13,9,4,7,109,89,21,107,185,56,24,6,20,5,27,69,29,30,58,17,247,239,79,15]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y,w,m,c,v,E,a,t,s,r,i,o,u,p,C,M,D,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,E.createDecorator)("nativeHostMainService");let O=class extends h.Disposable{constructor(F,x,z,ue,ee,le,Y,G,B){super(),this.windowsMainService=F,this.auxiliaryWindowsMainService=x,this.dialogMainService=z,this.lifecycleMainService=ue,this.environmentMainService=ee,this.logService=le,this.productService=Y,this.themeMainService=G,this.workspacesManagementMainService=B,this.onDidOpenMainWindow=P.Event.map(this.windowsMainService.onDidOpenWindow,T=>T.id),this.onDidTriggerWindowSystemContextMenu=P.Event.any(P.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:T,x:U,y:$})=>({windowId:T.id,x:U,y:$})),P.Event.map(this.auxiliaryWindowsMainService.onDidTriggerSystemContextMenu,({window:T,x:U,y:$})=>({windowId:T.id,x:U,y:$}))),this.onDidMaximizeWindow=P.Event.any(P.Event.map(this.windowsMainService.onDidMaximizeWindow,T=>T.id),P.Event.map(this.auxiliaryWindowsMainService.onDidMaximizeWindow,T=>T.id)),this.onDidUnmaximizeWindow=P.Event.any(P.Event.map(this.windowsMainService.onDidUnmaximizeWindow,T=>T.id),P.Event.map(this.auxiliaryWindowsMainService.onDidUnmaximizeWindow,T=>T.id)),this.onDidChangeWindowFullScreen=P.Event.any(P.Event.map(this.windowsMainService.onDidChangeFullScreen,T=>({windowId:T.window.id,fullscreen:T.fullscreen})),P.Event.map(this.auxiliaryWindowsMainService.onDidChangeFullScreen,T=>({windowId:T.window.id,fullscreen:T.fullscreen}))),this.onDidBlurMainWindow=P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(T,U)=>U.id),T=>!!this.windowsMainService.getWindowById(T)),this.onDidFocusMainWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),T=>!!T),T=>T.id),P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(T,U)=>U.id),T=>!!this.windowsMainService.getWindowById(T))),this.onDidBlurMainOrAuxiliaryWindow=P.Event.any(this.onDidBlurMainWindow,P.Event.map(P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(T,U)=>this.auxiliaryWindowsMainService.getWindowByWebContents(U.webContents)),T=>!!T),T=>T.id)),this.onDidFocusMainOrAuxiliaryWindow=P.Event.any(this.onDidFocusMainWindow,P.Event.map(P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(T,U)=>this.auxiliaryWindowsMainService.getWindowByWebContents(U.webContents)),T=>!!T),T=>T.id)),this.onDidResumeOS=P.Event.fromNodeEventEmitter(R.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new P.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(R.screen,"display-metrics-changed",(T,U,$)=>$),T=>!(Array.isArray(T)&&T.length===1&&T[0]==="workArea")),P.Event.fromNodeEventEmitter(R.screen,"display-added"),P.Event.fromNodeEventEmitter(R.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(F,x){const z=this.windowsMainService.getWindows().map(ee=>({id:ee.id,workspace:ee.openedWorkspace??(0,o.toWorkspaceIdentifier)(ee.backupPath,ee.isExtensionDevelopmentHost),title:ee.win?.getTitle()??"",filename:ee.getRepresentedFilename(),dirty:ee.isDocumentEdited()})),ue=[];return x.includeAuxiliaryWindows&&ue.push(...this.auxiliaryWindowsMainService.getWindows().map(ee=>({id:ee.id,parentId:ee.parentId,title:ee.win?.getTitle()??"",filename:ee.getRepresentedFilename()}))),[...z,...ue]}async getWindowCount(F){return this.windowsMainService.getWindowCount()}async getActiveWindowId(F){const x=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(x)return x.id}openWindow(F,x,z){return Array.isArray(x)?this.doOpenWindow(F,x,z):this.doOpenEmptyWindow(F,x)}async doOpenWindow(F,x,z=Object.create(null)){x.length>0&&await this.windowsMainService.open({context:5,contextWindowId:F,urisToOpen:x,cli:this.environmentMainService.args,forceNewWindow:z.forceNewWindow,forceReuseWindow:z.forceReuseWindow,preferNewWindow:z.preferNewWindow,diffMode:z.diffMode,mergeMode:z.mergeMode,addMode:z.addMode,gotoLineMode:z.gotoLineMode,noRecentEntry:z.noRecentEntry,waitMarkerFileURI:z.waitMarkerFileURI,remoteAuthority:z.remoteAuthority||void 0,forceProfile:z.forceProfile,forceTempProfile:z.forceTempProfile})}async doOpenEmptyWindow(F,x){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:F},x)}async toggleFullScreen(F,x){this.windowById(x?.targetWindowId,F)?.toggleFullScreen()}async handleTitleDoubleClick(F,x){this.windowById(x?.targetWindowId,F)?.handleTitleDoubleClick()}async getCursorScreenPoint(F){const x=R.screen.getCursorScreenPoint(),z=R.screen.getDisplayNearestPoint(x);return{point:x,display:z.bounds}}async isMaximized(F,x){return this.windowById(x?.targetWindowId,F)?.win?.isMaximized()??!1}async maximizeWindow(F,x){this.windowById(x?.targetWindowId,F)?.win?.maximize()}async unmaximizeWindow(F,x){this.windowById(x?.targetWindowId,F)?.win?.unmaximize()}async minimizeWindow(F,x){this.windowById(x?.targetWindowId,F)?.win?.minimize()}async moveWindowTop(F,x){this.windowById(x?.targetWindowId,F)?.win?.moveTop()}async positionWindow(F,x,z){const ue=this.windowById(z?.targetWindowId,F);if(ue?.win){if(ue.win.isFullScreen()){const ee=P.Event.toPromise(P.Event.once(P.Event.fromNodeEventEmitter(ue.win,"leave-full-screen")));ue.win.setFullScreen(!1),await ee}ue.win.setBounds(x)}}async updateWindowControls(F,x){this.windowById(x?.targetWindowId,F)?.updateWindowControls(x)}async focusWindow(F,x){this.windowById(x?.targetWindowId,F)?.focus({force:x?.force??!1})}async setMinimumSize(F,x,z){const ue=this.codeWindowById(F);if(ue?.win){const[ee,le]=ue.win.getSize(),[Y,G]=ue.win.getMinimumSize(),[B,T]=[x??Y,z??G],[U,$]=[Math.max(ee,B),Math.max(le,T)];(Y!==B||G!==T)&&ue.win.setMinimumSize(B,T),(ee!==U||le!==$)&&ue.win.setSize(U,$)}}async saveWindowSplash(F,x){this.themeMainService.saveWindowSplash(F,x)}async installShellCommand(F){const{source:x,target:z}=await this.getShellCommandLink();try{const{symbolicLink:ue}=await y.SymlinkSupport.stat(x);if(ue&&!ue.dangling){const ee=await(0,g.realpath)(x);if(z===ee)return}await y.Promises.unlink(x)}catch(ue){if(ue.code!=="ENOENT")throw ue}try{await y.Promises.symlink(z,x)}catch(ue){if(ue.code!=="EACCES"&&ue.code!=="ENOENT")throw ue;const{response:ee}=await this.showMessageBox(F,{type:"info",message:(0,m.localize)(0,null,this.productService.nameShort),buttons:[(0,m.localize)(1,null),(0,m.localize)(2,null)]});if(ee===1)throw new W.CancellationError;try{const le=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${z}' '${x}'\\" with administrator privileges"`;await(0,A.promisify)(n.exec)(le)}catch{throw new Error((0,m.localize)(3,null,x))}}}async uninstallShellCommand(F){const{source:x}=await this.getShellCommandLink();try{await y.Promises.unlink(x)}catch(z){switch(z.code){case"EACCES":{const{response:ue}=await this.showMessageBox(F,{type:"info",message:(0,m.localize)(4,null,this.productService.nameShort),buttons:[(0,m.localize)(5,null),(0,m.localize)(6,null)]});if(ue===1)throw new W.CancellationError;try{const ee=`osascript -e "do shell script \\"rm '${x}'\\" with administrator privileges"`;await(0,A.promisify)(n.exec)(ee)}catch{throw new Error((0,m.localize)(7,null,x))}break}case"ENOENT":break;default:throw z}}}async getShellCommandLink(){const F=(0,f.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),x=`/usr/local/bin/${this.productService.applicationName}`;if(!await y.Promises.exists(F))throw new Error((0,m.localize)(8,null,F));return{source:x,target:F}}async showMessageBox(F,x){const z=this.windowById(x?.targetWindowId,F);return this.dialogMainService.showMessageBox(x,z?.win??void 0)}async showSaveDialog(F,x){const z=this.windowById(x?.targetWindowId,F);return this.dialogMainService.showSaveDialog(x,z?.win??void 0)}async showOpenDialog(F,x){const z=this.windowById(x?.targetWindowId,F);return this.dialogMainService.showOpenDialog(x,z?.win??void 0)}async pickFileFolderAndOpen(F,x){const z=await this.dialogMainService.pickFileFolder(x);z&&await this.doOpenPicked(await Promise.all(z.map(async ue=>await y.SymlinkSupport.existsDirectory(ue)?{folderUri:b.URI.file(ue)}:{fileUri:b.URI.file(ue)})),x,F)}async pickFolderAndOpen(F,x){const z=await this.dialogMainService.pickFolder(x);z&&await this.doOpenPicked(z.map(ue=>({folderUri:b.URI.file(ue)})),x,F)}async pickFileAndOpen(F,x){const z=await this.dialogMainService.pickFile(x);z&&await this.doOpenPicked(z.map(ue=>({fileUri:b.URI.file(ue)})),x,F)}async pickWorkspaceAndOpen(F,x){const z=await this.dialogMainService.pickWorkspace(x);z&&await this.doOpenPicked(z.map(ue=>({workspaceUri:b.URI.file(ue)})),x,F)}async doOpenPicked(F,x,z){await this.windowsMainService.open({context:3,contextWindowId:z,cli:this.environmentMainService.args,urisToOpen:F,forceNewWindow:x.forceNewWindow})}async showItemInFolder(F,x){R.shell.showItemInFolder(x)}async setRepresentedFilename(F,x,z){this.windowById(z?.targetWindowId,F)?.setRepresentedFilename(x)}async setDocumentEdited(F,x,z){this.windowById(z?.targetWindowId,F)?.setDocumentEdited(x)}async openExternal(F,x){return this.environmentMainService.unsetSnapExportedVariables(),R.shell.openExternal(x),this.environmentMainService.restoreSnapExportedVariables(),!0}moveItemToTrash(F,x){return R.shell.trashItem(x)}async isAdmin(){let F;return S.isWindows?F=(await new Promise((x,z)=>{Q(["native-is-elevated"],x,z)}))():F=process.getuid?.()===0,F}async writeElevated(F,x,z,ue){const ee=await new Promise((le,Y)=>{Q(["@vscode/sudo-prompt"],le,Y)});return new Promise((le,Y)=>{const G=[`"${this.cliPath}"`];ue?.unlock&&G.push("--file-chmod"),G.push("--file-write",`"${x.fsPath}"`,`"${z.fsPath}"`);const B={name:this.productService.nameLong.replace("-",""),icns:S.isMacintosh&&this.environmentMainService.isBuilt?(0,f.join)((0,f.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ee.exec(G.join(" "),B,(T,U,$)=>{U&&this.logService.trace(`[sudo-prompt] received stdout: ${U}`),$&&this.logService.trace(`[sudo-prompt] received stderr: ${$}`),T?Y(T):le(void 0)})})}async isRunningUnderARM64Translation(){return S.isLinux||S.isWindows?!1:R.app.runningUnderARM64Translation}get cliPath(){return S.isWindows?this.environmentMainService.isBuilt?(0,f.join)((0,f.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,f.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):S.isLinux?this.environmentMainService.isBuilt?(0,f.join)((0,f.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,f.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,f.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,f.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,I.totalmem)(),freemem:(0,I.freemem)(),loadavg:(0,I.loadavg)()}}async getOSProperties(){return{arch:(0,I.arch)(),platform:(0,I.platform)(),release:(0,I.release)(),type:(0,I.type)(),cpus:(0,I.cpus)()}}async getOSVirtualMachineHint(){return d.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return S.isWindows&&(0,C.hasWSLFeatureInstalled)()}async killProcess(F,x,z){process.kill(x,z)}async readClipboardText(F,x){return R.clipboard.readText(x)}async writeClipboardText(F,x,z){return R.clipboard.writeText(x,z)}async readClipboardFindText(F){return R.clipboard.readFindText()}async writeClipboardFindText(F,x){return R.clipboard.writeFindText(x)}async writeClipboardBuffer(F,x,z,ue){return R.clipboard.writeBuffer(x,Buffer.from(z.buffer),ue)}async readClipboardBuffer(F,x){return p.VSBuffer.wrap(R.clipboard.readBuffer(x))}async hasClipboard(F,x,z){return R.clipboard.has(x,z)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){R.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){R.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){R.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){R.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){R.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,x){this.codeWindowById(F)?.updateTouchBar(x)}async notifyReady(F){this.codeWindowById(F)?.setReady()}async relaunch(F,x){return this.lifecycleMainService.relaunch(x)}async reload(F,x){const z=this.codeWindowById(F);if(z){if((0,o.isWorkspaceIdentifier)(z.openedWorkspace)){const ue=z.openedWorkspace.configPath;if(ue.scheme===l.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ue))?.transient)return this.openWindow(z.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(z,x?.disableExtensions!==void 0?{_:[],"disable-extensions":x.disableExtensions}:void 0)}}async closeWindow(F,x){return this.windowById(x?.targetWindowId,F)?.win?.close()}async quit(F){const x=this.windowsMainService.getLastActiveWindow();x?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&x.win?x.win.close():this.lifecycleMainService.quit()}async exit(F,x){await this.lifecycleMainService.kill(x)}async resolveProxy(F,x){return this.codeWindowById(F)?.win?.webContents?.session?.resolveProxy(x)}async loadCertificates(F){return(await new Promise((z,ue)=>{Q(["@vscode/proxy-agent"],z,ue)})).loadSystemCertificates({log:this.logService})}findFreePort(F,x,z,ue,ee=1){return(0,w.findFreePort)(x,z,ue,ee)}async openDevTools(F,x){this.windowById(x?.targetWindowId,F)?.win?.webContents.openDevTools(x?.mode?{mode:x.mode,activate:x.activate}:void 0)}async toggleDevTools(F,x){this.windowById(x?.targetWindowId,F)?.win?.webContents.toggleDevTools()}async profileRenderer(F,x,z){const ue=this.codeWindowById(F);if(!ue||!ue.win)throw new Error;return await new M.WindowProfiler(ue.win,x,this.logService).inspect(z)}async windowsGetStringRegKey(F,x,z,ue){if(!S.isWindows)return;const ee=await new Promise((le,Y)=>{Q(["@vscode/windows-registry"],le,Y)});try{return ee.GetStringRegKey(x,z,ue)}catch{return}}windowById(F,x){return this.codeWindowById(F)??this.auxiliaryWindowById(F)??this.codeWindowById(x)}codeWindowById(F){if(typeof F=="number")return this.windowsMainService.getWindowById(F)}auxiliaryWindowById(F){if(typeof F!="number")return;const x=R.webContents.fromId(F);if(x)return this.auxiliaryWindowsMainService.getWindowByWebContents(x)}};e.NativeHostMainService=O,Ie([k.memoize],O.prototype,"cliPath",null),e.NativeHostMainService=O=Ie([ie(0,i.IWindowsMainService),ie(1,D.IAuxiliaryWindowsMainService),ie(2,c.IDialogMainService),ie(3,a.ILifecycleMainService),ie(4,v.IEnvironmentMainService),ie(5,t.ILogService),ie(6,s.IProductService),ie(7,r.IThemeMainService),ie(8,u.IWorkspacesManagementMainService)],O)}),define(se[303],oe([0,1,14,26,8,23,31,2,13,4,111,37,182,92,134,56,24,5,70,80,27,81,34,61,55,29]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y,w,m,c,v,E,a,t,s,r,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=void 0;const u="issue.processExplorerWindowState";let p=class{static{o=this}static{this.DEFAULT_BACKGROUND_COLOR="#1E1E1E"}constructor(D,W,O,_,F,x,z,ue,ee,le,Y){this.userEnv=D,this.environmentMainService=W,this.logService=O,this.diagnosticsService=_,this.diagnosticsMainService=F,this.dialogMainService=x,this.nativeHostMainService=z,this.protocolMainService=ue,this.productService=ee,this.stateService=le,this.windowsMainService=Y,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){S.validatedIpcMain.on("vscode:listProcesses",async D=>{const W=[];try{W.push({name:(0,b.localize)(0,null),rootProcess:await(0,f.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(_=>{(0,g.isRemoteDiagnosticError)(_)?W.push({name:_.hostName,rootProcess:_}):_.processes&&W.push({name:_.hostName,rootProcess:_.processes})})}catch(O){this.logService.error(`Listing processes failed: ${O}`)}this.safeSend(D,"vscode:listProcessesResponse",W)}),S.validatedIpcMain.on("vscode:workbenchCommand",(D,W)=>{const{id:O,from:_,args:F}=W;let x;switch(_){case"processExplorer":x=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${_}`)}x?.webContents.send("vscode:runAction",{id:O,from:_,args:F})}),S.validatedIpcMain.on("vscode:closeProcessExplorer",D=>{this.processExplorerWindow?.close()}),S.validatedIpcMain.on("vscode:pidToNameRequest",async D=>{const W=await this.diagnosticsMainService.getMainDiagnostics(),O=[];for(const _ of W.windows)O.push([_.pid,`window [${_.id}] (${_.title})`]);for(const{pid:_,name:F}of s.UtilityProcess.getAll())O.push([_,F]);this.safeSend(D,"vscode:pidToNameResponse",O)})}async openReporter(D){if(this.issueReporterWindow)this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow);else if(this.issueReporterParentWindow=n.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow){const W=new P.DisposableStore,O=W.add(this.protocolMainService.createIPCObjectUrl()),_=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(_,O,{backgroundColor:D.styles.backgroundColor,title:(0,b.localize)(1,null),zoomLevel:D.zoomLevel,alwaysOnTop:!1},"issue-reporter"),O.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:D,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,R.type)(),arch:(0,R.arch)(),release:(0,R.release)()},product:v.default}),this.issueReporterWindow.loadURL(h.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,W.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,W.dispose())})}}async openProcessExplorer(D){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=n.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const W=new P.DisposableStore,O=W.add(this.protocolMainService.createIPCObjectUrl()),_=this.stateService.getItem(u,void 0),F=C(_)?_:this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(F,O,{backgroundColor:D.styles.backgroundColor,title:(0,b.localize)(2,null),zoomLevel:D.zoomLevel,alwaysOnTop:!0},"process-explorer"),O.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:D,product:v.default}),this.processExplorerWindow.loadURL(h.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,W.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,W.dispose())});const x=()=>{if(!this.processExplorerWindow)return;const z=this.processExplorerWindow.getSize(),ue=this.processExplorerWindow.getPosition();if(!z||!ue)return;const ee={width:z[0],height:z[1],x:ue[0],y:ue[1]};this.stateService.setItem(u,ee)};this.processExplorerWindow.on("moved",x),this.processExplorerWindow.on("resized",x)}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}async stopTracing(){if(!this.environmentMainService.args.trace)return;const D=await n.contentTracing.stopRecording(`${(0,k.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({type:"info",message:(0,b.localize)(3,null),detail:(0,b.localize)(4,null,D),buttons:[(0,b.localize)(5,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.nativeHostMainService.showItemInFolder(void 0,D)}async getSystemStatus(){const[D,W]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(D,W)}async $getSystemInfo(){const[D,W]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.diagnosticsService.getSystemInfo(D,W)}async $getPerformanceInfo(){try{const[D,W]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(D,W)}catch(D){throw this.logService.warn("issueService#getPerformanceInfo ",D.message),D}}async $reloadWithExtensionsDisabled(){if(this.issueReporterParentWindow)try{await this.nativeHostMainService.reload(this.issueReporterParentWindow.id,{disableExtensions:!0})}catch(D){this.logService.error(D)}}async $showConfirmCloseDialog(){if(this.issueReporterWindow){const{response:D}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,b.localize)(6,null),buttons:[(0,b.localize)(7,null),(0,b.localize)(8,null)]},this.issueReporterWindow);D===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}}async $showClipboardDialog(){if(this.issueReporterWindow){const{response:D}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,b.localize)(9,null),buttons:[(0,b.localize)(10,null),(0,b.localize)(11,null)]},this.issueReporterWindow);return D===0}return!1}issueReporterWindowCheck(){if(!this.issueReporterParentWindow)throw new Error("Issue reporter window not available");const D=this.windowsMainService.getWindowById(this.issueReporterParentWindow.id);if(!D)throw new Error("Window not found");return D}async $sendReporterMenu(D,W){const O=this.issueReporterWindowCheck(),_="vscode:triggerReporterMenu",F=new A.CancellationTokenSource;return O.sendWhenReady(_,F.token,{replyChannel:_,extensionId:D,extensionName:W}),await(0,I.raceTimeout)(new Promise(z=>S.validatedIpcMain.once(`vscode:triggerReporterMenuResponse:${D}`,(ue,ee)=>z(ee))),5e3,()=>{this.logService.error(`Error: Extension ${D} timed out waiting for menu response`),F.cancel()})}async $closeReporter(){this.issueReporterWindow?.close()}async closeProcessExplorer(){this.processExplorerWindow?.close()}focusWindow(D){D.isMinimized()&&D.restore(),D.focus()}safeSend(D,W,...O){D.sender.isDestroyed()||D.sender.send(W,...O)}createBrowserWindow(D,W,O,_){const F=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:D.width,height:D.height,minWidth:300,minHeight:200,x:D.x,y:D.y,title:O.title,backgroundColor:O.backgroundColor||o.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:h.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${W.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,r.zoomLevelToZoomFactor)(O.zoomLevel),sandbox:!0},alwaysOnTop:O.alwaysOnTop,experimentalDarkMode:!0});return F.setMenuBarVisibility(!1),F}getWindowPosition(D,W,O){let _;const F=n.screen.getAllDisplays();if(F.length===1)_=F[0];else{if(l.isMacintosh){const ue=n.screen.getCursorScreenPoint();_=n.screen.getDisplayNearestPoint(ue)}!_&&D&&(_=n.screen.getDisplayMatching(D.getBounds())),_||(_=n.screen.getPrimaryDisplay()||F[0])}const x=_.bounds,z={width:W,height:O,x:x.x+x.width/2-W/2,y:x.y+x.height/2-O/2};return x.width>0&&x.height>0&&(z.x<x.x&&(z.x=x.x),z.y<x.y&&(z.y=x.y),z.x>x.x+x.width&&(z.x=x.x),z.y>x.y+x.height&&(z.y=x.y),z.width>x.width&&(z.width=x.width),z.height>x.height&&(z.height=x.height)),z}};e.IssueMainService=p,e.IssueMainService=p=o=Ie([ie(1,w.IEnvironmentMainService),ie(2,m.ILogService),ie(3,g.IDiagnosticsService),ie(4,d.IDiagnosticsMainService),ie(5,y.IDialogMainService),ie(6,c.INativeHostMainService),ie(7,a.IProtocolMainService),ie(8,E.IProductService),ie(9,t.IStateService),ie(10,i.IWindowsMainService)],p);function C(M){return typeof M!="object"||M===null?!1:"x"in M&&"y"in M&&"width"in M&&"height"in M}}),define(se[304],oe([0,1,23,18,24,20,5,70,27,53,28,50,101]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let g=class extends b.AbstractUpdateService{constructor(y,w,m,c,v,E,a,t){super(y,w,c,v,E,t),this.telemetryService=m,this.nativeHostMainService=a}buildUpdateFeedUrl(y){return(0,b.createUpdateURL)(`linux-${process.arch}`,y,this.productService)}doCheckForUpdates(y){this.url&&(this.setState(S.State.CheckingForUpdates(y)),this.requestService.request({url:this.url},n.CancellationToken.None).then(l.asJson).then(w=>{!w||!w.url||!w.version||!w.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!y}),this.setState(S.State.Idle(1))):this.setState(S.State.AvailableForDownload(w))}).then(void 0,w=>{this.logService.error(w);const m=y?w.message||w:void 0;this.setState(S.State.Idle(1,m))}))}async doDownloadUpdate(y){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):y.update.url&&this.nativeHostMainService.openExternal(void 0,y.update.url),this.setState(S.State.Idle(1))}};e.LinuxUpdateService=g,e.LinuxUpdateService=g=Ie([ie(0,A.ILifecycleMainService),ie(1,R.IConfigurationService),ie(2,f.ITelemetryService),ie(3,I.IEnvironmentMainService),ie(4,l.IRequestService),ie(5,k.ILogService),ie(6,P.INativeHostMainService),ie(7,h.IProductService)],g)}),define(se[305],oe([0,1,49,43,26,8,23,51,46,9,7,146,21,18,24,16,20,5,70,27,53,28,50,101]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y,w,m,c,v,E,a,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(p,C=1e3){for(;!p();)await(0,A.timeout)(C)}let i;function o(){return typeof i>"u"&&(R.existsSync(l.join(l.dirname(process.execPath),"unins000.exe"))?i=0:l.basename(l.normalize(l.join(process.execPath,"..","..")))==="Program Files"?i=3:i=1),i}let u=class extends s.AbstractUpdateService{get cachePath(){const C=l.join((0,I.tmpdir)(),`${this.productService.applicationName}-${this.productService.quality}-${this.productService.target}-${process.arch}`);return b.Promises.mkdir(C,{recursive:!0}).then(()=>C)}constructor(C,M,D,W,O,_,F,x,z){super(C,M,W,O,_,z),this.telemetryService=D,this.fileService=F,this.nativeHostMainService=x,C.setRelaunchHandler(this)}handleRelaunch(C){return C?.addArgs||C?.removeArgs||this.state.type!=="ready"||!this.availableUpdate?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.setState(t.State.Disabled(5)),this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.initialize()}buildUpdateFeedUrl(C){let M=`win32-${process.arch}`;switch(o()){case 1:M+="-archive";break;case 3:M+="-msi";break;default:this.productService.target==="user"?M+="-user":M+="-system"}return(0,s.createUpdateURL)(M,C,this.productService)}doCheckForUpdates(C){this.url&&(this.setState(t.State.CheckingForUpdates(C)),this.requestService.request({url:this.url},k.CancellationToken.None).then(E.asJson).then(M=>{const D=o();return!M||!M.url||!M.version||!M.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!C}),this.setState(t.State.Idle(D)),Promise.resolve(null)):D===1?(this.setState(t.State.AvailableForDownload(M)),Promise.resolve(null)):(this.setState(t.State.Downloading),this.cleanup(M.version).then(()=>this.getUpdatePackagePath(M.version).then(W=>b.Promises.exists(W).then(O=>{if(O)return Promise.resolve(W);const _=`${W}.tmp`;return this.requestService.request({url:M.url},k.CancellationToken.None).then(F=>this.fileService.writeFile(f.URI.file(_),F.stream)).then(M.sha256hash?()=>(0,S.checksum)(_,M.sha256hash):()=>{}).then(()=>b.Promises.rename(_,W,!1)).then(()=>W)})).then(W=>{this.availableUpdate={packagePath:W},this.setState(t.State.Downloaded(M)),this.configurationService.getValue("update.enableWindowsBackgroundUpdates")?this.productService.target==="user"&&this.doApplyUpdate():this.setState(t.State.Ready(M))})))}).then(void 0,M=>{this.telemetryService.publicLog2("update:error",{messageHash:String((0,h.hash)(String(M)))}),this.logService.error(M);const D=C?M.message||M:void 0;this.setState(t.State.Idle(o(),D))}))}async doDownloadUpdate(C){C.update.url&&this.nativeHostMainService.openExternal(void 0,C.update.url),this.setState(t.State.Idle(o()))}async getUpdatePackagePath(C){const M=await this.cachePath;return l.join(M,`CodeSetup-${this.productService.quality}-${C}.exe`)}async cleanup(C=null){const M=C?_=>!new RegExp(`${this.productService.quality}-${C}\\.exe$`).test(_):()=>!0,D=await this.cachePath,O=(await b.Promises.readdir(D)).filter(M).map(async _=>{try{await b.Promises.unlink(l.join(D,_))}catch{}});await Promise.all(O)}async doApplyUpdate(){if(this.state.type!=="downloaded"||!this.availableUpdate)return Promise.resolve(void 0);const C=this.state.update;this.setState(t.State.Updating(C));const M=await this.cachePath;this.availableUpdate.updateFilePath=l.join(M,`CodeSetup-${this.productService.quality}-${C.version}.flag`),await b.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,n.spawn)(this.availableUpdate.packagePath,["/verysilent","/log",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(t.State.Idle(o()))});const W=`${this.productService.win32MutexName}-ready`,O=await new Promise((_,F)=>{Q(["@vscode/windows-mutex"],_,F)});r(()=>O.isActive(W)).then(()=>this.setState(t.State.Ready(C)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.availableUpdate.updateFilePath?R.unlinkSync(this.availableUpdate.updateFilePath):o()==3?(0,n.spawn)("msiexec.exe",["/i",this.availableUpdate.packagePath],{detached:!0,stdio:["ignore","ignore","ignore"]}):(0,n.spawn)(this.availableUpdate.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return o()}async _applySpecificUpdate(C){if(this.state.type!=="idle")return;const M=o()==0&&this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),D={version:"unknown",productVersion:"unknown"};this.setState(t.State.Downloading),this.availableUpdate={packagePath:C},this.setState(t.State.Downloaded(D)),M?this.productService.target==="user"&&this.doApplyUpdate():this.setState(t.State.Ready(D))}};e.Win32UpdateService=u,Ie([P.memoize],u.prototype,"cachePath",null),e.Win32UpdateService=u=Ie([ie(0,w.ILifecycleMainService),ie(1,g.IConfigurationService),ie(2,a.ITelemetryService),ie(3,d.IEnvironmentMainService),ie(4,E.IRequestService),ie(5,m.ILogService),ie(6,y.IFileService),ie(7,c.INativeHostMainService),ie(8,v.IProductService)],u)}),define(se[135],oe([0,1,14,8,23,47,3,2,13,66,4,7,193,26,65,18,56,24,64,16,20,5,27,81,256,84,28,106,69,55,29,30,58,82,39,34,57,67,22,6]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y,w,m,c,v,E,a,t,s,r,i,o,u,p,C,M,D,W,O,_,F,x,z,ue,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=e.BaseWindow=void 0;var le;(function(B){B[B.NONE=0]="NONE",B[B.NAVIGATING=1]="NAVIGATING",B[B.READY=2]="READY"})(le||(le={}));class Y extends P.Disposable{get lastFocusTime(){return this._lastFocusTime}get win(){return this._win}setWin(T){this._win=T,this._register(k.Event.fromNodeEventEmitter(T,"maximize")(()=>this._onDidMaximize.fire())),this._register(k.Event.fromNodeEventEmitter(T,"unmaximize")(()=>this._onDidUnmaximize.fire())),this._register(k.Event.fromNodeEventEmitter(T,"closed")(()=>{this._onDidClose.fire(),this.dispose()})),this._register(k.Event.fromNodeEventEmitter(T,"focus")(()=>{this._lastFocusTime=Date.now()})),this._register(k.Event.fromNodeEventEmitter(this._win,"enter-full-screen")(()=>this._onDidEnterFullScreen.fire())),this._register(k.Event.fromNodeEventEmitter(this._win,"leave-full-screen")(()=>this._onDidLeaveFullScreen.fire()));const U=!(0,C.hasNativeTitlebar)(this.configurationService);if(f.isMacintosh&&U&&T.setSheetOffset((0,f.isBigSurOrNewer)((0,g.release)())?28:22),U&&(f.isWindows&&(0,C.useWindowControlsOverlay)(this.configurationService)||f.isMacintosh)){const $=this.stateService.getItem(Y.windowControlHeightStateStorageKey);$&&this.updateWindowControls({height:$})}f.isWindows&&U&&T.hookWindowMessage(278,()=>{const[ae,V]=T.getPosition(),ce=n.screen.getCursorScreenPoint(),X=ce.x-ae,L=ce.y-V;return!(X>30&&L>=0&&L<=Math.max(T.getBounds().height*.15,35))||(T.setEnabled(!1),T.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:X,y:L})),0}),this.environmentMainService.args["open-devtools"]===!0&&T.webContents.openDevTools(),f.isMacintosh&&(this._register(this.onDidEnterFullScreen(()=>{this.joinNativeFullScreenTransition?.complete(!0)})),this._register(this.onDidLeaveFullScreen(()=>{this.joinNativeFullScreenTransition?.complete(!0)})))}constructor(T,U,$,ae){super(),this.configurationService=T,this.stateService=U,this.environmentMainService=$,this.logService=ae,this._onDidClose=this._register(new k.Emitter),this.onDidClose=this._onDidClose.event,this._onDidMaximize=this._register(new k.Emitter),this.onDidMaximize=this._onDidMaximize.event,this._onDidUnmaximize=this._register(new k.Emitter),this.onDidUnmaximize=this._onDidUnmaximize.event,this._onDidTriggerSystemContextMenu=this._register(new k.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidEnterFullScreen=this._register(new k.Emitter),this.onDidEnterFullScreen=this._onDidEnterFullScreen.event,this._onDidLeaveFullScreen=this._register(new k.Emitter),this.onDidLeaveFullScreen=this._onDidLeaveFullScreen.event,this._lastFocusTime=Date.now(),this._win=null,this.hasWindowControlOverlay=(0,C.useWindowControlsOverlay)(this.configurationService),this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0}applyState(T,U=n.screen.getAllDisplays().length>0){const $=this.configurationService.getValue("window"),ae=f.isMacintosh&&$?.nativeTabs===!0;(f.isMacintosh||f.isWindows)&&U&&(!ae||n.BrowserWindow.getAllWindows().length===1)&&[T.width,T.height,T.x,T.y].every(V=>typeof V=="number")&&this._win?.setBounds({width:T.width,height:T.height,x:T.x,y:T.y}),(T.mode===0||T.mode===3)&&(this._win?.maximize(),T.mode===3&&this.setFullScreen(!0,!0),this._win?.show())}setRepresentedFilename(T){f.isMacintosh?this.win?.setRepresentedFilename(T):this.representedFilename=T}getRepresentedFilename(){return f.isMacintosh?this.win?.getRepresentedFilename():this.representedFilename}setDocumentEdited(T){f.isMacintosh&&this.win?.setDocumentEdited(T),this.documentEdited=T}isDocumentEdited(){return f.isMacintosh?!!this.win?.isDocumentEdited():!!this.documentEdited}focus(T){f.isMacintosh&&T?.force&&n.app.focus({steal:!0});const U=this.win;U&&(U.isMinimized()&&U.restore(),U.focus())}handleTitleDoubleClick(){const T=this.win;if(T)if(f.isMacintosh)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":T.minimize();break;case"None":break;case"Maximize":default:T.isMaximized()?T.unmaximize():T.maximize()}else T.isMaximized()?T.unmaximize():T.maximize()}static{this.windowControlHeightStateStorageKey="windowControlHeight"}updateWindowControls(T){const U=this.win;if(U){if(T.height&&this.stateService.setItem(G.windowControlHeightStateStorageKey,T.height),f.isWindows&&this.hasWindowControlOverlay)U.setTitleBarOverlay({color:T.backgroundColor?.trim()===""?void 0:T.backgroundColor,symbolColor:T.foregroundColor?.trim()===""?void 0:T.foregroundColor,height:T.height?T.height-1:void 0});else if(f.isMacintosh&&T.height!==void 0){const $=(T.height-15)/2;$?U.setWindowButtonPosition({x:$,y:$}):U.setWindowButtonPosition(null)}}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen,!1)}setFullScreen(T,U){(0,C.useNativeFullScreen)(this.configurationService)?this.setNativeFullScreen(T,U):this.setSimpleFullScreen(T)}get isFullScreen(){if(f.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean")return this.transientIsNativeFullScreen;const T=this.win,U=T?.isFullScreen(),$=T?.isSimpleFullScreen();return!!(U||$)}setNativeFullScreen(T,U){const $=this.win;$?.isSimpleFullScreen()&&$?.setSimpleFullScreen(!1),this.doSetNativeFullScreen(T,U)}doSetNativeFullScreen(T,U){if(f.isMacintosh){this.transientIsNativeFullScreen=T;const ae=this.joinNativeFullScreenTransition=new R.DeferredPromise;(async()=>{const V=await Promise.race([ae.p,(0,R.timeout)(1e4).then(()=>!1)]);this.joinNativeFullScreenTransition===ae&&(this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,!V&&T&&U&&this.win&&!this.win.isFullScreen()&&(this.logService.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this._onDidLeaveFullScreen.fire()))})()}this.win?.setFullScreen(T)}setSimpleFullScreen(T){const U=this.win;U?.isFullScreen()&&this.doSetNativeFullScreen(!1,!1),U?.setSimpleFullScreen(T),U?.webContents.focus()}dispose(){super.dispose(),this._win=null}}e.BaseWindow=Y;let G=class extends Y{get id(){return this._id}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){if(!this.config)return;const T=this.userDataProfilesService.profiles.find(U=>U.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&T?T:this.userDataProfilesService.getProfileForWorkspace(this.config.workspace??(0,D.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.userDataProfilesService.defaultProfile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(T,U,$,ae,V,ce,X,L,N,Z,ne,K,H,j,q,re,he,me,pe,ye,Ee){super(Z,ye,ae,U),this.loggerMainService=$,this.policyService=V,this.userDataProfilesService=ce,this.fileService=X,this.applicationStorageMainService=L,this.storageMainService=N,this.themeMainService=ne,this.workspacesManagementMainService=K,this.backupMainService=H,this.telemetryService=j,this.dialogMainService=q,this.lifecycleMainService=re,this.productService=he,this.protocolMainService=me,this.windowsMainService=pe,this._onWillLoad=this._register(new k.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new k.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidDestroy=this._register(new k.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.customZoomLevel=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Pe,We]=this.restoreWindowState(T.state);this.windowState=Pe,this.logService.trace("window#ctor: using window state",Pe);const ve=Ee.invokeFunction(M.defaultBrowserWindowOptions,this.windowState,{preload:h.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none"});(0,l.mark)("code/willCreateCodeBrowserWindow"),this._win=new n.BrowserWindow(ve),(0,l.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.setWin(this._win),this.applyState(this.windowState,We),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(T=>{if(this.isReady)return T(this);this.whenReadyCallbacks.push(T)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(T=>{function U(){$.dispose(),ae.dispose(),T()}const $=this.onDidClose(()=>U()),ae=this.onWillLoad(()=>U())})}registerListeners(){this._register(k.Event.fromNodeEventEmitter(this._win,"unresponsive")(()=>this.onWindowError(1))),this._register(k.Event.fromNodeEventEmitter(this._win.webContents,"render-process-gone",(U,$)=>$)(U=>this.onWindowError(2,{...U}))),this._register(k.Event.fromNodeEventEmitter(this._win.webContents,"did-fail-load",(U,$,ae)=>({exitCode:$,reason:ae}))(({exitCode:U,reason:$})=>this.onWindowError(3,{reason:$,exitCode:U}))),this._register(k.Event.fromNodeEventEmitter(this._win.webContents,"will-prevent-unload")(U=>U.preventDefault())),this._register(k.Event.fromNodeEventEmitter(this._win.webContents,"did-finish-load")(()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)})),this._register(this.onDidMaximize(()=>{this._config&&(this._config.maximized=!0)})),this._register(this.onDidUnmaximize(()=>{this._config&&(this._config.maximized=!1)})),this._register(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",I.CancellationToken.None)})),this._register(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",I.CancellationToken.None)})),this._register(this.configurationService.onDidChangeConfiguration(U=>this.onConfigurationUpdated(U))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(U=>this.onDidDeleteUntitledWorkspace(U)));const T=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:T},async(U,$)=>{const ae=await this.getMarketplaceHeaders();$({cancel:!1,requestHeaders:Object.assign(U.requestHeaders,ae)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,r.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(T,U){switch(T){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:T,reason:U?.reason,code:U?.exitCode}),T){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(T===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const{response:$,checkboxChecked:ae}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,b.localize)(0,null),(0,b.localize)(1,null),(0,b.localize)(2,null)],message:(0,b.localize)(3,null),detail:(0,b.localize)(4,null),checkboxLabel:this._config?.workspace?(0,b.localize)(5,null):void 0},this._win);if($!==2){const V=$===0;await this.destroyWindow(V,ae)}}else if(T===2){let $;U?$=(0,b.localize)(7,null,U.reason,U.exitCode??"<unknown>"):$=(0,b.localize)(6,null);const{response:ae,checkboxChecked:V}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[this._config?.workspace?(0,b.localize)(8,null):(0,b.localize)(9,null),(0,b.localize)(10,null)],message:$,detail:this._config?.workspace?(0,b.localize)(11,null):(0,b.localize)(12,null),checkboxLabel:this._config?.workspace?(0,b.localize)(13,null):void 0},this._win),ce=ae===0;await this.destroyWindow(ce,V)}break}}async destroyWindow(T,U){const $=this._config?.workspace;if(U&&$)try{const ae=this.storageMainService.workspaceStorage($);await ae.init(),ae.delete("memento/workbench.parts.editor"),await ae.close()}catch(ae){this.logService.error(ae)}this._onDidDestroy.fire();try{if(T&&this._config){let ae,V;(0,D.isSingleFolderWorkspaceIdentifier)($)?ae={folderUri:$.uri}:(0,D.isWorkspaceIdentifier)($)?ae={workspaceUri:$.configPath}:V=!0,(0,ue.firstOrDefault)(await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:ae?[ae]:void 0,forceEmpty:V,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this._win?.destroy()}}onDidDeleteUntitledWorkspace(T){this._config?.workspace?.id===T.id&&(this._config.workspace=void 0)}onConfigurationUpdated(T){if(!T||T.affectsConfiguration("window.menuBarVisibility")){const U=this.getMenuBarVisibility();U!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=U,this.setMenuBarVisibility(U))}if(!T||T.affectsConfiguration("http.proxy")){let U=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;U?.endsWith("/")&&(U=U.substr(0,U.length-1));const $=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((U||"").indexOf("@")===-1&&(U!==this.currentHttpProxy||$!==this.currentNoProxy)){this.currentHttpProxy=U,this.currentNoProxy=$;const ae=U||"",V=$?`${$},<local>`:"<local>";this.logService.trace(`Setting proxy to '${ae}', bypassing '${V}'`),this._win.webContents.session.setProxy({proxyRules:ae,proxyBypassRules:V,pacScript:""}),typeof n.app.setProxy=="function"&&n.app.setProxy({proxyRules:ae,proxyBypassRules:V,pacScript:""})}}}addTabbedWindow(T){f.isMacintosh&&T.win&&this._win.addTabbedWindow(T.win)}load(T,U=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!U.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),U.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(T,U),this.readyState===0?this._config=T:this.pendingLoadConfig=T,this.readyState=1,this._win.loadURL(h.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0));const $=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new R.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:T.workspace,reason:U.isReload?3:$?2:1})}updateConfiguration(T,U){const $=(this._config??this.pendingLoadConfig)?.userEnv;if($){const ae=(0,c.isLaunchedFromCli)($)&&!(0,c.isLaunchedFromCli)(T.userEnv),V=this.isExtensionDevelopmentHost;(ae||V)&&(T.userEnv={...$,...T.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(T.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),U.disableExtensions!==void 0&&(T["disable-extensions"]=U.disableExtensions),T.fullscreen=this.isFullScreen,T.maximized=this._win.isMaximized(),T.partsSplash=this.themeMainService.getWindowSplash(),T.zoomLevel=this.getZoomLevel(),T.isCustomZoomLevel=typeof this.customZoomLevel=="number",T.isCustomZoomLevel&&T.partsSplash&&(T.partsSplash.zoomLevel=T.zoomLevel),(0,l.mark)("code/willOpenNewWindow"),T.perfMarks=(0,l.getMarks)(),this.configObjectUrl.update(T)}async reload(T){const U=Object.assign({},this._config);U.workspace=await this.validateWorkspaceBeforeReload(U),delete U.filesToOpenOrCreate,delete U.filesToDiff,delete U.filesToMerge,delete U.filesToWait,this.isExtensionDevelopmentHost&&T&&(U.verbose=T.verbose,U.debugId=T.debugId,U.extensionEnvironment=T.extensionEnvironment,U["inspect-extensions"]=T["inspect-extensions"],U["inspect-brk-extensions"]=T["inspect-brk-extensions"],U["extensions-dir"]=T["extensions-dir"]),U.accessibilitySupport=n.app.isAccessibilitySupportEnabled(),U.isInitialStartup=!1,U.policiesData=this.policyService.serialize(),U.continueOn=this.environmentMainService.continueOn,U.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile,home:this.userDataProfilesService.profilesHome},U.logLevel=this.loggerMainService.getLogLevel(),U.loggers={window:this.loggerMainService.getRegisteredLoggers(this.id),global:this.loggerMainService.getRegisteredLoggers()},this.load(U,{isReload:!0,disableExtensions:T?.["disable-extensions"]})}async validateWorkspaceBeforeReload(T){if((0,D.isWorkspaceIdentifier)(T.workspace)){const U=T.workspace.configPath;if(U.scheme===h.Schemas.file&&!await this.fileService.exists(U))return}else if((0,D.isSingleFolderWorkspaceIdentifier)(T.workspace)){const U=T.workspace.uri;if(U.scheme===h.Schemas.file&&!await this.fileService.exists(U))return}return T.workspace}serializeWindowState(){if(!this._win)return(0,O.defaultWindowState)();if(this.isFullScreen){let $;try{$=n.screen.getDisplayMatching(this.getBounds())}catch{}const ae=(0,O.defaultWindowState)();return{mode:3,display:$?$.id:void 0,width:this.windowState.width||ae.width,height:this.windowState.height||ae.height,x:this.windowState.x||0,y:this.windowState.y||0,zoomLevel:this.customZoomLevel}}const T=Object.create(null);let U;if(!f.isMacintosh&&this._win.isMaximized()?U=0:U=1,U===0?T.mode=0:T.mode=1,U===1||U===0){let $;U===1?$=this.getBounds():$=this._win.getNormalBounds(),T.x=$.x,T.y=$.y,T.width=$.width,T.height=$.height}return T.zoomLevel=this.customZoomLevel,T}restoreWindowState(T){(0,l.mark)("code/willRestoreCodeWindowState");let U=!1;if(T){this.customZoomLevel=T.zoomLevel;try{const $=n.screen.getAllDisplays();U=$.length>1,T=M.WindowStateValidator.validateWindowState(this.logService,T,$)}catch($){this.logService.warn(`Unexpected error validating window state: ${$}
${$.stack}`)}}return(0,l.mark)("code/didRestoreCodeWindowState"),[T||(0,O.defaultWindowState)(),U]}getBounds(){const[T,U]=this._win.getPosition(),[$,ae]=this._win.getSize();return{x:T,y:U,width:$,height:ae}}setFullScreen(T,U){super.setFullScreen(T,U),this.sendWhenReady(T?"vscode:enterFullScreen":"vscode:leaveFullScreen",I.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}getMenuBarVisibility(){let T=(0,C.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(T)<0&&(T="classic"),T}setMenuBarVisibility(T,U=!0){f.isMacintosh||(T==="toggle"&&U&&this.send("vscode:showInfoMessage",(0,b.localize)(14,null)),T==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(T)}):this.doSetMenuBarVisibility(T))}doSetMenuBarVisibility(T){const U=this.isFullScreen;switch(T){case"classic":this._win.setMenuBarVisibility(!U),this._win.autoHideMenuBar=U;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}notifyZoomLevel(T){this.customZoomLevel=T}getZoomLevel(){return typeof this.customZoomLevel=="number"?this.customZoomLevel:this.configurationService.getValue("window")?.zoomLevel}close(){this._win?.close()}sendWhenReady(T,U,...$){this.isReady?this.send(T,...$):this.ready().then(()=>{U.isCancellationRequested||this.send(T,...$)})}send(T,...U){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${T}' for window that is destroyed`);return}try{this._win.webContents.send(T,...U)}catch($){this.logService.warn(`Error sending IPC message to channel '${T}' of window ${this._id}: ${(0,A.toErrorMessage)($)}`)}}}updateTouchBar(T){f.isMacintosh&&this.touchBarGroups.forEach((U,$)=>{const ae=T[$];U.segments=this.createTouchBarGroupSegments(ae)})}createTouchBar(){if(f.isMacintosh){for(let T=0;T<10;T++){const U=this.createTouchBarGroup();this.touchBarGroups.push(U)}this._win.setTouchBar(new n.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(T=[]){const U=this.createTouchBarGroupSegments(T),$=new n.TouchBar.TouchBarSegmentedControl({segments:U,mode:"buttons",segmentStyle:"automatic",change:ae=>{this.sendWhenReady("vscode:runAction",I.CancellationToken.None,{id:$.segments[ae].id,from:"touchbar"})}});return $}createTouchBarGroupSegments(T=[]){return T.map($=>{let ae;$.icon&&!u.ThemeIcon.isThemeIcon($.icon)&&$.icon?.dark?.scheme===h.Schemas.file&&(ae=n.nativeImage.createFromPath(S.URI.revive($.icon.dark).fsPath),ae.isEmpty()&&(ae=void 0));let V;return typeof $.title=="string"?V=$.title:V=$.title.value,{id:$.id,label:ae?void 0:V,icon:ae}})}matches(T){return this._win?.webContents.id===T.id}dispose(){super.dispose(),this.loggerMainService.deregisterLoggers(this.id)}};e.CodeWindow=G,e.CodeWindow=G=Ie([ie(1,a.ILogService),ie(2,z.ILoggerMainService),ie(3,m.IEnvironmentMainService),ie(4,_.IPolicyService),ie(5,x.IUserDataProfilesMainService),ie(6,v.IFileService),ie(7,i.IApplicationStorageMainService),ie(8,i.IStorageMainService),ie(9,y.IConfigurationService),ie(10,p.IThemeMainService),ie(11,W.IWorkspacesManagementMainService),ie(12,d.IBackupMainService),ie(13,o.ITelemetryService),ie(14,w.IDialogMainService),ie(15,E.ILifecycleMainService),ie(16,t.IProductService),ie(17,s.IProtocolMainService),ie(18,M.IWindowsMainService),ie(19,F.IStateService),ie(20,ee.IInstantiationService)],G)}),define(se[306],oe([0,1,14,4,18,24,20,5,34,55,135]),function(Q,e,n,R,I,A,k,P,h,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuxiliaryWindow=void 0;let S=class extends f.BaseWindow{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(g,d,y,w,m,c){super(w,m,d,y),this.webContents=g,this.lifecycleMainService=c,this.id=this.webContents.id,this.parentId=-1,this.stateApplied=!1,this.tryClaimWindow()}tryClaimWindow(g){this._store.isDisposed||this.webContents.isDestroyed()||(this.doTryClaimWindow(),g&&!this.stateApplied&&(this.stateApplied=!0,this.applyState({x:g.x,y:g.y,width:g.width,height:g.height,mode:g.show===!1?0:1})))}doTryClaimWindow(){if(this._win)return;const g=n.BrowserWindow.fromWebContents(this.webContents);g&&(this.logService.trace("[aux window] Claimed browser window instance"),this.setWin(g),g.setMenu(null),(R.isWindows||R.isLinux)&&(0,l.hasNativeTitlebar)(this.configurationService)&&g.setAutoHideMenuBar(!0),this.lifecycleMainService.registerAuxWindow(this))}matches(g){return this.webContents.id===g.id}};e.AuxiliaryWindow=S,e.AuxiliaryWindow=S=Ie([ie(1,A.IEnvironmentMainService),ie(2,P.ILogService),ie(3,I.IConfigurationService),ie(4,h.IStateService),ie(5,k.ILifecycleMainService)],S)}),define(se[307],oe([0,1,14,3,2,13,37,306,6,5,82,29]),function(Q,e,n,R,I,A,k,P,h,l,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuxiliaryWindowsMainService=void 0;let b=class extends I.Disposable{constructor(d,y){super(),this.instantiationService=d,this.logService=y,this._onDidMaximizeWindow=this._register(new R.Emitter),this.onDidMaximizeWindow=this._onDidMaximizeWindow.event,this._onDidUnmaximizeWindow=this._register(new R.Emitter),this.onDidUnmaximizeWindow=this._onDidUnmaximizeWindow.event,this._onDidChangeFullScreen=this._register(new R.Emitter),this.onDidChangeFullScreen=this._onDidChangeFullScreen.event,this._onDidTriggerSystemContextMenu=this._register(new R.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windows=new Map,this.registerListeners()}registerListeners(){n.app.on("browser-window-created",(d,y)=>{const w=this.getWindowByWebContents(y.webContents);if(w)this.logService.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),w.tryClaimWindow();else{const m=new I.DisposableStore;m.add(R.Event.fromNodeEventEmitter(y.webContents,"did-create-window",(c,v)=>({browserWindow:c,details:v}))(({browserWindow:c,details:v})=>{const E=this.getWindowByWebContents(c.webContents);E&&(this.logService.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),E.tryClaimWindow(v.options))})),m.add(R.Event.fromNodeEventEmitter(y,"closed")(()=>m.dispose()))}}),k.validatedIpcMain.handle("vscode:registerAuxiliaryWindow",async(d,y)=>{const w=this.getWindowByWebContents(d.sender);return w&&(this.logService.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),w.parentId=y),d.sender.id})}createWindow(d){return this.instantiationService.invokeFunction(S.defaultBrowserWindowOptions,this.validateWindowState(d),{preload:A.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}validateWindowState(d){const y={},w=d.features.split(",");for(const c of w){const[v,E]=c.split("=");switch(v){case"width":y.width=parseInt(E,10);break;case"height":y.height=parseInt(E,10);break;case"left":y.x=parseInt(E,10);break;case"top":y.y=parseInt(E,10);break;case"window-maximized":y.mode=0;break;case"window-fullscreen":y.mode=3;break}}const m=S.WindowStateValidator.validateWindowState(this.logService,y)??(0,f.defaultAuxWindowState)();return this.logService.trace("[aux window] using window state",m),m}registerWindow(d){const y=new I.DisposableStore,w=this.instantiationService.createInstance(P.AuxiliaryWindow,d);this.windows.set(w.id,w),y.add((0,I.toDisposable)(()=>this.windows.delete(w.id))),y.add(w.onDidMaximize(()=>this._onDidMaximizeWindow.fire(w))),y.add(w.onDidUnmaximize(()=>this._onDidUnmaximizeWindow.fire(w))),y.add(w.onDidEnterFullScreen(()=>this._onDidChangeFullScreen.fire({window:w,fullscreen:!0}))),y.add(w.onDidLeaveFullScreen(()=>this._onDidChangeFullScreen.fire({window:w,fullscreen:!1}))),y.add(w.onDidTriggerSystemContextMenu(({x:m,y:c})=>this._onDidTriggerSystemContextMenu.fire({window:w,x:m,y:c}))),R.Event.once(w.onDidClose)(()=>y.dispose())}getWindowByWebContents(d){const y=this.windows.get(d.id);return y?.matches(d)?y:void 0}getFocusedWindow(){const d=n.BrowserWindow.getFocusedWindow();if(d)return this.getWindowByWebContents(d.webContents)}getLastActiveWindow(){return(0,S.getLastFocused)(Array.from(this.windows.values()))}getWindows(){return Array.from(this.windows.values())}};e.AuxiliaryWindowsMainService=b,e.AuxiliaryWindowsMainService=b=Ie([ie(0,h.IInstantiationService),ie(1,l.ILogService)],b)}),define(se[85],oe([0,1,14,22,8,3,48,2,13,4,19,7,21,196,6,20,5,84,98,30,58,32,56]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y,w,m,c,v,E,a,t){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let r=class extends P.Disposable{static{s=this}static{this.MAX_TOTAL_RECENT_ENTRIES=500}static{this.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList"}constructor(o,u,p,C,M){super(),this.logService=o,this.workspacesManagementMainService=u,this.lifecycleMainService=p,this.applicationStorageMainService=C,this.dialogMainService=M,this._onDidChangeRecentlyOpened=this._register(new A.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new I.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(o=>this.addRecentlyOpened([{workspace:o.workspace,remoteAuthority:o.window.remoteAuthority}])))}async addRecentlyOpened(o){let u=[],p=[];for(const M of o)if((0,c.isRecentWorkspace)(M))!this.workspacesManagementMainService.isUntitledWorkspace(M.workspace)&&!this.containsWorkspace(u,M.workspace)&&u.push(M);else if((0,c.isRecentFolder)(M))this.containsFolder(u,M.folderUri)||u.push(M);else{const D=this.containsFile(p,M.fileUri),W=M.fileUri.scheme===h.Schemas.file&&s.COMMON_FILES_FILTER.indexOf((0,f.basename)(M.fileUri))>=0;!D&&!W&&(p.push(M),l.isWindows&&M.fileUri.scheme===h.Schemas.file&&n.app.addRecentDocument(M.fileUri.fsPath))}const C=await this.mergeEntriesFromStorage({workspaces:u,files:p});u=C.workspaces,p=C.files,u.length>s.MAX_TOTAL_RECENT_ENTRIES&&(u.length=s.MAX_TOTAL_RECENT_ENTRIES),p.length>s.MAX_TOTAL_RECENT_ENTRIES&&(p.length=s.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:u,files:p}),this._onDidChangeRecentlyOpened.fire(),l.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(o){const u=D=>{const W=this.location(D);for(const O of o)if(f.extUriBiasedIgnorePathCase.isEqual(O,W))return!1;return!0},p=await this.getRecentlyOpened(),C=p.workspaces.filter(u),M=p.files.filter(u);(C.length!==p.workspaces.length||M.length!==p.files.length)&&(await this.saveRecentlyOpened({files:M,workspaces:C}),this._onDidChangeRecentlyOpened.fire(),l.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(o){if(o?.confirm){const{response:u}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,g.localize)(0,null),(0,g.localize)(1,null)],message:(0,g.localize)(2,null),detail:(0,g.localize)(3,null),cancelId:1});if(u!==0)return}await this.saveRecentlyOpened({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(o){const u=new a.ResourceMap(M=>f.extUriBiasedIgnorePathCase.getComparisonKey(M));if(o?.workspaces)for(const M of o.workspaces)u.set(this.location(M),M);const p=new a.ResourceMap(M=>f.extUriBiasedIgnorePathCase.getComparisonKey(M));if(o?.files)for(const M of o.files)p.set(this.location(M),M);const C=await this.getRecentlyOpenedFromStorage();for(const M of C.workspaces){const D=u.get(this.location(M));D?D.label=D.label??M.label:u.set(this.location(M),M)}for(const M of C.files){const D=p.get(this.location(M));D?D.label=D.label??M.label:p.set(this.location(M),M)}return{workspaces:[...u.values()],files:[...p.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let o;const u=this.applicationStorageMainService.get(s.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof u=="string")try{o=JSON.parse(u)}catch(p){this.logService.error("Unexpected error parsing opened paths list",p)}return(0,c.restoreRecentlyOpened)(o,this.logService)}async saveRecentlyOpened(o){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(s.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,c.toStoreData)(o)),-1,1)}location(o){return(0,c.isRecentFolder)(o)?o.folderUri:(0,c.isRecentFile)(o)?o.fileUri:o.workspace.configPath}containsWorkspace(o,u){return!!o.find(p=>(0,c.isRecentWorkspace)(p)&&p.workspace.id===u.id)}containsFolder(o,u){return!!o.find(p=>(0,c.isRecentFolder)(p)&&f.extUriBiasedIgnorePathCase.isEqual(p.folderUri,u))}containsFile(o,u){return!!o.find(p=>f.extUriBiasedIgnorePathCase.isEqual(p.fileUri,u))}static{this.MAX_MACOS_DOCK_RECENT_WORKSPACES=7}static{this.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10}static{this.MAX_WINDOWS_JUMP_LIST_ENTRIES=7}static{this.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"]}async handleWindowsJumpList(){l.isWindows&&(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!l.isWindows)return;const o=[];if(o.push({type:"tasks",items:[{type:"task",title:(0,g.localize)(4,null),description:(0,g.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const u=[];for(const M of n.app.getJumpListSettings().removedItems){const D=M.args;if(D){const W=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(D);W&&u.push(S.URI.parse(W[2]))}}await this.removeRecentlyOpened(u);let p=!1;const C=(0,R.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,s.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(M=>{const D=(0,c.isRecentWorkspace)(M)?M.workspace:M.folderUri,{title:W,description:O}=this.getWindowsJumpListLabel(D,M.label);let _;return S.URI.isUri(D)?_=`--folder-uri "${D.toString()}"`:(p=!0,_=`--file-uri "${D.configPath.toString()}"`),{type:"task",title:W.substr(0,255),description:O.substr(0,255),program:process.execPath,args:_,iconPath:"explorer.exe",iconIndex:0}}));C.length>0&&o.push({type:"custom",name:p?(0,g.localize)(6,null):(0,g.localize)(7,null),items:C})}o.push({type:"recent"});try{const u=n.app.setJumpList(o);u&&u!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${u}`)}catch(u){this.logService.warn("updateWindowsJumpList#setJumpList",u)}}getWindowsJumpListLabel(o,u){if(u)return{title:(0,k.splitRecentLabel)(u).name,description:u};if(S.URI.isUri(o))return{title:(0,f.basename)(o),description:this.renderJumpListPathDescription(o)};if(this.workspacesManagementMainService.isUntitledWorkspace(o))return{title:(0,g.localize)(8,null),description:""};let p=(0,f.basename)(o.configPath);return p.endsWith(v.WORKSPACE_EXTENSION)&&(p=p.substr(0,p.length-v.WORKSPACE_EXTENSION.length-1)),{title:(0,g.localize)(9,null,p),description:this.renderJumpListPathDescription(o.configPath)}}renderJumpListPathDescription(o){return o.scheme==="file"?(0,k.normalizeDriveLetter)(o.fsPath):o.toString()}async updateMacOSRecentDocuments(){if(!l.isMacintosh)return;n.app.clearRecentDocuments();const o=await this.getRecentlyOpened(),u=[];let p=0;for(let M=0;M<o.workspaces.length&&p<s.MAX_MACOS_DOCK_RECENT_WORKSPACES;M++){const D=this.location(o.workspaces[M]);if(D.scheme===h.Schemas.file){const W=(0,f.originalFSPath)(D);await b.Promises.exists(W)&&(u.push(W),p++)}}const C=[];for(let M=0;M<o.files.length&&p<s.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;M++){const D=this.location(o.files[M]);if(D.scheme===h.Schemas.file){const W=(0,f.originalFSPath)(D);if(s.COMMON_FILES_FILTER.includes((0,f.basename)(D))||u.includes(W))continue;await b.Promises.exists(W)&&(C.push(W),p++)}}C.reverse().forEach(M=>n.app.addRecentDocument(M)),u.reverse().forEach(M=>n.app.addRecentDocument(M))}};e.WorkspacesHistoryMainService=r,e.WorkspacesHistoryMainService=r=s=Ie([ie(0,w.ILogService),ie(1,E.IWorkspacesManagementMainService),ie(2,y.ILifecycleMainService),ie(3,m.IApplicationStorageMainService),ie(4,t.IDialogMainService)],r)}),define(se[308],oe([0,1,14,8,23,48,4,7,184,79,18,24,20,5,235,70,27,34,28,50,55,29,85]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y,w,m,c,v,E,a,t){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const r="menu";let i=class{static{s=this}static{this.lastKnownMenubarStorageKey="lastKnownMenubarData"}constructor(p,C,M,D,W,O,_,F,x,z,ue,ee){this.updateService=p,this.configurationService=C,this.windowsMainService=M,this.environmentMainService=D,this.telemetryService=W,this.workspacesHistoryMainService=O,this.stateService=_,this.lifecycleMainService=F,this.logService=x,this.nativeHostMainService=z,this.productService=ue,this.auxiliaryWindowsMainService=ee,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new R.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new R.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(k.isMacintosh||(0,E.hasNativeTitlebar)(C))&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveMainWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const p=this.stateService.getItem(s.lastKnownMenubarStorageKey);p&&(p.menus&&(this.menubarMenus=p.menus),p.keybindings&&(this.keybindings=p.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(O,_,F)=>{this.runActionInRenderer({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.windowsMainService.openEmptyWindow({context:2,contextWindowId:_?.id})},this.fallbackMenuHandlers["workbench.action.newWindow"]=(O,_,F)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:_?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(O,_,F)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:r}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(O,_,F)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:r}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(O,_,F)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:r}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened({confirm:!0});const p=this.productService.youTubeUrl;p&&(this.fallbackMenuHandlers["workbench.action.openYouTubeUrl"]=()=>this.openUrl(p,"openYouTubeUrl"));const C=this.productService.requestFeatureUrl;C&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(C,"openUserVoiceUrl"));const M=this.productService.reportIssueUrl;M&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(M,"openReportIssues"));const D=this.productService.licenseUrl;D&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(k.language){const O=D.indexOf("?")>0?"&":"?";this.openUrl(`${D}${O}lang=${k.language}`,"openLicenseUrl")}else this.openUrl(D,"openLicenseUrl")});const W=this.productService.privacyStatementUrl;W&&D&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(W,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(p=>this.onDidChangeWindowsCount(p)),this.nativeHostMainService.onDidBlurMainWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusMainWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const p=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof p!="boolean"?!0:p}get currentEnableNativeTabs(){if(!k.isMacintosh)return!1;const p=this.configurationService.getValue("window.nativeTabs");return typeof p!="boolean"?!1:p}updateMenu(p,C){this.menubarMenus=p.menus,this.keybindings=p.keybindings,this.stateService.setItem(s.lastKnownMenubarStorageKey,p),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(p){k.isMacintosh&&(p.oldCount===0&&p.newCount>0||p.oldCount>0&&p.newCount===0)&&(this.closedLastWindow=p.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){if(!k.isMacintosh)return;const p=n.BrowserWindow.getFocusedWindow();this.noActiveMainWindow=!p||!!this.auxiliaryWindowsMainService.getWindowByWebContents(p.webContents),this.scheduleUpdateMenu()}install(){const p=n.Menu.getApplicationMenu();if(p&&this.oldMenus.push(p),Object.keys(this.menubarMenus).length===0){this.doSetApplicationMenu(k.isMacintosh?new n.Menu:null);return}const C=new n.Menu;let M;if(k.isMacintosh){const W=new n.Menu;M=new n.MenuItem({label:this.productService.nameShort,submenu:W}),this.setMacApplicationMenu(W),C.append(M)}if(k.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const W=new n.Menu;W.append(new n.MenuItem({label:this.mnemonicLabel(h.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),n.app.dock.setMenu(W)}if(this.shouldDrawMenu("File")){const W=new n.Menu,O=new n.MenuItem({label:this.mnemonicLabel(h.localize(1,null)),submenu:W});this.setMenuById(W,"File"),C.append(O)}if(this.shouldDrawMenu("Edit")){const W=new n.Menu,O=new n.MenuItem({label:this.mnemonicLabel(h.localize(2,null)),submenu:W});this.setMenuById(W,"Edit"),C.append(O)}if(this.shouldDrawMenu("Selection")){const W=new n.Menu,O=new n.MenuItem({label:this.mnemonicLabel(h.localize(3,null)),submenu:W});this.setMenuById(W,"Selection"),C.append(O)}if(this.shouldDrawMenu("View")){const W=new n.Menu,O=new n.MenuItem({label:this.mnemonicLabel(h.localize(4,null)),submenu:W});this.setMenuById(W,"View"),C.append(O)}if(this.shouldDrawMenu("Go")){const W=new n.Menu,O=new n.MenuItem({label:this.mnemonicLabel(h.localize(5,null)),submenu:W});this.setMenuById(W,"Go"),C.append(O)}if(this.shouldDrawMenu("Run")){const W=new n.Menu,O=new n.MenuItem({label:this.mnemonicLabel(h.localize(6,null)),submenu:W});this.setMenuById(W,"Run"),C.append(O)}if(this.shouldDrawMenu("Terminal")){const W=new n.Menu,O=new n.MenuItem({label:this.mnemonicLabel(h.localize(7,null)),submenu:W});this.setMenuById(W,"Terminal"),C.append(O)}let D;if(this.shouldDrawMenu("Window")){const W=new n.Menu;D=new n.MenuItem({label:this.mnemonicLabel(h.localize(8,null)),submenu:W,role:"window"}),this.setMacWindowMenu(W)}if(D&&C.append(D),this.shouldDrawMenu("Help")){const W=new n.Menu,O=new n.MenuItem({label:this.mnemonicLabel(h.localize(9,null)),submenu:W,role:"help"});this.setMenuById(W,"Help"),C.append(O)}C.items&&C.items.length>0?this.doSetApplicationMenu(C):this.doSetApplicationMenu(null),this.menuGC.schedule()}doSetApplicationMenu(p){if(n.Menu.setApplicationMenu(p),p)for(const C of this.auxiliaryWindowsMainService.getWindows())C.win?.setMenu(null)}setMacApplicationMenu(p){const C=this.createMenuItem(h.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),M=this.getUpdateMenuItems();let D;if(this.shouldDrawMenu("Preferences")){const ee=new n.Menu;this.setMenuById(ee,"Preferences"),D=new n.MenuItem({label:this.mnemonicLabel(h.localize(11,null)),submenu:ee})}const W=new n.Menu,O=new n.MenuItem({label:h.localize(12,null),role:"services",submenu:W}),_=new n.MenuItem({label:h.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),F=new n.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),x=new n.MenuItem({label:h.localize(15,null),role:"unhide"}),z=new n.MenuItem(this.likeAction("workbench.action.quit",{label:h.localize(16,null,this.productService.nameLong),click:async(ee,le,Y)=>{const G=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||G?.win?.isMinimized())&&await this.confirmBeforeQuit(Y)&&this.nativeHostMainService.quit(void 0)}})),ue=[C];ue.push(...M),D&&ue.push(o(),D),ue.push(o(),O,o(),_,F,x,o(),z),ue.forEach(ee=>p.append(ee))}async confirmBeforeQuit(p){if(this.windowsMainService.getWindowCount()===0)return!0;const C=this.configurationService.getValue("window.confirmBeforeClose");if(C==="always"||C==="keyboardOnly"&&this.isKeyboardEvent(p)){const{response:M}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,{type:"question",buttons:[h.localize(17,null),h.localize(18,null)],message:h.localize(19,null)});return M===0}return!0}shouldDrawMenu(p){if(!k.isMacintosh&&!(0,E.hasNativeTitlebar)(this.configurationService))return!1;switch(p){case"File":case"Help":if(k.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow||!!this.menubarMenus&&!!this.menubarMenus[p];case"Window":if(k.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[p]}}setMenu(p,C){C.forEach(M=>{if((0,d.isMenubarMenuItemSeparator)(M))p.append(o());else if((0,d.isMenubarMenuItemSubmenu)(M)){const D=new n.Menu,W=new n.MenuItem({label:this.mnemonicLabel(M.label),submenu:D});this.setMenu(D,M.submenu.items),p.append(W)}else(0,d.isMenubarMenuItemRecentAction)(M)?p.append(this.createOpenRecentMenuItem(M)):(0,d.isMenubarMenuItemAction)(M)&&(M.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(p),k.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow?this.fallbackMenuHandlers[M.id]?p.append(new n.MenuItem(this.likeAction(M.id,{label:this.mnemonicLabel(M.label),click:this.fallbackMenuHandlers[M.id]}))):p.append(this.createMenuItem(M.label,M.id,!1,M.checked)):p.append(this.createMenuItem(M.label,M.id,M.enabled!==!1,!!M.checked)):p.append(this.createMenuItem(M.label,M.id,M.enabled!==!1,!!M.checked)))})}setMenuById(p,C){this.menubarMenus&&this.menubarMenus[C]&&this.setMenu(p,this.menubarMenus[C].items)}insertCheckForUpdatesItems(p){const C=this.getUpdateMenuItems();C.length&&(C.forEach(M=>p.append(M)),p.append(o()))}createOpenRecentMenuItem(p){const C=P.URI.revive(p.uri),M=p.id,D=M==="openRecentFile"?{fileUri:C}:M==="openRecentWorkspace"?{workspaceUri:C}:{folderUri:C};return new n.MenuItem(this.likeAction(M,{label:p.label,click:async(W,O,_)=>{const F=this.isOptionClick(_);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[D],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:p.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([C])}},!1))}isOptionClick(p){return!!(p&&(!k.isMacintosh&&(p.ctrlKey||p.shiftKey)||k.isMacintosh&&(p.metaKey||p.altKey)))}isKeyboardEvent(p){return!!(p.triggeredByAccelerator||p.altKey||p.ctrlKey||p.metaKey||p.shiftKey)}createRoleMenuItem(p,C,M){const D={label:this.mnemonicLabel(p),role:M,enabled:!0};return new n.MenuItem(this.withKeybinding(C,D))}setMacWindowMenu(p){const C=new n.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),M=new n.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),D=new n.MenuItem({label:h.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),W=this.createMenuItem(h.localize(23,null),"workbench.action.switchWindow"),O=[];this.currentEnableNativeTabs&&(O.push(o()),O.push(this.createMenuItem(h.localize(24,null),"workbench.action.newWindowTab")),O.push(this.createRoleMenuItem(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),O.push(this.createRoleMenuItem(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),O.push(this.createRoleMenuItem(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),O.push(this.createRoleMenuItem(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[C,M,o(),W,...O,o(),D].forEach(_=>p.append(_))}getUpdateMenuItems(){switch(this.updateService.state.type){case"idle":return[new n.MenuItem({label:this.mnemonicLabel(h.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new n.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new n.MenuItem({label:this.mnemonicLabel(h.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new n.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return k.isMacintosh?[]:[new n.MenuItem({label:this.mnemonicLabel(h.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new n.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new n.MenuItem({label:this.mnemonicLabel(h.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})];default:return[]}}createMenuItem(p,C,M,D){const W=this.mnemonicLabel(p),O=typeof C=="function"?C:(ue,ee,le)=>{const Y=ue?ue.userSettingsLabel:null;let G=C;Array.isArray(C)&&(G=this.isOptionClick(le)?C[1]:C[0]),Y&&le.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:Y}):this.runActionInRenderer({type:"commandId",commandId:G})},_=typeof M=="boolean"?M:this.windowsMainService.getWindowCount()>0,F=typeof D=="boolean"?D:!1,x={label:W,click:O,enabled:_};F&&(x.type="checkbox",x.checked=F);let z;return typeof C=="string"?z=C:Array.isArray(C)&&(z=C[0]),k.isMacintosh&&(z==="editor.action.clipboardCutAction"?x.role="cut":z==="editor.action.clipboardCopyAction"?x.role="copy":z==="editor.action.clipboardPasteAction"&&(x.role="paste"),z==="undo"?x.click=this.makeContextAwareClickHandler(O,{inDevTools:ue=>ue.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):z==="redo"?x.click=this.makeContextAwareClickHandler(O,{inDevTools:ue=>ue.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):z==="editor.action.selectAll"&&(x.click=this.makeContextAwareClickHandler(O,{inDevTools:ue=>ue.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.withKeybinding(z,x))}makeContextAwareClickHandler(p,C){return(M,D,W)=>{const O=n.BrowserWindow.getFocusedWindow();if(!O)return C.inNoWindow();if(O.webContents.isDevToolsFocused()&&O.webContents.devToolsWebContents)return C.inDevTools(O.webContents.devToolsWebContents);p(M,D||O,W)}}runActionInRenderer(p){let C=n.BrowserWindow.getFocusedWindow();if(C){const D=this.auxiliaryWindowsMainService.getWindowByWebContents(C.webContents);D&&(C=this.windowsMainService.getWindowById(D.parentId)?.win??null)}if(!C){const D=this.windowsMainService.getLastActiveWindow();D?.win?.isMinimized()&&(C=D.win)}const M=C?this.windowsMainService.getWindowById(C.id):void 0;if(M){if(this.logService.trace("menubar#runActionInRenderer",p),k.isMacintosh&&!this.environmentMainService.isBuilt&&!M.isReady&&(p.type==="commandId"&&p.commandId==="workbench.action.toggleDevTools"||p.type!=="commandId"&&p.userSettingsLabel==="alt+cmd+i"))return!1;if(p.type==="commandId"){const D={id:p.commandId,from:"menu"};M.sendWhenReady("vscode:runAction",I.CancellationToken.None,D)}else{const D={userSettingsLabel:p.userSettingsLabel};M.sendWhenReady("vscode:runKeybinding",I.CancellationToken.None,D)}return!0}else return this.logService.trace("menubar#runActionInRenderer: no active window found",p),!1}withKeybinding(p,C){const M=typeof p=="string"?this.keybindings[p]:void 0;if(M?.label){if(M.isNative!==!1)C.accelerator=M.label,C.userSettingsLabel=M.userSettingsLabel;else if(typeof C.label=="string"){const D=C.label.indexOf("[");D>=0?C.label=`${C.label.substr(0,D)} [${M.label}]`:C.label=`${C.label} [${M.label}]`}}else C.accelerator=void 0;return C}likeAction(p,C,M=!C.accelerator){M&&(C=this.withKeybinding(p,C));const D=C.click;return C.click=(W,O,_)=>{this.reportMenuActionTelemetry(p),D?.(W,O,_)},C}openUrl(p,C){this.nativeHostMainService.openExternal(void 0,p),this.reportMenuActionTelemetry(C)}reportMenuActionTelemetry(p){this.telemetryService.publicLog2("workbenchActionExecuted",{id:p,from:r})}mnemonicLabel(p){return(0,A.mnemonicMenuLabel)(p,!this.currentEnableMenuBarMnemonics)}};e.Menubar=i,e.Menubar=i=s=Ie([ie(0,v.IUpdateService),ie(1,f.IConfigurationService),ie(2,a.IWindowsMainService),ie(3,S.IEnvironmentMainService),ie(4,c.ITelemetryService),ie(5,t.IWorkspacesHistoryMainService),ie(6,m.IStateService),ie(7,b.ILifecycleMainService),ie(8,g.ILogService),ie(9,y.INativeHostMainService),ie(10,w.IProductService),ie(11,l.IAuxiliaryWindowsMainService)],i);function o(){return new n.MenuItem({type:"separator"})}}),define(se[309],oe([0,1,6,20,5,308]),function(Q,e,n,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,n.createDecorator)("menubarMainService");let k=class{constructor(h,l,f){this.instantiationService=h,this.lifecycleMainService=l,this.logService=f,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(A.Menubar)}async updateMenubar(h,l){this.logService.trace("menubarService#updateMenubar",h),(await this.menubar).updateMenu(l,h)}};e.MenubarMainService=k,e.MenubarMainService=k=Ie([ie(0,n.IInstantiationService),ie(1,R.ILifecycleMainService),ie(2,I.ILogService)],k)}),define(se[310],oe([0,1,14,21,102,26,22,23,3,31,48,2,13,9,66,4,36,19,12,7,194,65,18,56,24,16,6,20,5,80,81,68,34,55,135,29,133,302,30,99,85,58,69,39,57,67,79]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y,w,m,c,v,E,a,t,s,r,i,o,u,p,C,M,D,W,O,_,F,x,z,ue,ee,le,Y,G,B,T,U,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function ae(X){return(0,ue.isWorkspaceIdentifier)(X?.workspace)}function V(X){return(0,ue.isSingleFolderWorkspaceIdentifier)(X?.workspace)}let ce=class extends S.Disposable{constructor(L,N,Z,ne,K,H,j,q,re,he,me,pe,ye,Ee,Pe,We,ve,J,de,ge){super(),this.machineId=L,this.sqmId=N,this.initialUserEnv=Z,this.logService=ne,this.loggerService=K,this.stateService=H,this.policyService=j,this.environmentMainService=q,this.userDataProfilesMainService=re,this.lifecycleMainService=he,this.backupMainService=me,this.configurationService=pe,this.workspacesHistoryMainService=ye,this.workspacesManagementMainService=Ee,this.instantiationService=Pe,this.dialogMainService=We,this.fileService=ve,this.protocolMainService=J,this.themeMainService=de,this.auxiliaryWindowsMainService=ge,this._onDidOpenWindow=this._register(new h.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new h.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new h.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new h.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidMaximizeWindow=this._register(new h.Emitter),this.onDidMaximizeWindow=this._onDidMaximizeWindow.event,this._onDidUnmaximizeWindow=this._register(new h.Emitter),this.onDidUnmaximizeWindow=this._onDidUnmaximizeWindow.event,this._onDidChangeFullScreen=this._register(new h.Emitter),this.onDidChangeFullScreen=this._onDidChangeFullScreen.event,this._onDidTriggerSystemContextMenu=this._register(new h.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windows=new Map,this.windowsStateHandler=this._register(new z.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const N=new S.DisposableStore;if(N.add(h.Event.any(L.onDidClose,L.onDidDestroy)(()=>N.dispose())),L.config.extensionDevelopmentPath)for(const Z of L.config.extensionDevelopmentPath)N.add(this.protocolMainService.addValidFileRoot(Z));L.config.extensionTestsPath&&N.add(this.protocolMainService.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,N){const Z=this.environmentMainService.args,ne=N?.remoteAuthority||void 0,K=!0,H=N?.forceReuseWindow,j=!H;return this.open({...L,cli:Z,forceEmpty:K,forceNewWindow:j,forceReuseWindow:H,remoteAuthority:ne})}openExistingWindow(L,N){L.focus(),this.handleWaitMarkerFile(N,[L])}async open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const N=[],Z=[],ne=[],K=[],H=[];let j,q=0;const re=await this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",re);for(const Ee of re)V(Ee)?L.addMode?N.push(Ee):Z.push(Ee):ae(Ee)?ne.push(Ee):Ee.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ee.remoteAuthority}),j.filesToOpenOrCreate.push(Ee)):Ee.backupPath?H.push({backupFolder:(0,g.basename)(Ee.backupPath),remoteAuthority:Ee.remoteAuthority}):q++;L.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),L.mergeMode&&j&&j.filesToOpenOrCreate.length===4&&(j.filesToMerge=j.filesToOpenOrCreate.slice(0,4),j.filesToOpenOrCreate=[],j.filesToDiff=[]),j&&L.waitMarkerFileURI&&(j.filesToWait={paths:(0,k.coalesce)([...j.filesToDiff,j.filesToMerge[3],...j.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(K.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),ne.push(...K),H.push(...this.backupMainService.getEmptyWindowBackups())):H.length=0;const{windows:he,filesOpenedInWindow:me}=await this.doOpen(L,ne,Z,H,q,j,N);if(this.logService.trace(`windowsManager#open used window count ${he.length} (workspacesToOpen: ${ne.length}, foldersToOpen: ${Z.length}, emptyToRestore: ${H.length}, emptyToOpen: ${q})`),he.length>1)if(me)me.focus();else{const Ee=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Pe=!0,We=!0;if(Ee){const ve=he.filter(J=>this.windowsStateHandler.state.lastActiveWindow&&J.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ve.length&&(ve[0].focus(),Pe=!1,We=!1)}if(Pe)for(let ve=he.length-1;ve>=0;ve--){const J=he[ve];if(!(J.openedWorkspace&&K.some(de=>J.openedWorkspace&&de.workspace.id===J.openedWorkspace.id)||J.backupPath&&H.some(de=>J.backupPath&&de.backupFolder===(0,g.basename)(J.backupPath)))){J.focus(),We=!1;break}}We&&he[he.length-1].focus()}const pe=j&&j.filesToDiff.length>0,ye=j&&j.filesToMerge.length>0;if(!he.some(Ee=>Ee.isExtensionDevelopmentHost)&&!pe&&!ye&&!L.noRecentEntry){const Ee=[];for(const Pe of re)ae(Pe)&&!Pe.transient?Ee.push({label:Pe.label,workspace:Pe.workspace,remoteAuthority:Pe.remoteAuthority}):V(Pe)?Ee.push({label:Pe.label,folderUri:Pe.workspace.uri,remoteAuthority:Pe.remoteAuthority}):Pe.fileUri&&Ee.push({label:Pe.label,fileUri:Pe.fileUri,remoteAuthority:Pe.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Ee)}return this.handleWaitMarkerFile(L,he),he}handleWaitMarkerFile(L,N){const Z=L.waitMarkerFileURI;L.context===0&&Z&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.fileService.del(Z)}catch{}})()}async doOpen(L,N,Z,ne,K,H,j){const q=[];let re;function he(ve,J){q.push(ve),J&&(re=ve,H=void 0)}let{openFolderInNewWindow:me,openFilesInNewWindow:pe}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&j.length>0){const ve=j[0].remoteAuthority,J=this.getLastActiveWindowForAuthority(ve);J&&he(this.doAddFoldersToExistingWindow(J,j.map(de=>de.workspace.uri)))}const ye=Z.length+N.length+ne.length;if(H&&ye===0){const ve=H.filesToOpenOrCreate[0]||H.filesToDiff[0]||H.filesToMerge[3],J=this.getWindows().filter(ge=>H&&(0,m.isEqualAuthority)(ge.remoteAuthority,H.remoteAuthority));let de;ve?.fileUri&&!pe&&((L.context===4||L.context===0||L.context===1)&&(de=await(0,x.findWindowOnFile)(J,ve.fileUri,async ge=>ge.configPath.scheme===b.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(ge.configPath):void 0)),de||(de=this.doGetLastActiveWindow(J))),de?(0,ue.isWorkspaceIdentifier)(de.openedWorkspace)?N.push({workspace:de.openedWorkspace,remoteAuthority:de.remoteAuthority}):(0,ue.isSingleFolderWorkspaceIdentifier)(de.openedWorkspace)?Z.push({workspace:de.openedWorkspace,remoteAuthority:de.remoteAuthority}):he(this.doOpenFilesInExistingWindow(L,de,H),!0):he(await this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:H,forceNewWindow:!0,remoteAuthority:H.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile}),!0)}const Ee=(0,k.distinct)(N,ve=>ve.workspace.id);if(Ee.length>0){const ve=(0,k.coalesce)(Ee.map(J=>(0,x.findWindowOnWorkspaceOrFolder)(this.getWindows(),J.workspace.configPath)));if(ve.length>0){const J=ve[0],de=(0,m.isEqualAuthority)(H?.remoteAuthority,J.remoteAuthority)?H:void 0;he(this.doOpenFilesInExistingWindow(L,J,de),!!de),me=!0}for(const J of Ee){if(ve.some(ke=>ke.openedWorkspace&&ke.openedWorkspace.id===J.workspace.id))continue;const de=J.remoteAuthority,ge=(0,m.isEqualAuthority)(H?.remoteAuthority,de)?H:void 0;he(await this.doOpenFolderOrWorkspace(L,J,me,ge),!!ge),me=!0}}const Pe=(0,k.distinct)(Z,ve=>m.extUriBiasedIgnorePathCase.getComparisonKey(ve.workspace.uri));if(Pe.length>0){const ve=(0,k.coalesce)(Pe.map(J=>(0,x.findWindowOnWorkspaceOrFolder)(this.getWindows(),J.workspace.uri)));if(ve.length>0){const J=ve[0],de=(0,m.isEqualAuthority)(H?.remoteAuthority,J.remoteAuthority)?H:void 0;he(this.doOpenFilesInExistingWindow(L,J,de),!!de),me=!0}for(const J of Pe){if(ve.some(ke=>(0,ue.isSingleFolderWorkspaceIdentifier)(ke.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(ke.openedWorkspace.uri,J.workspace.uri)))continue;const de=J.remoteAuthority,ge=(0,m.isEqualAuthority)(H?.remoteAuthority,de)?H:void 0;he(await this.doOpenFolderOrWorkspace(L,J,me,ge),!!ge),me=!0}}const We=(0,k.distinct)(ne,ve=>ve.backupFolder);if(We.length>0)for(const ve of We){const J=ve.remoteAuthority,de=(0,m.isEqualAuthority)(H?.remoteAuthority,J)?H:void 0;he(await this.doOpenEmpty(L,!0,J,de,ve),!!de),me=!0}if(q.length===0||H){H&&!K&&K++;const ve=H?H.remoteAuthority:L.remoteAuthority;for(let J=0;J<K;J++)he(await this.doOpenEmpty(L,me,ve,H),!!H),me=!0}return{windows:(0,k.distinct)(q),filesOpenedInWindow:re}}doOpenFilesInExistingWindow(L,N,Z){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:Z}),this.focusMainOrChildWindow(N);const ne={filesToOpenOrCreate:Z?.filesToOpenOrCreate,filesToDiff:Z?.filesToDiff,filesToMerge:Z?.filesToMerge,filesToWait:Z?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",P.CancellationToken.None,ne),N}focusMainOrChildWindow(L){let N=L;const Z=n.BrowserWindow.getFocusedWindow();if(Z&&Z.id!==L.id){const ne=this.auxiliaryWindowsMainService.getWindowByWebContents(Z.webContents);ne&&ne.parentId===L.id&&(N=ne)}N.focus()}doAddFoldersToExistingWindow(L,N){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),L.focus();const Z={foldersToAdd:N};return L.sendWhenReady("vscode:addFolders",P.CancellationToken.None,Z),L}doOpenEmpty(L,N,Z,ne,K){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!K,remoteAuthority:Z,filesToOpen:ne,forceNewWindow:N});let H;return!N&&typeof L.contextWindowId=="number"&&(H=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:Z,forceNewWindow:N,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:ne,windowToUse:H,emptyWindowBackupInfo:K,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}doOpenFolderOrWorkspace(L,N,Z,ne,K){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:ne}),!Z&&!K&&typeof L.contextWindowId=="number"&&(K=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:N.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:Z,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:ne,windowToUse:K,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}async getPathsToOpen(L){let N,Z=!1,ne=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(N=await this.doExtractPathsFromAPI(L),Z=!0):L.forceEmpty?N=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(N=await this.doExtractPathsFromCLI(L.cli),N.length===0&&N.push(Object.create(null)),Z=!0):(N=await this.doGetPathsFromLastSession(),N.length===0&&N.push(Object.create(null)),ne=!0),!L.addMode&&Z){const K=N.filter(H=>V(H));if(K.length>1){const H=K[0].remoteAuthority;if(K.every(j=>(0,m.isEqualAuthority)(j.remoteAuthority,H))){const j=await this.workspacesManagementMainService.createUntitledWorkspace(K.map(q=>({uri:q.workspace.uri})));N.push({workspace:j,remoteAuthority:H}),N=N.filter(q=>!V(q))}}}if(L.initialStartup&&!ne&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const K=await this.doGetPathsFromLastSession();N.unshift(...K.filter(H=>ae(H)||V(H)||H.backupPath))}return N}async doExtractPathsFromAPI(L){const N={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority},Z=await Promise.all((0,k.coalesce)(L.urisToOpen||[]).map(async ne=>{const K=await this.resolveOpenable(ne,N);if(K)return K.label=ne.label,K;const H=this.resourceFromOpenable(ne);this.dialogMainService.showMessageBox({type:"info",buttons:[(0,E.localize)(0,null)],message:H.scheme===b.Schemas.file?(0,E.localize)(1,null):(0,E.localize)(2,null),detail:H.scheme===b.Schemas.file?(0,E.localize)(3,null,(0,f.getPathLabel)(H,{os:y.OS,tildify:this.environmentMainService})):(0,E.localize)(4,null,H.toString(!0))},n.BrowserWindow.getFocusedWindow()??void 0)}));return(0,k.coalesce)(Z)}async doExtractPathsFromCLI(L){const N=[],Z={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},ne=L["folder-uri"];if(ne){const j=await Promise.all(ne.map(q=>{const re=this.cliArgToUri(q);if(re)return this.resolveOpenable({folderUri:re},Z)}));N.push(...(0,k.coalesce)(j))}const K=L["file-uri"];if(K){const j=await Promise.all(K.map(q=>{const re=this.cliArgToUri(q);if(re)return this.resolveOpenable((0,ue.hasWorkspaceFileExtension)(q)?{workspaceUri:re}:{fileUri:re},Z)}));N.push(...(0,k.coalesce)(j))}const H=await Promise.all(L._.map(j=>Z.remoteAuthority?this.doResolveRemotePath(j,Z):this.doResolveFilePath(j,Z)));return N.push(...(0,k.coalesce)(H)),N}cliArgToUri(L){try{const N=v.URI.parse(L);if(!N.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return N.path?N:N.with({path:"/"})}catch(N){this.logService.error(`Invalid URI input string: ${L}, ${N.message}`)}}async doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];L!=="one"&&N.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&N.push(this.windowsStateHandler.state.lastActiveWindow);const Z=await Promise.all(N.map(async ne=>{if(ne.workspace){const K=await this.resolveOpenable({workspaceUri:ne.workspace.configPath},{remoteAuthority:ne.remoteAuthority,rejectTransientWorkspaces:!0});if(ae(K))return K}else if(ne.folderUri){const K=await this.resolveOpenable({folderUri:ne.folderUri},{remoteAuthority:ne.remoteAuthority});if(V(K))return K}else if(L!=="folders"&&ne.backupPath)return{backupPath:ne.backupPath,remoteAuthority:ne.remoteAuthority}}));return(0,k.coalesce)(Z)}}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}async resolveOpenable(L,N=Object.create(null)){const Z=this.resourceFromOpenable(L);return Z.scheme===b.Schemas.file?((0,O.isFileToOpen)(L)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(Z.fsPath,N)):this.doResolveRemoteOpenable(L,N)}doResolveRemoteOpenable(L,N){let Z=this.resourceFromOpenable(L);const ne=(0,D.getRemoteAuthority)(Z)||N.remoteAuthority;if(Z=(0,m.removeTrailingPathSeparator)((0,m.normalizePath)(Z)),(0,O.isFileToOpen)(L)){if(N.gotoLineMode){const{path:K,line:H,column:j}=(0,l.parseLineAndColumnAware)(Z.path);return{fileUri:Z.with({path:K}),options:{selection:H?{startLineNumber:H,startColumn:j||1}:void 0},remoteAuthority:ne}}return{fileUri:Z,remoteAuthority:ne}}else if((0,O.isWorkspaceToOpen)(L))return{workspace:(0,ee.getWorkspaceIdentifier)(Z),remoteAuthority:ne};return{workspace:(0,ee.getSingleFolderWorkspaceIdentifier)(Z),remoteAuthority:ne}}resourceFromOpenable(L){return(0,O.isWorkspaceToOpen)(L)?L.workspaceUri:(0,O.isFolderToOpen)(L)?L.folderUri:L.fileUri}async doResolveFilePath(L,N,Z){let ne,K;N.gotoLineMode&&({path:L,line:ne,column:K}=(0,l.parseLineAndColumnAware)(L)),L=(0,l.sanitizeFilePath)((0,g.normalize)(L),(0,w.cwd)());try{const H=await R.Promises.stat(L);if(H.isFile()){if(!N.forceOpenWorkspaceAsFile){const j=await this.workspacesManagementMainService.resolveLocalWorkspace(v.URI.file(L));if(j)return j.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:j.id,configPath:j.configPath},type:i.FileType.File,exists:!0,remoteAuthority:j.remoteAuthority,transient:j.transient}}return{fileUri:v.URI.file(L),type:i.FileType.File,exists:!0,options:{selection:ne?{startLineNumber:ne,startColumn:K||1}:void 0}}}else{if(H.isDirectory())return{workspace:(0,ee.getSingleFolderWorkspaceIdentifier)(v.URI.file(L),H),type:i.FileType.Directory,exists:!0};if(!y.isWindows&&L==="/dev/null")return{fileUri:v.URI.file(L),type:i.FileType.File,exists:!0}}}catch(H){if(H.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!Z)return this.onUNCHostNotAllowed(L,N);const j=v.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([j]),N.ignoreFileNotFound)return{fileUri:j,type:i.FileType.File,exists:!1}}}async onUNCHostNotAllowed(L,N){const Z=v.URI.file(L),{response:ne,checkboxChecked:K}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,E.localize)(5,null),(0,E.localize)(6,null),(0,E.localize)(7,null)],message:(0,E.localize)(8,null,Z.authority),detail:(0,E.localize)(9,null,(0,f.getPathLabel)(Z,{os:y.OS,tildify:this.environmentMainService})),checkboxLabel:(0,E.localize)(10,null,Z.authority),cancelId:1});if(ne===0){if((0,I.addUNCHostToAllowlist)(Z.authority),K){const H={channel:"vscode:configureAllowedUNCHost",args:Z.authority};this.sendToFocused(H.channel,H.args),this.sendToOpeningWindow(H.channel,H.args)}return this.doResolveFilePath(L,N,!0)}if(ne===2)return n.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.onUNCHostNotAllowed(L,N)}doResolveRemotePath(L,N){const Z=L.charCodeAt(0),ne=N.remoteAuthority;let K,H;N.gotoLineMode&&({path:L,line:K,column:H}=(0,l.parseLineAndColumnAware)(L)),Z!==47&&((0,l.isWindowsDriveLetter)(Z)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,l.toSlashes)(L)),L=`/${L}`);const j=v.URI.from({scheme:b.Schemas.vscodeRemote,authority:ne,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,ue.hasWorkspaceFileExtension)(L))return N.forceOpenWorkspaceAsFile?{fileUri:j,options:{selection:K?{startLineNumber:K,startColumn:H||1}:void 0},remoteAuthority:N.remoteAuthority}:{workspace:(0,ee.getWorkspaceIdentifier)(j),remoteAuthority:ne};if(N.gotoLineMode||g.posix.basename(L).indexOf(".")!==-1)return{fileUri:j,options:{selection:K?{startLineNumber:K,startColumn:H||1}:void 0},remoteAuthority:ne}}return{workspace:(0,ee.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:ne}}shouldOpenNewWindow(L){const N=this.configurationService.getValue("window"),Z=N?.openFoldersInNewWindow||"default",ne=N?.openFilesInNewWindow||"off";let K=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(Z==="on"||Z==="off")&&(K=Z==="on");let H=!1;return L.forceNewWindow||L.forceReuseWindow?H=!!L.forceNewWindow&&!L.forceReuseWindow:(y.isMacintosh?L.context===1&&(H=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(H=!0),!L.cli.extensionDevelopmentPath&&(ne==="on"||ne==="off")&&(H=ne==="on")),{openFolderInNewWindow:!!K,openFilesInNewWindow:H}}async openExtensionDevelopmentHostWindow(L,N){const Z=(0,x.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(Z)return this.lifecycleMainService.reload(Z,N.cli),Z.focus(),[Z];let ne=N.cli["folder-uri"]||[],K=N.cli["file-uri"]||[],H=N.cli._;if(!H.length&&!ne.length&&!K.length&&!N.cli.extensionTestsPath){const re=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,he=re?.workspace??re?.folderUri;he&&(v.URI.isUri(he)?he.scheme===b.Schemas.file?H=[he.fsPath]:ne=[he.toString()]:he.configPath.scheme===b.Schemas.file?H=[(0,m.originalFSPath)(he.configPath)]:K=[he.configPath.toString()])}let j=N.remoteAuthority;for(const re of L)if(re.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const he=v.URI.parse(re),me=(0,D.getRemoteAuthority)(he);me&&(j?(0,m.isEqualAuthority)(me,j)||this.logService.error("more than one extension development path authority"):j=me)}H=H.filter(re=>{const he=v.URI.file(re);return(0,x.findWindowOnWorkspaceOrFolder)(this.getWindows(),he)?!1:(0,m.isEqualAuthority)((0,D.getRemoteAuthority)(he),j)}),ne=ne.filter(re=>{const he=this.cliArgToUri(re);return he&&(0,x.findWindowOnWorkspaceOrFolder)(this.getWindows(),he)?!1:he?(0,m.isEqualAuthority)((0,D.getRemoteAuthority)(he),j):!1}),K=K.filter(re=>{const he=this.cliArgToUri(re);return he&&(0,x.findWindowOnWorkspaceOrFolder)(this.getWindows(),he)?!1:he?(0,m.isEqualAuthority)((0,D.getRemoteAuthority)(he),j):!1}),N.cli._=H,N.cli["folder-uri"]=ne,N.cli["file-uri"]=K;const q={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:!H.length&&!ne.length&&!K.length,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:j,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile};return this.open(q)}async openInBrowserWindow(L){const N=this.configurationService.getValue("window"),Z=this.getLastActiveWindow(),ne=Z?.profile??this.userDataProfilesMainService.defaultProfile;let K;!L.forceNewWindow&&!L.forceNewTabbedWindow&&(K=L.windowToUse||Z,K&&K.focus());const H={...this.environmentMainService.args,...L.cli,machineId:this.machineId,sqmId:this.sqmId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,g.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.userDataProfilesMainService.profilesHome,all:this.userDataProfilesMainService.profiles,profile:ne},homeDir:this.environmentMainService.userHome.with({scheme:b.Schemas.file}).fsPath,tmpDir:this.environmentMainService.tmpDir.with({scheme:b.Schemas.file}).fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.loggerService.getLogLevel(),loggers:{window:[],global:this.loggerService.getRegisteredLoggers()},logsPath:this.environmentMainService.logsHome.with({scheme:b.Schemas.file}).fsPath,product:C.default,isInitialStartup:L.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,A.release)(),hostname:(0,A.hostname)(),arch:(0,A.arch)()},autoDetectHighContrast:N?.autoDetectHighContrast??!0,autoDetectColorScheme:N?.autoDetectColorScheme??!1,accessibilitySupport:n.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};if(K){const j=K.config;!H.extensionDevelopmentPath&&j?.extensionDevelopmentPath&&(H.extensionDevelopmentPath=j.extensionDevelopmentPath,H.extensionDevelopmentKind=j.extensionDevelopmentKind,H["enable-proposed-api"]=j["enable-proposed-api"],H.verbose=j.verbose,H["inspect-extensions"]=j["inspect-extensions"],H["inspect-brk-extensions"]=j["inspect-brk-extensions"],H.debugId=j.debugId,H.extensionEnvironment=j.extensionEnvironment,H["extensions-dir"]=j["extensions-dir"],H["disable-extensions"]=j["disable-extensions"]),H.loggers={global:H.loggers.global,window:j?.loggers.window??H.loggers.window}}else{const j=this.windowsStateHandler.getNewWindowState(H);(0,d.mark)("code/willCreateCodeWindow");const q=K=this.instantiationService.createInstance(_.CodeWindow,{state:j,extensionDevelopmentPath:H.extensionDevelopmentPath,isExtensionTestHost:!!H.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(q),this.windows.set(q.id,q),this._onDidOpenWindow.fire(q),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const re=new S.DisposableStore;re.add(q.onDidSignalReady(()=>this._onDidSignalReadyWindow.fire(q))),re.add(h.Event.once(q.onDidClose)(()=>this.onWindowClosed(q,re))),re.add(h.Event.once(q.onDidDestroy)(()=>this.onWindowDestroyed(q))),re.add(q.onDidMaximize(()=>this._onDidMaximizeWindow.fire(q))),re.add(q.onDidUnmaximize(()=>this._onDidUnmaximizeWindow.fire(q))),re.add(q.onDidEnterFullScreen(()=>this._onDidChangeFullScreen.fire({window:q,fullscreen:!0}))),re.add(q.onDidLeaveFullScreen(()=>this._onDidChangeFullScreen.fire({window:q,fullscreen:!1}))),re.add(q.onDidTriggerSystemContextMenu(({x:me,y:pe})=>this._onDidTriggerSystemContextMenu.fire({window:q,x:me,y:pe})));const he=(0,c.assertIsDefined)(q.win?.webContents);he.removeAllListeners("devtools-reload-page"),re.add(h.Event.fromNodeEventEmitter(he,"devtools-reload-page")(()=>this.lifecycleMainService.reload(q))),this.lifecycleMainService.registerWindow(q)}return H.windowId=K.id,K.isReady?this.lifecycleMainService.unload(K,4).then(async j=>{j||await this.doOpenInBrowserWindow(K,H,L,ne)}):await this.doOpenInBrowserWindow(K,H,L,ne),K}async doOpenInBrowserWindow(L,N,Z,ne){if(N.extensionDevelopmentPath||((0,ue.isWorkspaceIdentifier)(N.workspace)?N.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:N.workspace,remoteAuthority:N.remoteAuthority}):(0,ue.isSingleFolderWorkspaceIdentifier)(N.workspace)?N.backupPath=this.backupMainService.registerFolderBackup({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority}):N.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:Z.emptyWindowBackupInfo?.backupFolder??(0,ee.createEmptyWorkspaceIdentifier)().id,remoteAuthority:N.remoteAuthority})),this.userDataProfilesMainService.isEnabled()){const K=N.workspace??(0,ue.toWorkspaceIdentifier)(N.backupPath,!1),H=this.resolveProfileForBrowserWindow(Z,K,ne),j=H instanceof Promise?await H:H;N.profiles.profile=j,N.extensionDevelopmentPath||await this.userDataProfilesMainService.setProfileForWorkspace(K,j)}L.load(N)}resolveProfileForBrowserWindow(L,N,Z){return L.forceProfile?this.userDataProfilesMainService.profiles.find(ne=>ne.name===L.forceProfile)??this.userDataProfilesMainService.createNamedProfile(L.forceProfile):L.forceTempProfile?this.userDataProfilesMainService.createTransientProfile():this.userDataProfilesMainService.getProfileForWorkspace(N)??Z}onWindowClosed(L,N){this.windows.delete(L.id),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),N.dispose()}onWindowDestroyed(L){this.windows.delete(L.id),this._onDidDestroyWindow.fire(L)}getFocusedWindow(){const L=n.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(N=>(0,m.isEqualAuthority)(N.remoteAuthority,L)))}doGetLastActiveWindow(L){return(0,F.getLastFocused)(L)}sendToFocused(L,...N){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,P.CancellationToken.None,...N)}sendToOpeningWindow(L,...N){this._register(h.Event.once(this.onDidSignalReadyWindow)(Z=>{Z.sendWhenReady(L,P.CancellationToken.None,...N)}))}sendToAll(L,N,Z){for(const ne of this.getWindows())Z&&Z.indexOf(ne.id)>=0||ne.sendWhenReady(L,P.CancellationToken.None,N)}getWindows(){return Array.from(this.windows.values())}getWindowCount(){return this.windows.size}getWindowById(L){return this.windows.get(L)}getWindowByWebContents(L){const N=n.BrowserWindow.fromWebContents(L);if(!N)return;const Z=this.getWindowById(N.id);return Z?.matches(L)?Z:void 0}};e.WindowsMainService=ce,e.WindowsMainService=ce=Ie([ie(3,p.ILogService),ie(4,U.ILoggerMainService),ie(5,W.IStateService),ie(6,B.IPolicyService),ie(7,r.IEnvironmentMainService),ie(8,T.IUserDataProfilesMainService),ie(9,u.ILifecycleMainService),ie(10,a.IBackupMainService),ie(11,t.IConfigurationService),ie(12,le.IWorkspacesHistoryMainService),ie(13,Y.IWorkspacesManagementMainService),ie(14,o.IInstantiationService),ie(15,s.IDialogMainService),ie(16,i.IFileService),ie(17,M.IProtocolMainService),ie(18,G.IThemeMainService),ie(19,$.IAuxiliaryWindowsMainService)],ce)}),define(se[311],oe([0,1,65,29,85,58]),function(Q,e,n,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let k=class{constructor(h,l,f,S){this.workspacesManagementMainService=h,this.windowsMainService=l,this.workspacesHistoryMainService=f,this.backupMainService=S,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(h,l){const f=this.windowsMainService.getWindowById(h);if(f)return this.workspacesManagementMainService.enterWorkspace(f,this.windowsMainService.getWindows(),l)}createUntitledWorkspace(h,l,f){return this.workspacesManagementMainService.createUntitledWorkspace(l,f)}deleteUntitledWorkspace(h,l){return this.workspacesManagementMainService.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(h,l){return this.workspacesManagementMainService.getWorkspaceIdentifier(l)}getRecentlyOpened(h){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(h,l){return this.workspacesHistoryMainService.addRecentlyOpened(l)}removeRecentlyOpened(h,l){return this.workspacesHistoryMainService.removeRecentlyOpened(l)}clearRecentlyOpened(h){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};e.WorkspacesMainService=k,e.WorkspacesMainService=k=Ie([ie(0,A.IWorkspacesManagementMainService),ie(1,R.IWindowsMainService),ie(2,I.IWorkspacesHistoryMainService),ie(3,n.IBackupMainService)],k)}),define(se[312],oe([0,1,14,102,37,26,17,47,15,31,3,42,48,2,13,9,4,12,7,33,160,44,161,114,294,164,65,287,18,203,92,134,56,120,224,24,64,95,212,297,214,215,216,16,228,94,78,6,93,223,303,288,295,20,5,309,70,27,68,298,96,34,279,84,126,28,255,257,54,50,269,292,304,293,305,131,271,272,273,276,301,55,29,310,278,30,98,85,311,58,39,237,57,248,53,83,132,281,296,284,8,259,280,232,67,300,275,22,129,299,267,243,62,79,307,72]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y,w,m,c,v,E,a,t,s,r,i,o,u,p,C,M,D,W,O,_,F,x,z,ue,ee,le,Y,G,B,T,U,$,ae,V,ce,X,L,N,Z,ne,K,H,j,q,re,he,me,pe,ye,Ee,Pe,We,ve,J,de,ge,ke,Ae,Be,Te,Fe,$e,He,Ke,xe,te,fe,we,be,Ce,Oe,Ue,Ge,Je,Xe,Ye,rt,it,ot,at,bt,Et,Pt,It,Ct,lt,gt,kt,Dt,Mt,ct,Rt,mt,ut,Lt,At,ht,Wt,pt,Ot,vt){"use strict";var dt;Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let ft=class extends g.Disposable{static{dt=this}static{this.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY={[d.Schemas.file]:"security.promptForLocalFileProtocolHandling",[d.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(De,Me,Le,Se,Re,ze,qe,Ve,_e,Ne,je,Qe){super(),this.mainProcessNodeIpcServer=De,this.userEnv=Me,this.mainInstantiationService=Le,this.logService=Se,this.loggerService=Re,this.environmentMainService=ze,this.lifecycleMainService=qe,this.configurationService=Ve,this.stateService=_e,this.fileService=Ne,this.productService=je,this.userDataProfilesMainService=Qe,this.configureSession(),this.registerListeners()}configureSession(){const De=_e=>_e?.startsWith(`${d.Schemas.vscodeWebview}://`),Me=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((_e,Ne,je,Qe)=>De(Qe.requestingUrl)?je(Me.has(Ne)):je(!1)),n.session.defaultSession.setPermissionCheckHandler((_e,Ne,je,Qe)=>De(Qe.requestingUrl)?Me.has(Ne):!1);const Le=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,d.Schemas.vscodeManagedRemoteResource,"devtools"]),Se=_e=>{for(let Ne=_e;Ne;Ne=Ne.parent)if(Ne.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},Re=_e=>_e.resourceType==="xhr"||Se(_e.frame),ze=_e=>{const Ne=_e.frame;if(!Ne||!this.windowsMainService)return!1;const je=n.BrowserWindow.getAllWindows();for(const Qe of je)if(Ne.processId===Qe.webContents.mainFrame.processId)return!0;return!1},qe=(_e,Ne)=>{if(_e.path!=="/index.html")return!0;const je=Ne.frame;if(!je||!this.windowsMainService)return!1;for(const Qe of this.windowsMainService.getWindows())if(Qe.win&&je.processId===Qe.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((_e,Ne)=>{const je=c.URI.parse(_e.url);return je.scheme===d.Schemas.vscodeWebview&&!qe(je,_e)?(this.logService.error("Blocked vscode-webview request",_e.url),Ne({cancel:!0})):je.scheme===d.Schemas.vscodeFileResource&&!ze(_e)?(this.logService.error("Blocked vscode-file request",_e.url),Ne({cancel:!0})):je.path.endsWith(".svg")&&!Le.has(je.scheme)?Ne({cancel:!Re(_e)}):Ne({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((_e,Ne)=>{const je=_e.responseHeaders,Qe=je["content-type"]||je["Content-Type"];if(Qe&&Array.isArray(Qe)){const Ze=c.URI.parse(_e.url);if(Ze.path.endsWith(".svg")&&Le.has(Ze.scheme))return je["Content-Type"]=["image/svg+xml"],Ne({cancel:!1,responseHeaders:je});if(!Ze.path.endsWith(d.Schemas.vscodeRemoteResource)&&Qe.some(nt=>nt.toLowerCase().includes("image/svg")))return Ne({cancel:!Re(_e)})}return Ne({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((_e,Ne)=>{if(_e.url.startsWith("https://vscode.download.prss.microsoft.com/")){const je=_e.responseHeaders??Object.create(null);if(je["Access-Control-Allow-Origin"]===void 0)return je["Access-Control-Allow-Origin"]=["*"],Ne({cancel:!1,responseHeaders:je})}return Ne({cancel:!1})});const Ve=n.session.defaultSession;typeof Ve.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ve.setCodeCachePath((0,y.join)(this.environmentMainService.codeCachePath,"chrome")),w.isWindows&&(this.configurationService.getValue("security.restrictUNCAccess")===!1?(0,R.disableUNCAccessRestrictions)():(0,R.addUNCHostToAllowlist)(this.configurationService.getValue("security.allowedUNCHosts")))}registerListeners(){(0,h.setUnexpectedErrorHandler)(Le=>this.onUnexpectedError(Le)),process.on("uncaughtException",Le=>{(0,h.isSigPipeError)(Le)||(0,h.onUnexpectedError)(Le)}),process.on("unhandledRejection",Le=>(0,h.onUnexpectedError)(Le)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,E.registerContextMenuListener)(),n.app.on("accessibility-support-changed",(Le,Se)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Se)}),n.app.on("activate",async(Le,Se)=>{this.logService.trace("app#activate"),Se||await this.windowsMainService?.openEmptyWindow({context:1})}),n.app.on("web-contents-created",(Le,Se)=>{Se?.opener?.url.startsWith(`${d.Schemas.vscodeFileResource}://${d.VSCODE_AUTHORITY}/`)&&(this.logService.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.auxiliaryWindowsMainService?.registerWindow(Se)),Se.on("will-navigate",Re=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Re.preventDefault()}),Se.setWindowOpenHandler(Re=>Re.url==="about:blank"?(this.logService.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.auxiliaryWindowsMainService?.createWindow(Re)}):(this.logService.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Re.url}}`),this.nativeHostMainService?.openExternal(void 0,Re.url),{action:"deny"}))});let De=[],Me;n.app.on("open-file",(Le,Se)=>{Se=(0,vt.normalizeNFC)(Se),this.logService.trace("app#open-file: ",Se),Le.preventDefault(),De.push((0,Oe.hasWorkspaceFileExtension)(Se)?{workspaceUri:c.URI.file(Se)}:{fileUri:c.URI.file(Se)}),Me!==void 0&&(clearTimeout(Me),Me=void 0),Me=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:De,gotoLineMode:!1,preferNewWindow:!0}),De=[],Me=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),I.validatedIpcMain.handle("vscode:fetchShellEnv",Le=>{const Se=this.windowsMainService?.getWindowByWebContents(Le.sender);let Re,ze;return Se?.config?(Re=Se.config,ze={...process.env,...Se.config.userEnv}):(Re=this.environmentMainService.args,ze=process.env),this.resolveShellEnvironment(Re,ze,!1)}),I.validatedIpcMain.handle("vscode:writeNlsFile",(Le,Se,Re)=>{const ze=this.validateNlsPath([Se]);if(!ze||typeof Re!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(ze,k.VSBuffer.fromString(Re))}),I.validatedIpcMain.handle("vscode:readNlsFile",async(Le,...Se)=>{const Re=this.validateNlsPath(Se);if(!Re)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Re)).value.toString()}),I.validatedIpcMain.on("vscode:toggleDevTools",Le=>Le.sender.toggleDevTools()),I.validatedIpcMain.on("vscode:openDevTools",Le=>Le.sender.openDevTools()),I.validatedIpcMain.on("vscode:reloadWindow",Le=>Le.sender.reload()),I.validatedIpcMain.handle("vscode:notifyZoomLevel",async(Le,Se)=>{const Re=this.windowsMainService?.getWindowByWebContents(Le.sender);Re&&Re.notifyZoomLevel(Se)})}validateNlsPath(De){let Me;for(const Le of De)typeof Le=="string"&&(typeof Me!="string"?Me=Le:Me=(0,y.join)(Me,Le));if(!(typeof Me!="string"||!(0,y.isAbsolute)(Me)||!(0,l.isEqualOrParent)(Me,this.environmentMainService.cachedLanguagesPath,!w.isLinux)))return c.URI.file(Me)}onUnexpectedError(De){if(De){const Me={message:`[uncaught exception in main]: ${De.message}`,stack:De.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Me))}this.logService.error(`[uncaught exception in main]: ${De}`),De.stack&&this.logService.error(De.stack)}async startup(){this.logService.debug("Starting VSCodium"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const De=this.productService.win32AppUserModelId;w.isWindows&&De&&n.app.setAppUserModelId(De);try{w.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.logService.error(Ne)}const Me=new t.Server;this.lifecycleMainService.onWillShutdown(Ne=>{Ne.reason===2&&Me.dispose()}),this.logService.trace("Resolving machine identifier...");const[Le,Se]=await Promise.all([(0,gt.resolveMachineId)(this.stateService,this.logService),(0,gt.resolveSqmId)(this.stateService,this.logService)]);this.logService.trace(`Resolved machine identifier: ${Le}`);const{sharedProcessReady:Re,sharedProcessClient:ze}=this.setupSharedProcess(Le,Se),qe=await this.initServices(Le,Se,Re);this._register(qe.createInstance(r.ProxyAuthHandler)),this._register(qe.createInstance(It.UserDataProfilesHandler)),qe.invokeFunction(Ne=>this.initChannels(Ne,Me,ze));const Ve=await qe.invokeFunction(Ne=>this.setupProtocolUrlHandlers(Ne,Me));this.setupManagedRemoteResourceUrlHandler(Me),this.lifecycleMainService.phase=2,await qe.invokeFunction(Ne=>this.openFirstWindow(Ne,Ve)),this.lifecycleMainService.phase=3,this.afterWindowOpen(),this._register(new lt.RunOnceScheduler(()=>{this._register((0,lt.runWhenGlobalIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}async setupProtocolUrlHandlers(De,Me){const Le=this.windowsMainService=De.get(we.IWindowsMainService),Se=De.get(Fe.IURLService),Re=this.nativeHostMainService=De.get(H.INativeHostMainService),ze=De.get(W.IDialogMainService),qe=this;Se.registerHandler({async handleURL(Ze,nt){return qe.handleProtocolUrl(Le,ze,Se,Ze,nt)}});const Ve=this._register(new Ce.ActiveWindowManager({onDidOpenMainWindow:Re.onDidOpenMainWindow,onDidFocusMainWindow:Re.onDidFocusMainWindow,getActiveWindowId:()=>Re.getActiveWindowId(-1)})),_e=new a.StaticRouter(Ze=>Ve.getActiveClientId().then(nt=>Ze===nt)),Ne=new $e.URLHandlerRouter(_e,this.logService),je=Me.getChannel("urlHandler",Ne);Se.registerHandler(new $e.URLHandlerChannelClient(je));const Qe=await this.resolveInitialProtocolUrls(Le,ze);return this._register(new Ke.ElectronURLListener(Qe?.urls,Se,Le,this.environmentMainService,this.productService,this.logService)),Qe}setupManagedRemoteResourceUrlHandler(De){const Me=()=>({statusCode:404,data:"Not found"}),Le=new Wt.Lazy(()=>De.getChannel(ht.NODE_REMOTE_RESOURCE_CHANNEL_NAME,new ht.NodeRemoteResourceRouter));n.protocol.registerBufferProtocol(d.Schemas.vscodeManagedRemoteResource,(Se,Re)=>{const ze=c.URI.parse(Se.url);if(!ze.authority.startsWith("window:"))return Re(Me());Le.value.call(ht.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME,[ze]).then(qe=>Re({...qe,data:Buffer.from(qe.body,"base64")}),qe=>{this.logService.warn("error dispatching remote resource call",qe),Re({statusCode:500,data:String(qe)})})})}async resolveInitialProtocolUrls(De,Me){const Le=this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[];Le.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Le);const Se=global.getOpenUrls()||[];if(Se.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Se),Le.length+Se.length===0)return;const Re=[...Le,...Se].map(Ve=>{try{return{uri:c.URI.parse(Ve),originalUrl:Ve}}catch{this.logService.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ve);return}}),ze=[],qe=[];for(const Ve of Re){if(!Ve)continue;const _e=this.getWindowOpenableFromProtocolUrl(Ve.uri);if(_e)if(await this.shouldBlockOpenable(_e,De,Me)){this.logService.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ve.uri.toString(!0));continue}else this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ve.uri.toString(!0),_e),ze.push(_e);else this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ve.uri.toString(!0)),qe.push(Ve)}return{urls:qe,openables:ze}}async shouldBlockOpenable(De,Me,Le){let Se,Re;if((0,fe.isWorkspaceToOpen)(De)?(Se=De.workspaceUri,Re=(0,i.localize)(0,null,Se.scheme===d.Schemas.file?(0,b.getPathLabel)(Se,{os:w.OS,tildify:this.environmentMainService}):Se.toString(!0),this.productService.nameShort)):(0,fe.isFolderToOpen)(De)?(Se=De.folderUri,Re=(0,i.localize)(1,null,Se.scheme===d.Schemas.file?(0,b.getPathLabel)(Se,{os:w.OS,tildify:this.environmentMainService}):Se.toString(!0),this.productService.nameShort)):(Se=De.fileUri,Re=(0,i.localize)(2,null,Se.scheme===d.Schemas.file?(0,b.getPathLabel)(Se,{os:w.OS,tildify:this.environmentMainService}):Se.toString(!0),this.productService.nameShort)),Se.scheme!==d.Schemas.file&&Se.scheme!==d.Schemas.vscodeRemote||this.configurationService.getValue(dt.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY[Se.scheme])===!1)return!1;const{response:qe,checkboxChecked:Ve}=await Le.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:Re,detail:(0,i.localize)(5,null),checkboxLabel:Se.scheme===d.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if(qe!==0)return!0;if(Ve){const _e={channel:"vscode:disablePromptForProtocolHandling",args:Se.scheme===d.Schemas.file?"local":"remote"};Me.sendToFocused(_e.channel,_e.args),Me.sendToOpeningWindow(_e.channel,_e.args)}return!1}getWindowOpenableFromProtocolUrl(De){if(De.path){if(De.authority===d.Schemas.file){const Me=c.URI.file(De.fsPath);return(0,Oe.hasWorkspaceFileExtension)(Me)?{workspaceUri:Me}:{fileUri:Me}}else if(De.authority===d.Schemas.vscodeRemote){const Me=De.path.indexOf(y.posix.sep,1);if(Me!==-1){const Le=De.path.substring(1,Me),Se=De.path.substring(Me);let Re=De.query;const ze=new URLSearchParams(De.query);ze.get("windowId")==="_blank"&&(ze.delete("windowId"),Re=ze.toString());const qe=c.URI.from({scheme:d.Schemas.vscodeRemote,authority:Le,path:Se,query:Re,fragment:De.fragment});return(0,Oe.hasWorkspaceFileExtension)(Se)?{workspaceUri:qe}:/:[\d]+$/.test(Se)?{fileUri:qe}:{folderUri:qe}}}}}async handleProtocolUrl(De,Me,Le,Se,Re){this.logService.trace("app#handleProtocolUrl():",Se.toString(!0),Re),Se.scheme===this.productService.urlProtocol&&Se.path==="workspace"&&(Se=Se.with({authority:"file",path:c.URI.parse(Se.query).path,query:""}));let ze=!1;const qe=new URLSearchParams(Se.query);qe.get("windowId")==="_blank"?(this.logService.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Se.toString(!0)),qe.delete("windowId"),Se=Se.with({query:qe.toString()}),ze=!0):w.isMacintosh&&De.getWindowCount()===0&&(this.logService.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Se.toString(!0)),ze=!0);const Ve=qe.get("continueOn");Ve!==null&&(this.logService.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Se.toString(!0)),qe.delete("continueOn"),Se=Se.with({query:qe.toString()}),this.environmentMainService.continueOn=Ve??void 0);const _e=this.getWindowOpenableFromProtocolUrl(Se);return _e?await this.shouldBlockOpenable(_e,De,Me)?(this.logService.trace("app#handleProtocolUrl() protocol url was blocked:",Se.toString(!0)),!0):(this.logService.trace("app#handleProtocolUrl() opening protocol url as window:",_e,Se.toString(!0)),(0,mt.firstOrDefault)(await De.open({context:5,cli:{...this.environmentMainService.args},urisToOpen:[_e],forceNewWindow:ze,gotoLineMode:!0}))?.focus(),!0):ze?(this.logService.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Se.toString(!0)),await(0,mt.firstOrDefault)(await De.open({context:5,cli:{...this.environmentMainService.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,q.getRemoteAuthority)(Se)}))?.ready(),Le.open(Se,Re)):(this.logService.trace("app#handleProtocolUrl(): not handled",Se.toString(!0),Re),!1)}setupSharedProcess(De,Me){const Le=this._register(this.mainInstantiationService.createInstance(re.SharedProcess,De,Me)),Se=(async()=>{this.logService.trace("Main->SharedProcess#connect");const ze=await Le.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new s.Client(ze,"main")})();return{sharedProcessReady:(async()=>(await Le.whenReady(),Se))(),sharedProcessClient:Se}}async initServices(De,Me,Le){const Se=new V.ServiceCollection;switch(process.platform){case"win32":Se.set(de.IUpdateService,new $.SyncDescriptor(Te.Win32UpdateService));break;case"linux":w.isLinuxSnap?Se.set(de.IUpdateService,new $.SyncDescriptor(Be.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Se.set(de.IUpdateService,new $.SyncDescriptor(Ae.LinuxUpdateService));break;case"darwin":Se.set(de.IUpdateService,new $.SyncDescriptor(ke.DarwinUpdateService));break}Se.set(we.IWindowsMainService,new $.SyncDescriptor(be.WindowsMainService,[De,Me,this.userEnv],!1)),Se.set(pt.IAuxiliaryWindowsMainService,new $.SyncDescriptor(Ot.AuxiliaryWindowsMainService,void 0,!1));const Re=new W.DialogMainService(this.logService,this.productService);Se.set(W.IDialogMainService,Re),Se.set(N.ILaunchMainService,new $.SyncDescriptor(N.LaunchMainService,void 0,!1)),Se.set(D.IDiagnosticsMainService,new $.SyncDescriptor(D.DiagnosticsMainService,void 0,!1)),Se.set(M.IDiagnosticsService,a.ProxyChannel.toService((0,a.getDelayedChannel)(Le.then(Ne=>Ne.getChannel("diagnostics"))))),Se.set(ce.IIssueMainService,new $.SyncDescriptor(X.IssueMainService,[this.userEnv])),Se.set(O.IEncryptionMainService,new $.SyncDescriptor(_.EncryptionMainService)),Se.set(L.IKeyboardLayoutMainService,new $.SyncDescriptor(L.KeyboardLayoutMainService)),Se.set(H.INativeHostMainService,new $.SyncDescriptor(H.NativeHostMainService,void 0,!1)),Se.set(xe.IWebviewManagerService,new $.SyncDescriptor(te.WebviewMainService)),Se.set(K.IMenubarMainService,new $.SyncDescriptor(K.MenubarMainService)),Se.set(ue.IExtensionHostStarter,new $.SyncDescriptor(ee.ExtensionHostStarter)),Se.set(ye.IStorageMainService,new $.SyncDescriptor(ye.StorageMainService)),Se.set(ye.IApplicationStorageMainService,new $.SyncDescriptor(ye.ApplicationStorageMainService));const ze=new Lt.ElectronPtyHostStarter({graceTime:6e4,shortGraceTime:6e3,scrollback:this.configurationService.getValue("terminal.integrated.persistentSessionScrollback")??100},this.configurationService,this.environmentMainService,this.lifecycleMainService,this.logService),qe=new At.PtyHostService(ze,this.configurationService,this.logService,this.loggerService);Se.set(ut.ILocalPtyService,qe),w.isWindows?Se.set(le.IExternalTerminalMainService,new $.SyncDescriptor(Y.WindowsExternalTerminalService)):w.isMacintosh?Se.set(le.IExternalTerminalMainService,new $.SyncDescriptor(Y.MacExternalTerminalService)):w.isLinux&&Se.set(le.IExternalTerminalMainService,new $.SyncDescriptor(Y.LinuxExternalTerminalService));const Ve=new u.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateService);Se.set(o.IBackupMainService,Ve);const _e=new Xe.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,Ve,Re);if(Se.set(Xe.IWorkspacesManagementMainService,_e),Se.set(Ue.IWorkspacesService,new $.SyncDescriptor(Je.WorkspacesMainService,void 0,!1)),Se.set(Ge.IWorkspacesHistoryMainService,new $.SyncDescriptor(Ge.WorkspacesHistoryMainService,void 0,!1)),Se.set(Fe.IURLService,new $.SyncDescriptor(He.NativeURLService,void 0,!1)),(0,J.supportsTelemetry)(this.productService,this.environmentMainService)){const Ne=(0,J.isInternalTelemetry)(this.productService,this.configurationService),je=(0,a.getDelayedChannel)(Le.then(st=>st.getChannel("telemetryAppender"))),Qe=new We.TelemetryAppenderClient(je),Ze=(0,Ee.resolveCommonProperties)((0,A.release)(),(0,A.hostname)(),process.arch,this.productService.commit,this.productService.version,De,Me,Ne),nt=(0,J.getPiiPathsFromEnvironment)(this.environmentMainService),et={appenders:[Qe],commonProperties:Ze,piiPaths:nt,sendErrorTelemetry:!0};Se.set(Pe.ITelemetryService,new $.SyncDescriptor(ve.TelemetryService,[et],!1))}else Se.set(Pe.ITelemetryService,J.NullTelemetryService);return Se.set(bt.IExtensionsProfileScannerService,new $.SyncDescriptor(kt.ExtensionsProfileScannerService,void 0,!0)),Se.set(Et.IExtensionsScannerService,new $.SyncDescriptor(Pt.ExtensionsScannerService,void 0,!0)),Se.set(ct.IUtilityProcessWorkerMainService,new $.SyncDescriptor(ct.UtilityProcessWorkerMainService,void 0,!0)),await lt.Promises.settled([Ve.initialize(),_e.initialize()]),this.mainInstantiationService.createChild(Se)}initChannels(De,Me,Le){const Se=this._register(new g.DisposableStore),Re=a.ProxyChannel.fromService(De.get(N.ILaunchMainService),Se,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Re);const ze=a.ProxyChannel.fromService(De.get(D.IDiagnosticsMainService),Se,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",ze);const qe=new rt.PolicyChannel(De.get(Ye.IPolicyService));Me.registerChannel("policy",qe),Le.then(tt=>tt.registerChannel("policy",qe));const Ve=this.fileService.getProvider(d.Schemas.file);(0,m.assertType)(Ve instanceof U.DiskFileSystemProvider);const _e=new T.DiskFileSystemProviderChannel(Ve,this.logService,this.environmentMainService);Me.registerChannel(G.LOCAL_FILE_SYSTEM_CHANNEL_NAME,_e),Le.then(tt=>tt.registerChannel(G.LOCAL_FILE_SYSTEM_CHANNEL_NAME,_e));const Ne=a.ProxyChannel.fromService(De.get(it.IUserDataProfilesMainService),Se);Me.registerChannel("userDataProfiles",Ne),Le.then(tt=>tt.registerChannel("userDataProfiles",Ne));const je=new ot.RequestChannel(De.get(at.IRequestService));Le.then(tt=>tt.registerChannel("request",je));const Qe=new ge.UpdateChannel(De.get(de.IUpdateService));Me.registerChannel("update",Qe);const Ze=a.ProxyChannel.fromService(De.get(ce.IIssueMainService),Se);Me.registerChannel("issue",Ze);const nt=a.ProxyChannel.fromService(De.get(O.IEncryptionMainService),Se);Me.registerChannel("encryption",nt);const et=a.ProxyChannel.fromService(De.get(he.ISignService),Se);Me.registerChannel("sign",et);const st=a.ProxyChannel.fromService(De.get(L.IKeyboardLayoutMainService),Se);Me.registerChannel("keyboardLayout",st),this.nativeHostMainService=De.get(H.INativeHostMainService);const wt=a.ProxyChannel.fromService(this.nativeHostMainService,Se);Me.registerChannel("nativeHost",wt),Le.then(tt=>tt.registerChannel("nativeHost",wt));const Tt=a.ProxyChannel.fromService(De.get(Ue.IWorkspacesService),Se);Me.registerChannel("workspaces",Tt);const Ft=a.ProxyChannel.fromService(De.get(K.IMenubarMainService),Se);Me.registerChannel("menubar",Ft);const _t=a.ProxyChannel.fromService(De.get(Fe.IURLService),Se);Me.registerChannel("url",_t);const Nt=a.ProxyChannel.fromService(De.get(xe.IWebviewManagerService),Se);Me.registerChannel("webview",Nt);const St=this._register(new pe.StorageDatabaseChannel(this.logService,De.get(ye.IStorageMainService)));Me.registerChannel("storage",St),Le.then(tt=>tt.registerChannel("storage",St));const xt=this._register(new Ct.ProfileStorageChangesListenerChannel(De.get(ye.IStorageMainService),De.get(it.IUserDataProfilesMainService),this.logService));Le.then(tt=>tt.registerChannel("profileStorageListener",xt));const Ut=a.ProxyChannel.fromService(De.get(ut.ILocalPtyService),Se);Me.registerChannel(ut.TerminalIpcChannels.LocalPty,Ut);const Bt=a.ProxyChannel.fromService(De.get(le.IExternalTerminalMainService),Se);Me.registerChannel("externalTerminal",Bt);const yt=new Dt.LoggerChannel(De.get(Mt.ILoggerMainService));Me.registerChannel("logger",yt),Le.then(tt=>tt.registerChannel("logger",yt));const zt=new C.ElectronExtensionHostDebugBroadcastChannel(De.get(we.IWindowsMainService));Me.registerChannel("extensionhostdebugservice",zt);const $t=a.ProxyChannel.fromService(De.get(ue.IExtensionHostStarter),Se);Me.registerChannel(ue.ipcExtensionHostStarterChannelName,$t);const qt=a.ProxyChannel.fromService(De.get(ct.IUtilityProcessWorkerMainService),Se);Me.registerChannel(Rt.ipcUtilityProcessWorkerChannelName,qt)}async openFirstWindow(De,Me){const Le=this.windowsMainService=De.get(we.IWindowsMainService);this.auxiliaryWindowsMainService=De.get(pt.IAuxiliaryWindowsMainService);const Se=(0,x.isLaunchedFromCli)(process.env)?0:4,Re=this.environmentMainService.args;if(Me){if(Me.openables.length>0)return Le.open({context:Se,cli:Re,urisToOpen:Me.openables,gotoLineMode:!0,initialStartup:!0});if(Me.urls.length>0)for(const et of Me.urls){const st=new URLSearchParams(et.uri.query);if(st.get("windowId")==="_blank")return st.delete("windowId"),et.originalUrl=et.uri.toString(!0),et.uri=et.uri.with({query:st.toString()}),Le.open({context:Se,cli:Re,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const ze=global.macOpenFiles,qe=Re._.length,Ve=!!Re["folder-uri"],_e=!!Re["file-uri"],Ne=Re["skip-add-to-recently-opened"]===!0,je=Re.wait&&Re.waitMarkerFilePath?c.URI.file(Re.waitMarkerFilePath):void 0,Qe=Re.remote||void 0,Ze=Re.profile,nt=Re["profile-temp"];if(!qe&&!Ve&&!_e){if(Re["new-window"]||Ze||nt)return Le.open({context:Se,cli:Re,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ne,waitMarkerFileURI:je,initialStartup:!0,remoteAuthority:Qe,forceProfile:Ze,forceTempProfile:nt});if(ze.length)return Le.open({context:1,cli:Re,urisToOpen:ze.map(et=>(et=(0,vt.normalizeNFC)(et),(0,Oe.hasWorkspaceFileExtension)(et)?{workspaceUri:c.URI.file(et)}:{fileUri:c.URI.file(et)})),noRecentEntry:Ne,waitMarkerFileURI:je,initialStartup:!0})}return Le.open({context:Se,cli:Re,forceNewWindow:Re["new-window"],diffMode:Re.diff,mergeMode:Re.merge,noRecentEntry:Ne,waitMarkerFileURI:je,gotoLineMode:Re.goto,initialStartup:!0,remoteAuthority:Qe,forceProfile:Ze,forceTempProfile:nt})}afterWindowOpen(){this.installMutex(),n.protocol.registerHttpProtocol(d.Schemas.vscodeRemoteResource,(De,Me)=>{Me({url:De.url.replace(/^vscode-remote-resource:/,"http:"),method:De.method})}),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement(),w.isMacintosh&&n.app.runningUnderARM64Translation&&this.windowsMainService?.sendToFocused("vscode:showTranslatedBuildWarning")}async installMutex(){const De=this.productService.win32MutexName;if(w.isWindows&&De)try{const Me=await new Promise((Se,Re)=>{Q(["@vscode/windows-mutex"],Se,Re)}),Le=new Me.Mutex(De);f.Event.once(this.lifecycleMainService.onWillShutdown)(()=>Le.release())}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(De,Me,Le){try{return await(0,z.getResolvedShellEnv)(this.configurationService,this.logService,De,Me)}catch(Se){const Re=(0,P.toErrorMessage)(Se);Le?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Re):this.logService.error(Re)}return{}}async updateCrashReporterEnablement(){try{const Me=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Le=JSON.parse((0,S.stripComments)(Me)),Re=(0,J.getTelemetryLevel)(this.configurationService)>=1;if(Le["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Re},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,v.generateUuid)()}"`,"}"],qe=Me.substring(0,Me.length-2).concat(`,
`,ze.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,k.VSBuffer.fromString(qe))}else{const ze=Me.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Re},`);ze!==Me&&await this.fileService.writeFile(this.environmentMainService.argvResource,k.VSBuffer.fromString(ze))}}catch(De){this.logService.error(De)}}};e.CodeApplication=ft,e.CodeApplication=ft=dt=Ie([ie(2,ae.IInstantiationService),ie(3,ne.ILogService),ie(4,ne.ILoggerService),ie(5,F.IEnvironmentMainService),ie(6,Z.ILifecycleMainService),ie(7,p.IConfigurationService),ie(8,me.IStateService),ie(9,B.IFileService),ie(10,j.IProductService),ie(11,it.IUserDataProfilesMainService)],ft)}),define(se[317],oe([0,1,14,43,7,22,8,47,15,31,3,48,13,9,66,4,36,25,21,44,100,312,10,18,242,254,24,64,205,16,226,94,78,222,93,20,229,5,80,27,81,282,130,291,53,290,96,253,34,54,69,57,39,238,236,2,40,270,67,231,119,125,274,102,268]),function(Q,e,n,R,I,A,k,P,h,l,f,S,b,g,d,y,w,m,c,v,E,a,t,s,r,i,o,u,p,C,M,D,W,O,_,F,x,z,ue,ee,le,Y,G,B,T,U,$,ae,V,ce,X,L,N,Z,ne,K,H,j,q,re,he,me,pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ee{main(){try{this.startup()}catch(ve){console.error(ve.message),n.app.exit(1)}}async startup(){(0,h.setUnexpectedErrorHandler)(Fe=>console.error(Fe));const[ve,J,de,ge,ke,Ae,Be,Te]=this.createServices();try{try{await this.initServices(de,Te,ge,ke,Be)}catch(Fe){throw this.handleStartupDataDirError(de,Be,Fe),Fe}await ve.invokeFunction(async Fe=>{const $e=Fe.get(z.ILogService),He=Fe.get(F.ILifecycleMainService),Ke=Fe.get(C.IFileService),xe=Fe.get(z.ILoggerService),te=await this.claimInstance($e,de,He,ve,Be,!0);return c.Promises.writeFile(de.mainLockfile,String(process.pid)).catch(fe=>{$e.warn(`app#startup(): Error writing main lockfile: ${fe.stack}`)}),Ae.logger=xe.createLogger("main",{name:(0,t.localize)(0,null)}),f.Event.once(He.onWillShutdown)(fe=>{Ke.dispose(),ge.dispose(),fe.join("instanceLockfile",c.Promises.unlink(de.mainLockfile).catch(()=>{}))}),ve.createInstance(a.CodeApplication,te,J).startup()})}catch(Fe){ve.invokeFunction(this.quit,Fe)}}createServices(){const ve=new _.ServiceCollection,J=new K.DisposableStore;process.once("exit",()=>J.dispose());const de={_serviceBrand:void 0,...ue.default};ve.set(ee.IProductService,de);const ge=new o.EnvironmentMainService(this.resolveArgs(),de),ke=this.patchEnvironment(ge);ve.set(o.IEnvironmentMainService,ge);const Ae=new q.LoggerMainService((0,z.getLogLevel)(ge),ge.logsHome);ve.set(q.ILoggerMainService,Ae);const Be=new x.BufferLogger(Ae.getLogLevel()),Te=J.add(new re.LogService(Be,[new z.ConsoleMainLogger(Ae.getLogLevel())]));ve.set(z.ILogService,Te);const Fe=new M.FileService(Te);ve.set(C.IFileService,Fe);const $e=new D.DiskFileSystemProvider(Te);Fe.registerProvider(b.Schemas.file,$e);const He=new j.UriIdentityService(Fe);ve.set(H.IUriIdentityService,He);const Ke=new me.StateService(1,ge,Te,Fe);ve.set(V.IStateReadService,Ke),ve.set(V.IStateService,Ke);const xe=new L.UserDataProfilesMainService(Ke,He,ge,Fe,Te);ve.set(L.IUserDataProfilesMainService,xe),Fe.registerProvider(b.Schemas.vscodeUserData,new pe.FileUserDataProvider(b.Schemas.file,$e,b.Schemas.vscodeUserData,xe,He,Te));const te=y.isWindows&&de.win32RegValueName?J.add(new Z.NativePolicyService(Te,de.win32RegValueName)):ge.policyFile?J.add(new ne.FilePolicyService(ge.policyFile,Fe,Te)):new N.NullPolicyService;ve.set(N.IPolicyService,te);const fe=new r.ConfigurationService(xe.defaultProfile.settingsResource,Fe,te,Te);return ve.set(s.IConfigurationService,fe),ve.set(F.ILifecycleMainService,new W.SyncDescriptor(F.LifecycleMainService,void 0,!1)),ve.set(T.IRequestService,new W.SyncDescriptor(U.RequestMainService,void 0,!0)),ve.set(X.IThemeMainService,new W.SyncDescriptor(X.ThemeMainService)),ve.set($.ISignService,new W.SyncDescriptor(ae.SignService,void 0,!1)),ve.set(G.ITunnelService,new W.SyncDescriptor(B.TunnelService)),ve.set(le.IProtocolMainService,new Y.ProtocolMainService(ge,xe,Te)),[new O.InstantiationService(ve,!0),ke,ge,fe,Ke,Be,de,xe]}patchEnvironment(ve){const J={VSCODE_IPC_HOOK:ve.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(de=>{const ge=process.env[de];typeof ge=="string"&&(J[de]=ge)}),Object.assign(process.env,J),J}async initServices(ve,J,de,ge,ke){await k.Promises.settled([Promise.all([this.allowWindowsUNCPath(ve.extensionsPath),ve.codeCachePath,ve.logsHome.with({scheme:b.Schemas.file}).fsPath,J.defaultProfile.globalStorageHome.with({scheme:b.Schemas.file}).fsPath,ve.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,ve.localHistoryHome.with({scheme:b.Schemas.file}).fsPath,ve.backupHome].map(Ae=>Ae?c.Promises.mkdir(Ae,{recursive:!0}):void 0)),ge.init(),de.initialize()]),J.init()}allowWindowsUNCPath(ve){if(y.isWindows){const J=(0,ye.getUNCHost)(ve);J&&(0,ye.addUNCHostToAllowlist)(J)}return ve}async claimInstance(ve,J,de,ge,ke,Ae){let Be;try{(0,d.mark)("code/willStartMainServer"),Be=await(0,E.serve)(J.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),f.Event.once(de.onWillShutdown)(()=>Be.dispose())}catch(Te){if(Te.code!=="EADDRINUSE")throw this.handleStartupDataDirError(J,ke,Te),Te;let Fe;try{Fe=await(0,E.connect)(J.mainIPCHandle,"main")}catch(xe){if(!Ae||y.isWindows||xe.code!=="ECONNREFUSED")throw xe.code==="EPERM"&&this.showStartupWarningDialog((0,t.localize)(1,null,ke.nameShort),(0,t.localize)(2,null),ke),xe;try{(0,R.unlinkSync)(J.mainIPCHandle)}catch(te){throw ve.warn("Could not delete obsolete instance handle",te),te}return this.claimInstance(ve,J,de,ge,ke,!1)}if(J.extensionTestsLocationURI&&!J.debugExtensionHost.break){const xe=`Running extension tests from the command line is currently only supported if no other instance of ${ke.nameShort} is running.`;throw ve.error(xe),Fe.dispose(),new Error(xe)}let $e;!J.args.wait&&!J.args.status&&($e=setTimeout(()=>{this.showStartupWarningDialog((0,t.localize)(3,null,ke.nameShort),(0,t.localize)(4,null),ke)},1e4));const He=v.ProxyChannel.toService(Fe.getChannel("launch"),{disableMarshalling:!0}),Ke=v.ProxyChannel.toService(Fe.getChannel("diagnostics"),{disableMarshalling:!0});if(J.args.status)return ge.invokeFunction(async()=>{const xe=new i.DiagnosticsService(ce.NullTelemetryService,ke),te=await Ke.getMainDiagnostics(),fe=await Ke.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),we=await xe.getDiagnostics(te,fe);throw console.log(we),new h.ExpectedError});throw y.isWindows&&await this.windowsAllowSetForegroundWindow(He,ve),ve.trace("Sending env to running instance..."),await He.start(J.args,process.env),Fe.dispose(),$e&&clearTimeout($e),new h.ExpectedError("Sent env to running instance. Terminating...")}if(J.args.status)throw console.log((0,t.localize)(5,null,ke.nameShort)),new h.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Be}handleStartupDataDirError(ve,J,de){if(de.code==="EACCES"||de.code==="EPERM"){const ge=(0,A.coalesce)([ve.userDataPath,ve.extensionsPath,E.XDG_RUNTIME_DIR]).map(ke=>(0,S.getPathLabel)(I.URI.file(ke),{os:y.OS,tildify:ve}));this.showStartupWarningDialog((0,t.localize)(6,null),(0,t.localize)(7,null,(0,P.toErrorMessage)(de),ge.join(`
`)),J)}}showStartupWarningDialog(ve,J,de){n.dialog.showMessageBoxSync((0,he.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ve,detail:J},de).options)}async windowsAllowSetForegroundWindow(ve,J){if(y.isWindows){const de=await ve.getMainProcessId();J.trace("Sending some foreground love to the running instance:",de);try{(await new Promise((ge,ke)=>{Q(["windows-foreground-love"],ge,ke)})).allowSetForegroundWindow(de)}catch(ge){J.error(ge)}}}quit(ve,J){const de=ve.get(z.ILogService),ge=ve.get(F.ILifecycleMainService);let ke=0;J&&(J.isExpected?J.message&&de.trace(J.message):(ke=1,J.stack?de.error(J.stack):de.error(`Startup error: ${J.toString()}`))),ge.kill(ke)}resolveArgs(){const ve=this.validatePaths((0,u.parseMainProcessArgv)(process.argv));if(ve.wait&&!ve.waitMarkerFilePath){const J=(0,p.createWaitMarkerFileSync)(ve.verbose);J&&((0,u.addArg)(process.argv,"--waitMarkerFilePath",J),ve.waitMarkerFilePath=J)}return ve}validatePaths(ve){if(ve["open-url"]&&(ve._urls=ve._,ve._=[]),!ve.remote){const J=this.doValidatePaths(ve._,ve.goto);ve._=J}return ve}doValidatePaths(ve,J){const de=(0,w.cwd)(),ge=ve.map(Be=>{let Te=String(Be),Fe;J&&(Fe=(0,l.parseLineAndColumnAware)(Te),Te=Fe.path),Te&&(Te=this.preparePath(de,Te));const $e=(0,l.sanitizeFilePath)(Te,de),He=(0,g.basename)($e);return He&&!(0,l.isValidBasename)(He)?null:J&&Fe?(Fe.path=$e,this.toPath(Fe)):$e}),ke=y.isWindows||y.isMacintosh,Ae=(0,A.distinct)(ge,Be=>Be&&ke?Be.toLowerCase():Be||"");return(0,A.coalesce)(Ae)}preparePath(ve,J){return y.isWindows&&(J=(0,m.rtrim)(J,'"')),J=(0,m.trim)((0,m.trim)(J," "),"	"),y.isWindows&&(J=(0,g.resolve)(ve,J),J=(0,m.rtrim)(J,".")),J}toPath(ve){const J=[ve.path];return typeof ve.line=="number"&&J.push(String(ve.line)),typeof ve.column=="number"&&J.push(String(ve.column)),J.join(":")}}new Ee().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a045dcfceda27f896936bfd8cbf524f6a93a2f46/core/vs/code/electron-main/main.js.map
