/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var _e=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/extpath","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/platform/contextkey/common/contextkey","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/base/common/themables","vs/editor/common/core/position","vs/base/common/process","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(ue){for(var e=[],h=0,O=ue.length;h<O;h++)e[h]=_e[ue[h]];return e};define(_e[163],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class h{static get(){const L=new Map,A=new Map,R=new Map,b=new Map;function m(S,E){S.has(E.detail)||S.set(E.detail,-E.timestamp)}function y(S,E){const d=S.get(E.detail);d&&(d>=0||S.set(E.detail,d+E.timestamp))}let T=[];typeof ue=="function"&&typeof ue.getStats=="function"&&(T=ue.getStats().slice(0).sort((S,E)=>S.timestamp-E.timestamp));for(const S of T)switch(S.type){case 10:m(L,S);break;case 11:case 12:y(L,S);break;case 21:m(A,S);break;case 22:y(A,S);break;case 33:m(R,S);break;case 34:y(R,S);break;case 31:m(b,S);break;case 32:y(b,S);break}let I=0;R.forEach(S=>I+=S);function p(S){const E=[];return S.forEach((d,f)=>E.push([f,d])),E}return{amdLoad:p(L),amdInvoke:p(A),nodeRequire:p(R),nodeEval:p(b),nodeRequireTotal:I}}static toMarkdownTable(L,A){let R="";const b=[];return L.forEach((m,y)=>{b[y]=m.length}),A.forEach(m=>{m.forEach((y,T)=>{typeof y>"u"&&(y=m[T]="-");const I=y.toString().length;b[T]=Math.max(I,b[T])})}),L.forEach((m,y)=>{R+=`| ${m+" ".repeat(b[y]-m.toString().length)} `}),R+=`|
`,L.forEach((m,y)=>{R+=`| ${"-".repeat(b[y])} `}),R+=`|
`,A.forEach(m=>{m.forEach((y,T)=>{typeof y<"u"&&(R+=`| ${y+" ".repeat(b[T]-y.toString().length)} `)}),R+=`|
`}),R}}e.LoaderStats=h}),define(_e[164],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=h,e.findLastIdx=O,e.findLastMonotonous=L,e.findLastIdxMonotonous=A,e.findFirstMonotonous=R,e.findFirstIdxMonotonousOrArrLen=b,e.findFirstIdxMonotonous=m,e.findFirstMax=T,e.findLastMax=I,e.findFirstMin=p,e.findMaxIdx=S,e.mapFindFirst=E;function h(d,f){const a=O(d,f);if(a!==-1)return d[a]}function O(d,f,a=d.length-1){for(let i=a;i>=0;i--){const n=d[i];if(f(n))return i}return-1}function L(d,f){const a=A(d,f);return a===-1?void 0:d[a]}function A(d,f,a=0,i=d.length){let n=a,l=i;for(;n<l;){const o=Math.floor((n+l)/2);f(d[o])?n=o+1:l=o}return n-1}function R(d,f){const a=b(d,f);return a===d.length?void 0:d[a]}function b(d,f,a=0,i=d.length){let n=a,l=i;for(;n<l;){const o=Math.floor((n+l)/2);f(d[o])?l=o:n=o+1}return n}function m(d,f,a=0,i=d.length){const n=b(d,f,a,i);return n===d.length?-1:n}class y{static{this.assertInvariants=!1}constructor(f){this._array=f,this._findLastMonotonousLastIdx=0}findLastMonotonous(f){if(y.assertInvariants){if(this._prevFindLastPredicate){for(const i of this._array)if(this._prevFindLastPredicate(i)&&!f(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=f}const a=A(this._array,f,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=a+1,a===-1?void 0:this._array[a]}}e.MonotonousArray=y;function T(d,f){if(d.length===0)return;let a=d[0];for(let i=1;i<d.length;i++){const n=d[i];f(n,a)>0&&(a=n)}return a}function I(d,f){if(d.length===0)return;let a=d[0];for(let i=1;i<d.length;i++){const n=d[i];f(n,a)>=0&&(a=n)}return a}function p(d,f){return T(d,(a,i)=>-f(a,i))}function S(d,f){if(d.length===0)return-1;let a=0;for(let i=1;i<d.length;i++){const n=d[i];f(n,d[a])>0&&(a=i)}return a}function E(d,f){for(const a of d){const i=f(a);if(i!==void 0)return i}}}),define(_e[74],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.groupBy=h,e.diffSets=O,e.diffMaps=L,e.intersection=A;function h(R,b){const m=Object.create(null);for(const y of R){const T=b(y);let I=m[T];I||(I=m[T]=[]),I.push(y)}return m}function O(R,b){const m=[],y=[];for(const T of R)b.has(T)||m.push(T);for(const T of b)R.has(T)||y.push(T);return{removed:m,added:y}}function L(R,b){const m=[],y=[];for(const[T,I]of R)b.has(T)||m.push(I);for(const[T,I]of b)R.has(T)||y.push(I);return{removed:m,added:y}}function A(R,b){const m=new Set;for(const y of b)R.has(y)&&m.add(y);return m}}),define(_e[56],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=O,e.debounce=L,e.throttle=A;function h(R){return(b,m,y)=>{let T=null,I=null;if(typeof y.value=="function"?(T="value",I=y.value):typeof y.get=="function"&&(T="get",I=y.get),!I)throw new Error("not supported");y[T]=R(I,m)}}function O(R,b,m){let y=null,T=null;if(typeof m.value=="function"?(y="value",T=m.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(y="get",T=m.get),!T)throw new Error("not supported");const I=`$memoize$${b}`;m[y]=function(...p){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,p)}),this[I]}}function L(R,b,m){return h((y,T)=>{const I=`$debounce$${T}`,p=`$debounce$result$${T}`;return function(...S){this[p]||(this[p]=m?m():void 0),clearTimeout(this[I]),b&&(this[p]=b(this[p],...S),S=[this[p]]),this[I]=setTimeout(()=>{y.apply(this,S),this[p]=m?m():void 0},R)}})}function A(R,b,m){return h((y,T)=>{const I=`$throttle$timer$${T}`,p=`$throttle$result$${T}`,S=`$throttle$lastRun$${T}`,E=`$throttle$pending$${T}`;return function(...d){if(this[p]||(this[p]=m?m():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),b&&(this[p]=b(this[p],...d)),this[E])return;const f=this[S]+R;f<=Date.now()?(this[S]=Date.now(),y.apply(this,[this[p]]),this[p]=m?m():void 0):(this[E]=!0,this[I]=setTimeout(()=>{this[E]=!1,this[S]=Date.now(),y.apply(this,[this[p]]),this[p]=m?m():void 0},f-Date.now()))}})}}),define(_e[13],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=O,e.isSigPipeError=L,e.onUnexpectedError=A,e.onUnexpectedExternalError=R,e.transformErrorForSerialization=b,e.isCancellationError=y,e.canceled=I,e.illegalArgument=p,e.illegalState=S,e.getErrorMessage=d;class h{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(u=>{u(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=h,e.errorHandler=new h;function O(o){e.errorHandler.setUnexpectedErrorHandler(o)}function L(o){if(!o||typeof o!="object")return!1;const t=o;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function A(o){y(o)||e.errorHandler.onUnexpectedError(o)}function R(o){y(o)||e.errorHandler.onUnexpectedExternalError(o)}function b(o){if(o instanceof Error){const{name:t,message:u}=o,r=o.stacktrace||o.stack;return{$isError:!0,name:t,message:u,stack:r,noTelemetry:n.isErrorNoTelemetry(o)}}return o}const m="Canceled";function y(o){return o instanceof T?!0:o instanceof Error&&o.name===m&&o.message===m}class T extends Error{constructor(){super(m),this.name=this.message}}e.CancellationError=T;function I(){const o=new Error(m);return o.name=o.message,o}function p(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function S(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class E extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=E;function d(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=f;class a extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=a;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const u=new n;return u.message=t.message,u.stack=t.stack,u}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=n;class l extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,l.prototype)}}e.BugIndicatingError=l}),define(_e[19],Ce([1,0,13,164]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=L,e.tail2=A,e.equals=R,e.removeFastWithoutKeepingOrder=b,e.binarySearch=m,e.binarySearch2=y,e.quickSelect=T,e.groupBy=I,e.groupAdjacentBy=p,e.forEachAdjacent=S,e.forEachWithNeighbors=E,e.sortedDiff=d,e.delta=f,e.top=a,e.topAsync=i,e.coalesce=l,e.coalesceInPlace=o,e.move=t,e.isFalsyOrEmpty=u,e.isNonEmptyArray=r,e.distinct=c,e.uniqueFilter=s,e.firstOrDefault=w,e.lastOrDefault=g,e.commonPrefixLength=D,e.flatten=v,e.range=_,e.index=C,e.insert=P,e.remove=k,e.arrayInsert=F,e.shuffle=x,e.pushToStart=z,e.pushToEnd=N,e.pushMany=M,e.mapArrayOrNot=W,e.asArray=X,e.getRandomElement=te,e.insertInto=H,e.splice=G,e.compareBy=pe,e.tieBreakComparators=le,e.reverseOrder=B;function L(oe,se=0){return oe[oe.length-(1+se)]}function A(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}function R(oe,se,re=(j,ie)=>j===ie){if(oe===se)return!0;if(!oe||!se||oe.length!==se.length)return!1;for(let j=0,ie=oe.length;j<ie;j++)if(!re(oe[j],se[j]))return!1;return!0}function b(oe,se){const re=oe.length-1;se<re&&(oe[se]=oe[re]),oe.pop()}function m(oe,se,re){return y(oe.length,j=>re(oe[j],se))}function y(oe,se){let re=0,j=oe-1;for(;re<=j;){const ie=(re+j)/2|0,me=se(ie);if(me<0)re=ie+1;else if(me>0)j=ie-1;else return ie}return-(re+1)}function T(oe,se,re){if(oe=oe|0,oe>=se.length)throw new TypeError("invalid index");const j=se[Math.floor(se.length*Math.random())],ie=[],me=[],be=[];for(const Ae of se){const fe=re(Ae,j);fe<0?ie.push(Ae):fe>0?me.push(Ae):be.push(Ae)}return oe<ie.length?T(oe,ie,re):oe<ie.length+be.length?be[0]:T(oe-(ie.length+be.length),me,re)}function I(oe,se){const re=[];let j;for(const ie of oe.slice(0).sort(se))!j||se(j[0],ie)!==0?(j=[ie],re.push(j)):j.push(ie);return re}function*p(oe,se){let re,j;for(const ie of oe)j!==void 0&&se(j,ie)?re.push(ie):(re&&(yield re),re=[ie]),j=ie;re&&(yield re)}function S(oe,se){for(let re=0;re<=oe.length;re++)se(re===0?void 0:oe[re-1],re===oe.length?void 0:oe[re])}function E(oe,se){for(let re=0;re<oe.length;re++)se(re===0?void 0:oe[re-1],oe[re],re+1===oe.length?void 0:oe[re+1])}function d(oe,se,re){const j=[];function ie(Ae,fe,De){if(fe===0&&De.length===0)return;const Te=j[j.length-1];Te&&Te.start+Te.deleteCount===Ae?(Te.deleteCount+=fe,Te.toInsert.push(...De)):j.push({start:Ae,deleteCount:fe,toInsert:De})}let me=0,be=0;for(;;){if(me===oe.length){ie(me,0,se.slice(be));break}if(be===se.length){ie(me,oe.length-me,[]);break}const Ae=oe[me],fe=se[be],De=re(Ae,fe);De===0?(me+=1,be+=1):De<0?(ie(me,1,[]),me+=1):De>0&&(ie(me,0,[fe]),be+=1)}return j}function f(oe,se,re){const j=d(oe,se,re),ie=[],me=[];for(const be of j)ie.push(...oe.slice(be.start,be.start+be.deleteCount)),me.push(...be.toInsert);return{removed:ie,added:me}}function a(oe,se,re){if(re===0)return[];const j=oe.slice(0,re).sort(se);return n(oe,se,j,re,oe.length),j}function i(oe,se,re,j,ie){return re===0?Promise.resolve([]):new Promise((me,be)=>{(async()=>{const Ae=oe.length,fe=oe.slice(0,re).sort(se);for(let De=re,Te=Math.min(re+j,Ae);De<Ae;De=Te,Te=Math.min(Te+j,Ae)){if(De>re&&await new Promise(ze=>setTimeout(ze)),ie&&ie.isCancellationRequested)throw new h.CancellationError;n(oe,se,fe,De,Te)}return fe})().then(me,be)})}function n(oe,se,re,j,ie){for(const me=re.length;j<ie;j++){const be=oe[j];if(se(be,re[me-1])<0){re.pop();const Ae=(0,O.findFirstIdxMonotonousOrArrLen)(re,fe=>se(be,fe)<0);re.splice(Ae,0,be)}}}function l(oe){return oe.filter(se=>!!se)}function o(oe){let se=0;for(let re=0;re<oe.length;re++)oe[re]&&(oe[se]=oe[re],se+=1);oe.length=se}function t(oe,se,re){oe.splice(re,0,oe.splice(se,1)[0])}function u(oe){return!Array.isArray(oe)||oe.length===0}function r(oe){return Array.isArray(oe)&&oe.length>0}function c(oe,se=re=>re){const re=new Set;return oe.filter(j=>{const ie=se(j);return re.has(ie)?!1:(re.add(ie),!0)})}function s(oe){const se=new Set;return re=>{const j=oe(re);return se.has(j)?!1:(se.add(j),!0)}}function w(oe,se){return oe.length>0?oe[0]:se}function g(oe,se){return oe.length>0?oe[oe.length-1]:se}function D(oe,se,re=(j,ie)=>j===ie){let j=0;for(let ie=0,me=Math.min(oe.length,se.length);ie<me&&re(oe[ie],se[ie]);ie++)j++;return j}function v(oe){return[].concat(...oe)}function _(oe,se){let re=typeof se=="number"?oe:0;typeof se=="number"?re=oe:(re=0,se=oe);const j=[];if(re<=se)for(let ie=re;ie<se;ie++)j.push(ie);else for(let ie=re;ie>se;ie--)j.push(ie);return j}function C(oe,se,re){return oe.reduce((j,ie)=>(j[se(ie)]=re?re(ie):ie,j),Object.create(null))}function P(oe,se){return oe.push(se),()=>k(oe,se)}function k(oe,se){const re=oe.indexOf(se);if(re>-1)return oe.splice(re,1),se}function F(oe,se,re){const j=oe.slice(0,se),ie=oe.slice(se);return j.concat(re,ie)}function x(oe,se){let re;if(typeof se=="number"){let j=se;re=()=>{const ie=Math.sin(j++)*179426549;return ie-Math.floor(ie)}}else re=Math.random;for(let j=oe.length-1;j>0;j-=1){const ie=Math.floor(re()*(j+1)),me=oe[j];oe[j]=oe[ie],oe[ie]=me}}function z(oe,se){const re=oe.indexOf(se);re>-1&&(oe.splice(re,1),oe.unshift(se))}function N(oe,se){const re=oe.indexOf(se);re>-1&&(oe.splice(re,1),oe.push(se))}function M(oe,se){for(const re of se)oe.push(re)}function W(oe,se){return Array.isArray(oe)?oe.map(se):se(oe)}function X(oe){return Array.isArray(oe)?oe:[oe]}function te(oe){return oe[Math.floor(Math.random()*oe.length)]}function H(oe,se,re){const j=Y(oe,se),ie=oe.length,me=re.length;oe.length=ie+me;for(let be=ie-1;be>=j;be--)oe[be+me]=oe[be];for(let be=0;be<me;be++)oe[be+j]=re[be]}function G(oe,se,re,j){const ie=Y(oe,se);let me=oe.splice(ie,re);return me===void 0&&(me=[]),H(oe,ie,j),me}function Y(oe,se){return se<0?Math.max(se+oe.length,0):Math.min(se,oe.length)}var ne;(function(oe){function se(me){return me<0}oe.isLessThan=se;function re(me){return me<=0}oe.isLessThanOrEqual=re;function j(me){return me>0}oe.isGreaterThan=j;function ie(me){return me===0}oe.isNeitherLessOrGreaterThan=ie,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(ne||(e.CompareResult=ne={}));function pe(oe,se){return(re,j)=>se(oe(re),oe(j))}function le(...oe){return(se,re)=>{for(const j of oe){const ie=j(se,re);if(!ne.isNeitherLessOrGreaterThan(ie))return ie}return ne.neitherLessOrGreaterThan}}const we=(oe,se)=>oe-se;e.numberComparator=we;const Z=(oe,se)=>(0,e.numberComparator)(oe?1:0,se?1:0);e.booleanComparator=Z;function B(oe){return(se,re)=>-oe(se,re)}class ee{constructor(se){this.items=se,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(se){let re=this.firstIdx;for(;re<this.items.length&&se(this.items[re]);)re++;const j=re===this.firstIdx?null:this.items.slice(this.firstIdx,re);return this.firstIdx=re,j}takeFromEndWhile(se){let re=this.lastIdx;for(;re>=0&&se(this.items[re]);)re--;const j=re===this.lastIdx?null:this.items.slice(re+1,this.lastIdx+1);return this.lastIdx=re,j}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const se=this.items[this.firstIdx];return this.firstIdx++,se}removeLast(){const se=this.items[this.lastIdx];return this.lastIdx--,se}takeCount(se){const re=this.items.slice(this.firstIdx,this.firstIdx+se);return this.firstIdx+=se,re}}e.ArrayQueue=ee;class ve{static{this.empty=new ve(se=>{})}constructor(se){this.iterate=se}forEach(se){this.iterate(re=>(se(re),!0))}toArray(){const se=[];return this.iterate(re=>(se.push(re),!0)),se}filter(se){return new ve(re=>this.iterate(j=>se(j)?re(j):!0))}map(se){return new ve(re=>this.iterate(j=>re(se(j))))}some(se){let re=!1;return this.iterate(j=>(re=se(j),!re)),re}findFirst(se){let re;return this.iterate(j=>se(j)?(re=j,!1):!0),re}findLast(se){let re;return this.iterate(j=>(se(j)&&(re=j),!0)),re}findLastMaxBy(se){let re,j=!0;return this.iterate(ie=>((j||ne.isGreaterThan(se(ie,re)))&&(j=!1,re=ie),!0)),re}}e.CallbackIterable=ve;class Pe{constructor(se){this._indexMap=se}static createSortPermutation(se,re){const j=Array.from(se.keys()).sort((ie,me)=>re(se[ie],se[me]));return new Pe(j)}apply(se){return se.map((re,j)=>se[this._indexMap[j]])}inverse(){const se=this._indexMap.slice();for(let re=0;re<this._indexMap.length;re++)se[this._indexMap[re]]=re;return new Pe(se)}}e.Permutation=Pe}),define(_e[62],Ce([1,0,13]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=O,e.assertNever=L,e.assert=A,e.softAssert=R,e.assertFn=b,e.checkAdjacentItems=m;function O(y,T){if(!y)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}function L(y,T="Unreachable"){throw new Error(T)}function A(y){if(!y)throw new h.BugIndicatingError("Assertion Failed")}function R(y){y||(0,h.onUnexpectedError)(new h.BugIndicatingError("Soft Assertion Failed"))}function b(y){if(!y()){debugger;y(),(0,h.onUnexpectedError)(new h.BugIndicatingError("Assertion Failed"))}}function m(y,T){let I=0;for(;I<y.length-1;){const p=y[I],S=y[I+1];if(!T(p,S))return!1;I++}return!0}}),define(_e[165],Ce([1,0,19]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.strictEquals=void 0,e.itemsEquals=L,e.jsonStringifyEquals=A,e.itemEquals=R,e.equalsIfDefined=b,e.structuralEquals=m,e.getStructuralKey=y;const O=(S,E)=>S===E;e.strictEquals=O;function L(S=e.strictEquals){return(E,d)=>h.equals(E,d,S)}function A(){return(S,E)=>JSON.stringify(S)===JSON.stringify(E)}function R(){return(S,E)=>S.equals(E)}function b(S,E,d){return!S||!E?S===E:d(S,E)}function m(S,E){if(S===E)return!0;if(Array.isArray(S)&&Array.isArray(E)){if(S.length!==E.length)return!1;for(let d=0;d<S.length;d++)if(!m(S[d],E[d]))return!1;return!0}if(S&&typeof S=="object"&&E&&typeof E=="object"&&Object.getPrototypeOf(S)===Object.prototype&&Object.getPrototypeOf(E)===Object.prototype){const d=S,f=E,a=Object.keys(d),i=Object.keys(f),n=new Set(i);if(a.length!==i.length)return!1;for(const l of a)if(!n.has(l)||!m(d[l],f[l]))return!1;return!0}return!1}function y(S){return JSON.stringify(p(S))}let T=0;const I=new WeakMap;function p(S){if(Array.isArray(S))return S.map(p);if(S&&typeof S=="object")if(Object.getPrototypeOf(S)===Object.prototype){const E=S,d=Object.create(null);for(const f of Object.keys(E).sort())d[f]=p(E[f]);return d}else{let E=I.get(S);return E===void 0&&(E=T++,I.set(S,E)),E+"----2b76a038c20c4bcc"}return S}}),define(_e[75],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=h;function h(O,L){const A=this;let R=!1,b;return function(){if(R)return b;if(R=!0,L)try{b=O.apply(A,arguments)}finally{L()}else b=O.apply(A,arguments);return b}}}),define(_e[125],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class h{constructor(L){this._prefix=L,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=h,e.defaultGenerator=new h("id#")}),define(_e[39],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var h;(function(O){function L(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}O.is=L;const A=Object.freeze([]);function R(){return A}O.empty=R;function*b(t){yield t}O.single=b;function m(t){return L(t)?t:b(t)}O.wrap=m;function y(t){return t||A}O.from=y;function*T(t){for(let u=t.length-1;u>=0;u--)yield t[u]}O.reverse=T;function I(t){return!t||t[Symbol.iterator]().next().done===!0}O.isEmpty=I;function p(t){return t[Symbol.iterator]().next().value}O.first=p;function S(t,u){for(const r of t)if(u(r))return!0;return!1}O.some=S;function E(t,u){for(const r of t)if(u(r))return r}O.find=E;function*d(t,u){for(const r of t)u(r)&&(yield r)}O.filter=d;function*f(t,u){let r=0;for(const c of t)yield u(c,r++)}O.map=f;function*a(...t){for(const u of t)yield*u}O.concat=a;function i(t,u,r){let c=r;for(const s of t)c=u(c,s);return c}O.reduce=i;function*n(t,u,r=t.length){for(u<0&&(u+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);u<r;u++)yield t[u]}O.slice=n;function l(t,u=Number.POSITIVE_INFINITY){const r=[];if(u===0)return[r,t];const c=t[Symbol.iterator]();for(let s=0;s<u;s++){const w=c.next();if(w.done)return[r,O.empty()];r.push(w.value)}return[r,{[Symbol.iterator](){return c}}]}O.consume=l;async function o(t){const u=[];for await(const r of t)u.push(r);return Promise.resolve(u)}O.asyncToArray=o})(h||(e.Iterable=h={}))}),define(_e[166],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=R,e.getLocation=I,e.parse=p,e.parseTree=S,e.findNodeAtLocation=E,e.getNodePath=d,e.getNodeValue=f,e.contains=a,e.findNodeAtOffset=i,e.visit=n,e.stripComments=l,e.getNodeType=o;var h;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(h||(e.ScanError=h={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function R(t,u=!1){let r=0;const c=t.length;let s="",w=0,g=16,D=0;function v(z){let N=0,M=0;for(;N<z;){const W=t.charCodeAt(r);if(W>=48&&W<=57)M=M*16+W-48;else if(W>=65&&W<=70)M=M*16+W-65+10;else if(W>=97&&W<=102)M=M*16+W-97+10;else break;r++,N++}return N<z&&(M=-1),M}function _(z){r=z,s="",w=0,g=16,D=0}function C(){const z=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&y(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&y(t.charCodeAt(r)))for(r++;r<t.length&&y(t.charCodeAt(r));)r++;else return D=3,t.substring(z,r);let N=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&y(t.charCodeAt(r))){for(r++;r<t.length&&y(t.charCodeAt(r));)r++;N=r}else D=3;return t.substring(z,N)}function P(){let z="",N=r;for(;;){if(r>=c){z+=t.substring(N,r),D=2;break}const M=t.charCodeAt(r);if(M===34){z+=t.substring(N,r),r++;break}if(M===92){if(z+=t.substring(N,r),r++,r>=c){D=2;break}switch(t.charCodeAt(r++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const X=v(4);X>=0?z+=String.fromCharCode(X):D=4;break}default:D=5}N=r;continue}if(M>=0&&M<=31)if(m(M)){z+=t.substring(N,r),D=2;break}else D=6;r++}return z}function k(){if(s="",D=0,w=r,r>=c)return w=c,g=17;let z=t.charCodeAt(r);if(b(z)){do r++,s+=String.fromCharCode(z),z=t.charCodeAt(r);while(b(z));return g=15}if(m(z))return r++,s+=String.fromCharCode(z),z===13&&t.charCodeAt(r)===10&&(r++,s+=`
`),g=14;switch(z){case 123:return r++,g=1;case 125:return r++,g=2;case 91:return r++,g=3;case 93:return r++,g=4;case 58:return r++,g=6;case 44:return r++,g=5;case 34:return r++,s=P(),g=10;case 47:{const N=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<c&&!m(t.charCodeAt(r));)r++;return s=t.substring(N,r),g=12}if(t.charCodeAt(r+1)===42){r+=2;const M=c-1;let W=!1;for(;r<M;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,W=!0;break}r++}return W||(r++,D=1),s=t.substring(N,r),g=13}return s+=String.fromCharCode(z),r++,g=16}case 45:if(s+=String.fromCharCode(z),r++,r===c||!y(t.charCodeAt(r)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=C(),g=11;default:for(;r<c&&F(z);)r++,z=t.charCodeAt(r);if(w!==r){switch(s=t.substring(w,r),s){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return s+=String.fromCharCode(z),r++,g=16}}function F(z){if(b(z)||m(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let z;do z=k();while(z>=12&&z<=15);return z}return{setPosition:_,getPosition:()=>r,scan:u?x:k,getToken:()=>g,getTokenValue:()=>s,getTokenOffset:()=>w,getTokenLength:()=>r-w,getTokenError:()=>D}}function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function I(t,u){const r=[],c=new Object;let s;const w={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function D(v,_,C,P){w.value=v,w.offset=_,w.length=C,w.type=P,w.colonOffset=void 0,s=w}try{n(t,{onObjectBegin:(v,_)=>{if(u<=v)throw c;s=void 0,g=u>v,r.push("")},onObjectProperty:(v,_,C)=>{if(u<_||(D(v,_,C,"property"),r[r.length-1]=v,u<=_+C))throw c},onObjectEnd:(v,_)=>{if(u<=v)throw c;s=void 0,r.pop()},onArrayBegin:(v,_)=>{if(u<=v)throw c;s=void 0,r.push(0)},onArrayEnd:(v,_)=>{if(u<=v)throw c;s=void 0,r.pop()},onLiteralValue:(v,_,C)=>{if(u<_||(D(v,_,C,o(v)),u<=_+C))throw c},onSeparator:(v,_,C)=>{if(u<=_)throw c;if(v===":"&&s&&s.type==="property")s.colonOffset=_,g=!1,s=void 0;else if(v===","){const P=r[r.length-1];typeof P=="number"?r[r.length-1]=P+1:(g=!0,r[r.length-1]=""),s=void 0}}})}catch(v){if(v!==c)throw v}return{path:r,previousNode:s,isAtPropertyKey:g,matches:v=>{let _=0;for(let C=0;_<v.length&&C<r.length;C++)if(v[_]===r[C]||v[_]==="*")_++;else if(v[_]!=="**")return!1;return _===v.length}}}function p(t,u=[],r=A.DEFAULT){let c=null,s=[];const w=[];function g(v){Array.isArray(s)?s.push(v):c!==null&&(s[c]=v)}return n(t,{onObjectBegin:()=>{const v={};g(v),w.push(s),s=v,c=null},onObjectProperty:v=>{c=v},onObjectEnd:()=>{s=w.pop()},onArrayBegin:()=>{const v=[];g(v),w.push(s),s=v,c=null},onArrayEnd:()=>{s=w.pop()},onLiteralValue:g,onError:(v,_,C)=>{u.push({error:v,offset:_,length:C})}},r),s[0]}function S(t,u=[],r=A.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(v){c.type==="property"&&(c.length=v-c.offset,c=c.parent)}function w(v){return c.children.push(v),v}n(t,{onObjectBegin:v=>{c=w({type:"object",offset:v,length:-1,parent:c,children:[]})},onObjectProperty:(v,_,C)=>{c=w({type:"property",offset:_,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:v,offset:_,length:C,parent:c})},onObjectEnd:(v,_)=>{c.length=v+_-c.offset,c=c.parent,s(v+_)},onArrayBegin:(v,_)=>{c=w({type:"array",offset:v,length:-1,parent:c,children:[]})},onArrayEnd:(v,_)=>{c.length=v+_-c.offset,c=c.parent,s(v+_)},onLiteralValue:(v,_,C)=>{w({type:o(v),offset:_,length:C,parent:c,value:v}),s(_+C)},onSeparator:(v,_,C)=>{c.type==="property"&&(v===":"?c.colonOffset=_:v===","&&s(_))},onError:(v,_,C)=>{u.push({error:v,offset:_,length:C})}},r);const D=c.children[0];return D&&delete D.parent,D}function E(t,u){if(!t)return;let r=t;for(const c of u)if(typeof c=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const w of r.children)if(Array.isArray(w.children)&&w.children[0].value===c){r=w.children[1],s=!0;break}if(!s)return}else{const s=c;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}function d(t){if(!t.parent||!t.parent.children)return[];const u=d(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;u.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&u.push(r)}return u}function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const u=Object.create(null);for(const r of t.children){const c=r.children[1];c&&(u[r.children[0].value]=f(c))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function a(t,u,r=!1){return u>=t.offset&&u<t.offset+t.length||r&&u===t.offset+t.length}function i(t,u,r=!1){if(a(t,u,r)){const c=t.children;if(Array.isArray(c))for(let s=0;s<c.length&&c[s].offset<=u;s++){const w=i(c[s],u,r);if(w)return w}return t}}function n(t,u,r=A.DEFAULT){const c=R(t,!1);function s(pe){return pe?()=>pe(c.getTokenOffset(),c.getTokenLength()):()=>!0}function w(pe){return pe?le=>pe(le,c.getTokenOffset(),c.getTokenLength()):()=>!0}const g=s(u.onObjectBegin),D=w(u.onObjectProperty),v=s(u.onObjectEnd),_=s(u.onArrayBegin),C=s(u.onArrayEnd),P=w(u.onLiteralValue),k=w(u.onSeparator),F=s(u.onComment),x=w(u.onError),z=r&&r.disallowComments,N=r&&r.allowTrailingComma;function M(){for(;;){const pe=c.scan();switch(c.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:z||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(pe){case 12:case 13:z?W(10):F();break;case 16:W(1);break;case 15:case 14:break;default:return pe}}}function W(pe,le=[],we=[]){if(x(pe),le.length+we.length>0){let Z=c.getToken();for(;Z!==17;){if(le.indexOf(Z)!==-1){M();break}else if(we.indexOf(Z)!==-1)break;Z=M()}}}function X(pe){const le=c.getTokenValue();return pe?P(le):D(le),M(),!0}function te(){switch(c.getToken()){case 11:{let pe=0;try{pe=JSON.parse(c.getTokenValue()),typeof pe!="number"&&(W(2),pe=0)}catch{W(2)}P(pe);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return M(),!0}function H(){return c.getToken()!==10?(W(3,[],[2,5]),!1):(X(!1),c.getToken()===6?(k(":"),M(),ne()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function G(){g(),M();let pe=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(pe||W(4,[],[]),k(","),M(),c.getToken()===2&&N)break}else pe&&W(6,[],[]);H()||W(4,[],[2,5]),pe=!0}return v(),c.getToken()!==2?W(7,[2],[]):M(),!0}function Y(){_(),M();let pe=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(pe||W(4,[],[]),k(","),M(),c.getToken()===4&&N)break}else pe&&W(6,[],[]);ne()||W(4,[],[4,5]),pe=!0}return C(),c.getToken()!==4?W(8,[4],[]):M(),!0}function ne(){switch(c.getToken()){case 3:return Y();case 1:return G();case 10:return X(!0);default:return te()}}return M(),c.getToken()===17?r.allowEmptyContent?!0:(W(4,[],[]),!1):ne()?(c.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}function l(t,u){const r=R(t),c=[];let s,w=0,g;do switch(g=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:w!==g&&c.push(t.substring(w,g)),u!==void 0&&c.push(r.getTokenValue().replace(/[^\r\n]/g,u)),w=r.getPosition();break}while(s!==17);return c.join("")}function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(_e[46],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class h{constructor(L){this.executor=L,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(L){this._error=L}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=h}),define(_e[76],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class h{static{this.Undefined=new h(void 0)}constructor(A){this.element=A,this.next=h.Undefined,this.prev=h.Undefined}}class O{constructor(){this._first=h.Undefined,this._last=h.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===h.Undefined}clear(){let A=this._first;for(;A!==h.Undefined;){const R=A.next;A.prev=h.Undefined,A.next=h.Undefined,A=R}this._first=h.Undefined,this._last=h.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,R){const b=new h(A);if(this._first===h.Undefined)this._first=b,this._last=b;else if(R){const y=this._last;this._last=b,b.prev=y,y.next=b}else{const y=this._first;this._first=b,b.next=y,y.prev=b}this._size+=1;let m=!1;return()=>{m||(m=!0,this._remove(b))}}shift(){if(this._first!==h.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==h.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==h.Undefined&&A.next!==h.Undefined){const R=A.prev;R.next=A.next,A.next.prev=R}else A.prev===h.Undefined&&A.next===h.Undefined?(this._first=h.Undefined,this._last=h.Undefined):A.next===h.Undefined?(this._last=this._last.prev,this._last.next=h.Undefined):A.prev===h.Undefined&&(this._first=this._first.next,this._first.prev=h.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==h.Undefined;)yield A.element,A=A.next}}e.LinkedList=O}),define(_e[27],Ce([1,0]),function(ue,e){"use strict";var h,O,L;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=A,e.mapToString=R,e.setToString=b,e.mapsStrictEqualIgnoreOrder=l;function A(o,t,u){let r=o.get(t);return r===void 0&&(r=u,o.set(t,r)),r}function R(o){const t=[];return o.forEach((u,r)=>{t.push(`${r} => ${u}`)}),`Map(${o.size}) {${t.join(", ")}}`}function b(o){const t=[];return o.forEach(u=>{t.push(u)}),`Set(${o.size}) {${t.join(", ")}}`}class m{constructor(t,u){this.uri=t,this.value=u}}function y(o){return Array.isArray(o)}class T{static{this.defaultToKey=t=>t.toString()}constructor(t,u){if(this[h]="ResourceMap",t instanceof T)this.map=new Map(t.map),this.toKey=u??T.defaultToKey;else if(y(t)){this.map=new Map,this.toKey=u??T.defaultToKey;for(const[r,c]of t)this.set(r,c)}else this.map=new Map,this.toKey=t??T.defaultToKey}set(t,u){return this.map.set(this.toKey(t),new m(t,u)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,u){typeof u<"u"&&(t=t.bind(u));for(const[r,c]of this.map)t(c.value,c.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(h=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=T;class I{constructor(t,u){this[O]="ResourceSet",!t||typeof t=="function"?this._map=new T(t):(this._map=new T(u),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,u){this._map.forEach((r,c)=>t.call(u,c,c,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=I;var p;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class S{constructor(){this[L]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,u=0){const r=this._map.get(t);if(r)return u!==0&&this.touch(r,u),r.value}set(t,u,r=0){let c=this._map.get(t);if(c)c.value=u,r!==0&&this.touch(c,r);else{switch(c={key:t,value:u,next:void 0,previous:void 0},r){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(t,c),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const u=this._map.get(t);if(u)return this._map.delete(t),this.removeItem(u),this._size--,u.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,u){const r=this._state;let c=this._head;for(;c;){if(u?t.bind(u)(c.value,c.key,this):t(c.value,c.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,u=this._state;let r=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==u)throw new Error("LinkedMap got modified during iteration.");if(r){const s={value:r.key,done:!1};return r=r.next,s}else return{value:void 0,done:!0}}};return c}values(){const t=this,u=this._state;let r=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==u)throw new Error("LinkedMap got modified during iteration.");if(r){const s={value:r.value,done:!1};return r=r.next,s}else return{value:void 0,done:!0}}};return c}entries(){const t=this,u=this._state;let r=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==u)throw new Error("LinkedMap got modified during iteration.");if(r){const s={value:[r.key,r.value],done:!1};return r=r.next,s}else return{value:void 0,done:!0}}};return c}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let u=this._head,r=this.size;for(;u&&r>t;)this._map.delete(u.key),u=u.next,r--;this._head=u,this._size=r,u&&(u.previous=void 0),this._state++}trimNew(t){if(t>=this.size)return;if(t===0){this.clear();return}let u=this._tail,r=this.size;for(;u&&r>t;)this._map.delete(u.key),u=u.previous,r--;this._tail=u,this._size=r,u&&(u.next=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const u=t.next,r=t.previous;if(!u||!r)throw new Error("Invalid list");u.previous=r,r.next=u}t.next=void 0,t.previous=void 0,this._state++}touch(t,u){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(t===this._head)return;const r=t.next,c=t.previous;t===this._tail?(c.next=void 0,this._tail=c):(r.previous=c,c.next=r),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(u===2){if(t===this._tail)return;const r=t.next,c=t.previous;t===this._head?(r.previous=void 0,this._head=r):(r.previous=c,c.next=r),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((u,r)=>{t.push([r,u])}),t}fromJSON(t){this.clear();for(const[u,r]of t)this.set(u,r)}}e.LinkedMap=S;class E extends S{constructor(t,u=1){super(),this._limit=t,this._ratio=Math.min(Math.max(0,u),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,u=2){return super.get(t,u)}peek(t){return super.get(t,0)}set(t,u){return super.set(t,u,2),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class d extends E{constructor(t,u=1){super(t,u)}trim(t){this.trimOld(t)}set(t,u){return super.set(t,u),this.checkTrim(),this}}e.LRUCache=d;class f extends E{constructor(t,u=1){super(t,u)}trim(t){this.trimNew(t)}set(t,u){return this._limit<=this.size&&!this.has(t)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(t,u),this}}e.MRUCache=f;class a{constructor(){this.map=new Map}add(t){return this.map.set(t,(this.map.get(t)||0)+1),this}delete(t){let u=this.map.get(t)||0;return u===0?!1:(u--,u===0?this.map.delete(t):this.map.set(t,u),!0)}has(t){return this.map.has(t)}}e.CounterSet=a;class i{constructor(t){if(this._m1=new Map,this._m2=new Map,t)for(const[u,r]of t)this.set(u,r)}clear(){this._m1.clear(),this._m2.clear()}set(t,u){this._m1.set(t,u),this._m2.set(u,t)}get(t){return this._m1.get(t)}getKey(t){return this._m2.get(t)}delete(t){const u=this._m1.get(t);return u===void 0?!1:(this._m1.delete(t),this._m2.delete(u),!0)}forEach(t,u){this._m1.forEach((r,c)=>{t.call(u,r,c,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=i;class n{constructor(){this.map=new Map}add(t,u){let r=this.map.get(t);r||(r=new Set,this.map.set(t,r)),r.add(u)}delete(t,u){const r=this.map.get(t);r&&(r.delete(u),r.size===0&&this.map.delete(t))}forEach(t,u){const r=this.map.get(t);r&&r.forEach(u)}get(t){const u=this.map.get(t);return u||new Set}}e.SetMap=n;function l(o,t){if(o===t)return!0;if(o.size!==t.size)return!1;for(const[u,r]of o)if(!t.has(u)||t.get(u)!==r)return!1;for(const[u]of t)if(!o.has(u))return!1;return!0}}),define(_e[3],Ce([1,0,19,74,27,75,39]),function(ue,e,h,O,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=T,e.trackDisposable=I,e.markAsDisposed=p,e.markAsSingleton=d,e.isDisposable=f,e.dispose=a,e.disposeIfDisposable=i,e.combinedDisposable=n,e.toDisposable=l,e.disposeOnReturn=v;const b=!1;let m=null;class y{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(P){let k=this.livingDisposables.get(P);return k||(k={parent:null,source:null,isSingleton:!1,value:P,idx:y.idx++},this.livingDisposables.set(P,k)),k}trackDisposable(P){const k=this.getDisposableData(P);k.source||(k.source=new Error().stack)}setParent(P,k){const F=this.getDisposableData(P);F.parent=k}markAsDisposed(P){this.livingDisposables.delete(P)}markAsSingleton(P){this.getDisposableData(P).isSingleton=!0}getRootParent(P,k){const F=k.get(P);if(F)return F;const x=P.parent?this.getRootParent(this.getDisposableData(P.parent),k):P;return k.set(P,x),x}getTrackedDisposables(){const P=new Map;return[...this.livingDisposables.entries()].filter(([,F])=>F.source!==null&&!this.getRootParent(F,P).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(P=10,k){let F;if(k)F=k;else{const W=new Map,X=[...this.livingDisposables.values()].filter(H=>H.source!==null&&!this.getRootParent(H,W).isSingleton);if(X.length===0)return;const te=new Set(X.map(H=>H.value));if(F=X.filter(H=>!(H.parent&&te.has(H.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function x(W){function X(H,G){for(;H.length>0&&G.some(Y=>typeof Y=="string"?Y===H[0]:H[0].match(Y));)H.shift()}const te=W.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return X(te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),te.reverse()}const z=new L.SetMap;for(const W of F){const X=x(W);for(let te=0;te<=X.length;te++)z.add(X.slice(0,te).join(`
`),W)}F.sort((0,h.compareBy)(W=>W.idx,h.numberComparator));let N="",M=0;for(const W of F.slice(0,P)){M++;const X=x(W),te=[];for(let H=0;H<X.length;H++){let G=X[H];G=`(shared with ${z.get(X.slice(0,H+1).join(`
`)).size}/${F.length} leaks) at ${G}`;const ne=z.get(X.slice(0,H).join(`
`)),pe=(0,O.groupBy)([...ne].map(le=>x(le)[H]),le=>le);delete pe[X[H]];for(const[le,we]of Object.entries(pe))te.unshift(`    - stacktraces of ${we.length} other leaks continue with ${le}`);te.unshift(G)}N+=`


==================== Leaking disposable ${M}/${F.length}: ${W.value.constructor.name} ====================
${te.join(`
`)}
============================================================

`}return F.length>P&&(N+=`


... and ${F.length-P} more leaking disposables

`),{leaks:F,details:N}}}e.DisposableTracker=y;function T(C){m=C}if(b){const C="__is_disposable_tracked__";T(new class{trackDisposable(P){const k=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[C]||console.log(k)},3e3)}setParent(P,k){if(P&&P!==t.None)try{P[C]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[C]=!0}catch{}}markAsSingleton(P){}})}function I(C){return m?.trackDisposable(C),C}function p(C){m?.markAsDisposed(C)}function S(C,P){m?.setParent(C,P)}function E(C,P){if(m)for(const k of C)m.setParent(k,P)}function d(C){return m?.markAsSingleton(C),C}function f(C){return typeof C=="object"&&C!==null&&typeof C.dispose=="function"&&C.dispose.length===0}function a(C){if(R.Iterable.is(C)){const P=[];for(const k of C)if(k)try{k.dispose()}catch(F){P.push(F)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(C)?[]:C}else if(C)return C.dispose(),C}function i(C){for(const P of C)f(P)&&P.dispose();return[]}function n(...C){const P=l(()=>a(C));return E(C,P),P}function l(C){const P=I({dispose:(0,A.createSingleCallFunction)(()=>{p(P),C()})});return P}class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(p(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{a(this._toDispose)}finally{this._toDispose.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return S(P,this),this._isDisposed?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(P),P.dispose()}}deleteAndLeak(P){P&&this._toDispose.has(P)&&(this._toDispose.delete(P),S(P,null))}}e.DisposableStore=o;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new o,I(this),S(this._store,this)}dispose(){p(this),this._store.dispose()}_register(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(P)}}e.Disposable=t;class u{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(P){this._isDisposed||P===this._value||(this._value?.dispose(),P&&S(P,this),this._value=P)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,p(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const P=this._value;return this._value=void 0,P&&S(P,null),P}}e.MutableDisposable=u;class r{constructor(P){this._disposable=new u,this._isDisposed=!1,this._disposable.value=P}get value(){return this._disposable.value}set value(P){this._isDisposed||P===this._disposable.value||(this._disposable.value=P)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=r;class c{constructor(P){this._disposable=P,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(P){let k=P;return this.unset=()=>k=void 0,this.isset=()=>k!==void 0,this.dispose=()=>{k&&(k(),k=void 0,p(this))},this}}e.SafeDisposable=s;class w{constructor(){this.references=new Map}acquire(P,...k){let F=this.references.get(P);F||(F={counter:0,object:this.createReferencedObject(P,...k)},this.references.set(P,F));const{object:x}=F,z=(0,A.createSingleCallFunction)(()=>{--F.counter===0&&(this.destroyReferencedObject(P,F.object),this.references.delete(P))});return F.counter++,{object:x,dispose:z}}}e.ReferenceCollection=w;class g{constructor(P){this.referenceCollection=P}async acquire(P,...k){const F=this.referenceCollection.acquire(P,...k);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(x){throw F.dispose(),x}}}e.AsyncReferenceCollection=g;class D{constructor(P){this.object=P}dispose(){}}e.ImmortalReference=D;function v(C){const P=new o;try{C(P)}finally{P.dispose()}}class _{constructor(){this._store=new Map,this._isDisposed=!1,I(this)}dispose(){p(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{a(this._store.values())}finally{this._store.clear()}}has(P){return this._store.has(P)}get size(){return this._store.size}get(P){return this._store.get(P)}set(P,k,F=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this._store.get(P)?.dispose(),this._store.set(P,k)}deleteAndDispose(P){this._store.get(P)?.dispose(),this._store.delete(P)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=_}),function(ue,e){typeof define=="function"&&define.amd?define(_e[167],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ue=typeof globalThis<"u"?globalThis:ue||self,e(ue.marked={}))}(this,function(ue){"use strict";function e(oe,se){for(var re=0;re<se.length;re++){var j=se[re];j.enumerable=j.enumerable||!1,j.configurable=!0,"value"in j&&(j.writable=!0),Object.defineProperty(oe,j.key,j)}}function h(oe,se,re){return se&&e(oe.prototype,se),re&&e(oe,re),Object.defineProperty(oe,"prototype",{writable:!1}),oe}function O(oe,se){if(oe){if(typeof oe=="string")return L(oe,se);var re=Object.prototype.toString.call(oe).slice(8,-1);if(re==="Object"&&oe.constructor&&(re=oe.constructor.name),re==="Map"||re==="Set")return Array.from(oe);if(re==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(re))return L(oe,se)}}function L(oe,se){(se==null||se>oe.length)&&(se=oe.length);for(var re=0,j=new Array(se);re<se;re++)j[re]=oe[re];return j}function A(oe,se){var re=typeof Symbol<"u"&&oe[Symbol.iterator]||oe["@@iterator"];if(re)return(re=re.call(oe)).next.bind(re);if(Array.isArray(oe)||(re=O(oe))||se&&oe&&typeof oe.length=="number"){re&&(oe=re);var j=0;return function(){return j>=oe.length?{done:!0}:{done:!1,value:oe[j++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ue.defaults=R();function b(oe){ue.defaults=oe}var m=/[&<>"']/,y=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(se){return p[se]};function E(oe,se){if(se){if(m.test(oe))return oe.replace(y,S)}else if(T.test(oe))return oe.replace(I,S);return oe}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(oe){return oe.replace(d,function(se,re){return re=re.toLowerCase(),re==="colon"?":":re.charAt(0)==="#"?re.charAt(1)==="x"?String.fromCharCode(parseInt(re.substring(2),16)):String.fromCharCode(+re.substring(1)):""})}var a=/(^|[^\[])\^/g;function i(oe,se){oe=typeof oe=="string"?oe:oe.source,se=se||"";var re={replace:function(ie,me){return me=me.source||me,me=me.replace(a,"$1"),oe=oe.replace(ie,me),re},getRegex:function(){return new RegExp(oe,se)}};return re}var n=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function o(oe,se,re){if(oe){var j;try{j=decodeURIComponent(f(re)).replace(n,"").toLowerCase()}catch{return null}if(j.indexOf("javascript:")===0||j.indexOf("vbscript:")===0||j.indexOf("data:")===0)return null}se&&!l.test(re)&&(re=s(se,re));try{re=encodeURI(re).replace(/%25/g,"%")}catch{return null}return re}var t={},u=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(oe,se){t[" "+oe]||(u.test(oe)?t[" "+oe]=oe+"/":t[" "+oe]=v(oe,"/",!0)),oe=t[" "+oe];var re=oe.indexOf(":")===-1;return se.substring(0,2)==="//"?re?se:oe.replace(r,"$1")+se:se.charAt(0)==="/"?re?se:oe.replace(c,"$1")+se:oe+se}var w={exec:function(){}};function g(oe){for(var se=1,re,j;se<arguments.length;se++){re=arguments[se];for(j in re)Object.prototype.hasOwnProperty.call(re,j)&&(oe[j]=re[j])}return oe}function D(oe,se){var re=oe.replace(/\|/g,function(me,be,Ae){for(var fe=!1,De=be;--De>=0&&Ae[De]==="\\";)fe=!fe;return fe?"|":" |"}),j=re.split(/ \|/),ie=0;if(j[0].trim()||j.shift(),j.length>0&&!j[j.length-1].trim()&&j.pop(),j.length>se)j.splice(se);else for(;j.length<se;)j.push("");for(;ie<j.length;ie++)j[ie]=j[ie].trim().replace(/\\\|/g,"|");return j}function v(oe,se,re){var j=oe.length;if(j===0)return"";for(var ie=0;ie<j;){var me=oe.charAt(j-ie-1);if(me===se&&!re)ie++;else if(me!==se&&re)ie++;else break}return oe.slice(0,j-ie)}function _(oe,se){if(oe.indexOf(se[1])===-1)return-1;for(var re=oe.length,j=0,ie=0;ie<re;ie++)if(oe[ie]==="\\")ie++;else if(oe[ie]===se[0])j++;else if(oe[ie]===se[1]&&(j--,j<0))return ie;return-1}function C(oe){oe&&oe.sanitize&&!oe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(oe,se){if(se<1)return"";for(var re="";se>1;)se&1&&(re+=oe),se>>=1,oe+=oe;return re+oe}function k(oe,se,re,j){var ie=se.href,me=se.title?E(se.title):null,be=oe[1].replace(/\\([\[\]])/g,"$1");if(oe[0].charAt(0)!=="!"){j.state.inLink=!0;var Ae={type:"link",raw:re,href:ie,title:me,text:be,tokens:j.inlineTokens(be)};return j.state.inLink=!1,Ae}return{type:"image",raw:re,href:ie,title:me,text:E(be)}}function F(oe,se){var re=oe.match(/^(\s+)(?:```)/);if(re===null)return se;var j=re[1];return se.split(`
`).map(function(ie){var me=ie.match(/^\s+/);if(me===null)return ie;var be=me[0];return be.length>=j.length?ie.slice(j.length):ie}).join(`
`)}var x=function(){function oe(re){this.options=re||ue.defaults}var se=oe.prototype;return se.space=function(j){var ie=this.rules.block.newline.exec(j);if(ie&&ie[0].length>0)return{type:"space",raw:ie[0]}},se.code=function(j){var ie=this.rules.block.code.exec(j);if(ie){var me=ie[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ie[0],codeBlockStyle:"indented",text:this.options.pedantic?me:v(me,`
`)}}},se.fences=function(j){var ie=this.rules.block.fences.exec(j);if(ie){var me=ie[0],be=F(me,ie[3]||"");return{type:"code",raw:me,lang:ie[2]?ie[2].trim():ie[2],text:be}}},se.heading=function(j){var ie=this.rules.block.heading.exec(j);if(ie){var me=ie[2].trim();if(/#$/.test(me)){var be=v(me,"#");(this.options.pedantic||!be||/ $/.test(be))&&(me=be.trim())}return{type:"heading",raw:ie[0],depth:ie[1].length,text:me,tokens:this.lexer.inline(me)}}},se.hr=function(j){var ie=this.rules.block.hr.exec(j);if(ie)return{type:"hr",raw:ie[0]}},se.blockquote=function(j){var ie=this.rules.block.blockquote.exec(j);if(ie){var me=ie[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ie[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},se.list=function(j){var ie=this.rules.block.list.exec(j);if(ie){var me,be,Ae,fe,De,Te,ze,U,$,K,Q,de,Ee=ie[1].trim(),Fe=Ee.length>1,He={type:"list",raw:"",ordered:Fe,start:Fe?+Ee.slice(0,-1):"",loose:!1,items:[]};Ee=Fe?"\\d{1,9}\\"+Ee.slice(-1):"\\"+Ee,this.options.pedantic&&(Ee=Fe?Ee:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+Ee+")((?:[	 ][^\\n]*)?(?:\\n|$))");j&&(de=!1,!(!(ie=Ke.exec(j))||this.rules.block.hr.test(j)));){if(me=ie[0],j=j.substring(me.length),U=ie[2].split(`
`,1)[0],$=j.split(`
`,1)[0],this.options.pedantic?(fe=2,Q=U.trimLeft()):(fe=ie[2].search(/[^ ]/),fe=fe>4?1:fe,Q=U.slice(fe),fe+=ie[1].length),Te=!1,!U&&/^ *$/.test($)&&(me+=$+`
`,j=j.substring($.length+1),de=!0),!de)for(var rt=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,fe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,fe-1)+"}#");j&&(K=j.split(`
`,1)[0],U=K,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(U)||st.test(U)||rt.test(U)||tt.test(j)));){if(U.search(/[^ ]/)>=fe||!U.trim())Q+=`
`+U.slice(fe);else if(!Te)Q+=`
`+U;else break;!Te&&!U.trim()&&(Te=!0),me+=K+`
`,j=j.substring(K.length+1)}He.loose||(ze?He.loose=!0:/\n *\n *$/.test(me)&&(ze=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(Q),be&&(Ae=be[0]!=="[ ] ",Q=Q.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:me,task:!!be,checked:Ae,loose:!1,text:Q}),He.raw+=me}He.items[He.items.length-1].raw=me.trimRight(),He.items[He.items.length-1].text=Q.trimRight(),He.raw=He.raw.trimRight();var Ie=He.items.length;for(De=0;De<Ie;De++){this.lexer.state.top=!1,He.items[De].tokens=this.lexer.blockTokens(He.items[De].text,[]);var Be=He.items[De].tokens.filter(function(Oe){return Oe.type==="space"}),qe=Be.every(function(Oe){for(var Qe=Oe.raw.split(""),ae=0,ce=A(Qe),ke;!(ke=ce()).done;){var je=ke.value;if(je===`
`&&(ae+=1),ae>1)return!0}return!1});!He.loose&&Be.length&&qe&&(He.loose=!0,He.items[De].loose=!0)}return He}},se.html=function(j){var ie=this.rules.block.html.exec(j);if(ie){var me={type:"html",raw:ie[0],pre:!this.options.sanitizer&&(ie[1]==="pre"||ie[1]==="script"||ie[1]==="style"),text:ie[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(ie[0]):E(ie[0]);me.type="paragraph",me.text=be,me.tokens=this.lexer.inline(be)}return me}},se.def=function(j){var ie=this.rules.block.def.exec(j);if(ie){ie[3]&&(ie[3]=ie[3].substring(1,ie[3].length-1));var me=ie[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:ie[0],href:ie[2],title:ie[3]}}},se.table=function(j){var ie=this.rules.block.table.exec(j);if(ie){var me={type:"table",header:D(ie[1]).map(function(ze){return{text:ze}}),align:ie[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ie[3]&&ie[3].trim()?ie[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=ie[0];var be=me.align.length,Ae,fe,De,Te;for(Ae=0;Ae<be;Ae++)/^ *-+: *$/.test(me.align[Ae])?me.align[Ae]="right":/^ *:-+: *$/.test(me.align[Ae])?me.align[Ae]="center":/^ *:-+ *$/.test(me.align[Ae])?me.align[Ae]="left":me.align[Ae]=null;for(be=me.rows.length,Ae=0;Ae<be;Ae++)me.rows[Ae]=D(me.rows[Ae],me.header.length).map(function(ze){return{text:ze}});for(be=me.header.length,fe=0;fe<be;fe++)me.header[fe].tokens=this.lexer.inline(me.header[fe].text);for(be=me.rows.length,fe=0;fe<be;fe++)for(Te=me.rows[fe],De=0;De<Te.length;De++)Te[De].tokens=this.lexer.inline(Te[De].text);return me}}},se.lheading=function(j){var ie=this.rules.block.lheading.exec(j);if(ie)return{type:"heading",raw:ie[0],depth:ie[2].charAt(0)==="="?1:2,text:ie[1],tokens:this.lexer.inline(ie[1])}},se.paragraph=function(j){var ie=this.rules.block.paragraph.exec(j);if(ie){var me=ie[1].charAt(ie[1].length-1)===`
`?ie[1].slice(0,-1):ie[1];return{type:"paragraph",raw:ie[0],text:me,tokens:this.lexer.inline(me)}}},se.text=function(j){var ie=this.rules.block.text.exec(j);if(ie)return{type:"text",raw:ie[0],text:ie[0],tokens:this.lexer.inline(ie[0])}},se.escape=function(j){var ie=this.rules.inline.escape.exec(j);if(ie)return{type:"escape",raw:ie[0],text:E(ie[1])}},se.tag=function(j){var ie=this.rules.inline.tag.exec(j);if(ie)return!this.lexer.state.inLink&&/^<a /i.test(ie[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ie[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ie[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ie[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ie[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):E(ie[0]):ie[0]}},se.link=function(j){var ie=this.rules.inline.link.exec(j);if(ie){var me=ie[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var be=v(me.slice(0,-1),"\\");if((me.length-be.length)%2===0)return}else{var Ae=_(ie[2],"()");if(Ae>-1){var fe=ie[0].indexOf("!")===0?5:4,De=fe+ie[1].length+Ae;ie[2]=ie[2].substring(0,Ae),ie[0]=ie[0].substring(0,De).trim(),ie[3]=""}}var Te=ie[2],ze="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Te);U&&(Te=U[1],ze=U[3])}else ze=ie[3]?ie[3].slice(1,-1):"";return Te=Te.trim(),/^</.test(Te)&&(this.options.pedantic&&!/>$/.test(me)?Te=Te.slice(1):Te=Te.slice(1,-1)),k(ie,{href:Te&&Te.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},ie[0],this.lexer)}},se.reflink=function(j,ie){var me;if((me=this.rules.inline.reflink.exec(j))||(me=this.rules.inline.nolink.exec(j))){var be=(me[2]||me[1]).replace(/\s+/g," ");if(be=ie[be.toLowerCase()],!be||!be.href){var Ae=me[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return k(me,be,me[0],this.lexer)}},se.emStrong=function(j,ie,me){me===void 0&&(me="");var be=this.rules.inline.emStrong.lDelim.exec(j);if(be&&!(be[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=be[1]||be[2]||"";if(!Ae||Ae&&(me===""||this.rules.inline.punctuation.exec(me))){var fe=be[0].length-1,De,Te,ze=fe,U=0,$=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for($.lastIndex=0,ie=ie.slice(-1*j.length+fe);(be=$.exec(ie))!=null;)if(De=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!De){if(Te=De.length,be[3]||be[4]){ze+=Te;continue}else if((be[5]||be[6])&&fe%3&&!((fe+Te)%3)){U+=Te;continue}if(ze-=Te,!(ze>0)){if(Te=Math.min(Te,Te+ze+U),Math.min(fe,Te)%2){var K=j.slice(1,fe+be.index+Te);return{type:"em",raw:j.slice(0,fe+be.index+Te+1),text:K,tokens:this.lexer.inlineTokens(K)}}var Q=j.slice(2,fe+be.index+Te-1);return{type:"strong",raw:j.slice(0,fe+be.index+Te+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}}}}},se.codespan=function(j){var ie=this.rules.inline.code.exec(j);if(ie){var me=ie[2].replace(/\n/g," "),be=/[^ ]/.test(me),Ae=/^ /.test(me)&&/ $/.test(me);return be&&Ae&&(me=me.substring(1,me.length-1)),me=E(me,!0),{type:"codespan",raw:ie[0],text:me}}},se.br=function(j){var ie=this.rules.inline.br.exec(j);if(ie)return{type:"br",raw:ie[0]}},se.del=function(j){var ie=this.rules.inline.del.exec(j);if(ie)return{type:"del",raw:ie[0],text:ie[2],tokens:this.lexer.inlineTokens(ie[2])}},se.autolink=function(j,ie){var me=this.rules.inline.autolink.exec(j);if(me){var be,Ae;return me[2]==="@"?(be=E(this.options.mangle?ie(me[1]):me[1]),Ae="mailto:"+be):(be=E(me[1]),Ae=be),{type:"link",raw:me[0],text:be,href:Ae,tokens:[{type:"text",raw:be,text:be}]}}},se.url=function(j,ie){var me;if(me=this.rules.inline.url.exec(j)){var be,Ae;if(me[2]==="@")be=E(this.options.mangle?ie(me[0]):me[0]),Ae="mailto:"+be;else{var fe;do fe=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(fe!==me[0]);be=E(me[0]),me[1]==="www."?Ae="http://"+be:Ae=be}return{type:"link",raw:me[0],text:be,href:Ae,tokens:[{type:"text",raw:be,text:be}]}}},se.inlineText=function(j,ie){var me=this.rules.inline.text.exec(j);if(me){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):E(me[0]):me[0]:be=E(this.options.smartypants?ie(me[0]):me[0]),{type:"text",raw:me[0],text:be}}},oe}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:w,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=i(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=i(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=i(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=i(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=i(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=i(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=g({},z),z.gfm=g({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=i(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=i(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=g({},z.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:w,paragraph:i(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:w,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:w,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=i(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=i(z._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=i(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=i(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=i(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=i(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=i(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=i(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=i(N.reflink).replace("label",N._label).replace("ref",z._label).getRegex(),N.nolink=i(N.nolink).replace("ref",z._label).getRegex(),N.reflinkSearch=i(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=g({},N),N.pedantic=g({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=g({},N.normal,{escape:i(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=i(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=g({},N.gfm,{br:i(N.br).replace("{2,}","*").getRegex(),text:i(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(oe){return oe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(oe){var se="",re,j,ie=oe.length;for(re=0;re<ie;re++)j=oe.charCodeAt(re),Math.random()>.5&&(j="x"+j.toString(16)),se+="&#"+j+";";return se}var X=function(){function oe(re){this.tokens=[],this.tokens.links=Object.create(null),this.options=re||ue.defaults,this.options.tokenizer=this.options.tokenizer||new x,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var j={block:z.normal,inline:N.normal};this.options.pedantic?(j.block=z.pedantic,j.inline=N.pedantic):this.options.gfm&&(j.block=z.gfm,this.options.breaks?j.inline=N.breaks:j.inline=N.gfm),this.tokenizer.rules=j}oe.lex=function(j,ie){var me=new oe(ie);return me.lex(j)},oe.lexInline=function(j,ie){var me=new oe(ie);return me.inlineTokens(j)};var se=oe.prototype;return se.lex=function(j){j=j.replace(/\r\n|\r/g,`
`),this.blockTokens(j,this.tokens);for(var ie;ie=this.inlineQueue.shift();)this.inlineTokens(ie.src,ie.tokens);return this.tokens},se.blockTokens=function(j,ie){var me=this;ie===void 0&&(ie=[]),this.options.pedantic?j=j.replace(/\t/g,"    ").replace(/^ +$/gm,""):j=j.replace(/^( *)(\t+)/gm,function(ze,U,$){return U+"    ".repeat($.length)});for(var be,Ae,fe,De;j;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(be=ze.call({lexer:me},j,ie))?(j=j.substring(be.raw.length),ie.push(be),!0):!1}))){if(be=this.tokenizer.space(j)){j=j.substring(be.raw.length),be.raw.length===1&&ie.length>0?ie[ie.length-1].raw+=`
`:ie.push(be);continue}if(be=this.tokenizer.code(j)){j=j.substring(be.raw.length),Ae=ie[ie.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+be.raw,Ae.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ie.push(be);continue}if(be=this.tokenizer.fences(j)){j=j.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.heading(j)){j=j.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.hr(j)){j=j.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.blockquote(j)){j=j.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.list(j)){j=j.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.html(j)){j=j.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.def(j)){j=j.substring(be.raw.length),Ae=ie[ie.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+be.raw,Ae.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(j)){j=j.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.lheading(j)){j=j.substring(be.raw.length),ie.push(be);continue}if(fe=j,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,U=j.slice(1),$=void 0;me.options.extensions.startBlock.forEach(function(K){$=K.call({lexer:this},U),typeof $=="number"&&$>=0&&(ze=Math.min(ze,$))}),ze<1/0&&ze>=0&&(fe=j.substring(0,ze+1))}(),this.state.top&&(be=this.tokenizer.paragraph(fe))){Ae=ie[ie.length-1],De&&Ae.type==="paragraph"?(Ae.raw+=`
`+be.raw,Ae.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ie.push(be),De=fe.length!==j.length,j=j.substring(be.raw.length);continue}if(be=this.tokenizer.text(j)){j=j.substring(be.raw.length),Ae=ie[ie.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+be.raw,Ae.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ie.push(be);continue}if(j){var Te="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(Te);break}else throw new Error(Te)}}return this.state.top=!0,ie},se.inline=function(j,ie){return ie===void 0&&(ie=[]),this.inlineQueue.push({src:j,tokens:ie}),ie},se.inlineTokens=function(j,ie){var me=this;ie===void 0&&(ie=[]);var be,Ae,fe,De=j,Te,ze,U;if(this.tokens.links){var $=Object.keys(this.tokens.links);if($.length>0)for(;(Te=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)$.includes(Te[0].slice(Te[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,Te.index)+"["+P("a",Te[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Te=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,Te.index)+"["+P("a",Te[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Te=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,Te.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;j;)if(ze||(U=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Q){return(be=Q.call({lexer:me},j,ie))?(j=j.substring(be.raw.length),ie.push(be),!0):!1}))){if(be=this.tokenizer.escape(j)){j=j.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.tag(j)){j=j.substring(be.raw.length),Ae=ie[ie.length-1],Ae&&be.type==="text"&&Ae.type==="text"?(Ae.raw+=be.raw,Ae.text+=be.text):ie.push(be);continue}if(be=this.tokenizer.link(j)){j=j.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.reflink(j,this.tokens.links)){j=j.substring(be.raw.length),Ae=ie[ie.length-1],Ae&&be.type==="text"&&Ae.type==="text"?(Ae.raw+=be.raw,Ae.text+=be.text):ie.push(be);continue}if(be=this.tokenizer.emStrong(j,De,U)){j=j.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.codespan(j)){j=j.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.br(j)){j=j.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.del(j)){j=j.substring(be.raw.length),ie.push(be);continue}if(be=this.tokenizer.autolink(j,W)){j=j.substring(be.raw.length),ie.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(j,W))){j=j.substring(be.raw.length),ie.push(be);continue}if(fe=j,this.options.extensions&&this.options.extensions.startInline&&function(){var Q=1/0,de=j.slice(1),Ee=void 0;me.options.extensions.startInline.forEach(function(Fe){Ee=Fe.call({lexer:this},de),typeof Ee=="number"&&Ee>=0&&(Q=Math.min(Q,Ee))}),Q<1/0&&Q>=0&&(fe=j.substring(0,Q+1))}(),be=this.tokenizer.inlineText(fe,M)){j=j.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(U=be.raw.slice(-1)),ze=!0,Ae=ie[ie.length-1],Ae&&Ae.type==="text"?(Ae.raw+=be.raw,Ae.text+=be.text):ie.push(be);continue}if(j){var K="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return ie},h(oe,null,[{key:"rules",get:function(){return{block:z,inline:N}}}]),oe}(),te=function(){function oe(re){this.options=re||ue.defaults}var se=oe.prototype;return se.code=function(j,ie,me){var be=(ie||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(j,be);Ae!=null&&Ae!==j&&(me=!0,j=Ae)}return j=j.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+E(be,!0)+'">'+(me?j:E(j,!0))+`</code></pre>
`:"<pre><code>"+(me?j:E(j,!0))+`</code></pre>
`},se.blockquote=function(j){return`<blockquote>
`+j+`</blockquote>
`},se.html=function(j){return j},se.heading=function(j,ie,me,be){if(this.options.headerIds){var Ae=this.options.headerPrefix+be.slug(me);return"<h"+ie+' id="'+Ae+'">'+j+"</h"+ie+`>
`}return"<h"+ie+">"+j+"</h"+ie+`>
`},se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},se.list=function(j,ie,me){var be=ie?"ol":"ul",Ae=ie&&me!==1?' start="'+me+'"':"";return"<"+be+Ae+`>
`+j+"</"+be+`>
`},se.listitem=function(j){return"<li>"+j+`</li>
`},se.checkbox=function(j){return"<input "+(j?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},se.paragraph=function(j){return"<p>"+j+`</p>
`},se.table=function(j,ie){return ie&&(ie="<tbody>"+ie+"</tbody>"),`<table>
<thead>
`+j+`</thead>
`+ie+`</table>
`},se.tablerow=function(j){return`<tr>
`+j+`</tr>
`},se.tablecell=function(j,ie){var me=ie.header?"th":"td",be=ie.align?"<"+me+' align="'+ie.align+'">':"<"+me+">";return be+j+("</"+me+`>
`)},se.strong=function(j){return"<strong>"+j+"</strong>"},se.em=function(j){return"<em>"+j+"</em>"},se.codespan=function(j){return"<code>"+j+"</code>"},se.br=function(){return this.options.xhtml?"<br/>":"<br>"},se.del=function(j){return"<del>"+j+"</del>"},se.link=function(j,ie,me){if(j=o(this.options.sanitize,this.options.baseUrl,j),j===null)return me;var be='<a href="'+E(j)+'"';return ie&&(be+=' title="'+ie+'"'),be+=">"+me+"</a>",be},se.image=function(j,ie,me){if(j=o(this.options.sanitize,this.options.baseUrl,j),j===null)return me;var be='<img src="'+j+'" alt="'+me+'"';return ie&&(be+=' title="'+ie+'"'),be+=this.options.xhtml?"/>":">",be},se.text=function(j){return j},oe}(),H=function(){function oe(){}var se=oe.prototype;return se.strong=function(j){return j},se.em=function(j){return j},se.codespan=function(j){return j},se.del=function(j){return j},se.html=function(j){return j},se.text=function(j){return j},se.link=function(j,ie,me){return""+me},se.image=function(j,ie,me){return""+me},se.br=function(){return""},oe}(),G=function(){function oe(){this.seen={}}var se=oe.prototype;return se.serialize=function(j){return j.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},se.getNextSafeSlug=function(j,ie){var me=j,be=0;if(this.seen.hasOwnProperty(me)){be=this.seen[j];do be++,me=j+"-"+be;while(this.seen.hasOwnProperty(me))}return ie||(this.seen[j]=be,this.seen[me]=0),me},se.slug=function(j,ie){ie===void 0&&(ie={});var me=this.serialize(j);return this.getNextSafeSlug(me,ie.dryrun)},oe}(),Y=function(){function oe(re){this.options=re||ue.defaults,this.options.renderer=this.options.renderer||new te,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new H,this.slugger=new G}oe.parse=function(j,ie){var me=new oe(ie);return me.parse(j)},oe.parseInline=function(j,ie){var me=new oe(ie);return me.parseInline(j)};var se=oe.prototype;return se.parse=function(j,ie){ie===void 0&&(ie=!0);var me="",be,Ae,fe,De,Te,ze,U,$,K,Q,de,Ee,Fe,He,Ke,rt,tt,it,st,Ie=j.length;for(be=0;be<Ie;be++){if(Q=j[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Q.type]&&(st=this.options.extensions.renderers[Q.type].call({parser:this},Q),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Q.type))){me+=st||"";continue}switch(Q.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(Q.tokens),Q.depth,f(this.parseInline(Q.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(Q.text,Q.lang,Q.escaped);continue}case"table":{for($="",U="",De=Q.header.length,Ae=0;Ae<De;Ae++)U+=this.renderer.tablecell(this.parseInline(Q.header[Ae].tokens),{header:!0,align:Q.align[Ae]});for($+=this.renderer.tablerow(U),K="",De=Q.rows.length,Ae=0;Ae<De;Ae++){for(ze=Q.rows[Ae],U="",Te=ze.length,fe=0;fe<Te;fe++)U+=this.renderer.tablecell(this.parseInline(ze[fe].tokens),{header:!1,align:Q.align[fe]});K+=this.renderer.tablerow(U)}me+=this.renderer.table($,K);continue}case"blockquote":{K=this.parse(Q.tokens),me+=this.renderer.blockquote(K);continue}case"list":{for(de=Q.ordered,Ee=Q.start,Fe=Q.loose,De=Q.items.length,K="",Ae=0;Ae<De;Ae++)Ke=Q.items[Ae],rt=Ke.checked,tt=Ke.task,He="",Ke.task&&(it=this.renderer.checkbox(rt),Fe?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=it+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=it+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:it}):He+=it),He+=this.parse(Ke.tokens,Fe),K+=this.renderer.listitem(He,tt,rt);me+=this.renderer.list(K,de,Ee);continue}case"html":{me+=this.renderer.html(Q.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(Q.tokens));continue}case"text":{for(K=Q.tokens?this.parseInline(Q.tokens):Q.text;be+1<Ie&&j[be+1].type==="text";)Q=j[++be],K+=`
`+(Q.tokens?this.parseInline(Q.tokens):Q.text);me+=ie?this.renderer.paragraph(K):K;continue}default:{var Be='Token with "'+Q.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return me},se.parseInline=function(j,ie){ie=ie||this.renderer;var me="",be,Ae,fe,De=j.length;for(be=0;be<De;be++){if(Ae=j[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(fe=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),fe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){me+=fe||"";continue}switch(Ae.type){case"escape":{me+=ie.text(Ae.text);break}case"html":{me+=ie.html(Ae.text);break}case"link":{me+=ie.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,ie));break}case"image":{me+=ie.image(Ae.href,Ae.title,Ae.text);break}case"strong":{me+=ie.strong(this.parseInline(Ae.tokens,ie));break}case"em":{me+=ie.em(this.parseInline(Ae.tokens,ie));break}case"codespan":{me+=ie.codespan(Ae.text);break}case"br":{me+=ie.br();break}case"del":{me+=ie.del(this.parseInline(Ae.tokens,ie));break}case"text":{me+=ie.text(Ae.text);break}default:{var Te='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}}return me},oe}();function ne(oe,se,re){if(typeof oe>"u"||oe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");if(typeof se=="function"&&(re=se,se=null),se=g({},ne.defaults,se||{}),C(se),re){var j=se.highlight,ie;try{ie=X.lex(oe,se)}catch(De){return re(De)}var me=function(Te){var ze;if(!Te)try{se.walkTokens&&ne.walkTokens(ie,se.walkTokens),ze=Y.parse(ie,se)}catch(U){Te=U}return se.highlight=j,Te?re(Te):re(null,ze)};if(!j||j.length<3||(delete se.highlight,!ie.length))return me();var be=0;ne.walkTokens(ie,function(De){De.type==="code"&&(be++,setTimeout(function(){j(De.text,De.lang,function(Te,ze){if(Te)return me(Te);ze!=null&&ze!==De.text&&(De.text=ze,De.escaped=!0),be--,be===0&&me()})},0))}),be===0&&me();return}function Ae(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+E(De.message+"",!0)+"</pre>";throw De}try{var fe=X.lex(oe,se);if(se.walkTokens){if(se.async)return Promise.all(ne.walkTokens(fe,se.walkTokens)).then(function(){return Y.parse(fe,se)}).catch(Ae);ne.walkTokens(fe,se.walkTokens)}return Y.parse(fe,se)}catch(De){Ae(De)}}ne.options=ne.setOptions=function(oe){return g(ne.defaults,oe),b(ne.defaults),ne},ne.getDefaults=R,ne.defaults=ue.defaults,ne.use=function(){for(var oe=arguments.length,se=new Array(oe),re=0;re<oe;re++)se[re]=arguments[re];var j=g.apply(void 0,[{}].concat(se)),ie=ne.defaults.extensions||{renderers:{},childTokens:{}},me;se.forEach(function(be){if(be.extensions&&(me=!0,be.extensions.forEach(function(fe){if(!fe.name)throw new Error("extension name required");if(fe.renderer){var De=ie.renderers?ie.renderers[fe.name]:null;De?ie.renderers[fe.name]=function(){for(var Te=arguments.length,ze=new Array(Te),U=0;U<Te;U++)ze[U]=arguments[U];var $=fe.renderer.apply(this,ze);return $===!1&&($=De.apply(this,ze)),$}:ie.renderers[fe.name]=fe.renderer}if(fe.tokenizer){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ie[fe.level]?ie[fe.level].unshift(fe.tokenizer):ie[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?ie.startBlock?ie.startBlock.push(fe.start):ie.startBlock=[fe.start]:fe.level==="inline"&&(ie.startInline?ie.startInline.push(fe.start):ie.startInline=[fe.start]))}fe.childTokens&&(ie.childTokens[fe.name]=fe.childTokens)})),be.renderer&&function(){var fe=ne.defaults.renderer||new te,De=function(U){var $=fe[U];fe[U]=function(){for(var K=arguments.length,Q=new Array(K),de=0;de<K;de++)Q[de]=arguments[de];var Ee=be.renderer[U].apply(fe,Q);return Ee===!1&&(Ee=$.apply(fe,Q)),Ee}};for(var Te in be.renderer)De(Te);j.renderer=fe}(),be.tokenizer&&function(){var fe=ne.defaults.tokenizer||new x,De=function(U){var $=fe[U];fe[U]=function(){for(var K=arguments.length,Q=new Array(K),de=0;de<K;de++)Q[de]=arguments[de];var Ee=be.tokenizer[U].apply(fe,Q);return Ee===!1&&(Ee=$.apply(fe,Q)),Ee}};for(var Te in be.tokenizer)De(Te);j.tokenizer=fe}(),be.walkTokens){var Ae=ne.defaults.walkTokens;j.walkTokens=function(fe){var De=[];return De.push(be.walkTokens.call(this,fe)),Ae&&(De=De.concat(Ae.call(this,fe))),De}}me&&(j.extensions=ie),ne.setOptions(j)})},ne.walkTokens=function(oe,se){for(var re=[],j=function(){var Ae=me.value;switch(re=re.concat(se.call(ne,Ae)),Ae.type){case"table":{for(var fe=A(Ae.header),De;!(De=fe()).done;){var Te=De.value;re=re.concat(ne.walkTokens(Te.tokens,se))}for(var ze=A(Ae.rows),U;!(U=ze()).done;)for(var $=U.value,K=A($),Q;!(Q=K()).done;){var de=Q.value;re=re.concat(ne.walkTokens(de.tokens,se))}break}case"list":{re=re.concat(ne.walkTokens(Ae.items,se));break}default:ne.defaults.extensions&&ne.defaults.extensions.childTokens&&ne.defaults.extensions.childTokens[Ae.type]?ne.defaults.extensions.childTokens[Ae.type].forEach(function(Ee){re=re.concat(ne.walkTokens(Ae[Ee],se))}):Ae.tokens&&(re=re.concat(ne.walkTokens(Ae.tokens,se)))}},ie=A(oe),me;!(me=ie()).done;)j();return re},ne.parseInline=function(oe,se){if(typeof oe>"u"||oe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");se=g({},ne.defaults,se||{}),C(se);try{var re=X.lexInline(oe,se);return se.walkTokens&&ne.walkTokens(re,se.walkTokens),Y.parseInline(re,se)}catch(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+E(j.message+"",!0)+"</pre>";throw j}},ne.Parser=Y,ne.parser=Y.parse,ne.Renderer=te,ne.TextRenderer=H,ne.Lexer=X,ne.lexer=X.lex,ne.Tokenizer=x,ne.Slugger=G,ne.parse=ne;var pe=ne.options,le=ne.setOptions,we=ne.use,Z=ne.walkTokens,B=ne.parseInline,ee=ne,ve=Y.parse,Pe=X.lex;ue.Lexer=X,ue.Parser=Y,ue.Renderer=te,ue.Slugger=G,ue.TextRenderer=H,ue.Tokenizer=x,ue.getDefaults=R,ue.lexer=Pe,ue.marked=ne,ue.options=pe,ue.parse=ee,ue.parseInline=B,ue.parser=ve,ue.setOptions=le,ue.use=we,ue.walkTokens=Z,Object.defineProperty(ue,"__esModule",{value:!0})}),define(_e[168],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getKoreanAltChars=h;function h(d){const f=A(d);if(f&&f.length>0)return new Uint32Array(f)}let O=0;const L=new Uint32Array(10);function A(d){if(O=0,R(d,I,4352),O>0||(R(d,p,4449),O>0)||(R(d,S,4520),O>0)||(R(d,E,12593),O))return L.subarray(0,O);if(d>=44032&&d<=55203){const f=d-44032,a=f%588,i=Math.floor(f/588),n=Math.floor(a/28),l=a%28-1;if(i<I.length?R(i,I,0):4352+i-12593<E.length&&R(4352+i,E,12593),n<p.length?R(n,p,0):4449+n-12593<E.length&&R(4449+n-12593,E,12593),l>=0&&(l<S.length?R(l,S,0):4520+l-12593<E.length&&R(4520+l-12593,E,12593)),O>0)return L.subarray(0,O)}}function R(d,f,a){d>=a&&d<a+f.length&&b(f[d-a])}function b(d){d!==0&&(L[O++]=d&255,d>>8&&(L[O++]=d>>8&255),d>>16&&(L[O++]=d>>16&255))}var m;(function(d){d[d.InitialConsonant=4352]="InitialConsonant",d[d.Vowel=4449]="Vowel",d[d.FinalConsonant=4520]="FinalConsonant",d[d.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var y;(function(d){d[d.NUL=0]="NUL",d[d.A=65]="A",d[d.B=66]="B",d[d.C=67]="C",d[d.D=68]="D",d[d.E=69]="E",d[d.F=70]="F",d[d.G=71]="G",d[d.H=72]="H",d[d.I=73]="I",d[d.J=74]="J",d[d.K=75]="K",d[d.L=76]="L",d[d.M=77]="M",d[d.N=78]="N",d[d.O=79]="O",d[d.P=80]="P",d[d.Q=81]="Q",d[d.R=82]="R",d[d.S=83]="S",d[d.T=84]="T",d[d.U=85]="U",d[d.V=86]="V",d[d.W=87]="W",d[d.X=88]="X",d[d.Y=89]="Y",d[d.Z=90]="Z",d[d.a=97]="a",d[d.b=98]="b",d[d.c=99]="c",d[d.d=100]="d",d[d.e=101]="e",d[d.f=102]="f",d[d.g=103]="g",d[d.h=104]="h",d[d.i=105]="i",d[d.j=106]="j",d[d.k=107]="k",d[d.l=108]="l",d[d.m=109]="m",d[d.n=110]="n",d[d.o=111]="o",d[d.p=112]="p",d[d.q=113]="q",d[d.r=114]="r",d[d.s=115]="s",d[d.t=116]="t",d[d.u=117]="u",d[d.v=118]="v",d[d.w=119]="w",d[d.x=120]="x",d[d.y=121]="y",d[d.z=122]="z"})(y||(y={}));var T;(function(d){d[d.fa=24934]="fa",d[d.fg=26470]="fg",d[d.fq=29030]="fq",d[d.fr=29286]="fr",d[d.ft=29798]="ft",d[d.fv=30310]="fv",d[d.fx=30822]="fx",d[d.hk=27496]="hk",d[d.hl=27752]="hl",d[d.ho=28520]="ho",d[d.ml=27757]="ml",d[d.nj=27246]="nj",d[d.nl=27758]="nl",d[d.np=28782]="np",d[d.qt=29809]="qt",d[d.rt=29810]="rt",d[d.sg=26483]="sg",d[d.sw=30579]="sw"})(T||(T={}));const I=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),p=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),S=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),E=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(_e[77],Ce([1,0,27]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=L,e.normalizeNFD=R;const O=new h.LRUCache(1e4);function L(y){return m(y,"NFC",O)}const A=new h.LRUCache(1e4);function R(y){return m(y,"NFD",A)}const b=/[^\u0000-\u0080]/;function m(y,T,I){if(!y)return y;const p=I.get(y);if(p)return p;let S;return b.test(y)?S=y.normalize(T):S=y,I.set(y,S),S}e.removeAccents=function(){const y=/[\u0300-\u036f]/g;return function(T){return R(T).replace(y,"")}}()}),define(_e[126],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=h,e.rot=O;function h(b,m,y){return Math.min(Math.max(b,m),y)}function O(b,m){return(m+b%m)%m}class L{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=L;class A{constructor(){this._n=1,this._val=0}update(m){return this._val=this._val+(m-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class R{constructor(m){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(m),this._values.fill(0,0,m)}update(m){const y=this._values[this._index];return this._values[this._index]=m,this._index=(this._index+1)%this._values.length,this._sum-=y,this._sum+=m,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=R}),define(_e[169],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugNameData=void 0,e.getDebugName=A,e.getFunctionName=p;class h{constructor(E,d,f){this.owner=E,this.debugNameSource=d,this.referenceFn=f}getDebugName(E){return A(E,this)}}e.DebugNameData=h;const O=new Map,L=new WeakMap;function A(S,E){const d=L.get(S);if(d)return d;const f=R(S,E);if(f){let a=O.get(f)??0;a++,O.set(f,a);const i=a===1?f:`${f}#${a}`;return L.set(S,i),i}}function R(S,E){const d=L.get(S);if(d)return d;const f=E.owner?T(E.owner)+".":"";let a;const i=E.debugNameSource;if(i!==void 0)if(typeof i=="function"){if(a=i(),a!==void 0)return f+a}else return f+i;const n=E.referenceFn;if(n!==void 0&&(a=p(n),a!==void 0))return f+a;if(E.owner!==void 0){const l=b(E.owner,S);if(l!==void 0)return f+l}}function b(S,E){for(const d in S)if(S[d]===E)return d}const m=new Map,y=new WeakMap;function T(S){const E=y.get(S);if(E)return E;const d=I(S);let f=m.get(d)??0;f++,m.set(d,f);const a=f===1?d:`${d}#${f}`;return y.set(S,a),a}function I(S){const E=S.constructor;return E?E.name:"Object"}function p(S){const E=S.toString(),f=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(E);return(f?f[1]:void 0)?.trim()}}),define(_e[170],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=void 0,e.setLogger=O,e.getLogger=L;let h;function O(d){h=d}function L(){return h}class A{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(f){return R([b(S("|  ",this.indentation)),f])}formatInfo(f){return f.hadValue?f.didChange?[b(" "),y(T(f.oldValue,70),{color:"red",strikeThrough:!0}),b(" "),y(T(f.newValue,60),{color:"green"})]:[b(" (unchanged)")]:[b(" "),y(T(f.newValue,60),{color:"green"}),b(" (initial)")]}handleObservableChanged(f,a){console.log(...this.textToConsoleArgs([m("observable value changed"),y(f.debugName,{color:"BlueViolet"}),...this.formatInfo(a)]))}formatChanges(f){if(f.size!==0)return y(" (changed deps: "+[...f].map(a=>a.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(f){const a=f.handleChange;this.changedObservablesSets.set(f,new Set),f.handleChange=(i,n)=>(this.changedObservablesSets.get(f).add(i),a.apply(f,[i,n]))}handleDerivedRecomputed(f,a){const i=this.changedObservablesSets.get(f);console.log(...this.textToConsoleArgs([m("derived recomputed"),y(f.debugName,{color:"BlueViolet"}),...this.formatInfo(a),this.formatChanges(i),{data:[{fn:f._computeFn}]}])),i.clear()}handleFromEventObservableTriggered(f,a){console.log(...this.textToConsoleArgs([m("observable from event triggered"),y(f.debugName,{color:"BlueViolet"}),...this.formatInfo(a),{data:[{fn:f._getValue}]}]))}handleAutorunCreated(f){const a=f.handleChange;this.changedObservablesSets.set(f,new Set),f.handleChange=(i,n)=>(this.changedObservablesSets.get(f).add(i),a.apply(f,[i,n]))}handleAutorunTriggered(f){const a=this.changedObservablesSets.get(f);console.log(...this.textToConsoleArgs([m("autorun"),y(f.debugName,{color:"BlueViolet"}),this.formatChanges(a),{data:[{fn:f._runFn}]}])),a.clear(),this.indentation++}handleAutorunFinished(f){this.indentation--}handleBeginTransaction(f){let a=f.getDebugName();a===void 0&&(a=""),console.log(...this.textToConsoleArgs([m("transaction"),y(a,{color:"BlueViolet"}),{data:[{fn:f._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=A;function R(d){const f=new Array,a=[];let i="";function n(o){if("length"in o)for(const t of o)t&&n(t);else"text"in o?(i+=`%c${o.text}`,f.push(o.style),o.data&&a.push(...o.data)):"data"in o&&a.push(...o.data)}n(d);const l=[i,...f];return l.push(...a),l}function b(d){return y(d,{color:"black"})}function m(d){return y(E(`${d}: `,10),{color:"black",bold:!0})}function y(d,f={color:"black"}){function a(n){return Object.entries(n).reduce((l,[o,t])=>`${l}${o}:${t};`,"")}const i={color:f.color};return f.strikeThrough&&(i["text-decoration"]="line-through"),f.bold&&(i["font-weight"]="bold"),{text:d,style:a(i)}}function T(d,f){switch(typeof d){case"number":return""+d;case"string":return d.length+2<=f?`"${d}"`:`"${d.substr(0,f-7)}"+...`;case"boolean":return d?"true":"false";case"undefined":return"undefined";case"object":return d===null?"null":Array.isArray(d)?I(d,f):p(d,f);case"symbol":return d.toString();case"function":return`[[Function${d.name?" "+d.name:""}]]`;default:return""+d}}function I(d,f){let a="[ ",i=!0;for(const n of d){if(i||(a+=", "),a.length-5>f){a+="...";break}i=!1,a+=`${T(n,f-a.length)}`}return a+=" ]",a}function p(d,f){let a="{ ",i=!0;for(const[n,l]of Object.entries(d)){if(i||(a+=", "),a.length-5>f){a+="...";break}i=!1,a+=`${n}: ${T(l,f-a.length)}`}return a+=" }",a}function S(d,f){let a="";for(let i=1;i<=f;i++)a+=d;return a}function E(d,f){for(;d.length<f;)d+=" ";return d}}),define(_e[171],Ce([1,0,165,169,170]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.ObservableValue=e.TransactionImpl=e.BaseObservable=e.ConvenientObservable=void 0,e._setRecomputeInitiallyAndOnChange=R,e._setKeepObserved=m,e._setDerivedOpts=T,e.transaction=S,e.globalTransaction=d,e.asyncTransaction=f,e.subtransaction=a,e.observableValue=n,e.observableValueOpts=l,e.disposableObservableValue=t;let A;function R(r){A=r}let b;function m(r){b=r}let y;function T(r){y=r}class I{get TChange(){return null}reportChanges(){this.get()}read(c){return c?c.readObservable(this):this.get()}map(c,s){const w=s===void 0?void 0:c,g=s===void 0?c:s;return y({owner:w,debugName:()=>{const D=(0,O.getFunctionName)(g);if(D!==void 0)return D;const _=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(g.toString());if(_)return`${this.debugName}.${_[2]}`;if(!w)return`${this.debugName} (mapped)`},debugReferenceFn:g},D=>g(this.read(D),D))}recomputeInitiallyAndOnChange(c,s){return c.add(A(this,s)),this}keepObserved(c){return c.add(b(this)),this}get debugValue(){return this.get()}}e.ConvenientObservable=I;class p extends I{constructor(){super(...arguments),this.observers=new Set}addObserver(c){const s=this.observers.size;this.observers.add(c),s===0&&this.onFirstObserverAdded()}removeObserver(c){this.observers.delete(c)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=p;function S(r,c){const s=new i(r,c);try{r(s)}finally{s.finish()}}let E;function d(r){if(E)r(E);else{const c=new i(r,void 0);E=c;try{r(c)}finally{c.finish(),E=void 0}}}async function f(r,c){const s=new i(r,c);try{await r(s)}finally{s.finish()}}function a(r,c,s){r?c(r):S(c,s)}class i{constructor(c,s){this._fn=c,this._getDebugName=s,this.updatingObservers=[],(0,L.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():(0,O.getFunctionName)(this._fn)}updateObserver(c,s){this.updatingObservers.push({observer:c,observable:s}),c.beginUpdate(s)}finish(){const c=this.updatingObservers;for(let s=0;s<c.length;s++){const{observer:w,observable:g}=c[s];w.endUpdate(g)}this.updatingObservers=null,(0,L.getLogger)()?.handleEndTransaction()}}e.TransactionImpl=i;function n(r,c){let s;return typeof r=="string"?s=new O.DebugNameData(void 0,r,void 0):s=new O.DebugNameData(r,void 0,void 0),new o(s,c,h.strictEquals)}function l(r,c){return new o(new O.DebugNameData(r.owner,r.debugName,void 0),c,r.equalsFn??h.strictEquals)}class o extends p{get debugName(){return this._debugNameData.getDebugName(this)??"ObservableValue"}constructor(c,s,w){super(),this._debugNameData=c,this._equalityComparator=w,this._value=s}get(){return this._value}set(c,s,w){if(this._equalityComparator(this._value,c))return;let g;s||(s=g=new i(()=>{},()=>`Setting ${this.debugName}`));try{const D=this._value;this._setValue(c),(0,L.getLogger)()?.handleObservableChanged(this,{oldValue:D,newValue:c,change:w,didChange:!0,hadValue:!0});for(const v of this.observers)s.updateObserver(v,this),v.handleChange(this,w)}finally{g&&g.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(c){this._value=c}}e.ObservableValue=o;function t(r,c){let s;return typeof r=="string"?s=new O.DebugNameData(void 0,r,void 0):s=new O.DebugNameData(r,void 0,void 0),new u(s,c,h.strictEquals)}class u extends o{_setValue(c){this._value!==c&&(this._value&&this._value.dispose(),this._value=c)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=u}),function(){function ue(L){const A=[];typeof L=="number"&&A.push("code/timeOrigin",L);function R(m){A.push(m,Date.now())}function b(){const m=[];for(let y=0;y<A.length;y+=2)m.push({name:A[y],startTime:A[y+1]});return m}return{mark:R,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ue():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(L+R.startTime)});return A}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ue(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),ue()}function h(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return h(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=h(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=h(O))}(),define(_e[172],Ce([1,0,39]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WellDefinedPrefixTree=void 0;const O=Symbol("unset");class L{constructor(){this.root=new R,this._size=0}get size(){return this._size}get nodes(){return this.root.children?.values()||h.Iterable.empty()}insert(m,y,T){this.opNode(m,I=>I._value=y,T)}mutate(m,y){this.opNode(m,T=>T._value=y(T._value===O?void 0:T._value))}delete(m){const y=this.getPathToKey(m);if(!y)return;let T=y.length-1;const I=y[T].node._value;if(I!==O){for(this._size--,y[T].node._value=O;T>0;T--){const{node:p,part:S}=y[T];if(p.children?.size||p._value!==O)break;y[T-1].node.children.delete(S)}return I}}*deleteRecursive(m){const y=this.getPathToKey(m);if(!y)return;const T=y[y.length-1].node;for(let I=y.length-1;I>0;I--){const p=y[I-1];if(p.node.children.delete(y[I].part),p.node.children.size>0||p.node._value!==O)break}for(const I of A(T))I._value!==O&&(this._size--,yield I._value)}find(m){let y=this.root;for(const T of m){const I=y.children?.get(T);if(!I)return;y=I}return y._value===O?void 0:y._value}hasKeyOrParent(m){let y=this.root;for(const T of m){const I=y.children?.get(T);if(!I)return!1;if(I._value!==O)return!0;y=I}return!1}hasKeyOrChildren(m){let y=this.root;for(const T of m){const I=y.children?.get(T);if(!I)return!1;y=I}return!0}hasKey(m){let y=this.root;for(const T of m){const I=y.children?.get(T);if(!I)return!1;y=I}return y._value!==O}getPathToKey(m){const y=[{part:"",node:this.root}];let T=0;for(const I of m){const p=y[T].node.children?.get(I);if(!p)return;y.push({part:I,node:p}),T++}return y}opNode(m,y,T){let I=this.root;for(const E of m){if(I.children)if(I.children.has(E))I=I.children.get(E);else{const d=new R;I.children.set(E,d),I=d}else{const d=new R;I.children=new Map([[E,d]]),I=d}T?.(I)}const p=I._value===O?0:1;y(I);const S=I._value===O?0:1;this._size+=S-p}*values(){for(const{_value:m}of A(this.root))m!==O&&(yield m)}}e.WellDefinedPrefixTree=L;function*A(b){const m=[b];for(;m.length>0;){const y=m.pop();if(yield y,y.children)for(const T of y.children.values())m.push(T)}}class R{constructor(){this._value=O}get value(){return this._value===O?void 0:this._value}set value(m){this._value=m===void 0?O:m}}}),function(ue,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var h=e();for(var O in h)(typeof exports=="object"?exports:ue)[O]=h[O]}}(typeof self<"u"?self:this,function(){return function(ue){var e={};function h(O){if(e[O])return e[O].exports;var L=e[O]={i:O,l:!1,exports:{}};return ue[O].call(L.exports,L,L.exports,h),L.l=!0,L.exports}return h.m=ue,h.c=e,h.d=function(O,L,A){h.o(O,L)||Object.defineProperty(O,L,{enumerable:!0,get:A})},h.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},h.t=function(O,L){if(1&L&&(O=h(O)),8&L||4&L&&typeof O=="object"&&O&&O.__esModule)return O;var A=Object.create(null);if(h.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:O}),2&L&&typeof O!="string")for(var R in O)h.d(A,R,function(b){return O[b]}.bind(null,R));return A},h.n=function(O){var L=O&&O.__esModule?function(){return O.default}:function(){return O};return h.d(L,"a",L),L},h.o=function(O,L){return Object.prototype.hasOwnProperty.call(O,L)},h.p="",h(h.s=0)}([function(ue,e,h){(function(O){var L;e=ue.exports=we,L=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var $=Array.prototype.slice.call(arguments,0);$.unshift("SEMVER"),console.log.apply(console,$)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],m=e.src=[],y=0,T=y++;m[T]="0|[1-9]\\d*";var I=y++;m[I]="[0-9]+";var p=y++;m[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=y++;m[S]="("+m[T]+")\\.("+m[T]+")\\.("+m[T]+")";var E=y++;m[E]="("+m[I]+")\\.("+m[I]+")\\.("+m[I]+")";var d=y++;m[d]="(?:"+m[T]+"|"+m[p]+")";var f=y++;m[f]="(?:"+m[I]+"|"+m[p]+")";var a=y++;m[a]="(?:-("+m[d]+"(?:\\."+m[d]+")*))";var i=y++;m[i]="(?:-?("+m[f]+"(?:\\."+m[f]+")*))";var n=y++;m[n]="[0-9A-Za-z-]+";var l=y++;m[l]="(?:\\+("+m[n]+"(?:\\."+m[n]+")*))";var o=y++,t="v?"+m[S]+m[a]+"?"+m[l]+"?";m[o]="^"+t+"$";var u="[v=\\s]*"+m[E]+m[i]+"?"+m[l]+"?",r=y++;m[r]="^"+u+"$";var c=y++;m[c]="((?:<|>)?=?)";var s=y++;m[s]=m[I]+"|x|X|\\*";var w=y++;m[w]=m[T]+"|x|X|\\*";var g=y++;m[g]="[v=\\s]*("+m[w]+")(?:\\.("+m[w]+")(?:\\.("+m[w]+")(?:"+m[a]+")?"+m[l]+"?)?)?";var D=y++;m[D]="[v=\\s]*("+m[s]+")(?:\\.("+m[s]+")(?:\\.("+m[s]+")(?:"+m[i]+")?"+m[l]+"?)?)?";var v=y++;m[v]="^"+m[c]+"\\s*"+m[g]+"$";var _=y++;m[_]="^"+m[c]+"\\s*"+m[D]+"$";var C=y++;m[C]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=y++;m[P]="(?:~>?)";var k=y++;m[k]="(\\s*)"+m[P]+"\\s+",b[k]=new RegExp(m[k],"g");var F=y++;m[F]="^"+m[P]+m[g]+"$";var x=y++;m[x]="^"+m[P]+m[D]+"$";var z=y++;m[z]="(?:\\^)";var N=y++;m[N]="(\\s*)"+m[z]+"\\s+",b[N]=new RegExp(m[N],"g");var M=y++;m[M]="^"+m[z]+m[g]+"$";var W=y++;m[W]="^"+m[z]+m[D]+"$";var X=y++;m[X]="^"+m[c]+"\\s*("+u+")$|^$";var te=y++;m[te]="^"+m[c]+"\\s*("+t+")$|^$";var H=y++;m[H]="(\\s*)"+m[c]+"\\s*("+u+"|"+m[g]+")",b[H]=new RegExp(m[H],"g");var G=y++;m[G]="^\\s*("+m[g]+")\\s+-\\s+("+m[g]+")\\s*$";var Y=y++;m[Y]="^\\s*("+m[D]+")\\s+-\\s+("+m[D]+")\\s*$";var ne=y++;m[ne]="(<|>)?=?\\s*\\*";for(var pe=0;pe<35;pe++)L(pe,m[pe]),b[pe]||(b[pe]=new RegExp(m[pe]));function le($,K){if($ instanceof we)return $;if(typeof $!="string"||$.length>A||!(K?b[r]:b[o]).test($))return null;try{return new we($,K)}catch{return null}}function we($,K){if($ instanceof we){if($.loose===K)return $;$=$.version}else if(typeof $!="string")throw new TypeError("Invalid Version: "+$);if($.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof we))return new we($,K);L("SemVer",$,K),this.loose=K;var Q=$.trim().match(K?b[r]:b[o]);if(!Q)throw new TypeError("Invalid Version: "+$);if(this.raw=$,this.major=+Q[1],this.minor=+Q[2],this.patch=+Q[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Q[4]?this.prerelease=Q[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var Ee=+de;if(Ee>=0&&Ee<R)return Ee}return de}):this.prerelease=[],this.build=Q[5]?Q[5].split("."):[],this.format()}e.parse=le,e.valid=function($,K){var Q=le($,K);return Q?Q.version:null},e.clean=function($,K){var Q=le($.trim().replace(/^[=v]+/,""),K);return Q?Q.version:null},e.SemVer=we,we.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},we.prototype.toString=function(){return this.version},we.prototype.compare=function($){return L("SemVer.compare",this.version,this.loose,$),$ instanceof we||($=new we($,this.loose)),this.compareMain($)||this.comparePre($)},we.prototype.compareMain=function($){return $ instanceof we||($=new we($,this.loose)),B(this.major,$.major)||B(this.minor,$.minor)||B(this.patch,$.patch)},we.prototype.comparePre=function($){if($ instanceof we||($=new we($,this.loose)),this.prerelease.length&&!$.prerelease.length)return-1;if(!this.prerelease.length&&$.prerelease.length)return 1;if(!this.prerelease.length&&!$.prerelease.length)return 0;var K=0;do{var Q=this.prerelease[K],de=$.prerelease[K];if(L("prerelease compare",K,Q,de),Q===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(Q===void 0)return-1;if(Q!==de)return B(Q,de)}while(++K)},we.prototype.inc=function($,K){switch($){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Q=this.prerelease.length;--Q>=0;)typeof this.prerelease[Q]=="number"&&(this.prerelease[Q]++,Q=-2);Q===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+$)}return this.format(),this.raw=this.version,this},e.inc=function($,K,Q,de){typeof Q=="string"&&(de=Q,Q=void 0);try{return new we($,Q).inc(K,de).version}catch{return null}},e.diff=function($,K){if(oe($,K))return null;var Q=le($),de=le(K);if(Q.prerelease.length||de.prerelease.length){for(var Ee in Q)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&Q[Ee]!==de[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in Q)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&Q[Ee]!==de[Ee])return Ee},e.compareIdentifiers=B;var Z=/^[0-9]+$/;function B($,K){var Q=Z.test($),de=Z.test(K);return Q&&de&&($=+$,K=+K),Q&&!de?-1:de&&!Q?1:$<K?-1:$>K?1:0}function ee($,K,Q){return new we($,Q).compare(new we(K,Q))}function ve($,K,Q){return ee($,K,Q)>0}function Pe($,K,Q){return ee($,K,Q)<0}function oe($,K,Q){return ee($,K,Q)===0}function se($,K,Q){return ee($,K,Q)!==0}function re($,K,Q){return ee($,K,Q)>=0}function j($,K,Q){return ee($,K,Q)<=0}function ie($,K,Q,de){var Ee;switch(K){case"===":typeof $=="object"&&($=$.version),typeof Q=="object"&&(Q=Q.version),Ee=$===Q;break;case"!==":typeof $=="object"&&($=$.version),typeof Q=="object"&&(Q=Q.version),Ee=$!==Q;break;case"":case"=":case"==":Ee=oe($,Q,de);break;case"!=":Ee=se($,Q,de);break;case">":Ee=ve($,Q,de);break;case">=":Ee=re($,Q,de);break;case"<":Ee=Pe($,Q,de);break;case"<=":Ee=j($,Q,de);break;default:throw new TypeError("Invalid operator: "+K)}return Ee}function me($,K){if($ instanceof me){if($.loose===K)return $;$=$.value}if(!(this instanceof me))return new me($,K);L("comparator",$,K),this.loose=K,this.parse($),this.semver===be?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function($,K){return B(K,$)},e.major=function($,K){return new we($,K).major},e.minor=function($,K){return new we($,K).minor},e.patch=function($,K){return new we($,K).patch},e.compare=ee,e.compareLoose=function($,K){return ee($,K,!0)},e.rcompare=function($,K,Q){return ee(K,$,Q)},e.sort=function($,K){return $.sort(function(Q,de){return e.compare(Q,de,K)})},e.rsort=function($,K){return $.sort(function(Q,de){return e.rcompare(Q,de,K)})},e.gt=ve,e.lt=Pe,e.eq=oe,e.neq=se,e.gte=re,e.lte=j,e.cmp=ie,e.Comparator=me;var be={};function Ae($,K){if($ instanceof Ae)return $.loose===K?$:new Ae($.raw,K);if($ instanceof me)return new Ae($.value,K);if(!(this instanceof Ae))return new Ae($,K);if(this.loose=K,this.raw=$,this.set=$.split(/\s*\|\|\s*/).map(function(Q){return this.parseRange(Q.trim())},this).filter(function(Q){return Q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+$);this.format()}function fe($){return!$||$.toLowerCase()==="x"||$==="*"}function De($,K,Q,de,Ee,Fe,He,Ke,rt,tt,it,st,Ie){return((K=fe(Q)?"":fe(de)?">="+Q+".0.0":fe(Ee)?">="+Q+"."+de+".0":">="+K)+" "+(Ke=fe(rt)?"":fe(tt)?"<"+(+rt+1)+".0.0":fe(it)?"<"+rt+"."+(+tt+1)+".0":st?"<="+rt+"."+tt+"."+it+"-"+st:"<="+Ke)).trim()}function Te($,K){for(var Q=0;Q<$.length;Q++)if(!$[Q].test(K))return!1;if(K.prerelease.length){for(Q=0;Q<$.length;Q++)if(L($[Q].semver),$[Q].semver!==be&&$[Q].semver.prerelease.length>0){var de=$[Q].semver;if(de.major===K.major&&de.minor===K.minor&&de.patch===K.patch)return!0}return!1}return!0}function ze($,K,Q){try{K=new Ae(K,Q)}catch{return!1}return K.test($)}function U($,K,Q,de){var Ee,Fe,He,Ke,rt;switch($=new we($,de),K=new Ae(K,de),Q){case">":Ee=ve,Fe=j,He=Pe,Ke=">",rt=">=";break;case"<":Ee=Pe,Fe=re,He=ve,Ke="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze($,K,de))return!1;for(var tt=0;tt<K.set.length;++tt){var it=K.set[tt],st=null,Ie=null;if(it.forEach(function(Be){Be.semver===be&&(Be=new me(">=0.0.0")),st=st||Be,Ie=Ie||Be,Ee(Be.semver,st.semver,de)?st=Be:He(Be.semver,Ie.semver,de)&&(Ie=Be)}),st.operator===Ke||st.operator===rt||(!Ie.operator||Ie.operator===Ke)&&Fe($,Ie.semver)||Ie.operator===rt&&He($,Ie.semver))return!1}return!0}me.prototype.parse=function($){var K=this.loose?b[X]:b[te],Q=$.match(K);if(!Q)throw new TypeError("Invalid comparator: "+$);this.operator=Q[1],this.operator==="="&&(this.operator=""),Q[2]?this.semver=new we(Q[2],this.loose):this.semver=be},me.prototype.toString=function(){return this.value},me.prototype.test=function($){return L("Comparator.test",$,this.loose),this.semver===be||(typeof $=="string"&&($=new we($,this.loose)),ie($,this.operator,this.semver,this.loose))},me.prototype.intersects=function($,K){if(!($ instanceof me))throw new TypeError("a Comparator is required");var Q;if(this.operator==="")return Q=new Ae($.value,K),ze(this.value,Q,K);if($.operator==="")return Q=new Ae(this.value,K),ze($.semver,Q,K);var de=!(this.operator!==">="&&this.operator!==">"||$.operator!==">="&&$.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||$.operator!=="<="&&$.operator!=="<"),Fe=this.semver.version===$.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||$.operator!==">="&&$.operator!=="<="),Ke=ie(this.semver,"<",$.semver,K)&&(this.operator===">="||this.operator===">")&&($.operator==="<="||$.operator==="<"),rt=ie(this.semver,">",$.semver,K)&&(this.operator==="<="||this.operator==="<")&&($.operator===">="||$.operator===">");return de||Ee||Fe&&He||Ke||rt},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function($){return $.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function($){var K=this.loose;$=$.trim(),L("range",$,K);var Q=K?b[Y]:b[G];$=$.replace(Q,De),L("hyphen replace",$),$=$.replace(b[H],"$1$2$3"),L("comparator trim",$,b[H]),$=($=($=$.replace(b[k],"$1~")).replace(b[N],"$1^")).split(/\s+/).join(" ");var de=K?b[X]:b[te],Ee=$.split(" ").map(function(Fe){return function(He,Ke){return L("comp",He),He=function(rt,tt){return rt.trim().split(/\s+/).map(function(it){return function(st,Ie){L("caret",st,Ie);var Be=Ie?b[W]:b[M];return st.replace(Be,function(qe,Oe,Qe,ae,ce){var ke;return L("caret",st,qe,Oe,Qe,ae,ce),fe(Oe)?ke="":fe(Qe)?ke=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":fe(ae)?ke=Oe==="0"?">="+Oe+"."+Qe+".0 <"+Oe+"."+(+Qe+1)+".0":">="+Oe+"."+Qe+".0 <"+(+Oe+1)+".0.0":ce?(L("replaceCaret pr",ce),ce.charAt(0)!=="-"&&(ce="-"+ce),ke=Oe==="0"?Qe==="0"?">="+Oe+"."+Qe+"."+ae+ce+" <"+Oe+"."+Qe+"."+(+ae+1):">="+Oe+"."+Qe+"."+ae+ce+" <"+Oe+"."+(+Qe+1)+".0":">="+Oe+"."+Qe+"."+ae+ce+" <"+(+Oe+1)+".0.0"):(L("no pr"),ke=Oe==="0"?Qe==="0"?">="+Oe+"."+Qe+"."+ae+" <"+Oe+"."+Qe+"."+(+ae+1):">="+Oe+"."+Qe+"."+ae+" <"+Oe+"."+(+Qe+1)+".0":">="+Oe+"."+Qe+"."+ae+" <"+(+Oe+1)+".0.0"),L("caret return",ke),ke})}(it,tt)}).join(" ")}(He,Ke),L("caret",He),He=function(rt,tt){return rt.trim().split(/\s+/).map(function(it){return function(st,Ie){var Be=Ie?b[x]:b[F];return st.replace(Be,function(qe,Oe,Qe,ae,ce){var ke;return L("tilde",st,qe,Oe,Qe,ae,ce),fe(Oe)?ke="":fe(Qe)?ke=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":fe(ae)?ke=">="+Oe+"."+Qe+".0 <"+Oe+"."+(+Qe+1)+".0":ce?(L("replaceTilde pr",ce),ce.charAt(0)!=="-"&&(ce="-"+ce),ke=">="+Oe+"."+Qe+"."+ae+ce+" <"+Oe+"."+(+Qe+1)+".0"):ke=">="+Oe+"."+Qe+"."+ae+" <"+Oe+"."+(+Qe+1)+".0",L("tilde return",ke),ke})}(it,tt)}).join(" ")}(He,Ke),L("tildes",He),He=function(rt,tt){return L("replaceXRanges",rt,tt),rt.split(/\s+/).map(function(it){return function(st,Ie){st=st.trim();var Be=Ie?b[_]:b[v];return st.replace(Be,function(qe,Oe,Qe,ae,ce,ke){L("xRange",st,qe,Oe,Qe,ae,ce,ke);var je=fe(Qe),Le=je||fe(ae),ot=Le||fe(ce);return Oe==="="&&ot&&(Oe=""),je?qe=Oe===">"||Oe==="<"?"<0.0.0":"*":Oe&&ot?(Le&&(ae=0),ot&&(ce=0),Oe===">"?(Oe=">=",Le?(Qe=+Qe+1,ae=0,ce=0):ot&&(ae=+ae+1,ce=0)):Oe==="<="&&(Oe="<",Le?Qe=+Qe+1:ae=+ae+1),qe=Oe+Qe+"."+ae+"."+ce):Le?qe=">="+Qe+".0.0 <"+(+Qe+1)+".0.0":ot&&(qe=">="+Qe+"."+ae+".0 <"+Qe+"."+(+ae+1)+".0"),L("xRange return",qe),qe})}(it,tt)}).join(" ")}(He,Ke),L("xrange",He),He=function(rt,tt){return L("replaceStars",rt,tt),rt.trim().replace(b[ne],"")}(He,Ke),L("stars",He),He}(Fe,K)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(Fe){return!!Fe.match(de)})),Ee=Ee.map(function(Fe){return new me(Fe,K)})},Ae.prototype.intersects=function($,K){if(!($ instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(Q){return Q.every(function(de){return $.set.some(function(Ee){return Ee.every(function(Fe){return de.intersects(Fe,K)})})})})},e.toComparators=function($,K){return new Ae($,K).set.map(function(Q){return Q.map(function(de){return de.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function($){if(!$)return!1;typeof $=="string"&&($=new we($,this.loose));for(var K=0;K<this.set.length;K++)if(Te(this.set[K],$))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function($,K,Q){var de=null,Ee=null;try{var Fe=new Ae(K,Q)}catch{return null}return $.forEach(function(He){Fe.test(He)&&(de&&Ee.compare(He)!==-1||(Ee=new we(de=He,Q)))}),de},e.minSatisfying=function($,K,Q){var de=null,Ee=null;try{var Fe=new Ae(K,Q)}catch{return null}return $.forEach(function(He){Fe.test(He)&&(de&&Ee.compare(He)!==1||(Ee=new we(de=He,Q)))}),de},e.validRange=function($,K){try{return new Ae($,K).range||"*"}catch{return null}},e.ltr=function($,K,Q){return U($,K,"<",Q)},e.gtr=function($,K,Q){return U($,K,">",Q)},e.outside=U,e.prerelease=function($,K){var Q=le($,K);return Q&&Q.prerelease.length?Q.prerelease:null},e.intersects=function($,K,Q){return $=new Ae($,Q),K=new Ae(K,Q),$.intersects(K)},e.coerce=function($){if($ instanceof we)return $;if(typeof $!="string")return null;var K=$.match(b[C]);return K==null?null:le((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,h(1))},function(ue,e){var h,O,L=ue.exports={};function A(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function b(f){if(h===setTimeout)return setTimeout(f,0);if((h===A||!h)&&setTimeout)return h=setTimeout,setTimeout(f,0);try{return h(f,0)}catch{try{return h.call(null,f,0)}catch{return h.call(this,f,0)}}}(function(){try{h=typeof setTimeout=="function"?setTimeout:A}catch{h=A}try{O=typeof clearTimeout=="function"?clearTimeout:R}catch{O=R}})();var m,y=[],T=!1,I=-1;function p(){T&&m&&(T=!1,m.length?y=m.concat(y):I=-1,y.length&&S())}function S(){if(!T){var f=b(p);T=!0;for(var a=y.length;a;){for(m=y,y=[];++I<a;)m&&m[I].run();I=-1,a=y.length}m=null,T=!1,function(i){if(O===clearTimeout)return clearTimeout(i);if((O===R||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(i);try{O(i)}catch{try{return O.call(null,i)}catch{return O.call(this,i)}}}(f)}}function E(f,a){this.fun=f,this.array=a}function d(){}L.nextTick=function(f){var a=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)a[i-1]=arguments[i];y.push(new E(f,a)),y.length!==1||T||b(S)},E.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=d,L.addListener=d,L.once=d,L.off=d,L.removeListener=d,L.removeAllListeners=d,L.emit=d,L.prependListener=d,L.prependOnceListener=d,L.listeners=function(f){return[]},L.binding=function(f){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(f){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(_e[40],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const h=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(A){return new O(A)}constructor(A){this._now=h&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=O}),define(_e[4],Ce([1,0,13,75,3,76,40]),function(ue,e,h,O,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=S;const b=!1,m=!1,y=!1;var T;(function(k){k.None=()=>L.Disposable.None;function F(Ae){if(y){const{onDidAddListener:fe}=Ae,De=d.create();let Te=0;Ae.onDidAddListener=()=>{++Te===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),De.print()),fe?.()}}}function x(Ae,fe){return ne(Ae,()=>{},0,void 0,!0,void 0,fe)}k.defer=x;function z(Ae){return(fe,De=null,Te)=>{let ze=!1,U;return U=Ae($=>{if(!ze)return U?U.dispose():ze=!0,fe.call(De,$)},null,Te),ze&&U.dispose(),U}}k.once=z;function N(Ae,fe,De){return G((Te,ze=null,U)=>Ae($=>Te.call(ze,fe($)),null,U),De)}k.map=N;function M(Ae,fe,De){return G((Te,ze=null,U)=>Ae($=>{fe($),Te.call(ze,$)},null,U),De)}k.forEach=M;function W(Ae,fe,De){return G((Te,ze=null,U)=>Ae($=>fe($)&&Te.call(ze,$),null,U),De)}k.filter=W;function X(Ae){return Ae}k.signal=X;function te(...Ae){return(fe,De=null,Te)=>{const ze=(0,L.combinedDisposable)(...Ae.map(U=>U($=>fe.call(De,$))));return Y(ze,Te)}}k.any=te;function H(Ae,fe,De,Te){let ze=De;return N(Ae,U=>(ze=fe(ze,U),ze),Te)}k.reduce=H;function G(Ae,fe){let De;const Te={onWillAddFirstListener(){De=Ae(ze.fire,ze)},onDidRemoveLastListener(){De?.dispose()}};fe||F(Te);const ze=new o(Te);return fe?.add(ze),ze.event}function Y(Ae,fe){return fe instanceof Array?fe.push(Ae):fe&&fe.add(Ae),Ae}function ne(Ae,fe,De=100,Te=!1,ze=!1,U,$){let K,Q,de,Ee=0,Fe;const He={leakWarningThreshold:U,onWillAddFirstListener(){K=Ae(rt=>{Ee++,Q=fe(Q,rt),Te&&!de&&(Ke.fire(Q),Q=void 0),Fe=()=>{const tt=Q;Q=void 0,de=void 0,(!Te||Ee>1)&&Ke.fire(tt),Ee=0},typeof De=="number"?(clearTimeout(de),de=setTimeout(Fe,De)):de===void 0&&(de=0,queueMicrotask(Fe))})},onWillRemoveListener(){ze&&Ee>0&&Fe?.()},onDidRemoveLastListener(){Fe=void 0,K.dispose()}};$||F(He);const Ke=new o(He);return $?.add(Ke),Ke.event}k.debounce=ne;function pe(Ae,fe=0,De){return k.debounce(Ae,(Te,ze)=>Te?(Te.push(ze),Te):[ze],fe,void 0,!0,void 0,De)}k.accumulate=pe;function le(Ae,fe=(Te,ze)=>Te===ze,De){let Te=!0,ze;return W(Ae,U=>{const $=Te||!fe(U,ze);return Te=!1,ze=U,$},De)}k.latch=le;function we(Ae,fe,De){return[k.filter(Ae,fe,De),k.filter(Ae,Te=>!fe(Te),De)]}k.split=we;function Z(Ae,fe=!1,De=[],Te){let ze=De.slice(),U=Ae(Q=>{ze?ze.push(Q):K.fire(Q)});Te&&Te.add(U);const $=()=>{ze?.forEach(Q=>K.fire(Q)),ze=null},K=new o({onWillAddFirstListener(){U||(U=Ae(Q=>K.fire(Q)),Te&&Te.add(U))},onDidAddFirstListener(){ze&&(fe?setTimeout($):$())},onDidRemoveLastListener(){U&&U.dispose(),U=null}});return Te&&Te.add(K),K.event}k.buffer=Z;function B(Ae,fe){return(Te,ze,U)=>{const $=fe(new ve);return Ae(function(K){const Q=$.evaluate(K);Q!==ee&&Te.call(ze,Q)},void 0,U)}}k.chain=B;const ee=Symbol("HaltChainable");class ve{constructor(){this.steps=[]}map(fe){return this.steps.push(fe),this}forEach(fe){return this.steps.push(De=>(fe(De),De)),this}filter(fe){return this.steps.push(De=>fe(De)?De:ee),this}reduce(fe,De){let Te=De;return this.steps.push(ze=>(Te=fe(Te,ze),Te)),this}latch(fe=(De,Te)=>De===Te){let De=!0,Te;return this.steps.push(ze=>{const U=De||!fe(ze,Te);return De=!1,Te=ze,U?ze:ee}),this}evaluate(fe){for(const De of this.steps)if(fe=De(fe),fe===ee)break;return fe}}function Pe(Ae,fe,De=Te=>Te){const Te=(...K)=>$.fire(De(...K)),ze=()=>Ae.on(fe,Te),U=()=>Ae.removeListener(fe,Te),$=new o({onWillAddFirstListener:ze,onDidRemoveLastListener:U});return $.event}k.fromNodeEventEmitter=Pe;function oe(Ae,fe,De=Te=>Te){const Te=(...K)=>$.fire(De(...K)),ze=()=>Ae.addEventListener(fe,Te),U=()=>Ae.removeEventListener(fe,Te),$=new o({onWillAddFirstListener:ze,onDidRemoveLastListener:U});return $.event}k.fromDOMEventEmitter=oe;function se(Ae){return new Promise(fe=>z(Ae)(fe))}k.toPromise=se;function re(Ae){const fe=new o;return Ae.then(De=>{fe.fire(De)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}k.fromPromise=re;function j(Ae,fe,De){return fe(De),Ae(Te=>fe(Te))}k.runAndSubscribe=j;class ie{constructor(fe,De){this._observable=fe,this._counter=0,this._hasChanged=!1;const Te={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};De||F(Te),this.emitter=new o(Te),De&&De.add(this.emitter)}beginUpdate(fe){this._counter++}handlePossibleChange(fe){}handleChange(fe,De){this._hasChanged=!0}endUpdate(fe){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function me(Ae,fe){return new ie(Ae,fe).emitter.event}k.fromObservable=me;function be(Ae){return(fe,De,Te)=>{let ze=0,U=!1;const $={beginUpdate(){ze++},endUpdate(){ze--,ze===0&&(Ae.reportChanges(),U&&(U=!1,fe.call(De)))},handlePossibleChange(){},handleChange(){U=!0}};Ae.addObserver($),Ae.reportChanges();const K={dispose(){Ae.removeObserver($)}};return Te instanceof L.DisposableStore?Te.add(K):Array.isArray(Te)&&Te.push(K),K}}k.fromObservableLight=be})(T||(e.Event=T={}));class I{static{this.all=new Set}static{this._idPool=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${I._idPool++}`,I.all.add(this)}start(F){this._stopWatch=new R.StopWatch,this.listenerCount=F}stop(){if(this._stopWatch){const F=this._stopWatch.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=I;let p=-1;function S(k){const F=p;return p=k,{dispose(){p=F}}}class E{constructor(F,x=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=x,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(F,x){const z=this.threshold;if(z<=0||x<z)return;this._stacks||(this._stacks=new Map);const N=this._stacks.get(F.value)||0;if(this._stacks.set(F.value,N+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=z*.5;let M,W=0;for(const[X,te]of this._stacks)(!M||W<te)&&(M=X,W=te);console.warn(`[${this.name}] potential listener LEAK detected, having ${x} listeners already. MOST frequent listener (${W}):`),console.warn(M)}return()=>{const M=this._stacks.get(F.value)||0;this._stacks.set(F.value,M-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let f=0;class a{constructor(F){this.value=F,this.id=f++}}const i=2,n=(k,F)=>{if(k instanceof a)F(k);else for(let x=0;x<k.length;x++){const z=k[x];z&&F(z)}},l=b?new FinalizationRegistry(k=>{typeof k=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(k))}):void 0;class o{constructor(F){this._size=0,this._options=F,this._leakageMon=p>0||this._options?.leakWarningThreshold?new E(this._options?.leakWarningThreshold??p):void 0,this._perfMon=this._options?._profName?new I(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(m){const F=this._listeners;queueMicrotask(()=>{n(F,x=>x.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(F,x,z)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.Disposable.None;if(this._disposed)return L.Disposable.None;x&&(F=F.bind(x));const N=new a(F);let M,W;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(N.stack=d.create(),M=this._leakageMon.check(N.stack,this._size+1)),m&&(N.stack=W??d.create()),this._listeners?this._listeners instanceof a?(this._deliveryQueue??=new u,this._listeners=[this._listeners,N]):this._listeners.push(N):(this._options?.onWillAddFirstListener?.(this),this._listeners=N,this._options?.onDidAddFirstListener?.(this)),this._size++;const X=(0,L.toDisposable)(()=>{l?.unregister(X),M?.(),this._removeListener(N)});if(z instanceof L.DisposableStore?z.add(X):Array.isArray(z)&&z.push(X),l){const te=new Error().stack.split(`
`).slice(2).join(`
`).trim();l.register(X,te,X)}return X},this._event}_removeListener(F){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const x=this._listeners,z=x.indexOf(F);if(z===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,x[z]=void 0;const N=this._deliveryQueue.current===this;if(this._size*i<=x.length){let M=0;for(let W=0;W<x.length;W++)x[W]?x[M++]=x[W]:N&&(this._deliveryQueue.end--,M<this._deliveryQueue.i&&this._deliveryQueue.i--);x.length=M}}_deliver(F,x){if(!F)return;const z=this._options?.onListenerError||h.onUnexpectedError;if(!z){F.value(x);return}try{F.value(x)}catch(N){z(N)}}_deliverQueue(F){const x=F.current._listeners;for(;F.i<F.end;)this._deliver(x[F.i++],F.value);F.reset()}fire(F){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof a)this._deliver(this._listeners,F);else{const x=this._deliveryQueue;x.enqueue(this,F,this._listeners.length),this._deliverQueue(x)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=o;const t=()=>new u;e.createEventDeliveryQueue=t;class u{constructor(){this.i=-1,this.end=0}enqueue(F,x,z){this.i=0,this.end=z,this.current=F,this.value=x}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends o{async fireAsync(F,x,z){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList),n(this._listeners,N=>this._asyncDeliveryQueue.push([N.value,F]));this._asyncDeliveryQueue.size>0&&!x.isCancellationRequested;){const[N,M]=this._asyncDeliveryQueue.shift(),W=[],X={...M,token:x,waitUntil:te=>{if(Object.isFrozen(W))throw new Error("waitUntil can NOT be called asynchronous");z&&(te=z(te,N)),W.push(te)}};try{N(X)}catch(te){(0,h.onUnexpectedError)(te);continue}Object.freeze(W),await Promise.allSettled(W).then(te=>{for(const H of te)H.status==="rejected"&&(0,h.onUnexpectedError)(H.reason)})}}}e.AsyncEmitter=r;class c extends o{get isPaused(){return this._isPaused!==0}constructor(F){super(F),this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=F?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const F=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(F))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(F){this._size&&(this._isPaused!==0?this._eventQueue.push(F):super.fire(F))}}e.PauseableEmitter=c;class s extends c{constructor(F){super(F),this._delay=F.delay??100}fire(F){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(F)}}e.DebounceEmitter=s;class w extends o{constructor(F){super(F),this._queuedEvents=[],this._mergeFn=F?.merge}fire(F){this.hasListeners()&&(this._queuedEvents.push(F),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(x=>super.fire(x)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=w;class g{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new o({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(F){const x={event:F,listener:null};this.events.push(x),this.hasListeners&&this.hook(x);const z=()=>{this.hasListeners&&this.unhook(x);const N=this.events.indexOf(x);this.events.splice(N,1)};return(0,L.toDisposable)((0,O.createSingleCallFunction)(z))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(F=>this.hook(F))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(F=>this.unhook(F))}hook(F){F.listener=F.event(x=>this.emitter.fire(x))}unhook(F){F.listener?.dispose(),F.listener=null}dispose(){this.emitter.dispose();for(const F of this.events)F.listener?.dispose();this.events=[]}}e.EventMultiplexer=g;class D{constructor(F,x,z,N){this._store=new L.DisposableStore;const M=this._store.add(new g),W=this._store.add(new L.DisposableMap);function X(te){W.set(te,M.add(N(te)))}for(const te of F)X(te);this._store.add(x(te=>{X(te)})),this._store.add(z(te=>{W.deleteAndDispose(te)})),this.event=M.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=D;class v{constructor(){this.buffers=[]}wrapEvent(F){return(x,z,N)=>F(M=>{const W=this.buffers[this.buffers.length-1];W?W.push(()=>x.call(z,M)):x.call(z,M)},void 0,N)}bufferEvents(F){const x=[];this.buffers.push(x);const z=F();return this.buffers.pop(),x.forEach(N=>N()),z}}e.EventBufferer=v;class _{constructor(){this.listening=!1,this.inputEvent=T.None,this.inputEventListener=L.Disposable.None,this.emitter=new o({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(F){this.inputEvent=F,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=F(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=_;class C{static const(F){return new P(F)}constructor(F){this._value=F,this._onDidChange=new o,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(F){F!==this._value&&(this._value=F,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=C;class P{constructor(F){this.value=F,this.onDidChange=T.None}}}),define(_e[22],Ce([1,0,4]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=b;const O=Object.freeze(function(m,y){const T=setTimeout(m.bind(y),0);return{dispose(){clearTimeout(T)}}});var L;(function(m){function y(T){return T===m.None||T===m.Cancelled||T instanceof A?!0:!T||typeof T!="object"?!1:typeof T.isCancellationRequested=="boolean"&&typeof T.onCancellationRequested=="function"}m.isCancellationToken=y,m.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:h.Event.None}),m.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(L||(e.CancellationToken=L={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?O:(this._emitter||(this._emitter=new h.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class R{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=L.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=R;function b(m){const y=new R;return m.add({dispose(){y.cancel()}}),y.token}}),define(_e[173],Ce([1,0,22]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=L;class O{constructor(m){this.task=m,this.result=null}get(){if(this.result)return this.result;const m=new h.CancellationTokenSource,y=this.task(m.token);return this.result={promise:y,dispose:()=>{this.result=null,m.cancel(),m.dispose()}},this.result}}e.Cache=O;function L(b){return b}class A{constructor(m,y){this.lastCache=void 0,this.lastArgKey=void 0,typeof m=="function"?(this._fn=m,this._computeKey=L):(this._fn=y,this._computeKey=m.getCacheKey)}get(m){const y=this._computeKey(m);return this.lastArgKey!==y&&(this.lastArgKey=y,this.lastCache=this._fn(m)),this.lastCache}}e.LRUCachedFunction=A;class R{get cachedValues(){return this._map}constructor(m,y){this._map=new Map,this._map2=new Map,typeof m=="function"?(this._fn=m,this._computeKey=L):(this._fn=y,this._computeKey=m.getCacheKey)}get(m){const y=this._computeKey(m);if(this._map2.has(y))return this._map2.get(y);const T=this._fn(m);return this._map.set(m,T),this._map2.set(y,T),T}}e.CachedFunction=R}),define(_e[98],Ce([1,0,13,3]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=L,e.isReadableStream=A,e.isReadableBufferedStream=R,e.newWriteableStream=b,e.consumeReadable=y,e.peekReadable=T,e.consumeStream=I,e.listenStream=p,e.peekStream=S,e.toStream=E,e.emptyStream=d,e.toReadable=f,e.transform=a,e.prefixedReadable=i,e.prefixedStream=n;function L(l){const o=l;return o?typeof o.read=="function":!1}function A(l){const o=l;return o?[o.on,o.pause,o.resume,o.destroy].every(t=>typeof t=="function"):!1}function R(l){const o=l;return o?A(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}function b(l,o){return new m(l,o)}class m{constructor(o,t){this.reducer=o,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o<"u"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(t=>t(o))}emitError(o){this.listeners.error.length===0?(0,h.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(t=>t(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,t){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(o,t){if(this.state.destroyed)return;let u;switch(o){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const r=u.indexOf(t);r>=0&&u.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(l,o){const t=[];let u;for(;(u=l.read())!==null;)t.push(u);return o(t)}function T(l,o,t){const u=[];let r;for(;(r=l.read())!==null&&u.length<t;)u.push(r);return r===null&&u.length>0?o(u):{read:()=>{if(u.length>0)return u.shift();if(typeof r<"u"){const c=r;return r=void 0,c}return l.read()}}}function I(l,o){return new Promise((t,u)=>{const r=[];p(l,{onData:c=>{o&&r.push(c)},onError:c=>{o?u(c):t(void 0)},onEnd:()=>{t(o?o(r):void 0)}})})}function p(l,o,t){l.on("error",u=>{t?.isCancellationRequested||o.onError(u)}),l.on("end",()=>{t?.isCancellationRequested||o.onEnd()}),l.on("data",u=>{t?.isCancellationRequested||o.onData(u)})}function S(l,o){return new Promise((t,u)=>{const r=new O.DisposableStore,c=[],s=D=>{if(c.push(D),c.length>o)return r.dispose(),l.pause(),t({stream:l,buffer:c,ended:!1})},w=D=>(r.dispose(),u(D)),g=()=>(r.dispose(),t({stream:l,buffer:c,ended:!0}));r.add((0,O.toDisposable)(()=>l.removeListener("error",w))),l.on("error",w),r.add((0,O.toDisposable)(()=>l.removeListener("end",g))),l.on("end",g),r.add((0,O.toDisposable)(()=>l.removeListener("data",s))),l.on("data",s)})}function E(l,o){const t=b(o);return t.end(l),t}function d(){const l=b(()=>{throw new Error("not supported")});return l.end(),l}function f(l){let o=!1;return{read:()=>o?null:(o=!0,l)}}function a(l,o,t){const u=b(t);return p(l,{onData:r=>u.write(o.data(r)),onError:r=>u.error(o.error?o.error(r):r),onEnd:()=>u.end()}),u}function i(l,o,t){let u=!1;return{read:()=>{const r=o.read();return u?r:(u=!0,r!==null?t([l,r]):l)}}}function n(l,o,t){let u=!1;const r=b(t);return p(o,{onData:c=>u?r.write(c):(u=!0,r.write(t([l,c]))),onError:c=>r.error(c),onEnd:()=>{u||(u=!0,r.write(l)),r.end()}}),r}}),define(_e[21],Ce([1,0,46,98]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=y,e.readUInt16LE=T,e.writeUInt16LE=I,e.readUInt32BE=p,e.writeUInt32BE=S,e.readUInt32LE=E,e.writeUInt32LE=d,e.readUInt8=f,e.writeUInt8=a,e.readableToBuffer=i,e.bufferToReadable=n,e.streamToBuffer=l,e.bufferedStreamToBuffer=o,e.bufferToStream=t,e.streamToBufferReadableStream=u,e.newWriteableBufferStream=r,e.prefixedBufferReadable=c,e.prefixedBufferStream=s,e.decodeBase64=w,e.encodeBase64=v;const L=typeof Buffer<"u",A=new h.Lazy(()=>new Uint8Array(256));let R,b;class m{static alloc(C){return L?new m(Buffer.allocUnsafe(C)):new m(new Uint8Array(C))}static wrap(C){return L&&!Buffer.isBuffer(C)&&(C=Buffer.from(C.buffer,C.byteOffset,C.byteLength)),new m(C)}static fromString(C,P){return!(P?.dontUseNodeBuffer||!1)&&L?new m(Buffer.from(C)):(R||(R=new TextEncoder),new m(R.encode(C)))}static fromByteArray(C){const P=m.alloc(C.length);for(let k=0,F=C.length;k<F;k++)P.buffer[k]=C[k];return P}static concat(C,P){if(typeof P>"u"){P=0;for(let x=0,z=C.length;x<z;x++)P+=C[x].byteLength}const k=m.alloc(P);let F=0;for(let x=0,z=C.length;x<z;x++){const N=C[x];k.set(N,F),F+=N.byteLength}return k}constructor(C){this.buffer=C,this.byteLength=this.buffer.byteLength}clone(){const C=m.alloc(this.byteLength);return C.set(this),C}toString(){return L?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(C,P){return new m(this.buffer.subarray(C,P))}set(C,P){if(C instanceof m)this.buffer.set(C.buffer,P);else if(C instanceof Uint8Array)this.buffer.set(C,P);else if(C instanceof ArrayBuffer)this.buffer.set(new Uint8Array(C),P);else if(ArrayBuffer.isView(C))this.buffer.set(new Uint8Array(C.buffer,C.byteOffset,C.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(C){return p(this.buffer,C)}writeUInt32BE(C,P){S(this.buffer,C,P)}readUInt32LE(C){return E(this.buffer,C)}writeUInt32LE(C,P){d(this.buffer,C,P)}readUInt8(C){return f(this.buffer,C)}writeUInt8(C,P){a(this.buffer,C,P)}indexOf(C,P=0){return y(this.buffer,C instanceof m?C.buffer:C,P)}}e.VSBuffer=m;function y(_,C,P=0){const k=C.byteLength,F=_.byteLength;if(k===0)return 0;if(k===1)return _.indexOf(C[0]);if(k>F-P)return-1;const x=A.value;x.fill(C.length);for(let W=0;W<C.length;W++)x[C[W]]=C.length-W-1;let z=P+C.length-1,N=z,M=-1;for(;z<F;)if(_[z]===C[N]){if(N===0){M=z;break}z--,N--}else z+=Math.max(C.length-N,x[_[z]]),N=C.length-1;return M}function T(_,C){return _[C+0]<<0>>>0|_[C+1]<<8>>>0}function I(_,C,P){_[P+0]=C&255,C=C>>>8,_[P+1]=C&255}function p(_,C){return _[C]*2**24+_[C+1]*2**16+_[C+2]*2**8+_[C+3]}function S(_,C,P){_[P+3]=C,C=C>>>8,_[P+2]=C,C=C>>>8,_[P+1]=C,C=C>>>8,_[P]=C}function E(_,C){return _[C+0]<<0>>>0|_[C+1]<<8>>>0|_[C+2]<<16>>>0|_[C+3]<<24>>>0}function d(_,C,P){_[P+0]=C&255,C=C>>>8,_[P+1]=C&255,C=C>>>8,_[P+2]=C&255,C=C>>>8,_[P+3]=C&255}function f(_,C){return _[C]}function a(_,C,P){_[P]=C}function i(_){return O.consumeReadable(_,C=>m.concat(C))}function n(_){return O.toReadable(_)}function l(_){return O.consumeStream(_,C=>m.concat(C))}async function o(_){return _.ended?m.concat(_.buffer):m.concat([..._.buffer,await l(_.stream)])}function t(_){return O.toStream(_,C=>m.concat(C))}function u(_){return O.transform(_,{data:C=>typeof C=="string"?m.fromString(C):m.wrap(C)},C=>m.concat(C))}function r(_){return O.newWriteableStream(C=>m.concat(C),_)}function c(_,C){return O.prefixedReadable(_,C,P=>m.concat(P))}function s(_,C){return O.prefixedStream(_,C,P=>m.concat(P))}function w(_){let C=0,P=0,k=0;const F=new Uint8Array(Math.floor(_.length/4*3)),x=N=>{switch(P){case 3:F[k++]=C|N,P=0;break;case 2:F[k++]=C|N>>>2,C=N<<6,P=3;break;case 1:F[k++]=C|N>>>4,C=N<<4,P=2;break;default:C=N<<2,P=1}};for(let N=0;N<_.length;N++){const M=_.charCodeAt(N);if(M>=65&&M<=90)x(M-65);else if(M>=97&&M<=122)x(M-97+26);else if(M>=48&&M<=57)x(M-48+52);else if(M===43||M===45)x(62);else if(M===47||M===95)x(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${_[N]}`)}}const z=k;for(;P>0;)x(0);return m.wrap(F).slice(0,z)}const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:_},C=!0,P=!1){const k=P?D:g;let F="";const x=_.byteLength%3;let z=0;for(;z<_.byteLength-x;z+=3){const N=_[z+0],M=_[z+1],W=_[z+2];F+=k[N>>>2],F+=k[(N<<4|M>>>4)&63],F+=k[(M<<2|W>>>6)&63],F+=k[W&63]}if(x===1){const N=_[z+0];F+=k[N>>>2],F+=k[N<<4&63],C&&(F+="==")}else if(x===2){const N=_[z+0],M=_[z+1];F+=k[N>>>2],F+=k[(N<<4|M>>>4)&63],F+=k[M<<2&63],C&&(F+="=")}return F}}),define(_e[14],Ce([1,0,173,46]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=L,e.format=R,e.format2=m,e.htmlAttributeEncodeValue=y,e.escape=T,e.escapeRegExpCharacters=I,e.count=p,e.truncate=S,e.truncateMiddle=E,e.trim=d,e.ltrim=f,e.rtrim=a,e.convertSimple2RegExpPattern=i,e.stripWildcards=n,e.createRegExp=l,e.regExpLeadsToEndlessLoop=o,e.splitLines=t,e.splitLinesIncludeSeparators=u,e.firstNonWhitespaceIndex=r,e.getLeadingWhitespace=c,e.lastNonWhitespaceIndex=s,e.replaceAsync=w,e.compare=g,e.compareSubstring=D,e.compareIgnoreCase=v,e.compareSubstringIgnoreCase=_,e.isAsciiDigit=C,e.isLowerAsciiLetter=P,e.isUpperAsciiLetter=k,e.equalsIgnoreCase=F,e.startsWithIgnoreCase=x,e.commonPrefixLength=z,e.commonSuffixLength=N,e.isHighSurrogate=M,e.isLowSurrogate=W,e.computeCodePoint=X,e.getNextCodePoint=te,e.nextCharLength=ne,e.prevCharLength=pe,e.getCharContainingOffset=le,e.charCount=we,e.containsRTL=ee,e.isBasicASCII=Pe,e.containsUnusualLineTerminators=oe,e.isFullWidthCharacter=se,e.isEmojiImprecise=re,e.lcut=j,e.forAnsiStringParts=me,e.removeAnsiEscapeCodes=be,e.startsWithUTF8BOM=Ae,e.stripUTF8BOM=fe,e.fuzzyContains=De,e.containsUppercaseCharacter=Te,e.uppercaseFirstLetter=ze,e.getNLines=U,e.singleLetterHash=$,e.getGraphemeBreakType=K,e.getLeftDeleteOffset=He;function L(Ie){return!Ie||typeof Ie!="string"?!0:Ie.trim().length===0}const A=/{(\d+)}/g;function R(Ie,...Be){return Be.length===0?Ie:Ie.replace(A,function(qe,Oe){const Qe=parseInt(Oe,10);return isNaN(Qe)||Qe<0||Qe>=Be.length?qe:Be[Qe]})}const b=/{([^}]+)}/g;function m(Ie,Be){return Object.keys(Be).length===0?Ie:Ie.replace(b,(qe,Oe)=>Be[Oe]??qe)}function y(Ie){return Ie.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function T(Ie){return Ie.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function I(Ie){return Ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function p(Ie,Be){let qe=0;const Oe=Be.charCodeAt(0);for(let Qe=Ie.length-1;Qe>=0;Qe--)Ie.charCodeAt(Qe)===Oe&&qe++;return qe}function S(Ie,Be,qe="\u2026"){return Ie.length<=Be?Ie:`${Ie.substr(0,Be)}${qe}`}function E(Ie,Be,qe="\u2026"){if(Ie.length<=Be)return Ie;const Oe=Math.ceil(Be/2)-qe.length/2,Qe=Math.floor(Be/2)-qe.length/2;return`${Ie.substr(0,Oe)}${qe}${Ie.substr(Ie.length-Qe)}`}function d(Ie,Be=" "){const qe=f(Ie,Be);return a(qe,Be)}function f(Ie,Be){if(!Ie||!Be)return Ie;const qe=Be.length;if(qe===0||Ie.length===0)return Ie;let Oe=0;for(;Ie.indexOf(Be,Oe)===Oe;)Oe=Oe+qe;return Ie.substring(Oe)}function a(Ie,Be){if(!Ie||!Be)return Ie;const qe=Be.length,Oe=Ie.length;if(qe===0||Oe===0)return Ie;let Qe=Oe,ae=-1;for(;ae=Ie.lastIndexOf(Be,Qe-1),!(ae===-1||ae+qe!==Qe);){if(ae===0)return"";Qe=ae}return Ie.substring(0,Qe)}function i(Ie){return Ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function n(Ie){return Ie.replace(/\*/g,"")}function l(Ie,Be,qe={}){if(!Ie)throw new Error("Cannot create regex from empty string");Be||(Ie=I(Ie)),qe.wholeWord&&(/\B/.test(Ie.charAt(0))||(Ie="\\b"+Ie),/\B/.test(Ie.charAt(Ie.length-1))||(Ie=Ie+"\\b"));let Oe="";return qe.global&&(Oe+="g"),qe.matchCase||(Oe+="i"),qe.multiline&&(Oe+="m"),qe.unicode&&(Oe+="u"),new RegExp(Ie,Oe)}function o(Ie){return Ie.source==="^"||Ie.source==="^$"||Ie.source==="$"||Ie.source==="^\\s*$"?!1:!!(Ie.exec("")&&Ie.lastIndex===0)}function t(Ie){return Ie.split(/\r\n|\r|\n/)}function u(Ie){const Be=[],qe=Ie.split(/(\r\n|\r|\n)/);for(let Oe=0;Oe<Math.ceil(qe.length/2);Oe++)Be.push(qe[2*Oe]+(qe[2*Oe+1]??""));return Be}function r(Ie){for(let Be=0,qe=Ie.length;Be<qe;Be++){const Oe=Ie.charCodeAt(Be);if(Oe!==32&&Oe!==9)return Be}return-1}function c(Ie,Be=0,qe=Ie.length){for(let Oe=Be;Oe<qe;Oe++){const Qe=Ie.charCodeAt(Oe);if(Qe!==32&&Qe!==9)return Ie.substring(Be,Oe)}return Ie.substring(Be,qe)}function s(Ie,Be=Ie.length-1){for(let qe=Be;qe>=0;qe--){const Oe=Ie.charCodeAt(qe);if(Oe!==32&&Oe!==9)return qe}return-1}function w(Ie,Be,qe){const Oe=[];let Qe=0;for(const ae of Ie.matchAll(Be)){if(Oe.push(Ie.slice(Qe,ae.index)),ae.index===void 0)throw new Error("match.index should be defined");Qe=ae.index+ae[0].length,Oe.push(qe(ae[0],...ae.slice(1),ae.index,Ie,ae.groups))}return Oe.push(Ie.slice(Qe)),Promise.all(Oe).then(ae=>ae.join(""))}function g(Ie,Be){return Ie<Be?-1:Ie>Be?1:0}function D(Ie,Be,qe=0,Oe=Ie.length,Qe=0,ae=Be.length){for(;qe<Oe&&Qe<ae;qe++,Qe++){const je=Ie.charCodeAt(qe),Le=Be.charCodeAt(Qe);if(je<Le)return-1;if(je>Le)return 1}const ce=Oe-qe,ke=ae-Qe;return ce<ke?-1:ce>ke?1:0}function v(Ie,Be){return _(Ie,Be,0,Ie.length,0,Be.length)}function _(Ie,Be,qe=0,Oe=Ie.length,Qe=0,ae=Be.length){for(;qe<Oe&&Qe<ae;qe++,Qe++){let je=Ie.charCodeAt(qe),Le=Be.charCodeAt(Qe);if(je===Le)continue;if(je>=128||Le>=128)return D(Ie.toLowerCase(),Be.toLowerCase(),qe,Oe,Qe,ae);P(je)&&(je-=32),P(Le)&&(Le-=32);const ot=je-Le;if(ot!==0)return ot}const ce=Oe-qe,ke=ae-Qe;return ce<ke?-1:ce>ke?1:0}function C(Ie){return Ie>=48&&Ie<=57}function P(Ie){return Ie>=97&&Ie<=122}function k(Ie){return Ie>=65&&Ie<=90}function F(Ie,Be){return Ie.length===Be.length&&_(Ie,Be)===0}function x(Ie,Be){const qe=Be.length;return Be.length>Ie.length?!1:_(Ie,Be,0,qe)===0}function z(Ie,Be){const qe=Math.min(Ie.length,Be.length);let Oe;for(Oe=0;Oe<qe;Oe++)if(Ie.charCodeAt(Oe)!==Be.charCodeAt(Oe))return Oe;return qe}function N(Ie,Be){const qe=Math.min(Ie.length,Be.length);let Oe;const Qe=Ie.length-1,ae=Be.length-1;for(Oe=0;Oe<qe;Oe++)if(Ie.charCodeAt(Qe-Oe)!==Be.charCodeAt(ae-Oe))return Oe;return qe}function M(Ie){return 55296<=Ie&&Ie<=56319}function W(Ie){return 56320<=Ie&&Ie<=57343}function X(Ie,Be){return(Ie-55296<<10)+(Be-56320)+65536}function te(Ie,Be,qe){const Oe=Ie.charCodeAt(qe);if(M(Oe)&&qe+1<Be){const Qe=Ie.charCodeAt(qe+1);if(W(Qe))return X(Oe,Qe)}return Oe}function H(Ie,Be){const qe=Ie.charCodeAt(Be-1);if(W(qe)&&Be>1){const Oe=Ie.charCodeAt(Be-2);if(M(Oe))return X(Oe,qe)}return qe}class G{get offset(){return this._offset}constructor(Be,qe=0){this._str=Be,this._len=Be.length,this._offset=qe}setOffset(Be){this._offset=Be}prevCodePoint(){const Be=H(this._str,this._offset);return this._offset-=Be>=65536?2:1,Be}nextCodePoint(){const Be=te(this._str,this._len,this._offset);return this._offset+=Be>=65536?2:1,Be}eol(){return this._offset>=this._len}}e.CodePointIterator=G;class Y{get offset(){return this._iterator.offset}constructor(Be,qe=0){this._iterator=new G(Be,qe)}nextGraphemeLength(){const Be=Ee.getInstance(),qe=this._iterator,Oe=qe.offset;let Qe=Be.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const ae=qe.offset,ce=Be.getGraphemeBreakType(qe.nextCodePoint());if(Q(Qe,ce)){qe.setOffset(ae);break}Qe=ce}return qe.offset-Oe}prevGraphemeLength(){const Be=Ee.getInstance(),qe=this._iterator,Oe=qe.offset;let Qe=Be.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const ae=qe.offset,ce=Be.getGraphemeBreakType(qe.prevCodePoint());if(Q(ce,Qe)){qe.setOffset(ae);break}Qe=ce}return Oe-qe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Y;function ne(Ie,Be){return new Y(Ie,Be).nextGraphemeLength()}function pe(Ie,Be){return new Y(Ie,Be).prevGraphemeLength()}function le(Ie,Be){Be>0&&W(Ie.charCodeAt(Be))&&Be--;const qe=Be+ne(Ie,Be);return[qe-pe(Ie,qe),qe]}function we(Ie){const Be=new Y(Ie);let qe=0;for(;!Be.eol();)qe++,Be.nextGraphemeLength();return qe}let Z;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ee(Ie){return Z||(Z=B()),Z.test(Ie)}const ve=/^[\t\n\r\x20-\x7E]*$/;function Pe(Ie){return ve.test(Ie)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(Ie){return e.UNUSUAL_LINE_TERMINATORS.test(Ie)}function se(Ie){return Ie>=11904&&Ie<=55215||Ie>=63744&&Ie<=64255||Ie>=65281&&Ie<=65374}function re(Ie){return Ie>=127462&&Ie<=127487||Ie===8986||Ie===8987||Ie===9200||Ie===9203||Ie>=9728&&Ie<=10175||Ie===11088||Ie===11093||Ie>=127744&&Ie<=128591||Ie>=128640&&Ie<=128764||Ie>=128992&&Ie<=129008||Ie>=129280&&Ie<=129535||Ie>=129648&&Ie<=129782}function j(Ie,Be,qe=""){const Oe=Ie.trimStart();if(Oe.length<Be)return Oe;const Qe=/\b/g;let ae=0;for(;Qe.test(Oe)&&!(Oe.length-Qe.lastIndex<Be);)ae=Qe.lastIndex,Qe.lastIndex+=1;return ae===0?Oe:qe+Oe.substring(ae).trimStart()}const ie=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*me(Ie){let Be=0;for(const qe of Ie.matchAll(ie))Be!==qe.index&&(yield{isCode:!1,str:Ie.substring(Be,qe.index)}),yield{isCode:!0,str:qe[0]},Be=qe.index+qe[0].length;Be!==Ie.length&&(yield{isCode:!1,str:Ie.substring(Be)})}function be(Ie){return Ie&&(Ie=Ie.replace(ie,"")),Ie}e.UTF8_BOM_CHARACTER="\uFEFF";function Ae(Ie){return!!(Ie&&Ie.length>0&&Ie.charCodeAt(0)===65279)}function fe(Ie){return Ae(Ie)?Ie.substr(1):Ie}function De(Ie,Be){if(!Ie||!Be||Ie.length<Be.length)return!1;const qe=Be.length,Oe=Ie.toLowerCase();let Qe=0,ae=-1;for(;Qe<qe;){const ce=Oe.indexOf(Be[Qe],ae+1);if(ce<0)return!1;ae=ce,Qe++}return!0}function Te(Ie,Be=!1){return Ie?(Be&&(Ie=Ie.replace(/\\./g,"")),Ie.toLowerCase()!==Ie):!1}function ze(Ie){return Ie.charAt(0).toUpperCase()+Ie.slice(1)}function U(Ie,Be=1){if(Be===0)return"";let qe=-1;do qe=Ie.indexOf(`
`,qe+1),Be--;while(Be>0&&qe>=0);return qe===-1?Ie:(Ie[qe-1]==="\r"&&qe--,Ie.substr(0,qe))}function $(Ie){return Ie=Ie%(2*26),Ie<26?String.fromCharCode(97+Ie):String.fromCharCode(65+Ie-26)}function K(Ie){return Ee.getInstance().getGraphemeBreakType(Ie)}function Q(Ie,Be){return Ie===0?Be!==5&&Be!==7:Ie===2&&Be===3?!1:Ie===4||Ie===2||Ie===3||Be===4||Be===2||Be===3?!0:!(Ie===8&&(Be===8||Be===9||Be===11||Be===12)||(Ie===11||Ie===9)&&(Be===9||Be===10)||(Ie===12||Ie===10)&&Be===10||Be===5||Be===13||Be===7||Ie===1||Ie===13&&Be===14||Ie===6&&Be===6)}var de;(function(Ie){Ie[Ie.Other=0]="Other",Ie[Ie.Prepend=1]="Prepend",Ie[Ie.CR=2]="CR",Ie[Ie.LF=3]="LF",Ie[Ie.Control=4]="Control",Ie[Ie.Extend=5]="Extend",Ie[Ie.Regional_Indicator=6]="Regional_Indicator",Ie[Ie.SpacingMark=7]="SpacingMark",Ie[Ie.L=8]="L",Ie[Ie.V=9]="V",Ie[Ie.T=10]="T",Ie[Ie.LV=11]="LV",Ie[Ie.LVT=12]="LVT",Ie[Ie.ZWJ=13]="ZWJ",Ie[Ie.Extended_Pictographic=14]="Extended_Pictographic"})(de||(e.GraphemeBreakType=de={}));class Ee{static{this._INSTANCE=null}static getInstance(){return Ee._INSTANCE||(Ee._INSTANCE=new Ee),Ee._INSTANCE}constructor(){this._data=Fe()}getGraphemeBreakType(Be){if(Be<32)return Be===10?3:Be===13?2:4;if(Be<127)return 0;const qe=this._data,Oe=qe.length/3;let Qe=1;for(;Qe<=Oe;)if(Be<qe[3*Qe])Qe=2*Qe;else if(Be>qe[3*Qe+1])Qe=2*Qe+1;else return qe[3*Qe+2];return 0}}function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(Ie,Be){if(Ie===0)return 0;const qe=Ke(Ie,Be);if(qe!==void 0)return qe;const Oe=new G(Be,Ie);return Oe.prevCodePoint(),Oe.offset}function Ke(Ie,Be){const qe=new G(Be,Ie);let Oe=qe.prevCodePoint();for(;rt(Oe)||Oe===65039||Oe===8419;){if(qe.offset===0)return;Oe=qe.prevCodePoint()}if(!re(Oe))return;let Qe=qe.offset;return Qe>0&&qe.prevCodePoint()===8205&&(Qe=qe.offset),Qe}function rt(Ie){return 127995<=Ie&&Ie<=127999}var tt;(function(Ie){Ie[Ie.zwj=8205]="zwj",Ie[Ie.emojiVariantSelector=65039]="emojiVariantSelector",Ie[Ie.enclosingKeyCap=8419]="enclosingKeyCap"})(tt||(tt={})),e.noBreakWhitespace="\xA0";class it{static{this.ambiguousCharacterData=new O.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new h.LRUCachedFunction({getCacheKey:JSON.stringify},Be=>{function qe(ot){const lt=new Map;for(let wt=0;wt<ot.length;wt+=2)lt.set(ot[wt],ot[wt+1]);return lt}function Oe(ot,lt){const wt=new Map(ot);for(const[At,Wt]of lt)wt.set(At,Wt);return wt}function Qe(ot,lt){if(!ot)return lt;const wt=new Map;for(const[At,Wt]of ot)lt.has(At)&&wt.set(At,Wt);return wt}const ae=this.ambiguousCharacterData.value;let ce=Be.filter(ot=>!ot.startsWith("_")&&ot in ae);ce.length===0&&(ce=["_default"]);let ke;for(const ot of ce){const lt=qe(ae[ot]);ke=Qe(ke,lt)}const je=qe(ae._common),Le=Oe(je,ke);return new it(Le)})}static getInstance(Be){return it.cache.get(Array.from(Be))}static{this._locales=new O.Lazy(()=>Object.keys(it.ambiguousCharacterData.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return it._locales.value}constructor(Be){this.confusableDictionary=Be}isAmbiguous(Be){return this.confusableDictionary.has(Be)}getPrimaryConfusable(Be){return this.confusableDictionary.get(Be)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=it;class st{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(st.getRawData())),this._data}static isInvisibleCharacter(Be){return st.getData().has(Be)}static get codePoints(){return st.getData()}}e.InvisibleCharacters=st}),define(_e[127],Ce([1,0,27,168,14]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FuzzyScoreOptions=e.FuzzyScore=e.matchesPrefix=e.matchesStrictPrefix=void 0,e.or=A,e.matchesContiguousSubString=b,e.matchesSubString=m,e.isUpper=I,e.matchesCamelCase=w,e.matchesWords=g,e.matchesFuzzy=k,e.matchesFuzzy2=F,e.anyScore=x,e.createMatches=z,e.isPatternInWord=ee,e.fuzzyScore=se,e.fuzzyScoreGracefulAggressive=ie,e.fuzzyScoreGraceful=me;function A(...fe){return function(De,Te){for(let ze=0,U=fe.length;ze<U;ze++){const $=fe[ze](De,Te);if($)return $}return null}}e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(fe,De,Te){if(!Te||Te.length<De.length)return null;let ze;return fe?ze=L.startsWithIgnoreCase(Te,De):ze=Te.indexOf(De)===0,ze?De.length>0?[{start:0,end:De.length}]:[]:null}function b(fe,De){const Te=De.toLowerCase().indexOf(fe.toLowerCase());return Te===-1?null:[{start:Te,end:Te+fe.length}]}function m(fe,De){return y(fe.toLowerCase(),De.toLowerCase(),0,0)}function y(fe,De,Te,ze){if(Te===fe.length)return[];if(ze===De.length)return null;if(fe[Te]===De[ze]){let U=null;return(U=y(fe,De,Te+1,ze+1))?l({start:ze,end:ze+1},U):null}return y(fe,De,Te,ze+1)}function T(fe){return 97<=fe&&fe<=122}function I(fe){return 65<=fe&&fe<=90}function p(fe){return 48<=fe&&fe<=57}function S(fe){return fe===32||fe===9||fe===10||fe===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(fe=>E.add(fe.charCodeAt(0)));function d(fe){return S(fe)||E.has(fe)}function f(fe,De){return fe===De||d(fe)&&d(De)}const a=new Map;function i(fe){if(a.has(fe))return a.get(fe);let De;const Te=(0,O.getKoreanAltChars)(fe);return Te&&(De=Te),a.set(fe,De),De}function n(fe){return T(fe)||I(fe)||p(fe)}function l(fe,De){return De.length===0?De=[fe]:fe.end===De[0].start?De[0].start=fe.start:De.unshift(fe),De}function o(fe,De){for(let Te=De;Te<fe.length;Te++){const ze=fe.charCodeAt(Te);if(I(ze)||p(ze)||Te>0&&!n(fe.charCodeAt(Te-1)))return Te}return fe.length}function t(fe,De,Te,ze){if(Te===fe.length)return[];if(ze===De.length)return null;if(fe[Te]!==De[ze].toLowerCase())return null;{let U=null,$=ze+1;for(U=t(fe,De,Te+1,ze+1);!U&&($=o(De,$))<De.length;)U=t(fe,De,Te+1,$),$++;return U===null?null:l({start:ze,end:ze+1},U)}}function u(fe){let De=0,Te=0,ze=0,U=0,$=0;for(let Fe=0;Fe<fe.length;Fe++)$=fe.charCodeAt(Fe),I($)&&De++,T($)&&Te++,n($)&&ze++,p($)&&U++;const K=De/fe.length,Q=Te/fe.length,de=ze/fe.length,Ee=U/fe.length;return{upperPercent:K,lowerPercent:Q,alphaPercent:de,numericPercent:Ee}}function r(fe){const{upperPercent:De,lowerPercent:Te}=fe;return Te===0&&De>.6}function c(fe){const{upperPercent:De,lowerPercent:Te,alphaPercent:ze,numericPercent:U}=fe;return Te>.2&&De<.8&&ze>.6&&U<.2}function s(fe){let De=0,Te=0,ze=0,U=0;for(let $=0;$<fe.length;$++)ze=fe.charCodeAt($),I(ze)&&De++,T(ze)&&Te++,S(ze)&&U++;return(De===0||Te===0)&&U===0?fe.length<=30:De<=5}function w(fe,De){if(!De||(De=De.trim(),De.length===0)||!s(fe))return null;De.length>60&&(De=De.substring(0,60));const Te=u(De);if(!c(Te)){if(!r(Te))return null;De=De.toLowerCase()}let ze=null,U=0;for(fe=fe.toLowerCase();U<De.length&&(ze=t(fe,De,0,U))===null;)U=o(De,U+1);return ze}function g(fe,De,Te=!1){if(!De||De.length===0)return null;let ze=null,U=0;for(fe=fe.toLowerCase(),De=De.toLowerCase();U<De.length&&(ze=D(fe,De,0,U,Te),ze===null);)U=v(De,U+1);return ze}function D(fe,De,Te,ze,U){let $=0;if(Te===fe.length)return[];if(ze===De.length)return null;if(!f(fe.charCodeAt(Te),De.charCodeAt(ze))){const de=i(fe.charCodeAt(Te));if(!de)return null;for(let Ee=0;Ee<de.length;Ee++)if(!f(de[Ee],De.charCodeAt(ze+Ee)))return null;$+=de.length-1}let K=null,Q=ze+$+1;if(K=D(fe,De,Te+1,Q,U),!U)for(;!K&&(Q=v(De,Q))<De.length;)K=D(fe,De,Te+1,Q,U),Q++;if(!K)return null;if(fe.charCodeAt(Te)!==De.charCodeAt(ze)){const de=i(fe.charCodeAt(Te));if(!de)return K;for(let Ee=0;Ee<de.length;Ee++)if(de[Ee]!==De.charCodeAt(ze+Ee))return K}return l({start:ze,end:ze+$+1},K)}function v(fe,De){for(let Te=De;Te<fe.length;Te++)if(d(fe.charCodeAt(Te))||Te>0&&d(fe.charCodeAt(Te-1)))return Te;return fe.length}const _=A(e.matchesPrefix,w,b),C=A(e.matchesPrefix,w,m),P=new h.LRUCache(1e4);function k(fe,De,Te=!1){if(typeof fe!="string"||typeof De!="string")return null;let ze=P.get(fe);ze||(ze=new RegExp(L.convertSimple2RegExpPattern(fe),"i"),P.set(fe,ze));const U=ze.exec(De);return U?[{start:U.index,end:U.index+U[0].length}]:Te?C(fe,De):_(fe,De)}function F(fe,De){const Te=se(fe,fe.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Te?z(Te):null}function x(fe,De,Te,ze,U,$){const K=Math.min(13,fe.length);for(;Te<K;Te++){const Q=se(fe,De,Te,ze,U,$,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,$]}function z(fe){if(typeof fe>"u")return[];const De=[],Te=fe[1];for(let ze=fe.length-1;ze>1;ze--){const U=fe[ze]+Te,$=De[De.length-1];$&&$.end===U?$.end=U+1:De.push({start:U,end:U+1})}return De}const N=128;function M(){const fe=[],De=[];for(let Te=0;Te<=N;Te++)De[Te]=0;for(let Te=0;Te<=N;Te++)fe.push(De.slice(0));return fe}function W(fe){const De=[];for(let Te=0;Te<=fe;Te++)De[Te]=0;return De}const X=W(2*N),te=W(2*N),H=M(),G=M(),Y=M(),ne=!1;function pe(fe,De,Te,ze,U){function $(Q,de,Ee=" "){for(;Q.length<de;)Q=Ee+Q;return Q}let K=` |   |${ze.split("").map(Q=>$(Q,3)).join("|")}
`;for(let Q=0;Q<=Te;Q++)Q===0?K+=" |":K+=`${De[Q-1]}|`,K+=fe[Q].slice(0,U+1).map(de=>$(de.toString(),3)).join("|")+`
`;return K}function le(fe,De,Te,ze){fe=fe.substr(De),Te=Te.substr(ze),console.log(pe(G,fe,fe.length,Te,Te.length)),console.log(pe(Y,fe,fe.length,Te,Te.length)),console.log(pe(H,fe,fe.length,Te,Te.length))}function we(fe,De){if(De<0||De>=fe.length)return!1;const Te=fe.codePointAt(De);switch(Te){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(Te)}}function Z(fe,De){if(De<0||De>=fe.length)return!1;switch(fe.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function B(fe,De,Te){return De[fe]!==Te[fe]}function ee(fe,De,Te,ze,U,$,K=!1){for(;De<Te&&U<$;)fe[De]===ze[U]&&(K&&(X[De]=U),De+=1),U+=1;return De===Te}var ve;(function(fe){fe[fe.Diag=1]="Diag",fe[fe.Left=2]="Left",fe[fe.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Pe;(function(fe){fe.Default=[-100,0];function De(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}fe.isDefault=De})(Pe||(e.FuzzyScore=Pe={}));class oe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,Te){this.firstMatchCanBeWeak=De,this.boostFullMatch=Te}}e.FuzzyScoreOptions=oe;function se(fe,De,Te,ze,U,$,K=oe.default){const Q=fe.length>N?N:fe.length,de=ze.length>N?N:ze.length;if(Te>=Q||$>=de||Q-Te>de-$||!ee(De,Te,Q,U,$,de,!0))return;re(Q,de,Te,$,De,U);let Ee=1,Fe=1,He=Te,Ke=$;const rt=[!1];for(Ee=1,He=Te;He<Q;Ee++,He++){const Be=X[He],qe=te[He],Oe=He+1<Q?te[He+1]:de;for(Fe=Be-$+1,Ke=Be;Ke<Oe;Fe++,Ke++){let Qe=Number.MIN_SAFE_INTEGER,ae=!1;Ke<=qe&&(Qe=j(fe,De,He,Te,ze,U,Ke,de,$,H[Ee-1][Fe-1]===0,rt));let ce=0;Qe!==Number.MAX_SAFE_INTEGER&&(ae=!0,ce=Qe+G[Ee-1][Fe-1]);const ke=Ke>Be,je=ke?G[Ee][Fe-1]+(H[Ee][Fe-1]>0?-5:0):0,Le=Ke>Be+1&&H[Ee][Fe-1]>0,ot=Le?G[Ee][Fe-2]+(H[Ee][Fe-2]>0?-5:0):0;if(Le&&(!ke||ot>=je)&&(!ae||ot>=ce))G[Ee][Fe]=ot,Y[Ee][Fe]=3,H[Ee][Fe]=0;else if(ke&&(!ae||je>=ce))G[Ee][Fe]=je,Y[Ee][Fe]=2,H[Ee][Fe]=0;else if(ae)G[Ee][Fe]=ce,Y[Ee][Fe]=1,H[Ee][Fe]=H[Ee-1][Fe-1]+1;else throw new Error("not possible")}}if(ne&&le(fe,Te,ze,$),!rt[0]&&!K.firstMatchCanBeWeak)return;Ee--,Fe--;const tt=[G[Ee][Fe],$];let it=0,st=0;for(;Ee>=1;){let Be=Fe;do{const qe=Y[Ee][Be];if(qe===3)Be=Be-2;else if(qe===2)Be=Be-1;else break}while(Be>=1);it>1&&De[Te+Ee-1]===U[$+Fe-1]&&!B(Be+$-1,ze,U)&&it+1>H[Ee][Be]&&(Be=Fe),Be===Fe?it++:it=1,st||(st=Be),Ee--,Fe=Be-1,tt.push(Fe)}de===Q&&K.boostFullMatch&&(tt[0]+=2);const Ie=st-Q;return tt[0]-=Ie,tt}function re(fe,De,Te,ze,U,$){let K=fe-1,Q=De-1;for(;K>=Te&&Q>=ze;)U[K]===$[Q]&&(te[K]=Q,K--),Q--}function j(fe,De,Te,ze,U,$,K,Q,de,Ee,Fe){if(De[Te]!==$[K])return Number.MIN_SAFE_INTEGER;let He=1,Ke=!1;return K===Te-ze?He=fe[Te]===U[K]?7:5:B(K,U,$)&&(K===0||!B(K-1,U,$))?(He=fe[Te]===U[K]?7:5,Ke=!0):we($,K)&&(K===0||!we($,K-1))?He=5:(we($,K-1)||Z($,K-1))&&(He=5,Ke=!0),He>1&&Te===ze&&(Fe[0]=!0),Ke||(Ke=B(K,U,$)||we($,K-1)||Z($,K-1)),Te===ze?K>de&&(He-=Ke?3:5):Ee?He+=Ke?2:0:He+=Ke?0:1,K+1===Q&&(He-=Ke?3:5),He}function ie(fe,De,Te,ze,U,$,K){return be(fe,De,Te,ze,U,$,!0,K)}function me(fe,De,Te,ze,U,$,K){return be(fe,De,Te,ze,U,$,!1,K)}function be(fe,De,Te,ze,U,$,K,Q){let de=se(fe,De,Te,ze,U,$,Q);if(de&&!K)return de;if(fe.length>=3){const Ee=Math.min(7,fe.length-1);for(let Fe=Te+1;Fe<Ee;Fe++){const He=Ae(fe,Fe);if(He){const Ke=se(He,He.toLowerCase(),Te,ze,U,$,Q);Ke&&(Ke[0]-=3,(!de||Ke[0]>de[0])&&(de=Ke))}}}return de}function Ae(fe,De){if(De+1>=fe.length)return;const Te=fe[De],ze=fe[De+1];if(Te!==ze)return fe.slice(0,De)+ze+Te+fe.slice(De+2)}}),define(_e[57],Ce([1,0,14]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=O,e.doHash=L,e.numberHash=A,e.stringHash=b,e.toHexString=d;function O(a){return L(a,0)}function L(a,i){switch(typeof a){case"object":return a===null?A(349,i):Array.isArray(a)?m(a,i):y(a,i);case"string":return b(a,i);case"boolean":return R(a,i);case"number":return A(a,i);case"undefined":return A(937,i);default:return A(617,i)}}function A(a,i){return(i<<5)-i+a|0}function R(a,i){return A(a?433:863,i)}function b(a,i){i=A(149417,i);for(let n=0,l=a.length;n<l;n++)i=A(a.charCodeAt(n),i);return i}function m(a,i){return i=A(104579,i),a.reduce((n,l)=>L(l,n),i)}function y(a,i){return i=A(181387,i),Object.keys(a).sort().reduce((n,l)=>(n=b(l,n),L(a[l],n)),i)}class T{constructor(){this._value=0}get value(){return this._value}hash(i){return this._value=L(i,this._value),this._value}}e.Hasher=T;var I;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function p(a,i,n=32){const l=n-i,o=~((1<<l)-1);return(a<<i|(o&a)>>>l)>>>0}function S(a,i=0,n=a.byteLength,l=0){for(let o=0;o<n;o++)a[i+o]=l}function E(a,i,n="0"){for(;a.length<i;)a=n+a;return a}function d(a,i=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(n=>n.toString(16).padStart(2,"0")).join(""):E((a>>>0).toString(16),i/4)}class f{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(i){const n=i.length;if(n===0)return;const l=this._buff;let o=this._buffLen,t=this._leftoverHighSurrogate,u,r;for(t!==0?(u=t,r=-1,t=0):(u=i.charCodeAt(0),r=0);;){let c=u;if(h.isHighSurrogate(u))if(r+1<n){const s=i.charCodeAt(r+1);h.isLowSurrogate(s)?(r++,c=h.computeCodePoint(u,s)):c=65533}else{t=u;break}else h.isLowSurrogate(u)&&(c=65533);if(o=this._push(l,o,c),r++,r<n)u=i.charCodeAt(r);else break}this._buffLen=o,this._leftoverHighSurrogate=t}_push(i,n,l){return l<128?i[n++]=l:l<2048?(i[n++]=192|(l&1984)>>>6,i[n++]=128|(l&63)>>>0):l<65536?(i[n++]=224|(l&61440)>>>12,i[n++]=128|(l&4032)>>>6,i[n++]=128|(l&63)>>>0):(i[n++]=240|(l&1835008)>>>18,i[n++]=128|(l&258048)>>>12,i[n++]=128|(l&4032)>>>6,i[n++]=128|(l&63)>>>0),n>=64&&(this._step(),n-=64,this._totalLen+=64,i[0]=i[64],i[1]=i[65],i[2]=i[66]),n}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const i=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(i/4294967296),!1),this._buffDV.setUint32(60,i%4294967296,!1),this._step()}_step(){const i=f._bigBlock32,n=this._buffDV;for(let g=0;g<64;g+=4)i.setUint32(g,n.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)i.setUint32(g,p(i.getUint32(g-12,!1)^i.getUint32(g-32,!1)^i.getUint32(g-56,!1)^i.getUint32(g-64,!1),1),!1);let l=this._h0,o=this._h1,t=this._h2,u=this._h3,r=this._h4,c,s,w;for(let g=0;g<80;g++)g<20?(c=o&t|~o&u,s=1518500249):g<40?(c=o^t^u,s=1859775393):g<60?(c=o&t|o&u|t&u,s=2400959708):(c=o^t^u,s=3395469782),w=p(l,5)+c+r+s+i.getUint32(g*4,!1)&4294967295,r=u,u=t,t=p(o,30),o=l,l=w;this._h0=this._h0+l&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=f}),define(_e[41],Ce([1,0,14]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(O||(O={})),function(L){const A="error",R="warning",b="warn",m="info",y="ignore";function T(p){return p?h.equalsIgnoreCase(A,p)?L.Error:h.equalsIgnoreCase(R,p)||h.equalsIgnoreCase(b,p)?L.Warning:h.equalsIgnoreCase(m,p)?L.Info:L.Ignore:L.Ignore}L.fromValue=T;function I(p){switch(p){case L.Error:return A;case L.Warning:return R;case L.Info:return m;default:return y}}L.toString=I}(O||(O={})),e.default=O}),define(_e[174],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(_e[78],Ce([1,0,19,14]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class L{constructor(){this._value="",this._pos=0}reset(S){return this._value=S,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(S){const E=S.charCodeAt(0),d=this._value.charCodeAt(this._pos);return E-d}value(){return this._value[this._pos]}}e.StringIterator=L;class A{constructor(S=!0){this._caseSensitive=S}reset(S){return this._value=S,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let S=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(S)this._from++;else break;else S=!1;return this}cmp(S){return this._caseSensitive?(0,O.compareSubstring)(S,this._value,0,S.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(S,this._value,0,S.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class R{constructor(S=!0,E=!0){this._splitOnBackslash=S,this._caseSensitive=E}reset(S){this._from=0,this._to=0,this._value=S,this._valueLen=S.length;for(let E=S.length-1;E>=0;E--,this._valueLen--){const d=this._value.charCodeAt(E);if(!(d===47||this._splitOnBackslash&&d===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let S=!0;for(;this._to<this._valueLen;this._to++){const E=this._value.charCodeAt(this._to);if(E===47||this._splitOnBackslash&&E===92)if(S)this._from++;else break;else S=!1}return this}cmp(S){return this._caseSensitive?(0,O.compareSubstring)(S,this._value,0,S.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(S,this._value,0,S.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=R;var b;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(b||(b={}));class m{constructor(S,E){this._ignorePathCasing=S,this._ignoreQueryAndFragment=E,this._states=[],this._stateIdx=0}reset(S){return this._value=S,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new R(!1,!this._ignorePathCasing(S)),this._pathIterator.reset(S.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(S)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(S){if(this._states[this._stateIdx]===1)return(0,O.compareIgnoreCase)(S,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,O.compareIgnoreCase)(S,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(S);if(this._states[this._stateIdx]===4)return(0,O.compare)(S,this._value.query);if(this._states[this._stateIdx]===5)return(0,O.compare)(S,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=m;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(T||(T={}));class I{static forUris(S=()=>!1,E=()=>!1){return new I(new m(S,E))}static forPaths(S=!1){return new I(new R(void 0,!S))}static forStrings(){return new I(new L)}static forConfigKeys(){return new I(new A)}constructor(S){this._iter=S}clear(){this._root=void 0}fill(S,E){if(E){const d=E.slice(0);(0,h.shuffle)(d);for(const f of d)this.set(f,S)}else{const d=S.slice(0);(0,h.shuffle)(d);for(const f of d)this.set(f[0],f[1])}}set(S,E){const d=this._iter.reset(S);let f;this._root||(this._root=new y,this._root.segment=d.value());const a=[];for(f=this._root;;){const n=d.cmp(f.segment);if(n>0)f.left||(f.left=new y,f.left.segment=d.value()),a.push([-1,f]),f=f.left;else if(n<0)f.right||(f.right=new y,f.right.segment=d.value()),a.push([1,f]),f=f.right;else if(d.hasNext())d.next(),f.mid||(f.mid=new y,f.mid.segment=d.value()),a.push([0,f]),f=f.mid;else break}const i=f.value;f.value=E,f.key=S;for(let n=a.length-1;n>=0;n--){const l=a[n][1];l.updateHeight();const o=l.balanceFactor();if(o<-1||o>1){const t=a[n][0],u=a[n+1][0];if(t===1&&u===1)a[n][1]=l.rotateLeft();else if(t===-1&&u===-1)a[n][1]=l.rotateRight();else if(t===1&&u===-1)l.right=a[n+1][1]=a[n+1][1].rotateRight(),a[n][1]=l.rotateLeft();else if(t===-1&&u===1)l.left=a[n+1][1]=a[n+1][1].rotateLeft(),a[n][1]=l.rotateRight();else throw new Error;if(n>0)switch(a[n-1][0]){case-1:a[n-1][1].left=a[n][1];break;case 1:a[n-1][1].right=a[n][1];break;case 0:a[n-1][1].mid=a[n][1];break}else this._root=a[0][1]}}return i}get(S){return this._getNode(S)?.value}_getNode(S){const E=this._iter.reset(S);let d=this._root;for(;d;){const f=E.cmp(d.segment);if(f>0)d=d.left;else if(f<0)d=d.right;else if(E.hasNext())E.next(),d=d.mid;else break}return d}has(S){const E=this._getNode(S);return!(E?.value===void 0&&E?.mid===void 0)}delete(S){return this._delete(S,!1)}deleteSuperstr(S){return this._delete(S,!0)}_delete(S,E){const d=this._iter.reset(S),f=[];let a=this._root;for(;a;){const i=d.cmp(a.segment);if(i>0)f.push([-1,a]),a=a.left;else if(i<0)f.push([1,a]),a=a.right;else if(d.hasNext())d.next(),f.push([0,a]),a=a.mid;else break}if(a){if(E?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const i=this._min(a.right);if(i.key){const{key:n,value:l,segment:o}=i;this._delete(i.key,!1),a.key=n,a.value=l,a.segment=o}}else{const i=a.left??a.right;if(f.length>0){const[n,l]=f[f.length-1];switch(n){case-1:l.left=i;break;case 0:l.mid=i;break;case 1:l.right=i;break}}else this._root=i}for(let i=f.length-1;i>=0;i--){const n=f[i][1];n.updateHeight();const l=n.balanceFactor();if(l>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),f[i][1]=n.rotateLeft()):l<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),f[i][1]=n.rotateRight()),i>0)switch(f[i-1][0]){case-1:f[i-1][1].left=f[i][1];break;case 1:f[i-1][1].right=f[i][1];break;case 0:f[i-1][1].mid=f[i][1];break}else this._root=f[0][1]}}}_min(S){for(;S.left;)S=S.left;return S}findSubstr(S){const E=this._iter.reset(S);let d=this._root,f;for(;d;){const a=E.cmp(d.segment);if(a>0)d=d.left;else if(a<0)d=d.right;else if(E.hasNext())E.next(),f=d.value||f,d=d.mid;else break}return d&&d.value||f}findSuperstr(S){return this._findSuperstrOrElement(S,!1)}_findSuperstrOrElement(S,E){const d=this._iter.reset(S);let f=this._root;for(;f;){const a=d.cmp(f.segment);if(a>0)f=f.left;else if(a<0)f=f.right;else if(d.hasNext())d.next(),f=f.mid;else return f.mid?this._entries(f.mid):E?f.value:void 0}}hasElementOrSubtree(S){return this._findSuperstrOrElement(S,!0)!==void 0}forEach(S){for(const[E,d]of this)S(d,E)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(S){const E=[];return this._dfsEntries(S,E),E[Symbol.iterator]()}_dfsEntries(S,E){S&&(S.left&&this._dfsEntries(S.left,E),S.value&&E.push([S.key,S.value]),S.mid&&this._dfsEntries(S.mid,E),S.right&&this._dfsEntries(S.right,E))}_isBalanced(){const S=E=>{if(!E)return!0;const d=E.balanceFactor();return d<-1||d>1?!1:S(E.left)&&S(E.right)};return S(this._root)}}e.TernarySearchTree=I}),define(_e[18],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=h,e.isStringArray=O,e.isObject=L,e.isTypedArray=A,e.isNumber=R,e.isIterable=b,e.isBoolean=m,e.isUndefined=y,e.isDefined=T,e.isUndefinedOrNull=I,e.assertType=p,e.assertIsDefined=S,e.assertAllDefined=E,e.isEmptyObject=f,e.isFunction=a,e.areFunctions=i,e.validateConstraints=n,e.validateConstraint=l;function h(o){return typeof o=="string"}function O(o){return Array.isArray(o)&&o.every(t=>h(t))}function L(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function A(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}function R(o){return typeof o=="number"&&!isNaN(o)}function b(o){return!!o&&typeof o[Symbol.iterator]=="function"}function m(o){return o===!0||o===!1}function y(o){return typeof o>"u"}function T(o){return!I(o)}function I(o){return y(o)||o===null}function p(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function S(o){if(I(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function E(...o){const t=[];for(let u=0;u<o.length;u++){const r=o[u];if(I(r))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);t.push(r)}return t}const d=Object.prototype.hasOwnProperty;function f(o){if(!L(o))return!1;for(const t in o)if(d.call(o,t))return!1;return!0}function a(o){return typeof o=="function"}function i(...o){return o.length>0&&o.every(a)}function n(o,t){const u=Math.min(o.length,t.length);for(let r=0;r<u;r++)l(o[r],t[r])}function l(o,t){if(h(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(a(t)){try{if(o instanceof t)return}catch{}if(!I(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(_e[99],Ce([1,0,18]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.register=L,e.getCodiconFontCharacters=A;const O=Object.create(null);function L(R,b){if((0,h.isString)(b)){const m=O[b];if(m===void 0)throw new Error(`${R} references an unknown codicon: ${b}`);b=m}return O[R]=b,{id:R}}function A(){return O}}),define(_e[175],Ce([1,0,99]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.codiconsLibrary=void 0,e.codiconsLibrary={add:(0,h.register)("add",6e4),plus:(0,h.register)("plus",6e4),gistNew:(0,h.register)("gist-new",6e4),repoCreate:(0,h.register)("repo-create",6e4),lightbulb:(0,h.register)("lightbulb",60001),lightBulb:(0,h.register)("light-bulb",60001),repo:(0,h.register)("repo",60002),repoDelete:(0,h.register)("repo-delete",60002),gistFork:(0,h.register)("gist-fork",60003),repoForked:(0,h.register)("repo-forked",60003),gitPullRequest:(0,h.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,h.register)("git-pull-request-abandoned",60004),recordKeys:(0,h.register)("record-keys",60005),keyboard:(0,h.register)("keyboard",60005),tag:(0,h.register)("tag",60006),gitPullRequestLabel:(0,h.register)("git-pull-request-label",60006),tagAdd:(0,h.register)("tag-add",60006),tagRemove:(0,h.register)("tag-remove",60006),person:(0,h.register)("person",60007),personFollow:(0,h.register)("person-follow",60007),personOutline:(0,h.register)("person-outline",60007),personFilled:(0,h.register)("person-filled",60007),gitBranch:(0,h.register)("git-branch",60008),gitBranchCreate:(0,h.register)("git-branch-create",60008),gitBranchDelete:(0,h.register)("git-branch-delete",60008),sourceControl:(0,h.register)("source-control",60008),mirror:(0,h.register)("mirror",60009),mirrorPublic:(0,h.register)("mirror-public",60009),star:(0,h.register)("star",60010),starAdd:(0,h.register)("star-add",60010),starDelete:(0,h.register)("star-delete",60010),starEmpty:(0,h.register)("star-empty",60010),comment:(0,h.register)("comment",60011),commentAdd:(0,h.register)("comment-add",60011),alert:(0,h.register)("alert",60012),warning:(0,h.register)("warning",60012),search:(0,h.register)("search",60013),searchSave:(0,h.register)("search-save",60013),logOut:(0,h.register)("log-out",60014),signOut:(0,h.register)("sign-out",60014),logIn:(0,h.register)("log-in",60015),signIn:(0,h.register)("sign-in",60015),eye:(0,h.register)("eye",60016),eyeUnwatch:(0,h.register)("eye-unwatch",60016),eyeWatch:(0,h.register)("eye-watch",60016),circleFilled:(0,h.register)("circle-filled",60017),primitiveDot:(0,h.register)("primitive-dot",60017),closeDirty:(0,h.register)("close-dirty",60017),debugBreakpoint:(0,h.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,h.register)("debug-breakpoint-disabled",60017),debugHint:(0,h.register)("debug-hint",60017),terminalDecorationSuccess:(0,h.register)("terminal-decoration-success",60017),primitiveSquare:(0,h.register)("primitive-square",60018),edit:(0,h.register)("edit",60019),pencil:(0,h.register)("pencil",60019),info:(0,h.register)("info",60020),issueOpened:(0,h.register)("issue-opened",60020),gistPrivate:(0,h.register)("gist-private",60021),gitForkPrivate:(0,h.register)("git-fork-private",60021),lock:(0,h.register)("lock",60021),mirrorPrivate:(0,h.register)("mirror-private",60021),close:(0,h.register)("close",60022),removeClose:(0,h.register)("remove-close",60022),x:(0,h.register)("x",60022),repoSync:(0,h.register)("repo-sync",60023),sync:(0,h.register)("sync",60023),clone:(0,h.register)("clone",60024),desktopDownload:(0,h.register)("desktop-download",60024),beaker:(0,h.register)("beaker",60025),microscope:(0,h.register)("microscope",60025),vm:(0,h.register)("vm",60026),deviceDesktop:(0,h.register)("device-desktop",60026),file:(0,h.register)("file",60027),fileText:(0,h.register)("file-text",60027),more:(0,h.register)("more",60028),ellipsis:(0,h.register)("ellipsis",60028),kebabHorizontal:(0,h.register)("kebab-horizontal",60028),mailReply:(0,h.register)("mail-reply",60029),reply:(0,h.register)("reply",60029),organization:(0,h.register)("organization",60030),organizationFilled:(0,h.register)("organization-filled",60030),organizationOutline:(0,h.register)("organization-outline",60030),newFile:(0,h.register)("new-file",60031),fileAdd:(0,h.register)("file-add",60031),newFolder:(0,h.register)("new-folder",60032),fileDirectoryCreate:(0,h.register)("file-directory-create",60032),trash:(0,h.register)("trash",60033),trashcan:(0,h.register)("trashcan",60033),history:(0,h.register)("history",60034),clock:(0,h.register)("clock",60034),folder:(0,h.register)("folder",60035),fileDirectory:(0,h.register)("file-directory",60035),symbolFolder:(0,h.register)("symbol-folder",60035),logoGithub:(0,h.register)("logo-github",60036),markGithub:(0,h.register)("mark-github",60036),github:(0,h.register)("github",60036),terminal:(0,h.register)("terminal",60037),console:(0,h.register)("console",60037),repl:(0,h.register)("repl",60037),zap:(0,h.register)("zap",60038),symbolEvent:(0,h.register)("symbol-event",60038),error:(0,h.register)("error",60039),stop:(0,h.register)("stop",60039),variable:(0,h.register)("variable",60040),symbolVariable:(0,h.register)("symbol-variable",60040),array:(0,h.register)("array",60042),symbolArray:(0,h.register)("symbol-array",60042),symbolModule:(0,h.register)("symbol-module",60043),symbolPackage:(0,h.register)("symbol-package",60043),symbolNamespace:(0,h.register)("symbol-namespace",60043),symbolObject:(0,h.register)("symbol-object",60043),symbolMethod:(0,h.register)("symbol-method",60044),symbolFunction:(0,h.register)("symbol-function",60044),symbolConstructor:(0,h.register)("symbol-constructor",60044),symbolBoolean:(0,h.register)("symbol-boolean",60047),symbolNull:(0,h.register)("symbol-null",60047),symbolNumeric:(0,h.register)("symbol-numeric",60048),symbolNumber:(0,h.register)("symbol-number",60048),symbolStructure:(0,h.register)("symbol-structure",60049),symbolStruct:(0,h.register)("symbol-struct",60049),symbolParameter:(0,h.register)("symbol-parameter",60050),symbolTypeParameter:(0,h.register)("symbol-type-parameter",60050),symbolKey:(0,h.register)("symbol-key",60051),symbolText:(0,h.register)("symbol-text",60051),symbolReference:(0,h.register)("symbol-reference",60052),goToFile:(0,h.register)("go-to-file",60052),symbolEnum:(0,h.register)("symbol-enum",60053),symbolValue:(0,h.register)("symbol-value",60053),symbolRuler:(0,h.register)("symbol-ruler",60054),symbolUnit:(0,h.register)("symbol-unit",60054),activateBreakpoints:(0,h.register)("activate-breakpoints",60055),archive:(0,h.register)("archive",60056),arrowBoth:(0,h.register)("arrow-both",60057),arrowDown:(0,h.register)("arrow-down",60058),arrowLeft:(0,h.register)("arrow-left",60059),arrowRight:(0,h.register)("arrow-right",60060),arrowSmallDown:(0,h.register)("arrow-small-down",60061),arrowSmallLeft:(0,h.register)("arrow-small-left",60062),arrowSmallRight:(0,h.register)("arrow-small-right",60063),arrowSmallUp:(0,h.register)("arrow-small-up",60064),arrowUp:(0,h.register)("arrow-up",60065),bell:(0,h.register)("bell",60066),bold:(0,h.register)("bold",60067),book:(0,h.register)("book",60068),bookmark:(0,h.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,h.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,h.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,h.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,h.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,h.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,h.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,h.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,h.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,h.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,h.register)("briefcase",60076),broadcast:(0,h.register)("broadcast",60077),browser:(0,h.register)("browser",60078),bug:(0,h.register)("bug",60079),calendar:(0,h.register)("calendar",60080),caseSensitive:(0,h.register)("case-sensitive",60081),check:(0,h.register)("check",60082),checklist:(0,h.register)("checklist",60083),chevronDown:(0,h.register)("chevron-down",60084),chevronLeft:(0,h.register)("chevron-left",60085),chevronRight:(0,h.register)("chevron-right",60086),chevronUp:(0,h.register)("chevron-up",60087),chromeClose:(0,h.register)("chrome-close",60088),chromeMaximize:(0,h.register)("chrome-maximize",60089),chromeMinimize:(0,h.register)("chrome-minimize",60090),chromeRestore:(0,h.register)("chrome-restore",60091),circleOutline:(0,h.register)("circle-outline",60092),circle:(0,h.register)("circle",60092),debugBreakpointUnverified:(0,h.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,h.register)("terminal-decoration-incomplete",60092),circleSlash:(0,h.register)("circle-slash",60093),circuitBoard:(0,h.register)("circuit-board",60094),clearAll:(0,h.register)("clear-all",60095),clippy:(0,h.register)("clippy",60096),closeAll:(0,h.register)("close-all",60097),cloudDownload:(0,h.register)("cloud-download",60098),cloudUpload:(0,h.register)("cloud-upload",60099),code:(0,h.register)("code",60100),collapseAll:(0,h.register)("collapse-all",60101),colorMode:(0,h.register)("color-mode",60102),commentDiscussion:(0,h.register)("comment-discussion",60103),creditCard:(0,h.register)("credit-card",60105),dash:(0,h.register)("dash",60108),dashboard:(0,h.register)("dashboard",60109),database:(0,h.register)("database",60110),debugContinue:(0,h.register)("debug-continue",60111),debugDisconnect:(0,h.register)("debug-disconnect",60112),debugPause:(0,h.register)("debug-pause",60113),debugRestart:(0,h.register)("debug-restart",60114),debugStart:(0,h.register)("debug-start",60115),debugStepInto:(0,h.register)("debug-step-into",60116),debugStepOut:(0,h.register)("debug-step-out",60117),debugStepOver:(0,h.register)("debug-step-over",60118),debugStop:(0,h.register)("debug-stop",60119),debug:(0,h.register)("debug",60120),deviceCameraVideo:(0,h.register)("device-camera-video",60121),deviceCamera:(0,h.register)("device-camera",60122),deviceMobile:(0,h.register)("device-mobile",60123),diffAdded:(0,h.register)("diff-added",60124),diffIgnored:(0,h.register)("diff-ignored",60125),diffModified:(0,h.register)("diff-modified",60126),diffRemoved:(0,h.register)("diff-removed",60127),diffRenamed:(0,h.register)("diff-renamed",60128),diff:(0,h.register)("diff",60129),diffSidebyside:(0,h.register)("diff-sidebyside",60129),discard:(0,h.register)("discard",60130),editorLayout:(0,h.register)("editor-layout",60131),emptyWindow:(0,h.register)("empty-window",60132),exclude:(0,h.register)("exclude",60133),extensions:(0,h.register)("extensions",60134),eyeClosed:(0,h.register)("eye-closed",60135),fileBinary:(0,h.register)("file-binary",60136),fileCode:(0,h.register)("file-code",60137),fileMedia:(0,h.register)("file-media",60138),filePdf:(0,h.register)("file-pdf",60139),fileSubmodule:(0,h.register)("file-submodule",60140),fileSymlinkDirectory:(0,h.register)("file-symlink-directory",60141),fileSymlinkFile:(0,h.register)("file-symlink-file",60142),fileZip:(0,h.register)("file-zip",60143),files:(0,h.register)("files",60144),filter:(0,h.register)("filter",60145),flame:(0,h.register)("flame",60146),foldDown:(0,h.register)("fold-down",60147),foldUp:(0,h.register)("fold-up",60148),fold:(0,h.register)("fold",60149),folderActive:(0,h.register)("folder-active",60150),folderOpened:(0,h.register)("folder-opened",60151),gear:(0,h.register)("gear",60152),gift:(0,h.register)("gift",60153),gistSecret:(0,h.register)("gist-secret",60154),gist:(0,h.register)("gist",60155),gitCommit:(0,h.register)("git-commit",60156),gitCompare:(0,h.register)("git-compare",60157),compareChanges:(0,h.register)("compare-changes",60157),gitMerge:(0,h.register)("git-merge",60158),githubAction:(0,h.register)("github-action",60159),githubAlt:(0,h.register)("github-alt",60160),globe:(0,h.register)("globe",60161),grabber:(0,h.register)("grabber",60162),graph:(0,h.register)("graph",60163),gripper:(0,h.register)("gripper",60164),heart:(0,h.register)("heart",60165),home:(0,h.register)("home",60166),horizontalRule:(0,h.register)("horizontal-rule",60167),hubot:(0,h.register)("hubot",60168),inbox:(0,h.register)("inbox",60169),issueReopened:(0,h.register)("issue-reopened",60171),issues:(0,h.register)("issues",60172),italic:(0,h.register)("italic",60173),jersey:(0,h.register)("jersey",60174),json:(0,h.register)("json",60175),kebabVertical:(0,h.register)("kebab-vertical",60176),key:(0,h.register)("key",60177),law:(0,h.register)("law",60178),lightbulbAutofix:(0,h.register)("lightbulb-autofix",60179),linkExternal:(0,h.register)("link-external",60180),link:(0,h.register)("link",60181),listOrdered:(0,h.register)("list-ordered",60182),listUnordered:(0,h.register)("list-unordered",60183),liveShare:(0,h.register)("live-share",60184),loading:(0,h.register)("loading",60185),location:(0,h.register)("location",60186),mailRead:(0,h.register)("mail-read",60187),mail:(0,h.register)("mail",60188),markdown:(0,h.register)("markdown",60189),megaphone:(0,h.register)("megaphone",60190),mention:(0,h.register)("mention",60191),milestone:(0,h.register)("milestone",60192),gitPullRequestMilestone:(0,h.register)("git-pull-request-milestone",60192),mortarBoard:(0,h.register)("mortar-board",60193),move:(0,h.register)("move",60194),multipleWindows:(0,h.register)("multiple-windows",60195),mute:(0,h.register)("mute",60196),noNewline:(0,h.register)("no-newline",60197),note:(0,h.register)("note",60198),octoface:(0,h.register)("octoface",60199),openPreview:(0,h.register)("open-preview",60200),package:(0,h.register)("package",60201),paintcan:(0,h.register)("paintcan",60202),pin:(0,h.register)("pin",60203),play:(0,h.register)("play",60204),run:(0,h.register)("run",60204),plug:(0,h.register)("plug",60205),preserveCase:(0,h.register)("preserve-case",60206),preview:(0,h.register)("preview",60207),project:(0,h.register)("project",60208),pulse:(0,h.register)("pulse",60209),question:(0,h.register)("question",60210),quote:(0,h.register)("quote",60211),radioTower:(0,h.register)("radio-tower",60212),reactions:(0,h.register)("reactions",60213),references:(0,h.register)("references",60214),refresh:(0,h.register)("refresh",60215),regex:(0,h.register)("regex",60216),remoteExplorer:(0,h.register)("remote-explorer",60217),remote:(0,h.register)("remote",60218),remove:(0,h.register)("remove",60219),replaceAll:(0,h.register)("replace-all",60220),replace:(0,h.register)("replace",60221),repoClone:(0,h.register)("repo-clone",60222),repoForcePush:(0,h.register)("repo-force-push",60223),repoPull:(0,h.register)("repo-pull",60224),repoPush:(0,h.register)("repo-push",60225),report:(0,h.register)("report",60226),requestChanges:(0,h.register)("request-changes",60227),rocket:(0,h.register)("rocket",60228),rootFolderOpened:(0,h.register)("root-folder-opened",60229),rootFolder:(0,h.register)("root-folder",60230),rss:(0,h.register)("rss",60231),ruby:(0,h.register)("ruby",60232),saveAll:(0,h.register)("save-all",60233),saveAs:(0,h.register)("save-as",60234),save:(0,h.register)("save",60235),screenFull:(0,h.register)("screen-full",60236),screenNormal:(0,h.register)("screen-normal",60237),searchStop:(0,h.register)("search-stop",60238),server:(0,h.register)("server",60240),settingsGear:(0,h.register)("settings-gear",60241),settings:(0,h.register)("settings",60242),shield:(0,h.register)("shield",60243),smiley:(0,h.register)("smiley",60244),sortPrecedence:(0,h.register)("sort-precedence",60245),splitHorizontal:(0,h.register)("split-horizontal",60246),splitVertical:(0,h.register)("split-vertical",60247),squirrel:(0,h.register)("squirrel",60248),starFull:(0,h.register)("star-full",60249),starHalf:(0,h.register)("star-half",60250),symbolClass:(0,h.register)("symbol-class",60251),symbolColor:(0,h.register)("symbol-color",60252),symbolConstant:(0,h.register)("symbol-constant",60253),symbolEnumMember:(0,h.register)("symbol-enum-member",60254),symbolField:(0,h.register)("symbol-field",60255),symbolFile:(0,h.register)("symbol-file",60256),symbolInterface:(0,h.register)("symbol-interface",60257),symbolKeyword:(0,h.register)("symbol-keyword",60258),symbolMisc:(0,h.register)("symbol-misc",60259),symbolOperator:(0,h.register)("symbol-operator",60260),symbolProperty:(0,h.register)("symbol-property",60261),wrench:(0,h.register)("wrench",60261),wrenchSubaction:(0,h.register)("wrench-subaction",60261),symbolSnippet:(0,h.register)("symbol-snippet",60262),tasklist:(0,h.register)("tasklist",60263),telescope:(0,h.register)("telescope",60264),textSize:(0,h.register)("text-size",60265),threeBars:(0,h.register)("three-bars",60266),thumbsdown:(0,h.register)("thumbsdown",60267),thumbsup:(0,h.register)("thumbsup",60268),tools:(0,h.register)("tools",60269),triangleDown:(0,h.register)("triangle-down",60270),triangleLeft:(0,h.register)("triangle-left",60271),triangleRight:(0,h.register)("triangle-right",60272),triangleUp:(0,h.register)("triangle-up",60273),twitter:(0,h.register)("twitter",60274),unfold:(0,h.register)("unfold",60275),unlock:(0,h.register)("unlock",60276),unmute:(0,h.register)("unmute",60277),unverified:(0,h.register)("unverified",60278),verified:(0,h.register)("verified",60279),versions:(0,h.register)("versions",60280),vmActive:(0,h.register)("vm-active",60281),vmOutline:(0,h.register)("vm-outline",60282),vmRunning:(0,h.register)("vm-running",60283),watch:(0,h.register)("watch",60284),whitespace:(0,h.register)("whitespace",60285),wholeWord:(0,h.register)("whole-word",60286),window:(0,h.register)("window",60287),wordWrap:(0,h.register)("word-wrap",60288),zoomIn:(0,h.register)("zoom-in",60289),zoomOut:(0,h.register)("zoom-out",60290),listFilter:(0,h.register)("list-filter",60291),listFlat:(0,h.register)("list-flat",60292),listSelection:(0,h.register)("list-selection",60293),selection:(0,h.register)("selection",60293),listTree:(0,h.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,h.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,h.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,h.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,h.register)("debug-stackframe-active",60297),circleSmallFilled:(0,h.register)("circle-small-filled",60298),debugStackframeDot:(0,h.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,h.register)("terminal-decoration-mark",60298),debugStackframe:(0,h.register)("debug-stackframe",60299),debugStackframeFocused:(0,h.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,h.register)("debug-breakpoint-unsupported",60300),symbolString:(0,h.register)("symbol-string",60301),debugReverseContinue:(0,h.register)("debug-reverse-continue",60302),debugStepBack:(0,h.register)("debug-step-back",60303),debugRestartFrame:(0,h.register)("debug-restart-frame",60304),debugAlt:(0,h.register)("debug-alt",60305),callIncoming:(0,h.register)("call-incoming",60306),callOutgoing:(0,h.register)("call-outgoing",60307),menu:(0,h.register)("menu",60308),expandAll:(0,h.register)("expand-all",60309),feedback:(0,h.register)("feedback",60310),gitPullRequestReviewer:(0,h.register)("git-pull-request-reviewer",60310),groupByRefType:(0,h.register)("group-by-ref-type",60311),ungroupByRefType:(0,h.register)("ungroup-by-ref-type",60312),account:(0,h.register)("account",60313),gitPullRequestAssignee:(0,h.register)("git-pull-request-assignee",60313),bellDot:(0,h.register)("bell-dot",60314),debugConsole:(0,h.register)("debug-console",60315),library:(0,h.register)("library",60316),output:(0,h.register)("output",60317),runAll:(0,h.register)("run-all",60318),syncIgnored:(0,h.register)("sync-ignored",60319),pinned:(0,h.register)("pinned",60320),githubInverted:(0,h.register)("github-inverted",60321),serverProcess:(0,h.register)("server-process",60322),serverEnvironment:(0,h.register)("server-environment",60323),pass:(0,h.register)("pass",60324),issueClosed:(0,h.register)("issue-closed",60324),stopCircle:(0,h.register)("stop-circle",60325),playCircle:(0,h.register)("play-circle",60326),record:(0,h.register)("record",60327),debugAltSmall:(0,h.register)("debug-alt-small",60328),vmConnect:(0,h.register)("vm-connect",60329),cloud:(0,h.register)("cloud",60330),merge:(0,h.register)("merge",60331),export:(0,h.register)("export",60332),graphLeft:(0,h.register)("graph-left",60333),magnet:(0,h.register)("magnet",60334),notebook:(0,h.register)("notebook",60335),redo:(0,h.register)("redo",60336),checkAll:(0,h.register)("check-all",60337),pinnedDirty:(0,h.register)("pinned-dirty",60338),passFilled:(0,h.register)("pass-filled",60339),circleLargeFilled:(0,h.register)("circle-large-filled",60340),circleLarge:(0,h.register)("circle-large",60341),circleLargeOutline:(0,h.register)("circle-large-outline",60341),combine:(0,h.register)("combine",60342),gather:(0,h.register)("gather",60342),table:(0,h.register)("table",60343),variableGroup:(0,h.register)("variable-group",60344),typeHierarchy:(0,h.register)("type-hierarchy",60345),typeHierarchySub:(0,h.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,h.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,h.register)("git-pull-request-create",60348),runAbove:(0,h.register)("run-above",60349),runBelow:(0,h.register)("run-below",60350),notebookTemplate:(0,h.register)("notebook-template",60351),debugRerun:(0,h.register)("debug-rerun",60352),workspaceTrusted:(0,h.register)("workspace-trusted",60353),workspaceUntrusted:(0,h.register)("workspace-untrusted",60354),workspaceUnknown:(0,h.register)("workspace-unknown",60355),terminalCmd:(0,h.register)("terminal-cmd",60356),terminalDebian:(0,h.register)("terminal-debian",60357),terminalLinux:(0,h.register)("terminal-linux",60358),terminalPowershell:(0,h.register)("terminal-powershell",60359),terminalTmux:(0,h.register)("terminal-tmux",60360),terminalUbuntu:(0,h.register)("terminal-ubuntu",60361),terminalBash:(0,h.register)("terminal-bash",60362),arrowSwap:(0,h.register)("arrow-swap",60363),copy:(0,h.register)("copy",60364),personAdd:(0,h.register)("person-add",60365),filterFilled:(0,h.register)("filter-filled",60366),wand:(0,h.register)("wand",60367),debugLineByLine:(0,h.register)("debug-line-by-line",60368),inspect:(0,h.register)("inspect",60369),layers:(0,h.register)("layers",60370),layersDot:(0,h.register)("layers-dot",60371),layersActive:(0,h.register)("layers-active",60372),compass:(0,h.register)("compass",60373),compassDot:(0,h.register)("compass-dot",60374),compassActive:(0,h.register)("compass-active",60375),azure:(0,h.register)("azure",60376),issueDraft:(0,h.register)("issue-draft",60377),gitPullRequestClosed:(0,h.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,h.register)("git-pull-request-draft",60379),debugAll:(0,h.register)("debug-all",60380),debugCoverage:(0,h.register)("debug-coverage",60381),runErrors:(0,h.register)("run-errors",60382),folderLibrary:(0,h.register)("folder-library",60383),debugContinueSmall:(0,h.register)("debug-continue-small",60384),beakerStop:(0,h.register)("beaker-stop",60385),graphLine:(0,h.register)("graph-line",60386),graphScatter:(0,h.register)("graph-scatter",60387),pieChart:(0,h.register)("pie-chart",60388),bracket:(0,h.register)("bracket",60175),bracketDot:(0,h.register)("bracket-dot",60389),bracketError:(0,h.register)("bracket-error",60390),lockSmall:(0,h.register)("lock-small",60391),azureDevops:(0,h.register)("azure-devops",60392),verifiedFilled:(0,h.register)("verified-filled",60393),newline:(0,h.register)("newline",60394),layout:(0,h.register)("layout",60395),layoutActivitybarLeft:(0,h.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,h.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,h.register)("layout-panel-left",60398),layoutPanelCenter:(0,h.register)("layout-panel-center",60399),layoutPanelJustify:(0,h.register)("layout-panel-justify",60400),layoutPanelRight:(0,h.register)("layout-panel-right",60401),layoutPanel:(0,h.register)("layout-panel",60402),layoutSidebarLeft:(0,h.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,h.register)("layout-sidebar-right",60404),layoutStatusbar:(0,h.register)("layout-statusbar",60405),layoutMenubar:(0,h.register)("layout-menubar",60406),layoutCentered:(0,h.register)("layout-centered",60407),target:(0,h.register)("target",60408),indent:(0,h.register)("indent",60409),recordSmall:(0,h.register)("record-small",60410),errorSmall:(0,h.register)("error-small",60411),terminalDecorationError:(0,h.register)("terminal-decoration-error",60411),arrowCircleDown:(0,h.register)("arrow-circle-down",60412),arrowCircleLeft:(0,h.register)("arrow-circle-left",60413),arrowCircleRight:(0,h.register)("arrow-circle-right",60414),arrowCircleUp:(0,h.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,h.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,h.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,h.register)("layout-sidebar-left-off",60418),blank:(0,h.register)("blank",60419),heartFilled:(0,h.register)("heart-filled",60420),map:(0,h.register)("map",60421),mapHorizontal:(0,h.register)("map-horizontal",60421),foldHorizontal:(0,h.register)("fold-horizontal",60421),mapFilled:(0,h.register)("map-filled",60422),mapHorizontalFilled:(0,h.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,h.register)("fold-horizontal-filled",60422),circleSmall:(0,h.register)("circle-small",60423),bellSlash:(0,h.register)("bell-slash",60424),bellSlashDot:(0,h.register)("bell-slash-dot",60425),commentUnresolved:(0,h.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,h.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,h.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,h.register)("search-fuzzy",60429),commentDraft:(0,h.register)("comment-draft",60430),send:(0,h.register)("send",60431),sparkle:(0,h.register)("sparkle",60432),insert:(0,h.register)("insert",60433),mic:(0,h.register)("mic",60434),thumbsdownFilled:(0,h.register)("thumbsdown-filled",60435),thumbsupFilled:(0,h.register)("thumbsup-filled",60436),coffee:(0,h.register)("coffee",60437),snake:(0,h.register)("snake",60438),game:(0,h.register)("game",60439),vr:(0,h.register)("vr",60440),chip:(0,h.register)("chip",60441),piano:(0,h.register)("piano",60442),music:(0,h.register)("music",60443),micFilled:(0,h.register)("mic-filled",60444),repoFetch:(0,h.register)("repo-fetch",60445),copilot:(0,h.register)("copilot",60446),lightbulbSparkle:(0,h.register)("lightbulb-sparkle",60447),robot:(0,h.register)("robot",60448),sparkleFilled:(0,h.register)("sparkle-filled",60449),diffSingle:(0,h.register)("diff-single",60450),diffMultiple:(0,h.register)("diff-multiple",60451),surroundWith:(0,h.register)("surround-with",60452),share:(0,h.register)("share",60453),gitStash:(0,h.register)("git-stash",60454),gitStashApply:(0,h.register)("git-stash-apply",60455),gitStashPop:(0,h.register)("git-stash-pop",60456),vscode:(0,h.register)("vscode",60457),vscodeInsiders:(0,h.register)("vscode-insiders",60458),codeOss:(0,h.register)("code-oss",60459),runCoverage:(0,h.register)("run-coverage",60460),runAllCoverage:(0,h.register)("run-all-coverage",60461),coverage:(0,h.register)("coverage",60462),githubProject:(0,h.register)("github-project",60463),mapVertical:(0,h.register)("map-vertical",60464),foldVertical:(0,h.register)("fold-vertical",60464),mapVerticalFilled:(0,h.register)("map-vertical-filled",60465),foldVerticalFilled:(0,h.register)("fold-vertical-filled",60465),goToSearch:(0,h.register)("go-to-search",60466),percentage:(0,h.register)("percentage",60467),sortPercentage:(0,h.register)("sort-percentage",60467)}}),define(_e[79],Ce([1,0,99,175]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.codiconsDerived=void 0,e.getAllCodicons=L;function L(){return Object.values(e.Codicon)}e.codiconsDerived={dialogError:(0,h.register)("dialog-error","error"),dialogWarning:(0,h.register)("dialog-warning","warning"),dialogInfo:(0,h.register)("dialog-info","info"),dialogClose:(0,h.register)("dialog-close","close"),treeItemExpanded:(0,h.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,h.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,h.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,h.register)("tree-filter-clear","close"),treeItemLoading:(0,h.register)("tree-item-loading","loading"),menuSelection:(0,h.register)("menu-selection","check"),menuSubmenu:(0,h.register)("menu-submenu","chevron-right"),menuBarMore:(0,h.register)("menubar-more","more"),scrollbarButtonLeft:(0,h.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,h.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,h.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,h.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,h.register)("toolbar-more","more"),quickInputBack:(0,h.register)("quick-input-back","arrow-left"),dropDownButton:(0,h.register)("drop-down-button",60084),symbolCustomColor:(0,h.register)("symbol-customcolor",60252),exportIcon:(0,h.register)("export",60332),workspaceUnspecified:(0,h.register)("workspace-unspecified",60355),newLine:(0,h.register)("newline",60394),thumbsDownFilled:(0,h.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,h.register)("thumbsup-filled",60436),gitFetch:(0,h.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,h.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,h.register)("debug-breakpoint-pending",60377)},e.Codicon={...O.codiconsLibrary,...e.codiconsDerived}}),define(_e[24],Ce([1,0,18]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=O,e.deepFreeze=L,e.cloneAndChange=R,e.mixin=m,e.equals=y,e.safeStringify=T,e.distinct=I,e.getCaseInsensitive=p,e.filter=S,e.getAllPropertyNames=E,e.getAllMethodNames=d,e.createProxyObject=f;function O(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const i=Array.isArray(a)?[]:{};return Object.entries(a).forEach(([n,l])=>{i[n]=l&&typeof l=="object"?O(l):l}),i}function L(a){if(!a||typeof a!="object")return a;const i=[a];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const l in n)if(A.call(n,l)){const o=n[l];typeof o=="object"&&!Object.isFrozen(o)&&!(0,h.isTypedArray)(o)&&i.push(o)}}return a}const A=Object.prototype.hasOwnProperty;function R(a,i){return b(a,i,new Set)}function b(a,i,n){if((0,h.isUndefinedOrNull)(a))return a;const l=i(a);if(typeof l<"u")return l;if(Array.isArray(a)){const o=[];for(const t of a)o.push(b(t,i,n));return o}if((0,h.isObject)(a)){if(n.has(a))throw new Error("Cannot clone recursive data-structure");n.add(a);const o={};for(const t in a)A.call(a,t)&&(o[t]=b(a[t],i,n));return n.delete(a),o}return a}function m(a,i,n=!0){return(0,h.isObject)(a)?((0,h.isObject)(i)&&Object.keys(i).forEach(l=>{l in a?n&&((0,h.isObject)(a[l])&&(0,h.isObject)(i[l])?m(a[l],i[l],n):a[l]=i[l]):a[l]=i[l]}),a):i}function y(a,i){if(a===i)return!0;if(a==null||i===null||i===void 0||typeof a!=typeof i||typeof a!="object"||Array.isArray(a)!==Array.isArray(i))return!1;let n,l;if(Array.isArray(a)){if(a.length!==i.length)return!1;for(n=0;n<a.length;n++)if(!y(a[n],i[n]))return!1}else{const o=[];for(l in a)o.push(l);o.sort();const t=[];for(l in i)t.push(l);if(t.sort(),!y(o,t))return!1;for(n=0;n<o.length;n++)if(!y(a[o[n]],i[o[n]]))return!1}return!0}function T(a){const i=new Set;return JSON.stringify(a,(n,l)=>{if((0,h.isObject)(l)||Array.isArray(l)){if(i.has(l))return"[Circular]";i.add(l)}return typeof l=="bigint"?`[BigInt ${l.toString()}]`:l})}function I(a,i){const n=Object.create(null);return!a||!i||Object.keys(i).forEach(o=>{const t=a[o],u=i[o];y(t,u)||(n[o]=u)}),n}function p(a,i){const n=i.toLowerCase(),l=Object.keys(a).find(o=>o.toLowerCase()===n);return l?a[l]:a[i]}function S(a,i){const n=Object.create(null);for(const[l,o]of Object.entries(a))i(l,o)&&(n[l]=o);return n}function E(a){let i=[];for(;Object.prototype!==a;)i=i.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return i}function d(a){const i=[];for(const n of E(a))typeof a[n]=="function"&&i.push(n);return i}function f(a,i){const n=o=>function(){const t=Array.prototype.slice.call(arguments,0);return i(o,t)},l={};for(const o of a)l[o]=n(o);return l}}),define(_e[50],Ce([1,0,79]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.themeColorFromId=L;var O;(function(R){function b(m){return m&&typeof m=="object"&&typeof m.id=="string"}R.isThemeColor=b})(O||(e.ThemeColor=O={}));function L(R){return{id:R}}var A;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function m(i){const n=b.exec(i.id);if(!n)return m(h.Codicon.error);const[,l,o]=n,t=["codicon","codicon-"+l];return o&&t.push("codicon-modifier-"+o.substring(1)),t}R.asClassNameArray=m;function y(i){return m(i).join(" ")}R.asClassName=y;function T(i){return"."+m(i).join(".")}R.asCSSSelector=T;function I(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||O.isThemeColor(i.color))}R.isThemeIcon=I;const p=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function S(i){const n=p.exec(i);if(!n)return;const[,l]=n;return{id:l}}R.fromString=S;function E(i){return{id:i}}R.fromId=E;function d(i,n){let l=i.id;const o=l.lastIndexOf("~");return o!==-1&&(l=l.substring(0,o)),n&&(l=`${l}~${n}`),{id:l}}R.modify=d;function f(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}R.getModifier=f;function a(i,n){return i.id===n.id&&i.color?.id===n.color?.id}R.isEqual=a})(A||(e.ThemeIcon=A={}))}),define(_e[176],Ce([1,0,127,14,50]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.escapeIcons=m,e.markdownEscapeEscapedIcons=T,e.stripIcons=p,e.getCodiconAriaLabel=S,e.parseLabelWithIcons=d,e.matchesFuzzyIconAware=f;const A="$(",R=new RegExp(`\\$\\(${L.ThemeIcon.iconNameExpression}(?:${L.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${R.source}`,"g");function m(a){return a.replace(b,(i,n)=>n?i:`\\${i}`)}const y=new RegExp(`\\\\${R.source}`,"g");function T(a){return a.replace(y,i=>`\\${i}`)}const I=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function p(a){return a.indexOf(A)===-1?a:a.replace(I,(i,n,l,o)=>l?i:n||o||"")}function S(a){return a?a.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}const E=new RegExp(`\\$\\(${L.ThemeIcon.iconNameCharacter}+\\)`,"g");function d(a){E.lastIndex=0;let i="";const n=[];let l=0;for(;;){const o=E.lastIndex,t=E.exec(a),u=a.substring(o,t?.index);if(u.length>0){i+=u;for(let r=0;r<u.length;r++)n.push(l)}if(!t)break;l+=t[0].length}return{text:i,iconOffsets:n}}function f(a,i,n=!1){const{text:l,iconOffsets:o}=i;if(!o||o.length===0)return(0,h.matchesFuzzy)(a,l,n);const t=(0,O.ltrim)(l," "),u=l.length-t.length,r=(0,h.matchesFuzzy)(a,t,n);if(r)for(const c of r){const s=o[c.start+u]+u;c.start+=s,c.end+=s}return r}}),define(_e[128],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=O,e.toUint32=L;var h;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(h||(e.Constants=h={}));function O(A){return A<0?0:A>255?255:A|0}function L(A){return A<0?0:A>4294967295?4294967295:A|0}}),define(_e[30],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=O;const h=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(L){return h.test(L)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(b){for(let m=0;m<b.length;m++)b[m]=Math.floor(Math.random()*256);return b};const A=new Uint8Array(16),R=[];for(let b=0;b<256;b++)R.push(b.toString(16).padStart(2,"0"));return function(){L(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let m=0,y="";return y+=R[A[m++]],y+=R[A[m++]],y+=R[A[m++]],y+=R[A[m++]],y+="-",y+=R[A[m++]],y+=R[A[m++]],y+="-",y+=R[A[m++]],y+=R[A[m++]],y+="-",y+=R[A[m++]],y+=R[A[m++]],y+="-",y+=R[A[m++]],y+=R[A[m++]],y+=R[A[m++]],y+=R[A[m++]],y+=R[A[m++]],y+=R[A[m++]],y}}()}),define(_e[177],Ce([1,0,19,39,30]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=void 0,e.createStringDataTransferItem=A,e.createFileDataTransferItem=R,e.matchesMimeType=y;function A(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}function R(I,p,S){const E={id:(0,L.generateUuid)(),name:I,uri:p,data:S};return{asString:async()=>"",asFile:()=>E,value:void 0}}class b{constructor(){this._entries=new Map}get size(){let p=0;for(const S of this._entries)p++;return p}has(p){return this._entries.has(this.toKey(p))}matches(p){const S=[...this._entries.keys()];return O.Iterable.some(this,([E,d])=>d.asFile())&&S.push("files"),T(m(p),S)}get(p){return this._entries.get(this.toKey(p))?.[0]}append(p,S){const E=this._entries.get(p);E?E.push(S):this._entries.set(this.toKey(p),[S])}replace(p,S){this._entries.set(this.toKey(p),[S])}delete(p){this._entries.delete(this.toKey(p))}*[Symbol.iterator](){for(const[p,S]of this._entries)for(const E of S)yield[p,E]}toKey(p){return m(p)}}e.VSDataTransfer=b;function m(I){return I.toLowerCase()}function y(I,p){return T(m(I),p.map(m))}function T(I,p){if(I==="*/*")return p.length>0;if(p.includes(I))return!0;const S=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[E,d,f]=S;return f==="*"?p.some(a=>a.startsWith(d+"/")):!1}e.UriList=Object.freeze({create:I=>(0,h.distinct)(I.map(p=>p.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.UriList.split(I).filter(p=>!p.startsWith("#"))})}),define(_e[178],Ce([1,0,63]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BROWSER_RESTRICTED_PORTS=void 0,e.findFreePort=O,e.findFreePortFaster=A;function O(b,m,y,T=1){let I=!1;return new Promise(p=>{const S=setTimeout(()=>{if(!I)return I=!0,p(0)},y);L(b,m,T,E=>{if(!I)return I=!0,clearTimeout(S),p(E)})})}function L(b,m,y,T){if(m===0)return T(0);const I=new h.Socket;I.once("connect",()=>(R(I),L(b+y,m-1,y,T))),I.once("data",()=>{}),I.once("error",p=>(R(I),p.code!=="ECONNREFUSED"?L(b+y,m-1,y,T):T(b))),I.connect(b,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(b,m,y,T="127.0.0.1"){let I=!1,p,S=1;const E=h.createServer({pauseOnConnect:!0});function d(f,a){I||(I=!0,E.removeAllListeners(),E.close(),p&&clearTimeout(p),a(f))}return new Promise(f=>{p=setTimeout(()=>{d(0,f)},y),E.on("listening",()=>{d(b,f)}),E.on("error",a=>{a&&(a.code==="EADDRINUSE"||a.code==="EACCES")&&S<m?(b++,S++,E.listen(b,T)):d(0,f)}),E.on("close",()=>{d(0,f)}),E.listen(b,T)})}function R(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(m){console.error(m)}}}),define(_e[129],Ce([1,0,128]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class O{constructor(b){const m=(0,h.toUint8)(b);this._defaultValue=m,this._asciiMap=O._createAsciiMap(m),this._map=new Map}static _createAsciiMap(b){const m=new Uint8Array(256);return m.fill(b),m}set(b,m){const y=(0,h.toUint8)(m);b>=0&&b<256?this._asciiMap[b]=y:this._map.set(b,y)}get(b){return b>=0&&b<256?this._asciiMap[b]:this._map.get(b)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=O;var L;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(L||(L={}));class A{constructor(){this._actual=new O(0)}add(b){this._actual.set(b,1)}has(b){return this._actual.get(b)===1}clear(){return this._actual.clear()}}e.CharacterSet=A}),define(_e[179],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.countEOL=O;var h;(function(L){L[L.Unknown=0]="Unknown",L[L.Invalid=3]="Invalid",L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(h||(e.StringEOL=h={}));function O(L){let A=0,R=0,b=0,m=0;for(let y=0,T=L.length;y<T;y++){const I=L.charCodeAt(y);I===13?(A===0&&(R=y),A++,y+1<T&&L.charCodeAt(y+1)===10?(m|=2,y++):m|=3,b=y+1):I===10&&(m|=1,A===0&&(R=y),A++,b=y+1)}return A===0&&(R=L.length),[A,R,L.length-b,m]}}),define(_e[51],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class h{constructor(L,A){this.lineNumber=L,this.column=A}with(L=this.lineNumber,A=this.column){return L===this.lineNumber&&A===this.column?this:new h(L,A)}delta(L=0,A=0){return this.with(this.lineNumber+L,this.column+A)}equals(L){return h.equals(this,L)}static equals(L,A){return!L&&!A?!0:!!L&&!!A&&L.lineNumber===A.lineNumber&&L.column===A.column}isBefore(L){return h.isBefore(this,L)}static isBefore(L,A){return L.lineNumber<A.lineNumber?!0:A.lineNumber<L.lineNumber?!1:L.column<A.column}isBeforeOrEqual(L){return h.isBeforeOrEqual(this,L)}static isBeforeOrEqual(L,A){return L.lineNumber<A.lineNumber?!0:A.lineNumber<L.lineNumber?!1:L.column<=A.column}static compare(L,A){const R=L.lineNumber|0,b=A.lineNumber|0;if(R===b){const m=L.column|0,y=A.column|0;return m-y}return R-b}clone(){return new h(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(L){return new h(L.lineNumber,L.column)}static isIPosition(L){return L&&typeof L.lineNumber=="number"&&typeof L.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.Position=h}),define(_e[29],Ce([1,0,51]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class O{constructor(A,R,b,m){A>b||A===b&&R>m?(this.startLineNumber=b,this.startColumn=m,this.endLineNumber=A,this.endColumn=R):(this.startLineNumber=A,this.startColumn=R,this.endLineNumber=b,this.endColumn=m)}isEmpty(){return O.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return O.containsPosition(this,A)}static containsPosition(A,R){return!(R.lineNumber<A.startLineNumber||R.lineNumber>A.endLineNumber||R.lineNumber===A.startLineNumber&&R.column<A.startColumn||R.lineNumber===A.endLineNumber&&R.column>A.endColumn)}static strictContainsPosition(A,R){return!(R.lineNumber<A.startLineNumber||R.lineNumber>A.endLineNumber||R.lineNumber===A.startLineNumber&&R.column<=A.startColumn||R.lineNumber===A.endLineNumber&&R.column>=A.endColumn)}containsRange(A){return O.containsRange(this,A)}static containsRange(A,R){return!(R.startLineNumber<A.startLineNumber||R.endLineNumber<A.startLineNumber||R.startLineNumber>A.endLineNumber||R.endLineNumber>A.endLineNumber||R.startLineNumber===A.startLineNumber&&R.startColumn<A.startColumn||R.endLineNumber===A.endLineNumber&&R.endColumn>A.endColumn)}strictContainsRange(A){return O.strictContainsRange(this,A)}static strictContainsRange(A,R){return!(R.startLineNumber<A.startLineNumber||R.endLineNumber<A.startLineNumber||R.startLineNumber>A.endLineNumber||R.endLineNumber>A.endLineNumber||R.startLineNumber===A.startLineNumber&&R.startColumn<=A.startColumn||R.endLineNumber===A.endLineNumber&&R.endColumn>=A.endColumn)}plusRange(A){return O.plusRange(this,A)}static plusRange(A,R){let b,m,y,T;return R.startLineNumber<A.startLineNumber?(b=R.startLineNumber,m=R.startColumn):R.startLineNumber===A.startLineNumber?(b=R.startLineNumber,m=Math.min(R.startColumn,A.startColumn)):(b=A.startLineNumber,m=A.startColumn),R.endLineNumber>A.endLineNumber?(y=R.endLineNumber,T=R.endColumn):R.endLineNumber===A.endLineNumber?(y=R.endLineNumber,T=Math.max(R.endColumn,A.endColumn)):(y=A.endLineNumber,T=A.endColumn),new O(b,m,y,T)}intersectRanges(A){return O.intersectRanges(this,A)}static intersectRanges(A,R){let b=A.startLineNumber,m=A.startColumn,y=A.endLineNumber,T=A.endColumn;const I=R.startLineNumber,p=R.startColumn,S=R.endLineNumber,E=R.endColumn;return b<I?(b=I,m=p):b===I&&(m=Math.max(m,p)),y>S?(y=S,T=E):y===S&&(T=Math.min(T,E)),b>y||b===y&&m>T?null:new O(b,m,y,T)}equalsRange(A){return O.equalsRange(this,A)}static equalsRange(A,R){return!A&&!R?!0:!!A&&!!R&&A.startLineNumber===R.startLineNumber&&A.startColumn===R.startColumn&&A.endLineNumber===R.endLineNumber&&A.endColumn===R.endColumn}getEndPosition(){return O.getEndPosition(this)}static getEndPosition(A){return new h.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return O.getStartPosition(this)}static getStartPosition(A){return new h.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,R){return new O(this.startLineNumber,this.startColumn,A,R)}setStartPosition(A,R){return new O(A,R,this.endLineNumber,this.endColumn)}collapseToStart(){return O.collapseToStart(this)}static collapseToStart(A){return new O(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return O.collapseToEnd(this)}static collapseToEnd(A){return new O(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new O(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,R=A){return new O(A.lineNumber,A.column,R.lineNumber,R.column)}static lift(A){return A?new O(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,R){return!(A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<R.startColumn||R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<A.startColumn)}static areIntersecting(A,R){return!(A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<=R.startColumn||R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,R){if(A&&R){const y=A.startLineNumber|0,T=R.startLineNumber|0;if(y===T){const I=A.startColumn|0,p=R.startColumn|0;if(I===p){const S=A.endLineNumber|0,E=R.endLineNumber|0;if(S===E){const d=A.endColumn|0,f=R.endColumn|0;return d-f}return S-E}return I-p}return y-T}return(A?1:0)-(R?1:0)}static compareRangesUsingEnds(A,R){return A.endLineNumber===R.endLineNumber?A.endColumn===R.endColumn?A.startLineNumber===R.startLineNumber?A.startColumn-R.startColumn:A.startLineNumber-R.startLineNumber:A.endColumn-R.endColumn:A.endLineNumber-R.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=O}),define(_e[180],Ce([1,0,29]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditOperation=void 0;class O{static insert(A,R){return{range:new h.Range(A.lineNumber,A.column,A.lineNumber,A.column),text:R,forceMoveMarkers:!0}}static delete(A){return{range:A,text:null}}static replace(A,R){return{range:A,text:R}}static replaceMove(A,R){return{range:A,text:R,forceMoveMarkers:!0}}}e.EditOperation=O}),define(_e[181],Ce([1,0,51,29]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var L;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(L||(e.SelectionDirection=L={}));class A extends O.Range{constructor(b,m,y,T){super(b,m,y,T),this.selectionStartLineNumber=b,this.selectionStartColumn=m,this.positionLineNumber=y,this.positionColumn=T}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return A.selectionsEqual(this,b)}static selectionsEqual(b,m){return b.selectionStartLineNumber===m.selectionStartLineNumber&&b.selectionStartColumn===m.selectionStartColumn&&b.positionLineNumber===m.positionLineNumber&&b.positionColumn===m.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,m){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,b,m):new A(b,m,this.startLineNumber,this.startColumn)}getPosition(){return new h.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new h.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,m){return this.getDirection()===0?new A(b,m,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,b,m)}static fromPositions(b,m=b){return new A(b.lineNumber,b.column,m.lineNumber,m.column)}static fromRange(b,m){return m===0?new A(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new A(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new A(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,m){if(b&&!m||!b&&m)return!1;if(!b&&!m)return!0;if(b.length!==m.length)return!1;for(let y=0,T=b.length;y<T;y++)if(!this.selectionsEqual(b[y],m[y]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,m,y,T,I){return I===0?new A(b,m,y,T):new A(y,T,b,m)}}e.Selection=A}),define(_e[182],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(_e[183],Ce([1,0,27,129]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WordCharacterClassifier=e.WordCharacterClass=void 0,e.getMapForWordSeparators=b;var L;(function(m){m[m.Regular=0]="Regular",m[m.Whitespace=1]="Whitespace",m[m.WordSeparator=2]="WordSeparator"})(L||(e.WordCharacterClass=L={}));class A extends O.CharacterClassifier{constructor(y,T){super(0),this._segmenter=null,this._cachedLine=null,this._cachedSegments=[],this.intlSegmenterLocales=T,this.intlSegmenterLocales.length>0?this._segmenter=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this._segmenter=null;for(let I=0,p=y.length;I<p;I++)this.set(y.charCodeAt(I),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(y,T){let I=null;for(const p of this._getIntlSegmenterWordsOnLine(y)){if(p.index>T)break;I=p}return I}findNextIntlWordAtOrAfterOffset(y,T){for(const I of this._getIntlSegmenterWordsOnLine(y))if(!(I.index<T))return I;return null}_getIntlSegmenterWordsOnLine(y){return this._segmenter?this._cachedLine===y?this._cachedSegments:(this._cachedLine=y,this._cachedSegments=this._filterWordSegments(this._segmenter.segment(y)),this._cachedSegments):[]}_filterWordSegments(y){const T=[];for(const I of y)this._isWordLike(I)&&T.push(I);return T}_isWordLike(y){return!!y.isWordLike}}e.WordCharacterClassifier=A;const R=new h.LRUCache(10);function b(m,y){const T=`${m}/${y.join(",")}`;let I=R.get(T);return I||(I=new A(m,y),R.set(T,I)),I}}),define(_e[130],Ce([1,0,39,3,76]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.ensureValidWordDefinition=R,e.setDefaultGetWordAtTextConfig=m,e.getWordAtText=y,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(I=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const S of e.USUAL_WORD_SEPARATORS)I.indexOf(S)>=0||(p+="\\"+S);return p+="\\s]+)",new RegExp(p,"g")}e.DEFAULT_WORD_REGEXP=A();function R(I){let p=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)p=I;else{let S="g";I.ignoreCase&&(S+="i"),I.multiline&&(S+="m"),I.unicode&&(S+="u"),p=new RegExp(I.source,S)}return p.lastIndex=0,p}const b=new L.LinkedList;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function m(I){const p=b.unshift(I);return(0,O.toDisposable)(p)}function y(I,p,S,E,d){if(p=R(p),d||(d=h.Iterable.first(b)),S.length>d.maxLen){let l=I-d.maxLen/2;return l<0?l=0:E+=l,S=S.substring(l,I+d.maxLen/2),y(I,p,S,E,d)}const f=Date.now(),a=I-1-E;let i=-1,n=null;for(let l=1;!(Date.now()-f>=d.timeBudget);l++){const o=a-d.windowSize*l;p.lastIndex=Math.max(0,o);const t=T(p,S,a,i);if(!t&&n||(n=t,o<=0))break;i=o}if(n){const l={word:n[0],startColumn:E+1+n.index,endColumn:E+1+n.index+n[0].length};return p.lastIndex=0,l}return null}function T(I,p,S,E){let d;for(;d=I.exec(p);){const f=d.index||0;if(f<=S&&I.lastIndex>=S)return d;if(E>0&&f>E)return null}return null}}),define(_e[184],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var h;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(h||(e.IndentAction=h={}));class O{constructor(b){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=b.open,this.close=b.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(b.notIn))for(let m=0,y=b.notIn.length;m<y;m++)switch(b.notIn[m]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(b,m){if(b.getTokenCount()===0)return!0;const y=b.findTokenIndexAtOffset(m-2),T=b.getStandardTokenType(y);return this.isOK(T)}_findNeutralCharacterInRange(b,m){for(let y=b;y<=m;y++){const T=String.fromCharCode(y);if(!this.open.includes(T)&&!this.close.includes(T))return T}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=O;class L{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const m of b)A(this.autoClosingPairsOpenByStart,m.open.charAt(0),m),A(this.autoClosingPairsOpenByEnd,m.open.charAt(m.open.length-1),m),A(this.autoClosingPairsCloseByStart,m.close.charAt(0),m),A(this.autoClosingPairsCloseByEnd,m.close.charAt(m.close.length-1),m),m.close.length===1&&m.open.length===1&&A(this.autoClosingPairsCloseSingleChar,m.close,m)}}e.AutoClosingPairs=L;function A(R,b,m){R.has(b)?R.get(b).push(m):R.set(b,[m])}}),define(_e[185],Ce([1,0,129]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkComputer=e.StateMachine=e.State=void 0,e.computeLinks=p;var O;(function(S){S[S.Invalid=0]="Invalid",S[S.Start=1]="Start",S[S.H=2]="H",S[S.HT=3]="HT",S[S.HTT=4]="HTT",S[S.HTTP=5]="HTTP",S[S.F=6]="F",S[S.FI=7]="FI",S[S.FIL=8]="FIL",S[S.BeforeColon=9]="BeforeColon",S[S.AfterColon=10]="AfterColon",S[S.AlmostThere=11]="AlmostThere",S[S.End=12]="End",S[S.Accept=13]="Accept",S[S.LastKnownState=14]="LastKnownState"})(O||(e.State=O={}));class L{constructor(E,d,f){const a=new Uint8Array(E*d);for(let i=0,n=E*d;i<n;i++)a[i]=f;this._data=a,this.rows=E,this.cols=d}get(E,d){return this._data[E*this.cols+d]}set(E,d,f){this._data[E*this.cols+d]=f}}class A{constructor(E){let d=0,f=0;for(let i=0,n=E.length;i<n;i++){const[l,o,t]=E[i];o>d&&(d=o),l>f&&(f=l),t>f&&(f=t)}d++,f++;const a=new L(f,d,0);for(let i=0,n=E.length;i<n;i++){const[l,o,t]=E[i];a.set(l,o,t)}this._states=a,this._maxCharCode=d}nextState(E,d){return d<0||d>=this._maxCharCode?0:this._states.get(E,d)}}e.StateMachine=A;let R=null;function b(){return R===null&&(R=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var m;(function(S){S[S.None=0]="None",S[S.ForceTermination=1]="ForceTermination",S[S.CannotEndIn=2]="CannotEndIn"})(m||(m={}));let y=null;function T(){if(y===null){y=new h.CharacterClassifier(0);const S=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<S.length;d++)y.set(S.charCodeAt(d),1);const E=".,;:";for(let d=0;d<E.length;d++)y.set(E.charCodeAt(d),2)}return y}class I{static _createLink(E,d,f,a,i){let n=i-1;do{const l=d.charCodeAt(n);if(E.get(l)!==2)break;n--}while(n>a);if(a>0){const l=d.charCodeAt(a-1),o=d.charCodeAt(n);(l===40&&o===41||l===91&&o===93||l===123&&o===125)&&n--}return{range:{startLineNumber:f,startColumn:a+1,endLineNumber:f,endColumn:n+2},url:d.substring(a,n+1)}}static computeLinks(E,d=b()){const f=T(),a=[];for(let i=1,n=E.getLineCount();i<=n;i++){const l=E.getLineContent(i),o=l.length;let t=0,u=0,r=0,c=1,s=!1,w=!1,g=!1,D=!1;for(;t<o;){let v=!1;const _=l.charCodeAt(t);if(c===13){let C;switch(_){case 40:s=!0,C=0;break;case 41:C=s?0:1;break;case 91:g=!0,w=!0,C=0;break;case 93:g=!1,C=w?0:1;break;case 123:D=!0,C=0;break;case 125:C=D?0:1;break;case 39:case 34:case 96:r===_?C=1:r===39||r===34||r===96?C=0:C=1;break;case 42:C=r===42?1:0;break;case 124:C=r===124?1:0;break;case 32:C=g?0:1;break;default:C=f.get(_)}C===1&&(a.push(I._createLink(f,l,i,u,t)),v=!0)}else if(c===12){let C;_===91?(w=!0,C=0):C=f.get(_),C===1?v=!0:c=13}else c=d.nextState(c,_),c===0&&(v=!0);v&&(c=1,s=!1,w=!1,D=!1,u=t+1,r=_),t++}c===13&&a.push(I._createLink(f,l,i,u,o))}return a}}e.LinkComputer=I;function p(S){return!S||typeof S.getLineCount!="function"||typeof S.getLineContent!="function"?[]:I.computeLinks(S)}}),define(_e[80],Ce([1,0,24]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.isITextSnapshot=E,e.shouldSynchronizeModel=l;var O;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(O||(e.OverviewRulerLane=O={}));var L;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=3]="Right"})(L||(e.GlyphMarginLane=L={}));var A;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(A||(e.MinimapPosition=A={}));var R;(function(o){o[o.Normal=1]="Normal",o[o.Underlined=2]="Underlined"})(R||(e.MinimapSectionHeaderStyle=R={}));var b;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(b||(e.InjectedTextCursorStops=b={}));var m;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(m||(e.EndOfLinePreference=m={}));var y;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(y||(e.DefaultEndOfLine=y={}));var T;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(T||(e.EndOfLineSequence=T={}));class I{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,t.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this._indentSizeIsTabSize===t._indentSizeIsTabSize&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,h.equals)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class p{constructor(t,u){this._findMatchBrand=void 0,this.range=t,this.matches=u}}e.FindMatch=p;var S;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(S||(e.TrackedRangeStickiness=S={}));function E(o){return o&&typeof o.read=="function"}var d;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(d||(e.PositionAffinity=d={}));var f;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(f||(e.ModelConstants=f={}));class a{constructor(t,u,r,c,s,w){this.identifier=t,this.range=u,this.text=r,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=s,this._isTracked=w}}e.ValidAnnotatedEditOperation=a;class i{constructor(t,u,r){this.regex=t,this.wordSeparators=u,this.simpleSearch=r}}e.SearchData=i;class n{constructor(t,u,r){this.reverseEdits=t,this.changes=u,this.trimAutoWhitespaceLineNumbers=r}}e.ApplyEditsResult=n;function l(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}}),define(_e[186],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SENTINEL=e.NodeColor=e.TreeNode=void 0,e.leftest=L,e.righttest=A,e.leftRotate=y,e.rightRotate=T,e.rbDelete=I,e.fixInsert=p,e.updateTreeMetadata=S,e.recomputeTreeMetadata=E;class h{constructor(f,a){this.piece=f,this.color=a,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.SENTINEL)return L(this.right);let f=this;for(;f.parent!==e.SENTINEL&&f.parent.left!==f;)f=f.parent;return f.parent===e.SENTINEL?e.SENTINEL:f.parent}prev(){if(this.left!==e.SENTINEL)return A(this.left);let f=this;for(;f.parent!==e.SENTINEL&&f.parent.right!==f;)f=f.parent;return f.parent===e.SENTINEL?e.SENTINEL:f.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.TreeNode=h;var O;(function(d){d[d.Black=0]="Black",d[d.Red=1]="Red"})(O||(e.NodeColor=O={})),e.SENTINEL=new h(null,0),e.SENTINEL.parent=e.SENTINEL,e.SENTINEL.left=e.SENTINEL,e.SENTINEL.right=e.SENTINEL,e.SENTINEL.color=0;function L(d){for(;d.left!==e.SENTINEL;)d=d.left;return d}function A(d){for(;d.right!==e.SENTINEL;)d=d.right;return d}function R(d){return d===e.SENTINEL?0:d.size_left+d.piece.length+R(d.right)}function b(d){return d===e.SENTINEL?0:d.lf_left+d.piece.lineFeedCnt+b(d.right)}function m(){e.SENTINEL.parent=e.SENTINEL}function y(d,f){const a=f.right;a.size_left+=f.size_left+(f.piece?f.piece.length:0),a.lf_left+=f.lf_left+(f.piece?f.piece.lineFeedCnt:0),f.right=a.left,a.left!==e.SENTINEL&&(a.left.parent=f),a.parent=f.parent,f.parent===e.SENTINEL?d.root=a:f.parent.left===f?f.parent.left=a:f.parent.right=a,a.left=f,f.parent=a}function T(d,f){const a=f.left;f.left=a.right,a.right!==e.SENTINEL&&(a.right.parent=f),a.parent=f.parent,f.size_left-=a.size_left+(a.piece?a.piece.length:0),f.lf_left-=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),f.parent===e.SENTINEL?d.root=a:f===f.parent.right?f.parent.right=a:f.parent.left=a,a.right=f,f.parent=a}function I(d,f){let a,i;if(f.left===e.SENTINEL?(i=f,a=i.right):f.right===e.SENTINEL?(i=f,a=i.left):(i=L(f.right),a=i.right),i===d.root){d.root=a,a.color=0,f.detach(),m(),d.root.parent=e.SENTINEL;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=a:i.parent.right=a,i===f?(a.parent=i.parent,E(d,a)):(i.parent===f?a.parent=i:a.parent=i.parent,E(d,a),i.left=f.left,i.right=f.right,i.parent=f.parent,i.color=f.color,f===d.root?d.root=i:f===f.parent.left?f.parent.left=i:f.parent.right=i,i.left!==e.SENTINEL&&(i.left.parent=i),i.right!==e.SENTINEL&&(i.right.parent=i),i.size_left=f.size_left,i.lf_left=f.lf_left,E(d,i)),f.detach(),a.parent.left===a){const o=R(a),t=b(a);if(o!==a.parent.size_left||t!==a.parent.lf_left){const u=o-a.parent.size_left,r=t-a.parent.lf_left;a.parent.size_left=o,a.parent.lf_left=t,S(d,a.parent,u,r)}}if(E(d,a.parent),n){m();return}let l;for(;a!==d.root&&a.color===0;)a===a.parent.left?(l=a.parent.right,l.color===1&&(l.color=0,a.parent.color=1,y(d,a.parent),l=a.parent.right),l.left.color===0&&l.right.color===0?(l.color=1,a=a.parent):(l.right.color===0&&(l.left.color=0,l.color=1,T(d,l),l=a.parent.right),l.color=a.parent.color,a.parent.color=0,l.right.color=0,y(d,a.parent),a=d.root)):(l=a.parent.left,l.color===1&&(l.color=0,a.parent.color=1,T(d,a.parent),l=a.parent.left),l.left.color===0&&l.right.color===0?(l.color=1,a=a.parent):(l.left.color===0&&(l.right.color=0,l.color=1,y(d,l),l=a.parent.left),l.color=a.parent.color,a.parent.color=0,l.left.color=0,T(d,a.parent),a=d.root));a.color=0,m()}function p(d,f){for(E(d,f);f!==d.root&&f.parent.color===1;)if(f.parent===f.parent.parent.left){const a=f.parent.parent.right;a.color===1?(f.parent.color=0,a.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.right&&(f=f.parent,y(d,f)),f.parent.color=0,f.parent.parent.color=1,T(d,f.parent.parent))}else{const a=f.parent.parent.left;a.color===1?(f.parent.color=0,a.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.left&&(f=f.parent,T(d,f)),f.parent.color=0,f.parent.parent.color=1,y(d,f.parent.parent))}d.root.color=0}function S(d,f,a,i){for(;f!==d.root&&f!==e.SENTINEL;)f.parent.left===f&&(f.parent.size_left+=a,f.parent.lf_left+=i),f=f.parent}function E(d,f){let a=0,i=0;if(f!==d.root){for(;f!==d.root&&f===f.parent.right;)f=f.parent;if(f!==d.root)for(f=f.parent,a=R(f.left)-f.size_left,i=b(f.left)-f.lf_left,f.size_left+=a,f.lf_left+=i;f!==d.root&&(a!==0||i!==0);)f.parent.left===f&&(f.parent.size_left+=a,f.parent.lf_left+=i),f=f.parent}}}),define(_e[187],Ce([1,0,19,128]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class L{constructor(m){this.values=m,this.prefixSum=new Uint32Array(m.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(m,y){m=(0,O.toUint32)(m);const T=this.values,I=this.prefixSum,p=y.length;return p===0?!1:(this.values=new Uint32Array(T.length+p),this.values.set(T.subarray(0,m),0),this.values.set(T.subarray(m),m+p),this.values.set(y,m),m-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=m-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(m,y){return m=(0,O.toUint32)(m),y=(0,O.toUint32)(y),this.values[m]===y?!1:(this.values[m]=y,m-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=m-1),!0)}removeValues(m,y){m=(0,O.toUint32)(m),y=(0,O.toUint32)(y);const T=this.values,I=this.prefixSum;if(m>=T.length)return!1;const p=T.length-m;return y>=p&&(y=p),y===0?!1:(this.values=new Uint32Array(T.length-y),this.values.set(T.subarray(0,m),0),this.values.set(T.subarray(m+y),m),this.prefixSum=new Uint32Array(this.values.length),m-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=m-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(m){return m<0?0:(m=(0,O.toUint32)(m),this._getPrefixSum(m))}_getPrefixSum(m){if(m<=this.prefixSumValidIndex[0])return this.prefixSum[m];let y=this.prefixSumValidIndex[0]+1;y===0&&(this.prefixSum[0]=this.values[0],y++),m>=this.values.length&&(m=this.values.length-1);for(let T=y;T<=m;T++)this.prefixSum[T]=this.prefixSum[T-1]+this.values[T];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],m),this.prefixSum[m]}getIndexOf(m){m=Math.floor(m),this.getTotalSum();let y=0,T=this.values.length-1,I=0,p=0,S=0;for(;y<=T;)if(I=y+(T-y)/2|0,p=this.prefixSum[I],S=p-this.values[I],m<S)T=I-1;else if(m>=p)y=I+1;else break;return new R(I,m-S)}}e.PrefixSumComputer=L;class A{constructor(m){this._values=m,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(m){return this._ensureValid(),m===0?0:this._prefixSum[m-1]}getIndexOf(m){this._ensureValid();const y=this._indexBySum[m],T=y>0?this._prefixSum[y-1]:0;return new R(y,m-T)}removeValues(m,y){this._values.splice(m,y),this._invalidate(m)}insertValues(m,y){this._values=(0,h.arrayInsert)(this._values,m,y),this._invalidate(m)}_invalidate(m){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,m-1)}_ensureValid(){if(!this._isValid){for(let m=this._validEndIndex+1,y=this._values.length;m<y;m++){const T=this._values[m],I=m>0?this._prefixSum[m-1]:0;this._prefixSum[m]=I+T;for(let p=0;p<T;p++)this._indexBySum[I+p]=m}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(m,y){this._values[m]!==y&&(this._values[m]=y,this._invalidate(m))}}e.ConstantTimePrefixSumComputer=A;class R{constructor(m,y){this.index=m,this.remainder=y,this._prefixSumIndexOfResultBrand=void 0,this.index=m,this.remainder=y}}e.PrefixSumIndexOfResult=R}),define(_e[188],Ce([1,0,14,51,187]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(b,m,y,T){this._uri=b,this._lines=m,this._eol=y,this._versionId=T,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(b){b.eol&&b.eol!==this._eol&&(this._eol=b.eol,this._lineStarts=null);const m=b.changes;for(const y of m)this._acceptDeleteRange(y.range),this._acceptInsertText(new O.Position(y.range.startLineNumber,y.range.startColumn),y.text);this._versionId=b.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const b=this._eol.length,m=this._lines.length,y=new Uint32Array(m);for(let T=0;T<m;T++)y[T]=this._lines[T].length+b;this._lineStarts=new L.PrefixSumComputer(y)}}_setLineText(b,m){this._lines[b]=m,this._lineStarts&&this._lineStarts.setValue(b,this._lines[b].length+this._eol.length)}_acceptDeleteRange(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this._setLineText(b.startLineNumber-1,this._lines[b.startLineNumber-1].substring(0,b.startColumn-1)+this._lines[b.startLineNumber-1].substring(b.endColumn-1));return}this._setLineText(b.startLineNumber-1,this._lines[b.startLineNumber-1].substring(0,b.startColumn-1)+this._lines[b.endLineNumber-1].substring(b.endColumn-1)),this._lines.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}_acceptInsertText(b,m){if(m.length===0)return;const y=(0,h.splitLines)(m);if(y.length===1){this._setLineText(b.lineNumber-1,this._lines[b.lineNumber-1].substring(0,b.column-1)+y[0]+this._lines[b.lineNumber-1].substring(b.column-1));return}y[y.length-1]+=this._lines[b.lineNumber-1].substring(b.column-1),this._setLineText(b.lineNumber-1,this._lines[b.lineNumber-1].substring(0,b.column-1)+y[0]);const T=new Uint32Array(y.length-1);for(let I=1;I<y.length;I++)this._lines.splice(b.lineNumber+I-1,0,y[I]),T[I-1]=y[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(b.lineNumber,T)}}e.MirrorTextModel=A}),define(_e[100],Ce([1,0,14,183,51,29,80]),function(ue,e,h,O,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.TextModelSearch=e.SearchParams=void 0,e.isMultilineRegexSource=y,e.createFindMatch=T,e.isValidMatch=d;const b=999;class m{constructor(i,n,l,o){this.searchString=i,this.isRegex=n,this.matchCase=l,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=y(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=h.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let l=!this.isRegex&&!i;return l&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(l=this.matchCase),new R.SearchData(n,this.wordSeparators?(0,O.getMapForWordSeparators)(this.wordSeparators,[]):null,l?this.searchString:null)}}e.SearchParams=m;function y(a){if(!a||a.length===0)return!1;for(let i=0,n=a.length;i<n;i++){const l=a.charCodeAt(i);if(l===10)return!0;if(l===92){if(i++,i>=n)break;const o=a.charCodeAt(i);if(o===110||o===114||o===87)return!0}}return!1}function T(a,i,n){if(!n)return new R.FindMatch(a,null);const l=[];for(let o=0,t=i.length;o<t;o++)l[o]=i[o];return new R.FindMatch(a,l)}class I{constructor(i){const n=[];let l=0;for(let o=0,t=i.length;o<t;o++)i.charCodeAt(o)===10&&(n[l++]=o);this._lineFeedsOffsets=n}findLineFeedCountBeforeOffset(i){const n=this._lineFeedsOffsets;let l=0,o=n.length-1;if(o===-1||i<=n[0])return 0;for(;l<o;){const t=l+((o-l)/2>>0);n[t]>=i?o=t-1:n[t+1]>=i?(l=t,o=t):l=t+1}return l+1}}class p{static findMatches(i,n,l,o,t){const u=n.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(i,l,new f(u.wordSeparators,u.regex),o,t):this._doFindMatchesLineByLine(i,l,u,o,t):[]}static _getMultilineMatchRange(i,n,l,o,t,u){let r,c=0;o?(c=o.findLineFeedCountBeforeOffset(t),r=n+t+c):r=n+t;let s;if(o){const v=o.findLineFeedCountBeforeOffset(t+u.length)-c;s=r+u.length+v}else s=r+u.length;const w=i.getPositionAt(r),g=i.getPositionAt(s);return new A.Range(w.lineNumber,w.column,g.lineNumber,g.column)}static _doFindMatchesMultiline(i,n,l,o,t){const u=i.getOffsetAt(n.getStartPosition()),r=i.getValueInRange(n,1),c=i.getEOL()===`\r
`?new I(r):null,s=[];let w=0,g;for(l.reset(0);g=l.next(r);)if(s[w++]=T(this._getMultilineMatchRange(i,u,r,c,g.index,g[0]),g,o),w>=t)return s;return s}static _doFindMatchesLineByLine(i,n,l,o,t){const u=[];let r=0;if(n.startLineNumber===n.endLineNumber){const s=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return r=this._findMatchesInLine(l,s,n.startLineNumber,n.startColumn-1,r,u,o,t),u}const c=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);r=this._findMatchesInLine(l,c,n.startLineNumber,n.startColumn-1,r,u,o,t);for(let s=n.startLineNumber+1;s<n.endLineNumber&&r<t;s++)r=this._findMatchesInLine(l,i.getLineContent(s),s,0,r,u,o,t);if(r<t){const s=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);r=this._findMatchesInLine(l,s,n.endLineNumber,0,r,u,o,t)}return u}static _findMatchesInLine(i,n,l,o,t,u,r,c){const s=i.wordSeparators;if(!r&&i.simpleSearch){const D=i.simpleSearch,v=D.length,_=n.length;let C=-v;for(;(C=n.indexOf(D,C+v))!==-1;)if((!s||d(s,n,_,C,v))&&(u[t++]=new R.FindMatch(new A.Range(l,C+1+o,l,C+1+v+o),null),t>=c))return t;return t}const w=new f(i.wordSeparators,i.regex);let g;w.reset(0);do if(g=w.next(n),g&&(u[t++]=T(new A.Range(l,g.index+1+o,l,g.index+1+g[0].length+o),g,r),t>=c))return t;while(g);return t}static findNextMatch(i,n,l,o){const t=n.parseSearchRequest();if(!t)return null;const u=new f(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindNextMatchMultiline(i,l,u,o):this._doFindNextMatchLineByLine(i,l,u,o)}static _doFindNextMatchMultiline(i,n,l,o){const t=new L.Position(n.lineNumber,1),u=i.getOffsetAt(t),r=i.getLineCount(),c=i.getValueInRange(new A.Range(t.lineNumber,t.column,r,i.getLineMaxColumn(r)),1),s=i.getEOL()===`\r
`?new I(c):null;l.reset(n.column-1);const w=l.next(c);return w?T(this._getMultilineMatchRange(i,u,c,s,w.index,w[0]),w,o):n.lineNumber!==1||n.column!==1?this._doFindNextMatchMultiline(i,new L.Position(1,1),l,o):null}static _doFindNextMatchLineByLine(i,n,l,o){const t=i.getLineCount(),u=n.lineNumber,r=i.getLineContent(u),c=this._findFirstMatchInLine(l,r,u,n.column,o);if(c)return c;for(let s=1;s<=t;s++){const w=(u+s-1)%t,g=i.getLineContent(w+1),D=this._findFirstMatchInLine(l,g,w+1,1,o);if(D)return D}return null}static _findFirstMatchInLine(i,n,l,o,t){i.reset(o-1);const u=i.next(n);return u?T(new A.Range(l,u.index+1,l,u.index+1+u[0].length),u,t):null}static findPreviousMatch(i,n,l,o){const t=n.parseSearchRequest();if(!t)return null;const u=new f(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindPreviousMatchMultiline(i,l,u,o):this._doFindPreviousMatchLineByLine(i,l,u,o)}static _doFindPreviousMatchMultiline(i,n,l,o){const t=this._doFindMatchesMultiline(i,new A.Range(1,1,n.lineNumber,n.column),l,o,10*b);if(t.length>0)return t[t.length-1];const u=i.getLineCount();return n.lineNumber!==u||n.column!==i.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(i,new L.Position(u,i.getLineMaxColumn(u)),l,o):null}static _doFindPreviousMatchLineByLine(i,n,l,o){const t=i.getLineCount(),u=n.lineNumber,r=i.getLineContent(u).substring(0,n.column-1),c=this._findLastMatchInLine(l,r,u,o);if(c)return c;for(let s=1;s<=t;s++){const w=(t+u-s-1)%t,g=i.getLineContent(w+1),D=this._findLastMatchInLine(l,g,w+1,o);if(D)return D}return null}static _findLastMatchInLine(i,n,l,o){let t=null,u;for(i.reset(0);u=i.next(n);)t=T(new A.Range(l,u.index+1,l,u.index+1+u[0].length),u,o);return t}}e.TextModelSearch=p;function S(a,i,n,l,o){if(l===0)return!0;const t=i.charCodeAt(l-1);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const u=i.charCodeAt(l);if(a.get(u)!==0)return!0}return!1}function E(a,i,n,l,o){if(l+o===n)return!0;const t=i.charCodeAt(l+o);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const u=i.charCodeAt(l+o-1);if(a.get(u)!==0)return!0}return!1}function d(a,i,n,l,o){return S(a,i,n,l,o)&&E(a,i,n,l,o)}class f{constructor(i,n){this._wordSeparators=i,this._searchRegex=n,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(i){this._searchRegex.lastIndex=i,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(i){const n=i.length;let l;do{if(this._prevMatchStartIndex+this._prevMatchLength===n||(l=this._searchRegex.exec(i),!l))return null;const o=l.index,t=l[0].length;if(o===this._prevMatchStartIndex&&t===this._prevMatchLength){if(t===0){h.getNextCodePoint(i,n,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=o,this._prevMatchLength=t,!this._wordSeparators||d(this._wordSeparators,i,n,o,t))return l}while(l);return null}}e.Searcher=f}),define(_e[131],Ce([1,0,51,29,80,186,100]),function(ue,e,h,O,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeBase=e.StringBuffer=e.Piece=void 0,e.createLineStartsFast=T,e.createLineStarts=I;const b=65535;function m(a){let i;return a[a.length-1]<65536?i=new Uint16Array(a.length):i=new Uint32Array(a.length),i.set(a,0),i}class y{constructor(i,n,l,o,t){this.lineStarts=i,this.cr=n,this.lf=l,this.crlf=o,this.isBasicASCII=t}}function T(a,i=!0){const n=[0];let l=1;for(let o=0,t=a.length;o<t;o++){const u=a.charCodeAt(o);u===13?o+1<t&&a.charCodeAt(o+1)===10?(n[l++]=o+2,o++):n[l++]=o+1:u===10&&(n[l++]=o+1)}return i?m(n):n}function I(a,i){a.length=0,a[0]=0;let n=1,l=0,o=0,t=0,u=!0;for(let c=0,s=i.length;c<s;c++){const w=i.charCodeAt(c);w===13?c+1<s&&i.charCodeAt(c+1)===10?(t++,a[n++]=c+2,c++):(l++,a[n++]=c+1):w===10?(o++,a[n++]=c+1):u&&w!==9&&(w<32||w>126)&&(u=!1)}const r=new y(m(a),l,o,t,u);return a.length=0,r}class p{constructor(i,n,l,o,t){this.bufferIndex=i,this.start=n,this.end=l,this.lineFeedCnt=o,this.length=t}}e.Piece=p;class S{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.StringBuffer=S;class E{constructor(i,n){this._pieces=[],this._tree=i,this._BOM=n,this._index=0,i.root!==A.SENTINEL&&i.iterate(i.root,l=>(l!==A.SENTINEL&&this._pieces.push(l.piece),!0))}read(){return this._pieces.length===0?this._index===0?(this._index++,this._BOM):null:this._index>this._pieces.length-1?null:this._index===0?this._BOM+this._tree.getPieceContent(this._pieces[this._index++]):this._tree.getPieceContent(this._pieces[this._index++])}}class d{constructor(i){this._limit=i,this._cache=[]}get(i){for(let n=this._cache.length-1;n>=0;n--){const l=this._cache[n];if(l.nodeStartOffset<=i&&l.nodeStartOffset+l.node.piece.length>=i)return l}return null}get2(i){for(let n=this._cache.length-1;n>=0;n--){const l=this._cache[n];if(l.nodeStartLineNumber&&l.nodeStartLineNumber<i&&l.nodeStartLineNumber+l.node.piece.lineFeedCnt>=i)return l}return null}set(i){this._cache.length>=this._limit&&this._cache.shift(),this._cache.push(i)}validate(i){let n=!1;const l=this._cache;for(let o=0;o<l.length;o++){const t=l[o];if(t.node.parent===null||t.nodeStartOffset>=i){l[o]=null,n=!0;continue}}if(n){const o=[];for(const t of l)t!==null&&o.push(t);this._cache=o}}}class f{constructor(i,n,l){this.create(i,n,l)}create(i,n,l){this._buffers=[new S("",[0])],this._lastChangeBufferPos={line:0,column:0},this.root=A.SENTINEL,this._lineCnt=1,this._length=0,this._EOL=n,this._EOLLength=n.length,this._EOLNormalized=l;let o=null;for(let t=0,u=i.length;t<u;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=T(i[t].buffer));const r=new p(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this._buffers.push(i[t]),o=this.rbInsertRight(o,r)}this._searchCache=new d(1),this._lastVisitedLine={lineNumber:0,value:""},this.computeBufferMetadata()}normalizeEOL(i){const n=b,l=n-Math.floor(n/3),o=l*2;let t="",u=0;const r=[];if(this.iterate(this.root,c=>{const s=this.getNodeContent(c),w=s.length;if(u<=l||u+w<o)return t+=s,u+=w,!0;const g=t.replace(/\r\n|\r|\n/g,i);return r.push(new S(g,T(g))),t=s,u=w,!0}),u>0){const c=t.replace(/\r\n|\r|\n/g,i);r.push(new S(c,T(c)))}this.create(r,i,!0)}getEOL(){return this._EOL}setEOL(i){this._EOL=i,this._EOLLength=this._EOL.length,this.normalizeEOL(i)}createSnapshot(i){return new E(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,o=>{if(o===A.SENTINEL)return!0;const t=this.getNodeContent(o),u=t.length,r=i.nodeAt(n),c=i.nodeAt(n+u),s=i.getValueInRange2(r,c);return n+=u,t===s})}getOffsetAt(i,n){let l=0,o=this.root;for(;o!==A.SENTINEL;)if(o.left!==A.SENTINEL&&o.lf_left+1>=i)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=i){l+=o.size_left;const t=this.getAccumulatedValue(o,i-o.lf_left-2);return l+=t+n-1}else i-=o.lf_left+o.piece.lineFeedCnt,l+=o.size_left+o.piece.length,o=o.right;return l}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,l=0;const o=i;for(;n!==A.SENTINEL;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.getIndexOf(n,i-n.size_left);if(l+=n.lf_left+t.index,t.index===0){const u=this.getOffsetAt(l+1,1),r=o-u;return new h.Position(l+1,r+1)}return new h.Position(l+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,l+=n.lf_left+n.piece.lineFeedCnt,n.right===A.SENTINEL){const t=this.getOffsetAt(l+1,1),u=o-i-t;return new h.Position(l+1,u+1)}else n=n.right;return new h.Position(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const l=this.nodeAt2(i.startLineNumber,i.startColumn),o=this.nodeAt2(i.endLineNumber,i.endColumn),t=this.getValueInRange2(l,o);return n?n!==this._EOL||!this._EOLNormalized?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this._EOLNormalized?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const r=i.node,c=this._buffers[r.piece.bufferIndex].buffer,s=this.offsetInBuffer(r.piece.bufferIndex,r.piece.start);return c.substring(s+i.remainder,s+n.remainder)}let l=i.node;const o=this._buffers[l.piece.bufferIndex].buffer,t=this.offsetInBuffer(l.piece.bufferIndex,l.piece.start);let u=o.substring(t+i.remainder,t+l.piece.length);for(l=l.next();l!==A.SENTINEL;){const r=this._buffers[l.piece.bufferIndex].buffer,c=this.offsetInBuffer(l.piece.bufferIndex,l.piece.start);if(l===n.node){u+=r.substring(c,c+n.remainder);break}else u+=r.substr(c,l.piece.length);l=l.next()}return u}getLinesContent(){const i=[];let n=0,l="",o=!1;return this.iterate(this.root,t=>{if(t===A.SENTINEL)return!0;const u=t.piece;let r=u.length;if(r===0)return!0;const c=this._buffers[u.bufferIndex].buffer,s=this._buffers[u.bufferIndex].lineStarts,w=u.start.line,g=u.end.line;let D=s[w]+u.start.column;if(o&&(c.charCodeAt(D)===10&&(D++,r--),i[n++]=l,l="",o=!1,r===0))return!0;if(w===g)return!this._EOLNormalized&&c.charCodeAt(D+r-1)===13?(o=!0,l+=c.substr(D,r-1)):l+=c.substr(D,r),!0;l+=this._EOLNormalized?c.substring(D,Math.max(D,s[w+1]-this._EOLLength)):c.substring(D,s[w+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=l;for(let v=w+1;v<g;v++)l=this._EOLNormalized?c.substring(s[v],s[v+1]-this._EOLLength):c.substring(s[v],s[v+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=l;return!this._EOLNormalized&&c.charCodeAt(s[g]+u.end.column-1)===13?(o=!0,u.end.column===0?n--:l=c.substr(s[g],u.end.column-1)):l=c.substr(s[g],u.end.column),!0}),o&&(i[n++]=l,l=""),i[n++]=l,i}getLength(){return this._length}getLineCount(){return this._lineCnt}getLineContent(i){return this._lastVisitedLine.lineNumber===i?this._lastVisitedLine.value:(this._lastVisitedLine.lineNumber=i,i===this._lineCnt?this._lastVisitedLine.value=this.getLineRawContent(i):this._EOLNormalized?this._lastVisitedLine.value=this.getLineRawContent(i,this._EOLLength):this._lastVisitedLine.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this._lastVisitedLine.value)}_getCharCode(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const l=this._buffers[n.piece.bufferIndex],o=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start);return l.buffer.charCodeAt(o)}else{const n=this._buffers[i.node.piece.bufferIndex],o=this.offsetInBuffer(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(o)}}getLineCharCode(i,n){const l=this.nodeAt2(i,n+1);return this._getCharCode(l)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this._EOLLength}getCharCode(i){const n=this.nodeAt(i);return this._getCharCode(n)}findMatchesInNode(i,n,l,o,t,u,r,c,s,w,g){const D=this._buffers[i.piece.bufferIndex],v=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start),_=this.offsetInBuffer(i.piece.bufferIndex,t),C=this.offsetInBuffer(i.piece.bufferIndex,u);let P;const k={line:0,column:0};let F,x;n._wordSeparators?(F=D.buffer.substring(_,C),x=z=>z+_,n.reset(0)):(F=D.buffer,x=z=>z,n.reset(_));do if(P=n.next(F),P){if(x(P.index)>=C)return w;this.positionInBuffer(i,x(P.index)-v,k);const z=this.getLineFeedCnt(i.piece.bufferIndex,t,k),N=k.line===t.line?k.column-t.column+o:k.column+1,M=N+P[0].length;if(g[w++]=(0,R.createFindMatch)(new O.Range(l+z,N,l+z,M),P,c),x(P.index)+P[0].length>=C||w>=s)return w}while(P);return w}findMatchesLineByLine(i,n,l,o){const t=[];let u=0;const r=new R.Searcher(n.wordSeparators,n.regex);let c=this.nodeAt2(i.startLineNumber,i.startColumn);if(c===null)return[];const s=this.nodeAt2(i.endLineNumber,i.endColumn);if(s===null)return[];let w=this.positionInBuffer(c.node,c.remainder);const g=this.positionInBuffer(s.node,s.remainder);if(c.node===s.node)return this.findMatchesInNode(c.node,r,i.startLineNumber,i.startColumn,w,g,n,l,o,u,t),t;let D=i.startLineNumber,v=c.node;for(;v!==s.node;){const C=this.getLineFeedCnt(v.piece.bufferIndex,w,v.piece.end);if(C>=1){const k=this._buffers[v.piece.bufferIndex].lineStarts,F=this.offsetInBuffer(v.piece.bufferIndex,v.piece.start),x=k[w.line+C],z=D===i.startLineNumber?i.startColumn:1;if(u=this.findMatchesInNode(v,r,D,z,w,this.positionInBuffer(v,x-F),n,l,o,u,t),u>=o)return t;D+=C}const P=D===i.startLineNumber?i.startColumn-1:0;if(D===i.endLineNumber){const k=this.getLineContent(D).substring(P,i.endColumn-1);return u=this._findMatchesInLine(n,r,k,i.endLineNumber,P,u,t,l,o),t}if(u=this._findMatchesInLine(n,r,this.getLineContent(D).substr(P),D,P,u,t,l,o),u>=o)return t;D++,c=this.nodeAt2(D,1),v=c.node,w=this.positionInBuffer(c.node,c.remainder)}if(D===i.endLineNumber){const C=D===i.startLineNumber?i.startColumn-1:0,P=this.getLineContent(D).substring(C,i.endColumn-1);return u=this._findMatchesInLine(n,r,P,i.endLineNumber,C,u,t,l,o),t}const _=D===i.startLineNumber?i.startColumn:1;return u=this.findMatchesInNode(s.node,r,D,_,w,g,n,l,o,u,t),t}_findMatchesInLine(i,n,l,o,t,u,r,c,s){const w=i.wordSeparators;if(!c&&i.simpleSearch){const D=i.simpleSearch,v=D.length,_=l.length;let C=-v;for(;(C=l.indexOf(D,C+v))!==-1;)if((!w||(0,R.isValidMatch)(w,l,_,C,v))&&(r[u++]=new L.FindMatch(new O.Range(o,C+1+t,o,C+1+v+t),null),u>=s))return u;return u}let g;n.reset(0);do if(g=n.next(l),g&&(r[u++]=(0,R.createFindMatch)(new O.Range(o,g.index+1+t,o,g.index+1+g[0].length+t),g,c),u>=s))return u;while(g);return u}insert(i,n,l=!1){if(this._EOLNormalized=this._EOLNormalized&&l,this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",this.root!==A.SENTINEL){const{node:o,remainder:t,nodeStartOffset:u}=this.nodeAt(i),r=o.piece,c=r.bufferIndex,s=this.positionInBuffer(o,t);if(o.piece.bufferIndex===0&&r.end.line===this._lastChangeBufferPos.line&&r.end.column===this._lastChangeBufferPos.column&&u+r.length===i&&n.length<b){this.appendToNode(o,n),this.computeBufferMetadata();return}if(u===i)this.insertContentToNodeLeft(n,o),this._searchCache.validate(i);else if(u+o.piece.length>i){const w=[];let g=new p(r.bufferIndex,s,r.end,this.getLineFeedCnt(r.bufferIndex,s,r.end),this.offsetInBuffer(c,r.end)-this.offsetInBuffer(c,s));if(this.shouldCheckCRLF()&&this.endWithCR(n)&&this.nodeCharCodeAt(o,t)===10){const C={line:g.start.line+1,column:0};g=new p(g.bufferIndex,C,g.end,this.getLineFeedCnt(g.bufferIndex,C,g.end),g.length-1),n+=`
`}if(this.shouldCheckCRLF()&&this.startWithLF(n))if(this.nodeCharCodeAt(o,t-1)===13){const C=this.positionInBuffer(o,t-1);this.deleteNodeTail(o,C),n="\r"+n,o.piece.length===0&&w.push(o)}else this.deleteNodeTail(o,s);else this.deleteNodeTail(o,s);const D=this.createNewPieces(n);g.length>0&&this.rbInsertRight(o,g);let v=o;for(let _=0;_<D.length;_++)v=this.rbInsertRight(v,D[_]);this.deleteNodes(w)}else this.insertContentToNodeRight(n,o)}else{const o=this.createNewPieces(n);let t=this.rbInsertLeft(null,o[0]);for(let u=1;u<o.length;u++)t=this.rbInsertRight(t,o[u])}this.computeBufferMetadata()}delete(i,n){if(this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",n<=0||this.root===A.SENTINEL)return;const l=this.nodeAt(i),o=this.nodeAt(i+n),t=l.node,u=o.node;if(t===u){const D=this.positionInBuffer(t,l.remainder),v=this.positionInBuffer(t,o.remainder);if(l.nodeStartOffset===i){if(n===t.piece.length){const _=t.next();(0,A.rbDelete)(this,t),this.validateCRLFWithPrevNode(_),this.computeBufferMetadata();return}this.deleteNodeHead(t,v),this._searchCache.validate(i),this.validateCRLFWithPrevNode(t),this.computeBufferMetadata();return}if(l.nodeStartOffset+t.piece.length===i+n){this.deleteNodeTail(t,D),this.validateCRLFWithNextNode(t),this.computeBufferMetadata();return}this.shrinkNode(t,D,v),this.computeBufferMetadata();return}const r=[],c=this.positionInBuffer(t,l.remainder);this.deleteNodeTail(t,c),this._searchCache.validate(i),t.piece.length===0&&r.push(t);const s=this.positionInBuffer(u,o.remainder);this.deleteNodeHead(u,s),u.piece.length===0&&r.push(u);const w=t.next();for(let D=w;D!==A.SENTINEL&&D!==u;D=D.next())r.push(D);const g=t.piece.length===0?t.prev():t;this.deleteNodes(r),this.validateCRLFWithNextNode(g),this.computeBufferMetadata()}insertContentToNodeLeft(i,n){const l=[];if(this.shouldCheckCRLF()&&this.endWithCR(i)&&this.startWithLF(n)){const u=n.piece,r={line:u.start.line+1,column:0},c=new p(u.bufferIndex,r,u.end,this.getLineFeedCnt(u.bufferIndex,r,u.end),u.length-1);n.piece=c,i+=`
`,(0,A.updateTreeMetadata)(this,n,-1,-1),n.piece.length===0&&l.push(n)}const o=this.createNewPieces(i);let t=this.rbInsertLeft(n,o[o.length-1]);for(let u=o.length-2;u>=0;u--)t=this.rbInsertLeft(t,o[u]);this.validateCRLFWithPrevNode(t),this.deleteNodes(l)}insertContentToNodeRight(i,n){this.adjustCarriageReturnFromNext(i,n)&&(i+=`
`);const l=this.createNewPieces(i),o=this.rbInsertRight(n,l[0]);let t=o;for(let u=1;u<l.length;u++)t=this.rbInsertRight(t,l[u]);this.validateCRLFWithPrevNode(o)}positionInBuffer(i,n,l){const o=i.piece,t=i.piece.bufferIndex,u=this._buffers[t].lineStarts,c=u[o.start.line]+o.start.column+n;let s=o.start.line,w=o.end.line,g=0,D=0,v=0;for(;s<=w&&(g=s+(w-s)/2|0,v=u[g],g!==w);)if(D=u[g+1],c<v)w=g-1;else if(c>=D)s=g+1;else break;return l?(l.line=g,l.column=c-v,null):{line:g,column:c-v}}getLineFeedCnt(i,n,l){if(l.column===0)return l.line-n.line;const o=this._buffers[i].lineStarts;if(l.line===o.length-1)return l.line-n.line;const t=o[l.line+1],u=o[l.line]+l.column;if(t>u+1)return l.line-n.line;const r=u-1;return this._buffers[i].buffer.charCodeAt(r)===13?l.line-n.line+1:l.line-n.line}offsetInBuffer(i,n){return this._buffers[i].lineStarts[n.line]+n.column}deleteNodes(i){for(let n=0;n<i.length;n++)(0,A.rbDelete)(this,i[n])}createNewPieces(i){if(i.length>b){const w=[];for(;i.length>b;){const D=i.charCodeAt(b-1);let v;D===13||D>=55296&&D<=56319?(v=i.substring(0,b-1),i=i.substring(b-1)):(v=i.substring(0,b),i=i.substring(b));const _=T(v);w.push(new p(this._buffers.length,{line:0,column:0},{line:_.length-1,column:v.length-_[_.length-1]},_.length-1,v.length)),this._buffers.push(new S(v,_))}const g=T(i);return w.push(new p(this._buffers.length,{line:0,column:0},{line:g.length-1,column:i.length-g[g.length-1]},g.length-1,i.length)),this._buffers.push(new S(i,g)),w}let n=this._buffers[0].buffer.length;const l=T(i,!1);let o=this._lastChangeBufferPos;if(this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-1]===n&&n!==0&&this.startWithLF(i)&&this.endWithCR(this._buffers[0].buffer)){this._lastChangeBufferPos={line:this._lastChangeBufferPos.line,column:this._lastChangeBufferPos.column+1},o=this._lastChangeBufferPos;for(let w=0;w<l.length;w++)l[w]+=n+1;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(l.slice(1)),this._buffers[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let w=0;w<l.length;w++)l[w]+=n;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(l.slice(1)),this._buffers[0].buffer+=i}const t=this._buffers[0].buffer.length,u=this._buffers[0].lineStarts.length-1,r=t-this._buffers[0].lineStarts[u],c={line:u,column:r},s=new p(0,o,c,this.getLineFeedCnt(0,o,c),t-n);return this._lastChangeBufferPos=c,[s]}getLinesRawContent(){return this.getContentOfSubTree(this.root)}getLineRawContent(i,n=0){let l=this.root,o="";const t=this._searchCache.get2(i);if(t){l=t.node;const u=this.getAccumulatedValue(l,i-t.nodeStartLineNumber-1),r=this._buffers[l.piece.bufferIndex].buffer,c=this.offsetInBuffer(l.piece.bufferIndex,l.piece.start);if(t.nodeStartLineNumber+l.piece.lineFeedCnt===i)o=r.substring(c+u,c+l.piece.length);else{const s=this.getAccumulatedValue(l,i-t.nodeStartLineNumber);return r.substring(c+u,c+s-n)}}else{let u=0;const r=i;for(;l!==A.SENTINEL;)if(l.left!==A.SENTINEL&&l.lf_left>=i-1)l=l.left;else if(l.lf_left+l.piece.lineFeedCnt>i-1){const c=this.getAccumulatedValue(l,i-l.lf_left-2),s=this.getAccumulatedValue(l,i-l.lf_left-1),w=this._buffers[l.piece.bufferIndex].buffer,g=this.offsetInBuffer(l.piece.bufferIndex,l.piece.start);return u+=l.size_left,this._searchCache.set({node:l,nodeStartOffset:u,nodeStartLineNumber:r-(i-1-l.lf_left)}),w.substring(g+c,g+s-n)}else if(l.lf_left+l.piece.lineFeedCnt===i-1){const c=this.getAccumulatedValue(l,i-l.lf_left-2),s=this._buffers[l.piece.bufferIndex].buffer,w=this.offsetInBuffer(l.piece.bufferIndex,l.piece.start);o=s.substring(w+c,w+l.piece.length);break}else i-=l.lf_left+l.piece.lineFeedCnt,u+=l.size_left+l.piece.length,l=l.right}for(l=l.next();l!==A.SENTINEL;){const u=this._buffers[l.piece.bufferIndex].buffer;if(l.piece.lineFeedCnt>0){const r=this.getAccumulatedValue(l,0),c=this.offsetInBuffer(l.piece.bufferIndex,l.piece.start);return o+=u.substring(c,c+r-n),o}else{const r=this.offsetInBuffer(l.piece.bufferIndex,l.piece.start);o+=u.substr(r,l.piece.length)}l=l.next()}return o}computeBufferMetadata(){let i=this.root,n=1,l=0;for(;i!==A.SENTINEL;)n+=i.lf_left+i.piece.lineFeedCnt,l+=i.size_left+i.piece.length,i=i.right;this._lineCnt=n,this._length=l,this._searchCache.validate(this._length)}getIndexOf(i,n){const l=i.piece,o=this.positionInBuffer(i,n),t=o.line-l.start.line;if(this.offsetInBuffer(l.bufferIndex,l.end)-this.offsetInBuffer(l.bufferIndex,l.start)===n){const u=this.getLineFeedCnt(i.piece.bufferIndex,l.start,o);if(u!==t)return{index:u,remainder:0}}return{index:t,remainder:o.column}}getAccumulatedValue(i,n){if(n<0)return 0;const l=i.piece,o=this._buffers[l.bufferIndex].lineStarts,t=l.start.line+n+1;return t>l.end.line?o[l.end.line]+l.end.column-o[l.start.line]-l.start.column:o[t]-o[l.start.line]-l.start.column}deleteNodeTail(i,n){const l=i.piece,o=l.lineFeedCnt,t=this.offsetInBuffer(l.bufferIndex,l.end),u=n,r=this.offsetInBuffer(l.bufferIndex,u),c=this.getLineFeedCnt(l.bufferIndex,l.start,u),s=c-o,w=r-t,g=l.length+w;i.piece=new p(l.bufferIndex,l.start,u,c,g),(0,A.updateTreeMetadata)(this,i,w,s)}deleteNodeHead(i,n){const l=i.piece,o=l.lineFeedCnt,t=this.offsetInBuffer(l.bufferIndex,l.start),u=n,r=this.getLineFeedCnt(l.bufferIndex,u,l.end),c=this.offsetInBuffer(l.bufferIndex,u),s=r-o,w=t-c,g=l.length+w;i.piece=new p(l.bufferIndex,u,l.end,r,g),(0,A.updateTreeMetadata)(this,i,w,s)}shrinkNode(i,n,l){const o=i.piece,t=o.start,u=o.end,r=o.length,c=o.lineFeedCnt,s=n,w=this.getLineFeedCnt(o.bufferIndex,o.start,s),g=this.offsetInBuffer(o.bufferIndex,n)-this.offsetInBuffer(o.bufferIndex,t);i.piece=new p(o.bufferIndex,o.start,s,w,g),(0,A.updateTreeMetadata)(this,i,g-r,w-c);const D=new p(o.bufferIndex,l,u,this.getLineFeedCnt(o.bufferIndex,l,u),this.offsetInBuffer(o.bufferIndex,u)-this.offsetInBuffer(o.bufferIndex,l)),v=this.rbInsertRight(i,D);this.validateCRLFWithPrevNode(v)}appendToNode(i,n){this.adjustCarriageReturnFromNext(n,i)&&(n+=`
`);const l=this.shouldCheckCRLF()&&this.startWithLF(n)&&this.endWithCR(i),o=this._buffers[0].buffer.length;this._buffers[0].buffer+=n;const t=T(n,!1);for(let v=0;v<t.length;v++)t[v]+=o;if(l){const v=this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-2];this._buffers[0].lineStarts.pop(),this._lastChangeBufferPos={line:this._lastChangeBufferPos.line-1,column:o-v}}this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(t.slice(1));const u=this._buffers[0].lineStarts.length-1,r=this._buffers[0].buffer.length-this._buffers[0].lineStarts[u],c={line:u,column:r},s=i.piece.length+n.length,w=i.piece.lineFeedCnt,g=this.getLineFeedCnt(0,i.piece.start,c),D=g-w;i.piece=new p(i.piece.bufferIndex,i.piece.start,c,g,s),this._lastChangeBufferPos=c,(0,A.updateTreeMetadata)(this,i,n.length,D)}nodeAt(i){let n=this.root;const l=this._searchCache.get(i);if(l)return{node:l.node,nodeStartOffset:l.nodeStartOffset,remainder:i-l.nodeStartOffset};let o=0;for(;n!==A.SENTINEL;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){o+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:o};return this._searchCache.set(t),t}else i-=n.size_left+n.piece.length,o+=n.size_left+n.piece.length,n=n.right;return null}nodeAt2(i,n){let l=this.root,o=0;for(;l!==A.SENTINEL;)if(l.left!==A.SENTINEL&&l.lf_left>=i-1)l=l.left;else if(l.lf_left+l.piece.lineFeedCnt>i-1){const t=this.getAccumulatedValue(l,i-l.lf_left-2),u=this.getAccumulatedValue(l,i-l.lf_left-1);return o+=l.size_left,{node:l,remainder:Math.min(t+n-1,u),nodeStartOffset:o}}else if(l.lf_left+l.piece.lineFeedCnt===i-1){const t=this.getAccumulatedValue(l,i-l.lf_left-2);if(t+n-1<=l.piece.length)return{node:l,remainder:t+n-1,nodeStartOffset:o};n-=l.piece.length-t;break}else i-=l.lf_left+l.piece.lineFeedCnt,o+=l.size_left+l.piece.length,l=l.right;for(l=l.next();l!==A.SENTINEL;){if(l.piece.lineFeedCnt>0){const t=this.getAccumulatedValue(l,0),u=this.offsetOfNode(l);return{node:l,remainder:Math.min(n-1,t),nodeStartOffset:u}}else if(l.piece.length>=n-1){const t=this.offsetOfNode(l);return{node:l,remainder:n-1,nodeStartOffset:t}}else n-=l.piece.length;l=l.next()}return null}nodeCharCodeAt(i,n){if(i.piece.lineFeedCnt<1)return-1;const l=this._buffers[i.piece.bufferIndex],o=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start)+n;return l.buffer.charCodeAt(o)}offsetOfNode(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}shouldCheckCRLF(){return!(this._EOLNormalized&&this._EOL===`
`)}startWithLF(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===A.SENTINEL||i.piece.lineFeedCnt===0)return!1;const n=i.piece,l=this._buffers[n.bufferIndex].lineStarts,o=n.start.line,t=l[o]+n.start.column;return o===l.length-1||l[o+1]>t+1?!1:this._buffers[n.bufferIndex].buffer.charCodeAt(t)===10}endWithCR(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===A.SENTINEL||i.piece.lineFeedCnt===0?!1:this.nodeCharCodeAt(i,i.piece.length-1)===13}validateCRLFWithPrevNode(i){if(this.shouldCheckCRLF()&&this.startWithLF(i)){const n=i.prev();this.endWithCR(n)&&this.fixCRLF(n,i)}}validateCRLFWithNextNode(i){if(this.shouldCheckCRLF()&&this.endWithCR(i)){const n=i.next();this.startWithLF(n)&&this.fixCRLF(i,n)}}fixCRLF(i,n){const l=[],o=this._buffers[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:o[i.piece.end.line]-o[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const u=i.piece.length-1,r=i.piece.lineFeedCnt-1;i.piece=new p(i.piece.bufferIndex,i.piece.start,t,r,u),(0,A.updateTreeMetadata)(this,i,-1,-1),i.piece.length===0&&l.push(i);const c={line:n.piece.start.line+1,column:0},s=n.piece.length-1,w=this.getLineFeedCnt(n.piece.bufferIndex,c,n.piece.end);n.piece=new p(n.piece.bufferIndex,c,n.piece.end,w,s),(0,A.updateTreeMetadata)(this,n,-1,-1),n.piece.length===0&&l.push(n);const g=this.createNewPieces(`\r
`);this.rbInsertRight(i,g[0]);for(let D=0;D<l.length;D++)(0,A.rbDelete)(this,l[D])}adjustCarriageReturnFromNext(i,n){if(this.shouldCheckCRLF()&&this.endWithCR(i)){const l=n.next();if(this.startWithLF(l)){if(i+=`
`,l.piece.length===1)(0,A.rbDelete)(this,l);else{const o=l.piece,t={line:o.start.line+1,column:0},u=o.length-1,r=this.getLineFeedCnt(o.bufferIndex,t,o.end);l.piece=new p(o.bufferIndex,t,o.end,r,u),(0,A.updateTreeMetadata)(this,l,-1,-1)}return!0}}return!1}iterate(i,n){if(i===A.SENTINEL)return n(A.SENTINEL);const l=this.iterate(i.left,n);return l&&n(i)&&this.iterate(i.right,n)}getNodeContent(i){if(i===A.SENTINEL)return"";const n=this._buffers[i.piece.bufferIndex],l=i.piece,o=this.offsetInBuffer(l.bufferIndex,l.start),t=this.offsetInBuffer(l.bufferIndex,l.end);return n.buffer.substring(o,t)}getPieceContent(i){const n=this._buffers[i.bufferIndex],l=this.offsetInBuffer(i.bufferIndex,i.start),o=this.offsetInBuffer(i.bufferIndex,i.end);return n.buffer.substring(l,o)}rbInsertRight(i,n){const l=new A.TreeNode(n,1);if(l.left=A.SENTINEL,l.right=A.SENTINEL,l.parent=A.SENTINEL,l.size_left=0,l.lf_left=0,this.root===A.SENTINEL)this.root=l,l.color=0;else if(i.right===A.SENTINEL)i.right=l,l.parent=i;else{const t=(0,A.leftest)(i.right);t.left=l,l.parent=t}return(0,A.fixInsert)(this,l),l}rbInsertLeft(i,n){const l=new A.TreeNode(n,1);if(l.left=A.SENTINEL,l.right=A.SENTINEL,l.parent=A.SENTINEL,l.size_left=0,l.lf_left=0,this.root===A.SENTINEL)this.root=l,l.color=0;else if(i.left===A.SENTINEL)i.left=l,l.parent=i;else{const o=(0,A.righttest)(i.left);o.right=l,l.parent=o}return(0,A.fixInsert)(this,l),l}getContentOfSubTree(i){let n="";return this.iterate(i,l=>(n+=this.getNodeContent(l),!0)),n}}e.PieceTreeBase=f}),define(_e[189],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class h{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(A){if(A&&this._dragOperations.has(A)){const R=this._dragOperations.get(A);return this._dragOperations.delete(A),R}}addDragOperationTransfer(A,R){this._dragOperations.set(A,R)}}e.TreeViewsDnDService=h;class O{constructor(A){this.identifier=A}}e.DraggedTreeItemsIdentifier=O}),define(_e[190],Ce([1,0,4,3]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class L{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new h.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(b){this._onDidChange.fire({changedLanguages:b,changedColorMap:!1})}register(b,m){return this._tokenizationSupports.set(b,m),this.handleChange([b]),(0,O.toDisposable)(()=>{this._tokenizationSupports.get(b)===m&&(this._tokenizationSupports.delete(b),this.handleChange([b]))})}get(b){return this._tokenizationSupports.get(b)||null}registerFactory(b,m){this._factories.get(b)?.dispose();const y=new A(this,b,m);return this._factories.set(b,y),(0,O.toDisposable)(()=>{const T=this._factories.get(b);!T||T!==y||(this._factories.delete(b),T.dispose())})}async getOrCreate(b){const m=this.get(b);if(m)return m;const y=this._factories.get(b);return!y||y.isResolved?null:(await y.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const y=this._factories.get(b);return!!(!y||y.isResolved)}setColorMap(b){this._colorMap=b,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=L;class A extends O.Disposable{get isResolved(){return this._isResolved}constructor(b,m,y){super(),this._registry=b,this._languageId=m,this._factory=y,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const b=await this._factory.tokenizationSupport;this._isResolved=!0,b&&!this._isDisposed&&this._register(this._registry.register(this._languageId,b))}}}),define(_e[191],Ce([9,10]),function(ue,e){return ue.create("vs/base/common/actions",e)}),define(_e[192],Ce([1,0,4,3,191]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0,e.toAction=T;class A extends O.Disposable{constructor(p,S="",E="",d=!0,f){super(),this._onDidChange=this._register(new h.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=p,this._label=S,this._cssClass=E,this._enabled=d,this._actionCallback=f}get id(){return this._id}get label(){return this._label}set label(p){this._setLabel(p)}_setLabel(p){this._label!==p&&(this._label=p,this._onDidChange.fire({label:p}))}get tooltip(){return this._tooltip||""}set tooltip(p){this._setTooltip(p)}_setTooltip(p){this._tooltip!==p&&(this._tooltip=p,this._onDidChange.fire({tooltip:p}))}get class(){return this._cssClass}set class(p){this._setClass(p)}_setClass(p){this._cssClass!==p&&(this._cssClass=p,this._onDidChange.fire({class:p}))}get enabled(){return this._enabled}set enabled(p){this._setEnabled(p)}_setEnabled(p){this._enabled!==p&&(this._enabled=p,this._onDidChange.fire({enabled:p}))}get checked(){return this._checked}set checked(p){this._setChecked(p)}_setChecked(p){this._checked!==p&&(this._checked=p,this._onDidChange.fire({checked:p}))}async run(p,S){this._actionCallback&&await this._actionCallback(p)}}e.Action=A;class R extends O.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new h.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new h.Emitter),this.onDidRun=this._onDidRun.event}async run(p,S){if(!p.enabled)return;this._onWillRun.fire({action:p});let E;try{await this.runAction(p,S)}catch(d){E=d}this._onDidRun.fire({action:p,error:E})}async runAction(p,S){await p.run(S)}}e.ActionRunner=R;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let S=[];for(const E of p)E.length&&(S.length?S=[...S,new b,...E]:S=E);return S}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=b;class m{get actions(){return this._actions}constructor(p,S,E,d){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=S,this.class=d,this._actions=E}async run(){}}e.SubmenuAction=m;class y extends A{static{this.ID="vs.actions.empty"}constructor(){super(y.ID,L.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=y;function T(I){return{id:I.id,label:I.label,class:I.class,enabled:I.enabled??!0,checked:I.checked,run:async(...p)=>I.run(...p),tooltip:I.label}}}),define(_e[193],Ce([9,10]),function(ue,e){return ue.create("vs/base/common/date",e)}),define(_e[194],Ce([1,0,193]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=y,e.getDurationString=T,e.toLocalISOString=I;const O=60,L=O*60,A=L*24,R=A*7,b=A*30,m=A*365;function y(p,S,E,d){typeof p!="number"&&(p=p.getTime());const f=Math.round((new Date().getTime()-p)/1e3);if(f<-30)return(0,h.localize)(0,null,y(new Date().getTime()+f*1e3,!1));if(!d&&f<30)return(0,h.localize)(1,null);let a;return f<O?(a=f,S?a===1?E?(0,h.localize)(2,null,a):(0,h.localize)(3,null,a):E?(0,h.localize)(4,null,a):(0,h.localize)(5,null,a):a===1?E?(0,h.localize)(6,null,a):(0,h.localize)(7,null,a):E?(0,h.localize)(8,null,a):(0,h.localize)(9,null,a)):f<L?(a=Math.floor(f/O),S?a===1?E?(0,h.localize)(10,null,a):(0,h.localize)(11,null,a):E?(0,h.localize)(12,null,a):(0,h.localize)(13,null,a):a===1?E?(0,h.localize)(14,null,a):(0,h.localize)(15,null,a):E?(0,h.localize)(16,null,a):(0,h.localize)(17,null,a)):f<A?(a=Math.floor(f/L),S?a===1?E?(0,h.localize)(18,null,a):(0,h.localize)(19,null,a):E?(0,h.localize)(20,null,a):(0,h.localize)(21,null,a):a===1?E?(0,h.localize)(22,null,a):(0,h.localize)(23,null,a):E?(0,h.localize)(24,null,a):(0,h.localize)(25,null,a)):f<R?(a=Math.floor(f/A),S?a===1?(0,h.localize)(26,null,a):(0,h.localize)(27,null,a):a===1?(0,h.localize)(28,null,a):(0,h.localize)(29,null,a)):f<b?(a=Math.floor(f/R),S?a===1?E?(0,h.localize)(30,null,a):(0,h.localize)(31,null,a):E?(0,h.localize)(32,null,a):(0,h.localize)(33,null,a):a===1?E?(0,h.localize)(34,null,a):(0,h.localize)(35,null,a):E?(0,h.localize)(36,null,a):(0,h.localize)(37,null,a)):f<m?(a=Math.floor(f/b),S?a===1?E?(0,h.localize)(38,null,a):(0,h.localize)(39,null,a):E?(0,h.localize)(40,null,a):(0,h.localize)(41,null,a):a===1?E?(0,h.localize)(42,null,a):(0,h.localize)(43,null,a):E?(0,h.localize)(44,null,a):(0,h.localize)(45,null,a)):(a=Math.floor(f/m),S?a===1?E?(0,h.localize)(46,null,a):(0,h.localize)(47,null,a):E?(0,h.localize)(48,null,a):(0,h.localize)(49,null,a):a===1?E?(0,h.localize)(50,null,a):(0,h.localize)(51,null,a):E?(0,h.localize)(52,null,a):(0,h.localize)(53,null,a))}function T(p,S){const E=Math.abs(p/1e3);return E<1?S?(0,h.localize)(54,null,p):(0,h.localize)(55,null,p):E<O?S?(0,h.localize)(56,null,Math.round(p)/1e3):(0,h.localize)(57,null,Math.round(p)/1e3):E<L?S?(0,h.localize)(58,null,Math.round(p/(1e3*O))):(0,h.localize)(59,null,Math.round(p/(1e3*O))):E<A?S?(0,h.localize)(60,null,Math.round(p/(1e3*L))):(0,h.localize)(61,null,Math.round(p/(1e3*L))):(0,h.localize)(62,null,Math.round(p/(1e3*A)))}function I(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(_e[195],Ce([9,10]),function(ue,e){return ue.create("vs/base/common/errorMessage",e)}),define(_e[47],Ce([1,0,19,18,195]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=m,e.isErrorWithActions=y,e.createErrorWithActions=T;function A(I,p){return p&&(I.stack||I.stacktrace)?L.localize(0,null,b(I),R(I.stack)||R(I.stacktrace)):b(I)}function R(I){return Array.isArray(I)?I.join(`
`):I}function b(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?L.localize(1,null,I.message):I.message||L.localize(2,null)}function m(I=null,p=!1){if(!I)return L.localize(3,null);if(Array.isArray(I)){const S=h.coalesce(I),E=m(S[0],p);return S.length>1?L.localize(4,null,E,S.length):E}if(O.isString(I))return I;if(I.detail){const S=I.detail;if(S.error)return A(S.error,p);if(S.exception)return A(S.exception,p)}return I.stack?A(I,p):I.message?I.message:L.localize(5,null)}function y(I){const p=I;return p instanceof Error&&Array.isArray(p.actions)}function T(I,p){let S;return typeof I=="string"?S=new Error(I):S=I,S.actions=p,S}}),define(_e[196],Ce([9,10]),function(ue,e){return ue.create("vs/base/common/platform",e)}),define(_e[12],Ce([1,0,196]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=u,e.isLittleEndian=D,e.isBigSurOrNewer=v,e.LANGUAGE_DEFAULT="en";let O=!1,L=!1,A=!1,R=!1,b=!1,m=!1,y=!1,T=!1,I=!1,p=!1,S,E=e.LANGUAGE_DEFAULT,d=e.LANGUAGE_DEFAULT,f,a;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(n=process);const l=typeof n?.versions?.electron=="string",o=l&&n?.type==="renderer";if(typeof n=="object"){O=n.platform==="win32",L=n.platform==="darwin",A=n.platform==="linux",R=A&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,y=l,I=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=e.LANGUAGE_DEFAULT,E=e.LANGUAGE_DEFAULT;const _=n.env.VSCODE_NLS_CONFIG;if(_)try{const C=JSON.parse(_),P=C.availableLanguages["*"];S=C.locale,d=C.osLocale,E=P||e.LANGUAGE_DEFAULT,f=C._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!o?(a=navigator.userAgent,O=a.indexOf("Windows")>=0,L=a.indexOf("Macintosh")>=0,T=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=a.indexOf("Linux")>=0,p=a?.indexOf("Mobi")>=0,m=!0,S=h.getConfiguredDefaultLocale(h.localize(0,null))||e.LANGUAGE_DEFAULT,E=S,d=navigator.language):console.error("Unable to resolve platform.");var t;(function(_){_[_.Web=0]="Web",_[_.Mac=1]="Mac",_[_.Linux=2]="Linux",_[_.Windows=3]="Windows"})(t||(e.Platform=t={}));function u(_){switch(_){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let r=0;L?r=1:O?r=3:A&&(r=2),e.isWindows=O,e.isMacintosh=L,e.isLinux=A,e.isLinuxSnap=R,e.isNative=b,e.isElectron=y,e.isWeb=m,e.isWebWorker=m&&typeof i.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?i.origin:void 0,e.isIOS=T,e.isMobile=p,e.isCI=I,e.platform=r,e.userAgent=a,e.language=E;var c;(function(_){function C(){return e.language}_.value=C;function P(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}_.isDefaultVariant=P;function k(){return e.language==="en"}_.isDefault=k})(c||(e.Language=c={})),e.locale=S,e.platformLocale=d,e.translationsConfigFile=f,e.setTimeout0IsFaster=typeof i.postMessage=="function"&&!i.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const _=[];i.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let k=0,F=_.length;k<F;k++){const x=_[k];if(x.id===P.data.vscodeScheduleAsyncWork){_.splice(k,1),x.callback();return}}});let C=0;return P=>{const k=++C;_.push({id:k,callback:P}),i.postMessage({vscodeScheduleAsyncWork:k},"*")}}return _=>setTimeout(_)})();var s;(function(_){_[_.Windows=1]="Windows",_[_.Macintosh=2]="Macintosh",_[_.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=L||T?2:O?1:3;let w=!0,g=!1;function D(){if(!g){g=!0;const _=new Uint8Array(2);_[0]=1,_[1]=2,w=new Uint16Array(_.buffer)[0]===513}return w}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function v(_){return parseFloat(_)>=20}}),define(_e[52],Ce([1,0,12]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let O;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const A=L.process;O={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return h.isWindows?"win32":h.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.platform=O.platform,e.arch=O.arch}),define(_e[17],Ce([1,0,52]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const O=65,L=97,A=90,R=122,b=46,m=47,y=92,T=58,I=63;class p extends Error{constructor(u,r,c){let s;typeof r=="string"&&r.indexOf("not ")===0?(s="must not be",r=r.replace(/^not /,"")):s="must be";const w=u.indexOf(".")!==-1?"property":"argument";let g=`The "${u}" ${w} ${s} of type ${r}`;g+=`. Received type ${typeof c}`,super(g),this.code="ERR_INVALID_ARG_TYPE"}}function S(t,u){if(t===null||typeof t!="object")throw new p(u,"Object",t)}function E(t,u){if(typeof t!="string")throw new p(u,"string",t)}const d=h.platform==="win32";function f(t){return t===m||t===y}function a(t){return t===m}function i(t){return t>=O&&t<=A||t>=L&&t<=R}function n(t,u,r,c){let s="",w=0,g=-1,D=0,v=0;for(let _=0;_<=t.length;++_){if(_<t.length)v=t.charCodeAt(_);else{if(c(v))break;v=m}if(c(v)){if(!(g===_-1||D===1))if(D===2){if(s.length<2||w!==2||s.charCodeAt(s.length-1)!==b||s.charCodeAt(s.length-2)!==b){if(s.length>2){const C=s.lastIndexOf(r);C===-1?(s="",w=0):(s=s.slice(0,C),w=s.length-1-s.lastIndexOf(r)),g=_,D=0;continue}else if(s.length!==0){s="",w=0,g=_,D=0;continue}}u&&(s+=s.length>0?`${r}..`:"..",w=2)}else s.length>0?s+=`${r}${t.slice(g+1,_)}`:s=t.slice(g+1,_),w=_-g-1;g=_,D=0}else v===b&&D!==-1?++D:D=-1}return s}function l(t,u){S(u,"pathObject");const r=u.dir||u.root,c=u.base||`${u.name||""}${u.ext||""}`;return r?r===u.root?`${r}${c}`:`${r}${t}${c}`:c}e.win32={resolve(...t){let u="",r="",c=!1;for(let s=t.length-1;s>=-1;s--){let w;if(s>=0){if(w=t[s],E(w,"path"),w.length===0)continue}else u.length===0?w=h.cwd():(w=h.env[`=${u}`]||h.cwd(),(w===void 0||w.slice(0,2).toLowerCase()!==u.toLowerCase()&&w.charCodeAt(2)===y)&&(w=`${u}\\`));const g=w.length;let D=0,v="",_=!1;const C=w.charCodeAt(0);if(g===1)f(C)&&(D=1,_=!0);else if(f(C))if(_=!0,f(w.charCodeAt(1))){let P=2,k=P;for(;P<g&&!f(w.charCodeAt(P));)P++;if(P<g&&P!==k){const F=w.slice(k,P);for(k=P;P<g&&f(w.charCodeAt(P));)P++;if(P<g&&P!==k){for(k=P;P<g&&!f(w.charCodeAt(P));)P++;(P===g||P!==k)&&(v=`\\\\${F}\\${w.slice(k,P)}`,D=P)}}}else D=1;else i(C)&&w.charCodeAt(1)===T&&(v=w.slice(0,2),D=2,g>2&&f(w.charCodeAt(2))&&(_=!0,D=3));if(v.length>0)if(u.length>0){if(v.toLowerCase()!==u.toLowerCase())continue}else u=v;if(c){if(u.length>0)break}else if(r=`${w.slice(D)}\\${r}`,c=_,_&&u.length>0)break}return r=n(r,!c,"\\",f),c?`${u}\\${r}`:`${u}${r}`||"."},normalize(t){E(t,"path");const u=t.length;if(u===0)return".";let r=0,c,s=!1;const w=t.charCodeAt(0);if(u===1)return a(w)?"\\":t;if(f(w))if(s=!0,f(t.charCodeAt(1))){let D=2,v=D;for(;D<u&&!f(t.charCodeAt(D));)D++;if(D<u&&D!==v){const _=t.slice(v,D);for(v=D;D<u&&f(t.charCodeAt(D));)D++;if(D<u&&D!==v){for(v=D;D<u&&!f(t.charCodeAt(D));)D++;if(D===u)return`\\\\${_}\\${t.slice(v)}\\`;D!==v&&(c=`\\\\${_}\\${t.slice(v,D)}`,r=D)}}}else r=1;else i(w)&&t.charCodeAt(1)===T&&(c=t.slice(0,2),r=2,u>2&&f(t.charCodeAt(2))&&(s=!0,r=3));let g=r<u?n(t.slice(r),!s,"\\",f):"";return g.length===0&&!s&&(g="."),g.length>0&&f(t.charCodeAt(u-1))&&(g+="\\"),c===void 0?s?`\\${g}`:g:s?`${c}\\${g}`:`${c}${g}`},isAbsolute(t){E(t,"path");const u=t.length;if(u===0)return!1;const r=t.charCodeAt(0);return f(r)||u>2&&i(r)&&t.charCodeAt(1)===T&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let u,r;for(let w=0;w<t.length;++w){const g=t[w];E(g,"path"),g.length>0&&(u===void 0?u=r=g:u+=`\\${g}`)}if(u===void 0)return".";let c=!0,s=0;if(typeof r=="string"&&f(r.charCodeAt(0))){++s;const w=r.length;w>1&&f(r.charCodeAt(1))&&(++s,w>2&&(f(r.charCodeAt(2))?++s:c=!1))}if(c){for(;s<u.length&&f(u.charCodeAt(s));)s++;s>=2&&(u=`\\${u.slice(s)}`)}return e.win32.normalize(u)},relative(t,u){if(E(t,"from"),E(u,"to"),t===u)return"";const r=e.win32.resolve(t),c=e.win32.resolve(u);if(r===c||(t=r.toLowerCase(),u=c.toLowerCase(),t===u))return"";let s=0;for(;s<t.length&&t.charCodeAt(s)===y;)s++;let w=t.length;for(;w-1>s&&t.charCodeAt(w-1)===y;)w--;const g=w-s;let D=0;for(;D<u.length&&u.charCodeAt(D)===y;)D++;let v=u.length;for(;v-1>D&&u.charCodeAt(v-1)===y;)v--;const _=v-D,C=g<_?g:_;let P=-1,k=0;for(;k<C;k++){const x=t.charCodeAt(s+k);if(x!==u.charCodeAt(D+k))break;x===y&&(P=k)}if(k!==C){if(P===-1)return c}else{if(_>C){if(u.charCodeAt(D+k)===y)return c.slice(D+k+1);if(k===2)return c.slice(D+k)}g>C&&(t.charCodeAt(s+k)===y?P=k:k===2&&(P=3)),P===-1&&(P=0)}let F="";for(k=s+P+1;k<=w;++k)(k===w||t.charCodeAt(k)===y)&&(F+=F.length===0?"..":"\\..");return D+=P,F.length>0?`${F}${c.slice(D,v)}`:(c.charCodeAt(D)===y&&++D,c.slice(D,v))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const u=e.win32.resolve(t);if(u.length<=2)return t;if(u.charCodeAt(0)===y){if(u.charCodeAt(1)===y){const r=u.charCodeAt(2);if(r!==I&&r!==b)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(i(u.charCodeAt(0))&&u.charCodeAt(1)===T&&u.charCodeAt(2)===y)return`\\\\?\\${u}`;return t},dirname(t){E(t,"path");const u=t.length;if(u===0)return".";let r=-1,c=0;const s=t.charCodeAt(0);if(u===1)return f(s)?t:".";if(f(s)){if(r=c=1,f(t.charCodeAt(1))){let D=2,v=D;for(;D<u&&!f(t.charCodeAt(D));)D++;if(D<u&&D!==v){for(v=D;D<u&&f(t.charCodeAt(D));)D++;if(D<u&&D!==v){for(v=D;D<u&&!f(t.charCodeAt(D));)D++;if(D===u)return t;D!==v&&(r=c=D+1)}}}}else i(s)&&t.charCodeAt(1)===T&&(r=u>2&&f(t.charCodeAt(2))?3:2,c=r);let w=-1,g=!0;for(let D=u-1;D>=c;--D)if(f(t.charCodeAt(D))){if(!g){w=D;break}}else g=!1;if(w===-1){if(r===-1)return".";w=r}return t.slice(0,w)},basename(t,u){u!==void 0&&E(u,"ext"),E(t,"path");let r=0,c=-1,s=!0,w;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===T&&(r=2),u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let g=u.length-1,D=-1;for(w=t.length-1;w>=r;--w){const v=t.charCodeAt(w);if(f(v)){if(!s){r=w+1;break}}else D===-1&&(s=!1,D=w+1),g>=0&&(v===u.charCodeAt(g)?--g===-1&&(c=w):(g=-1,c=D))}return r===c?c=D:c===-1&&(c=t.length),t.slice(r,c)}for(w=t.length-1;w>=r;--w)if(f(t.charCodeAt(w))){if(!s){r=w+1;break}}else c===-1&&(s=!1,c=w+1);return c===-1?"":t.slice(r,c)},extname(t){E(t,"path");let u=0,r=-1,c=0,s=-1,w=!0,g=0;t.length>=2&&t.charCodeAt(1)===T&&i(t.charCodeAt(0))&&(u=c=2);for(let D=t.length-1;D>=u;--D){const v=t.charCodeAt(D);if(f(v)){if(!w){c=D+1;break}continue}s===-1&&(w=!1,s=D+1),v===b?r===-1?r=D:g!==1&&(g=1):r!==-1&&(g=-1)}return r===-1||s===-1||g===0||g===1&&r===s-1&&r===c+1?"":t.slice(r,s)},format:l.bind(null,"\\"),parse(t){E(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const r=t.length;let c=0,s=t.charCodeAt(0);if(r===1)return f(s)?(u.root=u.dir=t,u):(u.base=u.name=t,u);if(f(s)){if(c=1,f(t.charCodeAt(1))){let P=2,k=P;for(;P<r&&!f(t.charCodeAt(P));)P++;if(P<r&&P!==k){for(k=P;P<r&&f(t.charCodeAt(P));)P++;if(P<r&&P!==k){for(k=P;P<r&&!f(t.charCodeAt(P));)P++;P===r?c=P:P!==k&&(c=P+1)}}}}else if(i(s)&&t.charCodeAt(1)===T){if(r<=2)return u.root=u.dir=t,u;if(c=2,f(t.charCodeAt(2))){if(r===3)return u.root=u.dir=t,u;c=3}}c>0&&(u.root=t.slice(0,c));let w=-1,g=c,D=-1,v=!0,_=t.length-1,C=0;for(;_>=c;--_){if(s=t.charCodeAt(_),f(s)){if(!v){g=_+1;break}continue}D===-1&&(v=!1,D=_+1),s===b?w===-1?w=_:C!==1&&(C=1):w!==-1&&(C=-1)}return D!==-1&&(w===-1||C===0||C===1&&w===D-1&&w===g+1?u.base=u.name=t.slice(g,D):(u.name=t.slice(g,w),u.base=t.slice(g,D),u.ext=t.slice(w,D))),g>0&&g!==c?u.dir=t.slice(0,g-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(d){const t=/\\/g;return()=>{const u=h.cwd().replace(t,"/");return u.slice(u.indexOf("/"))}}return()=>h.cwd()})();e.posix={resolve(...t){let u="",r=!1;for(let c=t.length-1;c>=-1&&!r;c--){const s=c>=0?t[c]:o();E(s,"path"),s.length!==0&&(u=`${s}/${u}`,r=s.charCodeAt(0)===m)}return u=n(u,!r,"/",a),r?`/${u}`:u.length>0?u:"."},normalize(t){if(E(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===m,r=t.charCodeAt(t.length-1)===m;return t=n(t,!u,"/",a),t.length===0?u?"/":r?"./":".":(r&&(t+="/"),u?`/${t}`:t)},isAbsolute(t){return E(t,"path"),t.length>0&&t.charCodeAt(0)===m},join(...t){if(t.length===0)return".";let u;for(let r=0;r<t.length;++r){const c=t[r];E(c,"path"),c.length>0&&(u===void 0?u=c:u+=`/${c}`)}return u===void 0?".":e.posix.normalize(u)},relative(t,u){if(E(t,"from"),E(u,"to"),t===u||(t=e.posix.resolve(t),u=e.posix.resolve(u),t===u))return"";const r=1,c=t.length,s=c-r,w=1,g=u.length-w,D=s<g?s:g;let v=-1,_=0;for(;_<D;_++){const P=t.charCodeAt(r+_);if(P!==u.charCodeAt(w+_))break;P===m&&(v=_)}if(_===D)if(g>D){if(u.charCodeAt(w+_)===m)return u.slice(w+_+1);if(_===0)return u.slice(w+_)}else s>D&&(t.charCodeAt(r+_)===m?v=_:_===0&&(v=0));let C="";for(_=r+v+1;_<=c;++_)(_===c||t.charCodeAt(_)===m)&&(C+=C.length===0?"..":"/..");return`${C}${u.slice(w+v)}`},toNamespacedPath(t){return t},dirname(t){if(E(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===m;let r=-1,c=!0;for(let s=t.length-1;s>=1;--s)if(t.charCodeAt(s)===m){if(!c){r=s;break}}else c=!1;return r===-1?u?"/":".":u&&r===1?"//":t.slice(0,r)},basename(t,u){u!==void 0&&E(u,"ext"),E(t,"path");let r=0,c=-1,s=!0,w;if(u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let g=u.length-1,D=-1;for(w=t.length-1;w>=0;--w){const v=t.charCodeAt(w);if(v===m){if(!s){r=w+1;break}}else D===-1&&(s=!1,D=w+1),g>=0&&(v===u.charCodeAt(g)?--g===-1&&(c=w):(g=-1,c=D))}return r===c?c=D:c===-1&&(c=t.length),t.slice(r,c)}for(w=t.length-1;w>=0;--w)if(t.charCodeAt(w)===m){if(!s){r=w+1;break}}else c===-1&&(s=!1,c=w+1);return c===-1?"":t.slice(r,c)},extname(t){E(t,"path");let u=-1,r=0,c=-1,s=!0,w=0;for(let g=t.length-1;g>=0;--g){const D=t.charCodeAt(g);if(D===m){if(!s){r=g+1;break}continue}c===-1&&(s=!1,c=g+1),D===b?u===-1?u=g:w!==1&&(w=1):u!==-1&&(w=-1)}return u===-1||c===-1||w===0||w===1&&u===c-1&&u===r+1?"":t.slice(u,c)},format:l.bind(null,"/"),parse(t){E(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const r=t.charCodeAt(0)===m;let c;r?(u.root="/",c=1):c=0;let s=-1,w=0,g=-1,D=!0,v=t.length-1,_=0;for(;v>=c;--v){const C=t.charCodeAt(v);if(C===m){if(!D){w=v+1;break}continue}g===-1&&(D=!1,g=v+1),C===b?s===-1?s=v:_!==1&&(_=1):s!==-1&&(_=-1)}if(g!==-1){const C=w===0&&r?1:w;s===-1||_===0||_===1&&s===g-1&&s===w+1?u.base=u.name=t.slice(C,g):(u.name=t.slice(C,s),u.base=t.slice(C,g),u.ext=t.slice(s,g))}return w>0?u.dir=t.slice(0,w-1):r&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=d?e.win32.normalize:e.posix.normalize,e.isAbsolute=d?e.win32.isAbsolute:e.posix.isAbsolute,e.join=d?e.win32.join:e.posix.join,e.resolve=d?e.win32.resolve:e.posix.resolve,e.relative=d?e.win32.relative:e.posix.relative,e.dirname=d?e.win32.dirname:e.posix.dirname,e.basename=d?e.win32.basename:e.posix.basename,e.extname=d?e.win32.extname:e.posix.extname,e.format=d?e.win32.format:e.posix.format,e.parse=d?e.win32.parse:e.posix.parse,e.toNamespacedPath=d?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=d?e.win32.sep:e.posix.sep,e.delimiter=d?e.win32.delimiter:e.posix.delimiter}),define(_e[132],Ce([1,0,46,17]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareFileNames=b,e.compareFileNamesDefault=m,e.compareFileNamesUpper=y,e.compareFileNamesLower=T,e.compareFileNamesUnicode=I,e.compareFileExtensions=p,e.compareFileExtensionsDefault=S,e.compareFileExtensionsUpper=E,e.compareFileExtensionsLower=d,e.compareFileExtensionsUnicode=f,e.comparePaths=s,e.compareAnything=w,e.compareByPrefix=g;const L=new h.Lazy(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),A=new h.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new h.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(D,v,_=!1){const C=D||"",P=v||"",k=L.value.collator.compare(C,P);return L.value.collatorIsNumeric&&k===0&&C!==P?C<P?-1:1:k}function m(D,v){const _=A.value.collator;return D=D||"",v=v||"",l(_,D,v)}function y(D,v){const _=A.value.collator;return D=D||"",v=v||"",r(D,v)||l(_,D,v)}function T(D,v){const _=A.value.collator;return D=D||"",v=v||"",u(D,v)||l(_,D,v)}function I(D,v){return D=D||"",v=v||"",D===v?0:D<v?-1:1}function p(D,v){const[_,C]=i(D),[P,k]=i(v);let F=L.value.collator.compare(C,k);if(F===0){if(L.value.collatorIsNumeric&&C!==k)return C<k?-1:1;if(F=L.value.collator.compare(_,P),L.value.collatorIsNumeric&&F===0&&_!==P)return _<P?-1:1}return F}function S(D,v){D=D||"",v=v||"";const _=n(D),C=n(v),P=A.value.collator,k=R.value.collator;return l(k,_,C)||l(P,D,v)}function E(D,v){D=D||"",v=v||"";const _=n(D),C=n(v),P=A.value.collator,k=R.value.collator;return l(k,_,C)||r(D,v)||l(P,D,v)}function d(D,v){D=D||"",v=v||"";const _=n(D),C=n(v),P=A.value.collator,k=R.value.collator;return l(k,_,C)||u(D,v)||l(P,D,v)}function f(D,v){D=D||"",v=v||"";const _=n(D).toLowerCase(),C=n(v).toLowerCase();return _!==C?_<C?-1:1:D!==v?D<v?-1:1:0}const a=/^(.*?)(\.([^.]*))?$/;function i(D,v=!1){const _=D?a.exec(D):[];let C=[_&&_[1]||"",_&&_[3]||""];return v&&(!C[0]&&C[1]||C[0]&&C[0].charAt(0)===".")&&(C=[C[0]+"."+C[1],""]),C}function n(D){const v=D?a.exec(D):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function l(D,v,_){const C=D.compare(v,_);return C!==0?C:v.length!==_.length?v.length<_.length?-1:1:0}function o(D){const v=D.charAt(0);return v.toLocaleUpperCase()!==v}function t(D){const v=D.charAt(0);return v.toLocaleLowerCase()!==v}function u(D,v){return o(D)&&t(v)?-1:t(D)&&o(v)?1:0}function r(D,v){return t(D)&&o(v)?-1:o(D)&&t(v)?1:0}function c(D,v,_=!1){return _||(D=D&&D.toLowerCase(),v=v&&v.toLowerCase()),D===v?0:D<v?-1:1}function s(D,v,_=!1){const C=D.split(O.sep),P=v.split(O.sep),k=C.length-1,F=P.length-1;let x,z;for(let N=0;;N++){if(x=k===N,z=F===N,x&&z)return b(C[N],P[N],_);if(x)return-1;if(z)return 1;const M=c(C[N],P[N],_);if(M!==0)return M}}function w(D,v,_){const C=D.toLowerCase(),P=v.toLowerCase(),k=g(D,v,_);if(k)return k;const F=C.endsWith(_),x=P.endsWith(_);if(F!==x)return F?-1:1;const z=b(C,P);return z!==0?z:C.localeCompare(P)}function g(D,v,_){const C=D.toLowerCase(),P=v.toLowerCase(),k=C.startsWith(_),F=P.startsWith(_);if(k!==F)return k?-1:1;if(k&&F){if(C.length<P.length)return-1;if(C.length>P.length)return 1}return 0}}),define(_e[31],Ce([1,0,17,12,14,18]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=R,e.toSlashes=b,e.toPosixPath=m,e.getRoot=y,e.isUNC=T,e.isValidBasename=E,e.isEqual=d,e.isEqualOrParent=f,e.isWindowsDriveLetter=a,e.sanitizeFilePath=i,e.removeTrailingPathSeparator=n,e.isRootOrDriveLetter=l,e.hasDriveLetter=o,e.getDriveLetter=t,e.indexOfPath=u,e.parseLineAndColumnAware=r,e.randomPath=w;function R(g){return g===47||g===92}function b(g){return g.replace(/[\\/]/g,h.posix.sep)}function m(g){return g.indexOf("/")===-1&&(g=b(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}function y(g,D=h.posix.sep){if(!g)return"";const v=g.length,_=g.charCodeAt(0);if(R(_)){if(R(g.charCodeAt(1))&&!R(g.charCodeAt(2))){let P=3;const k=P;for(;P<v&&!R(g.charCodeAt(P));P++);if(k!==P&&!R(g.charCodeAt(P+1))){for(P+=1;P<v;P++)if(R(g.charCodeAt(P)))return g.slice(0,P+1).replace(/[\\/]/g,D)}}return D}else if(a(_)&&g.charCodeAt(1)===58)return R(g.charCodeAt(2))?g.slice(0,2)+D:g.slice(0,2);let C=g.indexOf("://");if(C!==-1){for(C+=3;C<v;C++)if(R(g.charCodeAt(C)))return g.slice(0,C+1)}return""}function T(g){if(!O.isWindows||!g||g.length<5)return!1;let D=g.charCodeAt(0);if(D!==92||(D=g.charCodeAt(1),D!==92))return!1;let v=2;const _=v;for(;v<g.length&&(D=g.charCodeAt(v),D!==92);v++);return!(_===v||(D=g.charCodeAt(v+1),isNaN(D)||D===92))}const I=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function E(g,D=O.isWindows){const v=D?I:p;return!(!g||g.length===0||/^\s+$/.test(g)||(v.lastIndex=0,v.test(g))||D&&S.test(g)||g==="."||g===".."||D&&g[g.length-1]==="."||D&&g.length!==g.trim().length||g.length>255)}function d(g,D,v){const _=g===D;return!v||_?_:!g||!D?!1:(0,L.equalsIgnoreCase)(g,D)}function f(g,D,v,_=h.sep){if(g===D)return!0;if(!g||!D||D.length>g.length)return!1;if(v){if(!(0,L.startsWithIgnoreCase)(g,D))return!1;if(D.length===g.length)return!0;let P=D.length;return D.charAt(D.length-1)===_&&P--,g.charAt(P)===_}return D.charAt(D.length-1)!==_&&(D+=_),g.indexOf(D)===0}function a(g){return g>=65&&g<=90||g>=97&&g<=122}function i(g,D){return O.isWindows&&g.endsWith(":")&&(g+=h.sep),(0,h.isAbsolute)(g)||(g=(0,h.join)(D,g)),g=(0,h.normalize)(g),n(g)}function n(g){return O.isWindows?(g=(0,L.rtrim)(g,h.sep),g.endsWith(":")&&(g+=h.sep)):(g=(0,L.rtrim)(g,h.sep),g||(g=h.sep)),g}function l(g){const D=(0,h.normalize)(g);return O.isWindows?g.length>3?!1:o(D)&&(g.length===2||D.charCodeAt(2)===92):D===h.posix.sep}function o(g,D=O.isWindows){return D?a(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}function t(g,D=O.isWindows){return o(g,D)?g[0]:void 0}function u(g,D,v){return D.length>g.length?-1:g===D?0:(v&&(g=g.toLowerCase(),D=D.toLowerCase()),g.indexOf(D))}function r(g){const D=g.split(":");let v,_,C;for(const P of D){const k=Number(P);(0,A.isNumber)(k)?_===void 0?_=k:C===void 0&&(C=k):v=v?[v,P].join(":"):P}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:_!==void 0?_:void 0,column:C!==void 0?C:_!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function w(g,D,v=8){let _="";for(let P=0;P<v;P++){let k;P===0&&O.isWindows&&!D&&(v===3||v===4)?k=s:k=c,_+=k.charAt(Math.floor(Math.random()*k.length))}let C;return D?C=`${D}-${_}`:C=_,g?(0,h.join)(g,C):C}}),define(_e[133],Ce([1,0,132,127,57,17,12,14]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.scoreFuzzy=T,e.scoreFuzzy2=f,e.scoreItemFuzzy=r,e.compareItemsByFuzzyScore=_,e.prepareQuery=z,e.pieceToQuery=M;const m=0,y=[m,[]];function T(W,X,te,H){if(!W||!X)return y;const G=W.length,Y=X.length;if(G<Y)return y;const ne=W.toLowerCase();return I(X,te,Y,W,ne,G,H)}function I(W,X,te,H,G,Y,ne){const pe=[],le=[];for(let ee=0;ee<te;ee++){const ve=ee*Y,Pe=ve-Y,oe=ee>0,se=W[ee],re=X[ee];for(let j=0;j<Y;j++){const ie=j>0,me=ve+j,be=me-1,Ae=Pe+j-1,fe=ie?pe[be]:0,De=oe&&ie?pe[Ae]:0,Te=oe&&ie?le[Ae]:0;let ze;!De&&oe?ze=0:ze=p(se,re,H,G,j,Te),ze&&De+ze>=fe&&(ne||oe||G.startsWith(X,j))?(le[me]=Te+1,pe[me]=De+ze):(le[me]=m,pe[me]=fe)}}const we=[];let Z=te-1,B=Y-1;for(;Z>=0&&B>=0;){const ee=Z*Y+B;le[ee]===m||(we.push(B),Z--),B--}return[pe[te*Y-1],we.reverse()]}function p(W,X,te,H,G,Y){let ne=0;if(!S(X,H[G]))return ne;if(ne+=1,Y>0&&(ne+=Y*5),W===te[G]&&(ne+=1),G===0)ne+=8;else{const pe=E(te.charCodeAt(G-1));pe?ne+=pe:(0,O.isUpper)(te.charCodeAt(G))&&Y===0&&(ne+=2)}return ne}function S(W,X){return W===X?!0:W==="/"||W==="\\"?X==="/"||X==="\\":!1}function E(W){switch(W){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const d=[void 0,[]];function f(W,X,te=0,H=0){const G=X;return G.values&&G.values.length>1?a(W,G.values,te,H):i(W,X,te,H)}function a(W,X,te,H){let G=0;const Y=[];for(const ne of X){const[pe,le]=i(W,ne,te,H);if(typeof pe!="number")return d;G+=pe,Y.push(...le)}return[G,D(Y)]}function i(W,X,te,H){const G=(0,O.fuzzyScore)(X.original,X.originalLowercase,te,W,W.toLowerCase(),H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return G?[G[0],(0,O.createMatches)(G)]:d}const n=Object.freeze({score:0}),l=1<<18,o=1<<17,t=65536;function u(W,X,te,H){const G=H.values?H.values:[H];return(0,L.hash)({[H.normalized]:{values:G.map(ne=>({value:ne.normalized,expectContiguousMatch:ne.expectContiguousMatch})),label:W,description:X,allowNonContiguousMatches:te}})}function r(W,X,te,H,G){if(!W||!X.normalized)return n;const Y=H.getItemLabel(W);if(!Y)return n;const ne=H.getItemDescription(W),pe=u(Y,ne,te,X),le=G[pe];if(le)return le;const we=c(Y,ne,H.getItemPath(W),X,te);return G[pe]=we,we}function c(W,X,te,H,G){const Y=!te||!H.containsPathSeparator;return te&&(R.isLinux?H.pathNormalized===te:(0,b.equalsIgnoreCase)(H.pathNormalized,te))?{score:l,labelMatch:[{start:0,end:W.length}],descriptionMatch:X?[{start:0,end:X.length}]:void 0}:H.values&&H.values.length>1?s(W,X,te,H.values,Y,G):w(W,X,te,H,Y,G)}function s(W,X,te,H,G,Y){let ne=0;const pe=[],le=[];for(const we of H){const{score:Z,labelMatch:B,descriptionMatch:ee}=w(W,X,te,we,G,Y);if(Z===m)return n;ne+=Z,B&&pe.push(...B),ee&&le.push(...ee)}return{score:ne,labelMatch:D(pe),descriptionMatch:D(le)}}function w(W,X,te,H,G,Y){if(G||!X){const[ne,pe]=T(W,H.normalized,H.normalizedLowercase,Y&&!H.expectContiguousMatch);if(ne){const le=(0,O.matchesPrefix)(H.normalized,W);let we;if(le){we=o;const Z=Math.round(H.normalized.length/W.length*100);we+=Z}else we=t;return{score:we+ne,labelMatch:le||g(pe)}}}if(X){let ne=X;te&&(ne=`${X}${A.sep}`);const pe=ne.length,le=`${ne}${W}`,[we,Z]=T(le,H.normalized,H.normalizedLowercase,Y&&!H.expectContiguousMatch);if(we){const B=g(Z),ee=[],ve=[];return B.forEach(Pe=>{Pe.start<pe&&Pe.end>pe?(ee.push({start:0,end:Pe.end-pe}),ve.push({start:Pe.start,end:pe})):Pe.start>=pe?ee.push({start:Pe.start-pe,end:Pe.end-pe}):ve.push(Pe)}),{score:we,labelMatch:ee,descriptionMatch:ve}}}return n}function g(W){const X=[];if(!W)return X;let te;for(const H of W)te&&te.end===H?te.end+=1:(te={start:H,end:H+1},X.push(te));return X}function D(W){const X=W.sort((G,Y)=>G.start-Y.start),te=[];let H;for(const G of X)!H||!v(H,G)?(H=G,te.push(G)):(H.start=Math.min(H.start,G.start),H.end=Math.max(H.end,G.end));return te}function v(W,X){return!(W.end<X.start||X.end<W.start)}function _(W,X,te,H,G,Y){const ne=r(W,te,H,G,Y),pe=r(X,te,H,G,Y),le=ne.score,we=pe.score;if((le===l||we===l)&&le!==we)return le===l?-1:1;if(le>t||we>t){if(le!==we)return le>we?-1:1;if(le<o&&we<o){const se=P(ne.labelMatch,pe.labelMatch);if(se!==0)return se}const Pe=G.getItemLabel(W)||"",oe=G.getItemLabel(X)||"";if(Pe.length!==oe.length)return Pe.length-oe.length}if(le!==we)return le>we?-1:1;const Z=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0,B=Array.isArray(pe.labelMatch)&&pe.labelMatch.length>0;if(Z&&!B)return-1;if(B&&!Z)return 1;const ee=C(W,ne,G),ve=C(X,pe,G);return ee&&ve&&ee!==ve?ve>ee?-1:1:k(W,X,te,G)}function C(W,X,te){let H=-1,G=-1;if(X.descriptionMatch&&X.descriptionMatch.length?H=X.descriptionMatch[0].start:X.labelMatch&&X.labelMatch.length&&(H=X.labelMatch[0].start),X.labelMatch&&X.labelMatch.length){if(G=X.labelMatch[X.labelMatch.length-1].end,X.descriptionMatch&&X.descriptionMatch.length){const Y=te.getItemDescription(W);Y&&(G+=Y.length)}}else X.descriptionMatch&&X.descriptionMatch.length&&(G=X.descriptionMatch[X.descriptionMatch.length-1].end);return G-H}function P(W,X){if(!W&&!X||(!W||!W.length)&&(!X||!X.length))return 0;if(!X||!X.length)return-1;if(!W||!W.length)return 1;const te=W[0].start,G=W[W.length-1].end-te,Y=X[0].start,pe=X[X.length-1].end-Y;return G===pe?0:pe<G?1:-1}function k(W,X,te,H){const G=H.getItemLabel(W)||"",Y=H.getItemLabel(X)||"",ne=H.getItemDescription(W),pe=H.getItemDescription(X),le=G.length+(ne?ne.length:0),we=Y.length+(pe?pe.length:0);if(le!==we)return le-we;const Z=H.getItemPath(W),B=H.getItemPath(X);return Z&&B&&Z.length!==B.length?Z.length-B.length:G!==Y?(0,h.compareAnything)(G,Y,te.normalized):ne&&pe&&ne!==pe?(0,h.compareAnything)(ne,pe,te.normalized):Z&&B&&Z!==B?(0,h.compareAnything)(Z,B,te.normalized):0}function F(W){return W.startsWith('"')&&W.endsWith('"')}const x=" ";function z(W){typeof W!="string"&&(W="");const X=W.toLowerCase(),{pathNormalized:te,normalized:H,normalizedLowercase:G}=N(W),Y=te.indexOf(A.sep)>=0,ne=F(W);let pe;const le=W.split(x);if(le.length>1)for(const we of le){const Z=F(we),{pathNormalized:B,normalized:ee,normalizedLowercase:ve}=N(we);ee&&(pe||(pe=[]),pe.push({original:we,originalLowercase:we.toLowerCase(),pathNormalized:B,normalized:ee,normalizedLowercase:ve,expectContiguousMatch:Z}))}return{original:W,originalLowercase:X,pathNormalized:te,normalized:H,normalizedLowercase:G,values:pe,containsPathSeparator:Y,expectContiguousMatch:ne}}function N(W){let X;R.isWindows?X=W.replace(/\//g,A.sep):X=W.replace(/\\/g,A.sep);const te=(0,b.stripWildcards)(X).replace(/\s|"/g,"");return{pathNormalized:X,normalized:te,normalizedLowercase:te.toLowerCase()}}function M(W){return Array.isArray(W)?z(W.map(X=>X.original).join(x)):z(W.original)}}),define(_e[101],Ce([1,0,17]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Mimes=void 0,e.getMediaOrTextMime=A,e.getMediaMime=R,e.getExtensionForMimeType=b,e.normalizeMimeType=y,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(T){const I=(0,h.extname)(T),p=O[I.toLowerCase()];return p!==void 0?p:R(T)}function R(T){const I=(0,h.extname)(T);return L[I.toLowerCase()]}function b(T){for(const I in L)if(L[I]===T)return I}const m=/^(.+)\/(.+?)(;.+)?$/;function y(T,I){const p=m.exec(T);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:I?void 0:T}}),define(_e[102],Ce([1,0,12]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=A,e.removeDangerousEnvVariables=R;var O;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(O||(e.Source=O={}));var L;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function A(b,...m){const y=m.reduce((p,S)=>(p[S]=!0,p),{}),T=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(p=>!y[p]).forEach(p=>{for(let S=0;S<T.length;S++)if(p.search(T[S])!==-1){delete b[p];break}})}function R(b){b&&(delete b.DEBUG,h.isMacintosh&&delete b.DYLD_LIBRARY_PATH,h.isLinux&&delete b.LD_PRELOAD)}}),define(_e[2],Ce([1,0,17,12]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=E,e.uriToFsPath=l;const L=/^\w[\w\d+.-]*$/,A=/^\//,R=/^\/\//;function b(c,s){if(!c.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!L.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!A.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(c,s){return!c&&!s?"file":c}function y(c,s){switch(c){case"https":case"http":case"file":s?s[0]!==I&&(s=I+s):s=I;break}return s}const T="",I="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{static isUri(s){return s instanceof S?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,w,g,D,v,_=!1){typeof s=="object"?(this.scheme=s.scheme||T,this.authority=s.authority||T,this.path=s.path||T,this.query=s.query||T,this.fragment=s.fragment||T):(this.scheme=m(s,_),this.authority=w||T,this.path=y(this.scheme,g||T),this.query=D||T,this.fragment=v||T,b(this,_))}get fsPath(){return l(this,!1)}with(s){if(!s)return this;let{scheme:w,authority:g,path:D,query:v,fragment:_}=s;return w===void 0?w=this.scheme:w===null&&(w=T),g===void 0?g=this.authority:g===null&&(g=T),D===void 0?D=this.path:D===null&&(D=T),v===void 0?v=this.query:v===null&&(v=T),_===void 0?_=this.fragment:_===null&&(_=T),w===this.scheme&&g===this.authority&&D===this.path&&v===this.query&&_===this.fragment?this:new f(w,g,D,v,_)}static parse(s,w=!1){const g=p.exec(s);return g?new f(g[2]||T,r(g[4]||T),r(g[5]||T),r(g[7]||T),r(g[9]||T),w):new f(T,T,T,T,T)}static file(s){let w=T;if(O.isWindows&&(s=s.replace(/\\/g,I)),s[0]===I&&s[1]===I){const g=s.indexOf(I,2);g===-1?(w=s.substring(2),s=I):(w=s.substring(2,g),s=s.substring(g)||I)}return new f("file",w,s,T,T)}static from(s,w){return new f(s.scheme,s.authority,s.path,s.query,s.fragment,w)}static joinPath(s,...w){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return O.isWindows&&s.scheme==="file"?g=S.file(h.win32.join(l(s,!0),...w)).path:g=h.posix.join(s.path,...w),s.with({path:g})}toString(s=!1){return o(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof S)return s;{const w=new f(s);return w._formatted=s.external??null,w._fsPath=s._sep===d?s.fsPath??null:null,w}}else return s}}e.URI=S;function E(c){return!c||typeof c!="object"?!1:typeof c.scheme=="string"&&(typeof c.authority=="string"||typeof c.authority>"u")&&(typeof c.path=="string"||typeof c.path>"u")&&(typeof c.query=="string"||typeof c.query>"u")&&(typeof c.fragment=="string"||typeof c.fragment>"u")}const d=O.isWindows?1:void 0;class f extends S{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(s=!1){return s?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=d),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const a={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function i(c,s,w){let g,D=-1;for(let v=0;v<c.length;v++){const _=c.charCodeAt(v);if(_>=97&&_<=122||_>=65&&_<=90||_>=48&&_<=57||_===45||_===46||_===95||_===126||s&&_===47||w&&_===91||w&&_===93||w&&_===58)D!==-1&&(g+=encodeURIComponent(c.substring(D,v)),D=-1),g!==void 0&&(g+=c.charAt(v));else{g===void 0&&(g=c.substr(0,v));const C=a[_];C!==void 0?(D!==-1&&(g+=encodeURIComponent(c.substring(D,v)),D=-1),g+=C):D===-1&&(D=v)}}return D!==-1&&(g+=encodeURIComponent(c.substring(D))),g!==void 0?g:c}function n(c){let s;for(let w=0;w<c.length;w++){const g=c.charCodeAt(w);g===35||g===63?(s===void 0&&(s=c.substr(0,w)),s+=a[g]):s!==void 0&&(s+=c[w])}return s!==void 0?s:c}function l(c,s){let w;return c.authority&&c.path.length>1&&c.scheme==="file"?w=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===47&&(c.path.charCodeAt(1)>=65&&c.path.charCodeAt(1)<=90||c.path.charCodeAt(1)>=97&&c.path.charCodeAt(1)<=122)&&c.path.charCodeAt(2)===58?s?w=c.path.substr(1):w=c.path[1].toLowerCase()+c.path.substr(2):w=c.path,O.isWindows&&(w=w.replace(/\//g,"\\")),w}function o(c,s){const w=s?n:i;let g="",{scheme:D,authority:v,path:_,query:C,fragment:P}=c;if(D&&(g+=D,g+=":"),(v||D==="file")&&(g+=I,g+=I),v){let k=v.indexOf("@");if(k!==-1){const F=v.substr(0,k);v=v.substr(k+1),k=F.lastIndexOf(":"),k===-1?g+=w(F,!1,!1):(g+=w(F.substr(0,k),!1,!1),g+=":",g+=w(F.substr(k+1),!1,!0)),g+="@"}v=v.toLowerCase(),k=v.lastIndexOf(":"),k===-1?g+=w(v,!1,!0):(g+=w(v.substr(0,k),!1,!0),g+=v.substr(k))}if(_){if(_.length>=3&&_.charCodeAt(0)===47&&_.charCodeAt(2)===58){const k=_.charCodeAt(1);k>=65&&k<=90&&(_=`/${String.fromCharCode(k+32)}:${_.substr(3)}`)}else if(_.length>=2&&_.charCodeAt(1)===58){const k=_.charCodeAt(0);k>=65&&k<=90&&(_=`${String.fromCharCode(k+32)}:${_.substr(2)}`)}g+=w(_,!0,!1)}return C&&(g+="?",g+=w(C,!1,!1)),P&&(g+="#",g+=s?P:i(P,!1,!1)),g}function t(c){try{return decodeURIComponent(c)}catch{return c.length>3?c.substr(0,3)+t(c.substr(3)):c}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(c){return c.match(u)?c.replace(u,s=>t(s)):c}}),define(_e[197],Ce([1,0,2]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=O,e.parse=L,e.getFirstFrame=A,e.log=b;function O(y){const T=y;return T&&typeof T.type=="string"&&typeof T.severity=="string"}function L(y){const T=[];let I;try{const p=JSON.parse(y.arguments),S=p[p.length-1];S&&S.__$stack&&(p.pop(),I=S.__$stack),T.push(...p)}catch{T.push("Unable to log remote console arguments",y.arguments)}return{args:T,stack:I}}function A(y){if(typeof y!="string")return A(L(y).stack);const T=y;if(T){const I=R(T),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(p&&p.length===4)return{uri:h.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}function R(y){if(!y)return y;const T=y.indexOf(`
`);return T===-1?y:y.substring(0,T)}function b(y,T){const{args:I,stack:p}=L(y),S=typeof I[0]=="string"&&I.length===1;let E=R(p);E&&(E=`(${E.trim()})`);let d=[];if(typeof I[0]=="string"?E&&S?d=[`%c[${T}] %c${I[0]} %c${E}`,m("blue"),m(""),m("grey")]:d=[`%c[${T}] %c${I[0]}`,m("blue"),m(""),...I.slice(1)]:d=[`%c[${T}]%`,m("blue"),...I],E&&!S&&d.push(E),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,d)}function m(y){return`color: ${y}`}}),define(_e[58],Ce([1,0,21,2]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=L,e.parse=A,e.revive=b;function L(m){return JSON.stringify(m,R)}function A(m){let y=JSON.parse(m);return y=b(y),y}function R(m,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function b(m,y=0){if(!m||y>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return O.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof h.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let T=0;T<m.length;++T)m[T]=b(m[T],y+1);else for(const T in m)Object.hasOwnProperty.call(m,T)&&(m[T]=b(m[T],y+1))}return m}}),define(_e[15],Ce([1,0,13,12,14,2,17]),function(ue,e,h,O,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=m,e.matchesSomeScheme=y,e.getServerRootPath=I;var b;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeManagedRemoteResource="vscode-managed-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.vscodeChatCodeBlock="vscode-chat-code-block",E.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",E.vscodeChatSesssion="vscode-chat-editor",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm",E.commentsInput="comment",E.codeSetting="code-setting"})(b||(e.Schemas=b={}));function m(E,d){return A.URI.isUri(E)?(0,L.equalsIgnoreCase)(E.scheme,d):(0,L.startsWithIgnoreCase)(E,d+":")}function y(E,...d){return d.some(f=>m(E,f))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(d){this._preferredWebSchema=d}setDelegate(d){this._delegate=d}setServerRootPath(d,f){this._serverRootPath=I(d,f)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return R.posix.join(this._serverRootPath,b.vscodeRemoteResource)}set(d,f,a){this._hosts[d]=f,this._ports[d]=a}setConnectionToken(d,f){this._connectionTokens[d]=f}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(d){if(this._delegate)try{return this._delegate(d)}catch(o){return h.onUnexpectedError(o),d}const f=d.authority;let a=this._hosts[f];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const i=this._ports[f],n=this._connectionTokens[f];let l=`path=${encodeURIComponent(d.path)}`;return typeof n=="string"&&(l+=`&${e.connectionTokenQueryName}=${encodeURIComponent(n)}`),A.URI.from({scheme:O.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${a}:${i}`,path:this._remoteResourcesPath,query:l})}}e.RemoteAuthorities=new T;function I(E,d){return R.posix.join(d??"/",`${E.quality??"oss"}-${E.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class p{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(d){const f=this.toUri(d,ue);return this.uriToBrowserUri(f)}uriToBrowserUri(d){return d.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(d):d.scheme===b.file&&(O.isNative||O.webWorkerOrigin===`${b.vscodeFileResource}://${p.FALLBACK_AUTHORITY}`)?d.with({scheme:b.vscodeFileResource,authority:d.authority||p.FALLBACK_AUTHORITY,query:null,fragment:null}):d}asFileUri(d){const f=this.toUri(d,ue);return this.uriToFileUri(f)}uriToFileUri(d){return d.scheme===b.vscodeFileResource?d.with({scheme:b.file,authority:d.authority!==p.FALLBACK_AUTHORITY?d.authority:null,query:null,fragment:null}):d}toUri(d,f){return A.URI.isUri(d)?d:A.URI.parse(f.toUrl(d))}}e.FileAccess=new p;var S;(function(E){const d=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(d.get("3"));const f="vscode-coi";function a(n){let l;typeof n=="string"?l=new URL(n).searchParams:n instanceof URL?l=n.searchParams:A.URI.isUri(n)&&(l=new URL(n.toString(!0)).searchParams);const o=l?.get(f);if(o)return d.get(o)}E.getHeadersFromQuery=a;function i(n,l,o){if(!globalThis.crossOriginIsolated)return;const t=l&&o?"3":o?"2":"1";n instanceof URLSearchParams?n.set(f,t):n[f]=t}E.addSearchParam=i})(S||(e.COI=S={}))}),define(_e[198],Ce([1,0,163,15,12,2]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=T;class R{constructor(p,S,E){this.id=p,this.dependencies=S,this.callback=E}}class b{static{this.INSTANCE=new b}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(p,S,E)=>{typeof p!="string"&&(E=S,S=p,p=null),(typeof S!="object"||!Array.isArray(S))&&(E=S,S=null),this._defineCalls.push(new R(p,S,E))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this._initialize();const S=await(this._isWebWorker?this._workerLoadScript(p):this._isRenderer?this._rendererLoadScript(p):this._nodeJSLoadScript(p));if(!S)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(S.dependencies)&&S.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${S.dependencies.join(", ")}`);return typeof S.callback=="function"?S.callback([]):S.callback}_rendererLoadScript(p){return new Promise((S,E)=>{const d=document.createElement("script");d.setAttribute("async","async"),d.setAttribute("type","text/javascript");const f=()=>{d.removeEventListener("load",a),d.removeEventListener("error",i)},a=n=>{f(),S(this._defineCalls.pop())},i=n=>{f(),E(n)};d.addEventListener("load",a),d.addEventListener("error",i),this._amdPolicy&&(p=this._amdPolicy.createScriptURL(p)),d.setAttribute("src",p),window.document.getElementsByTagName("head")[0].appendChild(d)})}_workerLoadScript(p){return new Promise((S,E)=>{try{this._amdPolicy&&(p=this._amdPolicy.createScriptURL(p)),importScripts(p),S(this._defineCalls.pop())}catch(d){E(d)}})}async _nodeJSLoadScript(p){try{const S=globalThis._VSCODE_NODE_MODULES.fs,E=globalThis._VSCODE_NODE_MODULES.vm,d=globalThis._VSCODE_NODE_MODULES.module,f=A.URI.parse(p).fsPath,a=S.readFileSync(f).toString(),i=d.wrap(a.replace(/^#!.*/,""));return new E.Script(i).runInThisContext().apply(),this._defineCalls.pop()}catch(S){throw S}}}const m=new Map;let y={};typeof globalThis.require=="object"&&(y=globalThis.require.paths??{});async function T(I,p,S){if(h.isESM){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),y[I]&&(I=y[I]);const E=`${I}/${p}`;if(m.has(E))return m.get(E);let d;if(/^\w[\w\d+.-]*:\/\//.test(E))d=E;else{const n=`${S&&!L.isWeb?O.nodeModulesAsarPath:O.nodeModulesPath}/${E}`;d=O.FileAccess.asBrowserUri(n).toString(!0)}const f=b.INSTANCE.load(d);return m.set(E,f),f}else return await new Promise((E,d)=>{ue([I],E,d)})}}),define(_e[23],Ce([1,0,31,15,17,12,14,2]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=m,e.distinctParents=T,e.toLocalResource=p;function m(S){return(0,b.uriToFsPath)(S,!0)}class y{constructor(E){this._ignorePathCasing=E}compare(E,d,f=!1){return E===d?0:(0,R.compare)(this.getComparisonKey(E,f),this.getComparisonKey(d,f))}isEqual(E,d,f=!1){return E===d?!0:!E||!d?!1:this.getComparisonKey(E,f)===this.getComparisonKey(d,f)}getComparisonKey(E,d=!1){return E.with({path:this._ignorePathCasing(E)?E.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(E){return this._ignorePathCasing(E)}isEqualOrParent(E,d,f=!1){if(E.scheme===d.scheme){if(E.scheme===O.Schemas.file)return h.isEqualOrParent(m(E),m(d),this._ignorePathCasing(E))&&E.query===d.query&&(f||E.fragment===d.fragment);if((0,e.isEqualAuthority)(E.authority,d.authority))return h.isEqualOrParent(E.path,d.path,this._ignorePathCasing(E),"/")&&E.query===d.query&&(f||E.fragment===d.fragment)}return!1}joinPath(E,...d){return b.URI.joinPath(E,...d)}basenameOrAuthority(E){return(0,e.basename)(E)||E.authority}basename(E){return L.posix.basename(E.path)}extname(E){return L.posix.extname(E.path)}dirname(E){if(E.path.length===0)return E;let d;return E.scheme===O.Schemas.file?d=b.URI.file(L.dirname(m(E))).path:(d=L.posix.dirname(E.path),E.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${E.toString})) resulted in a relative path`),d="/")),E.with({path:d})}normalizePath(E){if(!E.path.length)return E;let d;return E.scheme===O.Schemas.file?d=b.URI.file(L.normalize(m(E))).path:d=L.posix.normalize(E.path),E.with({path:d})}relativePath(E,d){if(E.scheme!==d.scheme||!(0,e.isEqualAuthority)(E.authority,d.authority))return;if(E.scheme===O.Schemas.file){const i=L.relative(m(E),m(d));return A.isWindows?h.toSlashes(i):i}let f=E.path||"/";const a=d.path||"/";if(this._ignorePathCasing(E)){let i=0;for(const n=Math.min(f.length,a.length);i<n&&!(f.charCodeAt(i)!==a.charCodeAt(i)&&f.charAt(i).toLowerCase()!==a.charAt(i).toLowerCase());i++);f=a.substr(0,i)+f.substr(i)}return L.posix.relative(f,a)}resolvePath(E,d){if(E.scheme===O.Schemas.file){const f=b.URI.file(L.resolve(m(E),d));return E.with({authority:f.authority,path:f.path})}return d=h.toPosixPath(d),E.with({path:L.posix.resolve(E.path,d)})}isAbsolutePath(E){return!!E.path&&E.path[0]==="/"}isEqualAuthority(E,d){return E===d||E!==void 0&&d!==void 0&&(0,R.equalsIgnoreCase)(E,d)}hasTrailingPathSeparator(E,d=L.sep){if(E.scheme===O.Schemas.file){const f=m(E);return f.length>h.getRoot(f).length&&f[f.length-1]===d}else{const f=E.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(E.fsPath)}}removeTrailingPathSeparator(E,d=L.sep){return(0,e.hasTrailingPathSeparator)(E,d)?E.with({path:E.path.substr(0,E.path.length-1)}):E}addTrailingPathSeparator(E,d=L.sep){let f=!1;if(E.scheme===O.Schemas.file){const a=m(E);f=a!==void 0&&a.length===h.getRoot(a).length&&a[a.length-1]===d}else{d="/";const a=E.path;f=a.length===1&&a.charCodeAt(a.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(E,d)?E.with({path:E.path+"/"}):E}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(S=>S.scheme===O.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new y(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(S,E){const d=[];for(let f=0;f<S.length;f++){const a=E(S[f]);S.some((i,n)=>n===f?!1:(0,e.isEqualOrParent)(a,E(i)))||d.push(S[f])}return d}var I;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function E(d){const f=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(n=>{const[l,o]=n.split(":");l&&o&&f.set(l,o)});const i=d.path.substring(0,d.path.indexOf(";"));return i&&f.set(S.META_DATA_MIME,i),f}S.parseMetaData=E})(I||(e.DataUri=I={}));function p(S,E,d){if(E){let f=S.path;return f&&f[0]!==L.posix.sep&&(f=L.posix.sep+f),S.with({scheme:d,authority:E,path:f})}return S.with({scheme:d})}}),define(_e[7],Ce([1,0,22,13,4,3,23,12,174,46]),function(ue,e,h,O,L,A,R,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=T,e.createCancelablePromise=I,e.raceCancellation=p,e.raceCancellationError=S,e.raceCancellablePromises=E,e.raceTimeout=d,e.asPromise=f,e.promiseWithResolvers=a,e.timeout=w,e.disposableTimeout=g,e.sequence=D,e.first=v,e.firstParallel=_,e.retry=G,e.createCancelableAsyncIterable=oe;function T(re){return!!re&&typeof re.then=="function"}function I(re){const j=new h.CancellationTokenSource,ie=re(j.token),me=new Promise((be,Ae)=>{const fe=j.token.onCancellationRequested(()=>{fe.dispose(),Ae(new O.CancellationError)});Promise.resolve(ie).then(De=>{fe.dispose(),j.dispose(),be(De)},De=>{fe.dispose(),j.dispose(),Ae(De)})});return new class{cancel(){j.cancel(),j.dispose()}then(be,Ae){return me.then(be,Ae)}catch(be){return this.then(void 0,be)}finally(be){return me.finally(be)}}}function p(re,j,ie){return new Promise((me,be)=>{const Ae=j.onCancellationRequested(()=>{Ae.dispose(),me(ie)});re.then(me,be).finally(()=>Ae.dispose())})}function S(re,j){return new Promise((ie,me)=>{const be=j.onCancellationRequested(()=>{be.dispose(),me(new O.CancellationError)});re.then(ie,me).finally(()=>be.dispose())})}async function E(re){let j=-1;const ie=re.map((me,be)=>me.then(Ae=>(j=be,Ae)));try{return await Promise.race(ie)}finally{re.forEach((me,be)=>{be!==j&&me.cancel()})}}function d(re,j,ie){let me;const be=setTimeout(()=>{me?.(void 0),ie?.()},j);return Promise.race([re.finally(()=>clearTimeout(be)),new Promise(Ae=>me=Ae)])}function f(re){return new Promise((j,ie)=>{const me=re();T(me)?me.then(j,ie):j(me)})}function a(){let re,j;return{promise:new Promise((me,be)=>{re=me,j=be}),resolve:re,reject:j}}class i{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(j){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=j,!this.queuedPromise){const ie=()=>{if(this.queuedPromise=null,this.isDisposed)return;const me=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,me};this.queuedPromise=new Promise(me=>{this.activePromise.then(ie,ie).then(me)})}return new Promise((ie,me)=>{this.queuedPromise.then(ie,me)})}return this.activePromise=j(),new Promise((ie,me)=>{this.activePromise.then(be=>{this.activePromise=null,ie(be)},be=>{this.activePromise=null,me(be)})})}dispose(){this.isDisposed=!0}}e.Throttler=i;class n{constructor(){this.current=Promise.resolve(null)}queue(j){return this.current=this.current.then(()=>j(),()=>j())}}e.Sequencer=n;class l{constructor(){this.promiseMap=new Map}queue(j,ie){const be=(this.promiseMap.get(j)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.promiseMap.get(j)===be&&this.promiseMap.delete(j)});return this.promiseMap.set(j,be),be}}e.SequencerByKey=l;const o=(re,j)=>{let ie=!0;const me=setTimeout(()=>{ie=!1,j()},re);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(me),ie=!1}}},t=re=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,re())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};class u{constructor(j){this.defaultDelay=j,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(j,ie=this.defaultDelay){this.task=j,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((be,Ae)=>{this.doResolve=be,this.doReject=Ae}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const be=this.task;return this.task=null,be()}}));const me=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ie===m.MicrotaskDelay?t(me):o(ie,me),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new O.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class r{constructor(j){this.delayer=new u(j),this.throttler=new i}trigger(j,ie){return this.delayer.trigger(()=>this.throttler.queue(j),ie)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=r;class c{constructor(){this._isOpen=!1,this._promise=new Promise((j,ie)=>{this._completePromise=j})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class s extends c{constructor(j){super(),this._timeout=setTimeout(()=>this.open(),j)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function w(re,j){return j?new Promise((ie,me)=>{const be=setTimeout(()=>{Ae.dispose(),ie()},re),Ae=j.onCancellationRequested(()=>{clearTimeout(be),Ae.dispose(),me(new O.CancellationError)})}):I(ie=>w(re,ie))}function g(re,j=0,ie){const me=setTimeout(()=>{re(),ie&&be.dispose()},j),be=(0,A.toDisposable)(()=>{clearTimeout(me),ie?.deleteAndLeak(be)});return ie?.add(be),be}function D(re){const j=[];let ie=0;const me=re.length;function be(){return ie<me?re[ie++]():null}function Ae(fe){fe!=null&&j.push(fe);const De=be();return De?De.then(Ae):Promise.resolve(j)}return Promise.resolve(null).then(Ae)}function v(re,j=me=>!!me,ie=null){let me=0;const be=re.length,Ae=()=>{if(me>=be)return Promise.resolve(ie);const fe=re[me++];return Promise.resolve(fe()).then(Te=>j(Te)?Promise.resolve(Te):Ae())};return Ae()}function _(re,j=me=>!!me,ie=null){if(re.length===0)return Promise.resolve(ie);let me=re.length;const be=()=>{me=-1;for(const Ae of re)Ae.cancel?.()};return new Promise((Ae,fe)=>{for(const De of re)De.then(Te=>{--me>=0&&j(Te)?(be(),Ae(Te)):me===0&&Ae(ie)}).catch(Te=>{--me>=0&&(be(),fe(Te))})})}class C{constructor(j){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=j,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new L.Emitter}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(j){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((ie,me)=>{this.outstandingPromises.push({factory:j,c:ie,e:me}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const j=this.outstandingPromises.shift();this.runningPromises++;const ie=j.factory();ie.then(j.c,j.e),ie.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=C;class P extends C{constructor(){super(1)}}e.Queue=P;class k{constructor(){this.sequentializer=new Y,this.tasks=0}queue(j){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,j())):this.sequentializer.run(this.tasks++,j())}}e.LimitedQueue=k;class F{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const j=new le;return this.drainers.add(j),j.p}isDrained(){for(const[,j]of this.queues)if(j.size>0)return!1;return!0}queueSize(j,ie=R.extUri){const me=ie.getComparisonKey(j);return this.queues.get(me)?.size??0}queueFor(j,ie,me=R.extUri){const be=me.getComparisonKey(j);let Ae=this.queues.get(be);if(!Ae){Ae=new P;const fe=this.drainListenerCount++,De=L.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.queues.delete(be),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(fe),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new A.DisposableMap),this.drainListeners.set(fe,De),this.queues.set(be,Ae)}return Ae.queue(ie)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const j of this.drainers)j.complete();this.drainers.clear()}dispose(){for(const[,j]of this.queues)j.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=F;class x{constructor(j,ie){this._token=-1,typeof j=="function"&&typeof ie=="number"&&this.setIfNotSet(j,ie)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(j,ie){this.cancel(),this._token=setTimeout(()=>{this._token=-1,j()},ie)}setIfNotSet(j,ie){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,j()},ie))}}e.TimeoutTimer=x;class z{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(j,ie,me=globalThis){this.cancel();const be=me.setInterval(()=>{j()},ie);this.disposable=(0,A.toDisposable)(()=>{me.clearInterval(be),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=z;class N{constructor(j,ie){this.timeoutToken=-1,this.runner=j,this.timeout=ie,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(j=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,j)}get delay(){return this.timeout}set delay(j){this.timeout=j}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=N;class M{constructor(j,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.runner=j,this.timeout=ie,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(j=this.timeout){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(j/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=M;class W extends N{constructor(j,ie){super(j,ie),this.units=[]}work(j){this.units.push(j),this.isScheduled()||this.schedule()}doRun(){const j=this.units;this.units=[],this.runner?.(j)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=W;class X extends A.Disposable{constructor(j,ie){super(),this.options=j,this.handler=ie,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(j){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+j.length>this.options.maxBufferedWork)return!1}else if(this.pending+j.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const ie of j)this.pendingWork.push(ie);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new N(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=X,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(re,j)=>{(0,b.setTimeout0)(()=>{if(ie)return;const me=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e._runWhenIdle=(re,j,ie)=>{const me=re.requestIdleCallback(j,typeof ie=="number"?{timeout:ie}:void 0);let be=!1;return{dispose(){be||(be=!0,re.cancelIdleCallback(me))}}},e.runWhenGlobalIdle=re=>(0,e._runWhenIdle)(globalThis,re)}();class te{constructor(j,ie){this._didRun=!1,this._executor=()=>{try{this._value=ie()}catch(me){this._error=me}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(j,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=te;class H extends te{constructor(j){super(globalThis,j)}}e.GlobalIdleValue=H;async function G(re,j,ie){let me;for(let be=0;be<ie;be++)try{return await re()}catch(Ae){me=Ae,await w(j)}throw me}class Y{isRunning(j){return typeof j=="number"?this._running?.taskId===j:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(j,ie,me){return this._running={taskId:j,cancel:()=>me?.(),promise:ie},ie.then(()=>this.doneRunning(j),()=>this.doneRunning(j)),ie}doneRunning(j){this._running&&j===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const j=this._queued;this._queued=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}queue(j){if(this._queued)this._queued.run=j;else{const{promise:ie,resolve:me,reject:be}=a();this._queued={run:j,promise:ie,promiseResolve:me,promiseReject:be}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=Y;class ne{constructor(j,ie=()=>Date.now()){this.interval=j,this.nowFn=ie,this.lastIncrementTime=0,this.value=0}increment(){const j=this.nowFn();return j-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=j,this.value=0),this.value++,this.value}}e.IntervalCounter=ne;var pe;(function(re){re[re.Resolved=0]="Resolved",re[re.Rejected=1]="Rejected"})(pe||(pe={}));class le{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((j,ie)=>{this.completeCallback=j,this.errorCallback=ie})}complete(j){return new Promise(ie=>{this.completeCallback(j),this.outcome={outcome:0,value:j},ie()})}error(j){return new Promise(ie=>{this.errorCallback(j),this.outcome={outcome:1,value:j},ie()})}cancel(){return this.error(new O.CancellationError)}}e.DeferredPromise=le;var we;(function(re){async function j(me){let be;const Ae=await Promise.all(me.map(fe=>fe.then(De=>De,De=>{be||(be=De)})));if(typeof be<"u")throw be;return Ae}re.settled=j;function ie(me){return new Promise(async(be,Ae)=>{try{await me(be,Ae)}catch(fe){Ae(fe)}})}re.withAsyncBody=ie})(we||(e.Promises=we={}));class Z{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(j){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=j.then(ie=>(this._value=ie,this._isResolved=!0,ie),ie=>{throw this._error=ie,this._isResolved=!0,ie})}requireValue(){if(!this._isResolved)throw new O.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=Z;class B{constructor(j){this._compute=j,this._promise=new y.Lazy(()=>new Z(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=B;var ee;(function(re){re[re.Initial=0]="Initial",re[re.DoneOK=1]="DoneOK",re[re.DoneError=2]="DoneError"})(ee||(ee={}));class ve{static fromArray(j){return new ve(ie=>{ie.emitMany(j)})}static fromPromise(j){return new ve(async ie=>{ie.emitMany(await j)})}static fromPromises(j){return new ve(async ie=>{await Promise.all(j.map(async me=>ie.emitOne(await me)))})}static merge(j){return new ve(async ie=>{await Promise.all(j.map(async me=>{for await(const be of me)ie.emitOne(be)}))})}static{this.EMPTY=ve.fromArray([])}constructor(j,ie){this._state=0,this._results=[],this._error=null,this._onReturn=ie,this._onStateChanged=new L.Emitter,queueMicrotask(async()=>{const me={emitOne:be=>this.emitOne(be),emitMany:be=>this.emitMany(be),reject:be=>this.reject(be)};try{await Promise.resolve(j(me)),this.resolve()}catch(be){this.reject(be)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(j<this._results.length)return{done:!1,value:this._results[j++]};if(this._state===1)return{done:!0,value:void 0};await L.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(j,ie){return new ve(async me=>{for await(const be of j)me.emitOne(ie(be))})}map(j){return ve.map(this,j)}static filter(j,ie){return new ve(async me=>{for await(const be of j)ie(be)&&me.emitOne(be)})}filter(j){return ve.filter(this,j)}static coalesce(j){return ve.filter(j,ie=>!!ie)}coalesce(){return ve.coalesce(this)}static async toPromise(j){const ie=[];for await(const me of j)ie.push(me);return ie}toPromise(){return ve.toPromise(this)}emitOne(j){this._state===0&&(this._results.push(j),this._onStateChanged.fire())}emitMany(j){this._state===0&&(this._results=this._results.concat(j),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(j){this._state===0&&(this._state=2,this._error=j,this._onStateChanged.fire())}}e.AsyncIterableObject=ve;class Pe extends ve{constructor(j,ie){super(ie),this._source=j}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Pe;function oe(re){const j=new h.CancellationTokenSource,ie=re(j.token);return new Pe(j,async me=>{const be=j.token.onCancellationRequested(()=>{be.dispose(),j.dispose(),me.reject(new O.CancellationError)});try{for await(const Ae of ie){if(j.token.isCancellationRequested)return;me.emitOne(Ae)}be.dispose(),j.dispose()}catch(Ae){be.dispose(),j.dispose(),me.reject(Ae)}})}class se{constructor(j){this._deferred=new le,this._asyncIterable=new ve(be=>{if(ie){be.reject(ie);return}return me&&be.emitMany(me),this._errorFn=Ae=>be.reject(Ae),this._emitFn=Ae=>be.emitOne(Ae),this._deferred.p},j);let ie,me;this._emitFn=be=>{me||(me=[]),me.push(be)},this._errorFn=be=>{ie||(ie=be)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(j){this._errorFn(j),this._deferred.complete()}emitOne(j){this._emitFn(j)}}e.AsyncIterableSource=se}),define(_e[35],Ce([1,0,19,7,31,27,17,12,14]),function(ue,e,h,O,L,A,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=y,e.splitGlobAware=E,e.match=P,e.parse=k,e.isRelativePattern=F,e.getBasenameTerms=x,e.getPathTerms=z,e.patternsEquals=X;function y(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const T="[/\\\\]",I="[^/\\\\]",p=/\//g;function S(te,H){switch(te){case 0:return"";case 1:return`${I}*?`;default:return`(?:${T}|${I}+${T}${H?`|${T}${I}+`:""})*?`}}function E(te,H){if(!te)return[];const G=[];let Y=!1,ne=!1,pe="";for(const le of te){switch(le){case H:if(!Y&&!ne){G.push(pe),pe="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}pe+=le}return pe&&G.push(pe),G}function d(te){if(!te)return"";let H="";const G=E(te,e.GLOB_SPLIT);if(G.every(Y=>Y===e.GLOBSTAR))H=".*";else{let Y=!1;G.forEach((ne,pe)=>{if(ne===e.GLOBSTAR){if(Y)return;H+=S(2,pe===G.length-1)}else{let le=!1,we="",Z=!1,B="";for(const ee of ne){if(ee!=="}"&&le){we+=ee;continue}if(Z&&(ee!=="]"||!B)){let ve;ee==="-"?ve=ee:(ee==="^"||ee==="!")&&!B?ve="^":ee===e.GLOB_SPLIT?ve="":ve=(0,m.escapeRegExpCharacters)(ee),B+=ve;continue}switch(ee){case"{":le=!0;continue;case"[":Z=!0;continue;case"}":{const Pe=`(?:${E(we,",").map(oe=>d(oe)).join("|")})`;H+=Pe,le=!1,we="";break}case"]":{H+="["+B+"]",Z=!1,B="";break}case"?":H+=I;continue;case"*":H+=S(1);continue;default:H+=(0,m.escapeRegExpCharacters)(ee)}}pe<G.length-1&&(G[pe+1]!==e.GLOBSTAR||pe+2<G.length)&&(H+=T)}Y=ne===e.GLOBSTAR})}return H}const f=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),u=function(){return!1},r=function(){return null};function c(te,H){if(!te)return r;let G;typeof te!="string"?G=te.pattern:G=te,G=G.trim();const Y=`${G}_${!!H.trimForExclusions}`;let ne=t.get(Y);if(ne)return s(ne,te);let pe;return f.test(G)?ne=g(G.substr(4),G):(pe=a.exec(w(G,H)))?ne=D(pe[1],G):(H.trimForExclusions?n:i).test(G)?ne=v(G,H):(pe=l.exec(w(G,H)))?ne=_(pe[1].substr(1),G,!0):(pe=o.exec(w(G,H)))?ne=_(pe[1],G,!1):ne=C(G),t.set(Y,ne),s(ne,te)}function s(te,H){if(typeof H=="string")return te;const G=function(Y,ne){return(0,L.isEqualOrParent)(Y,H.base,!b.isLinux)?te((0,m.ltrim)(Y.substr(H.base.length),R.sep),ne):null};return G.allBasenames=te.allBasenames,G.allPaths=te.allPaths,G.basenames=te.basenames,G.patterns=te.patterns,G}function w(te,H){return H.trimForExclusions&&te.endsWith("/**")?te.substr(0,te.length-2):te}function g(te,H){return function(G,Y){return typeof G=="string"&&G.endsWith(te)?H:null}}function D(te,H){const G=`/${te}`,Y=`\\${te}`,ne=function(le,we){return typeof le!="string"?null:we?we===te?H:null:le===te||le.endsWith(G)||le.endsWith(Y)?H:null},pe=[te];return ne.basenames=pe,ne.patterns=[H],ne.allBasenames=pe,ne}function v(te,H){const G=W(te.slice(1,-1).split(",").map(we=>c(we,H)).filter(we=>we!==r),te),Y=G.length;if(!Y)return r;if(Y===1)return G[0];const ne=function(we,Z){for(let B=0,ee=G.length;B<ee;B++)if(G[B](we,Z))return te;return null},pe=G.find(we=>!!we.allBasenames);pe&&(ne.allBasenames=pe.allBasenames);const le=G.reduce((we,Z)=>Z.allPaths?we.concat(Z.allPaths):we,[]);return le.length&&(ne.allPaths=le),ne}function _(te,H,G){const Y=R.sep===R.posix.sep,ne=Y?te:te.replace(p,R.sep),pe=R.sep+ne,le=R.posix.sep+te;let we;return G?we=function(Z,B){return typeof Z=="string"&&(Z===ne||Z.endsWith(pe)||!Y&&(Z===te||Z.endsWith(le)))?H:null}:we=function(Z,B){return typeof Z=="string"&&(Z===ne||!Y&&Z===te)?H:null},we.allPaths=[(G?"*/":"./")+te],we}function C(te){try{const H=new RegExp(`^${d(te)}$`);return function(G){return H.lastIndex=0,typeof G=="string"&&H.test(G)?te:null}}catch{return r}}function P(te,H,G){return!te||typeof H!="string"?!1:k(te)(H,void 0,G)}function k(te,H={}){if(!te)return u;if(typeof te=="string"||F(te)){const G=c(te,H);if(G===r)return u;const Y=function(ne,pe){return!!G(ne,pe)};return G.allBasenames&&(Y.allBasenames=G.allBasenames),G.allPaths&&(Y.allPaths=G.allPaths),Y}return N(te,H)}function F(te){const H=te;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}function x(te){return te.allBasenames||[]}function z(te){return te.allPaths||[]}function N(te,H){const G=W(Object.getOwnPropertyNames(te).map(we=>M(we,te[we],H)).filter(we=>we!==r)),Y=G.length;if(!Y)return r;if(!G.some(we=>!!we.requiresSiblings)){if(Y===1)return G[0];const we=function(ee,ve){let Pe;for(let oe=0,se=G.length;oe<se;oe++){const re=G[oe](ee,ve);if(typeof re=="string")return re;(0,O.isThenable)(re)&&(Pe||(Pe=[]),Pe.push(re))}return Pe?(async()=>{for(const oe of Pe){const se=await oe;if(typeof se=="string")return se}return null})():null},Z=G.find(ee=>!!ee.allBasenames);Z&&(we.allBasenames=Z.allBasenames);const B=G.reduce((ee,ve)=>ve.allPaths?ee.concat(ve.allPaths):ee,[]);return B.length&&(we.allPaths=B),we}const ne=function(we,Z,B){let ee,ve;for(let Pe=0,oe=G.length;Pe<oe;Pe++){const se=G[Pe];se.requiresSiblings&&B&&(Z||(Z=(0,R.basename)(we)),ee||(ee=Z.substr(0,Z.length-(0,R.extname)(we).length)));const re=se(we,Z,ee,B);if(typeof re=="string")return re;(0,O.isThenable)(re)&&(ve||(ve=[]),ve.push(re))}return ve?(async()=>{for(const Pe of ve){const oe=await Pe;if(typeof oe=="string")return oe}return null})():null},pe=G.find(we=>!!we.allBasenames);pe&&(ne.allBasenames=pe.allBasenames);const le=G.reduce((we,Z)=>Z.allPaths?we.concat(Z.allPaths):we,[]);return le.length&&(ne.allPaths=le),ne}function M(te,H,G){if(H===!1)return r;const Y=c(te,G);if(Y===r)return r;if(typeof H=="boolean")return Y;if(H){const ne=H.when;if(typeof ne=="string"){const pe=(le,we,Z,B)=>{if(!B||!Y(le,we))return null;const ee=ne.replace("$(basename)",()=>Z),ve=B(ee);return(0,O.isThenable)(ve)?ve.then(Pe=>Pe?te:null):ve?te:null};return pe.requiresSiblings=!0,pe}}return Y}function W(te,H){const G=te.filter(we=>!!we.basenames);if(G.length<2)return te;const Y=G.reduce((we,Z)=>{const B=Z.basenames;return B?we.concat(B):we},[]);let ne;if(H){ne=[];for(let we=0,Z=Y.length;we<Z;we++)ne.push(H)}else ne=G.reduce((we,Z)=>{const B=Z.patterns;return B?we.concat(B):we},[]);const pe=function(we,Z){if(typeof we!="string")return null;if(!Z){let ee;for(ee=we.length;ee>0;ee--){const ve=we.charCodeAt(ee-1);if(ve===47||ve===92)break}Z=we.substr(ee)}const B=Y.indexOf(Z);return B!==-1?ne[B]:null};pe.basenames=Y,pe.patterns=ne,pe.allBasenames=Y;const le=te.filter(we=>!we.basenames);return le.push(pe),le}function X(te,H){return(0,h.equals)(te,H,(G,Y)=>typeof G=="string"&&typeof Y=="string"?G===Y:typeof G!="string"&&typeof Y!="string"?G.base===Y.base&&G.pattern===Y.pattern:!1)}}),define(_e[81],Ce([1,0,13,176,23,14,2]),function(ue,e,h,O,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0,e.isEmptyMarkdownString=y,e.isMarkdownString=T,e.markdownStringEqual=I,e.escapeMarkdownSyntaxTokens=p,e.appendEscapedMarkdownCodeBlockFence=S,e.escapeDoubleQuotes=E,e.removeMarkdownEscapes=d,e.parseHrefAndDimensions=f;var b;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class m{constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,h.illegalArgument)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=p(this.supportThemeIcons?(0,O.escapeIcons)(i):i).replace(/([ \t]+)/g,(l,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${S(n,i)}
`,this}appendLink(i,n,l){return this.value+="[",this.value+=this._escape(n,"]"),this.value+="](",this.value+=this._escape(String(i),")"),l&&(this.value+=` "${this._escape(this._escape(l,'"'),")")}"`),this.value+=")",this}_escape(i,n){const l=new RegExp((0,A.escapeRegExpCharacters)(n),"g");return i.replace(l,(o,t)=>i.charAt(t-1)!=="\\"?`\\${o}`:o)}}e.MarkdownString=m;function y(a){return T(a)?!a.value:Array.isArray(a)?a.every(y):!0}function T(a){return a instanceof m?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}function I(a,i){return a===i?!0:!a||!i?!1:a.value===i.value&&a.isTrusted===i.isTrusted&&a.supportThemeIcons===i.supportThemeIcons&&a.supportHtml===i.supportHtml&&(a.baseUri===i.baseUri||!!a.baseUri&&!!i.baseUri&&(0,L.isEqual)(R.URI.from(a.baseUri),R.URI.from(i.baseUri)))}function p(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function S(a,i){const n=a.match(/^`+/gm)?.reduce((o,t)=>o.length>t.length?o:t).length??0,l=n>=3?n+1:3;return[`${"`".repeat(l)}${i}`,a,`${"`".repeat(l)}`].join(`
`)}function E(a){return a.replace(/"/g,"&quot;")}function d(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function f(a){const i=[],n=a.split("|").map(o=>o.trim());a=n[0];const l=n[1];if(l){const o=/height=(\d+)/.exec(l),t=/width=(\d+)/.exec(l),u=o?o[1]:"",r=t?t[1]:"",c=isFinite(parseInt(r)),s=isFinite(parseInt(u));c&&i.push(`width="${r}"`),s&&i.push(`height="${u}"`)}return{href:a,dimensions:i}}}),define(_e[103],Ce([1,0,19,31,17,12,23,14]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathLabel=m,e.normalizeDriveLetter=T,e.tildify=p,e.untildify=S,e.shorten=a,e.template=n,e.mnemonicMenuLabel=l,e.mnemonicButtonLabel=o,e.unmnemonicLabel=t,e.splitRecentLabel=u;function m(c,s){const{os:w,tildify:g,relative:D}=s;if(D){const C=y(c,D,w);if(typeof C=="string")return C}let v=c.fsPath;if(w===1&&!A.isWindows?v=v.replace(/\//g,"\\"):w!==1&&A.isWindows&&(v=v.replace(/\\/g,"/")),w!==1&&g?.userHome){const C=g.userHome.fsPath;let P;c.scheme!==g.userHome.scheme&&c.path[0]===L.posix.sep&&c.path[1]!==L.posix.sep?P=g.userHome.with({path:c.path}).fsPath:P=v,v=p(P,C,w)}return(w===1?L.win32:L.posix).normalize(T(v,w===1))}function y(c,s,w){const g=w===1?L.win32:L.posix,D=w===3?R.extUri:R.extUriIgnorePathCase,v=s.getWorkspace(),_=(0,h.firstOrDefault)(v.folders);if(!_)return;c.scheme!==_.uri.scheme&&c.path[0]===L.posix.sep&&c.path[1]!==L.posix.sep&&(c=_.uri.with({path:c.path}));const C=s.getWorkspaceFolder(c);if(!C)return;let P;if(D.isEqual(C.uri,c)?P="":P=D.relativePath(C.uri,c)??"",P&&(P=g.normalize(P)),v.folders.length>1&&!s.noPrefix){const k=C.name?C.name:D.basenameOrAuthority(C.uri);P=P?`${k} \u2022 ${P}`:k}return P}function T(c,s=A.isWindows){return(0,O.hasDriveLetter)(c,s)?c.charAt(0).toUpperCase()+c.slice(1):c}let I=Object.create(null);function p(c,s,w=A.OS){if(w===1||!c||!s)return c;let g=I.original===s?I.normalized:void 0;g||(g=s,A.isWindows&&(g=(0,O.toSlashes)(g)),g=`${(0,b.rtrim)(g,L.posix.sep)}${L.posix.sep}`,I={original:s,normalized:g});let D=c;return A.isWindows&&(D=(0,O.toSlashes)(D)),(w===3?D.startsWith(g):(0,b.startsWithIgnoreCase)(D,g))?`~/${D.substr(g.length)}`:c}function S(c,s){return c.replace(/^~($|\/|\\)/,`${s}$1`)}const E="\u2026",d="\\\\",f="~";function a(c,s=L.sep){const w=new Array(c.length);let g=!1;for(let D=0;D<c.length;D++){const v=c[D];if(v===""){w[D]=`.${s}`;continue}if(!v){w[D]=v;continue}g=!0;let _="",C=v;C.indexOf(d)===0?(_=C.substr(0,C.indexOf(d)+d.length),C=C.substr(C.indexOf(d)+d.length)):C.indexOf(s)===0?(_=C.substr(0,C.indexOf(s)+s.length),C=C.substr(C.indexOf(s)+s.length)):C.indexOf(f)===0&&(_=C.substr(0,C.indexOf(f)+f.length),C=C.substr(C.indexOf(f)+f.length));const P=C.split(s);for(let k=1;g&&k<=P.length;k++)for(let F=P.length-k;g&&F>=0;F--){g=!1;let x=P.slice(F,F+k).join(s);for(let z=0;!g&&z<c.length;z++)if(z!==D&&c[z]&&c[z].indexOf(x)>-1){const N=F+k===P.length,M=F>0&&c[z].indexOf(s)>-1?s+x:x,W=c[z].endsWith(M);g=!N||W}if(!g){let z="";(P[0].endsWith(":")||_!=="")&&(F===1&&(F=0,k++,x=P[0]+s+x),F>0&&(z=P[0]+s),z=_+z),F>0&&(z=z+E+s),z=z+x,F+k<P.length&&(z=z+s+E),w[D]=z}}g&&(w[D]=v)}return w}var i;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(c,s=Object.create(null)){const w=[];let g=!1,D="";for(const v of c)if(v==="$"||g&&v==="{")D&&w.push({value:D,type:i.TEXT}),D="",g=!0;else if(v==="}"&&g){const _=s[D];if(typeof _=="string")_.length&&w.push({value:_,type:i.VARIABLE});else if(_){const C=w[w.length-1];(!C||C.type!==i.SEPARATOR)&&w.push({value:_.label,type:i.SEPARATOR})}D="",g=!1}else D+=v;return D&&!g&&w.push({value:D,type:i.TEXT}),w.filter((v,_)=>{if(v.type===i.SEPARATOR){const C=w[_-1],P=w[_+1];return[C,P].every(k=>k&&(k.type===i.VARIABLE||k.type===i.TEXT)&&k.value.length>0)}return!0}).map(v=>v.value).join("")}function l(c,s){return A.isMacintosh||s?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):c.replace(/&&|&/g,w=>w==="&"?"&&":"&")}function o(c,s){return A.isMacintosh||s?c.replace(/\(&&\w\)|&&/g,""):A.isWindows?c.replace(/&&|&/g,w=>w==="&"?"&&":"&"):c.replace(/&&/g,"_")}function t(c){return c.replace(/&/g,"&&")}function u(c){if(c.endsWith("]")){const s=c.lastIndexOf(" [",c.length-2);if(s!==-1){const w=r(c.substring(0,s)),g=c.substring(s);return{name:w.name+g,parentPath:w.parentPath}}}return r(c)}function r(c){const s=c.indexOf("/")!==-1?L.posix:L.win32,w=s.basename(c),g=s.dirname(c);return w.length?{name:w,parentPath:g}:{name:g,parentPath:""}}}),define(_e[134],Ce([1,0,21,2]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=b,e.transformIncomingURIs=y,e.transformAndReviveIncomingURIs=T;function L(I){return I.toJSON()}class A{constructor(p){this._uriTransformer=p}transformIncoming(p){const S=this._uriTransformer.transformIncoming(p);return S===p?p:L(O.URI.from(S))}transformOutgoing(p){const S=this._uriTransformer.transformOutgoing(p);return S===p?p:L(O.URI.from(S))}transformOutgoingURI(p){const S=this._uriTransformer.transformOutgoing(p);return S===p?p:O.URI.from(S)}transformOutgoingScheme(p){return this._uriTransformer.transformOutgoingScheme(p)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function R(I,p,S){if(!I||S>200)return null;if(typeof I=="object"){if(I instanceof O.URI)return p.transformOutgoing(I);for(const E in I)if(Object.hasOwnProperty.call(I,E)){const d=R(I[E],p,S+1);d!==null&&(I[E]=d)}}return null}function b(I,p){const S=R(I,p,0);return S===null?I:S}function m(I,p,S,E){if(!I||E>200)return null;if(typeof I=="object"){if(I.$mid===1)return S?O.URI.revive(p.transformIncoming(I)):p.transformIncoming(I);if(I instanceof h.VSBuffer)return null;for(const d in I)if(Object.hasOwnProperty.call(I,d)){const f=m(I[d],p,S,E+1);f!==null&&(I[d]=f)}}return null}function y(I,p){const S=m(I,p,!1,0);return S===null?I:S}function T(I,p){const S=m(I,p,!0,0);return S===null?I:S}}),define(_e[32],Ce([1,0,53,64,400,7,31,77,17,12,23,2]),function(ue,e,h,O,L,A,R,b,m,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=f,e.readdirSync=n,e.whenDeleted=t,e.configureFlushOnWrite=w,e.writeFileSync=D;var p;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function S(M,W=p.UNLINK,X){if((0,R.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return W===p.UNLINK?d(M):E(M,X)}async function E(M,W=(0,R.randomPath)((0,O.tmpdir)())){try{try{await h.promises.rename(M,W)}catch(X){return X.code==="ENOENT"?void 0:d(M)}d(W).catch(X=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function d(M){return(0,L.promisify)(h.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function f(M){if((0,R.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");h.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}async function a(M,W){return l(await(W?i(M):(0,L.promisify)(h.readdir)(M)))}async function i(M){try{return await(0,L.promisify)(h.readdir)(M,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const W=[],X=await a(M);for(const te of X){let H=!1,G=!1,Y=!1;try{const ne=await e.Promises.lstat((0,m.join)(M,te));H=ne.isFile(),G=ne.isDirectory(),Y=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}W.push({name:te,isFile:()=>H,isDirectory:()=>G,isSymbolicLink:()=>Y})}return W}function n(M){return l(h.readdirSync(M))}function l(M){return M.map(W=>typeof W=="string"?y.isMacintosh?(0,b.normalizeNFC)(W):W:(W.name=y.isMacintosh?(0,b.normalizeNFC)(W.name):W.name,W))}async function o(M){const W=await a(M),X=[];for(const te of W)await u.existsDirectory((0,m.join)(M,te))&&X.push(te);return X}function t(M,W=1e3){return new Promise(X=>{let te=!1;const H=setInterval(()=>{te||(te=!0,h.access(M,G=>{te=!1,G&&(clearInterval(H),X(void 0))}))},W)})}var u;(function(M){async function W(H){let G;try{if(G=await e.Promises.lstat(H),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(y.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw ne}throw Y}}M.stat=W;async function X(H){try{const{stat:G,symbolicLink:Y}=await M.stat(H);return G.isFile()&&Y?.dangling!==!0}catch{}return!1}M.existsFile=X;async function te(H){try{const{stat:G,symbolicLink:Y}=await M.stat(H);return G.isDirectory()&&Y?.dangling!==!0}catch{}return!1}M.existsDirectory=te})(u||(e.SymlinkSupport=u={}));const r=new A.ResourceQueue;function c(M,W,X){return r.queueFor(I.URI.file(M),()=>{const te=v(X);return new Promise((H,G)=>g(M,W,te,Y=>Y?G(Y):H()))},T.extUriBiasedIgnorePathCase)}let s=!0;function w(M){s=M}function g(M,W,X,te){if(!s)return h.writeFile(M,W,{mode:X.mode,flag:X.flag},te);h.open(M,X.flag,X.mode,(H,G)=>{if(H)return te(H);h.writeFile(G,W,Y=>{if(Y)return h.close(G,()=>te(Y));h.fdatasync(G,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),w(!1)),h.close(G,pe=>te(pe))))})})}function D(M,W,X){const te=v(X);if(!s)return h.writeFileSync(M,W,{mode:te.mode,flag:te.flag});const H=h.openSync(M,te.flag,te.mode);try{h.writeFileSync(H,W);try{h.fdatasyncSync(H)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),w(!1)}}finally{h.closeSync(H)}}function v(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function _(M,W,X=6e4){if(M!==W)try{y.isWindows&&typeof X=="number"?await C(M,W,Date.now(),X):await(0,L.promisify)(h.rename)(M,W)}catch(te){if(M.toLowerCase()!==W.toLowerCase()&&te.code==="EXDEV"||M.endsWith("."))await P(M,W,{preserveSymlinks:!1}),await S(M,p.MOVE);else throw te}}async function C(M,W,X,te,H=0){try{return await(0,L.promisify)(h.rename)(M,W)}catch(G){if(G.code!=="EACCES"&&G.code!=="EPERM"&&G.code!=="EBUSY")throw G;if(Date.now()-X>=te)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${G}`),G;if(H===0){let Y=!1;try{const{stat:ne}=await u.stat(W);ne.isFile()||(Y=!0)}catch{}if(Y)throw G}return await(0,A.timeout)(Math.min(100,H*10)),C(M,W,X,te,H+1)}}async function P(M,W,X){return F(M,W,{root:{source:M,target:W},options:X,handledSourcePaths:new Set})}const k=511;async function F(M,W,X){if(X.handledSourcePaths.has(M))return;X.handledSourcePaths.add(M);const{stat:te,symbolicLink:H}=await u.stat(M);if(H){if(X.options.preserveSymlinks)try{return await N(M,W,X)}catch{}if(H.dangling)return}return te.isDirectory()?x(M,W,te.mode&k,X):z(M,W,te.mode&k)}async function x(M,W,X,te){await e.Promises.mkdir(W,{recursive:!0,mode:X});const H=await a(M);for(const G of H)await F((0,m.join)(M,G),(0,m.join)(W,G),te)}async function z(M,W,X){await e.Promises.copyFile(M,W),await e.Promises.chmod(W,X)}async function N(M,W,X){let te=await e.Promises.readlink(M);(0,R.isEqualOrParent)(te,X.root.source,!y.isLinux)&&(te=(0,m.join)(X.root.target,te.substr(X.root.source.length+1))),await e.Promises.symlink(te,W)}e.Promises=new class{get access(){return(0,L.promisify)(h.access)}get stat(){return(0,L.promisify)(h.stat)}get lstat(){return(0,L.promisify)(h.lstat)}get utimes(){return(0,L.promisify)(h.utimes)}get read(){return(M,W,X,te,H)=>new Promise((G,Y)=>{h.read(M,W,X,te,H,(ne,pe,le)=>ne?Y(ne):G({bytesRead:pe,buffer:le}))})}get readFile(){return(0,L.promisify)(h.readFile)}get write(){return(M,W,X,te,H)=>new Promise((G,Y)=>{h.write(M,W,X,te,H,(ne,pe,le)=>ne?Y(ne):G({bytesWritten:pe,buffer:le}))})}get appendFile(){return(0,L.promisify)(h.appendFile)}get fdatasync(){return(0,L.promisify)(h.fdatasync)}get truncate(){return(0,L.promisify)(h.truncate)}get copyFile(){return(0,L.promisify)(h.copyFile)}get open(){return(0,L.promisify)(h.open)}get close(){return(0,L.promisify)(h.close)}get symlink(){return(0,L.promisify)(h.symlink)}get readlink(){return(0,L.promisify)(h.readlink)}get chmod(){return(0,L.promisify)(h.chmod)}get mkdir(){return(0,L.promisify)(h.mkdir)}get unlink(){return(0,L.promisify)(h.unlink)}get rmdir(){return(0,L.promisify)(h.rmdir)}get realpath(){return(0,L.promisify)(h.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return a}get readDirsInDir(){return o}get writeFile(){return c}get rm(){return S}get rename(){return _}get copy(){return P}}}),define(_e[104],Ce([1,0,53,17,12,14,32]),function(ue,e,h,O,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=b,e.realcase=m,e.realpath=y,e.realpathSync=T;function b(p){if(L.isLinux)return p;const S=(0,O.dirname)(p);if(p===S)return p;const E=((0,O.basename)(p)||p).toLowerCase();try{const f=(0,R.readdirSync)(S).filter(a=>a.toLowerCase()===E);if(f.length===1){const a=b(S);if(a)return(0,O.join)(a,f[0])}else if(f.length>1){const a=f.indexOf(E);if(a>=0){const i=b(S);if(i)return(0,O.join)(i,f[a])}}}catch{}return null}async function m(p,S){if(L.isLinux)return p;const E=(0,O.dirname)(p);if(p===E)return p;const d=((0,O.basename)(p)||p).toLowerCase();try{if(S?.isCancellationRequested)return null;const a=(await R.Promises.readdir(E)).filter(i=>i.toLowerCase()===d);if(a.length===1){const i=await m(E,S);if(i)return(0,O.join)(i,a[0])}else if(a.length>1){const i=a.indexOf(d);if(i>=0){const n=await m(E,S);if(n)return(0,O.join)(n,a[i])}}}catch{}return null}async function y(p){try{return await R.Promises.realpath(p)}catch{const E=I(p);return await R.Promises.access(E,h.constants.R_OK),E}}function T(p){try{return h.realpathSync(p)}catch{const E=I(p);return h.accessSync(E,h.constants.R_OK),E}}function I(p){return(0,A.rtrim)((0,O.normalize)(p),O.sep)}}),define(_e[105],Ce([1,0,17,12,52,102,18,32]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=m,e.createQueuedSender=y,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function m(I=L.env){return I.comspec||"cmd.exe"}function y(I){let p=[],S=!1;const E=function(d){if(S){p.push(d);return}(!I.send(d,a=>{if(a&&console.error(a),S=!1,p.length>0){const i=p.slice(0);p=[],i.forEach(n=>E(n))}})||O.isWindows)&&(S=!0)};return{send:E}}var T;(function(I){async function p(S,E,d){if(h.isAbsolute(S))return S;if(E===void 0&&(E=L.cwd()),h.dirname(S)!=="."||(d===void 0&&R.isString(L.env.PATH)&&(d=L.env.PATH.split(h.delimiter)),d===void 0||d.length===0))return h.join(E,S);async function a(i){if(await b.Promises.exists(i)){let n;try{n=await b.Promises.stat(i)}catch(l){l.message.startsWith("EACCES")&&(n=await b.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of d){let n;if(h.isAbsolute(i)?n=h.join(i,S):n=h.join(E,i,S),await a(n))return n;let l=n+".com";if(await a(l)||(l=n+".exe",await a(l)))return l}return h.join(E,S)}I.findExecutable=p})(T||(e.win32=T={}))});var Ge=this&&this.__decorate||function(ue,e,h,O){var L=arguments.length,A=L<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,h):O,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ue,e,h,O);else for(var b=ue.length-1;b>=0;b--)(R=ue[b])&&(A=(L<3?R(A):L>3?R(e,h,A):R(e,h))||A);return L>3&&A&&Object.defineProperty(e,h,A),A};define(_e[82],Ce([1,0,19,7,21,22,56,13,4,3,58,14,18]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=w,e.deserialize=g,e.getDelayedChannel=k,e.getNextTickChannel=F;var S;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(S||(S={}));function E(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(d||(d={}));function f(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(a||(a={}));function i(H){let G=0;for(let Y=0;;Y+=7){const ne=H.read(1);if(G|=(ne.buffer[0]&127)<<Y,!(ne.buffer[0]&128))return G}}const n=r(0);function l(H,G){if(G===0){H.write(n);return}let Y=0;for(let pe=G;pe!==0;pe=pe>>>7)Y++;const ne=L.VSBuffer.alloc(Y);for(let pe=0;G!==0;pe++)ne.buffer[pe]=G&127,G=G>>>7,G>0&&(ne.buffer[pe]|=128);H.write(ne)}class o{constructor(G){this.buffer=G,this.pos=0}read(G){const Y=this.buffer.slice(this.pos,this.pos+G);return this.pos+=Y.byteLength,Y}}e.BufferReader=o;class t{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(G){this.buffers.push(G)}}e.BufferWriter=t;var u;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(u||(u={}));function r(H){const G=L.VSBuffer.alloc(1);return G.writeUInt8(H,0),G}const c={Undefined:r(u.Undefined),String:r(u.String),Buffer:r(u.Buffer),VSBuffer:r(u.VSBuffer),Array:r(u.Array),Object:r(u.Object),Uint:r(u.Int)},s=typeof Buffer<"u";function w(H,G){if(typeof G>"u")H.write(c.Undefined);else if(typeof G=="string"){const Y=L.VSBuffer.fromString(G);H.write(c.String),l(H,Y.byteLength),H.write(Y)}else if(s&&Buffer.isBuffer(G)){const Y=L.VSBuffer.wrap(G);H.write(c.Buffer),l(H,Y.byteLength),H.write(Y)}else if(G instanceof L.VSBuffer)H.write(c.VSBuffer),l(H,G.byteLength),H.write(G);else if(Array.isArray(G)){H.write(c.Array),l(H,G.length);for(const Y of G)w(H,Y)}else if(typeof G=="number"&&(G|0)===G)H.write(c.Uint),l(H,G);else{const Y=L.VSBuffer.fromString(JSON.stringify(G));H.write(c.Object),l(H,Y.byteLength),H.write(Y)}}function g(H){switch(H.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return H.read(i(H)).toString();case u.Buffer:return H.read(i(H)).buffer;case u.VSBuffer:return H.read(i(H));case u.Array:{const Y=i(H),ne=[];for(let pe=0;pe<Y;pe++)ne.push(g(H));return ne}case u.Object:return JSON.parse(H.read(i(H)).toString());case u.Int:return i(H)}}class D{constructor(G,Y,ne=null,pe=1e3){this.protocol=G,this.ctx=Y,this.logger=ne,this.timeoutDelay=pe,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(le=>this.onRawMessage(le)),this.sendResponse({type:200})}registerChannel(G,Y){this.channels.set(G,Y),setTimeout(()=>this.flushPendingRequests(G),0)}sendResponse(G){switch(G.type){case 200:{const Y=this.send([G.type]);this.logger?.logOutgoing(Y,0,1,f(G.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([G.type,G.id],G.data);this.logger?.logOutgoing(Y,G.id,1,f(G.type),G.data);return}}}send(G,Y=void 0){const ne=new t;return w(ne,G),w(ne,Y),this.sendBuffer(ne.buffer)}sendBuffer(G){try{return this.protocol.send(G),G.byteLength}catch{return 0}}onRawMessage(G){const Y=new o(G),ne=g(Y),pe=g(Y),le=ne[0];switch(le){case 100:return this.logger?.logIncoming(G.byteLength,ne[1],1,`${E(le)}: ${ne[2]}.${ne[3]}`,pe),this.onPromise({type:le,id:ne[1],channelName:ne[2],name:ne[3],arg:pe});case 102:return this.logger?.logIncoming(G.byteLength,ne[1],1,`${E(le)}: ${ne[2]}.${ne[3]}`,pe),this.onEventListen({type:le,id:ne[1],channelName:ne[2],name:ne[3],arg:pe});case 101:return this.logger?.logIncoming(G.byteLength,ne[1],1,`${E(le)}`),this.disposeActiveRequest({type:le,id:ne[1]});case 103:return this.logger?.logIncoming(G.byteLength,ne[1],1,`${E(le)}`),this.disposeActiveRequest({type:le,id:ne[1]})}}onPromise(G){const Y=this.channels.get(G.channelName);if(!Y){this.collectPendingRequest(G);return}const ne=new A.CancellationTokenSource;let pe;try{pe=Y.call(this.ctx,G.name,G.arg,ne.token)}catch(Z){pe=Promise.reject(Z)}const le=G.id;pe.then(Z=>{this.sendResponse({id:le,data:Z,type:201})},Z=>{Z instanceof Error?this.sendResponse({id:le,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:le,data:Z,type:203})}).finally(()=>{we.dispose(),this.activeRequests.delete(G.id)});const we=(0,y.toDisposable)(()=>ne.cancel());this.activeRequests.set(G.id,we)}onEventListen(G){const Y=this.channels.get(G.channelName);if(!Y){this.collectPendingRequest(G);return}const ne=G.id,le=Y.listen(this.ctx,G.name,G.arg)(we=>this.sendResponse({id:ne,data:we,type:204}));this.activeRequests.set(G.id,le)}disposeActiveRequest(G){const Y=this.activeRequests.get(G.id);Y&&(Y.dispose(),this.activeRequests.delete(G.id))}collectPendingRequest(G){let Y=this.pendingRequests.get(G.channelName);Y||(Y=[],this.pendingRequests.set(G.channelName,Y));const ne=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.sendResponse({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:G,timeoutTimer:ne})}flushPendingRequests(G){const Y=this.pendingRequests.get(G);if(Y){for(const ne of Y)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.onPromise(ne.request);break;case 102:this.onEventListen(ne.request);break}this.pendingRequests.delete(G)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,y.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=D;var v;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));class _{constructor(G,Y=null){this.protocol=G,this.isDisposed=!1,this.state=a.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ne=>this.onBuffer(ne)),this.logger=Y}getChannel(G){const Y=this;return{call(ne,pe,le){return Y.isDisposed?Promise.reject(new b.CancellationError):Y.requestPromise(G,ne,pe,le)},listen(ne,pe){return Y.isDisposed?m.Event.None:Y.requestEvent(G,ne,pe)}}}requestPromise(G,Y,ne,pe=A.CancellationToken.None){const le=this.lastRequestId++,Z={id:le,type:100,channelName:G,name:Y,arg:ne};if(pe.isCancellationRequested)return Promise.reject(new b.CancellationError);let B;return new Promise((ve,Pe)=>{if(pe.isCancellationRequested)return Pe(new b.CancellationError);const oe=()=>{const ie=me=>{switch(me.type){case 201:this.handlers.delete(le),ve(me.data);break;case 202:{this.handlers.delete(le);const be=new Error(me.data.message);be.stack=Array.isArray(me.data.stack)?me.data.stack.join(`
`):me.data.stack,be.name=me.data.name,Pe(be);break}case 203:this.handlers.delete(le),Pe(me.data);break}};this.handlers.set(le,ie),this.sendRequest(Z)};let se=null;this.state===a.Idle?oe():(se=(0,O.createCancelablePromise)(ie=>this.whenInitialized()),se.then(()=>{se=null,oe()}));const re=()=>{se?(se.cancel(),se=null):this.sendRequest({id:le,type:101}),Pe(new b.CancellationError)},j=pe.onCancellationRequested(re);B=(0,y.combinedDisposable)((0,y.toDisposable)(re),j),this.activeRequests.add(B)}).finally(()=>{B.dispose(),this.activeRequests.delete(B)})}requestEvent(G,Y,ne){const pe=this.lastRequestId++,we={id:pe,type:102,channelName:G,name:Y,arg:ne};let Z=null;const B=new m.Emitter({onWillAddFirstListener:()=>{Z=(0,O.createCancelablePromise)(ve=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(B),this.sendRequest(we)})},onDidRemoveLastListener:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(B),this.sendRequest({id:pe,type:103}))}}),ee=ve=>B.fire(ve.data);return this.handlers.set(pe,ee),B.event}sendRequest(G){switch(G.type){case 100:case 102:{const Y=this.send([G.type,G.id,G.channelName,G.name],G.arg);this.logger?.logOutgoing(Y,G.id,0,`${E(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const Y=this.send([G.type,G.id]);this.logger?.logOutgoing(Y,G.id,0,E(G.type));return}}}send(G,Y=void 0){const ne=new t;return w(ne,G),w(ne,Y),this.sendBuffer(ne.buffer)}sendBuffer(G){try{return this.protocol.send(G),G.byteLength}catch{return 0}}onBuffer(G){const Y=new o(G),ne=g(Y),pe=g(Y),le=ne[0];switch(le){case 200:return this.logger?.logIncoming(G.byteLength,0,0,f(le)),this.onResponse({type:ne[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(G.byteLength,ne[1],0,f(le),pe),this.onResponse({type:ne[0],id:ne[1],data:pe})}}onResponse(G){if(G.type===200){this.state=a.Idle,this._onDidInitialize.fire();return}this.handlers.get(G.id)?.(G)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,y.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=_,Ge([R.memoize],_.prototype,"onDidInitializePromise",null);class C{get connections(){const G=[];return this._connections.forEach(Y=>G.push(Y)),G}constructor(G,Y,ne){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new y.DisposableStore,this.disposables.add(G(({protocol:pe,onDidClientDisconnect:le})=>{const we=m.Event.once(pe.onMessage);this.disposables.add(we(Z=>{const B=new o(Z),ee=g(B),ve=new D(pe,ee,Y,ne),Pe=new _(pe,Y);this.channels.forEach((se,re)=>ve.registerChannel(re,se));const oe={channelServer:ve,channelClient:Pe,ctx:ee};this._connections.add(oe),this._onDidAddConnection.fire(oe),this.disposables.add(le(()=>{ve.dispose(),Pe.dispose(),this._connections.delete(oe),this._onDidRemoveConnection.fire(oe)}))}))}))}getChannel(G,Y){const ne=this;return{call(pe,le,we){let Z;if((0,p.isFunction)(Y)){const ee=(0,h.getRandomElement)(ne.connections.filter(Y));Z=ee?Promise.resolve(ee):m.Event.toPromise(m.Event.filter(ne.onDidAddConnection,Y))}else Z=Y.routeCall(ne,pe,le);const B=Z.then(ee=>ee.channelClient.getChannel(G));return k(B).call(pe,le,we)},listen(pe,le){if((0,p.isFunction)(Y))return ne.getMulticastEvent(G,Y,pe,le);const we=Y.routeEvent(ne,pe,le).then(Z=>Z.channelClient.getChannel(G));return k(we).listen(pe,le)}}}getMulticastEvent(G,Y,ne,pe){const le=this;let we;const Z=new m.Emitter({onWillAddFirstListener:()=>{we=new y.DisposableStore;const B=new m.EventMultiplexer,ee=new Map,ve=oe=>{const re=oe.channelClient.getChannel(G).listen(ne,pe),j=B.add(re);ee.set(oe,j)},Pe=oe=>{const se=ee.get(oe);se&&(se.dispose(),ee.delete(oe))};le.connections.filter(Y).forEach(ve),m.Event.filter(le.onDidAddConnection,Y)(ve,void 0,we),le.onDidRemoveConnection(Pe,void 0,we),B.event(Z.fire,Z,we),we.add(B)},onDidRemoveLastListener:()=>{we?.dispose(),we=void 0}});return Z.event}registerChannel(G,Y){this.channels.set(G,Y);for(const ne of this._connections)ne.channelServer.registerChannel(G,Y)}dispose(){this.disposables.dispose();for(const G of this._connections)G.channelClient.dispose(),G.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=C;class P{constructor(G,Y,ne=null){const pe=new t;w(pe,Y),G.send(pe.buffer),this.channelClient=new _(G,ne),this.channelServer=new D(G,Y,ne)}getChannel(G){return this.channelClient.getChannel(G)}registerChannel(G,Y){this.channelServer.registerChannel(G,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=P;function k(H){return{call(G,Y,ne){return H.then(pe=>pe.call(G,Y,ne))},listen(G,Y){const ne=new m.Relay;return H.then(pe=>ne.input=pe.listen(G,Y)),ne.event}}}function F(H){let G=!1;return{call(Y,ne,pe){return G?H.call(Y,ne,pe):(0,O.timeout)(0).then(()=>G=!0).then(()=>H.call(Y,ne,pe))},listen(Y,ne){if(G)return H.listen(Y,ne);const pe=new m.Relay;return(0,O.timeout)(0).then(()=>G=!0).then(()=>pe.input=H.listen(Y,ne)),pe.event}}}class x{constructor(G){this.fn=G}routeCall(G){return this.route(G)}routeEvent(G){return this.route(G)}async route(G){for(const Y of G.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await m.Event.toPromise(G.onDidAddConnection),await this.route(G)}}e.StaticRouter=x;var z;(function(H){function G(le,we,Z){const B=le,ee=Z&&Z.disableMarshalling,ve=new Map;for(const Pe in B)ne(Pe)&&ve.set(Pe,m.Event.buffer(B[Pe],!0,void 0,we));return new class{listen(Pe,oe,se){const re=ve.get(oe);if(re)return re;const j=B[oe];if(typeof j=="function"){if(pe(oe))return j.call(B,se);if(ne(oe))return ve.set(oe,m.Event.buffer(B[oe],!0,void 0,we)),ve.get(oe)}throw new b.ErrorNoTelemetry(`Event not found: ${oe}`)}call(Pe,oe,se){const re=B[oe];if(typeof re=="function"){if(!ee&&Array.isArray(se))for(let ie=0;ie<se.length;ie++)se[ie]=(0,T.revive)(se[ie]);let j=re.apply(B,se);return j instanceof Promise||(j=Promise.resolve(j)),j}throw new b.ErrorNoTelemetry(`Method not found: ${oe}`)}}}H.fromService=G;function Y(le,we){const Z=we&&we.disableMarshalling;return new Proxy({},{get(B,ee){if(typeof ee=="string")return we?.properties?.has(ee)?we.properties.get(ee):pe(ee)?function(ve){return le.listen(ee,ve)}:ne(ee)?le.listen(ee):async function(...ve){let Pe;we&&!(0,p.isUndefinedOrNull)(we.context)?Pe=[we.context,...ve]:Pe=ve;const oe=await le.call(ee,Pe);return Z?oe:(0,T.revive)(oe)};throw new b.ErrorNoTelemetry(`Property not found: ${String(ee)}`)}})}H.toService=Y;function ne(le){return le[0]==="o"&&le[1]==="n"&&I.isUpperAsciiLetter(le.charCodeAt(2))}function pe(le){return/^onDynamic/.test(le)&&I.isUpperAsciiLetter(le.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const G=H.toString();if(G!=="[object Object]")return G}return H}function W(H){return Array.isArray(H)?H.map(M):M(H)}function X(H,G,Y,ne,pe,le,we){we=W(we);const Z=N[pe],B=Z[ne%Z.length];let ee=[`%c[${H}]%c[${String(G).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(le)?(ee=ee.concat(we),ee.push(")")):ee.push(we),console.log.apply(console,ee)}class te{constructor(G,Y){this._outgoingPrefix=G,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(G,Y,ne,pe,le){this._totalOutgoing+=G,X(this._outgoingPrefix,this._totalOutgoing,G,Y,ne,pe,le)}logIncoming(G,Y,ne,pe,le){this._totalIncoming+=G,X(this._incomingPrefix,this._totalIncoming,G,Y,ne,pe,le)}}e.IPCLogger=te}),define(_e[83],Ce([1,0,21,4,3,82]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(c){c.Created="created",c.Read="read",c.Write="write",c.Open="open",c.Error="error",c.Close="close",c.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",c.NodeEndReceived="nodeEndReceived",c.NodeEndSent="nodeEndSent",c.NodeDrainBegin="nodeDrainBegin",c.NodeDrainEnd="nodeDrainEnd",c.zlibInflateError="zlibInflateError",c.zlibInflateData="zlibInflateData",c.zlibInflateInitialWrite="zlibInflateInitialWrite",c.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",c.zlibInflateWrite="zlibInflateWrite",c.zlibInflateFlushFired="zlibInflateFlushFired",c.zlibDeflateError="zlibDeflateError",c.zlibDeflateData="zlibDeflateData",c.zlibDeflateWrite="zlibDeflateWrite",c.zlibDeflateFlushFired="zlibDeflateFlushFired",c.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",c.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",c.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",c.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",c.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",c.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",c.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",c.ProtocolHeaderRead="protocolHeaderRead",c.ProtocolMessageRead="protocolMessageRead",c.ProtocolHeaderWrite="protocolHeaderWrite",c.ProtocolMessageWrite="protocolMessageWrite",c.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var b;(function(c){c.enableDiagnostics=!1,c.records=[];const s=new WeakMap;let w=0;function g(v,_){if(!s.has(v)){const C=String(++w);s.set(v,C)}return s.get(v)}function D(v,_,C,P){if(!c.enableDiagnostics)return;const k=g(v,_);if(P instanceof h.VSBuffer||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const F=h.VSBuffer.alloc(P.byteLength);F.set(P),c.records.push({timestamp:Date.now(),id:k,label:_,type:C,buff:F})}else c.records.push({timestamp:Date.now(),id:k,label:_,type:C,data:P})}c.traceSocketEvent=D})(b||(e.SocketDiagnostics=b={}));var m;(function(c){c[c.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",c[c.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(m||(e.SocketCloseEventType=m={}));let y=null;function T(){return y||(y=h.VSBuffer.alloc(0)),y}class I{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,w){if(s===0)return T();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const _=this._chunks[0];return w&&(this._chunks.shift(),this._totalLength-=s),_}if(this._chunks[0].byteLength>s){const _=this._chunks[0].slice(0,s);return w&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),_}const g=h.VSBuffer.alloc(s);let D=0,v=0;for(;s>0;){const _=this._chunks[v];if(_.byteLength>s){const C=_.slice(0,s);g.set(C,D),D+=s,w&&(this._chunks[v]=_.slice(s),this._totalLength-=s),s-=s}else g.set(_,D),D+=_.byteLength,w?(this._chunks.shift(),this._totalLength-=_.byteLength):v++,s-=_.byteLength}return g}}e.ChunkStream=I;var p;(function(c){c[c.None=0]="None",c[c.Regular=1]="Regular",c[c.Control=2]="Control",c[c.Ack=3]="Ack",c[c.Disconnect=5]="Disconnect",c[c.ReplayRequest=6]="ReplayRequest",c[c.Pause=7]="Pause",c[c.Resume=8]="Resume",c[c.KeepAlive=9]="KeepAlive"})(p||(p={}));function S(c){switch(c){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var E;(function(c){c[c.HeaderLength=13]="HeaderLength",c[c.AcknowledgeTime=2e3]="AcknowledgeTime",c[c.TimeoutTime=2e4]="TimeoutTime",c[c.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",c[c.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",c[c.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(E||(e.ProtocolConstants=E={}));class d{constructor(s,w,g,D){this.type=s,this.id=w,this.ack=g,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends L.Disposable{constructor(s){super(),this._onMessage=this._register(new O.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(w=>this.acceptChunk(w))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const w=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=w.readUInt32BE(9),this._state.messageType=w.readUInt8(0),this._state.id=w.readUInt32BE(1),this._state.ack=w.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:S(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const g=this._state.messageType,D=this._state.id,v=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",w),this._onMessage.fire(new d(g,D,v,w)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class a{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const w=h.VSBuffer.alloc(13);w.writeUInt8(s.type,0),w.writeUInt32BE(s.id,1),w.writeUInt32BE(s.ack,5),w.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:S(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(w,s.data)}_bufferAdd(s,w){const g=this._totalLength===0;return this._data.push(s,w),this._totalLength+=s.byteLength+w.byteLength,g}_bufferTake(){const s=h.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,w){this._bufferAdd(s,w)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class i extends L.Disposable{constructor(s){super(),this._onMessage=new O.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new O.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new a(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(w=>{w.type===1&&this._onMessage.fire(w.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new d(1,0,0,s))}}e.Protocol=i;class n extends A.IPCClient{static fromSocket(s,w){return new n(new i(s),w)}get onDidDispose(){return this.protocol.onDidDispose}constructor(s,w,g=null){super(s,w,g),this.protocol=s}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=n;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new O.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class o{constructor(s){this.data=s,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let s=0,w=this._first;for(;w;)w=w.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let w=0,g=this._first;for(;g;)s[w++]=g.data,g=g.next;return s}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const w=new o(s);if(!this._first){this._first=w,this._last=w;return}this._last.next=w,this._last=w}}class u{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return u._INSTANCE||(u._INSTANCE=new u),u._INSTANCE}constructor(){this.lastRuns=[];const s=Date.now();for(let w=0;w<u._HISTORY_LENGTH;w++)this.lastRuns[w]=s-1e3*w;setInterval(()=>{for(let w=u._HISTORY_LENGTH;w>=1;w--)this.lastRuns[w]=this.lastRuns[w-1];this.lastRuns[0]=Date.now()},1e3)}load(){const s=Date.now(),w=(1+u._HISTORY_LENGTH)*1e3;let g=0;for(let D=0;D<u._HISTORY_LENGTH;D++)s-this.lastRuns[D]<=w&&g++;return 1-g/u._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class r{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(s){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=s.loadEstimator??u.getInstance(),this._shouldSendKeepAlive=s.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new L.DisposableStore,this._socket=s.socket,this._socketWriter=this._socketDisposables.add(new a(this._socket)),this._socketReader=this._socketDisposables.add(new f(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(w=>this._receiveMessage(w))),this._socketDisposables.add(this._socket.onClose(w=>this._onSocketClose.fire(w))),s.initialChunk&&this._socketReader.acceptChunk(s.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new d(5,0,0,T());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new d(7,0,0,T());this._socketWriter.write(s)}sendResume(){const s=new d(8,0,0,T());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,w){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new L.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=this._socketDisposables.add(new a(this._socket)),this._socketReader=this._socketDisposables.add(new f(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(g=>this._receiveMessage(g))),this._socketDisposables.add(this._socket.onClose(g=>this._onSocketClose.fire(g))),this._socketReader.acceptChunk(w)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new d(3,0,this._incomingAckId,T());this._socketWriter.write(s);const w=this._outgoingUnackMsg.toArray();for(let g=0,D=w.length;g<D;g++)this._socketWriter.write(w[g]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const w=this._outgoingUnackMsg.peek();if(w&&w.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const w=Date.now();w-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=w,this._socketWriter.write(new d(6,0,0,T())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const w=this._outgoingUnackMsg.toArray();for(let g=0,D=w.length;g<D;g++)this._socketWriter.write(w[g]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const w=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const g=new d(1,w,this._incomingAckId,s);this._outgoingUnackMsg.push(g),this._isReconnecting||(this._socketWriter.write(g),this._recvAckCheck())}sendControl(s){const w=new d(2,0,0,s);this._socketWriter.write(w)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),w=Date.now()-s.writtenTime,g=Date.now()-this._socketReader.lastReadTime,D=Date.now()-this._lastSocketTimeoutTime;if(w>=2e4&&g>=2e4&&D>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:w,timeSinceLastReceivedSomeData:g});return}const v=Math.max(2e4-w,2e4-g,2e4-D,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},v)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new d(3,0,this._incomingAckId,T());this._socketWriter.write(s)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const s=new d(9,0,this._incomingAckId,T());this._socketWriter.write(s)}}e.PersistentProtocol=r}),define(_e[199],Ce([1,0,54,7,21,22,197,13,4,3,24,105,102,82]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class E extends S.ChannelServer{constructor(a){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:m.Event.fromNodeEventEmitter(process,"message",i=>L.VSBuffer.wrap(Buffer.from(i,"base64")))},a),process.once("disconnect",()=>this.dispose())}}e.Server=E;class d{constructor(a,i){this.modulePath=a,this.options=i,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new m.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const n=i&&i.timeout?i.timeout:6e4;this.disposeDelayer=new O.Delayer(n),this.child=null,this._client=null}getChannel(a){const i=this;return{call(n,l,o){return i.requestPromise(a,n,l,o)},listen(n,l){return i.requestEvent(a,n,l)}}}requestPromise(a,i,n,l=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(a),t=(0,O.createCancelablePromise)(c=>o.call(i,n,c)),u=l.onCancellationRequested(()=>t.cancel()),r=(0,y.toDisposable)(()=>t.cancel());return this.activeRequests.add(r),t.finally(()=>{u.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(a,i,n){if(!this.disposeDelayer)return m.Event.None;this.disposeDelayer.cancel();let l;const o=new m.Emitter({onWillAddFirstListener:()=>{l=this.getCachedChannel(a).listen(i,n)(o.fire,o),this.activeRequests.add(l)},onDidRemoveLastListener:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const a=this.options&&this.options.args?this.options.args:[],i=Object.create(null);i.env={...(0,T.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(i.env={...i.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(i.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(w=>!/^--inspect(-brk)?=/.test(w)).filter(w=>!w.startsWith("--vscode-"))),(0,p.removeDangerousEnvVariables)(i.env),this.child=(0,h.fork)(this.modulePath,a,i);const n=new m.Emitter,o=m.Event.fromNodeEventEmitter(this.child,"message",w=>w)(w=>{if((0,R.isRemoteConsoleLog)(w)){(0,R.log)(w,`IPC Library: ${this.options.serverName}`);return}n.fire(L.VSBuffer.wrap(Buffer.from(w,"base64")))}),t=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,u=w=>this.child&&this.child.connected&&t.send(w.buffer.toString("base64")),r=n.event,c={send:u,onMessage:r};this._client=new S.ChannelClient(c);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",w=>console.warn('IPC "'+this.options.serverName+'" errored with '+w)),this.child.on("exit",(w,g)=>{process.removeListener("exit",s),o.dispose(),this.activeRequests.forEach(D=>(0,y.dispose)(D)),this.activeRequests.clear(),w!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+w+" and signal "+g),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:w,signal:g})})}return this._client}getCachedChannel(a){let i=this.channels.get(a);return i||(i=this.client.getChannel(a),this.channels.set(a,i)),i}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=d}),define(_e[200],Ce([1,0,7,4,3,58,18]),function(ue,e,h,O,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=m;var b;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function m(p){const S=p;return S?.changed instanceof Map||S?.deleted instanceof Set}var y;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(y||(e.StorageState=y={}));class T extends L.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(S,E=Object.create(null)){super(),this.database=S,this.options=E,this._onDidChangeStorage=this._register(new O.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=y.None,this.cache=new Map,this.flushDelayer=this._register(new h.ThrottledDelayer(T.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){this._onDidChangeStorage.pause();try{S.changed?.forEach((E,d)=>this.acceptExternal(d,E)),S.deleted?.forEach(E=>this.acceptExternal(E,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(S,E){if(this.state===y.Closed)return;let d=!1;(0,R.isUndefinedOrNull)(E)?d=this.cache.delete(S):this.cache.get(S)!==E&&(this.cache.set(S,E),d=!0),d&&this._onDidChangeStorage.fire({key:S,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===y.None&&(this.state=y.Initialized,this.options.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,E){const d=this.cache.get(S);return(0,R.isUndefinedOrNull)(d)?E:d}getBoolean(S,E){const d=this.get(S);return(0,R.isUndefinedOrNull)(d)?E:d==="true"}getNumber(S,E){const d=this.get(S);return(0,R.isUndefinedOrNull)(d)?E:parseInt(d,10)}getObject(S,E){const d=this.get(S);return(0,R.isUndefinedOrNull)(d)?E:(0,A.parse)(d)}async set(S,E,d=!1){if(this.state===y.Closed)return;if((0,R.isUndefinedOrNull)(E))return this.delete(S,d);const f=(0,R.isObject)(E)||Array.isArray(E)?(0,A.stringify)(E):String(E);if(this.cache.get(S)!==f)return this.cache.set(S,f),this.pendingInserts.set(S,f),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire({key:S,external:d}),this.doFlush()}async delete(S,E=!1){if(!(this.state===y.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire({key:S,external:E}),this.doFlush()}async optimize(){if(this.state!==y.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=y.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(this.hasPending)return this.doFlush(S)}async doFlush(S){return this.options.hint===b.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}isInMemory(){return this.options.hint===b.STORAGE_IN_MEMORY}}e.Storage=T;class I{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert?.forEach((E,d)=>this.items.set(d,E)),S.delete?.forEach(E=>this.items.delete(E))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=I}),define(_e[201],Ce([1,0,14,12,21]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringBuilder=void 0,e.getPlatformTextDecoder=T,e.decodeUTF16LE=I;let A;function R(){return A||(A=new TextDecoder("UTF-16LE")),A}let b;function m(){return b||(b=new TextDecoder("UTF-16BE")),b}let y;function T(){return y||(y=O.isLittleEndian()?R():m()),y}function I(E,d,f){const a=new Uint16Array(E.buffer,d,f);return f>0&&(a[0]===65279||a[0]===65534)?p(E,d,f):R().decode(a)}function p(E,d,f){const a=[];let i=0;for(let n=0;n<f;n++){const l=L.readUInt16LE(E,d);d+=2,a[i++]=String.fromCharCode(l)}return a.join("")}class S{constructor(d){this._capacity=d|0,this._buffer=new Uint16Array(this._capacity),this._completedStrings=null,this._bufferLength=0}reset(){this._completedStrings=null,this._bufferLength=0}build(){return this._completedStrings!==null?(this._flushBuffer(),this._completedStrings.join("")):this._buildBuffer()}_buildBuffer(){if(this._bufferLength===0)return"";const d=new Uint16Array(this._buffer.buffer,0,this._bufferLength);return T().decode(d)}_flushBuffer(){const d=this._buildBuffer();this._bufferLength=0,this._completedStrings===null?this._completedStrings=[d]:this._completedStrings[this._completedStrings.length]=d}appendCharCode(d){const f=this._capacity-this._bufferLength;f<=1&&(f===0||h.isHighSurrogate(d))&&this._flushBuffer(),this._buffer[this._bufferLength++]=d}appendASCIICharCode(d){this._bufferLength===this._capacity&&this._flushBuffer(),this._buffer[this._bufferLength++]=d}appendString(d){const f=d.length;if(this._bufferLength+f>=this._capacity){this._flushBuffer(),this._completedStrings[this._completedStrings.length]=d;return}for(let a=0;a<f;a++)this._buffer[this._bufferLength++]=d.charCodeAt(a)}}e.StringBuilder=S}),define(_e[202],Ce([1,0,21,201]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextChange=void 0,e.compressConsecutiveTextChanges=R;function L(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class A{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,T,I,p){this.oldPosition=y,this.oldText=T,this.newPosition=I,this.newText=p}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${L(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${L(this.oldText)}")`:`(replace@${this.oldPosition} "${L(this.oldText)}" with "${L(this.newText)}")`}static _writeStringSize(y){return 4+2*y.length}static _writeString(y,T,I){const p=T.length;h.writeUInt32BE(y,p,I),I+=4;for(let S=0;S<p;S++)h.writeUInt16LE(y,T.charCodeAt(S),I),I+=2;return I}static _readString(y,T){const I=h.readUInt32BE(y,T);return T+=4,(0,O.decodeUTF16LE)(y,T,I)}writeSize(){return 8+A._writeStringSize(this.oldText)+A._writeStringSize(this.newText)}write(y,T){return h.writeUInt32BE(y,this.oldPosition,T),T+=4,h.writeUInt32BE(y,this.newPosition,T),T+=4,T=A._writeString(y,this.oldText,T),T=A._writeString(y,this.newText,T),T}static read(y,T,I){const p=h.readUInt32BE(y,T);T+=4;const S=h.readUInt32BE(y,T);T+=4;const E=A._readString(y,T);T+=A._writeStringSize(E);const d=A._readString(y,T);return T+=A._writeStringSize(d),I.push(new A(p,E,S,d)),T}}e.TextChange=A;function R(m,y){return m===null||m.length===0?y:new b(m,y).compress()}class b{constructor(y,T){this._prevEdits=y,this._currEdits=T,this._result=[],this._resultLen=0,this._prevLen=this._prevEdits.length,this._prevDeltaOffset=0,this._currLen=this._currEdits.length,this._currDeltaOffset=0}compress(){let y=0,T=0,I=this._getPrev(y),p=this._getCurr(T);for(;y<this._prevLen||T<this._currLen;){if(I===null){this._acceptCurr(p),p=this._getCurr(++T);continue}if(p===null){this._acceptPrev(I),I=this._getPrev(++y);continue}if(p.oldEnd<=I.newPosition){this._acceptCurr(p),p=this._getCurr(++T);continue}if(I.newEnd<=p.oldPosition){this._acceptPrev(I),I=this._getPrev(++y);continue}if(p.oldPosition<I.newPosition){const[a,i]=b._splitCurr(p,I.newPosition-p.oldPosition);this._acceptCurr(a),p=i;continue}if(I.newPosition<p.oldPosition){const[a,i]=b._splitPrev(I,p.oldPosition-I.newPosition);this._acceptPrev(a),I=i;continue}let d,f;if(p.oldEnd===I.newEnd)d=I,f=p,I=this._getPrev(++y),p=this._getCurr(++T);else if(p.oldEnd<I.newEnd){const[a,i]=b._splitPrev(I,p.oldLength);d=a,f=p,I=i,p=this._getCurr(++T)}else{const[a,i]=b._splitCurr(p,I.newLength);d=I,f=a,I=this._getPrev(++y),p=i}this._result[this._resultLen++]=new A(d.oldPosition,d.oldText,f.newPosition,f.newText),this._prevDeltaOffset+=d.newLength-d.oldLength,this._currDeltaOffset+=f.newLength-f.oldLength}const S=b._merge(this._result);return b._removeNoOps(S)}_acceptCurr(y){this._result[this._resultLen++]=b._rebaseCurr(this._prevDeltaOffset,y),this._currDeltaOffset+=y.newLength-y.oldLength}_getCurr(y){return y<this._currLen?this._currEdits[y]:null}_acceptPrev(y){this._result[this._resultLen++]=b._rebasePrev(this._currDeltaOffset,y),this._prevDeltaOffset+=y.newLength-y.oldLength}_getPrev(y){return y<this._prevLen?this._prevEdits[y]:null}static _rebaseCurr(y,T){return new A(T.oldPosition-y,T.oldText,T.newPosition,T.newText)}static _rebasePrev(y,T){return new A(T.oldPosition,T.oldText,T.newPosition+y,T.newText)}static _splitPrev(y,T){const I=y.newText.substr(0,T),p=y.newText.substr(T);return[new A(y.oldPosition,y.oldText,y.newPosition,I),new A(y.oldEnd,"",y.newPosition+T,p)]}static _splitCurr(y,T){const I=y.oldText.substr(0,T),p=y.oldText.substr(T);return[new A(y.oldPosition,I,y.newPosition,y.newText),new A(y.oldPosition+T,p,y.newEnd,"")]}static _merge(y){if(y.length===0)return y;const T=[];let I=0,p=y[0];for(let S=1;S<y.length;S++){const E=y[S];p.oldEnd===E.oldPosition?p=new A(p.oldPosition,p.oldText+E.oldText,p.newPosition,p.newText+E.newText):(T[I++]=p,p=E)}return T[I++]=p,T}static _removeNoOps(y){if(y.length===0)return y;const T=[];let I=0;for(let p=0;p<y.length;p++){const S=y[p];S.oldText!==S.newText&&(T[I++]=S)}return T}}}),define(_e[203],Ce([1,0,35,17]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=L,e.targetsNotebooks=A;function L(R,b,m,y,T,I){if(Array.isArray(R)){let p=0;for(const S of R){const E=L(S,b,m,y,T,I);if(E===10)return E;E>p&&(p=E)}return p}else{if(typeof R=="string")return y?R==="*"?5:R===m?10:0:0;if(R){const{language:p,pattern:S,scheme:E,hasAccessToAllModels:d,notebookType:f}=R;if(!y&&!d)return 0;f&&T&&(b=T);let a=0;if(E)if(E===b.scheme)a=10;else if(E==="*")a=5;else return 0;if(p)if(p===m)a=10;else if(p==="*")a=Math.max(a,5);else return 0;if(f)if(f===I)a=10;else if(f==="*"&&I!==void 0)a=Math.max(a,5);else return 0;if(S){let i;if(typeof S=="string"?i=S:i={...S,base:(0,O.normalize)(S.base)},i===b.fsPath||(0,h.match)(i,b.fsPath))a=10;else return 0}return a}else return 0}}function A(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(A):!!R.notebookType}}),define(_e[204],Ce([1,0,4,14,29,80,131,179,202,3]),function(ue,e,h,O,L,A,R,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBuffer=void 0;class T extends y.Disposable{constructor(p,S,E,d,f,a,i){super(),this._onDidChangeContent=this._register(new h.Emitter),this.onDidChangeContent=this._onDidChangeContent.event,this._BOM=S,this._mightContainNonBasicASCII=!a,this._mightContainRTL=d,this._mightContainUnusualLineTerminators=f,this._pieceTree=new R.PieceTreeBase(p,E,i)}equals(p){return!(p instanceof T)||this._BOM!==p._BOM||this.getEOL()!==p.getEOL()?!1:this._pieceTree.equal(p._pieceTree)}mightContainRTL(){return this._mightContainRTL}mightContainUnusualLineTerminators(){return this._mightContainUnusualLineTerminators}resetMightContainUnusualLineTerminators(){this._mightContainUnusualLineTerminators=!1}mightContainNonBasicASCII(){return this._mightContainNonBasicASCII}getBOM(){return this._BOM}getEOL(){return this._pieceTree.getEOL()}createSnapshot(p){return this._pieceTree.createSnapshot(p?this._BOM:"")}getOffsetAt(p,S){return this._pieceTree.getOffsetAt(p,S)}getPositionAt(p){return this._pieceTree.getPositionAt(p)}getRangeAt(p,S){const E=p+S,d=this.getPositionAt(p),f=this.getPositionAt(E);return new L.Range(d.lineNumber,d.column,f.lineNumber,f.column)}getValueInRange(p,S=0){if(p.isEmpty())return"";const E=this._getEndOfLine(S);return this._pieceTree.getValueInRange(p,E)}getValueLengthInRange(p,S=0){if(p.isEmpty())return 0;if(p.startLineNumber===p.endLineNumber)return p.endColumn-p.startColumn;const E=this.getOffsetAt(p.startLineNumber,p.startColumn),d=this.getOffsetAt(p.endLineNumber,p.endColumn);let f=0;const a=this._getEndOfLine(S),i=this.getEOL();if(a.length!==i.length){const n=a.length-i.length,l=p.endLineNumber-p.startLineNumber;f=n*l}return d-E+f}getCharacterCountInRange(p,S=0){if(this._mightContainNonBasicASCII){let E=0;const d=p.startLineNumber,f=p.endLineNumber;for(let a=d;a<=f;a++){const i=this.getLineContent(a),n=a===d?p.startColumn-1:0,l=a===f?p.endColumn-1:i.length;for(let o=n;o<l;o++)O.isHighSurrogate(i.charCodeAt(o))?(E=E+1,o=o+1):E=E+1}return E+=this._getEndOfLine(S).length*(f-d),E}return this.getValueLengthInRange(p,S)}getLength(){return this._pieceTree.getLength()}getLineCount(){return this._pieceTree.getLineCount()}getLinesContent(){return this._pieceTree.getLinesContent()}getLineContent(p){return this._pieceTree.getLineContent(p)}getLineCharCode(p,S){return this._pieceTree.getLineCharCode(p,S)}getCharCode(p){return this._pieceTree.getCharCode(p)}getLineLength(p){return this._pieceTree.getLineLength(p)}getLineMinColumn(p){return 1}getLineMaxColumn(p){return this.getLineLength(p)+1}getLineFirstNonWhitespaceColumn(p){const S=O.firstNonWhitespaceIndex(this.getLineContent(p));return S===-1?0:S+1}getLineLastNonWhitespaceColumn(p){const S=O.lastNonWhitespaceIndex(this.getLineContent(p));return S===-1?0:S+2}_getEndOfLine(p){switch(p){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(p){this._pieceTree.setEOL(p)}applyEdits(p,S,E){let d=this._mightContainRTL,f=this._mightContainUnusualLineTerminators,a=this._mightContainNonBasicASCII,i=!0,n=[];for(let s=0;s<p.length;s++){const w=p[s];i&&w._isTracked&&(i=!1);const g=w.range;if(w.text){let P=!0;a||(P=!O.isBasicASCII(w.text),a=P),!d&&P&&(d=O.containsRTL(w.text)),!f&&P&&(f=O.containsUnusualLineTerminators(w.text))}let D="",v=0,_=0,C=0;if(w.text){let P;[v,_,C,P]=(0,b.countEOL)(w.text);const k=this.getEOL();P===0||P===(k===`\r
`?2:1)?D=w.text:D=w.text.replace(/\r\n|\r|\n/g,k)}n[s]={sortIndex:s,identifier:w.identifier||null,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g),text:D,eolCount:v,firstLineLength:_,lastLineLength:C,forceMoveMarkers:!!w.forceMoveMarkers,isAutoWhitespaceEdit:w.isAutoWhitespaceEdit||!1}}n.sort(T._sortOpsAscending);let l=!1;for(let s=0,w=n.length-1;s<w;s++){const g=n[s].range.getEndPosition(),D=n[s+1].range.getStartPosition();if(D.isBeforeOrEqual(g)){if(D.isBefore(g))throw new Error("Overlapping ranges are not allowed!");l=!0}}i&&(n=this._reduceOperations(n));const o=E||S?T._getInverseEditRanges(n):[],t=[];if(S)for(let s=0;s<n.length;s++){const w=n[s],g=o[s];if(w.isAutoWhitespaceEdit&&w.range.isEmpty())for(let D=g.startLineNumber;D<=g.endLineNumber;D++){let v="";D===g.startLineNumber&&(v=this.getLineContent(w.range.startLineNumber),O.firstNonWhitespaceIndex(v)!==-1)||t.push({lineNumber:D,oldContent:v})}}let u=null;if(E){let s=0;u=[];for(let w=0;w<n.length;w++){const g=n[w],D=o[w],v=this.getValueInRange(g.range),_=g.rangeOffset+s;s+=g.text.length-v.length,u[w]={sortIndex:g.sortIndex,identifier:g.identifier,range:D,text:v,textChange:new m.TextChange(g.rangeOffset,v,_,g.text)}}l||u.sort((w,g)=>w.sortIndex-g.sortIndex)}this._mightContainRTL=d,this._mightContainUnusualLineTerminators=f,this._mightContainNonBasicASCII=a;const r=this._doApplyEdits(n);let c=null;if(S&&t.length>0){t.sort((s,w)=>w.lineNumber-s.lineNumber),c=[];for(let s=0,w=t.length;s<w;s++){const g=t[s].lineNumber;if(s>0&&t[s-1].lineNumber===g)continue;const D=t[s].oldContent,v=this.getLineContent(g);v.length===0||v===D||O.firstNonWhitespaceIndex(v)!==-1||c.push(g)}}return this._onDidChangeContent.fire(),new A.ApplyEditsResult(u,r,c)}_reduceOperations(p){return p.length<1e3?p:[this._toSingleEditOperation(p)]}_toSingleEditOperation(p){let S=!1;const E=p[0].range,d=p[p.length-1].range,f=new L.Range(E.startLineNumber,E.startColumn,d.endLineNumber,d.endColumn);let a=E.startLineNumber,i=E.startColumn;const n=[];for(let r=0,c=p.length;r<c;r++){const s=p[r],w=s.range;S=S||s.forceMoveMarkers,n.push(this.getValueInRange(new L.Range(a,i,w.startLineNumber,w.startColumn))),s.text.length>0&&n.push(s.text),a=w.endLineNumber,i=w.endColumn}const l=n.join(""),[o,t,u]=(0,b.countEOL)(l);return{sortIndex:0,identifier:p[0].identifier,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f,0),text:l,eolCount:o,firstLineLength:t,lastLineLength:u,forceMoveMarkers:S,isAutoWhitespaceEdit:!1}}_doApplyEdits(p){p.sort(T._sortOpsDescending);const S=[];for(let E=0;E<p.length;E++){const d=p[E],f=d.range.startLineNumber,a=d.range.startColumn,i=d.range.endLineNumber,n=d.range.endColumn;if(f===i&&a===n&&d.text.length===0)continue;d.text?(this._pieceTree.delete(d.rangeOffset,d.rangeLength),this._pieceTree.insert(d.rangeOffset,d.text,!0)):this._pieceTree.delete(d.rangeOffset,d.rangeLength);const l=new L.Range(f,a,i,n);S.push({range:l,rangeLength:d.rangeLength,text:d.text,rangeOffset:d.rangeOffset,forceMoveMarkers:d.forceMoveMarkers})}return S}findMatchesLineByLine(p,S,E,d){return this._pieceTree.findMatchesLineByLine(p,S,E,d)}getPieceTree(){return this._pieceTree}static _getInverseEditRange(p,S){const E=p.startLineNumber,d=p.startColumn,[f,a,i]=(0,b.countEOL)(S);let n;if(S.length>0){const l=f+1;l===1?n=new L.Range(E,d,E,d+a):n=new L.Range(E,d,E+l-1,i+1)}else n=new L.Range(E,d,E,d);return n}static _getInverseEditRanges(p){const S=[];let E=0,d=0,f=null;for(let a=0,i=p.length;a<i;a++){const n=p[a];let l,o;f?f.range.endLineNumber===n.range.startLineNumber?(l=E,o=d+(n.range.startColumn-f.range.endColumn)):(l=E+(n.range.startLineNumber-f.range.endLineNumber),o=n.range.startColumn):(l=n.range.startLineNumber,o=n.range.startColumn);let t;if(n.text.length>0){const u=n.eolCount+1;u===1?t=new L.Range(l,o,l,o+n.firstLineLength):t=new L.Range(l,o,l+u-1,n.lastLineLength+1)}else t=new L.Range(l,o,l,o);E=t.endLineNumber,d=t.endColumn,S.push(t),f=n}return S}static _sortOpsAscending(p,S){const E=L.Range.compareRangesUsingEnds(p.range,S.range);return E===0?p.sortIndex-S.sortIndex:E}static _sortOpsDescending(p,S){const E=L.Range.compareRangesUsingEnds(p.range,S.range);return E===0?S.sortIndex-p.sortIndex:-E}}e.PieceTreeTextBuffer=T}),define(_e[205],Ce([1,0,14,131,204]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBufferBuilder=void 0;class A{constructor(m,y,T,I,p,S,E,d,f){this._chunks=m,this._bom=y,this._cr=T,this._lf=I,this._crlf=p,this._containsRTL=S,this._containsUnusualLineTerminators=E,this._isBasicASCII=d,this._normalizeEOL=f}_getEOL(m){const y=this._cr+this._lf+this._crlf,T=this._cr+this._crlf;return y===0?m===1?`
`:`\r
`:T>y/2?`\r
`:`
`}create(m){const y=this._getEOL(m),T=this._chunks;if(this._normalizeEOL&&(y===`\r
`&&(this._cr>0||this._lf>0)||y===`
`&&(this._cr>0||this._crlf>0)))for(let p=0,S=T.length;p<S;p++){const E=T[p].buffer.replace(/\r\n|\r|\n/g,y),d=(0,O.createLineStartsFast)(E);T[p]=new O.StringBuffer(E,d)}const I=new L.PieceTreeTextBuffer(T,this._bom,y,this._containsRTL,this._containsUnusualLineTerminators,this._isBasicASCII,this._normalizeEOL);return{textBuffer:I,disposable:I}}getFirstLineText(m){return this._chunks[0].buffer.substr(0,m).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.chunks=[],this.BOM="",this._hasPreviousChar=!1,this._previousChar=0,this._tmpLineStarts=[],this.cr=0,this.lf=0,this.crlf=0,this.containsRTL=!1,this.containsUnusualLineTerminators=!1,this.isBasicASCII=!0}acceptChunk(m){if(m.length===0)return;this.chunks.length===0&&h.startsWithUTF8BOM(m)&&(this.BOM=h.UTF8_BOM_CHARACTER,m=m.substr(1));const y=m.charCodeAt(m.length-1);y===13||y>=55296&&y<=56319?(this._acceptChunk1(m.substr(0,m.length-1),!1),this._hasPreviousChar=!0,this._previousChar=y):(this._acceptChunk1(m,!1),this._hasPreviousChar=!1,this._previousChar=y)}_acceptChunk1(m,y){!y&&m.length===0||(this._hasPreviousChar?this._acceptChunk2(String.fromCharCode(this._previousChar)+m):this._acceptChunk2(m))}_acceptChunk2(m){const y=(0,O.createLineStarts)(this._tmpLineStarts,m);this.chunks.push(new O.StringBuffer(m,y.lineStarts)),this.cr+=y.cr,this.lf+=y.lf,this.crlf+=y.crlf,y.isBasicASCII||(this.isBasicASCII=!1,this.containsRTL||(this.containsRTL=h.containsRTL(m)),this.containsUnusualLineTerminators||(this.containsUnusualLineTerminators=h.containsUnusualLineTerminators(m)))}finish(m=!0){return this._finish(),new A(this.chunks,this.BOM,this.cr,this.lf,this.crlf,this.containsRTL,this.containsUnusualLineTerminators,this.isBasicASCII,m)}_finish(){if(this.chunks.length===0&&this._acceptChunk1("",!0),this._hasPreviousChar){this._hasPreviousChar=!1;const m=this.chunks[this.chunks.length-1];m.buffer+=String.fromCharCode(this._previousChar);const y=(0,O.createLineStartsFast)(m.buffer);m.lineStarts=y,this._previousChar===13&&this.cr++}}}e.PieceTreeTextBufferBuilder=R}),define(_e[135],Ce([1,0,21,12]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeSemanticTokensDto=m,e.decodeSemanticTokensDto=T;var L;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(L||(L={}));function A(I){for(let p=0,S=I.length;p<S;p+=4){const E=I[p+0],d=I[p+1],f=I[p+2],a=I[p+3];I[p+0]=a,I[p+1]=f,I[p+2]=d,I[p+3]=E}}function R(I){const p=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return O.isLittleEndian()||A(p),h.VSBuffer.wrap(p)}function b(I){const p=I.buffer;if(O.isLittleEndian()||A(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const S=new Uint8Array(p.byteLength);return S.set(p),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function m(I){const p=new Uint32Array(y(I));let S=0;if(p[S++]=I.id,I.type==="full")p[S++]=1,p[S++]=I.data.length,p.set(I.data,S),S+=I.data.length;else{p[S++]=2,p[S++]=I.deltas.length;for(const E of I.deltas)p[S++]=E.start,p[S++]=E.deleteCount,E.data?(p[S++]=E.data.length,p.set(E.data,S),S+=E.data.length):p[S++]=0}return R(p)}function y(I){let p=0;if(p+=2,I.type==="full")p+=1+I.data.length;else{p+=1,p+=3*I.deltas.length;for(const S of I.deltas)S.data&&(p+=S.data.length)}return p}function T(I){const p=b(I);let S=0;const E=p[S++];if(p[S++]===1){const i=p[S++],n=p.subarray(S,S+i);return S+=i,{id:E,type:"full",data:n}}const f=p[S++],a=[];for(let i=0;i<f;i++){const n=p[S++],l=p[S++],o=p[S++];let t;o>0&&(t=p.subarray(S,S+o),S+=o),a[i]={start:n,deleteCount:l,data:t}}return{id:E,type:"delta",deltas:a}}}),define(_e[206],Ce([9,10]),function(ue,e){return ue.create("vs/editor/common/config/editorOptions",e)}),define(_e[136],Ce([1,0,19,24,12,182,130,206]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=f,e.clampedInt=i,e.clampedFloat=l,e.stringSet=u,e.cursorStyleToString=C,e.filterValidationDecorations=be;var m;(function(ae){ae[ae.None=0]="None",ae[ae.Keep=1]="Keep",ae[ae.Brackets=2]="Brackets",ae[ae.Advanced=3]="Advanced",ae[ae.Full=4]="Full"})(m||(e.EditorAutoIndentStrategy=m={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ce){this._values=ce}hasChanged(ce){return this._values[ce]}}e.ConfigurationChangedEvent=y;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class I{constructor(ce,ke,je,Le){this.id=ce,this.name=ke,this.defaultValue=je,this.schema=Le}applyUpdate(ce,ke){return S(ce,ke)}compute(ce,ke,je){return je}}class p{constructor(ce,ke){this.newValue=ce,this.didChange=ke}}e.ApplyUpdateResult=p;function S(ae,ce){if(typeof ae!="object"||typeof ce!="object"||!ae||!ce)return new p(ce,ae!==ce);if(Array.isArray(ae)||Array.isArray(ce)){const je=Array.isArray(ae)&&Array.isArray(ce)&&h.equals(ae,ce);return new p(ce,!je)}let ke=!1;for(const je in ce)if(ce.hasOwnProperty(je)){const Le=S(ae[je],ce[je]);Le.didChange&&(ae[je]=Le.newValue,ke=!0)}return new p(ae,ke)}class E{constructor(ce){this.schema=void 0,this.id=ce,this.name="_never_",this.defaultValue=void 0}applyUpdate(ce,ke){return S(ce,ke)}validate(ce){return this.defaultValue}}class d{constructor(ce,ke,je,Le){this.id=ce,this.name=ke,this.defaultValue=je,this.schema=Le}applyUpdate(ce,ke){return S(ce,ke)}validate(ce){return typeof ce>"u"?this.defaultValue:ce}compute(ce,ke,je){return je}}function f(ae,ce){return typeof ae>"u"?ce:ae==="false"?!1:!!ae}class a extends d{constructor(ce,ke,je,Le=void 0){typeof Le<"u"&&(Le.type="boolean",Le.default=je),super(ce,ke,je,Le)}validate(ce){return f(ce,this.defaultValue)}}function i(ae,ce,ke,je){if(typeof ae>"u")return ce;let Le=parseInt(ae,10);return isNaN(Le)?ce:(Le=Math.max(ke,Le),Le=Math.min(je,Le),Le|0)}class n extends d{static clampedInt(ce,ke,je,Le){return i(ce,ke,je,Le)}constructor(ce,ke,je,Le,ot,lt=void 0){typeof lt<"u"&&(lt.type="integer",lt.default=je,lt.minimum=Le,lt.maximum=ot),super(ce,ke,je,lt),this.minimum=Le,this.maximum=ot}validate(ce){return n.clampedInt(ce,this.defaultValue,this.minimum,this.maximum)}}function l(ae,ce,ke,je){if(typeof ae>"u")return ce;const Le=o.float(ae,ce);return o.clamp(Le,ke,je)}class o extends d{static clamp(ce,ke,je){return ce<ke?ke:ce>je?je:ce}static float(ce,ke){if(typeof ce=="number")return ce;if(typeof ce>"u")return ke;const je=parseFloat(ce);return isNaN(je)?ke:je}constructor(ce,ke,je,Le,ot){typeof ot<"u"&&(ot.type="number",ot.default=je),super(ce,ke,je,ot),this.validationFn=Le}validate(ce){return this.validationFn(o.float(ce,this.defaultValue))}}class t extends d{static string(ce,ke){return typeof ce!="string"?ke:ce}constructor(ce,ke,je,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.default=je),super(ce,ke,je,Le)}validate(ce){return t.string(ce,this.defaultValue)}}function u(ae,ce,ke,je){return typeof ae!="string"?ce:je&&ae in je?je[ae]:ke.indexOf(ae)===-1?ce:ae}class r extends d{constructor(ce,ke,je,Le,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=Le,ot.default=je),super(ce,ke,je,ot),this._allowedValues=Le}validate(ce){return u(ce,this.defaultValue,this._allowedValues)}}class c extends I{constructor(ce,ke,je,Le,ot,lt,wt=void 0){typeof wt<"u"&&(wt.type="string",wt.enum=ot,wt.default=Le),super(ce,ke,je,wt),this._allowedValues=ot,this._convert=lt}validate(ce){return typeof ce!="string"?this.defaultValue:this._allowedValues.indexOf(ce)===-1?this.defaultValue:this._convert(ce)}}function s(ae){switch(ae){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class w extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ce){switch(ce){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ce,ke,je){return je===0?ce.accessibilitySupport:je}}class g extends I{constructor(){const ce={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ce,{"editor.comments.insertSpace":{type:"boolean",default:ce.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ce.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const ke=ce;return{insertSpace:f(ke.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(ke.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(ae){ae[ae.Hidden=0]="Hidden",ae[ae.Blink=1]="Blink",ae[ae.Smooth=2]="Smooth",ae[ae.Phase=3]="Phase",ae[ae.Expand=4]="Expand",ae[ae.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function v(ae){switch(ae){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var _;(function(ae){ae[ae.Line=1]="Line",ae[ae.Block=2]="Block",ae[ae.Underline=3]="Underline",ae[ae.LineThin=4]="LineThin",ae[ae.BlockOutline=5]="BlockOutline",ae[ae.UnderlineThin=6]="UnderlineThin"})(_||(e.TextEditorCursorStyle=_={}));function C(ae){switch(ae){case _.Line:return"line";case _.Block:return"block";case _.Underline:return"underline";case _.LineThin:return"line-thin";case _.BlockOutline:return"block-outline";case _.UnderlineThin:return"underline-thin"}}function P(ae){switch(ae){case"line":return _.Line;case"block":return _.Block;case"underline":return _.Underline;case"line-thin":return _.LineThin;case"block-outline":return _.BlockOutline;case"underline-thin":return _.UnderlineThin}}class k extends E{constructor(){super(142)}compute(ce,ke,je){const Le=["monaco-editor"];return ke.get(39)&&Le.push(ke.get(39)),ce.extraEditorClassName&&Le.push(ce.extraEditorClassName),ke.get(74)==="default"?Le.push("mouse-default"):ke.get(74)==="copy"&&Le.push("mouse-copy"),ke.get(111)&&Le.push("showUnused"),ke.get(140)&&Le.push("showDeprecated"),Le.join(" ")}}class F extends a{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ce,ke,je){return je&&ce.emptySelectionClipboard}}class x extends I{constructor(){const ce={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ce,{"editor.find.cursorMoveOnType":{type:"boolean",default:ce.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ce.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ce.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ce.globalFindClipboard,description:b.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ce.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ce.loop,description:b.localize(18,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const ke=ce;return{cursorMoveOnType:f(ke.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ce.seedSearchStringFromSelection=="boolean"?ce.seedSearchStringFromSelection?"always":"never":u(ke.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ce.autoFindInSelection=="boolean"?ce.autoFindInSelection?"always":"never":u(ke.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(ke.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(ke.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(ke.loop,this.defaultValue.loop)}}}class z extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"||ce.length===0?z.OFF:ce==="true"?z.ON:ce:ce?z.ON:z.OFF}}e.EditorFontLigatures=z;class N extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"?N.OFF:ce==="true"?N.TRANSLATE:ce:ce?N.TRANSLATE:N.OFF}compute(ce,ke,je){return ce.fontInfo.fontVariationSettings}}e.EditorFontVariations=N;class M extends E{constructor(){super(50)}compute(ce,ke,je){return ce.fontInfo}}class W extends d{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ce){const ke=o.float(ce,this.defaultValue);return ke===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(ke,6,100)}compute(ce,ke,je){return ce.fontInfo.fontSize}}class X extends I{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:X.MINIMUM_VALUE,maximum:X.MAXIMUM_VALUE,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:X.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ce){return ce==="normal"||ce==="bold"?ce:String(n.clampedInt(ce,e.EDITOR_FONT_DEFAULTS.fontWeight,X.MINIMUM_VALUE,X.MAXIMUM_VALUE))}}class te extends I{constructor(){const ce={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ke={type:"string",enum:["peek","gotoAndPeek","goto"],default:ce.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ce,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...ke},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...ke},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...ke},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...ke},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...ke},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ce.alternativeDefinitionCommand,enum:je,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ce.alternativeTypeDefinitionCommand,enum:je,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ce.alternativeDeclarationCommand,enum:je,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ce.alternativeImplementationCommand,enum:je,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ce.alternativeReferenceCommand,enum:je,description:b.localize(41,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const ke=ce;return{multiple:u(ke.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ke.multipleDefinitions??u(ke.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ke.multipleTypeDefinitions??u(ke.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ke.multipleDeclarations??u(ke.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ke.multipleImplementations??u(ke.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ke.multipleReferences??u(ke.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(ke.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(ke.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(ke.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(ke.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(ke.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class H extends I{constructor(){const ce={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ce,{"editor.hover.enabled":{type:"boolean",default:ce.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ce.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ce.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ce.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ce.above,description:b.localize(46,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const ke=ce;return{enabled:f(ke.enabled,this.defaultValue.enabled),delay:n.clampedInt(ke.delay,this.defaultValue.delay,0,1e4),sticky:f(ke.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(ke.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:f(ke.above,this.defaultValue.above)}}}var G;(function(ae){ae[ae.None=0]="None",ae[ae.Text=1]="Text",ae[ae.Blocks=2]="Blocks"})(G||(e.RenderMinimap=G={}));class Y extends E{constructor(){super(145)}compute(ce,ke,je){return Y.computeLayout(ke,{memory:ce.memory,outerWidth:ce.outerWidth,outerHeight:ce.outerHeight,isDominatedByLongLines:ce.isDominatedByLongLines,lineHeight:ce.fontInfo.lineHeight,viewLineCount:ce.viewLineCount,lineNumbersDigitCount:ce.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ce.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ce.fontInfo.maxDigitWidth,pixelRatio:ce.pixelRatio,glyphMarginDecorationLaneCount:ce.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ce){const ke=ce.height/ce.lineHeight,je=Math.floor(ce.paddingTop/ce.lineHeight);let Le=Math.floor(ce.paddingBottom/ce.lineHeight);ce.scrollBeyondLastLine&&(Le=Math.max(Le,ke-1));const ot=(je+ce.viewLineCount+Le)/(ce.pixelRatio*ce.height),lt=Math.floor(ce.viewLineCount/ot);return{typicalViewportLineCount:ke,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:Le,desiredRatio:ot,minimapLineCount:lt}}static _computeMinimapLayout(ce,ke){const je=ce.outerWidth,Le=ce.outerHeight,ot=ce.pixelRatio;if(!ce.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const lt=ke.stableMinimapLayoutInput,wt=lt&&ce.outerHeight===lt.outerHeight&&ce.lineHeight===lt.lineHeight&&ce.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&ce.pixelRatio===lt.pixelRatio&&ce.scrollBeyondLastLine===lt.scrollBeyondLastLine&&ce.paddingTop===lt.paddingTop&&ce.paddingBottom===lt.paddingBottom&&ce.minimap.enabled===lt.minimap.enabled&&ce.minimap.side===lt.minimap.side&&ce.minimap.size===lt.minimap.size&&ce.minimap.showSlider===lt.minimap.showSlider&&ce.minimap.renderCharacters===lt.minimap.renderCharacters&&ce.minimap.maxColumn===lt.minimap.maxColumn&&ce.minimap.scale===lt.minimap.scale&&ce.verticalScrollbarWidth===lt.verticalScrollbarWidth&&ce.isViewportWrapping===lt.isViewportWrapping,At=ce.lineHeight,Wt=ce.typicalHalfwidthCharacterWidth,ti=ce.scrollBeyondLastLine,Xt=ce.minimap.renderCharacters;let _t=ot>=2?Math.round(ce.minimap.scale*2):ce.minimap.scale;const Qt=ce.minimap.maxColumn,Yt=ce.minimap.size,et=ce.minimap.side,oi=ce.verticalScrollbarWidth,jt=ce.viewLineCount,ft=ce.remainingWidth,pt=ce.isViewportWrapping,Jt=Xt?2:3;let Gt=Math.floor(ot*Le);const Ft=Gt/ot;let gt=!1,Ut=!1,Zt=Jt*_t,$t=_t/ot,Je=1;if(Yt==="fill"||Yt==="fit"){const{typicalViewportLineCount:Ot,extraLinesBeforeFirstLine:ii,extraLinesBeyondLastLine:Vt,desiredRatio:ni,minimapLineCount:kt}=Y.computeContainedMinimapLineCount({viewLineCount:jt,scrollBeyondLastLine:ti,paddingTop:ce.paddingTop,paddingBottom:ce.paddingBottom,height:Le,lineHeight:At,pixelRatio:ot});if(jt/kt>1)gt=!0,Ut=!0,_t=1,Zt=1,$t=_t/ot;else{let Lt=!1,Pt=_t+1;if(Yt==="fit"){const mt=Math.ceil((ii+jt+Vt)*Zt);pt&&wt&&ft<=ke.stableFitRemainingWidth?(Lt=!0,Pt=ke.stableFitMaxMinimapScale):Lt=mt>Gt}if(Yt==="fill"||Lt){gt=!0;const mt=_t;Zt=Math.min(At*ot,Math.max(1,Math.floor(1/ni))),pt&&wt&&ft<=ke.stableFitRemainingWidth&&(Pt=ke.stableFitMaxMinimapScale),_t=Math.min(Pt,Math.max(1,Math.floor(Zt/Jt))),_t>mt&&(Je=Math.min(2,_t/mt)),$t=_t/ot/Je,Gt=Math.ceil(Math.max(Ot,ii+jt+Vt)*Zt),pt?(ke.stableMinimapLayoutInput=ce,ke.stableFitRemainingWidth=ft,ke.stableFitMaxMinimapScale=_t):(ke.stableMinimapLayoutInput=null,ke.stableFitRemainingWidth=0)}}}const li=Math.floor(Qt*$t),Kt=Math.min(li,Math.max(0,Math.floor((ft-oi-2)*$t/(Wt+$t)))+e.MINIMAP_GUTTER_WIDTH);let Ht=Math.floor(ot*Kt);const vt=Ht/ot;Ht=Math.floor(Ht*Je);const xt=Xt?1:2,Rt=et==="left"?0:je-Kt-oi;return{renderMinimap:xt,minimapLeft:Rt,minimapWidth:Kt,minimapHeightIsEditorHeight:gt,minimapIsSampling:Ut,minimapScale:_t,minimapLineHeight:Zt,minimapCanvasInnerWidth:Ht,minimapCanvasInnerHeight:Gt,minimapCanvasOuterWidth:vt,minimapCanvasOuterHeight:Ft}}static computeLayout(ce,ke){const je=ke.outerWidth|0,Le=ke.outerHeight|0,ot=ke.lineHeight|0,lt=ke.lineNumbersDigitCount|0,wt=ke.typicalHalfwidthCharacterWidth,At=ke.maxDigitWidth,Wt=ke.pixelRatio,ti=ke.viewLineCount,Xt=ce.get(137),_t=Xt==="inherit"?ce.get(136):Xt,Qt=_t==="inherit"?ce.get(132):_t,Yt=ce.get(135),et=ke.isDominatedByLongLines,oi=ce.get(57),jt=ce.get(68).renderType!==0,ft=ce.get(69),pt=ce.get(105),Jt=ce.get(84),Gt=ce.get(73),Ft=ce.get(103),gt=Ft.verticalScrollbarSize,Ut=Ft.verticalHasArrows,Zt=Ft.arrowSize,$t=Ft.horizontalScrollbarSize,Je=ce.get(43),li=ce.get(110)!=="never";let Kt=ce.get(66);Je&&li&&(Kt+=16);let Ht=0;if(jt){const ai=Math.max(lt,ft);Ht=Math.round(ai*At)}let vt=0;oi&&(vt=ot*ke.glyphMarginDecorationLaneCount);let xt=0,Rt=xt+vt,Ot=Rt+Ht,ii=Ot+Kt;const Vt=je-vt-Ht-Kt;let ni=!1,kt=!1,Nt=-1;_t==="inherit"&&et?(ni=!0,kt=!0):Qt==="on"||Qt==="bounded"?kt=!0:Qt==="wordWrapColumn"&&(Nt=Yt);const Lt=Y._computeMinimapLayout({outerWidth:je,outerHeight:Le,lineHeight:ot,typicalHalfwidthCharacterWidth:wt,pixelRatio:Wt,scrollBeyondLastLine:pt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:Gt,verticalScrollbarWidth:gt,viewLineCount:ti,remainingWidth:Vt,isViewportWrapping:kt},ke.memory||new T);Lt.renderMinimap!==0&&Lt.minimapLeft===0&&(xt+=Lt.minimapWidth,Rt+=Lt.minimapWidth,Ot+=Lt.minimapWidth,ii+=Lt.minimapWidth);const Pt=Vt-Lt.minimapWidth,mt=Math.max(1,Math.floor((Pt-gt-2)/wt)),Ct=Ut?Zt:0;return kt&&(Nt=Math.max(1,mt),Qt==="bounded"&&(Nt=Math.min(Nt,Yt))),{width:je,height:Le,glyphMarginLeft:xt,glyphMarginWidth:vt,glyphMarginDecorationLaneCount:ke.glyphMarginDecorationLaneCount,lineNumbersLeft:Rt,lineNumbersWidth:Ht,decorationsLeft:Ot,decorationsWidth:Kt,contentLeft:ii,contentWidth:Pt,minimap:Lt,viewportColumn:mt,isWordWrapMinified:ni,isViewportWrapping:kt,wrappingColumn:Nt,verticalScrollbarWidth:gt,horizontalScrollbarHeight:$t,overviewRuler:{top:Ct,width:gt,height:Le-2*Ct,right:0}}}}e.EditorLayoutInfoComputer=Y;class ne extends I{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ce){return u(ce,"simple",["simple","advanced"])}compute(ce,ke,je){return ke.get(2)===2?"advanced":je}}var pe;(function(ae){ae.Off="off",ae.OnCode="onCode",ae.On="on"})(pe||(e.ShowLightbulbIconMode=pe={}));class le extends I{constructor(){const ce={enabled:pe.On};super(65,"lightbulb",ce,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[pe.Off,pe.OnCode,pe.On],default:ce.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{enabled:u(ce.enabled,this.defaultValue.enabled,[pe.Off,pe.OnCode,pe.On])}}}class we extends I{constructor(){const ce={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ce,{"editor.stickyScroll.enabled":{type:"boolean",default:ce.enabled,description:b.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ce.maxLineCount,minimum:1,maximum:20,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ce.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ce.scrollWithEditor,description:b.localize(57,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const ke=ce;return{enabled:f(ke.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(ke.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:u(ke.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:f(ke.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class Z extends I{constructor(){const ce={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",ce,{"editor.inlayHints.enabled":{type:"string",default:ce.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,L.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,L.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ce.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ce.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ce.padding,description:b.localize(65,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const ke=ce;return typeof ke.enabled=="boolean"&&(ke.enabled=ke.enabled?"on":"off"),{enabled:u(ke.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(ke.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(ke.fontFamily,this.defaultValue.fontFamily),padding:f(ke.padding,this.defaultValue.padding)}}}class B extends I{constructor(){super(66,"lineDecorationsWidth",10)}validate(ce){return typeof ce=="string"&&/^\d+(\.\d+)?ch$/.test(ce)?-parseFloat(ce.substring(0,ce.length-2)):n.clampedInt(ce,this.defaultValue,0,1e3)}compute(ce,ke,je){return je<0?n.clampedInt(-je*ce.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class ee extends o{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ce=>o.clamp(ce,0,150),{markdownDescription:b.localize(66,null)})}compute(ce,ke,je){return ce.fontInfo.lineHeight}}class ve extends I{constructor(){const ce={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",ce,{"editor.minimap.enabled":{type:"boolean",default:ce.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ce.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:ce.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ce.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ce.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:ce.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ce.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ce.maxColumn,description:b.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ce.showRegionSectionHeaders,description:b.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ce.showMarkSectionHeaders,description:b.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ce.sectionHeaderFontSize,description:b.localize(80,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const ke=ce;return{enabled:f(ke.enabled,this.defaultValue.enabled),autohide:f(ke.autohide,this.defaultValue.autohide),size:u(ke.size,this.defaultValue.size,["proportional","fill","fit"]),side:u(ke.side,this.defaultValue.side,["right","left"]),showSlider:u(ke.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(ke.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(ke.scale,1,1,3),maxColumn:n.clampedInt(ke.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:f(ke.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:f(ke.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:o.clamp(ke.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Pe(ae){return ae==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class oe extends I{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(82,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const ke=ce;return{top:n.clampedInt(ke.top,0,0,1e3),bottom:n.clampedInt(ke.bottom,0,0,1e3)}}}class se extends I{constructor(){const ce={enabled:!0,cycle:!0};super(86,"parameterHints",ce,{"editor.parameterHints.enabled":{type:"boolean",default:ce.enabled,description:b.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:ce.cycle,description:b.localize(84,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const ke=ce;return{enabled:f(ke.enabled,this.defaultValue.enabled),cycle:f(ke.cycle,this.defaultValue.cycle)}}}class re extends E{constructor(){super(143)}compute(ce,ke,je){return ce.pixelRatio}}class j extends I{constructor(){const ce={other:"on",comments:"off",strings:"off"},ke=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(85,null),b.localize(86,null),b.localize(87,null)]}];super(89,"quickSuggestions",ce,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ke,default:ce.strings,description:b.localize(88,null)},comments:{anyOf:ke,default:ce.comments,description:b.localize(89,null)},other:{anyOf:ke,default:ce.other,description:b.localize(90,null)}},default:ce,markdownDescription:b.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ce}validate(ce){if(typeof ce=="boolean"){const Wt=ce?"on":"off";return{comments:Wt,strings:Wt,other:Wt}}if(!ce||typeof ce!="object")return this.defaultValue;const{other:ke,comments:je,strings:Le}=ce,ot=["on","inline","off"];let lt,wt,At;return typeof ke=="boolean"?lt=ke?"on":"off":lt=u(ke,this.defaultValue.other,ot),typeof je=="boolean"?wt=je?"on":"off":wt=u(je,this.defaultValue.comments,ot),typeof Le=="boolean"?At=Le?"on":"off":At=u(Le,this.defaultValue.strings,ot),{other:lt,comments:wt,strings:At}}}var ie;(function(ae){ae[ae.Off=0]="Off",ae[ae.On=1]="On",ae[ae.Relative=2]="Relative",ae[ae.Interval=3]="Interval",ae[ae.Custom=4]="Custom"})(ie||(e.RenderLineNumbersType=ie={}));class me extends I{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(92,null),b.localize(93,null),b.localize(94,null),b.localize(95,null)],default:"on",description:b.localize(96,null)})}validate(ce){let ke=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof ce<"u"&&(typeof ce=="function"?(ke=4,je=ce):ce==="interval"?ke=3:ce==="relative"?ke=2:ce==="on"?ke=1:ke=0),{renderType:ke,renderFn:je}}}function be(ae){const ce=ae.get(98);return ce==="editable"?ae.get(91):ce!=="on"}class Ae extends I{constructor(){const ce=[],ke={type:"number",description:b.localize(97,null)};super(102,"rulers",ce,{type:"array",items:{anyOf:[ke,{type:["object"],properties:{column:ke,color:{type:"string",description:b.localize(98,null),format:"color-hex"}}}]},default:ce,description:b.localize(99,null)})}validate(ce){if(Array.isArray(ce)){const ke=[];for(const je of ce)if(typeof je=="number")ke.push({column:n.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const Le=je;ke.push({column:n.clampedInt(Le.column,0,0,1e4),color:Le.color})}return ke.sort((je,Le)=>je.column-Le.column),ke}return this.defaultValue}}class fe extends I{constructor(){super(92,"readOnlyMessage",void 0)}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:ce}}function De(ae,ce){if(typeof ae!="string")return ce;switch(ae){case"hidden":return 2;case"visible":return 3;default:return 1}}class Te extends I{constructor(){const ce={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ce,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(100,null),b.localize(101,null),b.localize(102,null)],default:"auto",description:b.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(104,null),b.localize(105,null),b.localize(106,null)],default:"auto",description:b.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ce.verticalScrollbarSize,description:b.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ce.horizontalScrollbarSize,description:b.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ce.scrollByPage,description:b.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ce.ignoreHorizontalScrollbarInContentHeight,description:b.localize(111,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const ke=ce,je=n.clampedInt(ke.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=n.clampedInt(ke.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(ke.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:De(ke.vertical,this.defaultValue.vertical),horizontal:De(ke.horizontal,this.defaultValue.horizontal),useShadows:f(ke.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(ke.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(ke.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(ke.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(ke.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:n.clampedInt(ke.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:n.clampedInt(ke.verticalSliderSize,Le,0,1e3),scrollByPage:f(ke.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:f(ke.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends I{constructor(){const ce={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ce,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.nonBasicASCII,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ce.invisibleCharacters,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ce.ambiguousCharacters,description:b.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeComments,description:b.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeStrings,description:b.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ce.allowedCharacters,description:b.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ce.allowedLocales,description:b.localize(118,null)}})}applyUpdate(ce,ke){let je=!1;ke.allowedCharacters&&ce&&(O.equals(ce.allowedCharacters,ke.allowedCharacters)||(ce={...ce,allowedCharacters:ke.allowedCharacters},je=!0)),ke.allowedLocales&&ce&&(O.equals(ce.allowedLocales,ke.allowedLocales)||(ce={...ce,allowedLocales:ke.allowedLocales},je=!0));const Le=super.applyUpdate(ce,ke);return je?new p(Le.newValue,!0):Le}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const ke=ce;return{nonBasicASCII:de(ke.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:f(ke.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:f(ke.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:de(ke.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:de(ke.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(ce.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(ce.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(ce,ke){if(typeof ce!="object"||!ce)return ke;const je={};for(const[Le,ot]of Object.entries(ce))ot===!0&&(je[Le]=!0);return je}}class U extends I{constructor(){const ce={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",ce,{"editor.inlineSuggest.enabled":{type:"boolean",default:ce.enabled,description:b.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(120,null),b.localize(121,null),b.localize(122,null)],description:b.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ce.suppressSuggestions,description:b.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ce.fontFamily,description:b.localize(125,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const ke=ce;return{enabled:f(ke.enabled,this.defaultValue.enabled),mode:u(ke.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:u(ke.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:f(ke.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:f(ke.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(ke.fontFamily,this.defaultValue.fontFamily)}}}class $ extends I{constructor(){const ce={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",ce,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ce.enabled,description:b.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(127,null),b.localize(128,null),b.localize(129,null)],description:b.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ce.fontFamily,description:b.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:ce.backgroundColoring,description:b.localize(132,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const ke=ce;return{enabled:f(ke.enabled,this.defaultValue.enabled),showToolbar:u(ke.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(ke.fontFamily,this.defaultValue.fontFamily),keepOnBlur:f(ke.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:f(ke.backgroundColoring,this.defaultValue.backgroundColoring)}}}class K extends I{constructor(){const ce={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ce,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ce.independentColorPoolPerBracketType,description:b.localize(134,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const ke=ce;return{enabled:f(ke.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:f(ke.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Q extends I{constructor(){const ce={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ce,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(135,null),b.localize(136,null),b.localize(137,null)],default:ce.bracketPairs,description:b.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(139,null),b.localize(140,null),b.localize(141,null)],default:ce.bracketPairsHorizontal,description:b.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ce.highlightActiveBracketPair,description:b.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:ce.indentation,description:b.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(145,null),b.localize(146,null),b.localize(147,null)],default:ce.highlightActiveIndentation,description:b.localize(148,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const ke=ce;return{bracketPairs:de(ke.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:de(ke.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:f(ke.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:f(ke.indentation,this.defaultValue.indentation),highlightActiveIndentation:de(ke.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function de(ae,ce,ke){const je=ke.indexOf(ae);return je===-1?ce:ke[je]}class Ee extends I{constructor(){const ce={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ce,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(149,null),b.localize(150,null)],default:ce.insertMode,description:b.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ce.filterGraceful,description:b.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:ce.localityBonus,description:b.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ce.shareSuggestSelections,markdownDescription:b.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(155,null),b.localize(156,null),b.localize(157,null),b.localize(158,null)],default:ce.selectionMode,markdownDescription:b.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ce.snippetsPreventQuickSuggestions,description:b.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:ce.showIcons,description:b.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ce.showStatusBar,description:b.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:ce.preview,description:b.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ce.showInlineDetails,description:b.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(196,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const ke=ce;return{insertMode:u(ke.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(ke.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(ke.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(ke.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(ke.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:u(ke.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:f(ke.showIcons,this.defaultValue.showIcons),showStatusBar:f(ke.showStatusBar,this.defaultValue.showStatusBar),preview:f(ke.preview,this.defaultValue.preview),previewMode:u(ke.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:f(ke.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(ke.showMethods,this.defaultValue.showMethods),showFunctions:f(ke.showFunctions,this.defaultValue.showFunctions),showConstructors:f(ke.showConstructors,this.defaultValue.showConstructors),showDeprecated:f(ke.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:f(ke.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:f(ke.showFields,this.defaultValue.showFields),showVariables:f(ke.showVariables,this.defaultValue.showVariables),showClasses:f(ke.showClasses,this.defaultValue.showClasses),showStructs:f(ke.showStructs,this.defaultValue.showStructs),showInterfaces:f(ke.showInterfaces,this.defaultValue.showInterfaces),showModules:f(ke.showModules,this.defaultValue.showModules),showProperties:f(ke.showProperties,this.defaultValue.showProperties),showEvents:f(ke.showEvents,this.defaultValue.showEvents),showOperators:f(ke.showOperators,this.defaultValue.showOperators),showUnits:f(ke.showUnits,this.defaultValue.showUnits),showValues:f(ke.showValues,this.defaultValue.showValues),showConstants:f(ke.showConstants,this.defaultValue.showConstants),showEnums:f(ke.showEnums,this.defaultValue.showEnums),showEnumMembers:f(ke.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(ke.showKeywords,this.defaultValue.showKeywords),showWords:f(ke.showWords,this.defaultValue.showWords),showColors:f(ke.showColors,this.defaultValue.showColors),showFiles:f(ke.showFiles,this.defaultValue.showFiles),showReferences:f(ke.showReferences,this.defaultValue.showReferences),showFolders:f(ke.showFolders,this.defaultValue.showFolders),showTypeParameters:f(ke.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(ke.showSnippets,this.defaultValue.showSnippets),showUsers:f(ke.showUsers,this.defaultValue.showUsers),showIssues:f(ke.showIssues,this.defaultValue.showIssues)}}}class Fe extends I{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(198,null),default:!0,type:"boolean"}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(ce.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:f(ce.selectSubwords,this.defaultValue.selectSubwords)}}}class He extends I{constructor(){const ce=[];super(130,"wordSegmenterLocales",ce,{anyOf:[{description:b.localize(199,null),type:"string"},{description:b.localize(200,null),type:"array",items:{type:"string"}}]})}validate(ce){if(typeof ce=="string"&&(ce=[ce]),Array.isArray(ce)){const ke=[];for(const je of ce)if(typeof je=="string")try{Intl.Segmenter.supportedLocalesOf(je).length>0&&ke.push(je)}catch{}return ke}return this.defaultValue}}var Ke;(function(ae){ae[ae.None=0]="None",ae[ae.Same=1]="Same",ae[ae.Indent=2]="Indent",ae[ae.DeepIndent=3]="DeepIndent"})(Ke||(e.WrappingIndent=Ke={}));class rt extends I{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(201,null),b.localize(202,null),b.localize(203,null),b.localize(204,null)],description:b.localize(205,null),default:"same"}})}validate(ce){switch(ce){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ce,ke,je){return ke.get(2)===2?0:je}}class tt extends E{constructor(){super(146)}compute(ce,ke,je){const Le=ke.get(145);return{isDominatedByLongLines:ce.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}class it extends I{constructor(){const ce={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ce,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(208,null),b.localize(209,null)],default:"afterDrop"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const ke=ce;return{enabled:f(ke.enabled,this.defaultValue.enabled),showDropSelector:u(ke.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends I{constructor(){const ce={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ce,{"editor.pasteAs.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(212,null),b.localize(213,null)],default:"afterPaste"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const ke=ce;return{enabled:f(ke.enabled,this.defaultValue.enabled),showPasteSelector:u(ke.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ie="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?Be:L.isLinux?qe:Ie,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Oe(ae){return e.editorOptionsRegistry[ae.id]=ae,ae}var Qe;(function(ae){ae[ae.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ae[ae.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ae[ae.accessibilitySupport=2]="accessibilitySupport",ae[ae.accessibilityPageSize=3]="accessibilityPageSize",ae[ae.ariaLabel=4]="ariaLabel",ae[ae.ariaRequired=5]="ariaRequired",ae[ae.autoClosingBrackets=6]="autoClosingBrackets",ae[ae.autoClosingComments=7]="autoClosingComments",ae[ae.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ae[ae.autoClosingDelete=9]="autoClosingDelete",ae[ae.autoClosingOvertype=10]="autoClosingOvertype",ae[ae.autoClosingQuotes=11]="autoClosingQuotes",ae[ae.autoIndent=12]="autoIndent",ae[ae.automaticLayout=13]="automaticLayout",ae[ae.autoSurround=14]="autoSurround",ae[ae.bracketPairColorization=15]="bracketPairColorization",ae[ae.guides=16]="guides",ae[ae.codeLens=17]="codeLens",ae[ae.codeLensFontFamily=18]="codeLensFontFamily",ae[ae.codeLensFontSize=19]="codeLensFontSize",ae[ae.colorDecorators=20]="colorDecorators",ae[ae.colorDecoratorsLimit=21]="colorDecoratorsLimit",ae[ae.columnSelection=22]="columnSelection",ae[ae.comments=23]="comments",ae[ae.contextmenu=24]="contextmenu",ae[ae.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ae[ae.cursorBlinking=26]="cursorBlinking",ae[ae.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ae[ae.cursorStyle=28]="cursorStyle",ae[ae.cursorSurroundingLines=29]="cursorSurroundingLines",ae[ae.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ae[ae.cursorWidth=31]="cursorWidth",ae[ae.disableLayerHinting=32]="disableLayerHinting",ae[ae.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ae[ae.domReadOnly=34]="domReadOnly",ae[ae.dragAndDrop=35]="dragAndDrop",ae[ae.dropIntoEditor=36]="dropIntoEditor",ae[ae.emptySelectionClipboard=37]="emptySelectionClipboard",ae[ae.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ae[ae.extraEditorClassName=39]="extraEditorClassName",ae[ae.fastScrollSensitivity=40]="fastScrollSensitivity",ae[ae.find=41]="find",ae[ae.fixedOverflowWidgets=42]="fixedOverflowWidgets",ae[ae.folding=43]="folding",ae[ae.foldingStrategy=44]="foldingStrategy",ae[ae.foldingHighlight=45]="foldingHighlight",ae[ae.foldingImportsByDefault=46]="foldingImportsByDefault",ae[ae.foldingMaximumRegions=47]="foldingMaximumRegions",ae[ae.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ae[ae.fontFamily=49]="fontFamily",ae[ae.fontInfo=50]="fontInfo",ae[ae.fontLigatures=51]="fontLigatures",ae[ae.fontSize=52]="fontSize",ae[ae.fontWeight=53]="fontWeight",ae[ae.fontVariations=54]="fontVariations",ae[ae.formatOnPaste=55]="formatOnPaste",ae[ae.formatOnType=56]="formatOnType",ae[ae.glyphMargin=57]="glyphMargin",ae[ae.gotoLocation=58]="gotoLocation",ae[ae.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ae[ae.hover=60]="hover",ae[ae.inDiffEditor=61]="inDiffEditor",ae[ae.inlineSuggest=62]="inlineSuggest",ae[ae.inlineEdit=63]="inlineEdit",ae[ae.letterSpacing=64]="letterSpacing",ae[ae.lightbulb=65]="lightbulb",ae[ae.lineDecorationsWidth=66]="lineDecorationsWidth",ae[ae.lineHeight=67]="lineHeight",ae[ae.lineNumbers=68]="lineNumbers",ae[ae.lineNumbersMinChars=69]="lineNumbersMinChars",ae[ae.linkedEditing=70]="linkedEditing",ae[ae.links=71]="links",ae[ae.matchBrackets=72]="matchBrackets",ae[ae.minimap=73]="minimap",ae[ae.mouseStyle=74]="mouseStyle",ae[ae.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ae[ae.mouseWheelZoom=76]="mouseWheelZoom",ae[ae.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ae[ae.multiCursorModifier=78]="multiCursorModifier",ae[ae.multiCursorPaste=79]="multiCursorPaste",ae[ae.multiCursorLimit=80]="multiCursorLimit",ae[ae.occurrencesHighlight=81]="occurrencesHighlight",ae[ae.overviewRulerBorder=82]="overviewRulerBorder",ae[ae.overviewRulerLanes=83]="overviewRulerLanes",ae[ae.padding=84]="padding",ae[ae.pasteAs=85]="pasteAs",ae[ae.parameterHints=86]="parameterHints",ae[ae.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ae[ae.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ae[ae.quickSuggestions=89]="quickSuggestions",ae[ae.quickSuggestionsDelay=90]="quickSuggestionsDelay",ae[ae.readOnly=91]="readOnly",ae[ae.readOnlyMessage=92]="readOnlyMessage",ae[ae.renameOnType=93]="renameOnType",ae[ae.renderControlCharacters=94]="renderControlCharacters",ae[ae.renderFinalNewline=95]="renderFinalNewline",ae[ae.renderLineHighlight=96]="renderLineHighlight",ae[ae.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ae[ae.renderValidationDecorations=98]="renderValidationDecorations",ae[ae.renderWhitespace=99]="renderWhitespace",ae[ae.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ae[ae.roundedSelection=101]="roundedSelection",ae[ae.rulers=102]="rulers",ae[ae.scrollbar=103]="scrollbar",ae[ae.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ae[ae.scrollBeyondLastLine=105]="scrollBeyondLastLine",ae[ae.scrollPredominantAxis=106]="scrollPredominantAxis",ae[ae.selectionClipboard=107]="selectionClipboard",ae[ae.selectionHighlight=108]="selectionHighlight",ae[ae.selectOnLineNumbers=109]="selectOnLineNumbers",ae[ae.showFoldingControls=110]="showFoldingControls",ae[ae.showUnused=111]="showUnused",ae[ae.snippetSuggestions=112]="snippetSuggestions",ae[ae.smartSelect=113]="smartSelect",ae[ae.smoothScrolling=114]="smoothScrolling",ae[ae.stickyScroll=115]="stickyScroll",ae[ae.stickyTabStops=116]="stickyTabStops",ae[ae.stopRenderingLineAfter=117]="stopRenderingLineAfter",ae[ae.suggest=118]="suggest",ae[ae.suggestFontSize=119]="suggestFontSize",ae[ae.suggestLineHeight=120]="suggestLineHeight",ae[ae.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ae[ae.suggestSelection=122]="suggestSelection",ae[ae.tabCompletion=123]="tabCompletion",ae[ae.tabIndex=124]="tabIndex",ae[ae.unicodeHighlighting=125]="unicodeHighlighting",ae[ae.unusualLineTerminators=126]="unusualLineTerminators",ae[ae.useShadowDOM=127]="useShadowDOM",ae[ae.useTabStops=128]="useTabStops",ae[ae.wordBreak=129]="wordBreak",ae[ae.wordSegmenterLocales=130]="wordSegmenterLocales",ae[ae.wordSeparators=131]="wordSeparators",ae[ae.wordWrap=132]="wordWrap",ae[ae.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",ae[ae.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",ae[ae.wordWrapColumn=135]="wordWrapColumn",ae[ae.wordWrapOverride1=136]="wordWrapOverride1",ae[ae.wordWrapOverride2=137]="wordWrapOverride2",ae[ae.wrappingIndent=138]="wrappingIndent",ae[ae.wrappingStrategy=139]="wrappingStrategy",ae[ae.showDeprecated=140]="showDeprecated",ae[ae.inlayHints=141]="inlayHints",ae[ae.editorClassName=142]="editorClassName",ae[ae.pixelRatio=143]="pixelRatio",ae[ae.tabFocusMode=144]="tabFocusMode",ae[ae.layoutInfo=145]="layoutInfo",ae[ae.wrappingInfo=146]="wrappingInfo",ae[ae.defaultColorDecorators=147]="defaultColorDecorators",ae[ae.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",ae[ae.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Qe||(e.EditorOption=Qe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Oe(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(214,null)})),acceptSuggestionOnEnter:Oe(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(215,null),""],markdownDescription:b.localize(216,null)})),accessibilitySupport:Oe(new w),accessibilityPageSize:Oe(new n(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(217,null),tags:["accessibility"]})),ariaLabel:Oe(new t(4,"ariaLabel",b.localize(218,null))),ariaRequired:Oe(new a(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Oe(new a(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Oe(new r(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(220,null),b.localize(221,null),""],description:b.localize(222,null)})),autoClosingComments:Oe(new r(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(223,null),b.localize(224,null),""],description:b.localize(225,null)})),autoClosingDelete:Oe(new r(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(226,null),""],description:b.localize(227,null)})),autoClosingOvertype:Oe(new r(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(228,null),""],description:b.localize(229,null)})),autoClosingQuotes:Oe(new r(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(230,null),b.localize(231,null),""],description:b.localize(232,null)})),autoIndent:Oe(new c(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],s,{enumDescriptions:[b.localize(233,null),b.localize(234,null),b.localize(235,null),b.localize(236,null),b.localize(237,null)],description:b.localize(238,null)})),automaticLayout:Oe(new a(13,"automaticLayout",!1)),autoSurround:Oe(new r(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(239,null),b.localize(240,null),b.localize(241,null),""],description:b.localize(242,null)})),bracketPairColorization:Oe(new K),bracketPairGuides:Oe(new Q),stickyTabStops:Oe(new a(116,"stickyTabStops",!1,{description:b.localize(243,null)})),codeLens:Oe(new a(17,"codeLens",!0,{description:b.localize(244,null)})),codeLensFontFamily:Oe(new t(18,"codeLensFontFamily","",{description:b.localize(245,null)})),codeLensFontSize:Oe(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(246,null)})),colorDecorators:Oe(new a(20,"colorDecorators",!0,{description:b.localize(247,null)})),colorDecoratorActivatedOn:Oe(new r(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(248,null),b.localize(249,null),b.localize(250,null)],description:b.localize(251,null)})),colorDecoratorsLimit:Oe(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(252,null)})),columnSelection:Oe(new a(22,"columnSelection",!1,{description:b.localize(253,null)})),comments:Oe(new g),contextmenu:Oe(new a(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Oe(new a(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(254,null)})),cursorBlinking:Oe(new c(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:b.localize(255,null)})),cursorSmoothCaretAnimation:Oe(new r(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(256,null),b.localize(257,null),b.localize(258,null)],description:b.localize(259,null)})),cursorStyle:Oe(new c(28,"cursorStyle",_.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:b.localize(260,null)})),cursorSurroundingLines:Oe(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(261,null)})),cursorSurroundingLinesStyle:Oe(new r(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(262,null),b.localize(263,null)],markdownDescription:b.localize(264,null)})),cursorWidth:Oe(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(265,null)})),disableLayerHinting:Oe(new a(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Oe(new a(33,"disableMonospaceOptimizations",!1)),domReadOnly:Oe(new a(34,"domReadOnly",!1)),dragAndDrop:Oe(new a(35,"dragAndDrop",!0,{description:b.localize(266,null)})),emptySelectionClipboard:Oe(new F),dropIntoEditor:Oe(new it),stickyScroll:Oe(new we),experimentalWhitespaceRendering:Oe(new r(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(267,null),b.localize(268,null),b.localize(269,null)],description:b.localize(270,null)})),extraEditorClassName:Oe(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Oe(new o(40,"fastScrollSensitivity",5,ae=>ae<=0?5:ae,{markdownDescription:b.localize(271,null)})),find:Oe(new x),fixedOverflowWidgets:Oe(new a(42,"fixedOverflowWidgets",!1)),folding:Oe(new a(43,"folding",!0,{description:b.localize(272,null)})),foldingStrategy:Oe(new r(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(273,null),b.localize(274,null)],description:b.localize(275,null)})),foldingHighlight:Oe(new a(45,"foldingHighlight",!0,{description:b.localize(276,null)})),foldingImportsByDefault:Oe(new a(46,"foldingImportsByDefault",!1,{description:b.localize(277,null)})),foldingMaximumRegions:Oe(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(278,null)})),unfoldOnClickAfterEndOfLine:Oe(new a(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(279,null)})),fontFamily:Oe(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(280,null)})),fontInfo:Oe(new M),fontLigatures2:Oe(new z),fontSize:Oe(new W),fontWeight:Oe(new X),fontVariations:Oe(new N),formatOnPaste:Oe(new a(55,"formatOnPaste",!1,{description:b.localize(281,null)})),formatOnType:Oe(new a(56,"formatOnType",!1,{description:b.localize(282,null)})),glyphMargin:Oe(new a(57,"glyphMargin",!0,{description:b.localize(283,null)})),gotoLocation:Oe(new te),hideCursorInOverviewRuler:Oe(new a(59,"hideCursorInOverviewRuler",!1,{description:b.localize(284,null)})),hover:Oe(new H),inDiffEditor:Oe(new a(61,"inDiffEditor",!1)),letterSpacing:Oe(new o(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ae=>o.clamp(ae,-5,20),{description:b.localize(285,null)})),lightbulb:Oe(new le),lineDecorationsWidth:Oe(new B),lineHeight:Oe(new ee),lineNumbers:Oe(new me),lineNumbersMinChars:Oe(new n(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Oe(new a(70,"linkedEditing",!1,{description:b.localize(286,null)})),links:Oe(new a(71,"links",!0,{description:b.localize(287,null)})),matchBrackets:Oe(new r(72,"matchBrackets","always",["always","near","never"],{description:b.localize(288,null)})),minimap:Oe(new ve),mouseStyle:Oe(new r(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Oe(new o(75,"mouseWheelScrollSensitivity",1,ae=>ae===0?1:ae,{markdownDescription:b.localize(289,null)})),mouseWheelZoom:Oe(new a(76,"mouseWheelZoom",!1,{markdownDescription:L.isMacintosh?b.localize(290,null):b.localize(291,null)})),multiCursorMergeOverlapping:Oe(new a(77,"multiCursorMergeOverlapping",!0,{description:b.localize(292,null)})),multiCursorModifier:Oe(new c(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Pe,{markdownEnumDescriptions:[b.localize(293,null),b.localize(294,null)],markdownDescription:b.localize(295,null)})),multiCursorPaste:Oe(new r(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(296,null),b.localize(297,null)],markdownDescription:b.localize(298,null)})),multiCursorLimit:Oe(new n(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(299,null)})),occurrencesHighlight:Oe(new r(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(300,null),b.localize(301,null),b.localize(302,null)],markdownDescription:b.localize(303,null)})),overviewRulerBorder:Oe(new a(82,"overviewRulerBorder",!0,{description:b.localize(304,null)})),overviewRulerLanes:Oe(new n(83,"overviewRulerLanes",3,0,3)),padding:Oe(new oe),pasteAs:Oe(new st),parameterHints:Oe(new se),peekWidgetDefaultFocus:Oe(new r(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(305,null),b.localize(306,null)],description:b.localize(307,null)})),definitionLinkOpensInPeek:Oe(new a(88,"definitionLinkOpensInPeek",!1,{description:b.localize(308,null)})),quickSuggestions:Oe(new j),quickSuggestionsDelay:Oe(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(309,null)})),readOnly:Oe(new a(91,"readOnly",!1)),readOnlyMessage:Oe(new fe),renameOnType:Oe(new a(93,"renameOnType",!1,{description:b.localize(310,null),markdownDeprecationMessage:b.localize(311,null)})),renderControlCharacters:Oe(new a(94,"renderControlCharacters",!0,{description:b.localize(312,null),restricted:!0})),renderFinalNewline:Oe(new r(95,"renderFinalNewline",L.isLinux?"dimmed":"on",["off","on","dimmed"],{description:b.localize(313,null)})),renderLineHighlight:Oe(new r(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(314,null)],description:b.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Oe(new a(97,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(316,null)})),renderValidationDecorations:Oe(new r(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Oe(new r(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(317,null),b.localize(318,null),b.localize(319,null),""],description:b.localize(320,null)})),revealHorizontalRightPadding:Oe(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Oe(new a(101,"roundedSelection",!0,{description:b.localize(321,null)})),rulers:Oe(new Ae),scrollbar:Oe(new Te),scrollBeyondLastColumn:Oe(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(322,null)})),scrollBeyondLastLine:Oe(new a(105,"scrollBeyondLastLine",!0,{description:b.localize(323,null)})),scrollPredominantAxis:Oe(new a(106,"scrollPredominantAxis",!0,{description:b.localize(324,null)})),selectionClipboard:Oe(new a(107,"selectionClipboard",!0,{description:b.localize(325,null),included:L.isLinux})),selectionHighlight:Oe(new a(108,"selectionHighlight",!0,{description:b.localize(326,null)})),selectOnLineNumbers:Oe(new a(109,"selectOnLineNumbers",!0)),showFoldingControls:Oe(new r(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(327,null),b.localize(328,null),b.localize(329,null)],description:b.localize(330,null)})),showUnused:Oe(new a(111,"showUnused",!0,{description:b.localize(331,null)})),showDeprecated:Oe(new a(140,"showDeprecated",!0,{description:b.localize(332,null)})),inlayHints:Oe(new Z),snippetSuggestions:Oe(new r(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(333,null),b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),smartSelect:Oe(new Fe),smoothScrolling:Oe(new a(114,"smoothScrolling",!1,{description:b.localize(338,null)})),stopRenderingLineAfter:Oe(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Oe(new Ee),inlineSuggest:Oe(new U),inlineEdit:Oe(new $),inlineCompletionsAccessibilityVerbose:Oe(new a(149,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(339,null)})),suggestFontSize:Oe(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Oe(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Oe(new a(121,"suggestOnTriggerCharacters",!0,{description:b.localize(342,null)})),suggestSelection:Oe(new r(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null),b.localize(345,null)],description:b.localize(346,null)})),tabCompletion:Oe(new r(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null)],description:b.localize(350,null)})),tabIndex:Oe(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Oe(new ze),unusualLineTerminators:Oe(new r(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(351,null),b.localize(352,null),b.localize(353,null)],description:b.localize(354,null)})),useShadowDOM:Oe(new a(127,"useShadowDOM",!0)),useTabStops:Oe(new a(128,"useTabStops",!0,{description:b.localize(355,null)})),wordBreak:Oe(new r(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(356,null),b.localize(357,null)],description:b.localize(358,null)})),wordSegmenterLocales:Oe(new He),wordSeparators:Oe(new t(131,"wordSeparators",R.USUAL_WORD_SEPARATORS,{description:b.localize(359,null)})),wordWrap:Oe(new r(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(360,null),b.localize(361,null),b.localize(362,null),b.localize(363,null)],description:b.localize(364,null)})),wordWrapBreakAfterCharacters:Oe(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Oe(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Oe(new n(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(365,null)})),wordWrapOverride1:Oe(new r(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Oe(new r(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Oe(new k),defaultColorDecorators:Oe(new a(147,"defaultColorDecorators",!1,{markdownDescription:b.localize(366,null)})),pixelRatio:Oe(new re),tabFocusMode:Oe(new a(144,"tabFocusMode",!1,{markdownDescription:b.localize(367,null)})),layoutInfo:Oe(new Y),wrappingInfo:Oe(new tt),wrappingIndent:Oe(new rt),wrappingStrategy:Oe(new ne)}}),define(_e[207],Ce([9,10]),function(ue,e){return ue.create("vs/editor/common/languages",e)}),define(_e[84],Ce([1,0,79,2,180,29,190,207]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.FoldingRangeKind=e.TextEdit=e.SymbolKinds=e.SymbolTag=e.symbolKindNames=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0,e.isLocationLink=r,e.getAriaLabelForSymbol=s;class m{constructor(G,Y,ne){this.offset=G,this.type=Y,this.language=ne,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=m;class y{constructor(G,Y){this.tokens=G,this.endState=Y,this._tokenizationResultBrand=void 0}}e.TokenizationResult=y;class T{constructor(G,Y){this.tokens=G,this.endState=Y,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=T;var I;(function(H){H[H.Increase=0]="Increase",H[H.Decrease=1]="Decrease"})(I||(e.HoverVerbosityAction=I={}));var p;(function(H){H[H.Method=0]="Method",H[H.Function=1]="Function",H[H.Constructor=2]="Constructor",H[H.Field=3]="Field",H[H.Variable=4]="Variable",H[H.Class=5]="Class",H[H.Struct=6]="Struct",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Event=10]="Event",H[H.Operator=11]="Operator",H[H.Unit=12]="Unit",H[H.Value=13]="Value",H[H.Constant=14]="Constant",H[H.Enum=15]="Enum",H[H.EnumMember=16]="EnumMember",H[H.Keyword=17]="Keyword",H[H.Text=18]="Text",H[H.Color=19]="Color",H[H.File=20]="File",H[H.Reference=21]="Reference",H[H.Customcolor=22]="Customcolor",H[H.Folder=23]="Folder",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue",H[H.Snippet=27]="Snippet"})(p||(e.CompletionItemKind=p={}));var S;(function(H){const G=new Map;G.set(0,h.Codicon.symbolMethod),G.set(1,h.Codicon.symbolFunction),G.set(2,h.Codicon.symbolConstructor),G.set(3,h.Codicon.symbolField),G.set(4,h.Codicon.symbolVariable),G.set(5,h.Codicon.symbolClass),G.set(6,h.Codicon.symbolStruct),G.set(7,h.Codicon.symbolInterface),G.set(8,h.Codicon.symbolModule),G.set(9,h.Codicon.symbolProperty),G.set(10,h.Codicon.symbolEvent),G.set(11,h.Codicon.symbolOperator),G.set(12,h.Codicon.symbolUnit),G.set(13,h.Codicon.symbolValue),G.set(15,h.Codicon.symbolEnum),G.set(14,h.Codicon.symbolConstant),G.set(15,h.Codicon.symbolEnum),G.set(16,h.Codicon.symbolEnumMember),G.set(17,h.Codicon.symbolKeyword),G.set(27,h.Codicon.symbolSnippet),G.set(18,h.Codicon.symbolText),G.set(19,h.Codicon.symbolColor),G.set(20,h.Codicon.symbolFile),G.set(21,h.Codicon.symbolReference),G.set(22,h.Codicon.symbolCustomColor),G.set(23,h.Codicon.symbolFolder),G.set(24,h.Codicon.symbolTypeParameter),G.set(25,h.Codicon.account),G.set(26,h.Codicon.issues);function Y(le){let we=G.get(le);return we||(console.info("No codicon found for CompletionItemKind "+le),we=h.Codicon.symbolProperty),we}H.toIcon=Y;const ne=new Map;ne.set("method",0),ne.set("function",1),ne.set("constructor",2),ne.set("field",3),ne.set("variable",4),ne.set("class",5),ne.set("struct",6),ne.set("interface",7),ne.set("module",8),ne.set("property",9),ne.set("event",10),ne.set("operator",11),ne.set("unit",12),ne.set("value",13),ne.set("constant",14),ne.set("enum",15),ne.set("enum-member",16),ne.set("enumMember",16),ne.set("keyword",17),ne.set("snippet",27),ne.set("text",18),ne.set("color",19),ne.set("file",20),ne.set("reference",21),ne.set("customcolor",22),ne.set("folder",23),ne.set("type-parameter",24),ne.set("typeParameter",24),ne.set("account",25),ne.set("issue",26);function pe(le,we){let Z=ne.get(le);return typeof Z>"u"&&!we&&(Z=9),Z}H.fromString=pe})(S||(e.CompletionItemKinds=S={}));var E;(function(H){H[H.Deprecated=1]="Deprecated"})(E||(e.CompletionItemTag=E={}));var d;(function(H){H[H.None=0]="None",H[H.KeepWhitespace=1]="KeepWhitespace",H[H.InsertAsSnippet=4]="InsertAsSnippet"})(d||(e.CompletionItemInsertTextRule=d={}));var f;(function(H){H[H.Word=0]="Word",H[H.Line=1]="Line",H[H.Suggest=2]="Suggest"})(f||(e.PartialAcceptTriggerKind=f={}));var a;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(a||(e.CompletionTriggerKind=a={}));var i;(function(H){H[H.Automatic=0]="Automatic",H[H.Explicit=1]="Explicit"})(i||(e.InlineCompletionTriggerKind=i={}));class n{constructor(G,Y,ne,pe){this.range=G,this.text=Y,this.completionKind=ne,this.isSnippetText=pe}equals(G){return A.Range.lift(this.range).equalsRange(G.range)&&this.text===G.text&&this.completionKind===G.completionKind&&this.isSnippetText===G.isSnippetText}}e.SelectedSuggestionInfo=n;var l;(function(H){H[H.Invoke=1]="Invoke",H[H.Auto=2]="Auto"})(l||(e.CodeActionTriggerType=l={}));var o;(function(H){H[H.Automatic=0]="Automatic",H[H.PasteAs=1]="PasteAs"})(o||(e.DocumentPasteTriggerKind=o={}));var t;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var u;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(u||(e.DocumentHighlightKind=u={}));function r(H){return H&&O.URI.isUri(H.uri)&&A.Range.isIRange(H.range)&&(A.Range.isIRange(H.originSelectionRange)||A.Range.isIRange(H.targetSelectionRange))}var c;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(c||(e.SymbolKind=c={})),e.symbolKindNames={17:(0,b.localize)(0,null),16:(0,b.localize)(1,null),4:(0,b.localize)(2,null),13:(0,b.localize)(3,null),8:(0,b.localize)(4,null),9:(0,b.localize)(5,null),21:(0,b.localize)(6,null),23:(0,b.localize)(7,null),7:(0,b.localize)(8,null),0:(0,b.localize)(9,null),11:(0,b.localize)(10,null),10:(0,b.localize)(11,null),19:(0,b.localize)(12,null),5:(0,b.localize)(13,null),1:(0,b.localize)(14,null),2:(0,b.localize)(15,null),20:(0,b.localize)(16,null),15:(0,b.localize)(17,null),18:(0,b.localize)(18,null),24:(0,b.localize)(19,null),3:(0,b.localize)(20,null),6:(0,b.localize)(21,null),14:(0,b.localize)(22,null),22:(0,b.localize)(23,null),25:(0,b.localize)(24,null),12:(0,b.localize)(25,null)};function s(H,G){return(0,b.localize)(26,null,H,e.symbolKindNames[G])}var w;(function(H){H[H.Deprecated=1]="Deprecated"})(w||(e.SymbolTag=w={}));var g;(function(H){const G=new Map;G.set(0,h.Codicon.symbolFile),G.set(1,h.Codicon.symbolModule),G.set(2,h.Codicon.symbolNamespace),G.set(3,h.Codicon.symbolPackage),G.set(4,h.Codicon.symbolClass),G.set(5,h.Codicon.symbolMethod),G.set(6,h.Codicon.symbolProperty),G.set(7,h.Codicon.symbolField),G.set(8,h.Codicon.symbolConstructor),G.set(9,h.Codicon.symbolEnum),G.set(10,h.Codicon.symbolInterface),G.set(11,h.Codicon.symbolFunction),G.set(12,h.Codicon.symbolVariable),G.set(13,h.Codicon.symbolConstant),G.set(14,h.Codicon.symbolString),G.set(15,h.Codicon.symbolNumber),G.set(16,h.Codicon.symbolBoolean),G.set(17,h.Codicon.symbolArray),G.set(18,h.Codicon.symbolObject),G.set(19,h.Codicon.symbolKey),G.set(20,h.Codicon.symbolNull),G.set(21,h.Codicon.symbolEnumMember),G.set(22,h.Codicon.symbolStruct),G.set(23,h.Codicon.symbolEvent),G.set(24,h.Codicon.symbolOperator),G.set(25,h.Codicon.symbolTypeParameter);function Y(ne){let pe=G.get(ne);return pe||(console.info("No codicon found for SymbolKind "+ne),pe=h.Codicon.symbolProperty),pe}H.toIcon=Y})(g||(e.SymbolKinds=g={}));class D{static asEditOperation(G){return L.EditOperation.replace(A.Range.lift(G.range),G.text)}}e.TextEdit=D;class v{static{this.Comment=new v("comment")}static{this.Imports=new v("imports")}static{this.Region=new v("region")}static fromValue(G){switch(G){case"comment":return v.Comment;case"imports":return v.Imports;case"region":return v.Region}return new v(G)}constructor(G){this.value=G}}e.FoldingRangeKind=v;var _;(function(H){H[H.AIGenerated=1]="AIGenerated"})(_||(e.NewSymbolNameTag=_={}));var C;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(C||(e.NewSymbolNameTriggerKind=C={}));var P;(function(H){function G(Y){return!Y||typeof Y!="object"?!1:typeof Y.id=="string"&&typeof Y.title=="string"}H.is=G})(P||(e.Command=P={}));var k;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(k||(e.CommentThreadCollapsibleState=k={}));var F;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(F||(e.CommentThreadState=F={}));var x;(function(H){H[H.Current=0]="Current",H[H.Outdated=1]="Outdated"})(x||(e.CommentThreadApplicability=x={}));var z;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(z||(e.CommentMode=z={}));var N;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(N||(e.CommentState=N={}));var M;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(M||(e.InlayHintKind=M={}));class W{constructor(G){this.createSupport=G,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(G=>{G&&G.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}e.LazyTokenizationSupport=W,e.TokenizationRegistry=new R.TokenizationRegistry;var X;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(X||(e.ExternalUriOpenerPriority=X={}));var te;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(te||(e.InlineEditTriggerKind=te={}))}),define(_e[208],Ce([9,10]),function(ue,e){return ue.create("vs/platform/configuration/common/configurationRegistry",e)}),define(_e[209],Ce([9,10]),function(ue,e){return ue.create("vs/platform/contextkey/common/contextkey",e)}),define(_e[210],Ce([9,10]),function(ue,e){return ue.create("vs/platform/contextkey/common/scanner",e)}),define(_e[211],Ce([9,10]),function(ue,e){return ue.create("vs/platform/dialogs/common/dialogs",e)}),define(_e[212],Ce([9,10]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(_e[213],Ce([9,10]),function(ue,e){return ue.create("vs/platform/extensions/common/extensionValidator",e)}),define(_e[214],Ce([9,10]),function(ue,e){return ue.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(_e[215],Ce([9,10]),function(ue,e){return ue.create("vs/platform/files/common/files",e)}),define(_e[216],Ce([9,10]),function(ue,e){return ue.create("vs/platform/files/common/io",e)}),define(_e[217],Ce([9,10]),function(ue,e){return ue.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(_e[218],Ce([9,10]),function(ue,e){return ue.create("vs/platform/log/common/log",e)}),define(_e[219],Ce([9,10]),function(ue,e){return ue.create("vs/platform/markers/common/markers",e)}),define(_e[220],Ce([9,10]),function(ue,e){return ue.create("vs/platform/request/common/request",e)}),define(_e[221],Ce([9,10]),function(ue,e){return ue.create("vs/platform/theme/common/iconRegistry",e)}),define(_e[222],Ce([9,10]),function(ue,e){return ue.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(_e[223],Ce([9,10]),function(ue,e){return ue.create("vs/platform/workspace/common/workspace",e)}),define(_e[224],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(_e[225],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostExtensionService",e)}),define(_e[226],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(_e[227],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(_e[228],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostLogService",e)}),define(_e[229],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostNotebook",e)}),define(_e[230],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostStatusBar",e)}),define(_e[231],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostTelemetry",e)}),define(_e[232],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostTerminalService",e)}),define(_e[233],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostTreeViews",e)}),define(_e[234],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostTunnelService",e)}),define(_e[235],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostWorkspace",e)}),define(_e[236],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/api/node/extHostDebugService",e)}),define(_e[237],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/common/configuration",e)}),define(_e[238],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/common/editor",e)}),define(_e[239],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/common/views",e)}),define(_e[240],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(_e[241],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(_e[242],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/contrib/debug/common/debug",e)}),define(_e[243],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(_e[244],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(_e[245],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(_e[246],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(_e[247],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(_e[248],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(_e[249],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(_e[250],Ce([9,10]),function(ue,e){return ue.create("vs/workbench/services/search/common/queryBuilder",e)}),define(_e[251],Ce([1,0,13,210]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var L;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(L||(e.TokenType=L={}));function A(...y){switch(y.length){case 1:return(0,O.localize)(0,null,y[0]);case 2:return(0,O.localize)(1,null,y[0],y[1]);case 3:return(0,O.localize)(2,null,y[0],y[1],y[2]);default:return}}const R=(0,O.localize)(3,null),b=(0,O.localize)(4,null);class m{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,h.illegalState)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(T=>T.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(T){return this._input=T,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const I=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:I})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const I=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:I})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(T){return this._isAtEnd()||this._input.charCodeAt(this._current)!==T?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(T){this._tokens.push({type:T,offset:this._start})}_error(T){const I=this._start,p=this._input.substring(this._start,this._current),S={type:19,offset:this._start,lexeme:p};this._errors.push({offset:I,lexeme:p,additionalInfo:T}),this._tokens.push(S)}_string(){this.stringRe.lastIndex=this._start;const T=this.stringRe.exec(this._input);if(T){this._current=this._start+T[0].length;const I=this._input.substring(this._start,this._current),p=m._keywords.get(I);p?this._addToken(p):this._tokens.push({type:17,lexeme:I,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(R);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let T=this._current,I=!1,p=!1;for(;;){if(T>=this._input.length){this._current=T,this._error(b);return}const E=this._input.charCodeAt(T);if(I)I=!1;else if(E===47&&!p){T++;break}else E===91?p=!0:E===92?I=!0:E===93&&(p=!1);T++}for(;T<this._input.length&&m._regexFlags.has(this._input.charCodeAt(T));)T++;this._current=T;const S=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:S,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=m}),define(_e[252],Ce([1,0,23,41,213,401]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=m,e.parseVersion=y,e.normalizeVersion=T,e.isValidVersion=I,e.validateExtensionManifest=p,e.isValidExtensionVersion=S,e.isEngineValid=E;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function m(a){return a=a.trim(),a==="*"||R.test(a)}function y(a){if(!m(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=a.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function T(a){if(!a)return null;const i=a.majorBase,n=a.majorMustEqual,l=a.minorBase;let o=a.minorMustEqual;const t=a.patchBase;let u=a.patchMustEqual;a.hasCaret&&(i===0||(o=!1),u=!1);let r=0;if(a.preRelease){const c=b.exec(a.preRelease);if(c){const[,s,w,g]=c;r=Date.UTC(Number(s),Number(w)-1,Number(g))}}return{majorBase:i,majorMustEqual:n,minorBase:l,minorMustEqual:o,patchBase:t,patchMustEqual:u,isMinimum:a.hasGreaterEquals,notBefore:r}}function I(a,i,n){let l;typeof a=="string"?l=T(y(a)):l=a;let o;i instanceof Date?o=i.getTime():typeof i=="string"&&(o=new Date(i).getTime());let t;if(typeof n=="string"?t=T(y(n)):t=n,!l||!t)return!1;const u=l.majorBase,r=l.minorBase,c=l.patchBase;let s=t.majorBase,w=t.minorBase,g=t.patchBase;const D=t.notBefore;let v=t.majorMustEqual,_=t.minorMustEqual,C=t.patchMustEqual;return t.isMinimum?u>s?!0:u<s?!1:r>w?!0:r<w||o&&o<D?!1:c>=g:(u===1&&s===0&&(!v||!_||!C)&&(s=1,w=0,g=0,v=!0,_=!1,C=!1),u<s?!1:u>s?!v:r<w?!1:r>w?!_:c<g?!1:c>g?!C:!(o&&o<D))}function p(a,i,n,l,o){const t=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return t.push([O.default.Error,L.localize(0,null)]),t;if(typeof l.name!="string")return t.push([O.default.Error,L.localize(1,null,"name")]),t;if(typeof l.version!="string")return t.push([O.default.Error,L.localize(2,null,"version")]),t;if(!l.engines)return t.push([O.default.Error,L.localize(3,null,"engines")]),t;if(typeof l.engines.vscode!="string")return t.push([O.default.Error,L.localize(4,null,"engines.vscode")]),t;if(typeof l.extensionDependencies<"u"&&!f(l.extensionDependencies))return t.push([O.default.Error,L.localize(5,null,"extensionDependencies")]),t;if(typeof l.activationEvents<"u"){if(!f(l.activationEvents))return t.push([O.default.Error,L.localize(6,null,"activationEvents")]),t;if(typeof l.main>"u"&&typeof l.browser>"u")return t.push([O.default.Error,L.localize(7,null,"activationEvents","main","browser")]),t}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&t.push([O.default.Warning,L.localize(8,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return t.push([O.default.Error,L.localize(9,null,"main")]),t;{const c=(0,h.joinPath)(n,l.main);(0,h.isEqualOrParent)(c,n)||t.push([O.default.Warning,L.localize(10,null,c.path,n.path)])}}if(typeof l.browser<"u"){if(typeof l.browser!="string")return t.push([O.default.Error,L.localize(11,null,"browser")]),t;{const c=(0,h.joinPath)(n,l.browser);(0,h.isEqualOrParent)(c,n)||t.push([O.default.Warning,L.localize(12,null,c.path,n.path)])}}if(!A.valid(l.version))return t.push([O.default.Error,L.localize(13,null)]),t;const u=[];if(!S(a,i,l,o,u))for(const c of u)t.push([O.default.Error,c]);return t}function S(a,i,n,l,o){return l||typeof n.main>"u"&&typeof n.browser>"u"?!0:d(a,i,n.engines.vscode,o)}function E(a,i,n){return a==="*"||d(i,n,a)}function d(a,i,n,l=[]){const o=T(y(n));if(!o)return l.push(L.localize(14,null,n)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return l.push(L.localize(15,null,n)),!1}else if(!o.majorMustEqual)return l.push(L.localize(16,null,n)),!1;return I(a,i,o)?!0:(l.push(L.localize(17,null,a,n)),!1)}function f(a){if(!Array.isArray(a))return!1;for(let i=0,n=a.length;i<n;i++)if(typeof a[i]!="string")return!1;return!0}}),define(_e[106],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class h{constructor(L,A=[],R=!1){this.ctor=L,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=h}),define(_e[85],Ce([1,0,106]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=A,e.getSingletonServiceDescriptors=R;const O=[];var L;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function A(b,m,y){m instanceof h.SyncDescriptor||(m=new h.SyncDescriptor(m,[],!!y)),O.push([b,m])}function R(){return O}}),define(_e[253],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class h{constructor(A,R){this.key=A,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.Node=h;class O{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const R of this._nodes.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const b=this.lookupOrInsertNode(A),m=this.lookupOrInsertNode(R);b.outgoing.set(m.key,m),m.incoming.set(b.key,b)}removeNode(A){const R=this._hashFn(A);this._nodes.delete(R);for(const b of this._nodes.values())b.outgoing.delete(R),b.incoming.delete(R)}lookupOrInsertNode(A){const R=this._hashFn(A);let b=this._nodes.get(R);return b||(b=new h(R,A),this._nodes.set(R,b)),b}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[R,b]of this._nodes)A.push(`${R}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,R]of this._nodes){const b=new Set([A]),m=this._findCycle(R,b);if(m)return m}}_findCycle(A,R){for(const[b,m]of A.outgoing){if(R.has(b))return[...R,b].join(" -> ");R.add(b);const y=this._findCycle(m,R);if(y)return y;R.delete(b)}}}e.Graph=O}),define(_e[5],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=L,e.refineServiceDecorator=A;var h;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function b(m){return m[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=b})(h||(e._util=h={})),e.IInstantiationService=L("instantiationService");function O(R,b,m){b[h.DI_TARGET]===b?b[h.DI_DEPENDENCIES].push({id:R,index:m}):(b[h.DI_DEPENDENCIES]=[{id:R,index:m}],b[h.DI_TARGET]=b)}function L(R){if(h.serviceIds.has(R))return h.serviceIds.get(R);const b=function(m,y,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(b,m,T)};return b.toString=()=>R,h.serviceIds.set(R,b),b}function A(R){return R}}),define(_e[55],Ce([1,0,18,2,5]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=A,e.isConfigurationUpdateOverrides=R,e.ConfigurationTargetToString=m,e.isConfigured=y,e.toValuesTree=T,e.addToValueTree=I,e.removeFromValueTree=p,e.getConfigurationValue=E,e.merge=d,e.getLanguageTagSettingPlainKey=f,e.IConfigurationService=(0,L.createDecorator)("configurationService");function A(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof O.URI)}function R(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof O.URI)}var b;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function m(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function y(a){return a.applicationValue!==void 0||a.userValue!==void 0||a.userLocalValue!==void 0||a.userRemoteValue!==void 0||a.workspaceValue!==void 0||a.workspaceFolderValue!==void 0}function T(a,i){const n=Object.create(null);for(const l in a)I(n,l,a[l],i);return n}function I(a,i,n,l){const o=i.split("."),t=o.pop();let u=a;for(let r=0;r<o.length;r++){const c=o[r];let s=u[c];switch(typeof s){case"undefined":s=u[c]=Object.create(null);break;case"object":if(s===null){l(`Ignoring ${i} as ${o.slice(0,r+1).join(".")} is null`);return}break;default:l(`Ignoring ${i} as ${o.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}u=s}if(typeof u=="object"&&u!==null)try{u[t]=n}catch{l(`Ignoring ${i} as ${o.join(".")} is ${JSON.stringify(u)}`)}else l(`Ignoring ${i} as ${o.join(".")} is ${JSON.stringify(u)}`)}function p(a,i){const n=i.split(".");S(a,n)}function S(a,i){const n=i.shift();if(i.length===0){delete a[n];return}if(Object.keys(a).indexOf(n)!==-1){const l=a[n];typeof l=="object"&&!Array.isArray(l)&&(S(l,i),Object.keys(l).length===0&&delete a[n])}}function E(a,i,n){function l(u,r){let c=u;for(const s of r){if(typeof c!="object"||c===null)return;c=c[s]}return c}const o=i.split("."),t=l(a,o);return typeof t>"u"?n:t}function d(a,i,n){Object.keys(i).forEach(l=>{l!=="__proto__"&&(l in a?h.isObject(a[l])&&h.isObject(i[l])?d(a[l],i[l],n):n&&(a[l]=i[l]):a[l]=i[l])})}function f(a){return a.replace(/[\[\]]/g,"")}}),define(_e[38],Ce([1,0,12,14,251,5,209,13]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=y,e.validateWhenClauses=u,e.expressionsAreEqualWithConstantSubstitution=r,e.implies=pe;const m=new Map;m.set("false",!1),m.set("true",!0),m.set("isMac",h.isMacintosh),m.set("isLinux",h.isLinux),m.set("isWindows",h.isWindows),m.set("isWeb",h.isWeb),m.set("isMacNative",h.isMacintosh&&!h.isWeb),m.set("isEdge",h.isEdge),m.set("isFirefox",h.isFirefox),m.set("isChrome",h.isChrome),m.set("isSafari",h.isSafari);function y(Z,B){if(m.get(Z)!==void 0)throw(0,b.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");m.set(Z,B)}const T=Object.prototype.hasOwnProperty;var I;(function(Z){Z[Z.False=0]="False",Z[Z.True=1]="True",Z[Z.Defined=2]="Defined",Z[Z.Not=3]="Not",Z[Z.Equals=4]="Equals",Z[Z.NotEquals=5]="NotEquals",Z[Z.And=6]="And",Z[Z.Regex=7]="Regex",Z[Z.NotRegex=8]="NotRegex",Z[Z.Or=9]="Or",Z[Z.In=10]="In",Z[Z.NotIn=11]="NotIn",Z[Z.Greater=12]="Greater",Z[Z.GreaterEquals=13]="GreaterEquals",Z[Z.Smaller=14]="Smaller",Z[Z.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const p={regexParsingWithErrorRecovery:!0},S=(0,R.localize)(0,null),E=(0,R.localize)(1,null),d=(0,R.localize)(2,null),f=(0,R.localize)(3,null),a=(0,R.localize)(4,null),i=(0,R.localize)(5,null),n=(0,R.localize)(6,null),l=(0,R.localize)(7,null);class o{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(B=p){this._config=B,this._scanner=new L.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(B){if(B===""){this._parsingErrors.push({message:S,offset:0,lexeme:"",additionalInfo:E});return}this._tokens=this._scanner.reset(B).scan(),this._current=0,this._parsingErrors=[];try{const ee=this._expr();if(!this._isAtEnd()){const ve=this._peek(),Pe=ve.type===17?i:void 0;throw this._parsingErrors.push({message:a,offset:ve.offset,lexeme:L.Scanner.getLexeme(ve),additionalInfo:Pe}),o._parseError}return ee}catch(ee){if(ee!==o._parseError)throw ee;return}}_expr(){return this._or()}_or(){const B=[this._and()];for(;this._matchOne(16);){const ee=this._and();B.push(ee)}return B.length===1?B[0]:t.or(...B)}_and(){const B=[this._term()];for(;this._matchOne(15);){const ee=this._term();B.push(ee)}return B.length===1?B[0]:t.and(...B)}_term(){if(this._matchOne(2)){const B=this._peek();switch(B.type){case 11:return this._advance(),s.INSTANCE;case 12:return this._advance(),w.INSTANCE;case 0:{this._advance();const ee=this._expr();return this._consume(1,f),ee?.negate()}case 17:return this._advance(),P.create(B.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",B)}}return this._primary()}_primary(){const B=this._peek();switch(B.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const ee=this._expr();return this._consume(1,f),ee}case 17:{const ee=B.lexeme;if(this._advance(),this._matchOne(9)){const Pe=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),Pe.type!==10)throw this._errExpectedButGot("REGEX",Pe);const oe=Pe.lexeme,se=oe.lastIndexOf("/"),re=se===oe.length-1?void 0:this._removeFlagsGY(oe.substring(se+1));let j;try{j=new RegExp(oe.substring(1,se),re)}catch{throw this._errExpectedButGot("REGEX",Pe)}return M.create(ee,j)}switch(Pe.type){case 10:case 19:{const oe=[Pe.lexeme];this._advance();let se=this._peek(),re=0;for(let Ae=0;Ae<Pe.lexeme.length;Ae++)Pe.lexeme.charCodeAt(Ae)===40?re++:Pe.lexeme.charCodeAt(Ae)===41&&re--;for(;!this._isAtEnd()&&se.type!==15&&se.type!==16;){switch(se.type){case 0:re++;break;case 1:re--;break;case 10:case 18:for(let Ae=0;Ae<se.lexeme.length;Ae++)se.lexeme.charCodeAt(Ae)===40?re++:Pe.lexeme.charCodeAt(Ae)===41&&re--}if(re<0)break;oe.push(L.Scanner.getLexeme(se)),this._advance(),se=this._peek()}const j=oe.join(""),ie=j.lastIndexOf("/"),me=ie===j.length-1?void 0:this._removeFlagsGY(j.substring(ie+1));let be;try{be=new RegExp(j.substring(1,ie),me)}catch{throw this._errExpectedButGot("REGEX",Pe)}return t.regex(ee,be)}case 18:{const oe=Pe.lexeme;this._advance();let se=null;if(!(0,O.isFalsyOrWhitespace)(oe)){const re=oe.indexOf("/"),j=oe.lastIndexOf("/");if(re!==j&&re>=0){const ie=oe.slice(re+1,j),me=oe[j+1]==="i"?"i":"";try{se=new RegExp(ie,me)}catch{throw this._errExpectedButGot("REGEX",Pe)}}}if(se===null)throw this._errExpectedButGot("REGEX",Pe);return M.create(ee,se)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,d);const Pe=this._value();return t.notIn(ee,Pe)}switch(this._peek().type){case 3:{this._advance();const Pe=this._value();if(this._previous().type===18)return t.equals(ee,Pe);switch(Pe){case"true":return t.has(ee);case"false":return t.not(ee);default:return t.equals(ee,Pe)}}case 4:{this._advance();const Pe=this._value();if(this._previous().type===18)return t.notEquals(ee,Pe);switch(Pe){case"true":return t.not(ee);case"false":return t.has(ee);default:return t.notEquals(ee,Pe)}}case 5:return this._advance(),z.create(ee,this._value());case 6:return this._advance(),N.create(ee,this._value());case 7:return this._advance(),F.create(ee,this._value());case 8:return this._advance(),x.create(ee,this._value());case 13:return this._advance(),t.in(ee,this._value());default:return t.has(ee)}}case 20:throw this._parsingErrors.push({message:n,offset:B.offset,lexeme:"",additionalInfo:l}),o._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const B=this._peek();switch(B.type){case 17:case 18:return this._advance(),B.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(B){return B.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(B){return this._check(B)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(B,ee){if(this._check(B))return this._advance();throw this._errExpectedButGot(ee,this._peek())}_errExpectedButGot(B,ee,ve){const Pe=(0,R.localize)(8,null,B,L.Scanner.getLexeme(ee)),oe=ee.offset,se=L.Scanner.getLexeme(ee);return this._parsingErrors.push({message:Pe,offset:oe,lexeme:se,additionalInfo:ve}),o._parseError}_check(B){return this._peek().type===B}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=o;class t{static false(){return s.INSTANCE}static true(){return w.INSTANCE}static has(B){return g.create(B)}static equals(B,ee){return D.create(B,ee)}static notEquals(B,ee){return C.create(B,ee)}static regex(B,ee){return M.create(B,ee)}static in(B,ee){return v.create(B,ee)}static notIn(B,ee){return _.create(B,ee)}static not(B){return P.create(B)}static and(...B){return te.create(B,null,!0)}static or(...B){return H.create(B,null,!0)}static greater(B,ee){return F.create(B,ee)}static greaterEquals(B,ee){return x.create(B,ee)}static smaller(B,ee){return z.create(B,ee)}static smallerEquals(B,ee){return N.create(B,ee)}static{this._parser=new o({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this._parser.parse(B)}}e.ContextKeyExpr=t;function u(Z){const B=new o({regexParsingWithErrorRecovery:!1});return Z.map(ee=>(B.parse(ee),B.lexingErrors.length>0?B.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,R.localize)(9,null,ve.additionalInfo):(0,R.localize)(10,null),offset:ve.offset,length:ve.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function r(Z,B){const ee=Z?Z.substituteConstants():void 0,ve=B?B.substituteConstants():void 0;return!ee&&!ve?!0:!ee||!ve?!1:ee.equals(ve)}function c(Z,B){return Z.cmp(B)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return w.INSTANCE}}e.ContextKeyFalseExpr=s;class w{static{this.INSTANCE=new w}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return s.INSTANCE}}e.ContextKeyTrueExpr=w;class g{static create(B,ee=null){const ve=m.get(B);return typeof ve=="boolean"?ve?w.INSTANCE:s.INSTANCE:new g(B,ee)}constructor(B,ee){this.key=B,this.negated=ee,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:Y(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=m.get(this.key);return typeof B=="boolean"?B?w.INSTANCE:s.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.negated||(this.negated=P.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=g;class D{static create(B,ee,ve=null){if(typeof ee=="boolean")return ee?g.create(B,ve):P.create(B,ve);const Pe=m.get(B);return typeof Pe=="boolean"?ee===(Pe?"true":"false")?w.INSTANCE:s.INSTANCE:new D(B,ee,ve)}constructor(B,ee,ve){this.key=B,this.value=ee,this.negated=ve,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){const B=m.get(this.key);if(typeof B=="boolean"){const ee=B?"true":"false";return this.value===ee?w.INSTANCE:s.INSTANCE}return this}evaluate(B){return B.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(B){return B.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=D;class v{static create(B,ee){return new v(B,ee)}constructor(B,ee){this.key=B,this.valueKey=ee,this.type=10,this.negated=null}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.key,this.valueKey,B.key,B.valueKey)}equals(B){return B.type===this.type?this.key===B.key&&this.valueKey===B.valueKey:!1}substituteConstants(){return this}evaluate(B){const ee=B.getValue(this.valueKey),ve=B.getValue(this.key);return Array.isArray(ee)?ee.includes(ve):typeof ve=="string"&&typeof ee=="object"&&ee!==null?T.call(ee,ve):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(B){return B.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=_.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=v;class _{static create(B,ee){return new _(B,ee)}constructor(B,ee){this.key=B,this.valueKey=ee,this.type=11,this._negated=v.create(B,ee)}cmp(B){return B.type!==this.type?this.type-B.type:this._negated.cmp(B._negated)}equals(B){return B.type===this.type?this._negated.equals(B._negated):!1}substituteConstants(){return this}evaluate(B){return!this._negated.evaluate(B)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(B){return B.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=_;class C{static create(B,ee,ve=null){if(typeof ee=="boolean")return ee?P.create(B,ve):g.create(B,ve);const Pe=m.get(B);return typeof Pe=="boolean"?ee===(Pe?"true":"false")?s.INSTANCE:w.INSTANCE:new C(B,ee,ve)}constructor(B,ee,ve){this.key=B,this.value=ee,this.negated=ve,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){const B=m.get(this.key);if(typeof B=="boolean"){const ee=B?"true":"false";return this.value===ee?s.INSTANCE:w.INSTANCE}return this}evaluate(B){return B.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(B){return B.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=C;class P{static create(B,ee=null){const ve=m.get(B);return typeof ve=="boolean"?ve?s.INSTANCE:w.INSTANCE:new P(B,ee)}constructor(B,ee){this.key=B,this.negated=ee,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:Y(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=m.get(this.key);return typeof B=="boolean"?B?s.INSTANCE:w.INSTANCE:this}evaluate(B){return!B.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(B){return B.mapNot(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=P;function k(Z,B){if(typeof Z=="string"){const ee=parseFloat(Z);isNaN(ee)||(Z=ee)}return typeof Z=="string"||typeof Z=="number"?B(Z):s.INSTANCE}class F{static create(B,ee,ve=null){return k(ee,Pe=>new F(B,Pe,ve))}constructor(B,ee,ve){this.key=B,this.value=ee,this.negated=ve,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){return this}evaluate(B){return typeof this.value=="string"?!1:parseFloat(B.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(B){return B.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=F;class x{static create(B,ee,ve=null){return k(ee,Pe=>new x(B,Pe,ve))}constructor(B,ee,ve){this.key=B,this.value=ee,this.negated=ve,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){return this}evaluate(B){return typeof this.value=="string"?!1:parseFloat(B.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(B){return B.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=z.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=x;class z{static create(B,ee,ve=null){return k(ee,Pe=>new z(B,Pe,ve))}constructor(B,ee,ve){this.key=B,this.value=ee,this.negated=ve,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){return this}evaluate(B){return typeof this.value=="string"?!1:parseFloat(B.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(B){return B.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=z;class N{static create(B,ee,ve=null){return k(ee,Pe=>new N(B,Pe,ve))}constructor(B,ee,ve){this.key=B,this.value=ee,this.negated=ve,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){return this}evaluate(B){return typeof this.value=="string"?!1:parseFloat(B.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(B){return B.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=N;class M{static create(B,ee){return new M(B,ee)}constructor(B,ee){this.key=B,this.regexp=ee,this.type=7,this.negated=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.key<B.key)return-1;if(this.key>B.key)return 1;const ee=this.regexp?this.regexp.source:"",ve=B.regexp?B.regexp.source:"";return ee<ve?-1:ee>ve?1:0}equals(B){if(B.type===this.type){const ee=this.regexp?this.regexp.source:"",ve=B.regexp?B.regexp.source:"";return this.key===B.key&&ee===ve}return!1}substituteConstants(){return this}evaluate(B){const ee=B.getValue(this.key);return this.regexp?this.regexp.test(ee):!1}serialize(){const B=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${B}`}keys(){return[this.key]}map(B){return B.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=W.create(this)),this.negated}}e.ContextKeyRegexExpr=M;class W{static create(B){return new W(B)}constructor(B){this._actual=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this._actual.cmp(B._actual)}equals(B){return B.type===this.type?this._actual.equals(B._actual):!1}substituteConstants(){return this}evaluate(B){return!this._actual.evaluate(B)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(B){return new W(this._actual.map(B))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=W;function X(Z){let B=null;for(let ee=0,ve=Z.length;ee<ve;ee++){const Pe=Z[ee].substituteConstants();if(Z[ee]!==Pe&&B===null){B=[];for(let oe=0;oe<ee;oe++)B[oe]=Z[oe]}B!==null&&(B[ee]=Pe)}return B===null?Z:B}class te{static create(B,ee,ve){return te._normalizeArr(B,ee,ve)}constructor(B,ee){this.expr=B,this.negated=ee,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ee=0,ve=this.expr.length;ee<ve;ee++){const Pe=c(this.expr[ee],B.expr[ee]);if(Pe!==0)return Pe}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ee=0,ve=this.expr.length;ee<ve;ee++)if(!this.expr[ee].equals(B.expr[ee]))return!1;return!0}return!1}substituteConstants(){const B=X(this.expr);return B===this.expr?this:te.create(B,this.negated,!1)}evaluate(B){for(let ee=0,ve=this.expr.length;ee<ve;ee++)if(!this.expr[ee].evaluate(B))return!1;return!0}static _normalizeArr(B,ee,ve){const Pe=[];let oe=!1;for(const se of B)if(se){if(se.type===1){oe=!0;continue}if(se.type===0)return s.INSTANCE;if(se.type===6){Pe.push(...se.expr);continue}Pe.push(se)}if(Pe.length===0&&oe)return w.INSTANCE;if(Pe.length!==0){if(Pe.length===1)return Pe[0];Pe.sort(c);for(let se=1;se<Pe.length;se++)Pe[se-1].equals(Pe[se])&&(Pe.splice(se,1),se--);if(Pe.length===1)return Pe[0];for(;Pe.length>1;){const se=Pe[Pe.length-1];if(se.type!==9)break;Pe.pop();const re=Pe.pop(),j=Pe.length===0,ie=H.create(se.expr.map(me=>te.create([me,re],null,ve)),null,j);ie&&(Pe.push(ie),Pe.sort(c))}if(Pe.length===1)return Pe[0];if(ve){for(let se=0;se<Pe.length;se++)for(let re=se+1;re<Pe.length;re++)if(Pe[se].negate().equals(Pe[re]))return s.INSTANCE;if(Pe.length===1)return Pe[0]}return new te(Pe,ee)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const ee of this.expr)B.push(...ee.keys());return B}map(B){return new te(this.expr.map(ee=>ee.map(B)),null)}negate(){if(!this.negated){const B=[];for(const ee of this.expr)B.push(ee.negate());this.negated=H.create(B,this,!0)}return this.negated}}e.ContextKeyAndExpr=te;class H{static create(B,ee,ve){return H._normalizeArr(B,ee,ve)}constructor(B,ee){this.expr=B,this.negated=ee,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ee=0,ve=this.expr.length;ee<ve;ee++){const Pe=c(this.expr[ee],B.expr[ee]);if(Pe!==0)return Pe}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ee=0,ve=this.expr.length;ee<ve;ee++)if(!this.expr[ee].equals(B.expr[ee]))return!1;return!0}return!1}substituteConstants(){const B=X(this.expr);return B===this.expr?this:H.create(B,this.negated,!1)}evaluate(B){for(let ee=0,ve=this.expr.length;ee<ve;ee++)if(this.expr[ee].evaluate(B))return!0;return!1}static _normalizeArr(B,ee,ve){let Pe=[],oe=!1;if(B){for(let se=0,re=B.length;se<re;se++){const j=B[se];if(j){if(j.type===0){oe=!0;continue}if(j.type===1)return w.INSTANCE;if(j.type===9){Pe=Pe.concat(j.expr);continue}Pe.push(j)}}if(Pe.length===0&&oe)return s.INSTANCE;Pe.sort(c)}if(Pe.length!==0){if(Pe.length===1)return Pe[0];for(let se=1;se<Pe.length;se++)Pe[se-1].equals(Pe[se])&&(Pe.splice(se,1),se--);if(Pe.length===1)return Pe[0];if(ve){for(let se=0;se<Pe.length;se++)for(let re=se+1;re<Pe.length;re++)if(Pe[se].negate().equals(Pe[re]))return w.INSTANCE;if(Pe.length===1)return Pe[0]}return new H(Pe,ee)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const ee of this.expr)B.push(...ee.keys());return B}map(B){return new H(this.expr.map(ee=>ee.map(B)),null)}negate(){if(!this.negated){const B=[];for(const ee of this.expr)B.push(ee.negate());for(;B.length>1;){const ee=B.shift(),ve=B.shift(),Pe=[];for(const oe of we(ee))for(const se of we(ve))Pe.push(te.create([oe,se],null,!1));B.unshift(H.create(Pe,null,!1))}this.negated=H.create(B,this,!0)}return this.negated}}e.ContextKeyOrExpr=H;class G extends g{static{this._info=[]}static all(){return G._info.values()}constructor(B,ee,ve){super(B,null),this._defaultValue=ee,typeof ve=="object"?G._info.push({...ve,key:B}):ve!==!0&&G._info.push({key:B,description:ve,type:ee!=null?typeof ee:void 0})}bindTo(B){return B.createKey(this.key,this._defaultValue)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return D.create(this.key,B)}notEqualsTo(B){return C.create(this.key,B)}}e.RawContextKey=G,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function Y(Z,B){return Z<B?-1:Z>B?1:0}function ne(Z,B,ee,ve){return Z<ee?-1:Z>ee?1:B<ve?-1:B>ve?1:0}function pe(Z,B){if(Z.type===0||B.type===1)return!0;if(Z.type===9)return B.type===9?le(Z.expr,B.expr):!1;if(B.type===9){for(const ee of B.expr)if(pe(Z,ee))return!0;return!1}if(Z.type===6){if(B.type===6)return le(B.expr,Z.expr);for(const ee of Z.expr)if(pe(ee,B))return!0;return!1}return Z.equals(B)}function le(Z,B){let ee=0,ve=0;for(;ee<Z.length&&ve<B.length;){const Pe=Z[ee].cmp(B[ve]);if(Pe<0)return!1;Pe===0&&ee++,ve++}return ee===Z.length}function we(Z){return Z.type===9?Z.expr:[Z]}}),define(_e[254],Ce([1,0,23,41,211,5,103,12,24]),function(ue,e,h,O,L,A,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.getFileNamesMessage=S,e.massageMessageBoxOptions=E,e.IDialogService=(0,A.createDecorator)("dialogService");var y;(function(d){d[d.Confirmation=1]="Confirmation",d[d.Prompt=2]="Prompt",d[d.Input=3]="Input"})(y||(y={}));class T{getConfirmationButtons(f){return this.getButtons(f,y.Confirmation)}getPromptButtons(f){return this.getButtons(f,y.Prompt)}getInputButtons(f){return this.getButtons(f,y.Input)}getButtons(f,a){const i=[];switch(a){case y.Confirmation:{const n=f;n.primaryButton?i.push(n.primaryButton):i.push((0,L.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,L.localize)(1,null));break}case y.Prompt:{const n=f;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(l=>l.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,L.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,L.localize)(3,null))),i.length===0&&i.push((0,L.localize)(4,null));break}case y.Input:{const n=f;n.primaryButton?i.push(n.primaryButton):i.push((0,L.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,L.localize)(6,null));break}}return i}getDialogType(f){if(typeof f=="string")return f;if(typeof f=="number")return f===O.default.Info?"info":f===O.default.Error?"error":f===O.default.Warning?"warning":"none"}getPromptResult(f,a,i){const n=[...f.buttons??[]];f.cancelButton&&typeof f.cancelButton!="string"&&typeof f.cancelButton!="boolean"&&n.push(f.cancelButton);let l=n[a]?.run({checkboxChecked:i});return l instanceof Promise||(l=Promise.resolve(l)),{result:l,checkboxChecked:i}}}e.AbstractDialogHandler=T,e.IFileDialogService=(0,A.createDecorator)("fileDialogService");var I;(function(d){d[d.SAVE=0]="SAVE",d[d.DONT_SAVE=1]="DONT_SAVE",d[d.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const p=10;function S(d){const f=[];return f.push(...d.slice(0,p).map(a=>typeof a=="string"?a:(0,h.basename)(a))),d.length>p&&(d.length-p===1?f.push((0,L.localize)(7,null)):f.push((0,L.localize)(8,null,d.length-p))),f.push(""),f.join(`
`)}function E(d,f){const a=(0,m.deepClone)(d);let i=(a.buttons??[]).map(t=>(0,R.mnemonicButtonLabel)(t)),n=(d.buttons||[]).map((t,u)=>u),l=0,o=a.cancelId??i.length-1;if(i.length>1){const t=typeof o=="number"?i[o]:void 0;if(b.isLinux||b.isMacintosh){if(typeof t=="string"&&i.length>1&&o!==1){i.splice(o,1),i.splice(1,0,t);const u=n[o];n.splice(o,1),n.splice(1,0,u),o=1}b.isLinux&&i.length>1&&(i=i.reverse(),n=n.reverse(),l=i.length-1,typeof t=="string"&&(o=l-1))}else if(b.isWindows&&typeof t=="string"&&i.length>1&&o!==i.length-1){i.splice(o,1),i.push(t);const u=n[o];n.splice(o,1),n.push(u),o=i.length-1}}return a.buttons=i,a.defaultId=l,a.cancelId=o,a.noLink=!0,a.title=a.title||f.nameLong,{options:a,buttonIndeces:n}}}),define(_e[137],Ce([1,0,5]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,h.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,h.refineServiceDecorator)(e.IEnvironmentService)}),define(_e[138],Ce([1,0,212,5]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=L,e.toTargetPlatform=A,e.getTargetPlatform=R,e.isNotWebExtensionInWebTargetPlatform=b,e.isTargetPlatformCompatible=m,e.isIExtensionIdentifier=y,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function L(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PowerPC";case"linux-riscv64":return"Linux RISC-V 64";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function A(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"linux-riscv64":return"linux-riscv64";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function R(i,n){switch(i){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":n==="ppc64le"?"linux-ppc64le":n==="riscv64"?"linux-riscv64":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function b(i,n){return n==="web"&&!i.includes("web")}function m(i,n,l){return b(n,l)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===l}function y(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var T;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(T||(e.SortBy=T={}));var I;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var p;(function(i){i.Install="install",i.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var S;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var E;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));class d extends Error{constructor(n,l){super(n),this.code=l,this.name=l}}e.ExtensionManagementError=d;var f;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(f||(e.ExtensionGalleryErrorCode=f={}));class a extends Error{constructor(n,l){super(n),this.code=l,this.name=l}}e.ExtensionGalleryError=a,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,h.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,h.localize2)(1,"Preferences")}),define(_e[255],Ce([1,0,5]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,h.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(_e[256],Ce([1,0,54,56,15,17,12,102,32,105,214,255]),function(ue,e,h,O,L,A,R,b,m,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const p=T.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:E.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class E extends S{static{this.CMD="cmd.exe"}openTerminal(o,t){return this.spawnTerminal(h,o,y.getWindowsShell(),t)}spawnTerminal(o,t,u,r){const c=t.windowsExec||E.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const s=A.basename(c,".exe").toLowerCase();if(s==="cmder")return o.spawn(c,r?[r]:void 0),Promise.resolve(void 0);const w=["/c","start","/wait"];return c.indexOf(" ")>=0&&w.push('""'),w.push(c),s==="wt"&&w.push("-d ."),new Promise((g,D)=>{const v=a(process),_=o.spawn(u,w,{cwd:r,env:v,detached:!0});_.on("error",D),_.on("exit",()=>g())})}async runInTerminal(o,t,u,r,c){const s="windowsExec"in c&&c.windowsExec?c.windowsExec:E.getDefaultTerminalWindows(),w=await E.getWtExePath();return new Promise((g,D)=>{const v=`"${t} - ${p}"`,_=`"${u.join('" "')}" & pause`,C=Object.assign({},a(process),r);Object.keys(C).filter(z=>C[z]===null).forEach(z=>delete C[z]);const P={cwd:t,env:C,windowsVerbatimArguments:!0};let k,F;A.basename(s,".exe")==="wt"?(k=s,F=["-d",".",E.CMD,"/c",_]):w?(k=w,F=["-d",".",s,"/c",_]):(k=E.CMD,F=["/c","start",v,"/wait",s,"/c",`"${_}"`]),h.spawn(k,F,P).on("error",z=>{D(i(z))}),g(void 0)})}static getDefaultTerminalWindows(){if(!E._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");E._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return E._DEFAULT_TERMINAL_WINDOWS}static async getWtExePath(){try{const o=await y.win32.findExecutable("wt");return await m.Promises.exists(o)?o:void 0}catch{return}}}e.WindowsExternalTerminalService=E,Ge([O.memoize],E,"getWtExePath",null);class d extends S{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(o,t){return this.spawnTerminal(h,o,t)}runInTerminal(o,t,u,r,c){const s=c.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((w,g)=>{if(s===I.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const D=s===I.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",_=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",o||p,"-w",t];for(const k of u)_.push("-a"),_.push(k);if(r){const k=Object.assign({},a(process),r);for(const F in k){const x=k[F];x===null?(_.push("-u"),_.push(F)):(_.push("-e"),_.push(`${F}=${x}`))}}let C="";const P=h.spawn(d.OSASCRIPT,_);P.on("error",k=>{g(i(k))}),P.stderr.on("data",k=>{C+=k.toString()}),P.on("exit",k=>{if(k===0)w(void 0);else if(C){const F=C.split(`
`,1);g(new Error(F[0]))}else g(new Error(T.localize(1,null,D,k)))})}else g(new Error(T.localize(2,null,s)))})}spawnTerminal(o,t,u){const r=t.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((c,s)=>{const w=["-a",r];u&&w.push(u);const g=a(process),D=o.spawn("/usr/bin/open",w,{cwd:u,env:g});D.on("error",s),D.on("exit",()=>c())})}}e.MacExternalTerminalService=d;class f extends S{static{this.WAIT_MESSAGE=T.localize(3,null)}openTerminal(o,t){return this.spawnTerminal(h,o,t)}runInTerminal(o,t,u,r,c){const s=c.linuxExec?Promise.resolve(c.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((w,g)=>{const D=[];s.then(v=>{v.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const _=`${n(u)}; echo; read -p "${f.WAIT_MESSAGE}" -n1;`;D.push(`''${_}''`);const C=Object.assign({},a(process),r);Object.keys(C).filter(x=>C[x]===null).forEach(x=>delete C[x]);const P={cwd:t,env:C};let k="";const F=h.spawn(v,D,P);F.on("error",x=>{g(i(x))}),F.stderr.on("data",x=>{k+=x.toString()}),F.on("exit",x=>{if(x===0)w(void 0);else if(k){const z=k.split(`
`,1);g(new Error(z[0]))}else g(new Error(T.localize(4,null,v,x)))})})})}static async getDefaultTerminalLinuxReady(){if(!f._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)f._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const o=await m.Promises.exists("/etc/debian_version");f._DEFAULT_TERMINAL_LINUX_READY=new Promise(t=>{o?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return f._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,t,u){const r=t.linuxExec?Promise.resolve(t.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((c,s)=>{r.then(w=>{const g=a(process),D=o.spawn(w,[],{cwd:u,env:g});D.on("error",s),D.on("exit",()=>c())})})}}e.LinuxExternalTerminalService=f;function a(l){const o={...l.env};return(0,b.sanitizeProcessEnvironment)(o),o}function i(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(T.localize(5,null,l.path)):l}function n(l){let o="";for(const t of l)t.indexOf(" ")>=0?o+='"'+t+'"':o+=t,o+=" ";return o}}),define(_e[33],Ce([1,0,78,17,14,18,2,215,5,12,15,46]),function(ue,e,h,O,L,A,R,b,m,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=p,e.isFileSystemWatcher=f,e.hasReadWriteCapability=i,e.hasFileFolderCopyCapability=n,e.hasFileCloneCapability=l,e.hasOpenReadWriteCloseCapability=o,e.hasFileReadStreamCapability=t,e.hasFileAtomicReadCapability=u,e.hasFileAtomicWriteCapability=r,e.hasFileAtomicDeleteCapability=c,e.hasReadonlyCapability=s,e.createFileSystemProviderError=D,e.ensureFileSystemProviderError=v,e.markAsFileSystemProviderError=_,e.toFileSystemProviderErrorCode=C,e.toFileOperationResult=P,e.isParent=N,e.etag=G,e.whenProviderRegistered=Y,e.getLargeFileConfirmationLimit=pe,e.IFileService=(0,m.createDecorator)("fileService");function p(le){return le.create===!0}var S;(function(le){le[le.Unknown=0]="Unknown",le[le.File=1]="File",le[le.Directory=2]="Directory",le[le.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var E;(function(le){le[le.Readonly=1]="Readonly",le[le.Locked=2]="Locked"})(E||(e.FilePermission=E={}));var d;(function(le){le[le.UPDATED=2]="UPDATED",le[le.ADDED=4]="ADDED",le[le.DELETED=8]="DELETED"})(d||(e.FileChangeFilter=d={}));function f(le){const we=le;return!!we&&typeof we.onDidChange=="function"}var a;(function(le){le[le.None=0]="None",le[le.FileReadWrite=2]="FileReadWrite",le[le.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",le[le.FileReadStream=16]="FileReadStream",le[le.FileFolderCopy=8]="FileFolderCopy",le[le.PathCaseSensitive=1024]="PathCaseSensitive",le[le.Readonly=2048]="Readonly",le[le.Trash=4096]="Trash",le[le.FileWriteUnlock=8192]="FileWriteUnlock",le[le.FileAtomicRead=16384]="FileAtomicRead",le[le.FileAtomicWrite=32768]="FileAtomicWrite",le[le.FileAtomicDelete=65536]="FileAtomicDelete",le[le.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function i(le){return!!(le.capabilities&2)}function n(le){return!!(le.capabilities&8)}function l(le){return!!(le.capabilities&131072)}function o(le){return!!(le.capabilities&4)}function t(le){return!!(le.capabilities&16)}function u(le){return i(le)?!!(le.capabilities&16384):!1}function r(le){return i(le)?!!(le.capabilities&32768):!1}function c(le){return!!(le.capabilities&65536)}function s(le){return!!(le.capabilities&2048)}var w;(function(le){le.FileExists="EntryExists",le.FileNotFound="EntryNotFound",le.FileNotADirectory="EntryNotADirectory",le.FileIsADirectory="EntryIsADirectory",le.FileExceedsStorageQuota="EntryExceedsStorageQuota",le.FileTooLarge="EntryTooLarge",le.FileWriteLocked="EntryWriteLocked",le.NoPermissions="NoPermissions",le.Unavailable="Unavailable",le.Unknown="Unknown"})(w||(e.FileSystemProviderErrorCode=w={}));class g extends Error{static create(we,Z){const B=new g(we.toString(),Z);return _(B,Z),B}constructor(we,Z){super(we),this.code=Z}}e.FileSystemProviderError=g;function D(le,we){return g.create(le,we)}function v(le){return le||D((0,b.localize)(0,null),w.Unknown)}function _(le,we){return le.name=we?`${we} (FileSystemError)`:"FileSystemError",le}function C(le){if(!le)return w.Unknown;if(le instanceof g)return le.code;const we=/^(.+) \(FileSystemError\)$/.exec(le.name);if(!we)return w.Unknown;switch(we[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}function P(le){if(le instanceof M)return le.fileOperationResult;switch(C(le)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 9;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileTooLarge:return 7;default:return 10}}var k;(function(le){le[le.CREATE=0]="CREATE",le[le.DELETE=1]="DELETE",le[le.MOVE=2]="MOVE",le[le.COPY=3]="COPY",le[le.WRITE=4]="WRITE"})(k||(e.FileOperation=k={}));class F{constructor(we,Z,B){this.resource=we,this.operation=Z,this.target=B}isOperation(we){return this.operation===we}}e.FileOperationEvent=F;var x;(function(le){le[le.UPDATED=0]="UPDATED",le[le.ADDED=1]="ADDED",le[le.DELETED=2]="DELETED"})(x||(e.FileChangeType=x={}));class z{static{this.MIXED_CORRELATION=null}constructor(we,Z){this.ignorePathCasing=Z,this.correlationId=void 0,this.added=new I.Lazy(()=>{const B=h.TernarySearchTree.forUris(()=>this.ignorePathCasing);return B.fill(this.rawAdded.map(ee=>[ee,!0])),B}),this.updated=new I.Lazy(()=>{const B=h.TernarySearchTree.forUris(()=>this.ignorePathCasing);return B.fill(this.rawUpdated.map(ee=>[ee,!0])),B}),this.deleted=new I.Lazy(()=>{const B=h.TernarySearchTree.forUris(()=>this.ignorePathCasing);return B.fill(this.rawDeleted.map(ee=>[ee,!0])),B}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const B of we){switch(B.type){case 1:this.rawAdded.push(B.resource);break;case 0:this.rawUpdated.push(B.resource);break;case 2:this.rawDeleted.push(B.resource);break}this.correlationId!==z.MIXED_CORRELATION&&(typeof B.cId=="number"?this.correlationId===void 0?this.correlationId=B.cId:this.correlationId!==B.cId&&(this.correlationId=z.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=z.MIXED_CORRELATION))}}contains(we,...Z){return this.doContains(we,{includeChildren:!1},...Z)}affects(we,...Z){return this.doContains(we,{includeChildren:!0},...Z)}doContains(we,Z,...B){if(!we)return!1;const ee=B.length>0;return!!((!ee||B.includes(1))&&(this.added.value.get(we)||Z.includeChildren&&this.added.value.findSuperstr(we))||(!ee||B.includes(0))&&(this.updated.value.get(we)||Z.includeChildren&&this.updated.value.findSuperstr(we))||(!ee||B.includes(2))&&(this.deleted.value.findSubstr(we)||Z.includeChildren&&this.deleted.value.findSuperstr(we)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(we){return this.correlationId===we}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=z;function N(le,we,Z){return!le||!we||le===we||we.length>le.length?!1:(we.charAt(we.length-1)!==O.sep&&(we+=O.sep),Z?(0,L.startsWithIgnoreCase)(le,we):le.indexOf(we)===0)}class M extends Error{constructor(we,Z,B){super(we),this.fileOperationResult=Z,this.options=B}}e.FileOperationError=M;class W extends M{constructor(we,Z,B,ee){super(we,Z,ee),this.fileOperationResult=Z,this.size=B}}e.TooLargeFileOperationError=W;class X extends M{constructor(we,Z,B){super(we,2,B),this.stat=Z}}e.NotModifiedSinceFileOperationError=X;var te;(function(le){le[le.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",le[le.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",le[le.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",le[le.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",le[le.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",le[le.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",le[le.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",le[le.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",le[le.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",le[le.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",le[le.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(te||(e.FileOperationResult=te={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var H;(function(le){le[le.FILE=0]="FILE",le[le.FOLDER=1]="FOLDER",le[le.ROOT_FOLDER=2]="ROOT_FOLDER"})(H||(e.FileKind=H={})),e.ETAG_DISABLED="";function G(le){if(!(typeof le.size!="number"||typeof le.mtime!="number"))return le.mtime.toString(29)+le.size.toString(31)}async function Y(le,we){if(!we.hasProvider(R.URI.from({scheme:le.scheme})))return new Promise(Z=>{const B=we.onDidChangeFileSystemProviderRegistrations(ee=>{ee.scheme===le.scheme&&ee.added&&(B.dispose(),Z())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(we){return(0,A.isNumber)(we)||(we=0),we<ne.KB?(0,b.localize)(1,null,we.toFixed(0)):we<ne.MB?(0,b.localize)(2,null,(we/ne.KB).toFixed(2)):we<ne.GB?(0,b.localize)(3,null,(we/ne.MB).toFixed(2)):we<ne.TB?(0,b.localize)(4,null,(we/ne.GB).toFixed(2)):(0,b.localize)(5,null,(we/ne.TB).toFixed(2))}}e.ByteSize=ne;function pe(le){const we=typeof le=="string"||le?.scheme===T.Schemas.vscodeRemote;return typeof le!="string"&&le?.scheme===T.Schemas.file?1024*ne.MB:we?10*ne.MB:y.isWeb?50*ne.MB:1024*ne.MB}}),define(_e[257],Ce([1,0,21,13,216,33]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=R;async function R(T,I,p,S,E,d){let f;try{await b(T,I,p,S,E,d)}catch(a){f=a}finally{f&&E.errorTransformer&&(f=E.errorTransformer(f)),typeof f<"u"&&p.error(f),p.end()}}async function b(T,I,p,S,E,d){m(d);const f=await T.open(I,{create:!1});try{m(d);let a=0,i=0,n=E&&typeof E.length=="number"?E.length:void 0,l=h.VSBuffer.alloc(Math.min(E.bufferSize,typeof n=="number"?n:E.bufferSize)),o=E&&typeof E.position=="number"?E.position:0,t=0;do i=await T.read(f,o,l.buffer,t,l.byteLength-t),o+=i,t+=i,a+=i,typeof n=="number"&&(n-=i),t===l.byteLength&&(await p.write(S(l)),l=h.VSBuffer.alloc(Math.min(E.bufferSize,typeof n=="number"?n:E.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&m(d)&&y(a,E));if(t>0){let u=t;typeof n=="number"&&(u=Math.min(t,n)),p.write(S(l.slice(0,u)))}}catch(a){throw(0,A.ensureFileSystemProviderError)(a)}finally{await T.close(f)}}function m(T){if(T.isCancellationRequested)throw(0,O.canceled)();return!0}function y(T,I){if(typeof I?.limits?.size=="number"&&T>I.limits.size)throw(0,A.createFileSystemProviderError)((0,L.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(_e[65],Ce([1,0,35,3,17,12,2,33]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=m,e.isRecursiveWatchRequest=y,e.reviveFileChanges=S,e.coalesceEvents=E,e.normalizeWatcherPattern=d,e.parseWatcherPatterns=f,e.isFiltered=i,e.requestFilterToString=n;function m(l){return typeof l.correlationId=="number"}function y(l){return l.recursive===!0}class T extends O.Disposable{static{this.MAX_RESTARTS=5}constructor(o,t,u,r){super(),this.onFileChanges=o,this.onLogMessage=t,this.verboseLogging=u,this.options=r,this.watcherDisposables=this._register(new O.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const o=new O.DisposableStore;this.watcherDisposables.value=o,this.watcher=this.createWatcher(o),this.watcher.setVerboseLogging(this.verboseLogging),o.add(this.watcher.onDidChangeFile(t=>this.onFileChanges(t))),o.add(this.watcher.onDidLogMessage(t=>this.onLogMessage(t))),o.add(this.watcher.onDidError(t=>this.onError(t)))}onError(o){this.options.restartOnError?this.restartCounter<T.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${o}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${o}`):this.error(o)}restart(o){this.restartCounter++,this.init(),this.watch(o)}async watch(o){this.requests=o,await this.watcher?.watch(o)}async setVerboseLogging(o){this.verboseLogging=o,await this.watcher?.setVerboseLogging(o)}error(o){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${o}`})}trace(o){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${o}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=T;class I extends T{constructor(o,t,u){super(o,t,u,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class p extends T{constructor(o,t,u){super(o,t,u,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=p;function S(l){return l.map(o=>({type:o.type,resource:R.URI.revive(o.resource),cId:o.cId}))}function E(l){const o=new a;for(const t of l)o.processEvent(t);return o.coalesce()}function d(l,o){return typeof o=="string"&&!o.startsWith(h.GLOBSTAR)&&!(0,L.isAbsolute)(o)?{base:l,pattern:o}:o}function f(l,o){const t=[];for(const u of o)t.push((0,h.parse)(d(l,u)));return t}class a{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(o){return A.isLinux?o.resource.fsPath:o.resource.fsPath.toLowerCase()}processEvent(o){const t=this.mapPathToChange.get(this.toKey(o));let u=!1;if(t){const r=t.type,c=o.type;t.resource.fsPath!==o.resource.fsPath&&(o.type===2||o.type===1)?u=!0:r===1&&c===2?(this.mapPathToChange.delete(this.toKey(o)),this.coalesced.delete(t)):r===2&&c===1?t.type=0:r===1&&c===0||(t.type=c)}else u=!0;u&&(this.coalesced.add(o),this.mapPathToChange.set(this.toKey(o),o))}coalesce(){const o=[],t=[];return Array.from(this.coalesced).filter(u=>u.type!==2?(o.push(u),!1):!0).sort((u,r)=>u.resource.fsPath.length-r.resource.fsPath.length).filter(u=>t.some(r=>(0,b.isParent)(u.resource.fsPath,r,!A.isLinux))?!1:(t.push(u.resource.fsPath),!0)).concat(o)}}function i(l,o){if(typeof o=="number")switch(l.type){case 1:return(o&4)===0;case 2:return(o&8)===0;case 0:return(o&2)===0}return!1}function n(l){if(typeof l=="number"){const o=[];return l&4&&o.push("Added"),l&8&&o.push("Deleted"),l&2&&o.push("Updated"),o.length===0?"<all>":`[${o.join(", ")}]`}return"<none>"}}),define(_e[258],Ce([1,0,53,3,65,4,2,7]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class m extends O.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new A.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new A.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new O.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new b.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(T=>this.handleDidWatchFail(T)))}handleDidWatchFail(T){this.isCorrelated(T)&&this.suspendWatchRequest(T)}isCorrelated(T){return(0,L.isWatchRequestWithCorrelation)(T)}async watch(T){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new b.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const I of T)this.isCorrelated(I)?this.allCorrelatedWatchRequests.set(I.correlationId,I):this.allNonCorrelatedWatchRequests.add(I);for(const[I]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(I)||(this.suspendedWatchRequests.deleteAndDispose(I),this.suspendedWatchRequestsWithPolling.delete(I));return await this.updateWatchers()}finally{this.joinWatch.complete()}}updateWatchers(){return this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(T=>!this.suspendedWatchRequests.has(T.correlationId))])}isSuspended(T){return typeof T.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(T.correlationId)?"polling":this.suspendedWatchRequests.has(T.correlationId)}async suspendWatchRequest(T){if(this.suspendedWatchRequests.has(T.correlationId))return;const I=new O.DisposableStore;this.suspendedWatchRequests.set(T.correlationId,I),await this.joinWatch.p,!I.isDisposed&&(this.monitorSuspendedWatchRequest(T,I),this.updateWatchers())}resumeWatchRequest(T){this.suspendedWatchRequests.deleteAndDispose(T.correlationId),this.suspendedWatchRequestsWithPolling.delete(T.correlationId),this.updateWatchers()}monitorSuspendedWatchRequest(T,I){this.doMonitorWithExistingWatcher(T,I)?(this.trace(`reusing an existing recursive watcher to monitor ${T.path}`),this.suspendedWatchRequestsWithPolling.delete(T.correlationId)):(this.doMonitorWithNodeJS(T,I),this.suspendedWatchRequestsWithPolling.add(T.correlationId))}doMonitorWithExistingWatcher(T,I){const p=this.recursiveWatcher?.subscribe(T.path,(S,E)=>{I.isDisposed||(S?this.monitorSuspendedWatchRequest(T,I):E?.type===1&&this.onMonitoredPathAdded(T))});return p?(I.add(p),!0):!1}doMonitorWithNodeJS(T,I){let p=!1;const S=(E,d)=>{if(I.isDisposed)return;const f=this.isPathNotFound(E),a=this.isPathNotFound(d),i=p;p=f,!f&&(a||i)&&this.onMonitoredPathAdded(T)};this.trace(`starting fs.watchFile() on ${T.path} (correlationId: ${T.correlationId})`);try{(0,h.watchFile)(T.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},S)}catch(E){this.warn(`fs.watchFile() failed with error ${E} on path ${T.path} (correlationId: ${T.correlationId})`)}I.add((0,O.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${T.path} (correlationId: ${T.correlationId})`);try{(0,h.unwatchFile)(T.path,S)}catch(E){this.warn(`fs.unwatchFile() failed with error ${E} on path ${T.path} (correlationId: ${T.correlationId})`)}}))}onMonitoredPathAdded(T){this.trace(`detected ${T.path} exists again, resuming watcher (correlationId: ${T.correlationId})`);const I={resource:R.URI.file(T.path),type:1,cId:T.correlationId};this._onDidChangeFile.fire([I]),this.traceEvent(I,T),this.resumeWatchRequest(T)}isPathNotFound(T){return T.ctimeMs===0&&T.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(T,I){if(this.verboseLogging){const p=` >> normalized ${T.type===1?"[ADDED]":T.type===2?"[DELETED]":"[CHANGED]"} ${T.resource.fsPath}`;this.traceWithCorrelation(p,I)}}traceWithCorrelation(T,I){this.verboseLogging&&this.trace(`${T}${typeof I.correlationId=="number"?` <${I.correlationId}> `:""}`)}requestToString(T){return`${T.path} (excludes: ${T.excludes.length>0?T.excludes:"<none>"}, includes: ${T.includes&&T.includes.length>0?JSON.stringify(T.includes):"<all>"}, filter: ${(0,L.requestFilterToString)(T.filter)}, correlationId: ${typeof T.correlationId=="number"?T.correlationId:"<none>"})`}async setVerboseLogging(T){this.verboseLogging=T}}e.BaseWatcher=m}),define(_e[259],Ce([1,0,53,7,22,31,3,77,17,12,23,2,104,32,65]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=f;class d extends R.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}get isReusingRecursiveWatcher(){return this._isReusingRecursiveWatcher}get failed(){return this.didFail}constructor(i,n,l,o,t,u){super(),this.request=i,this.recursiveWatcher=n,this.onDidFilesChange=l,this.onDidWatchFail=o,this.onLogMessage=t,this.verboseLogging=u,this.throttledFileChangesEmitter=this._register(new O.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},r=>this.onDidFilesChange(r))),this.fileChangesAggregator=this._register(new O.RunOnceWorker(r=>this.handleFileChanges(r),d.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,E.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,E.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.filter=(0,E.isWatchRequestWithCorrelation)(this.request)?this.request.filter:void 0,this.cts=new L.CancellationTokenSource,this.ready=this.watch(),this._isReusingRecursiveWatcher=!1,this.didFail=!1}async watch(){try{const i=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const n=await S.Promises.stat(i);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.error(i):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${i})`),this.notifyWatchFailed()}}notifyWatchFailed(){this.didFail=!0,this.onDidWatchFail?.()}async normalizePath(i){let n=i.path;try{n=await S.Promises.realpath(i.path),i.path===n&&(n=await(0,p.realcase)(i.path,this.cts.token)??i.path),i.path!==n&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async doWatch(i,n){const l=new R.DisposableStore;return this.doWatchWithExistingWatcher(i,n,l)?(this.trace(`reusing an existing recursive watcher for ${this.request.path}`),this._isReusingRecursiveWatcher=!0):(this._isReusingRecursiveWatcher=!1,await this.doWatchWithNodeJS(i,n,l)),l}doWatchWithExistingWatcher(i,n,l){if(n)return!1;const o=I.URI.file(this.request.path),t=this.recursiveWatcher?.subscribe(this.request.path,async(u,r)=>{if(!l.isDisposed)if(u){const c=await this.doWatch(i,n);l.isDisposed?c.dispose():l.add(c)}else r&&(typeof r.cId=="number"||typeof this.request.correlationId=="number")&&this.onFileChange({resource:o,type:r.type,cId:this.request.correlationId},!0)});return t?(l.add(t),!0):!1}async doWatchWithNodeJS(i,n,l){if(y.isMacintosh&&(0,A.isEqualOrParent)(i,"/Volumes/",!0)){this.error(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const o=new L.CancellationTokenSource(this.cts.token);l.add((0,R.toDisposable)(()=>o.dispose(!0)));const t=new R.DisposableStore;l.add(t);try{const u=I.URI.file(this.request.path),r=(0,m.basename)(i),c=(0,h.watch)(i);t.add((0,R.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${i}'`);const s=new Set;if(n)try{for(const g of await S.Promises.readdir(i))s.add(g)}catch(g){this.error(g)}if(o.token.isCancellationRequested)return;const w=new Map;t.add((0,R.toDisposable)(()=>{for(const[,g]of w)g.dispose();w.clear()})),c.on("error",(g,D)=>{o.token.isCancellationRequested||(this.error(`Failed to watch ${i} for changes using fs.watch() (${g}, ${D})`),this.notifyWatchFailed())}),c.on("change",(g,D)=>{if(o.token.isCancellationRequested)return;this.verboseLogging&&this.traceWithCorrelation(`[raw] ["${g}"] ${D}`);let v="";if(D&&(v=D.toString(),y.isMacintosh&&(v=(0,b.normalizeNFC)(v))),!(!v||g!=="change"&&g!=="rename"))if(n)if(g==="rename"){w.get(v)?.dispose();const _=setTimeout(async()=>{if(w.delete(v),v===r&&!await S.Promises.exists(i)){this.onWatchedPathDeleted(u);return}if(o.token.isCancellationRequested)return;const C=await this.existsChildStrictCase((0,m.join)(i,v));if(o.token.isCancellationRequested)return;let P;C?s.has(v)?P=0:(P=1,s.add(v)):(s.delete(v),P=2),this.onFileChange({resource:(0,T.joinPath)(u,v),type:P,cId:this.request.correlationId})},d.FILE_DELETE_HANDLER_DELAY);w.set(v,(0,R.toDisposable)(()=>clearTimeout(_)))}else{let _;s.has(v)?_=0:(_=1,s.add(v)),this.onFileChange({resource:(0,T.joinPath)(u,v),type:_,cId:this.request.correlationId})}else if(g==="rename"||v!==r){const _=setTimeout(async()=>{const C=await S.Promises.exists(i);o.token.isCancellationRequested||(C?(this.onFileChange({resource:u,type:0,cId:this.request.correlationId},!0),t.add(await this.doWatch(i,!1))):this.onWatchedPathDeleted(u))},d.FILE_DELETE_HANDLER_DELAY);t.clear(),t.add((0,R.toDisposable)(()=>clearTimeout(_)))}else this.onFileChange({resource:u,type:0,cId:this.request.correlationId},!0)})}catch(u){o.token.isCancellationRequested||this.error(`Failed to watch ${i} for changes using fs.watch() (${u.toString()})`),this.notifyWatchFailed()}}onWatchedPathDeleted(i){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:i,type:2,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.notifyWatchFailed()}onFileChange(i,n=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.traceWithCorrelation(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.excludes.some(l=>l(i.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.includes&&this.includes.length>0&&!this.includes.some(l=>l(i.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${i.resource.fsPath}`):this.fileChangesAggregator.work(i))}handleFileChanges(i){const n=(0,E.coalesceEvents)(i),l=[];for(const t of n){if((0,E.isFiltered)(t,this.filter)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${t.resource.fsPath}`);continue}l.push(t)}if(l.length===0)return;if(this.verboseLogging)for(const t of l)this.traceWithCorrelation(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.throttledFileChangesEmitter.work(l)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async existsChildStrictCase(i){if(y.isLinux)return S.Promises.exists(i);try{const n=(0,m.basename)(i);return(await S.Promises.readdir((0,m.dirname)(i))).some(o=>o===n)}catch(n){return this.trace(n),!1}}setVerboseLogging(i){this.verboseLogging=i}error(i){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}warn(i){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}trace(i){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}traceWithCorrelation(i){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.trace(`${i}${typeof this.request.correlationId=="number"?` <${this.request.correlationId}> `:""}`)}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=d;async function f(a,i,n,l,o=512){const t=await S.Promises.open(a,"r"),u=Buffer.allocUnsafe(o),r=new L.CancellationTokenSource(l);let c,s=!1;const w={path:a,excludes:[],recursive:!1},g=new d(w,void 0,D=>{(async()=>{for(const{type:v}of D)if(v===0){if(s)return;s=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:_}=await S.Promises.read(t,u,0,o,null);if(!_||r.token.isCancellationRequested)break;i(u.slice(0,_))}}catch(_){c=new Error(_),r.dispose(!0)}finally{s=!1}}})()});return await g.ready,n(),new Promise((D,v)=>{r.token.onCancellationRequested(async()=>{g.dispose();try{await S.Promises.close(t)}catch(_){c=new Error(_)}c?v(c):D()})})}}),define(_e[260],Ce([1,0,4,35,258,12,259,31]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class m extends L.BaseWatcher{constructor(T){super(),this.recursiveWatcher=T,this.onDidError=h.Event.None,this.watchers=new Set}async doWatch(T){T=this.removeDuplicateRequests(T);const I=[],p=new Set(Array.from(this.watchers));for(const S of T){const E=this.findWatcher(S);E&&(0,O.patternsEquals)(E.request.excludes,S.excludes)&&(0,O.patternsEquals)(E.request.includes,S.includes)?p.delete(E):I.push(S)}I.length&&this.trace(`Request to start watching: ${I.map(S=>this.requestToString(S)).join(",")}`),p.size&&this.trace(`Request to stop watching: ${Array.from(p).map(S=>this.requestToString(S.request)).join(",")}`);for(const S of p)this.stopWatching(S);for(const S of I)this.startWatching(S)}findWatcher(T){for(const I of this.watchers)if(typeof T.correlationId=="number"||typeof I.request.correlationId=="number"){if(I.request.correlationId===T.correlationId)return I}else if((0,b.isEqual)(I.request.path,T.path,!A.isLinux))return I}startWatching(T){const I=new R.NodeJSFileWatcherLibrary(T,this.recursiveWatcher,S=>this._onDidChangeFile.fire(S),()=>this._onDidWatchFail.fire(T),S=>this._onDidLogMessage.fire(S),this.verboseLogging),p={request:T,instance:I};this.watchers.add(p)}async stop(){await super.stop();for(const T of this.watchers)this.stopWatching(T)}stopWatching(T){this.trace("stopping file watcher",T),this.watchers.delete(T),T.instance.dispose()}removeDuplicateRequests(T){const I=new Map;for(const p of T){const S=A.isLinux?p.path:p.path.toLowerCase();let E=I.get(p.correlationId);E||(E=new Map,I.set(p.correlationId,E)),E.has(S)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(p)}`),E.set(S,p)}return Array.from(I.values()).map(p=>Array.from(p.values())).flat()}async setVerboseLogging(T){super.setVerboseLogging(T);for(const I of this.watchers)I.instance.setVerboseLogging(T)}trace(T,I){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(T,I)})}warn(T){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(T)})}toMessage(T,I){return I?`[File Watcher (node.js)] ${T} (${this.requestToString(I.request)})`:`[File Watcher (node.js)] ${T}`}}e.NodeJSWatcher=m}),define(_e[261],Ce([1,0,65,260]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class L extends h.AbstractNonRecursiveWatcherClient{constructor(R,b,m){super(R,b,m),this.init()}createWatcher(R){return R.add(new O.NodeJSWatcher(void 0))}}e.NodeJSWatcherClient=L}),define(_e[262],Ce([1,0,15,82,199,65]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class R extends A.AbstractUniversalWatcherClient{constructor(m,y,T){super(m,y,T),this.init()}createWatcher(m){const y=m.add(new L.Client(h.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return m.add(y.onDidProcessExit(({code:T,signal:I})=>this.onError(`terminated by itself with code ${T}, signal: ${I} (ETERM)`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(y.getChannel("watcher")))}}e.UniversalWatcherClient=R}),define(_e[107],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class h{constructor(...L){this._entries=new Map;for(const[A,R]of L)this.set(A,R)}set(L,A){const R=this._entries.get(L);return this._entries.set(L,A),R}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=h}),define(_e[263],Ce([1,0,7,13,3,106,253,5,107,76]),function(ue,e,h,O,L,A,R,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const T=!1;class I extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class p{constructor(f=new m.ServiceCollection,a=!1,i,n=T){this._services=f,this._strict=a,this._parent=i,this._enableTracing=n,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(b.IInstantiationService,this),this._globalGraph=n?i?._globalGraph??new R.Graph(l=>l):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,L.dispose)(this._children),this._children.clear();for(const f of this._servicesToMaybeDispose)(0,L.isDisposable)(f)&&f.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(f){this._throwIfDisposed();const a=new class extends p{dispose(){this._children.delete(a),super.dispose()}}(f,this._strict,this,this._enableTracing);return this._children.add(a),a}invokeFunction(f,...a){this._throwIfDisposed();const i=E.traceInvocation(this._enableTracing,f);let n=!1;try{return f({get:o=>{if(n)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(o,i);if(!t)throw new Error(`[invokeFunction] unknown service '${o}'`);return t}},...a)}finally{n=!0,i.stop()}}createInstance(f,...a){this._throwIfDisposed();let i,n;return f instanceof A.SyncDescriptor?(i=E.traceCreation(this._enableTracing,f.ctor),n=this._createInstance(f.ctor,f.staticArguments.concat(a),i)):(i=E.traceCreation(this._enableTracing,f),n=this._createInstance(f,a,i)),i.stop(),n}_createInstance(f,a=[],i){const n=b._util.getServiceDependencies(f).sort((t,u)=>t.index-u.index),l=[];for(const t of n){const u=this._getOrCreateServiceInstance(t.id,i);u||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),l.push(u)}const o=n.length>0?n[0].index:a.length;if(a.length!==o){console.trace(`[createInstance] First service dependency of ${f.name} at position ${o+1} conflicts with ${a.length} static arguments`);const t=o-a.length;t>0?a=a.concat(new Array(t)):a=a.slice(0,o)}return Reflect.construct(f,a.concat(l))}_setCreatedServiceInstance(f,a){if(this._services.get(f)instanceof A.SyncDescriptor)this._services.set(f,a);else if(this._parent)this._parent._setCreatedServiceInstance(f,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){const a=this._services.get(f);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):a}_getOrCreateServiceInstance(f,a){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(f));const i=this._getServiceInstanceOrDescriptor(f);return i instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,i,a.branch(f,!0)):(a.branch(f,!1),i)}_safeCreateAndCacheServiceInstance(f,a,i){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,a,i)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,a,i){const n=new R.Graph(t=>t.id.toString());let l=0;const o=[{id:f,desc:a,_trace:i}];for(;o.length;){const t=o.pop();if(n.lookupOrInsertNode(t),l++>1e3)throw new I(n);for(const u of b._util.getServiceDependencies(t.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(u.id);if(r||this._throwIfStrict(`[createInstance] ${f} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(u.id)),r instanceof A.SyncDescriptor){const c={id:u.id,desc:r,_trace:t._trace.branch(u.id,!0)};n.insertEdge(t,c),o.push(c)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new I(n);break}for(const{data:u}of t){if(this._getServiceInstanceOrDescriptor(u.id)instanceof A.SyncDescriptor){const c=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setCreatedServiceInstance(u.id,c)}n.removeNode(u)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,a,i=[],n,l){if(this._services.get(f)instanceof A.SyncDescriptor)return this._createServiceInstance(f,a,i,n,l,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,a,i,n,l);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(f,a,i=[],n,l,o){if(n){const t=new p(void 0,this._strict,this,this._enableTracing);t._globalGraphImplicitDependency=String(f);const u=new Map,r=new h.GlobalIdleValue(()=>{const c=t._createInstance(a,i,l);for(const[s,w]of u){const g=c[s];if(typeof g=="function")for(const D of w)D.disposable=g.apply(c,D.listener)}return u.clear(),o.add(c),c});return new Proxy(Object.create(null),{get(c,s){if(!r.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let D=u.get(s);return D||(D=new y.LinkedList,u.set(s,D)),(_,C,P)=>{if(r.isInitialized)return r.value[s](_,C,P);{const k={listener:[_,C,P],disposable:void 0},F=D.push(k);return(0,L.toDisposable)(()=>{F(),k.disposable?.dispose()})}}}if(s in c)return c[s];const w=r.value;let g=w[s];return typeof g!="function"||(g=g.bind(w),c[s]=g),g},set(c,s,w){return r.value[s]=w,!0},getPrototypeOf(c){return a.prototype}})}else{const t=this._createInstance(a,i,l);return o.add(t),t}}_throwIfStrict(f,a){if(a&&console.warn(f),this._strict)throw new Error(f)}}e.InstantiationService=p;var S;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(S||(S={}));class E{static{this.all=new Set}static{this._None=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(f,a){return f?new E(2,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E._None}static traceCreation(f,a){return f?new E(1,a.name):E._None}static{this._totals=0}constructor(f,a){this.type=f,this.name=a,this._start=Date.now(),this._dep=[]}branch(f,a){const i=new E(3,f.toString());return this._dep.push([f,a,i]),i}stop(){const f=Date.now()-this._start;E._totals+=f;let a=!1;function i(l,o){const t=[],u=new Array(l+1).join("	");for(const[r,c,s]of o._dep)if(c&&s){a=!0,t.push(`${u}CREATES -> ${r}`);const w=i(l+1,s);w&&t.push(w)}else t.push(`${u}uses -> ${r}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(f>2||a)&&E.all.add(n.join(`
`))}}e.Trace=E}),define(_e[11],Ce([1,0,218,47,4,57,3,27,12,23,18,2,38,5]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=d,e.log=a,e.getLogLevel=g,e.LogLevelToString=D,e.LogLevelToLocalizedString=v,e.parseLogLevel=_,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function E(){return new Date().toISOString()}function d(C){return(0,T.isNumber)(C)}var f;(function(C){C[C.Off=0]="Off",C[C.Trace=1]="Trace",C[C.Debug=2]="Debug",C[C.Info=3]="Info",C[C.Warning=4]="Warning",C[C.Error=5]="Error"})(f||(e.LogLevel=f={})),e.DEFAULT_LOG_LEVEL=f.Info;function a(C,P,k){switch(P){case f.Trace:C.trace(k);break;case f.Debug:C.debug(k);break;case f.Info:C.info(k);break;case f.Warning:C.warn(k);break;case f.Error:C.error(k);break;case f.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function i(C,P=!1){let k="";for(let F=0;F<C.length;F++){let x=C[F];if(x instanceof Error&&(x=(0,O.toErrorMessage)(x,P)),typeof x=="object")try{x=JSON.stringify(x)}catch{}k+=(F>0?" ":"")+x}return k}class n extends R.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(P){this.level!==P&&(this.level=P,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(P){return this.level!==f.Off&&this.level<=P}}e.AbstractLogger=n;class l extends n{constructor(P){super(),this.logAlways=P}checkLogLevel(P){return this.logAlways||super.checkLogLevel(P)}trace(P,...k){this.checkLogLevel(f.Trace)&&this.log(f.Trace,i([P,...k],!0))}debug(P,...k){this.checkLogLevel(f.Debug)&&this.log(f.Debug,i([P,...k]))}info(P,...k){this.checkLogLevel(f.Info)&&this.log(f.Info,i([P,...k]))}warn(P,...k){this.checkLogLevel(f.Warning)&&this.log(f.Warning,i([P,...k]))}error(P,...k){if(this.checkLogLevel(f.Error))if(P instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=P.stack,this.log(f.Error,i(F))}else this.log(f.Error,i([P,...k]))}flush(){}}e.AbstractMessageLogger=l;class o extends n{constructor(P=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(P),this.useColors=!m.isWindows}trace(P,...k){this.checkLogLevel(f.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,P,...k):console.log(`[main ${E()}]`,P,...k))}debug(P,...k){this.checkLogLevel(f.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,P,...k):console.log(`[main ${E()}]`,P,...k))}info(P,...k){this.checkLogLevel(f.Info)&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,P,...k):console.log(`[main ${E()}]`,P,...k))}warn(P,...k){this.checkLogLevel(f.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,P,...k):console.warn(`[main ${E()}]`,P,...k))}error(P,...k){this.checkLogLevel(f.Error)&&(this.useColors?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,P,...k):console.error(`[main ${E()}]`,P,...k))}flush(){}}e.ConsoleMainLogger=o;class t extends n{constructor(P=e.DEFAULT_LOG_LEVEL,k=!0){super(),this.useColors=k,this.setLevel(P)}trace(P,...k){this.checkLogLevel(f.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",P,...k):console.log(P,...k))}debug(P,...k){this.checkLogLevel(f.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",P,...k):console.log(P,...k))}info(P,...k){this.checkLogLevel(f.Info)&&(this.useColors?console.log("%c INFO","color: #33f",P,...k):console.log(P,...k))}warn(P,...k){this.checkLogLevel(f.Warning)&&(this.useColors?console.log("%c WARN","color: #993",P,...k):console.log(P,...k))}error(P,...k){this.checkLogLevel(f.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",P,...k):console.error(P,...k))}flush(){}}e.ConsoleLogger=t;class u extends n{constructor(P,k=e.DEFAULT_LOG_LEVEL){super(),this.adapter=P,this.setLevel(k)}trace(P,...k){this.checkLogLevel(f.Trace)&&this.adapter.log(f.Trace,[this.extractMessage(P),...k])}debug(P,...k){this.checkLogLevel(f.Debug)&&this.adapter.log(f.Debug,[this.extractMessage(P),...k])}info(P,...k){this.checkLogLevel(f.Info)&&this.adapter.log(f.Info,[this.extractMessage(P),...k])}warn(P,...k){this.checkLogLevel(f.Warning)&&this.adapter.log(f.Warning,[this.extractMessage(P),...k])}error(P,...k){this.checkLogLevel(f.Error)&&this.adapter.log(f.Error,[this.extractMessage(P),...k])}extractMessage(P){return typeof P=="string"?P:(0,O.toErrorMessage)(P,this.checkLogLevel(f.Trace))}flush(){}}e.AdapterLogger=u;class r extends n{constructor(P){super(),this.loggers=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const k of this.loggers)k.setLevel(P);super.setLevel(P)}trace(P,...k){for(const F of this.loggers)F.trace(P,...k)}debug(P,...k){for(const F of this.loggers)F.debug(P,...k)}info(P,...k){for(const F of this.loggers)F.info(P,...k)}warn(P,...k){for(const F of this.loggers)F.warn(P,...k)}error(P,...k){for(const F of this.loggers)F.error(P,...k)}flush(){for(const P of this.loggers)P.flush()}dispose(){for(const P of this.loggers)P.dispose();super.dispose()}}e.MultiplexLogger=r;class c extends R.Disposable{constructor(P,k,F){if(super(),this.logLevel=P,this.logsHome=k,this._loggers=new b.ResourceMap,this._onDidChangeLoggers=this._register(new L.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new L.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,F)for(const x of F)this._loggers.set(x.resource,{logger:void 0,info:x})}getLoggerEntry(P){return(0,T.isString)(P)?[...this._loggers.values()].find(k=>k.info.id===P):this._loggers.get(P)}getLogger(P){return this.getLoggerEntry(P)?.logger}createLogger(P,k){const F=this.toResource(P),x=(0,T.isString)(P)?P:k?.id??(0,A.hash)(F.toString()).toString(16);let z=this._loggers.get(F)?.logger;const N=k?.logLevel==="always"?f.Trace:k?.logLevel;z||(z=this.doCreateLogger(F,N??this.getLogLevel(F)??this.logLevel,{...k,id:x}));const M={logger:z,info:{resource:F,id:x,logLevel:N,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(M.info),this._loggers.set(F,M),z}toResource(P){return(0,T.isString)(P)?(0,y.joinPath)(this.logsHome,`${P}.log`):P}setLogLevel(P,k){if(I.URI.isUri(P)){const F=P,x=k,z=this._loggers.get(F);z&&x!==z.info.logLevel&&(z.info.logLevel=x===this.logLevel?void 0:x,z.logger?.setLevel(x),this._loggers.set(z.info.resource,z),this._onDidChangeLogLevel.fire([F,x]))}else{this.logLevel=P;for(const[F,x]of this._loggers.entries())this._loggers.get(F)?.info.logLevel===void 0&&x.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(P,k){const F=this.getLoggerEntry(P);F&&k!==!F.info.hidden&&(F.info.hidden=!k,this._loggers.set(F.info.resource,F),this._onDidChangeVisibility.fire([F.info.resource,k]))}getLogLevel(P){let k;return P&&(k=this._loggers.get(P)?.info.logLevel),k??this.logLevel}registerLogger(P){const k=this._loggers.get(P.resource);k?k.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this._loggers.set(P.resource,{info:P,logger:void 0}),this._onDidChangeLoggers.fire({added:[P],removed:[]}))}deregisterLogger(P){const k=this._loggers.get(P);k&&(k.logger&&k.logger.dispose(),this._loggers.delete(P),this._onDidChangeLoggers.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const P of this._loggers.values())yield P.info}getRegisteredLogger(P){return this._loggers.get(P)?.info}dispose(){this._loggers.forEach(P=>P.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=c;class s{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(P){}getLevel(){return f.Info}trace(P,...k){}debug(P,...k){}info(P,...k){}warn(P,...k){}error(P,...k){}critical(P,...k){}dispose(){}flush(){}}e.NullLogger=s;class w extends s{}e.NullLogService=w;function g(C){if(C.verbose)return f.Trace;if(typeof C.logLevel=="string"){const P=_(C.logLevel.toLowerCase());if(P!==void 0)return P}return e.DEFAULT_LOG_LEVEL}function D(C){switch(C){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}function v(C){switch(C){case f.Trace:return{original:"Trace",value:h.localize(0,null)};case f.Debug:return{original:"Debug",value:h.localize(1,null)};case f.Info:return{original:"Info",value:h.localize(2,null)};case f.Warning:return{original:"Warning",value:h.localize(3,null)};case f.Error:return{original:"Error",value:h.localize(4,null)};case f.Off:return{original:"Off",value:h.localize(5,null)}}}function _(C){switch(C){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.CONTEXT_LOG_LEVEL=new p.RawContextKey("logLevel",D(f.Info))}),define(_e[264],Ce([1,0,19,7,13,4,31,3,17,65,11]),function(ue,e,h,O,L,A,R,b,m,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends b.Disposable{constructor(S,E){super(),this.logService=S,this.options=E,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalWatchRequests=[],this.universalWatchRequestDelayer=this._register(new O.ThrottledDelayer(0)),this.nonRecursiveWatchRequests=[],this.nonRecursiveWatchRequestDelayer=this._register(new O.ThrottledDelayer(0))}watch(S,E){return E.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,E):this.watchNonRecursive(S,E)}watchUniversal(S,E){const d={path:this.toWatchPath(S),excludes:E.excludes,includes:E.includes,recursive:E.recursive,filter:E.filter,correlationId:E.correlationId},f=(0,h.insert)(this.universalWatchRequests,d);return this.refreshUniversalWatchers(),(0,b.toDisposable)(()=>{f(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,L.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(E=>this._onDidChangeFile.fire((0,y.reviveFileChanges)(E)),E=>this.onWatcherLogMessage(E),this.logService.getLevel()===T.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===T.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const E of this.universalWatchRequests)(0,y.isRecursiveWatchRequest)(E)&&(E.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const E of this.universalWatchRequests)(0,y.isRecursiveWatchRequest)(E)&&S.includes(E.path)&&(E.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalWatchRequests)}watchNonRecursive(S,E){const d={path:this.toWatchPath(S),excludes:E.excludes,includes:E.includes,recursive:!1,filter:E.filter,correlationId:E.correlationId},f=(0,h.insert)(this.nonRecursiveWatchRequests,d);return this.refreshNonRecursiveWatchers(),(0,b.toDisposable)(()=>{f(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,L.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,y.reviveFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===T.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===T.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursiveWatchRequests)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logWatcherMessage(S)}logWatcherMessage(S){this.logService[S.type](S.message)}toFilePath(S){return(0,m.normalize)(S.fsPath)}toWatchPath(S){const E=this.toFilePath(S);return(0,R.removeTrailingPathSeparator)(E)}}e.AbstractDiskFileSystemProvider=I}),define(_e[265],Ce([1,0,53,402,7,27,21,4,31,3,17,12,23,98,32,217,33,257,264,47,262,261]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i,n,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(h)}catch(u){console.error(`Error enabling graceful-fs: ${(0,n.toErrorMessage)(u)}`)}})();class t extends i.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(r,c){super(r,c),this.onDidChangeCapabilities=b.Event.None,this.resourceLocks=new A.ResourceMap(s=>p.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:c,symbolicLink:s}=await E.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(c,s),ctime:c.birthtime.getTime(),mtime:c.mtime.getTime(),size:c.size,permissions:c.mode&128?void 0:f.FilePermission.Locked}}catch(c){throw this.toFileSystemProviderError(c)}}async statIgnoreError(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const c=await E.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),s=[];return await Promise.all(c.map(async w=>{try{let g;w.isSymbolicLink()?g=(await this.stat((0,p.joinPath)(r,w.name))).type:g=this.toType(w),s.push([w.name,g])}catch(g){this.logService.trace(g)}})),s}catch(c){throw this.toFileSystemProviderError(c)}}toType(r,c){let s;return c?.dangling?s=f.FileType.Unknown:r.isFile()?s=f.FileType.File:r.isDirectory()?s=f.FileType.Directory:s=f.FileType.Unknown,c&&(s|=f.FileType.SymbolicLink),s}async createResourceLock(r){const c=this.toFilePath(r);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${c})`);let s;for(;s=this.resourceLocks.get(r);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${c})`),await s.wait();const w=new L.Barrier;return this.resourceLocks.set(r,w),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${c})`),(0,y.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${c})`),this.resourceLocks.get(r)===w&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${c})`),this.resourceLocks.delete(r)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${c})`),w.open()})}async readFile(r,c){let s;try{c?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(r)})`),s=await this.createResourceLock(r));const w=this.toFilePath(r);return await E.Promises.readFile(w)}catch(w){throw this.toFileSystemProviderError(w)}finally{s?.dispose()}}traceLock(r){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(r)}readFileStream(r,c,s){const w=(0,S.newWriteableStream)(g=>R.VSBuffer.concat(g.map(D=>R.VSBuffer.wrap(D))).buffer);return(0,a.readFileIntoStream)(this,r,w,g=>g.buffer,{...c,bufferSize:256*1024},s),w}async writeFile(r,c,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.canWriteFileAtomic(r)?this.doWriteFileAtomic(r,(0,p.joinPath)((0,p.dirname)(r),`${(0,p.basename)(r)}${s.atomic.postfix}`),c,s):this.doWriteFile(r,c,s)}async canWriteFileAtomic(r){try{const c=this.toFilePath(r),{symbolicLink:s}=await E.SymlinkSupport.stat(c);if(s)return!1}catch{}return!0}async doWriteFileAtomic(r,c,s,w){const g=new y.DisposableStore;try{g.add(await this.createResourceLock(r)),g.add(await this.createResourceLock(c)),await this.doWriteFile(c,s,w,!0);try{await this.rename(c,r,{overwrite:!0})}catch(D){try{await this.delete(c,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{g.dispose()}}async doWriteFile(r,c,s,w){let g;try{const D=this.toFilePath(r);if(!s.create||!s.overwrite){if(await E.Promises.exists(D)){if(!s.overwrite)throw(0,f.createFileSystemProviderError)((0,d.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,f.createFileSystemProviderError)((0,d.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(r,{create:!0,unlock:s.unlock},w),await this.write(g,0,c,0,c.byteLength)}catch(D){throw await this.toFileSystemProviderWriteError(r,D)}finally{typeof g=="number"&&await this.close(g)}}static{this.canFlush=!0}static configureFlushOnWrite(r){t.canFlush=r}async open(r,c,s){const w=this.toFilePath(r);let g;(0,f.isFileOpenForWriteOptions)(c)&&!s&&(g=await this.createResourceLock(r));let D;try{if((0,f.isFileOpenForWriteOptions)(c)&&c.unlock)try{const{stat:_}=await E.SymlinkSupport.stat(w);_.mode&128||await E.Promises.chmod(w,_.mode|128)}catch(_){_.code!=="ENOENT"&&this.logService.trace(_)}let v;if((0,f.isFileOpenForWriteOptions)(c)){if(I.isWindows)try{await E.Promises.truncate(w,0),v="r+"}catch(_){_.code!=="ENOENT"&&this.logService.trace(_)}v||(v="w")}else v="r";D=await E.Promises.open(w,v)}catch(v){throw g?.dispose(),(0,f.isFileOpenForWriteOptions)(c)?await this.toFileSystemProviderWriteError(r,v):this.toFileSystemProviderError(v)}if(this.mapHandleToPos.set(D,0),(0,f.isFileOpenForWriteOptions)(c)&&this.writeHandles.set(D,r),g){const v=this.mapHandleToLock.get(D);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${w})`),this.mapHandleToLock.set(D,g),v&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${w})`),v.dispose())}return D}async close(r){const c=this.mapHandleToLock.get(r);try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&t.canFlush)try{await E.Promises.fdatasync(r)}catch(s){t.configureFlushOnWrite(!1),this.logService.error(s)}return await E.Promises.close(r)}catch(s){throw this.toFileSystemProviderError(s)}finally{c&&(this.mapHandleToLock.get(r)===c&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.mapHandleToLock.delete(r)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),c.dispose())}}async read(r,c,s,w,g){const D=this.normalizePos(r,c);let v=null;try{v=(await E.Promises.read(r,s,w,g,D)).bytesRead}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(r,D,v)}return v}normalizePos(r,c){return c===this.mapHandleToPos.get(r)?null:c}updatePos(r,c,s){const w=this.mapHandleToPos.get(r);typeof w=="number"&&(typeof c=="number"||(typeof s=="number"?this.mapHandleToPos.set(r,w+s):this.mapHandleToPos.delete(r)))}async write(r,c,s,w,g){return(0,L.retry)(()=>this.doWrite(r,c,s,w,g),100,3)}async doWrite(r,c,s,w,g){const D=this.normalizePos(r,c);let v=null;try{v=(await E.Promises.write(r,s,w,g,D)).bytesWritten}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),_)}finally{this.updatePos(r,D,v)}return v}async mkdir(r){try{await E.Promises.mkdir(this.toFilePath(r))}catch(c){throw this.toFileSystemProviderError(c)}}async delete(r,c){try{const s=this.toFilePath(r);if(c.recursive){let w;c?.atomic!==!1&&c.atomic.postfix&&(w=(0,T.join)((0,T.dirname)(s),`${(0,T.basename)(s)}${c.atomic.postfix}`)),await E.Promises.rm(s,E.RimRafMode.MOVE,w)}else try{await E.Promises.unlink(s)}catch(w){if(w.code==="EPERM"||w.code==="EISDIR"){let g=!1;try{const{stat:D,symbolicLink:v}=await E.SymlinkSupport.stat(s);g=D.isDirectory()&&!v}catch{}if(g)await E.Promises.rmdir(s);else throw w}else throw w}}catch(s){throw this.toFileSystemProviderError(s)}}async rename(r,c,s){const w=this.toFilePath(r),g=this.toFilePath(c);if(w!==g)try{await this.validateMoveCopy(r,c,"move",s.overwrite),await E.Promises.rename(w,g)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,d.localize)(2,null,(0,T.basename)(w),(0,T.basename)((0,T.dirname)(g)),D.toString()))),this.toFileSystemProviderError(D)}}async copy(r,c,s){const w=this.toFilePath(r),g=this.toFilePath(c);if(w!==g)try{await this.validateMoveCopy(r,c,"copy",s.overwrite),await E.Promises.copy(w,g,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,d.localize)(3,null,(0,T.basename)(w),(0,T.basename)((0,T.dirname)(g)),D.toString()))),this.toFileSystemProviderError(D)}}async validateMoveCopy(r,c,s,w){const g=this.toFilePath(r),D=this.toFilePath(c);let v=!1;if(!!(this.capabilities&1024)||(v=(0,m.isEqual)(g,D,!0)),v){if(s==="copy")throw(0,f.createFileSystemProviderError)((0,d.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const C=await this.statIgnoreError(r);if(!C)throw(0,f.createFileSystemProviderError)((0,d.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const P=await this.statIgnoreError(c);if(P){if(!w)throw(0,f.createFileSystemProviderError)((0,d.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);C.type&f.FileType.File&&P.type&f.FileType.File||await this.delete(c,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,c){return this.doCloneFile(r,c,!1)}async doCloneFile(r,c,s){const w=this.toFilePath(r),g=this.toFilePath(c),D=!!(this.capabilities&1024);if((0,m.isEqual)(w,g,!D))return;const v=new y.DisposableStore;try{v.add(await this.createResourceLock(r)),v.add(await this.createResourceLock(c)),s&&await E.Promises.mkdir((0,T.dirname)(g),{recursive:!0}),await E.Promises.copyFile(w,g)}catch(_){if(_.code==="ENOENT"&&!s)return this.doCloneFile(r,c,!0);throw this.toFileSystemProviderError(_)}finally{v.dispose()}}createUniversalWatcher(r,c,s){return new l.UniversalWatcherClient(w=>r(w),w=>c(w),s)}createNonRecursiveWatcher(r,c,s){return new o.NodeJSWatcherClient(w=>r(w),w=>c(w),s)}toFileSystemProviderError(r){if(r instanceof f.FileSystemProviderError)return r;let c=r,s;switch(r.code){case"ENOENT":s=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":c=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=f.FileSystemProviderErrorCode.Unknown;break;default:s=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(c,s)}async toFileSystemProviderWriteError(r,c){let s=this.toFileSystemProviderError(c);if(r&&s.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:w}=await E.SymlinkSupport.stat(this.toFilePath(r));w.mode&128||(s=(0,f.createFileSystemProviderError)(c,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(w){this.logService.trace(w)}return s}}e.DiskFileSystemProvider=t}),define(_e[266],Ce([1,0,3,11]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class L extends h.Disposable{constructor(R,b=[]){super(),this.logger=new O.MultiplexLogger([R,...b]),this._register(R.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(R){this.logger.setLevel(R)}getLevel(){return this.logger.getLevel()}trace(R,...b){this.logger.trace(R,...b)}debug(R,...b){this.logger.debug(R,...b)}info(R,...b){this.logger.info(R,...b)}warn(R,...b){this.logger.warn(R,...b)}error(R,...b){this.logger.error(R,...b)}flush(){this.logger.flush()}}e.LogService=L}),define(_e[267],Ce([1,0,33,11]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var L;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(L||(L={}));async function A(y,T,I,p,S){try{const E=await new Promise((f,a)=>{ue(["@vscode/spdlog"],f,a)});E.setFlushOn(L.Trace);const d=await E.createAsyncRotatingLogger(y,T,I,p);return S?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(E){console.error(E)}return null}function R(y,T,I){switch(T){case O.LogLevel.Trace:y.trace(I);break;case O.LogLevel.Debug:y.debug(I);break;case O.LogLevel.Info:y.info(I);break;case O.LogLevel.Warning:y.warn(I);break;case O.LogLevel.Error:y.error(I);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${T}`)}}function b(y,T){switch(T){case O.LogLevel.Trace:y.setLevel(L.Trace);break;case O.LogLevel.Debug:y.setLevel(L.Debug);break;case O.LogLevel.Info:y.setLevel(L.Info);break;case O.LogLevel.Warning:y.setLevel(L.Warning);break;case O.LogLevel.Error:y.setLevel(L.Error);break;case O.LogLevel.Off:y.setLevel(L.Off);break;default:throw new Error(`Invalid log level ${T}`)}}class m extends O.AbstractMessageLogger{constructor(T,I,p,S,E){super(),this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(T,I,p,S),this._register(this.onDidChangeLogLevel(d=>{this._logger&&b(this._logger,d)}))}async _createSpdLogLogger(T,I,p,S){const E=p?6:1,d=30/E*h.ByteSize.MB,f=await A(T,I,d,E,S);if(f){this._logger=f,b(this._logger,this.getLevel());for(const{level:a,message:i}of this.buffer)R(this._logger,a,i);this.buffer=[]}}log(T,I){this._logger?R(this._logger,T,I):this.getLevel()<=T&&this.buffer.push({level:T,message:I})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=m}),define(_e[139],Ce([1,0,41,219,5]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var R;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(m){function y(E,d){return d-E}m.compare=y;const T=Object.create(null);T[m.Error]=(0,O.localize)(0,null),T[m.Warning]=(0,O.localize)(1,null),T[m.Info]=(0,O.localize)(2,null);function I(E){return T[E]||""}m.toString=I;function p(E){switch(E){case h.default.Error:return m.Error;case h.default.Warning:return m.Warning;case h.default.Info:return m.Info;case h.default.Ignore:return m.Hint}}m.fromSeverity=p;function S(E){switch(E){case m.Error:return h.default.Error;case m.Warning:return h.default.Warning;case m.Info:return h.default.Info;case m.Hint:return h.default.Ignore}}m.toSeverity=S}(R||(e.MarkerSeverity=R={}));var b;(function(m){const y="";function T(p){return I(p,!0)}m.makeKey=T;function I(p,S){const E=[y];return p.source?E.push(p.source.replace("\xA6","\\\xA6")):E.push(y),p.code?typeof p.code=="string"?E.push(p.code.replace("\xA6","\\\xA6")):E.push(p.code.value.replace("\xA6","\\\xA6")):E.push(y),p.severity!==void 0&&p.severity!==null?E.push(R.toString(p.severity)):E.push(y),p.message&&S?E.push(p.message.replace("\xA6","\\\xA6")):E.push(y),p.startLineNumber!==void 0&&p.startLineNumber!==null?E.push(p.startLineNumber.toString()):E.push(y),p.startColumn!==void 0&&p.startColumn!==null?E.push(p.startColumn.toString()):E.push(y),p.endLineNumber!==void 0&&p.endLineNumber!==null?E.push(p.endLineNumber.toString()):E.push(y),p.endColumn!==void 0&&p.endColumn!==null?E.push(p.endColumn.toString()):E.push(y),E.push(y),E.join("\xA6")}m.makeKeyOptionalMessage=I})(b||(e.IMarkerData=b={})),e.IMarkerService=(0,L.createDecorator)("markerService")}),define(_e[268],Ce([1,0,4,41,5]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.isNotificationSource=b,e.Severity=O.default,e.INotificationService=(0,L.createDecorator)("notificationService");var A;(function(I){I[I.DEFAULT=0]="DEFAULT",I[I.SILENT=1]="SILENT",I[I.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var R;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function b(I){if(I){const p=I;return typeof p.id=="string"&&typeof p.label=="string"}return!1}var m;(function(I){I[I.OFF=0]="OFF",I[I.ERROR=1]="ERROR"})(m||(e.NotificationsFilter=m={}));class y{constructor(){this.progress=new T,this.onDidClose=h.Event.None,this.onDidChangeVisibility=h.Event.None}updateSeverity(p){}updateMessage(p){}updateActions(p){}close(){}}e.NoOpNotification=y;class T{infinite(){}done(){}total(p){}worked(p){}}e.NoOpProgress=T}),define(_e[269],Ce([1,0,52]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const A=L.context.configuration();if(A)O=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){O=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:A,searchUrl:R,itemUrl:b,controlUrl:m}=O.extensionsGallery||{};Object.assign(O,{extensionsGallery:{serviceUrl:h.env.VSCODE_GALLERY_SERVICE_URL||A,searchUrl:h.env.VSCODE_GALLERY_SEARCH_URL||R,itemUrl:h.env.VSCODE_GALLERY_ITEM_URL||b,controlUrl:h.env.VSCODE_GALLERY_CONTROL_URL||m}});try{const y=(...I)=>I.reduce((p,S)=>(Object.keys(S).forEach(E=>{Array.isArray(p[E])&&Array.isArray(S[E])?p[E]=S[E]:typeof p[E]=="object"&&typeof S[E]=="object"?p[E]=y(p[E],S[E]):p[E]=S[E]}),p),{}),T=globalThis._VSCODE_USER_PRODUCT_JSON||{};O=y(O,T)}catch{}if(h.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`,serverDataFolderName:O.serverDataFolderName?`${O.serverDataFolderName}-dev`:void 0}),!O.version){const y=globalThis._VSCODE_PACKAGE_JSON;Object.assign(O,{version:y.version,release:y.release})}}else O={},Object.keys(O).length===0&&Object.assign(O,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=O}),define(_e[108],Ce([1,0,5]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,h.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var Ue=this&&this.__param||function(ue,e){return function(h,O){e(h,O,ue)}};define(_e[109],Ce([1,0,7,22,3,5]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.AsyncProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var R;(function(I){I[I.Explorer=1]="Explorer",I[I.Scm=3]="Scm",I[I.Extensions=5]="Extensions",I[I.Window=10]="Window",I[I.Notification=15]="Notification",I[I.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(p){this.callback=p}report(p){this._value=p,this.callback(this._value)}}e.Progress=b;class m{get value(){return this._value}constructor(p){this.callback=p}report(p){this._asyncQueue?this._asyncQueue.push(p):this._asyncQueue=[p],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const p=this._asyncQueue.shift();this._value=p,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const p=this._drainListener;this._drainListener=void 0,p?.()}}drain(){return this._processingAsyncQueue?new Promise(p=>{const S=this._drainListener;this._drainListener=()=>{S?.(),p()}}):Promise.resolve()}}e.AsyncProgress=m;let y=class extends L.Disposable{constructor(p,S){super(),this.deferred=new h.DeferredPromise,S.withProgress(p,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,L.toDisposable)(()=>this.deferred.complete()))}report(p){this.reporter?this.reporter.report(p):this.lastStep=p}};e.UnmanagedProgress=y,e.UnmanagedProgress=y=Ge([Ue(1,e.IProgressService)],y);class T extends L.Disposable{constructor(p){super(),this.progressIndicator=p,this.currentOperationId=0,this.currentOperationDisposables=this._register(new L.DisposableStore)}start(p){this.stop();const S=++this.currentOperationId,E=new O.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{S===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},p),this.currentOperationDisposables.add((0,L.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,L.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,L.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:S,token:E.token,stop:()=>this.doStop(S),isCurrent:()=>this.currentOperationId===S}}stop(){this.doStop(this.currentOperationId)}doStop(p){this.currentOperationId===p&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(_e[36],Ce([1,0,62,18]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(R,b){h.ok(O.isString(R)),h.ok(O.isObject(b)),h.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,b)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new L}),define(_e[110],Ce([1,0,4,36]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class A{constructor(){this._onDidChangeSchema=new h.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(m,y){this.schemasById[L(m)]=y,this._onDidChangeSchema.fire(m)}notifySchemaChanged(m){this._onDidChangeSchema.fire(m)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new A;O.Registry.add(e.Extensions.JSONContribution,R)}),define(_e[66],Ce([1,0,19,4,18,208,55,110,36]),function(ue,e,h,O,L,A,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=d,e.keyFromOverrideIdentifiers=f,e.getDefaultValue=a,e.validateProperty=n,e.getScopes=l;var y;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=m.Registry.as(b.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,u=!0){this.registerConfigurations([t],u)}registerConfigurations(t,u=!0){const r=new Set;this.doRegisterConfigurations(t,u,r),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(t){const u=new Set;this.doDeregisterConfigurations(t,u),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:t,remove:u}){const r=new Set;this.doDeregisterConfigurations(u,r),this.doRegisterConfigurations(t,!1,r),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}registerDefaultConfigurations(t){const u=new Set;this.doRegisterDefaultConfigurations(t,u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,u){const r=[];for(const{overrides:c,source:s}of t)for(const w in c)if(u.add(w),e.OVERRIDE_PROPERTY_REGEX.test(w)){const g=this.configurationDefaultsOverrides.get(w),D=g?.valuesSources??new Map;if(s)for(const P of Object.keys(c[w]))D.set(P,s);const v={...g?.value||{},...c[w]};this.configurationDefaultsOverrides.set(w,{source:s,value:v,valuesSources:D});const _=(0,R.getLanguageTagSettingPlainKey)(w),C={type:"object",default:v,description:A.localize(1,null,_),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:v,source:L.isString(s)?void 0:s,defaultValueSource:s};r.push(...d(w)),this.configurationProperties[w]=C,this.defaultLanguageConfigurationOverridesNode.properties[w]=C}else{this.configurationDefaultsOverrides.set(w,{value:c[w],source:s});const g=this.configurationProperties[w];g&&(this.updatePropertyDefaultValue(w,g),this.updateSchema(w,g))}this.doRegisterOverrideIdentifiers(r)}deregisterDefaultConfigurations(t){const u=new Set;this.doDeregisterDefaultConfigurations(t,u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,u){for(const{overrides:r,source:c}of t)for(const s in r){const w=this.configurationDefaultsOverrides.get(s),g=L.isString(c)?c:c?.id,D=L.isString(w?.source)?w?.source:w?.source?.id;if(g===D)if(u.add(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const v=this.configurationProperties[s];v&&(this.updatePropertyDefaultValue(s,v),this.updateSchema(s,v))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let u=!1;const r=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,r),u=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,r),u=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,r),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:u})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const u of t)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,u,r){t.forEach(c=>{this.validateAndRegisterProperties(c,u,c.extensionInfo,c.restrictedProperties,void 0,r),this.configurationContributors.push(c),this.registerJSONConfiguration(c)})}doDeregisterConfigurations(t,u){const r=c=>{if(c.properties)for(const s in c.properties){u.add(s);const w=this.configurationProperties[s];w?.policy?.name&&this.policyConfigurations.delete(w.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,c.properties[s])}c.allOf?.forEach(s=>r(s))};for(const c of t){r(c);const s=this.configurationContributors.indexOf(c);s!==-1&&this.configurationContributors.splice(s,1)}}validateAndRegisterProperties(t,u=!0,r,c,s=3,w){s=L.isUndefinedOrNull(t.scope)?s:t.scope;const g=t.properties;if(g)for(const v in g){const _=g[v];if(u&&n(v,_)){delete g[v];continue}if(_.source=r,_.defaultDefaultValue=g[v].default,this.updatePropertyDefaultValue(v,_),e.OVERRIDE_PROPERTY_REGEX.test(v)?_.scope=void 0:(_.scope=L.isUndefinedOrNull(_.scope)?s:_.scope,_.restricted=L.isUndefinedOrNull(_.restricted)?!!c?.includes(v):_.restricted),g[v].hasOwnProperty("included")&&!g[v].included){this.excludedConfigurationProperties[v]=g[v],delete g[v];continue}else this.configurationProperties[v]=g[v],g[v].policy?.name&&this.policyConfigurations.set(g[v].policy.name,v);!g[v].deprecationMessage&&g[v].markdownDeprecationMessage&&(g[v].deprecationMessage=g[v].markdownDeprecationMessage),w.add(v)}const D=t.allOf;if(D)for(const v of D)this.validateAndRegisterProperties(v,u,r,c,s,w)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const u=r=>{const c=r.properties;if(c)for(const w in c)this.updateSchema(w,c[w]);r.allOf?.forEach(u)};u(t)}updateSchema(t,u){switch(e.allSettings.properties[t]=u,u.scope){case 1:e.applicationSettings.properties[t]=u;break;case 2:e.machineSettings.properties[t]=u;break;case 6:e.machineOverridableSettings.properties[t]=u;break;case 3:e.windowSettings.properties[t]=u;break;case 4:e.resourceSettings.properties[t]=u;break;case 5:e.resourceSettings.properties[t]=u,this.resourceLanguageSettingsSchema.properties[t]=u;break}}removeFromSchema(t,u){switch(delete e.allSettings.properties[t],u.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const u=`[${t}]`,r={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,r),e.allSettings.properties[u]=r,e.applicationSettings.properties[u]=r,e.machineSettings.properties[u]=r,e.machineOverridableSettings.properties[u]=r,e.windowSettings.properties[u]=r,e.resourceSettings.properties[u]=r}}registerOverridePropertyPatternKey(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,u){const r=this.configurationDefaultsOverrides.get(t);let c=r?.value,s=r?.source;L.isUndefined(c)&&(c=u.defaultDefaultValue,s=void 0),L.isUndefined(c)&&(c=a(u.type)),u.default=c,u.defaultValueSource=s}}const S="\\[([^\\]]+)\\]",E=new RegExp(S,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${S})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(o){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(o)){let u=E.exec(o);for(;u?.length;){const r=u[1].trim();r&&t.push(r),u=E.exec(o)}}return(0,h.distinct)(t)}function f(o){return o.reduce((t,u)=>`${t}[${u}]`,"")}function a(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const i=new p;m.Registry.add(e.Extensions.Configuration,i);function n(o,t){return o.trim()?e.OVERRIDE_PROPERTY_REGEX.test(o)?A.localize(7,null,o):i.getConfigurationProperties()[o]!==void 0?A.localize(8,null,o):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,o,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}function l(){const o=[],t=i.getConfigurationProperties();for(const u of Object.keys(t))o.push([u,t[u].scope]);return o.push(["launch",4]),o.push(["task",4]),o}}),define(_e[270],Ce([1,0,19,4,166,3,27,24,18,2,55,66,36]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=n;function S(u){return Object.isFrozen(u)?u:b.deepFreeze(u)}class E{static createEmptyModel(r){return new E({},[],[],void 0,r)}constructor(r,c,s,w,g){this._contents=r,this._keys=c,this._overrides=s,this.raw=w,this.logService=g,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(c=>{if(c instanceof E)return c;const s=new d("",this.logService);return s.parseRaw(c),s.configurationModel});this._rawConfiguration=r.reduce((c,s)=>s===c?s:c.merge(s),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,T.getConfigurationValue)(this.contents,r):this.contents}inspect(r,c){const s=this;return{get value(){return S(s.rawConfiguration.getValue(r))},get override(){return c?S(s.rawConfiguration.getOverrideValue(r,c)):void 0},get merged(){return S(c?s.rawConfiguration.override(c).getValue(r):s.rawConfiguration.getValue(r))},get overrides(){const w=[];for(const{contents:g,identifiers:D,keys:v}of s.rawConfiguration.overrides){const _=new E(g,v,[],void 0,s.logService).getValue(r);_!==void 0&&w.push({identifiers:D,value:_})}return w.length?S(w):void 0}}}getOverrideValue(r,c){const s=this.getContentsForOverrideIdentifer(c);return s?r?(0,T.getConfigurationValue)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const c=[];for(const s of this.overrides)s.identifiers.includes(r)&&c.push(...s.keys);return h.distinct(c)}getAllOverrideIdentifiers(){const r=[];for(const c of this.overrides)r.push(...c.identifiers);return h.distinct(r)}override(r){let c=this.overrideConfigurations.get(r);return c||(c=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,c)),c}merge(...r){const c=b.deepClone(this.contents),s=b.deepClone(this.overrides),w=[...this.keys],g=this.raw?.length?[...this.raw]:[this];for(const D of r)if(g.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.mergeContents(c,D.contents);for(const v of D.overrides){const[_]=s.filter(C=>h.equals(C.identifiers,v.identifiers));_?(this.mergeContents(_.contents,v.contents),_.keys.push(...v.keys),_.keys=h.distinct(_.keys)):s.push(b.deepClone(v))}for(const v of D.keys)w.indexOf(v)===-1&&w.push(v)}return new E(c,w,s,g.every(D=>D instanceof E)?void 0:g,this.logService)}createOverrideConfigurationModel(r){const c=this.getContentsForOverrideIdentifer(r);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const s={};for(const w of h.distinct([...Object.keys(this.contents),...Object.keys(c)])){let g=this.contents[w];const D=c[w];D&&(typeof g=="object"&&typeof D=="object"?(g=b.deepClone(g),this.mergeContents(g,D)):g=D),s[w]=g}return new E(s,this.keys,this.overrides,void 0,this.logService)}mergeContents(r,c){for(const s of Object.keys(c)){if(s in r&&m.isObject(r[s])&&m.isObject(c[s])){this.mergeContents(r[s],c[s]);continue}r[s]=b.deepClone(c[s])}}getContentsForOverrideIdentifer(r){let c=null,s=null;const w=g=>{g&&(s?this.mergeContents(s,g):s=b.deepClone(g))};for(const g of this.overrides)g.identifiers.length===1&&g.identifiers[0]===r?c=g.contents:g.identifiers.includes(r)&&w(g.contents);return w(c),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,c){this.updateValue(r,c,!0)}setValue(r,c){this.updateValue(r,c,!1)}removeValue(r){const c=this.keys.indexOf(r);c!==-1&&(this.keys.splice(c,1),(0,T.removeFromValueTree)(this.contents,r),I.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(s=>h.equals(s.identifiers,(0,I.overrideIdentifiersFromKey)(r))),1))}updateValue(r,c,s){(0,T.addToValueTree)(this.contents,r,c,w=>this.logService.error(w)),s=s||this.keys.indexOf(r)===-1,s&&this.keys.push(r),I.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,I.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,T.toValuesTree)(this.contents[r],w=>this.logService.error(w))})}}e.ConfigurationModel=E;class d{constructor(r,c){this._name=r,this.logService=c,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||E.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,c){if(!m.isUndefinedOrNull(r)){const s=this.doParseContent(r);this.parseRaw(s,c)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,c){this._raw=r;const{contents:s,keys:w,overrides:g,restricted:D,hasExcludedProperties:v}=this.doParseRaw(r,c);this._configurationModel=new E(s,w,g,v?[r]:void 0,this.logService),this._restrictedConfigurations=D||[]}doParseContent(r){let c={},s=null,w=[];const g=[],D=[];function v(C){Array.isArray(w)?w.push(C):s!==null&&(w[s]=C)}const _={onObjectBegin:()=>{const C={};v(C),g.push(w),w=C,s=null},onObjectProperty:C=>{s=C},onObjectEnd:()=>{w=g.pop()},onArrayBegin:()=>{const C=[];v(C),g.push(w),w=C,s=null},onArrayEnd:()=>{w=g.pop()},onLiteralValue:v,onError:(C,P,k)=>{D.push({error:C,offset:P,length:k})}};if(r)try{L.visit(r,_),c=w[0]||{}}catch(C){this.logService.error(`Error while parsing settings file ${this._name}: ${C}`),this._parseErrors=[C]}return c}doParseRaw(r,c){const s=p.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),w=this.filter(r,s,!0,c);r=w.raw;const g=(0,T.toValuesTree)(r,_=>this.logService.error(`Conflict in settings file ${this._name}: ${_}`)),D=Object.keys(r),v=this.toOverrides(r,_=>this.logService.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:g,keys:D,overrides:v,restricted:w.restricted,hasExcludedProperties:w.hasExcludedProperties}}filter(r,c,s,w){let g=!1;if(!w?.scopes&&!w?.skipRestricted&&!w?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:g};const D={},v=[];for(const _ in r)if(I.OVERRIDE_PROPERTY_REGEX.test(_)&&s){const C=this.filter(r[_],c,!1,w);D[_]=C.raw,g=g||C.hasExcludedProperties,v.push(...C.restricted)}else{const C=c[_],P=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&v.push(_),!w.exclude?.includes(_)&&(w.include?.includes(_)||(P===void 0||w.scopes===void 0||w.scopes.includes(P))&&!(w.skipRestricted&&C?.restricted))?D[_]=r[_]:g=!0}return{raw:D,restricted:v,hasExcludedProperties:g}}toOverrides(r,c){const s=[];for(const w of Object.keys(r))if(I.OVERRIDE_PROPERTY_REGEX.test(w)){const g={};for(const D in r[w])g[D]=r[w][D];s.push({identifiers:(0,I.overrideIdentifiersFromKey)(w),keys:Object.keys(g),contents:(0,T.toValuesTree)(g,c)})}return s}}e.ConfigurationModelParser=d;class f extends A.Disposable{constructor(r,c,s,w,g){super(),this.userSettingsResource=r,this.parseOptions=c,this.fileService=w,this.logService=g,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString(),g),this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(O.Event.any(O.Event.filter(this.fileService.onDidFilesChange,D=>D.contains(this.userSettingsResource)),O.Event.filter(this.fileService.onDidRunOperation,D=>(D.isOperation(0)||D.isOperation(3)||D.isOperation(1)||D.isOperation(4))&&s.isEqual(D.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return E.createEmptyModel(this.logService)}}reparse(r){return r&&(this.parseOptions=r),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class a{constructor(r,c,s,w,g,D,v,_,C,P,k,F,x){this.key=r,this.overrides=c,this._value=s,this.overrideIdentifiers=w,this.defaultConfiguration=g,this.policyConfiguration=D,this.applicationConfiguration=v,this.userConfiguration=_,this.localUserConfiguration=C,this.remoteUserConfiguration=P,this.workspaceConfiguration=k,this.folderConfigurationModel=F,this.memoryConfigurationModel=x}get value(){return S(this._value)}toInspectValue(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class i{constructor(r,c,s,w,g,D,v,_,C,P){this._defaultConfiguration=r,this._policyConfiguration=c,this._applicationConfiguration=s,this._localUserConfiguration=w,this._remoteUserConfiguration=g,this._workspaceConfiguration=D,this._folderConfigurations=v,this._memoryConfiguration=_,this._memoryConfigurationByResource=C,this.logService=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(r,c,s){return this.getConsolidatedConfigurationModel(r,c,s).getValue(r)}updateValue(r,c,s={}){let w;s.resource?(w=this._memoryConfigurationByResource.get(s.resource),w||(w=E.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(s.resource,w))):w=this._memoryConfiguration,c===void 0?w.removeValue(r):w.setValue(r,c),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,c,s){const w=this.getConsolidatedConfigurationModel(r,c,s),g=this.getFolderConfigurationModelForResource(c.resource,s),D=c.resource?this._memoryConfigurationByResource.get(c.resource)||this._memoryConfiguration:this._memoryConfiguration,v=new Set;for(const _ of w.overrides)for(const C of _.identifiers)w.getOverrideValue(r,C)!==void 0&&v.add(C);return new a(r,c,w.getValue(r),v.size?[...v]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this._workspaceConfiguration:void 0,g||void 0,D)}keys(r){const c=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,c){this._folderConfigurations.set(r,c),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,c){const s=[];if(!c){const{added:w,updated:g,removed:D}=o(this._defaultConfiguration,r);c=[...w,...g,...D]}for(const w of c)for(const g of(0,I.overrideIdentifiersFromKey)(w)){const D=this._defaultConfiguration.getKeysForOverrideIdentifier(g),v=r.getKeysForOverrideIdentifier(g),_=[...v.filter(C=>D.indexOf(C)===-1),...D.filter(C=>v.indexOf(C)===-1),...D.filter(C=>!b.equals(this._defaultConfiguration.override(g).getValue(C),r.override(g).getValue(C)))];s.push([g,_])}return this.updateDefaultConfiguration(r),{keys:c,overrides:s}}compareAndUpdatePolicyConfiguration(r){const{added:c,updated:s,removed:w}=o(this._policyConfiguration,r),g=[...c,...s,...w];return g.length&&this.updatePolicyConfiguration(r),{keys:g,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:c,updated:s,removed:w,overrides:g}=o(this.applicationConfiguration,r),D=[...c,...s,...w];return D.length&&this.updateApplicationConfiguration(r),{keys:D,overrides:g}}compareAndUpdateLocalUserConfiguration(r){const{added:c,updated:s,removed:w,overrides:g}=o(this.localUserConfiguration,r),D=[...c,...s,...w];return D.length&&this.updateLocalUserConfiguration(r),{keys:D,overrides:g}}compareAndUpdateRemoteUserConfiguration(r){const{added:c,updated:s,removed:w,overrides:g}=o(this.remoteUserConfiguration,r),D=[...c,...s,...w];return D.length&&this.updateRemoteUserConfiguration(r),{keys:D,overrides:g}}compareAndUpdateWorkspaceConfiguration(r){const{added:c,updated:s,removed:w,overrides:g}=o(this.workspaceConfiguration,r),D=[...c,...s,...w];return D.length&&this.updateWorkspaceConfiguration(r),{keys:D,overrides:g}}compareAndUpdateFolderConfiguration(r,c){const s=this.folderConfigurations.get(r),{added:w,updated:g,removed:D,overrides:v}=o(s,c),_=[...w,...g,...D];return(_.length||!s)&&this.updateFolderConfiguration(r,c),{keys:_,overrides:v}}compareAndDeleteFolderConfiguration(r){const c=this.folderConfigurations.get(r);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:w,removed:g,overrides:D}=o(c,void 0);return{keys:[...s,...w,...g],overrides:D}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,c,s){let w=this.getConsolidatedConfigurationModelForResource(c,s);return c.overrideIdentifier&&(w=w.override(c.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(w=w.merge(this._policyConfiguration)),w}getConsolidatedConfigurationModelForResource({resource:r},c){let s=this.getWorkspaceConsolidatedConfiguration();if(c&&r){const w=c.getFolder(r);w&&(s=this.getFolderConsolidatedConfiguration(w.uri)||s);const g=this._memoryConfigurationByResource.get(r);g&&(s=s.merge(g))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let c=this._foldersConsolidatedConfigurations.get(r);if(!c){const s=this.getWorkspaceConsolidatedConfiguration(),w=this._folderConfigurations.get(r);w?(c=s.merge(w),this._foldersConsolidatedConfigurations.set(r,c)):c=s}return c}getFolderConfigurationModelForResource(r,c){if(c&&r){const s=c.getFolder(r);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,c)=>{const{contents:s,overrides:w,keys:g}=this._folderConfigurations.get(c);return r.push([c,{contents:s,overrides:w,keys:g}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.keys.forEach(c=>r.add(c)),this.userConfiguration.keys.forEach(c=>r.add(c)),this._workspaceConfiguration.keys.forEach(c=>r.add(c)),this._folderConfigurations.forEach(c=>c.keys.forEach(s=>r.add(s))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this._folderConfigurations.forEach(c=>c.getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const c=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>c.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>c.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>c.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(w=>c.add(w))),[...c.values()]}static parse(r,c){const s=this.parseConfigurationModel(r.defaults,c),w=this.parseConfigurationModel(r.policy,c),g=this.parseConfigurationModel(r.application,c),D=this.parseConfigurationModel(r.user,c),v=this.parseConfigurationModel(r.workspace,c),_=r.folders.reduce((C,P)=>(C.set(y.URI.revive(P[0]),this.parseConfigurationModel(P[1],c)),C),new R.ResourceMap);return new i(s,w,g,D,E.createEmptyModel(c),v,_,E.createEmptyModel(c),new R.ResourceMap,c)}static parseConfigurationModel(r,c){return new E(r.contents,r.keys,r.overrides,void 0,c)}}e.Configuration=i;function n(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const r=new Set,c=new Map;for(const w of u)w.keys.forEach(g=>r.add(g)),w.overrides.forEach(([g,D])=>{const v=(0,R.getOrSet)(c,g,new Set);D.forEach(_=>v.add(_))});const s=[];return c.forEach((w,g)=>s.push([g,[...w.values()]])),{keys:[...r.values()],overrides:s}}class l{constructor(r,c,s,w,g){this.change=r,this.previous=c,this.currentConfiguraiton=s,this.currentWorkspace=w,this.logService=g,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const D of r.keys)this.affectedKeys.add(D);for(const[,D]of r.overrides)for(const v of D)this.affectedKeys.add(v);this._affectsConfigStr=this._marker;for(const D of this.affectedKeys)this._affectsConfigStr+=D+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=i.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(r,c){const s=this._marker+r,w=this._affectsConfigStr.indexOf(s);if(w<0)return!1;const g=w+s.length;if(g>=this._affectsConfigStr.length)return!1;const D=this._affectsConfigStr.charCodeAt(g);if(D!==this._markerCode1&&D!==this._markerCode2)return!1;if(c){const v=this.previousConfiguration?this.previousConfiguration.getValue(r,c,this.previous?.workspace):void 0,_=this.currentConfiguraiton.getValue(r,c,this.currentWorkspace);return!b.equals(v,_)}return!0}}e.ConfigurationChangeEvent=l;function o(u,r){const{added:c,removed:s,updated:w}=t(r?.rawConfiguration,u?.rawConfiguration),g=[],D=u?.getAllOverrideIdentifiers()||[],v=r?.getAllOverrideIdentifiers()||[];if(r){const _=v.filter(C=>!D.includes(C));for(const C of _)g.push([C,r.getKeysForOverrideIdentifier(C)])}if(u){const _=D.filter(C=>!v.includes(C));for(const C of _)g.push([C,u.getKeysForOverrideIdentifier(C)])}if(r&&u){for(const _ of D)if(v.includes(_)){const C=t({contents:u.getOverrideValue(void 0,_)||{},keys:u.getKeysForOverrideIdentifier(_)},{contents:r.getOverrideValue(void 0,_)||{},keys:r.getKeysForOverrideIdentifier(_)});g.push([_,[...C.added,...C.removed,...C.updated]])}}return{added:c,removed:s,updated:w,overrides:g}}function t(u,r){const c=u?r?u.keys.filter(g=>r.keys.indexOf(g)===-1):[...u.keys]:[],s=r?u?r.keys.filter(g=>u.keys.indexOf(g)===-1):[...r.keys]:[],w=[];if(u&&r){for(const g of r.keys)if(u.keys.indexOf(g)!==-1){const D=(0,T.getConfigurationValue)(r.contents,g),v=(0,T.getConfigurationValue)(u.contents,g);b.equals(D,v)||w.push(g)}}return{added:c,removed:s,updated:w}}}),define(_e[271],Ce([1,0,21,4,3,83]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0,e.connectManagedSocket=b;const R=(y,T,I)=>{const p=new Uint8Array(16);for(let d=0;d<16;d++)p[d]=Math.round(Math.random()*256);const S=(0,h.encodeBase64)(h.VSBuffer.wrap(p));return[`GET ws://localhost${y}?${T}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=R,e.socketRawEndHeaderSequence=h.VSBuffer.fromString(`\r
\r
`);async function b(y,T,I,p,S){y.write(h.VSBuffer.fromString((0,e.makeRawSocketHeaders)(T,I,p)));const E=new L.DisposableStore;try{return await new Promise((d,f)=>{let a;E.add(y.onData(i=>{a?a=h.VSBuffer.concat([a,i],a.byteLength+i.byteLength):a=i;const n=a.indexOf(e.socketRawEndHeaderSequence);if(n===-1)return;d(y),y.pauseData();const l=a.slice(n+e.socketRawEndHeaderSequence.byteLength);l.byteLength&&S.onData.fire(l)})),E.add(y.onClose(i=>f(i??new Error("socket closed")))),E.add(y.onEnd(()=>f(new Error("socket ended"))))})}catch(d){throw y.dispose(),d}finally{E.dispose()}}class m extends L.Disposable{constructor(T,I){super(),this.debugLabel=T,this.pausableDataEmitter=this._register(new O.PauseableEmitter),this.onData=(...p)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...p)),this.didDisposeEmitter=this._register(new O.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(I.onData),this._register(I.onData.event(p=>this.pausableDataEmitter.fire(p))),this.onClose=this._register(I.onClose).event,this.onEnd=this._register(I.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(T,I){A.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,T,I)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=m}),define(_e[67],Ce([1,0,13,5]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=y,e.IRemoteAuthorityResolverService=(0,O.createDecorator)("remoteAuthorityResolverService");var L;(function(T){T[T.WebSocket=0]="WebSocket",T[T.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class A{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=A;class R{constructor(I,p){this.host=I,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=R;var b;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound",T.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class m extends h.ErrorNoTelemetry{static isNotAvailable(I){return I instanceof m&&I._code===b.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof m&&I._code===b.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof m&&I._code===b.NoResolverFound}static isInvalidAuthority(I){return I instanceof m&&I._code===b.InvalidAuthority}static isHandled(I){return I instanceof m&&I.isHandled}constructor(I,p=b.Unknown,S){super(I),this._message=I,this._code=p,this._detail=S,this.isHandled=p===b.NotAvailable&&S===!0,Object.setPrototypeOf(this,m.prototype)}}e.RemoteAuthorityResolverError=m;function y(T){const I=T.indexOf("+");return I===-1?T:T.substring(0,I)}}),define(_e[272],Ce([1,0,7,21,22,13,4,3,15,59,40,30,83,67]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.connectRemoteAgentManagement=D,e.connectRemoteAgentExtensionHost=v,e.connectRemoteAgentTunnel=C;const E=30*1e3;var d;(function(Z){Z[Z.Management=1]="Management",Z[Z.ExtensionHost=2]="ExtensionHost",Z[Z.Tunnel=3]="Tunnel"})(d||(e.ConnectionType=d={}));function f(Z){switch(Z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function a(Z){const B=new L.CancellationTokenSource;return setTimeout(()=>B.cancel(),Z),B.token}function i(Z,B){if(Z.isCancellationRequested||B.isCancellationRequested)return L.CancellationToken.Cancelled;const ee=new L.CancellationTokenSource;return Z.onCancellationRequested(()=>ee.cancel()),B.onCancellationRequested(()=>ee.cancel()),ee.token}class n{get didTimeout(){return this._state==="timedout"}constructor(B){this._state="pending",this._disposables=new b.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,h.promiseWithResolvers)(),B.isCancellationRequested?this._timeout():this._disposables.add(B.onCancellationRequested(()=>this._timeout()))}registerDisposable(B){this._state==="pending"?this._disposables.add(B):B.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(B))}reject(B){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(B))}}function l(Z,B){const ee=new n(B);return ee.registerDisposable(Z.onControlMessage(ve=>{const Pe=JSON.parse(ve.toString()),oe=G(Pe);oe?ee.reject(oe):ee.resolve(Pe)})),ee.promise}function o(Z,B,ee,ve,Pe,oe,se,re){const j=new n(re),ie=T.StopWatch.create(!1);return Z.info(`Creating a socket (${se})...`),y.mark(`code/willCreateSocket/${oe}`),B.connect(ee,ve,Pe,se).then(me=>{j.didTimeout?(y.mark(`code/didCreateSocketError/${oe}`),Z.info(`Creating a socket (${se}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),me?.dispose()):(y.mark(`code/didCreateSocketOK/${oe}`),Z.info(`Creating a socket (${se}) was successful after ${ie.elapsed()} ms.`),j.resolve(me))},me=>{y.mark(`code/didCreateSocketError/${oe}`),Z.info(`Creating a socket (${se}) returned an error after ${ie.elapsed()} ms.`),Z.error(me),j.reject(me)}),j.promise}function t(Z,B){const ee=new n(B);return Z.then(ve=>{ee.didTimeout||ee.resolve(ve)},ve=>{ee.didTimeout||ee.reject(ve)}),ee.promise}async function u(Z,B,ee,ve){const Pe=le(Z,B);Z.logService.trace(`${Pe} 1/6. invoking socketFactory.connect().`);let oe;try{oe=await o(Z.logService,Z.remoteSocketFactoryService,Z.connectTo,m.RemoteAuthorities.getServerRootPath(),`reconnectionToken=${Z.reconnectionToken}&reconnection=${Z.reconnectionProtocol?"true":"false"}`,f(B),`renderer-${f(B)}-${Z.reconnectionToken}`,ve)}catch(me){throw Z.logService.error(`${Pe} socketFactory.connect() failed or timed out. Error:`),Z.logService.error(me),me}Z.logService.trace(`${Pe} 2/6. socketFactory.connect() was successful.`);let se,re;Z.reconnectionProtocol?(Z.reconnectionProtocol.beginAcceptReconnection(oe,null),se=Z.reconnectionProtocol,re=!1):(se=new p.PersistentProtocol({socket:oe}),re=!0),Z.logService.trace(`${Pe} 3/6. sending AuthRequest control message.`);const j=await t(Z.signService.createNewMessage((0,I.generateUuid)()),ve),ie={type:"auth",auth:Z.connectionToken||"00000000000000000000",data:j.data};se.sendControl(O.VSBuffer.fromString(JSON.stringify(ie)));try{const me=await l(se,i(ve,a(1e4)));if(me.type!=="sign"||typeof me.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(Z.logService.trace(`${Pe} 4/6. received SignRequest control message.`),!await t(Z.signService.validate(j,me.signedData),ve)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const Ae=await t(Z.signService.sign(me.data),ve),fe={type:"connectionType",commit:Z.commit,signedData:Ae,desiredConnectionType:B};return ee&&(fe.args=ee),Z.logService.trace(`${Pe} 5/6. sending ConnectionTypeRequest control message.`),se.sendControl(O.VSBuffer.fromString(JSON.stringify(fe))),{protocol:se,ownsProtocol:re}}catch(me){throw me&&me.code==="ETIMEDOUT"&&(Z.logService.error(`${Pe} the handshake timed out. Error:`),Z.logService.error(me)),me&&me.code==="VSCODE_CONNECTION_ERROR"&&(Z.logService.error(`${Pe} received error control message when negotiating connection. Error:`),Z.logService.error(me)),re&&H(se),me}}async function r(Z,B,ee,ve){const Pe=Date.now(),oe=le(Z,B),{protocol:se,ownsProtocol:re}=await u(Z,B,ee,ve),j=new n(ve);return j.registerDisposable(se.onControlMessage(ie=>{const me=JSON.parse(ie.toString()),be=G(me);be?(Z.logService.error(`${oe} received error control message when negotiating connection. Error:`),Z.logService.error(be),re&&H(se),j.reject(be)):(Z.reconnectionProtocol?.endAcceptReconnection(),Z.logService.trace(`${oe} 6/6. handshake finished, connection is up and running after ${we(Pe)}!`),j.resolve({protocol:se,firstMessage:me}))})),j.promise}async function c(Z,B){const{protocol:ee}=await r(Z,1,void 0,B);return{protocol:ee}}async function s(Z,B,ee){const{protocol:ve,firstMessage:Pe}=await r(Z,2,B,ee),oe=Pe&&Pe.debugPort;return{protocol:ve,debugPort:oe}}async function w(Z,B,ee){const ve=Date.now(),Pe=le(Z,3),{protocol:oe}=await u(Z,3,B,ee);return Z.logService.trace(`${Pe} 6/6. handshake finished, connection is up and running after ${we(ve)}!`),oe}async function g(Z,B,ee){const{connectTo:ve,connectionToken:Pe}=await Z.addressProvider.getAddress();return{commit:Z.commit,quality:Z.quality,connectTo:ve,connectionToken:Pe,reconnectionToken:B,reconnectionProtocol:ee,remoteSocketFactoryService:Z.remoteSocketFactoryService,signService:Z.signService,logService:Z.logService}}async function D(Z,B,ee){return _(Z,async ve=>{const{protocol:Pe}=await c(ve,L.CancellationToken.None);return new X(Z,B,ee,ve.reconnectionToken,Pe)})}async function v(Z,B){return _(Z,async ee=>{const{protocol:ve,debugPort:Pe}=await s(ee,B,L.CancellationToken.None);return new te(Z,B,ee.reconnectionToken,ve,Pe)})}async function _(Z,B){for(let ve=1;;ve++)try{const Pe=(0,I.generateUuid)(),oe=await g(Z,Pe,null);return await B(oe)}catch(Pe){if(ve<5)Z.logService.error(`[remote-connection][attempt ${ve}] An error occurred in initial connection! Will retry... Error:`),Z.logService.error(Pe);else throw Z.logService.error(`[remote-connection][attempt ${ve}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),Z.logService.error(Pe),W.triggerPermanentFailure(0,0,S.RemoteAuthorityResolverError.isHandled(Pe)),Pe}}async function C(Z,B,ee){const ve=await g(Z,(0,I.generateUuid)(),null);return await w(ve,{host:B,port:ee},L.CancellationToken.None)}function P(Z){return(0,h.createCancelablePromise)(B=>new Promise((ee,ve)=>{const Pe=setTimeout(ee,Z*1e3);B.onCancellationRequested(()=>{clearTimeout(Pe),ee()})}))}var k;(function(Z){Z[Z.ConnectionLost=0]="ConnectionLost",Z[Z.ReconnectionWait=1]="ReconnectionWait",Z[Z.ReconnectionRunning=2]="ReconnectionRunning",Z[Z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",Z[Z.ConnectionGain=4]="ConnectionGain"})(k||(e.PersistentConnectionEventType=k={}));class F{constructor(B,ee){this.reconnectionToken=B,this.millisSinceLastIncomingData=ee,this.type=0}}e.ConnectionLostEvent=F;class x{constructor(B,ee,ve,Pe){this.reconnectionToken=B,this.millisSinceLastIncomingData=ee,this.durationSeconds=ve,this.cancellableTimer=Pe,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=x;class z{constructor(B,ee,ve){this.reconnectionToken=B,this.millisSinceLastIncomingData=ee,this.attempt=ve,this.type=2}}e.ReconnectionRunningEvent=z;class N{constructor(B,ee,ve){this.reconnectionToken=B,this.millisSinceLastIncomingData=ee,this.attempt=ve,this.type=4}}e.ConnectionGainEvent=N;class M{constructor(B,ee,ve,Pe){this.reconnectionToken=B,this.millisSinceLastIncomingData=ee,this.attempt=ve,this.handled=Pe,this.type=3}}e.ReconnectionPermanentFailureEvent=M;class W extends b.Disposable{static triggerPermanentFailure(B,ee,ve){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=B,this._permanentFailureAttempt=ee,this._permanentFailureHandled=ve,this._instances.forEach(Pe=>Pe._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(B=>B._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(B=>B._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||W._permanentFailure}constructor(B,ee,ve,Pe,oe){super(),this._connectionType=B,this._options=ee,this.reconnectionToken=ve,this.protocol=Pe,this._reconnectionFailureIsFatal=oe,this._onDidStateChange=this._register(new R.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(Pe.onSocketClose(se=>{const re=pe(this._connectionType,this.reconnectionToken,!0);se?se.type===0?(this._options.logService.info(`${re} received socket close event (hadError: ${se.hadError}).`),se.error&&this._options.logService.error(se.error)):(this._options.logService.info(`${re} received socket close event (wasClean: ${se.wasClean}, code: ${se.code}, reason: ${se.reason}).`),se.event&&this._options.logService.error(se.event)):this._options.logService.info(`${re} received socket close event.`),this._beginReconnecting()})),this._register(Pe.onSocketTimeout(se=>{const re=pe(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${se.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${se.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${se.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),W._instances.push(this),this._register((0,b.toDisposable)(()=>{const se=W._instances.indexOf(this);se>=0&&W._instances.splice(se,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(W._permanentFailureMillisSinceLastIncomingData,W._permanentFailureAttempt,W._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const B=pe(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ee=[0,5,5,10,10,10,10,10,30];let ve=-1;do{ve++;const Pe=ve<ee.length?ee[ve]:ee[ee.length-1];try{if(Pe>0){const se=P(Pe);this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Pe,se)),this._options.logService.info(`${B} waiting for ${Pe} seconds before reconnecting...`);try{await se}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ve+1)),this._options.logService.info(`${B} resolving connection...`);const oe=await g(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${B} connecting to ${oe.connectTo}...`),await this._reconnect(oe,a(E)),this._options.logService.info(`${B} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ve+1));break}catch(oe){if(oe.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(oe),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),ve+1,!1);break}if(ve>360){this._options.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(oe),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),ve+1,!1);break}if(S.RemoteAuthorityResolverError.isTemporarilyNotAvailable(oe)){this._options.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(oe);continue}if((oe.code==="ETIMEDOUT"||oe.code==="ENETUNREACH"||oe.code==="ECONNREFUSED"||oe.code==="ECONNRESET")&&oe.syscall==="connect"){this._options.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(oe);continue}if((0,A.isCancellationError)(oe)){this._options.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(oe);continue}if(oe instanceof S.RemoteAuthorityResolverError){this._options.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(oe),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),ve+1,S.RemoteAuthorityResolverError.isHandled(oe));break}this._options.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(oe),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),ve+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(B,ee,ve){this._reconnectionFailureIsFatal?W.triggerPermanentFailure(B,ee,ve):this._gotoPermanentFailure(B,ee,ve)}_gotoPermanentFailure(B,ee,ve){this._onDidStateChange.fire(new M(this.reconnectionToken,B,ee,ve)),H(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=W;class X extends W{constructor(B,ee,ve,Pe,oe){super(1,B,Pe,oe,!0),this.client=this._register(new p.Client(oe,{remoteAuthority:ee,clientId:ve},B.ipcLogger))}async _reconnect(B,ee){await c(B,ee)}}e.ManagementPersistentConnection=X;class te extends W{constructor(B,ee,ve,Pe,oe){super(2,B,ve,Pe,!1),this._startArguments=ee,this.debugPort=oe}async _reconnect(B,ee){await s(B,this._startArguments,ee)}}e.ExtensionHostPersistentConnection=te;function H(Z){try{Z.acceptDisconnect();const B=Z.getSocket();Z.dispose(),B.dispose()}catch(B){(0,A.onUnexpectedError)(B)}}function G(Z){if(Z&&Z.type==="error"){const B=new Error(`Connection error: ${Z.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function Y(Z,B){for(;Z.length<B;)Z+=" ";return Z}function ne(Z,B){return`[remote-connection][${Y(f(Z),13)}][${B.substr(0,5)}\u2026]`}function pe(Z,B,ee){return`${ne(Z,B)}[${ee?"reconnect":"initial"}]`}function le(Z,B){return`${pe(B,Z.reconnectionToken,!!Z.reconnectionProtocol)}[${Z.connectTo}]`}function we(Z){return`${Date.now()-Z} ms`}}),define(_e[86],Ce([1,0,15]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=O,e.getRemoteName=L,e.parseAuthorityWithPort=A,e.parseAuthorityWithOptionalPort=R;function O(m){return m.scheme===h.Schemas.vscodeRemote?m.authority:void 0}function L(m){if(!m)return;const y=m.indexOf("+");return y<0?m:m.substr(0,y)}function A(m){const{host:y,port:T}=b(m);if(typeof T>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:y,port:T}}function R(m,y){let{host:T,port:I}=b(m);return typeof I>"u"&&(I=y),{host:T,port:I}}function b(m){const y=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const T=m.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const I=m.match(/(.*):(\d+)$/);return I?{host:I[1],port:parseInt(I[2],10)}:{host:m,port:void 0}}}),define(_e[25],Ce([1,0,14,5,86]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=A,e.isApplicationScopedExtension=I,e.isLanguagePackExtension=p,e.isAuthenticationProviderExtension=S,e.isResolverExtension=E,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(R||(e.ExtensionType=R={}));var b;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.LINUX_PPC64LE="linux-ppc64le",d.LINUX_RISCV64="linux-riscv64",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class m{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,a){if(typeof f>"u"||f===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof f=="string"||typeof a=="string"){const i=typeof f=="string"?f:f.value,n=typeof a=="string"?a:a.value;return h.equalsIgnoreCase(i,n)}return f._lower===a._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.ExtensionIdentifier=m;class y{get size(){return this._set.size}constructor(f){if(this._set=new Set,f)for(const a of f)this.add(a)}add(f){this._set.add(m.toKey(f))}delete(f){return this._set.delete(m.toKey(f))}has(f){return this._set.has(m.toKey(f))}}e.ExtensionIdentifierSet=y;class T{constructor(){this._map=new Map}clear(){this._map.clear()}delete(f){this._map.delete(m.toKey(f))}get(f){return this._map.get(m.toKey(f))}has(f){return this._map.has(m.toKey(f))}set(f,a){this._map.set(m.toKey(f),a)}values(){return this._map.values()}forEach(f){this._map.forEach(f)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=T;function I(d){return p(d)}function p(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}function S(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}function E(d,f){if(f){const a=`onResolveRemoteAuthority:${(0,L.getRemoteName)(f)}`;return!!d.activationEvents?.includes(a)}return!1}e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(_e[140],Ce([1,0,13,25]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class L{constructor(){this._generators=new Map,this._cache=new WeakMap}register(R,b){this._generators.set(R,b)}readActivationEvents(R){return this._cache.has(R)||this._cache.set(R,this._readActivationEvents(R)),this._cache.get(R)}createActivationEventsMap(R){const b=Object.create(null);for(const m of R){const y=this.readActivationEvents(m);y.length>0&&(b[O.ExtensionIdentifier.toKey(m.identifier)]=y)}return b}_readActivationEvents(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const b=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let m=0;m<b.length;m++)b[m]==="onUri"&&(b[m]=`onUri:${O.ExtensionIdentifier.toKey(R.identifier)}`);if(!R.contributes)return b;for(const m in R.contributes){const y=this._generators.get(m);if(!y)continue;const T=R.contributes[m],I=Array.isArray(T)?T:[T];try{y(I,b)}catch(p){(0,h.onUnexpectedError)(p)}}return b}}e.ImplicitActivationEventsImpl=L,e.ImplicitActivationEvents=new L}),define(_e[273],Ce([1,0,3,5]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,O.createDecorator)("remoteSocketFactoryService");class L{constructor(){this.factories={}}register(R,b){return this.factories[R]??=[],this.factories[R].push(b),(0,h.toDisposable)(()=>{const m=this.factories[R]?.indexOf(b);typeof m=="number"&&m>=0&&this.factories[R]?.splice(m,1)})}getSocketFactory(R){return(this.factories[R.type]||[]).find(m=>m.supports(R))}connect(R,b,m,y){const T=this.getSocketFactory(R);if(!T)throw new Error(`No socket factory found for ${R}`);return T.connect(R,b,m,y)}}e.RemoteSocketFactoryService=L}),define(_e[274],Ce([1,0,21,13,3,220,66,5,11,36]),function(ue,e,h,O,L,A,R,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=p,e.hasNoContent=S,e.asText=E,e.asTextOrError=d,e.asJson=f,e.updateProxyConfigurationsScope=a,e.IRequestService=(0,b.createDecorator)("requestService");class T{constructor(o){this.original=o}toJSON(){if(!this.headers){const o=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?o[t]="*****":o[t]=this.original[t];this.headers=o}return this.headers}}class I extends L.Disposable{constructor(o){super(),this.counter=0,this.logger=o.createLogger("network",{name:(0,A.localize)(0,null),when:m.CONTEXT_LOG_LEVEL.isEqualTo((0,m.LogLevelToString)(m.LogLevel.Trace)).serialize()})}async logAndRequest(o,t,u){const r=`${o} #${++this.counter}: ${t.url}`;this.logger.trace(`${r} - begin`,t.type,new T(t.headers??{}));try{const c=await u();return this.logger.trace(`${r} - end`,t.type,c.res.statusCode,c.res.headers),c}catch(c){throw this.logger.error(`${r} - error`,t.type,(0,O.getErrorMessage)(c)),c}}}e.AbstractRequestService=I;function p(l){return l.res.statusCode&&l.res.statusCode>=200&&l.res.statusCode<300||l.res.statusCode===1223}function S(l){return l.res.statusCode===204}async function E(l){return S(l)?null:(await(0,h.streamToBuffer)(l.stream)).toString()}async function d(l){if(!p(l))throw new Error("Server returned "+l.res.statusCode);return E(l)}async function f(l){if(!p(l))throw new Error("Server returned "+l.res.statusCode);if(S(l))return null;const t=(await(0,h.streamToBuffer)(l.stream)).toString();try{return JSON.parse(t)}catch(u){throw u.message+=`:
`+t,u}}function a(l){n(l)}let i;function n(l){const o=y.Registry.as(R.Extensions.Configuration),t=i;i={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:l,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},o.updateConfigurations({add:[i],remove:t?[t]:[]})}n(1)}),define(_e[275],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class h{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(L){try{const A=await this.getValidator();if(A){const R=String(h._nextId++);return this.validators.set(R,A),{id:R,data:A.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,A){if(!L.id)return!0;const R=this.validators.get(L.id);if(!R)return!1;this.validators.delete(L.id);try{return R.validate(A)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(L){try{return await this.signValue(L)}catch{}return L}}e.AbstractSignService=h}),define(_e[111],Ce([1,0,5]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,h.createDecorator)(e.SIGN_SERVICE_ID)}),define(_e[141],Ce([1,0,275]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class O extends h.AbstractSignService{getValidator(){return this.vsda().then(A=>new A.validator)}signValue(A){return this.vsda().then(R=>new R.signer().sign(A))}vsda(){return new Promise((A,R)=>ue(["vsda"],A,R))}}e.SignService=O}),define(_e[276],Ce([1,0,12,52,30]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=R,e.verifyMicrosoftInternalDomain=b;function A(m){if(h.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}function R(m,y,T,I,p,S,E,d,f){const a=Object.create(null);a["common.machineId"]=S,a["common.sqmId"]=E,a.sessionID=(0,L.generateUuid)()+Date.now(),a.commitHash=I,a.version=p,a["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,h.PlatformToString)(h.platform),a["common.nodePlatform"]=O.platform,a["common.nodeArch"]=T,a["common.product"]=f||"desktop",d&&(a["common.msftInternal"]=d);let i=0;const n=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),h.isLinuxSnap&&(a["common.snap"]="true");const l=A(y);return l&&(a["common.platformDetail"]=l),a}function b(m){const y=O.env.USERDNSDOMAIN;if(!y)return!1;const T=y.toLowerCase();return m.some(I=>T===I)}}),define(_e[277],Ce([1,0,5]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,h.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,h.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var L;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(_e[87],Ce([1,0,24,18,86,276,277]),function(ue,e,h,O,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=T,e.isLoggingOnly=I,e.getTelemetryLevel=p,e.validateTelemetryData=S,e.cleanRemoteAuthority=d,e.isInternalTelemetry=a,e.getPiiPathsFromEnvironment=i,e.cleanData=o;class b{constructor(u){this.value=u,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=b;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=m,e.NullTelemetryService=new m;class y{async publicLog(u,r,c){}async publicLogError(u,r,c){}}e.NullEndpointTelemetryService=y,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function T(t,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!t.enableTelemetry)}function I(t,u){return u.extensionTestsLocationURI?!0:!(u.isBuilt||u.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function p(t){const u=t.getValue(R.TELEMETRY_SETTING_ID),r=t.getValue(R.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(R.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function S(t){const u={},r={},c={};f(t,c);for(let s in c){s=s.length>150?s.substr(s.length-149):s;const w=c[s];typeof w=="number"?r[s]=w:typeof w=="boolean"?r[s]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${w.length}`),u[s]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(u[s]=w)}return{properties:u,measurements:r}}const E=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(t){if(!t)return"none";const u=(0,L.getRemoteName)(t);return E.has(u)?u:"other"}function f(t,u,r=0,c){if(t)for(const s of Object.getOwnPropertyNames(t)){const w=t[s],g=c?c+s:s;Array.isArray(w)?u[g]=(0,h.safeStringify)(w):w instanceof Date?u[g]=w.toISOString():(0,O.isObject)(w)?r<2?f(w,u,r+1,g+"."):u[g]=(0,h.safeStringify)(w):u[g]=w}}function a(t,u){const r=t.msftInternalDomains||[],c=u.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(r)||c}function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function n(t,u){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const c=[];for(const D of u)for(;;){const v=D.exec(t);if(!v)break;c.push([v.index,D.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(r="";;){const D=w.exec(t);if(!D)break;const v=c.some(([_,C])=>D.index<C&&_<w.lastIndex);!s.test(D[0])&&!v&&(r+=t.substring(g,D.index)+"<REDACTED: user-file-path>",g=w.lastIndex)}return g<t.length&&(r+=t.substr(g)),r}function l(t){if(!t)return t;const u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of u)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function o(t,u){return(0,h.cloneAndChange)(t,r=>{if(r instanceof b||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let c=r.replaceAll("%20"," ");c=n(c,u);for(const s of u)c=c.replace(s,"");return c=l(c),c}})}}),define(_e[278],Ce([1,0,14,138,25,12,2,13,52,87]),function(ue,e,h,O,L,A,R,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=T,e.getIdAndVersion=E,e.getExtensionId=d,e.adoptToGalleryExtensionId=f,e.getGalleryExtensionId=a,e.groupByExtension=i,e.getLocalExtensionTelemetryData=n,e.getGalleryExtensionTelemetryData=l,e.getExtensionDependencies=o,e.computeTargetPlatform=u;function T(r,c){return r.uuid&&c.uuid?r.uuid===c.uuid:r.id===c.id?!0:(0,h.compareIgnoreCase)(r.id,c.id)===0}const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(c){const s=c.manifest?c.manifest.version:c.version,w=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new p(c.identifier,s,w)}static parse(c){const s=I.exec(c);return s&&s[1]&&s[2]?new p({id:s[1]},s[2],s[4]||void 0):null}constructor(c,s,w="undefined"){this.version=s,this.targetPlatform=w,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof p?T(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.ExtensionKey=p;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(r){const c=S.exec(r);return c&&c[1]?[f(c[1]),c[2]]:[f(r),void 0]}function d(r,c){return`${r}.${c}`}function f(r){return r.toLowerCase()}function a(r,c){return f(d(r??L.UNDEFINED_PUBLISHER,c))}function i(r,c){const s=[],w=g=>{for(const D of s)if(D.some(v=>T(c(v),c(g))))return D;return null};for(const g of r){const D=w(g);D?D.push(g):s.push([g])}return s}function n(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function l(r){return{id:new y.TelemetryTrustedValue(r.identifier.id),name:new y.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function o(r,c){const s=[],w=c.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const g=w.shift();if(g&&s.every(D=>!T(D.identifier,{id:g}))){const D=r.filter(v=>T(v.identifier,{id:g}));D.length===1&&(s.push(D[0]),w.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function t(r,c){if(!A.isLinux)return!1;let s;try{s=(await r.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(g){c.debug("Error while getting the os-release file.",(0,b.getErrorMessage)(g))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(r,c){const s=await t(r,c),w=(0,O.getTargetPlatform)(s?"alpine":A.platform,m.arch);return c.debug("ComputeTargetPlatform:",w),w}}),define(_e[279],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=h,e.serializeEnvironmentDescriptionMap=O,e.deserializeEnvironmentVariableCollection=L,e.deserializeEnvironmentDescriptionMap=A,e.serializeEnvironmentVariableCollections=R,e.deserializeEnvironmentVariableCollections=b;function h(m){return[...m.entries()]}function O(m){return m?[...m.entries()]:[]}function L(m){return new Map(m)}function A(m){return new Map(m??[])}function R(m){return Array.from(m.entries()).map(y=>[y[0],h(y[1].map),O(y[1].descriptionMap)])}function b(m){return new Map(m.map(y=>[y[0],{map:L(y[1]),descriptionMap:A(y[2])}]))}}),define(_e[280],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class h{constructor(L){this._callback=L,this._terminalBufferMap=new Map}dispose(){for(const L of this._terminalBufferMap.values())L.dispose()}startBuffering(L,A,R=5){const b=A(m=>{const y=typeof m=="string"?m:m.data;let T=this._terminalBufferMap.get(L);if(T){T.data.push(y);return}const I=setTimeout(()=>this.flushBuffer(L),R);T={data:[y],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(L),b.dispose()}},this._terminalBufferMap.set(L,T)});return b}stopBuffering(L){this._terminalBufferMap.get(L)?.dispose()}flushBuffer(L){const A=this._terminalBufferMap.get(L);A&&(this._terminalBufferMap.delete(L),this._callback(L,A.data.join("")))}}e.TerminalDataBufferer=h}),define(_e[281],Ce([1,0,7,79,99,50,4,18,2,221,110,36]),function(ue,e,h,O,L,A,R,b,m,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.registerIcon=f,e.getIconRegistry=a,e.Extensions={IconContribution:"base.contributions.icons"};var p;(function(o){function t(u,r){let c=u.defaults;for(;A.ThemeIcon.isThemeIcon(c);){const s=d.getIcon(c.id);if(!s)return;c=s.defaults}return c}o.getDefinition=t})(p||(e.IconContribution=p={}));var S;(function(o){function t(r){return{weight:r.weight,style:r.style,src:r.src.map(c=>({format:c.format,location:c.location.toString()}))}}o.toJSONObject=t;function u(r){const c=s=>(0,b.isString)(s)?s:void 0;if(r&&Array.isArray(r.src)&&r.src.every(s=>(0,b.isString)(s.format)&&(0,b.isString)(s.location)))return{weight:c(r.weight),style:c(r.style),src:r.src.map(s=>({format:s.format,location:m.URI.parse(s.location)}))}}o.fromJSONObject=u})(S||(e.IconFontDefinition=S={}));class E{constructor(){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${A.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(t,u,r,c){const s=this.iconsById[t];if(s){if(r&&!s.description){s.description=r,this.iconSchema.properties[t].markdownDescription=`${r} $(${t})`;const D=this.iconReferenceSchema.enum.indexOf(t);D!==-1&&(this.iconReferenceSchema.enumDescriptions[D]=r),this._onDidChange.fire()}return s}const w={id:t,description:r,defaults:u,deprecationMessage:c};this.iconsById[t]=w;const g={$ref:"#/definitions/icons"};return c&&(g.deprecationMessage=c),r&&(g.markdownDescription=`${r}: $(${t})`),this.iconSchema.properties[t]=g,this.iconReferenceSchema.enum.push(t),this.iconReferenceSchema.enumDescriptions.push(r||""),this._onDidChange.fire(),{id:t}}deregisterIcon(t){delete this.iconsById[t],delete this.iconSchema.properties[t];const u=this.iconReferenceSchema.enum.indexOf(t);u!==-1&&(this.iconReferenceSchema.enum.splice(u,1),this.iconReferenceSchema.enumDescriptions.splice(u,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(t=>this.iconsById[t])}getIcon(t){return this.iconsById[t]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(t,u){const r=this.iconFontsById[t];return r||(this.iconFontsById[t]=u,this._onDidChange.fire(),u)}deregisterIconFont(t){delete this.iconFontsById[t]}getIconFont(t){return this.iconFontsById[t]}toString(){const t=(s,w)=>s.id.localeCompare(w.id),u=s=>{for(;A.ThemeIcon.isThemeIcon(s.defaults);)s=this.iconsById[s.defaults.id];return`codicon codicon-${s?s.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.iconsById).map(s=>this.iconsById[s]);for(const s of c.filter(w=>!!w.description).sort(t))r.push(`|<i class="${u(s)}"></i>|${s.id}|${A.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const s of c.filter(w=>!A.ThemeIcon.isThemeIcon(w.defaults)).sort(t))r.push(`|<i class="${u(s)}"></i>|${s.id}|`);return r.join(`
`)}}const d=new E;I.Registry.add(e.Extensions.IconContribution,d);function f(o,t,u,r){return d.registerIcon(o,t,u,r)}function a(){return d}function i(){const o=(0,L.getCodiconFontCharacters)();for(const t in o){const u="\\"+o[t].toString(16);d.registerIcon(t,{fontCharacter:u})}}i(),e.iconsSchemaId="vscode://schemas/icons";const n=I.Registry.as(T.Extensions.JSONContribution);n.registerSchema(e.iconsSchemaId,d.getIconSchema());const l=new h.RunOnceScheduler(()=>n.notifySchemaChanged(e.iconsSchemaId),200);d.onDidChange(()=>{l.isScheduled()||l.schedule()}),e.widgetClose=f("widget-close",O.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=f("goto-previous-location",O.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=f("goto-next-location",O.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=A.ThemeIcon.modify(O.Codicon.sync,"spin"),e.spinningLoading=A.ThemeIcon.modify(O.Codicon.loading,"spin")}),define(_e[88],Ce([1,0,4,2,55,5,11]),function(ue,e,h,O,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=y,e.extractLocalHostUriMetaDataForPortMapping=I,e.extractQueryLocalHostUriMetaDataForPortMapping=p,e.isLocalhost=S,e.isAllInterfaces=E,e.isPortPrivileged=d,e.ITunnelService=(0,A.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,A.createDecorator)("sharedTunnelsService");var b;(function(i){i.Http="http",i.Https="https"})(b||(e.TunnelProtocol=b={}));var m;(function(i){i.ConstantPrivate="constantPrivate",i.Private="private",i.Public="public"})(m||(e.TunnelPrivacyId=m={}));function y(i){return!!i.forwardPort}var T;(function(i){i[i.Notify=1]="Notify",i[i.OpenBrowser=2]="OpenBrowser",i[i.OpenPreview=3]="OpenPreview",i[i.Silent=4]="Silent",i[i.Ignore=5]="Ignore",i[i.OpenBrowserOnce=6]="OpenBrowserOnce"})(T||(e.ProvidedOnAutoForward=T={}));function I(i){if(i.scheme!=="http"&&i.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(i.authority);if(n)return{address:n[1],port:+n[2]}}function p(i){if(i.scheme!=="http"&&i.scheme!=="https"||!i.query)return;const n=i.query.split("&");for(const l of n){const o=l.split("=")[1];if(/^https?:/.exec(o)){const t=I(O.URI.parse(o));if(t)return t}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(i){return e.LOCALHOST_ADDRESSES.indexOf(i)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(i){return e.ALL_INTERFACES_ADDRESSES.indexOf(i)>=0}function d(i,n,l,o){if(l===1)return!1;if(l===2&&E(n)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(t?.length===4&&parseInt(t[1])>=18)return!1}return i<1024}class f{constructor(n,l,o){this.remoteAddress=n,this.localAddress=l,this._dispose=o,this._onDispose=new h.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=f;let a=class{constructor(n,l){this.logService=n,this.configurationService=l,this._onTunnelOpened=new h.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new h.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new h.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const n=this.configurationService.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this._tunnelProvider=n,n?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this._canElevate=n.elevation,this._privacyOptions=n.privacyOptions,this._canChangeProtocol=n.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const n=[],l=Array.from(this._tunnels.values());for(const o of l){const t=Array.from(o.values());for(const u of t){const r=await u.value;r&&typeof r!="string"&&n.push(r)}}return n}async dispose(){for(const n of this._tunnels.values()){for(const{value:l}of n.values())await l.then(o=>typeof o!="string"?o?.dispose():void 0);n.clear()}this._tunnels.clear()}setEnvironmentTunnel(n,l,o,t,u){this.addTunnelToMap(n,l,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:l,localAddress:o,privacy:t,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,l){(E(n)||S(n))&&(n=e.LOCALHOST_ADDRESSES[0]);const o=this.getTunnelFromMap(n,l);if(o)return++o.refcount,o.value}openTunnel(n,l,o,t,u,r=!1,c,s){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${o} on local port ${u}.`);const w=this._tunnelProvider??n;if(!w)return;if(l||(l="localhost"),t||(t=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(o)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const g=this.retainOrCreateTunnel(w,l,o,t,u,r,c,s);return g?g.then(D=>{if(D){if(typeof D=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(l,o),D}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(l,o);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.makeTunnel(D);return(D.tunnelRemoteHost!==l||D.tunnelRemotePort!==o)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),c&&D.privacy!==c&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(v),v}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),g)}makeTunnel(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const l=this._tunnels.get(n.tunnelRemoteHost);if(l){const o=l.get(n.tunnelRemotePort);o&&(o.refcount--,await this.tryDisposeTunnel(n.tunnelRemoteHost,n.tunnelRemotePort,o))}}}}async tryDisposeTunnel(n,l,o){if(o.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${l}.`);const t=o.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(n)&&this._tunnels.get(n).delete(l),t}}async closeTunnel(n,l){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${l} `);const o=this._tunnels.get(n);if(o&&o.has(l)){const t=o.get(l);t.refcount=0,await this.tryDisposeTunnel(n,l,t)}}addTunnelToMap(n,l,o){this._tunnels.has(n)||this._tunnels.set(n,new Map),this._tunnels.get(n).set(l,{refcount:1,value:o})}async removeEmptyOrErrorTunnelFromMap(n,l){const o=this._tunnels.get(n);if(o){const t=o.get(l),u=t?await t.value:void 0;(!u||typeof u=="string")&&o.delete(l),o.size===0&&this._tunnels.delete(n)}}getTunnelFromMap(n,l){const o=[n];S(n)?(o.push(...e.LOCALHOST_ADDRESSES),o.push(...e.ALL_INTERFACES_ADDRESSES)):E(n)&&o.push(...e.ALL_INTERFACES_ADDRESSES);const t=o.map(u=>this._tunnels.get(u));for(const u of t){const r=u?.get(l);if(r)return r}}canTunnel(n){return!!I(n)}createWithProvider(n,l,o,t,u,r,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${o} on local port ${t}.`);const s=o;this._factoryInProgress.add(s);const w=t===void 0?o:t,g={elevationRequired:u?this.isPortPrivileged(w):!1},D={remoteAddress:{host:l,port:o},localAddressPort:t,privacy:r,public:r?r!==m.Private:void 0,protocol:c},v=n.forwardPort(D,g);return v?(this.addTunnelToMap(l,o,v),v.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),v}};e.AbstractTunnelService=a,e.AbstractTunnelService=a=Ge([Ue(0,R.ILogService),Ue(1,L.IConfigurationService)],a)}),define(_e[282],Ce([1,0,5]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,h.createDecorator)("IUriIdentityService")}),define(_e[283],Ce([1,0,5]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,h.createDecorator)("editSessionIdentityService");var O;(function(L){L[L.Complete=100]="Complete",L[L.Partial=50]="Partial",L[L.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(_e[284],Ce([1,0,15]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualResource=O,e.getVirtualWorkspaceLocation=L,e.getVirtualWorkspaceScheme=A,e.getVirtualWorkspaceAuthority=R,e.isVirtualWorkspace=b;function O(m){return m.scheme!==h.Schemas.file&&m.scheme!==h.Schemas.vscodeRemote}function L(m){if(m.folders.length)return m.folders.every(y=>O(y.uri))?m.folders[0].uri:void 0;if(m.configuration&&O(m.configuration))return m.configuration}function A(m){return L(m)?.scheme}function R(m){return L(m)?.authority}function b(m){return L(m)!==void 0}}),define(_e[42],Ce([1,0,223,17,78,23,2,5,15]),function(ue,e,h,O,L,A,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=y,e.isEmptyWorkspaceIdentifier=T,e.toWorkspaceIdentifier=I,e.isWorkspaceIdentifier=p,e.reviveIdentifier=S,e.isWorkspace=d,e.isWorkspaceFolder=f,e.toWorkspaceFolder=n,e.isUntitledWorkspace=l,e.isTemporaryWorkspace=o,e.isStandaloneEditorWorkspace=t,e.isSavedWorkspace=u,e.hasWorkspaceFileExtension=r,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function y(c){const s=c;return typeof s?.id=="string"&&R.URI.isUri(s.uri)}function T(c){return typeof c?.id=="string"&&!y(c)&&!p(c)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function I(c,s){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,O.basename)(c)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const w=c;return w.configuration?{id:w.id,configPath:w.configuration}:w.folders.length===1?{id:w.id,uri:w.folders[0].uri}:{id:w.id}}function p(c){const s=c;return typeof s?.id=="string"&&R.URI.isUri(s.configPath)}function S(c){const s=c;if(s?.uri)return{id:s.id,uri:R.URI.revive(s.uri)};const w=c;if(w?.configPath)return{id:w.id,configPath:R.URI.revive(w.configPath)};if(c?.id)return{id:c.id}}var E;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(E||(e.WorkbenchState=E={}));function d(c){const s=c;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function f(c){const s=c;return!!(s&&typeof s=="object"&&R.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class a{constructor(s,w,g,D,v){this._id=s,this._transient=g,this._configuration=D,this._ignorePathCasing=v,this._foldersMap=L.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=w}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=L.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=a;class i{constructor(s,w){this.raw=w,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function n(c){return new i({uri:c,index:0,name:(0,A.basenameOrAuthority)(c)},{uri:c.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,h.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function l(c,s){return A.extUriBiasedIgnorePathCase.isEqualOrParent(c,s.untitledWorkspacesHome)}function o(c){let s;return R.URI.isUri(c)?s=c:s=c.configuration,s?.scheme===m.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(c){return c.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function u(c,s){return!l(c,s)&&!o(c)}function r(c){return(typeof c=="string"?(0,O.extname)(c):(0,A.extname)(c))===e.WORKSPACE_SUFFIX}}),define(_e[285],Ce([1,0,57,4,3,23,2,222,137,33,5,11,42,27,282,7,30,14,18]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=l,e.reviveProfile=o,e.toUserDataProfile=t;var n;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Tasks="tasks",c.Extensions="extensions",c.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function l(c){const s=c;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&R.URI.isUri(s.location)&&R.URI.isUri(s.globalStorageHome)&&R.URI.isUri(s.settingsResource)&&R.URI.isUri(s.keybindingsResource)&&R.URI.isUri(s.tasksResource)&&R.URI.isUri(s.snippetsHome)&&R.URI.isUri(s.extensionsResource))}e.IUserDataProfilesService=(0,T.createDecorator)("IUserDataProfilesService");function o(c,s){return{id:c.id,isDefault:c.isDefault,name:c.name,shortName:c.shortName,icon:c.icon,location:R.URI.revive(c.location).with({scheme:s}),globalStorageHome:R.URI.revive(c.globalStorageHome).with({scheme:s}),settingsResource:R.URI.revive(c.settingsResource).with({scheme:s}),keybindingsResource:R.URI.revive(c.keybindingsResource).with({scheme:s}),tasksResource:R.URI.revive(c.tasksResource).with({scheme:s}),snippetsHome:R.URI.revive(c.snippetsHome).with({scheme:s}),extensionsResource:R.URI.revive(c.extensionsResource).with({scheme:s}),cacheHome:R.URI.revive(c.cacheHome).with({scheme:s}),useDefaultFlags:c.useDefaultFlags,isTransient:c.isTransient}}function t(c,s,w,g,D,v){return{id:c,name:s,location:w,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:v&&D?.useDefaultFlags?.globalState?v.globalStorageHome:(0,A.joinPath)(w,"globalStorage"),settingsResource:v&&D?.useDefaultFlags?.settings?v.settingsResource:(0,A.joinPath)(w,"settings.json"),keybindingsResource:v&&D?.useDefaultFlags?.keybindings?v.keybindingsResource:(0,A.joinPath)(w,"keybindings.json"),tasksResource:v&&D?.useDefaultFlags?.tasks?v.tasksResource:(0,A.joinPath)(w,"tasks.json"),snippetsHome:v&&D?.useDefaultFlags?.snippets?v.snippetsHome:(0,A.joinPath)(w,"snippets"),extensionsResource:v&&D?.useDefaultFlags?.extensions?v.extensionsResource:(0,A.joinPath)(w,"extensions.json"),cacheHome:(0,A.joinPath)(g,c),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}let u=class extends L.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(s,w,g,D){super(),this.environmentService=s,this.fileService=w,this.uriIdentityService=g,this.logService=D,this.enabled=!0,this._onDidChangeProfiles=this._register(new O.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new O.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new O.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new O.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new S.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,A.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(s){this.enabled!==s&&(this._profilesObject=void 0,this.enabled=s)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const s=this.createDefaultProfile(),w=[s];if(this.enabled)try{for(const v of this.getStoredProfiles()){if(!v.name||!(0,i.isString)(v.name)||!v.location){this.logService.warn("Skipping the invalid stored profile",v.location||v.name);continue}w.push(t((0,A.basename)(v.location),v.name,v.location,this.profilesCacheHome,{shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags},s))}}catch(v){this.logService.error(v)}const g=new S.ResourceMap,D=new Map;if(w.length)try{const v=this.getStoredProfileAssociations();if(v.workspaces)for(const[_,C]of Object.entries(v.workspaces)){const P=R.URI.parse(_),k=w.find(F=>F.id===C);k&&g.set(P,k)}if(v.emptyWindows)for(const[_,C]of Object.entries(v.emptyWindows)){const P=w.find(k=>k.id===C);P&&D.set(_,P)}}catch(v){this.logService.error(v)}this._profilesObject={profiles:w,workspaces:g,emptyWindows:D}}return this._profilesObject}createDefaultProfile(){const s=t("__default__profile__",(0,b.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...s,extensionsResource:this.getDefaultProfileExtensionsLocation()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const w="Temp",g=new RegExp(`${(0,a.escapeRegExpCharacters)(w)}\\s(\\d+)`);let D=0;for(const _ of this.profiles){const C=g.exec(_.name),P=C?parseInt(C[1]):0;D=P>D?P:D}const v=`${w} ${D+1}`;return this.createProfile((0,h.hash)((0,f.generateUuid)()).toString(16),v,{transient:!0},s)}async createNamedProfile(s,w,g){return this.createProfile((0,h.hash)((0,f.generateUuid)()).toString(16),s,w,g)}async createProfile(s,w,g,D){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const v=await this.doCreateProfile(s,w,g);return D&&await this.setProfileForWorkspace(D,v),v}async doCreateProfile(s,w,g){if(!(0,i.isString)(w)||!w)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.profileCreationPromises.get(w);return D||(D=(async()=>{try{if(this.profiles.find(P=>P.name===w||P.id===s))throw new Error(`Profile with ${w} name already exists`);const _=t(s,w,(0,A.joinPath)(this.profilesHome,s),this.profilesCacheHome,g,this.defaultProfile);await this.fileService.createFolder(_.location);const C=[];return this._onWillCreateProfile.fire({profile:_,join(P){C.push(P)}}),await d.Promises.settled(C),this.updateProfiles([_],[],[]),_}finally{this.profileCreationPromises.delete(w)}})(),this.profileCreationPromises.set(w,D)),D}async updateProfile(s,w){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let g=this.profiles.find(D=>D.id===s.id);if(!g)throw new Error(`Profile '${s.name}' does not exist`);return g=t(g.id,w.name??g.name,g.location,this.profilesCacheHome,{shortName:w.shortName??g.shortName,icon:w.icon===null?void 0:w.icon??g.icon,transient:w.transient??g.isTransient,useDefaultFlags:w.useDefaultFlags??g.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[g]),g}async removeProfile(s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const w=this.profiles.find(D=>D.id===s.id);if(!w)throw new Error(`Profile '${s.name}' does not exist`);const g=[];this._onWillRemoveProfile.fire({profile:w,join(D){g.push(D)}});try{await Promise.allSettled(g)}catch(D){this.logService.error(D)}for(const D of[...this.profilesObject.emptyWindows.keys()])w.id===this.profilesObject.emptyWindows.get(D)?.id&&this.profilesObject.emptyWindows.delete(D);for(const D of[...this.profilesObject.workspaces.keys()])w.id===this.profilesObject.workspaces.get(D)?.id&&this.profilesObject.workspaces.delete(D);this.updateStoredProfileAssociations(),this.updateProfiles([],[w],[]);try{await this.fileService.del(w.cacheHome,{recursive:!0})}catch(D){(0,y.toFileOperationResult)(D)!==1&&this.logService.error(D)}}async setProfileForWorkspace(s,w){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const g=this.profiles.find(D=>D.id===w.id);if(!g)throw new Error(`Profile '${w.name}' does not exist`);this.updateWorkspaceAssociation(s,g)}unsetWorkspace(s,w){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(s,void 0,w)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const s=await this.fileService.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(w=>w.isDirectory&&this.profiles.every(g=>!this.uriIdentityService.extUri.isEqual(g.location,w.resource))).map(w=>this.fileService.del(w.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const s=this.transientProfilesObject.profiles.filter(w=>!this.isProfileAssociatedToWorkspace(w));await Promise.allSettled(s.map(w=>this.removeProfile(w)))}getProfileForWorkspace(s){const w=this.getWorkspace(s);return R.URI.isUri(w)?this.transientProfilesObject.workspaces.get(w)??this.profilesObject.workspaces.get(w):this.transientProfilesObject.emptyWindows.get(w)??this.profilesObject.emptyWindows.get(w)}getWorkspace(s){return(0,p.isSingleFolderWorkspaceIdentifier)(s)?s.uri:(0,p.isWorkspaceIdentifier)(s)?s.configPath:s.id}isProfileAssociatedToWorkspace(s){return!!([...this.transientProfilesObject.emptyWindows.values()].some(w=>this.uriIdentityService.extUri.isEqual(w.location,s.location))||[...this.transientProfilesObject.workspaces.values()].some(w=>this.uriIdentityService.extUri.isEqual(w.location,s.location))||[...this.profilesObject.emptyWindows.values()].some(w=>this.uriIdentityService.extUri.isEqual(w.location,s.location))||[...this.profilesObject.workspaces.values()].some(w=>this.uriIdentityService.extUri.isEqual(w.location,s.location)))}updateProfiles(s,w,g){const D=[...this.profiles,...s],v=[];this.transientProfilesObject.profiles=[];for(let _ of D)_.isDefault||w.some(C=>_.id===C.id)||(_=g.find(C=>_.id===C.id)??_,_.isTransient?this.transientProfilesObject.profiles.push(_):v.push({location:_.location,name:_.name,shortName:_.shortName,icon:_.icon,useDefaultFlags:_.useDefaultFlags}));this.saveStoredProfiles(v),this._profilesObject=void 0,this.triggerProfilesChanges(s,w,g)}triggerProfilesChanges(s,w,g){this._onDidChangeProfiles.fire({added:s,removed:w,updated:g,all:this.profiles})}updateWorkspaceAssociation(s,w,g){g=w?.isTransient?!0:g,g||this.updateWorkspaceAssociation(s,void 0,!0);const D=this.getWorkspace(s),v=g?this.transientProfilesObject:this.profilesObject;R.URI.isUri(D)?(v.workspaces.delete(D),w&&v.workspaces.set(D,w)):(v.emptyWindows.delete(D),w&&v.emptyWindows.set(D,w)),g||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const s={};for(const[g,D]of this.profilesObject.workspaces.entries())s[g.toString()]=D.id;const w={};for(const[g,D]of this.profilesObject.emptyWindows.entries())w[g.toString()]=D.id;this.saveStoredProfileAssociations({workspaces:s,emptyWindows:w}),this._profilesObject=void 0}migrateStoredProfileAssociations(s){const w={},g=this.createDefaultProfile();if(s.workspaces)for(const[v,_]of Object.entries(s.workspaces)){const C=R.URI.parse(_);w[v]=this.uriIdentityService.extUri.isEqual(C,g.location)?g.id:this.uriIdentityService.extUri.basename(C)}const D={};if(s.emptyWindows)for(const[v,_]of Object.entries(s.emptyWindows)){const C=R.URI.parse(_);D[v]=this.uriIdentityService.extUri.isEqual(C,g.location)?g.id:this.uriIdentityService.extUri.basename(C)}return{workspaces:w,emptyWindows:D}}getStoredProfiles(){return[]}saveStoredProfiles(s){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(s){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=u,e.UserDataProfilesService=u=Ge([Ue(0,m.IEnvironmentService),Ue(1,y.IFileService),Ue(2,E.IUriIdentityService),Ue(3,I.ILogService)],u);class r extends u{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(s){this.storedProfiles=s}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(s){this.storedProfileAssociations=s}}e.InMemoryUserDataProfilesService=r}),define(_e[142],Ce([1,0,7,4,3,59,18,200,5,285]),function(ue,e,h,O,L,A,R,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=S,e.isProfileUsingDefaultStorage=d,e.logStorage=a,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,m.createDecorator)("storageService");var T;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(T||(e.WillSaveStateReason=T={}));var I;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var p;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function S(i){const n=i.get(e.TARGET_KEY);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class E extends L.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(n={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super(),this.options=n,this._onDidChangeValue=this._register(new O.PauseableEmitter),this._onDidChangeTarget=this._register(new O.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new O.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new h.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(n,l,o){return O.Event.filter(this._onDidChangeValue.event,t=>t.scope===n&&(l===void 0||t.key===l),o)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,h.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(n,l){const{key:o,external:t}=l;if(o===e.TARGET_KEY){switch(n){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:n})}else this._onDidChangeValue.fire({scope:n,key:o,target:this.getKeyTargets(n)[o],external:t})}emitWillSaveState(n){this._onWillSaveState.fire({reason:n})}get(n,l,o){return this.getStorage(l)?.get(n,o)}getBoolean(n,l,o){return this.getStorage(l)?.getBoolean(n,o)}getNumber(n,l,o){return this.getStorage(l)?.getNumber(n,o)}getObject(n,l,o){return this.getStorage(l)?.getObject(n,o)}storeAll(n,l){this.withPausedEmitters(()=>{for(const o of n)this.store(o.key,o.value,o.scope,o.target,l)})}store(n,l,o,t,u=!1){if((0,R.isUndefinedOrNull)(l)){this.remove(n,o,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(n,o,t),this.getStorage(o)?.set(n,l,u)})}remove(n,l,o=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(n,l,void 0),this.getStorage(l)?.delete(n,o)})}withPausedEmitters(n){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{n()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(n,l){const o=[],t=this.getKeyTargets(n);for(const u of Object.keys(t))t[u]===l&&o.push(u);return o}updateKeyTarget(n,l,o,t=!1){const u=this.getKeyTargets(l);typeof o=="number"?u[n]!==o&&(u[n]=o,this.getStorage(l)?.set(e.TARGET_KEY,JSON.stringify(u),t)):typeof u[n]=="number"&&(delete u[n],this.getStorage(l)?.set(e.TARGET_KEY,JSON.stringify(u),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(n){switch(n){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(n){const l=this.getStorage(n);return l?S(l):Object.create(null)}isNew(n){return this.getBoolean(e.IS_NEW_KEY,n)===!0}async flush(n=T.NONE){this._onWillSaveState.fire({reason:n});const l=this.getStorage(-1),o=this.getStorage(0),t=this.getStorage(1);switch(n){case T.NONE:await h.Promises.settled([l?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await h.Promises.settled([l?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.getStorage(-1)?.items??new Map,l=this.getStorage(0)?.items??new Map,o=this.getStorage(1)?.items??new Map;return a(n,l,o,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(n){return await this.flush(),this.getStorage(n)?.optimize()}async switch(n,l){return this.emitWillSaveState(T.NONE),(0,y.isUserDataProfile)(n)?this.switchToProfile(n,l):this.switchToWorkspace(n,l)}canSwitchProfile(n,l){return!(n.id===l.id||d(l)&&d(n))}switchData(n,l,o){this.withPausedEmitters(()=>{const t=new Set;for(const[u,r]of n)t.add(u),l.get(u)!==r&&this.emitDidChangeValue(o,{key:u,external:!0});for(const[u]of l.items)t.has(u)||this.emitDidChangeValue(o,{key:u,external:!0})})}}e.AbstractStorageService=E;function d(i){return i.isDefault||!!i.useDefaultFlags?.globalState}class f extends E{constructor(){super(),this.applicationStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(n=>this.emitDidChangeValue(1,n))),this._register(this.profileStorage.onDidChangeStorage(n=>this.emitDidChangeValue(0,n))),this._register(this.applicationStorage.onDidChangeStorage(n=>this.emitDidChangeValue(-1,n)))}getStorage(n){switch(n){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(n){return!1}}e.InMemoryStorageService=f;async function a(i,n,l,o,t,u){const r=P=>{try{return JSON.parse(P)}catch{return P}},c=new Map,s=new Map;i.forEach((P,k)=>{c.set(k,P),s.set(k,r(P))});const w=new Map,g=new Map;n.forEach((P,k)=>{w.set(k,P),g.set(k,r(P))});const D=new Map,v=new Map;l.forEach((P,k)=>{D.set(k,P),v.set(k,r(P))}),console.group(o!==t?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const _=[];if(c.forEach((P,k)=>{_.push({key:k,value:P})}),console.table(_),console.groupEnd(),console.log(s),o!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];w.forEach((k,F)=>{P.push({key:F,value:k})}),console.table(P),console.groupEnd(),console.log(g)}console.group(`Storage: Workspace (path: ${u})`);const C=[];D.forEach((P,k)=>{C.push({key:k,value:P})}),console.table(C),console.groupEnd(),console.log(v)}}),define(_e[112],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class h{static{this.enableDebugLogging=!1}constructor(L){this.id=L,this._data=new Map,this._idPool=1}add(L){const A=this._idPool++;return this._data.set(A,L),this.logDebugInfo(),A}get(L,A){return this._data.has(L)?this._data.get(L)[A]:void 0}delete(L){this._data.delete(L),this.logDebugInfo()}logDebugInfo(){h.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=h}),define(_e[60],Ce([1,0,15,23,5]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(h.Schemas)),this._providerInfo=new Map,this.extUri=new O.ExtUri(b=>{const m=this._providerInfo.get(b.scheme);return!(m===void 0||m&1024)})}$acceptProviderInfos(b,m){m===null?this._providerInfo.delete(b.scheme):this._providerInfo.set(b.scheme,m)}isFreeScheme(b){return!this._providerInfo.has(b)&&!this._systemSchemes.has(b)}getCapabilities(b){return this._providerInfo.get(b)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,L.createDecorator)("IExtHostFileSystemInfo")}),define(_e[28],Ce([1,0,5]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,h.createDecorator)("IExtHostInitDataService")}),define(_e[286],Ce([1,0,228,11,266,28]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends L.LogService{constructor(m,y,T){const I=T.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",p=T.remote.isRemote?(0,h.localize)(0,null):m?(0,h.localize)(1,null):(0,h.localize)(2,null);super(y.createLogger(I,{name:p}))}};e.ExtHostLogService=R,e.ExtHostLogService=R=Ge([Ue(1,O.ILoggerService),Ue(2,A.IExtHostInitDataService)],R)}),define(_e[287],Ce([1,0,7]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class O{constructor(R,b,m){this._deferredPromises=new Map,this._id=R,this._shared=b,this._storage=m,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)}),this._scheduler=new h.RunOnceScheduler(()=>{const y=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const T of y.values())T.complete()}catch(T){for(const I of y.values())I.error(T)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,b){let m=this._value[R];return typeof m>"u"&&(m=b),m}update(R,b){this._value[R]=b;const m=this._deferredPromises.get(R);if(m!==void 0)return m.p;const y=new h.DeferredPromise;return this._deferredPromises.set(R,y),this._scheduler.isScheduled()||this._scheduler.schedule(),y.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=O;class L extends O{setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}constructor(R,b){super(R.identifier.value,!0,b),this._extension=R}}e.ExtensionGlobalMemento=L}),define(_e[288],Ce([1,0,4,2]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class L{constructor(R){this._notebooksAndEditors=R,this._onDidSaveNotebookDocument=new h.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new h.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(R,b,m,y){const I=this._notebooksAndEditors.getNotebookDocument(O.URI.revive(R)).acceptModelChanged(b.value,m,y);this._onDidChangeNotebookDocument.fire(I)}$acceptDirtyStateChanged(R,b){this._notebooksAndEditors.getNotebookDocument(O.URI.revive(R)).acceptDirty(b)}$acceptModelSaved(R){const b=this._notebooksAndEditors.getNotebookDocument(O.URI.revive(R));this._onDidSaveNotebookDocument.fire(b.apiNotebook)}}e.ExtHostNotebookDocuments=L}),define(_e[20],Ce([1,0,5]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,h.createDecorator)("IExtHostRpcService");class O{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=O}),define(_e[289],Ce([1,0,25,4]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class L{#e;constructor(R,b){this._onDidChange=new O.Emitter,this.onDidChange=this._onDidChange.event,this._id=h.ExtensionIdentifier.toKey(R.identifier),this.#e=b,this.#e.onDidChangePassword(m=>{m.extensionId===this._id&&this._onDidChange.fire({key:m.key})})}get(R){return this.#e.get(this._id,R)}store(R,b){return this.#e.store(this._id,R,b)}delete(R){return this.#e.delete(this._id,R)}}e.ExtensionSecrets=L}),define(_e[68],Ce([1,0,5]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,h.createDecorator)("IURITransformerService");class O{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=O}),define(_e[290],Ce([1,0,21]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewMessage=L,e.deserializeWebviewMessage=R;class O{constructor(){this.buffers=[]}add(m){let y=this.buffers.indexOf(m);return y<0&&(y=this.buffers.length,this.buffers.push(m)),y}}function L(b,m){if(m.serializeBuffersForPostMessage){const y=new O,I=JSON.stringify(b,(S,E)=>{if(E instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add(E)};if(ArrayBuffer.isView(E)){const d=A(E);if(d)return{$$vscode_array_buffer_reference$$:!0,index:y.add(E.buffer),view:{type:d,byteLength:E.byteLength,byteOffset:E.byteOffset}}}return E}),p=y.buffers.map(S=>{const E=new Uint8Array(S);return h.VSBuffer.wrap(E)});return{message:I,buffers:p}}else return{message:JSON.stringify(b),buffers:[]}}function A(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(b,m){const y=m.map(p=>{const S=new ArrayBuffer(p.byteLength);return new Uint8Array(S).set(p.buffer),S}),T=m.length?(p,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const E=S,{index:d}=E,f=y[d];if(E.view)switch(E.view.type){case 1:return new Int8Array(f,E.view.byteOffset,E.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(f,E.view.byteOffset,E.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(f,E.view.byteOffset,E.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(f,E.view.byteOffset,E.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(f,E.view.byteOffset,E.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(f,E.view.byteOffset,E.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(f,E.view.byteOffset,E.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(f,E.view.byteOffset,E.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(f,E.view.byteOffset,E.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(f,E.view.byteOffset,E.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(f,E.view.byteOffset,E.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return S}:void 0;return{message:JSON.parse(b,T),arrayBuffers:y}}}),define(_e[291],Ce([1,0,292,403,404,63,2,11,405]),function(ue,e,h,O,L,A,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=T;const y=!1;function T(n,l,o,t,u,r){const c=r.environment.useHostProxy,s=typeof c=="boolean"?c:!r.remote.isRemote,w={resolveProxy:v=>n.resolveProxy(v),lookupProxyAuthorization:f.bind(void 0,t,u,l,{},r.remote.isRemote),getProxyURL:()=>l.getConfiguration("http").get("proxy"),getProxySupport:()=>l.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>p(l),addCertificatesV2:()=>S(l),log:t,getLogLevel:()=>{const v=t.getLevel();switch(v){case b.LogLevel.Trace:return m.LogLevel.Trace;case b.LogLevel.Debug:return m.LogLevel.Debug;case b.LogLevel.Info:return m.LogLevel.Info;case b.LogLevel.Warning:return m.LogLevel.Warning;case b.LogLevel.Error:return m.LogLevel.Error;case b.LogLevel.Off:return m.LogLevel.Off;default:return _(v)}function _(C){return t.error("Unknown log level",C),m.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:s,loadAdditionalCertificates:async()=>{const v=[];if(r.remote.isRemote&&v.push((0,m.loadSystemCertificates)({log:t})),s){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const _=n.loadCertificates();_.then(C=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",C.length)),v.push(_)}return(await Promise.all(v)).flat()},env:process.env},g=(0,m.createProxyResolver)(w),D=I(w,g);return d(o,D)}function I(n,l){return{http:Object.assign(h,(0,m.createHttpPatch)(n,h,l)),https:Object.assign(O,(0,m.createHttpPatch)(n,O,l)),net:Object.assign(A,(0,m.createNetPatch)(n,A)),tls:Object.assign(L,(0,m.createTlsPatch)(n,L))}}function p(n){const l=n.getConfiguration("http");return!l.get("experimental.systemCertificatesV2",y)&&!!l.get("systemCertificates")}function S(n){const l=n.getConfiguration("http");return!!l.get("experimental.systemCertificatesV2",y)&&!!l.get("systemCertificates")}const E=new Map;function d(n,l){return n.getExtensionPathIndex().then(o=>{const t=globalThis._VSCODE_NODE_MODULES.module,u=t._load;t._load=function(c,s,w){if(c==="net")return l.net;if(c==="tls")return l.tls;if(c!=="http"&&c!=="https")return u.apply(this,arguments);const g=o.findSubstr(R.URI.file(s.filename));let D=E.get(g);if(D||E.set(g,D={}),!D[c]){const v=l[c];D[c]={...v}}return D[c]}})}async function f(n,l,o,t,u,r,c,s){const w=t[r];c&&(t[r]=c),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${r}`,`proxyAuthenticate:${c}`,`proxyAuthenticateCache:${w}`);const g=c||w,D=Array.isArray(g)?g:typeof g=="string"?[g]:[];if(i(l,D,u),D.some(v=>/^(Negotiate|Kerberos)( |$)/i.test(v))&&!s.kerberosRequested)try{s.kerberosRequested=!0;const v=await new Promise((F,x)=>{ue(["kerberos"],F,x)}),_=new URL(r),C=o.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${_.hostname}`:`HTTP@${_.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${r}`,`spn:${C}`),"Negotiate "+await(await v.initializeClient(C)).step("")}catch(v){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",v)}}let a=!1;function i(n,l,o){a||!l.length||(a=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:l.map(t=>t.split(" ")[0]).join(","),extensionHostType:o?"remote":"local"}))}}),define(_e[293],Ce([1,0,134]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=L;function O(A){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:A,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function L(A){return new h.URITransformer(O(A))}}),define(_e[143],Ce([1,0,238,18,2,3,5,36,33,15,47,192,41]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.EditorResourceAccessor=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.isEditorPaneWithSelection=d,e.isEditorPaneWithScrolling=f,e.findViewStateForEditor=a,e.isResourceEditorInput=i,e.isResourceDiffEditorInput=n,e.isResourceMultiDiffEditorInput=l,e.isResourceSideBySideEditorInput=o,e.isUntitledResourceEditorInput=t,e.isResourceMergeEditorInput=u,e.isEditorInput=D,e.isSideBySideEditorInput=_,e.isDiffEditorInput=C,e.createTooLargeFileError=P,e.isEditorInputWithOptions=k,e.isEditorInputWithOptionsAndGroup=F,e.isEditorIdentifier=x,e.preventEditorClose=te,e.pathsToEditors=Y,e.isTextEditorViewState=pe,e.isEditorOpenError=le,e.createEditorOpenError=we,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,h.localize)(0,null),providerDisplayName:(0,h.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var S;(function(Z){Z[Z.PROGRAMMATIC=1]="PROGRAMMATIC",Z[Z.USER=2]="USER",Z[Z.EDIT=3]="EDIT",Z[Z.NAVIGATION=4]="NAVIGATION",Z[Z.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var E;(function(Z){Z[Z.IDENTICAL=1]="IDENTICAL",Z[Z.SIMILAR=2]="SIMILAR",Z[Z.DIFFERENT=3]="DIFFERENT"})(E||(e.EditorPaneSelectionCompareResult=E={}));function d(Z){const B=Z;return!!B&&typeof B.getSelection=="function"&&!!B.onDidChangeSelection}function f(Z){const B=Z;return!!B&&typeof B.getScrollPosition=="function"&&typeof B.setScrollPosition=="function"&&!!B.onDidChangeScroll}function a(Z,B,ee){for(const ve of ee.visibleEditorPanes)if(ve.group.id===B&&Z.matches(ve.input))return ve.getViewState()}function i(Z){if(D(Z))return!1;const B=Z;return L.URI.isUri(B?.resource)}function n(Z){if(D(Z))return!1;const B=Z;return B?.original!==void 0&&B.modified!==void 0}function l(Z){if(D(Z))return!1;const B=Z;return!B||B.resources&&!Array.isArray(B.resources)?!1:!!B.resources||!!B.multiDiffSource}function o(Z){if(D(Z)||n(Z))return!1;const B=Z;return B?.primary!==void 0&&B.secondary!==void 0}function t(Z){if(D(Z))return!1;const B=Z;return B?B.resource===void 0||B.resource.scheme===y.Schemas.untitled||B.forceUntitled===!0:!1}function u(Z){if(D(Z))return!1;const B=Z;return L.URI.isUri(B?.base?.resource)&&L.URI.isUri(B?.input1?.resource)&&L.URI.isUri(B?.input2?.resource)&&L.URI.isUri(B?.result?.resource)}var r;(function(Z){Z[Z.SHORT=0]="SHORT",Z[Z.MEDIUM=1]="MEDIUM",Z[Z.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var c;(function(Z){Z[Z.EXPLICIT=1]="EXPLICIT",Z[Z.AUTO=2]="AUTO",Z[Z.FOCUS_CHANGE=3]="FOCUS_CHANGE",Z[Z.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c||(e.SaveReason=c={}));class s{constructor(){this.mapIdToSaveSource=new Map}registerSource(B,ee){let ve=this.mapIdToSaveSource.get(B);return ve||(ve={source:B,label:ee},this.mapIdToSaveSource.set(B,ve)),ve.source}getSourceLabel(B){return this.mapIdToSaveSource.get(B)?.label??B}}e.SaveSourceRegistry=new s;var w;(function(Z){Z[Z.None=0]="None",Z[Z.Readonly=2]="Readonly",Z[Z.Untitled=4]="Untitled",Z[Z.Singleton=8]="Singleton",Z[Z.RequiresTrust=16]="RequiresTrust",Z[Z.CanSplitInGroup=32]="CanSplitInGroup",Z[Z.ForceDescription=64]="ForceDescription",Z[Z.CanDropIntoEditor=128]="CanDropIntoEditor",Z[Z.MultipleEditors=256]="MultipleEditors",Z[Z.Scratchpad=512]="Scratchpad"})(w||(e.EditorInputCapabilities=w={}));class g extends A.Disposable{}e.AbstractEditorInput=g;function D(Z){return Z instanceof g}function v(Z){const B=Z;return L.URI.isUri(B?.preferredResource)}function _(Z){const B=Z;return D(B?.primary)&&D(B?.secondary)}function C(Z){const B=Z;return D(B?.modified)&&D(B?.original)}function P(Z,B,ee,ve,Pe){return we(ve,[(0,I.toAction)({id:"workbench.action.openLargeFile",label:(0,h.localize)(2,null),run:()=>{const oe={...ee,limits:{size:Number.MAX_VALUE}};Z.openEditor(B,oe)}}),(0,I.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,h.localize)(3,null),run:()=>Pe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}function k(Z){return D(Z?.editor)}function F(Z){const B=Z;return k(Z)&&B?.group!==void 0}function x(Z){const B=Z;return typeof B?.groupId=="number"&&D(B.editor)}var z;(function(Z){Z[Z.UNKNOWN=0]="UNKNOWN",Z[Z.REPLACE=1]="REPLACE",Z[Z.MOVE=2]="MOVE",Z[Z.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var N;(function(Z){Z[Z.GROUP_ACTIVE=0]="GROUP_ACTIVE",Z[Z.GROUP_INDEX=1]="GROUP_INDEX",Z[Z.GROUP_LABEL=2]="GROUP_LABEL",Z[Z.GROUP_LOCKED=3]="GROUP_LOCKED",Z[Z.EDITOR_OPEN=4]="EDITOR_OPEN",Z[Z.EDITOR_CLOSE=5]="EDITOR_CLOSE",Z[Z.EDITOR_MOVE=6]="EDITOR_MOVE",Z[Z.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",Z[Z.EDITOR_LABEL=8]="EDITOR_LABEL",Z[Z.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",Z[Z.EDITOR_PIN=10]="EDITOR_PIN",Z[Z.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",Z[Z.EDITOR_STICKY=12]="EDITOR_STICKY",Z[Z.EDITOR_DIRTY=13]="EDITOR_DIRTY",Z[Z.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(N||(e.GroupModelChangeKind=N={}));var M;(function(Z){Z[Z.PRIMARY=1]="PRIMARY",Z[Z.SECONDARY=2]="SECONDARY",Z[Z.BOTH=3]="BOTH",Z[Z.ANY=4]="ANY"})(M||(e.SideBySideEditor=M={}));class W{getOriginalUri(B,ee){if(!B)return;if(u(B))return e.EditorResourceAccessor.getOriginalUri(B.result,ee);if(ee?.supportSideBySide){const{primary:Pe,secondary:oe}=this.getSideEditors(B);if(Pe&&oe){if(ee?.supportSideBySide===M.BOTH)return{primary:this.getOriginalUri(Pe,{filterByScheme:ee.filterByScheme}),secondary:this.getOriginalUri(oe,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===M.ANY)return this.getOriginalUri(Pe,{filterByScheme:ee.filterByScheme})??this.getOriginalUri(oe,{filterByScheme:ee.filterByScheme});B=ee.supportSideBySide===M.PRIMARY?Pe:oe}}if(n(B)||l(B)||o(B)||u(B))return;const ve=v(B)?B.preferredResource:B.resource;return!ve||!ee||!ee.filterByScheme?ve:this.filterUri(ve,ee.filterByScheme)}getSideEditors(B){return _(B)||o(B)?{primary:B.primary,secondary:B.secondary}:C(B)||n(B)?{primary:B.modified,secondary:B.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(B,ee){if(!B)return;if(u(B))return e.EditorResourceAccessor.getCanonicalUri(B.result,ee);if(ee?.supportSideBySide){const{primary:Pe,secondary:oe}=this.getSideEditors(B);if(Pe&&oe){if(ee?.supportSideBySide===M.BOTH)return{primary:this.getCanonicalUri(Pe,{filterByScheme:ee.filterByScheme}),secondary:this.getCanonicalUri(oe,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===M.ANY)return this.getCanonicalUri(Pe,{filterByScheme:ee.filterByScheme})??this.getCanonicalUri(oe,{filterByScheme:ee.filterByScheme});B=ee.supportSideBySide===M.PRIMARY?Pe:oe}}if(n(B)||l(B)||o(B)||u(B))return;const ve=B.resource;return!ve||!ee||!ee.filterByScheme?ve:this.filterUri(ve,ee.filterByScheme)}filterUri(B,ee){if(Array.isArray(ee)){if(ee.some(ve=>B.scheme===ve))return B}else if(ee===B.scheme)return B}}var X;(function(Z){Z[Z.UNKNOWN=0]="UNKNOWN",Z[Z.KEYBOARD=1]="KEYBOARD",Z[Z.MOUSE=2]="MOUSE"})(X||(e.EditorCloseMethod=X={}));function te(Z,B,ee,ve){if(!Z.isSticky(B))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return ee===X.MOUSE||ee===X.KEYBOARD;case"mouse":return ee===X.MOUSE;case"keyboard":return ee===X.KEYBOARD}return!1}e.EditorResourceAccessor=new W;var H;(function(Z){Z[Z.LEFT=0]="LEFT",Z[Z.RIGHT=1]="RIGHT"})(H||(e.CloseDirection=H={}));class G{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(B){const ee=this.instantiationService=B.get(R.IInstantiationService);for(const[ve,Pe]of this.editorSerializerConstructors)this.createEditorSerializer(ve,Pe,ee);this.editorSerializerConstructors.clear()}createEditorSerializer(B,ee,ve){const Pe=ve.createInstance(ee);this.editorSerializerInstances.set(B,Pe)}registerFileEditorFactory(B){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=B}getFileEditorFactory(){return(0,O.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(B,ee){if(this.editorSerializerConstructors.has(B)||this.editorSerializerInstances.has(B))throw new Error(`A editor serializer with type ID '${B}' was already registered.`);return this.instantiationService?this.createEditorSerializer(B,ee,this.instantiationService):this.editorSerializerConstructors.set(B,ee),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(B),this.editorSerializerInstances.delete(B)})}getEditorSerializer(B){return this.editorSerializerInstances.get(typeof B=="string"?B:B.typeId)}}b.Registry.add(e.EditorExtensions.EditorFactory,new G);async function Y(Z,B,ee){return!Z||!Z.length?[]:await Promise.all(Z.map(async ve=>{const Pe=L.URI.revive(ve.fileUri);if(!Pe){ee.info("Cannot resolve the path because it is not valid.",ve);return}if(!await B.canHandleResource(Pe)){ee.info("Cannot resolve the path because it cannot be handled",ve);return}let se=ve.exists,re=ve.type;if(typeof se!="boolean"||typeof re!="number")try{re=(await B.stat(Pe)).isDirectory?m.FileType.Directory:m.FileType.Unknown,se=!0}catch(ie){ee.error(ie),se=!1}if(!se&&ve.openOnlyIfExists){ee.info("Cannot resolve the path because it does not exist",ve);return}if(re===m.FileType.Directory){ee.info("Cannot resolve the path because it is a directory",ve);return}const j={...ve.options,pinned:!0};return se?{resource:Pe,options:j}:{resource:Pe,options:j,forceUntitled:!0}}))}var ne;(function(Z){Z[Z.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Z[Z.SEQUENTIAL=1]="SEQUENTIAL"})(ne||(e.EditorsOrder=ne={}));function pe(Z){const B=Z;if(!B)return!1;const ee=B;if(ee.modified)return pe(ee.modified);const ve=B;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function le(Z){return(0,T.isErrorWithActions)(Z)}function we(Z,B,ee){const ve=(0,T.createErrorWithActions)(Z,B);return ve.forceMessage=ee?.forceMessage,ve.forceSeverity=ee?.forceSeverity,ve.allowDialog=ee?.allowDialog,ve}}),define(_e[294],Ce([1,0,4,239,5,3,27,36,19,24,79,281]),function(ue,e,h,O,L,A,R,b,m,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.ViewContentGroups=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=e.VIEWS_LOG_NAME=e.VIEWS_LOG_ID=void 0,e.ViewContainerLocationToString=E,e.VIEWS_LOG_ID="views",e.VIEWS_LOG_NAME=(0,O.localize)(0,null),e.defaultViewIcon=(0,I.registerIcon)("default-view-icon",T.Codicon.window,(0,O.localize)(1,null));var p;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(p||(e.Extensions=p={}));var S;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel",u[u.AuxiliaryBar=2]="AuxiliaryBar"})(S||(e.ViewContainerLocation=S={})),e.ViewContainerLocations=[0,1,2];function E(u){switch(u){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class d extends A.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new h.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new h.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,m.flatten)([...this.viewContainers.values()])}registerViewContainer(r,c,s){const w=this.get(r.id);if(w)return w;const g=r;return g.openCommandActionDescriptor=s?.doNotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,R.getOrSet)(this.viewContainers,c,[]).push(g),s?.isDefault&&this.defaultViewContainers.push(g),this._onDidRegister.fire({viewContainer:g,viewContainerLocation:c}),g}deregisterViewContainer(r){for(const c of this.viewContainers.keys()){const s=this.viewContainers.get(c),w=s?.indexOf(r);if(w!==-1){s?.splice(w,1),s.length===0&&this.viewContainers.delete(c),this._onDidDeregister.fire({viewContainer:r,viewContainerLocation:c});return}}}get(r){return this.all.filter(c=>c.id===r)[0]}getViewContainers(r){return[...this.viewContainers.get(r)||[]]}getViewContainerLocation(r){return[...this.viewContainers.keys()].filter(c=>this.getViewContainers(c).filter(s=>s?.id===r.id).length>0)[0]}getDefaultViewContainer(r){return this.defaultViewContainers.find(c=>this.getViewContainerLocation(c)===r)}}b.Registry.add(p.ViewContainersRegistry,new d);var f;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(f||(e.ViewContentGroups=f={}));function a(u,r){const c=u.group??f.More,s=r.group??f.More;return c!==s?c.localeCompare(s):(u.order??5)-(r.order??5)}class i extends A.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new h.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new h.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new h.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new h.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new R.SetMap}registerViews(r,c){this.registerViews2([{views:r,viewContainer:c}])}registerViews2(r){r.forEach(({views:c,viewContainer:s})=>this.addViews(c,s)),this._onViewsRegistered.fire(r)}deregisterViews(r,c){const s=this.removeViews(r,c);s.length&&this._onViewsDeregistered.fire({views:s,viewContainer:c})}moveViews(r,c){for(const s of this._views.keys())if(s!==c){const w=this.removeViews(r,s);w.length&&(this.addViews(w,c),this._onDidChangeContainer.fire({views:w,from:s,to:c}))}}getViews(r){return this._views.get(r)||[]}getView(r){for(const c of this._viewContainers){const s=(this._views.get(c)||[]).filter(w=>w.id===r)[0];if(s)return s}return null}getViewContainer(r){for(const c of this._viewContainers)if((this._views.get(c)||[]).filter(w=>w.id===r)[0])return c;return null}registerViewWelcomeContent(r,c){return this._viewWelcomeContents.add(r,c),this._onDidChangeViewWelcomeContent.fire(r),(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(r,c),this._onDidChangeViewWelcomeContent.fire(r)})}registerViewWelcomeContent2(r,c){const s=new Map;for(const[w,g]of c)this._viewWelcomeContents.add(r,g),s.set(w,(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(r,g),this._onDidChangeViewWelcomeContent.fire(r)}));return this._onDidChangeViewWelcomeContent.fire(r),s}getViewWelcomeContent(r){const c=[];return this._viewWelcomeContents.forEach(r,s=>c.push(s)),c.sort(a)}addViews(r,c){let s=this._views.get(c);s||(s=[],this._views.set(c,s),this._viewContainers.push(c));for(const w of r){if(this.getView(w.id)!==null)throw new Error((0,O.localize)(2,null,w.id));s.push(w)}}removeViews(r,c){const s=this._views.get(c);if(!s)return[];const w=[],g=[];for(const D of s)r.includes(D)?w.push(D):g.push(D);return w.length&&(g.length?this._views.set(c,g):(this._views.delete(c),this._viewContainers.splice(this._viewContainers.indexOf(c),1))),w}}b.Registry.add(p.ViewsRegistry,new i),e.IViewDescriptorService=(0,L.createDecorator)("viewDescriptorService");var n;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var l;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(l||(e.TreeItemCollapsibleState=l={}));class o{constructor(r,c){this.resolved=!1,this._hasResolve=!1,(0,y.mixin)(this,r),this._hasResolve=!!c,this.resolve=async s=>{if(c&&!this.resolved){const w=await c(s);w&&(this.tooltip=this.tooltip??w.tooltip,this.command=this.command??w.command)}s.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=o;class t extends Error{constructor(r){super((0,O.localize)(3,null,r)),this.name="NoTreeViewError"}static is(r){return r.name==="NoTreeViewError"}}e.NoTreeViewError=t}),define(_e[295],Ce([1,0,240,38]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_CHAT_LOCATION=e.CONTEXT_CHAT_INPUT_HAS_AGENT=e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=e.CONTEXT_CHAT_ENABLED=e.CONTEXT_IN_CHAT_SESSION=e.CONTEXT_IN_CHAT_INPUT=e.CONTEXT_CHAT_INPUT_HAS_FOCUS=e.CONTEXT_CHAT_INPUT_HAS_TEXT=e.CONTEXT_CHAT_EDIT_APPLIED=e.CONTEXT_REQUEST=e.CONTEXT_RESPONSE=e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=e.CONTEXT_RESPONSE_FILTERED=e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=e.CONTEXT_RESPONSE_VOTE=void 0,e.CONTEXT_RESPONSE_VOTE=new O.RawContextKey("chatSessionResponseVote","",{type:"string",description:(0,h.localize)(0,null)}),e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=new O.RawContextKey("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,h.localize)(1,null)}),e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=new O.RawContextKey("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,h.localize)(2,null)}),e.CONTEXT_RESPONSE_FILTERED=new O.RawContextKey("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,h.localize)(3,null)}),e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=new O.RawContextKey("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,h.localize)(4,null)}),e.CONTEXT_RESPONSE=new O.RawContextKey("chatResponse",!1,{type:"boolean",description:(0,h.localize)(5,null)}),e.CONTEXT_REQUEST=new O.RawContextKey("chatRequest",!1,{type:"boolean",description:(0,h.localize)(6,null)}),e.CONTEXT_CHAT_EDIT_APPLIED=new O.RawContextKey("chatEditApplied",!1,{type:"boolean",description:(0,h.localize)(7,null)}),e.CONTEXT_CHAT_INPUT_HAS_TEXT=new O.RawContextKey("chatInputHasText",!1,{type:"boolean",description:(0,h.localize)(8,null)}),e.CONTEXT_CHAT_INPUT_HAS_FOCUS=new O.RawContextKey("chatInputHasFocus",!1,{type:"boolean",description:(0,h.localize)(9,null)}),e.CONTEXT_IN_CHAT_INPUT=new O.RawContextKey("inChatInput",!1,{type:"boolean",description:(0,h.localize)(10,null)}),e.CONTEXT_IN_CHAT_SESSION=new O.RawContextKey("inChat",!1,{type:"boolean",description:(0,h.localize)(11,null)}),e.CONTEXT_CHAT_ENABLED=new O.RawContextKey("chatIsEnabled",!1,{type:"boolean",description:(0,h.localize)(12,null)}),e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=new O.RawContextKey("chatCursorAtTop",!1),e.CONTEXT_CHAT_INPUT_HAS_AGENT=new O.RawContextKey("chatInputHasAgent",!1),e.CONTEXT_CHAT_LOCATION=new O.RawContextKey("chatLocation",void 0)}),define(_e[296],Ce([1,0,7,22,4,39,3,171,14,38,5,11,108,274,142,295]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.ChatAgentNameService=e.IChatAgentNameService=e.MergedChatAgent=e.ChatAgentService=e.IChatAgentService=e.ChatAgentLocation=void 0;var a;(function(o){o.Panel="panel",o.Terminal="terminal",o.Notebook="notebook",o.Editor="editor"})(a||(e.ChatAgentLocation=a={})),function(o){function t(u){switch(u){case"panel":return o.Panel;case"terminal":return o.Terminal;case"notebook":return o.Notebook;case"editor":return o.Editor}return o.Panel}o.fromRaw=t}(a||(e.ChatAgentLocation=a={})),e.IChatAgentService=(0,T.createDecorator)("chatAgentService");let i=class{static{this.AGENT_LEADER="@"}constructor(t){this.contextKeyService=t,this._agents=[],this._onDidChangeAgents=new L.Emitter,this.onDidChangeAgents=this._onDidChangeAgents.event,this._hasDefaultAgent=d.CONTEXT_CHAT_ENABLED.bindTo(this.contextKeyService)}registerAgent(t,u){if(this.getAgent(t))throw new Error(`Agent already registered: ${JSON.stringify(t)}`);const c=this,s=u.slashCommands;u={...u,get slashCommands(){return s.filter(g=>!g.when||c.contextKeyService.contextMatchesRules(y.ContextKeyExpr.deserialize(g.when)))}};const w={data:u};return this._agents.push(w),(0,R.toDisposable)(()=>{this._agents=this._agents.filter(g=>g!==w),this._onDidChangeAgents.fire(void 0)})}registerAgentImplementation(t,u){const r=this._getAgentEntry(t);if(!r)throw new Error(`Unknown agent: ${JSON.stringify(t)}`);if(r.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(t)}`);return r.data.isDefault&&this._hasDefaultAgent.set(!0),r.impl=u,this._onDidChangeAgents.fire(new n(r.data,u)),(0,R.toDisposable)(()=>{r.impl=void 0,this._onDidChangeAgents.fire(void 0),r.data.isDefault&&this._hasDefaultAgent.set(!1)})}registerDynamicAgent(t,u){const r={data:t,impl:u};return this._agents.push(r),this._onDidChangeAgents.fire(new n(t,u)),(0,R.toDisposable)(()=>{this._agents=this._agents.filter(c=>c!==r),this._onDidChangeAgents.fire(void 0)})}updateAgent(t,u){const r=this._getAgentEntry(t);if(!r?.impl)throw new Error(`No activated agent with id ${JSON.stringify(t)} registered`);r.data.metadata={...r.data.metadata,...u},this._onDidChangeAgents.fire(new n(r.data,r.impl))}getDefaultAgent(t){return this.getActivatedAgents().find(u=>!!u.isDefault&&u.locations.includes(t))}getContributedDefaultAgent(t){return this.getAgents().find(u=>!!u.isDefault&&u.locations.includes(t))}getSecondaryAgent(){return A.Iterable.find(this._agents.values(),t=>!!t.data.metadata.isSecondary)?.data}_getAgentEntry(t){return this._agents.find(u=>u.data.id===t)}getAgent(t){return this._getAgentEntry(t)?.data}getAgents(){return this._agents.map(t=>t.data)}getActivatedAgents(){return Array.from(this._agents.values()).filter(t=>!!t.impl).map(t=>new n(t.data,t.impl))}getAgentsByName(t){return this.getAgents().filter(u=>u.name===t)}async invokeAgent(t,u,r,c,s){const w=this._getAgentEntry(t);if(!w?.impl)throw new Error(`No activated agent with id ${t}`);return await w.impl.invoke(u,r,c,s)}async getFollowups(t,u,r,c,s){const w=this._getAgentEntry(t);if(!w?.impl)throw new Error(`No activated agent with id ${t}`);return w.impl?.provideFollowups?w.impl.provideFollowups(u,r,c,s):[]}};e.ChatAgentService=i,e.ChatAgentService=i=Ge([Ue(0,y.IContextKeyService)],i);class n{constructor(t,u){this.data=t,this.impl=u}get id(){return this.data.id}get name(){return this.data.name??""}get description(){return this.data.description??""}get extensionId(){return this.data.extensionId}get extensionPublisherId(){return this.data.extensionPublisherId}get extensionPublisherDisplayName(){return this.data.extensionPublisherDisplayName}get extensionDisplayName(){return this.data.extensionDisplayName}get isDefault(){return this.data.isDefault}get metadata(){return this.data.metadata}get slashCommands(){return this.data.slashCommands}get defaultImplicitVariables(){return this.data.defaultImplicitVariables}get locations(){return this.data.locations}async invoke(t,u,r,c){return this.impl.invoke(t,u,r,c)}async provideFollowups(t,u,r,c){return this.impl.provideFollowups?this.impl.provideFollowups(t,u,r,c):[]}provideWelcomeMessage(t,u){if(this.impl.provideWelcomeMessage)return this.impl.provideWelcomeMessage(t,u)}provideSampleQuestions(t,u){if(this.impl.provideSampleQuestions)return this.impl.provideSampleQuestions(t,u)}}e.MergedChatAgent=n,e.IChatAgentNameService=(0,T.createDecorator)("chatAgentNameService");let l=class{static{f=this}static{this.StorageKey="chat.participantNameRegistry"}constructor(t,u,r,c){if(this.requestService=u,this.logService=r,this.storageService=c,this.registry=(0,b.observableValue)(this,Object.create(null)),this.disposed=!1,!t.chatParticipantRegistry)return;this.url=t.chatParticipantRegistry;const s=c.get(f.StorageKey,-1);try{this.registry.set(JSON.parse(s??"{}"),void 0)}catch{c.remove(f.StorageKey,-1)}this.refresh()}refresh(){this.disposed||this.update().catch(t=>this.logService.warn("Failed to fetch chat participant registry",t)).then(()=>(0,h.timeout)(5*60*1e3)).then(()=>this.refresh())}async update(){const t=await this.requestService.request({type:"GET",url:this.url},O.CancellationToken.None);if(t.res.statusCode!==200)throw new Error("Could not get extensions report.");const u=await(0,S.asJson)(t);if(!u||u.version!==1)throw new Error("Unexpected chat participant registry response.");const r=u.restrictedChatParticipants;this.registry.set(r,void 0),this.storageService.store(f.StorageKey,JSON.stringify(r),-1,1)}getAgentNameRestriction(t){return this.registry.map(r=>r[t.name.toLowerCase()]).map(r=>r?r.some(c=>(0,m.equalsIgnoreCase)(c,c.includes(".")?t.extensionId.value:t.extensionPublisherId)):!0)}dispose(){this.disposed=!0}};e.ChatAgentNameService=l,e.ChatAgentNameService=l=f=Ge([Ue(0,p.IProductService),Ue(1,S.IRequestService),Ue(2,I.ILogService),Ue(3,E.IStorageService)],l)}),define(_e[297],Ce([1,0,2,29,5]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KEYWORD_ACTIVIATION_SETTING_ID=e.IChatService=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.isIDocumentContext=A,e.isIUsedContext=R;function A(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof h.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(O.Range.isIRange)}function R(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(A)}var b;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var m;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})(m||(e.ChatCopyKind=m={})),e.IChatService=(0,L.createDecorator)("IChatService"),e.KEYWORD_ACTIVIATION_SETTING_ID="accessibility.voice.keywordActivation"}),define(_e[144],Ce([1,0,4,7,241]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new h.Emitter,this._onExit=new h.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(b){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=b}onEvent(b){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=b}onRequest(b){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=b}sendResponse(b){b.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.internalSend("response",b)}sendRequest(b,m,y,T){const I={command:b};if(m&&Object.keys(m).length>0&&(I.arguments=m),this.internalSend("request",I),typeof T=="number"){const p=setTimeout(()=>{clearTimeout(p);const S=this.pendingRequests.get(I.seq);if(S){this.pendingRequests.delete(I.seq);const E={type:"response",seq:0,request_seq:I.seq,success:!1,command:b,message:(0,L.localize)(0,null,T,b)};S(E)}},T)}return y&&this.pendingRequests.set(I.seq,y),I.seq}acceptMessage(b){this.messageCallback?this.messageCallback(b):(this.queue.push(b),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(b,m){return b.type!=="event"||m.type!=="event"}async processQueue(){let b;for(;this.queue.length;){if((!b||this.needsTaskBoundaryBetween(this.queue[0],b))&&await(0,O.timeout)(0),b=this.queue.shift(),!b)return;switch(b.type){case"event":this.eventCallback?.(b);break;case"request":this.requestCallback?.(b);break;case"response":{const m=b,y=this.pendingRequests.get(m.request_seq);y&&(this.pendingRequests.delete(m.request_seq),y(m));break}}}}internalSend(b,m){m.type=b,m.seq=this.sequence++,this.sendMessage(m)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const b=new Map;this.pendingRequests.forEach((m,y)=>b.set(y,m)),await(0,O.timeout)(500),b.forEach((m,y)=>{m({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(y)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(_e[298],Ce([1,0,2,242,38,5]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_EXTENSIONID=e.CONTEXT_VARIABLE_LANGUAGE=e.CONTEXT_VARIABLE_NAME=e.CONTEXT_VARIABLE_INTERFACES=e.CONTEXT_VARIABLE_TYPE=e.CONTEXT_VARIABLE_VALUE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_HAS_MODES=e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.getStateLabel=m,e.isFrameDeemphasized=T,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new L.RawContextKey("debugType",void 0,{type:"string",description:O.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new L.RawContextKey("debugConfigurationType",void 0,{type:"string",description:O.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new L.RawContextKey("debugState","inactive",{type:"string",description:O.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new L.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:O.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new L.RawContextKey("hasDebugged",!1,{type:"boolean",description:O.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new L.RawContextKey("inDebugMode",!1,{type:"boolean",description:O.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new L.RawContextKey("inDebugRepl",!1,{type:"boolean",description:O.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new L.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:O.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new L.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:O.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new L.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:O.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new L.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:O.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new L.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:O.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new L.RawContextKey("variablesFocused",!0,{type:"boolean",description:O.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new L.RawContextKey("expressionSelected",!1,{type:"boolean",description:O.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new L.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:O.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new L.RawContextKey("callStackItemType",void 0,{type:"string",description:O.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new L.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:O.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new L.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:O.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new L.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:O.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new L.RawContextKey("watchItemType",void 0,{type:"string",description:O.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new L.RawContextKey("canViewMemory",void 0,{type:"boolean",description:O.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new L.RawContextKey("breakpointItemType",void 0,{type:"string",description:O.localize(21,null)}),e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=new L.RawContextKey("breakpointItemBytes",void 0,{type:"boolean",description:O.localize(22,null)}),e.CONTEXT_BREAKPOINT_HAS_MODES=new L.RawContextKey("breakpointHasModes",!1,{type:"boolean",description:O.localize(23,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new L.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:O.localize(24,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new L.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:O.localize(25,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new L.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:O.localize(26,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new L.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:O.localize(27,null)}),e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=new L.RawContextKey("focusedSessionIsNoDebug",!1,{type:"boolean",description:O.localize(28,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new L.RawContextKey("stepBackSupported",!1,{type:"boolean",description:O.localize(29,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new L.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:O.localize(30,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new L.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:O.localize(31,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new L.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:O.localize(32,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new L.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:O.localize(33,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new L.RawContextKey("breakpointsExist",!1,{type:"boolean",description:O.localize(34,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new L.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:O.localize(35,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new L.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:O.localize(36,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new L.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:O.localize(37,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new L.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:O.localize(38,null)}),e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=new L.RawContextKey("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:O.localize(39,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new L.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:O.localize(40,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new L.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:O.localize(41,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new L.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:O.localize(42,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new L.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:O.localize(43,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new L.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:O.localize(44,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new L.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:O.localize(45,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new L.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:O.localize(46,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new L.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:O.localize(47,null)}),e.CONTEXT_VARIABLE_VALUE=new L.RawContextKey("variableValue",!1,{type:"string",description:O.localize(48,null)}),e.CONTEXT_VARIABLE_TYPE=new L.RawContextKey("variableType",!1,{type:"string",description:O.localize(49,null)}),e.CONTEXT_VARIABLE_INTERFACES=new L.RawContextKey("variableInterfaces",!1,{type:"array",description:O.localize(50,null)}),e.CONTEXT_VARIABLE_NAME=new L.RawContextKey("variableName",!1,{type:"string",description:O.localize(51,null)}),e.CONTEXT_VARIABLE_LANGUAGE=new L.RawContextKey("variableLanguage",!1,{type:"string",description:O.localize(52,null)}),e.CONTEXT_VARIABLE_EXTENSIONID=new L.RawContextKey("variableExtensionId",!1,{type:"string",description:O.localize(53,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new L.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:O.localize(54,null)}),e.CONTEXT_MULTI_SESSION_REPL=new L.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:O.localize(55,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new L.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:O.localize(56,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new L.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:O.localize(57,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new L.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:O.localize(58,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new L.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:O.localize(59,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new L.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:O.localize(60,null)});const R=n=>O.localize(61,null,n);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:O.localize(62,null)};var b;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(b||(e.State=b={}));function m(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var y;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";function T(n){return n.source.presentationHint==="deemphasize"||n.presentationHint==="deemphasize"||n.presentationHint==="subtle"}var I;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(I||(e.DataBreakpointSetType=I={}));var p;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(p||(e.DebugConfigurationProviderTriggerKind=p={}));var S;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(S||(e.DebuggerString=S={})),e.IDebugService=(0,A.createDecorator)("debugService");var E;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(E||(e.BreakpointWidgetContext=E={}));var d;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(d||(e.DebugVisualizationType=d={}));var f;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(f||(e.DebugTreeItemCollapsibleState=f={}));var a;(function(n){n.deserialize=l=>l,n.serialize=l=>l})(a||(e.IDebugVisualizationTreeItem=a={}));var i;(function(n){n.deserialize=l=>({id:l.id,name:l.name,iconPath:l.iconPath&&{light:h.URI.revive(l.iconPath.light),dark:h.URI.revive(l.iconPath.dark)},iconClass:l.iconClass,visualization:l.visualization}),n.serialize=l=>l})(i||(e.IDebugVisualization=i={}))}),define(_e[299],Ce([1,0,14,2,17,24,15,29,22,19]),function(ue,e,h,O,L,A,R,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=void 0,e.formatPII=I,e.filterExceptionsFromTelemetry=p,e.isSessionAttach=S,e.getExtensionHostDebugSession=E,e.isDebuggerMainContribution=d,e.getExactExpressionStartAndEnd=f,e.getEvaluatableExpressionAtPosition=a,e.isUri=n,e.convertToDAPaths=t,e.convertToVSCPaths=u,e.getVisibleAndSorted=c,e.saveAllBeforeDebugStart=w;const T=/{([^}]+)}/g;function I(D,v,_){return D.replace(T,function(C,P){return v&&P.length>0&&P[0]!=="_"?C:_&&_.hasOwnProperty(P)?_[P]:C})}function p(D){const v={};for(const _ of Object.keys(D))_.startsWith("!")||(v[_]=D[_]);return v}function S(D){return D.configuration.request==="attach"&&!E(D)&&(!D.parentSession||S(D.parentSession))}function E(D){let v=D.configuration.type;if(v)return v==="vslsShare"&&(v=D.configuration.adapterProxy.configuration.type),(0,h.equalsIgnoreCase)(v,"extensionhost")||(0,h.equalsIgnoreCase)(v,"pwa-extensionhost")?D:D.parentSession?E(D.parentSession):void 0}function d(D){return D.type&&(D.label||D.program||D.runtime)}function f(D,v,_){let C,P=0;const k=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let F=null;for(;F=k.exec(D);){const x=F.index+1,z=x+F[0].length;if(x<=v&&z>=_){C=F[0],P=x;break}}if(C){const x=/\w+/g;let z=null;for(;(z=x.exec(C))&&!(z.index+1+P+z[0].length>=_););z&&(C=C.substring(0,x.lastIndex))}return C?{start:P,end:P+C.length-1}:{start:0,end:0}}async function a(D,v,_,C){if(D.evaluatableExpressionProvider.has(v)){const P=D.evaluatableExpressionProvider.ordered(v),k=(0,y.coalesce)(await Promise.all(P.map(async F=>{try{return await F.provideEvaluatableExpression(v,_,C??m.CancellationToken.None)}catch{return}})));if(k.length>0){let F=k[0].expression;const x=k[0].range;return F||(F=v.getLineContent(_.lineNumber).substring(x.startColumn-1,x.endColumn-1)),{range:x,matchingExpression:F}}}else{const P=v.getLineContent(_.lineNumber),{start:k,end:F}=f(P,_.column,_.column),x=P.substring(k-1,F);return{matchingExpression:x,range:new b.Range(_.lineNumber,k,_.lineNumber,k+x.length)}}return null}const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(D){return!!(D&&D.match(i))}function l(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(n(D.path))return O.URI.parse(D.path);if((0,L.isAbsolute)(D.path))return O.URI.file(D.path)}return D.path}function o(D){if(typeof D.path=="object"){const v=O.URI.revive(D.path);if(v)return v.scheme===R.Schemas.file?v.fsPath:v.toString()}return D.path}function t(D,v){const _=v?l:o,C=(0,A.deepClone)(D);return r(C,(P,k)=>{P&&k&&(k.path=_(k))}),C}function u(D,v){const _=v?l:o,C=(0,A.deepClone)(D);return r(C,(P,k)=>{!P&&k&&(k.path=_(k))}),C}function r(D,v){switch(D.type){case"event":{const _=D;switch(_.event){case"output":v(!1,_.body.source);break;case"loadedSource":v(!1,_.body.source);break;case"breakpoint":v(!1,_.body.breakpoint.source);break;default:break}break}case"request":{const _=D;switch(_.command){case"setBreakpoints":v(!0,_.arguments.source);break;case"breakpointLocations":v(!0,_.arguments.source);break;case"source":v(!0,_.arguments.source);break;case"gotoTargets":v(!0,_.arguments.source);break;case"launchVSCode":_.arguments.args.forEach(C=>v(!1,C));break;default:break}break}case"response":{const _=D;if(_.success&&_.body)switch(_.command){case"stackTrace":_.body.stackFrames.forEach(C=>v(!1,C.source));break;case"loadedSources":_.body.sources.forEach(C=>v(!1,C));break;case"scopes":_.body.scopes.forEach(C=>v(!1,C.source));break;case"setFunctionBreakpoints":_.body.breakpoints.forEach(C=>v(!1,C.source));break;case"setBreakpoints":_.body.breakpoints.forEach(C=>v(!1,C.source));break;case"disassemble":_.body?.instructions.forEach(P=>v(!1,P.location));break;default:break}break}}}function c(D){return D.filter(v=>!v.presentation?.hidden).sort((v,_)=>v.presentation?_.presentation?v.presentation.group?_.presentation.group?v.presentation.group!==_.presentation.group?v.presentation.group.localeCompare(_.presentation.group):s(v.presentation.order,_.presentation.order):-1:_.presentation.group?1:s(v.presentation.order,_.presentation.order):-1:_.presentation?1:0)}function s(D,v){return typeof D!="number"?typeof v!="number"?0:1:typeof v!="number"?-1:D-v}async function w(D,v){const _=D.getValue("debug.saveBeforeStart",{overrideIdentifier:v.activeTextEditorLanguageId});if(_!=="none"&&(await v.saveAll(),_==="allEditorsInActiveGroup")){const C=v.activeEditorPane;C&&C.input.resource?.scheme===R.Schemas.untitled&&await v.save({editor:C.input,groupId:C.group.id})}await D.reloadConfiguration()}const g=(D,v)=>!D||!v?D===v:D.name===v.name&&D.path===v.path&&D.sourceReference===v.sourceReference;e.sourcesEqual=g}),define(_e[300],Ce([1,0,54,63,24,17,12,14,32,243,144]),function(ue,e,h,O,L,A,R,b,m,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class I extends T.AbstractDebugAdapter{static{this.TWO_CRLF=`\r
\r
`}static{this.HEADER_LINESEPARATOR=/\r?\n/}static{this.HEADER_FIELDSEPARATOR=/: */}constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(a,i){this.outputStream=i,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,a.on("data",n=>this.handleData(n))}sendMessage(a){if(this.outputStream){const i=JSON.stringify(a);this.outputStream.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${I.TWO_CRLF}${i}`,"utf8")}}handleData(a){for(this.rawData=Buffer.concat([this.rawData,a]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const i=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this._onError.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.rawData.indexOf(I.TWO_CRLF);if(i!==-1){const l=this.rawData.toString("utf8",0,i).split(I.HEADER_LINESEPARATOR);for(const o of l){const t=o.split(I.HEADER_FIELDSEPARATOR);t[0]==="Content-Length"&&(this.contentLength=Number(t[1]))}this.rawData=this.rawData.slice(i+I.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=I;class p extends I{startSession(){return new Promise((a,i)=>{let n=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),a(),n=!0}),this.socket.on("close",()=>{n?this._onError.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.socket.on("error",l=>{n?this._onError.fire(l):i(l)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=p;class S extends p{constructor(a){super(),this.adapterServer=a}createConnection(a){return O.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",a)}}e.SocketDebugAdapter=S;class E extends p{constructor(a){super(),this.adapterServer=a}createConnection(a){return O.createConnection(this.adapterServer.path,a)}}e.NamedPipeDebugAdapter=E;class d extends I{constructor(a,i){super(),this.adapterExecutable=a,this.debugType=i}async startSession(){const a=this.adapterExecutable.command,i=this.adapterExecutable.args,n=this.adapterExecutable.options||{};try{if(a)if(A.isAbsolute(a)){if(!await m.Promises.exists(a))throw new Error(y.localize(0,null,a))}else a.indexOf("/")<0&&a.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.debugType));let l=process.env;if(n.env&&Object.keys(n.env).length>0&&(l=L.mixin(L.deepClone(process.env),n.env)),a==="node")if(Array.isArray(i)&&i.length>0){const o=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:l,execArgv:o?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const u=h.fork(i[0],i.slice(1),t);if(!u.pid)throw new Error(y.localize(2,null,i[0]));this.serverProcess=u}else throw new Error(y.localize(3,null));else{const o={env:l};n.cwd&&(o.cwd=n.cwd),this.serverProcess=h.spawn(a,i,o)}this.serverProcess.on("error",o=>{this._onError.fire(o)}),this.serverProcess.on("exit",(o,t)=>{this._onExit.fire(o)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",o=>{this._onError.fire(o)}),this.serverProcess.stdin.on("error",o=>{this._onError.fire(o)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(l){this._onError.fire(l)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),R.isWindows?new Promise((a,i)=>{const n=h.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(l,o,t){if(l)return i(l)});n.on("exit",a),n.on("error",i)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(a,i){if(!a)return;const n=Object.create(null);a.runtime&&(a.runtime.indexOf("./")===0?n.runtime=A.join(i,a.runtime):n.runtime=a.runtime),a.runtimeArgs&&(n.runtimeArgs=a.runtimeArgs),a.program&&(A.isAbsolute(a.program)?n.program=a.program:n.program=A.join(i,a.program)),a.args&&(n.args=a.args);const l=a;return l.win&&(n.win=d.extract(l.win,i)),l.winx86&&(n.winx86=d.extract(l.winx86,i)),l.windows&&(n.windows=d.extract(l.windows,i)),l.osx&&(n.osx=d.extract(l.osx,i)),l.linux&&(n.linux=d.extract(l.linux,i)),n}static platformAdapterExecutable(a,i){let n=Object.create(null);i=i.toLowerCase();for(const c of a)if(c.contributes){const s=c.contributes.debuggers;s&&s.length>0&&s.filter(w=>typeof w.type=="string"&&b.equalsIgnoreCase(w.type,i)).forEach(w=>{const g=d.extract(w,c.extensionLocation.fsPath);n=L.mixin(n,g,c.isBuiltin)})}let l;R.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?l=n.winx86||n.win||n.windows:R.isWindows?l=n.win||n.windows:R.isMacintosh?l=n.osx:R.isLinux&&(l=n.linux),l=l||n;const o=l.program||n.program,t=l.args||n.args,u=l.runtime||n.runtime,r=l.runtimeArgs||n.runtimeArgs;if(u)return{type:"executable",command:u,args:(r||[]).concat(typeof o=="string"?[o]:[]).concat(t||[])};if(o)return{type:"executable",command:o,args:t||[]}}}e.ExecutableDebugAdapter=d}),define(_e[301],Ce([1,0,54,31,12]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasChildProcesses=R,e.prepareCommand=m;function A(y,T){return new Promise((I,p)=>{let S="";const E=h.spawn(y,T);E.pid&&E.stdout.on("data",d=>{S+=d.toString()}),E.on("error",d=>{p(d)}),E.on("close",d=>{I(S)})})}async function R(y){if(y)if(L.isWindows){const T=await new Promise((I,p)=>{ue(["@vscode/windows-process-tree"],I,p)});return new Promise(I=>{T.getProcessTree(y,p=>{I(!!p&&p.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(y)]).then(T=>{const I=T.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},T=>!0);return Promise.resolve(!0)}var b;(function(y){y[y.cmd=0]="cmd",y[y.powershell=1]="powershell",y[y.bash=2]="bash"})(b||(b={}));function m(y,T,I,p,S){y=y.trim().toLowerCase();let E;y.indexOf("powershell")>=0||y.indexOf("pwsh")>=0?E=1:y.indexOf("cmd.exe")>=0?E=0:y.indexOf("bash")>=0?E=2:L.isWindows?E=0:E=2;let d,f=" ";switch(E){case 1:if(d=a=>(a=a.replace(/\'/g,"''"),a.length>0&&a.charAt(a.length-1)==="\\"?`'${a}\\'`:`'${a}'`),p){const a=(0,O.getDriveLetter)(p);a&&(f+=`${a}:; `),f+=`cd ${d(p)}; `}if(S)for(const a in S){const i=S[a];i===null?f+=`Remove-Item env:${a}; `:f+=`\${env:${a}}='${i}'; `}if(T.length>0){const a=T.shift(),i=I?a:d(a);f+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of T)f+=n==="<"||n===">"||I?n:d(n),f+=" "}break;case 0:if(d=a=>(a=a.replace(/\"/g,'""'),a=a.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>a.includes(i))||a.length===0?`"${a}"`:a),p){const a=(0,O.getDriveLetter)(p);a&&(f+=`${a}: && `),f+=`cd ${d(p)} && `}if(S){f+='cmd /C "';for(const a in S){let i=S[a];i===null?f+=`set "${a}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),f+=`set "${a}=${i}" && `)}}for(const a of T)f+=a==="<"||a===">"||I?a:d(a),f+=" ";S&&(f+='"');break;case 2:{d=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),i.length===0?'""':i);const a=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(p&&(f+=`cd ${d(p)} ; `),S){f+="/usr/bin/env";for(const i in S){const n=S[i];n===null?f+=` -u ${a(i)}`:f+=` ${a(`${i}=${n}`)}`}f+=" "}for(const i of T)f+=i==="<"||i===">"||I?i:d(i),f+=" ";break}}return f}}),define(_e[302],Ce([1,0,5]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var O;(function(L){L[L.Output=1]="Output",L[L.OutputItems=2]="OutputItems",L[L.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.INotebookExecutionService=(0,h.createDecorator)("INotebookExecutionService")}),define(_e[303],Ce([1,0,5]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookKernelHistoryService=e.INotebookKernelService=e.ProxyKernelState=e.variablePageSize=void 0,e.variablePageSize=100;var O;(function(L){L[L.Disconnected=1]="Disconnected",L[L.Connected=2]="Connected",L[L.Initializing=3]="Initializing"})(O||(e.ProxyKernelState=O={})),e.INotebookKernelService=(0,h.createDecorator)("INotebookKernelService"),e.INotebookKernelHistoryService=(0,h.createDecorator)("INotebookKernelHistoryService")}),define(_e[304],Ce([1,0,3,29,205,100]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellSearchModel=void 0;class R extends h.Disposable{constructor(m,y,T){super(),this._source=m,this._inputTextBuffer=y,this._outputs=T,this._outputTextBuffers=void 0}_getFullModelRange(m){const y=m.getLineCount();return new O.Range(1,1,y,this._getLineMaxColumn(m,y))}_getLineMaxColumn(m,y){if(y<1||y>m.getLineCount())throw new Error("Illegal value for lineNumber");return m.getLineLength(y)+1}get inputTextBuffer(){if(!this._inputTextBuffer){const m=new L.PieceTreeTextBufferBuilder;m.acceptChunk(this._source);const y=m.finish(!0),{textBuffer:T,disposable:I}=y.create(1);this._inputTextBuffer=T,this._register(I)}return this._inputTextBuffer}get outputTextBuffers(){return this._outputTextBuffers||(this._outputTextBuffers=this._outputs.map(m=>{const y=new L.PieceTreeTextBufferBuilder;y.acceptChunk(m);const T=y.finish(!0),{textBuffer:I,disposable:p}=T.create(1);return this._register(p),I})),this._outputTextBuffers}findInInputs(m){const T=new A.SearchParams(m,!1,!1,null).parseSearchRequest();if(!T)return[];const I=this._getFullModelRange(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(I,T,!0,5e3)}findInOutputs(m){const T=new A.SearchParams(m,!1,!1,null).parseSearchRequest();return T?this.outputTextBuffers.map(I=>{const p=I.findMatchesLineByLine(this._getFullModelRange(I),T,!0,5e3);if(p.length!==0)return{textBuffer:I,matches:p}}).filter(I=>!!I):[]}}e.CellSearchModel=R}),define(_e[69],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var h;(function(A){A.Delimiter="\0"})(h||(e.TestIdPathParts=h={}));var O;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class L{static fromExtHostTestItem(R,b,m=R.parent){if(R._isRoot)return new L([b]);const y=[R.id];for(let T=m;T&&T.id!==b;T=T.parent)y.push(T.id);return y.push(b),new L(y.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const b=R.indexOf("\0");return b===-1?R:R.slice(0,b)}static fromString(R){return new L(R.split("\0"))}static join(R,b){return new L([...R.path,b])}static joinToString(R,b){return R.toString()+"\0"+b}static parentId(R){const b=R.lastIndexOf("\0");return b===-1?void 0:R.slice(0,b)}static localId(R){const b=R.lastIndexOf("\0");return b===-1?R:R.slice(b+1)}static isChild(R,b){return b.startsWith(R)&&b[R.length]==="\0"}static compare(R,b){return R===b?0:L.isChild(R,b)?2:L.isChild(b,R)?3:1}constructor(R,b=R.length){if(this.path=R,this.viewEnd=b,R.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new L(this.path,1)}get parentId(){return this.viewEnd>1?new L(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new L(this.path,R)}*idsToRoot(){for(let R=this.viewEnd;R>0;R--)yield new L(this.path,R)}compare(R){if(typeof R=="string")return L.compare(this.toString(),R);for(let b=0;b<R.viewEnd&&b<this.viewEnd;b++)if(R.path[b]!==this.path[b])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=L}),define(_e[89],Ce([1,0,2,51,29,69]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.KEEP_N_LAST_COVERAGE_REPORTS=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.testResultStateToContextValues=e.TestResultState=void 0;var R;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.testResultStateToContextValues={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var b;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var m;(function(N){N[N.Run=2]="Run",N[N.Debug=4]="Debug",N[N.Coverage=8]="Coverage",N[N.HasNonDefaultProfile=16]="HasNonDefaultProfile",N[N.HasConfigurable=32]="HasConfigurable",N[N.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const y=N=>"runId"in N;e.isStartControllerTests=y;var T;(function(N){N.serialize=M=>({range:M.range.toJSON(),uri:M.uri.toJSON()}),N.deserialize=(M,W)=>({range:L.Range.lift(W.range),uri:M.asCanonicalUri(h.URI.revive(W.uri))})})(T||(e.IRichLocation=T={}));var I;(function(N){N[N.Error=0]="Error",N[N.Output=1]="Output"})(I||(e.TestMessageType=I={}));var p;(function(N){N.serialize=M=>({message:M.message,type:0,expected:M.expected,actual:M.actual,contextValue:M.contextValue,location:M.location&&T.serialize(M.location)}),N.deserialize=(M,W)=>({message:W.message,type:0,expected:W.expected,actual:W.actual,contextValue:W.contextValue,location:W.location&&T.deserialize(M,W.location)})})(p||(e.ITestErrorMessage=p={}));const S=(N,M)=>`${M?"s":"e"}${N}`;e.getMarkId=S;var E;(function(N){N.serialize=M=>({message:M.message,type:1,offset:M.offset,length:M.length,location:M.location&&T.serialize(M.location)}),N.deserialize=(M,W)=>({message:W.message,type:1,offset:W.offset,length:W.length,location:W.location&&T.deserialize(M,W.location)})})(E||(e.ITestOutputMessage=E={}));var d;(function(N){N.serialize=M=>M.type===0?p.serialize(M):E.serialize(M),N.deserialize=(M,W)=>W.type===0?p.deserialize(M,W):E.deserialize(M,W)})(d||(e.ITestMessage=d={}));var f;(function(N){N.serializeWithoutMessages=M=>({state:M.state,duration:M.duration,messages:[]}),N.serialize=M=>({state:M.state,duration:M.duration,messages:M.messages.map(d.serialize)}),N.deserialize=(M,W)=>({state:W.state,duration:W.duration,messages:W.messages.map(X=>d.deserialize(M,X))})})(f||(e.ITestTaskState=f={}));const a="\0",i=(N,M)=>N+a+M;e.namespaceTestTag=i;const n=N=>{const M=N.indexOf(a);return{ctrlId:N.slice(0,M),tagId:N.slice(M+1)}};e.denamespaceTestTag=n;var l;(function(N){N.serialize=M=>({extId:M.extId,label:M.label,tags:M.tags,busy:M.busy,children:void 0,uri:M.uri?.toJSON(),range:M.range?.toJSON()||null,description:M.description,error:M.error,sortText:M.sortText}),N.deserialize=(M,W)=>({extId:W.extId,label:W.label,tags:W.tags,busy:W.busy,children:void 0,uri:W.uri?M.asCanonicalUri(h.URI.revive(W.uri)):void 0,range:W.range?L.Range.lift(W.range):null,description:W.description,error:W.error,sortText:W.sortText})})(l||(e.ITestItem=l={}));var o;(function(N){N[N.NotExpandable=0]="NotExpandable",N[N.Expandable=1]="Expandable",N[N.BusyExpanding=2]="BusyExpanding",N[N.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var t;(function(N){N.serialize=M=>({expand:M.expand,item:l.serialize(M.item)}),N.deserialize=(M,W)=>({controllerId:A.TestId.root(W.item.extId),expand:W.expand,item:l.deserialize(M,W.item)})})(t||(e.InternalTestItem=t={}));var u;(function(N){N.serialize=M=>{let W;return M.item&&(W={},M.item.label!==void 0&&(W.label=M.item.label),M.item.tags!==void 0&&(W.tags=M.item.tags),M.item.busy!==void 0&&(W.busy=M.item.busy),M.item.uri!==void 0&&(W.uri=M.item.uri?.toJSON()),M.item.range!==void 0&&(W.range=M.item.range?.toJSON()),M.item.description!==void 0&&(W.description=M.item.description),M.item.error!==void 0&&(W.error=M.item.error),M.item.sortText!==void 0&&(W.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:W}},N.deserialize=M=>{let W;return M.item&&(W={},M.item.label!==void 0&&(W.label=M.item.label),M.item.tags!==void 0&&(W.tags=M.item.tags),M.item.busy!==void 0&&(W.busy=M.item.busy),M.item.range!==void 0&&(W.range=M.item.range?L.Range.lift(M.item.range):null),M.item.description!==void 0&&(W.description=M.item.description),M.item.error!==void 0&&(W.error=M.item.error),M.item.sortText!==void 0&&(W.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:W}}})(u||(e.ITestItemUpdate=u={}));const r=(N,M)=>{M.expand!==void 0&&(N.expand=M.expand),M.item!==void 0&&(N.item=N.item?Object.assign(N.item,M.item):M.item)};e.applyTestItemUpdate=r;var c;(function(N){N.serializeWithoutMessages=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(f.serializeWithoutMessages)}),N.serialize=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(f.serialize)}),N.deserialize=(M,W)=>({...t.deserialize(M,W),ownComputedState:W.ownComputedState,computedState:W.computedState,tasks:W.tasks.map(X=>f.deserialize(M,X)),retired:!0})})(c||(e.TestResultItem=c={}));var s;(function(N){N.empty=()=>({covered:0,total:0}),N.sum=(M,W)=>{M.covered+=W.covered,M.total+=W.total}})(s||(e.ICoverageCount=s={}));var w;(function(N){N.serialize=M=>({id:M.id,statement:M.statement,branch:M.branch,declaration:M.declaration,uri:M.uri.toJSON()}),N.deserialize=(M,W)=>({id:W.id,statement:W.statement,branch:W.branch,declaration:W.declaration,uri:M.asCanonicalUri(h.URI.revive(W.uri))})})(w||(e.IFileCoverage=w={}));function g(N){return{...N,location:N.location?.toJSON()}}function D(N){return N.location=N.location?O.Position.isIPosition(N.location)?O.Position.lift(N.location):L.Range.lift(N.location):void 0,N}e.KEEP_N_LAST_COVERAGE_REPORTS=3;var v;(function(N){N[N.Declaration=0]="Declaration",N[N.Statement=1]="Statement",N[N.Branch=2]="Branch"})(v||(e.DetailType=v={}));var _;(function(N){N.serialize=M=>M.type===0?P.serialize(M):k.serialize(M),N.deserialize=M=>M.type===0?P.deserialize(M):k.deserialize(M)})(_||(e.CoverageDetails=_={}));var C;(function(N){N.serialize=g,N.deserialize=D})(C||(e.IBranchCoverage=C={}));var P;(function(N){N.serialize=g,N.deserialize=D})(P||(e.IDeclarationCoverage=P={}));var k;(function(N){N.serialize=M=>({...g(M),branches:M.branches?.map(C.serialize)}),N.deserialize=M=>({...D(M),branches:M.branches?.map(C.deserialize)})})(k||(e.IStatementCoverage=k={}));var F;(function(N){N[N.Add=0]="Add",N[N.Update=1]="Update",N[N.DocumentSynced=2]="DocumentSynced",N[N.Remove=3]="Remove",N[N.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",N[N.Retire=5]="Retire",N[N.AddTag=6]="AddTag",N[N.RemoveTag=7]="RemoveTag"})(F||(e.TestDiffOpType=F={}));var x;(function(N){N.deserialize=(M,W)=>W.op===0?{op:W.op,item:t.deserialize(M,W.item)}:W.op===1?{op:W.op,item:u.deserialize(W.item)}:W.op===2?{op:W.op,uri:M.asCanonicalUri(h.URI.revive(W.uri)),docv:W.docv}:W,N.serialize=M=>M.op===0?{op:M.op,item:t.serialize(M.item)}:M.op===1?{op:M.op,item:u.serialize(M.item)}:M})(x||(e.TestsDiffOp=x={}));class z{constructor(M){this.uriIdentity=M,this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(M){const W=this.createChangeCollector();for(const X of M)switch(X.op){case 0:this.add(t.deserialize(this.uriIdentity,X.item),W);break;case 1:this.update(u.deserialize(X.item),W);break;case 3:this.remove(X.itemId,W);break;case 5:this.retireTest(X.itemId);break;case 4:this.updatePendingRoots(X.amount);break;case 6:this._tags.set(X.tag.id,X.tag);break;case 7:this._tags.delete(X.id);break}W.complete?.()}add(M,W){const X=A.TestId.parentId(M.item.extId)?.toString();let te;if(!X)te=this.createItem(M),this.roots.add(te),this.items.set(M.item.extId,te);else if(this.items.has(X)){const H=this.items.get(X);H.children.add(M.item.extId),te=this.createItem(M,H),this.items.set(M.item.extId,te)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(M)}`);return}return W.add?.(te),M.expand===2&&this.busyControllerCount++,te}update(M,W){const X=this.items.get(M.extId);if(X)return M.expand!==void 0&&(X.expand===2&&this.busyControllerCount--,M.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(X,M),W.update?.(X),X}remove(M,W){const X=this.items.get(M);if(!X)return;const te=A.TestId.parentId(X.item.extId)?.toString();te?this.items.get(te).children.delete(X.item.extId):this.roots.delete(X);const H=[[M]];for(;H.length;)for(const G of H.pop()){const Y=this.items.get(G);Y&&(H.push(Y.children),this.items.delete(G),W.remove?.(Y,Y!==X),Y.expand===2&&this.busyControllerCount--)}}retireTest(M){}updatePendingRoots(M){this.pendingRootCount+=M}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=z}),define(_e[113],Ce([1,0,7,4,3,62,89,69]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var m;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const y=(i,n)=>i===n,I=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:y,label:y,description:y,error:y,sortText:y,tags:(i,n)=>!(i.length!==n.length||i.some(l=>!n.includes(l)))}),p=(i,n)=>{let l;for(const[o,t]of I)t(i[o],n[o])||(l?l[o]=n[o]:l={[o]:n[o]});return l};class S extends L.Disposable{get root(){return this.options.root}constructor(n){super(),this.options=n,this.debounceSendDiff=this._register(new h.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new O.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const l of this.tree.values())this.updateExpandability(l)}get resolveHandler(){return this._resolveHandler}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){switch(n.op){case 2:{for(const l of this.diff)if(l.op===2&&l.uri===n.uri){l.docv=n.docv;return}break}case 1:{const l=this.diff[this.diff.length-1];if(l){if(l.op===1&&l.item.extId===n.item.extId){(0,R.applyTestItemUpdate)(l.item,n.item);return}if(l.op===0&&l.item.item.extId===n.item.extId){(0,R.applyTestItemUpdate)(l.item,n.item);return}}break}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,l){const o=this.tree.get(n);if(o){if((o.expandLevels===void 0||l>o.expandLevels)&&(o.expandLevels=l),o.expand===1){const t=this.resolveChildren(o);return t.isOpen()?this.expandChildren(o,l-1):t.wait().then(()=>this.expandChildren(o,l-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.expandChildren(o,l-1)):this.expandChildren(o,l-1)}}dispose(){for(const n of this.tree.values())this.options.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,l){switch(l.op){case 3:this.removeItem(b.TestId.joinToString(n.fullId,l.id));break;case 0:this.upsertItem(l.item,n);break;case 5:for(const o of l.ops)this.onTestItemEvent(n,o);break;case 1:this.diffTagRefs(l.new,l.old,n.fullId.toString());break;case 2:this.updateExpandability(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:l.update}});break;case 6:this.documentSynced(n.actual.uri);break;default:(0,A.assertNever)(l)}}documentSynced(n){n&&this.pushDiff({op:2,uri:n,docv:this.options.getDocumentVersion(n)})}upsertItem(n,l){const o=b.TestId.fromExtHostTestItem(n,this.root.id,l?.actual),t=this.options.getApiFor(n);t.parent&&t.parent!==l?.actual&&this.options.getChildren(t.parent).delete(n.id);let u=this.tree.get(o.toString());if(!u){u={fullId:o,actual:n,expandLevels:l?.expandLevels?l.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(u.fullId.toString(),u),this.setItemParent(n,l),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:u.expand,item:this.options.toITestItem(n)}}),this.connectItemAndChildren(n,u,l);return}if(u.actual===n){this.connectItem(n,u,l);return}if(u.actual.uri?.toString()!==n.uri?.toString())return this.removeItem(o.toString()),this.upsertItem(n,l);const r=this.options.getChildren(u.actual),c=u.actual,s=p(this.options.toITestItem(c),this.options.toITestItem(n));this.options.getApiFor(c).listener=void 0,u.actual=n,u.resolveBarrier=void 0,u.expand=0,s&&(s.hasOwnProperty("tags")&&(this.diffTagRefs(n.tags,c.tags,o.toString()),delete s.tags),this.onTestItemEvent(u,{op:4,update:s})),this.connectItemAndChildren(n,u,l);for(const[g,D]of r)this.options.getChildren(n).get(D.id)||this.removeItem(b.TestId.joinToString(o,D.id));const w=u.expandLevels;w!==void 0&&queueMicrotask(()=>{u.expand===1&&(u.expandLevels=void 0,this.expand(o.toString(),w))}),this.documentSynced(u.actual.uri)}diffTagRefs(n,l,o){const t=new Set(l.map(u=>u.id));for(const u of n)t.delete(u.id)||this.incrementTagRefs(u);this.pushDiff({op:1,item:{extId:o,item:{tags:n.map(u=>(0,R.namespaceTestTag)(this.options.controllerId,u.id))}}}),t.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const l=this.tags.get(n.id);l?l.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.namespaceTestTag)(this.options.controllerId,n.id)}}))}decrementTagRefs(n){const l=this.tags.get(n);l&&!--l.refCount&&(this.tags.delete(n),this.pushDiff({op:7,id:(0,R.namespaceTestTag)(this.options.controllerId,n)}))}setItemParent(n,l){this.options.getApiFor(n).parent=l&&l.actual!==this.root?l.actual:void 0}connectItem(n,l,o){this.setItemParent(n,o);const t=this.options.getApiFor(n);t.parent=o?.actual,t.listener=u=>this.onTestItemEvent(l,u),this.updateExpandability(l)}connectItemAndChildren(n,l,o){this.connectItem(n,l,o);for(const[t,u]of this.options.getChildren(n))this.upsertItem(u,l)}updateExpandability(n){let l;this._resolveHandler?n.resolveBarrier?l=n.resolveBarrier.isOpen()?3:2:l=n.actual.canResolveChildren?1:0:l=0,l!==n.expand&&(n.expand=l,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:l}}),l===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,l){if(l<0)return;const o=[];for(const[t,u]of this.options.getChildren(n.actual)){const r=this.expand(b.TestId.joinToString(n.fullId,u.id),l);(0,h.isThenable)(r)&&o.push(r)}if(o.length)return Promise.all(o).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const u=new h.Barrier;return u.open(),u}n.expand=2,this.pushExpandStateUpdate(n);const l=n.resolveBarrier=new h.Barrier,o=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,u)};let t;try{t=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(u){o(u)}return(0,h.isThenable)(t)?t.catch(o).then(()=>{l.open(),this.updateExpandability(n)}):(l.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}removeItem(n){const l=this.tree.get(n);if(!l)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const o=[l];for(;o.length;){const t=o.pop();if(t){this.options.getApiFor(t.actual).listener=void 0;for(const u of t.actual.tags)this.decrementTagRefs(u.id);this.tree.delete(t.fullId.toString());for(const[u,r]of this.options.getChildren(t.actual))o.push(this.tree.get(b.TestId.joinToString(t.fullId,r.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.TestItemCollection=S;class E extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.DuplicateTestItemError=E;class d extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class f extends Error{constructor(n,l,o){super(`TestItem with ID "${n}" is from controller "${l}" and cannot be added as a child of an item from controller "${o}".`)}}e.MixedTestItemController=f;const a=(i,n,l)=>{let o=new Map;return{get size(){return o.size},forEach(t,u){for(const r of o.values())t.call(u,r,this)},[Symbol.iterator](){return o.entries()},replace(t){const u=new Map,r=new Set(o.keys()),c={op:5,ops:[]};for(const s of t){if(!(s instanceof l))throw new d(s.id);const w=n(s).controllerId;if(w!==i.controllerId)throw new f(s.id,w,i.controllerId);if(u.has(s.id))throw new E(s.id);u.set(s.id,s),r.delete(s.id),c.ops.push({op:0,item:s})}for(const s of r.keys())c.ops.push({op:3,id:s});i.listener?.(c),o=u},add(t){if(!(t instanceof l))throw new d(t.id);o.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){o.delete(t)&&i.listener?.({op:3,id:t})},get(t){return o.get(t)},toJSON(){return Array.from(o.values())}}};e.createTestItemChildren=a}),define(_e[145],Ce([1,0,113]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const O=new WeakMap,L=(R,b)=>{const m={controllerId:b};return O.set(R,m),m};e.createPrivateApiFor=L;const A=R=>{const b=O.get(R);if(!b)throw new h.InvalidTestItemError(R?.id||"<unknown>");return b};e.getPrivateApiFor=A}),define(_e[114],Ce([1,0,15,2]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.asWebviewUri=L,e.decodeAuthority=R,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function L(b,m){return b.scheme===h.Schemas.http||b.scheme===h.Schemas.https?b:(m&&m.authority&&m.isRemote&&b.scheme===h.Schemas.file&&(b=O.URI.from({scheme:h.Schemas.vscodeRemote,authority:m.authority,path:b.path})),O.URI.from({scheme:h.Schemas.https,authority:`${b.scheme}+${A(b.authority)}.${e.webviewRootResourceAuthority}`,path:b.path,fragment:b.fragment,query:b.query}))}function A(b){return b.replace(/./g,m=>{const y=m.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?m:"-"+y.toString(16).padStart(4,"0")})}function R(b){return b.replace(/-([0-9a-f]{4})/g,(m,y)=>String.fromCharCode(parseInt(y,16)))}}),define(_e[305],Ce([1,0,4,3,114]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(b,m,y){this._proxy=b,this._editors=m,this._remoteInfo=y,this._handlePool=0,this._disposables=new O.DisposableStore,this._insets=new Map,this._disposables.add(m.onDidChangeVisibleTextEditors(()=>{const T=m.getVisibleTextEditors();for(const I of this._insets.values())T.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(b=>b.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(b,m,y,T,I){let p;for(const n of this._editors.getVisibleTextEditors(!0))if(n.value===b){p=n;break}if(!p)throw new Error("not a visible editor");const S=this,E=this._handlePool++,d=new h.Emitter,f=new h.Emitter,a=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(n){return(0,L.asWebviewUri)(n,S._remoteInfo)}get cspSource(){return L.webviewGenericCspSource}set options(n){this._options=n,S._proxy.$setOptions(E,n)}get options(){return this._options}set html(n){this._html=n,S._proxy.$setHtml(E,n)}get html(){return this._html}get onDidReceiveMessage(){return d.event}postMessage(n){return S._proxy.$postMessage(E,n)}},i=new class{constructor(){this.editor=b,this.line=m,this.height=y,this.webview=a,this.onDidDispose=f.event}dispose(){S._insets.has(E)&&(S._insets.delete(E),S._proxy.$disposeEditorInset(E),f.fire(),f.dispose(),d.dispose())}};return this._proxy.$createEditorInset(E,p.id,p.value.document.uri,m+1,y,T||{},I.identifier,I.extensionLocation),this._insets.set(E,{editor:b,inset:i,onDidReceiveMessage:d}),i}$onDidDispose(b){const m=this._insets.get(b);m&&m.inset.dispose()}$onDidReceiveMessage(b,m){this._insets.get(b)?.onDidReceiveMessage.fire(m)}}e.ExtHostEditorInsets=A}),define(_e[146],Ce([1,0,5]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuthenticationExtensionsService=e.IAuthenticationService=e.INTERNAL_AUTH_PROVIDER_PREFIX=void 0,e.INTERNAL_AUTH_PROVIDER_PREFIX="__",e.IAuthenticationService=(0,h.createDecorator)("IAuthenticationService"),e.IAuthenticationExtensionsService=(0,h.createDecorator)("IAuthenticationExtensionsService")}),define(_e[306],Ce([1,0,5]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,h.createDecorator)("configurationResolverService");var O;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator",A.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class L extends Error{constructor(R,b){super(b),this.variable=R}}e.VariableError=L}),define(_e[307],Ce([1,0,17,52,18,24,12,103,246,306,14]),function(ue,e,h,O,L,A,R,b,m,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,E,d,f){this._contributedVariables=new Map,this._context=S,this._labelService=E,this._userHomePromise=d,f&&(this._envVariablesPromise=f.then(a=>this.prepareEnv(a)))}prepareEnv(S){if(R.isWindows){const E=Object.create(null);return Object.keys(S).forEach(d=>{E[d.toLowerCase()]=S[d]}),E}return S}resolveWithEnvironment(S,E,d){return this.recursiveResolve({env:this.prepareEnv(S),userHome:void 0},E?E.uri:void 0,d)}async resolveAsync(S,E){const d={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(d,S?S.uri:void 0,E)}async resolveAnyBase(S,E,d,f){const a=A.deepClone(E);R.isWindows&&a.windows?Object.keys(a.windows).forEach(n=>a[n]=a.windows[n]):R.isMacintosh&&a.osx?Object.keys(a.osx).forEach(n=>a[n]=a.osx[n]):R.isLinux&&a.linux&&Object.keys(a.linux).forEach(n=>a[n]=a.linux[n]),delete a.windows,delete a.osx,delete a.linux;const i={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(i,S?S.uri:void 0,a,d,f)}async resolveAnyAsync(S,E,d){return this.resolveAnyBase(S,E,d)}async resolveAnyMap(S,E,d){const f=new Map;return{newConfig:await this.resolveAnyBase(S,E,d,f),resolvedVariables:f}}resolveWithInteractionReplace(S,E,d,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,E,d,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,E){if(this._contributedVariables.has(S))throw new Error("Variable "+S+" is contributed twice.");this._contributedVariables.set(S,E)}async recursiveResolve(S,E,d,f,a){if(L.isString(d))return this.resolveString(S,E,d,f,a);if(Array.isArray(d))return Promise.all(d.map(i=>this.recursiveResolve(S,E,i,f,a)));if(L.isObject(d)){const i=Object.create(null),n=await Promise.all(Object.keys(d).map(async l=>[await this.resolveString(S,E,l,f,a),await this.recursiveResolve(S,E,d[l],f,a)]));for(const[l,o]of n)i[l]=o;return i}return d}resolveString(S,E,d,f,a){return(0,T.replaceAsync)(d,I.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(I.VARIABLE_LHS))return i;let l=await this.evaluateSingleVariable(S,i,n,E,f);return a?.set(n,l),l!==i&&L.isString(l)&&l.match(I.VARIABLE_REGEXP)&&(l=await this.resolveString(S,E,l,f,a)),l})}fsPath(S){return this._labelService?this._labelService.getUriLabel(S,{noPrefix:!0}):S.fsPath}async evaluateSingleVariable(S,E,d,f,a){let i;const n=d.split(":");n.length>1&&(d=n[0],i=n[1]);const l=u=>{const r=this._context.getFilePath();if(r)return(0,b.normalizeDriveLetter)(r);throw new y.VariableError(u,(0,m.localize)(0,null,E))},o=u=>{const r=l(u);if(this._context.getWorkspaceFolderPathForFile){const c=this._context.getWorkspaceFolderPathForFile();if(c)return(0,b.normalizeDriveLetter)(c)}throw new y.VariableError(u,(0,m.localize)(1,null,E,h.basename(r)))},t=u=>{if(i){const r=this._context.getFolderUri(i);if(r)return r;throw new y.VariableError(u,(0,m.localize)(2,null,E,i))}if(f)return f;throw this._context.getWorkspaceFolderCount()>1?new y.VariableError(u,(0,m.localize)(3,null,E)):new y.VariableError(u,(0,m.localize)(4,null,E))};switch(d){case"env":if(i){if(S.env){const u=S.env[R.isWindows?i.toLowerCase():i];if(L.isString(u))return u}return""}throw new y.VariableError(y.VariableKind.Env,(0,m.localize)(5,null,E));case"config":if(i){const u=this._context.getConfigurationValue(f,i);if(L.isUndefinedOrNull(u))throw new y.VariableError(y.VariableKind.Config,(0,m.localize)(6,null,E,i));if(L.isObject(u))throw new y.VariableError(y.VariableKind.Config,(0,m.localize)(7,null,E,i));return u}throw new y.VariableError(y.VariableKind.Config,(0,m.localize)(8,null,E));case"command":return this.resolveFromMap(y.VariableKind.Command,E,i,a,"command");case"input":return this.resolveFromMap(y.VariableKind.Input,E,i,a,"input");case"extensionInstallFolder":if(i){const u=await this._context.getExtension(i);if(!u)throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,m.localize)(9,null,E,i));return this.fsPath(u.extensionLocation)}throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,m.localize)(10,null,E));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,b.normalizeDriveLetter)(this.fsPath(t(y.VariableKind.WorkspaceFolder)));case"cwd":return f||i?(0,b.normalizeDriveLetter)(this.fsPath(t(y.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.normalizeDriveLetter)(h.basename(this.fsPath(t(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new y.VariableError(y.VariableKind.UserHome,(0,m.localize)(11,null,E))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new y.VariableError(y.VariableKind.LineNumber,(0,m.localize)(12,null,E))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new y.VariableError(y.VariableKind.SelectedText,(0,m.localize)(13,null,E))}case"file":return l(y.VariableKind.File);case"fileWorkspaceFolder":return o(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return h.basename(o(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return f||i?h.relative(this.fsPath(t(y.VariableKind.RelativeFile)),l(y.VariableKind.RelativeFile)):l(y.VariableKind.RelativeFile);case"relativeFileDirname":{const u=h.dirname(l(y.VariableKind.RelativeFileDirname));if(f||i){const r=h.relative(this.fsPath(t(y.VariableKind.RelativeFileDirname)),u);return r.length===0?".":r}return u}case"fileDirname":return h.dirname(l(y.VariableKind.FileDirname));case"fileExtname":return h.extname(l(y.VariableKind.FileExtname));case"fileBasename":return h.basename(l(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=h.basename(l(y.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-h.extname(u).length)}case"fileDirnameBasename":return h.basename(h.dirname(l(y.VariableKind.FileDirnameBasename)));case"execPath":{const u=this._context.getExecPath();return u||E}case"execInstallFolder":{const u=this._context.getAppRoot();return u||E}case"pathSeparator":case"/":return h.sep;default:try{const u=i?`${d}:${i}`:d;return this.resolveFromMap(y.VariableKind.Unknown,E,u,a,void 0)}catch{return E}}}}resolveFromMap(S,E,d,f,a){if(d&&f){const i=a===void 0?f[d]:f[a+":"+d];if(typeof i=="string")return i;throw new y.VariableError(S,(0,m.localize)(14,null,E))}return E}}e.AbstractVariableResolverService=I}),define(_e[147],Ce([1,0,5,143]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.isEditorReplacement=y,e.isEditorGroup=p,e.preferredSideBySideGroupDirection=S,e.IEditorGroupsService=(0,h.createDecorator)("editorGroupsService");var L;(function(E){E[E.UP=0]="UP",E[E.DOWN=1]="DOWN",E[E.LEFT=2]="LEFT",E[E.RIGHT=3]="RIGHT"})(L||(e.GroupDirection=L={}));var A;(function(E){E[E.HORIZONTAL=0]="HORIZONTAL",E[E.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var R;(function(E){E[E.FIRST=0]="FIRST",E[E.LAST=1]="LAST",E[E.NEXT=2]="NEXT",E[E.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var b;(function(E){E[E.MAXIMIZE=0]="MAXIMIZE",E[E.EXPAND=1]="EXPAND",E[E.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var m;(function(E){E[E.COPY_EDITORS=0]="COPY_EDITORS",E[E.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function y(E){const d=E;return(0,O.isEditorInput)(d?.editor)&&(0,O.isEditorInput)(d?.replacement)}var T;(function(E){E[E.CREATION_TIME=0]="CREATION_TIME",E[E.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",E[E.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var I;(function(E){E[E.NEW_EDITOR=1]="NEW_EDITOR",E[E.MOVE_EDITOR=2]="MOVE_EDITOR",E[E.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function p(E){const d=E;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}function S(E){return E.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(_e[308],Ce([1,0,5,147]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AUX_WINDOW_GROUP=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.isPreferredGroup=L,e.IEditorService=(0,h.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2,e.AUX_WINDOW_GROUP=-3;function L(A){const R=A;return typeof A=="number"||(0,O.isEditorGroup)(R)}}),define(_e[148],Ce([1,0,5,137]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,h.refineServiceDecorator)(O.IEnvironmentService)}),define(_e[149],Ce([1,0,25,4,17,3,7]),function(ue,e,h,O,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class b{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.DeltaExtensionsResult=b;class m{static isHostExtension(i,n,l){if(n.getExtensionDescription(i))return!1;const o=l.getExtensionDescription(i);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(i,n){this._activationEventsReader=i,this._onDidChange=new O.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(d),this._extensionsMap=new h.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this._extensionsMap.set(i.identifier,i),this._extensionsArr.push(i);const n=this._activationEventsReader.readActivationEvents(i);for(const l of n)this._activationMap.has(l)||this._activationMap.set(l,[]),this._activationMap.get(l).push(i)}}set(i){return this._extensionDescriptions=i,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(i,n){this._extensionDescriptions=f(this._extensionDescriptions,n),this._extensionDescriptions=this._extensionDescriptions.concat(i);const l=m._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=f(this._extensionDescriptions,l.map(o=>o.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new b(this._versionId,l)}static _findLoopingExtensions(i){const n=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(r){this._nodesSet.has(r)||(this._nodesSet.add(r),this._nodesArr.push(r))}addArc(r,c){this.addNode(r),this.addNode(c),this._arcs.has(r)?this._arcs.get(r).push(c):this._arcs.set(r,[c])}getArcs(r){return this._arcs.has(r)?this._arcs.get(r):[]}hasOnlyGoodArcs(r,c){const s=n.getArcs(r);for(let w=0;w<s.length;w++)if(!c.has(s[w]))return!1;return!0}getNodes(){return this._nodesArr}},l=new h.ExtensionIdentifierMap;for(const r of i)if(l.set(r.identifier,r),r.extensionDependencies)for(const c of r.extensionDependencies)n.addArc(h.ExtensionIdentifier.toKey(r.identifier),h.ExtensionIdentifier.toKey(c));const o=new Set;n.getNodes().filter(r=>n.getArcs(r).length===0).forEach(r=>o.add(r));const t=n.getNodes().filter(r=>!o.has(r));let u;do{u=!1;for(let r=0;r<t.length;r++){const c=t[r];n.hasOnlyGoodArcs(c,o)&&(t.splice(r,1),r--,o.add(c),u=!0)}}while(u);return t.map(r=>l.get(r))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this._activationMap.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new y(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this._extensionsMap.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this._extensionsArr)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.ExtensionDescriptionRegistry=m;class y{constructor(i,n){this.versionId=i,this.extensions=n}}e.ExtensionDescriptionRegistrySnapshot=y;class T{constructor(i){this._lock=new S,this._actual=new m(i,[])}async acquireLock(i){const n=await this._lock.acquire(i);return new I(this,n)}deltaExtensions(i,n,l){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(n,l)}containsActivationEvent(i){return this._actual.containsActivationEvent(i)}containsExtension(i){return this._actual.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this._actual.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(i){return this._actual.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this._actual.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this._actual.getExtensionDescriptionByIdOrUUID(i,n)}}e.LockableExtensionDescriptionRegistry=T;class I extends A.Disposable{constructor(i,n){super(),this._registry=i,this._isDisposed=!1,this._register(n)}isAcquiredFor(i){return!this._isDisposed&&this._registry===i}}e.ExtensionDescriptionRegistryLock=I;class p{constructor(i){this.name=i;const n=(0,R.promiseWithResolvers)();this.promise=n.promise,this._resolve=n.resolve}resolve(i){this._resolve(i)}}class S{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(i){const n=new p(i);return this._pendingCustomers.push(n),this._advance(),n.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const i=this._pendingCustomers.shift();this._isLocked=!0;let n=!0;const l=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{n&&(clearTimeout(l),n=!1,this._isLocked=!1,this._advance())};i.resolve((0,A.toDisposable)(o))}}var E;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(E||(E={}));function d(a,i){const n=a.isBuiltin?0:a.isUnderDevelopment?2:1,l=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==l)return n-l;const o=L.posix.basename(a.extensionLocation.path),t=L.posix.basename(i.extensionLocation.path);return o<t?-1:o>t?1:0}function f(a,i){const n=new h.ExtensionIdentifierSet(i);return a.filter(l=>!n.has(l.identifier))}}),define(_e[309],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0,e.writeExtHostConnection=b,e.readExtHostConnection=m;var h;(function(T){T[T.IPC=1]="IPC",T[T.Socket=2]="Socket",T[T.MessagePort=3]="MessagePort"})(h||(e.ExtHostConnectionType=h={}));class O{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[O.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=O;class L{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[L.ENV_KEY]="1"}}e.SocketExtHostConnection=L;class A{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[A.ENV_KEY]="1"}}e.MessagePortExtHostConnection=A;function R(T){delete T[O.ENV_KEY],delete T[L.ENV_KEY],delete T[A.ENV_KEY]}function b(T,I){R(I),T.serialize(I)}function m(T){if(T[O.ENV_KEY])return y(T,new O(T[O.ENV_KEY]));if(T[L.ENV_KEY])return y(T,new L);if(T[A.ENV_KEY])return y(T,new A);throw new Error("No connection information defined in environment!")}function y(T,I){return R(T),I}}),define(_e[115],Ce([1,0,21]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.createMessageOfType=R,e.isMessageOfType=b;var O;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(O||(e.UIKind=O={}));var L;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(L||(e.ExtensionHostExitCode=L={}));var A;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function R(y){const T=h.VSBuffer.alloc(1);switch(y){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}function b(y,T){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}var m;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(_e[90],Ce([1,0,5,4,11,28,115,86,87,24,2,3,231]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0,e.isNewAppInstall=d;let S=class extends I.Disposable{constructor(a,i){super(),this.initData=a,this.loggerService=i,this._onDidChangeTelemetryEnabled=this._register(new O.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new O.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=T.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=i.createLogger(this.extHostTelemetryLogFile,{id:m.extensionTelemetryLogChannelId,name:(0,p.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(this._outputLogger),this._register(i.onDidChangeLogLevel(n=>{(0,L.isLogLevel)(n)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===L.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(a,i,n){const l=this.getTelemetryDetails(),o=new E(i,n,a,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(a),{isUsageEnabled:l.isUsageEnabled,isErrorsEnabled:l.isErrorsEnabled}),t=this._telemetryLoggers.get(a.identifier.value)??[];return this._telemetryLoggers.set(a.identifier.value,[...t,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(a,i,n){this._level=a,this._telemetryIsSupported=i,this._productConfig=n??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(a){const i=Object.create(null);switch(i["common.extname"]=`${a.publisher}.${a.name}`,i["common.extversion"]=a.version,i["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,i["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,i["common.sqmid"]=this.initData.telemetryInfo.sqmId,i["common.vscodeversion"]=this.initData.version,i["common.isnewappinstall"]=d(this.initData.telemetryInfo.firstSessionDate),i["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.getRemoteName)((0,m.cleanRemoteAuthority)(this.initData.remote.authority)),i}$onDidChangeTelemetryLevel(a){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=a;const i=this.getTelemetryDetails();this._telemetryLoggers.forEach((n,l)=>{const o=n.filter(t=>!t.isDisposed);o.length===0?this._telemetryLoggers.delete(l):this._telemetryLoggers.set(l,o)}),this._telemetryLoggers.forEach(n=>{for(const l of n)l.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(a,i){const l=this._telemetryLoggers.get(a.value)?.filter(t=>!t.isDisposed);if(!l)return this._telemetryLoggers.delete(a.value),!1;let o=!1;for(const t of l)t.ignoreUnhandledExtHostErrors||(t.logError(i),o=!0);return o}};e.ExtHostTelemetry=S,e.ExtHostTelemetry=S=Ge([Ue(0,A.IExtHostInitDataService),Ue(1,L.ILoggerService)],S);class E{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,i,n,l,o,t,u){this._extension=n,this._logger=l,this._inLoggingOnlyMode=o,this._commonProperties=t,this._onDidChangeEnableStates=new O.Emitter,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=i?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=i?.additionalCommonProperties,this._sender=a,this._telemetryEnablements={isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}}updateTelemetryEnablements(a,i){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:a,isErrorsEnabled:i},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(a){let i="properties"in a?a.properties??{}:a;return i=(0,m.cleanData)(i,[]),this._additionalCommonProperties&&(i=(0,y.mixin)(i,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(i=(0,y.mixin)(i,this._commonProperties)),"properties"in a?a.properties=i:a=i,a}logEvent(a,i){this._sender&&(this._extension.publisher==="vscode"?a=this._extension.name+"/"+a:a=this._extension.identifier.value+"/"+a,i=this.mixInCommonPropsAndCleanData(i||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(a,i),this._logger.trace(a,i))}logUsage(a,i){this._telemetryEnablements.isUsageEnabled&&this.logEvent(a,i)}logError(a,i){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof a=="string")this.logEvent(a,i);else{const n={name:a.name,message:a.message,stack:a.stack,cause:a.cause},l=(0,m.cleanData)(n,[]),o=new Error(l.message,{cause:l.cause});o.stack=l.stack,o.name=l.name,i=this.mixInCommonPropsAndCleanData(i||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(o,i),this._logger.trace("exception",i)}}get apiTelemetryLogger(){if(!this._apiObject){const a=this,i={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return a._telemetryEnablements.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a._onDidChangeEnableStates.event.bind(a)};this._apiObject=Object.freeze(i)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let a=this._sender;this._sender=void 0,Promise.resolve(a.flush()).then(a=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=E;function d(f){const a=Date.now()-new Date(f).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.IExtHostTelemetry=(0,h.createDecorator)("IExtHostTelemetry")}),define(_e[26],Ce([1,0,4,2,278,140,25,5]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.isProposedApiEnabled=p,e.checkProposedApiEnabled=S,e.toExtension=a,e.toExtensionDescription=i,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,b.createDecorator)("extensionService");class m{constructor(o){this.dependency=o}}e.MissingExtensionDependency=m;var y;(function(l){l[l.EagerAutoStart=1]="EagerAutoStart",l[l.EagerManualStart=2]="EagerManualStart",l[l.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class T{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(o,t,u){this._versionId=o,this._allExtensions=t.slice(0),this._myExtensions=u.slice(0),this._myActivationEvents=null}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:A.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(o,t,u){if(this._versionId>o)throw new Error(`ExtensionHostExtensions: invalid versionId ${o} (current: ${this._versionId})`);const r=[],c=[],s=[],w=[],g=I(this._allExtensions),D=I(t),v=(F,x)=>F.extensionLocation.toString()===x.extensionLocation.toString()||F.isBuiltin===x.isBuiltin||F.isUserBuiltin===x.isUserBuiltin||F.isUnderDevelopment===x.isUnderDevelopment;for(const F of this._allExtensions){const x=D.get(F.identifier);if(!x){r.push(F.identifier),g.delete(F.identifier);continue}if(!v(F,x)){r.push(F.identifier),g.delete(F.identifier);continue}}for(const F of t){const x=g.get(F.identifier);if(!x){c.push(F);continue}if(!v(x,F)){r.push(x.identifier),g.delete(x.identifier);continue}}const _=new R.ExtensionIdentifierSet(this._myExtensions),C=new R.ExtensionIdentifierSet(u);for(const F of this._myExtensions)C.has(F)||s.push(F);for(const F of u)_.has(F)||w.push(F);const P=A.ImplicitActivationEvents.createActivationEventsMap(c),k={versionId:o,toRemove:r,toAdd:c,addActivationEvents:P,myToRemove:s,myToAdd:w};return this.delta(k),k}delta(o){if(this._versionId>=o.versionId)return null;const{toRemove:t,toAdd:u,myToRemove:r,myToAdd:c}=o,s=new R.ExtensionIdentifierSet(t),w=new R.ExtensionIdentifierSet(r);for(let g=0;g<this._allExtensions.length;g++)s.has(this._allExtensions[g].identifier)&&(this._allExtensions.splice(g,1),g--);for(let g=0;g<this._myExtensions.length;g++)w.has(this._myExtensions[g])&&(this._myExtensions.splice(g,1),g--);for(const g of u)this._allExtensions.push(g);for(const g of c)this._myExtensions.push(g);return this._myActivationEvents=null,o}containsExtension(o){for(const t of this._myExtensions)if(R.ExtensionIdentifier.equals(t,o))return!0;return!1}containsActivationEvent(o){return this._myActivationEvents||(this._myActivationEvents=this._readMyActivationEvents()),this._myActivationEvents.has(o)}_readMyActivationEvents(){const o=new Set;for(const t of this._allExtensions){if(!this.containsExtension(t.identifier))continue;const u=A.ImplicitActivationEvents.readActivationEvents(t);for(const r of u)o.add(r)}return o}}e.ExtensionHostExtensions=T;function I(l){const o=new R.ExtensionIdentifierMap;for(const t of l)o.set(t.identifier,t);return o}function p(l,o){return l.enabledApiProposals?l.enabledApiProposals.includes(o):!1}function S(l,o){if(!p(l,o))throw new Error(`Extension '${l.identifier.value}' CANNOT use API proposal: ${o}.
Its package.json#enabledApiProposals-property declares: ${l.enabledApiProposals?.join(", ")??"[]"} but NOT ${o}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${l.identifier.value}`)}class E{constructor(o,t,u,r){this.codeLoadingTime=o,this.activateCallTime=t,this.activateResolvedTime=u,this.activationReason=r}}e.ActivationTimes=E;class d{constructor(o,t){this.description=o,this.value=t}}e.ExtensionPointContribution=d;var f;(function(l){l[l.Normal=0]="Normal",l[l.Immediate=1]="Immediate"})(f||(e.ActivationKind=f={}));function a(l){return{type:l.isBuiltin?0:1,isBuiltin:l.isBuiltin||l.isUserBuiltin,identifier:{id:(0,L.getGalleryExtensionId)(l.publisher,l.name),uuid:l.uuid},manifest:l,location:l.extensionLocation,targetPlatform:l.targetPlatform,validations:[],isValid:!0}}function i(l,o){return{identifier:new R.ExtensionIdentifier((0,L.getExtensionId)(l.manifest.publisher,l.manifest.name)),isBuiltin:l.type===0,isUserBuiltin:l.type===1&&l.isBuiltin,isUnderDevelopment:!!o,extensionLocation:l.location,...l.manifest,uuid:l.identifier.uuid,targetPlatform:l.targetPlatform,publisherDisplayName:l.publisherDisplayName}}class n{constructor(){this.onDidRegisterExtensions=h.Event.None,this.onDidChangeExtensionsStatus=h.Event.None,this.onDidChangeExtensions=h.Event.None,this.onWillActivateByEvent=h.Event.None,this.onDidChangeResponsiveChange=h.Event.None,this.onWillStop=h.Event.None,this.extensions=[]}activateByEvent(o){return Promise.resolve(void 0)}activateById(o,t){return Promise.resolve(void 0)}activationEventIsDone(o){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(o){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(o,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(o){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=n}),define(_e[310],Ce([1,0,13,149,25,26,11,7]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class m{static{this.NONE=new m(!1,-1,-1,-1)}constructor(a,i,n,l){this.startup=a,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=l}}e.ExtensionActivationTimes=m;class y{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,i){return a===-1||i===-1?-1:i-a}build(){return new m(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class T{constructor(a,i,n,l,o,t){this.activationFailed=a,this.activationFailedError=i,this.activationTimes=n,this.module=l,this.exports=o,this.subscriptions=t}}e.ActivatedExtension=T;class I extends T{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=I;class p extends T{constructor(){super(!1,null,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=p;class S extends T{constructor(a){super(!0,a,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let E=class{constructor(a,i,n,l){this._logService=l,this._registry=a,this._globalRegistry=i,this._host=n,this._operations=new L.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[a,i]of this._operations)i.dispose()}async waitForActivatingExtensions(){const a=[];for(const[i,n]of this._operations)a.push(n.wait());await Promise.all(a)}isActivated(a){const i=this._operations.get(a);return!!(i&&i.value)}getActivatedExtension(a){const i=this._operations.get(a);if(!i||!i.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return i.value}async activateByEvent(a,i){if(this._alreadyActivatedEvents[a])return;const n=this._registry.getExtensionDescriptionsForActivationEvent(a);await this._activateExtensions(n.map(l=>({id:l.identifier,reason:{startup:i,extensionId:l.identifier,activationEvent:a}}))),this._alreadyActivatedEvents[a]=!0}activateById(a,i){const n=this._registry.getExtensionDescription(a);if(!n)throw new Error(`Extension '${a.value}' is not known`);return this._activateExtensions([{id:n.identifier,reason:i}])}async _activateExtensions(a){const i=a.filter(n=>!this.isActivated(n.id)).map(n=>this._handleActivationRequest(n));await Promise.all(i.map(n=>n.wait()))}_handleActivationRequest(a){if(this._operations.has(a.id))return this._operations.get(a.id);if(this._isHostExtension(a.id))return this._createAndSaveOperation(a,null,[],null);const i=this._registry.getExtensionDescription(a.id);if(!i){const o=new Error(`Cannot activate unknown extension '${a.id.value}'`),t=this._createAndSaveOperation(a,null,[],new S(o));return this._host.onExtensionActivationError(a.id,o,new A.MissingExtensionDependency(a.id.value)),t}const n=[],l=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const o of l){if(this._isResolvedExtension(o))continue;const t=this._operations.get(o);if(t){n.push(t);continue}if(this._isHostExtension(o)){n.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(o).identifier,reason:a.reason}));continue}const u=this._registry.getExtensionDescription(o);if(u){if(!u.main&&!u.browser)continue;n.push(this._handleActivationRequest({id:u.identifier,reason:a.reason}));continue}const r=i.displayName||i.identifier.value,c=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${o}'`),s=this._createAndSaveOperation(a,i.displayName,[],new S(c));return this._host.onExtensionActivationError(i.identifier,c,new A.MissingExtensionDependency(o)),s}return this._createAndSaveOperation(a,i.displayName,n,null)}_createAndSaveOperation(a,i,n,l){const o=new d(a.id,i,a.reason,n,l,this._host,this._logService);return this._operations.set(a.id,o),o}_isHostExtension(a){return O.ExtensionDescriptionRegistry.isHostExtension(a,this._registry,this._globalRegistry)}_isResolvedExtension(a){const i=this._globalRegistry.getExtensionDescription(a);return i?!i.main&&!i.browser:!1}};e.ExtensionsActivator=E,e.ExtensionsActivator=E=Ge([Ue(3,R.ILogService)],E);let d=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(a,i,n,l,o,t,u){this._id=a,this._displayName=i,this._reason=n,this._deps=l,this._value=o,this._host=t,this._logService=u,this._barrier=new b.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let a=0;a<this._deps.length;a++){const i=this._deps[a];if(i.value&&!i.value.activationFailed){this._deps.splice(a,1),a--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this._value=new S(n),this._host.onExtensionActivationError(this._id,n,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(a=>a.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(a){const i=new Error;if(a&&a.name&&(i.name=a.name),a&&a.message?i.message=`Activating extension '${this._id.value}' failed: ${a.message}.`:i.message=`Activating extension '${this._id.value}' failed: ${a}.`,a&&a.stack&&(i.stack=a.stack),this._value=new S(i),this._isDisposed&&h.isCancellationError(a))return;this._host.onExtensionActivationError(this._id,i,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(a)}}};d=Ge([Ue(6,R.ILogService)],d)}),define(_e[311],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testPreserveFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testPreserveFocus.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(_e[312],Ce([1,0,248,13,41,138,110,36,25,311,108,140]),function(ue,e,h,O,L,A,R,b,m,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const p=b.Registry.as(R.Extensions.JSONContribution);class S{constructor(o,t,u){this._messageHandler=o,this._extension=t,this._extensionPointId=u}_msg(o,t){this._messageHandler({type:o,message:t,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(o){this._msg(L.default.Error,o)}warn(o){this._msg(L.default.Warning,o)}info(o){this._msg(L.default.Info,o)}}e.ExtensionMessageCollector=S;class E{static _toSet(o){const t=new m.ExtensionIdentifierSet;for(let u=0,r=o.length;u<r;u++)t.add(o[u].description.identifier);return t}static compute(o,t){if(!o||!o.length)return new E(t,[]);if(!t||!t.length)return new E([],o);const u=this._toSet(o),r=this._toSet(t),c=t.filter(w=>!u.has(w.description.identifier)),s=o.filter(w=>!r.has(w.description.identifier));return new E(c,s)}constructor(o,t){this.added=o,this.removed=t}}e.ExtensionPointUserDelta=E;class d{constructor(o,t){this.name=o,this.defaultExtensionKind=t,this._handler=null,this._users=null,this._delta=null}setHandler(o){if(this._handler!==null)throw new Error("Handler already set!");this._handler=o,this._handle()}acceptUsers(o){this._delta=E.compute(this._users,o),this._users=o,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(o){(0,O.onUnexpectedError)(o)}}}e.ExtensionPoint=d;const f={type:"string",enum:["ui","workspace"],enumDescriptions:[h.localize(0,null),h.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:h.localize(2,null),properties:{vscode:{type:"string",description:h.localize(3,null),default:"^1.22.0"}}},publisher:{description:h.localize(4,null),type:"string"},displayName:{description:h.localize(5,null),type:"string"},categories:{description:h.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:h.localize(7,null)}]}},galleryBanner:{type:"object",description:h.localize(8,null),properties:{color:{description:h.localize(9,null),type:"string"},theme:{description:h.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:h.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:h.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:h.localize(13,null)},enabledApiProposals:{markdownDescription:h.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:h.localize(15,null),type:"string",enum:["none"],enumDescriptions:[h.localize(16,null)]},activationEvents:{description:h.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:h.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:h.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:h.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:h.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:h.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:h.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:h.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:h.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:h.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:h.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:h.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:h.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:h.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:h.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:h.localize(32,null)},{label:"onUri",body:"onUri",description:h.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:h.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:h.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:h.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:h.localize(37,null)},{label:"onRenderer",description:h.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:h.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:h.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:h.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:h.localize(42,null)},{label:"*",description:h.localize(43,null),body:"*"}]}},badges:{type:"array",description:h.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:h.localize(45,null)},href:{type:"string",description:h.localize(46,null)},description:{type:"string",description:h.localize(47,null)}}}},markdown:{type:"string",description:h.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:h.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:h.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:h.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:h.localize(52,null),type:"array",items:f,default:["workspace"],defaultSnippets:[{body:["ui"],description:h.localize(53,null)},{body:["workspace"],description:h.localize(54,null)},{body:["ui","workspace"],description:h.localize(55,null)},{body:["workspace","ui"],description:h.localize(56,null)},{body:[],description:h.localize(57,null)}]},capabilities:{description:h.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:h.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:h.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[h.localize(61,null),h.localize(62,null),h.localize(63,null)]},description:{type:"string",markdownDescription:h.localize(64,null)}}},untrustedWorkspaces:{description:h.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:h.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[h.localize(67,null),h.localize(68,null),h.localize(69,null)]},restrictedConfigurations:{description:h.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:h.localize(71,null)}}}}},sponsor:{description:h.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:h.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:h.localize(74,null),type:"string"},"vscode:uninstall":{description:h.localize(75,null),type:"string"}}},icon:{type:"string",description:h.localize(76,null)},l10n:{type:"string",description:h.localize(77,null)},pricing:{type:"string",markdownDescription:h.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this._extensionPoints=new Map}registerExtensionPoint(o){if(this._extensionPoints.has(o.extensionPoint))throw new Error("Duplicate extension point: "+o.extensionPoint);const t=new d(o.extensionPoint,o.defaultExtensionKind);return this._extensionPoints.set(o.extensionPoint,t),o.activationEventsGenerator&&I.ImplicitActivationEvents.register(o.extensionPoint,o.activationEventsGenerator),e.schema.properties.contributes.properties[o.extensionPoint]=o.jsonSchema,p.registerSchema(a,e.schema),t}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};b.Registry.add(n.ExtensionsRegistry,new i),e.ExtensionsRegistry=b.Registry.as(n.ExtensionsRegistry),p.registerSchema(a,e.schema),p.registerSchema(T.productSchemaId,{properties:{extensionEnabledApiProposals:{description:h.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(_e[313],Ce([1,0,244,18,24,312,38,4]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:h.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:h.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:h.localize(2,null),default:""}}};var y;(function(p){function S(E,d,f){if(!E)return;const a=O.isString(E.type)?E.type:void 0;if(!a||a.length===0){f.error(h.localize(3,null));return}const i=[];if(Array.isArray(E.required))for(const n of E.required)O.isString(n)&&i.push(n);return{extensionId:d.value,taskType:a,required:i,properties:E.properties?L.deepClone(E.properties):{},when:E.when?R.ContextKeyExpr.deserialize(E.when):void 0}}p.from=S})(y||(y={}));const T=A.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(p,S)=>{for(const E of p)E.type&&S.push(`onTaskType:${E.type}`)},jsonSchema:{description:h.localize(4,null),type:"array",items:m}});class I{constructor(){this._onDefinitionsChanged=new b.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((S,E)=>{T.setHandler((d,f)=>{this._schema=void 0;try{for(const a of f.removed){const i=a.value;for(const n of i)this.taskTypes&&n.type&&this.taskTypes[n.type]&&delete this.taskTypes[n.type]}for(const a of f.added){const i=a.value;for(const n of i){const l=y.from(n,a.description.identifier,a.collector);l&&(this.taskTypes[l.taskType]=l)}}(f.removed.length>0||f.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}S(void 0)})})}onReady(){return this.readyPromise}get(S){return this.taskTypes[S]}all(){return Object.keys(this.taskTypes).map(S=>this.taskTypes[S])}getJsonSchema(){if(this._schema===void 0){const S=[];for(const E of this.all()){const d={type:"object",additionalProperties:!1};E.required.length>0&&(d.required=E.required.slice(0)),E.properties!==void 0?d.properties=L.deepClone(E.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[E.taskType]},S.push(d)}this._schema={oneOf:S}}return this._schema}}e.TaskDefinitionRegistry=new I}),define(_e[314],Ce([1,0,245,18,23,24,38,313]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new R.RawContextKey("taskRunning",!1,h.localize(0,null)),e.TASKS_CATEGORY=h.localize2(2,"Tasks");var m;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(m||(e.ShellQuoting=m={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function M(W){if(!W)return N.Strong;switch(W.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=M}(m||(e.ShellQuoting=m={}));var y;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var T;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(T||(e.RevealKind=T={})),function(N){function M(W){switch(W.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=M}(T||(e.RevealKind=T={}));var I;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(N){function M(W){switch(W.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=M}(I||(e.RevealProblemKind=I={}));var p;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(p||(e.PanelKind=p={})),function(N){function M(W){switch(W.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=M}(p||(e.PanelKind=p={}));var S;(function(N){N.defaults={echo:!0,reveal:T.Always,revealProblems:I.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(S||(e.PresentationOptions=S={}));var E;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(E||(e.RuntimeType=E={})),function(N){function M(X){switch(X.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=M;function W(X){switch(X){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=W}(E||(e.RuntimeType=E={}));var d;(function(N){function M(W){return O.isString(W)?W:W.value}N.value=M})(d||(e.CommandString=d={}));var f;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function M(X){return X===N.Clean._id||X===N.Build._id||X===N.Rebuild._id||X===N.Test._id}N.is=M;function W(X){if(X!==void 0)return O.isString(X)?M(X)?{_id:X,isDefault:!1}:void 0:X}N.from=W})(f||(e.TaskGroup=f={}));var a;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(a||(e.TaskScope=a={}));var i;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function M(W){switch(W){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=M})(i||(e.TaskSourceKind=i={}));var n;(function(N){N.parallel="parallel",N.sequence="sequence"})(n||(e.DependsOrder=n={}));var l;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(l||(e.RunOnOptions=l={}));var o;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:l.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class t{constructor(M,W,X,te,H,G){this._label="",this._id=M,W&&(this._label=W),X&&(this.type=X),this.runOptions=te,this.configurationProperties=H,this._source=G}getDefinition(M){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const M={folder:this.getFolderId(),id:this._id};return JSON.stringify(M)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(M,W=!1){if(M===void 0)return!1;if(O.isString(M))return M===this._label||M===this.configurationProperties.identifier||W&&M===this._id;const X=this.getDefinition(!0);return X!==void 0&&X._key===M._key}getQualifiedLabel(){const M=this.getWorkspaceFolder();return M?`${this._label} (${M.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(M){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),M&&(this._taskLoadMessages=this._taskLoadMessages.concat(M))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class u extends t{constructor(M,W,X,te,H,G,Y,ne){super(M,X,void 0,Y,ne,W),this.command={},this._source=W,this.hasDefinedMatchers=G,H&&(this.command=H)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(M=!1){if(M&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case E.Shell:W="shell";break;case E.Process:W="process";break;case E.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(M){return M instanceof u}getMapKey(){const M=this._source.config.workspaceFolder;return M?`${M.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===i.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const M=this.getFolderId();if(!M)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const X={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:W};return JSON.stringify(X)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(M){return new u(M._id,M._source,M._label,M.type,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.CustomTask=u;class r extends t{constructor(M,W,X,te,H,G,Y){super(M,X,te,G,Y,W),this._source=W,this.configures=H}static is(M){return M instanceof r}fromObject(M){return M}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===i.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getKey(){const M=this.getFolderId();if(!M)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const X={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:W};return JSON.stringify(X)}}e.ConfiguringTask=r;class c extends t{constructor(M,W,X,te,H,G,Y,ne,pe){super(M,X,te,ne,pe,W),this.defines=H,this.hasDefinedMatchers=Y,this.command=G,this.icon=pe.icon,this.hide=pe.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(M){return M instanceof c}getMapKey(){const M=this._source.workspaceFolder;return M?`${this._source.scope.toString()}|${M.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const M={type:"contributed",scope:this._source.scope,id:this._id};return M.folder=this.getFolderId(),JSON.stringify(M)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(M){return new c(M._id,M._source,M._label,M.type,M.defines,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.ContributedTask=c;class s extends t{constructor(M,W,X,te,H,G){super(M,X,te,H,G,W),this._source=W}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(M){return M instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(M){return new s(M._id,M._source,M._label,M.type,M.runOptions,M.configurationProperties)}}e.InMemoryTask=s;var w;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(w||(e.ExecutionEngine=w={})),function(N){N._default=N.Terminal}(w||(e.ExecutionEngine=w={}));var g;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(g||(e.JsonSchemaVersion=g={}));class D{constructor(M){this._order=new Map;for(let W=0;W<M.length;W++)this._order.set(M[W].uri.toString(),W)}compare(M,W){const X=M.getWorkspaceFolder(),te=W.getWorkspaceFolder();if(X&&te){let H=this._order.get(X.uri.toString());H=H===void 0?0:H+1;let G=this._order.get(te.uri.toString());return G=G===void 0?0:G+1,H===G?M._label.localeCompare(W._label):H-G}else return!X&&te?-1:X&&!te?1:0}}e.TaskSorter=D;var v;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(v||(e.TaskEventKind=v={}));var _;(function(N){N.SingleRun="singleRun",N.Background="background"})(_||(e.TaskRunType=_={}));var C;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(C||(e.TaskRunSource=C={}));var P;(function(N){function M(ne){return{taskId:ne._id,taskName:ne.configurationProperties.name,runType:ne.configurationProperties.isBackground?"background":"singleRun",group:ne.configurationProperties.group,__task:ne}}function W(ne,pe,le){return{...M(ne),kind:"start",terminalId:pe,resolvedVariables:le}}N.start=W;function X(ne,pe,le){return{...M(ne),kind:"processStarted",terminalId:pe,processId:le}}N.processStarted=X;function te(ne,pe,le){return{...M(ne),kind:"processEnded",terminalId:pe,exitCode:le}}N.processEnded=te;function H(ne,pe,le){return{...M(ne),kind:"terminated",exitReason:le,terminalId:pe}}N.terminated=H;function G(ne,pe,le){return{...M(pe),kind:ne,terminalId:le}}N.general=G;function Y(){return{kind:"changed"}}N.changed=Y})(P||(e.TaskEvent=P={}));var k;(function(N){function M(X){const te=Object.keys(X).sort();let H="";for(const G of te){let Y=X[G];Y instanceof Object?Y=M(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),H+=G+","+Y+","}return H}function W(X){const H={_key:M(X),type:X.taskType};return Object.assign(H,X),H}N.create=W})(k||(e.KeyedTaskIdentifier=k={}));var F;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(F||(e.TaskSettingId=F={}));var x;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(x||(e.TasksSchemaProperties=x={}));var z;(function(N){function M(W,X){const te=b.TaskDefinitionRegistry.get(W.type);if(te===void 0){const ne=A.deepClone(W);return delete ne._key,k.create(ne)}const H=Object.create(null);H.type=te.taskType;const G=new Set;te.required.forEach(ne=>G.add(ne));const Y=te.properties;for(const ne of Object.keys(Y)){const pe=W[ne];if(pe!=null)H[ne]=pe;else if(G.has(ne)){const le=Y[ne];if(le.default!==void 0)H[ne]=A.deepClone(le.default);else switch(le.type){case"boolean":H[ne]=!1;break;case"number":case"integer":H[ne]=0;break;case"string":H[ne]="";break;default:X.error(h.localize(1,null,JSON.stringify(W,void 0,0),ne));return}}}return k.create(H)}N.createTaskIdentifier=M})(z||(e.TaskDefinition=z={}))}),define(_e[315],Ce([1,0,13]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class O{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((R,b)=>{this._actualOk=R,this._actualErr=b,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(R){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=R,this._actual&&this._actualOk(R))}resolveErr(R){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=R,this._actual?this._actualErr(R):(0,h.onUnexpectedError)(R))}then(R,b){return this._ensureActual().then(R,b)}catch(R){return this._ensureActual().then(void 0,R)}finally(R){return this._ensureActual().finally(R)}}e.LazyPromise=O;class L extends O{constructor(){super(),this._hasErr=!0,this._err=new h.CancellationError}}e.CanceledLazyPromise=L}),define(_e[48],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.ProxyIdentifier=void 0,e.createProxyIdentifier=L,e.getStringIdentifierForProxy=A;class h{static{this.count=0}constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++h.count}}e.ProxyIdentifier=h;const O=[];function L(b){const m=new h(b);return O[m.nid]=m,m}function A(b){return O[b].sid}class R{constructor(m){this.value=m}}e.SerializableObjectWithBuffers=R}),define(_e[6],Ce([1,0,48]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var L;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput",d[d.ChatEditorInput=10]="ChatEditorInput",d[d.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(L||(e.TabInputKind=L={}));var A;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var R;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var b;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var m;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var y;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var T;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(T||(e.CandidatePortSource=T={}));class I{static{this._n=0}static mixin(f){return f._id=I._n++,f}}e.IdObject=I;var p;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var S;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var E;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(E||(e.ExtHostTestingResource=E={})),e.MainContext={MainThreadAuthentication:(0,h.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,h.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,h.createProxyIdentifier)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,h.createProxyIdentifier)("MainThreadChatAgents2"),MainThreadChatVariables:(0,h.createProxyIdentifier)("MainThreadChatVariables"),MainThreadClipboard:(0,h.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,h.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,h.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,h.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,h.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,h.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,h.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,h.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,h.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,h.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,h.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,h.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,h.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,h.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,h.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,h.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,h.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,h.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,h.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,h.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,h.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,h.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,h.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,h.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,h.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,h.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,h.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,h.createProxyIdentifier)("MainThreadStorage"),MainThreadSpeech:(0,h.createProxyIdentifier)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,h.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,h.createProxyIdentifier)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,h.createProxyIdentifier)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,h.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,h.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,h.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,h.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,h.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,h.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,h.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,h.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,h.createProxyIdentifier)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,h.createProxyIdentifier)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,h.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,h.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,h.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,h.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,h.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,h.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,h.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,h.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,h.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,h.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,h.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,h.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,h.createProxyIdentifier)("MainThreadInteractive"),MainThreadInlineChat:(0,h.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,h.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,h.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,h.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,h.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,h.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,h.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,h.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,h.createProxyIdentifier)("MainThreadAiEmbeddingVector")},e.ExtHostContext={ExtHostCommands:(0,h.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,h.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,h.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,h.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,h.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,h.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,h.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,h.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,h.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,h.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,h.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,h.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,h.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,h.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,h.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,h.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,h.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,h.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,h.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,h.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,h.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,h.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,h.createProxyIdentifier)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,h.createProxyIdentifier)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,h.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,h.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,h.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,h.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,h.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,h.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,h.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,h.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,h.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,h.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,h.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,h.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,h.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,h.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,h.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,h.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,h.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,h.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,h.createProxyIdentifier)("ExtHostOutputService"),ExtHostLabelService:(0,h.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,h.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,h.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,h.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,h.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,h.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,h.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,h.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,h.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,h.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,h.createProxyIdentifier)("ExtHostChatVariables"),ExtHostChatProvider:(0,h.createProxyIdentifier)("ExtHostChatProvider"),ExtHostSpeech:(0,h.createProxyIdentifier)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,h.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,h.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,h.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,h.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,h.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,h.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,h.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,h.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,h.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,h.createProxyIdentifier)("ExtHostLocalization")}}),define(_e[91],Ce([1,0,5,11,6,20]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,h.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(m,y){this._extHostLogService=y,this._reportedUsages=new Set,this._telemetryShape=m.getProxy(L.MainContext.MainThreadTelemetry)}report(m,y,T){const I=this.getUsageKey(m,y);this._reportedUsages.has(I)||(this._reportedUsages.add(I),y.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${m}' is deprecated. ${T}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:m}))}getUsageKey(m,y){return`${m}-${y.identifier.value}`}};e.ExtHostApiDeprecationService=R,e.ExtHostApiDeprecationService=R=Ge([Ue(0,A.IExtHostRpcService),Ue(1,O.ILogService)],R),e.NullApiDeprecationService=Object.freeze(new class{report(b,m,y){}})}),define(_e[316],Ce([1,0,6]),function(ue,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class O{constructor(A){const R=A.getProxy(h.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(b){return R.$writeText(b)}})}}e.ExtHostClipboard=O}),define(_e[317],Ce([1,0,24,6,28,20]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let R=class{constructor(T,I){this._mainThreadConsole=T.getProxy(O.MainContext.MainThreadConsole),this._includeStack=I.consoleForward.includeStack,this._logNative=I.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("debug","debug"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(T,I){const p=this,S=console[T];Object.defineProperty(console,T,{set:()=>{},get:()=>function(){p._handleConsoleCall(T,I,S,arguments)}})}_handleConsoleCall(T,I,p,S){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:I,arguments:m(S,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(T,p,S)}};e.AbstractExtHostConsoleForwarder=R,e.AbstractExtHostConsoleForwarder=R=Ge([Ue(0,A.IExtHostRpcService),Ue(1,L.IExtHostInitDataService)],R);const b=1e5;function m(y,T){const I=[];if(y.length)for(let p=0;p<y.length;p++){let S=y[p];if(typeof S>"u")S="undefined";else if(S instanceof Error){const E=S;E.stack?S=E.stack:S=E.toString()}I.push(S)}if(T){const p=new Error().stack;p&&I.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,h.safeStringify)(I);return p.length>b?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(_e[318],Ce([1,0,2,6,26]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(b){this._proxy=b.getProxy(O.MainContext.MainThreadDialogs)}showOpenDialog(b,m){return m?.allowUIResources&&(0,L.checkProposedApiEnabled)(b,"showLocal"),this._proxy.$showOpenDialog(m).then(y=>y?y.map(T=>h.URI.revive(T)):void 0)}showSaveDialog(b){return this._proxy.$showSaveDialog(b).then(m=>m?h.URI.revive(m):void 0)}}e.ExtHostDialogs=A}),define(_e[319],Ce([1,0,3,6]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class L{constructor(R){this._handlePool=0,this._proxy=R.getProxy(O.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const b=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(b,R),(0,h.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(b)})}}e.ExtHostLabelService=L}),define(_e[116],Ce([1,0,12,14,2,5,11,6,28,20]),function(ue,e,h,O,L,A,R,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let T=class{constructor(p,S,E){this.logService=E,this.bundleCache=new Map,this._proxy=S.getProxy(b.MainContext.MainThreadLocalization),this.currentLanguage=p.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===h.LANGUAGE_DEFAULT}getMessage(p,S){const{message:E,args:d,comment:f}=S;if(this.isDefaultLanguage)return(0,O.format2)(E,d??{});let a=E;f&&f.length>0&&(a+=`/${Array.isArray(f)?f.join(""):f}`);const i=this.bundleCache.get(p)?.contents[a];return i||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,O.format2)(i??E,d??{})}getBundle(p){return this.bundleCache.get(p)?.contents}getBundleUri(p){return this.bundleCache.get(p)?.uri}async initializeLocalizedMessages(p){if(this.isDefaultLanguage||!p.l10n&&!p.isBuiltin||this.bundleCache.has(p.identifier.value))return;let S;const E=await this.getBundleLocation(p);if(!E){this.logService.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const d=await this._proxy.$fetchBundleContents(E),f=JSON.parse(d);S=p.isBuiltin?f.contents?.bundle:f}catch(d){this.logService.error(`Failed to load translations for ${p.identifier.value} from ${E}: ${d.message}`);return}S&&this.bundleCache.set(p.identifier.value,{contents:S,uri:E})}async getBundleLocation(p){if(p.isBuiltin){const S=await this._proxy.$fetchBuiltInBundleUri(p.identifier.value,this.currentLanguage);return L.URI.revive(S)}return p.l10n?L.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=T,e.ExtHostLocalizationService=T=Ge([Ue(0,m.IExtHostInitDataService),Ue(1,y.IExtHostRpcService),Ue(2,R.ILogService)],T),e.IExtHostLocalizationService=(0,A.createDecorator)("IExtHostLocalizationService")}),define(_e[150],Ce([1,0,11,6,28,20,2,58]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let m=class extends h.AbstractLoggerService{constructor(I,p){super(p.logLevel,p.logsLocation,p.loggers.map(S=>(0,b.revive)(S))),this._proxy=I.getProxy(O.MainContext.MainThreadLogger)}$setLogLevel(I,p){p?this.setLogLevel(R.URI.revive(p),I):this.setLogLevel(I)}setVisibility(I,p){super.setVisibility(I,p),this._proxy.$setVisibility(I,p)}doCreateLogger(I,p,S){return new y(this._proxy,I,p,S)}};e.ExtHostLoggerService=m,e.ExtHostLoggerService=m=Ge([Ue(0,A.IExtHostRpcService),Ue(1,L.IExtHostInitDataService)],m);class y extends h.AbstractMessageLogger{constructor(I,p,S,E){super(E?.logLevel==="always"),this.proxy=I,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(S),this.proxy.$createLogger(p,E).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(I,p){const S=[[I,p]];this.isLoggerCreated?this.doLog(S):this.buffer.push(...S)}doLog(I){this.proxy.$log(this.file,I)}flush(){this.proxy.$flush(this.file)}}}),define(_e[117],Ce([1,0,6,5,3,20,21]),function(ue,e,h,O,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,O.createDecorator)("IExtHostManagedSockets");let b=class{constructor(I){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=I.getProxy(h.MainContext.MainThreadManagedSockets)}setFactory(I,p){for(const S of this._managedRemoteSockets.values())S.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new m(I,p),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(I){if(!this._factory||this._factory.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const p=++this._remoteSocketIdCounter,S=await this._factory.makeConnection(),E=new L.DisposableStore;return this._managedRemoteSockets.set(p,new y(p,S,E)),E.add((0,L.toDisposable)(()=>this._managedRemoteSockets.delete(p))),E.add(S.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(p),E.dispose()})),E.add(S.onDidClose(d=>{this._proxy.$onDidManagedSocketClose(p,d?.stack??d?.message),E.dispose()})),E.add(S.onDidReceiveMessage(d=>this._proxy.$onDidManagedSocketHaveData(p,R.VSBuffer.wrap(d)))),p}$remoteSocketWrite(I,p){this._managedRemoteSockets.get(I)?.actual.send(p.buffer)}$remoteSocketEnd(I){const p=this._managedRemoteSockets.get(I);p&&(p.actual.end(),p.dispose())}async $remoteSocketDrain(I){await this._managedRemoteSockets.get(I)?.actual.drain?.()}};e.ExtHostManagedSockets=b,e.ExtHostManagedSockets=b=Ge([Ue(0,A.IExtHostRpcService)],b);class m{constructor(I,p){this.socketFactoryId=I,this.makeConnection=p}}class y extends L.Disposable{constructor(I,p,S){super(),this.socketId=I,this.actual=p,this._register(S)}}}),define(_e[320],Ce([1,0,6,11,26]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(b){return b&&b.title}let R=class{constructor(m,y){this._logService=y,this._proxy=m.getProxy(h.MainContext.MainThreadMessageService)}showMessage(m,y,T,I,p){const S={source:{identifier:m.identifier,label:m.displayName||m.name}};let E;typeof I=="string"||A(I)?E=[I,...p]:(S.modal=I?.modal,S.useCustom=I?.useCustom,S.detail=I?.detail,E=p),S.useCustom&&(0,L.checkProposedApiEnabled)(m,"resolvers");const d=[];let f=!1;for(let a=0;a<E.length;a++){const i=E[a];if(typeof i=="string")d.push({title:i,handle:a,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:l}=i;d.push({title:n,isCloseAffordance:!!l,handle:a}),l&&(f?this._logService.warn(`[${m.identifier}] Only one message item can have 'isCloseAffordance':`,i):f=!0)}else this._logService.warn(`[${m.identifier}] Invalid message item:`,i)}return this._proxy.$showMessage(y,T,S,d).then(a=>{if(typeof a=="number")return E[a]})}};e.ExtHostMessageService=R,e.ExtHostMessageService=R=Ge([Ue(1,O.ILogService)],R)}),define(_e[321],Ce([1,0,3,18,2,26,6]),function(ue,e,h,O,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class b{constructor(y){this.handlers=new Map,this.proxy=y.getProxy(R.MainContext.MainThreadProfileContentHandlers)}registerProfileContentHandler(y,T,I){if((0,A.checkProposedApiEnabled)(y,"profileContentHandlers"),this.handlers.has(T))throw new Error(`Handler with id '${T}' already registered`);return this.handlers.set(T,I),this.proxy.$registerProfileContentHandler(T,I.name,I.description,y.identifier.value),(0,h.toDisposable)(()=>{this.handlers.delete(T),this.proxy.$unregisterProfileContentHandler(T)})}async $saveProfile(y,T,I,p){const S=this.handlers.get(y);if(!S)throw new Error(`Unknown handler with id: ${y}`);return S.saveProfile(T,I,p)}async $readProfile(y,T,I){const p=this.handlers.get(y);if(!p)throw new Error(`Unknown handler with id: ${y}`);return p.readProfile((0,O.isString)(T)?T:L.URI.revive(T),I)}}e.ExtHostProfileContentHandlers=b}),define(_e[118],Ce([1,0,6,4,5]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(b){this._onDidChangePassword=new O.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=b.getProxy(h.MainContext.MainThreadSecretState)}async $onDidChangePassword(b){this._onDidChangePassword.fire(b)}get(b,m){return this._proxy.$getPassword(b,m)}store(b,m,y){return this._proxy.$setPassword(b,m,y)}delete(b,m){return this._proxy.$deletePassword(b,m)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,L.createDecorator)("IExtHostSecretState")}),define(_e[322],Ce([1,0,22,3,6]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSpeech=void 0;class A{static{this.ID_POOL=1}constructor(b){this.providers=new Map,this.sessions=new Map,this.proxy=b.getProxy(L.MainContext.MainThreadSpeech)}async $createSpeechToTextSession(b,m,y){const T=this.providers.get(b);if(!T)return;const I=new O.DisposableStore,p=new h.CancellationTokenSource;this.sessions.set(m,p);const S=I.add(T.provideSpeechToTextSession(p.token,y?{language:y}:void 0));I.add(S.onDidChange(E=>{p.token.isCancellationRequested||this.proxy.$emitSpeechToTextEvent(m,E)})),I.add(p.token.onCancellationRequested(()=>I.dispose()))}async $cancelSpeechToTextSession(b){this.sessions.get(b)?.dispose(!0),this.sessions.delete(b)}async $createKeywordRecognitionSession(b,m){const y=this.providers.get(b);if(!y)return;const T=new O.DisposableStore,I=new h.CancellationTokenSource;this.sessions.set(m,I);const p=T.add(y.provideKeywordRecognitionSession(I.token));T.add(p.onDidChange(S=>{I.token.isCancellationRequested||this.proxy.$emitKeywordRecognitionEvent(m,S)})),T.add(I.token.onCancellationRequested(()=>T.dispose()))}async $cancelKeywordRecognitionSession(b){this.sessions.get(b)?.dispose(!0),this.sessions.delete(b)}registerProvider(b,m,y){const T=A.ID_POOL++;return this.providers.set(T,y),this.proxy.$registerProvider(T,m,{extension:b,displayName:b.value}),(0,O.toDisposable)(()=>{this.proxy.$unregisterProvider(T),this.providers.delete(T)})}}e.ExtHostSpeech=A}),define(_e[119],Ce([1,0,6,4,5]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(b,m){this._logService=m,this._onDidChangeStorage=new O.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=b.getProxy(h.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(b,m){this._proxy.$registerExtensionStorageKeysToSync(b,m)}async initializeExtensionStorage(b,m,y){const T=await this._proxy.$initializeExtensionStorage(b,m);let I;return T&&(I=this.safeParseValue(b,m,T)),I||y}setValue(b,m,y){return this._proxy.$setValue(b,m,y)}$acceptValue(b,m,y){const T=this.safeParseValue(b,m,y);T&&this._onDidChangeStorage.fire({shared:b,key:m,value:T})}safeParseValue(b,m,y){try{return JSON.parse(y)}catch(T){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${b}): ${T}`)}}}e.ExtHostStorage=A,e.IExtHostStorage=(0,L.createDecorator)("IExtHostStorage")}),define(_e[323],Ce([1,0,3,15,2,6]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{static{this.supportedSchemes=new Set([O.Schemas.http,O.Schemas.https])}constructor(m){this._openers=new Map,this._proxy=m.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(m,y,T,I){if(this._openers.has(y))throw new Error(`Opener with id '${y}' already registered`);const p=I.schemes.find(S=>!R.supportedSchemes.has(S));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this._openers.set(y,T),this._proxy.$registerUriOpener(y,I.schemes,m,I.label),(0,h.toDisposable)(()=>{this._openers.delete(y),this._proxy.$unregisterUriOpener(y)})}async $canOpenUri(m,y,T){const I=this._openers.get(m);if(!I)throw new Error(`Unknown opener with id: ${m}`);const p=L.URI.revive(y);return I.canOpenExternalUri(p,T)}async $openUri(m,y,T){const I=this._openers.get(m);if(!I)throw new Error(`Unknown opener id: '${m}'`);return I.openExternalUri(L.URI.revive(y.resolvedUri),{sourceUri:L.URI.revive(y.sourceUri)},T)}}e.ExtHostUriOpeners=R}),define(_e[324],Ce([1,0,6,2,3,13,25]),function(ue,e,h,O,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class b{static{this.HandlePool=0}constructor(y){this.handles=new R.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=y.getProxy(h.MainContext.MainThreadUrls)}registerUriHandler(y,T){const I=y.identifier;if(this.handles.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const p=b.HandlePool++;return this.handles.add(I),this.handlers.set(p,T),this._proxy.$registerUriHandler(p,I,y.displayName||y.name),(0,L.toDisposable)(()=>{this.handles.delete(I),this.handlers.delete(p),this._proxy.$unregisterUriHandler(p)})}$handleExternalUri(y,T){const I=this.handlers.get(y);if(!I)return Promise.resolve(void 0);try{I.handleUri(O.URI.revive(T))}catch(p){(0,A.onUnexpectedError)(p)}return Promise.resolve(void 0)}async createAppUri(y){return O.URI.revive(await this._proxy.$createAppUri(y))}}e.ExtHostUrls=b}),define(_e[92],Ce([1,0,4,3,15,24,2,252,290,114,6]),function(ue,e,h,O,L,A,R,b,m,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviews=e.ExtHostWebview=void 0,e.shouldSerializeBuffersForPostMessage=p,e.toExtensionData=d,e.serializeWebviewOptions=f;class I{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#h;constructor(l,o,t,u,r,c,s){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new h.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new h.Emitter,this._onDidDispose=this.#d.event,this.#e=l,this.#t=o,this.#o=t,this.#n=u,this.#s=r,this.#r=c,this.#u=p(c),this.#h=S(c),this.#i=s}#d;dispose(){this.#c=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(l){return this.#l=!0,(0,y.asWebviewUri)(l,this.#n)}get cspSource(){const l=this.#r.extensionLocation;if(l.scheme===L.Schemas.https||l.scheme===L.Schemas.http){let o=l.toString();return o.endsWith("/")||(o+="/"),o+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#a}set html(l){this.assertNotDisposed(),this.#a!==l&&(this.#a=l,this.#h&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(l)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(l)))}get options(){return this.assertNotDisposed(),this.#o}set options(l){this.assertNotDisposed(),A.equals(this.#o,l)||this.#t.$setOptions(this.#e,f(this.#r,this.#s,l)),this.#o=l}async postMessage(l){if(this.#c)return!1;const o=(0,m.serializeWebviewMessage)(l,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,o.message,...o.buffers)}assertNotDisposed(){if(this.#c)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(l){if(!this.#h)return l;const o=this.#r.extensionLocation?.scheme===L.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===L.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return l.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,r,c,s,w,g)=>{const D=R.URI.from({scheme:s||"file",path:decodeURIComponent(w)}),v=(0,y.asWebviewUri)(D,{isRemote:o,authority:t}).toString();return`${r}${v}${g}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,r,c,s,w,g)=>{const D=R.URI.from({scheme:s||"file",path:decodeURIComponent(w)}),v=(0,y.asWebviewUri)(D,{isRemote:o,authority:t}).toString();return`${r}${v}${g}`})}}e.ExtHostWebview=I;function p(n){try{const l=(0,b.normalizeVersion)((0,b.parseVersion)(n.engines.vscode));return!!l&&l.majorBase>=1&&l.minorBase>=57}catch{return!1}}function S(n){try{const l=(0,b.normalizeVersion)((0,b.parseVersion)(n.engines.vscode));return l?l.majorBase<1||l.majorBase===1&&l.minorBase<60:!1}catch{return!1}}class E extends O.Disposable{constructor(l,o,t,u,r){super(),this.remoteInfo=o,this.workspace=t,this._logService=u,this._deprecationService=r,this._webviews=new Map,this._webviewProxy=l.getProxy(T.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const l of this._webviews.values())l.dispose();this._webviews.clear()}$onMessage(l,o,t){const u=this.getWebview(l);if(u){const{message:r}=(0,m.deserializeWebviewMessage)(o,t.value);u._onMessageEmitter.fire(r)}}$onMissingCsp(l,o){this._logService.warn(`${o} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(l,o,t){const u=new I(l,this._webviewProxy,a(o),this.remoteInfo,this.workspace,t,this._deprecationService);this._webviews.set(l,u);const r=u._onDidDispose(()=>{r.dispose(),this.deleteWebview(l)});return u}deleteWebview(l){this._webviews.delete(l)}getWebview(l){return this._webviews.get(l)}}e.ExtHostWebviews=E;function d(n){return{id:n.identifier,location:n.extensionLocation}}function f(n,l,o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots||i(n,l)}}function a(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(l=>R.URI.from(l))}}function i(n,l){return[...(l?.getWorkspaceFolders()||[]).map(o=>o.uri),n.extensionLocation]}}),define(_e[151],Ce([1,0,4,15,14,2,5,20,6]),function(ue,e,h,O,L,A,R,b,m){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class{static{y=this}static{this.InitialState={focused:!0,active:!0}}getState(){const p=this._state;return{get focused(){return p.focused},get active(){return p.active}}}constructor(p){this._onDidChangeWindowState=new h.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=y.InitialState,this._proxy=p.getProxy(m.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:S,isActive:E})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",E)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,S){S!==this._state[p]&&(this._state={...this._state,[p]:S},this._onDidChangeWindowState.fire(this._state))}openUri(p,S){let E;if(typeof p=="string"){E=p;try{p=A.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,L.isFalsyOrWhitespace)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===O.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this._proxy.$openUri(p,E,S)}async asExternalUri(p,S){if((0,L.isFalsyOrWhitespace)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this._proxy.$asExternalUri(p,S);return A.URI.from(E)}};e.ExtHostWindow=T,e.ExtHostWindow=T=y=Ge([Ue(0,b.IExtHostRpcService)],T),e.IExtHostWindow=(0,R.createDecorator)("IExtHostWindow")}),define(_e[325],Ce([1,0,317,28,20]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const A=1024*1024;let R=class extends h.AbstractExtHostConsoleForwarder{constructor(m,y){super(m,y),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(m,y,T){const I=m==="error"||m==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,I.write(`
START_NATIVE_LOG
`),y.apply(console,T),I.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(m,y){const T=process[m],I=T.write;let p="";Object.defineProperty(T,"write",{set:()=>{},get:()=>(S,E,d)=>{if(!this._isMakingConsoleCall){p+=S.toString(E);const f=p.length>A?p.length:p.lastIndexOf(`
`);f!==-1&&(console[y](p.slice(0,f)),p=p.slice(f+1))}I.call(T,S,E,d)}})}};e.ExtHostConsoleForwarder=R,e.ExtHostConsoleForwarder=R=Ge([Ue(0,L.IExtHostRpcService),Ue(1,O.IExtHostInitDataService)],R)}),define(_e[326],Ce([1,0,150,15,267,30]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class R extends h.ExtHostLoggerService{doCreateLogger(m,y,T){return m.scheme===O.Schemas.file?new L.SpdLogLogger(T?.name||(0,A.generateUuid)(),m.fsPath,!T?.donotRotate,!!T?.donotUseFormatters,y):super.doCreateLogger(m,y,T)}registerLogger(m){super.registerLogger(m),this._proxy.$registerLogger(m)}deregisterLogger(m){super.deregisterLogger(m),this._proxy.$deregisterLogger(m)}}e.ExtHostLoggerService=R}),define(_e[327],Ce([1,0,7,21,22,13,4,3,134,315,48]),function(ue,e,h,O,L,A,R,b,m,y,T){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0,e.stringifyJsonWithBufferRefs=f,e.parseJsonAndRestoreBufferRefs=a;function p(C,P){try{return JSON.stringify(C,P)}catch{return"null"}}const S="$$ref$$",E={[S]:-1};class d{constructor(P,k){this.jsonString=P,this.referencedBuffers=k}}function f(C,P=null,k=!1){const F=[];return{jsonString:(k?p:JSON.stringify)(C,(z,N)=>{if(typeof N>"u")return E;if(typeof N=="object"){if(N instanceof O.VSBuffer){const M=F.push(N)-1;return{[S]:M}}if(P)return P(z,N)}return N}),referencedBuffers:F}}function a(C,P,k){return JSON.parse(C,(F,x)=>{if(x){const z=x[S];if(typeof z=="number")return P[z];if(k&&x.$mid===1)return k.transformIncoming(x)}return x})}function i(C,P){return JSON.stringify(C,P)}function n(C){return C?(P,k)=>k&&k.$mid===1?C.transformOutgoing(k):k:null}var l;(function(C){C[C.LocalSide=0]="LocalSide",C[C.OtherSide=1]="OtherSide"})(l||(e.RequestInitiator=l={}));var o;(function(C){C[C.Responsive=0]="Responsive",C[C.Unresponsive=1]="Unresponsive"})(o||(e.ResponsiveState=o={}));const t=()=>{},u=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class c extends b.Disposable{static{I=u}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(P,k=null,F=null){super(),this[I]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=P,this._logger=k,this._uriTransformer=F,this._uriReplacer=n(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let x=0,z=T.ProxyIdentifier.count;x<z;x++)this._locals[x]=null,this._proxies[x]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new h.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(x=>this._receiveOneMessage(x))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(P=>{const k=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P],k.resolveErr(A.canceled())}),super.dispose()}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(P){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(P){this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(P){this._responsiveState!==P&&(this._responsiveState=P,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(P){return this._uriTransformer?(0,m.transformIncomingURIs)(P,this._uriTransformer):P}getProxy(P){const{nid:k,sid:F}=P;return this._proxies[k]||(this._proxies[k]=this._createProxy(k,F)),this._proxies[k]}_createProxy(P,k){const F={get:(x,z)=>(typeof z=="string"&&!x[z]&&z.charCodeAt(0)===36&&(x[z]=(...N)=>this._remoteCall(P,z,N)),z===r?k:x[z])};return new Proxy(Object.create(null),F)}set(P,k){return this._locals[P.nid]=k,k}assertRegistered(P){for(let k=0,F=P.length;k<F;k++){const x=P[k];if(!this._locals[x.nid])throw new Error(`Missing proxy instance ${x.sid}`)}}_receiveOneMessage(P){if(this._isDisposed)return;const k=P.byteLength,F=w.read(P,0),x=F.readUInt8(),z=F.readUInt32();switch(x){case 1:case 2:{let{rpcId:N,method:M,args:W}=D.deserializeRequestJSONArgs(F);this._uriTransformer&&(W=(0,m.transformIncomingURIs)(W,this._uriTransformer)),this._receiveRequest(k,z,N,M,W,x===2);break}case 3:case 4:{let{rpcId:N,method:M,args:W}=D.deserializeRequestMixedArgs(F);this._uriTransformer&&(W=(0,m.transformIncomingURIs)(W,this._uriTransformer)),this._receiveRequest(k,z,N,M,W,x===4);break}case 5:{this._logger?.logIncoming(k,z,0,"ack"),this._onDidReceiveAcknowledge(z);break}case 6:{this._receiveCancel(k,z);break}case 7:{this._receiveReply(k,z,void 0);break}case 9:{let N=D.deserializeReplyOKJSON(F);this._uriTransformer&&(N=(0,m.transformIncomingURIs)(N,this._uriTransformer)),this._receiveReply(k,z,N);break}case 10:{const N=D.deserializeReplyOKJSONWithBuffers(F,this._uriTransformer);this._receiveReply(k,z,N);break}case 8:{const N=D.deserializeReplyOKVSBuffer(F);this._receiveReply(k,z,N);break}case 11:{let N=D.deserializeReplyErrError(F);this._uriTransformer&&(N=(0,m.transformIncomingURIs)(N,this._uriTransformer)),this._receiveReplyErr(k,z,N);break}case 12:{this._receiveReplyErr(k,z,void 0);break}default:console.error("received unexpected message"),console.error(P)}}_receiveRequest(P,k,F,x,z,N){this._logger?.logIncoming(P,k,1,`receiveRequest ${(0,T.getStringIdentifierForProxy)(F)}.${x}(`,z);const M=String(k);let W,X;if(N){const H=new L.CancellationTokenSource;z.push(H.token),W=this._invokeHandler(F,x,z),X=()=>H.cancel()}else W=this._invokeHandler(F,x,z),X=t;this._cancelInvokedHandlers[M]=X;const te=D.serializeAcknowledged(k);this._logger?.logOutgoing(te.byteLength,k,1,"ack"),this._protocol.send(te),W.then(H=>{delete this._cancelInvokedHandlers[M];const G=D.serializeReplyOK(k,H,this._uriReplacer);this._logger?.logOutgoing(G.byteLength,k,1,"reply:",H),this._protocol.send(G)},H=>{delete this._cancelInvokedHandlers[M];const G=D.serializeReplyErr(k,H);this._logger?.logOutgoing(G.byteLength,k,1,"replyErr:",H),this._protocol.send(G)})}_receiveCancel(P,k){this._logger?.logIncoming(P,k,1,"receiveCancel");const F=String(k);this._cancelInvokedHandlers[F]?.()}_receiveReply(P,k,F){this._logger?.logIncoming(P,k,0,"receiveReply:",F);const x=String(k);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const z=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x],z.resolveOk(F)}_receiveReplyErr(P,k,F){this._logger?.logIncoming(P,k,0,"receiveReplyErr:",F);const x=String(k);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const z=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x];let N;F&&(F.$isError?(N=new Error,N.name=F.name,N.message=F.message,N.stack=F.stack):N=F),z.resolveErr(N)}_invokeHandler(P,k,F){try{return Promise.resolve(this._doInvokeHandler(P,k,F))}catch(x){return Promise.reject(x)}}_doInvokeHandler(P,k,F){const x=this._locals[P];if(!x)throw new Error("Unknown actor "+(0,T.getStringIdentifierForProxy)(P));const z=x[k];if(typeof z!="function")throw new Error("Unknown method "+k+" on actor "+(0,T.getStringIdentifierForProxy)(P));return z.apply(x,F)}_remoteCall(P,k,F){if(this._isDisposed)return new y.CanceledLazyPromise;let x=null;if(F.length>0&&L.CancellationToken.isCancellationToken(F[F.length-1])&&(x=F.pop()),x&&x.isCancellationRequested)return Promise.reject(A.canceled());const z=D.serializeRequestArguments(F,this._uriReplacer),N=++this._lastMessageId,M=String(N),W=new y.LazyPromise,X=new b.DisposableStore;x&&X.add(x.onCancellationRequested(()=>{const H=D.serializeCancel(N);this._logger?.logOutgoing(H.byteLength,N,0,"cancel"),this._protocol.send(D.serializeCancel(N))})),this._pendingRPCReplies[M]=new s(W,X),this._onWillSendRequest(N);const te=D.serializeRequest(N,P,k,z,!!x);return this._logger?.logOutgoing(te.byteLength,N,0,`request: ${(0,T.getStringIdentifierForProxy)(P)}.${k}(`,F),this._protocol.send(te),W}}e.RPCProtocol=c;class s{constructor(P,k){this._promise=P,this._disposable=k}resolveOk(P){this._promise.resolveOk(P),this._disposable.dispose()}resolveErr(P){this._promise.resolveErr(P),this._disposable.dispose()}}class w{static alloc(P,k,F){const x=new w(O.VSBuffer.alloc(F+1+4),0);return x.writeUInt8(P),x.writeUInt32(k),x}static read(P,k){return new w(P,k)}get buffer(){return this._buff}constructor(P,k){this._buff=P,this._offset=k}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this._buff.writeUInt8(P,this._offset),this._offset+=1}readUInt8(){const P=this._buff.readUInt8(this._offset);return this._offset+=1,P}writeUInt32(P){this._buff.writeUInt32BE(P,this._offset),this._offset+=4}readUInt32(){const P=this._buff.readUInt32BE(this._offset);return this._offset+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this._buff.writeUInt8(P.byteLength,this._offset),this._offset+=1,this._buff.set(P,this._offset),this._offset+=P.byteLength}readShortString(){const P=this._buff.readUInt8(this._offset);this._offset+=1;const F=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,F}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readLongString(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,F}writeBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readVSBuffer(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const k=this._buff.slice(this._offset,this._offset+P);return this._offset+=P,k}static sizeMixedArray(P){let k=0;k+=1;for(let F=0,x=P.length;F<x;F++){const z=P[F];switch(k+=1,z.type){case 1:k+=this.sizeLongString(z.value);break;case 2:k+=this.sizeVSBuffer(z.value);break;case 3:k+=this.sizeUInt32,k+=this.sizeLongString(z.value);for(let N=0;N<z.buffers.length;++N)k+=this.sizeVSBuffer(z.buffers[N]);break;case 4:break}}return k}writeMixedArray(P){this._buff.writeUInt8(P.length,this._offset),this._offset+=1;for(let k=0,F=P.length;k<F;k++){const x=P[k];switch(x.type){case 1:this.writeUInt8(1),this.writeLongString(x.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(x.value);break;case 3:this.writeUInt8(3),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let z=0;z<x.buffers.length;++z)this.writeBuffer(x.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this._buff.readUInt8(this._offset);this._offset+=1;const k=new Array(P);for(let F=0;F<P;F++)switch(this.readUInt8()){case 1:k[F]=this.readLongString();break;case 2:k[F]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),N=this.readLongString(),M=[];for(let W=0;W<z;++W)M.push(this.readVSBuffer());k[F]=new T.SerializableObjectWithBuffers(a(N,M,null));break}case 4:k[F]=void 0;break}return k}}var g;(function(C){C[C.Simple=0]="Simple",C[C.Mixed=1]="Mixed"})(g||(g={}));class D{static _useMixedArgSerialization(P){for(let k=0,F=P.length;k<F;k++)if(P[k]instanceof O.VSBuffer||P[k]instanceof T.SerializableObjectWithBuffers||typeof P[k]>"u")return!0;return!1}static serializeRequestArguments(P,k){if(this._useMixedArgSerialization(P)){const F=[];for(let x=0,z=P.length;x<z;x++){const N=P[x];if(N instanceof O.VSBuffer)F[x]={type:2,value:N};else if(typeof N>"u")F[x]={type:4};else if(N instanceof T.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:W}=f(N.value,k);F[x]={type:3,value:O.VSBuffer.fromString(M),buffers:W}}else F[x]={type:1,value:O.VSBuffer.fromString(i(N,k))}}return{type:1,args:F}}return{type:0,args:i(P,k)}}static serializeRequest(P,k,F,x,z){switch(x.type){case 0:return this._requestJSONArgs(P,k,F,x.args,z);case 1:return this._requestMixedArgs(P,k,F,x.args,z)}}static _requestJSONArgs(P,k,F,x,z){const N=O.VSBuffer.fromString(F),M=O.VSBuffer.fromString(x);let W=0;W+=w.sizeUInt8(),W+=w.sizeShortString(N),W+=w.sizeLongString(M);const X=w.alloc(z?2:1,P,W);return X.writeUInt8(k),X.writeShortString(N),X.writeLongString(M),X.buffer}static deserializeRequestJSONArgs(P){const k=P.readUInt8(),F=P.readShortString(),x=P.readLongString();return{rpcId:k,method:F,args:JSON.parse(x)}}static _requestMixedArgs(P,k,F,x,z){const N=O.VSBuffer.fromString(F);let M=0;M+=w.sizeUInt8(),M+=w.sizeShortString(N),M+=w.sizeMixedArray(x);const W=w.alloc(z?4:3,P,M);return W.writeUInt8(k),W.writeShortString(N),W.writeMixedArray(x),W.buffer}static deserializeRequestMixedArgs(P){const k=P.readUInt8(),F=P.readShortString(),x=P.readMixedArray(),z=new Array(x.length);for(let N=0,M=x.length;N<M;N++){const W=x[N];typeof W=="string"?z[N]=JSON.parse(W):z[N]=W}return{rpcId:k,method:F,args:z}}static serializeAcknowledged(P){return w.alloc(5,P,0).buffer}static serializeCancel(P){return w.alloc(6,P,0).buffer}static serializeReplyOK(P,k,F){if(typeof k>"u")return this._serializeReplyOKEmpty(P);if(k instanceof O.VSBuffer)return this._serializeReplyOKVSBuffer(P,k);if(k instanceof T.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:z}=f(k.value,F,!0);return this._serializeReplyOKJSONWithBuffers(P,x,z)}else return this._serializeReplyOKJSON(P,p(k,F))}static _serializeReplyOKEmpty(P){return w.alloc(7,P,0).buffer}static _serializeReplyOKVSBuffer(P,k){let F=0;F+=w.sizeVSBuffer(k);const x=w.alloc(8,P,F);return x.writeVSBuffer(k),x.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static _serializeReplyOKJSON(P,k){const F=O.VSBuffer.fromString(k);let x=0;x+=w.sizeLongString(F);const z=w.alloc(9,P,x);return z.writeLongString(F),z.buffer}static _serializeReplyOKJSONWithBuffers(P,k,F){const x=O.VSBuffer.fromString(k);let z=0;z+=w.sizeUInt32,z+=w.sizeLongString(x);for(const M of F)z+=w.sizeVSBuffer(M);const N=w.alloc(10,P,z);N.writeUInt32(F.length),N.writeLongString(x);for(const M of F)N.writeBuffer(M);return N.buffer}static deserializeReplyOKJSON(P){const k=P.readLongString();return JSON.parse(k)}static deserializeReplyOKJSONWithBuffers(P,k){const F=P.readUInt32(),x=P.readLongString(),z=[];for(let N=0;N<F;++N)z.push(P.readVSBuffer());return new T.SerializableObjectWithBuffers(a(x,z,k))}static serializeReplyErr(P,k){const F=k?p(A.transformErrorForSerialization(k),null):void 0;if(typeof F!="string")return this._serializeReplyErrEmpty(P);const x=O.VSBuffer.fromString(F);let z=0;z+=w.sizeLongString(x);const N=w.alloc(11,P,z);return N.writeLongString(x),N.buffer}static deserializeReplyErrError(P){const k=P.readLongString();return JSON.parse(k)}static _serializeReplyErrEmpty(P){return w.alloc(12,P,0).buffer}}var v;(function(C){C[C.RequestJSONArgs=1]="RequestJSONArgs",C[C.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",C[C.RequestMixedArgs=3]="RequestMixedArgs",C[C.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",C[C.Acknowledged=5]="Acknowledged",C[C.Cancel=6]="Cancel",C[C.ReplyOKEmpty=7]="ReplyOKEmpty",C[C.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",C[C.ReplyOKJSON=9]="ReplyOKJSON",C[C.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",C[C.ReplyErrError=11]="ReplyErrError",C[C.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var _;(function(C){C[C.String=1]="String",C[C.VSBuffer=2]="VSBuffer",C[C.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",C[C.Undefined=4]="Undefined"})(_||(_={}))}),define(_e[328],Ce([1,0,21,27,15,85,5]),function(ue,e,h,O,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookDocumentWorkbenchService=e.INotebookDocumentService=void 0,e.parse=T,e.generate=I,e.INotebookDocumentService=(0,R.createDecorator)("notebookDocumentService");const b=["W","X","Y","Z","a","b","c","d","e","f"],m=new RegExp(`^[${b.join("")}]+`),y=7;function T(S){if(S.scheme!==L.Schemas.vscodeNotebookCell)return;const E=S.fragment.indexOf("s");if(E<0)return;const d=parseInt(S.fragment.substring(0,E).replace(m,""),y),f=(0,h.decodeBase64)(S.fragment.substring(E+1)).toString();if(!isNaN(d))return{handle:d,notebook:S.with({scheme:f,fragment:null})}}function I(S,E){const d=E.toString(y),a=`${d.length<b.length?b[d.length-1]:"z"}${d}s${(0,h.encodeBase64)(h.VSBuffer.fromString(S.scheme),!0,!0)}`;return S.with({scheme:L.Schemas.vscodeNotebookCell,fragment:a})}class p{constructor(){this._documents=new O.ResourceMap}getNotebook(E){if(E.scheme===L.Schemas.vscodeNotebookCell){const d=T(E);if(d){const f=this._documents.get(d.notebook);if(f)return f}}return this._documents.get(E)}addNotebookDocument(E){this._documents.set(E.uri,E)}removeNotebookDocument(E){this._documents.delete(E.uri)}}e.NotebookDocumentWorkbenchService=p,(0,A.registerSingleton)(e.INotebookDocumentService,p,1)}),define(_e[120],Ce([1,0,21,35,39,101,15,17,12,38,328]),function(ue,e,h,O,L,A,R,b,m,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.diff=u,e.isDocumentExcludePattern=c,e.notebookDocumentFilterMatch=s,e.isTextStreamMime=D,e.compressOutputItemStreams=_,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var I;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(I||(e.CellKind=I={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",A.Mimes.latex,A.Mimes.markdown,"image/png","image/jpeg",A.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[A.Mimes.latex,A.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var p;(function(W){W[W.Running=1]="Running",W[W.Idle=2]="Idle"})(p||(e.NotebookRunState=p={}));var S;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(S||(e.NotebookCellExecutionState=S={}));var E;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(E||(e.NotebookExecutionState=E={}));var d;(function(W){W[W.WithHardKernelDependency=0]="WithHardKernelDependency",W[W.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",W[W.Pure=2]="Pure",W[W.Never=3]="Never"})(d||(e.NotebookRendererMatch=d={}));var f;(function(W){W.Always="always",W.Never="never",W.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var a;(function(W){W[W.ModelChange=1]="ModelChange",W[W.Move=2]="Move",W[W.ChangeCellLanguage=5]="ChangeCellLanguage",W[W.Initialize=6]="Initialize",W[W.ChangeCellMetadata=7]="ChangeCellMetadata",W[W.Output=8]="Output",W[W.OutputItem=9]="OutputItem",W[W.ChangeCellContent=10]="ChangeCellContent",W[W.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",W[W.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",W[W.ChangeCellMime=13]="ChangeCellMime",W[W.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var i;(function(W){W[W.Handle=0]="Handle",W[W.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(W){W[W.Replace=1]="Replace",W[W.Output=2]="Output",W[W.Metadata=3]="Metadata",W[W.CellLanguage=4]="CellLanguage",W[W.DocumentMetadata=5]="DocumentMetadata",W[W.Move=6]="Move",W[W.OutputItems=7]="OutputItems",W[W.PartialMetadata=8]="PartialMetadata",W[W.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var l;(function(W){W.scheme=R.Schemas.vscodeNotebookCell;function X(pe,le){return(0,T.generate)(pe,le)}W.generate=X;function te(pe){return(0,T.parse)(pe)}W.parse=te;function H(pe,le){return pe.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${le??""},${pe.scheme!==R.Schemas.file?pe.scheme:""}`})}W.generateCellOutputUri=H;function G(pe){if(pe.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const le=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(pe.fragment);if(!le)return;const we=le[1]&&le[1]!==""?le[1]:void 0,Z=le[2];return{outputId:we,notebook:pe.with({scheme:Z||R.Schemas.file,fragment:null})}}W.parseCellOutputUri=G;function Y(pe,le,we){return W.generate(pe,le).with({scheme:we})}W.generateCellPropertyUri=Y;function ne(pe,le){if(pe.scheme===le)return W.parse(pe.with({scheme:W.scheme}))}W.parseCellPropertyUri=ne})(l||(e.CellUri=l={}));const o=W=>m.isWindows?W.replace(/\//g,"\\"):W;class t{constructor(X=[],te=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=te,this.order=[...new Set(X)].map(H=>({pattern:H,matches:O.parse(o(H))}))}sort(X){const te=new Map(L.Iterable.map(X,G=>[G,o(G)]));let H=[];for(const{matches:G}of this.order)for(const[Y,ne]of te)if(G(ne)){H.push(Y),te.delete(Y);break}return te.size&&(H=H.concat([...te.keys()].sort((G,Y)=>this.defaultOrder.indexOf(G)-this.defaultOrder.indexOf(Y)))),H}prioritize(X,te){const H=this.findIndex(X);if(H===-1){this.order.unshift({pattern:X,matches:O.parse(o(X))});return}const G=new Set(te.map(ne=>this.findIndex(ne,H)));G.delete(-1);const Y=Array.from(G).sort();this.order.splice(H+1,0,...Y.map(ne=>this.order[ne]));for(let ne=Y.length-1;ne>=0;ne--)this.order.splice(Y[ne],1)}toArray(){return this.order.map(X=>X.pattern)}findIndex(X,te=this.order.length){const H=o(X);for(let G=0;G<te;G++)if(this.order[G].matches(H))return G;return-1}}e.MimeTypeDisplayOrder=t;function u(W,X,te,H=(G,Y)=>G===Y){const G=[];function Y(le,we,Z){if(we===0&&Z.length===0)return;const B=G[G.length-1];B&&B.start+B.deleteCount===le?(B.deleteCount+=we,B.toInsert.push(...Z)):G.push({start:le,deleteCount:we,toInsert:Z})}let ne=0,pe=0;for(;;){if(ne===W.length){Y(ne,0,X.slice(pe));break}if(pe===X.length){Y(ne,W.length-ne,[]);break}const le=W[ne],we=X[pe];if(H(le,we)){ne+=1,pe+=1;continue}te(we)?(Y(ne,1,[]),ne+=1):(Y(ne,0,[we]),pe+=1)}return G}e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtLineBoundary","none");var r;(function(W){W.default="default",W.option="option"})(r||(e.NotebookEditorPriority=r={}));function c(W){const X=W;return!!((typeof X.include=="string"||O.isRelativePattern(X.include))&&(typeof X.exclude=="string"||O.isRelativePattern(X.exclude)))}function s(W,X,te){if(Array.isArray(W.viewType)&&W.viewType.indexOf(X)>=0||W.viewType===X)return!0;if(W.filenamePattern){const H=c(W.filenamePattern)?W.filenamePattern.include:W.filenamePattern,G=c(W.filenamePattern)?W.filenamePattern.exclude:void 0;if(O.match(H,(0,b.basename)(te.fsPath).toLowerCase()))return!(G&&O.match(G,(0,b.basename)(te.fsPath).toLowerCase()))}return!1}e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var w;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(w||(e.CellStatusbarAlignment=w={}));class g{static{this._prefix="notebook/"}static create(X){return`${g._prefix}${X}`}static parse(X){if(X.startsWith(g._prefix))return X.substring(g._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=g;function D(W){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(W)}const v=new TextDecoder;function _(W){const X=[];let te=!1;for(const ne of W)(X.length===0||te)&&(X.push(ne),te=!0);let H=k(X);const G=h.VSBuffer.concat(X.map(ne=>h.VSBuffer.wrap(ne))),Y=M(G);return H=H||Y.byteLength!==G.byteLength,{data:Y,didCompression:H}}e.MOVE_CURSOR_1_LINE_COMMAND="\x1B[A";const C=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(W=>W.charCodeAt(0)),P=10;function k(W){let X=!1;return W.forEach((te,H)=>{if(H===0||te.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const G=W[H-1],Y=te.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(Y[0]===C[0]&&Y[1]===C[1]&&Y[2]===C[2]){const ne=G.lastIndexOf(P);if(ne===-1)return;X=!0,W[H-1]=G.subarray(0,ne),W[H]=te.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),X}function F(W){let X=W;do W=X,X=W.replace(/[^\n]\x08/gm,"");while(X.length<W.length);return W}function x(W){for(W=W.replace(/\r+\n/gm,`
`);W.search(/\r[^$]/g)>-1;){const X=W.match(/^(.*)\r+/m)[1];let te=W.match(/\r+(.*)$/m)[1];te=te+X.slice(te.length,X.length),W=W.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,te)}return W}const z=8,N=13;function M(W){return!W.buffer.includes(z)&&!W.buffer.includes(N)?W:h.VSBuffer.fromString(x(F(v.decode(W.buffer))))}}),define(_e[8],Ce([1,0,19,13,81,27,101,14,18,2,30,25,33,67,120]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E){"use strict";var d,f,a,i,n,l,o,t,u,r,c,s,w,g,D,v,_;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.InlineEdit=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.LanguageModelError=e.LanguageModelChatAssistantMessage=e.LanguageModelChatUserMessage=e.LanguageModelChatSystemMessage=e.ChatLocation=e.ChatResponseTurn=e.ChatRequestTurn=e.ChatResponseTextEditPart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFileTreePart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.ChatCompletionItem=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.TextMultiDiffTabInput=e.ChatEditorTabInput=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.DeclarationCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.TestCoverageCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookVariablesRequestKind=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugVisualization=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.NewSymbolName=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugThread=e.DebugStackFrame=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropOrPasteEditKind=e.DocumentPasteTriggerKind=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.DocumentHighlightKind=e.HoverVerbosityAction=e.VerboseHover=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.asStatusBarItemIdentifier=At,e.setBreakpointId=Me,e.validateTestCoverageCount=wn;function C(q){return Object.assign(q,{apply:function(...ge){if(ge.length===0)return Reflect.construct(q,[]);{const Ne=ge.length===1?[]:ge[1];return Reflect.construct(q,Ne,ge[0].constructor)}},call:function(...ge){if(ge.length===0)return Reflect.construct(q,[]);{const[Ne,...Ye]=ge;return Reflect.construct(q,Ye,Ne.constructor)}}})}var P;(function(q){q[q.Top=0]="Top",q[q.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var k;(function(q){q[q.TerminalCommand=0]="TerminalCommand",q[q.Opener=1]="Opener",q[q.Command=3]="Command"})(k||(e.TerminalQuickFixType=k={}));let F=d=class{static from(...V){let ge=V;return new d(function(){if(ge){for(const Ne of ge)Ne&&typeof Ne.dispose=="function"&&Ne.dispose();ge=void 0}})}#e;constructor(V){this.#e=V}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=F,e.Disposable=F=d=Ge([C],F);let x=f=class{static Min(...V){if(V.length===0)throw new TypeError;let ge=V[0];for(let Ne=1;Ne<V.length;Ne++){const Ye=V[Ne];Ye.isBefore(ge)&&(ge=Ye)}return ge}static Max(...V){if(V.length===0)throw new TypeError;let ge=V[0];for(let Ne=1;Ne<V.length;Ne++){const Ye=V[Ne];Ye.isAfter(ge)&&(ge=Ye)}return ge}static isPosition(V){if(!V)return!1;if(V instanceof f)return!0;const{line:ge,character:Ne}=V;return typeof ge=="number"&&typeof Ne=="number"}static of(V){if(V instanceof f)return V;if(this.isPosition(V))return new f(V.line,V.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(V,ge){if(V<0)throw(0,O.illegalArgument)("line must be non-negative");if(ge<0)throw(0,O.illegalArgument)("character must be non-negative");this._line=V,this._character=ge}isBefore(V){return this._line<V._line?!0:V._line<this._line?!1:this._character<V._character}isBeforeOrEqual(V){return this._line<V._line?!0:V._line<this._line?!1:this._character<=V._character}isAfter(V){return!this.isBeforeOrEqual(V)}isAfterOrEqual(V){return!this.isBefore(V)}isEqual(V){return this._line===V._line&&this._character===V._character}compareTo(V){return this._line<V._line?-1:this._line>V.line?1:this._character<V._character?-1:this._character>V._character?1:0}translate(V,ge=0){if(V===null||ge===null)throw(0,O.illegalArgument)();let Ne;return typeof V>"u"?Ne=0:typeof V=="number"?Ne=V:(Ne=typeof V.lineDelta=="number"?V.lineDelta:0,ge=typeof V.characterDelta=="number"?V.characterDelta:0),Ne===0&&ge===0?this:new f(this.line+Ne,this.character+ge)}with(V,ge=this.character){if(V===null||ge===null)throw(0,O.illegalArgument)();let Ne;return typeof V>"u"?Ne=this.line:typeof V=="number"?Ne=V:(Ne=typeof V.line=="number"?V.line:this.line,ge=typeof V.character=="number"?V.character:this.character),Ne===this.line&&ge===this.character?this:new f(Ne,ge)}toJSON(){return{line:this.line,character:this.character}}};e.Position=x,e.Position=x=f=Ge([C],x);let z=a=class{static isRange(V){return V instanceof a?!0:V?x.isPosition(V.start)&&x.isPosition(V.end):!1}static of(V){if(V instanceof a)return V;if(this.isRange(V))return new a(V.start,V.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(V,ge,Ne,Ye){let nt,ht;if(typeof V=="number"&&typeof ge=="number"&&typeof Ne=="number"&&typeof Ye=="number"?(nt=new x(V,ge),ht=new x(Ne,Ye)):x.isPosition(V)&&x.isPosition(ge)&&(nt=x.of(V),ht=x.of(ge)),!nt||!ht)throw new Error("Invalid arguments");nt.isBefore(ht)?(this._start=nt,this._end=ht):(this._start=ht,this._end=nt)}contains(V){return a.isRange(V)?this.contains(V.start)&&this.contains(V.end):x.isPosition(V)?!(x.of(V).isBefore(this._start)||this._end.isBefore(V)):!1}isEqual(V){return this._start.isEqual(V._start)&&this._end.isEqual(V._end)}intersection(V){const ge=x.Max(V.start,this._start),Ne=x.Min(V.end,this._end);if(!ge.isAfter(Ne))return new a(ge,Ne)}union(V){if(this.contains(V))return this;if(V.contains(this))return V;const ge=x.Min(V.start,this._start),Ne=x.Max(V.end,this.end);return new a(ge,Ne)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(V,ge=this.end){if(V===null||ge===null)throw(0,O.illegalArgument)();let Ne;return V?x.isPosition(V)?Ne=V:(Ne=V.start||this.start,ge=V.end||this.end):Ne=this.start,Ne.isEqual(this._start)&&ge.isEqual(this.end)?this:new a(Ne,ge)}toJSON(){return[this.start,this.end]}};e.Range=z,e.Range=z=a=Ge([C],z);let N=i=class extends z{static isSelection(V){return V instanceof i?!0:V?z.isRange(V)&&x.isPosition(V.anchor)&&x.isPosition(V.active)&&typeof V.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(V,ge,Ne,Ye){let nt,ht;if(typeof V=="number"&&typeof ge=="number"&&typeof Ne=="number"&&typeof Ye=="number"?(nt=new x(V,ge),ht=new x(Ne,Ye)):x.isPosition(V)&&x.isPosition(ge)&&(nt=x.of(V),ht=x.of(ge)),!nt||!ht)throw new Error("Invalid arguments");super(nt,ht),this._anchor=nt,this._active=ht}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=N,e.Selection=N=i=Ge([C],N);const M=q=>{if(typeof q!="string"||q.length===0||!/^[0-9A-Za-z_\-]+$/.test(q))throw(0,O.illegalArgument)("connectionToken")};class W{static isResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.host=="string"&&typeof V.port=="number"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,ge,Ne){if(typeof V!="string"||V.length===0)throw(0,O.illegalArgument)("host");if(typeof ge!="number"||ge===0||Math.round(ge)!==ge)throw(0,O.illegalArgument)("port");typeof Ne<"u"&&M(Ne),this.host=V,this.port=Math.round(ge),this.connectionToken=Ne}}e.ResolvedAuthority=W;class X{static isManagedResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.makeConnection=="function"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,ge){this.makeConnection=V,this.connectionToken=ge,typeof ge<"u"&&M(ge)}}e.ManagedResolvedAuthority=X;class te extends Error{static NotAvailable(V,ge){return new te(V,S.RemoteAuthorityResolverErrorCode.NotAvailable,ge)}static TemporarilyNotAvailable(V){return new te(V,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(V,ge=S.RemoteAuthorityResolverErrorCode.Unknown,Ne){super(V),this._message=V,this._code=ge,this._detail=Ne,Object.setPrototypeOf(this,te.prototype)}}e.RemoteAuthorityResolverError=te;var H;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(H||(e.EndOfLine=H={}));var G;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(G||(e.EnvironmentVariableMutatorType=G={}));let Y=n=class{static isTextEdit(V){return V instanceof n?!0:V?z.isRange(V)&&typeof V.newText=="string":!1}static replace(V,ge){return new n(V,ge)}static insert(V,ge){return n.replace(new z(V,V),ge)}static delete(V){return n.replace(V,"")}static setEndOfLine(V){const ge=new n(new z(new x(0,0),new x(0,0)),"");return ge.newEol=V,ge}get range(){return this._range}set range(V){if(V&&!z.isRange(V))throw(0,O.illegalArgument)("range");this._range=V}get newText(){return this._newText||""}set newText(V){if(V&&typeof V!="string")throw(0,O.illegalArgument)("newText");this._newText=V}get newEol(){return this._newEol}set newEol(V){if(V&&typeof V!="number")throw(0,O.illegalArgument)("newEol");this._newEol=V}constructor(V,ge){this._range=V,this._newText=ge}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=Y,e.TextEdit=Y=n=Ge([C],Y);let ne=l=class{static isNotebookCellEdit(V){return V instanceof l?!0:V?gi.isNotebookRange(V)&&Array.isArray(V.newCells):!1}static replaceCells(V,ge){return new l(V,ge)}static insertCells(V,ge){return new l(new gi(V,V),ge)}static deleteCells(V){return new l(V,[])}static updateCellMetadata(V,ge){const Ne=new l(new gi(V,V),[]);return Ne.newCellMetadata=ge,Ne}static updateNotebookMetadata(V){const ge=new l(new gi(0,0),[]);return ge.newNotebookMetadata=V,ge}constructor(V,ge){this.range=V,this.newCells=ge}};e.NotebookEdit=ne,e.NotebookEdit=ne=l=Ge([C],ne);class pe{static isSnippetTextEdit(V){return V instanceof pe?!0:V?z.isRange(V.range)&&Z.isSnippetString(V.snippet):!1}static replace(V,ge){return new pe(V,ge)}static insert(V,ge){return pe.replace(new z(V,V),ge)}constructor(V,ge){this.range=V,this.snippet=ge}}e.SnippetTextEdit=pe;var le;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace",q[q.Snippet=6]="Snippet"})(le||(e.FileEditType=le={}));let we=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(V,ge,Ne,Ye){this._edits.push({_type:1,from:V,to:ge,options:Ne,metadata:Ye})}createFile(V,ge,Ne){this._edits.push({_type:1,from:void 0,to:V,options:ge,metadata:Ne})}deleteFile(V,ge,Ne){this._edits.push({_type:1,from:V,to:void 0,options:ge,metadata:Ne})}replaceNotebookMetadata(V,ge,Ne){this._edits.push({_type:3,metadata:Ne,uri:V,edit:{editType:5,metadata:ge},notebookMetadata:ge})}replaceNotebookCells(V,ge,Ne,Ye){const nt=ge.start,ht=ge.end;(nt!==ht||Ne.length>0)&&this._edits.push({_type:5,uri:V,index:nt,count:ht-nt,cells:Ne,metadata:Ye})}replaceNotebookCellMetadata(V,ge,Ne,Ye){this._edits.push({_type:3,metadata:Ye,uri:V,edit:{editType:3,index:ge,metadata:Ne}})}replace(V,ge,Ne,Ye){this._edits.push({_type:2,uri:V,edit:new Y(ge,Ne),metadata:Ye})}insert(V,ge,Ne,Ye){this.replace(V,new z(ge,ge),Ne,Ye)}delete(V,ge,Ne){this.replace(V,ge,"",Ne)}has(V){return this._edits.some(ge=>ge._type===2&&ge.uri.toString()===V.toString())}set(V,ge){if(ge)for(const Ne of ge){if(!Ne)continue;let Ye,nt;Array.isArray(Ne)?(Ye=Ne[0],nt=Ne[1]):Ye=Ne,ne.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.replaceNotebookCellMetadata(V,Ye.range.start,Ye.newCellMetadata,nt):Ye.newNotebookMetadata?this.replaceNotebookMetadata(V,Ye.newNotebookMetadata,nt):this.replaceNotebookCells(V,Ye.range,Ye.newCells,nt):pe.isSnippetTextEdit(Ye)?this._edits.push({_type:6,uri:V,range:Ye.range,edit:Ye.snippet,metadata:nt}):this._edits.push({_type:2,uri:V,edit:Ye,metadata:nt})}else{for(let Ne=0;Ne<this._edits.length;Ne++){const Ye=this._edits[Ne];switch(Ye._type){case 2:case 6:case 3:case 5:Ye.uri.toString()===V.toString()&&(this._edits[Ne]=void 0);break}}(0,h.coalesceInPlace)(this._edits)}}get(V){const ge=[];for(const Ne of this._edits)Ne._type===2&&Ne.uri.toString()===V.toString()&&ge.push(Ne.edit);return ge}entries(){const V=new A.ResourceMap;for(const ge of this._edits)if(ge._type===2){let Ne=V.get(ge.uri);Ne||(Ne=[ge.uri,[]],V.set(ge.uri,Ne)),Ne[1].push(ge.edit)}return[...V.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=we,e.WorkspaceEdit=we=Ge([C],we);let Z=o=class{static isSnippetString(V){return V instanceof o?!0:V?typeof V.value=="string":!1}static _escape(V){return V.replace(/\$|}|\\/g,"\\$&")}constructor(V){this._tabstop=1,this.value=V||""}appendText(V){return this.value+=o._escape(V),this}appendTabstop(V=this._tabstop++){return this.value+="$",this.value+=V,this}appendPlaceholder(V,ge=this._tabstop++){if(typeof V=="function"){const Ne=new o;Ne._tabstop=this._tabstop,V(Ne),this._tabstop=Ne._tabstop,V=Ne.value}else V=o._escape(V);return this.value+="${",this.value+=ge,this.value+=":",this.value+=V,this.value+="}",this}appendChoice(V,ge=this._tabstop++){const Ne=V.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ge,this.value+="|",this.value+=Ne,this.value+="|}",this}appendVariable(V,ge){if(typeof ge=="function"){const Ne=new o;Ne._tabstop=this._tabstop,ge(Ne),this._tabstop=Ne._tabstop,ge=Ne.value}else typeof ge=="string"&&(ge=ge.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=V,ge&&(this.value+=":",this.value+=ge),this.value+="}",this}};e.SnippetString=Z,e.SnippetString=Z=o=Ge([C],Z);var B;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(B||(e.DiagnosticTag=B={}));var ee;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(ee||(e.DiagnosticSeverity=ee={}));let ve=t=class{static isLocation(V){return V instanceof t?!0:V?z.isRange(V.range)&&y.URI.isUri(V.uri):!1}constructor(V,ge){if(this.uri=V,ge)if(z.isRange(ge))this.range=z.of(ge);else if(x.isPosition(ge))this.range=new z(ge,ge);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=ve,e.Location=ve=t=Ge([C],ve);let Pe=class{static is(V){return V?typeof V.message=="string"&&V.location&&z.isRange(V.location.range)&&y.URI.isUri(V.location.uri):!1}constructor(V,ge){this.location=V,this.message=ge}static isEqual(V,ge){return V===ge?!0:!V||!ge?!1:V.message===ge.message&&V.location.range.isEqual(ge.location.range)&&V.location.uri.toString()===ge.location.uri.toString()}};e.DiagnosticRelatedInformation=Pe,e.DiagnosticRelatedInformation=Pe=Ge([C],Pe);let oe=class{constructor(V,ge,Ne=ee.Error){if(!z.isRange(V))throw new TypeError("range must be set");if(!ge)throw new TypeError("message must be set");this.range=V,this.message=ge,this.severity=Ne}toJSON(){return{severity:ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(V,ge){return V===ge?!0:!V||!ge?!1:V.message===ge.message&&V.severity===ge.severity&&V.code===ge.code&&V.severity===ge.severity&&V.source===ge.source&&V.range.isEqual(ge.range)&&(0,h.equals)(V.tags,ge.tags)&&(0,h.equals)(V.relatedInformation,ge.relatedInformation,Pe.isEqual)}};e.Diagnostic=oe,e.Diagnostic=oe=Ge([C],oe);let se=class{constructor(V,ge){if(!V)throw new Error("Illegal argument, contents must be defined");Array.isArray(V)?this.contents=V:this.contents=[V],this.range=ge}};e.Hover=se,e.Hover=se=Ge([C],se);let re=class extends se{constructor(V,ge,Ne,Ye){super(V,ge),this.canIncreaseHover=Ne,this.canDecreaseHover=Ye}};e.VerboseHover=re,e.VerboseHover=re=Ge([C],re);var j;(function(q){q[q.Increase=0]="Increase",q[q.Decrease=1]="Decrease"})(j||(e.HoverVerbosityAction=j={}));var ie;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(ie||(e.DocumentHighlightKind=ie={}));let me=class{constructor(V,ge=ie.Text){this.range=V,this.kind=ge}toJSON(){return{range:this.range,kind:ie[this.kind]}}};e.DocumentHighlight=me,e.DocumentHighlight=me=Ge([C],me);let be=class{constructor(V,ge){this.uri=V,this.highlights=ge}toJSON(){return{uri:this.uri,highlights:this.highlights.map(V=>V.toJSON())}}};e.MultiDocumentHighlight=be,e.MultiDocumentHighlight=be=Ge([C],be);var Ae;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(Ae||(e.SymbolKind=Ae={}));var fe;(function(q){q[q.Deprecated=1]="Deprecated"})(fe||(e.SymbolTag=fe={}));let De=u=class{static validate(V){if(!V.name)throw new Error("name must not be falsy")}constructor(V,ge,Ne,Ye,nt){this.name=V,this.kind=ge,this.containerName=nt,typeof Ne=="string"&&(this.containerName=Ne),Ye instanceof ve?this.location=Ye:Ne instanceof z&&(this.location=new ve(Ye,Ne)),u.validate(this)}toJSON(){return{name:this.name,kind:Ae[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=De,e.SymbolInformation=De=u=Ge([C],De);let Te=r=class{static validate(V){if(!V.name)throw new Error("name must not be falsy");if(!V.range.contains(V.selectionRange))throw new Error("selectionRange must be contained in fullRange");V.children?.forEach(r.validate)}constructor(V,ge,Ne,Ye,nt){this.name=V,this.detail=ge,this.kind=Ne,this.range=Ye,this.selectionRange=nt,this.children=[],r.validate(this)}};e.DocumentSymbol=Te,e.DocumentSymbol=Te=r=Ge([C],Te);var ze;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(ze||(e.CodeActionTriggerKind=ze={}));let U=class{constructor(V,ge){this.title=V,this.kind=ge}};e.CodeAction=U,e.CodeAction=U=Ge([C],U);let $=class{static{c=this}static{this.sep="."}constructor(V){this.value=V}append(V){return new c(this.value?this.value+c.sep+V:V)}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+c.sep)}};e.CodeActionKind=$,e.CodeActionKind=$=c=Ge([C],$),$.Empty=new $(""),$.QuickFix=$.Empty.append("quickfix"),$.Refactor=$.Empty.append("refactor"),$.RefactorExtract=$.Refactor.append("extract"),$.RefactorInline=$.Refactor.append("inline"),$.RefactorMove=$.Refactor.append("move"),$.RefactorRewrite=$.Refactor.append("rewrite"),$.Source=$.Empty.append("source"),$.SourceOrganizeImports=$.Source.append("organizeImports"),$.SourceFixAll=$.Source.append("fixAll"),$.Notebook=$.Empty.append("notebook");let K=class{constructor(V,ge){if(this.range=V,this.parent=ge,ge&&!ge.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=K,e.SelectionRange=K=Ge([C],K);class Q{constructor(V,ge,Ne,Ye,nt,ht){this.kind=V,this.name=ge,this.detail=Ne,this.uri=Ye,this.range=nt,this.selectionRange=ht}}e.CallHierarchyItem=Q;class de{constructor(V,ge){this.fromRanges=ge,this.from=V}}e.CallHierarchyIncomingCall=de;class Ee{constructor(V,ge){this.fromRanges=ge,this.to=V}}e.CallHierarchyOutgoingCall=Ee;var Fe;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(Fe||(e.LanguageStatusSeverity=Fe={}));let He=class{constructor(V,ge){this.range=V,this.command=ge}get isResolved(){return!!this.command}};e.CodeLens=He,e.CodeLens=He=Ge([C],He);let Ke=s=class{#e;static isMarkdownString(V){return V instanceof s?!0:V&&V.appendCodeblock&&V.appendMarkdown&&V.appendText&&V.value!==void 0}constructor(V,ge=!1){this.#e=new L.MarkdownString(V,{supportThemeIcons:ge})}get value(){return this.#e.value}set value(V){this.#e.value=V}get isTrusted(){return this.#e.isTrusted}set isTrusted(V){this.#e.isTrusted=V}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(V){this.#e.supportThemeIcons=V}get supportHtml(){return this.#e.supportHtml}set supportHtml(V){this.#e.supportHtml=V}get baseUri(){return this.#e.baseUri}set baseUri(V){this.#e.baseUri=V}appendText(V){return this.#e.appendText(V),this}appendMarkdown(V){return this.#e.appendMarkdown(V),this}appendCodeblock(V,ge){return this.#e.appendCodeblock(ge??"",V),this}};e.MarkdownString=Ke,e.MarkdownString=Ke=s=Ge([C],Ke);let rt=class{constructor(V,ge){this.label=V,this.documentation=ge}};e.ParameterInformation=rt,e.ParameterInformation=rt=Ge([C],rt);let tt=class{constructor(V,ge){this.label=V,this.documentation=ge,this.parameters=[]}};e.SignatureInformation=tt,e.SignatureInformation=tt=Ge([C],tt);let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=it,e.SignatureHelp=it=Ge([C],it);var st;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(st||(e.SignatureHelpTriggerKind=st={}));var Ie;(function(q){q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(Ie||(e.InlayHintKind=Ie={}));let Be=class{constructor(V){this.value=V}};e.InlayHintLabelPart=Be,e.InlayHintLabelPart=Be=Ge([C],Be);let qe=class{constructor(V,ge,Ne){this.position=V,this.label=ge,this.kind=Ne}};e.InlayHint=qe,e.InlayHint=qe=Ge([C],qe);var Oe;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Oe||(e.CompletionTriggerKind=Oe={}));var Qe;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(Qe||(e.CompletionItemKind=Qe={}));var ae;(function(q){q[q.Deprecated=1]="Deprecated"})(ae||(e.CompletionItemTag=ae={}));let ce=class{constructor(V,ge){this.label=V,this.kind=ge}toJSON(){return{label:this.label,kind:this.kind&&Qe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=ce,e.CompletionItem=ce=Ge([C],ce);let ke=class{constructor(V=[],ge=!1){this.items=V,this.isIncomplete=ge}};e.CompletionList=ke,e.CompletionList=ke=Ge([C],ke);let je=class{constructor(V,ge,Ne){this.insertText=V,this.range=ge,this.command=Ne}};e.InlineSuggestion=je,e.InlineSuggestion=je=Ge([C],je);let Le=class{constructor(V){this.commands=void 0,this.suppressSuggestions=void 0,this.items=V}};e.InlineSuggestionList=Le,e.InlineSuggestionList=Le=Ge([C],Le);var ot;(function(q){q[q.Unknown=0]="Unknown",q[q.Word=1]="Word",q[q.Line=2]="Line",q[q.Suggest=3]="Suggest"})(ot||(e.PartialAcceptTriggerKind=ot={}));var lt;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(lt||(e.ViewColumn=lt={}));var wt;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(wt||(e.StatusBarAlignment=wt={}));function At(q,V){return`${I.ExtensionIdentifier.toKey(q)}.${V}`}var Wt;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative",q[q.Interval=3]="Interval"})(Wt||(e.TextEditorLineNumbersStyle=Wt={}));var ti;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(ti||(e.TextDocumentSaveReason=ti={}));var Xt;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Xt||(e.TextEditorRevealType=Xt={}));var _t;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(_t||(e.TextEditorSelectionChangeKind=_t={}));var Qt;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(Qt||(e.TextDocumentChangeReason=Qt={}));var Yt;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(Yt||(e.DecorationRangeBehavior=Yt={})),function(q){function V(ge){switch(ge){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=V}(_t||(e.TextEditorSelectionChangeKind=_t={}));var et;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=3]="RegEx"})(et||(e.SyntaxTokenType=et={})),function(q){function V(ge){switch(ge){case q.Other:return"other";case q.Comment:return"comment";case q.String:return"string";case q.RegEx:return"regex"}return"other"}q.toString=V}(et||(e.SyntaxTokenType=et={}));let oi=class{constructor(V,ge){if(ge&&!y.URI.isUri(ge))throw(0,O.illegalArgument)("target");if(!z.isRange(V)||V.isEmpty)throw(0,O.illegalArgument)("range");this.range=V,this.target=ge}};e.DocumentLink=oi,e.DocumentLink=oi=Ge([C],oi);let jt=class{constructor(V,ge,Ne,Ye){this.red=V,this.green=ge,this.blue=Ne,this.alpha=Ye}};e.Color=jt,e.Color=jt=Ge([C],jt);let ft=class{constructor(V,ge){if(ge&&!(ge instanceof jt))throw(0,O.illegalArgument)("color");if(!z.isRange(V)||V.isEmpty)throw(0,O.illegalArgument)("range");this.range=V,this.color=ge}};e.ColorInformation=ft,e.ColorInformation=ft=Ge([C],ft);let pt=class{constructor(V){if(!V||typeof V!="string")throw(0,O.illegalArgument)("label");this.label=V}};e.ColorPresentation=pt,e.ColorPresentation=pt=Ge([C],pt);var Jt;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var Gt;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(Gt||(e.SourceControlInputBoxValidationType=Gt={}));var Ft;(function(q){q[q.Unknown=0]="Unknown",q[q.Shutdown=1]="Shutdown",q[q.Process=2]="Process",q[q.User=3]="User",q[q.Extension=4]="Extension"})(Ft||(e.TerminalExitReason=Ft={}));var gt;(function(q){q[q.Low=0]="Low",q[q.Medium=1]="Medium",q[q.High=2]="High"})(gt||(e.TerminalShellExecutionCommandLineConfidence=gt={}));class Ut{constructor(V,ge,Ne){if(this.startIndex=V,this.length=ge,this.tooltip=Ne,typeof V!="number"||V<0)throw(0,O.illegalArgument)("startIndex");if(typeof ge!="number"||ge<1)throw(0,O.illegalArgument)("length");if(Ne!==void 0&&typeof Ne!="string")throw(0,O.illegalArgument)("tooltip")}}e.TerminalLink=Ut;class Zt{constructor(V){this.uri=V}}e.TerminalQuickFixOpener=Zt;class $t{constructor(V){this.terminalCommand=V}}e.TerminalQuickFixCommand=$t;var Je;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(Je||(e.TerminalLocation=Je={}));class li{constructor(V){if(this.options=V,typeof V!="object")throw(0,O.illegalArgument)("options")}}e.TerminalProfile=li;var Kt;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(Kt||(e.TaskRevealKind=Kt={}));var Ht;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(Ht||(e.TaskPanelKind=Ht={}));let vt=class{static{w=this}static{this.Clean=new w("clean","Clean")}static{this.Build=new w("build","Build")}static{this.Rebuild=new w("rebuild","Rebuild")}static{this.Test=new w("test","Test")}static from(V){switch(V){case"clean":return w.Clean;case"build":return w.Build;case"rebuild":return w.Rebuild;case"test":return w.Test;default:return}}constructor(V,ge){if(this.label=ge,typeof V!="string"||typeof ge!="string")throw(0,O.illegalArgument)("name");this._id=V}get id(){return this._id}};e.TaskGroup=vt,e.TaskGroup=vt=w=Ge([C],vt);function xt(q){let V="";for(let ge=0;ge<q.length;ge++)V+=q[ge].replace(/,/g,",,")+",";return V}let Rt=class{constructor(V,ge,Ne){if(typeof V!="string")throw(0,O.illegalArgument)("process");this._args=[],this._process=V,ge!==void 0&&(Array.isArray(ge)?(this._args=ge,this._options=Ne):this._options=ge)}get process(){return this._process}set process(V){if(typeof V!="string")throw(0,O.illegalArgument)("process");this._process=V}get args(){return this._args}set args(V){Array.isArray(V)||(V=[]),this._args=V}get options(){return this._options}set options(V){this._options=V}computeId(){const V=[];if(V.push("process"),this._process!==void 0&&V.push(this._process),this._args&&this._args.length>0)for(const ge of this._args)V.push(ge);return xt(V)}};e.ProcessExecution=Rt,e.ProcessExecution=Rt=Ge([C],Rt);let Ot=class{constructor(V,ge,Ne){if(this._args=[],Array.isArray(ge)){if(!V)throw(0,O.illegalArgument)("command can't be undefined or null");if(typeof V!="string"&&typeof V.value!="string")throw(0,O.illegalArgument)("command");this._command=V,this._args=ge,this._options=Ne}else{if(typeof V!="string")throw(0,O.illegalArgument)("commandLine");this._commandLine=V,this._options=ge}}get commandLine(){return this._commandLine}set commandLine(V){if(typeof V!="string")throw(0,O.illegalArgument)("commandLine");this._commandLine=V}get command(){return this._command?this._command:""}set command(V){if(typeof V!="string"&&typeof V.value!="string")throw(0,O.illegalArgument)("command");this._command=V}get args(){return this._args}set args(V){this._args=V||[]}get options(){return this._options}set options(V){this._options=V}computeId(){const V=[];if(V.push("shell"),this._commandLine!==void 0&&V.push(this._commandLine),this._command!==void 0&&V.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ge of this._args)V.push(typeof ge=="string"?ge:ge.value);return xt(V)}};e.ShellExecution=Ot,e.ShellExecution=Ot=Ge([C],Ot);var ii;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(ii||(e.ShellQuoting=ii={}));var Vt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(Vt||(e.TaskScope=Vt={}));class ni{constructor(V){this._callback=V}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(V){this._callback=V}get callback(){return this._callback}}e.CustomExecution=ni;let kt=class{static{g=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(V,ge,Ne,Ye,nt,ht){this.__deprecated=!1,this._definition=this.definition=V;let bt;typeof ge=="string"?(this._name=this.name=ge,this._source=this.source=Ne,this.execution=Ye,bt=nt,this.__deprecated=!0):ge===Vt.Global||ge===Vt.Workspace?(this.target=ge,this._name=this.name=Ne,this._source=this.source=Ye,this.execution=nt,bt=ht):(this.target=ge,this._name=this.name=Ne,this._source=this.source=Ye,this.execution=nt,bt=ht),typeof bt=="string"?(this._problemMatchers=[bt],this._hasDefinedMatchers=!0):Array.isArray(bt)?(this._problemMatchers=bt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(V){this.__id=V}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Rt?this._definition={type:g.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ot?this._definition={type:g.ShellType,id:this._execution.computeId()}:this._execution instanceof ni?this._definition={type:g.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:g.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(V){if(V==null)throw(0,O.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=V}get scope(){return this._scope}set target(V){this.clear(),this._scope=V}get name(){return this._name}set name(V){if(typeof V!="string")throw(0,O.illegalArgument)("name");this.clear(),this._name=V}get execution(){return this._execution}set execution(V){V===null&&(V=void 0),this.clear(),this._execution=V;const ge=this._definition.type;(g.EmptyType===ge||g.ProcessType===ge||g.ShellType===ge||g.ExtensionCallbackType===ge)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(V){if(Array.isArray(V))this.clear(),this._problemMatchers=V,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(V){V!==!0&&V!==!1&&(V=!1),this.clear(),this._isBackground=V}get source(){return this._source}set source(V){if(typeof V!="string"||V.length===0)throw(0,O.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=V}get group(){return this._group}set group(V){V===null&&(V=void 0),this.clear(),this._group=V}get detail(){return this._detail}set detail(V){V===null&&(V=void 0),this._detail=V}get presentationOptions(){return this._presentationOptions}set presentationOptions(V){V==null&&(V=Object.create(null)),this.clear(),this._presentationOptions=V}get runOptions(){return this._runOptions}set runOptions(V){V==null&&(V=Object.create(null)),this.clear(),this._runOptions=V}};e.Task=kt,e.Task=kt=g=Ge([C],kt);var Nt;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(Nt||(e.ProgressLocation=Nt={}));var Lt;(function(q){function V(ge){const Ne=ge;return(0,m.isNumber)(Ne.value)?Ne.tooltip&&!(0,m.isString)(Ne.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ne.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ne.value),!1)}q.isViewBadge=V})(Lt||(e.ViewBadge=Lt={}));let Pt=D=class{static isTreeItem(V,ge){const Ne=V;if(Ne.checkboxState!==void 0){const Ye=(0,m.isNumber)(Ne.checkboxState)?Ne.checkboxState:(0,m.isObject)(Ne.checkboxState)&&(0,m.isNumber)(Ne.checkboxState.state)?Ne.checkboxState.state:void 0,nt=!(0,m.isNumber)(Ne.checkboxState)&&(0,m.isObject)(Ne.checkboxState)?Ne.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==Ct.Checked&&Ye!==Ct.Unchecked||nt!==void 0&&!(0,m.isString)(nt))return console.log("INVALID tree item, invalid checkboxState",Ne.checkboxState),!1}if(V instanceof D)return!0;if(Ne.label!==void 0&&!(0,m.isString)(Ne.label)&&!Ne.label?.label)return console.log("INVALID tree item, invalid label",Ne.label),!1;if(Ne.id!==void 0&&!(0,m.isString)(Ne.id))return console.log("INVALID tree item, invalid id",Ne.id),!1;if(Ne.iconPath!==void 0&&!(0,m.isString)(Ne.iconPath)&&!y.URI.isUri(Ne.iconPath)&&(!Ne.iconPath||!(0,m.isString)(Ne.iconPath.id))){const Ye=Ne.iconPath;if(!Ye||!(0,m.isString)(Ye.light)&&!y.URI.isUri(Ye.light)&&!(0,m.isString)(Ye.dark)&&!y.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Ne.iconPath),!1}return Ne.description!==void 0&&!(0,m.isString)(Ne.description)&&typeof Ne.description!="boolean"?(console.log("INVALID tree item, invalid description",Ne.description),!1):Ne.resourceUri!==void 0&&!y.URI.isUri(Ne.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ne.resourceUri),!1):Ne.tooltip!==void 0&&!(0,m.isString)(Ne.tooltip)&&!(Ne.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",Ne.tooltip),!1):Ne.command!==void 0&&!Ne.command.command?(console.log("INVALID tree item, invalid command",Ne.command),!1):Ne.collapsibleState!==void 0&&Ne.collapsibleState<mt.None&&Ne.collapsibleState>mt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ne.collapsibleState),!1):Ne.contextValue!==void 0&&!(0,m.isString)(Ne.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ne.contextValue),!1):Ne.accessibilityInformation!==void 0&&!Ne.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ne.accessibilityInformation),!1):!0}constructor(V,ge=mt.None){this.collapsibleState=ge,y.URI.isUri(V)?this.resourceUri=V:this.label=V}};e.TreeItem=Pt,e.TreeItem=Pt=D=Ge([C],Pt);var mt;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(mt||(e.TreeItemCollapsibleState=mt={}));var Ct;(function(q){q[q.Unchecked=0]="Unchecked",q[q.Checked=1]="Checked"})(Ct||(e.TreeItemCheckboxState=Ct={}));let ai=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(V){this.value=V}};e.DataTransferItem=ai,e.DataTransferItem=ai=Ge([C],ai);class Dt extends ai{}e.InternalDataTransferItem=Dt;class fi extends Dt{#e;constructor(V){super(""),this.#e=V}asFile(){return this.#e}}e.InternalFileDataTransferItem=fi;class ri{constructor(V,ge,Ne,Ye){this.name=V,this.uri=ge,this._itemId=Ne,this._getData=Ye}data(){return this._getData()}}e.DataTransferFile=ri;let pi=class{#e=new Map;constructor(V){for(const[ge,Ne]of V??[]){const Ye=this.#e.get(this.#t(ge));Ye?Ye.push(Ne):this.#e.set(this.#t(ge),[Ne])}}get(V){return this.#e.get(this.#t(V))?.[0]}set(V,ge){this.#e.set(this.#t(V),[ge])}forEach(V,ge){for(const[Ne,Ye]of this.#e)for(const nt of Ye)V.call(ge,nt,Ne,this)}*[Symbol.iterator](){for(const[V,ge]of this.#e)for(const Ne of ge)yield[V,Ne]}#t(V){return V.toLowerCase()}};e.DataTransfer=pi,e.DataTransfer=pi=Ge([C],pi);let ui=class{constructor(V,ge,Ne){this.insertText=V,this.title=ge,this.kind=Ne}};e.DocumentDropEdit=ui,e.DocumentDropEdit=ui=Ge([C],ui);var bi;(function(q){q[q.Automatic=0]="Automatic",q[q.PasteAs=1]="PasteAs"})(bi||(e.DocumentPasteTriggerKind=bi={}));class It{static{this.sep="."}constructor(V){this.value=V}append(...V){return new It((this.value?[this.value,...V]:V).join(It.sep))}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+It.sep)}}e.DocumentDropOrPasteEditKind=It,It.Empty=new It("");class wi{constructor(V,ge,Ne){this.title=ge,this.insertText=V,this.kind=Ne}}e.DocumentPasteEdit=wi;let si=class{constructor(V,ge){this.id=V,this.color=ge}static isThemeIcon(V){return typeof V.id!="string"?(console.log("INVALID ThemeIcon, invalid id",V.id),!1):!0}};e.ThemeIcon=si,e.ThemeIcon=si=Ge([C],si),si.File=new si("file"),si.Folder=new si("folder");let Re=class{constructor(V){this.id=V}};e.ThemeColor=Re,e.ThemeColor=Re=Ge([C],Re);var xe;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(xe||(e.ConfigurationTarget=xe={}));let Se=class{get base(){return this._base}set base(V){this._base=V,this._baseUri=y.URI.file(V)}get baseUri(){return this._baseUri}set baseUri(V){this._baseUri=V,this._base=V.fsPath}constructor(V,ge){if(typeof V!="string"&&(!V||!y.URI.isUri(V)&&!y.URI.isUri(V.uri)))throw(0,O.illegalArgument)("base");if(typeof ge!="string")throw(0,O.illegalArgument)("pattern");typeof V=="string"?this.baseUri=y.URI.file(V):y.URI.isUri(V)?this.baseUri=V:this.baseUri=V.uri,this.pattern=ge}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=Se,e.RelativePattern=Se=Ge([C],Se);const J=new WeakMap;function Me(q,V){J.set(q,V)}let Ve=class{constructor(V,ge,Ne,Ye,nt){this.enabled=typeof V=="boolean"?V:!0,typeof ge=="string"&&(this.condition=ge),typeof Ne=="string"&&(this.hitCondition=Ne),typeof Ye=="string"&&(this.logMessage=Ye),typeof nt=="string"&&(this.mode=nt)}get id(){return this._id||(this._id=J.get(this)??(0,T.generateUuid)()),this._id}};e.Breakpoint=Ve,e.Breakpoint=Ve=Ge([C],Ve);let Ze=class extends Ve{constructor(V,ge,Ne,Ye,nt,ht){if(super(ge,Ne,Ye,nt,ht),V===null)throw(0,O.illegalArgument)("location");this.location=V}};e.SourceBreakpoint=Ze,e.SourceBreakpoint=Ze=Ge([C],Ze);let Xe=class extends Ve{constructor(V,ge,Ne,Ye,nt,ht){super(ge,Ne,Ye,nt,ht),this.functionName=V}};e.FunctionBreakpoint=Xe,e.FunctionBreakpoint=Xe=Ge([C],Xe);let dt=class extends Ve{constructor(V,ge,Ne,Ye,nt,ht,bt,qt){if(super(Ye,nt,ht,bt,qt),!ge)throw(0,O.illegalArgument)("dataId");this.label=V,this.dataId=ge,this.canPersist=Ne}};e.DataBreakpoint=dt,e.DataBreakpoint=dt=Ge([C],dt);let yt=class{constructor(V,ge,Ne){this.command=V,this.args=ge||[],this.options=Ne}};e.DebugAdapterExecutable=yt,e.DebugAdapterExecutable=yt=Ge([C],yt);let zt=class{constructor(V,ge){this.port=V,this.host=ge}};e.DebugAdapterServer=zt,e.DebugAdapterServer=zt=Ge([C],zt);let ut=class{constructor(V){this.path=V}};e.DebugAdapterNamedPipeServer=ut,e.DebugAdapterNamedPipeServer=ut=Ge([C],ut);let Mt=class{constructor(V){this.implementation=V}};e.DebugAdapterInlineImplementation=Mt,e.DebugAdapterInlineImplementation=Mt=Ge([C],Mt);class Bt{constructor(V,ge,Ne){this.session=V,this.threadId=ge,this.frameId=Ne}}e.DebugStackFrame=Bt;class Si{constructor(V,ge){this.session=V,this.threadId=ge}}e.DebugThread=Si;let Ci=class{constructor(V,ge){this.range=V,this.expression=ge}};e.EvaluatableExpression=Ci,e.EvaluatableExpression=Ci=Ge([C],Ci);var ji;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(ji||(e.InlineCompletionTriggerKind=ji={}));let Li=class{constructor(V,ge){this.range=V,this.text=ge}};e.InlineValueText=Li,e.InlineValueText=Li=Ge([C],Li);let Oi=class{constructor(V,ge,Ne=!0){this.range=V,this.variableName=ge,this.caseSensitiveLookup=Ne}};e.InlineValueVariableLookup=Oi,e.InlineValueVariableLookup=Oi=Ge([C],Oi);let Di=class{constructor(V,ge){this.range=V,this.expression=ge}};e.InlineValueEvaluatableExpression=Di,e.InlineValueEvaluatableExpression=Di=Ge([C],Di);let Ni=class{constructor(V,ge){this.frameId=V,this.stoppedLocation=ge}};e.InlineValueContext=Ni,e.InlineValueContext=Ni=Ge([C],Ni);var Mi;(function(q){q[q.AIGenerated=1]="AIGenerated"})(Mi||(e.NewSymbolNameTag=Mi={}));var Gi;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(Gi||(e.NewSymbolNameTriggerKind=Gi={}));class Fi{constructor(V,ge){this.newSymbolName=V,this.tags=ge}}e.NewSymbolName=Fi;var Ii;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Ii||(e.FileChangeType=Ii={}));let xi=v=class extends Error{static FileExists(V){return new v(V,p.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(V){return new v(V,p.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(V){return new v(V,p.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(V){return new v(V,p.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(V){return new v(V,p.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(V){return new v(V,p.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}constructor(V,ge=p.FileSystemProviderErrorCode.Unknown,Ne){super(y.URI.isUri(V)?V.toString(!0):V),this.code=Ne?.name??"Unknown",(0,p.markAsFileSystemProviderError)(this,ge),Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof Ne=="function"&&Error.captureStackTrace(this,Ne)}};e.FileSystemError=xi,e.FileSystemError=xi=v=Ge([C],xi);let zi=class{constructor(V,ge,Ne){this.start=V,this.end=ge,this.kind=Ne}};e.FoldingRange=zi,e.FoldingRange=zi=Ge([C],zi);var Ei;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(Ei||(e.FoldingRangeKind=Ei={}));var Ki;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(Ki||(e.CommentThreadCollapsibleState=Ki={}));var Xi;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(Xi||(e.CommentMode=Xi={}));var Qi;(function(q){q[q.Published=0]="Published",q[q.Draft=1]="Draft"})(Qi||(e.CommentState=Qi={}));var Pi;(function(q){q[q.Unresolved=0]="Unresolved",q[q.Resolved=1]="Resolved"})(Pi||(e.CommentThreadState=Pi={}));var Yi;(function(q){q[q.Current=0]="Current",q[q.Outdated=1]="Outdated"})(Yi||(e.CommentThreadApplicability=Yi={}));class Ji{constructor(V,ge=[]){this.tokenTypes=V,this.tokenModifiers=ge}}e.SemanticTokensLegend=Ji;function hn(q){return typeof q>"u"||(0,m.isStringArray)(q)}class ki{constructor(V){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,V){this._hasLegend=!0;for(let ge=0,Ne=V.tokenTypes.length;ge<Ne;ge++)this._tokenTypeStrToInt.set(V.tokenTypes[ge],ge);for(let ge=0,Ne=V.tokenModifiers.length;ge<Ne;ge++)this._tokenModifierStrToInt.set(V.tokenModifiers[ge],ge)}}push(V,ge,Ne,Ye,nt){if(typeof V=="number"&&typeof ge=="number"&&typeof Ne=="number"&&typeof Ye=="number"&&(typeof nt=="number"||typeof nt>"u"))return typeof nt>"u"&&(nt=0),this._pushEncoded(V,ge,Ne,Ye,nt);if(z.isRange(V)&&typeof ge=="string"&&hn(Ne))return this._push(V,ge,Ne);throw(0,O.illegalArgument)()}_push(V,ge,Ne){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(V.start.line!==V.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ge))throw new Error("`tokenType` is not in the provided legend");const Ye=V.start.line,nt=V.start.character,ht=V.end.character-V.start.character,bt=this._tokenTypeStrToInt.get(ge);let qt=0;if(Ne)for(const ci of Ne){if(!this._tokenModifierStrToInt.has(ci))throw new Error("`tokenModifier` is not in the provided legend");const hi=this._tokenModifierStrToInt.get(ci);qt|=1<<hi>>>0}this._pushEncoded(Ye,nt,ht,bt,qt)}_pushEncoded(V,ge,Ne,Ye,nt){if(this._dataIsSortedAndDeltaEncoded&&(V<this._prevLine||V===this._prevLine&&ge<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const qt=this._data.length/5|0;let ci=0,hi=0;for(let mi=0;mi<qt;mi++){let vi=this._data[5*mi],Vi=this._data[5*mi+1];vi===0?(vi=ci,Vi+=hi):vi+=ci,this._data[5*mi]=vi,this._data[5*mi+1]=Vi,ci=vi,hi=Vi}}let ht=V,bt=ge;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ht-=this._prevLine,ht===0&&(bt-=this._prevChar)),this._data[this._dataLen++]=ht,this._data[this._dataLen++]=bt,this._data[this._dataLen++]=Ne,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=nt,this._prevLine=V,this._prevChar=ge}static _sortAndDeltaEncode(V){const ge=[],Ne=V.length/5|0;for(let bt=0;bt<Ne;bt++)ge[bt]=bt;ge.sort((bt,qt)=>{const ci=V[5*bt],hi=V[5*qt];if(ci===hi){const mi=V[5*bt+1],vi=V[5*qt+1];return mi-vi}return ci-hi});const Ye=new Uint32Array(V.length);let nt=0,ht=0;for(let bt=0;bt<Ne;bt++){const qt=5*ge[bt],ci=V[qt+0],hi=V[qt+1],mi=V[qt+2],vi=V[qt+3],Vi=V[qt+4],Nn=ci-nt,hr=Nn===0?hi-ht:hi,qi=5*bt;Ye[qi+0]=Nn,Ye[qi+1]=hr,Ye[qi+2]=mi,Ye[qi+3]=vi,Ye[qi+4]=Vi,nt=ci,ht=hi}return Ye}build(V){return this._dataIsSortedAndDeltaEncoded?new Bi(new Uint32Array(this._data),V):new Bi(ki._sortAndDeltaEncode(this._data),V)}}e.SemanticTokensBuilder=ki;class Bi{constructor(V,ge){this.resultId=ge,this.data=V}}e.SemanticTokens=Bi;class fn{constructor(V,ge,Ne){this.start=V,this.deleteCount=ge,this.data=Ne}}e.SemanticTokensEdit=fn;class gn{constructor(V,ge){this.resultId=ge,this.edits=V}}e.SemanticTokensEdits=gn;var Zi;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));class Wi{constructor(V){this.name=V}}e.DebugVisualization=Wi;let Ti=class{static{this.Back={iconPath:new si("arrow-left")}}constructor(){}};e.QuickInputButtons=Ti,e.QuickInputButtons=Ti=Ge([C],Ti);var $e;(function(q){q[q.Separator=-1]="Separator",q[q.Default=0]="Default"})($e||(e.QuickPickItemKind=$e={}));var di;(function(q){q[q.Info=1]="Info",q[q.Warning=2]="Warning",q[q.Error=3]="Error"})(di||(e.InputBoxValidationSeverity=di={}));var $i;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})($i||(e.ExtensionKind=$i={}));class at{static validate(V){if(typeof V.badge=="string"){let ge=(0,b.nextCharLength)(V.badge,0);if(ge<V.badge.length&&(ge+=(0,b.nextCharLength)(V.badge,ge)),V.badge.length>ge)throw new Error("The 'badge'-property must be undefined or a short character")}else if(V.badge&&!si.isThemeIcon(V.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!V.color&&!V.badge&&!V.tooltip)throw new Error("The decoration is empty");return!0}constructor(V,ge,Ne){this.badge=V,this.tooltip=ge,this.color=Ne}}e.FileDecoration=at;let Et=class{constructor(V){this.kind=V}};e.ColorTheme=Et,e.ColorTheme=Et=Ge([C],Et);var en;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast",q[q.HighContrastLight=4]="HighContrastLight"})(en||(e.ColorThemeKind=en={}));class gi{static isNotebookRange(V){return V instanceof gi?!0:V?typeof V.start=="number"&&typeof V.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(V,ge){if(V<0)throw(0,O.illegalArgument)("start must be positive");if(ge<0)throw(0,O.illegalArgument)("end must be positive");V<=ge?(this._start=V,this._end=ge):(this._start=ge,this._end=V)}with(V){let ge=this._start,Ne=this._end;return V.start!==void 0&&(ge=V.start),V.end!==void 0&&(Ne=V.end),ge===this._start&&Ne===this._end?this:new gi(ge,Ne)}}e.NotebookRange=gi;class yi{static validate(V){if(typeof V.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof V.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof V.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(V){return Array.isArray(V)&&V.every(ge=>yi.isNotebookCellData(ge))}static isNotebookCellData(V){return!0}constructor(V,ge,Ne,Ye,nt,ht,bt){this.kind=V,this.value=ge,this.languageId=Ne,this.mime=Ye,this.outputs=nt??[],this.metadata=ht,this.executionSummary=bt,yi.validate(this)}}e.NotebookCellData=yi;class mn{constructor(V){this.cells=V}}e.NotebookData=mn;class ei{static isNotebookCellOutputItem(V){return V instanceof ei?!0:V?typeof V.mime=="string"&&V.data instanceof Uint8Array:!1}static error(V){const ge={name:V.name,message:V.message,stack:V.stack};return ei.json(ge,"application/vnd.code.notebook.error")}static stdout(V){return ei.text(V,"application/vnd.code.notebook.stdout")}static stderr(V){return ei.text(V,"application/vnd.code.notebook.stderr")}static bytes(V,ge="application/octet-stream"){return new ei(V,ge)}static#e=new TextEncoder;static text(V,ge=R.Mimes.text){const Ne=ei.#e.encode(String(V));return new ei(Ne,ge)}static json(V,ge="text/x-json"){const Ne=JSON.stringify(V,void 0,"	");return ei.text(Ne,ge)}constructor(V,ge){this.data=V,this.mime=ge;const Ne=(0,R.normalizeMimeType)(ge,!0);if(!Ne)throw new Error(`INVALID mime type: ${ge}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ne}}e.NotebookCellOutputItem=ei;class Ai{static isNotebookCellOutput(V){return V instanceof Ai?!0:!V||typeof V!="object"?!1:typeof V.id=="string"&&Array.isArray(V.items)}static ensureUniqueMimeTypes(V,ge=!1){const Ne=new Set,Ye=new Set;for(let nt=0;nt<V.length;nt++){const ht=V[nt],bt=(0,R.normalizeMimeType)(ht.mime);if(!Ne.has(bt)||(0,E.isTextStreamMime)(bt)){Ne.add(bt);continue}Ye.add(nt),ge&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Ye.size===0?V:V.filter((nt,ht)=>!Ye.has(ht))}constructor(V,ge,Ne){this.items=Ai.ensureUniqueMimeTypes(V,!0),typeof ge=="string"?(this.id=ge,this.metadata=Ne):(this.id=(0,T.generateUuid)(),this.metadata=ge??Ne)}}e.NotebookCellOutput=Ai;var tn;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var Ui;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(Ui||(e.NotebookCellStatusBarAlignment=Ui={}));var rn;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(rn||(e.NotebookEditorRevealType=rn={}));class pn{constructor(V,ge){this.text=V,this.alignment=ge}}e.NotebookCellStatusBarItem=pn;var sn;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var on;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred",q[q.Hidden=-1]="Hidden"})(on||(e.NotebookControllerAffinity2=on={}));class vn{constructor(V,ge=[]){this.uri=V,this.provides=(0,h.asArray)(ge)}}e.NotebookRendererScript=vn;class bn{constructor(V){this.label=V}}e.NotebookKernelSourceAction=bn;var an;(function(q){q[q.Named=1]="Named",q[q.Indexed=2]="Indexed"})(an||(e.NotebookVariablesRequestKind=an={}));let Hi=class{constructor(V,ge){this.label=V,this.timestamp=ge}};e.TimelineItem=Hi,e.TimelineItem=Hi=Ge([C],Hi);var cn;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(cn||(e.ExtensionMode=cn={}));var ln;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(ln||(e.ExtensionRuntime=ln={}));var un;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=3]="RegEx"})(un||(e.StandardTokenType=un={}));class he{constructor(V,ge){this.ranges=V,this.wordPattern=ge}}e.LinkedEditingRanges=he;class ye{constructor(V){this._autoForwardAction=V}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ye;var We;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(We||(e.TestResultState=We={}));var ct;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(ct||(e.TestRunProfileKind=ct={}));let St=class{constructor(V=void 0,ge=void 0,Ne=void 0,Ye=!1,nt=!0){this.include=V,this.exclude=ge,this.profile=Ne,this.continuous=Ye,this.preserveFocus=nt}};e.TestRunRequest=St,e.TestRunRequest=St=Ge([C],St);let Tt=_=class{static diff(V,ge,Ne){const Ye=new _(V);return Ye.expectedOutput=ge,Ye.actualOutput=Ne,Ye}constructor(V){this.message=V}};e.TestMessage=Tt,e.TestMessage=Tt=_=Ge([C],Tt);let _i=class{constructor(V){this.id=V}};e.TestTag=_i,e.TestTag=_i=Ge([C],_i);class dn{constructor(V,ge){this.covered=V,this.total=ge,wn(this)}}e.TestCoverageCount=dn;function wn(q){if(q){if(q.covered>q.total)throw new Error(`The total number of covered items (${q.covered}) cannot be greater than the total (${q.total})`);if(q.total<0)throw new Error(`The number of covered items (${q.total}) cannot be negative`)}}class En{static fromDetails(V,ge){const Ne=new dn(0,0),Ye=new dn(0,0),nt=new dn(0,0);for(const bt of ge)if("branches"in bt){Ne.total+=1,Ne.covered+=bt.executed?1:0;for(const qt of bt.branches)Ye.total+=1,Ye.covered+=qt.executed?1:0}else nt.total+=1,nt.covered+=bt.executed?1:0;const ht=new En(V,Ne,Ye.total>0?Ye:void 0,nt.total>0?nt:void 0);return ht.detailedCoverage=ge,ht}constructor(V,ge,Ne,Ye){this.uri=V,this.statementCoverage=ge,this.branchCoverage=Ne,this.declarationCoverage=Ye}}e.FileCoverage=En;class Mn{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,ge,Ne=[]){this.executed=V,this.location=ge,this.branches=Ne}}e.StatementCoverage=Mn;class Fn{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,ge,Ne){this.executed=V,this.location=ge,this.label=Ne}}e.BranchCoverage=Fn;class xn{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,ge,Ne){this.name=V,this.executed=ge,this.location=Ne}}e.DeclarationCoverage=xn;var Sn;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(Sn||(e.ExternalUriOpenerPriority=Sn={}));var yn;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(yn||(e.WorkspaceTrustState=yn={}));var _n;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(_n||(e.PortAutoForwardAction=_n={}));class zn{constructor(V,ge,Ne,Ye,nt,ht){this.kind=V,this.name=ge,this.detail=Ne,this.uri=Ye,this.range=nt,this.selectionRange=ht}}e.TypeHierarchyItem=zn;class Bn{constructor(V){this.uri=V}}e.TextTabInput=Bn;class Wn{constructor(V,ge){this.original=V,this.modified=ge}}e.TextDiffTabInput=Wn;class $n{constructor(V,ge,Ne,Ye){this.base=V,this.input1=ge,this.input2=Ne,this.result=Ye}}e.TextMergeTabInput=$n;class Un{constructor(V,ge){this.uri=V,this.viewType=ge}}e.CustomEditorTabInput=Un;class Hn{constructor(V){this.viewType=V}}e.WebviewEditorTabInput=Hn;class Vn{constructor(V,ge){this.uri=V,this.notebookType=ge}}e.NotebookEditorTabInput=Vn;class qn{constructor(V,ge,Ne){this.original=V,this.modified=ge,this.notebookType=Ne}}e.NotebookDiffEditorTabInput=qn;class jn{constructor(){}}e.TerminalEditorTabInput=jn;class Gn{constructor(V,ge){this.uri=V,this.inputBoxUri=ge}}e.InteractiveWindowInput=Gn;class Kn{constructor(){}}e.ChatEditorTabInput=Kn;class Xn{constructor(V){this.textDiffs=V}}e.TextMultiDiffTabInput=Xn;var Cn;(function(q){q[q.Down=0]="Down",q[q.Up=1]="Up"})(Cn||(e.InteractiveSessionVoteDirection=Cn={}));var Dn;(function(q){q[q.Action=1]="Action",q[q.Toolbar=2]="Toolbar"})(Dn||(e.ChatCopyKind=Dn={}));var In;(function(q){q[q.Short=1]="Short",q[q.Medium=2]="Medium",q[q.Full=3]="Full"})(In||(e.ChatVariableLevel=In={}));class Qn{constructor(V,ge){this.label=V,this.values=ge}}e.ChatCompletionItem=Qn;var Pn;(function(q){q[q.Unhelpful=0]="Unhelpful",q[q.Helpful=1]="Helpful",q[q.Undone=2]="Undone",q[q.Accepted=3]="Accepted",q[q.Bug=4]="Bug"})(Pn||(e.InteractiveEditorResponseFeedbackKind=Pn={}));var kn;(function(q){q[q.Unhelpful=0]="Unhelpful",q[q.Helpful=1]="Helpful"})(kn||(e.ChatResultFeedbackKind=kn={}));class Yn{constructor(V){if(typeof V!="string"&&V.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof V=="string"?new Ke(V):V}}e.ChatResponseMarkdownPart=Yn;class Jn{constructor(V,ge){if(typeof V!="string"&&V.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof V=="string"?new Ke(V):V,this.vulnerabilities=ge}}e.ChatResponseMarkdownWithVulnerabilitiesPart=Jn;class Zn{constructor(V,ge){this.participant=V,this.command=ge}}e.ChatResponseDetectedParticipantPart=Zn;class er{constructor(V,ge){this.value=V,this.baseUri=ge}}e.ChatResponseFileTreePart=er;class tr{constructor(V,ge){this.value=V,this.title=ge}}e.ChatResponseAnchorPart=tr;class ir{constructor(V){this.value=V}}e.ChatResponseProgressPart=ir;class nr{constructor(V){this.value=V}}e.ChatResponseCommandButtonPart=nr;class rr{constructor(V,ge){this.value=V,this.iconPath=ge}}e.ChatResponseReferencePart=rr;class sr{constructor(V,ge){this.uri=V,this.edits=Array.isArray(ge)?ge:[ge]}}e.ChatResponseTextEditPart=sr;class or{constructor(V,ge,Ne,Ye){this.prompt=V,this.command=ge,this.variables=Ne,this.participant=Ye}}e.ChatRequestTurn=or;class ar{constructor(V,ge,Ne,Ye){this.response=V,this.result=ge,this.participant=Ne,this.command=Ye}}e.ChatResponseTurn=ar;var Tn;(function(q){q[q.Panel=1]="Panel",q[q.Terminal=2]="Terminal",q[q.Notebook=3]="Notebook",q[q.Editor=4]="Editor"})(Tn||(e.ChatLocation=Tn={}));class cr{constructor(V){this.content=V}}e.LanguageModelChatSystemMessage=cr;class lr{constructor(V,ge){this.content=V,this.name=ge}}e.LanguageModelChatUserMessage=lr;class ur{constructor(V,ge){this.content=V,this.name=ge}}e.LanguageModelChatAssistantMessage=ur;class Ri extends Error{static NotFound(V){return new Ri(V,Ri.NotFound.name)}static NoPermissions(V){return new Ri(V,Ri.NoPermissions.name)}constructor(V,ge,Ne){super(V,{cause:Ne}),this.name="LanguageModelError",this.code=ge??""}}e.LanguageModelError=Ri;var An;(function(q){q[q.SymbolInformation=1]="SymbolInformation",q[q.CommandInformation=2]="CommandInformation",q[q.SearchInformation=3]="SearchInformation",q[q.SettingInformation=4]="SettingInformation"})(An||(e.RelatedInformationType=An={}));var Rn;(function(q){q[q.Started=1]="Started",q[q.Recognizing=2]="Recognizing",q[q.Recognized=3]="Recognized",q[q.Stopped=4]="Stopped",q[q.Error=5]="Error"})(Rn||(e.SpeechToTextStatus=Rn={}));var Ln;(function(q){q[q.Recognized=1]="Recognized",q[q.Stopped=2]="Stopped"})(Ln||(e.KeywordRecognitionStatus=Ln={}));class dr{constructor(V,ge){this.text=V,this.range=ge}}e.InlineEdit=dr;var On;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(On||(e.InlineEditTriggerKind=On={}))}),define(_e[329],Ce([1,0,6,8]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class L{constructor(R){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=R.getProxy(h.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,b,m){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const y=this._relatedInformationProviders.get(R);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation(b,m)??[]}getRelatedInformation(R,b,m){return this._proxy.$getAiRelatedInformation(b,m)}registerRelatedInformationProvider(R,b,m){const y=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(y,m),this._proxy.$registerAiRelatedInformationProvider(y,b),new O.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(y),this._relatedInformationProviders.delete(y)})}}e.ExtHostRelatedInformation=L}),define(_e[121],Ce([1,0,4,6,8,25,146,5,20]),function(ue,e,h,O,L,A,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=e.IExtHostAuthentication=void 0,e.IExtHostAuthentication=(0,b.createDecorator)("IExtHostAuthentication");let y=class{constructor(p){this._authenticationProviders=new Map,this._onDidChangeSessions=new h.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new T,this._getSessionsTaskSingler=new T,this._proxy=p.getProxy(O.MainContext.MainThreadAuthentication)}async getSession(p,S,E,d={}){const f=A.ExtensionIdentifier.toKey(p.identifier),a=[...E].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${f} ${S} ${a}`,async()=>{await this._proxy.$ensureProvider(S);const i=p.displayName||p.name;return this._proxy.$getSession(S,E,f,i,d)})}async getSessions(p,S,E){const d=A.ExtensionIdentifier.toKey(p.identifier),f=[...E].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${d} ${f}`,async()=>{await this._proxy.$ensureProvider(S);const a=p.displayName||p.name;return this._proxy.$getSessions(S,E,d,a)})}async removeSession(p,S){const E=this._authenticationProviders.get(p);return E?E.provider.removeSession(S):this._proxy.$removeSession(p,S)}registerAuthenticationProvider(p,S,E,d){if(this._authenticationProviders.get(p))throw new Error(`An authentication provider with id '${p}' is already registered.`);this._authenticationProviders.set(p,{label:S,provider:E,options:d??{supportsMultipleAccounts:!1}});const f=E.onDidChangeSessions(a=>this._proxy.$sendDidChangeSessions(p,a));return this._proxy.$registerAuthenticationProvider(p,S,d?.supportsMultipleAccounts??!1),new L.Disposable(()=>{f.dispose(),this._authenticationProviders.delete(p),this._proxy.$unregisterAuthenticationProvider(p)})}$createSession(p,S,E){const d=this._authenticationProviders.get(p);if(d)return Promise.resolve(d.provider.createSession(S,E));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$removeSession(p,S){const E=this._authenticationProviders.get(p);if(E)return Promise.resolve(E.provider.removeSession(S));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$getSessions(p,S){const E=this._authenticationProviders.get(p);if(E)return Promise.resolve(E.provider.getSessions(S));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$onDidChangeAuthenticationSessions(p,S){return p.startsWith(R.INTERNAL_AUTH_PROVIDER_PREFIX)||this._onDidChangeSessions.fire({provider:{id:p,label:S}}),Promise.resolve()}};e.ExtHostAuthentication=y,e.ExtHostAuthentication=y=Ge([Ue(0,m.IExtHostRpcService)],y);class T{constructor(){this._inFlightPromises=new Map}getOrCreate(p,S){const E=this._inFlightPromises.get(p);if(E)return E;const d=S().finally(()=>this._inFlightPromises.delete(p));return this._inFlightPromises.set(p,d),d}}}),define(_e[152],Ce([1,0,2,6,8,5,20,11,19,14,17,26]),function(ue,e,h,O,L,A,R,b,m,y,T,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let S=class{static{p=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(d,f){this._logService=f,this._provider=new Map,this._proxy=d.getProxy(O.MainContext.MainThreadDecorations)}registerFileDecorationProvider(d,f){const a=p._handlePool++;this._provider.set(a,{provider:d,extensionDescription:f}),this._proxy.$registerDecorationProvider(a,f.identifier.value);const i=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(n=>{if(!n){this._proxy.$onDidChange(a,null);return}const l=(0,m.asArray)(n);if(l.length<=p._maxEventSize){this._proxy.$onDidChange(a,l);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,l.length);const o=l.map(r=>({uri:r,rank:(0,y.count)(r.path,"/")})),t=(0,m.groupBy)(o,(r,c)=>r.rank-c.rank||(0,y.compare)(r.uri.path,c.uri.path)),u=[];e:for(const r of t){let c;for(const s of r){const w=(0,T.dirname)(s.uri.path);if(c!==w&&(c=w,u.push(s.uri)>=p._maxEventSize))break e}}this._proxy.$onDidChange(a,u)});return new L.Disposable(()=>{i?.dispose(),this._proxy.$unregisterDecorationProvider(a),this._provider.delete(a)})}async $provideDecorations(d,f,a){if(!this._provider.has(d))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:l}=this._provider.get(d);return await Promise.all(f.map(async o=>{try{const{uri:t,id:u}=o,r=await Promise.resolve(n.provideFileDecoration(h.URI.revive(t),a));if(!r)return;try{L.FileDecoration.validate(r),r.badge&&typeof r.badge!="string"&&(0,I.checkProposedApiEnabled)(l,"codiconDecoration"),i[u]=[r.propagate,r.tooltip,r.badge,r.color]}catch(c){this._logService.warn(`INVALID decoration from extension '${l.identifier.value}': ${c}`)}}catch(t){this._logService.error(t)}})),i}};e.ExtHostDecorations=S,e.ExtHostDecorations=S=p=Ge([Ue(0,R.IExtHostRpcService),Ue(1,b.ILogService)],S),e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(_e[330],Ce([1,0,13,2,8,6,15,22,14]),function(ue,e,h,O,L,A,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class y{static{this._handlePool=0}constructor(I,p,S){this._documentsAndEditors=p,this._logService=S,this._documentContentProviders=new Map,this._proxy=I.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,p){if(Object.keys(R.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const S=y._handlePool++;this._documentContentProviders.set(S,p),this._proxy.$registerTextContentProvider(S,I);let E;if(typeof p.onDidChange=="function"){let d;E=p.onDidChange(async f=>{if(f.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}if(!this._documentsAndEditors.getDocument(f))return;d&&await d;const a=this.$provideTextDocumentContent(S,f).then(async i=>{if(!i&&typeof i!="string")return;const n=this._documentsAndEditors.getDocument(f);if(!n)return;const l=(0,m.splitLines)(i);if(!n.equalLines(l))return this._proxy.$onVirtualDocumentChange(f,i)}).catch(h.onUnexpectedError).finally(()=>{d===a&&(d=void 0)});d=a})}return new L.Disposable(()=>{this._documentContentProviders.delete(S)&&this._proxy.$unregisterTextContentProvider(S),E&&(E.dispose(),E=void 0)})}$provideTextDocumentContent(I,p){const S=this._documentContentProviders.get(I);return S?Promise.resolve(S.provideTextDocumentContent(O.URI.revive(p),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.ExtHostDocumentContentProvider=y}),define(_e[153],Ce([1,0,62,15,14,188,130,8,19]),function(ue,e,h,O,L,A,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=void 0,e.setWordDefinitionFor=T;const y=new Map;function T(E,d){d?y.set(E,d):y.delete(E)}function I(E){return y.get(E)}class p extends A.MirrorTextModel{constructor(d,f,a,i,n,l,o){super(f,a,i,n),this._proxy=d,this._languageId=l,this._isDirty=o,this._isDisposed=!1}dispose(){(0,h.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,m.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===O.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},save(){return d._save()},getText(f){return f?d._getTextInRange(f):d.getText()},get eol(){return d._eol===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(f){return d._lineAt(f)},offsetAt(f){return d._offsetAt(f)},positionAt(f){return d._positionAt(f)},validateRange(f){return d._validateRange(f)},validatePosition(f){return d._validatePosition(f)},getWordRangeAtPosition(f,a){return d._getWordRangeAtPosition(f,a)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,h.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,h.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const f=this._validateRange(d);if(f.isEmpty)return"";if(f.isSingleLine)return this._lines[f.start.line].substring(f.start.character,f.end.character);const a=this._eol,i=f.start.line,n=f.end.line,l=[];l.push(this._lines[i].substring(f.start.character));for(let o=i+1;o<n;o++)l.push(this._lines[o]);return l.push(this._lines[n].substring(0,f.end.character)),l.join(a)}_lineAt(d){let f;if(d instanceof b.Position?f=d.line:typeof d=="number"&&(f=d),typeof f!="number"||f<0||f>=this._lines.length||Math.floor(f)!==f)throw new Error("Illegal value for `line`");return new S(f,this._lines[f],f===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getPrefixSum(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const f=this._lineStarts.getIndexOf(d),a=this._lines[f.index].length;return new b.Position(f.index,Math.min(f.remainder,a))}_validateRange(d){if(!(d instanceof b.Range))throw new Error("Invalid argument");const f=this._validatePosition(d.start),a=this._validatePosition(d.end);return f===d.start&&a===d.end?d:new b.Range(f.line,f.character,a.line,a.character)}_validatePosition(d){if(!(d instanceof b.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:f,character:a}=d,i=!1;if(f<0)f=0,a=0,i=!0;else if(f>=this._lines.length)f=this._lines.length-1,a=this._lines[f].length,i=!0;else{const n=this._lines[f].length;a<0?(a=0,i=!0):a>n&&(a=n,i=!0)}return i?new b.Position(f,a):d}_getWordRangeAtPosition(d,f){const a=this._validatePosition(d);if(!f)f=I(this._languageId);else if((0,L.regExpLeadsToEndlessLoop)(f))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${f.source}' because it matches the empty string.`);const i=(0,R.getWordAtText)(a.character+1,(0,R.ensureValidWordDefinition)(f),this._lines[a.line],0);if(i)return new b.Range(a.line,i.startColumn-1,a.line,i.endColumn-1)}}e.ExtHostDocumentData=p;class S{constructor(d,f,a){this._line=d,this._text=f,this._isLastLine=a}get lineNumber(){return this._line}get text(){return this._text}get range(){return new b.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new b.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=S}),define(_e[331],Ce([1,0,6,8]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class L{constructor(R){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=R.getProxy(h.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,b,m){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const y=this._AiEmbeddingVectorProviders.get(R);if(!y)throw new Error("Embedding vector provider not found");const T=await y.provideEmbeddingVector(b,m);if(!T)throw new Error("Embedding vector provider returned undefined");return T}registerEmbeddingVectorProvider(R,b,m){const y=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(y,m),this._proxy.$registerAiEmbeddingVectorProvider(b,y),new O.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(y),this._AiEmbeddingVectorProviders.delete(y)})}}e.ExtHostAiEmbeddingVector=L}),define(_e[70],Ce([1,0,6,33,8,21,5,20,60,3,7,23,15]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let E=S=class{constructor(f,a){this._fileSystemProvider=new Map,this._writeQueue=new T.ResourceQueue,this._proxy=f.getProxy(h.MainContext.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let l;const o=i._fileSystemProvider.get(n.scheme);return o?(await i._proxy.$ensureActivation(n.scheme),l=await o.impl.stat(n)):l=await i._proxy.$stat(n),{type:l.type,ctime:l.ctime,mtime:l.mtime,size:l.size,permissions:l.permissions===O.FilePermission.Readonly?1:void 0}}catch(l){S._handleError(l)}},async readDirectory(n){try{const l=i._fileSystemProvider.get(n.scheme);return l?(await i._proxy.$ensureActivation(n.scheme),(await l.impl.readDirectory(n)).slice()):await i._proxy.$readdir(n)}catch(l){return S._handleError(l)}},async createDirectory(n){try{const l=i._fileSystemProvider.get(n.scheme);return l&&!l.isReadonly?(await i._proxy.$ensureActivation(n.scheme),await i.mkdirp(l.impl,l.extUri,n)):await i._proxy.$mkdir(n)}catch(l){return S._handleError(l)}},async readFile(n){try{const l=i._fileSystemProvider.get(n.scheme);return l?(await i._proxy.$ensureActivation(n.scheme),(await l.impl.readFile(n)).slice()):(await i._proxy.$readFile(n)).buffer}catch(l){return S._handleError(l)}},async writeFile(n,l){try{const o=i._fileSystemProvider.get(n.scheme);return o&&!o.isReadonly?(await i._proxy.$ensureActivation(n.scheme),await i.mkdirp(o.impl,o.extUri,o.extUri.dirname(n)),await i._writeQueue.queueFor(n,()=>Promise.resolve(o.impl.writeFile(n,l,{create:!0,overwrite:!0})))):await i._proxy.$writeFile(n,A.VSBuffer.wrap(l))}catch(o){return S._handleError(o)}},async delete(n,l){try{const o=i._fileSystemProvider.get(n.scheme);return o&&!o.isReadonly&&!l?.useTrash?(await i._proxy.$ensureActivation(n.scheme),await o.impl.delete(n,{recursive:!1,...l})):await i._proxy.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...l})}catch(o){return S._handleError(o)}},async rename(n,l,o){try{return await i._proxy.$rename(n,l,{overwrite:!1,...o})}catch(t){return S._handleError(t)}},async copy(n,l,o){try{return await i._proxy.$copy(n,l,{overwrite:!1,...o})}catch(t){return S._handleError(t)}},isWritableFileSystem(n){const l=a.getCapabilities(n);if(typeof l=="number")return!(l&2048)}})}async mkdirp(f,a,i){const n=[];for(;!a.isEqual(i,a.dirname(i));)try{if(!((await f.stat(i)).type&O.FileType.Directory))throw L.FileSystemError.FileExists(`Unable to create folder '${i.scheme===p.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(l){if(O.toFileSystemProviderErrorCode(l)!==O.FileSystemProviderErrorCode.FileNotFound)throw l;n.push(a.basename(i)),i=a.dirname(i)}for(let l=n.length-1;l>=0;l--){i=a.joinPath(i,n[l]);try{await f.createDirectory(i)}catch(o){if(O.toFileSystemProviderErrorCode(o)!==O.FileSystemProviderErrorCode.FileExists)throw o}}}static _handleError(f){if(f instanceof L.FileSystemError)throw f;if(f instanceof O.FileSystemProviderError)switch(f.code){case O.FileSystemProviderErrorCode.FileExists:throw L.FileSystemError.FileExists(f.message);case O.FileSystemProviderErrorCode.FileNotFound:throw L.FileSystemError.FileNotFound(f.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw L.FileSystemError.FileNotADirectory(f.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw L.FileSystemError.FileIsADirectory(f.message);case O.FileSystemProviderErrorCode.NoPermissions:throw L.FileSystemError.NoPermissions(f.message);case O.FileSystemProviderErrorCode.Unavailable:throw L.FileSystemError.Unavailable(f.message);default:throw new L.FileSystemError(f.message,f.name)}if(!(f instanceof Error))throw new L.FileSystemError(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw L.FileSystemError.Unavailable(f.message);switch(f.name){case O.FileSystemProviderErrorCode.FileExists:throw L.FileSystemError.FileExists(f.message);case O.FileSystemProviderErrorCode.FileNotFound:throw L.FileSystemError.FileNotFound(f.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw L.FileSystemError.FileNotADirectory(f.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw L.FileSystemError.FileIsADirectory(f.message);case O.FileSystemProviderErrorCode.NoPermissions:throw L.FileSystemError.NoPermissions(f.message);case O.FileSystemProviderErrorCode.Unavailable:throw L.FileSystemError.Unavailable(f.message);default:throw new L.FileSystemError(f.message,f.name)}}addFileSystemProvider(f,a,i){return this._fileSystemProvider.set(f,{impl:a,extUri:i?.isCaseSensitive?I.extUri:I.extUriIgnorePathCase,isReadonly:!!i?.isReadonly}),(0,y.toDisposable)(()=>this._fileSystemProvider.delete(f))}getFileSystemProviderExtUri(f){return this._fileSystemProvider.get(f)?.extUri??I.extUri}};e.ExtHostConsumerFileSystem=E,e.ExtHostConsumerFileSystem=E=S=Ge([Ue(0,b.IExtHostRpcService),Ue(1,m.IExtHostFileSystemInfo)],E),e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(_e[93],Ce([1,0,5,28,11,70,2]),function(ue,e,h,O,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,h.createDecorator)("IExtensionStoragePaths");let b=class{constructor(y,T,I){this._logService=T,this._extHostFileSystem=I,this._workspace=y.workspace??void 0,this._environment=y.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(p=>this._value=p)}async _getWorkspaceStorageURI(y){return R.URI.joinPath(this._environment.workspaceStorageHome,y)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const y=this._workspace.id,T=await this._getWorkspaceStorageURI(y);try{return await this._extHostFileSystem.value.stat(T),this._logService.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",T),await this._extHostFileSystem.value.createDirectory(T),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),T}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(y){if(this._value)return R.URI.joinPath(this._value,y.identifier.value)}globalValue(y){return R.URI.joinPath(this._environment.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=b,e.ExtensionStoragePaths=b=Ge([Ue(0,O.IExtHostInitDataService),Ue(1,L.ILogService),Ue(2,A.IExtHostConsumerFileSystem)],b)}),define(_e[332],Ce([1,0,8,20,4]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(b){this._actual=new h.ColorTheme(h.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new L.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(b){let m;switch(b){case"light":m=h.ColorThemeKind.Light;break;case"hcDark":m=h.ColorThemeKind.HighContrast;break;case"hcLight":m=h.ColorThemeKind.HighContrastLight;break;default:m=h.ColorThemeKind.Dark}this._actual=new h.ColorTheme(m),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=A,e.ExtHostTheming=A=Ge([Ue(0,O.IExtHostRpcService)],A)}),define(_e[71],Ce([1,0,22,4,3,234,5,11,88,6,28,20,8]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class S extends m.DisposableTunnel{}var E;(function(f){function a(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:n.protocol}}f.fromApiTunnel=a;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==m.TunnelPrivacyId.ConstantPrivate&&n.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}f.fromServiceTunnel=i})(E||(e.TunnelDtoConverter=E={})),e.IExtHostTunnelService=(0,R.createDecorator)("IExtHostTunnelService");let d=class extends L.Disposable{constructor(a,i,n){super(),this.logService=n,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new O.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=a.getProxy(y.MainContext.MainThreadTunnelService)}async openTunnel(a,i){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this._proxy.$openTunnel(i,a.displayName);if(n){const l=new S(n.remoteAddress,n.localAddress,()=>this._proxy.$closeTunnel(n.remoteAddress));return this._register(l),l}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(a,i){a.portRange===void 0&&a.commandPattern===void 0&&this.logService.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(n,{selector:a,provider:i}),this._proxy.$registerPortsAttributesProvider(a,n),new p.Disposable(()=>{this._portAttributesProviders.delete(n),this._proxy.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(a,i,n,l,o){const t=[];for(const r of a){const c=this._portAttributesProviders.get(r);if(!c)return[];t.push(...await Promise.all(i.map(async s=>{let w;try{w=await c.provider.providePortAttributes({port:s,pid:n,commandLine:l},o)}catch{w=await c.provider.providePortAttributes(s,n,l,o)}return{providedAttributes:w,port:s}})))}const u=t.filter(r=>!!r.providedAttributes);return u.length>0?u.map(r=>({autoForwardAction:r.providedAttributes.autoForwardAction,port:r.port})):[]}async $registerCandidateFinder(a){}registerTunnelProvider(a,i){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(l,o)=>await a.provideTunnel(l,o,h.CancellationToken.None)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this._proxy.$setTunnelProvider(n),Promise.resolve((0,L.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(a,i){if(a){a.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this._showCandidatePort=a.showCandidatePort,this._proxy.$setCandidateFilter());const n=a.tunnelFactory??(i?this.makeManagedTunnelFactory(i):void 0);if(n){this._forwardPortProvider=n;let l=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&l.length===0&&(l=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const o=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:l,protocol:!0}:void 0;this._proxy.$setTunnelProvider(o)}}else this._forwardPortProvider=void 0;return(0,L.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(a){}async $closeTunnel(a,i){if(this._extensionTunnels.has(a.host)){const n=this._extensionTunnels.get(a.host);n.has(a.port)&&(i&&n.get(a.port).disposeListener.dispose(),await n.get(a.port).tunnel.dispose(),n.delete(a.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(a,i){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this._forwardPortProvider(a,i);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const l=await n;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),l===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(a.remoteAddress.host)||this._extensionTunnels.set(a.remoteAddress.host,new Map);const o=this._register(l.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(l.remoteAddress))));return this._extensionTunnels.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:l,disposeListener:o}),E.fromApiTunnel(l)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(a){const i=await Promise.all(a.map(l=>this._showCandidatePort(l.host,l.port,l.detail??""))),n=a.filter((l,o)=>i[o]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(l=>l.port).join(", ")} to ${n.map(l=>l.port).join(", ")}`),n}};e.ExtHostTunnelService=d,e.ExtHostTunnelService=d=Ge([Ue(0,I.IExtHostRpcService),Ue(1,T.IExtHostInitDataService),Ue(2,b.ILogService)],d)}),define(_e[16],Ce([1,0,19,21,177,75,81,27,167,58,101,24,172,23,18,2,29,84,139,145,143,296,120,69,89,308,8,50]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i,n,l,o,t,u,r,c,s,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.isDecorationOptionsArr=W,e.fromRangeOrRangeWithMessage=te,e.pathOrURIToURI=H;var g;(function(Re){function xe(J){const{selectionStartLineNumber:Me,selectionStartColumn:Ve,positionLineNumber:Ze,positionColumn:Xe}=J,dt=new s.Position(Me-1,Ve-1),yt=new s.Position(Ze-1,Xe-1);return new s.Selection(dt,yt)}Re.to=xe;function Se(J){const{anchor:Me,active:Ve}=J;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Re.from=Se})(g||(e.Selection=g={}));var D;(function(Re){function xe(J){if(!J)return;const{start:Me,end:Ve}=J;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Re.from=xe;function Se(J){if(!J)return;const{startLineNumber:Me,startColumn:Ve,endLineNumber:Ze,endColumn:Xe}=J;return new s.Range(Me-1,Ve-1,Ze-1,Xe-1)}Re.to=Se})(D||(e.Range=D={}));var v;(function(Re){function xe(J){return{uri:J.uri,range:D.from(J.range)}}Re.from=xe;function Se(J){return new s.Location(d.URI.revive(J.uri),D.to(J.range))}Re.to=Se})(v||(e.Location=v={}));var _;(function(Re){function xe(Se){switch(Se){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Re.to=xe})(_||(e.TokenType=_={}));var C;(function(Re){function xe(J){return new s.Position(J.lineNumber-1,J.column-1)}Re.to=xe;function Se(J){return{lineNumber:J.line+1,column:J.character+1}}Re.from=Se})(C||(e.Position=C={}));var P;(function(Re){function xe(Me,Ve,Ze){return(0,h.coalesce)((0,h.asArray)(Me).map(Xe=>Se(Xe,Ve,Ze)))}Re.from=xe;function Se(Me,Ve,Ze){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Ze?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:J(Me.scheme,Ve),pattern:ke.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Ze?.isBuiltin}}function J(Me,Ve){return Ve&&typeof Me=="string"?Ve.transformOutgoingScheme(Me):Me}})(P||(e.DocumentSelector=P={}));var k;(function(Re){function xe(J){switch(J){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Re.from=xe;function Se(J){switch(J){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Re.to=Se})(k||(e.DiagnosticTag=k={}));var F;(function(Re){function xe(J){let Me;return J.code&&((0,E.isString)(J.code)||(0,E.isNumber)(J.code)?Me=String(J.code):Me={value:String(J.code.value),target:J.code.target}),{...D.from(J.range),message:J.message,source:J.source,code:Me,severity:z.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(x.from),tags:Array.isArray(J.tags)?(0,h.coalesce)(J.tags.map(k.from)):void 0}}Re.from=xe;function Se(J){const Me=new s.Diagnostic(D.to(J),J.message,z.to(J.severity));return Me.source=J.source,Me.code=(0,E.isString)(J.code)?J.code:J.code?.value,Me.relatedInformation=J.relatedInformation&&J.relatedInformation.map(x.to),Me.tags=J.tags&&(0,h.coalesce)(J.tags.map(k.to)),Me}Re.to=Se})(F||(e.Diagnostic=F={}));var x;(function(Re){function xe(J){return{...D.from(J.location.range),message:J.message,resource:J.location.uri}}Re.from=xe;function Se(J){return new s.DiagnosticRelatedInformation(new s.Location(J.resource,D.to(J)),J.message)}Re.to=Se})(x||(e.DiagnosticRelatedInformation=x={}));var z;(function(Re){function xe(J){switch(J){case s.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}Re.from=xe;function Se(J){switch(J){case i.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Re.to=Se})(z||(e.DiagnosticSeverity=z={}));var N;(function(Re){function xe(J){return typeof J=="number"&&J>=s.ViewColumn.One?J-1:J===s.ViewColumn.Beside?c.SIDE_GROUP:c.ACTIVE_GROUP}Re.from=xe;function Se(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Se})(N||(e.ViewColumn=N={}));function M(Re){return typeof Re.range<"u"}function W(Re){return Re.length===0?!0:!!M(Re[0])}var X;(function(Re){function xe(Xe){return Xe.map(Re.from)}Re.fromMany=xe;function Se(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function J(Xe){let dt;if(Se(Xe)){const{language:Mt,value:Bt}=Xe;dt={value:"```"+Mt+`
`+Bt+"\n```\n"}}else s.MarkdownString.isMarkdownString(Xe)?dt={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons,supportHtml:Xe.supportHtml,baseUri:Xe.baseUri}:typeof Xe=="string"?dt={value:Xe}:dt={value:""};const yt=Object.create(null);dt.uris=yt;const zt=Mt=>{try{let Bt=d.URI.parse(Mt,!0);Bt=Bt.with({query:Me(Bt.query,yt)}),yt[Mt]=Bt}catch{}return""},ut=new m.marked.Renderer;return ut.link=zt,ut.image=Mt=>typeof Mt=="string"?zt(R.parseHrefAndDimensions(Mt).href):"",(0,m.marked)(dt.value,{renderer:ut}),dt}Re.from=J;function Me(Xe,dt){if(!Xe)return Xe;let yt;try{yt=(0,y.parse)(Xe)}catch{}if(!yt)return Xe;let zt=!1;return yt=(0,I.cloneAndChange)(yt,ut=>{if(d.URI.isUri(ut)){const Mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return dt[Mt]=ut,zt=!0,Mt}else return}),zt?JSON.stringify(yt):Xe}function Ve(Xe){const dt=new s.MarkdownString(Xe.value,Xe.supportThemeIcons);return dt.isTrusted=Xe.isTrusted,dt.supportHtml=Xe.supportHtml,dt.baseUri=Xe.baseUri?d.URI.from(Xe.baseUri):void 0,dt}Re.to=Ve;function Ze(Xe){if(Xe)return typeof Xe=="string"?Xe:Re.from(Xe)}Re.fromStrict=Ze})(X||(e.MarkdownString=X={}));function te(Re){return W(Re)?Re.map(xe=>({range:D.from(xe.range),hoverMessage:Array.isArray(xe.hoverMessage)?X.fromMany(xe.hoverMessage):xe.hoverMessage?X.from(xe.hoverMessage):void 0,renderOptions:xe.renderOptions})):Re.map(xe=>({range:D.from(xe)}))}function H(Re){return typeof Re>"u"?Re:typeof Re=="string"?d.URI.file(Re):Re}var G;(function(Re){function xe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?H(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Re.from=xe})(G||(e.ThemableDecorationAttachmentRenderOptions=G={}));var Y;(function(Re){function xe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?H(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?G.from(Se.before):void 0,after:Se.after?G.from(Se.after):void 0}}Re.from=xe})(Y||(e.ThemableDecorationRenderOptions=Y={}));var ne;(function(Re){function xe(Se){if(typeof Se>"u")return Se;switch(Se){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=xe})(ne||(e.DecorationRangeBehavior=ne={}));var pe;(function(Re){function xe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?ne.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?Y.from(Se.light):void 0,dark:Se.dark?Y.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?H(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?G.from(Se.before):void 0,after:Se.after?G.from(Se.after):void 0}}Re.from=xe})(pe||(e.DecorationRenderOptions=pe={}));var le;(function(Re){function xe(J){return{text:J.newText,eol:J.newEol&&qe.from(J.newEol),range:D.from(J.range)}}Re.from=xe;function Se(J){const Me=new s.TextEdit(D.to(J.range),J.text);return Me.newEol=typeof J.eol>"u"?void 0:qe.to(J.eol),Me}Re.to=Se})(le||(e.TextEdit=le={}));var we;(function(Re){function xe(J,Me){const Ve={edits:[]};if(J instanceof s.WorkspaceEdit){const Ze=new b.ResourceSet;for(const Xe of J._allEntries())Xe._type===1&&d.URI.isUri(Xe.to)&&Xe.from===void 0&&Ze.add(Xe.to);for(const Xe of J._allEntries())if(Xe._type===1){let dt;Xe.options?.contents&&(ArrayBuffer.isView(Xe.options.contents)?dt={type:"base64",value:(0,O.encodeBase64)(O.VSBuffer.wrap(Xe.options.contents))}:dt={type:"dataTransferItem",id:Xe.options.contents._itemId}),Ve.edits.push({oldResource:Xe.from,newResource:Xe.to,options:{...Xe.options,contents:dt},metadata:Xe.metadata})}else Xe._type===2?Ve.edits.push({resource:Xe.uri,textEdit:le.from(Xe.edit),versionId:Ze.has(Xe.uri)?void 0:Me?.getTextDocumentVersion(Xe.uri),metadata:Xe.metadata}):Xe._type===6?Ve.edits.push({resource:Xe.uri,textEdit:{range:D.from(Xe.range),text:Xe.edit.value,insertAsSnippet:!0},versionId:Ze.has(Xe.uri)?void 0:Me?.getTextDocumentVersion(Xe.uri),metadata:Xe.metadata}):Xe._type===3?Ve.edits.push({metadata:Xe.metadata,resource:Xe.uri,cellEdit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(Xe.uri)}):Xe._type===5&&Ve.edits.push({metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:Me?.getNotebookDocumentVersion(Xe.uri),cellEdit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(ti.from)}})}return Ve}Re.from=xe;function Se(J){const Me=new s.WorkspaceEdit,Ve=new b.ResourceMap;for(const Ze of J.edits)if(Ze.textEdit){const Xe=Ze,dt=d.URI.revive(Xe.resource),yt=D.to(Xe.textEdit.range),zt=Xe.textEdit.text,ut=Xe.textEdit.insertAsSnippet;let Mt;ut?Mt=s.SnippetTextEdit.replace(yt,new s.SnippetString(zt)):Mt=s.TextEdit.replace(yt,zt);const Bt=Ve.get(dt);Bt?Bt.push(Mt):Ve.set(dt,[Mt])}else Me.renameFile(d.URI.revive(Ze.oldResource),d.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Xe]of Ve)Me.set(Ze,Xe);return Me}Re.to=Se})(we||(e.WorkspaceEdit=we={}));var Z;(function(Re){const xe=Object.create(null);xe[s.SymbolKind.File]=0,xe[s.SymbolKind.Module]=1,xe[s.SymbolKind.Namespace]=2,xe[s.SymbolKind.Package]=3,xe[s.SymbolKind.Class]=4,xe[s.SymbolKind.Method]=5,xe[s.SymbolKind.Property]=6,xe[s.SymbolKind.Field]=7,xe[s.SymbolKind.Constructor]=8,xe[s.SymbolKind.Enum]=9,xe[s.SymbolKind.Interface]=10,xe[s.SymbolKind.Function]=11,xe[s.SymbolKind.Variable]=12,xe[s.SymbolKind.Constant]=13,xe[s.SymbolKind.String]=14,xe[s.SymbolKind.Number]=15,xe[s.SymbolKind.Boolean]=16,xe[s.SymbolKind.Array]=17,xe[s.SymbolKind.Object]=18,xe[s.SymbolKind.Key]=19,xe[s.SymbolKind.Null]=20,xe[s.SymbolKind.EnumMember]=21,xe[s.SymbolKind.Struct]=22,xe[s.SymbolKind.Event]=23,xe[s.SymbolKind.Operator]=24,xe[s.SymbolKind.TypeParameter]=25;function Se(Me){return typeof xe[Me]=="number"?xe[Me]:6}Re.from=Se;function J(Me){for(const Ve in xe)if(xe[Ve]===Me)return Number(Ve);return s.SymbolKind.Property}Re.to=J})(Z||(e.SymbolKind=Z={}));var B;(function(Re){function xe(J){switch(J){case s.SymbolTag.Deprecated:return 1}}Re.from=xe;function Se(J){switch(J){case 1:return s.SymbolTag.Deprecated}}Re.to=Se})(B||(e.SymbolTag=B={}));var ee;(function(Re){function xe(J){return{name:J.name,kind:Z.from(J.kind),tags:J.tags&&J.tags.map(B.from),containerName:J.containerName,location:re.from(J.location)}}Re.from=xe;function Se(J){const Me=new s.SymbolInformation(J.name,Z.to(J.kind),J.containerName,re.to(J.location));return Me.tags=J.tags&&J.tags.map(B.to),Me}Re.to=Se})(ee||(e.WorkspaceSymbol=ee={}));var ve;(function(Re){function xe(J){const Me={name:J.name||"!!MISSING: name!!",detail:J.detail,range:D.from(J.range),selectionRange:D.from(J.selectionRange),kind:Z.from(J.kind),tags:J.tags?.map(B.from)??[]};return J.children&&(Me.children=J.children.map(xe)),Me}Re.from=xe;function Se(J){const Me=new s.DocumentSymbol(J.name,J.detail,Z.to(J.kind),D.to(J.range),D.to(J.selectionRange));return(0,h.isNonEmptyArray)(J.tags)&&(Me.tags=J.tags.map(B.to)),J.children&&(Me.children=J.children.map(Se)),Me}Re.to=Se})(ve||(e.DocumentSymbol=ve={}));var Pe;(function(Re){function xe(J){const Me=new s.CallHierarchyItem(Z.to(J.kind),J.name,J.detail||"",d.URI.revive(J.uri),D.to(J.range),D.to(J.selectionRange));return Me._sessionId=J._sessionId,Me._itemId=J._itemId,Me}Re.to=xe;function Se(J,Me,Ve){if(Me=Me??J._sessionId,Ve=Ve??J._itemId,Me===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ve,name:J.name,detail:J.detail,kind:Z.from(J.kind),uri:J.uri,range:D.from(J.range),selectionRange:D.from(J.selectionRange),tags:J.tags?.map(B.from)}}Re.from=Se})(Pe||(e.CallHierarchyItem=Pe={}));var oe;(function(Re){function xe(Se){return new s.CallHierarchyIncomingCall(Pe.to(Se.from),Se.fromRanges.map(J=>D.to(J)))}Re.to=xe})(oe||(e.CallHierarchyIncomingCall=oe={}));var se;(function(Re){function xe(Se){return new s.CallHierarchyOutgoingCall(Pe.to(Se.to),Se.fromRanges.map(J=>D.to(J)))}Re.to=xe})(se||(e.CallHierarchyOutgoingCall=se={}));var re;(function(Re){function xe(J){return{range:J.range&&D.from(J.range),uri:J.uri}}Re.from=xe;function Se(J){return new s.Location(d.URI.revive(J.uri),D.to(J.range))}Re.to=Se})(re||(e.location=re={}));var j;(function(Re){function xe(J){const Me=J,Ve=J;return{originSelectionRange:Me.originSelectionRange?D.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Ve.uri,range:D.from(Me.targetRange?Me.targetRange:Ve.range),targetSelectionRange:Me.targetSelectionRange?D.from(Me.targetSelectionRange):void 0}}Re.from=xe;function Se(J){return{targetUri:d.URI.revive(J.uri),targetRange:D.to(J.range),targetSelectionRange:J.targetSelectionRange?D.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?D.to(J.originSelectionRange):void 0}}Re.to=Se})(j||(e.DefinitionLink=j={}));var ie;(function(Re){function xe(J){return{range:D.from(J.range),contents:X.fromMany(J.contents),canIncreaseVerbosity:J.canIncreaseVerbosity,canDecreaseVerbosity:J.canDecreaseVerbosity}}Re.from=xe;function Se(J){const Me=J.contents.map(X.to),Ve=D.to(J.range),Ze=J.canIncreaseVerbosity,Xe=J.canDecreaseVerbosity;return new s.VerboseHover(Me,Ve,Ze,Xe)}Re.to=Se})(ie||(e.Hover=ie={}));var me;(function(Re){function xe(J){return{range:D.from(J.range),expression:J.expression}}Re.from=xe;function Se(J){return new s.EvaluatableExpression(D.to(J.range),J.expression)}Re.to=Se})(me||(e.EvaluatableExpression=me={}));var be;(function(Re){function xe(J){if(J instanceof s.InlineValueText)return{type:"text",range:D.from(J.range),text:J.text};if(J instanceof s.InlineValueVariableLookup)return{type:"variable",range:D.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:D.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=xe;function Se(J){switch(J.type){case"text":return{range:D.to(J.range),text:J.text};case"variable":return{range:D.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:D.to(J.range),expression:J.expression}}}Re.to=Se})(be||(e.InlineValue=be={}));var Ae;(function(Re){function xe(J){return{frameId:J.frameId,stoppedLocation:D.from(J.stoppedLocation)}}Re.from=xe;function Se(J){return new s.InlineValueContext(J.frameId,D.to(J.stoppedLocation))}Re.to=Se})(Ae||(e.InlineValueContext=Ae={}));var fe;(function(Re){function xe(J){return{range:D.from(J.range),kind:J.kind}}Re.from=xe;function Se(J){return new s.DocumentHighlight(D.to(J.range),J.kind)}Re.to=Se})(fe||(e.DocumentHighlight=fe={}));var De;(function(Re){function xe(J){return{uri:J.uri,highlights:J.highlights.map(fe.from)}}Re.from=xe;function Se(J){return new s.MultiDocumentHighlight(d.URI.revive(J.uri),J.highlights.map(fe.to))}Re.to=Se})(De||(e.MultiDocumentHighlight=De={}));var Te;(function(Re){function xe(Se){switch(Se){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Re.to=xe})(Te||(e.CompletionTriggerKind=Te={}));var ze;(function(Re){function xe(Se){return{triggerKind:Te.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Re.to=xe})(ze||(e.CompletionContext=ze={}));var U;(function(Re){function xe(J){switch(J){case s.CompletionItemTag.Deprecated:return 1}}Re.from=xe;function Se(J){switch(J){case 1:return s.CompletionItemTag.Deprecated}}Re.to=Se})(U||(e.CompletionItemTag=U={}));var $;(function(Re){const xe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Se(Ve){return xe.get(Ve)??9}Re.from=Se;const J=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Me(Ve){return J.get(Ve)??s.CompletionItemKind.Property}Re.to=Me})($||(e.CompletionItemKind=$={}));var K;(function(Re){function xe(Se,J){const Me=new s.CompletionItem(Se.label);return Me.insertText=Se.insertText,Me.kind=$.to(Se.kind),Me.tags=Se.tags?.map(U.to),Me.detail=Se.detail,Me.documentation=R.isMarkdownString(Se.documentation)?X.to(Se.documentation):Se.documentation,Me.sortText=Se.sortText,Me.filterText=Se.filterText,Me.preselect=Se.preselect,Me.commitCharacters=Se.commitCharacters,f.Range.isIRange(Se.range)?Me.range=D.to(Se.range):typeof Se.range=="object"&&(Me.range={inserting:D.to(Se.range.insert),replacing:D.to(Se.range.replace)}),Me.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Me.insertText=new s.SnippetString(Se.insertText):(Me.insertText=Se.insertText,Me.textEdit=Me.range instanceof s.Range?new s.TextEdit(Me.range,Me.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Me.additionalTextEdits=Se.additionalTextEdits.map(Ve=>le.to(Ve))),Me.command=J&&Se.command?J.fromInternal(Se.command):void 0,Me}Re.to=xe})(K||(e.CompletionItem=K={}));var Q;(function(Re){function xe(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:X.fromStrict(J.documentation)}}Re.from=xe;function Se(J){return{label:J.label,documentation:R.isMarkdownString(J.documentation)?X.to(J.documentation):J.documentation}}Re.to=Se})(Q||(e.ParameterInformation=Q={}));var de;(function(Re){function xe(J){return{label:J.label,documentation:X.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(Q.from):[],activeParameter:J.activeParameter}}Re.from=xe;function Se(J){return{label:J.label,documentation:R.isMarkdownString(J.documentation)?X.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(Q.to):[],activeParameter:J.activeParameter}}Re.to=Se})(de||(e.SignatureInformation=de={}));var Ee;(function(Re){function xe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(de.from):[]}}Re.from=xe;function Se(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(de.to):[]}}Re.to=Se})(Ee||(e.SignatureHelp=Ee={}));var Fe;(function(Re){function xe(Se,J){const Me=new s.InlayHint(C.to(J.position),typeof J.label=="string"?J.label:J.label.map(He.to.bind(void 0,Se)),J.kind&&Ke.to(J.kind));return Me.textEdits=J.textEdits&&J.textEdits.map(le.to),Me.tooltip=R.isMarkdownString(J.tooltip)?X.to(J.tooltip):J.tooltip,Me.paddingLeft=J.paddingLeft,Me.paddingRight=J.paddingRight,Me}Re.to=xe})(Fe||(e.InlayHint=Fe={}));var He;(function(Re){function xe(Se,J){const Me=new s.InlayHintLabelPart(J.label);return Me.tooltip=R.isMarkdownString(J.tooltip)?X.to(J.tooltip):J.tooltip,a.Command.is(J.command)&&(Me.command=Se.fromInternal(J.command)),J.location&&(Me.location=re.to(J.location)),Me}Re.to=xe})(He||(e.InlayHintLabelPart=He={}));var Ke;(function(Re){function xe(J){return J}Re.from=xe;function Se(J){return J}Re.to=Se})(Ke||(e.InlayHintKind=Ke={}));var rt;(function(Re){function xe(J){return{range:D.from(J.range),url:J.target,tooltip:J.tooltip}}Re.from=xe;function Se(J){let Me;if(J.url)try{Me=typeof J.url=="string"?d.URI.parse(J.url,!0):d.URI.revive(J.url)}catch{}return new s.DocumentLink(D.to(J.range),Me)}Re.to=Se})(rt||(e.DocumentLink=rt={}));var tt;(function(Re){function xe(J){const Me=new s.ColorPresentation(J.label);return J.textEdit&&(Me.textEdit=le.to(J.textEdit)),J.additionalTextEdits&&(Me.additionalTextEdits=J.additionalTextEdits.map(Ve=>le.to(Ve))),Me}Re.to=xe;function Se(J){return{label:J.label,textEdit:J.textEdit?le.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Me=>le.from(Me)):void 0}}Re.from=Se})(tt||(e.ColorPresentation=tt={}));var it;(function(Re){function xe(J){return new s.Color(J[0],J[1],J[2],J[3])}Re.to=xe;function Se(J){return[J.red,J.green,J.blue,J.alpha]}Re.from=Se})(it||(e.Color=it={}));var st;(function(Re){function xe(J){return{range:D.from(J.range)}}Re.from=xe;function Se(J){return new s.SelectionRange(D.to(J.range))}Re.to=Se})(st||(e.SelectionRange=st={}));var Ie;(function(Re){function xe(Se){switch(Se){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Re.to=xe})(Ie||(e.TextDocumentSaveReason=Ie={}));var Be;(function(Re){function xe(J){switch(J){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.Interval:return 3;case s.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=xe;function Se(J){switch(J){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 3:return s.TextEditorLineNumbersStyle.Interval;case 1:default:return s.TextEditorLineNumbersStyle.On}}Re.to=Se})(Be||(e.TextEditorLineNumbersStyle=Be={}));var qe;(function(Re){function xe(J){if(J===s.EndOfLine.CRLF)return 1;if(J===s.EndOfLine.LF)return 0}Re.from=xe;function Se(J){if(J===1)return s.EndOfLine.CRLF;if(J===0)return s.EndOfLine.LF}Re.to=Se})(qe||(e.EndOfLine=qe={}));var Oe;(function(Re){function xe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=xe})(Oe||(e.ProgressLocation=Oe={}));var Qe;(function(Re){function xe(J){const Me={start:J.start+1,end:J.end+1};return J.kind&&(Me.kind=ae.from(J.kind)),Me}Re.from=xe;function Se(J){const Me={start:J.start-1,end:J.end-1};return J.kind&&(Me.kind=ae.to(J.kind)),Me}Re.to=Se})(Qe||(e.FoldingRange=Qe={}));var ae;(function(Re){function xe(J){if(J)switch(J){case s.FoldingRangeKind.Comment:return a.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return a.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return a.FoldingRangeKind.Region}}Re.from=xe;function Se(J){if(J)switch(J.value){case a.FoldingRangeKind.Comment.value:return s.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports.value:return s.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region.value:return s.FoldingRangeKind.Region}}Re.to=Se})(ae||(e.FoldingRangeKind=ae={}));var ce;(function(Re){function xe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?D.from(Se.selection):void 0,override:typeof Se.override=="boolean"?l.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Re.from=xe})(ce||(e.TextEditorOpenOptions=ce={}));var ke;(function(Re){function xe(Ve){return Ve instanceof s.RelativePattern?Ve.toJSON():typeof Ve=="string"?Ve:Se(Ve)||J(Ve)?new s.RelativePattern(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Re.from=xe;function Se(Ve){const Ze=Ve;return Ze?d.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function J(Ve){const Ze=Ve;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Me(Ve){return typeof Ve=="string"?Ve:new s.RelativePattern(d.URI.revive(Ve.baseUri),Ve.pattern)}Re.to=Me})(ke||(e.GlobPattern=ke={}));var je;(function(Re){function xe(Se){if(Se){if(Array.isArray(Se))return Se.map(xe);if(typeof Se=="string")return Se;{const J=Se;return{language:J.language,scheme:J.scheme,pattern:ke.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}Re.from=xe})(je||(e.LanguageSelector=je={}));var Le;(function(Re){function xe(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Me=>Array.isArray(Me)&&Me.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&d.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(Ze=>Ze instanceof s.Range)))}Re.is=xe;function Se(J){return{documents:J.documents.map(Me=>Me.map(Ve=>({uri:d.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(Ze=>D.from(Ze))})))}}Re.from=Se})(Le||(e.MappedEditsContext=Le={}));var ot;(function(Re){function xe(J){return{start:J.start,end:J.end}}Re.from=xe;function Se(J){return new s.NotebookRange(J.start,J.end)}Re.to=Se})(ot||(e.NotebookRange=ot={}));var lt;(function(Re){function xe(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}Re.to=xe;function Se(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}Re.from=Se})(lt||(e.NotebookCellExecutionSummary=lt={}));var wt;(function(Re){function xe(Se){if(Se===t.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Se===t.NotebookCellExecutionState.Pending)return;if(Se===t.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Re.to=xe})(wt||(e.NotebookCellExecutionState=wt={}));var At;(function(Re){function xe(J){switch(J){case s.NotebookCellKind.Markup:return t.CellKind.Markup;case s.NotebookCellKind.Code:default:return t.CellKind.Code}}Re.from=xe;function Se(J){switch(J){case t.CellKind.Markup:return s.NotebookCellKind.Markup;case t.CellKind.Code:default:return s.NotebookCellKind.Code}}Re.to=Se})(At||(e.NotebookCellKind=At={}));var Wt;(function(Re){function xe(J){const Me={metadata:J.metadata??Object.create(null),cells:[]};for(const Ve of J.cells)s.NotebookCellData.validate(Ve),Me.cells.push(ti.from(Ve));return Me}Re.from=xe;function Se(J){const Me=new s.NotebookData(J.cells.map(ti.to));return(0,E.isEmptyObject)(J.metadata)||(Me.metadata=J.metadata),Me}Re.to=Se})(Wt||(e.NotebookData=Wt={}));var ti;(function(Re){function xe(J){return{cellKind:At.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:lt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(_t.from):[]}}Re.from=xe;function Se(J){return new s.NotebookCellData(At.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(_t.to):void 0,J.metadata,J.internalMetadata?lt.to(J.internalMetadata):void 0)}Re.to=Se})(ti||(e.NotebookCellData=ti={}));var Xt;(function(Re){function xe(J){return{mime:J.mime,valueBytes:O.VSBuffer.wrap(J.data)}}Re.from=xe;function Se(J){return new s.NotebookCellOutputItem(J.valueBytes.buffer,J.mime)}Re.to=Se})(Xt||(e.NotebookCellOutputItem=Xt={}));var _t;(function(Re){function xe(J){return{outputId:J.id,items:J.items.map(Xt.from),metadata:J.metadata}}Re.from=xe;function Se(J){const Me=J.items.map(Xt.to);return new s.NotebookCellOutput(Me,J.outputId,J.metadata)}Re.to=Se})(_t||(e.NotebookCellOutput=_t={}));var Qt;(function(Re){function xe(Me){return J(Me)?{include:ke.from(Me.include)??void 0,exclude:ke.from(Me.exclude)??void 0}:ke.from(Me)??void 0}Re.from=xe;function Se(Me){return J(Me)?{include:ke.to(Me.include),exclude:ke.to(Me.exclude)}:ke.to(Me)}Re.to=Se;function J(Me){const Ve=Me;return Ve?!(0,E.isUndefinedOrNull)(Ve.include)&&!(0,E.isUndefinedOrNull)(Ve.exclude):!1}})(Qt||(e.NotebookExclusiveDocumentPattern=Qt={}));var Yt;(function(Re){function xe(Se,J,Me){const Ve=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Ve,Me),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Re.from=xe})(Yt||(e.NotebookStatusBarItem=Yt={}));var et;(function(Re){function xe(Se,J,Me){const Ve=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:J.toInternal(Ve,Me),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Re.from=xe})(et||(e.NotebookKernelSourceAction=et={}));var oi;(function(Re){function xe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Re.from=xe})(oi||(e.NotebookDocumentContentOptions=oi={}));var jt;(function(Re){function xe(J){return{uri:J.uri,provides:J.provides}}Re.from=xe;function Se(J){return new s.NotebookRendererScript(d.URI.revive(J.uri),J.provides)}Re.to=Se})(jt||(e.NotebookRendererScript=jt={}));var ft;(function(Re){function xe(J){return{message:X.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:D.from(J.location.range),uri:J.location.uri}}}Re.from=xe;function Se(J){const Me=new s.TestMessage(typeof J.message=="string"?J.message:X.to(J.message));return Me.actualOutput=J.actual,Me.expectedOutput=J.expected,Me.contextValue=J.contextValue,Me.location=J.location?re.to(J.location):void 0,Me}Re.to=Se})(ft||(e.TestMessage=ft={}));var pt;(function(Re){Re.namespace=r.namespaceTestTag,Re.denamespace=r.denamespaceTestTag})(pt||(e.TestTag=pt={}));var Jt;(function(Re){function xe(J){const Me=(0,n.getPrivateApiFor)(J).controllerId;return{extId:u.TestId.fromExtHostTestItem(J,Me).toString(),label:J.label,uri:d.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Ve=>pt.namespace(Me,Ve.id)),range:f.Range.lift(D.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&X.fromStrict(J.error)||null}}Re.from=xe;function Se(J){return{parent:void 0,error:void 0,id:u.TestId.fromString(J.extId).localId,label:J.label,uri:d.URI.revive(J.uri),tags:(J.tags||[]).map(Me=>{const{tagId:Ve}=pt.denamespace(Me);return new s.TestTag(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:D.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}Re.toPlain=Se})(Jt||(e.TestItem=Jt={})),function(Re){function xe(J){return{id:J.id}}Re.from=xe;function Se(J){return new s.TestTag(J.id)}Re.to=Se}(pt||(e.TestTag=pt={}));var Gt;(function(Re){const xe=(J,Me)=>{const Ve=J.value;if(!Ve)return;const Ze={...Jt.toPlain(Ve.item),parent:Me,taskStates:Ve.tasks.map(Xe=>({state:Xe.state,duration:Xe.duration,messages:Xe.messages.filter(dt=>dt.type===0).map(ft.to)})),children:[]};if(J.children)for(const Xe of J.children.values()){const dt=xe(Xe,Ze);dt&&Ze.children.push(dt)}return Ze};function Se(J){const Me=new p.WellDefinedPrefixTree;for(const Xe of J.items)Me.insert(u.TestId.fromString(Xe.item.extId).path,Xe);const Ve=[Me.nodes],Ze=[];for(;Ve.length;)for(const Xe of Ve.pop())Xe.value?Ze.push(Xe):Xe.children&&Ve.push(Xe.children.values());return{completedAt:J.completedAt,results:Ze.map(Xe=>xe(Xe)).filter(E.isDefined)}}Re.to=Se})(Gt||(e.TestResults=Gt={}));var Ft;(function(Re){function xe(Ve){return{covered:Ve.covered,total:Ve.total}}function Se(Ve){return"line"in Ve?C.from(Ve):D.from(Ve)}function J(Ve){if(typeof Ve.executed=="number"&&Ve.executed<0)throw new Error(`Invalid coverage count ${Ve.executed}`);return"branches"in Ve?{count:Ve.executed,location:Se(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&Se(Ze.location),label:Ze.label})):void 0}:{type:0,name:Ve.name,count:Ve.executed,location:Se(Ve.location)}}Re.fromDetails=J;function Me(Ve,Ze){return s.validateTestCoverageCount(Ze.statementCoverage),s.validateTestCoverageCount(Ze.branchCoverage),s.validateTestCoverageCount(Ze.declarationCoverage),{id:Ve,uri:Ze.uri,statement:xe(Ze.statementCoverage),branch:Ze.branchCoverage&&xe(Ze.branchCoverage),declaration:Ze.declarationCoverage&&xe(Ze.declarationCoverage)}}Re.fromFile=Me})(Ft||(e.TestCoverage=Ft={}));var gt;(function(Re){function xe(Se){switch(Se){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Re.to=xe})(gt||(e.CodeActionTriggerKind=gt={}));var Ut;(function(Re){function xe(J){const Me=new s.TypeHierarchyItem(Z.to(J.kind),J.name,J.detail||"",d.URI.revive(J.uri),D.to(J.range),D.to(J.selectionRange));return Me._sessionId=J._sessionId,Me._itemId=J._itemId,Me}Re.to=xe;function Se(J,Me,Ve){if(Me=Me??J._sessionId,Ve=Ve??J._itemId,Me===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ve,kind:Z.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:D.from(J.range),selectionRange:D.from(J.selectionRange),tags:J.tags?.map(B.from)}}Re.from=Se})(Ut||(e.TypeHierarchyItem=Ut={}));var Zt;(function(Re){function xe(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}Re.from=xe})(Zt||(e.ViewBadge=Zt={}));var $t;(function(Re){function xe(Ve,Ze,Xe){const dt=Ze.fileData;return dt?new s.InternalFileDataTransferItem(new s.DataTransferFile(dt.name,d.URI.revive(dt.uri),dt.id,(0,A.createSingleCallFunction)(()=>Xe(dt.id)))):Ve===T.Mimes.uriList&&Ze.uriListData?new s.InternalDataTransferItem(Me(Ze.uriListData)):new s.InternalDataTransferItem(Ze.asString)}Re.to=xe;async function Se(Ve,Ze){const Xe=await Ze.asString();if(Ve===T.Mimes.uriList)return{asString:Xe,fileData:void 0,uriListData:J(Xe)};const dt=Ze.asFile();return{asString:Xe,fileData:dt?{name:dt.name,uri:dt.uri,id:dt._itemId??dt.id}:void 0}}Re.from=Se;function J(Ve){return L.UriList.split(Ve).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return d.URI.parse(Ze)}catch{}return Ze})}function Me(Ve){return L.UriList.create(Ve.map(Ze=>typeof Ze=="string"?Ze:d.URI.revive(Ze)))}})($t||(e.DataTransferItem=$t={}));var Je;(function(Re){function xe(J,Me){const Ve=J.items.map(([Ze,Xe])=>[Ze,$t.to(Ze,Xe,Me)]);return new s.DataTransfer(Ve)}Re.toDataTransfer=xe;async function Se(J){const Me={items:[]},Ve=[];for(const[Ze,Xe]of J)Ve.push((async()=>{Me.items.push([Ze,await $t.from(Ze,Xe)])})());return await Promise.all(Ve),Me}Re.from=Se})(Je||(e.DataTransfer=Je={}));var li;(function(Re){function xe(J,Me){return{kind:"reply",agentId:J.participant??Me?.agentId??"",subCommand:J.command??Me?.command,message:J.prompt,title:J.label}}Re.from=xe;function Se(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}Re.to=Se})(li||(e.ChatFollowup=li={}));var Kt;(function(Re){function xe(Se){return"commandId"in Se?{kind:"command",title:Se.title??"",commandId:Se.commandId??"",when:Se.when??"",args:Se.args}:{kind:"reply",message:Se.message,title:Se.title,tooltip:Se.tooltip}}Re.from=xe})(Kt||(e.ChatInlineFollowup=Kt={}));var Ht;(function(Re){function xe(J){switch(J.role){case 0:return new s.LanguageModelChatSystemMessage(J.content);case 1:return new s.LanguageModelChatUserMessage(J.content);case 2:return new s.LanguageModelChatAssistantMessage(J.content)}}Re.to=xe;function Se(J){if(J instanceof s.LanguageModelChatSystemMessage)return{role:0,content:J.content};if(J instanceof s.LanguageModelChatUserMessage)return{role:1,content:J.content};if(J instanceof s.LanguageModelChatAssistantMessage)return{role:2,content:J.content};throw new Error("Invalid LanguageModelMessage")}Re.from=Se})(Ht||(e.LanguageModelMessage=Ht={}));var vt;(function(Re){function xe(Me){const Ve={};for(const Ze of Object.keys(Me))Ve[Ze]=Me[Ze].map(Re.to);return Ve}Re.objectTo=xe;function Se(Me){return{level:xt.to(Me.level),kind:Me.kind,value:(0,d.isUriComponents)(Me.value)?d.URI.revive(Me.value):Me.value,description:Me.description}}Re.to=Se;function J(Me){return{level:xt.from(Me.level),kind:Me.kind,value:Me.value,description:Me.description}}Re.from=J})(vt||(e.ChatVariable=vt={}));var xt;(function(Re){function xe(J){switch(J){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Re.to=xe;function Se(J){switch(J){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Re.from=Se})(xt||(e.ChatVariableLevel=xt={}));var Rt;(function(Re){function xe(Se){switch(Se){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Re.to=xe})(Rt||(e.InteractiveEditorResponseFeedbackKind=Rt={}));var Ot;(function(Re){function xe(J){return{kind:"markdownContent",content:X.from(J.value)}}Re.from=xe;function Se(J){return new s.ChatResponseMarkdownPart(X.to(J.content))}Re.to=Se})(Ot||(e.ChatResponseMarkdownPart=Ot={}));var ii;(function(Re){function xe(J){return{kind:"markdownVuln",content:X.from(J.value),vulnerabilities:J.vulnerabilities}}Re.from=xe;function Se(J){return new s.ChatResponseMarkdownWithVulnerabilitiesPart(X.to(J.content),J.vulnerabilities)}Re.to=Se})(ii||(e.ChatResponseMarkdownWithVulnerabilitiesPart=ii={}));var Vt;(function(Re){function xe(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}Re.from=xe;function Se(J){return new s.ChatResponseDetectedParticipantPart(J.agentId,J.command)}Re.to=Se})(Vt||(e.ChatResponseDetectedParticipantPart=Vt={}));var ni;(function(Re){function xe(J){const{value:Me,baseUri:Ve}=J;function Ze(Xe,dt){return Xe.map(yt=>{const zt=d.URI.joinPath(dt,yt.name);return{label:yt.name,uri:zt,children:yt.children&&Ze(yt.children,zt)}})}return{kind:"treeData",treeData:{label:(0,S.basename)(Ve),uri:Ve,children:Ze(Me,Ve)}}}Re.from=xe;function Se(J){const Me=(0,y.revive)(J.treeData);function Ve(dt){return dt.map(yt=>({name:yt.label,children:yt.children&&Ve(yt.children)}))}const Ze=Me.uri,Xe=Me.children?Ve(Me.children):[];return new s.ChatResponseFileTreePart(Xe,Ze)}Re.to=Se})(ni||(e.ChatResponseFilesPart=ni={}));var kt;(function(Re){function xe(J){return{kind:"inlineReference",name:J.title,inlineReference:d.URI.isUri(J.value)?J.value:v.from(J.value)}}Re.from=xe;function Se(J){const Me=(0,y.revive)(J);return new s.ChatResponseAnchorPart(d.URI.isUri(Me.inlineReference)?Me.inlineReference:v.to(Me.inlineReference),J.name)}Re.to=Se})(kt||(e.ChatResponseAnchorPart=kt={}));var Nt;(function(Re){function xe(J){return{kind:"progressMessage",content:X.from(J.value)}}Re.from=xe;function Se(J){return new s.ChatResponseProgressPart(J.content.value)}Re.to=Se})(Nt||(e.ChatResponseProgressPart=Nt={}));var Lt;(function(Re){function xe(J,Me,Ve){return{kind:"command",command:Me.toInternal(J.value,Ve)??{command:J.value.command,title:J.value.title}}}Re.from=xe;function Se(J,Me){return new s.ChatResponseCommandButtonPart(Me.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}Re.to=Se})(Lt||(e.ChatResponseCommandButtonPart=Lt={}));var Pt;(function(Re){function xe(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(Me=>le.from(Me))}}Re.from=xe;function Se(J){return new s.ChatResponseTextEditPart(d.URI.revive(J.uri),J.edits.map(Me=>le.to(Me)))}Re.to=Se})(Pt||(e.ChatResponseTextEditPart=Pt={}));var mt;(function(Re){function xe(J){const Me=w.ThemeIcon.isThemeIcon(J.iconPath)?J.iconPath:void 0;return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:d.URI.isUri(J.value.value)||!J.value.value?J.value.value:v.from(J.value.value)},iconPath:Me}:{kind:"reference",reference:d.URI.isUri(J.value)?J.value:v.from(J.value),iconPath:Me}}Re.from=xe;function Se(J){const Me=(0,y.revive)(J),Ve=Ze=>d.URI.isUri(Ze)?Ze:v.to(Ze);return new s.ChatResponseReferencePart("variableName"in Me.reference?{variableName:Me.reference.variableName,value:Me.reference.value&&Ve(Me.reference.value)}:Ve(Me.reference))}Re.to=Se})(mt||(e.ChatResponseReferencePart=mt={}));var Ct;(function(Re){function xe(Me,Ve,Ze){return Me instanceof s.ChatResponseMarkdownPart?Ot.from(Me):Me instanceof s.ChatResponseAnchorPart?kt.from(Me):Me instanceof s.ChatResponseReferencePart?mt.from(Me):Me instanceof s.ChatResponseProgressPart?Nt.from(Me):Me instanceof s.ChatResponseFileTreePart?ni.from(Me):Me instanceof s.ChatResponseCommandButtonPart?Lt.from(Me,Ve,Ze):Me instanceof s.ChatResponseTextEditPart?Pt.from(Me):Me instanceof s.ChatResponseMarkdownWithVulnerabilitiesPart?ii.from(Me):Me instanceof s.ChatResponseDetectedParticipantPart?Vt.from(Me):{kind:"markdownContent",content:X.from("")}}Re.from=xe;function Se(Me,Ve){switch(Me.kind){case"reference":return mt.to(Me);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(Me,Ve)}}Re.to=Se;function J(Me,Ve){switch(Me.kind){case"markdownContent":return Ot.to(Me);case"inlineReference":return kt.to(Me);case"progressMessage":return;case"treeData":return ni.to(Me);case"command":return Lt.to(Me,Ve)}}Re.toContent=J})(Ct||(e.ChatResponsePart=Ct={}));var ai;(function(Re){function xe(Se){return{prompt:Se.message,command:Se.command,attempt:Se.attempt??0,enableCommandDetection:Se.enableCommandDetection??!0,variables:Se.variables.variables.map(fi.to),location:Dt.to(Se.location)}}Re.to=xe})(ai||(e.ChatAgentRequest=ai={}));var Dt;(function(Re){function xe(Se){switch(Se){case o.ChatAgentLocation.Notebook:return s.ChatLocation.Notebook;case o.ChatAgentLocation.Terminal:return s.ChatLocation.Terminal;case o.ChatAgentLocation.Panel:return s.ChatLocation.Panel;case o.ChatAgentLocation.Editor:return s.ChatLocation.Editor}}Re.to=xe})(Dt||(e.ChatLocation=Dt={}));var fi;(function(Re){function xe(Se){return{name:Se.name,range:Se.range&&[Se.range.start,Se.range.endExclusive],values:Se.values.map(vt.to)}}Re.to=xe})(fi||(e.ChatAgentResolvedVariable=fi={}));var ri;(function(Re){function xe(Se,J,Me){return{label:Se.label,values:Se.values.map(vt.from),insertText:Se.insertText,detail:Se.detail,documentation:Se.documentation,command:J.toInternal(Se.command,Me)}}Re.from=xe})(ri||(e.ChatAgentCompletionItem=ri={}));var pi;(function(Re){function xe(Se){return{errorDetails:Se.errorDetails,metadata:Se.metadata}}Re.to=xe})(pi||(e.ChatAgentResult=pi={}));var ui;(function(Re){function xe(Se,J,Me){if(J.action.kind==="vote")return;const Ve=pi.to(Se);if(J.action.kind==="command"){const Ze=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Me.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:Ve}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:li.to(J.action.followup)},result:Ve}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:Ve}:{action:J.action,result:Ve}}Re.to=xe})(ui||(e.ChatAgentUserActionEvent=ui={}));var bi;(function(Re){function xe(Se,J,Me){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand,shouldExecute:Se.shouldExecute}:"uri"in Se?{uri:Se.uri}:J.toInternal(Se,Me)}Re.from=xe})(bi||(e.TerminalQuickFix=bi={}));var It;(function(Re){function xe(Se){return{kind:wi.to(Se.kind)}}Re.to=xe})(It||(e.PartialAcceptInfo=It={}));var wi;(function(Re){function xe(Se){switch(Se){case 0:return s.PartialAcceptTriggerKind.Word;case 1:return s.PartialAcceptTriggerKind.Line;case 2:return s.PartialAcceptTriggerKind.Suggest;default:return s.PartialAcceptTriggerKind.Unknown}}Re.to=xe})(wi||(e.PartialAcceptTriggerKind=wi={}));var si;(function(Re){function xe(Se,J){return{id:J,label:Se.label,description:Se.description,canEdit:Se.canEdit,collapsibleState:Se.collapsibleState||0,contextValue:Se.contextValue}}Re.from=xe})(si||(e.DebugTreeItem=si={}))}),define(_e[333],Ce([1,0,6,20,16,48]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(m,y){this._proxy=m.getProxy(h.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:T=>y.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,y,T){const I=new A.SerializableObjectWithBuffers(L.WorkspaceEdit.from(m,this._versionInformationProvider));return this._proxy.$tryApplyWorkspaceEdit(I,void 0,T?.isRefactoring??!1)}};e.ExtHostBulkEdits=R,e.ExtHostBulkEdits=R=Ge([Ue(0,O.IExtHostRpcService)],R)}),define(_e[334],Ce([1,0,19,7,47,4,39,3,40,18,2,25,6,16,8,297,26]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents2=void 0;class a{constructor(o,t,u,r,c){this._extension=o,this._request=t,this._proxy=u,this._commandsConverter=r,this._sessionDisposables=c,this._stopWatch=m.StopWatch.create(!1),this._isClosed=!1}close(){this._isClosed=!0}get timings(){return{firstProgress:this._firstProgress,totalElapsed:this._stopWatch.elapsed()}}get apiObject(){if(!this._apiObject){let t=function(r){if(o._isClosed){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,r),c}};const o=this;this._stopWatch.reset();const u=r=>{typeof this._firstProgress>"u"&&"content"in r&&(this._firstProgress=this._stopWatch.elapsed()),this._proxy.$handleProgressChunk(this._request.requestId,r)};this._apiObject={markdown(r){t(this.markdown);const c=new E.ChatResponseMarkdownPart(r),s=S.ChatResponseMarkdownPart.from(c);return u(s),this},markdownWithVulnerabilities(r,c){t(this.markdown),c&&(0,f.checkProposedApiEnabled)(o._extension,"chatParticipantAdditions");const s=new E.ChatResponseMarkdownWithVulnerabilitiesPart(r,c),w=S.ChatResponseMarkdownWithVulnerabilitiesPart.from(s);return u(w),this},filetree(r,c){t(this.filetree);const s=new E.ChatResponseFileTreePart(r,c),w=S.ChatResponseFilesPart.from(s);return u(w),this},anchor(r,c){t(this.anchor);const s=new E.ChatResponseAnchorPart(r,c),w=S.ChatResponseAnchorPart.from(s);return u(w),this},button(r){t(this.anchor);const c=new E.ChatResponseCommandButtonPart(r),s=S.ChatResponseCommandButtonPart.from(c,o._commandsConverter,o._sessionDisposables);return u(s),this},progress(r){t(this.progress);const c=new E.ChatResponseProgressPart(r),s=S.ChatResponseProgressPart.from(c);return u(s),this},reference(r,c){if(t(this.reference),"variableName"in r&&!r.value){const s=o._request.variables.variables.find(w=>w.name===r.variableName);if(s){let w;if(s.references?.length)w=s.references.map(g=>({kind:"reference",reference:{variableName:r.variableName,value:g.reference}}));else{const g=new E.ChatResponseReferencePart(r,c);w=[S.ChatResponseReferencePart.from(g)]}return w.forEach(g=>u(g)),this}}else{const s=new E.ChatResponseReferencePart(r,c),w=S.ChatResponseReferencePart.from(s);u(w)}return this},textEdit(r,c){t(this.textEdit),(0,f.checkProposedApiEnabled)(o._extension,"chatParticipantAdditions");const s=new E.ChatResponseTextEditPart(r,c),w=S.ChatResponseTextEditPart.from(s);return u(w),this},detectedParticipant(r,c){t(this.detectedParticipant),(0,f.checkProposedApiEnabled)(o._extension,"chatParticipantAdditions");const s=new E.ChatResponseDetectedParticipantPart(r,c),w=S.ChatResponseDetectedParticipantPart.from(s);return u(w),this},push(r){if(t(this.push),(r instanceof E.ChatResponseTextEditPart||r instanceof E.ChatResponseMarkdownWithVulnerabilitiesPart||r instanceof E.ChatResponseDetectedParticipantPart)&&(0,f.checkProposedApiEnabled)(o._extension,"chatParticipantAdditions"),r instanceof E.ChatResponseReferencePart)this.reference(r.value,r.iconPath);else{const c=S.ChatResponsePart.from(r,o._commandsConverter,o._sessionDisposables);u(c)}return this}}}return this._apiObject}}class i extends b.Disposable{static{this._idPool=0}constructor(o,t,u){super(),this._logService=t,this.commands=u,this._agents=new Map,this._sessionDisposables=this._register(new b.DisposableMap),this._completionDisposables=this._register(new b.DisposableStore),this._proxy=o.getProxy(p.MainContext.MainThreadChatAgents2)}transferActiveChat(o){this._proxy.$transferActiveChatSession(o)}createChatAgent(o,t,u){const r=i._idPool++,c=new n(o,t,this._proxy,r,u);return this._agents.set(r,c),this._proxy.$registerAgent(r,o.identifier,t,{},void 0),c.apiAgent}createDynamicChatAgent(o,t,u,r,c){const s=i._idPool++,w=new n(o,t,this._proxy,s,c);return this._agents.set(s,w),this._proxy.$registerAgent(s,o.identifier,t,{isSticky:!0},{name:u,description:r}),w.apiAgent}async $invokeAgent(o,t,u,r){const c=this._agents.get(o);if(!c)throw new Error(`[CHAT](${o}) CANNOT invoke agent because the agent is not registered`);let s=this._sessionDisposables.get(t.sessionId);s||(s=new b.DisposableStore,this._sessionDisposables.set(t.sessionId,s));const w=new a(c.extension,t,this._proxy,this.commands.converter,s);try{const g=await this.prepareHistoryTurns(t.agentId,u),D=c.invoke(S.ChatAgentRequest.to(t),{history:g},w.apiObject,r);return await(0,O.raceCancellation)(Promise.resolve(D).then(v=>{if(v?.metadata)try{JSON.stringify(v.metadata)}catch(_){const C=`result.metadata MUST be JSON.stringify-able. Got error: ${_.message}`;return this._logService.error(`[${c.extension.identifier.value}] [@${c.id}] ${C}`,c.extension),{errorDetails:{message:C},timings:w.timings}}return{errorDetails:v?.errorDetails,timings:w.timings,metadata:v?.metadata}}),r)}catch(g){return this._logService.error(g,c.extension),{errorDetails:{message:(0,L.toErrorMessage)(g),responseIsIncomplete:!0}}}finally{w.close()}}async prepareHistoryTurns(o,t){const u=[];for(const r of t.history){const c=S.ChatAgentResult.to(r.result),s=o===r.request.agentId?c:{...c,metadata:void 0};u.push(new E.ChatRequestTurn(r.request.message,r.request.command,r.request.variables.variables.map(S.ChatAgentResolvedVariable.to),r.request.agentId));const w=(0,h.coalesce)(r.response.map(g=>S.ChatResponsePart.toContent(g,this.commands.converter)));u.push(new E.ChatResponseTurn(w,s,r.request.agentId,r.request.command))}return u}$releaseSession(o){this._sessionDisposables.deleteAndDispose(o)}async $provideFollowups(o,t,u,r,c){const s=this._agents.get(t);if(!s)return Promise.resolve([]);const w=await this.prepareHistoryTurns(s.id,r),g=S.ChatAgentResult.to(u);return(await s.provideFollowups(g,{history:w},c)).filter(D=>{const v=!D.participant||R.Iterable.some(this._agents.values(),_=>_.id===D.participant&&I.ExtensionIdentifier.equals(_.extension.identifier,s.extension.identifier));return v||this._logService.warn(`[@${s.id}] ChatFollowup refers to an unknown participant: ${D.participant}`),v}).map(D=>S.ChatFollowup.from(D,o))}$acceptFeedback(o,t,u,r){const c=this._agents.get(o);if(!c)return;const s=S.ChatAgentResult.to(t);let w;switch(u){case d.InteractiveSessionVoteDirection.Down:w=E.ChatResultFeedbackKind.Unhelpful;break;case d.InteractiveSessionVoteDirection.Up:w=E.ChatResultFeedbackKind.Helpful;break}c.acceptFeedback(Object.freeze(r?{result:s,kind:w,reportIssue:r}:{result:s,kind:w}))}$acceptAction(o,t,u){const r=this._agents.get(o);if(!r||u.action.kind==="vote")return;const c=S.ChatAgentUserActionEvent.to(t,u,this.commands.converter);c&&r.acceptAction(Object.freeze(c))}async $invokeCompletionProvider(o,t,u){const r=this._agents.get(o);return r?(await r.invokeCompletionProvider(t,u)).map(s=>S.ChatAgentCompletionItem.from(s,this.commands.converter,this._completionDisposables)):[]}async $provideWelcomeMessage(o,t,u){const r=this._agents.get(o);if(r)return await r.provideWelcomeMessage(S.ChatLocation.to(t),u)}async $provideSampleQuestions(o,t,u){const r=this._agents.get(o);if(r)return(await r.provideSampleQuestions(S.ChatLocation.to(t),u)).map(c=>S.ChatFollowup.from(c,void 0))}}e.ExtHostChatAgents2=i;class n{constructor(o,t,u,r,c){this.extension=o,this.id=t,this._proxy=u,this._handle=r,this._requestHandler=c,this._onDidReceiveFeedback=new A.Emitter,this._onDidPerformAction=new A.Emitter}acceptFeedback(o){this._onDidReceiveFeedback.fire(o)}acceptAction(o){this._onDidPerformAction.fire(o)}async invokeCompletionProvider(o,t){return this._agentVariableProvider?await this._agentVariableProvider.provider.provideCompletionItems(o,t)??[]:[]}async provideFollowups(o,t,u){if(!this._followupProvider)return[];const r=await this._followupProvider.provideFollowups(o,t,u);return r?r.filter(c=>!(c&&"commandId"in c)).filter(c=>!(c&&"message"in c)):[]}async provideWelcomeMessage(o,t){if(!this._welcomeMessageProvider)return[];const u=await this._welcomeMessageProvider.provideWelcomeMessage(o,t);return u?u.map(r=>typeof r=="string"?r:S.MarkdownString.from(r)):[]}async provideSampleQuestions(o,t){if(!this._welcomeMessageProvider||!this._welcomeMessageProvider.provideSampleQuestions)return[];const u=await this._welcomeMessageProvider.provideSampleQuestions(o,t);return u||[]}get apiAgent(){let o=!1,t=!1;const u=()=>{o||t||(t=!0,queueMicrotask(()=>{this._proxy.$updateAgent(this._handle,{fullName:this._fullName,icon:this._iconPath?this._iconPath instanceof T.URI?this._iconPath:"light"in this._iconPath?this._iconPath.light:void 0:void 0,iconDark:this._iconPath&&"dark"in this._iconPath?this._iconPath.dark:void 0,themeIcon:this._iconPath instanceof E.ThemeIcon?this._iconPath:void 0,hasFollowups:this._followupProvider!==void 0,isSecondary:this._isSecondary,helpTextPrefix:!this._helpTextPrefix||typeof this._helpTextPrefix=="string"?this._helpTextPrefix:S.MarkdownString.from(this._helpTextPrefix),helpTextVariablesPrefix:!this._helpTextVariablesPrefix||typeof this._helpTextVariablesPrefix=="string"?this._helpTextVariablesPrefix:S.MarkdownString.from(this._helpTextVariablesPrefix),helpTextPostfix:!this._helpTextPostfix||typeof this._helpTextPostfix=="string"?this._helpTextPostfix:S.MarkdownString.from(this._helpTextPostfix),sampleRequest:this._sampleRequest,supportIssueReporting:this._supportIssueReporting,requester:this._requester}),t=!1}))},r=this;return{get id(){return r.id},get fullName(){return(0,f.checkProposedApiEnabled)(r.extension,"defaultChatParticipant"),r._fullName??r.extension.displayName??r.extension.name},set fullName(c){(0,f.checkProposedApiEnabled)(r.extension,"defaultChatParticipant"),r._fullName=c,u()},get iconPath(){return r._iconPath},set iconPath(c){r._iconPath=c,u()},get requestHandler(){return r._requestHandler},set requestHandler(c){(0,y.assertType)(typeof c=="function","Invalid request handler"),r._requestHandler=c},get followupProvider(){return r._followupProvider},set followupProvider(c){r._followupProvider=c,u()},get isDefault(){return(0,f.checkProposedApiEnabled)(r.extension,"defaultChatParticipant"),r._isDefault},set isDefault(c){(0,f.checkProposedApiEnabled)(r.extension,"defaultChatParticipant"),r._isDefault=c,u()},get helpTextPrefix(){return(0,f.checkProposedApiEnabled)(r.extension,"defaultChatParticipant"),r._helpTextPrefix},set helpTextPrefix(c){(0,f.checkProposedApiEnabled)(r.extension,"defaultChatParticipant"),r._helpTextPrefix=c,u()},get helpTextVariablesPrefix(){return(0,f.checkProposedApiEnabled)(r.extension,"defaultChatParticipant"),r._helpTextVariablesPrefix},set helpTextVariablesPrefix(c){(0,f.checkProposedApiEnabled)(r.extension,"defaultChatParticipant"),r._helpTextVariablesPrefix=c,u()},get helpTextPostfix(){return(0,f.checkProposedApiEnabled)(r.extension,"defaultChatParticipant"),r._helpTextPostfix},set helpTextPostfix(c){(0,f.checkProposedApiEnabled)(r.extension,"defaultChatParticipant"),r._helpTextPostfix=c,u()},get isSecondary(){return(0,f.checkProposedApiEnabled)(r.extension,"defaultChatParticipant"),r._isSecondary},set isSecondary(c){(0,f.checkProposedApiEnabled)(r.extension,"defaultChatParticipant"),r._isSecondary=c,u()},get sampleRequest(){return r._sampleRequest},set sampleRequest(c){r._sampleRequest=c,u()},get supportIssueReporting(){return(0,f.checkProposedApiEnabled)(r.extension,"chatParticipantAdditions"),r._supportIssueReporting},set supportIssueReporting(c){(0,f.checkProposedApiEnabled)(r.extension,"chatParticipantAdditions"),r._supportIssueReporting=c,u()},get onDidReceiveFeedback(){return r._onDidReceiveFeedback.event},set participantVariableProvider(c){if((0,f.checkProposedApiEnabled)(r.extension,"chatParticipantAdditions"),r._agentVariableProvider=c,c){if(!c.triggerCharacters.length)throw new Error("triggerCharacters are required");r._proxy.$registerAgentCompletionsProvider(r._handle,c.triggerCharacters)}else r._proxy.$unregisterAgentCompletionsProvider(r._handle)},get participantVariableProvider(){return(0,f.checkProposedApiEnabled)(r.extension,"chatParticipantAdditions"),r._agentVariableProvider},set welcomeMessageProvider(c){(0,f.checkProposedApiEnabled)(r.extension,"defaultChatParticipant"),r._welcomeMessageProvider=c,u()},get welcomeMessageProvider(){return(0,f.checkProposedApiEnabled)(r.extension,"defaultChatParticipant"),r._welcomeMessageProvider},onDidPerformAction:(0,f.isProposedApiEnabled)(this.extension,"chatParticipantAdditions")?this._onDidPerformAction.event:void 0,set requester(c){r._requester=c,u()},get requester(){return r._requester},dispose(){o=!0,r._followupProvider=void 0,r._onDidReceiveFeedback.dispose(),r._proxy.$unregisterAgent(r._handle)}}}invoke(o,t,u,r){return this._requestHandler(o,t,u,r)}}}),define(_e[335],Ce([1,0,13,3,6,16,8,26]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0;class m{static{this._idPool=0}constructor(I){this._resolver=new Map,this._proxy=I.getProxy(L.MainContext.MainThreadChatVariables)}async $resolveVariable(I,p,S,E){const d=this._resolver.get(I);if(d)try{if(d.resolver.resolve2){(0,b.checkProposedApiEnabled)(d.extension,"chatParticipantAdditions");const f=new y(p,this._proxy),a=await d.resolver.resolve2(d.data.name,{prompt:S},f.apiObject,E);if(a)return a.map(A.ChatVariable.from)}else{const f=await d.resolver.resolve(d.data.name,{prompt:S},E);if(f)return f.map(A.ChatVariable.from)}}catch(f){(0,h.onUnexpectedExternalError)(f)}}registerVariableResolver(I,p,S,E){const d=m._idPool++;return this._resolver.set(d,{extension:I,data:{name:p,description:S},resolver:E}),this._proxy.$registerVariable(d,{name:p,description:S}),(0,O.toDisposable)(()=>{this._resolver.delete(d),this._proxy.$unregisterVariable(d)})}}e.ExtHostChatVariables=m;class y{constructor(I,p){this._requestId=I,this._proxy=p,this._isClosed=!1}close(){this._isClosed=!0}get apiObject(){if(!this._apiObject){let p=function(E){if(I._isClosed){const d=new Error("Response stream has been closed");throw Error.captureStackTrace(d,E),d}};const I=this,S=E=>{this._proxy.$handleProgressChunk(this._requestId,E)};this._apiObject={progress(E){p(this.progress);const d=new R.ChatResponseProgressPart(E),f=A.ChatResponseProgressPart.from(d);return S(f),this},reference(E){p(this.reference);const d=new R.ChatResponseReferencePart(E),f=A.ChatResponseReferencePart.from(d);return S(f),this},push(E){return p(this.push),E instanceof R.ChatResponseReferencePart?S(A.ChatResponseReferencePart.from(E)):E instanceof R.ChatResponseProgressPart&&S(A.ChatResponseProgressPart.from(E)),this}}}return this._apiObject}}}),define(_e[336],Ce([1,0,7,56,4,3,2,84,25,16,8,6,26]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=S;function S(E,d,f){const a=E.getProxy(I.MainContext.MainThreadComments);class i{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new m.ExtensionIdentifierMap,d.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===6){const D=this._commentControllers.get(g.handle);return D?D.value:g}else if(g&&g.$mid===7){const D=g,v=this._commentControllers.get(D.commentControlHandle);if(!v)return D;const _=v.getCommentThread(D.commentThreadHandle);return _?_.value:D}else if(g&&(g.$mid===9||g.$mid===8)){const D=this._commentControllers.get(g.thread.commentControlHandle);if(!D)return g;const v=D.getCommentThread(g.thread.commentThreadHandle);return v?g.$mid===8?v.value:{thread:v.value,text:g.text}:g}else if(g&&g.$mid===10){const D=this._commentControllers.get(g.thread.commentControlHandle);if(!D)return g;const v=D.getCommentThread(g.thread.commentThreadHandle);if(!v)return g;const _=g.commentUniqueId,C=v.getCommentByUniqueId(_);return C||g}else if(g&&g.$mid===11){const D=this._commentControllers.get(g.thread.commentControlHandle);if(!D)return g;const v=D.getCommentThread(g.thread.commentThreadHandle);if(!v)return g;const _=g.text,C=g.commentUniqueId,P=v.getCommentByUniqueId(C);return P?(typeof P.body=="string"?P.body=_:P.body=new T.MarkdownString(_),P):g}return g}})}createCommentController(g,D,v){const _=i.handlePool++,C=new l(g,_,D,v);this._commentControllers.set(C.handle,C);const P=this._commentControllersByExtension.get(g.identifier)||[];return P.push(C),this._commentControllersByExtension.set(g.identifier,P),C.value}async $createCommentThreadTemplate(g,D,v){const _=this._commentControllers.get(g);_&&_.$createCommentThreadTemplate(D,v)}async $setActiveComment(g,D){const v=this._commentControllers.get(g);v&&v.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(g,D,v){const _=this._commentControllers.get(g);_&&_.$updateCommentThreadTemplate(D,v)}$deleteCommentThread(g,D){this._commentControllers.get(g)?.$deleteCommentThread(D)}async $provideCommentingRanges(g,D,v){const _=this._commentControllers.get(g);if(!_||!_.commentingRangeProvider)return Promise.resolve(void 0);const C=await f.ensureDocumentData(R.URI.revive(D));return(0,h.asPromise)(async()=>{const P=await _.commentingRangeProvider.provideCommentingRanges(C.document,v);let k;return Array.isArray(P)?k={ranges:P,fileComments:!1}:P?k={ranges:P.ranges||[],fileComments:P.fileComments||!1}:k=P??void 0,k}).then(P=>{let k;return P&&(k={ranges:P.ranges.map(F=>y.Range.from(F)),fileComments:P.fileComments}),k})}$toggleReaction(g,D,v,_,C){const P=this._commentControllers.get(g);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,h.asPromise)(()=>{const k=P.getCommentThread(D);if(k){const F=k.getCommentByUniqueId(_.uniqueIdInThread);if(P!==void 0&&F&&P.reactionHandler)return P.reactionHandler(F,u(C))}return Promise.resolve(void 0)})}}class n{static{this._handlePool=0}set threadId(g){this._id=g}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(g){(g===void 0!=(this._range===void 0)||!g||!this._range||!g.isEqual(this._range))&&(this._range=g,this.modifications.range=g,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(g){this._canReply!==g&&(this._canReply=g,this.modifications.canReply=g,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(g){this._label=g,this.modifications.label=g,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(g){this._contextValue=g,this.modifications.contextValue=g,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(g){this._comments=g,this.modifications.comments=g,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(g){this._collapseState=g,this.modifications.collapsibleState=g,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(g){this._state=g,typeof g=="object"?((0,p.checkProposedApiEnabled)(this.extensionDescription,"commentThreadApplicability"),this.modifications.state=g.resolved,this.modifications.applicability=g.applicability):this.modifications.state=g,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(g,D,v,_,C,P,k,F){this._commentControllerHandle=D,this._id=v,this._uri=_,this._range=C,this._comments=P,this.extensionDescription=k,this._isTemplate=F,this.handle=n._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new L.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${g}.${this.handle}`),a.$createCommentThread(D,this.handle,this._id,this._uri,y.Range.from(this._range),k.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this._localDisposables.push({dispose:()=>{a.$deleteCommentThread(D,this.handle)}});const x=this;this.value={get uri(){return x.uri},get range(){return x.range},set range(z){x.range=z},get comments(){return x.comments},set comments(z){x.comments=z},get collapsibleState(){return x.collapsibleState},set collapsibleState(z){x.collapsibleState=z},get canReply(){return x.canReply},set canReply(z){x.canReply=z},get contextValue(){return x.contextValue},set contextValue(z){x.contextValue=z},get label(){return x.label},set label(z){x.label=z},get state(){return x.state},set state(z){x.state=z},dispose:()=>{x.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const g=v=>Object.prototype.hasOwnProperty.call(this.modifications,v),D={};g("range")&&(D.range=y.Range.from(this._range)),g("label")&&(D.label=this.label),g("contextValue")&&(D.contextValue=this.contextValue??null),g("comments")&&(D.comments=this._comments.map(v=>o(this,v,this._commentsMap,this.extensionDescription))),g("collapsibleState")&&(D.collapseState=r(this._collapseState)),g("canReply")&&(D.canReply=this.canReply),g("state")&&(D.state=c(this._state)),g("applicability")&&(D.applicability=s(this._state)),g("isTemplate")&&(D.isTemplate=this._isTemplate),this.modifications={},a.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,D)}getCommentByUniqueId(g){for(const D of this._commentsMap){const v=D[0],_=D[1];if(g===_)return v}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(g=>g.dispose())}}Ge([(0,O.debounce)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class l{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(g){this._commentingRangeProvider=g,g?.resourceHints&&(0,p.checkProposedApiEnabled)(this._extension,"commentingRangeHint"),a.$updateCommentingRanges(this.handle,g?.resourceHints)}get reactionHandler(){return this._reactionHandler}set reactionHandler(g){this._reactionHandler=g,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!g})}get options(){return this._options}set options(g){this._options=g,a.$updateCommentControllerFeatures(this.handle,{options:this._options})}get activeComment(){return(0,p.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeComment}get activeCommentThread(){return(0,p.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeThread}constructor(g,D,v,_){this._extension=g,this._handle=D,this._id=v,this._label=_,this._threads=new Map,a.$registerCommentController(this.handle,v,_,this._extension.identifier.value);const C=this;this.value=Object.freeze({id:C.id,label:C.label,get options(){return C.options},set options(P){C.options=P},get commentingRangeProvider(){return C.commentingRangeProvider},set commentingRangeProvider(P){C.commentingRangeProvider=P},get reactionHandler(){return C.reactionHandler},set reactionHandler(P){C.reactionHandler=P},get activeCommentThread(){return C.activeCommentThread},createCommentThread(P,k,F){return C.createCommentThread(P,k,F).value},dispose:()=>{C.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(g,D,v){D===void 0&&(0,p.checkProposedApiEnabled)(this._extension,"fileComments");const _=new n(this.id,this.handle,void 0,g,D,v,this._extension,!1);return this._threads.set(_.handle,_),_}$setActiveComment(g){if(!g){this._activeComment=void 0,this._activeThread=void 0;return}const D=this._threads.get(g.commentThreadHandle);D&&(this._activeComment=g.uniqueIdInThread?D.getCommentByUniqueId(g.uniqueIdInThread):void 0,this._activeThread=D)}$createCommentThreadTemplate(g,D){const v=new n(this.id,this.handle,void 0,R.URI.revive(g),y.Range.to(D),[],this._extension,!0);return v.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this._threads.set(v.handle,v),v}$updateCommentThreadTemplate(g,D){const v=this._threads.get(g);v&&(v.range=y.Range.to(D))}$deleteCommentThread(g){this._threads.get(g)?.dispose(),this._threads.delete(g)}getCommentThread(g){return this._threads.get(g)}dispose(){this._threads.forEach(g=>{g.dispose()}),this._localDisposables.forEach(g=>g.dispose())}}function o(w,g,D,v){let _=D.get(g);return _||(_=++w.commentHandle,D.set(g,_)),g.state!==void 0&&(0,p.checkProposedApiEnabled)(v,"commentsDraftState"),g.reactions?.some(C=>C.reactors!==void 0)&&(0,p.checkProposedApiEnabled)(v,"commentReactor"),{mode:g.mode,contextValue:g.contextValue,uniqueIdInThread:_,body:typeof g.body=="string"?g.body:y.MarkdownString.from(g.body),userName:g.author.name,userIconPath:g.author.iconPath,label:g.label,commentReactions:g.reactions?g.reactions.map(C=>t(C)):void 0,state:g.state,timestamp:g.timestamp?.toJSON()}}function t(w){return{label:w.label,iconPath:w.iconPath?y.pathOrURIToURI(w.iconPath):void 0,count:w.count,hasReacted:w.authorHasReacted,reactors:w.reactors&&w.reactors.length>0&&typeof w.reactors[0]!="string"?w.reactors.map(g=>g.name):w.reactors}}function u(w){return{label:w.label||"",count:w.count||0,iconPath:w.iconPath?R.URI.revive(w.iconPath):"",authorHasReacted:w.hasReacted||!1,reactors:w.reactors?.map(g=>({name:g}))}}function r(w){if(w!==void 0)switch(w){case T.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function c(w){let g;if(typeof w=="object"?g=w.resolved:g=w,g!==void 0)switch(g){case T.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case T.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}function s(w){let g;if(typeof w=="object"&&(g=w.applicability),g!==void 0)switch(g){case T.CommentThreadApplicability.Current:return b.CommentThreadApplicability.Current;case T.CommentThreadApplicability.Outdated:return b.CommentThreadApplicability.Outdated}return b.CommentThreadApplicability.Current}return new i}}),define(_e[337],Ce([1,0,22,57,3,15,23,2,16,92,112,6,8]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class S{constructor(u,r){this.document=u,this._storagePath=r,this._backupCounter=1,this._edits=new T.Cache("custom documents")}addEdit(u){return this._edits.add([u])}async undo(u,r){await this.getEdit(u).undo(),r||this.disposeBackup()}async redo(u,r){await this.getEdit(u).redo(),r||this.disposeBackup()}disposeEdits(u){for(const r of u)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const u=o(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,u)}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(u){const r=this._edits.get(u,0);if(!r)throw new Error("No edit found");return r}}class E{constructor(){this._documents=new Map}get(u,r){return this._documents.get(this.key(u,r))}add(u,r,c){const s=this.key(u,r.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${u} resource:${r.uri}`);const w=new S(r,c);return this._documents.set(s,w),w}delete(u,r){const c=this.key(u,r.uri);this._documents.delete(c)}key(u,r){return`${u}@@@${r}`}}var d;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(d||(d={}));class f{constructor(){this._providers=new Map}addTextProvider(u,r,c){return this.add(0,u,r,c)}addCustomProvider(u,r,c){return this.add(1,u,r,c)}get(u){return this._providers.get(u)}add(u,r,c,s){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:u,extension:c,provider:s}),new p.Disposable(()=>this._providers.delete(r))}}class a{constructor(u,r,c,s,w){this._extHostDocuments=r,this._extensionStoragePaths=c,this._extHostWebview=s,this._extHostWebviewPanels=w,this._editorProviders=new f,this._documents=new E,this._proxy=u.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(u,r,c,s){const w=new L.DisposableStore;return n(c)?(w.add(this._editorProviders.addTextProvider(r,u,c)),this._proxy.$registerTextEditorProvider((0,y.toExtensionData)(u),r,s.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,y.shouldSerializeBuffersForPostMessage)(u))):(w.add(this._editorProviders.addCustomProvider(r,u,c)),i(c)&&w.add(c.onDidChangeCustomDocument(g=>{const D=this.getCustomDocumentEntry(r,g.document.uri);if(l(g)){const v=D.addEdit(g);this._proxy.$onDidEdit(g.document.uri,r,v,g.label)}else this._proxy.$onContentChange(g.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,y.toExtensionData)(u),r,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,y.shouldSerializeBuffersForPostMessage)(u))),p.Disposable.from(w,new p.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(u,r,c,s,w){const g=this._editorProviders.get(r);if(!g)throw new Error(`No provider found for '${r}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${r}'`);const D=b.URI.revive(u),v=await g.provider.openCustomDocument(D,{backupId:c,untitledDocumentData:s?.buffer},w);let _;return i(g.provider)&&this._extensionStoragePaths&&(_=this._extensionStoragePaths.workspaceValue(g.extension)??this._extensionStoragePaths.globalValue(g.extension)),this._documents.add(r,v,_),{editable:i(g.provider)}}async $disposeCustomDocument(u,r){const c=this._editorProviders.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${r}'`);const s=b.URI.revive(u),{document:w}=this.getCustomDocumentEntry(r,s);this._documents.delete(r,w),w.dispose()}async $resolveCustomEditor(u,r,c,s,w,g){const D=this._editorProviders.get(c);if(!D)throw new Error(`No provider found for '${c}'`);const v=m.ViewColumn.to(w),_=this._extHostWebview.createNewWebview(r,s.contentOptions,D.extension),C=this._extHostWebviewPanels.createNewWebviewPanel(r,c,s.title,v,s.options,_,s.active),P=b.URI.revive(u);switch(D.type){case 1:{const{document:k}=this.getCustomDocumentEntry(c,P);return D.provider.resolveCustomEditor(k,C,g)}case 0:{const k=this._extHostDocuments.getDocument(P);return D.provider.resolveCustomTextEditor(k,C,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,r,c){this.getCustomDocumentEntry(r,u).disposeEdits(c)}async $onMoveCustomEditor(u,r,c){const s=this._editorProviders.get(c);if(!s)throw new Error(`No provider found for '${c}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const w=this._extHostWebviewPanels.getWebviewPanel(u);if(!w)throw new Error("No webview found");const g=b.URI.revive(r),D=this._extHostDocuments.getDocument(g);await s.provider.moveCustomTextEditor(D,w,h.CancellationToken.None)}async $undo(u,r,c,s){return this.getCustomDocumentEntry(r,u).undo(c,s)}async $redo(u,r,c,s){return this.getCustomDocumentEntry(r,u).redo(c,s)}async $revert(u,r,c){const s=this.getCustomDocumentEntry(r,u);await this.getCustomEditorProvider(r).revertCustomDocument(s.document,c),s.disposeBackup()}async $onSave(u,r,c){const s=this.getCustomDocumentEntry(r,u);await this.getCustomEditorProvider(r).saveCustomDocument(s.document,c),s.disposeBackup()}async $onSaveAs(u,r,c,s){const w=this.getCustomDocumentEntry(r,u);return this.getCustomEditorProvider(r).saveCustomDocumentAs(w.document,b.URI.revive(c),s)}async $backup(u,r,c){const s=this.getCustomDocumentEntry(r,u),g=await this.getCustomEditorProvider(r).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},c);return s.updateBackup(g),g.id}getCustomDocumentEntry(u,r){const c=this._documents.get(u,b.URI.revive(r));if(!c)throw new Error("No custom document found");return c}getCustomEditorProvider(u){const c=this._editorProviders.get(u)?.provider;if(!c||!i(c))throw new Error("Custom document is not editable");return c}}e.ExtHostCustomEditors=a;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function l(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function o(t){const u=t.scheme===A.Schemas.file||t.scheme===A.Schemas.untitled?t.fsPath:t.toString();return(0,O.hash)(u)+""}}),define(_e[338],Ce([1,0,224,139,2,6,8,16,4,11,27,60]),function(ue,e,h,O,L,A,R,b,m,y,T,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class S{#e;#t;#i;constructor(f,a,i,n,l,o,t,u){this._name=f,this._owner=a,this._maxDiagnosticsTotal=i,this._maxDiagnosticsPerFile=n,this._modelVersionIdProvider=l,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(n,i),this.#i=new T.ResourceMap(r=>o.getComparisonKey(r)),this.#e=t,this.#t=u}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(f,a){if(!f){this.clear();return}this._checkDisposed();let i=[];if(L.URI.isUri(f)){if(!a){this.delete(f);return}this.#i.set(f,a.slice()),i=[f]}else if(Array.isArray(f)){i=[];let o;f=[...f].sort(S._compareIndexedTuplesByUri);for(const t of f){const[u,r]=t;if((!o||u.toString()!==o.toString())&&(o&&this.#i.get(o).length===0&&this.#i.delete(o),o=u,i.push(u),this.#i.set(u,[])),r)this.#i.get(u)?.push(...r);else{const c=this.#i.get(u);c&&(c.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let l=0;for(const o of i){let t=[];const u=this.#i.get(o);if(u)if(u.length>this._maxDiagnosticsPerFile){t=[];const r=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const s of u)if(s.severity===r[c]&&t.push({...b.Diagnostic.from(s),modelVersionId:this._modelVersionIdProvider(o)})===this._maxDiagnosticsPerFile)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,h.localize)(0,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=u.map(r=>({...b.Diagnostic.from(r),modelVersionId:this._modelVersionIdProvider(o)}));if(n.push([o,t]),l+=t.length,l>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,n)}delete(f){this._checkDisposed(),this.#t.fire([f]),this.#i.delete(f),this.#e?.$changeMany(this._owner,[[f,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(f,a){this._checkDisposed();for(const[i,n]of this)f.call(a,i,n,this)}*[Symbol.iterator](){this._checkDisposed();for(const f of this.#i.keys())yield[f,this.get(f)]}get(f){this._checkDisposed();const a=this.#i.get(f);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(f){return this._checkDisposed(),Array.isArray(this.#i.get(f))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(f,a){return f[0].toString()<a[0].toString()?-1:f[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=S;let E=class{static{p=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*p._maxDiagnosticsPerFile}static _mapper(f){const a=new T.ResourceMap;for(const i of f)a.set(i,i);return{uris:Object.freeze(Array.from(a.values()))}}constructor(f,a,i,n){this._logService=a,this._fileSystemInfoService=i,this._extHostDocumentsAndEditors=n,this._collections=new Map,this._onDidChangeDiagnostics=new m.DebounceEmitter({merge:l=>l.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this._onDidChangeDiagnostics.event,p._mapper),this._proxy=f.getProxy(A.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(f,a){const{_collections:i,_proxy:n,_onDidChangeDiagnostics:l,_logService:o,_fileSystemInfoService:t,_extHostDocumentsAndEditors:u}=this,r=new class{$changeMany(w,g){n.$changeMany(w,g),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,w,g.length===0?"CLEARING":g)}$clear(w){n.$clear(w),o.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,w)}dispose(){n.dispose()}};let c;if(!a)a="_generated_diagnostic_collection_name_#"+p._idPool++,c=a;else if(!i.has(a))c=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do c=a+p._idPool++;while(i.has(c))}return new class extends S{constructor(){super(a,c,p._maxDiagnosticsTotal,p._maxDiagnosticsPerFile,w=>u.getDocument(w)?.version,t.extUri,r,l),i.set(c,this)}dispose(){super.dispose(),i.delete(c)}}}getDiagnostics(f){if(f)return this._getDiagnostics(f);{const a=new Map,i=[];for(const n of this._collections.values())n.forEach((l,o)=>{let t=a.get(l.toString());typeof t>"u"&&(t=i.length,a.set(l.toString(),t),i.push([l,[]])),i[t][1]=i[t][1].concat(...o)});return i}}_getDiagnostics(f){let a=[];for(const i of this._collections.values())i.has(f)&&(a=a.concat(i.get(f)));return a}$acceptMarkersChange(f){if(!this._mirrorCollection){const a="_generated_mirror",i=new S(a,a,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(a,i),this._mirrorCollection=i}for(const[a,i]of f)this._mirrorCollection.set(L.URI.revive(a),i.map(b.Diagnostic.to))}};e.ExtHostDiagnostics=E,e.ExtHostDiagnostics=E=p=Ge([Ue(1,y.ILogService),Ue(2,I.IExtHostFileSystemInfo)],E)}),define(_e[339],Ce([1,0,2,13,8,16,76,48]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class m{constructor(T,I,p,S={timeout:1500,errors:3}){this._logService=T,this._documents=I,this._mainThreadBulkEdits=p,this._thresholds=S,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(I,p,S)=>{const d={dispose:this._callbacks.push([I,p,T])};return Array.isArray(S)&&S.push(d),d}}async $participateInSave(T,I){const p=h.URI.revive(T);let S=!1;const E=setTimeout(()=>S=!0,this._thresholds.timeout),d=[];try{for(const f of[...this._callbacks]){if(S)break;const a=this._documents.getDocument(p),i=await this._deliverEventAsyncAndBlameBadListeners(f,{document:a,reason:A.TextDocumentSaveReason.to(I)});d.push(i)}}finally{clearTimeout(E)}return d}_deliverEventAsyncAndBlameBadListeners([T,I,p],S){const E=this._badListeners.get(T);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(p,T,I,S).then(()=>!0,d=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' threw ERROR`),this._logService.error(d),!(d instanceof Error)||d.message!=="concurrent_edits"){const f=this._badListeners.get(T);this._badListeners.set(T,f?f+1:1),typeof f=="number"&&f>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,I,p,S){const E=[],d=Date.now(),{document:f,reason:a}=S,{version:i}=f,n=Object.freeze({document:f,reason:a,waitUntil(l){if(Object.isFrozen(E))throw(0,O.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(l))}});try{I.apply(p,[n])}catch(l){return Promise.reject(l)}return Object.freeze(E),new Promise((l,o)=>{const t=setTimeout(()=>o(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(u=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-d}ms`),clearTimeout(t),l(u)}).catch(u=>{clearTimeout(t),o(u)})}).then(l=>{const o={edits:[]};for(const t of l)if(Array.isArray(t)&&t.every(u=>u instanceof L.TextEdit))for(const{newText:u,newEol:r,range:c}of t)o.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:c&&A.Range.from(c),text:u,eol:r&&A.EndOfLine.from(r)}});if(o.edits.length!==0)return i===f.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(new b.SerializableObjectWithBuffers(o)):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=m}),define(_e[340],Ce([1,0,4,3,2,6,153,16,18,24,8]),function(ue,e,h,O,L,A,R,b,m,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(S,E){this._onDidAddDocument=new h.Emitter,this._onDidRemoveDocument=new h.Emitter,this._onDidChangeDocument=new h.Emitter,this._onDidSaveDocument=new h.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new O.DisposableStore,this._documentLoader=new Map,this._proxy=S.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=E,this._documentsAndEditors.onDidRemoveDocuments(d=>{for(const f of d)this._onDidRemoveDocument.fire(f.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(d=>{for(const f of d)this._onDidAddDocument.fire(f.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(S){if(!S)return;const E=this._documentsAndEditors.getDocument(S);if(E)return E}getDocument(S){const E=this.getDocumentData(S);if(!E?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return E.document}ensureDocumentData(S){const E=this._documentsAndEditors.getDocument(S);if(E)return Promise.resolve(E);let d=this._documentLoader.get(S.toString());return d||(d=this._proxy.$tryOpenDocument(S).then(f=>{this._documentLoader.delete(S.toString());const a=L.URI.revive(f);return(0,m.assertIsDefined)(this._documentsAndEditors.getDocument(a))},f=>(this._documentLoader.delete(S.toString()),Promise.reject(f))),this._documentLoader.set(S.toString(),d)),d}createDocumentData(S){return this._proxy.$tryCreateDocument(S).then(E=>L.URI.revive(E))}$acceptModelLanguageChanged(S,E){const d=L.URI.revive(S),f=this._documentsAndEditors.getDocument(d);if(!f)throw new Error("unknown document");this._onDidRemoveDocument.fire(f.document),f._acceptLanguageId(E),this._onDidAddDocument.fire(f.document)}$acceptModelSaved(S){const E=L.URI.revive(S),d=this._documentsAndEditors.getDocument(E);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this._onDidSaveDocument.fire(d.document)}$acceptDirtyStateChanged(S,E){const d=L.URI.revive(S),f=this._documentsAndEditors.getDocument(d);if(!f)throw new Error("unknown document");f._acceptIsDirty(E),this._onDidChangeDocument.fire({document:f.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,E,d){const f=L.URI.revive(S),a=this._documentsAndEditors.getDocument(f);if(!a)throw new Error("unknown document");a._acceptIsDirty(d),a.onEvents(E);let i;E.isUndoing?i=T.TextDocumentChangeReason.Undo:E.isRedoing&&(i=T.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,y.deepFreeze)({document:a.document,contentChanges:E.changes.map(n=>({range:b.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(S,E){(0,R.setWordDefinitionFor)(S,E)}}e.ExtHostDocuments=I}),define(_e[72],Ce([1,0,74,4,18,2,5,6,20,16,8]),function(ue,e,h,O,L,A,R,b,m,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,R.createDecorator)("IExtHostEditorTabs");class I{constructor(f,a,i){this._activeTabIdGetter=i,this._parentGroup=a,this.acceptDtoUpdate(f)}get apiObject(){if(!this._apiObject){const f=this,a={get isActive(){return f._dto.id===f._activeTabIdGetter()},get label(){return f._dto.label},get input(){return f._input},get isDirty(){return f._dto.isDirty},get isPinned(){return f._dto.isPinned},get isPreview(){return f._dto.isPreview},get group(){return f._parentGroup.apiObject}};this._apiObject=Object.freeze(a)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(f){this._dto=f,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new T.TextTabInput(A.URI.revive(this._dto.input.uri));case 2:return new T.TextDiffTabInput(A.URI.revive(this._dto.input.original),A.URI.revive(this._dto.input.modified));case 3:return new T.TextMergeTabInput(A.URI.revive(this._dto.input.base),A.URI.revive(this._dto.input.input1),A.URI.revive(this._dto.input.input2),A.URI.revive(this._dto.input.result));case 6:return new T.CustomEditorTabInput(A.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new T.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new T.NotebookEditorTabInput(A.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new T.NotebookDiffEditorTabInput(A.URI.revive(this._dto.input.original),A.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new T.TerminalEditorTabInput;case 9:return new T.InteractiveWindowInput(A.URI.revive(this._dto.input.uri),A.URI.revive(this._dto.input.inputBoxUri));case 10:return new T.ChatEditorTabInput;case 11:return new T.TextMultiDiffTabInput(this._dto.input.diffEditors.map(f=>new T.TextDiffTabInput(A.URI.revive(f.original),A.URI.revive(f.modified))));default:return}}}class p{constructor(f,a){this._tabs=[],this._activeTabId="",this._dto=f,this._activeGroupIdGetter=a;for(const i of f.tabs)i.isActive&&(this._activeTabId=i.id),this._tabs.push(new I(i,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const f=this,a={get isActive(){return f._dto.groupId===f._activeGroupIdGetter()},get viewColumn(){return y.ViewColumn.to(f._dto.viewColumn)},get activeTab(){return f._tabs.find(i=>i.tabId===f._activeTabId)?.apiObject},get tabs(){return Object.freeze(f._tabs.map(i=>i.apiObject))}};this._apiObject=Object.freeze(a)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(f){this._dto=f}acceptTabOperation(f){if(f.kind===0){const i=new I(f.tabDto,this,()=>this.activeTabId());return this._tabs.splice(f.index,0,i),f.tabDto.isActive&&(this._activeTabId=i.tabId),i}else if(f.kind===1){const i=this._tabs.splice(f.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${f.index} which does not exist`);return i.tabId===this._activeTabId&&(this._activeTabId=""),i}else if(f.kind===3){if(f.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this._tabs.splice(f.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${f.oldIndex} which does not exist`);return this._tabs.splice(f.index,0,i),i}const a=this._tabs.find(i=>i.tabId===f.tabDto.id);if(!a)throw new Error("INVALID tab");return f.tabDto.isActive?this._activeTabId=f.tabDto.id:this._activeTabId===f.tabDto.id&&!f.tabDto.isActive&&(this._activeTabId=""),a.acceptDtoUpdate(f.tabDto),a}activeTabId(){return this._activeTabId}}let S=class{constructor(f){this._onDidChangeTabs=new O.Emitter,this._onDidChangeTabGroups=new O.Emitter,this._extHostTabGroups=[],this._proxy=f.getProxy(b.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const f=this,a={onDidChangeTabGroups:f._onDidChangeTabGroups.event,onDidChangeTabs:f._onDidChangeTabs.event,get all(){return Object.freeze(f._extHostTabGroups.map(i=>i.apiObject))},get activeTabGroup(){const i=f._activeGroupId;return(0,L.assertIsDefined)(f._extHostTabGroups.find(l=>l.groupId===i)?.apiObject)},close:async(i,n)=>{const l=Array.isArray(i)?i:[i];return l.length?E(l[0])?this._closeGroups(l,n):this._closeTabs(l,n):!0}};this._apiObject=Object.freeze(a)}return this._apiObject}$acceptEditorTabModel(f){const a=new Set(this._extHostTabGroups.map(r=>r.groupId)),i=new Set(f.map(r=>r.groupId)),n=(0,h.diffSets)(a,i),l=this._extHostTabGroups.filter(r=>n.removed.includes(r.groupId)).map(r=>r.apiObject),o=[],t=[];this._extHostTabGroups=f.map(r=>{const c=new p(r,()=>this._activeGroupId);return n.added.includes(c.groupId)?o.push(c.apiObject):t.push(c.apiObject),c});const u=(0,L.assertIsDefined)(f.find(r=>r.isActive===!0)?.groupId);u!==void 0&&this._activeGroupId!==u&&(this._activeGroupId=u),this._onDidChangeTabGroups.fire(Object.freeze({opened:o,closed:l,changed:t}))}$acceptTabGroupUpdate(f){const a=this._extHostTabGroups.find(i=>i.groupId===f.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(f),f.isActive&&(this._activeGroupId=f.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(f){const a=this._extHostTabGroups.find(n=>n.groupId===f.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const i=a.acceptTabOperation(f);switch(f.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}_findExtHostTabFromApi(f){for(const a of this._extHostTabGroups)for(const i of a.tabs)if(i.apiObject===f)return i}_findExtHostTabGroupFromApi(f){return this._extHostTabGroups.find(a=>a.apiObject===f)}async _closeTabs(f,a){const i=[];for(const n of f){const l=this._findExtHostTabFromApi(n);if(!l)throw new Error("Tab close: Invalid tab not found!");i.push(l.tabId)}return this._proxy.$closeTab(i,a)}async _closeGroups(f,a){const i=[];for(const n of f){const l=this._findExtHostTabGroupFromApi(n);if(!l)throw new Error("Group close: Invalid group not found!");i.push(l.groupId)}return this._proxy.$closeGroup(i,a)}};e.ExtHostEditorTabs=S,e.ExtHostEditorTabs=S=Ge([Ue(0,m.IExtHostRpcService)],S);function E(d){return d.tabs!==void 0}}),define(_e[341],Ce([1,0,2,6,3,8,16,185,14,21,26,81]),function(ue,e,h,O,L,A,R,b,m,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class p{constructor(){this._schemes=[]}add(d){this._stateMachine=void 0,this._schemes.push(d)}delete(d){const f=this._schemes.indexOf(d);f>=0&&(this._schemes.splice(f,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const d=this._schemes.sort(),f=[];let a,i,n=14,l=14;for(const o of d){let t=a?(0,m.commonPrefixLength)(a,o):0;for(t===0?i=1:i=l;t<o.length;t++)t+1===o.length?(n=l,l=9):l+=1,f.push([i,o.toUpperCase().charCodeAt(t),l]),f.push([i,o.toLowerCase().charCodeAt(t),l]),i=l;a=o,l=n}f.push([9,58,10]),f.push([10,47,12]),this._stateMachine=new b.StateMachine(f)}}provideDocumentLinks(d){this._initStateMachine();const f=[],a=b.LinkComputer.computeLinks({getLineContent(i){return d.lineAt(i-1).text},getLineCount(){return d.lineCount}},this._stateMachine);for(const i of a){const n=R.DocumentLink.to(i);n.target&&f.push(n)}return f}}class S{constructor(d,f){this._extHostLanguageFeatures=f,this._linkProvider=new p,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=d.getProxy(O.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(d,f,a,i={}){if(S._validateFileSystemProvider(a),this._registeredSchemes.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(d,"*",this._linkProvider));const n=this._handlePool++;this._linkProvider.add(f),this._registeredSchemes.add(f),this._fsProvider.set(n,a);let l=2;i.isCaseSensitive&&(l+=1024),i.isReadonly&&(l+=2048),typeof a.copy=="function"&&(l+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&((0,T.checkProposedApiEnabled)(d,"fsChunks"),l+=4);let o;i.isReadonly&&(0,I.isMarkdownString)(i.isReadonly)&&i.isReadonly.value!==""&&(o={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this._proxy.$registerFileSystemProvider(n,f,l,o).catch(u=>{console.error(`FAILED to register filesystem provider of ${d.identifier.value}-extension for the scheme ${f}`),console.error(u)});const t=a.onDidChangeFile(u=>{const r=[];for(const c of u){const{uri:s,type:w}=c;if(s.scheme!==f)continue;let g;switch(w){case A.FileChangeType.Changed:g=0;break;case A.FileChangeType.Created:g=1;break;case A.FileChangeType.Deleted:g=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:s,type:g})}this._proxy.$onFileSystemChange(n,r)});return(0,L.toDisposable)(()=>{t.dispose(),this._linkProvider.delete(f),this._registeredSchemes.delete(f),this._fsProvider.delete(n),this._proxy.$unregisterProvider(n)})}static _validateFileSystemProvider(d){if(!d)throw new Error("MISSING provider");if(typeof d.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof d.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof d.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof d.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof d.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof d.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof d.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof d.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(d){const{type:f,ctime:a,mtime:i,size:n,permissions:l}=d;return{type:f,ctime:a,mtime:i,size:n,permissions:l}}$stat(d,f){return Promise.resolve(this._getFsProvider(d).stat(h.URI.revive(f))).then(a=>S._asIStat(a))}$readdir(d,f){return Promise.resolve(this._getFsProvider(d).readDirectory(h.URI.revive(f)))}$readFile(d,f){return Promise.resolve(this._getFsProvider(d).readFile(h.URI.revive(f))).then(a=>y.VSBuffer.wrap(a))}$writeFile(d,f,a,i){return Promise.resolve(this._getFsProvider(d).writeFile(h.URI.revive(f),a.buffer,i))}$delete(d,f,a){return Promise.resolve(this._getFsProvider(d).delete(h.URI.revive(f),a))}$rename(d,f,a,i){return Promise.resolve(this._getFsProvider(d).rename(h.URI.revive(f),h.URI.revive(a),i))}$copy(d,f,a,i){const n=this._getFsProvider(d);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(h.URI.revive(f),h.URI.revive(a),i))}$mkdir(d,f){return Promise.resolve(this._getFsProvider(d).createDirectory(h.URI.revive(f)))}$watch(d,f,a,i){const n=this._getFsProvider(d).watch(h.URI.revive(a),i);this._watches.set(f,n)}$unwatch(d,f){const a=this._watches.get(f);a&&(a.dispose(),this._watches.delete(f))}$open(d,f,a){const i=this._getFsProvider(d);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(h.URI.revive(f),a))}$close(d,f){const a=this._getFsProvider(d);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(f))}$read(d,f,a,i){const n=this._getFsProvider(d);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const l=y.VSBuffer.alloc(i);return Promise.resolve(n.read(f,a,l.buffer,0,i)).then(o=>l.slice(0,o))}$write(d,f,a,i){const n=this._getFsProvider(d);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(f,a,i.buffer,0,i.byteLength))}_getFsProvider(d){const f=this._fsProvider.get(d);if(!f){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return f}}e.ExtHostFileSystem=S}),define(_e[342],Ce([1,0,4,35,2,6,16,8,46]),function(ue,e,h,O,L,A,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(S,E,d,f,a,i){this.session=Math.random(),this._onDidCreate=new h.Emitter,this._onDidChange=new h.Emitter,this._onDidDelete=new h.Emitter,this._config=0,i?.ignoreCreateEvents&&(this._config+=1),i?.ignoreChangeEvents&&(this._config+=2),i?.ignoreDeleteEvents&&(this._config+=4);const n=(0,O.parse)(a),l=typeof a=="string",o=i?.correlate,t=f(u=>{if(!(typeof u.session=="number"&&u.session!==this.session)&&!(o&&typeof u.session>"u")){if(!i?.ignoreCreateEvents)for(const r of u.created){const c=L.URI.revive(r);n(c.fsPath)&&(!l||E.getWorkspaceFolder(c))&&this._onDidCreate.fire(c)}if(!i?.ignoreChangeEvents)for(const r of u.changed){const c=L.URI.revive(r);n(c.fsPath)&&(!l||E.getWorkspaceFolder(c))&&this._onDidChange.fire(c)}if(!i?.ignoreDeleteEvents)for(const r of u.deleted){const c=L.URI.revive(r);n(c.fsPath)&&(!l||E.getWorkspaceFolder(c))&&this._onDidDelete.fire(c)}}});this._disposable=b.Disposable.from(this.ensureWatching(S,d,a,i,i?.correlate),this._onDidCreate,this._onDidChange,this._onDidDelete,t)}ensureWatching(S,E,d,f,a){const i=b.Disposable.from();if(typeof d=="string"||f?.ignoreChangeEvents&&f?.ignoreCreateEvents&&f?.ignoreDeleteEvents)return i;const n=S.getProxy(A.MainContext.MainThreadFileSystemEventService);let l=!1;(d.pattern.includes(O.GLOBSTAR)||d.pattern.includes(O.GLOB_SPLIT))&&(l=!0);let o;return a&&(f?.ignoreChangeEvents||f?.ignoreCreateEvents||f?.ignoreDeleteEvents)&&(o=14,f?.ignoreChangeEvents&&(o&=-3),f?.ignoreCreateEvents&&(o&=-5),f?.ignoreDeleteEvents&&(o&=-9)),n.$watch(E.identifier.value,this.session,d.baseUri,{recursive:l,excludes:f?.excludes??[],filter:o},!!a),b.Disposable.from({dispose:()=>n.$unwatch(this.session)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class T{constructor(S){this._events=S,this.session=this._events.session,this._created=new m.Lazy(()=>this._events.created.map(L.URI.revive)),this._changed=new m.Lazy(()=>this._events.changed.map(L.URI.revive)),this._deleted=new m.Lazy(()=>this._events.deleted.map(L.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class I{constructor(S,E,d){this._mainContext=S,this._logService=E,this._extHostDocumentsAndEditors=d,this._onFileSystemEvent=new h.Emitter,this._onDidRenameFile=new h.Emitter,this._onDidCreateFile=new h.Emitter,this._onDidDeleteFile=new h.Emitter,this._onWillRenameFile=new h.AsyncEmitter,this._onWillCreateFile=new h.AsyncEmitter,this._onWillDeleteFile=new h.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(S,E,d,f){return new y(this._mainContext,S,E,this._onFileSystemEvent.event,R.GlobPattern.from(d),f)}$onFileEvent(S){this._onFileSystemEvent.fire(new T(S))}$onDidRunFileOperation(S,E){switch(S){case 2:this._onDidRenameFile.fire(Object.freeze({files:E.map(d=>({oldUri:L.URI.revive(d.source),newUri:L.URI.revive(d.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:E.map(d=>L.URI.revive(d.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:E.map(d=>L.URI.revive(d.target))}));break;default:}}getOnWillRenameFileEvent(S){return this._createWillExecuteEvent(S,this._onWillRenameFile)}getOnWillCreateFileEvent(S){return this._createWillExecuteEvent(S,this._onWillCreateFile)}getOnWillDeleteFileEvent(S){return this._createWillExecuteEvent(S,this._onWillDeleteFile)}_createWillExecuteEvent(S,E){return(d,f,a)=>{const i=function(l){d.call(f,l)};return i.extension=S,E.event(i,void 0,a)}}async $onWillRunFileOperation(S,E,d,f){switch(S){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:E.map(a=>({oldUri:L.URI.revive(a.source),newUri:L.URI.revive(a.target)}))},d,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:E.map(a=>L.URI.revive(a.target))},d,f);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:E.map(a=>L.URI.revive(a.target))},d,f)}}async _fireWillEvent(S,E,d,f){const a=new Set,i=[];if(await S.fireAsync(E,f,async(l,o)=>{const t=Date.now(),u=await Promise.resolve(l);u instanceof b.WorkspaceEdit&&(i.push([o.extension,u]),a.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-t>d&&this._logService.warn("SLOW file-participant",o.extension.identifier)}),f.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,l]of i){const{edits:o}=R.WorkspaceEdit.from(l,{getTextDocumentVersion:t=>this._extHostDocumentsAndEditors.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(o)}return{edit:n,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=I}),define(_e[343],Ce([1,0,19,7,22,13,125,3,24,40,14,18,2,29,181,84,135,226,25,16,8,26,112,6]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i,n,l,o,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class r{constructor(U,$){this._documents=U,this._provider=$}async provideDocumentSymbols(U,$){const K=this._documents.getDocument(U),Q=await this._provider.provideDocumentSymbols(K,$);if(!(0,h.isFalsyOrEmpty)(Q))return Q[0]instanceof l.DocumentSymbol?Q.map(n.DocumentSymbol.from):r._asDocumentSymbolTree(Q)}static _asDocumentSymbolTree(U){U=U.slice(0).sort((Q,de)=>{let Ee=Q.location.range.start.compareTo(de.location.range.start);return Ee===0&&(Ee=de.location.range.end.compareTo(Q.location.range.end)),Ee});const $=[],K=[];for(const Q of U){const de={name:Q.name||"!!MISSING: name!!",kind:n.SymbolKind.from(Q.kind),tags:Q.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:n.Range.from(Q.location.range),selectionRange:n.Range.from(Q.location.range),children:[]};for(;;){if(K.length===0){K.push(de),$.push(de);break}const Ee=K[K.length-1];if(S.Range.containsRange(Ee.range,de.range)&&!S.Range.equalsRange(Ee.range,de.range)){Ee.children?.push(de),K.push(de);break}K.pop()}}return $}}class c{constructor(U,$,K,Q,de,Ee){this._documents=U,this._commands=$,this._provider=K,this._extension=Q,this._extTelemetry=de,this._logService=Ee,this._cache=new t.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(U,$){const K=this._documents.getDocument(U),Q=await this._provider.provideCodeLenses(K,$);if(!Q||$.isCancellationRequested)return;const de=this._cache.add(Q),Ee=new b.DisposableStore;this._disposables.set(de,Ee);const Fe={cacheId:de,lenses:[]};for(let He=0;He<Q.length;He++)Fe.lenses.push({cacheId:[de,He],range:n.Range.from(Q[He].range),command:this._commands.toInternal(Q[He].command,Ee)});return Fe}async resolveCodeLens(U,$){const K=U.cacheId&&this._cache.get(...U.cacheId);if(!K)return;let Q;if(typeof this._provider.resolveCodeLens!="function"||K.isResolved?Q=K:Q=await this._provider.resolveCodeLens(K,$),Q||(Q=K),$.isCancellationRequested)return;const de=U.cacheId&&this._disposables.get(U.cacheId[0]);if(de){if(!Q.command){const Ee=new Error("INVALID code lens resolved, lacks command: "+this._extension.identifier.value);this._extTelemetry.onExtensionError(this._extension.identifier,Ee),this._logService.error(Ee);return}return U.command=this._commands.toInternal(Q.command,de),U}}releaseCodeLenses(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}}function s(ze){return Array.isArray(ze)?ze.map(n.DefinitionLink.from):ze?[n.DefinitionLink.from(ze)]:[]}class w{constructor(U,$){this._documents=U,this._provider=$}async provideDefinition(U,$,K){const Q=this._documents.getDocument(U),de=n.Position.to($),Ee=await this._provider.provideDefinition(Q,de,K);return s(Ee)}}class g{constructor(U,$){this._documents=U,this._provider=$}async provideDeclaration(U,$,K){const Q=this._documents.getDocument(U),de=n.Position.to($),Ee=await this._provider.provideDeclaration(Q,de,K);return s(Ee)}}class D{constructor(U,$){this._documents=U,this._provider=$}async provideImplementation(U,$,K){const Q=this._documents.getDocument(U),de=n.Position.to($),Ee=await this._provider.provideImplementation(Q,de,K);return s(Ee)}}class v{constructor(U,$){this._documents=U,this._provider=$}async provideTypeDefinition(U,$,K){const Q=this._documents.getDocument(U),de=n.Position.to($),Ee=await this._provider.provideTypeDefinition(Q,de,K);return s(Ee)}}class _{static{this.HOVER_MAP_MAX_SIZE=10}constructor(U,$){this._documents=U,this._provider=$,this._hoverCounter=0,this._hoverMap=new Map}async provideHover(U,$,K,Q){const de=this._documents.getDocument(U),Ee=n.Position.to($);let Fe;if(K&&K.verbosityRequest){const tt=K.verbosityRequest.previousHover.id,it=this._hoverMap.get(tt);if(!it)throw new Error(`Hover with id ${tt} not found`);const st={action:K.verbosityRequest.action,previousHover:it};Fe=await this._provider.provideHover(de,Ee,Q,st)}else Fe=await this._provider.provideHover(de,Ee,Q);if(!Fe||(0,h.isFalsyOrEmpty)(Fe.contents))return;Fe.range||(Fe.range=de.getWordRangeAtPosition(Ee)),Fe.range||(Fe.range=new l.Range(Ee,Ee));const He=n.Hover.from(Fe),Ke=this._hoverCounter;if(this._hoverMap.size===_.HOVER_MAP_MAX_SIZE){const tt=Math.min(...this._hoverMap.keys());this._hoverMap.delete(tt)}return this._hoverMap.set(Ke,Fe),this._hoverCounter+=1,{...He,id:Ke}}releaseHover(U){this._hoverMap.delete(U)}}class C{constructor(U,$){this._documents=U,this._provider=$}async provideEvaluatableExpression(U,$,K){const Q=this._documents.getDocument(U),de=n.Position.to($),Ee=await this._provider.provideEvaluatableExpression(Q,de,K);if(Ee)return n.EvaluatableExpression.from(Ee)}}class P{constructor(U,$){this._documents=U,this._provider=$}async provideInlineValues(U,$,K,Q){const de=this._documents.getDocument(U),Ee=await this._provider.provideInlineValues(de,n.Range.to($),n.InlineValueContext.to(K),Q);if(Array.isArray(Ee))return Ee.map(Fe=>n.InlineValue.from(Fe))}}class k{constructor(U,$){this._documents=U,this._provider=$}async provideDocumentHighlights(U,$,K){const Q=this._documents.getDocument(U),de=n.Position.to($),Ee=await this._provider.provideDocumentHighlights(Q,de,K);if(Array.isArray(Ee))return Ee.map(n.DocumentHighlight.from)}}class F{constructor(U,$){this._documents=U,this._provider=$}async provideMultiDocumentHighlights(U,$,K,Q){const de=this._documents.getDocument(U),Ee=K.map(Ke=>this._documents.getDocument(Ke)),Fe=n.Position.to($),He=await this._provider.provideMultiDocumentHighlights(de,Fe,Ee,Q);if(Array.isArray(He))return He.map(n.MultiDocumentHighlight.from)}}class x{constructor(U,$){this._documents=U,this._provider=$}async provideLinkedEditingRanges(U,$,K){const Q=this._documents.getDocument(U),de=n.Position.to($),Ee=await this._provider.provideLinkedEditingRanges(Q,de,K);if(Ee&&Array.isArray(Ee.ranges))return{ranges:(0,h.coalesce)(Ee.ranges.map(n.Range.from)),wordPattern:Ee.wordPattern}}}class z{constructor(U,$){this._documents=U,this._provider=$}async provideReferences(U,$,K,Q){const de=this._documents.getDocument(U),Ee=n.Position.to($),Fe=await this._provider.provideReferences(de,Ee,K,Q);if(Array.isArray(Fe))return Fe.map(n.location.from)}}class N{static{this._maxCodeActionsPerFile=1e3}constructor(U,$,K,Q,de,Ee,Fe){this._documents=U,this._commands=$,this._diagnostics=K,this._provider=Q,this._logService=de,this._extension=Ee,this._apiDeprecation=Fe,this._cache=new t.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(U,$,K,Q){const de=this._documents.getDocument(U),Ee=E.Selection.isISelection($)?n.Selection.to($):n.Range.to($),Fe=[];for(const st of this._diagnostics.getDiagnostics(U))if(Ee.intersection(st.range)&&Fe.push(st)>N._maxCodeActionsPerFile)break;const He={diagnostics:Fe,only:K.only?new l.CodeActionKind(K.only):void 0,triggerKind:n.CodeActionTriggerKind.to(K.trigger)},Ke=await this._provider.provideCodeActions(de,Ee,He,Q);if(!(0,h.isNonEmptyArray)(Ke)||Q.isCancellationRequested)return;const rt=this._cache.add(Ke),tt=new b.DisposableStore;this._disposables.set(rt,tt);const it=[];for(let st=0;st<Ke.length;st++){const Ie=Ke[st];if(Ie)if(N._isCommand(Ie))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ie.title,command:this._commands.toInternal(Ie,tt)});else{He.only&&(Ie.kind?He.only.contains(Ie.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action is of kind '${Ie.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Be=Ie.ranges??[];it.push({cacheId:[rt,st],title:Ie.title,command:Ie.command&&this._commands.toInternal(Ie.command,tt),diagnostics:Ie.diagnostics&&Ie.diagnostics.map(n.Diagnostic.from),edit:Ie.edit&&n.WorkspaceEdit.from(Ie.edit,void 0),kind:Ie.kind&&Ie.kind.value,isPreferred:Ie.isPreferred,isAI:(0,o.isProposedApiEnabled)(this._extension,"codeActionAI")?Ie.isAI:!1,ranges:(0,o.isProposedApiEnabled)(this._extension,"codeActionRanges")?(0,h.coalesce)(Be.map(n.Range.from)):void 0,disabled:Ie.disabled?.reason})}}return{cacheId:rt,actions:it}}async resolveCodeAction(U,$){const[K,Q]=U,de=this._cache.get(K,Q);if(!de||N._isCommand(de))return{};if(!this._provider.resolveCodeAction)return{};const Ee=await this._provider.resolveCodeAction(de,$)??de;let Fe;Ee.edit&&(Fe=n.WorkspaceEdit.from(Ee.edit,void 0));let He;if(Ee.command){const Ke=this._disposables.get(K);Ke&&(He=this._commands.toInternal(Ee.command,Ke))}return{edit:Fe,command:He}}releaseCodeActions(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}static _isCommand(U){return typeof U.command=="string"&&typeof U.title=="string"}}class M{constructor(U,$,K,Q,de){this._proxy=U,this._documents=$,this._provider=K,this._handle=Q,this._extension=de,this._cache=new t.Cache("DocumentPasteEdit")}async prepareDocumentPaste(U,$,K,Q){if(!this._provider.prepareDocumentPaste)return;const de=this._documents.getDocument(U),Ee=$.map(Ke=>n.Range.to(Ke)),Fe=n.DataTransfer.toDataTransfer(K,()=>{throw new A.NotImplementedError});if(await this._provider.prepareDocumentPaste(de,Ee,Fe,Q),Q.isCancellationRequested)return;const He=Array.from(Fe).filter(([,Ke])=>!(Ke instanceof l.InternalDataTransferItem));return n.DataTransfer.from(He)}async providePasteEdits(U,$,K,Q,de,Ee){if(!this._provider.provideDocumentPasteEdits)return[];const Fe=this._documents.getDocument($),He=K.map(it=>n.Range.to(it)),Ke=n.DataTransfer.toDataTransfer(Q,async it=>(await this._proxy.$resolvePasteFileData(this._handle,U,it)).buffer),rt=await this._provider.provideDocumentPasteEdits(Fe,He,Ke,{only:de.only?new l.DocumentDropOrPasteEditKind(de.only):void 0,triggerKind:de.triggerKind},Ee);if(!rt||Ee.isCancellationRequested)return[];const tt=this._cache.add(rt);return rt.map((it,st)=>({_cacheId:[tt,st],title:it.title??(0,a.localize)(0,null,this._extension.displayName||this._extension.name),kind:it.kind,yieldTo:it.yieldTo?.map(Ie=>Ie.value),insertText:typeof it.insertText=="string"?it.insertText:{snippet:it.insertText.value},additionalEdit:it.additionalEdit?n.WorkspaceEdit.from(it.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,$){const[K,Q]=U,de=this._cache.get(K,Q);if(!de||!this._provider.resolveDocumentPasteEdit)return{};const Ee=await this._provider.resolveDocumentPasteEdit(de,$)??de;return{additionalEdit:Ee.additionalEdit?n.WorkspaceEdit.from(Ee.additionalEdit,void 0):void 0}}releasePasteEdits(U){this._cache.delete(U)}}class W{constructor(U,$){this._documents=U,this._provider=$}async provideDocumentFormattingEdits(U,$,K){const Q=this._documents.getDocument(U),de=await this._provider.provideDocumentFormattingEdits(Q,$,K);if(Array.isArray(de))return de.map(n.TextEdit.from)}}class X{constructor(U,$){this._documents=U,this._provider=$}async provideDocumentRangeFormattingEdits(U,$,K,Q){const de=this._documents.getDocument(U),Ee=n.Range.to($),Fe=await this._provider.provideDocumentRangeFormattingEdits(de,Ee,K,Q);if(Array.isArray(Fe))return Fe.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,$,K,Q){(0,I.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const de=this._documents.getDocument(U),Ee=$.map(n.Range.to),Fe=await this._provider.provideDocumentRangesFormattingEdits(de,Ee,K,Q);if(Array.isArray(Fe))return Fe.map(n.TextEdit.from)}}class te{constructor(U,$){this._documents=U,this._provider=$,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,$,K,Q,de){const Ee=this._documents.getDocument(U),Fe=n.Position.to($),He=await this._provider.provideOnTypeFormattingEdits(Ee,Fe,K,Q,de);if(Array.isArray(He))return He.map(n.TextEdit.from)}}class H{constructor(U,$){this._provider=U,this._logService=$,this._cache=new t.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(U,$){const K=await this._provider.provideWorkspaceSymbols(U,$);if(!(0,h.isNonEmptyArray)(K))return{symbols:[]};const Q=this._cache.add(K),de={cacheId:Q,symbols:[]};for(let Ee=0;Ee<K.length;Ee++){const Fe=K[Ee];if(!Fe||!Fe.name){this._logService.warn("INVALID SymbolInformation",Fe);continue}de.symbols.push({...n.WorkspaceSymbol.from(Fe),cacheId:[Q,Ee]})}return de}async resolveWorkspaceSymbol(U,$){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const K=this._cache.get(...U.cacheId);if(K){const Q=await this._provider.resolveWorkspaceSymbol(K,$);return Q&&(0,m.mixin)(U,n.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(U){this._cache.delete(U)}}class G{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,$,K){this._documents=U,this._provider=$,this._logService=K}async provideRenameEdits(U,$,K,Q){const de=this._documents.getDocument(U),Ee=n.Position.to($);try{const Fe=await this._provider.provideRenameEdits(de,Ee,K,Q);return Fe?n.WorkspaceEdit.from(Fe):void 0}catch(Fe){const He=G._asMessage(Fe);return He?{rejectReason:He,edits:void 0}:Promise.reject(Fe)}}async resolveRenameLocation(U,$,K){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const Q=this._documents.getDocument(U),de=n.Position.to($);try{const Ee=await this._provider.prepareRename(Q,de,K);let Fe,He;if(l.Range.isRange(Ee)?(Fe=Ee,He=Q.getText(Ee)):(0,I.isObject)(Ee)&&(Fe=Ee.range,He=Ee.placeholder),!Fe||!He)return;if(Fe.start.line>de.line||Fe.end.line<de.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Fe),text:He}}catch(Ee){const Fe=G._asMessage(Ee);return Fe?{rejectReason:Fe,range:void 0,text:void 0}:Promise.reject(Ee)}}static _asMessage(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class Y{static{this.languageTriggerKindToVSCodeTriggerKind={[d.NewSymbolNameTriggerKind.Invoke]:l.NewSymbolNameTriggerKind.Invoke,[d.NewSymbolNameTriggerKind.Automatic]:l.NewSymbolNameTriggerKind.Automatic}}constructor(U,$,K){this._documents=U,this._provider=$,this._logService=K}async supportsAutomaticNewSymbolNamesTriggerKind(){return this._provider.supportsAutomaticTriggerKind}async provideNewSymbolNames(U,$,K,Q){const de=this._documents.getDocument(U),Ee=n.Range.to($);try{const Fe=Y.languageTriggerKindToVSCodeTriggerKind[K],He=await this._provider.provideNewSymbolNames(de,Ee,Fe,Q);return He?He.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Fe){this._logService.error(Y._asMessage(Fe)??JSON.stringify(Fe,null,"	"));return}}static _asMessage(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class ne{constructor(U,$){this.resultId=U,this.tokens=$}}class pe{constructor(U,$){this._documents=U,this._provider=$,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(U,$,K){const Q=this._documents.getDocument(U),de=$!==0?this._previousResults.get($):null;let Ee=typeof de?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(Q,de.resultId,K):await this._provider.provideDocumentSemanticTokens(Q,K);return de&&this._previousResults.delete($),Ee?(Ee=pe._fixProvidedSemanticTokens(Ee),this._send(pe._convertToEdits(de,Ee),Ee)):null}async releaseDocumentSemanticColoring(U){this._previousResults.delete(U)}static _fixProvidedSemanticTokens(U){return pe._isSemanticTokens(U)?pe._isCorrectSemanticTokens(U)?U:new l.SemanticTokens(new Uint32Array(U.data),U.resultId):pe._isSemanticTokensEdits(U)?pe._isCorrectSemanticTokensEdits(U)?U:new l.SemanticTokensEdits(U.edits.map($=>new l.SemanticTokensEdit($.start,$.deleteCount,$.data?new Uint32Array($.data):$.data)),U.resultId):U}static _isSemanticTokens(U){return U&&!!U.data}static _isCorrectSemanticTokens(U){return U.data instanceof Uint32Array}static _isSemanticTokensEdits(U){return U&&Array.isArray(U.edits)}static _isCorrectSemanticTokensEdits(U){for(const $ of U.edits)if(!($.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(U,$){if(!pe._isSemanticTokens($)||!U||!U.tokens)return $;const K=U.tokens,Q=K.length,de=$.data,Ee=de.length;let Fe=0;const He=Math.min(Q,Ee);for(;Fe<He&&K[Fe]===de[Fe];)Fe++;if(Fe===Q&&Fe===Ee)return new l.SemanticTokensEdits([],$.resultId);let Ke=0;const rt=He-Fe;for(;Ke<rt&&K[Q-Ke-1]===de[Ee-Ke-1];)Ke++;return new l.SemanticTokensEdits([{start:Fe,deleteCount:Q-Fe-Ke,data:de.subarray(Fe,Ee-Ke)}],$.resultId)}_send(U,$){if(pe._isSemanticTokens(U)){const K=this._nextResultId++;return this._previousResults.set(K,new ne(U.resultId,U.data)),(0,f.encodeSemanticTokensDto)({id:K,type:"full",data:U.data})}if(pe._isSemanticTokensEdits(U)){const K=this._nextResultId++;return pe._isSemanticTokens($)?this._previousResults.set(K,new ne($.resultId,$.data)):this._previousResults.set(K,new ne(U.resultId)),(0,f.encodeSemanticTokensDto)({id:K,type:"delta",deltas:(U.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class le{constructor(U,$){this._documents=U,this._provider=$}async provideDocumentRangeSemanticTokens(U,$,K){const Q=this._documents.getDocument(U),de=await this._provider.provideDocumentRangeSemanticTokens(Q,n.Range.to($),K);return de?this._send(de):null}_send(U){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:U.data})}}class we{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,$,K,Q,de){this._documents=U,this._commands=$,this._provider=K,this._apiDeprecation=Q,this._extension=de,this._cache=new t.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(U,$,K,Q){const de=this._documents.getDocument(U),Ee=n.Position.to($),Fe=de.getWordRangeAtPosition(Ee)||new l.Range(Ee,Ee),He=Fe.with({end:Ee}),Ke=new y.StopWatch,rt=await this._provider.provideCompletionItems(de,Ee,Q,n.CompletionContext.to(K));if(!rt||Q.isCancellationRequested)return;const tt=Array.isArray(rt)?new l.CompletionList(rt):rt,it=we.supportsResolving(this._provider)?this._cache.add(tt.items):this._cache.add([]),st=new b.DisposableStore;this._disposables.set(it,st);const Ie=[],Be={x:it,b:Ie,a:{replace:n.Range.from(Fe),insert:n.Range.from(He)},c:tt.isIncomplete||void 0,d:Ke.elapsed()};for(let qe=0;qe<tt.items.length;qe++){const Oe=tt.items[qe],Qe=this._convertCompletionItem(Oe,[it,qe],He,Fe);Ie.push(Qe)}return Be}async resolveCompletionItem(U,$){if(typeof this._provider.resolveCompletionItem!="function")return;const K=this._cache.get(...U);if(!K)return;const Q=this._convertCompletionItem(K,U),de=await this._provider.resolveCompletionItem(K,$);if(!de)return;const Ee=this._convertCompletionItem(de,U);return(Q.h!==Ee.h||Q.i!==Ee.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==Ee.n||Q.o!==Ee.o||!(0,m.equals)(Q.p,Ee.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:Ee.d,c:Ee.c,l:Ee.l,h:Ee.h,i:Ee.i,n:Ee.n,o:Ee.o,p:Ee.p}}releaseCompletionItems(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}_convertCompletionItem(U,$,K,Q){const de=this._disposables.get($[0]);if(!de)throw Error("DisposableStore is missing...");const Ee=this._commands.toInternal(U.command,de),Fe={x:$,a:U.label,b:U.kind!==void 0?n.CompletionItemKind.from(U.kind):void 0,m:U.tags&&U.tags.map(n.CompletionItemTag.from),c:U.detail,d:typeof U.documentation>"u"?void 0:n.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters?.join(""),l:U.additionalTextEdits&&U.additionalTextEdits.map(n.TextEdit.from),n:Ee?.$ident,o:Ee?.id,p:Ee?.$ident?void 0:Ee?.arguments};U.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Fe.h=U.textEdit.newText):typeof U.insertText=="string"?Fe.h=U.insertText:U.insertText instanceof l.SnippetString&&(Fe.h=U.insertText.value,Fe.i|=4);let He;return U.textEdit?He=U.textEdit.range:U.range&&(He=U.range),l.Range.isRange(He)?Fe.j=n.Range.from(He):He&&(!K?.isEqual(He.inserting)||!Q?.isEqual(He.replacing))&&(Fe.j={insert:n.Range.from(He.inserting),replace:n.Range.from(He.replacing)}),Fe}}class Z{async provideInlineCompletions(U,$,K,Q){}disposeCompletions(U){}handleDidShowCompletionItem(U,$,K){}handlePartialAccept(U,$,K,Q){}}class B extends Z{constructor(U,$,K,Q){super(),this._extension=U,this._documents=$,this._provider=K,this._commands=Q,this._references=new ve,this._isAdditionsProposedApiEnabled=(0,o.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[d.InlineCompletionTriggerKind.Automatic]:l.InlineCompletionTriggerKind.Automatic,[d.InlineCompletionTriggerKind.Explicit]:l.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,o.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,$,K,Q){const de=this._documents.getDocument(U),Ee=n.Position.to($),Fe=await this._provider.provideInlineCompletionItems(de,Ee,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:n.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[K.triggerKind]},Q);if(!Fe||Q.isCancellationRequested)return;const He=Array.isArray(Fe)?Fe:Fe.items,Ke=this._isAdditionsProposedApiEnabled?Array.isArray(Fe)?[]:Fe.commands||[]:[],rt=this._isAdditionsProposedApiEnabled&&!Array.isArray(Fe)?Fe.enableForwardStability:void 0;let tt;return{pid:this._references.createReferenceId({dispose(){tt?.dispose()},items:He}),items:He.map((st,Ie)=>{let Be;st.command&&(tt||(tt=new b.DisposableStore),Be=this._commands.toInternal(st.command,tt));const qe=st.insertText;return{insertText:typeof qe=="string"?qe:{snippet:qe.value},filterText:st.filterText,range:st.range?n.Range.from(st.range):void 0,command:Be,idx:Ie,completeBracketPairs:this._isAdditionsProposedApiEnabled?st.completeBracketPairs:!1}}),commands:Ke.map(st=>(tt||(tt=new b.DisposableStore),this._commands.toInternal(st,tt))),suppressSuggestions:!1,enableForwardStability:rt}}disposeCompletions(U){this._references.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,$,K){const Q=this._references.get(U)?.items[$];Q&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(Q,K)}handlePartialAccept(U,$,K,Q){const de=this._references.get(U)?.items[$];de&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&(this._provider.handleDidPartiallyAcceptCompletionItem(de,K),this._provider.handleDidPartiallyAcceptCompletionItem(de,n.PartialAcceptInfo.to(Q)))}}class ee{async provideInlineEdits(U,$,K){const Q=this._documents.getDocument(U),de=await this._provider.provideInlineEdit(Q,{triggerKind:this.languageTriggerKindToVSCodeTriggerKind[$.triggerKind]},K);if(!de||K.isCancellationRequested)return;let Ee;const Fe=this._references.createReferenceId({dispose(){Ee?.dispose()},item:de});let He;de.accepted&&(Ee||(Ee=new b.DisposableStore),He=this._commands.toInternal(de.accepted,Ee));let Ke;return de.rejected&&(Ee||(Ee=new b.DisposableStore),Ke=this._commands.toInternal(de.rejected,Ee)),{pid:Fe,text:de.text,range:n.Range.from(de.range),accepted:He,rejected:Ke}}disposeEdit(U){this._references.disposeReferenceId(U)?.dispose()}constructor(U,$,K,Q){this._documents=$,this._provider=K,this._commands=Q,this._references=new ve,this.languageTriggerKindToVSCodeTriggerKind={[d.InlineEditTriggerKind.Automatic]:l.InlineEditTriggerKind.Automatic,[d.InlineEditTriggerKind.Invoke]:l.InlineEditTriggerKind.Invoke}}}class ve{constructor(){this._references=new Map,this._idPool=1}createReferenceId(U){const $=this._idPool++;return this._references.set($,U),$}disposeReferenceId(U){const $=this._references.get(U);return this._references.delete(U),$}get(U){return this._references.get(U)}}class Pe{constructor(U,$){this._documents=U,this._provider=$,this._cache=new t.Cache("SignatureHelp")}async provideSignatureHelp(U,$,K,Q){const de=this._documents.getDocument(U),Ee=n.Position.to($),Fe=this.reviveContext(K),He=await this._provider.provideSignatureHelp(de,Ee,Q,Fe);if(He){const Ke=this._cache.add([He]);return{...n.SignatureHelp.from(He),id:Ke}}}reviveContext(U){let $;if(U.activeSignatureHelp){const K=n.SignatureHelp.to(U.activeSignatureHelp),Q=this._cache.get(U.activeSignatureHelp.id,0);Q?($=Q,$.activeSignature=K.activeSignature,$.activeParameter=K.activeParameter):$=K}return{...U,activeSignatureHelp:$}}releaseSignatureHelp(U){this._cache.delete(U)}}class oe{constructor(U,$,K,Q,de){this._documents=U,this._commands=$,this._provider=K,this._logService=Q,this._extension=de,this._cache=new t.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(U,$,K){const Q=this._documents.getDocument(U),de=n.Range.to($),Ee=await this._provider.provideInlayHints(Q,de,K);if(!Array.isArray(Ee)||Ee.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify($)}`);return}if(K.isCancellationRequested)return;const Fe=this._cache.add(Ee);this._disposables.set(Fe,new b.DisposableStore);const He={hints:[],cacheId:Fe};for(let Ke=0;Ke<Ee.length;Ke++)this._isValidInlayHint(Ee[Ke],de)&&He.hints.push(this._convertInlayHint(Ee[Ke],[Fe,Ke]));return this._logService.trace(`[InlayHints] ${He.hints.length} inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify($)}`),He}async resolveInlayHint(U,$){if(typeof this._provider.resolveInlayHint!="function")return;const K=this._cache.get(...U);if(!K)return;const Q=await this._provider.resolveInlayHint(K,$);if(Q&&this._isValidInlayHint(Q))return this._convertInlayHint(Q,U)}releaseHints(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}_isValidInlayHint(U,$){return U.label.length===0||Array.isArray(U.label)&&U.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!($&&!$.contains(U.position))}_convertInlayHint(U,$){const K=this._disposables.get($[0]);if(!K)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:$,tooltip:n.MarkdownString.fromStrict(U.tooltip),position:n.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(n.TextEdit.from),kind:U.kind&&n.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")Q.label=U.label;else{const de=[];Q.label=de;for(const Ee of U.label){if(!Ee.value){console.warn("INVALID inlay hint, empty label part",this._extension.identifier.value);continue}const Fe={label:Ee.value,tooltip:n.MarkdownString.fromStrict(Ee.tooltip)};l.Location.isLocation(Ee.location)&&(Fe.location=n.location.from(Ee.location)),Ee.command&&(Fe.command=this._commands.toInternal(Ee.command,K)),de.push(Fe)}}return Q}}class se{constructor(U,$){this._documents=U,this._provider=$,this._cache=new t.Cache("DocumentLink")}async provideLinks(U,$){const K=this._documents.getDocument(U),Q=await this._provider.provideDocumentLinks(K,$);if(!(!Array.isArray(Q)||Q.length===0)&&!$.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:Q.filter(se._validateLink).map(n.DocumentLink.from)};{const de=this._cache.add(Q),Ee={links:[],cacheId:de};for(let Fe=0;Fe<Q.length;Fe++){if(!se._validateLink(Q[Fe]))continue;const He=n.DocumentLink.from(Q[Fe]);He.cacheId=[de,Fe],Ee.links.push(He)}return Ee}}}static _validateLink(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,$){if(typeof this._provider.resolveDocumentLink!="function")return;const K=this._cache.get(...U);if(!K)return;const Q=await this._provider.resolveDocumentLink(K,$);if(!(!Q||!se._validateLink(Q)))return n.DocumentLink.from(Q)}releaseLinks(U){this._cache.delete(U)}}class re{constructor(U,$){this._documents=U,this._provider=$}async provideColors(U,$){const K=this._documents.getDocument(U),Q=await this._provider.provideDocumentColors(K,$);return Array.isArray(Q)?Q.map(Ee=>({color:n.Color.from(Ee.color),range:n.Range.from(Ee.range)})):[]}async provideColorPresentations(U,$,K){const Q=this._documents.getDocument(U),de=n.Range.to($.range),Ee=n.Color.to($.color),Fe=await this._provider.provideColorPresentations(Ee,{document:Q,range:de},K);if(Array.isArray(Fe))return Fe.map(n.ColorPresentation.from)}}class j{constructor(U,$){this._documents=U,this._provider=$}async provideFoldingRanges(U,$,K){const Q=this._documents.getDocument(U),de=await this._provider.provideFoldingRanges(Q,$,K);if(Array.isArray(de))return de.map(n.FoldingRange.from)}}class ie{constructor(U,$,K){this._documents=U,this._provider=$,this._logService=K}async provideSelectionRanges(U,$,K){const Q=this._documents.getDocument(U),de=$.map(n.Position.to),Ee=await this._provider.provideSelectionRanges(Q,de,K);if(!(0,h.isNonEmptyArray)(Ee))return[];if(Ee.length!==de.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Fe=[];for(let He=0;He<de.length;He++){const Ke=[];Fe.push(Ke);let rt=de[He],tt=Ee[He];for(;;){if(!tt.range.contains(rt))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(n.SelectionRange.from(tt)),!tt.parent)break;rt=tt.range,tt=tt.parent}}return Fe}}class me{constructor(U,$){this._documents=U,this._provider=$,this._idPool=new R.IdGenerator(""),this._cache=new Map}async prepareSession(U,$,K){const Q=this._documents.getDocument(U),de=n.Position.to($),Ee=await this._provider.prepareCallHierarchy(Q,de,K);if(!Ee)return;const Fe=this._idPool.nextId();return this._cache.set(Fe,new Map),Array.isArray(Ee)?Ee.map(He=>this._cacheAndConvertItem(Fe,He)):[this._cacheAndConvertItem(Fe,Ee)]}async provideCallsTo(U,$,K){const Q=this._itemFromCache(U,$);if(!Q)throw new Error("missing call hierarchy item");const de=await this._provider.provideCallHierarchyIncomingCalls(Q,K);if(de)return de.map(Ee=>({from:this._cacheAndConvertItem(U,Ee.from),fromRanges:Ee.fromRanges.map(Fe=>n.Range.from(Fe))}))}async provideCallsFrom(U,$,K){const Q=this._itemFromCache(U,$);if(!Q)throw new Error("missing call hierarchy item");const de=await this._provider.provideCallHierarchyOutgoingCalls(Q,K);if(de)return de.map(Ee=>({to:this._cacheAndConvertItem(U,Ee.to),fromRanges:Ee.fromRanges.map(Fe=>n.Range.from(Fe))}))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,$){const K=this._cache.get(U),Q=n.CallHierarchyItem.from($,U,K.size.toString(36));return K.set(Q._itemId,$),Q}_itemFromCache(U,$){return this._cache.get(U)?.get($)}}class be{constructor(U,$){this._documents=U,this._provider=$,this._idPool=new R.IdGenerator(""),this._cache=new Map}async prepareSession(U,$,K){const Q=this._documents.getDocument(U),de=n.Position.to($),Ee=await this._provider.prepareTypeHierarchy(Q,de,K);if(!Ee)return;const Fe=this._idPool.nextId();return this._cache.set(Fe,new Map),Array.isArray(Ee)?Ee.map(He=>this._cacheAndConvertItem(Fe,He)):[this._cacheAndConvertItem(Fe,Ee)]}async provideSupertypes(U,$,K){const Q=this._itemFromCache(U,$);if(!Q)throw new Error("missing type hierarchy item");const de=await this._provider.provideTypeHierarchySupertypes(Q,K);if(de)return de.map(Ee=>this._cacheAndConvertItem(U,Ee))}async provideSubtypes(U,$,K){const Q=this._itemFromCache(U,$);if(!Q)throw new Error("missing type hierarchy item");const de=await this._provider.provideTypeHierarchySubtypes(Q,K);if(de)return de.map(Ee=>this._cacheAndConvertItem(U,Ee))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,$){const K=this._cache.get(U),Q=n.TypeHierarchyItem.from($,U,K.size.toString(36));return K.set(Q._itemId,$),Q}_itemFromCache(U,$){return this._cache.get(U)?.get($)}}class Ae{constructor(U,$,K,Q,de){this._proxy=U,this._documents=$,this._provider=K,this._handle=Q,this._extension=de,this._cache=new t.Cache("DocumentDropEdit")}async provideDocumentOnDropEdits(U,$,K,Q,de){const Ee=this._documents.getDocument($),Fe=n.Position.to(K),He=n.DataTransfer.toDataTransfer(Q,async it=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,U,it)).buffer),Ke=await this._provider.provideDocumentDropEdits(Ee,Fe,He,de);if(!Ke)return;const rt=(0,h.asArray)(Ke),tt=this._cache.add(rt);return rt.map((it,st)=>({_cacheId:[tt,st],title:it.title??(0,a.localize)(1,null,this._extension.displayName||this._extension.name),kind:it.kind?.value,yieldTo:it.yieldTo?.map(Ie=>Ie.value),insertText:typeof it.insertText=="string"?it.insertText:{snippet:it.insertText.value},additionalEdit:it.additionalEdit?n.WorkspaceEdit.from(it.additionalEdit,void 0):void 0}))}async resolveDropEdit(U,$){const[K,Q]=U,de=this._cache.get(K,Q);if(!de||!this._provider.resolveDocumentDropEdit)return{};const Ee=await this._provider.resolveDocumentDropEdit(de,$)??de;return{additionalEdit:Ee.additionalEdit?n.WorkspaceEdit.from(Ee.additionalEdit,void 0):void 0}}releaseDropEdits(U){this._cache.delete(U)}}class fe{constructor(U,$){this._documents=U,this._provider=$}async provideMappedEdits(U,$,K,Q){const de=p.URI.revive(U),Ee=this._documents.getDocument(de),Fe=K.documents.map(rt=>rt.map(tt=>({uri:p.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(it=>n.Range.to(it))}))),He={documents:Fe,selections:Fe[0]?.[0]?.ranges??[]},Ke=await this._provider.provideMappedEdits(Ee,$,He,Q);return Ke?n.WorkspaceEdit.from(Ke):null}}class De{constructor(U,$){this.adapter=U,this.extension=$}}class Te{static{this._handlePool=0}constructor(U,$,K,Q,de,Ee,Fe,He){this._uriTransformer=$,this._documents=K,this._commands=Q,this._diagnostics=de,this._logService=Ee,this._apiDeprecation=Fe,this._extensionTelemetry=He,this._adapter=new Map,this._proxy=U.getProxy(u.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(U,$){return n.DocumentSelector.from(U,this._uriTransformer,$)}_createDisposable(U){return new l.Disposable(()=>{this._adapter.delete(U),this._proxy.$unregister(U)})}_nextHandle(){return Te._handlePool++}async _withAdapter(U,$,K,Q,de,Ee=!1){const Fe=this._adapter.get(U);if(!Fe||!(Fe.adapter instanceof $))return Q;const He=Date.now();Ee||this._logService.trace(`[${Fe.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ke=K(Fe.adapter,Fe.extension);return Promise.resolve(Ke).catch(rt=>{(0,A.isCancellationError)(rt)||(this._logService.error(`[${Fe.extension.identifier.value}] provider FAILED`),this._logService.error(rt),this._extensionTelemetry.onExtensionError(Fe.extension.identifier,rt))}).finally(()=>{Ee||this._logService.trace(`[${Fe.extension.identifier.value}] provider DONE after ${Date.now()-He}ms`)}),L.CancellationToken.isCancellationToken(de)?(0,O.raceCancellationError)(Ke,de):Ke}_addNewAdapter(U,$){const K=this._nextHandle();return this._adapter.set(K,new De(U,$)),K}static _extLabel(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,$,K,Q){const de=this._addNewAdapter(new r(this._documents,K),U),Ee=Q&&Q.label||Te._extLabel(U);return this._proxy.$registerDocumentSymbolProvider(de,this._transformDocumentSelector($,U),Ee),this._createDisposable(de)}$provideDocumentSymbols(U,$,K){return this._withAdapter(U,r,Q=>Q.provideDocumentSymbols(p.URI.revive($),K),void 0,K)}registerCodeLensProvider(U,$,K){const Q=this._nextHandle(),de=typeof K.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(Q,new De(new c(this._documents,this._commands.converter,K,U,this._extensionTelemetry,this._logService),U)),this._proxy.$registerCodeLensSupport(Q,this._transformDocumentSelector($,U),de);let Ee=this._createDisposable(Q);if(de!==void 0){const Fe=K.onDidChangeCodeLenses(He=>this._proxy.$emitCodeLensEvent(de));Ee=l.Disposable.from(Ee,Fe)}return Ee}$provideCodeLenses(U,$,K){return this._withAdapter(U,c,Q=>Q.provideCodeLenses(p.URI.revive($),K),void 0,K)}$resolveCodeLens(U,$,K){return this._withAdapter(U,c,Q=>Q.resolveCodeLens($,K),void 0,void 0)}$releaseCodeLenses(U,$){this._withAdapter(U,c,K=>Promise.resolve(K.releaseCodeLenses($)),void 0,void 0)}registerDefinitionProvider(U,$,K){const Q=this._addNewAdapter(new w(this._documents,K),U);return this._proxy.$registerDefinitionSupport(Q,this._transformDocumentSelector($,U)),this._createDisposable(Q)}$provideDefinition(U,$,K,Q){return this._withAdapter(U,w,de=>de.provideDefinition(p.URI.revive($),K,Q),[],Q)}registerDeclarationProvider(U,$,K){const Q=this._addNewAdapter(new g(this._documents,K),U);return this._proxy.$registerDeclarationSupport(Q,this._transformDocumentSelector($,U)),this._createDisposable(Q)}$provideDeclaration(U,$,K,Q){return this._withAdapter(U,g,de=>de.provideDeclaration(p.URI.revive($),K,Q),[],Q)}registerImplementationProvider(U,$,K){const Q=this._addNewAdapter(new D(this._documents,K),U);return this._proxy.$registerImplementationSupport(Q,this._transformDocumentSelector($,U)),this._createDisposable(Q)}$provideImplementation(U,$,K,Q){return this._withAdapter(U,D,de=>de.provideImplementation(p.URI.revive($),K,Q),[],Q)}registerTypeDefinitionProvider(U,$,K){const Q=this._addNewAdapter(new v(this._documents,K),U);return this._proxy.$registerTypeDefinitionSupport(Q,this._transformDocumentSelector($,U)),this._createDisposable(Q)}$provideTypeDefinition(U,$,K,Q){return this._withAdapter(U,v,de=>de.provideTypeDefinition(p.URI.revive($),K,Q),[],Q)}registerHoverProvider(U,$,K,Q){const de=this._addNewAdapter(new _(this._documents,K),U);return this._proxy.$registerHoverProvider(de,this._transformDocumentSelector($,U)),this._createDisposable(de)}$provideHover(U,$,K,Q,de){return this._withAdapter(U,_,Ee=>Ee.provideHover(p.URI.revive($),K,Q,de),void 0,de)}$releaseHover(U,$){this._withAdapter(U,_,K=>Promise.resolve(K.releaseHover($)),void 0,void 0)}registerEvaluatableExpressionProvider(U,$,K,Q){const de=this._addNewAdapter(new C(this._documents,K),U);return this._proxy.$registerEvaluatableExpressionProvider(de,this._transformDocumentSelector($,U)),this._createDisposable(de)}$provideEvaluatableExpression(U,$,K,Q){return this._withAdapter(U,C,de=>de.provideEvaluatableExpression(p.URI.revive($),K,Q),void 0,Q)}registerInlineValuesProvider(U,$,K,Q){const de=typeof K.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Ee=this._addNewAdapter(new P(this._documents,K),U);this._proxy.$registerInlineValuesProvider(Ee,this._transformDocumentSelector($,U),de);let Fe=this._createDisposable(Ee);if(de!==void 0){const He=K.onDidChangeInlineValues(Ke=>this._proxy.$emitInlineValuesEvent(de));Fe=l.Disposable.from(Fe,He)}return Fe}$provideInlineValues(U,$,K,Q,de){return this._withAdapter(U,P,Ee=>Ee.provideInlineValues(p.URI.revive($),K,Q,de),void 0,de)}registerDocumentHighlightProvider(U,$,K){const Q=this._addNewAdapter(new k(this._documents,K),U);return this._proxy.$registerDocumentHighlightProvider(Q,this._transformDocumentSelector($,U)),this._createDisposable(Q)}registerMultiDocumentHighlightProvider(U,$,K){const Q=this._addNewAdapter(new F(this._documents,K),U);return this._proxy.$registerMultiDocumentHighlightProvider(Q,this._transformDocumentSelector($,U)),this._createDisposable(Q)}$provideDocumentHighlights(U,$,K,Q){return this._withAdapter(U,k,de=>de.provideDocumentHighlights(p.URI.revive($),K,Q),void 0,Q)}$provideMultiDocumentHighlights(U,$,K,Q,de){return this._withAdapter(U,F,Ee=>Ee.provideMultiDocumentHighlights(p.URI.revive($),K,Q.map(Fe=>p.URI.revive(Fe)),de),void 0,de)}registerLinkedEditingRangeProvider(U,$,K){const Q=this._addNewAdapter(new x(this._documents,K),U);return this._proxy.$registerLinkedEditingRangeProvider(Q,this._transformDocumentSelector($,U)),this._createDisposable(Q)}$provideLinkedEditingRanges(U,$,K,Q){return this._withAdapter(U,x,async de=>{const Ee=await de.provideLinkedEditingRanges(p.URI.revive($),K,Q);if(Ee)return{ranges:Ee.ranges,wordPattern:Ee.wordPattern?Te._serializeRegExp(Ee.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(U,$,K){const Q=this._addNewAdapter(new z(this._documents,K),U);return this._proxy.$registerReferenceSupport(Q,this._transformDocumentSelector($,U)),this._createDisposable(Q)}$provideReferences(U,$,K,Q,de){return this._withAdapter(U,z,Ee=>Ee.provideReferences(p.URI.revive($),K,Q,de),void 0,de)}registerCodeActionProvider(U,$,K,Q){const de=new b.DisposableStore,Ee=this._addNewAdapter(new N(this._documents,this._commands.converter,this._diagnostics,K,this._logService,U,this._apiDeprecation),U);return this._proxy.$registerQuickFixSupport(Ee,this._transformDocumentSelector($,U),{providedKinds:Q?.providedCodeActionKinds?.map(Fe=>Fe.value),documentation:Q?.documentation?.map(Fe=>({kind:Fe.kind.value,command:this._commands.converter.toInternal(Fe.command,de)}))},Te._extLabel(U),!!K.resolveCodeAction),de.add(this._createDisposable(Ee)),de}$provideCodeActions(U,$,K,Q,de){return this._withAdapter(U,N,Ee=>Ee.provideCodeActions(p.URI.revive($),K,Q,de),void 0,de)}$resolveCodeAction(U,$,K){return this._withAdapter(U,N,Q=>Q.resolveCodeAction($,K),{},void 0)}$releaseCodeActions(U,$){this._withAdapter(U,N,K=>Promise.resolve(K.releaseCodeActions($)),void 0,void 0)}registerDocumentFormattingEditProvider(U,$,K){const Q=this._addNewAdapter(new W(this._documents,K),U);return this._proxy.$registerDocumentFormattingSupport(Q,this._transformDocumentSelector($,U),U.identifier,U.displayName||U.name),this._createDisposable(Q)}$provideDocumentFormattingEdits(U,$,K,Q){return this._withAdapter(U,W,de=>de.provideDocumentFormattingEdits(p.URI.revive($),K,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(U,$,K){const Q=typeof K.provideDocumentRangesFormattingEdits=="function",de=this._addNewAdapter(new X(this._documents,K),U);return this._proxy.$registerRangeFormattingSupport(de,this._transformDocumentSelector($,U),U.identifier,U.displayName||U.name,Q),this._createDisposable(de)}$provideDocumentRangeFormattingEdits(U,$,K,Q,de){return this._withAdapter(U,X,Ee=>Ee.provideDocumentRangeFormattingEdits(p.URI.revive($),K,Q,de),void 0,de)}$provideDocumentRangesFormattingEdits(U,$,K,Q,de){return this._withAdapter(U,X,Ee=>Ee.provideDocumentRangesFormattingEdits(p.URI.revive($),K,Q,de),void 0,de)}registerOnTypeFormattingEditProvider(U,$,K,Q){const de=this._addNewAdapter(new te(this._documents,K),U);return this._proxy.$registerOnTypeFormattingSupport(de,this._transformDocumentSelector($,U),Q,U.identifier),this._createDisposable(de)}$provideOnTypeFormattingEdits(U,$,K,Q,de,Ee){return this._withAdapter(U,te,Fe=>Fe.provideOnTypeFormattingEdits(p.URI.revive($),K,Q,de,Ee),void 0,Ee)}registerWorkspaceSymbolProvider(U,$){const K=this._addNewAdapter(new H($,this._logService),U);return this._proxy.$registerNavigateTypeSupport(K,typeof $.resolveWorkspaceSymbol=="function"),this._createDisposable(K)}$provideWorkspaceSymbols(U,$,K){return this._withAdapter(U,H,Q=>Q.provideWorkspaceSymbols($,K),{symbols:[]},K)}$resolveWorkspaceSymbol(U,$,K){return this._withAdapter(U,H,Q=>Q.resolveWorkspaceSymbol($,K),void 0,void 0)}$releaseWorkspaceSymbols(U,$){this._withAdapter(U,H,K=>K.releaseWorkspaceSymbols($),void 0,void 0)}registerRenameProvider(U,$,K){const Q=this._addNewAdapter(new G(this._documents,K,this._logService),U);return this._proxy.$registerRenameSupport(Q,this._transformDocumentSelector($,U),G.supportsResolving(K)),this._createDisposable(Q)}$provideRenameEdits(U,$,K,Q,de){return this._withAdapter(U,G,Ee=>Ee.provideRenameEdits(p.URI.revive($),K,Q,de),void 0,de)}$resolveRenameLocation(U,$,K,Q){return this._withAdapter(U,G,de=>de.resolveRenameLocation(p.URI.revive($),K,Q),void 0,Q)}registerNewSymbolNamesProvider(U,$,K){const Q=this._addNewAdapter(new Y(this._documents,K,this._logService),U);return this._proxy.$registerNewSymbolNamesProvider(Q,this._transformDocumentSelector($,U)),this._createDisposable(Q)}$supportsAutomaticNewSymbolNamesTriggerKind(U){return this._withAdapter(U,Y,$=>$.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(U,$,K,Q,de){return this._withAdapter(U,Y,Ee=>Ee.provideNewSymbolNames(p.URI.revive($),K,Q,de),void 0,de)}registerDocumentSemanticTokensProvider(U,$,K,Q){const de=this._addNewAdapter(new pe(this._documents,K),U),Ee=typeof K.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(de,this._transformDocumentSelector($,U),Q,Ee);let Fe=this._createDisposable(de);if(Ee){const He=K.onDidChangeSemanticTokens(Ke=>this._proxy.$emitDocumentSemanticTokensEvent(Ee));Fe=l.Disposable.from(Fe,He)}return Fe}$provideDocumentSemanticTokens(U,$,K,Q){return this._withAdapter(U,pe,de=>de.provideDocumentSemanticTokens(p.URI.revive($),K,Q),null,Q)}$releaseDocumentSemanticTokens(U,$){this._withAdapter(U,pe,K=>K.releaseDocumentSemanticColoring($),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,$,K,Q){const de=this._addNewAdapter(new le(this._documents,K),U);return this._proxy.$registerDocumentRangeSemanticTokensProvider(de,this._transformDocumentSelector($,U),Q),this._createDisposable(de)}$provideDocumentRangeSemanticTokens(U,$,K,Q){return this._withAdapter(U,le,de=>de.provideDocumentRangeSemanticTokens(p.URI.revive($),K,Q),null,Q)}registerCompletionItemProvider(U,$,K,Q){const de=this._addNewAdapter(new we(this._documents,this._commands.converter,K,this._apiDeprecation,U),U);return this._proxy.$registerCompletionsProvider(de,this._transformDocumentSelector($,U),Q,we.supportsResolving(K),U.identifier),this._createDisposable(de)}$provideCompletionItems(U,$,K,Q,de){return this._withAdapter(U,we,Ee=>Ee.provideCompletionItems(p.URI.revive($),K,Q,de),void 0,de)}$resolveCompletionItem(U,$,K){return this._withAdapter(U,we,Q=>Q.resolveCompletionItem($,K),void 0,K)}$releaseCompletionItems(U,$){this._withAdapter(U,we,K=>K.releaseCompletionItems($),void 0,void 0)}registerInlineCompletionsProvider(U,$,K,Q){const de=new B(U,this._documents,K,this._commands.converter),Ee=this._addNewAdapter(de,U);return this._proxy.$registerInlineCompletionsSupport(Ee,this._transformDocumentSelector($,U),de.supportsHandleEvents,i.ExtensionIdentifier.toKey(U.identifier.value),Q?.yieldTo?.map(Fe=>i.ExtensionIdentifier.toKey(Fe))||[]),this._createDisposable(Ee)}$provideInlineCompletions(U,$,K,Q,de){return this._withAdapter(U,Z,Ee=>Ee.provideInlineCompletions(p.URI.revive($),K,Q,de),void 0,de)}$handleInlineCompletionDidShow(U,$,K,Q){this._withAdapter(U,Z,async de=>{de.handleDidShowCompletionItem($,K,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,$,K,Q,de){this._withAdapter(U,Z,async Ee=>{Ee.handlePartialAccept($,K,Q,de)},void 0,void 0)}$freeInlineCompletionsList(U,$){this._withAdapter(U,Z,async K=>{K.disposeCompletions($)},void 0,void 0)}registerInlineEditProvider(U,$,K){const Q=new ee(U,this._documents,K,this._commands.converter),de=this._addNewAdapter(Q,U);return this._proxy.$registerInlineEditProvider(de,this._transformDocumentSelector($,U),U.identifier),this._createDisposable(de)}$provideInlineEdit(U,$,K,Q){return this._withAdapter(U,ee,de=>de.provideInlineEdits(p.URI.revive($),K,Q),void 0,Q)}$freeInlineEdit(U,$){this._withAdapter(U,ee,async K=>{K.disposeEdit($)},void 0,void 0)}registerSignatureHelpProvider(U,$,K,Q){const de=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,Ee=this._addNewAdapter(new Pe(this._documents,K),U);return this._proxy.$registerSignatureHelpProvider(Ee,this._transformDocumentSelector($,U),de),this._createDisposable(Ee)}$provideSignatureHelp(U,$,K,Q,de){return this._withAdapter(U,Pe,Ee=>Ee.provideSignatureHelp(p.URI.revive($),K,Q,de),void 0,de)}$releaseSignatureHelp(U,$){this._withAdapter(U,Pe,K=>K.releaseSignatureHelp($),void 0,void 0)}registerInlayHintsProvider(U,$,K){const Q=typeof K.onDidChangeInlayHints=="function"?this._nextHandle():void 0,de=this._addNewAdapter(new oe(this._documents,this._commands.converter,K,this._logService,U),U);this._proxy.$registerInlayHintsProvider(de,this._transformDocumentSelector($,U),typeof K.resolveInlayHint=="function",Q,Te._extLabel(U));let Ee=this._createDisposable(de);if(Q!==void 0){const Fe=K.onDidChangeInlayHints(He=>this._proxy.$emitInlayHintsEvent(Q));Ee=l.Disposable.from(Ee,Fe)}return Ee}$provideInlayHints(U,$,K,Q){return this._withAdapter(U,oe,de=>de.provideInlayHints(p.URI.revive($),K,Q),void 0,Q)}$resolveInlayHint(U,$,K){return this._withAdapter(U,oe,Q=>Q.resolveInlayHint($,K),void 0,K)}$releaseInlayHints(U,$){this._withAdapter(U,oe,K=>K.releaseHints($),void 0,void 0)}registerDocumentLinkProvider(U,$,K){const Q=this._addNewAdapter(new se(this._documents,K),U);return this._proxy.$registerDocumentLinkProvider(Q,this._transformDocumentSelector($,U),typeof K.resolveDocumentLink=="function"),this._createDisposable(Q)}$provideDocumentLinks(U,$,K){return this._withAdapter(U,se,Q=>Q.provideLinks(p.URI.revive($),K),void 0,K,$.scheme==="output")}$resolveDocumentLink(U,$,K){return this._withAdapter(U,se,Q=>Q.resolveLink($,K),void 0,void 0,!0)}$releaseDocumentLinks(U,$){this._withAdapter(U,se,K=>K.releaseLinks($),void 0,void 0,!0)}registerColorProvider(U,$,K){const Q=this._addNewAdapter(new re(this._documents,K),U);return this._proxy.$registerDocumentColorProvider(Q,this._transformDocumentSelector($,U)),this._createDisposable(Q)}$provideDocumentColors(U,$,K){return this._withAdapter(U,re,Q=>Q.provideColors(p.URI.revive($),K),[],K)}$provideColorPresentations(U,$,K,Q){return this._withAdapter(U,re,de=>de.provideColorPresentations(p.URI.revive($),K,Q),void 0,Q)}registerFoldingRangeProvider(U,$,K){const Q=this._nextHandle(),de=typeof K.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(Q,new De(new j(this._documents,K),U)),this._proxy.$registerFoldingRangeProvider(Q,this._transformDocumentSelector($,U),U.identifier,de);let Ee=this._createDisposable(Q);if(de!==void 0){const Fe=K.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(de));Ee=l.Disposable.from(Ee,Fe)}return Ee}$provideFoldingRanges(U,$,K,Q){return this._withAdapter(U,j,de=>de.provideFoldingRanges(p.URI.revive($),K,Q),void 0,Q)}registerSelectionRangeProvider(U,$,K){const Q=this._addNewAdapter(new ie(this._documents,K,this._logService),U);return this._proxy.$registerSelectionRangeProvider(Q,this._transformDocumentSelector($,U)),this._createDisposable(Q)}$provideSelectionRanges(U,$,K,Q){return this._withAdapter(U,ie,de=>de.provideSelectionRanges(p.URI.revive($),K,Q),[],Q)}registerCallHierarchyProvider(U,$,K){const Q=this._addNewAdapter(new me(this._documents,K),U);return this._proxy.$registerCallHierarchyProvider(Q,this._transformDocumentSelector($,U)),this._createDisposable(Q)}$prepareCallHierarchy(U,$,K,Q){return this._withAdapter(U,me,de=>Promise.resolve(de.prepareSession(p.URI.revive($),K,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(U,$,K,Q){return this._withAdapter(U,me,de=>de.provideCallsTo($,K,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(U,$,K,Q){return this._withAdapter(U,me,de=>de.provideCallsFrom($,K,Q),void 0,Q)}$releaseCallHierarchy(U,$){this._withAdapter(U,me,K=>Promise.resolve(K.releaseSession($)),void 0,void 0)}registerTypeHierarchyProvider(U,$,K){const Q=this._addNewAdapter(new be(this._documents,K),U);return this._proxy.$registerTypeHierarchyProvider(Q,this._transformDocumentSelector($,U)),this._createDisposable(Q)}$prepareTypeHierarchy(U,$,K,Q){return this._withAdapter(U,be,de=>Promise.resolve(de.prepareSession(p.URI.revive($),K,Q)),void 0,Q)}$provideTypeHierarchySupertypes(U,$,K,Q){return this._withAdapter(U,be,de=>de.provideSupertypes($,K,Q),void 0,Q)}$provideTypeHierarchySubtypes(U,$,K,Q){return this._withAdapter(U,be,de=>de.provideSubtypes($,K,Q),void 0,Q)}$releaseTypeHierarchy(U,$){this._withAdapter(U,be,K=>Promise.resolve(K.releaseSession($)),void 0,void 0)}registerDocumentOnDropEditProvider(U,$,K,Q){const de=this._nextHandle();return this._adapter.set(de,new De(new Ae(this._proxy,this._documents,K,de,U),U)),this._proxy.$registerDocumentOnDropEditProvider(de,this._transformDocumentSelector($,U),(0,o.isProposedApiEnabled)(U,"documentPaste")&&Q?{supportsResolve:!!K.resolveDocumentDropEdit,dropMimeTypes:Q.dropMimeTypes}:void 0),this._createDisposable(de)}$provideDocumentOnDropEdits(U,$,K,Q,de,Ee){return this._withAdapter(U,Ae,Fe=>Promise.resolve(Fe.provideDocumentOnDropEdits($,p.URI.revive(K),Q,de,Ee)),void 0,void 0)}$resolveDropEdit(U,$,K){return this._withAdapter(U,Ae,Q=>Q.resolveDropEdit($,K),{},void 0)}$releaseDropEdits(U,$){this._withAdapter(U,Ae,K=>Promise.resolve(K.releaseDropEdits($)),void 0,void 0)}registerMappedEditsProvider(U,$,K){const Q=this._addNewAdapter(new fe(this._documents,K),U);return this._proxy.$registerMappedEditsProvider(Q,this._transformDocumentSelector($,U)),this._createDisposable(Q)}$provideMappedEdits(U,$,K,Q,de){return this._withAdapter(U,fe,Ee=>Promise.resolve(Ee.provideMappedEdits($,K,Q,de)),null,de)}registerDocumentPasteEditProvider(U,$,K,Q){const de=this._nextHandle();return this._adapter.set(de,new De(new M(this._proxy,this._documents,K,de,U),U)),this._proxy.$registerPasteEditProvider(de,this._transformDocumentSelector($,U),{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,supportsResolve:!!K.resolveDocumentPasteEdit,providedPasteEditKinds:Q.providedPasteEditKinds?.map(Ee=>Ee.value),copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this._createDisposable(de)}$prepareDocumentPaste(U,$,K,Q,de){return this._withAdapter(U,M,Ee=>Ee.prepareDocumentPaste(p.URI.revive($),K,Q,de),void 0,de)}$providePasteEdits(U,$,K,Q,de,Ee,Fe){return this._withAdapter(U,M,He=>He.providePasteEdits($,p.URI.revive(K),Q,de,Ee,Fe),void 0,Fe)}$resolvePasteEdit(U,$,K){return this._withAdapter(U,M,Q=>Q.resolvePasteEdit($,K),{},void 0)}$releasePasteEdits(U,$){this._withAdapter(U,M,K=>Promise.resolve(K.releasePasteEdits($)),void 0,void 0)}static _serializeRegExp(U){return{pattern:U.source,flags:U.flags}}static _serializeIndentationRule(U){return{decreaseIndentPattern:Te._serializeRegExp(U.decreaseIndentPattern),increaseIndentPattern:Te._serializeRegExp(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Te._serializeRegExp(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Te._serializeRegExp(U.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(U){return{beforeText:Te._serializeRegExp(U.beforeText),afterText:U.afterText?Te._serializeRegExp(U.afterText):void 0,previousLineText:U.previousLineText?Te._serializeRegExp(U.previousLineText):void 0,action:U.action}}static _serializeOnEnterRules(U){return U.map(Te._serializeOnEnterRule)}static _serializeAutoClosingPair(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map($=>l.SyntaxTokenType.toString($)):void 0}}static _serializeAutoClosingPairs(U){return U.map(Te._serializeAutoClosingPair)}setLanguageConfiguration(U,$,K){const{wordPattern:Q}=K;if(Q&&(0,T.regExpLeadsToEndlessLoop)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this._documents.setWordDefinitionFor($,Q):this._documents.setWordDefinitionFor($,void 0),K.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),K.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const de=this._nextHandle(),Ee={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Te._serializeRegExp(K.wordPattern):void 0,indentationRules:K.indentationRules?Te._serializeIndentationRule(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Te._serializeOnEnterRules(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Te._serializeAutoClosingPairs(K.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(de,$,Ee),this._createDisposable(de)}$setWordDefinitions(U){for(const $ of U)this._documents.setWordDefinitionFor($.languageId,new RegExp($.regexSource,$.regexFlags))}}e.ExtHostLanguageFeatures=Te}),define(_e[122],Ce([1,0,3,6,16,8,109,25,7,4,227,146,13,5,20,121,11,39]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageModels=e.IExtHostLanguageModels=void 0,e.IExtHostLanguageModels=(0,S.createDecorator)("IExtHostLanguageModels");class n{constructor(u,r){this.option=u,this.stream=new m.AsyncIterableSource,this.stream=r??new m.AsyncIterableSource}}class l{constructor(){this._responseStreams=new Map,this._defaultStream=new m.AsyncIterableSource,this._isDone=!1,this._isStreaming=!1;const u=this;this.apiObject={stream:u._defaultStream.asyncIterable}}*_streams(){if(this._responseStreams.size>0)for(const[,u]of this._responseStreams)yield u.stream;else yield this._defaultStream}handleFragment(u){if(this._isDone)return;this._isStreaming=!0;let r=this._responseStreams.get(u.index);r||(this._responseStreams.size===0?r=new n(u.index,this._defaultStream):r=new n(u.index),this._responseStreams.set(u.index,r)),r.stream.emitOne(u.part)}get isStreaming(){return this._isStreaming}reject(u){this._isDone=!0;for(const r of this._streams())r.reject(u)}resolve(){this._isDone=!0;for(const u of this._streams())u.resolve()}}let o=class{static{i=this}static{this._idPool=1}constructor(u,r,c){this._logService=r,this._extHostAuthentication=c,this._onDidChangeModelAccess=new y.Emitter,this._onDidChangeProviders=new y.Emitter,this.onDidChangeProviders=this._onDidChangeProviders.event,this._languageModels=new Map,this._allLanguageModelData=new Map,this._modelAccessList=new b.ExtensionIdentifierMap,this._pendingRequest=new Map,this._languageAccessInformationExtensions=new Set,this._proxy=u.getProxy(O.MainContext.MainThreadLanguageModels)}dispose(){this._onDidChangeModelAccess.dispose(),this._onDidChangeProviders.dispose()}registerLanguageModel(u,r,c,s){const w=i._idPool++;this._languageModels.set(w,{extension:u.identifier,provider:c,languageModelId:r});let g;s.auth&&(g={providerLabel:u.displayName||u.name,accountLabel:typeof s.auth=="object"?s.auth.label:void 0}),this._proxy.$registerLanguageModelProvider(w,r,{extension:u.identifier,identifier:r,name:s.name??"",version:s.version,tokens:s.tokens,auth:g});const D=c.onDidReceiveLanguageModelResponse2?.(({extensionId:v,participant:_,tokenCount:C})=>{this._proxy.$whenLanguageModelChatRequestMade(r,new b.ExtensionIdentifier(v),_,C)});return(0,h.toDisposable)(()=>{this._languageModels.delete(w),this._proxy.$unregisterProvider(w),D?.dispose()})}async $provideLanguageModelResponse(u,r,c,s,w,g){const D=this._languageModels.get(u);if(!D)return;const v=new R.Progress(async _=>{if(g.isCancellationRequested){this._logService.warn(`[CHAT](${D.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this._proxy.$handleProgressChunk(r,{index:_.index,part:_.part})});return D.provider.provideLanguageModelResponse2(s.map(L.LanguageModelMessage.to),w,b.ExtensionIdentifier.toKey(c),v,g)}$provideTokenLength(u,r,c){const s=this._languageModels.get(u);return s?Promise.resolve(s.provider.provideTokenCount(r,c)):Promise.resolve(0)}$updateLanguageModels(u){const r=[],c=[];if(u.added)for(const s of u.added)this._allLanguageModelData.set(s.identifier,s),r.push(s.identifier);if(u.removed)for(const s of u.removed){this._allLanguageModelData.delete(s),c.push(s);for(const[w,g]of this._pendingRequest)g.languageModelId===s&&(g.res.reject(new p.CancellationError),this._pendingRequest.delete(w))}this._onDidChangeProviders.fire(Object.freeze({added:Object.freeze(r),removed:Object.freeze(c)})),u.added?.forEach(this._fakeAuthPopulate,this)}getLanguageModelIds(){return Array.from(this._allLanguageModelData.keys())}$updateModelAccesslist(u){const r=new Array;for(const{from:c,to:s,enabled:w}of u){const g=this._modelAccessList.get(c)??new b.ExtensionIdentifierSet;if(g.has(s)!==w){w?g.add(s):g.delete(s),this._modelAccessList.set(c,g);const v={from:c,to:s};r.push(v),this._onDidChangeModelAccess.fire(v)}}}async sendChatRequest(u,r,c,s,w){const g=u.identifier,D=await this._proxy.$prepareChatAccess(g,r,s.justification);if(!D||!this._allLanguageModelData.has(r))throw A.LanguageModelError.NotFound(`Language model '${r}' is unknown.`);if(this._isUsingAuth(g,D)&&(!await this._getAuthAccess(u,{identifier:D.extension,displayName:D.auth.providerLabel},s.justification,s.silent)||!this._modelAccessList.get(g)?.has(D.extension)))throw A.LanguageModelError.NoPermissions(`Language model '${r}' cannot be used by '${g.value}'.`);const v=Math.random()*1e6|0,_=this._proxy.$fetchResponse(g,r,v,c.map(L.LanguageModelMessage.from),s.modelOptions??{},w),C=new m.Barrier,P=new l;this._pendingRequest.set(v,{languageModelId:r,res:P});let k;if(_.catch(F=>{C.isOpen()?P.reject(F):k=F}).finally(()=>{this._pendingRequest.delete(v),P.resolve(),C.open()}),await C.wait(),k)throw new A.LanguageModelError(`Language model '${r}' errored, check cause for more details`,"Unknown",k);return P.apiObject}async $handleResponseFragment(u,r){const c=this._pendingRequest.get(u);c&&c.res.handleFragment(r)}async _getAuthAccess(u,r,c,s){const w=I.INTERNAL_AUTH_PROVIDER_PREFIX+r.identifier.value;if(await this._extHostAuthentication.getSession(u,w,[],{silent:!0}))return this.$updateModelAccesslist([{from:u.identifier,to:r.identifier,enabled:!0}]),!0;if(s)return!1;try{const D=c?(0,T.localize)(0,null,r.displayName,c):(0,T.localize)(1,null,r.displayName);return await this._extHostAuthentication.getSession(u,w,[],{forceNewSession:{detail:D}}),this.$updateModelAccesslist([{from:u.identifier,to:r.identifier,enabled:!0}]),!0}catch{return!1}}_isUsingAuth(u,r){return!!r.auth&&!b.ExtensionIdentifier.equals(r.extension,u)}async _fakeAuthPopulate(u){for(const r of this._languageAccessInformationExtensions)try{await this._getAuthAccess(r,{identifier:u.extension,displayName:""},void 0,!0)}catch(c){this._logService.error("Fake Auth request failed"),this._logService.error(c)}}async computeTokenLength(u,r,c){const s=this._allLanguageModelData.get(u);if(!s)throw A.LanguageModelError.NotFound(`Language model '${u}' is unknown.`);const w=a.Iterable.find(this._languageModels.values(),g=>g.languageModelId===u);return w?w.provider.provideTokenCount(r,c):this._proxy.$countTokens(s.identifier,typeof r=="string"?r:L.LanguageModelMessage.from(r),c)}getLanguageModelInfo(u){const r=this._allLanguageModelData.get(u);if(r)return{id:r.identifier,name:r.name,version:r.version,tokens:r.tokens}}createLanguageModelAccessInformation(u){this._languageAccessInformationExtensions.add(u);const r=this,c=y.Event.signal(y.Event.filter(this._onDidChangeModelAccess.event,w=>b.ExtensionIdentifier.equals(w.from,u.identifier))),s=y.Event.signal(this._onDidChangeProviders.event);return{get onDidChange(){return y.Event.any(c,s)},canSendRequest(w){const g=r._allLanguageModelData.get(w);if(!g)return;if(!r._isUsingAuth(u.identifier,g))return!0;const D=r._modelAccessList.get(u.identifier);if(D)return D.has(g.extension)}}}};e.ExtHostLanguageModels=o,e.ExtHostLanguageModels=o=i=Ge([Ue(0,E.IExtHostRpcService),Ue(1,f.ILogService),Ue(2,d.IExtHostAuthentication)],o)}),define(_e[344],Ce([1,0,6,16,8,41,7,3,26]),function(ue,e,h,O,L,A,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(I,p,S,E){this._documents=p,this._commands=S,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=I.getProxy(h.MainContext.MainThreadLanguages)}$acceptLanguageIds(I){this._languageIds=I}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(I,p){await this._proxy.$changeLanguage(I,p);const S=this._documents.getDocumentData(I);if(!S)throw new Error(`document '${I.toString()}' NOT found`);return S.document}async tokenAtPosition(I,p){const S=I.version,E=O.Position.from(p),d=await this._proxy.$tokensAtPosition(I.uri,E),f={type:L.StandardTokenType.Other,range:I.getWordRangeAtPosition(p)??new L.Range(p.line,p.character,p.line,p.character)};if(!d)return f;const a={range:O.Range.to(d.range),type:O.TokenType.to(d.type)};return!a.range.contains(p)||S!==I.version?f:a}createLanguageStatusItem(I,p,S){const E=this._handlePool++,d=this._proxy,f=this._ids,a=`${I.identifier.value}/${p}`;if(f.has(a))throw new Error(`LanguageStatusItem with id '${p}' ALREADY exists`);f.add(a);const i={selector:S,id:p,name:I.displayName??I.name,severity:L.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const l=new b.DisposableStore,o=()=>{if(n?.dispose(),!f.has(a)){console.warn(`LanguageStatusItem (${p}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.disposableTimeout)(()=>{l.clear(),this._proxy.$setLanguageStatus(E,{id:a,name:i.name??I.displayName??I.name,source:I.displayName??I.name,selector:O.DocumentSelector.from(i.selector,this._uriTransformer),label:i.text,detail:i.detail??"",severity:i.severity===L.LanguageStatusSeverity.Error?A.default.Error:i.severity===L.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:i.command&&this._commands.toInternal(i.command,l),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){l.dispose(),n?.dispose(),d.$removeLanguageStatus(E),f.delete(a)},get id(){return i.id},get name(){return i.name},set name(u){i.name=u,o()},get selector(){return i.selector},set selector(u){i.selector=u,o()},get text(){return i.text},set text(u){i.text=u,o()},set text2(u){(0,m.checkProposedApiEnabled)(I,"languageStatusText"),i.text=u,o()},get text2(){return(0,m.checkProposedApiEnabled)(I,"languageStatusText"),i.text},get detail(){return i.detail},set detail(u){i.detail=u,o()},get severity(){return i.severity},set severity(u){i.severity=u,o()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(u){i.accessibilityInformation=u,o()},get command(){return i.command},set command(u){i.command=u,o()},get busy(){return i.busy},set busy(u){i.busy=u,o()}};return o(),t}}e.ExtHostLanguages=y}),define(_e[345],Ce([1,0,15,2,16,8,120]),function(ue,e,h,O,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class b{constructor(I,p,S,E){this.start=I,this.deletedCount=p,this.deletedItems=S,this.items=E}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(I){return{EOL:I.eol,lines:I.source,languageId:I.language,uri:I.uri,isDirty:!1,versionId:1}}constructor(I,p,S){this.notebook=I,this._extHostDocument=p,this._cellData=S,this.handle=S.handle,this.uri=O.URI.revive(S.uri),this.cellKind=S.cellKind,this._outputs=S.outputs.map(L.NotebookCellOutput.to),this._internalMetadata=S.internalMetadata??{},this._metadata=Object.freeze(S.metadata??{}),this._previousResult=Object.freeze(L.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const I=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:L.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get mime(){return I._mime},set mime(E){I._mime=E},get outputs(){return I._outputs.slice(0)},get metadata(){return I._metadata},get executionSummary(){return I._previousResult}};this._apiCell=Object.freeze(S)}return this._apiCell}setOutputs(I){this._outputs=I.map(L.NotebookCellOutput.to)}setOutputItems(I,p,S){const E=S.map(L.NotebookCellOutputItem.to),d=this._outputs.find(f=>f.id===I);if(d&&(p||(d.items.length=0),d.items.push(...E),d.items.length>1&&d.items.every(f=>R.isTextStreamMime(f.mime)))){const f=new Map,a=[];d.items.forEach(i=>{let n;f.has(i.mime)?n=f.get(i.mime):(n=[],f.set(i.mime,n),a.push(i.mime)),n.push(i.data)}),d.items.length=0,a.forEach(i=>{const n=R.compressOutputItemStreams(f.get(i));d.items.push({mime:i,data:n.data.buffer})})}}setMetadata(I){this._metadata=Object.freeze(I)}setInternalMetadata(I){this._internalMetadata=I,this._previousResult=Object.freeze(L.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.ExtHostCell=m;class y{static{this._handlePool=0}constructor(I,p,S,E,d){this._proxy=I,this._textDocumentsAndEditors=p,this._textDocuments=S,this.uri=E,this.handle=y._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=d.viewType,this._metadata=Object.freeze(d.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,d.cells]],!0,void 0),this._versionId=d.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const I=this,p={get uri(){return I.uri},get version(){return I._versionId},get notebookType(){return I._notebookType},get isDirty(){return I._isDirty},get isUntitled(){return I.uri.scheme===h.Schemas.untitled},get isClosed(){return I._disposed},get metadata(){return I._metadata},get cellCount(){return I._cells.length},cellAt(S){return S=I._validateIndex(S),I._cells[S].apiCell},getCells(S){return(S?I._getCells(S):I._cells).map(d=>d.apiCell)},save(){return I._save()}};this._notebook=Object.freeze(p)}return this._notebook}acceptDocumentPropertiesChanged(I){I.metadata&&(this._metadata=Object.freeze({...this._metadata,...I.metadata}))}acceptDirty(I){this._isDirty=I}acceptModelChanged(I,p,S){this._versionId=I.versionId,this._isDirty=p,this.acceptDocumentPropertiesChanged({metadata:S});const E={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},d=[];for(const a of I.rawEvents)a.kind===R.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1,E.contentChanges):a.kind===R.NotebookCellsChangeType.Move?this._moveCells(a.index,a.length,a.newIdx,E.contentChanges):a.kind===R.NotebookCellsChangeType.Output?(this._setCellOutputs(a.index,a.outputs),d.push({cell:this._cells[a.index].apiCell,outputs:this._cells[a.index].apiCell.outputs})):a.kind===R.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems),d.push({cell:this._cells[a.index].apiCell,outputs:this._cells[a.index].apiCell.outputs})):a.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(a.index,a.language),d.push({cell:this._cells[a.index].apiCell,document:this._cells[a.index].apiCell.document})):a.kind===R.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this._cells[a.index].apiCell,document:this._cells[a.index].apiCell.document}):a.kind===R.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(a.index,a.mime):a.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(a.index,a.metadata),d.push({cell:this._cells[a.index].apiCell,metadata:this._cells[a.index].apiCell.metadata})):a.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(a.index,a.internalMetadata),d.push({cell:this._cells[a.index].apiCell,executionSummary:this._cells[a.index].apiCell.executionSummary}));const f=new Map;for(let a=0;a<d.length;a++){const i=d[a],n=f.get(i.cell);if(n===void 0){const l=E.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});f.set(i.cell,l-1)}else E.cellChanges[n]={...E.cellChanges[n],...i}}return Object.freeze(E),Object.freeze(E.cellChanges),Object.freeze(E.contentChanges),E}_validateIndex(I){return I=I|0,I<0?0:I>=this._cells.length?this._cells.length-1:I}_validateRange(I){let p=I.start|0,S=I.end|0;return p<0&&(p=0),S>this._cells.length&&(S=this._cells.length),I.with({start:p,end:S})}_getCells(I){I=this._validateRange(I);const p=[];for(let S=I.start;S<I.end;S++)p.push(this._cells[S]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(I,p,S){if(this._disposed)return;const E=[],d=[],f=[];if(I.reverse().forEach(a=>{const n=a[2].map(t=>{const u=new m(this,this._textDocumentsAndEditors,t);return p||d.push(m.asModelAddData(t)),u}),l=new b(a[0],a[1],[],n),o=this._cells.splice(a[0],a[1],...n);for(const t of o)f.push(t.uri),l.deletedItems.push(t.apiCell);E.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:f}),S)for(const a of E)S.push(a.asApiEvent())}_moveCells(I,p,S,E){const d=this._cells.splice(I,p);this._cells.splice(S,0,...d);const f=[new b(I,p,d.map(a=>a.apiCell),[]),new b(S,0,[],d)];for(const a of f)E.push(a.asApiEvent())}_setCellOutputs(I,p){this._cells[I].setOutputs(p)}_setCellOutputItems(I,p,S,E){this._cells[I].setOutputItems(p,S,E)}_changeCellLanguage(I,p){const S=this._cells[I];S.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelLanguageChanged(S.uri,p)}_changeCellMime(I,p){const S=this._cells[I];S.apiCell.mime=p}_changeCellMetadata(I,p){this._cells[I].setMetadata(p)}_changeCellInternalMetadata(I,p){this._cells[I].setInternalMetadata(p)}getCellFromApiCell(I){return this._cells.find(p=>p.apiCell===I)}getCellFromIndex(I){return this._cells[I]}getCell(I){return this._cells.find(p=>p.handle===I)}getCellIndex(I){return this._cells.indexOf(I)}}e.ExtHostNotebookDocument=y}),define(_e[346],Ce([1,0,4,2,16,8,48]),function(ue,e,h,O,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class b{constructor(y,T,I,p={timeout:1500,errors:3}){this._logService=y,this._notebooksAndEditors=T,this._mainThreadBulkEdits=I,this._thresholds=p,this._onWillSaveNotebookDocumentEvent=new h.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(y){return(T,I,p)=>{const S=function(d){T.call(I,d)};return S.extension=y,this._onWillSaveNotebookDocumentEvent.event(S,void 0,p)}}async $participateInSave(y,T,I){const p=O.URI.revive(y),S=this._notebooksAndEditors.getNotebookDocument(p);if(!S)throw new Error("Unable to resolve notebook document");const E=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:S.apiNotebook,reason:L.TextDocumentSaveReason.to(T)},I,async(f,a)=>{const i=Date.now(),n=await await Promise.resolve(f);Date.now()-i>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!I.isCancellationRequested&&n&&(n instanceof A.WorkspaceEdit?E.push(n):this._logService.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),I.isCancellationRequested)return!1;if(E.length===0)return!0;const d={edits:[]};for(const f of E){const{edits:a}=L.WorkspaceEdit.from(f);d.edits=d.edits.concat(a)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(new R.SerializableObjectWithBuffers(d))}}e.ExtHostNotebookDocumentSaveParticipant=b}),define(_e[154],Ce([1,0,13,16,8]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,m,y,T,I,p){this.id=b,this._proxy=m,this.notebookData=y,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=I,this._visibleRanges=T,this._viewColumn=p}get apiEditor(){if(!this._editor){const b=this;this._editor={get notebook(){return b.notebookData.apiNotebook},get selection(){return b._selections[0]},set selection(m){this.selections=[m]},get selections(){return b._selections},set selections(m){if(!Array.isArray(m)||!m.every(L.NotebookRange.isNotebookRange))throw(0,h.illegalArgument)("selections");b._selections=m,b._trySetSelections(m)},get visibleRanges(){return b._visibleRanges},revealRange(m,y){b._proxy.$tryRevealRange(b.id,O.NotebookRange.from(m),y??L.NotebookEditorRevealType.Default)},get viewColumn(){return b._viewColumn}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(b){this._visible=b}_acceptVisibleRanges(b){this._visibleRanges=b}_acceptSelections(b){this._selections=b}_trySetSelections(b){this._proxy.$trySetSelections(this.id,b.map(O.NotebookRange.from))}_acceptViewColumn(b){this._viewColumn=b}}e.ExtHostNotebookEditor=A}),define(_e[347],Ce([1,0,4,11,16]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let A=class{constructor(b,m){this._logService=b,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new h.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new h.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(b,m){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,m);const y=this._notebooksAndEditors.getEditorById(b);m.visibleRanges&&y._acceptVisibleRanges(m.visibleRanges.ranges.map(L.NotebookRange.to)),m.selections&&y._acceptSelections(m.selections.selections.map(L.NotebookRange.to)),m.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:y.apiEditor,visibleRanges:y.apiEditor.visibleRanges}),m.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:y.apiEditor,selections:y.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const m in b)this._notebooksAndEditors.getEditorById(m)._acceptViewColumn(L.ViewColumn.to(b[m]))}};e.ExtHostNotebookEditors=A,e.ExtHostNotebookEditors=A=Ge([Ue(0,O.ILogService)],A)}),define(_e[348],Ce([1,0,4,6,154]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(b,m){this._extHostNotebook=m,this._rendererMessageEmitters=new Map,this.proxy=b.getProxy(O.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(b,m,y){const T=this._extHostNotebook.getEditorById(b);this._rendererMessageEmitters.get(m)?.fire({editor:T.apiEditor,message:y})}createRendererMessaging(b,m){if(!b.contributes?.notebookRenderer?.some(T=>T.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(T,I,p)=>this.getOrCreateEmitterFor(m).event(T,I,p),postMessage:(T,I)=>{L.ExtHostNotebookEditor.apiEditorsToExtHost.has(T)&&([T,I]=[I,T]);const p=I&&L.ExtHostNotebookEditor.apiEditorsToExtHost.get(I);return this.proxy.$postMessage(p?.id,m,T)}}}getOrCreateEmitterFor(b){let m=this._rendererMessageEmitters.get(b);return m||(m=new h.Emitter({onDidRemoveLastListener:()=>{m?.dispose(),this._rendererMessageEmitters.delete(b)}}),this._rendererMessageEmitters.set(b,m),m)}}e.ExtHostNotebookRenderers=A}),define(_e[349],Ce([1,0,16,109,22,56,13]),function(ue,e,h,O,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class b{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}async withProgress(I,p,S){const E=this._handles++,{title:d,location:f,cancellable:a}=p,i={label:I.displayName||I.name,id:I.identifier.value};return this._proxy.$startProgress(E,{location:h.ProgressLocation.from(f),title:d,source:i,cancellable:a},I.isUnderDevelopment?void 0:I.identifier.value).catch(R.onUnexpectedExternalError),this._withProgress(E,S,!!a)}_withProgress(I,p,S){let E;S&&(E=new L.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,E));const d=a=>{this._proxy.$progressEnd(a),this._mapHandleToCancellationSource.delete(a),E?.dispose()};let f;try{f=p(new y(this._proxy,I),S&&E?E.token:L.CancellationToken.None)}catch(a){throw d(I),a}return f.then(a=>d(I),a=>d(I)),f}$acceptProgressCanceled(I){const p=this._mapHandleToCancellationSource.get(I);p&&(p.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=b;function m(T,I){return T.message=I.message,typeof I.increment=="number"&&(typeof T.increment=="number"?T.increment+=I.increment:T.increment=I.increment),T}class y extends O.Progress{constructor(I,p){super(S=>this.throttledReport(S)),this._proxy=I,this._handle=p}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}Ge([(0,A.throttle)(100,(T,I)=>m(T,I),()=>Object.create(null))],y.prototype,"throttledReport",null)}),define(_e[350],Ce([1,0,2,6,7,16]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class R{static{this.handlePool=0}constructor(m,y){this.uriTransformer=y,this.providers=new Map,this.proxy=m.getProxy(O.MainContext.MainThreadQuickDiff)}$provideOriginalResource(m,y,T){const I=h.URI.revive(y),p=this.providers.get(m);return p?(0,L.asPromise)(()=>p.provideOriginalResource(I,T)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider(m,y,T,I){const p=R.handlePool++;return this.providers.set(p,y),this.proxy.$registerQuickDiffProvider(p,A.DocumentSelector.from(m,this.uriTransformer),T,I),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(p),this.providers.delete(p)}}}}e.ExtHostQuickDiff=R}),define(_e[351],Ce([1,0,22,4,3,6,2,8,13,19,41,50,26,16]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=E;function E(d,f,a){const i=d.getProxy(A.MainContext.MainThreadQuickOpen);class n{constructor(g,D){this._sessions=new Map,this._instances=0,this._workspace=g,this._commands=D}showQuickPick(g,D,v,_=h.CancellationToken.None){this._onDidSelectItem=void 0;const C=Promise.resolve(D),P=++this._instances,k=i.$show(P,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},_),F={},x=k.then(()=>F);return Promise.race([x,C]).then(z=>{if(z===F)return;const N=(0,p.isProposedApiEnabled)(g,"quickPickItemTooltip");return C.then(M=>{const W=[];for(let X=0;X<M.length;X++){const te=M[X];if(typeof te=="string")W.push({label:te,handle:X});else if(te.kind===b.QuickPickItemKind.Separator)W.push({type:"separator",label:te.label});else{te.tooltip&&!N&&console.warn(`Extension '${g.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${g.identifier.value}`);const H=te.iconPath?r(te.iconPath):void 0;W.push({label:te.label,iconPath:H?.iconPath,iconClass:H?.iconClass,description:te.description,detail:te.detail,picked:te.picked,alwaysShow:te.alwaysShow,tooltip:N?S.MarkdownString.fromStrict(te.tooltip):void 0,handle:X})}}return v&&typeof v.onDidSelectItem=="function"&&(this._onDidSelectItem=X=>{v.onDidSelectItem(M[X])}),i.$setItems(P,W),k.then(X=>{if(typeof X=="number")return M[X];if(Array.isArray(X))return X.map(te=>M[te])})})}).then(void 0,z=>{if(!(0,m.isCancellationError)(z))return i.$setError(P,z),Promise.reject(z)})}$onItemSelected(g){this._onDidSelectItem?.(g)}showInput(g,D=h.CancellationToken.None){return this._validateInput=g?.validateInput,i.$input(g,typeof this._validateInput=="function",D).then(void 0,v=>{if(!(0,m.isCancellationError)(v))return Promise.reject(v)})}async $validateInput(g){if(!this._validateInput)return;const D=await this._validateInput(g);if(!D||typeof D=="string")return D;let v;switch(D.severity){case b.InputBoxValidationSeverity.Info:v=T.default.Info;break;case b.InputBoxValidationSeverity.Warning:v=T.default.Warning;break;case b.InputBoxValidationSeverity.Error:v=T.default.Error;break;default:v=D.message?T.default.Error:T.default.Ignore;break}return{content:D.message,severity:v}}async showWorkspaceFolderPick(g,D=h.CancellationToken.None){const v=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[g]);if(!v)return;const _=await this._workspace.getWorkspaceFolders2();if(_)return _.find(C=>C.uri.toString()===v.uri.toString())}createQuickPick(g){const D=new c(g,()=>this._sessions.delete(D._id));return this._sessions.set(D._id,D),D}createInputBox(g){const D=new s(g,()=>this._sessions.delete(D._id));return this._sessions.set(D._id,D),D}$onDidChangeValue(g,D){this._sessions.get(g)?._fireDidChangeValue(D)}$onDidAccept(g){this._sessions.get(g)?._fireDidAccept()}$onDidChangeActive(g,D){const v=this._sessions.get(g);v instanceof c&&v._fireDidChangeActive(D)}$onDidChangeSelection(g,D){const v=this._sessions.get(g);v instanceof c&&v._fireDidChangeSelection(D)}$onDidTriggerButton(g,D){this._sessions.get(g)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(g,D,v){const _=this._sessions.get(g);_ instanceof c&&_._fireDidTriggerItemButton(D,v)}$onDidHide(g){this._sessions.get(g)?._fireDidHide()}}class l{static{this._nextId=1}constructor(g,D){this._extensionId=g,this._onDidDispose=D,this._id=c._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new O.Emitter,this._onDidChangeValueEmitter=new O.Emitter,this._onDidTriggerButtonEmitter=new O.Emitter,this._onDidHideEmitter=new O.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(g){this._title=g,this.update({title:g})}get step(){return this._steps}set step(g){this._steps=g,this.update({step:g})}get totalSteps(){return this._totalSteps}set totalSteps(g){this._totalSteps=g,this.update({totalSteps:g})}get enabled(){return this._enabled}set enabled(g){this._enabled=g,this.update({enabled:g})}get busy(){return this._busy}set busy(g){this._busy=g,this.update({busy:g})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(g){this._ignoreFocusOut=g,this.update({ignoreFocusOut:g})}get value(){return this._value}set value(g){this._value=g,this.update({value:g})}get placeholder(){return this._placeholder}set placeholder(g){this._placeholder=g,this.update({placeholder:g})}get buttons(){return this._buttons}set buttons(g){this._buttons=g.slice(),this._handlesToButtons.clear(),g.forEach((D,v)=>{const _=D===b.QuickInputButtons.Back?-1:v;this._handlesToButtons.set(_,D)}),this.update({buttons:g.map((D,v)=>({...r(D.iconPath),tooltip:D.tooltip,handle:D===b.QuickInputButtons.Back?-1:v}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(g){this._value=g,this._onDidChangeValueEmitter.fire(g)}_fireDidTriggerButton(g){const D=this._handlesToButtons.get(g);D&&this._onDidTriggerButtonEmitter.fire(D)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,L.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),i.$dispose(this._id))}update(g){if(!this._disposed){for(const D of Object.keys(g)){const v=g[D];this._pendingUpdate[D]=v===void 0?null:v}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){i.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function o(w){if(w instanceof b.ThemeIcon)return{id:w.id};const g=u(w),D=t(w);return{dark:typeof g=="string"?R.URI.file(g):g,light:typeof D=="string"?R.URI.file(D):D}}function t(w){return typeof w=="object"&&"light"in w?w.light:w}function u(w){return typeof w=="object"&&"dark"in w?w.dark:w}function r(w){const g=o(w);let D,v;return"id"in g?v=I.ThemeIcon.asClassName(g):D=g,{iconPath:D,iconClass:v}}class c extends l{constructor(g,D){super(g.identifier,D),this.extension=g,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new O.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new O.Emitter,this._onDidTriggerItemButtonEmitter=new O.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(g){this._items=g.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),g.forEach((_,C)=>{this._handlesToItems.set(C,_),this._itemsToHandles.set(_,C)});const D=(0,p.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),v=[];for(let _=0;_<g.length;_++){const C=g[_];if(C.kind===b.QuickPickItemKind.Separator)v.push({type:"separator",label:C.label});else{C.tooltip&&!D&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const P=C.iconPath?r(C.iconPath):void 0;v.push({handle:_,label:C.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:C.description,detail:C.detail,picked:C.picked,alwaysShow:C.alwaysShow,tooltip:D?S.MarkdownString.fromStrict(C.tooltip):void 0,buttons:C.buttons?.map((k,F)=>({...r(k.iconPath),tooltip:k.tooltip,handle:F}))})}}this.update({items:v})}get canSelectMany(){return this._canSelectMany}set canSelectMany(g){this._canSelectMany=g,this.update({canSelectMany:g})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(g){this._matchOnDescription=g,this.update({matchOnDescription:g})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(g){this._matchOnDetail=g,this.update({matchOnDetail:g})}get sortByLabel(){return this._sortByLabel}set sortByLabel(g){this._sortByLabel=g,this.update({sortByLabel:g})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(g){this._keepScrollPosition=g,this.update({keepScrollPosition:g})}get activeItems(){return this._activeItems}set activeItems(g){this._activeItems=g.filter(D=>this._itemsToHandles.has(D)),this.update({activeItems:this._activeItems.map(D=>this._itemsToHandles.get(D))})}get selectedItems(){return this._selectedItems}set selectedItems(g){this._selectedItems=g.filter(D=>this._itemsToHandles.has(D)),this.update({selectedItems:this._selectedItems.map(D=>this._itemsToHandles.get(D))})}_fireDidChangeActive(g){const D=(0,y.coalesce)(g.map(v=>this._handlesToItems.get(v)));this._activeItems=D,this._onDidChangeActiveEmitter.fire(D)}_fireDidChangeSelection(g){const D=(0,y.coalesce)(g.map(v=>this._handlesToItems.get(v)));this._selectedItems=D,this._onDidChangeSelectionEmitter.fire(D)}_fireDidTriggerItemButton(g,D){const v=this._handlesToItems.get(g);if(!v||!v.buttons||!v.buttons.length)return;const _=v.buttons[D];_&&this._onDidTriggerItemButtonEmitter.fire({button:_,item:v})}}class s extends l{constructor(g,D){super(g.identifier,D),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(g){this._password=g,this.update({password:g})}get prompt(){return this._prompt}set prompt(g){this._prompt=g,this.update({prompt:g})}get valueSelection(){return this._valueSelection}set valueSelection(g){this._valueSelection=g,this.update({valueSelection:g})}get validationMessage(){return this._validationMessage}set validationMessage(g){this._validationMessage=g,g?typeof g=="string"?this.update({validationMessage:g,severity:T.default.Error}):this.update({validationMessage:g.message,severity:g.severity??T.default.Error}):this.update({validationMessage:void 0,severity:T.default.Ignore})}}return new n(f,a)}}),define(_e[352],Ce([1,0,2,4,56,3,7,6,19,132,11,25,50,16,26,15,12]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function i(P){return P instanceof h.URI}function n(P,k){return P.scheme===d.Schemas.file&&k.scheme===d.Schemas.file&&f.isLinux?P.toString()===k.toString():P.toString().toLowerCase()===k.toString().toLowerCase()}function l(P){if(P)return typeof P.iconPath=="string"?h.URI.file(P.iconPath):h.URI.isUri(P.iconPath)||p.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function o(P){if(P.icon){if(h.URI.isUri(P.icon))return P.icon;if(p.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const k=P.icon;return{light:k.light,dark:k.dark}}}else return}function t(P,k){if(!P.iconPath&&!k.iconPath)return 0;if(P.iconPath){if(!k.iconPath)return 1}else return-1;const F=typeof P.iconPath=="string"?P.iconPath:h.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,x=typeof k.iconPath=="string"?k.iconPath:h.URI.isUri(k.iconPath)?k.iconPath.fsPath:k.iconPath.id;return(0,y.comparePaths)(F,x)}function u(P,k){let F=0;if(P.strikeThrough!==k.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==k.faded)return P.faded?1:-1;if(P.tooltip!==k.tooltip)return(P.tooltip||"").localeCompare(k.tooltip||"");if(F=t(P,k),F!==0)return F;if(P.light&&k.light)F=t(P.light,k.light);else{if(P.light)return 1;if(k.light)return-1}if(F!==0)return F;if(P.dark&&k.dark)F=t(P.dark,k.dark);else{if(P.dark)return 1;if(k.dark)return-1}return F}function r(P,k){if(P.command!==k.command)return P.command<k.command?-1:1;if(P.title!==k.title)return P.title<k.title?-1:1;if(P.tooltip!==k.tooltip){if(P.tooltip!==void 0&&k.tooltip!==void 0)return P.tooltip<k.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(k.tooltip!==void 0)return-1}if(P.arguments===k.arguments)return 0;if(P.arguments)if(k.arguments){if(P.arguments.length!==k.arguments.length)return P.arguments.length-k.arguments.length}else return 1;else return-1;for(let F=0;F<P.arguments.length;F++){const x=P.arguments[F],z=k.arguments[F];if(x!==z&&!(i(x)&&i(z)&&n(x,z)))return x<z?-1:1}return 0}function c(P,k){let F=(0,y.comparePaths)(P.resourceUri.fsPath,k.resourceUri.fsPath,!0);if(F!==0)return F;if(P.command&&k.command)F=r(P.command,k.command);else{if(P.command)return 1;if(k.command)return-1}if(F!==0)return F;if(P.decorations&&k.decorations)F=u(P.decorations,k.decorations);else{if(P.decorations)return 1;if(k.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&k.multiFileDiffEditorModifiedUri)F=(0,y.comparePaths)(P.multiFileDiffEditorModifiedUri.fsPath,k.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(k.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&k.multiDiffEditorOriginalUri)F=(0,y.comparePaths)(P.multiDiffEditorOriginalUri.fsPath,k.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(k.multiDiffEditorOriginalUri)return-1}return F}function s(P,k){for(let F=0;F<P.length;F++)if(P[F]!==k[F])return!1;return!0}function w(P,k){return P.command===k.command&&P.title===k.title&&P.tooltip===k.tooltip&&(P.arguments&&k.arguments?s(P.arguments,k.arguments):P.arguments===k.arguments)}function g(P,k){return(0,m.equals)(P,k,w)}class D{#e;#t;get value(){return this._value}set value(k){k=k??"",this.#e.$setInputBoxValue(this._sourceControlHandle,k),this.updateValue(k)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(k){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,k),this._placeholder=k}get validateInput(){return(0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(k){if((0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),k&&typeof k!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=k,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!k)}get enabled(){return this._enabled}set enabled(k){k=!!k,this._enabled!==k&&(this._enabled=k,this.#e.$setInputBoxEnablement(this._sourceControlHandle,k))}get visible(){return this._visible}set visible(k){k=!!k,this._visible!==k&&(this._visible=k,this.#e.$setInputBoxVisibility(this._sourceControlHandle,k))}get document(){return(0,E.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(k,F,x,z,N){this._extension=k,this._sourceControlHandle=z,this._documentUri=N,this._value="",this._onDidChange=new O.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=F,this.#e=x}showValidationMessage(k,F){(0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,k,F)}$onInputBoxValueChange(k){this.updateValue(k)}updateValue(k){this._value=k,this._onDidChange.fire(k)}}e.ExtHostSCMInputBox=D;class v{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(k){this._label=k,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,k)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(k){this._hideWhenEmpty=k,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(k){this._resourceStates=[...k],this._onDidUpdateResourceStates.fire()}constructor(k,F,x,z,N,M,W){this._proxy=k,this._commands=F,this._sourceControlHandle=x,this._id=z,this._label=N,this.multiDiffEditorEnableViewChanges=M,this._extension=W,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new O.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new O.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=v._handlePool++}getResourceState(k){return this._resourceStatesMap.get(k)}$executeResourceCommand(k,F){const x=this._resourceStatesCommandsMap.get(k);return x?(0,R.asPromise)(()=>this._commands.executeCommand(x.command,...x.arguments||[],F)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const k=[...this._resourceStates].sort(c),x=(0,m.sortedDiff)(this._resourceSnapshot,k,c).map(M=>{const W=M.toInsert.map(X=>{const te=this._resourceHandlePool++;this._resourceStatesMap.set(te,X);const H=X.resourceUri;let G;if(X.command)if(X.command.command==="vscode.open"||X.command.command==="vscode.diff"||X.command.command==="vscode.changes"){const re=new A.DisposableStore;G=this._commands.converter.toInternal(X.command,re),this._resourceStatesDisposablesMap.set(te,re)}else this._resourceStatesCommandsMap.set(te,X.command);const Y=(0,E.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor"),ne=Y?X.multiDiffEditorOriginalUri:void 0,pe=Y?X.multiFileDiffEditorModifiedUri:void 0,le=l(X.decorations),we=X.decorations&&l(X.decorations.light)||le,Z=X.decorations&&l(X.decorations.dark)||le,B=[we,Z],ee=X.decorations&&X.decorations.tooltip||"",ve=X.decorations&&!!X.decorations.strikeThrough,Pe=X.decorations&&!!X.decorations.faded,oe=X.contextValue||"";return{rawResource:[te,H,B,ee,ve,Pe,oe,G,ne,pe],handle:te}});return{start:M.start,deleteCount:M.deleteCount,toInsert:W}}),z=x.map(({start:M,deleteCount:W,toInsert:X})=>[M,W,X.map(te=>te.rawResource)]),N=x.reverse();for(const{start:M,deleteCount:W,toInsert:X}of N){const te=X.map(G=>G.handle),H=this._handlesSnapshot.splice(M,W,...te);for(const G of H)this._resourceStatesMap.delete(G),this._resourceStatesCommandsMap.delete(G),this._resourceStatesDisposablesMap.get(G)?.dispose(),this._resourceStatesDisposablesMap.delete(G)}return this._resourceSnapshot=k,z}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class _{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(k){this._count!==k&&(this._count=k,this.#e.$updateSourceControl(this.handle,{count:k}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(k){this._quickDiffProvider=k;let F;(0,E.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(F=k?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!k,quickDiffLabel:F})}get historyProvider(){return(0,E.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(k){(0,E.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=k,this._historyProviderDisposable.value=new A.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!k}),k&&this._historyProviderDisposable.value.add(k.onDidChangeCurrentHistoryItemGroup(()=>{this._historyProviderCurrentHistoryItemGroup=k?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup)}))}get commitTemplate(){return this._commitTemplate}set commitTemplate(k){k!==this._commitTemplate&&(this._commitTemplate=k,this.#e.$updateSourceControl(this.handle,{commitTemplate:k}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(k){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=k;const F=this._commands.converter.toInternal(k,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:F})}get actionButton(){return(0,E.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(k){(0,E.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=k;const F=k!==void 0?{command:this._commands.converter.toInternal(k.command,this._actionButtonDisposables.value),secondaryCommands:k.secondaryCommands?.map(x=>x.map(z=>this._commands.converter.toInternal(z,this._actionButtonDisposables.value))),description:k.description,enabled:k.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:F??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(k){if(this._statusBarCommands&&k&&g(this._statusBarCommands,k))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=k;const F=(k||[]).map(x=>this._commands.converter.toInternal(x,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:F})}get selected(){return this._selected}constructor(k,F,x,z,N,M,W){this._extension=k,this._commands=z,this._id=N,this._label=M,this._rootUri=W,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new A.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new O.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=_._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=x;const X=h.URI.from({scheme:d.Schemas.vscodeSourceControl,path:`${N}/scm${this.handle}/input`,query:W?`rootUri=${encodeURIComponent(W.toString())}`:void 0});this._inputBox=new D(k,F,this.#e,this.handle,X),this.#e.$registerSourceControl(this.handle,N,M,W,X)}createResourceGroup(k,F,x){const z=(0,E.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor")&&x?.multiDiffEditorEnableViewChanges===!0,N=new v(this.#e,this._commands,this.handle,k,F,z,this._extension),M=O.Event.once(N.onDidDispose)(()=>this.createdResourceGroups.delete(N));return this.createdResourceGroups.set(N,M),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const k=[],F=[];for(const[x,z]of this.createdResourceGroups){z.dispose();const N=x.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(x),this.eventuallyUpdateResourceStates()});O.Event.once(x.onDidDispose)(()=>{this.updatedResourceGroups.delete(x),N.dispose(),this._groups.delete(x.handle),this.#e.$unregisterGroup(this.handle,x.handle)}),k.push([x.handle,x.id,x.label,x.features,x.multiDiffEditorEnableViewChanges]);const M=x._takeResourceStateSnapshot();M.length>0&&F.push([x.handle,M]),this._groups.set(x.handle,x)}this.#e.$registerGroups(this.handle,k,F),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const k=[];this.updatedResourceGroups.forEach(F=>{const x=F._takeResourceStateSnapshot();x.length!==0&&k.push([F.handle,x])}),k.length>0&&this.#e.$spliceResourceStates(this.handle,k),this.updatedResourceGroups.clear()}getResourceGroup(k){return this._groups.get(k)}setSelectionState(k){this._selected=k,this._onDidChangeSelection.fire(k)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(k=>k.dispose()),this.#e.$unregisterSourceControl(this.handle)}}Ge([(0,L.debounce)(100)],_.prototype,"eventuallyAddResourceGroups",null),Ge([(0,L.debounce)(100)],_.prototype,"eventuallyUpdateResourceStates",null);let C=class{static{a=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(k,F,x,z){this._commands=F,this._extHostDocuments=x,this.logService=z,this._sourceControls=new Map,this._sourceControlsByExtension=new I.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new O.Emitter,this._proxy=k.getProxy(b.MainContext.MainThreadSCM),this._telemetry=k.getProxy(b.MainContext.MainThreadTelemetry),F.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===3){const M=this._sourceControls.get(N.sourceControlHandle);if(!M)return N;const W=M.getResourceGroup(N.groupHandle);return W?W.getResourceState(N.handle):N}else if(N&&N.$mid===4){const M=this._sourceControls.get(N.sourceControlHandle);return M?M.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===5){const M=this._sourceControls.get(N.handle);return M||N}return N}})}createSourceControl(k,F,x,z){this.logService.trace("ExtHostSCM#createSourceControl",k.identifier.value,F,x,z),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:k.identifier.value});const N=a._handlePool++,M=new _(k,this._extHostDocuments,this._proxy,this._commands,F,x,z);this._sourceControls.set(N,M);const W=this._sourceControlsByExtension.get(k.identifier)||[];return W.push(M),this._sourceControlsByExtension.set(k.identifier,W),M}getLastInputBox(k){this.logService.trace("ExtHostSCM#getLastInputBox",k.identifier.value);const F=this._sourceControlsByExtension.get(k.identifier),x=F&&F[F.length-1];return x&&x.inputBox}$provideOriginalResource(k,F,x){const z=h.URI.revive(F);this.logService.trace("ExtHostSCM#$provideOriginalResource",k,z.toString());const N=this._sourceControls.get(k);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>N.quickDiffProvider.provideOriginalResource(z,x)).then(M=>M||null)}$onInputBoxValueChange(k,F){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",k);const x=this._sourceControls.get(k);return x&&x.inputBox.$onInputBoxValueChange(F),Promise.resolve(void 0)}$executeResourceCommand(k,F,x,z){this.logService.trace("ExtHostSCM#$executeResourceCommand",k,F,x);const N=this._sourceControls.get(k);if(!N)return Promise.resolve(void 0);const M=N.getResourceGroup(F);return M?M.$executeResourceCommand(x,z):Promise.resolve(void 0)}$validateInput(k,F,x){this.logService.trace("ExtHostSCM#$validateInput",k);const z=this._sourceControls.get(k);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>z.inputBox.validateInput(F,x)).then(N=>{if(!N)return Promise.resolve(void 0);const M=S.MarkdownString.fromStrict(N.message);return M?Promise.resolve([M,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(k){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",k),k!==void 0&&this._sourceControls.get(k)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=k,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(k,F,x,z){return await this._sourceControls.get(k)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(F,x,z)??void 0}async $provideHistoryItems(k,F,x,z){return(await this._sourceControls.get(k)?.historyProvider?.provideHistoryItems(F,x,z))?.map(W=>({...W,icon:o(W)}))??void 0}async $provideHistoryItemSummary(k,F,x,z){const N=this._sourceControls.get(k)?.historyProvider;if(typeof N?.provideHistoryItemSummary!="function")return;const M=await N.provideHistoryItemSummary(F,x,z);return M?{...M,icon:o(M)}:void 0}async $provideHistoryItemChanges(k,F,x,z){return await this._sourceControls.get(k)?.historyProvider?.provideHistoryItemChanges(F,x,z)??void 0}};e.ExtHostSCM=C,e.ExtHostSCM=C=a=Ge([Ue(3,T.ILogService)],C)}),define(_e[353],Ce([1,0,6,16,2]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class A{static{this.handlePool=0}constructor(b,m){this.uriTransformer=m,this.providers=new Map,this.proxy=b.getProxy(h.MainContext.MainThreadShare)}async $provideShare(b,m,y){return await this.providers.get(b)?.provideShare({selection:O.Range.to(m.selection),resourceUri:L.URI.revive(m.resourceUri)},y)??void 0}registerShareProvider(b,m){const y=A.handlePool++;return this.providers.set(y,m),this.proxy.$registerShareProvider(y,O.DocumentSelector.from(b,this.uriTransformer),m.id,m.label,m.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(y),this.providers.delete(y)}}}}e.ExtHostShare=A}),define(_e[354],Ce([1,0,8,6,230,3,16,18]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class m{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new h.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new h.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(p,S,E,d,f,a=h.StatusBarAlignment.Left,i){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new A.DisposableStore,this.#e=p,this.#t=S,f&&d){this._entryId=(0,h.asStatusBarItemIdentifier)(d.identifier,f);const n=E.get(this._entryId);n&&(a=n.alignLeft?h.StatusBarAlignment.Left:h.StatusBarAlignment.Right,i=n.priority,this._visible=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this._entryId=String(m.ID_GEN++);this._extension=d,this._id=f,this._alignment=a,this._priority=this.validatePriority(i)}validatePriority(p){if((0,b.isNumber)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(p){this._text=p,this.update()}set name(p){this._name=p,this.update()}set tooltip(p){this._tooltip=p,this.update()}set color(p){this._color=p,this.update()}set backgroundColor(p){p&&!m.ALLOWED_BACKGROUND_COLORS.has(p.id)&&(p=void 0),this._backgroundColor=p,this.update()}set command(p){this._command?.fromApi!==p&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new A.DisposableStore,typeof p=="string"?this._command={fromApi:p,internal:this.#t.toInternal({title:"",command:p},this._latestCommandRegistration)}:p?this._command={fromApi:p,internal:this.#t.toInternal(p,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(p){this._accessibilityInformation=p,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let p;this._extension?this._id?p=`${this._extension.identifier.value}.${this._id}`:p=this._extension.identifier.value:p=this._id;let S;this._name?S=this._name:S=(0,L.localize)(0,null,this._extension.displayName||this._extension.name);let E=this._color;this._backgroundColor&&(E=m.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const d=R.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,p,this._extension?.identifier.value,S,this._text,d,this._command?.internal,E,this._backgroundColor,this._alignment===h.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=m;class y{constructor(p){this._messages=[],this._item=p.createStatusBarEntry(void 0,"status.extensionMessage",h.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,L.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(p){const S={message:p};return this._messages.unshift(S),this._update(),new h.Disposable(()=>{const E=this._messages.indexOf(S);E>=0&&(this._messages.splice(E,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class T{constructor(p,S){this._existingItems=new Map,this._proxy=p.getProxy(O.MainContext.MainThreadStatusBar),this._commands=S,this._statusMessage=new y(this)}$acceptStaticEntries(p){for(const S of p)this._existingItems.set(S.entryId,S)}createStatusBarEntry(p,S,E,d){return new m(this._proxy,this._commands,this._existingItems,p,S,E,d)}setStatusBarMessage(p,S){const E=this._statusMessage.setMessage(p);let d;return typeof S=="number"?d=setTimeout(()=>E.dispose(),S):typeof S<"u"&&S.then(()=>E.dispose(),()=>E.dispose()),new h.Disposable(()=>{E.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=T}),define(_e[155],Ce([1,0,29,145,69,113,89,16,2]),function(ue,e,h,O,L,A,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const y=(n,l,o,t)=>{let u=l;return{enumerable:!0,configurable:!1,get(){return u},set(r){if(!o(u,r)){const c=u;u=r,n.listener?.(t(r,c))}}}},T=(n,l)=>n===l,I={range:(n,l)=>n===l?!0:!n||!l?!1:n.isEqual(l),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(n,l)=>!(n.length!==l.length||n.some(o=>!l.find(t=>o.id===t.id)))},p=n=>l=>({op:4,update:n(l)}),S=(n,l)=>({range:(()=>{let o;const t=p(u=>({range:h.Range.lift(b.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return o},set(u){n.listener?.({op:6}),I.range(o,u)||(o=u,n.listener?.(t(u)))}}})(),label:y(n,l,I.label,p(o=>({label:o}))),description:y(n,void 0,I.description,p(o=>({description:o}))),sortText:y(n,void 0,I.sortText,p(o=>({sortText:o}))),canResolveChildren:y(n,!1,I.canResolveChildren,o=>({op:2,state:o})),busy:y(n,!1,I.busy,p(o=>({busy:o}))),error:y(n,void 0,I.error,p(o=>({error:b.MarkdownString.fromStrict(o)||null}))),tags:y(n,[],I.tags,(o,t)=>({op:1,new:o.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),E=n=>{const l=L.TestId.fromString(n.extId),o=new f(l.controllerId,l.localId,n.label,m.URI.revive(n.uri)||void 0);return o.range=b.Range.to(n.range||void 0),o.description=n.description||void 0,o.sortText=n.sortText||void 0,o.tags=n.tags.map(t=>b.TestTag.to({id:(0,R.denamespaceTestTag)(t).tagId})),o},d=n=>{let l;for(const o of n.tests){const t=E(o.item);(0,O.getPrivateApiFor)(t).parent=l,l=t}return l};e.toItemFromContext=d;class f{constructor(l,o,t,u){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const r=(0,O.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof a?void 0:r.parent}},children:{value:(0,A.createTestItemChildren)(r,O.getPrivateApiFor,f),enumerable:!0,writable:!1},...S(r,t)})}}e.TestItemImpl=f;class a extends f{constructor(l,o){super(l,l,o,void 0),this._isRoot=!0}}e.TestItemRootImpl=a;class i extends A.TestItemCollection{constructor(l,o,t){super({controllerId:l,getDocumentVersion:u=>u&&t.getDocument(u)?.version,getApiFor:O.getPrivateApiFor,getChildren:u=>u.children,root:new a(l,o),toITestItem:b.TestItem.from})}}e.ExtHostTestItemCollection=i}),define(_e[34],Ce([1,0,18,8,16,24,6,19,11,58,29,51,2,3,5,20,155,21,48,47,40,87,90,30]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i,n,l,o,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{#e;#t;#i;constructor(v,_,C){this._commands=new Map,this._apiCommands=new Map,this.#e=v.getProxy(R.MainContext.MainThreadCommands),this._logService=_,this.#i=C,this.#t=v.getProxy(R.MainContext.MainThreadTelemetry),this.converter=new c(this,P=>{const k=this._apiCommands.get(P);return k?.result===w.Void?k:void 0},_),this._argumentProcessors=[{processArgument(P){return(0,y.revive)(P)}},{processArgument(P){return(0,A.cloneAndChange)(P,function(k){if(T.Range.isIRange(k))return L.Range.to(k);if(I.Position.isIPosition(k))return L.Position.to(k);if(T.Range.isIRange(k.range)&&p.URI.isUri(k.uri))return L.location.to(k);if(k instanceof a.VSBuffer)return k.buffer.buffer;if(!Array.isArray(k))return k})}}]}registerArgumentProcessor(v){this._argumentProcessors.push(v)}registerApiCommand(v){const _=this.registerCommand(!1,v.id,async(...C)=>{const P=v.args.map((F,x)=>{if(!F.validate(C[x]))throw new Error(`Invalid argument '${F.name}' when running '${v.id}', received: ${typeof C[x]=="object"?JSON.stringify(C[x],null,"	"):C[x]} `);return F.convert(C[x])}),k=await this.executeCommand(v.internalId,...P);return v.result.convert(k,C,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this._apiCommands.set(v.id,v),new O.Disposable(()=>{_.dispose(),this._apiCommands.delete(v.id)})}registerCommand(v,_,C,P,k,F){if(this._logService.trace("ExtHostCommands#registerCommand",_),!_.trim().length)throw new Error("invalid id");if(this._commands.has(_))throw new Error(`command '${_}' already exists`);return this._commands.set(_,{callback:C,thisArg:P,metadata:k,extension:F}),v&&this.#e.$registerCommand(_),new O.Disposable(()=>{this._commands.delete(_)&&v&&this.#e.$unregisterCommand(_)})}executeCommand(v,..._){return this._logService.trace("ExtHostCommands#executeCommand",v),this._doExecuteCommand(v,_,!0)}async _doExecuteCommand(v,_,C){if(this._commands.has(v))return this.#e.$fireCommandActivationEvent(v),this._executeContributedCommand(v,_,!1);{let P=!1;const k=(0,A.cloneAndChange)(_,function(F){if(F instanceof O.Position)return L.Position.from(F);if(F instanceof O.Range)return L.Range.from(F);if(F instanceof O.Location)return L.location.from(F);if(O.NotebookRange.isNotebookRange(F))return L.NotebookRange.from(F);if(F instanceof ArrayBuffer)return P=!0,a.VSBuffer.wrap(new Uint8Array(F));if(F instanceof Uint8Array)return P=!0,a.VSBuffer.wrap(F);if(F instanceof a.VSBuffer)return P=!0,F;if(!Array.isArray(F))return F});try{const F=await this.#e.$executeCommand(v,P?new i.SerializableObjectWithBuffers(k):k,C);return(0,y.revive)(F)}catch(F){if(F instanceof Error&&F.message==="$executeCommand:retry")return this._doExecuteCommand(v,_,!1);throw F}}}async _executeContributedCommand(v,_,C){const P=this._commands.get(v);if(!P)throw new Error("Unknown command");const{callback:k,thisArg:F,metadata:x}=P;if(x?.args)for(let N=0;N<x.args.length;N++)try{(0,h.validateConstraint)(_[N],x.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${x.args[N].name}' - ${x.args[N].description}`)}const z=l.StopWatch.create();try{return await k.apply(F,_)}catch(N){if(v===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(..._);M&&(v=M.command)}if(this._logService.error(N,v,P.extension?.identifier),!C)throw N;if(P.extension?.identifier){const M=this.#i.onExtensionError(P.extension.identifier,N);this._logService.trace("forwarded error to extension?",M,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.toErrorMessage)(N)),this.id=v,this.source=P.extension?.displayName??P.extension?.name}}}finally{this._reportTelemetry(P,v,z.elapsed())}}_reportTelemetry(v,_,C){v.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:v.extension.identifier.value,id:new o.TelemetryTrustedValue(_),duration:C})}$executeContributedCommand(v,..._){this._logService.trace("ExtHostCommands#$executeContributedCommand",v);const C=this._commands.get(v);return C?(_=_.map(P=>this._argumentProcessors.reduce((k,F)=>F.processArgument(k,C.extension?.identifier),P)),this._executeContributedCommand(v,_,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this._logService.trace("ExtHostCommands#getCommands",v),this.#e.$getCommands().then(_=>(v&&(_=_.filter(C=>C[0]!=="_")),_))}$getContributedCommandMetadata(){const v=Object.create(null);for(const[_,C]of this._commands){const{metadata:P}=C;P&&(v[_]=P)}return Promise.resolve(v)}};e.ExtHostCommands=r,e.ExtHostCommands=r=Ge([Ue(0,d.IExtHostRpcService),Ue(1,m.ILogService),Ue(2,t.IExtHostTelemetry)],r),e.IExtHostCommands=(0,E.createDecorator)("IExtHostCommands");class c{constructor(v,_,C){this._commands=v,this._lookupApiCommand=_,this._logService=C,this.delegatingCommandId=`__vsc${(0,u.generateUuid)()}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(v,_){if(!v)return;const C={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return C;const P=this._lookupApiCommand(v.command);if(P)C.id=P.internalId,C.arguments=P.args.map((k,F)=>k.convert(v.arguments&&v.arguments[F]));else if((0,b.isNonEmptyArray)(v.arguments)){const k=`${v.command} /${++this._cachIdPool}`;this._cache.set(k,v),_.add((0,S.toDisposable)(()=>{this._cache.delete(k),this._logService.trace("CommandsConverter#DISPOSE",k)})),C.$ident=k,C.id=this.delegatingCommandId,C.arguments=[k],this._logService.trace("CommandsConverter#CREATE",v.command,k)}return C}fromInternal(v){return typeof v.$ident=="string"?this._cache.get(v.$ident):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this._cache.get(v[0])}_executeConvertedCommand(...v){const _=this.getActualCommand(...v);return this._logService.trace("CommandsConverter#EXECUTE",v[0],_?_.command:"MISSING"),_?this._commands.executeCommand(_.command,..._.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${v[0]}`)}}e.CommandsConverter=c;class s{static{this.Uri=new s("uri","Uri of a text document",v=>p.URI.isUri(v),v=>v)}static{this.Position=new s("position","A position in a text document",v=>O.Position.isPosition(v),L.Position.from)}static{this.Range=new s("range","A range in a text document",v=>O.Range.isRange(v),L.Range.from)}static{this.Selection=new s("selection","A selection in a text document",v=>O.Selection.isSelection(v),L.Selection.from)}static{this.Number=new s("number","",v=>typeof v=="number",v=>v)}static{this.String=new s("string","",v=>typeof v=="string",v=>v)}static{this.StringArray=s.Arr(s.String)}static Arr(v){return new s(`${v.name}_array`,`Array of ${v.name}, ${v.description}`,_=>Array.isArray(_)&&_.every(C=>v.validate(C)),_=>_.map(C=>v.convert(C)))}static{this.CallHierarchyItem=new s("item","A call hierarchy item",v=>v instanceof O.CallHierarchyItem,L.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new s("item","A type hierarchy item",v=>v instanceof O.TypeHierarchyItem,L.TypeHierarchyItem.from)}static{this.TestItem=new s("testItem","A VSCodium TestItem",v=>v instanceof f.TestItemImpl,L.TestItem.from)}constructor(v,_,C,P){this.name=v,this.description=_,this.validate=C,this.convert=P}optional(){return new s(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,_){return new s(v??this.name,_??this.description,this.validate,this.convert)}}e.ApiCommandArgument=s;class w{static{this.Void=new w("no result",v=>v)}constructor(v,_){this.description=v,this.convert=_}}e.ApiCommandResult=w;class g{constructor(v,_,C,P,k){this.id=v,this.internalId=_,this.description=C,this.args=P,this.result=k}}e.ApiCommand=g}),define(_e[355],Ce([1,0,19,15,2,84,135,38,34,16,8]),function(ue,e,h,O,L,A,R,b,m,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const I=[new m.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",S(y.DocumentHighlight.to))),new m.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,f)=>{if((0,h.isFalsyOrEmpty)(d))return;class a extends T.SymbolInformation{static to(n){const l=new a(n.name,y.SymbolKind.to(n.kind),n.containerName||"",new T.Location(f[0],y.Range.to(n.range)));return l.detail=n.detail,l.range=l.location.range,l.selectionRange=y.Range.to(n.selectionRange),l.children=n.children?n.children.map(a.to):[],l}}return d.map(a.to)})),new m.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",S(y.TextEdit.to))),new m.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range,new m.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",S(y.TextEdit.to))),new m.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,new m.ApiCommandArgument("ch","Trigger character",d=>typeof d=="string",d=>d),new m.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",S(y.TextEdit.to))),new m.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new m.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new m.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new m.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new m.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location-instances.",S(y.location.to))),new m.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Hover-instances.",S(y.Hover.to))),new m.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("position","A position in a text document",d=>Array.isArray(d)&&d.every(f=>T.Position.isPosition(f)),d=>d.map(y.Position.from))],new m.ApiCommandResult("A promise that resolves to an array of ranges.",d=>d.map(f=>{let a;for(const i of f.reverse())a=new T.SelectionRange(y.Range.to(i),a);return a}))),new m.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.ApiCommandArgument.String.with("query","Search string")],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",d=>d.map(y.WorkspaceSymbol.to))),new m.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",d=>d.map(y.CallHierarchyItem.to))),new m.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",d=>d.map(y.CallHierarchyIncomingCall.to))),new m.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",d=>d.map(y.CallHierarchyOutgoingCall.to))),new m.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to a range and placeholder text.",d=>{if(d)return{range:y.Range.to(d.range),placeholder:d.text}})),new m.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("newName","The new symbol name")],new m.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",d=>{if(d){if(d.rejectReason)throw new Error(d.rejectReason);return y.WorkspaceEdit.to(d)}})),new m.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(y.DocumentLink.to))),new m.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(d)return new T.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const f=(0,R.decodeSemanticTokensDto)(d);if(f.type==="full")return new T.SemanticTokens(f.data,void 0)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range.optional()],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(d)return new T.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const f=(0,R.decodeSemanticTokensDto)(d);if(f.type==="full")return new T.SemanticTokens(f.data,void 0)})),new m.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(d,f,a)=>{if(!d)return new T.CompletionList([]);const i=d.suggestions.map(n=>y.CompletionItem.to(n,a));return new T.CompletionList(i,d.incomplete)})),new m.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.ApiCommandResult("A promise that resolves to SignatureHelp.",d=>{if(d)return y.SignatureHelp.to(d)})),new m.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(d,f,a)=>S(i=>new T.CodeLens(y.Range.to(i.range),i.command&&a.fromInternal(i.command)))(d))),new m.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>T.Range.isRange(d),d=>T.Selection.isSelection(d)?y.Selection.from(d):y.Range.from(d)),m.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.ApiCommandResult("A promise that resolves to an array of Command-instances.",(d,f,a)=>S(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(i.command)}else{const n=new T.CodeAction(i.title,i.kind?new T.CodeActionKind(i.kind):void 0);return i.edit&&(n.edit=y.WorkspaceEdit.to(i.edit)),i.command&&(n.command=a.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(d))),new m.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(f=>new T.ColorInformation(y.Range.to(f.range),y.Color.to(f.color))):[])),new m.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.ApiCommandArgument("color","The color to show and insert",d=>d instanceof T.Color,y.Color.from),new m.ApiCommandArgument("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:y.Range.from(d.range)}))],new m.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(y.ColorPresentation.to):[])),new m.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to an array of Inlay objects",(d,f,a)=>d.map(y.InlayHint.to.bind(void 0,a)))),new m.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(d,f)=>{if(d)return d.map(y.FoldingRange.to)})),new m.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",S(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(f=>y.NotebookExclusiveDocumentPattern.to(f))})))),new m.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range,new m.ApiCommandArgument("context","An InlineValueContext",d=>d&&typeof d.frameId=="number"&&d.stoppedLocation instanceof T.Range,d=>y.InlineValueContext.from(d))],new m.ApiCommandResult("A promise that resolves to an array of InlineValue objects",d=>d.map(y.InlineValue.to))),new m.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",d=>L.URI.isUri(d)||typeof d=="string"&&(0,O.matchesSomeScheme)(d,O.Schemas.http,O.Schemas.https),d=>d),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[y.ViewColumn.from(d),void 0]:[y.ViewColumn.from(d.viewColumn),y.TextEditorOpenOptions.from(d)])).optional(),m.ApiCommandArgument.String.with("label","").optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.ApiCommandArgument.Uri.with("resource","Resource to open"),m.ApiCommandArgument.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VSCodium's default text editor"),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[y.ViewColumn.from(d),void 0]:[y.ViewColumn.from(d.viewColumn),y.TextEditorOpenOptions.from(d)])).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),m.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),m.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[y.ViewColumn.from(d.viewColumn),y.TextEditorOpenOptions.from(d)]).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.ApiCommandArgument.String.with("title","Human readable title for the changes editor"),new m.ApiCommandArgument("resourceList","List of resources to compare",d=>{for(const f of d){if(f.length!==3)return!1;const[a,i,n]=f;if(!L.URI.isUri(a)||!L.URI.isUri(i)&&i!==void 0&&i!==null||!L.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},d=>d)],m.ApiCommandResult.Void),new m.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(y.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(y.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(y.TypeHierarchyItem.to))),new m.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.ApiCommandArgument.TestItem],m.ApiCommandResult.Void),new m.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.ApiCommandResult.Void),new m.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.ApiCommandArgument.String.with("name","The context key name"),new m.ApiCommandArgument("value","The context key value",()=>!0,d=>d)],m.ApiCommandResult.Void),new m.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.StringArray,new m.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",d=>y.MappedEditsContext.is(d),d=>y.MappedEditsContext.from(d))],new m.ApiCommandResult("A promise that resolves to a workspace edit or null",d=>d?y.WorkspaceEdit.to(d):null))];class p{static register(f){I.forEach(f.registerApiCommand,f),this._registerValidateWhenClausesCommand(f)}static _registerValidateWhenClausesCommand(f){f.registerCommand(!1,"_validateWhenClauses",b.validateWhenClauses)}}e.ExtHostApiCommands=p;function S(d){return f=>{if(Array.isArray(f))return f.map(d)}}function E(d){if(!Array.isArray(d))return;const f=[];for(const a of d)A.isLocationLink(a)?f.push(y.DefinitionLink.to(a)):f.push(y.location.to(a));return f}}),define(_e[356],Ce([1,0,7,3,2,6,34,16,8]),function(ue,e,h,O,L,A,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class y{static{this._pool=0}constructor(S,E){this.extension=S,this.provider=E,this.handle=y._pool++}}class T{constructor(S){this.session=S,this.responses=[]}}class I{static{this._nextId=0}constructor(S,E,d,f){this._documents=d,this._logService=f,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=S.getProxy(A.MainContext.MainThreadInlineChat),E.registerApiCommand(new R.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new R.ApiCommandArgument("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?b.Range.from(a.initialRange):void 0,initialSelection:m.Selection.isSelection(a.initialSelection)?b.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?b.Position.from(a.position):void 0}})],R.ApiCommandResult.Void))}registerProvider(S,E,d){const f=new y(S,E);return this._inputProvider.set(f.handle,f),this._proxy.$registerInteractiveEditorProvider(f.handle,d?.label??S.displayName??S.name,S.identifier,typeof E.handleInteractiveEditorResponseFeedback=="function",typeof E.provideFollowups=="function",d?.supportReportIssue??!1),(0,O.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(f.handle),this._inputProvider.delete(f.handle)})}async $prepareSession(S,E,d,f){const a=this._inputProvider.get(S);if(!a){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this._documents.getDocument(L.URI.revive(E)),n=b.Selection.to(d),l=await a.provider.prepareInteractiveEditorSession({document:i,selection:n},f);if(!l)return;if(l.wholeRange&&!l.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const o=I._nextId++;return this._inputSessions.set(o,new T(l)),{id:o,placeholder:l.placeholder,input:l.input,slashCommands:l.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:b.Range.from(l.wholeRange),message:l.message}}async $provideResponse(S,E,d,f){const a=this._inputProvider.get(S);if(!a)return;const i=this._inputSessions.get(E.id);if(!i)return;const n={prompt:d.prompt,selection:b.Selection.to(d.selection),wholeRange:b.Range.to(d.wholeRange),attempt:d.attempt,live:d.live,previewDocument:this._documents.getDocument(L.URI.revive(d.previewDocument)),withIntentDetection:d.withIntentDetection};let l=!1;const o={report:async D=>{if(!d.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");l||f.isCancellationRequested||await this._proxy.$handleProgressChunk(d.requestId,{message:D.message,edits:D.edits?.map(b.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:m.MarkdownString.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(a.provider.provideInteractiveEditorResponse(i.session,n,o,f));let u;try{u=await(0,h.raceCancellation)(t,f)}finally{l=!0}if(!u)return;const r=i.responses.push(u)-1,c={wholeRange:b.Range.from(u.wholeRange),placeholder:u.placeholder};if(!I._isEditResponse(u))return{...c,id:r,type:"editorEdit",message:b.MarkdownString.from(u.contents),edits:[]};const{edits:s,contents:w}=u,g=w!==void 0?b.MarkdownString.from(w):void 0;return s instanceof m.WorkspaceEdit?{...c,id:r,type:"bulkEdit",edits:b.WorkspaceEdit.from(s),message:g}:{...c,id:r,type:"editorEdit",edits:s.map(b.TextEdit.from),message:g}}async $provideFollowups(S,E,d,f){const a=this._inputProvider.get(S),i=this._inputSessions.get(E),n=i?.responses[d];if(a&&n&&a.provider.provideFollowups){const l=Promise.resolve(a.provider.provideFollowups(i.session,n,f));return(await(0,h.raceCancellation)(l,f))?.map(b.ChatInlineFollowup.from)}}$handleFeedback(S,E,d,f){const a=this._inputProvider.get(S),i=this._inputSessions.get(E),n=i?.responses[d];if(a&&n){const l=b.InteractiveEditorResponseFeedbackKind.to(f);a.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,l)}}$releaseSession(S,E){}static _isEditResponse(S){return typeof S=="object"&&typeof S.edits=="object"}}e.ExtHostInteractiveEditor=I}),define(_e[357],Ce([1,0,2,34]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class L{constructor(R,b,m,y,T){this._extHostNotebooks=b,this._textDocumentsAndEditors=m,this._commands=y;const I=new O.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.ApiCommandArgument("showOptions","Show Options",p=>!0,p=>p),new O.ApiCommandArgument("resource","Interactive resource Uri",p=>!0,p=>p),new O.ApiCommandArgument("controllerId","Notebook controller Id",p=>!0,p=>p),new O.ApiCommandArgument("title","Interactive editor title",p=>!0,p=>p)],new O.ApiCommandResult("Notebook and input URI",p=>{if(T.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const S=this._extHostNotebooks.getEditorById(p.notebookEditorId);return T.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:h.URI.revive(p.notebookUri),inputUri:h.URI.revive(p.inputUri),notebookEditor:S.apiEditor}}return T.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:h.URI.revive(p.notebookUri),inputUri:h.URI.revive(p.inputUri)}}));this._commands.registerApiCommand(I)}$willAddInteractiveDocument(R,b,m,y){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:m,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,b){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=L}),define(_e[358],Ce([1,0,19,7,22,4,3,27,2,25,11,6,34,16,8,114,302,26,48,303]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0,e.createKernelId=s;let l=class{constructor(g,D,v,_,C){this._initData=D,this._extHostNotebook=v,this._commands=_,this._logService=C,this._activeExecutions=new b.ResourceMap,this._activeNotebookExecutions=new b.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this.id=0,this.variableStore={},this._proxy=g.getProxy(I.MainContext.MainThreadNotebookKernels);const P=new p.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.ApiCommandArgument("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const x=this._extHostNotebook.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:x}}else if(F&&"notebookEditor"in F){const x=this._extHostNotebook.getIdByEditor(F.notebookEditor);if(x===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:x}}return F})],p.ApiCommandResult.Void),k=new p.ApiCommand("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of variables",(F,x)=>F.map(z=>({variable:{name:z.name,value:z.value,expression:z.expression,type:z.type,language:z.language},hasNamedChildren:z.hasNamedChildren,indexedChildrenCount:z.indexedChildrenCount}))));this._commands.registerApiCommand(P),this._commands.registerApiCommand(k)}createNotebookController(g,D,v,_,C,P){for(const le of this._kernelData.values())if(le.controller.id===D&&y.ExtensionIdentifier.equals(g.identifier,le.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const k=this._handlePool++,F=this;this._logService.trace(`NotebookController[${k}], CREATED by ${g.identifier.value}, ${D}`);const x=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${g.identifier}'`);let z=!1;const N=new A.Emitter,M=new A.Emitter,W={id:s(g.identifier,D),notebookType:v,extensionId:g.identifier,extensionLocation:g.extensionLocation,label:_||g.identifier.value,preloads:P?P.map(S.NotebookRendererScript.from):[]};let X=C??x,te,H;this._proxy.$addKernel(k,W).catch(le=>{console.log(le),z=!0});let G=0;const Y=()=>{if(z)return;const le=++G;Promise.resolve().then(()=>{le===G&&this._proxy.$updateKernel(k,W)})},ne=new b.ResourceMap,pe={get id(){return D},get notebookType(){return W.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return W.label},set label(le){W.label=le??g.displayName??g.name,Y()},get detail(){return W.detail??""},set detail(le){W.detail=le,Y()},get description(){return W.description??""},set description(le){W.description=le,Y()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages(le){W.supportedLanguages=le,Y()},get supportsExecutionOrder(){return W.supportsExecutionOrder??!1},set supportsExecutionOrder(le){W.supportsExecutionOrder=le,Y()},get rendererScripts(){return W.preloads?W.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return X},set executeHandler(le){X=le??x},get interruptHandler(){return te},set interruptHandler(le){te=le,W.supportsInterrupt=!!le,Y()},set variableProvider(le){(0,a.checkProposedApiEnabled)(g,"notebookVariableProvider"),H=le,W.hasVariableProvider=!!le,le?.onDidChangeVariables(we=>F._proxy.$variablesUpdated(we.uri)),Y()},get variableProvider(){return H},createNotebookCellExecution(le){if(z)throw new Error("notebook controller is DISPOSED");if(!ne.has(le.notebook.uri))throw F._logService.trace(`NotebookController[${k}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${le.notebook.uri.toString()}`);return F._createNotebookCellExecution(le,s(g.identifier,this.id))},createNotebookExecution(le){if((0,a.checkProposedApiEnabled)(g,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!ne.has(le.uri))throw F._logService.trace(`NotebookController[${k}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${le.uri.toString()}`);return F._createNotebookExecution(le,s(g.identifier,this.id))},dispose:()=>{z||(this._logService.trace(`NotebookController[${k}], DISPOSED`),z=!0,this._kernelData.delete(k),N.dispose(),M.dispose(),this._proxy.$removeKernel(k))},updateNotebookAffinity(le,we){we===E.NotebookControllerAffinity2.Hidden&&(0,a.checkProposedApiEnabled)(g,"notebookControllerAffinityHidden"),F._proxy.$updateNotebookPriority(k,le.uri,we)},onDidReceiveMessage:M.event,postMessage(le,we){return(0,a.checkProposedApiEnabled)(g,"notebookMessaging"),F._proxy.$postMessage(k,we&&F._extHostNotebook.getIdByEditor(we),le)},asWebviewUri(le){return(0,a.checkProposedApiEnabled)(g,"notebookMessaging"),(0,d.asWebviewUri)(le,F._initData.remote)}};return this._kernelData.set(k,{extensionId:g.identifier,controller:pe,onDidReceiveMessage:M,onDidChangeSelection:N,associatedNotebooks:ne}),pe}getIdByController(g){for(const[D,v]of this._kernelData)if(v.controller===g)return s(v.extensionId,g.id);return null}createNotebookControllerDetectionTask(g,D){const v=this._kernelDetectionTaskHandlePool++,_=this;this._logService.trace(`NotebookControllerDetectionTask[${v}], CREATED by ${g.identifier.value}`),this._proxy.$addKernelDetectionTask(v,D);const C={dispose:()=>{this._kernelDetectionTask.delete(v),_._proxy.$removeKernelDetectionTask(v)}};return this._kernelDetectionTask.set(v,C),C}registerKernelSourceActionProvider(g,D,v){const _=this._kernelSourceActionProviderHandlePool++,C=typeof v.onDidChangeNotebookKernelSourceActions=="function"?_:void 0,P=this;this._kernelSourceActionProviders.set(_,v),this._logService.trace(`NotebookKernelSourceActionProvider[${_}], CREATED by ${g.identifier.value}`),this._proxy.$addKernelSourceActionProvider(_,_,D);let k;return C!==void 0&&(k=v.onDidChangeNotebookKernelSourceActions(F=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(C))),{dispose:()=>{this._kernelSourceActionProviders.delete(_),P._proxy.$removeKernelSourceActionProvider(_,_),k?.dispose()}}}async $provideKernelSourceActions(g,D){const v=this._kernelSourceActionProviders.get(g);if(v){const _=new R.DisposableStore;return(await v.provideNotebookKernelSourceActions(D)??[]).map(P=>S.NotebookKernelSourceAction.from(P,this._commands.converter,_))}return[]}$acceptNotebookAssociation(g,D,v){const _=this._kernelData.get(g);if(_){const C=this._extHostNotebook.getNotebookDocument(m.URI.revive(D));v?_.associatedNotebooks.set(C.uri,!0):_.associatedNotebooks.delete(C.uri),this._logService.trace(`NotebookController[${g}] ASSOCIATE notebook`,C.uri.toString(),v),_.onDidChangeSelection.fire({selected:v,notebook:C.apiNotebook})}}async $executeCells(g,D,v){const _=this._kernelData.get(g);if(!_)return;const C=this._extHostNotebook.getNotebookDocument(m.URI.revive(D)),P=[];for(const k of v){const F=C.getCell(k);F&&P.push(F.apiCell)}try{this._logService.trace(`NotebookController[${g}] EXECUTE cells`,C.uri.toString(),P.length),await _.controller.executeHandler.call(_.controller,P,C.apiNotebook,_.controller)}catch(k){this._logService.error(`NotebookController[${g}] execute cells FAILED`,k),console.error(k)}}async $cancelCells(g,D,v){const _=this._kernelData.get(g);if(!_)return;const C=this._extHostNotebook.getNotebookDocument(m.URI.revive(D));if(_.controller.interruptHandler)await _.controller.interruptHandler.call(_.controller,C.apiNotebook);else for(const P of v){const k=C.getCell(P);k&&this._activeExecutions.get(k.uri)?.cancel()}if(_.controller.interruptHandler){const P=this._activeNotebookExecutions.get(C.uri);v.length&&Array.isArray(P)&&P.length&&P.forEach(k=>k.dispose())}}async $provideVariables(g,D,v,_,C,P,k){const F=this._kernelData.get(g);if(!F)return;const x=this._extHostNotebook.getNotebookDocument(m.URI.revive(v)),z=F.controller.variableProvider;if(!z)return;let N;if(_!==void 0){if(N=this.variableStore[_],!N)return}else this.variableStore={};const M=C==="named"?E.NotebookVariablesRequestKind.Named:E.NotebookVariablesRequestKind.Indexed,W=z.provideVariables(x.apiNotebook,N,M,P,k);let X=0;for await(const te of W){if(k.isCancellationRequested)return;const H={id:this.id++,name:te.variable.name,value:te.variable.value,type:te.variable.type,interfaces:te.variable.interfaces,language:te.variable.language,expression:te.variable.expression,hasNamedChildren:te.hasNamedChildren,indexedChildrenCount:te.indexedChildrenCount,extensionId:F.extensionId.value};if(this.variableStore[H.id]=te.variable,this._proxy.$receiveVariable(D,H),X++>=n.variablePageSize)return}}$acceptKernelMessageFromRenderer(g,D,v){const _=this._kernelData.get(g);if(!_)return;const C=this._extHostNotebook.getEditorById(D);_.onDidReceiveMessage.fire(Object.freeze({editor:C.apiEditor,message:v}))}$cellExecutionChanged(g,D,v){const C=this._extHostNotebook.getNotebookDocument(m.URI.revive(g)).getCell(D);if(C){const P=v?S.NotebookCellExecutionState.to(v):E.NotebookCellExecutionState.Idle;P!==void 0&&this._onDidChangeCellExecutionState.fire({cell:C.apiCell,state:P})}}_createNotebookCellExecution(g,D){if(g.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const _=this._extHostNotebook.getNotebookDocument(g.notebook.uri).getCellFromApiCell(g);if(!_)throw new Error("invalid cell");if(this._activeExecutions.has(_.uri))throw new Error(`duplicate execution for ${_.uri}`);const C=new t(D,_,this._proxy);this._activeExecutions.set(_.uri,C);const P=C.onDidChangeState(()=>{C.state===o.Resolved&&(C.dispose(),P.dispose(),this._activeExecutions.delete(_.uri))});return C.asApiObject()}_createNotebookExecution(g,D){const v=this._extHostNotebook.getNotebookDocument(g.uri),_=g.getCells().find(k=>{const F=v.getCellFromApiCell(k);return F&&this._activeExecutions.has(F.uri)});if(_)throw new Error(`duplicate cell execution for ${_.document.uri}`);if(this._activeNotebookExecutions.has(v.uri))throw new Error(`duplicate notebook execution for ${v.uri}`);const C=new r(D,v,this._proxy),P=C.onDidChangeState(()=>{C.state===u.Resolved&&(C.dispose(),P.dispose(),this._activeNotebookExecutions.delete(v.uri))});return this._activeNotebookExecutions.set(v.uri,[C,P]),C.asApiObject()}};e.ExtHostNotebookKernels=l,e.ExtHostNotebookKernels=l=Ge([Ue(4,T.ILogService)],l);var o;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(o||(o={}));class t extends R.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(g,D,v){super(),this._cell=D,this._proxy=v,this._handle=t.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new L.CancellationTokenSource),this._collector=new c(10,_=>this.update(_)),this._executionOrder=D.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,g,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(g){await this._collector.addItem(g)}async update(g){const D=Array.isArray(g)?g:[g];return this._proxy.$updateExecution(this._handle,new i.SerializableObjectWithBuffers(D))}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(g){let D=this._cell;if(g&&(D=this._cell.notebook.getCellFromApiCell(g)),!D)throw new Error("INVALID cell");return D.handle}validateAndConvertOutputs(g){return g.map(D=>{const v=E.NotebookCellOutput.ensureUniqueMimeTypes(D.items,!0);return v===D.items?S.NotebookCellOutput.from(D):S.NotebookCellOutput.from({items:v,id:D.id,metadata:D.metadata})})}async updateOutputs(g,D,v){const _=this.cellIndexToHandle(D),C=this.validateAndConvertOutputs((0,h.asArray)(g));return this.updateSoon({editType:f.CellExecutionUpdateType.Output,cellHandle:_,append:v,outputs:C})}async updateOutputItems(g,D,v){return g=E.NotebookCellOutput.ensureUniqueMimeTypes((0,h.asArray)(g),!0),this.updateSoon({editType:f.CellExecutionUpdateType.OutputItems,items:g.map(S.NotebookCellOutputItem.from),outputId:D.id,append:v})}asApiObject(){const g=this;return Object.freeze({get token(){return g._tokenSource.token},get cell(){return g._cell.apiCell},get executionOrder(){return g._executionOrder},set executionOrder(v){g._executionOrder=v,g.update([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:g._executionOrder}])},start(v){if(g._state===o.Resolved||g._state===o.Started)throw new Error("Cannot call start again");g._state=o.Started,g._onDidChangeState.fire(),g.update({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:v})},end(v,_,C){if(g._state===o.Resolved)throw new Error("Cannot call resolve twice");g._state=o.Resolved,g._onDidChangeState.fire(),g._collector.flush();const P=C?{message:C.message,stack:C.stack,location:C?.location?{startLineNumber:C.location.start.line,startColumn:C.location.start.character,endLineNumber:C.location.end.line,endColumn:C.location.end.character}:void 0,uri:C.uri}:void 0;g._proxy.$completeExecution(g._handle,new i.SerializableObjectWithBuffers({runEndTime:_,lastRunSuccess:v,error:P}))},clearOutput(v){return g.verifyStateForOutput(),g.updateOutputs([],v,!1)},appendOutput(v,_){return g.verifyStateForOutput(),g.updateOutputs(v,_,!0)},replaceOutput(v,_){return g.verifyStateForOutput(),g.updateOutputs(v,_,!1)},appendOutputItems(v,_){return g.verifyStateForOutput(),g.updateOutputItems(v,_,!0)},replaceOutputItems(v,_){return g.verifyStateForOutput(),g.updateOutputItems(v,_,!1)}})}}var u;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(u||(u={}));class r extends R.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(g,D,v){super(),this._notebook=D,this._proxy=v,this._handle=r.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=u.Init,this._tokenSource=this._register(new L.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,g,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===u.Resolved||this._state===u.Started)throw new Error("Cannot call start again");this._state=u.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===u.Resolved)throw new Error("Cannot call resolve twice");this._state=u.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class c{constructor(g,D){this.delay=g,this.callback=D,this.batch=[],this.startedTimer=Date.now()}addItem(g){return this.batch.push(g),this.currentDeferred||(this.currentDeferred=new O.DeferredPromise,this.startedTimer=Date.now(),(0,O.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const g=this.currentDeferred;this.currentDeferred=void 0;const D=this.batch;return this.batch=[],this.callback(D).finally(()=>g.complete())}}function s(w,g){return`${w.value}/${g}`}}),define(_e[43],Ce([1,0,4,6,5,2,20,3,8,232,13,279,22,30,280,50,7,16,34]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,L.createDecorator)("IExtHostTerminalService");class n extends b.Disposable{constructor(v,_,C,P){super(),this._proxy=v,this._id=_,this._creationOptions=C,this._name=P,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._onWillDispose=this._register(new h.Emitter),this.onWillDispose=this._onWillDispose.event,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(F=>this._pidPromiseComplete=F);const k=this;this.value={get name(){return k._name||""},get processId(){return k._pidPromise},get creationOptions(){return k._creationOptions},get exitStatus(){return k._exitStatus},get state(){return k._state},get selection(){return k._selection},get shellIntegration(){return k.shellIntegration},sendText(F,x=!0){k._checkDisposed(),k._proxy.$sendText(k._id,F,x)},show(F){k._checkDisposed(),k._proxy.$show(k._id,F)},hide(){k._checkDisposed(),k._proxy.$hide(k._id)},dispose(){k._disposed||(k._disposed=!0,k._proxy.$dispose(k._id))},get dimensions(){if(!(k._cols===void 0||k._rows===void 0))return{columns:k._cols,rows:k._rows}}}}dispose(){this._onWillDispose.fire(),super.dispose()}async create(v,_){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:v.name,shellPath:v.shellPath??void 0,shellArgs:v.shellArgs??void 0,cwd:v.cwd??_?.cwd??void 0,env:v.env??void 0,icon:s(v.iconPath)??void 0,color:d.ThemeColor.isThemeColor(v.color)?v.color.id:void 0,initialText:v.message??void 0,strictEnv:v.strictEnv??void 0,hideFromUser:v.hideFromUser??void 0,forceShellIntegration:_?.forceShellIntegration??void 0,isFeatureTerminal:_?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:_?.useShellEnvironment??void 0,location:_?.location||this._serializeParentTerminal(v.location,_?.resolvedExtHostIdentifier),isTransient:v.isTransient??void 0})}async createExtensionTerminal(v,_,C,P,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:P,color:d.ThemeColor.isThemeColor(k)?k.id:void 0,location:_?.location||this._serializeParentTerminal(v,C),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(v,_){return typeof v=="object"?"parentTerminal"in v&&v.parentTerminal&&_?{parentTerminal:_}:"viewColumn"in v?{viewColumn:a.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus}:void 0:v}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(v){this._name=v}setExitStatus(v,_){this._exitStatus=Object.freeze({code:v,reason:_})}setDimensions(v,_){return v===this._cols&&_===this._rows||v===0||_===0?!1:(this._cols=v,this._rows=_,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(v){this._selection=v}_setProcessId(v){this._pidPromiseComplete?(this._pidPromiseComplete(v),this._pidPromiseComplete=void 0):this._pidPromise.then(_=>{_!==v&&(this._pidPromise=Promise.resolve(v))})}}e.ExtHostTerminal=n;class l{get onProcessReady(){return this._onProcessReady.event}constructor(v){this._pty=v,this.id=0,this.shouldPersist=!1,this._onProcessData=new h.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new h.Emitter,this._onDidChangeProperty=new h.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new h.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(v){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${v}`)}updateProperty(v,_){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${v}, value: ${_}`)}async start(){}shutdown(){this._pty.close()}input(v){this._pty.handleInput?.(v)}resize(v,_){this._pty.setDimensions?.({columns:v,rows:_})}clearBuffer(){}async processBinary(v){}acknowledgeDataEvent(v){}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(v){this._pty.onDidWrite(_=>this._onProcessData.fire(_)),this._pty.onDidClose?.((_=void 0)=>{this._onProcessExit.fire(_===void 0?void 0:_)}),this._pty.onDidOverrideDimensions?.(_=>{_&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:_.columns,rows:_.rows}})}),this._pty.onDidChangeName?.(_=>{this._onDidChangeProperty.fire({type:"title",value:_})}),this._pty.open(v||void 0),v&&this._pty.setDimensions?.(v),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let o=1,t=class extends b.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(v=>v.value)}constructor(v,_,C){super(),this._extHostCommands=_,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new b.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new h.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new h.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new h.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new h.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new h.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new h.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new h.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new h.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=C.getProxy(O.MainContext.MainThreadTerminalService),this._bufferer=new E.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(v),this._extHostCommands.registerArgumentProcessor({processArgument:P=>{const k=F=>{const x=F;return this.getTerminalById(x.instanceId)?.value};switch(P?.$mid){case 15:return k(P);default:{if(Array.isArray(P))for(let F=0;F<P.length&&P[F].$mid===15;F++)P[F]=k(P[F]);return P}}}}),this._register({dispose:()=>{for(const[P,k]of this._terminalProcesses)k.shutdown(!0)}})}getDefaultShell(v){return(v?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(v){return(v?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(v,_){const C=new n(this._proxy,(0,S.generateUuid)(),v,v.name),P=new l(v.pty);return C.createExtensionTerminal(v.location,_,this._serializeParentTerminal(v,_).resolvedExtHostIdentifier,s(v.iconPath),w(v.color)).then(k=>{const F=this._setupExtHostProcessListeners(k,P);this._terminalProcessDisposables[k]=F}),this._terminals.push(C),C.value}_serializeParentTerminal(v,_){if(_=_||{},v.location&&typeof v.location=="object"&&"parentTerminal"in v.location){const C=v.location.parentTerminal;if(C){const P=this._terminals.find(k=>k.value===C);P&&(_.resolvedExtHostIdentifier=P._id)}}else v.location&&typeof v.location!="object"?_.location=v.location:_.location&&typeof _.location=="object"&&"splitActiveTerminal"in _.location&&(_.location={splitActiveTerminal:!0});return _}attachPtyToTerminal(v,_){if(!this.getTerminalById(v))throw new Error(`Cannot resolve terminal with id ${v} for virtual process`);const P=new l(_),k=this._setupExtHostProcessListeners(v,P);this._terminalProcessDisposables[v]=k}async $acceptActiveTerminalChanged(v){const _=this._activeTerminal;if(v===null){this._activeTerminal=void 0,_!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const C=this.getTerminalById(v);C&&(this._activeTerminal=C,_!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(v,_){const C=this.getTerminalById(v);C&&this._onDidWriteTerminalData.fire({terminal:C.value,data:_})}async $acceptTerminalDimensions(v,_,C){const P=this.getTerminalById(v);P&&P.setDimensions(_,C)&&this._onDidChangeTerminalDimensions.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(v,_){const C=this.getTerminalById(v);C&&this._onDidExecuteCommand.fire({terminal:C.value,..._})}async $acceptTerminalMaximumDimensions(v,_,C){this._terminalProcesses.get(v)?.resize(_,C)}async $acceptTerminalTitleChange(v,_){const C=this.getTerminalById(v);C&&(C.name=_)}async $acceptTerminalClosed(v,_,C){const P=this._getTerminalObjectIndexById(this._terminals,v);if(P!==null){const k=this._terminals.splice(P,1)[0];k.setExitStatus(_,C),this._onDidCloseTerminal.fire(k.value)}}$acceptTerminalOpened(v,_,C,P){if(_){const x=this._getTerminalObjectIndexById(this._terminals,_);if(x!==null){this._terminals[x]._id=v,this._onDidOpenTerminal.fire(this.terminals[x]),this._terminals[x].isOpen=!0;return}}const k={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:A.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},F=new n(this._proxy,v,k,C);this._terminals.push(F),this._onDidOpenTerminal.fire(F.value),F.isOpen=!0}async $acceptTerminalProcessId(v,_){this.getTerminalById(v)?._setProcessId(_)}async $startExtensionTerminal(v,_){const C=this.getTerminalById(v);if(!C)return{message:(0,y.localize)(0,null,v)};C.isOpen||await new Promise(k=>{const F=this.onDidOpenTerminal(async x=>{x===C.value&&(F.dispose(),k())})});const P=this._terminalProcesses.get(v);P?P.startSendingEvents(_):this._extensionTerminalAwaitingStart[v]={initialDimensions:_}}_setupExtHostProcessListeners(v,_){const C=new b.DisposableStore;C.add(_.onProcessReady(k=>this._proxy.$sendProcessReady(v,k.pid,k.cwd,k.windowsPty))),C.add(_.onDidChangeProperty(k=>this._proxy.$sendProcessProperty(v,k))),this._bufferer.startBuffering(v,_.onProcessData),C.add(_.onProcessExit(k=>this._onProcessExit(v,k))),this._terminalProcesses.set(v,_);const P=this._extensionTerminalAwaitingStart[v];return P&&_ instanceof l&&(_.startSendingEvents(P.initialDimensions),delete this._extensionTerminalAwaitingStart[v]),C}$acceptProcessAckDataEvent(v,_){this._terminalProcesses.get(v)?.acknowledgeDataEvent(_)}$acceptProcessInput(v,_){this._terminalProcesses.get(v)?.input(_)}$acceptTerminalInteraction(v){const _=this.getTerminalById(v);_?.setInteractedWith()&&this._onDidChangeTerminalState.fire(_.value)}$acceptTerminalSelection(v,_){this.getTerminalById(v)?.setSelection(_)}$acceptProcessResize(v,_,C){try{this._terminalProcesses.get(v)?.resize(_,C)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(v,_){this._terminalProcesses.get(v)?.shutdown(_)}$acceptProcessRequestInitialCwd(v){this._terminalProcesses.get(v)?.getInitialCwd().then(_=>this._proxy.$sendProcessProperty(v,{type:"initialCwd",value:_}))}$acceptProcessRequestCwd(v){this._terminalProcesses.get(v)?.getCwd().then(_=>this._proxy.$sendProcessProperty(v,{type:"cwd",value:_}))}$acceptProcessRequestLatency(v){return Promise.resolve(v)}registerLinkProvider(v){return this._linkProviders.add(v),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new m.Disposable(()=>{this._linkProviders.delete(v),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(v,_,C){if(this._profileProviders.has(_))throw new Error(`Terminal profile provider "${_}" already registered`);return this._profileProviders.set(_,C),this._proxy.$registerProfileProvider(_,v.identifier.value),new m.Disposable(()=>{this._profileProviders.delete(_),this._proxy.$unregisterProfileProvider(_)})}registerTerminalQuickFixProvider(v,_,C){if(this._quickFixProviders.has(v))throw new Error(`Terminal quick fix provider "${v}" is already registered`);return this._quickFixProviders.set(v,C),this._proxy.$registerQuickFixProvider(v,_),new m.Disposable(()=>{this._quickFixProviders.delete(v),this._proxy.$unregisterQuickFixProvider(v)})}async $provideTerminalQuickFixes(v,_){const C=new p.CancellationTokenSource().token;if(C.isCancellationRequested)return;const P=this._quickFixProviders.get(v);if(!P)return;const k=await P.provideTerminalQuickFixes(_,C);if(k===null||Array.isArray(k)&&k.length===0)return;const F=new b.DisposableStore;if(this._lastQuickFixCommands.value=F,!Array.isArray(k))return k?a.TerminalQuickFix.from(k,this._extHostCommands.converter,F):void 0;const x=[];for(const z of k){const N=a.TerminalQuickFix.from(z,this._extHostCommands.converter,F);N&&x.push(N)}return x}async $createContributedProfileTerminal(v,_){const C=new p.CancellationTokenSource().token;let P=await this._profileProviders.get(v)?.provideTerminalProfile(C);if(!C.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${v}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,_);return}this.createTerminalFromOptions(P.options,_)}}async $provideLinks(v,_){const C=this.getTerminalById(v);if(!C)return[];this._terminalLinkCache.delete(v),this._terminalLinkCancellationSource.get(v)?.dispose(!0);const k=new p.CancellationTokenSource;this._terminalLinkCancellationSource.set(v,k);const F=[],x={terminal:C.value,line:_},z=[];for(const W of this._linkProviders)z.push(f.Promises.withAsyncBody(async X=>{k.token.onCancellationRequested(()=>X({provider:W,links:[]}));const te=await W.provideTerminalLinks(x,k.token)||[];k.token.isCancellationRequested||X({provider:W,links:te})}));const N=await Promise.all(z);if(k.token.isCancellationRequested)return[];const M=new Map;for(const W of N)W&&W.links.length>0&&F.push(...W.links.map(X=>{const te={id:o++,startIndex:X.startIndex,length:X.length,label:X.tooltip};return M.set(te.id,{provider:W.provider,link:X}),te}));return this._terminalLinkCache.set(v,M),F}$activateLink(v,_){const C=this._terminalLinkCache.get(v)?.get(_);C&&C.provider.handleTerminalLink(C.link)}_onProcessExit(v,_){this._bufferer.stopBuffering(v),this._terminalProcesses.delete(v),delete this._extensionTerminalAwaitingStart[v];const C=this._terminalProcessDisposables[v];C&&(C.dispose(),delete this._terminalProcessDisposables[v]),this._proxy.$sendProcessExit(v,_)}getTerminalById(v){return this._getTerminalObjectById(this._terminals,v)}getTerminalIdByApiObject(v){const _=this._terminals.findIndex(C=>C.value===v);return _>=0?_:null}_getTerminalObjectById(v,_){const C=this._getTerminalObjectIndexById(v,_);return C!==null?v[C]:null}_getTerminalObjectIndexById(v,_){const C=v.findIndex(P=>P._id===_);return C>=0?C:null}getEnvironmentVariableCollection(v){let _=this._environmentVariableCollections.get(v.identifier.value);return _||(_=new u,this._setEnvironmentVariableCollection(v.identifier.value,_)),_.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(v,_){const C=(0,I.serializeEnvironmentVariableCollection)(_.map),P=(0,I.serializeEnvironmentDescriptionMap)(_.descriptionMap);this._proxy.$setEnvironmentVariableCollection(v,_.persistent,C.length===0?void 0:C,P)}$initEnvironmentVariableCollections(v){v.forEach(_=>{const C=_[0],P=new u(_[1]);this._setEnvironmentVariableCollection(C,P)})}$acceptDefaultProfile(v,_){const C=this._defaultProfile;this._defaultProfile=v,this._defaultAutomationProfile=_,C?.path!==v.path&&this._onDidChangeShell.fire(v.path)}_setEnvironmentVariableCollection(v,_){this._environmentVariableCollections.set(v,_),_.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(v,_)})}};e.BaseExtHostTerminalService=t,e.BaseExtHostTerminalService=t=Ge([Ue(1,i.IExtHostCommands),Ue(2,R.IExtHostRpcService)],t);class u{get persistent(){return this._persistent}set persistent(v){this._persistent=v,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(v){this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new h.Emitter,this.map=new Map(v)}getScopedEnvironmentVariableCollection(v){const _=this.getScopeKey(v);let C=this.scopedCollections.get(_);return C||(C=new r(this,v),this.scopedCollections.set(_,C),C.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),C}replace(v,_,C,P){this._setIfDiffers(v,{value:_,type:m.EnvironmentVariableMutatorType.Replace,options:C??{applyAtProcessCreation:!0},scope:P})}append(v,_,C,P){this._setIfDiffers(v,{value:_,type:m.EnvironmentVariableMutatorType.Append,options:C??{applyAtProcessCreation:!0},scope:P})}prepend(v,_,C,P){this._setIfDiffers(v,{value:_,type:m.EnvironmentVariableMutatorType.Prepend,options:C??{applyAtProcessCreation:!0},scope:P})}_setIfDiffers(v,_){if(_.options&&_.options.applyAtProcessCreation===!1&&!_.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const C=this.getKey(v,_.scope),P=this.map.get(C),k=_.options?{applyAtProcessCreation:_.options.applyAtProcessCreation??!1,applyAtShellIntegration:_.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==_.value||P.type!==_.type||P.options?.applyAtProcessCreation!==k.applyAtProcessCreation||P.options?.applyAtShellIntegration!==k.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==_.scope?.workspaceFolder?.index){const F=this.getKey(v,_.scope),x={variable:v,..._,options:k};this.map.set(F,x),this._onDidChangeCollection.fire()}}get(v,_){const C=this.getKey(v,_),P=this.map.get(C);return P?g(P):void 0}getKey(v,_){const C=this.getScopeKey(_);return C.length?`${v}:::${C}`:v}getScopeKey(v){return this.getWorkspaceKey(v?.workspaceFolder)??""}getWorkspaceKey(v){return v?v.uri.toString():void 0}getVariableMap(v){const _=new Map;for(const[C,P]of this.map)this.getScopeKey(P.scope)===this.getScopeKey(v)&&_.set(P.variable,g(P));return _}delete(v,_){const C=this.getKey(v,_);this.map.delete(C),this._onDidChangeCollection.fire()}clear(v){if(v?.workspaceFolder){for(const[_,C]of this.map)C.scope?.workspaceFolder?.index===v.workspaceFolder.index&&this.map.delete(_);this.clearDescription(v)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(v,_){const C=this.getScopeKey(_),P=this.descriptionMap.get(C);if(!P||P.description!==v){let k;typeof v=="string"?k=v:k=v?.value.split(`

`)[0];const F={description:k,scope:_};this.descriptionMap.set(C,F),this._onDidChangeCollection.fire()}}getDescription(v){const _=this.getScopeKey(v);return this.descriptionMap.get(_)?.description}clearDescription(v){const _=this.getScopeKey(v);this.descriptionMap.delete(_)}}class r{get persistent(){return this.collection.persistent}set persistent(v){this.collection.persistent=v}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(v,_){this.collection=v,this.scope=_,this._onDidChangeCollection=new h.Emitter}getScoped(v){return this.collection.getScopedEnvironmentVariableCollection(v)}replace(v,_,C){this.collection.replace(v,_,C,this.scope)}append(v,_,C){this.collection.append(v,_,C,this.scope)}prepend(v,_,C){this.collection.prepend(v,_,C,this.scope)}get(v){return this.collection.get(v,this.scope)}forEach(v,_){this.collection.getVariableMap(this.scope).forEach((C,P)=>v.call(_,P,C,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(v){this.collection.delete(v,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(v){this.collection.setDescription(v,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let c=class extends t{constructor(v,_){super(!1,v,_)}createTerminal(v,_,C){throw new T.NotSupportedError}createTerminalFromOptions(v,_){throw new T.NotSupportedError}};e.WorkerExtHostTerminalService=c,e.WorkerExtHostTerminalService=c=Ge([Ue(0,i.IExtHostCommands),Ue(1,R.IExtHostRpcService)],c);function s(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function w(D){return d.ThemeColor.isThemeColor(D)?D:void 0}function g(D){const v={...D};return delete v.scope,v.options=v.options??void 0,delete v.variable,v}}),define(_e[156],Ce([1,0,8,3,5,6,20,43,4,2,7]),function(ue,e,h,O,L,A,R,b,m,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalShellIntegration=e.IExtHostTerminalShellIntegration=void 0,e.IExtHostTerminalShellIntegration=(0,L.createDecorator)("IExtHostTerminalShellIntegration");let I=class extends O.Disposable{constructor(f,a){super(),this._extHostTerminalService=a,this._activeShellIntegrations=new Map,this._onDidChangeTerminalShellIntegration=new m.Emitter,this.onDidChangeTerminalShellIntegration=this._onDidChangeTerminalShellIntegration.event,this._onDidStartTerminalShellExecution=new m.Emitter,this.onDidStartTerminalShellExecution=this._onDidStartTerminalShellExecution.event,this._onDidEndTerminalShellExecution=new m.Emitter,this.onDidEndTerminalShellExecution=this._onDidEndTerminalShellExecution.event,this._proxy=f.getProxy(A.MainContext.MainThreadTerminalShellIntegration),this._register((0,O.toDisposable)(()=>{for(const[i,n]of this._activeShellIntegrations)n.dispose();this._activeShellIntegrations.clear()}))}$shellIntegrationChange(f){const a=this._extHostTerminalService.getTerminalById(f);if(!a)return;const i=a.value;let n=this._activeShellIntegrations.get(f);n||(n=new p(a.value,this._onDidStartTerminalShellExecution),this._activeShellIntegrations.set(f,n),n.store.add(a.onWillDispose(()=>this._activeShellIntegrations.get(f)?.dispose())),n.store.add(n.onDidRequestShellExecution(l=>this._proxy.$executeCommand(f,l))),n.store.add(n.onDidRequestEndExecution(l=>this._onDidEndTerminalShellExecution.fire(l))),n.store.add(n.onDidRequestChangeShellIntegration(l=>this._onDidChangeTerminalShellIntegration.fire(l))),a.shellIntegration=n.value),this._onDidChangeTerminalShellIntegration.fire({terminal:i,shellIntegration:n.value})}$shellExecutionStart(f,a,i,n,l){this._activeShellIntegrations.has(f)||this.$shellIntegrationChange(f);const o={value:a,confidence:i,isTrusted:n};this._activeShellIntegrations.get(f)?.startShellExecution(o,l)}$shellExecutionEnd(f,a,i,n,l){const o={value:a,confidence:i,isTrusted:n};this._activeShellIntegrations.get(f)?.endShellExecution(o,l)}$shellExecutionData(f,a){this._activeShellIntegrations.get(f)?.emitData(a)}$cwdChange(f,a){this._activeShellIntegrations.get(f)?.setCwd((0,y.isUriComponents)(a)?y.URI.revive(a):a)}$closeTerminal(f){this._activeShellIntegrations.get(f)?.dispose(),this._activeShellIntegrations.delete(f)}};e.ExtHostTerminalShellIntegration=I,e.ExtHostTerminalShellIntegration=I=Ge([Ue(0,R.IExtHostRpcService),Ue(1,b.IExtHostTerminalService)],I);class p extends O.Disposable{get currentExecution(){return this._currentExecution}constructor(f,a){super(),this._terminal=f,this._onDidStartTerminalShellExecution=a,this._ignoreNextExecution=!1,this.store=this._register(new O.DisposableStore),this._onDidRequestChangeShellIntegration=this._register(new m.Emitter),this.onDidRequestChangeShellIntegration=this._onDidRequestChangeShellIntegration.event,this._onDidRequestShellExecution=this._register(new m.Emitter),this.onDidRequestShellExecution=this._onDidRequestShellExecution.event,this._onDidRequestEndExecution=this._register(new m.Emitter),this.onDidRequestEndExecution=this._onDidRequestEndExecution.event;const i=this;this.value={get cwd(){return i._cwd},executeCommand(n,l){let o=n;l&&(o+=` "${l.map(r=>`${r.replaceAll('"','\\"')}`).join('" "')}"`),i._onDidRequestShellExecution.fire(o);const t={value:o,confidence:h.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},u=i.startShellExecution(t,i._cwd,!0).value;return i._ignoreNextExecution=!0,u}}}startShellExecution(f,a,i){if(this._ignoreNextExecution&&this._currentExecution)this._ignoreNextExecution=!1;else{this._currentExecution&&(this._currentExecution.endExecution(void 0),this._onDidRequestEndExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value,exitCode:void 0}));const n=this._currentExecution=new S(f,a);i?queueMicrotask(()=>this._onDidStartTerminalShellExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:n.value})):this._onDidStartTerminalShellExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value})}return this._currentExecution}emitData(f){this.currentExecution?.emitData(f)}endShellExecution(f,a){this._currentExecution&&(this._currentExecution.endExecution(f),this._onDidRequestEndExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value,exitCode:a}),this._currentExecution=void 0)}setCwd(f){let a=!1;y.URI.isUri(this._cwd)?a=!y.URI.isUri(f)||this._cwd.toString()!==f.toString():this._cwd!==f&&(a=!0),a&&(this._cwd=f,this._onDidRequestChangeShellIntegration.fire({terminal:this._terminal,shellIntegration:this.value}))}}class S{constructor(f,a){this._commandLine=f,this.cwd=a,this._ended=!1;const i=this;this.value={get commandLine(){return i._commandLine},get cwd(){return i.cwd},read(){return i._createDataStream()}}}_createDataStream(){if(!this._dataStream){if(this._ended)return T.AsyncIterableObject.EMPTY;this._dataStream=new E}return this._dataStream.createIterable()}emitData(f){this._dataStream?.emitData(f)}endExecution(f){f&&(this._commandLine=f),this._dataStream?.endExecution(),this._dataStream=void 0,this._ended=!0}}class E extends O.Disposable{constructor(){super(...arguments),this._emitters=[]}createIterable(){this._barrier||(this._barrier=new T.Barrier);const f=this._barrier;return new T.AsyncIterableObject(async i=>{this._emitters.push(i),await f.wait()})}emitData(f){for(const a of this._emitters)a.emitOne(f)}endExecution(){this._barrier?.open(),this._barrier=void 0}}}),define(_e[359],Ce([1,0,7,21,22,4,75,57,3,18,30,11,6,20,155,16,8,69,113,89]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let l=class extends m.Disposable{constructor(k,F,x,z){super(),this.editors=z,this.resultsChangedEmitter=this._register(new A.Emitter),this.controllers=new Map,this.defaultProfilesChangedEmitter=this._register(new A.Emitter),this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=k.getProxy(p.MainContext.MainThreadTesting),this.observer=new D(this.proxy),this.runTracker=new r(this.proxy,F),x.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const M=N,W=M.tests[M.tests.length-1].item.extId;return this.controllers.get(a.TestId.root(W))?.collection.tree.get(W)?.actual??(0,E.toItemFromContext)(N)}case 18:{const{test:M,message:W}=N,X=M.item.extId;return{test:this.controllers.get(a.TestId.root(X))?.collection.tree.get(X)?.actual??(0,E.toItemFromContext)({$mid:16,tests:[M]}),message:d.TestMessage.to(W)}}default:return N}}}),x.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await x.executeCommand("_testing.getExplorerSelection"),M=W=>{const X=this.controllers.get(a.TestId.root(W));if(X)return a.TestId.isRoot(W)?X.controller:X.collection.tree.get(W)?.actual};return{include:N?.include.map(M).filter(y.isDefined)||[],exclude:N?.exclude.map(M).filter(y.isDefined)||[]}})}createTestController(k,F,x,z){if(this.controllers.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const N=new m.DisposableStore,M=N.add(new E.ExtHostTestItemCollection(F,x,this.editors));M.root.label=x;const W=new Map,X=new Set,te=this.proxy,H={items:M.root.children,get label(){return x},set label(Y){x=Y,M.root.label=Y,te.$updateController(F,{label:x})},get refreshHandler(){return z},set refreshHandler(Y){z=Y,te.$updateController(F,{canRefresh:!!Y})},get id(){return F},createRunProfile:(Y,ne,pe,le,we,Z)=>{let B=(0,b.hash)(Y);for(;W.has(B);)B++;return new _(this.proxy,W,X,this.defaultProfilesChangedEmitter.event,F,B,Y,ne,pe,le,we,Z)},createTestItem(Y,ne,pe){return new E.TestItemImpl(F,Y,ne,pe)},createTestRun:(Y,ne,pe=!0)=>this.runTracker.createTestRun(F,M,Y,ne,pe),invalidateTestResults:Y=>{if(Y===void 0)this.proxy.$markTestRetired(void 0);else{const ne=Y instanceof Array?Y:[Y];this.proxy.$markTestRetired(ne.map(pe=>a.TestId.fromExtHostTestItem(pe,F).toString()))}},set resolveHandler(Y){M.resolveHandler=Y},get resolveHandler(){return M.resolveHandler},dispose:()=>{N.dispose()}};te.$registerTestController(F,x,!!z),N.add((0,m.toDisposable)(()=>te.$unregisterTestController(F)));const G={controller:H,collection:M,profiles:W,extension:k,activeProfiles:X};return this.controllers.set(F,G),N.add((0,m.toDisposable)(()=>this.controllers.delete(F))),N.add(M.onDidGenerateDiff(Y=>te.$publishDiff(F,Y.map(n.TestsDiffOp.serialize)))),H}createTestObserver(){return this.observer.checkout()}async runTests(k,F=L.CancellationToken.None){const x=c(k);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.controllers.get(x.controllerId);if(!z)throw new Error("Controller not found");await this.proxy.$runTests({preserveFocus:k.preserveFocus??!0,targets:[{testIds:k.include?.map(N=>a.TestId.fromExtHostTestItem(N,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:C[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:k.exclude?.map(N=>N.id)},F)}$syncTests(){for(const{collection:k}of this.controllers.values())k.flushDiff();return Promise.resolve()}async $getCoverageDetails(k,F){return(await this.runTracker.getCoverageDetails(k,F))?.map(d.TestCoverage.fromDetails)}async $disposeRun(k){this.runTracker.disposeTestRun(k)}$configureRunProfile(k,F){this.controllers.get(k)?.profiles.get(F)?.configureHandler?.()}$setDefaultRunProfiles(k){const F=new Map;for(const[x,z]of Object.entries(k)){const N=this.controllers.get(x);if(!N)continue;const M=new Map,W=z.filter(te=>!N.activeProfiles.has(te)),X=[...N.activeProfiles].filter(te=>!z.includes(te));for(const te of W)M.set(te,!0),N.activeProfiles.add(te);for(const te of X)M.set(te,!1),N.activeProfiles.delete(te);M.size&&F.set(x,M)}this.defaultProfilesChangedEmitter.fire(F)}async $refreshTests(k,F){await this.controllers.get(k)?.controller.refreshHandler?.(F)}$publishTestResults(k){this.results=Object.freeze(k.map(d.TestResults.to).concat(this.results).sort((F,x)=>x.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(k,F){const x=this.controllers.get(a.TestId.fromString(k).controllerId)?.collection;x&&(await x.expand(k,F<0?1/0:F),x.flushDiff())}$acceptDiff(k){this.observer.applyDiff(k.map(F=>n.TestsDiffOp.deserialize({asCanonicalUri:x=>x},F)))}async $runControllerTests(k,F){return Promise.all(k.map(x=>this.runControllerTestRequest(x,!1,F)))}async $startContinuousRun(k,F){const x=new L.CancellationTokenSource(F),z=await Promise.all(k.map(N=>this.runControllerTestRequest(N,!0,x.token)));return!F.isCancellationRequested&&!z.some(N=>N.error)&&await new Promise(N=>F.onCancellationRequested(N)),x.dispose(!0),z}async runControllerTestRequest(k,F,x){const z=this.controllers.get(k.controllerId);if(!z)return{};const{collection:N,profiles:M}=z,W=M.get(k.profileId);if(!W)return{};const X=k.testIds.map(Y=>N.tree.get(Y)).filter(y.isDefined),te=k.excludeExtIds.map(Y=>z.collection.tree.get(Y)).filter(y.isDefined).filter(Y=>X.some(ne=>ne.fullId.compare(Y.fullId)===2));if(!X.length)return{};const H=new f.TestRunRequest(X.some(Y=>Y.actual instanceof E.TestItemRootImpl)?void 0:X.map(Y=>Y.actual),te.map(Y=>Y.actual),W,F),G=(0,n.isStartControllerTests)(k)&&this.runTracker.prepareForMainThreadTestRun(H,s.fromInternal(k,z.collection),W,x);try{return await W.runHandler(H,x),{}}catch(Y){return{error:String(Y)}}finally{G&&G.hasRunningTasks&&!x.isCancellationRequested&&await A.Event.toPromise(G.onEnd)}}$cancelExtensionTestRun(k){k===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(k)}};e.ExtHostTesting=l,e.ExtHostTesting=l=Ge([Ue(0,S.IExtHostRpcService),Ue(1,I.ILogService)],l);const o=1e4;var t;(function(P){P[P.Running=0]="Running",P[P.Cancelling=1]="Cancelling",P[P.Ended=2]="Ended"})(t||(t={}));class u extends m.Disposable{get hasRunningTasks(){return this.running>0}get id(){return this.dto.id}constructor(k,F,x,z,N){super(),this.dto=k,this.proxy=F,this.logService=x,this.profile=z,this.state=0,this.running=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.publishedCoverage=new Map,this.onEnd=this.endEmitter.event,this.cts=this._register(new L.CancellationTokenSource(N));const M=this._register(new h.RunOnceScheduler(()=>this.forciblyEndTasks(),o));this._register(this.cts.token.onCancellationRequested(()=>M.schedule()));const W=new A.Emitter;this.onDidDispose=W.event,this._register((0,m.toDisposable)(()=>{W.fire(),W.dispose()}))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverageDetails(k,F){const[,x,z]=a.TestId.fromString(k).path,N=this.publishedCoverage.get(z);if(!N)return[];const M=this.tasks.get(x);if(!M)throw new Error("unreachable: run task was not found");return this.profile?.loadDetailedCoverage?.(M.run,N,F)??[]}createRun(k){const F=this.dto.id,x=this.dto.controllerId,z=(0,T.generateUuid)(),N=te=>(H,...G)=>{if(W){this.logService.warn(`Setting the state of test "${H.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(H)&&(this.ensureTestIsKnown(H),te(H,...G))},M=(te,H)=>{const G=H instanceof Array?H.map(d.TestMessage.from):[d.TestMessage.from(H)];if(te.uri&&te.range){const Y={range:d.Range.from(te.range),uri:te.uri};for(const ne of G)ne.location=ne.location||Y}this.proxy.$appendTestMessagesInRun(F,z,a.TestId.fromExtHostTestItem(te,x).toString(),G)};let W=!1;const X={isPersisted:this.dto.isPersisted,token:this.cts.token,name:k,onDidDispose:this.onDidDispose,addCoverage:te=>{const H=te.uri.toString(),G=new a.TestId([F,z,H]).toString();this.publishedCoverage.set(H,te),this.proxy.$appendCoverage(F,z,d.TestCoverage.fromFile(G,te))},enqueued:N(te=>{this.proxy.$updateTestStateInRun(F,z,a.TestId.fromExtHostTestItem(te,x).toString(),1)}),skipped:N(te=>{this.proxy.$updateTestStateInRun(F,z,a.TestId.fromExtHostTestItem(te,x).toString(),5)}),started:N(te=>{this.proxy.$updateTestStateInRun(F,z,a.TestId.fromExtHostTestItem(te,x).toString(),2)}),errored:N((te,H,G)=>{M(te,H),this.proxy.$updateTestStateInRun(F,z,a.TestId.fromExtHostTestItem(te,x).toString(),6,G)}),failed:N((te,H,G)=>{M(te,H),this.proxy.$updateTestStateInRun(F,z,a.TestId.fromExtHostTestItem(te,x).toString(),4,G)}),passed:N((te,H)=>{this.proxy.$updateTestStateInRun(F,z,a.TestId.fromExtHostTestItem(te,this.dto.controllerId).toString(),3,H)}),appendOutput:(te,H,G)=>{W||(G&&(this.dto.isIncluded(G)?this.ensureTestIsKnown(G):G=void 0),this.proxy.$appendOutputToRun(F,z,O.VSBuffer.fromString(te),H&&d.location.from(H),G&&a.TestId.fromExtHostTestItem(G,x).toString()))},end:()=>{W||(W=!0,this.proxy.$finishedTestRunTask(F,z),--this.running||this.markEnded())}};return this.running++,this.tasks.set(z,{run:X}),this.proxy.$startedTestRunTask(F,{id:z,name:k,running:!0}),X}forciblyEndTasks(){for(const{run:k}of this.tasks.values())k.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(k){if(!(k instanceof E.TestItemImpl))throw new i.InvalidTestItemError(k.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(k,this.dto.controllerId).toString()))return;const F=[],x=this.dto.colllection.root;for(;;){const z=d.TestItem.from(k);if(F.unshift(z),this.sharedTestIds.has(z.extId)||(this.sharedTestIds.add(z.extId),k===x))break;k=k.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,F)}dispose(){this.markEnded(),super.dispose()}}class r{get trackers(){return this.tracked.values()}constructor(k,F){this.proxy=k,this.logService=F,this.tracked=new Map,this.trackedById=new Map}getCoverageDetails(k,F){const x=a.TestId.root(k);return this.trackedById.get(x)?.getCoverageDetails(k,F)||[]}disposeTestRun(k){this.trackedById.get(k)?.dispose(),this.trackedById.delete(k);for(const[F,{id:x}]of this.tracked)x===k&&this.tracked.delete(F)}prepareForMainThreadTestRun(k,F,x,z){return this.getTracker(k,F,x,z)}cancelRunById(k){this.trackedById.get(k)?.cancel()}cancelAllRuns(){for(const k of this.tracked.values())k.cancel()}createTestRun(k,F,x,z,N){const M=this.tracked.get(x);if(M)return M.createRun(z);const W=s.fromPublic(k,F,x,N),X=c(x);this.proxy.$startedExtensionTestRun({controllerId:k,continuous:!!x.continuous,profile:X&&{group:C[X.kind],id:X.profileId},exclude:x.exclude?.map(H=>a.TestId.fromExtHostTestItem(H,F.root.id).toString())??[],id:W.id,include:x.include?.map(H=>a.TestId.fromExtHostTestItem(H,F.root.id).toString())??[F.root.id],preserveFocus:x.preserveFocus??!0,persist:N});const te=this.getTracker(x,W,x.profile);return A.Event.once(te.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(W.id)}),te.createRun(z)}getTracker(k,F,x,z){const N=new u(F,this.proxy,this.logService,x,z);return this.tracked.set(k,N),this.trackedById.set(N.id,N),N}}e.TestRunCoordinator=r;const c=P=>{if(P.profile){if(!(P.profile instanceof _))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class s{static fromPublic(k,F,x,z){return new s(k,(0,T.generateUuid)(),x.include?.map(N=>a.TestId.fromExtHostTestItem(N,k).toString())??[k],x.exclude?.map(N=>a.TestId.fromExtHostTestItem(N,k).toString())??[],z,F)}static fromInternal(k,F){return new s(k.controllerId,k.runId,k.testIds,k.excludeExtIds,!0,F)}constructor(k,F,x,z,N,M){this.controllerId=k,this.id=F,this.isPersisted=N,this.colllection=M,this.includePrefix=x.map(W=>W+"\0"),this.excludePrefix=z.map(W=>W+"\0")}isIncluded(k){const F=a.TestId.fromExtHostTestItem(k,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(F===x||F.startsWith(x))return!1;for(const x of this.includePrefix)if(F===x||F.startsWith(x))return!0;return!1}}e.TestRunDto=s;class w{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(k){this.emitter=k,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(k){this.added.add(k)}update(k){Object.assign(k.revived,d.TestItem.toPlain(k.item)),this.added.has(k)||this.updated.add(k)}remove(k){if(this.added.has(k)){this.added.delete(k);return}this.updated.delete(k);const F=a.TestId.parentId(k.item.extId);if(F&&this.alreadyRemoved.has(F.toString())){this.alreadyRemoved.add(k.item.extId);return}this.removed.add(k)}getChangeEvent(){const{added:k,updated:F,removed:x}=this;return{get added(){return[...k].map(z=>z.revived)},get updated(){return[...F].map(z=>z.revived)},get removed(){return[...x].map(z=>z.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class g extends n.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(k){return this.items.get(k)}getMirroredTestDataByReference(k){return this.items.get(k.id)}createItem(k,F){return{...k,revived:d.TestItem.toPlain(k.item),depth:F?F.depth+1:0,children:new Set}}createChangeCollector(){return new w(this.changeEmitter)}}class D{constructor(k){this.proxy=k}checkout(){this.current||(this.current=this.createObserverData());const k=this.current;return k.observers++,{onDidChangeTest:k.tests.onDidChangeTests,get tests(){return[...k.tests.rootTests].map(F=>F.revived)},dispose:(0,R.createSingleCallFunction)(()=>{--k.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(k){return this.current?.tests.getMirroredTestDataByReference(k)}applyDiff(k){this.current?.tests.apply(k)}createObserverData(){const k=new g({asCanonicalUri:F=>F});return this.proxy.$subscribeToDiffs(),{observers:0,tests:k}}}const v=(P,k,F,x)=>{F?Object.assign(F,x):k.$updateTestRunConfig(P.controllerId,P.profileId,x)};class _{#e;#t;#i;#n;#s;get label(){return this._label}set label(k){k!==this._label&&(this._label=k,v(this,this.#e,this.#n,{label:k}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(k){k!==this._supportsContinuousRun&&(this._supportsContinuousRun=k,v(this,this.#e,this.#n,{supportsContinuousRun:k}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(k){k!==this.isDefault&&(k?this.#t.add(this.profileId):this.#t.delete(this.profileId),v(this,this.#e,this.#n,{isDefault:k}))}get tag(){return this._tag}set tag(k){k?.id!==this._tag?.id&&(this._tag=k,v(this,this.#e,this.#n,{tag:k?d.TestTag.namespace(this.controllerId,k.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(k){k!==this._configureHandler&&(this._configureHandler=k,v(this,this.#e,this.#n,{hasConfigurationHandler:!!k}))}get onDidChangeDefault(){return A.Event.chain(this.#i,k=>k.map(F=>F.get(this.controllerId)?.get(this.profileId)).filter(y.isDefined))}constructor(k,F,x,z,N,M,W,X,te,H=!1,G=void 0,Y=!1){this.controllerId=N,this.profileId=M,this._label=W,this.kind=X,this.runHandler=te,this._tag=G,this._supportsContinuousRun=Y,this.#e=k,this.#s=F,this.#t=x,this.#i=z,F.set(M,this);const ne=C[X];if(typeof ne!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);H&&x.add(M),this.#n={profileId:M,controllerId:N,tag:G?d.TestTag.namespace(this.controllerId,G.id):null,label:W,group:ne,isDefault:H,hasConfigurationHandler:!1,supportsContinuousRun:Y},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.TestRunProfileImpl=_;const C={[f.TestRunProfileKind.Coverage]:8,[f.TestRunProfileKind.Debug]:4,[f.TestRunProfileKind.Run]:2}}),define(_e[157],Ce([1,0,62,13,125,16,8]),function(ue,e,h,O,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class b{static{this._Keys=new L.IdGenerator("TextEditorDecorationType")}constructor(p,S,E){const d=b._Keys.nextId();p.$registerTextEditorDecorationType(S.identifier,d,A.DecorationRenderOptions.from(E)),this.value=Object.freeze({key:d,dispose(){p.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=b;class m{constructor(p,S){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=p,this._documentVersionId=p.version,this._undoStopBefore=S.undoStopBefore,this._undoStopAfter=S.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(p,S){this._throwIfFinalized();let E=null;if(p instanceof R.Position)E=new R.Range(p,p);else if(p instanceof R.Range)E=p;else throw new Error("Unrecognized location");this._pushEdit(E,S,!1)}insert(p,S){this._throwIfFinalized(),this._pushEdit(new R.Range(p,p),S,!0)}delete(p){this._throwIfFinalized();let S=null;if(p instanceof R.Range)S=p;else throw new Error("Unrecognized location");this._pushEdit(S,null,!0)}_pushEdit(p,S,E){const d=this._document.validateRange(p);this._collectedEdits.push({range:d,text:S,forceMoveMarkers:E})}setEndOfLine(p){if(this._throwIfFinalized(),p!==R.EndOfLine.LF&&p!==R.EndOfLine.CRLF)throw(0,O.illegalArgument)("endOfLine");this._setEndOfLine=p}}class y{constructor(p,S,E,d){this._proxy=p,this._id=S,this._accept(E),this._logService=d;const f=this;this.value={get tabSize(){return f._tabSize},set tabSize(a){f._setTabSize(a)},get indentSize(){return f._indentSize},set indentSize(a){f._setIndentSize(a)},get insertSpaces(){return f._insertSpaces},set insertSpaces(a){f._setInsertSpaces(a)},get cursorStyle(){return f._cursorStyle},set cursorStyle(a){f._setCursorStyle(a)},get lineNumbers(){return f._lineNumbers},set lineNumbers(a){f._setLineNumbers(a)}}}_accept(p){this._tabSize=p.tabSize,this._indentSize=p.indentSize,this._originalIndentSize=p.originalIndentSize,this._insertSpaces=p.insertSpaces,this._cursorStyle=p.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(p.lineNumbers)}_validateTabSize(p){if(p==="auto")return"auto";if(typeof p=="number"){const S=Math.floor(p);return S>0?S:null}if(typeof p=="string"){const S=parseInt(p,10);return isNaN(S)?null:S>0?S:null}return null}_setTabSize(p){const S=this._validateTabSize(p);if(S!==null){if(typeof S=="number"){if(this._tabSize===S)return;this._tabSize=S}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:S}))}}_validateIndentSize(p){if(p==="tabSize")return"tabSize";if(typeof p=="number"){const S=Math.floor(p);return S>0?S:null}if(typeof p=="string"){const S=parseInt(p,10);return isNaN(S)?null:S>0?S:null}return null}_setIndentSize(p){const S=this._validateIndentSize(p);if(S!==null){if(typeof S=="number"){if(this._originalIndentSize===S)return;this._indentSize=S,this._originalIndentSize=S}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:S}))}}_validateInsertSpaces(p){return p==="auto"?"auto":p==="false"?!1:!!p}_setInsertSpaces(p){const S=this._validateInsertSpaces(p);if(typeof S=="boolean"){if(this._insertSpaces===S)return;this._insertSpaces=S}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:S}))}_setCursorStyle(p){this._cursorStyle!==p&&(this._cursorStyle=p,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:p})))}_setLineNumbers(p){this._lineNumbers!==p&&(this._lineNumbers=p,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(p)})))}assign(p){const S={};let E=!1;if(typeof p.tabSize<"u"){const d=this._validateTabSize(p.tabSize);d==="auto"?(E=!0,S.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,E=!0,S.tabSize=d)}if(typeof p.indentSize<"u"){const d=this._validateIndentSize(p.indentSize);d==="tabSize"?(E=!0,S.indentSize=d):typeof d=="number"&&this._originalIndentSize!==d&&(this._indentSize=d,this._originalIndentSize=d,E=!0,S.indentSize=d)}if(typeof p.insertSpaces<"u"){const d=this._validateInsertSpaces(p.insertSpaces);d==="auto"?(E=!0,S.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,E=!0,S.insertSpaces=d)}typeof p.cursorStyle<"u"&&this._cursorStyle!==p.cursorStyle&&(this._cursorStyle=p.cursorStyle,E=!0,S.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this._lineNumbers!==p.lineNumbers&&(this._lineNumbers=p.lineNumbers,E=!0,S.lineNumbers=A.TextEditorLineNumbersStyle.from(p.lineNumbers)),E&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,S))}_warnOnError(p,S){S.catch(E=>{this._logService.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this._logService.warn(E)})}}e.ExtHostTextEditorOptions=y;class T{constructor(p,S,E,d,f,a,i,n){this.id=p,this._proxy=S,this._logService=E,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=f,this._options=new y(this._proxy,this.id,a,E),this._visibleRanges=i,this._viewColumn=n;const l=this;this.value=Object.freeze({get document(){return d.value},set document(o){throw new O.ReadonlyError("document")},get selection(){return l._selections&&l._selections[0]},set selection(o){if(!(o instanceof R.Selection))throw(0,O.illegalArgument)("selection");l._selections=[o],l._trySetSelection()},get selections(){return l._selections},set selections(o){if(!Array.isArray(o)||o.some(t=>!(t instanceof R.Selection)))throw(0,O.illegalArgument)("selections");l._selections=o,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(o){throw new O.ReadonlyError("visibleRanges")},get options(){return l._options.value},set options(o){l._disposed||l._options.assign(o)},get viewColumn(){return l._viewColumn},set viewColumn(o){throw new O.ReadonlyError("viewColumn")},edit(o,t={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new m(d.value,t);return o(u),l._applyEdit(u)},insertSnippet(o,t,u={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=l._selections.map(c=>A.Range.from(c));else if(t instanceof R.Position){const{lineNumber:c,column:s}=A.Position.from(t);r=[{startLineNumber:c,startColumn:s,endLineNumber:c,endColumn:s}]}else if(t instanceof R.Range)r=[A.Range.from(t)];else{r=[];for(const c of t)if(c instanceof R.Range)r.push(A.Range.from(c));else{const{lineNumber:s,column:w}=A.Position.from(c);r.push({startLineNumber:s,startColumn:w,endLineNumber:s,endColumn:w})}}return S.$tryInsertSnippet(p,d.value.version,o.value,r,u)},setDecorations(o,t){const u=t.length===0;u&&!l._hasDecorationsForKey.has(o.key)||(u?l._hasDecorationsForKey.delete(o.key):l._hasDecorationsForKey.add(o.key),l._runOnProxy(()=>{if(A.isDecorationOptionsArr(t))return S.$trySetDecorations(p,o.key,A.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let c=0,s=t.length;c<s;c++){const w=t[c];r[4*c]=w.start.line+1,r[4*c+1]=w.start.character+1,r[4*c+2]=w.end.line+1,r[4*c+3]=w.end.character+1}return S.$trySetDecorationsFast(p,o.key,r)}}))},revealRange(o,t){l._runOnProxy(()=>S.$tryRevealRange(p,A.Range.from(o),t||R.TextEditorRevealType.Default))},show(o){S.$tryShowEditor(p,A.ViewColumn.from(o))},hide(){S.$tryHideEditor(p)}})}dispose(){(0,h.ok)(!this._disposed),this._disposed=!0}_acceptOptions(p){(0,h.ok)(!this._disposed),this._options._accept(p)}_acceptVisibleRanges(p){(0,h.ok)(!this._disposed),this._visibleRanges=p}_acceptViewColumn(p){(0,h.ok)(!this._disposed),this._viewColumn=p}_acceptSelections(p){(0,h.ok)(!this._disposed),this._selections=p}async _trySetSelection(){const p=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,p)),this.value}_applyEdit(p){const S=p.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const E=S.edits.map(f=>f.range);E.sort((f,a)=>f.end.line===a.end.line?f.end.character===a.end.character?f.start.line===a.start.line?f.start.character-a.start.character:f.start.line-a.start.line:f.end.character-a.end.character:f.end.line-a.end.line);for(let f=0,a=E.length-1;f<a;f++){const i=E[f].end;if(E[f+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=S.edits.map(f=>({range:A.Range.from(f.range),text:f.text,forceMoveMarkers:f.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,d,{setEndOfLine:typeof S.setEndOfLine=="number"?A.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}_runOnProxy(p){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this._logService.warn(S),null))}}e.ExtHostTextEditor=T}),define(_e[73],Ce([1,0,62,4,3,2,5,6,153,20,157,16,11,27,15,39,46]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class a{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let i=class{constructor(l,o){this._extHostRpc=l,this._logService=o,this._activeEditorId=null,this._editors=new Map,this._documents=new S.ResourceMap,this._onDidAddDocuments=new O.Emitter,this._onDidRemoveDocuments=new O.Emitter,this._onDidChangeVisibleTextEditors=new O.Emitter,this._onDidChangeActiveTextEditor=new O.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const o=[],t=[],u=[];if(l.removedDocuments)for(const r of l.removedDocuments){const c=A.URI.revive(r),s=this._documents.get(c);s?.unref()&&(this._documents.delete(c),o.push(s.value))}if(l.addedDocuments)for(const r of l.addedDocuments){const c=A.URI.revive(r.uri);let s=this._documents.get(c);if(s&&c.scheme!==E.Schemas.vscodeNotebookCell&&c.scheme!==E.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);s||(s=new a(new m.ExtHostDocumentData(this._extHostRpc.getProxy(b.MainContext.MainThreadDocuments),c,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty)),this._documents.set(c,s),t.push(s.value)),s.ref()}if(l.removedEditors)for(const r of l.removedEditors){const c=this._editors.get(r);this._editors.delete(r),c&&u.push(c)}if(l.addedEditors)for(const r of l.addedEditors){const c=A.URI.revive(r.documentUri);h.ok(this._documents.has(c),`document '${c}' does not exist`),h.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const s=this._documents.get(c).value,w=new T.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(b.MainContext.MainThreadTextEditors),this._logService,new f.Lazy(()=>s.document),r.selections.map(I.Selection.to),r.options,r.visibleRanges.map(g=>I.Range.to(g)),typeof r.editorPosition=="number"?I.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,w)}l.newActiveEditor!==void 0&&(h.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,L.dispose)(o),(0,L.dispose)(u),l.removedDocuments&&this._onDidRemoveDocuments.fire(o),l.addedDocuments&&this._onDidAddDocuments.fire(t),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){return this._documents.get(l)?.value}allDocuments(){return d.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!this._activeEditorId)return;const o=this._editors.get(this._activeEditorId);return l?o:o?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=i,e.ExtHostDocumentsAndEditors=i=Ge([Ue(0,y.IExtHostRpcService),Ue(1,p.ILogService)],i),e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(_e[360],Ce([1,0,19,4,6,157,16,8]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class m{constructor(T,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new O.Emitter,this._onDidChangeTextEditorOptions=new O.Emitter,this._onDidChangeTextEditorVisibleRanges=new O.Emitter,this._onDidChangeTextEditorViewColumn=new O.Emitter,this._onDidChangeActiveTextEditor=new O.Emitter,this._onDidChangeVisibleTextEditors=new O.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=T.getProxy(L.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(p=>this._onDidChangeVisibleTextEditors.fire(p)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(p=>this._onDidChangeActiveTextEditor.fire(p))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(T){const I=this._extHostDocumentsAndEditors.allEditors();return T?I:I.map(p=>p.value)}async showTextDocument(T,I,p){let S;typeof I=="number"?S={position:R.ViewColumn.from(I),preserveFocus:p}:typeof I=="object"?S={position:R.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?R.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:S={preserveFocus:!1};const E=await this._proxy.$tryShowTextDocument(T.uri,S),d=E&&this._extHostDocumentsAndEditors.getEditor(E);if(d)return d.value;throw E?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T,I){return new A.TextEditorDecorationType(this._proxy,T,I).value}$acceptEditorPropertiesChanged(T,I){const p=this._extHostDocumentsAndEditors.getEditor(T);if(!p)throw new Error("unknown text editor");if(I.options&&p._acceptOptions(I.options),I.selections){const S=I.selections.selections.map(R.Selection.to);p._acceptSelections(S)}if(I.visibleRanges){const S=h.coalesce(I.visibleRanges.map(R.Range.to));p._acceptVisibleRanges(S)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:p.value,options:{...I.options,lineNumbers:R.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const S=b.TextEditorSelectionChangeKind.fromValue(I.selections.source),E=I.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:p.value,selections:E,kind:S})}if(I.visibleRanges){const S=h.coalesce(I.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:p.value,visibleRanges:S})}}$acceptEditorPositionData(T){for(const I in T){const p=this._extHostDocumentsAndEditors.getEditor(I);if(!p)throw new Error("Unknown text editor");const S=R.ViewColumn.to(T[I]);p.value.viewColumn!==S&&(p._acceptViewColumn(S),this._onDidChangeTextEditorViewColumn.fire({textEditor:p.value,viewColumn:S}))}}getDiffInformation(T){return Promise.resolve(this._proxy.$getDiffInformation(T))}}e.ExtHostEditors=m}),define(_e[361],Ce([1,0,2,5,6,3,8,16,25,18]),function(ue,e,h,O,L,A,R,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,O.createDecorator)("IExtHostTimeline");class T{constructor(S,E){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=S.getProxy(L.MainContext.MainThreadTimeline),E.registerArgumentProcessor({processArgument:(d,f)=>{if(d&&d.$mid===12)if(this._providers.get(d.source)&&m.ExtensionIdentifier.equals(f,this._providers.get(d.source)?.extension)){const a=d.uri===void 0?void 0:h.URI.revive(d.uri);return this._itemsBySourceAndUriMap.get(d.source)?.get(I(a))?.get(d.handle)}else return;return d}})}async $getTimeline(S,E,d,f){return this._providers.get(S)?.provider.provideTimeline(h.URI.revive(E),d,f)}registerTimelineProvider(S,E,d,f){const a=new A.DisposableStore,i=this.convertTimelineItem(E.id,f,a).bind(this);let n;E.onDidChange&&(n=E.onDidChange(o=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:E.id}),this));const l=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...E,scheme:S,onDidChange:void 0,async provideTimeline(o,t,u){t?.resetCache&&(a.clear(),l.get(E.id)?.clear());const r=await E.provideTimeline(o,t,u);if(r==null)return;const c=i(o,t);return{...r,source:E.id,items:r.items.map(c)}},dispose(){for(const o of l.values())o.get(E.id)?.clear();n?.dispose(),a.dispose()}},d)}convertTimelineItem(S,E,d){return(f,a)=>{let i;if(a?.cacheResults){let n=this._itemsBySourceAndUriMap.get(S);n===void 0&&(n=new Map,this._itemsBySourceAndUriMap.set(S,n));const l=I(f);i=n.get(l),i===void 0&&(i=new Map,n.set(l,i))}return n=>{const{iconPath:l,...o}=n,t=`${S}|${n.id??n.timestamp}`;i?.set(t,n);let u,r,c;n.iconPath&&(l instanceof R.ThemeIcon?c={id:l.id,color:l.color}:h.URI.isUri(l)?(u=l,r=l):{light:u,dark:r}=l);let s;return R.MarkdownString.isMarkdownString(o.tooltip)?s=b.MarkdownString.from(o.tooltip):(0,y.isString)(o.tooltip)?s=o.tooltip:R.MarkdownString.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=b.MarkdownString.from(o.detail)):(0,y.isString)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=o.detail),{...o,id:o.id??void 0,handle:t,source:S,command:n.command?E.toInternal(n.command,d):void 0,icon:u,iconDark:r,themeIcon:c,tooltip:s,accessibilityInformation:n.accessibilityInformation}}}}registerTimelineProviderCore(S,E){if(this._providers.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this._proxy.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this._providers.set(S.id,{provider:S,extension:E}),(0,A.toDisposable)(()=>{for(const f of this._itemsBySourceAndUriMap.values())f.get(S.id)?.clear();this._providers.delete(S.id),this._proxy.$unregisterTimelineProvider(S.id),S.dispose()})}}e.ExtHostTimeline=T;function I(p){return p?.toString()}}),define(_e[362],Ce([1,0,233,23,2,4,3,294,7,8,18,19,16,81,22,189,26]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function a(l,o){if((0,T.isString)(l))return{label:l};if(l&&typeof l=="object"&&typeof l.label=="string"){let t;return Array.isArray(l.highlights)&&(t=l.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),t=t.length?t:void 0),{label:l.label,highlights:t}}}class i extends R.Disposable{constructor(o,t,u){super(),this._proxy=o,this.commands=t,this.logService=u,this.treeViews=new Map,this.treeDragAndDropService=new d.TreeViewsDnDService;function r(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:c=>r(c)?this.convertArgument(c):Array.isArray(c)&&c.length>0?c.map(s=>r(s)?this.convertArgument(s):s):c})}registerTreeDataProvider(o,t,u){const r=this.createTreeView(o,{treeDataProvider:t},u);return{dispose:()=>r.dispose()}}createTreeView(o,t,u){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],c=t.dragAndDropController?.dragMimeTypes??[],s=!!t.dragAndDropController?.handleDrag,w=!!t.dragAndDropController?.handleDrop,g=this.createExtHostTreeView(o,t,u),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:c,hasHandleDrag:s,hasHandleDrop:w,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},v=this._proxy.$registerTreeViewDataProvider(o,D),_={get onDidCollapseElement(){return g.onDidCollapseElement},get onDidExpandElement(){return g.onDidExpandElement},get selection(){return g.selectedElements},get onDidChangeSelection(){return g.onDidChangeSelection},get activeItem(){return(0,f.checkProposedApiEnabled)(u,"treeViewActiveItem"),g.focusedElement},get onDidChangeActiveItem(){return(0,f.checkProposedApiEnabled)(u,"treeViewActiveItem"),g.onDidChangeActiveItem},get visible(){return g.visible},get onDidChangeVisibility(){return g.onDidChangeVisibility},get onDidChangeCheckboxState(){return g.onDidChangeCheckboxState},get message(){return g.message},set message(C){(0,S.isMarkdownString)(C)&&(0,f.checkProposedApiEnabled)(u,"treeViewMarkdownMessage"),g.message=C},get title(){return g.title},set title(C){g.title=C},get description(){return g.description},set description(C){g.description=C},get badge(){return g.badge},set badge(C){C!==void 0&&y.ViewBadge.isViewBadge(C)?g.badge={value:Math.floor(Math.abs(C.value)),tooltip:C.tooltip}:C===void 0&&(g.badge=void 0)},reveal:(C,P)=>g.reveal(C,P),dispose:async()=>{await v,this.treeViews.delete(o),g.dispose()}};return this._register(_),_}$getChildren(o,t){const u=this.treeViews.get(o);return u?u.getChildren(t):Promise.reject(new b.NoTreeViewError(o))}async $handleDrop(o,t,u,r,c,s,w,g){const D=this.treeViews.get(o);if(!D)return Promise.reject(new b.NoTreeViewError(o));const v=p.DataTransfer.toDataTransfer(u,async _=>(await this._proxy.$resolveDropFileData(o,t,_)).buffer);return w===o&&g&&await this.addAdditionalTransferItems(v,D,g,c,s),D.onDrop(v,r,c)}async addAdditionalTransferItems(o,t,u,r,c){const s=this.treeDragAndDropService.removeDragOperationTransfer(c);if(s)(await s)?.forEach((w,g)=>{w&&o.set(g,w)});else if(c&&t.handleDrag){const w=t.handleDrag(u,o,r);this.treeDragAndDropService.addDragOperationTransfer(c,w),await w}return o}async $handleDrag(o,t,u,r){const c=this.treeViews.get(o);if(!c)return Promise.reject(new b.NoTreeViewError(o));const s=await this.addAdditionalTransferItems(new y.DataTransfer,c,t,r,u);if(!(!s||r.isCancellationRequested))return p.DataTransfer.from(s)}async $hasResolve(o){const t=this.treeViews.get(o);if(!t)throw new b.NoTreeViewError(o);return t.hasResolve}$resolve(o,t,u){const r=this.treeViews.get(o);if(!r)throw new b.NoTreeViewError(o);return r.resolveTreeItem(t,u)}$setExpanded(o,t,u){const r=this.treeViews.get(o);if(!r)throw new b.NoTreeViewError(o);r.setExpanded(t,u)}$setSelectionAndFocus(o,t,u){const r=this.treeViews.get(o);if(!r)throw new b.NoTreeViewError(o);r.setSelectionAndFocus(t,u)}$setVisible(o,t){const u=this.treeViews.get(o);if(!u){if(!t)return;throw new b.NoTreeViewError(o)}u.setVisible(t)}$changeCheckboxState(o,t){const u=this.treeViews.get(o);if(!u)throw new b.NoTreeViewError(o);u.setCheckboxState(t)}createExtHostTreeView(o,t,u){const r=this._register(new n(o,t,this._proxy,this.commands.converter,this.logService,u));return this.treeViews.set(o,r),r}convertArgument(o){const t=this.treeViews.get(o.$treeViewId);return t&&"$treeItemHandle"in o?t.getExtensionElement(o.$treeItemHandle):t&&"$focusedTreeItem"in o&&o.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=i;class n extends R.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,T.isUndefinedOrNull)(o))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(o,t,u,r,c,s){if(super(),this.viewId=o,this.proxy=u,this.commands=r,this.logService=c,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new A.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new A.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new E.CancellationTokenSource,s.contributes&&s.contributes.views)for(const v in s.contributes.views)for(const _ of s.contributes.views[v])_.id===o&&(this._title=_.name);this.dataProvider=t.treeDataProvider,this.dndController=t.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(v=>{Array.isArray(v)&&v.length===0||this._onDidChangeData.fire({message:!1,element:v})}));let w,g;const D=A.Event.debounce(this._onDidChangeData.event,(v,_)=>(v||(v={message:!1,elements:[]}),_.element!==!1&&(w||(w=new Promise(C=>g=C),this.refreshPromise=this.refreshPromise.then(()=>w)),Array.isArray(_.element)?v.elements.push(..._.element):v.elements.push(_.element)),_.message&&(v.message=!0),v),200,!0);this._register(D(({message:v,elements:_})=>{_.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const C=g;return w=null,this.refresh(_).then(()=>C())})),v&&this.proxy.$setMessage(this.viewId,p.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(o){const t=o?this.getExtensionElement(o):void 0;if(o&&!t)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let u=this.getChildrenNodes(o);return u||(u=await this.fetchChildrenNodes(t)),u?u.map(r=>r.item):void 0}getExtensionElement(o){return this.elements.get(o)}reveal(o,t){t=t||{select:!0,focus:!1};const u=(0,T.isUndefinedOrNull)(t.select)?!0:t.select,r=(0,T.isUndefinedOrNull)(t.focus)?!1:t.focus,c=(0,T.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(s=>this.resolveTreeNode(o,s[s.length-1]).then(w=>this.proxy.$reveal(this.viewId,{item:w.item,parentChain:s.map(g=>g.item)},{select:u,focus:r,expand:c})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:r,expand:c})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}get badge(){return this._badge}set badge(o){this._badge?.value===o?.value&&this._badge?.tooltip===o?.tooltip||(this._badge=p.ViewBadge.from(o),this.proxy.$setBadge(this.viewId,o))}setExpanded(o,t){const u=this.getExtensionElement(o);u&&(t?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelectionAndFocus(o,t){const u=!(0,I.equals)(this._selectedHandles,o);this._selectedHandles=o;const r=this._focusedHandle!==t;this._focusedHandle=t,u&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),r&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(o){const t=(await Promise.all(o.map(async u=>{const r=this.getExtensionElement(u.treeItemHandle);return r?{extensionItem:r,treeItem:await this.dataProvider.getTreeItem(r),newState:u.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);t.forEach(u=>{u.treeItem.checkboxState=u.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:t.map(u=>[u.extensionItem,u.newState])})}async handleDrag(o,t,u){const r=[];for(const c of o){const s=this.getExtensionElement(c);s&&r.push(s)}if(!(!this.dndController?.handleDrag||r.length===0))return await this.dndController.handleDrag(r,t,u),t}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(o,t,u){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.dndController?.handleDrop))return(0,m.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(r,o,u):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,t){if(!this.dataProvider.resolveTreeItem)return;const u=this.elements.get(o);if(u){const r=this.nodes.get(u);if(r){const c=await this.dataProvider.resolveTreeItem(r.extensionItem,u,t)??r.extensionItem;return this.validateTreeItem(c),r.item.tooltip=this.getTooltip(c.tooltip),r.item.command=this.getCommand(r.disposableStore,c.command),r.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(t=>t?this.resolveUnknownParentChain(t).then(u=>this.resolveTreeNode(t,u[u.length-1]).then(r=>(u.push(r),u))):Promise.resolve([]))}resolveParent(o){const t=this.nodes.get(o);return t?Promise.resolve(t.parent?this.elements.get(t.parent.item.handle):void 0):(0,m.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,t){const u=this.nodes.get(o);return u?Promise.resolve(u):(0,m.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(r=>this.createHandle(o,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const c=this.getExtensionElement(r);if(c){const s=this.nodes.get(c);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${r} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(o){if(o){let t;if(typeof o=="string"){const u=this.getExtensionElement(o);t=u?this.nodes.get(u):void 0}else t=o;return t&&t.children||void 0}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const t=new E.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=o?this.nodes.get(o):void 0,r=await this.dataProvider.getChildren(o);if(t.token.isCancellationRequested)return;const c=(0,I.coalesce)(r||[]),s=await Promise.all((0,I.coalesce)(c).map(g=>this.dataProvider.getTreeItem(g)));if(t.token.isCancellationRequested)return;const w=s.map((g,D)=>g?this.createAndRegisterTreeNode(c[D],g,u):null);return(0,I.coalesce)(w)}finally{t.dispose()}}refresh(o){if(o.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new E.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(o);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const t=new Set,u=o.map(c=>this.nodes.get(c));for(const c of u)if(c&&!t.has(c.item.handle)){let s=c;for(;s&&s.parent&&u.findIndex(w=>s&&s.parent&&w&&w.item.handle===s.parent.item.handle)===-1;){const w=this.elements.get(s.parent.item.handle);s=w?this.nodes.get(w):void 0}s&&!s.parent&&t.add(c.item.handle)}const r=[];return t.forEach(c=>{const s=this.elements.get(c);if(s){const w=this.nodes.get(s);w&&(!w.parent||!t.has(w.parent.item.handle))&&r.push(c)}}),r}refreshHandles(o){const t={};return Promise.all(o.map(u=>this.refreshNode(u).then(r=>{r&&(t[u]=r.item)}))).then(()=>Object.keys(t).length?this.proxy.$refresh(this.viewId,t):void 0)}refreshNode(o){const t=this.getExtensionElement(o);if(t){const u=this.nodes.get(t);if(u)return this.clearChildren(t),(0,m.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(r=>{if(r){const c=this.createTreeNode(t,r,u.parent);return this.updateNodeCache(t,c,u,u.parent),u.dispose(),c}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,t,u){const r=this.createTreeNode(o,t,u);if(t.id&&this.elements.has(r.item.handle))throw new Error((0,h.localize)(0,null,t.id));return this.addNodeToCache(o,r),this.addNodeToParentCache(r,u),r}getTooltip(o){return y.MarkdownString.isMarkdownString(o)?p.MarkdownString.from(o):o}getCommand(o,t){return t?{...this.commands.toInternal(t,o),originalId:t.command}:void 0}getCheckbox(o){if(o.checkboxState===void 0)return;let t,u,r;return typeof o.checkboxState=="number"?t=o.checkboxState:(t=o.checkboxState.state,u=o.checkboxState.tooltip,r=o.checkboxState.accessibilityInformation),{isChecked:t===y.TreeItemCheckboxState.Checked,tooltip:u,accessibilityInformation:r}}validateTreeItem(o){if(!y.TreeItem.isTreeItem(o,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(o,t,u){this.validateTreeItem(t);const r=this._register(new R.DisposableStore),c=this.createHandle(o,t,u),s=this.getLightIconPath(t);return{item:{handle:c,parentHandle:u?u.item.handle:void 0,label:a(t.label,this.extension),description:t.description,resourceUri:t.resourceUri,tooltip:this.getTooltip(t.tooltip),command:this.getCommand(r,t.command),contextValue:t.contextValue,icon:s,iconDark:this.getDarkIconPath(t)||s,themeIcon:this.getThemeIcon(t),collapsibleState:(0,T.isUndefinedOrNull)(t.collapsibleState)?y.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.getCheckbox(t)},extensionItem:t,parent:u,children:void 0,disposableStore:r,dispose(){r.dispose()}}}getThemeIcon(o){return o.iconPath instanceof y.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:t,label:u,resourceUri:r},c,s){if(t)return`${n.ID_HANDLE_PREFIX}/${t}`;const w=a(u,this.extension),g=c?c.item.handle:n.LABEL_HANDLE_PREFIX;let D=w?w.label:r?(0,O.basename)(r):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const v=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,_=this.getChildrenNodes(c)||[];let C,P=0;do{if(C=`${g}/${P}:${D}`,s||!this.elements.has(C)||v===C)break;P++}while(P<=_.length);return C}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof y.ThemeIcon))return typeof o.iconPath=="string"||L.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof y.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return L.URI.isUri(o)?o:L.URI.file(o)}addNodeToCache(o,t){this.elements.set(t.item.handle,o),this.nodes.set(o,t)}updateNodeCache(o,t,u,r){this.elements.delete(t.item.handle),this.nodes.delete(o),t.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(o,t);const c=this.getChildrenNodes(r)||[],s=c.filter(w=>w.item.handle===u.item.handle)[0];s&&c.splice(c.indexOf(s),1,t)}addNodeToParentCache(o,t){t?(t.children||(t.children=[]),t.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const t=this.nodes.get(o);if(t){if(t.children)for(const u of t.children){const r=this.elements.get(u.item.handle);r&&this.clear(r)}t.children=void 0}}else this.clearAll()}clear(o){const t=this.nodes.get(o);if(t){if(t.children)for(const u of t.children){const r=this.elements.get(u.item.handle);r&&this.clear(r)}this.nodes.delete(o),this.elements.delete(t.item.handle),t.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(_e[363],Ce([1,0,4,3,2,30,16,92,6,8]),function(ue,e,h,O,L,A,R,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class T extends O.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#h;#d;constructor(E,d,f,a){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#h=this._register(new h.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new h.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=E,this.#t=d,this.#n=f,this.#i=a.viewType,this.#s=a.panelOptions,this.#o=a.viewColumn,this.#r=a.title,this.#l=a.active}dispose(){this.#u||(this.#u=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#n}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#r}set title(E){this.assertNotDisposed(),this.#r!==E&&(this.#r=E,this.#t.$setTitle(this.#e,E))}get iconPath(){return this.assertNotDisposed(),this.#a}set iconPath(E){this.assertNotDisposed(),this.#a!==E&&(this.#a=E,this.#t.$setIconPath(this.#e,L.URI.isUri(E)?{light:E,dark:E}:E))}get options(){return this.#s}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.assertNotDisposed(),this.#l}get visible(){return this.assertNotDisposed(),this.#c}_updateViewState(E){this.#u||(this.active!==E.active||this.visible!==E.visible||this.viewColumn!==E.viewColumn)&&(this.#l=E.active,this.#c=E.visible,this.#o=E.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(E,d){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof E>"u"?void 0:R.ViewColumn.from(E),preserveFocus:!!d})}assertNotDisposed(){if(this.#u)throw new Error("Webview is disposed")}}class I extends O.Disposable{static newHandle(){return(0,A.generateUuid)()}constructor(E,d,f){super(),this.webviews=d,this.workspace=f,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=E.getProxy(m.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(E=>E.dispose()),this._webviewPanels.clear()}createWebviewPanel(E,d,f,a,i={}){const n=typeof a=="object"?a.viewColumn:a,l={viewColumn:R.ViewColumn.from(n),preserveFocus:typeof a=="object"&&!!a.preserveFocus},o=(0,b.shouldSerializeBuffersForPostMessage)(E),t=I.newHandle();this._proxy.$createWebviewPanel((0,b.toExtensionData)(E),t,d,{title:f,panelOptions:p(i),webviewOptions:(0,b.serializeWebviewOptions)(E,this.workspace,i),serializeBuffersForPostMessage:o},l);const u=this.webviews.createNewWebview(t,i,E);return this.createNewWebviewPanel(t,d,f,n,i,u,!0)}$onDidChangeWebviewPanelViewStates(E){const d=Object.keys(E);d.sort((f,a)=>{const i=E[f],n=E[a];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const f of d){const a=this.getWebviewPanel(f);if(!a)continue;const i=E[f];a._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(E){this.getWebviewPanel(E)?.dispose(),this._webviewPanels.delete(E),this.webviews.deleteWebview(E)}registerWebviewPanelSerializer(E,d,f){if(this._serializers.has(d))throw new Error(`Serializer for '${d}' already registered`);return this._serializers.set(d,{serializer:f,extension:E}),this._proxy.$registerSerializer(d,{serializeBuffersForPostMessage:(0,b.shouldSerializeBuffersForPostMessage)(E)}),new y.Disposable(()=>{this._serializers.delete(d),this._proxy.$unregisterSerializer(d)})}async $deserializeWebviewPanel(E,d,f,a){const i=this._serializers.get(d);if(!i)throw new Error(`No serializer found for '${d}'`);const{serializer:n,extension:l}=i,o=this.webviews.createNewWebview(E,f.webviewOptions,l),t=this.createNewWebviewPanel(E,d,f.title,a,f.panelOptions,o,f.active);await n.deserializeWebviewPanel(t,f.state)}createNewWebviewPanel(E,d,f,a,i,n,l){const o=new T(E,this._proxy,n,{viewType:d,title:f,viewColumn:a,panelOptions:i,active:l});return this._webviewPanels.set(E,o),o}getWebviewPanel(E){return this._webviewPanels.get(E)}}e.ExtHostWebviewPanels=I;function p(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(_e[364],Ce([1,0,4,3,92,16,6,8]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends O.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(I,p,S,E,d,f){super(),this.#s=!1,this.#l=this._register(new h.Emitter),this.onDidChangeVisibility=this.#l.event,this.#u=this._register(new h.Emitter),this.onDidDispose=this.#u.event,this.#i=S,this.#a=E,this.#e=I,this.#t=p,this.#n=d,this.#r=f}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.assertNotDisposed(),this.#a}set title(I){this.assertNotDisposed(),this.#a!==I&&(this.#a=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.assertNotDisposed(),this.#o}set description(I){this.assertNotDisposed(),this.#o!==I&&(this.#o=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(I){I===this.#r||this.#s||(this.#r=I,this.#l.fire())}get badge(){return this.assertNotDisposed(),this.#c}set badge(I){this.assertNotDisposed(),!(I?.value===this.#c?.value&&I?.tooltip===this.#c?.tooltip)&&(this.#c=A.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.assertNotDisposed(),this.#t.$show(this.#e,!!I)}assertNotDisposed(){if(this.#s)throw new Error("Webview is disposed")}}class y{constructor(I,p){this._extHostWebview=p,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=I.getProxy(R.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(I,p,S,E){if(this._viewProviders.has(p))throw new Error(`View provider for '${p}' already registered`);return this._viewProviders.set(p,{provider:S,extension:I}),this._proxy.$registerWebviewViewProvider((0,L.toExtensionData)(I),p,{retainContextWhenHidden:E?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,L.shouldSerializeBuffersForPostMessage)(I)}),new b.Disposable(()=>{this._viewProviders.delete(p),this._proxy.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(I,p,S,E,d){const f=this._viewProviders.get(p);if(!f)throw new Error(`No view provider found for '${p}'`);const{provider:a,extension:i}=f,n=this._extHostWebview.createNewWebview(I,{},i),l=new m(I,this._proxy,p,S,n,!0);this._webviewViews.set(I,l),await a.resolveWebviewView(l,{state:E},d)}async $onDidChangeWebviewViewVisibility(I,p){this.getWebviewView(I)._setVisible(p)}async $disposeWebviewView(I){const p=this.getWebviewView(I);this._webviewViews.delete(I),p.dispose(),this._extHostWebview.deleteWebview(I)}getWebviewView(I){const p=this._webviewViews.get(I);if(!p)throw new Error("No webview found");return p}}e.ExtHostWebviewViews=y}),define(_e[365],Ce([1,0,70,15,11,265,33,12]),function(ue,e,h,O,L,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiskFileSystemProvider=void 0;let m=class{constructor(I,p){I.addFileSystemProvider(O.Schemas.file,new y(p),{isCaseSensitive:b.isLinux})}};e.ExtHostDiskFileSystemProvider=m,e.ExtHostDiskFileSystemProvider=m=Ge([Ue(0,h.IExtHostConsumerFileSystem),Ue(1,L.ILogService)],m);class y{constructor(I){this.logService=I,this.impl=new A.DiskFileSystemProvider(this.logService)}async stat(I){const p=await this.impl.stat(I);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.impl.readdir(I)}createDirectory(I){return this.impl.mkdir(I)}readFile(I){return this.impl.readFile(I)}writeFile(I,p,S){return this.impl.writeFile(I,p,{...S,unlock:!1,atomic:!1})}delete(I,p){return this.impl.delete(I,{...p,useTrash:!1,atomic:!1})}rename(I,p,S){return this.impl.rename(I,p,S)}copy(I,p,S){return this.impl.copy(I,p,S)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,p){throw new Error("Method not implemented.")}}}),define(_e[366],Ce([1,0,17,64,30,34,3,6,2,20]),function(ue,e,h,O,L,A,R,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let T=class extends R.Disposable{constructor(p,S){super();const E=p.getProxy(b.MainContext.MainThreadDownloadService);S.registerCommand(!1,"_workbench.downloadResource",async d=>{const f=m.URI.file((0,h.join)((0,O.tmpdir)(),(0,L.generateUuid)()));return await E.$download(d,f),f})}};e.ExtHostDownloadService=T,e.ExtHostDownloadService=T=Ge([Ue(0,y.IExtHostRpcService),Ue(1,A.IExtHostCommands)],T)}),define(_e[367],Ce([1,0,53,17,2,93,3,15,7,32]),function(ue,e,h,O,L,A,R,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class T extends A.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(t){const u=await super._getWorkspaceStorageURI(t);if(u.scheme!==b.Schemas.file)return u;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${u.fsPath}.`),u;const r=u.fsPath;let c=0;do{let s;c===0?s=r:s=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${c}`:`${r}-${c}`,await I(s);const w=O.join(s,"vscode.lock"),g=await d(this._logService,w,!1);if(g)return this._workspaceStorageLock=g,process.on("exit",()=>{g.dispose()}),L.URI.file(s);c++}while(c<10);return u}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=T;async function I(o){try{await y.Promises.stat(o);return}catch{}try{await y.Promises.mkdir(o,{recursive:!0})}catch{}}const p=1e3,S=10*60*1e3;class E extends R.Disposable{constructor(t,u){super(),this.logService=t,this.filename=u,this._timer=this._register(new m.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await f(t,u);(!r||r.pid!==process.pid)&&(t.info(`Lock '${u}': The lock was lost unexpectedly.`),this._timer.cancel());try{await y.Promises.utimes(u,new Date,new Date)}catch(c){t.error(c),t.info(`Lock '${u}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{h.unlinkSync(this.filename)}catch{}}async setWillRelease(t){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const u={pid:process.pid,willReleaseAt:Date.now()+t};await y.Promises.writeFile(this.filename,JSON.stringify(u),{flag:"w"})}catch(u){this.logService.error(u)}}}async function d(o,t,u){try{const c={pid:process.pid,willReleaseAt:0};await y.Promises.writeFile(t,JSON.stringify(c),{flag:"wx"})}catch(c){o.error(c)}const r=await f(o,t);return!r||r.pid!==process.pid?u?(o.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(o.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(o,t)):(o.info(`Lock '${t}': Lock acquired.`),new E(o,t))}async function f(o,t){let u;try{u=await y.Promises.readFile(t)}catch(r){return o.error(r),null}try{return JSON.parse(String(u))}catch(r){return o.error(r),null}}async function a(o,t){let u;try{u=await y.Promises.stat(t)}catch(r){return o.error(r),0}return u.mtime.getTime()}function i(o){try{return process.kill(o,0),!0}catch{return!1}}async function n(o,t){const u=await f(o,t);if(!u)return o.info(`Lock '${t}': Could not read pid of lock holder.`),l(o,t);if(u.willReleaseAt){let g=u.willReleaseAt-Date.now();if(g<5e3){for(g>0?o.info(`Lock '${t}': The lockfile is scheduled to be released in ${g} ms.`):o.info(`Lock '${t}': The lockfile is scheduled to have been released.`);g>0;){if(await(0,m.timeout)(Math.min(100,g)),await a(o,t)===0)return l(o,t);g=u.willReleaseAt-Date.now()}return l(o,t)}}if(!i(u.pid))return o.info(`Lock '${t}': The pid ${u.pid} appears to be gone.`),l(o,t);const r=await a(o,t),c=Date.now()-r;if(c<=S)return o.info(`Lock '${t}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null;o.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,m.timeout)(2e3);const s=await a(o,t),w=Date.now()-s;return w<=S?(o.info(`Lock '${t}': The lock does not look stale, elapsed: ${w} ms, giving up.`),null):(o.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),l(o,t))}async function l(o,t){o.info(`Lock '${t}': Deleting a stale lock.`);try{await y.Promises.unlink(t)}catch{}return d(o,t,!0)}}),define(_e[368],Ce([1,0,30,20,43,34]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let R=class extends L.BaseExtHostTerminalService{constructor(m,y){super(!0,m,y)}createTerminal(m,y,T){return this.createTerminalFromOptions({name:m,shellPath:y,shellArgs:T})}createTerminalFromOptions(m,y){const T=new L.ExtHostTerminal(this._proxy,(0,h.generateUuid)(),m,m.name);return this._terminals.push(T),T.create(m,this._serializeParentTerminal(m,y)),T.value}};e.ExtHostTerminalService=R,e.ExtHostTerminalService=R=Ge([Ue(0,A.IExtHostCommands),Ue(1,O.IExtHostRpcService)],R)}),define(_e[369],Ce([1,0,4,36,38,5]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=e.CONTEXT_ACTIVE_OUTPUT_LEVEL=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=e.CONTEXT_ACTIVE_FILE_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new L.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_FILE_OUTPUT=new L.RawContextKey("activeLogOutput",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=new L.RawContextKey("activeLogOutput.levelSettable",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL=new L.RawContextKey("activeLogOutput.level",""),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=new L.RawContextKey("activeLogOutput.levelIsDefault",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new L.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)("outputService");var R;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.channels=new Map,this._onDidRegisterChannel=new h.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new h.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(y){this.channels.has(y.id)||(this.channels.set(y.id,y),this._onDidRegisterChannel.fire(y.id))}getChannels(){const y=[];return this.channels.forEach(T=>y.push(T)),y}getChannel(y){return this.channels.get(y)}removeChannel(y){this.channels.delete(y),this._onDidRemoveChannel.fire(y)}}O.Registry.add(e.Extensions.OutputChannels,new b),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new L.RawContextKey("activeOutputChannel","")}),define(_e[158],Ce([1,0,6,5,20,25,11,369,70,28,60,194,21,18,33,4,3]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class a extends R.AbstractMessageLogger{get disposed(){return this._disposed}constructor(o,t,u,r,c){super(),this.id=o,this.name=t,this.logger=u,this.proxy=r,this.extension=c,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(u.getLevel()),this._register(u.onDidChangeLogLevel(s=>this.setLevel(s)))}get logLevel(){return this.getLevel()}appendLine(o){this.append(o+`
`)}append(o){this.info(o)}clear(){const o=this.offset;this.logger.flush(),this.proxy.$update(this.id,b.OutputChannelUpdateMode.Clear,o)}replace(o){const t=this.offset;this.info(o),this.proxy.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.logger.flush()}show(o,t){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof o=="boolean"?o:t))}hide(){this.proxy.$close(this.id)}log(o,t){this.offset+=p.VSBuffer.fromString(t).byteLength,(0,R.log)(this.logger,o,t),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class i extends a{appendLine(o){this.append(o)}}let n=class{constructor(o,t,u,r,c,s){this.initData=t,this.extHostFileSystem=u,this.extHostFileSystemInfo=r,this.loggerService=c,this.logService=s,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=o.getProxy(h.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(o){this.visibleChannelId=o;for(const[t,u]of this.channels)u.visible=t===this.visibleChannelId}createOutputChannel(o,t,u){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,c=(0,S.isString)(t)?t:void 0;if((0,S.isString)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let s;const w=this.initData.environment.extensionLogLevel?.find(([D])=>A.ExtensionIdentifier.equals(u.identifier,D))?.[1];w&&(s=(0,R.parseLogLevel)(w));const g=r?this.doCreateLogOutputChannel(o,s,u):this.doCreateOutputChannel(o,c,u);return g.then(D=>{this.channels.set(D.id,D),D.visible=D.id===this.visibleChannelId}),r?this.createExtHostLogOutputChannel(o,s??this.logService.getLevel(),g):this.createExtHostOutputChannel(o,g)}async doCreateOutputChannel(o,t,u){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const r=await this.outputDirectoryPromise,c=this.extHostFileSystemInfo.extUri.joinPath(r,`${this.namePool++}-${o.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.loggerService.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),w=await this.proxy.$register(o,c,t,u.identifier.value);return new a(w,o,s,this.proxy,u)}async doCreateLogOutputChannel(o,t,u){const r=await this.createExtensionLogDirectory(u),c=o.replace(/[\\/:\*\?"<>\|]/g,""),s=this.extHostFileSystemInfo.extUri.joinPath(r,`${c}.log`),w=`${u.identifier.value}.${c}`,g=this.loggerService.createLogger(s,{id:w,name:o,logLevel:t,extensionId:u.identifier.value});return new i(w,o,g,this.proxy,u)}createExtensionLogDirectory(o){let t=this.extensionLogDirectoryPromise.get(o.identifier.value);if(!t){const u=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,o.identifier.value);this.extensionLogDirectoryPromise.set(o.identifier.value,t=(async()=>{try{await this.extHostFileSystem.value.createDirectory(u)}catch(r){if((0,E.toFileSystemProviderErrorCode)(r)!==E.FileSystemProviderErrorCode.FileExists)throw r}return u})())}return t}createExtHostOutputChannel(o,t){let u=!1;const r=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return o},append(c){r(),t.then(s=>s.append(c))},appendLine(c){r(),t.then(s=>s.appendLine(c))},clear(){r(),t.then(c=>c.clear())},replace(c){r(),t.then(s=>s.replace(c))},show(c,s){r(),t.then(w=>w.show(c,s))},hide(){r(),t.then(c=>c.hide())},dispose(){u=!0,t.then(c=>c.dispose())}}}createExtHostLogOutputChannel(o,t,u){const r=new f.DisposableStore,c=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},s=r.add(new d.Emitter);function w(g){t=g,s.fire(g)}return u.then(g=>{r.add(g),g.logLevel!==t&&w(g.logLevel),r.add(g.onDidChangeLogLevel(D=>w(D)))}),{...this.createExtHostOutputChannel(o,u),get logLevel(){return t},onDidChangeLogLevel:s.event,trace(g,...D){c(),u.then(v=>v.trace(g,...D))},debug(g,...D){c(),u.then(v=>v.debug(g,...D))},info(g,...D){c(),u.then(v=>v.info(g,...D))},warn(g,...D){c(),u.then(v=>v.warn(g,...D))},error(g,...D){c(),u.then(v=>v.error(g,...D))},dispose(){r.dispose()}}}};e.ExtHostOutputService=n,e.ExtHostOutputService=n=Ge([Ue(0,L.IExtHostRpcService),Ue(1,y.IExtHostInitDataService),Ue(2,m.IExtHostConsumerFileSystem),Ue(3,T.IExtHostFileSystemInfo),Ue(4,R.ILoggerService),Ue(5,R.ILogService)],n),e.IExtHostOutputService=(0,O.createDecorator)("IExtHostOutputService")}),define(_e[159],Ce([1,0,5,7]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,h.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(L){let A=1/0;for(let b=0;b<this.maxSampleCount;b++){const m=await L.getRoundTripTime();if(m===void 0)return;A=Math.min(A,m/2),await(0,O.timeout)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(A):R=this.initial.reduce((b,m)=>b+m,0)/this.initial.length,this.lastMeasurement={initial:R,current:A,average:this.average.reduce((b,m)=>b+m,0)/this.average.length,high:typeof R>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(_e[370],Ce([1,0,237,66,36,42,55,3,4,159,12,24,7]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DynamicWorkbenchSecurityConfiguration=e.ConfigurationMigrationWorkbenchContribution=e.Extensions=e.problemsConfigurationNodeBase=e.securityConfigurationNodeBase=e.workbenchConfigurationNodeBase=e.applicationConfigurationNodeBase=void 0,e.applicationConfigurationNodeBase=Object.freeze({id:"application",order:100,title:(0,h.localize)(0,null),type:"object"}),e.workbenchConfigurationNodeBase=Object.freeze({id:"workbench",order:7,title:(0,h.localize)(1,null),type:"object"}),e.securityConfigurationNodeBase=Object.freeze({id:"security",scope:1,title:(0,h.localize)(2,null),type:"object",order:7}),e.problemsConfigurationNodeBase=Object.freeze({id:"problems",title:(0,h.localize)(3,null),type:"object",order:101}),e.Extensions={ConfigurationMigration:"base.contributions.configuration.migration"};class S{constructor(){this.migrations=[],this._onDidRegisterConfigurationMigrations=new m.Emitter,this.onDidRegisterConfigurationMigration=this._onDidRegisterConfigurationMigrations.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const E=new S;L.Registry.add(e.Extensions.ConfigurationMigration,E);let d=class extends b.Disposable{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,n){super(),this.configurationService=i,this.workspaceService=n,this._register(this.workspaceService.onDidChangeWorkspaceFolders(async l=>{for(const o of l.added)await this.migrateConfigurationsForFolder(o,E.migrations)})),this.migrateConfigurations(E.migrations),this._register(E.onDidRegisterConfigurationMigration(l=>this.migrateConfigurations(l)))}async migrateConfigurations(i){await this.migrateConfigurationsForFolder(void 0,i);for(const n of this.workspaceService.getWorkspace().folders)await this.migrateConfigurationsForFolder(n,i)}async migrateConfigurationsForFolder(i,n){await Promise.all([n.map(l=>this.migrateConfigurationsForFolderAndOverride(l,i?.uri))])}async migrateConfigurationsForFolderAndOverride(i,n){const l=this.configurationService.inspect(i.key,{resource:n}),o=this.workspaceService.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,u]of o){const r=l[t];if(!r)continue;const c=[];if(r.value!==void 0){const s=await this.runMigration(i,t,r.value,n,void 0);for(const w of s??[])c.push([w,[]])}for(const{identifiers:s,value:w}of r.overrides??[])if(w!==void 0){const g=await this.runMigration(i,t,w,n,s);for(const D of g??[])c.push([D,s])}c.length&&await Promise.allSettled(c.map(async([[s,w],g])=>this.configurationService.updateValue(s,w.value,{resource:n,overrideIdentifiers:g},u)))}}async runMigration(i,n,l,o,t){const u=c=>{const w=this.configurationService.inspect(c,{resource:o})[n];if(w)return t?w.overrides?.find(({identifiers:g})=>(0,I.equals)(g,t))?.value:w.value},r=await i.migrateFn(l,u);return Array.isArray(r)?r:[[i.key,r]]}};e.ConfigurationMigrationWorkbenchContribution=d,e.ConfigurationMigrationWorkbenchContribution=d=Ge([Ue(0,R.IConfigurationService),Ue(1,A.IWorkspaceContextService)],d);let f=class extends b.Disposable{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.remoteAgentService=i,this._ready=new p.DeferredPromise,this.ready=this._ready.p,this.create()}async create(){try{await this.doCreate()}finally{this._ready.complete()}}async doCreate(){if(!T.isWindows&&(await this.remoteAgentService.getEnvironment())?.os!==1)return;L.Registry.as(O.Extensions.Configuration).registerConfiguration({...e.securityConfigurationNodeBase,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,h.localize)(4,null)},default:[],markdownDescription:(0,h.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,h.localize)(6,null),scope:2}}})}};e.DynamicWorkbenchSecurityConfiguration=f,e.DynamicWorkbenchSecurityConfiguration=f=Ge([Ue(0,y.IRemoteAgentService)],f)}),define(_e[371],Ce([1,0,35,15,17,23,247,370,66,5,36]),function(ue,e,h,O,L,A,R,b,m,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.editorsAssociationsSettingId=e.IEditorResolverService=void 0,e.priorityToRank=d,e.globMatchesResource=f,e.IEditorResolverService=(0,y.createDecorator)("editorResolverService"),e.editorsAssociationsSettingId="workbench.editorAssociations";const I=T.Registry.as(m.Extensions.Configuration),p={...b.workbenchConfigurationNodeBase,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};I.registerConfiguration(p);var S;(function(a){a.builtin="builtin",a.option="option",a.exclusive="exclusive",a.default="default"})(S||(e.RegisteredEditorPriority=S={}));var E;(function(a){a[a.ABORT=1]="ABORT",a[a.NONE=2]="NONE"})(E||(e.ResolvedStatus=E={}));function d(a){switch(a){case S.exclusive:return 5;case S.default:return 4;case S.builtin:return 3;case S.option:default:return 1}}function f(a,i){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(i.scheme))return!1;const o=typeof a=="string"&&a.indexOf(L.posix.sep)>=0?`${i.scheme}:${i.path}`:(0,A.basename)(i);return h.match(typeof a=="string"?a.toLowerCase():a,o.toLowerCase())}}),define(_e[372],Ce([1,0,31,15,17,12,23,2,5,284,42,148,159]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,m.createDecorator)("pathService");let E=S=class{constructor(f,a,i,n){this.localUserHome=f,this.remoteAgentService=a,this.environmentService=i,this.contextService=n,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||A.OS)(),this.resolveUserHome=(async()=>{const l=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=l?.userHome??f})()}hasValidBasename(f,a,i){return typeof a=="string"||typeof a>"u"?this.resolveOS.then(n=>this.doHasValidBasename(f,n,a)):this.doHasValidBasename(f,a,i)}doHasValidBasename(f,a,i){return f.scheme===O.Schemas.file||f.scheme===O.Schemas.vscodeRemote?(0,h.isValidBasename)(i??(0,R.basename)(f),a===1):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,a){if(f.remoteAuthority)return O.Schemas.vscodeRemote;const i=(0,y.getVirtualWorkspaceScheme)(a.getWorkspace());if(i)return i;const n=a.getWorkspace().folders[0];if(n)return n.uri.scheme;const l=a.getWorkspace().configuration;return l?l.scheme:O.Schemas.file}userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?L.win32:L.posix)}async fileURI(f){let a="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const n=f.indexOf("/",2);n===-1?(a=f.substring(2),f="/"):(a=f.substring(2,n),f=f.substring(n)||"/")}return b.URI.from({scheme:O.Schemas.file,authority:a,path:f,query:"",fragment:""})}};e.AbstractPathService=E,e.AbstractPathService=E=S=Ge([Ue(1,p.IRemoteAgentService),Ue(2,I.IWorkbenchEnvironmentService),Ue(3,T.IWorkspaceContextService)],E)}),define(_e[373],Ce([1,0,249,19,56,4,57,3,2,55,254,11,67,142,88,42,148,26,22,18,24,38]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i,n,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelModel=e.PortsAttributes=e.OnPortForward=e.AutoTunnelSource=e.UserTunnelSource=e.TunnelSource=e.TunnelCloseReason=e.forwardedPortsViewEnabled=e.ACTIVATION_EVENT=void 0,e.parseAddress=s,e.mapHasAddress=D,e.mapHasAddressLocalhostOrAllInterfaces=v,e.makeAddress=_,e.isCandidatePort=P;const t=10*1e3,u="remote.tunnels.toRestore",r="remote.tunnels.toRestoreExpiration",c=1e3*60*60*24*14;e.ACTIVATION_EVENT="onTunnel",e.forwardedPortsViewEnabled=new o.RawContextKey("forwardedPortsViewEnabled",!1,h.localize(0,null));function s(x){const z=x.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(z)return{host:z[1]?.substring(0,z[1].length-1)||"localhost",port:Number(z[2])}}var w;(function(x){x.Other="Other",x.User="User",x.AutoForwardEnd="AutoForwardEnd"})(w||(e.TunnelCloseReason=w={}));var g;(function(x){x[x.User=0]="User",x[x.Auto=1]="Auto",x[x.Extension=2]="Extension"})(g||(e.TunnelSource=g={})),e.UserTunnelSource={source:g.User,description:h.localize(1,null)},e.AutoTunnelSource={source:g.Auto,description:h.localize(2,null)};function D(x,z,N){const M=x.get(_(z,N));if(M)return M;if((0,E.isLocalhost)(z))for(const W of E.LOCALHOST_ADDRESSES){const X=_(W,N);if(x.has(X))return x.get(X)}else if((0,E.isAllInterfaces)(z))for(const W of E.ALL_INTERFACES_ADDRESSES){const X=_(W,N);if(x.has(X))return x.get(X)}}function v(x,z,N){const M=D(x,z,N);if(M)return M;const W=(0,E.isAllInterfaces)(z)?"localhost":(0,E.isLocalhost)(z)?"0.0.0.0":void 0;if(W)return D(x,W,N)}function _(x,z){return x+":"+z}var C;(function(x){x.Notify="notify",x.OpenBrowser="openBrowser",x.OpenBrowserOnce="openBrowserOnce",x.OpenPreview="openPreview",x.Silent="silent",x.Ignore="ignore"})(C||(e.OnPortForward=C={}));function P(x){return x&&"host"in x&&typeof x.host=="string"&&"port"in x&&typeof x.port=="number"&&(!("detail"in x)||typeof x.detail=="string")&&(!("pid"in x)||typeof x.pid=="string")}class k extends b.Disposable{static{this.SETTING="remote.portsAttributes"}static{this.DEFAULTS="remote.otherPortsAttributes"}static{this.RANGE=/^(\d+)\-(\d+)$/}static{this.HOST_AND_PORT=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(z){super(),this.configurationService=z,this.portsAttributes=[],this._onDidChangeAttributes=new A.Emitter,this.onDidChangeAttributes=this._onDidChangeAttributes.event,this._register(z.onDidChangeConfiguration(N=>{(N.affectsConfiguration(k.SETTING)||N.affectsConfiguration(k.DEFAULTS))&&this.updateAttributes()})),this.updateAttributes()}updateAttributes(){this.portsAttributes=this.readSetting(),this._onDidChangeAttributes.fire()}getAttributes(z,N,M){let W=this.findNextIndex(z,N,M,this.portsAttributes,0);const X={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;W>=0;){const te=this.portsAttributes[W];te.key===z?(X.onAutoForward=te.onAutoForward??X.onAutoForward,X.elevateIfNeeded=te.elevateIfNeeded!==void 0?te.elevateIfNeeded:X.elevateIfNeeded,X.label=te.label??X.label,X.requireLocalPort=te.requireLocalPort,X.protocol=te.protocol):(X.onAutoForward=X.onAutoForward??te.onAutoForward,X.elevateIfNeeded=X.elevateIfNeeded!==void 0?X.elevateIfNeeded:te.elevateIfNeeded,X.label=X.label??te.label,X.requireLocalPort=X.requireLocalPort!==void 0?X.requireLocalPort:void 0,X.protocol=X.protocol??te.protocol),W=this.findNextIndex(z,N,M,this.portsAttributes,W+1)}return X.onAutoForward!==void 0||X.elevateIfNeeded!==void 0||X.label!==void 0||X.requireLocalPort!==void 0||X.protocol!==void 0?X:this.getOtherAttributes()}hasStartEnd(z){return z.start!==void 0&&z.end!==void 0}hasHostAndPort(z){return z.host!==void 0&&z.port!==void 0&&(0,n.isString)(z.host)&&(0,n.isNumber)(z.port)}findNextIndex(z,N,M,W,X){if(X>=W.length)return-1;const te=!(0,E.isLocalhost)(N)&&!(0,E.isAllInterfaces)(N),G=W.slice(X).findIndex(Y=>(0,n.isNumber)(Y.key)?te?!1:Y.key===z:this.hasStartEnd(Y.key)?te?!1:z>=Y.key.start&&z<=Y.key.end:this.hasHostAndPort(Y.key)?z===Y.key.port&&N===Y.key.host:M?Y.key.test(M):!1);return G>=0?G+X:-1}readSetting(){const z=this.configurationService.getValue(k.SETTING);if(!z||!(0,n.isObject)(z))return[];const N=[];for(const W in z){if(W===void 0)continue;const X=z[W];let te;if(Number(W))te=Number(W);else if((0,n.isString)(W))if(k.RANGE.test(W)){const H=W.match(k.RANGE);te={start:Number(H[1]),end:Number(H[2])}}else if(k.HOST_AND_PORT.test(W)){const H=W.match(k.HOST_AND_PORT);te={host:H[1],port:Number(H[2])}}else{let H;try{H=RegExp(W)}catch{}H&&(te=H)}te&&N.push({key:te,elevateIfNeeded:X.elevateIfNeeded,onAutoForward:X.onAutoForward,label:X.label,requireLocalPort:X.requireLocalPort,protocol:X.protocol})}const M=this.configurationService.getValue(k.DEFAULTS);return M&&(this.defaultPortAttributes={elevateIfNeeded:M.elevateIfNeeded,label:M.label,onAutoForward:M.onAutoForward,requireLocalPort:M.requireLocalPort,protocol:M.protocol}),this.sortAttributes(N)}sortAttributes(z){function N(M,W){return(0,n.isNumber)(M.key)?M.key:W.hasStartEnd(M.key)?M.key.start:W.hasHostAndPort(M.key)?M.key.port:Number.MAX_VALUE}return z.sort((M,W)=>N(M,this)-N(W,this))}getOtherAttributes(){return this.defaultPortAttributes}static providedActionToAction(z){switch(z){case E.ProvidedOnAutoForward.Notify:return C.Notify;case E.ProvidedOnAutoForward.OpenBrowser:return C.OpenBrowser;case E.ProvidedOnAutoForward.OpenBrowserOnce:return C.OpenBrowserOnce;case E.ProvidedOnAutoForward.OpenPreview:return C.OpenPreview;case E.ProvidedOnAutoForward.Silent:return C.Silent;case E.ProvidedOnAutoForward.Ignore:return C.Ignore;default:return}}async addAttributes(z,N,M){const X=this.configurationService.inspect(k.SETTING).userRemoteValue;let te;!X||!(0,n.isObject)(X)?te={}:te=(0,l.deepClone)(X),te[`${z}`]||(te[`${z}`]={});for(const H in N)te[`${z}`][H]=N[H];return this.configurationService.updateValue(k.SETTING,te,M)}}e.PortsAttributes=k;let F=class extends b.Disposable{constructor(z,N,M,W,X,te,H,G,Y,ne){super(),this.tunnelService=z,this.storageService=N,this.configurationService=M,this.environmentService=W,this.remoteAuthorityResolverService=X,this.workspaceContextService=te,this.logService=H,this.dialogService=G,this.extensionService=Y,this.contextKeyService=ne,this.inProgress=new Map,this._onForwardPort=new A.Emitter,this.onForwardPort=this._onForwardPort.event,this._onClosePort=new A.Emitter,this.onClosePort=this._onClosePort.event,this._onPortName=new A.Emitter,this.onPortName=this._onPortName.event,this._onCandidatesChanged=new A.Emitter,this.onCandidatesChanged=this._onCandidatesChanged.event,this._onEnvironmentTunnelsSet=new A.Emitter,this.onEnvironmentTunnelsSet=this._onEnvironmentTunnelsSet.event,this._environmentTunnelsSet=!1,this.restoreListener=void 0,this.restoreComplete=!1,this.onRestoreComplete=new A.Emitter,this.unrestoredExtensionTunnels=new Map,this.sessionCachedProperties=new Map,this.portAttributesProviders=[],this.mismatchCooldown=new Date,this.configPortsAttributes=new k(M),this.tunnelRestoreValue=this.getTunnelRestoreValue(),this._register(this.configPortsAttributes.onDidChangeAttributes(this.updateAttributes,this)),this.forwarded=new Map,this.remoteTunnels=new Map,this.tunnelService.tunnels.then(async pe=>{const le=await this.getAttributes(pe.map(we=>({port:we.tunnelRemotePort,host:we.tunnelRemoteHost})));for(const we of pe)if(we.localAddress){const Z=_(we.tunnelRemoteHost,we.tunnelRemotePort),B=v(this._candidates??new Map,we.tunnelRemoteHost,we.tunnelRemotePort);this.forwarded.set(Z,{remotePort:we.tunnelRemotePort,remoteHost:we.tunnelRemoteHost,localAddress:we.localAddress,protocol:le?.get(we.tunnelRemotePort)?.protocol??E.TunnelProtocol.Http,localUri:await this.makeLocalUri(we.localAddress,le?.get(we.tunnelRemotePort)),localPort:we.tunnelLocalPort,runningProcess:B?.detail,hasRunningProcess:!!B,pid:B?.pid,privacy:we.privacy,source:e.UserTunnelSource}),this.remoteTunnels.set(Z,we)}}),this.detected=new Map,this._register(this.tunnelService.onTunnelOpened(async pe=>{const le=_(pe.tunnelRemoteHost,pe.tunnelRemotePort);if(!v(this.forwarded,pe.tunnelRemoteHost,pe.tunnelRemotePort)&&!v(this.detected,pe.tunnelRemoteHost,pe.tunnelRemotePort)&&!v(this.inProgress,pe.tunnelRemoteHost,pe.tunnelRemotePort)&&pe.localAddress){const we=v(this._candidates??new Map,pe.tunnelRemoteHost,pe.tunnelRemotePort),Z=(await this.getAttributes([{port:pe.tunnelRemotePort,host:pe.tunnelRemoteHost}]))?.get(pe.tunnelRemotePort);this.forwarded.set(le,{remoteHost:pe.tunnelRemoteHost,remotePort:pe.tunnelRemotePort,localAddress:pe.localAddress,protocol:Z?.protocol??E.TunnelProtocol.Http,localUri:await this.makeLocalUri(pe.localAddress,Z),localPort:pe.tunnelLocalPort,closeable:!0,runningProcess:we?.detail,hasRunningProcess:!!we,pid:we?.pid,privacy:pe.privacy,source:e.UserTunnelSource})}await this.storeForwarded(),this.remoteTunnels.set(le,pe),this._onForwardPort.fire(this.forwarded.get(le))})),this._register(this.tunnelService.onTunnelClosed(pe=>this.onTunnelClosed(pe,w.Other))),this.checkExtensionActivationEvents()}extensionHasActivationEvent(){return this.extensionService.extensions.find(z=>z.activationEvents?.includes(e.ACTIVATION_EVENT))?(this.contextKeyService.createKey(e.forwardedPortsViewEnabled.key,!0),!0):!1}checkExtensionActivationEvents(){if(this.extensionHasActivationEvent())return;const z=this._register(this.extensionService.onDidRegisterExtensions(()=>{this.extensionHasActivationEvent()&&z.dispose()}))}async onTunnelClosed(z,N){const M=_(z.host,z.port);this.forwarded.has(M)&&(this.forwarded.delete(M),await this.storeForwarded(),this._onClosePort.fire(z))}makeLocalUri(z,N){if(z.startsWith("http"))return m.URI.parse(z);const M=N?.protocol??"http";return m.URI.parse(`${M}://${z}`)}async addStorageKeyPostfix(z){const N=this.workspaceContextService.getWorkspace(),M=N.configuration?(0,R.hash)(N.configuration.path):N.folders.length>0?(0,R.hash)(N.folders[0].uri.path):void 0;if(M===void 0){this.logService.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${z}.${this.environmentService.remoteAuthority}.${M}`}async getTunnelRestoreStorageKey(){return this.addStorageKeyPostfix(u)}async getRestoreExpirationStorageKey(){return this.addStorageKeyPostfix(r)}async getTunnelRestoreValue(){const z=this.storageService.get(u,1);if(z)return this.storageService.remove(u,1),await this.storeForwarded(),z;const N=await this.getTunnelRestoreStorageKey();if(N)return this.storageService.get(N,0)}async restoreForwarded(){if(this.cleanupExpiredTunnelsForRestore(),this.configurationService.getValue("remote.restoreForwardedPorts")){const z=await this.tunnelRestoreValue;if(z&&z!==this.knownPortsRestoreValue){const N=JSON.parse(z)??[];this.logService.trace(`ForwardedPorts: (TunnelModel) restoring ports ${N.map(M=>M.remotePort).join(", ")}`);for(const M of N){const W=v(this.detected,M.remoteHost,M.remotePort);M.source.source!==g.Extension&&!W||M.source.source===g.Extension&&W?await this.doForward({remote:{host:M.remoteHost,port:M.remotePort},local:M.localPort,name:M.name,elevateIfNeeded:!0,source:M.source}):M.source.source===g.Extension&&!W&&this.unrestoredExtensionTunnels.set(_(M.remoteHost,M.remotePort),M)}}}if(this.restoreComplete=!0,this.onRestoreComplete.fire(),!this.restoreListener){const z=await this.getTunnelRestoreStorageKey();this.restoreListener=this._register(new b.DisposableStore),this.restoreListener.add(this.storageService.onDidChangeValue(0,void 0,this.restoreListener)(async N=>{N.key===z&&(this.tunnelRestoreValue=Promise.resolve(this.storageService.get(z,0)),await this.restoreForwarded())}))}}cleanupExpiredTunnelsForRestore(){const z=this.storageService.keys(0,0).filter(N=>N.startsWith(r));for(const N of z){const M=this.storageService.getNumber(N,0);if(M&&M<Date.now()){this.tunnelRestoreValue=Promise.resolve(void 0);const W=N.replace(r,u);this.storageService.remove(N,0),this.storageService.remove(W,0)}}}async storeForwarded(){if(this.configurationService.getValue("remote.restoreForwardedPorts")){const z=Array.from(this.forwarded.values()),N=z.map(te=>({remoteHost:te.remoteHost,remotePort:te.remotePort,localPort:te.localPort,name:te.name,localAddress:te.localAddress,localUri:te.localUri,protocol:te.protocol,source:te.source}));let M;z.length>0&&(M=JSON.stringify(N));const W=await this.getTunnelRestoreStorageKey(),X=await this.getRestoreExpirationStorageKey();!M&&W&&X?(this.storageService.remove(W,0),this.storageService.remove(X,0)):M!==this.knownPortsRestoreValue&&W&&X&&(this.storageService.store(W,M,0,0),this.storageService.store(X,Date.now()+c,0,0)),this.knownPortsRestoreValue=M}}async showPortMismatchModalIfNeeded(z,N,M){if(!z.tunnelLocalPort||!M?.requireLocalPort||z.tunnelLocalPort===N)return;const W=new Date;if(this.mismatchCooldown.getTime()+t>W.getTime())return;this.mismatchCooldown=W;const X=h.localize(3,null,N,z.tunnelRemotePort,z.tunnelLocalPort);return this.dialogService.info(X)}async forward(z,N){return!this.restoreComplete&&this.environmentService.remoteAuthority&&await A.Event.toPromise(this.onRestoreComplete.event),this.doForward(z,N)}async doForward(z,N){await this.extensionService.activateByEvent(e.ACTIVATION_EVENT);const M=v(this.forwarded,z.remote.host,z.remote.port);N=N??(N!==null?(await this.getAttributes([z.remote]))?.get(z.remote.port):void 0);const W=z.local!==void 0?z.local:z.remote.port;let X;if(M)return this.mergeAttributesIntoExistingTunnel(M,z,N);{const te=this.environmentService.remoteAuthority,H=te?{getAddress:async()=>(await this.remoteAuthorityResolverService.resolveAuthority(te)).authority}:void 0,G=_(z.remote.host,z.remote.port);this.inProgress.set(G,!0),z=this.mergeCachedAndUnrestoredProperties(G,z);const Y=await this.tunnelService.openTunnel(H,z.remote.host,z.remote.port,void 0,W,z.elevateIfNeeded?z.elevateIfNeeded:N?.elevateIfNeeded,z.privacy,N?.protocol);if(typeof Y=="string")X=Y;else if(Y&&Y.localAddress){const ne=v(this._candidates??new Map,z.remote.host,z.remote.port),pe=Y.protocol?Y.protocol===E.TunnelProtocol.Https?E.TunnelProtocol.Https:E.TunnelProtocol.Http:N?.protocol??E.TunnelProtocol.Http,le={remoteHost:Y.tunnelRemoteHost,remotePort:Y.tunnelRemotePort,localPort:Y.tunnelLocalPort,name:N?.label??z.name,closeable:!0,localAddress:Y.localAddress,protocol:pe,localUri:await this.makeLocalUri(Y.localAddress,N),runningProcess:ne?.detail,hasRunningProcess:!!ne,pid:ne?.pid,source:z.source??e.UserTunnelSource,privacy:Y.privacy};return this.forwarded.set(G,le),this.remoteTunnels.set(G,Y),this.inProgress.delete(G),await this.storeForwarded(),await this.showPortMismatchModalIfNeeded(Y,W,N),this._onForwardPort.fire(le),Y}this.inProgress.delete(G)}return X}mergeCachedAndUnrestoredProperties(z,N){const M=this.unrestoredExtensionTunnels.has(z)?this.unrestoredExtensionTunnels:this.sessionCachedProperties.has(z)?this.sessionCachedProperties:void 0;if(M){const W=M.get(z);M.delete(z),W&&(N.name=W.name??N.name,N.local=("local"in W?W.local:"localPort"in W?W.localPort:void 0)??N.local,N.privacy=N.privacy)}return N}async mergeAttributesIntoExistingTunnel(z,N,M){const W=M?.label??N.name;let X;(function(H){H[H.None=0]="None",H[H.Fire=1]="Fire",H[H.Reopen=2]="Reopen"})(X||(X={}));let te=X.None;switch(W!==z.name&&(z.name=W,te=X.Fire),(M?.protocol||z.protocol!==E.TunnelProtocol.Http)&&M?.protocol!==z.protocol&&(N.source=z.source,te=X.Reopen),N.privacy&&z.privacy!==N.privacy&&(te=X.Reopen),te){case X.Fire:{this._onForwardPort.fire();break}case X.Reopen:await this.close(z.remoteHost,z.remotePort,w.User),await this.doForward(N,M)}return v(this.remoteTunnels,N.remote.host,N.remote.port)}async name(z,N,M){const W=v(this.forwarded,z,N),X=_(z,N);if(W){W.name=M,await this.storeForwarded(),this._onPortName.fire({host:z,port:N});return}else this.detected.has(X)&&(this.detected.get(X).name=M,this._onPortName.fire({host:z,port:N}))}async close(z,N,M){const W=_(z,N),X=this.forwarded.get(W);return M===w.AutoForwardEnd&&X&&X.source.source===g.Auto&&this.sessionCachedProperties.set(W,{local:X.localPort,name:X.name,privacy:X.privacy}),await this.tunnelService.closeTunnel(z,N),this.onTunnelClosed({host:z,port:N},M)}address(z,N){const M=_(z,N);return(this.forwarded.get(M)||this.detected.get(M))?.localAddress}get environmentTunnelsSet(){return this._environmentTunnelsSet}addEnvironmentTunnels(z){if(z)for(const N of z){const M=v(this._candidates??new Map,N.remoteAddress.host,N.remoteAddress.port),W=typeof N.localAddress=="string"?N.localAddress:_(N.localAddress.host,N.localAddress.port);this.detected.set(_(N.remoteAddress.host,N.remoteAddress.port),{remoteHost:N.remoteAddress.host,remotePort:N.remoteAddress.port,localAddress:W,protocol:E.TunnelProtocol.Http,localUri:this.makeLocalUri(W),closeable:!1,runningProcess:M?.detail,hasRunningProcess:!!M,pid:M?.pid,privacy:E.TunnelPrivacyId.ConstantPrivate,source:{source:g.Extension,description:h.localize(4,null)}}),this.tunnelService.setEnvironmentTunnel(N.remoteAddress.host,N.remoteAddress.port,W,E.TunnelPrivacyId.ConstantPrivate,E.TunnelProtocol.Http)}this._environmentTunnelsSet=!0,this._onEnvironmentTunnelsSet.fire(),this._onForwardPort.fire()}setCandidateFilter(z){this._candidateFilter=z}async setCandidates(z){let N=z;this._candidateFilter&&(N=await this._candidateFilter(z));const M=this.updateInResponseToCandidates(N);this.logService.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(M.values()).map(W=>W.port).join(", ")}`),this._onCandidatesChanged.fire(M)}updateInResponseToCandidates(z){const N=this._candidates??new Map,M=new Map;return this._candidates=M,z.forEach(W=>{const X=_(W.host,W.port);M.set(X,{host:W.host,port:W.port,detail:W.detail,pid:W.pid}),N.has(X)&&N.delete(X);const te=v(this.forwarded,W.host,W.port);te&&(te.runningProcess=W.detail,te.hasRunningProcess=!0,te.pid=W.pid)}),N.forEach((W,X)=>{const te=s(X);if(!te)return;const H=v(this.forwarded,te.host,te.port);H&&(H.runningProcess=void 0,H.hasRunningProcess=!1,H.pid=void 0);const G=v(this.detected,te.host,te.port);G&&(G.runningProcess=void 0,G.hasRunningProcess=!1,G.pid=void 0)}),N}get candidates(){return this._candidates?Array.from(this._candidates.values()):[]}get candidatesOrUndefined(){return this._candidates?this.candidates:void 0}async updateAttributes(){const z=Array.from(this.forwarded.values()),N=await this.getAttributes(z.map(M=>({port:M.remotePort,host:M.remoteHost})),!1);if(N)for(const M of z){const W=N.get(M.remotePort);(W?.protocol||M.protocol!==E.TunnelProtocol.Http)&&W?.protocol!==M.protocol&&await this.doForward({remote:{host:M.remoteHost,port:M.remotePort},local:M.localPort,name:M.name,source:M.source},W),W&&W.label&&W.label!==M.name&&await this.name(M.remoteHost,M.remotePort,W.label)}}async getAttributes(z,N=!0){const M=new Map,W=new Map;z.forEach(Y=>{const ne=v(this._candidates??new Map,E.LOCALHOST_ADDRESSES[0],Y.port)??Y;if(ne){M.set(Y.port,ne);const pe=P(ne)?ne.pid:void 0;W.has(pe)||W.set(pe,[]),W.get(pe)?.push(Y.port)}});const X=new Map;if(z.forEach(Y=>{const ne=this.configPortsAttributes.getAttributes(Y.port,Y.host,M.get(Y.port)?.detail);ne&&X.set(Y.port,ne)}),this.portAttributesProviders.length===0||!N)return X.size>0?X:void 0;const te=await Promise.all((0,O.flatten)(this.portAttributesProviders.map(Y=>Array.from(W.entries()).map(ne=>{const pe=ne[1],le=M.get(pe[0]);return Y.providePortAttributes(pe,le?.pid,le?.detail,i.CancellationToken.None)})))),H=new Map;if(te.forEach(Y=>Y.forEach(ne=>{ne&&H.set(ne.port,ne)})),!X&&!H)return;const G=new Map;return z.forEach(Y=>{const ne=X.get(Y.port),pe=H.get(Y.port);G.set(Y.port,{elevateIfNeeded:ne?.elevateIfNeeded,label:ne?.label,onAutoForward:ne?.onAutoForward??k.providedActionToAction(pe?.autoForwardAction),requireLocalPort:ne?.requireLocalPort,protocol:ne?.protocol})}),G}addAttributesProvider(z){this.portAttributesProviders.push(z)}};e.TunnelModel=F,Ge([(0,L.debounce)(1e3)],F.prototype,"storeForwarded",null),e.TunnelModel=F=Ge([Ue(0,E.ITunnelService),Ue(1,S.IStorageService),Ue(2,y.IConfigurationService),Ue(3,f.IWorkbenchEnvironmentService),Ue(4,p.IRemoteAuthorityResolverService),Ue(5,d.IWorkspaceContextService),Ue(6,I.ILogService),Ue(7,T.IDialogService),Ue(8,a.IExtensionService),Ue(9,o.IContextKeyService)],F)}),define(_e[94],Ce([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class h{constructor(R,b){this.line=R,this.character=b}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,b){return new h(0,0)}with(R){return new h(0,0)}}e.Position=h;class O{constructor(R,b,m,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new h(R,b),this.end=new h(m,y)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new O(0,0,0,0)}with(R){return new O(0,0,0,0)}}e.Range=O;var L;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(L||(e.TextSearchCompleteMessageType=L={}))}),define(_e[37],Ce([1,0,19,35,24,31,14,5,17,13,94,7]),function(ue,e,h,O,L,A,R,b,m,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.SerializableFileMatch=e.SearchError=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,e.resultIsMatch=a,e.isFileMatch=i,e.isProgressMessage=n,e.getExcludes=g,e.pathIncludedInQuery=D,e.deserializeSearchError=C,e.serializeSearchError=P,e.isSerializedSearchComplete=k,e.isSerializedSearchSuccess=F,e.isSerializedFileMatch=x,e.isFilePatternMatch=z,e.resolvePatternsForProvider=M,e.hasSiblingPromiseFn=te,e.hasSiblingFn=H,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const p="\u27EA ",S=" characters skipped \u27EB",E=(p.length+S.length+5)*2;e.ISearchService=(0,b.createDecorator)("searchService");var d;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text",Y[Y.aiText=2]="aiText"})(d||(e.SearchProviderType=d={}));var f;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text",Y[Y.aiText=3]="aiText"})(f||(e.QueryType=f={}));function a(Y){return!!Y.preview}function i(Y){return!!Y.resource}function n(Y){return!!Y.message}var l;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(l||(e.SearchCompletionExitCode=l={}));class o{constructor(ne){this.resource=ne,this.results=[]}}e.FileMatch=o;class t{constructor(ne,pe,le,we){this.ranges=pe,this.webviewIndex=we;const Z=Array.isArray(pe)?pe:[pe];if(le&&le.matchLines===1&&u(Z)){ne=(0,R.getNLines)(ne,le.matchLines);let B="",ee=0,ve=0;const Pe=Math.floor(le.charsPerLine/5),oe=[];for(const se of Z){const re=Math.max(se.startColumn-Pe,0),j=se.startColumn+le.charsPerLine;if(re>ve+Pe+E){const ie=p+(re-ve)+S;B+=ie+ne.slice(re,j),ee+=re-(ve+ie.length)}else B+=ne.slice(ve,j);oe.push(new c(0,se.startColumn-ee,se.endColumn-ee)),ve=j}this.preview={text:B,matches:Array.isArray(this.ranges)?oe:oe[0]}}else{const B=Array.isArray(pe)?pe[0].startLineNumber:pe.startLineNumber;this.preview={text:ne,matches:(0,h.mapArrayOrNot)(pe,ee=>new r(ee.startLineNumber-B,ee.startColumn,ee.endLineNumber-B,ee.endColumn))}}}}e.TextSearchMatch=t;function u(Y){const ne=Y[0].startLineNumber;for(const pe of Y)if(pe.startLineNumber!==ne||pe.endLineNumber!==ne)return!1;return!0}class r{constructor(ne,pe,le,we){this.startLineNumber=ne,this.startColumn=pe,this.endLineNumber=le,this.endColumn=we}}e.SearchRange=r;class c extends r{constructor(ne,pe,le){super(ne,pe,ne,le)}}e.OneLineRange=c;var s;(function(Y){Y.List="list",Y.Tree="tree"})(s||(e.ViewMode=s={}));var w;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(w||(e.SearchSortOrder=w={}));function g(Y,ne=!0){const pe=Y&&Y.files&&Y.files.exclude,le=ne&&Y&&Y.search&&Y.search.exclude;if(!pe&&!le)return;if(!pe||!le)return pe||le;let we=Object.create(null);return we=L.mixin(we,L.deepClone(pe)),we=L.mixin(we,L.deepClone(le),!0),we}function D(Y,ne){return Y.excludePattern&&O.match(Y.excludePattern,ne)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&O.match(Y.includePattern,ne)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(pe=>{const le=pe.folder.fsPath;if(A.isEqualOrParent(ne,le)){const we=m.relative(le,ne);return!pe.includePattern||!!O.match(pe.includePattern,we)}else return!1}):!1:!0}var v;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class _ extends Error{constructor(ne,pe){super(ne),this.code=pe}}e.SearchError=_;function C(Y){const ne=Y.message;if((0,y.isCancellationError)(Y))return new _(ne,v.canceled);try{const pe=JSON.parse(ne);return new _(pe.message,pe.code)}catch{return new _(ne,v.other)}}function P(Y){const ne={message:Y.message,code:Y.code};return new Error(JSON.stringify(ne))}function k(Y){return Y.type==="error"?!0:Y.type==="success"}function F(Y){return Y.type==="success"}function x(Y){return!!Y.path}function z(Y,ne,pe=!0){const le=Y.searchPath?Y.searchPath:Y.relativePath;return pe?(0,R.fuzzyContains)(le,ne):O.match(ne,le)}class N{constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=N;function M(Y,ne){const pe={...Y||{},...ne||{}};return Object.keys(pe).filter(le=>{const we=pe[le];return typeof we=="boolean"&&we})}class W{constructor(ne,pe){this._parsedIncludeExpression=null,this._excludeExpression={...ne.excludePattern||{},...pe.excludePattern||{}},this._parsedExcludeExpression=O.parse(this._excludeExpression);let le=ne.includePattern;pe.includePattern&&(le?le={...le,...pe.includePattern}:le=pe.includePattern),le&&(this._parsedIncludeExpression=O.parse(le))}matchesExcludesSync(ne,pe,le){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ne,pe,le))}includedInQuerySync(ne,pe,le){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ne,pe,le)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ne,pe,le))}includedInQuery(ne,pe,le){const we=this._parsedExcludeExpression(ne,pe,le),Z=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ne,pe,le):!0;return(0,I.isThenable)(we)?we.then(B=>B?!1:Z()):Z()}hasSiblingExcludeClauses(){return X(this._excludeExpression)}}e.QueryGlobTester=W;function X(Y){for(const ne in Y)if(typeof Y[ne]!="boolean")return!0;return!1}function te(Y){if(!Y)return;let ne;return pe=>(ne||(ne=(Y()||Promise.resolve([])).then(le=>le?G(le):{})),ne.then(le=>!!le[pe]))}function H(Y){if(!Y)return;let ne;return pe=>{if(!ne){const le=Y();ne=le?G(le):{}}return!!ne[pe]}}function G(Y){const ne={};for(const pe of Y)ne[pe]=!0;return ne}}),define(_e[44],Ce([1,0,19,7,22,4,3,78,15,126,23,14,2,235,5,11,268,42,60,28,20,16,8,68,37,6,58]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i,n,l,o,t,u,r,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function w(F,x,z){return new T.ExtUri(N=>_(N,z)).isEqual(F,x)}function g(F,x,z){return w(F.uri,x.uri,z)?0:(0,I.compare)(F.uri.toString(),x.uri.toString())}function D(F,x,z){return F.index!==x.index?F.index<x.index?-1:1:w(F.uri,x.uri,z)?(0,I.compare)(F.name,x.name):(0,I.compare)(F.uri.toString(),x.uri.toString())}function v(F,x,z,N){const M=F.slice(0).sort((X,te)=>z(X,te,N)),W=x.slice(0).sort((X,te)=>z(X,te,N));return(0,h.delta)(M,W,(X,te)=>z(X,te,N))}function _(F,x){const z=x.getCapabilities(F.scheme);return!(z&&z&1024)}class C extends a.Workspace{static toExtHostWorkspace(x,z,N,M){if(!x)return{workspace:null,added:[],removed:[]};const{id:W,name:X,folders:te,configuration:H,transient:G,isUntitled:Y}=x,ne=[],pe=z;z?te.forEach((B,ee)=>{const ve=p.URI.revive(B.uri),Pe=C._findFolder(N||z,ve,M);Pe?(Pe.name=B.name,Pe.index=B.index,ne.push(Pe)):ne.push({uri:ve,name:B.name,index:ee})}):ne.push(...te.map(({uri:B,name:ee,index:ve})=>({uri:p.URI.revive(B),name:ee,index:ve}))),ne.sort((B,ee)=>B.index<ee.index?-1:1);const le=new C(W,X,ne,!!G,H?p.URI.revive(H):null,!!Y,B=>_(B,M)),{added:we,removed:Z}=v(pe?pe.workspaceFolders:[],le.workspaceFolders,g,M);return{workspace:le,added:we,removed:Z}}static _findFolder(x,z,N){for(let M=0;M<x.folders.length;M++){const W=x.workspaceFolders[M];if(w(W.uri,z,N))return W}}constructor(x,z,N,M,W,X,te){super(x,N.map(H=>new a.WorkspaceFolder(H)),M,W,te),this._name=z,this._isUntitled=X,this._workspaceFolders=[],this._structure=b.TernarySearchTree.forUris(te),N.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(x,z){return z&&this._structure.get(x)&&(x=(0,T.dirname)(x)),this._structure.findSubstr(x)}resolveWorkspaceFolder(x){return this._structure.get(x)}}let P=class{constructor(x,z,N,M,W){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new A.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=M,this._extHostFileSystemInfo=N,this._uriTransformerService=W,this._requestIdProvider=new y.Counter,this._barrier=new O.Barrier,this._proxy=x.getProxy(c.MainContext.MainThreadWorkspace),this._messageService=x.getProxy(c.MainContext.MainThreadMessageService);const X=z.workspace;this._confirmedWorkspace=X?new C(X.id,X.name,[],!!X.transient,X.configuration?p.URI.revive(X.configuration):null,!!X.isUntitled,te=>_(te,N)):void 0}$initializeWorkspace(x,z){this._trusted=z,this.$acceptWorkspaceData(x),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?p.URI.from({scheme:m.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(x,z,N,...M){const W=[];if(Array.isArray(M)&&M.forEach(Y=>{p.URI.isUri(Y.uri)&&!W.some(ne=>w(ne.uri,Y.uri,this._extHostFileSystemInfo))&&W.push({uri:Y.uri,name:Y.name||(0,T.basenameOrAuthority)(Y.uri)})}),this._unconfirmedWorkspace||[z,N].some(Y=>typeof Y!="number"||Y<0)||N===0&&W.length===0)return!1;const X=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(z+N>X.length)return!1;const te=X.slice(0);te.splice(z,N,...W.map(Y=>({uri:Y.uri,name:Y.name||(0,T.basenameOrAuthority)(Y.uri),index:void 0})));for(let Y=0;Y<te.length;Y++){const ne=te[Y];if(te.some((pe,le)=>le!==Y&&w(ne.uri,pe.uri,this._extHostFileSystemInfo)))return!1}te.forEach((Y,ne)=>Y.index=ne);const{added:H,removed:G}=v(X,te,D,this._extHostFileSystemInfo);if(H.length===0&&G.length===0)return!1;if(this._proxy){const Y=x.displayName||x.name;this._proxy.$updateWorkspaceFolders(Y,z,N,W).then(void 0,ne=>{this._unconfirmedWorkspace=void 0;const pe={source:{identifier:x.identifier,label:x.displayName||x.name}};this._messageService.$showMessage(f.Severity.Error,(0,S.localize)(0,null,Y,ne.toString()),pe,[])})}return this.trySetWorkspaceFolders(te),!0}getWorkspaceFolder(x,z){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,z)}async getWorkspaceFolder2(x,z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,z)}async resolveWorkspaceFolder(x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(x)}getPath(){if(!this._actualWorkspace)return;const{folders:x}=this._actualWorkspace;if(x.length!==0)return x[0].uri.fsPath}getRelativePath(x,z){let N,M="";if(typeof x=="string"?(N=p.URI.file(x),M=x):typeof x<"u"&&(N=x,M=x.fsPath),!N)return M;const W=this.getWorkspaceFolder(N,!0);if(!W)return M;typeof z>"u"&&this._actualWorkspace&&(z=this._actualWorkspace.folders.length>1);let X=(0,T.relativePath)(W.uri,N);return z&&W.name&&(X=`${W.name}/${X}`),X}trySetWorkspaceFolders(x){this._actualWorkspace&&(this._unconfirmedWorkspace=C.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:x,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(x){const{workspace:z,added:N,removed:M}=C.toExtHostWorkspace(x,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=z||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:M}))}findFiles(x,z,N,M,W=L.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let X="",te=!0;return z===null?te=!1:z!==void 0&&(typeof z=="string"?X=z:X=z.pattern),this._findFilesImpl(x,void 0,{exclude:X,maxResults:N,useDefaultExcludes:te,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},W)}findFiles2(x,z={},N,M=L.CancellationToken.None){return this._logService.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${N.value}, entryPoint: findFiles2`),this._findFilesImpl(void 0,x,z,M)}async _findFilesImpl(x,z,N,M=L.CancellationToken.None){if(M&&M.isCancellationRequested)return Promise.resolve([]);const W=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,X={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof N.useDefaultSearchExcludes=="boolean"?!N.useDefaultSearchExcludes:!1,maxResults:N.maxResults,excludePattern:W,shouldGlobSearch:typeof N.fuzzy=="boolean"?!N.fuzzy:!0,_reason:"startFileSearch"};let te;if(x){const{includePattern:H,folder:G}=k(o.GlobPattern.from(x));te=G,X.includePattern=H}else{const{includePattern:H,folder:G}=k(o.GlobPattern.from(z));te=G,X.filePattern=H}return this._proxy.$startFileSearch(te??null,X,M).then(H=>Array.isArray(H)?H.map(G=>p.URI.revive(G)):[])}async findTextInFiles(x,z,N,M,W=L.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const X=this._requestIdProvider.getNext(),te=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:H,folder:G}=k(o.GlobPattern.from(z.include)),Y=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ne={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:te,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:H,excludePattern:Y},pe=!1;if(this._activeSearchCallbacks[X]=le=>{if(pe)return;const we=p.URI.revive(le.resource);le.results.forEach(Z=>{const B=(0,s.revive)(Z);(0,r.resultIsMatch)(B)?N({uri:we,preview:{text:B.preview.text,matches:(0,h.mapArrayOrNot)(B.preview.matches,ee=>new t.Range(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))},ranges:(0,h.mapArrayOrNot)(B.ranges,ee=>new t.Range(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))}):N({uri:we,text:B.text,lineNumber:B.lineNumber})})},W.isCancellationRequested)return{};try{const le=await this._proxy.$startTextSearch(x,G??null,ne,X,W);return delete this._activeSearchCallbacks[X],le||{}}catch(le){throw delete this._activeSearchCallbacks[X],le}}$handleTextSearchResult(x,z){this._activeSearchCallbacks[z]?.(x)}async save(x){const z=await this._proxy.$save(x,{saveAs:!1});return p.URI.revive(z)}async saveAs(x){const z=await this._proxy.$save(x,{saveAs:!0});return p.URI.revive(z)}saveAll(x){return this._proxy.$saveAll(x)}resolveProxy(x){return this._proxy.$resolveProxy(x)}loadCertificates(){return this._proxy.$loadCertificates()}get trusted(){return this._trusted}requestWorkspaceTrust(x){return this._proxy.$requestWorkspaceTrust(x)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(x,z){if(this._editSessionIdentityProviders.has(x))throw new Error(`A provider has already been registered for scheme ${x}`);this._editSessionIdentityProviders.set(x,z);const N=this._uriTransformerService.transformOutgoingScheme(x),M=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(M,N),(0,R.toDisposable)(()=>{this._editSessionIdentityProviders.delete(x),this._proxy.$unregisterEditSessionIdentityProvider(M)})}async $getEditSessionIdentifier(x,z){this._logService.info("Getting edit session identifier for workspaceFolder",x);const N=await this.resolveWorkspaceFolder(p.URI.revive(x));if(!N){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const M=this._editSessionIdentityProviders.get(N.uri.scheme);if(this._logService.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!M),!M)return;const W=await M.provideEditSessionIdentity(N,z);if(this._logService.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(x,z,N,M){this._logService.info("Getting edit session identifier for workspaceFolder",x);const W=await this.resolveWorkspaceFolder(p.URI.revive(x));if(!W){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const X=this._editSessionIdentityProviders.get(W.uri.scheme);if(this._logService.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!X),!X)return;const te=await X.provideEditSessionIdentityMatch?.(z,N,M);if(this._logService.info("Provider returned edit session identifier match result: ",te),!!te)return te}getOnWillCreateEditSessionIdentityEvent(x){return(z,N,M)=>{const W=function(te){z.call(N,te)};return W.extension=x,this._onWillCreateEditSessionIdentityEvent.event(W,void 0,M)}}async $onWillCreateEditSessionIdentity(x,z,N){const M=await this.resolveWorkspaceFolder(p.URI.revive(x));if(M===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:M},z,async(W,X)=>{const te=Date.now();await Promise.resolve(W),Date.now()-te>N&&this._logService.warn("SLOW edit session create-participant",X.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(x,z){if(this._canonicalUriProviders.has(x))throw new Error(`A provider has already been registered for scheme ${x}`);this._canonicalUriProviders.set(x,z);const N=this._uriTransformerService.transformOutgoingScheme(x),M=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(M,N),(0,R.toDisposable)(()=>{this._canonicalUriProviders.delete(x),this._proxy.$unregisterCanonicalUriProvider(M)})}async provideCanonicalUri(x,z,N){const M=this._canonicalUriProviders.get(x.scheme);if(!M)return;const W=await M.provideCanonicalUri?.(p.URI.revive(x),z,N);if(W)return W}async $provideCanonicalUri(x,z,N){return this.provideCanonicalUri(p.URI.revive(x),{targetScheme:z},N)}};e.ExtHostWorkspace=P,e.ExtHostWorkspace=P=Ge([Ue(0,l.IExtHostRpcService),Ue(1,n.IExtHostInitDataService),Ue(2,i.IExtHostFileSystemInfo),Ue(3,d.ILogService),Ue(4,u.IURITransformerService)],P),e.IExtHostWorkspace=(0,E.createDecorator)("IExtHostWorkspace");function k(F){let x,z;return F&&(typeof F=="string"?x=F:(x=F.pattern,z=p.URI.revive(F.baseUri))),{includePattern:x,folder:z}}}),define(_e[45],Ce([1,0,24,4,44,6,8,270,66,18,7,5,20,11,2]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(u,r){if(r){const c=r.split(".");let s=u;for(let w=0;s&&w<c.length;w++)s=s[c[w]];return s}}function f(u){return u instanceof E.URI}function a(u){return u&&u.uri instanceof E.URI&&u.languageId&&typeof u.languageId=="string"}function i(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function n(u){return u&&u.uri instanceof E.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function l(u){if(f(u))return{resource:u};if(a(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(i(u))return{overrideIdentifier:u.languageId};if(n(u))return{resource:u.uri};if(u===null)return{resource:null}}let o=class{constructor(r,c,s){this._proxy=r.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=c,this._logService=s,this._barrier=new T.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,c){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(r,c))}};e.ExtHostConfiguration=o,e.ExtHostConfiguration=o=Ge([Ue(0,p.IExtHostRpcService),Ue(1,L.IExtHostWorkspace),Ue(2,S.ILogService)],o);class t{constructor(r,c,s,w){this._onDidChangeConfiguration=new O.Emitter,this._proxy=r,this._logService=w,this._extHostWorkspace=c,this._configuration=b.Configuration.parse(s,w),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,c){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=b.Configuration.parse(r,this._logService),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(c,s))}getConfiguration(r,c,s){const w=l(c)||{},g=this._toReadonlyValue(r?d(this._configuration.getValue(void 0,w,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,w,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,w,s?.identifier);function D(_){if(_==null)return null;if(typeof _=="boolean")return _?2:5;switch(_){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(_){return typeof d(g,_)<"u"},get:(_,C)=>{this._validateConfigurationAccess(r?`${r}.${_}`:_,w,s?.identifier);let P=d(g,_);if(typeof P>"u")P=C;else{let k;const F=(x,z)=>{if((0,y.isObject)(x)){let N;const M=()=>{k=k||(0,h.deepClone)(g),N=N||d(k,z)};return new Proxy(x,{get:(W,X)=>{if(typeof X=="string"&&X.toLowerCase()==="tojson")return M(),()=>N;if(k)return N=N||d(k,z),N[X];const te=W[X];return typeof X=="string"?F(te,`${z}.${X}`):te},set:(W,X,te)=>(M(),N&&(N[X]=te),!0),deleteProperty:(W,X)=>(M(),N&&delete N[X],!0),defineProperty:(W,X,te)=>(M(),N&&Object.defineProperty(N,X,te),!0)})}return Array.isArray(x)?(0,h.deepClone)(x):x};P=F(P,_)}return P},update:(_,C,P,k)=>{_=r?`${r}.${_}`:_;const F=D(P);return C!==void 0?this._proxy.$updateConfigurationOption(F,_,C,w,k):this._proxy.$removeConfigurationOption(F,_,w,k)},inspect:_=>{_=r?`${r}.${_}`:_;const C=this._configuration.inspect(_,w,this._extHostWorkspace.workspace);if(C)return{key:_,defaultValue:(0,h.deepClone)(C.policy?.value??C.default?.value),globalValue:(0,h.deepClone)(C.user?.value??C.application?.value),workspaceValue:(0,h.deepClone)(C.workspace?.value),workspaceFolderValue:(0,h.deepClone)(C.workspaceFolder?.value),defaultLanguageValue:(0,h.deepClone)(C.default?.override),globalLanguageValue:(0,h.deepClone)(C.user?.override??C.application?.override),workspaceLanguageValue:(0,h.deepClone)(C.workspace?.override),workspaceFolderLanguageValue:(0,h.deepClone)(C.workspaceFolder?.override),languageIds:(0,h.deepClone)(C.overrideIdentifiers)}}};return typeof g=="object"&&(0,h.mixin)(v,g,!1),Object.freeze(v)}_toReadonlyValue(r){const c=s=>(0,y.isObject)(s)?new Proxy(s,{get:(w,g)=>c(w[g]),set:(w,g,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(w,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(w,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:w=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return c(r)}_validateConfigurationAccess(r,c,s){const w=m.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),g=s?`[${s.value}] `:"";if(w===4){typeof c?.resource>"u"&&this._logService.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(w===3){c?.resource&&this._logService.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,c){const s=new b.ConfigurationChangeEvent(r,c,this._configuration,this._extHostWorkspace.workspace,this._logService);return Object.freeze({affectsConfiguration:(w,g)=>s.affectsConfiguration(w,l(g))})}_toMap(r){return r.reduce((c,s)=>(c.set(s[0],s[1]),c),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")}),define(_e[95],Ce([1,0,2,7,4,6,8,44,73,45,22,43,20,28,5,15,12,11,91,314,13]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i,n,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var o;(function(F){function x(N){if(N!=null)return N}F.from=x;function z(N){if(N!=null)return N}F.to=z})(o||(o={}));var t;(function(F){function x(N){if(N!=null)return N}F.from=x;function z(N){if(N!=null)return N}F.to=z})(t||(t={}));var u;(function(F){function x(N){if(N!=null)return N}F.from=x;function z(N){if(N!=null)return N}F.to=z})(u||(u={}));var r;(function(F){function x(M){if(M){const W=M;return W&&!!W.process}else return!1}F.is=x;function z(M){if(M==null)return;const W={process:M.process,args:M.args};return M.options&&(W.options=u.from(M.options)),W}F.from=z;function N(M){if(M!=null)return new R.ProcessExecution(M.process,M.args,M.options)}F.to=N})(r||(r={}));var c;(function(F){function x(N){if(N!=null)return N}F.from=x;function z(N){if(N!=null)return N}F.to=z})(c||(c={}));var s;(function(F){function x(M){if(M){const W=M;return W&&(!!W.commandLine||!!W.command)}else return!1}F.is=x;function z(M){if(M==null)return;const W={};return M.commandLine!==void 0?W.commandLine=M.commandLine:(W.command=M.command,W.args=M.args),M.options&&(W.options=c.from(M.options)),W}F.from=z;function N(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new R.ShellExecution(M.commandLine,M.options):new R.ShellExecution(M.command,M.args?M.args:[],M.options)}F.to=N})(s||(s={}));var w;(function(F){function x(M){if(M){const W=M;return W&&W.customExecution==="customExecution"}else return!1}F.is=x;function z(M){return{customExecution:"customExecution"}}F.from=z;function N(M,W){return W.get(M)}F.to=N})(w||(e.CustomExecutionDTO=w={}));var g;(function(F){function x(z,N){let M;return z.scope!==void 0&&typeof z.scope!="number"?M=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===R.TaskScope.Workspace&&N&&N.workspaceFile?M=N.workspaceFile:M=n.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:M}}F.from=x})(g||(e.TaskHandleDTO=g={}));var D;(function(F){function x(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}F.from=x})(D||(D={}));var v;(function(F){function x(M,W){if(M==null)return[];const X=[];for(const te of M){const H=z(te,W);H&&X.push(H)}return X}F.fromMany=x;function z(M,W){if(M==null)return;let X;M.execution instanceof R.ProcessExecution?X=r.from(M.execution):M.execution instanceof R.ShellExecution?X=s.from(M.execution):M.execution&&M.execution instanceof R.CustomExecution&&(X=w.from(M.execution));const te=o.from(M.definition);let H;return M.scope?typeof M.scope=="number"?H=M.scope:H=M.scope.uri:H=R.TaskScope.Workspace,!te||!H?void 0:{_id:M._id,definition:te,name:M.name,source:{extensionId:W.identifier.value,label:M.source,scope:H},execution:X,isBackground:M.isBackground,group:D.from(M.group),presentationOptions:t.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}F.from=z;async function N(M,W,X){if(M==null)return;let te;r.is(M.execution)?te=r.to(M.execution):s.is(M.execution)?te=s.to(M.execution):w.is(M.execution)&&(te=w.to(M._id,X));const H=o.to(M.definition);let G;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?G=M.source.scope:G=await W.resolveWorkspaceFolder(h.URI.revive(M.source.scope)):G=R.TaskScope.Workspace),!H||!G)return;const Y=new R.Task(H,G,M.name,M.source.label,te,M.problemMatchers);return M.isBackground!==void 0&&(Y.isBackground=M.isBackground),M.group!==void 0&&(Y.group=R.TaskGroup.from(M.group._id),Y.group&&M.group.isDefault&&(Y.group=new R.TaskGroup(Y.group.id,Y.group.label),M.group.isDefault===!0&&(Y.group.isDefault=M.group.isDefault))),M.presentationOptions&&(Y.presentationOptions=t.to(M.presentationOptions)),M._id&&(Y._id=M._id),M.detail&&(Y.detail=M.detail),Y}F.to=N})(v||(e.TaskDTO=v={}));var _;(function(F){function x(N){return N}F.from=x;function z(N){if(N)return Object.assign(Object.create(null),N)}F.to=z})(_||(_={}));class C{#e;constructor(x,z,N){this._id=z,this._task=N,this.#e=x}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}let P=class{constructor(x,z,N,M,W,X,te,H){this._onDidExecuteTask=new L.Emitter,this._onDidTerminateTask=new L.Emitter,this._onDidTaskProcessStarted=new L.Emitter,this._onDidTaskProcessEnded=new L.Emitter,this._proxy=x.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=N,this._editorService=M,this._configurationService=W,this._terminalService=X,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=te,this._deprecationService=H,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,z,N){if(!N)return new R.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:z,provider:N,extension:x}),this._proxy.$registerTaskProvider(M,z),new R.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(x,z){this._proxy.$registerTaskSystem(x,z)}fetchTasks(x){return this._proxy.$fetchTasks(_.from(x)).then(async z=>{const N=[];for(const M of z){const W=await v.to(M,this._workspaceProvider,this._providedCustomExecutions2);W&&N.push(W)}return N})}get taskExecutions(){const x=[];return this._taskExecutions.forEach(z=>x.push(z)),x}terminateTask(x){if(!(x instanceof C))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,z,N){const M=this._providedCustomExecutions2.get(x.id);M&&(this._activeCustomExecutions2.set(x.id,M),this._terminalService.attachPtyToTerminal(z,await M.callback(N))),this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){if(!this._taskExecutionPromises.has(x.id))return;const z=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const z=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:z,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const z=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:x.exitCode})}$provideTasks(x,z){const N=this._handlers.get(x);if(!N)return Promise.reject(new Error("no handler found"));const M=[],W=(0,O.asPromise)(()=>N.provider.provideTasks(T.CancellationToken.None)).then(X=>this.provideTasksInternal(z,M,N,X));return new Promise(X=>{W.then(te=>{Promise.all(M).then(()=>{X(te)})})})}async $resolveTask(x,z){const N=this._handlers.get(x);if(!N)return Promise.reject(new Error("no handler found"));if(z.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${N.type}].`);const M=await v.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const W=await N.provider.resolveTask(M,T.CancellationToken.None);if(!W)return;this.checkDeprecation(W,N);const X=v.from(W,N.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return w.is(X.execution)&&await this.addCustomExecution(X,W,!0),await this.resolveTaskInternal(X)}nextHandle(){return this._handleCounter++}async addCustomExecution(x,z,N){const M=await this._proxy.$createTaskId(x);!N&&!this._providedCustomExecutions2.has(M)&&(this._notProvidedCustomExecutions.add(M),this._activeCustomExecutions2.set(M,z.execution)),this._providedCustomExecutions2.set(M,z.execution)}async getTaskExecution(x,z){if(typeof x=="string"){const W=this._taskExecutionPromises.get(x);if(!W)throw new l.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return W}const N=this._taskExecutionPromises.get(x.id);if(N)return N;let M;return z?M=Promise.resolve(new C(this,x.id,z)):M=v.to(x.task,this._workspaceProvider,this._providedCustomExecutions2).then(W=>{if(!W)throw new l.ErrorNoTelemetry("Unexpected: Task does not exist.");return new C(this,x.id,W)}),this._taskExecutionPromises.set(x.id,M),M.then(W=>(this._taskExecutions.set(x.id,W),W))}checkDeprecation(x,z){x._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));const N=this._notProvidedCustomExecutions.values();let M=N.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=N.next()}};e.ExtHostTaskBase=P,e.ExtHostTaskBase=P=Ge([Ue(0,p.IExtHostRpcService),Ue(1,S.IExtHostInitDataService),Ue(2,b.IExtHostWorkspace),Ue(3,m.IExtHostDocumentsAndEditors),Ue(4,y.IExtHostConfiguration),Ue(5,I.IExtHostTerminalService),Ue(6,a.ILogService),Ue(7,i.IExtHostApiDeprecationService)],P);let k=class extends P{constructor(x,z,N,M,W,X,te,H){super(x,z,N,M,W,X,te,H),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:f.PlatformToString(0)})}async executeTask(x,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const N=v.from(z,x);if(N===void 0)throw new Error("Task is not valid");if(w.is(N.execution))await this.addCustomExecution(N,z,!1);else throw new l.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(N),z);return this._proxy.$executeTask(N).catch(W=>{throw new Error(W)}),M}provideTasksInternal(x,z,N,M){const W=[];if(M)for(const X of M){if(this.checkDeprecation(X,N),!X.definition||!x[X.definition.type]){const H=X.source?X.source:"No task source";this._logService.warn(`The task [${H}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`)}const te=v.from(X,N.extension);te&&w.is(te.execution)?(W.push(te),z.push(this.addCustomExecution(te,X,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:W,extension:N.extension}}async resolveTaskInternal(x){if(w.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(x,z,N){}};e.WorkerExtHostTask=k,e.WorkerExtHostTask=k=Ge([Ue(0,p.IExtHostRpcService),Ue(1,S.IExtHostInitDataService),Ue(2,b.IExtHostWorkspace),Ue(3,m.IExtHostDocumentsAndEditors),Ue(4,y.IExtHostConfiguration),Ue(5,I.IExtHostTerminalService),Ue(6,a.ILogService),Ue(7,i.IExtHostApiDeprecationService)],k),e.IExtHostTask=(0,E.createDecorator)("IExtHostTask")}),define(_e[374],Ce([1,0,37,29]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rawCellPrefix=void 0,e.isINotebookFileMatchNoModel=L,e.genericCellMatchesToTextSearchMatches=A;function L(R){return"cellResults"in R}e.rawCellPrefix="rawCell#";function A(R,b){let m=-1;const y=[];let T=[];return R.forEach(p=>{p.range.startLineNumber!==m&&T.length>0&&(y.push([...T]),T=[]),T.push(p),m=p.range.endLineNumber}),T.length>0&&y.push([...T]),y.map(p=>{const S=[],E=p[0].range.startLineNumber,d=p[p.length-1].range.endLineNumber;for(let f=E;f<=d;f++)S.push(b.getLineContent(f));return new h.TextSearchMatch(S.join(`
`)+`
`,p.map(f=>new O.Range(f.range.startLineNumber-1,f.range.startColumn-1,f.range.endLineNumber-1,f.range.endColumn-1)))})}}),define(_e[375],Ce([1,0,229,21,4,3,27,14,18,2,33,112,6,34,16,8,48,345,154,24,15,304,374,371]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i,n,l,o,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class r{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}constructor(s,w,g,D,v,_){this._textDocumentsAndEditors=g,this._textDocuments=D,this._extHostFileSystem=v,this._extHostSearch=_,this._notebookStatusBarItemProviders=new Map,this._documents=new R.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new I.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=s.getProxy(p.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(p.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(p.MainContext.MainThreadNotebookEditors),this._commandsConverter=w.converter,w.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===13){const P=C.notebookEditor?.notebookUri,k=C.cell.handle,x=this._documents.get(P)?.getCell(k);if(x)return x.apiCell}if(C&&C.$mid===14){const P=C.uri,k=this._documents.get(P);if(k)return k.apiNotebook}return C}}),r._registerApiCommands(w)}getEditorById(s){const w=this._editors.get(s);if(!w)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);return w}getIdByEditor(s){for(const[w,g]of this._editors)if(g.apiEditor===s)return w}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(s,w){const g=this._documents.get(s);if(!g&&!w)throw new Error(`NO notebook document for '${s}'`);return g}static _convertNotebookRegistrationData(s,w){if(!w)return;const g=w.filenamePattern.map(D=>E.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(w.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${w.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:w.displayName,filenamePattern:g,exclusive:w.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,w,g){const D=r._notebookStatusBarItemProviderHandlePool++,v=typeof g.onDidChangeCellStatusBarItems=="function"?r._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(D,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(D,v,w);let _;return v!==void 0&&(_=g.onDidChangeCellStatusBarItems(C=>this._notebookProxy.$emitCellStatusBarEvent(v))),new d.Disposable(()=>{this._notebookStatusBarItemProviders.delete(D),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(D,v),_?.dispose()})}async createNotebookDocument(s){const w=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:s.viewType,content:s.content&&E.NotebookData.from(s.content)});return y.URI.revive(w)}async openNotebookDocument(s){const w=this._documents.get(s);if(w)return w.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(s),D=this._documents.get(y.URI.revive(g));return(0,m.assertIsDefined)(D?.apiNotebook)}async showNotebookDocument(s,w){y.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let g;typeof w=="object"?g={position:E.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selections:w.selections&&w.selections.map(E.NotebookRange.from),pinned:typeof w.preview=="boolean"?!w.preview:void 0}:g={preserveFocus:!1};const D=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.notebookType,g),v=D&&this._editors.get(D)?.apiEditor;if(v)return v;throw D?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,w,g,D){const v=this._notebookStatusBarItemProviders.get(s),_=y.URI.revive(w),C=this._documents.get(_);if(!C||!v)return;const P=C.getCellFromIndex(g);if(!P)return;const k=await v.provideCellStatusBarItems(P.apiCell,D);if(!k)return;const F=new A.DisposableStore,x=this._statusBarCache.add([F]),N=(Array.isArray(k)?k:[k]).map(M=>E.NotebookStatusBarItem.from(M,this._commandsConverter,F));return{cacheId:x,items:N}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,w,g,D,v){if((0,b.isFalsyOrWhitespace)(w))throw new Error("viewType cannot be empty or just whitespace");const _=this._handlePool++;return this._notebookSerializer.set(_,{viewType:w,serializer:g,options:D}),this._notebookProxy.$registerNotebookSerializer(_,{id:s.identifier,location:s.extensionLocation},w,E.NotebookDocumentContentOptions.from(D),r._convertNotebookRegistrationData(s,v)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(_)})}async $dataToNotebook(s,w,g){const D=this._notebookSerializer.get(s);if(!D)throw new Error("NO serializer found");const v=await D.serializer.deserializeNotebook(w.buffer,g);return new f.SerializableObjectWithBuffers(E.NotebookData.from(v))}async $notebookToData(s,w,g){const D=this._notebookSerializer.get(s);if(!D)throw new Error("NO serializer found");const v=await D.serializer.serializeNotebook(E.NotebookData.to(w.value),g);return O.VSBuffer.wrap(v)}async $saveNotebook(s,w,g,D,v){const _=y.URI.revive(w),C=this._notebookSerializer.get(s);if(!C)throw new Error("NO serializer found");const P=this._documents.get(_);if(!P)throw new Error("Document NOT found");if(P.versionId!==g)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(_.scheme))throw new T.FileOperationError((0,h.localize)(0,null,this._resourceForError(_)),6);await this._validateWriteFile(_,D);const k={metadata:(0,n.filter)(P.apiNotebook.metadata,M=>!(C.options?.transientDocumentMetadata??{})[M]),cells:[]};for(const M of P.apiNotebook.getCells()){const W=new d.NotebookCellData(M.kind,M.document.getText(),M.document.languageId,M.mime,C.options?.transientOutputs?[]:[...M.outputs],M.metadata,M.executionSummary);W.metadata=(0,n.filter)(M.metadata,X=>!(C.options?.transientCellMetadata??{})[X]),k.cells.push(W)}const F=await C.serializer.serializeNotebook(k,v);await this._extHostFileSystem.value.writeFile(_,F);const x=this._extHostFileSystem.getFileSystemProviderExtUri(_.scheme),z=await this._extHostFileSystem.value.stat(_);return{name:x.basename(_),isFile:(z.type&T.FileType.File)!==0,isDirectory:(z.type&T.FileType.Directory)!==0,isSymbolicLink:(z.type&T.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&T.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(_.scheme),locked:!!((z.permissions??0)&T.FilePermission.Locked),etag:T.etag({mtime:z.mtime,size:z.size}),children:void 0}}async $searchInNotebooks(s,w,g,D,v){const _=this._notebookSerializer.get(s)?.serializer;if(!_)return{limitHit:!1,results:[]};const C=new R.ResourceSet;await(async(z,N,M)=>{await Promise.all(z.map(async W=>await Promise.all(W.filenamePatterns.map(X=>{const te={_reason:M._reason,folderQueries:M.folderQueries,includePattern:M.includePattern,excludePattern:M.excludePattern,maxResults:M.maxResults,type:1,filePattern:X};return this._extHostSearch.doInternalFileSearchWithCustomCallback(te,N,H=>{H.forEach(G=>{C.has(G)||D.some(ne=>W.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(pe=>(0,u.globMatchesResource)(pe,G)))||C.add(G)})}).catch(H=>{if(H.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw H})}))))})(g,v,w);const k=new R.ResourceMap;let F=!1;const x=Array.from(C).map(async z=>{const N=[];try{if(v.isCancellationRequested)return;if(w.maxResults&&[...k.values()].reduce((te,H)=>te+H.cellResults.length,0)>w.maxResults){F=!0;return}const M=[],W=this._documents.get(z);if(W)W.apiNotebook.getCells().forEach(H=>M.push({input:H.document.getText(),outputs:H.outputs.flatMap(G=>G.items.map(Y=>Y.data.toString()))}));else{const te=await this._extHostFileSystem.value.readFile(z),H=O.VSBuffer.fromString(te.toString()),G=await _.deserializeNotebook(H.buffer,v);if(v.isCancellationRequested)return;E.NotebookData.from(G).cells.forEach(ne=>M.push({input:ne.source,outputs:ne.outputs.flatMap(pe=>pe.items.map(le=>le.valueBytes.toString()))}))}if(v.isCancellationRequested)return;M.forEach((te,H)=>{const G=w.contentPattern.pattern,Y=new o.CellSearchModel(te.input,void 0,te.outputs),ne=Y.findInInputs(G),pe=Y.findInOutputs(G),le=pe.flatMap(we=>(0,t.genericCellMatchesToTextSearchMatches)(we.matches,we.textBuffer)).map((we,Z)=>(we.webviewIndex=Z,we));if(ne.length>0||pe.length>0){const we={index:H,contentResults:(0,t.genericCellMatchesToTextSearchMatches)(ne,Y.inputTextBuffer),webviewResults:le};N.push(we)}});const X={resource:z,cellResults:N};k.set(z,X);return}catch{return}});return await Promise.all(x),{limitHit:F,results:[...k.values()]}}async _validateWriteFile(s,w){const g=await this._extHostFileSystem.value.stat(s);if(typeof w?.mtime=="number"&&typeof w.etag=="string"&&w.etag!==T.ETAG_DISABLED&&typeof g.mtime=="number"&&typeof g.size=="number"&&w.mtime<g.mtime&&w.etag!==T.etag({mtime:w.mtime,size:g.size}))throw new T.FileOperationError((0,h.localize)(1,null),3,w)}_resourceForError(s){return s.scheme===l.Schemas.file?s.fsPath:s.toString()}_createExtHostEditor(s,w,g){if(this._editors.has(w))throw new Error(`editor with id ALREADY EXSIST: ${w}`);const D=new i.ExtHostNotebookEditor(w,this._notebookEditorsProxy,s,g.visibleRanges.map(E.NotebookRange.to),g.selections.map(E.NotebookRange.to),typeof g.viewColumn=="number"?E.ViewColumn.to(g.viewColumn):void 0);this._editors.set(w,D)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const g of s.value.removedDocuments){const D=y.URI.revive(g),v=this._documents.get(D);v&&(v.dispose(),this._documents.delete(D),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(_=>_.document.uri)}),this._onDidCloseNotebookDocument.fire(v.apiNotebook));for(const _ of this._editors.values())_.notebookData.uri.toString()===D.toString()&&this._editors.delete(_.id)}if(s.value.addedDocuments){const g=[];for(const D of s.value.addedDocuments){const v=y.URI.revive(D.uri);if(this._documents.has(v))throw new Error(`adding EXISTING notebook ${v} `);const _=new a.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,v,D);g.push(...D.cells.map(C=>a.ExtHostCell.asModelAddData(C))),this._documents.get(v)?.dispose(),this._documents.set(v,_),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(_.apiNotebook)}}if(s.value.addedEditors)for(const g of s.value.addedEditors){if(this._editors.has(g.id))return;const D=y.URI.revive(g.documentUri),v=this._documents.get(D);v&&this._createExtHostEditor(v,g.id,g)}const w=[];if(s.value.removedEditors)for(const g of s.value.removedEditors){const D=this._editors.get(g);D&&(this._editors.delete(g),this._activeNotebookEditor?.id===D.id&&(this._activeNotebookEditor=void 0),w.push(D))}if(s.value.visibleEditors){this._visibleNotebookEditors=s.value.visibleEditors.map(D=>this._editors.get(D)).filter(D=>!!D);const g=new Set;this._visibleNotebookEditors.forEach(D=>g.add(D.id));for(const D of this._editors.values()){const v=g.has(D.id);D._acceptVisibility(v)}this._visibleNotebookEditors=[...this._editors.values()].map(D=>D).filter(D=>D.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this._activeNotebookEditor=void 0:s.value.newActiveEditor&&(this._editors.get(s.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${s.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(s){const w=S.ApiCommandArgument.String.with("notebookType","A notebook type"),g=new S.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[w,new S.ApiCommandArgument("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>O.VSBuffer.wrap(v))],new S.ApiCommandResult("Notebook Data",v=>E.NotebookData.to(v.value))),D=new S.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[w,new S.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new f.SerializableObjectWithBuffers(E.NotebookData.from(v)))],new S.ApiCommandResult("Bytes",v=>v.buffer));s.registerApiCommand(g),s.registerApiCommand(D)}}e.ExtHostNotebookController=r}),define(_e[376],Ce([1,0,17,22,47,35,23,40,37]),function(ue,e,h,O,L,A,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class y{constructor(p,S,E){this.config=p,this.provider=S,this.sessionToken=E,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=p.filePattern,this.includePattern=p.includePattern&&A.parse(p.includePattern),this.maxResults=p.maxResults||void 0,this.exists=p.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=p.excludePattern&&A.parse(p.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(p=>p.cancel()),this.activeCancellationTokens=new Set}search(p){const S=this.config.folderQueries||[];return new Promise((E,d)=>{const f=a=>{this.resultCount++,p(a)};if(this.isCanceled)return E({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(a=>{const i=a.toString(),n=h.basename(i);this.globalExcludePattern&&this.globalExcludePattern(i,n)||this.matchFile(f,{base:a,basename:n})}),Promise.all(S.map(a=>this.searchInFolder(a,f))).then(a=>{E({limitHit:this.isLimitHit,stats:a[0]||void 0})},a=>{d(new Error((0,L.toErrorMessage)(a)))})})}async searchInFolder(p,S){const E=new O.CancellationTokenSource,d=this.getSearchOptionsForFolder(p),f=this.initDirectoryTree(),a=new m.QueryGlobTester(this.config,p),i=!a.hasSiblingExcludeClauses();let n;try{this.activeCancellationTokens.add(E),n=b.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,E.token),o=n.elapsed(),t=b.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(u=>{const r=h.posix.relative(p.folder.path,u.path);if(i){const c=h.basename(u.path);this.matchFile(S,{base:p.folder,relativePath:r,basename:c});return}this.addDirectoryEntries(f,p.folder,r,S)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(f,a,S),{providerTime:o,postProcessTime:t.elapsed()})}finally{E.dispose(),this.activeCancellationTokens.delete(E)}}getSearchOptionsForFolder(p){const S=(0,m.resolvePatternsForProvider)(this.config.includePattern,p.includePattern),E=(0,m.resolvePatternsForProvider)(this.config.excludePattern,p.excludePattern);return{folder:p.folder,excludes:E,includes:S,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}addDirectoryEntries({pathToEntries:p},S,E,d){if(E===this.filePattern){const a=h.basename(this.filePattern);this.matchFile(d,{base:S,relativePath:this.filePattern,basename:a})}function f(a){const i=h.basename(a),n=h.dirname(a);let l=p[n];l||(l=p[n]=[],f(n)),l.push({base:S,relativePath:a,basename:i})}f(E)}matchDirectoryTree({rootEntries:p,pathToEntries:S},E,d){const f=this,a=this.filePattern;function i(n){const l=(0,m.hasSiblingFn)(()=>n.map(o=>o.basename));for(let o=0,t=n.length;o<t;o++){const u=n[o],{relativePath:r,basename:c}=u;if(E.matchesExcludesSync(r,c,a!==c?l:void 0))continue;const s=S[r];if(s)i(s);else{if(r===a)continue;f.matchFile(d,u)}if(f.isLimitHit)break}}i(p)}matchFile(p,S){(!this.includePattern||S.relativePath&&this.includePattern(S.relativePath,S.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||p(S))}}class T{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(p,S,E,d){const f=this.getSessionTokenSource(p.cacheKey),a=new y(p,S,f&&f.token);let i=0;const n=l=>{i+=l.length,E(l.map(o=>this.rawMatchToSearchItem(o)))};return this.doSearch(a,T.BATCH_SIZE,n,d).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:l.stats}}))}clearCache(p){this.getSessionTokenSource(p)?.cancel()}getSessionTokenSource(p){if(p)return this.sessions.has(p)||this.sessions.set(p,new O.CancellationTokenSource),this.sessions.get(p)}rawMatchToSearchItem(p){return p.relativePath?{resource:R.joinPath(p.base,p.relativePath)}:{resource:p.base}}doSearch(p,S,E,d){const f=d.onCancellationRequested(()=>{p.cancel()}),a=n=>{n&&(i.push(n),S>0&&i.length>=S&&(E(i),i=[]))};let i=[];return p.search(a).then(n=>(i.length&&E(i),f.dispose(),n),n=>(i.length&&E(i),f.dispose(),Promise.reject(n)))}}e.FileSearchManager=T}),define(_e[377],Ce([1,0,19,74,35,103,27,15,17,23,14,18,2,100,250,55,11,42,147,372,37]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i,n,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryBuilder=void 0,e.resolveResourcesForSearchIncludes=D;let o=class{constructor(_,C,P,k,F){this.configurationService=_,this.workspaceContextService=C,this.editorGroupsService=P,this.logService=k,this.pathService=F}text(_,C,P={}){_=this.getContentPattern(_,P);const k=this.configurationService.getValue(),F=C&&C.some(z=>!this.configurationService.getValue({resource:z}).search.useRipgrep);return{...this.commonQuery(C?.map(a.toWorkspaceFolder),P),type:2,contentPattern:_,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:k.search.usePCRE2||F||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}getContentPattern(_,C){const P=this.configurationService.getValue();_.isRegExp&&(_.pattern=_.pattern.replace(/\r?\n/g,"\\n"));const k={..._,wordSeparators:P.editor.wordSeparators};return this.isCaseSensitive(_,C)&&(k.isCaseSensitive=!0),this.isMultiline(_)&&(k.isMultiline=!0),C.notebookSearchConfig?.includeMarkupInput&&(k.notebookInfo||(k.notebookInfo={}),k.notebookInfo.isInNotebookMarkdownInput=C.notebookSearchConfig.includeMarkupInput),C.notebookSearchConfig?.includeMarkupPreview&&(k.notebookInfo||(k.notebookInfo={}),k.notebookInfo.isInNotebookMarkdownPreview=C.notebookSearchConfig.includeMarkupPreview),C.notebookSearchConfig?.includeCodeInput&&(k.notebookInfo||(k.notebookInfo={}),k.notebookInfo.isInNotebookCellInput=C.notebookSearchConfig.includeCodeInput),C.notebookSearchConfig?.includeOutput&&(k.notebookInfo||(k.notebookInfo={}),k.notebookInfo.isInNotebookCellOutput=C.notebookSearchConfig.includeOutput),k}file(_,C={}){return{...this.commonQuery(_,C),type:1,filePattern:C.filePattern?C.filePattern.trim():C.filePattern,exists:C.exists,sortByScore:C.sortByScore,cacheKey:C.cacheKey,shouldGlobMatchFilePattern:C.shouldGlobSearch}}handleIncludeExclude(_,C){return _?(_=Array.isArray(_)?_.map(s):s(_),C?this.parseSearchPaths(_):{pattern:u(...Array.isArray(_)?_:[_])}):{}}commonQuery(_=[],C={}){const P=this.handleIncludeExclude(C.includePattern,C.expandPatterns),k=this.handleIncludeExclude(C.excludePattern,C.expandPatterns),F=_.length>1,x=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(M=>this.getFolderQueryForSearchPath(M,C,k)):_.map(M=>this.getFolderQueryForRoot(M,C,k,F))).filter(M=>!!M),z={_reason:C._reason,folderQueries:x,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:C.extraFileResources,excludePattern:k.pattern,includePattern:P.pattern,onlyOpenEditors:C.onlyOpenEditors,maxResults:C.maxResults};if(C.onlyOpenEditors){const M=h.coalesce(h.flatten(this.editorGroupsService.groups.map(te=>te.editors.map(H=>H.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const W=M.filter(te=>(0,l.pathIncludedInQuery)(z,te.fsPath)),X=this.commonQueryFromFileList(W);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...z,...X}}const N=C.extraFileResources&&C.extraFileResources.filter(M=>(0,l.pathIncludedInQuery)(z,M.fsPath));return z.extraFileResources=N&&N.length?N:void 0,z}commonQueryFromFileList(_){const C=[],P=new R.ResourceMap,k={};let F=!1;return _.forEach(x=>{if(x.scheme===b.Schemas.walkThrough)return;if((0,y.isAbsolutePath)(x)){const N=this.workspaceContextService.getWorkspaceFolder(x)?.uri??x.with({path:m.dirname(x.fsPath)});let M=P.get(N);M||(F=!0,M={folder:N,includePattern:{}},C.push(M),P.set(N,M));const W=m.relative(N.fsPath,x.fsPath);(0,I.assertIsDefined)(M.includePattern)[W.replace(/\\/g,"/")]=!0}else x.fsPath&&(F=!0,k[x.fsPath]=!0)}),{folderQueries:C,includePattern:k,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(_,C){if(C.isSmartCase){if(_.isRegExp){if(T.containsUppercaseCharacter(_.pattern,!0))return!0}else if(T.containsUppercaseCharacter(_.pattern))return!0}return!!_.isCaseSensitive}isMultiline(_){return _.isMultiline||_.isRegExp&&(0,S.isMultilineRegexSource)(_.pattern)||_.pattern.indexOf(`
`)>=0?!0:!!_.isMultiline}parseSearchPaths(_){const C=X=>m.isAbsolute(X)||/^\.\.?([\/\\]|$)/.test(X),k=(Array.isArray(_)?_:r(_)).map(X=>{const te=this.pathService.resolvedUserHome;return te?(0,A.untildify)(X,te.scheme===b.Schemas.file?te.fsPath:te.path):X}),F=O.groupBy(k,X=>C(X)?"searchPaths":"exprSegments"),x=(F.exprSegments||[]).map(X=>T.rtrim(X,"/")).map(X=>T.rtrim(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),c(X))),z={},N=this.expandSearchPathPatterns(F.searchPaths||[]);N&&N.length&&(z.searchPaths=N);const M=h.flatten(x),W=u(...M);return W&&(z.pattern=W),z}getExcludesForFolder(_,C){return C.disregardExcludeSettings?void 0:(0,l.getExcludes)(_,!C.disregardSearchExcludeSettings)}expandSearchPathPatterns(_){if(!_||!_.length)return[];const C=_.flatMap(k=>{let{pathPortion:F,globPortion:x}=t(k);return x&&(x=w(x)),this.expandOneSearchPath(F).flatMap(N=>this.resolveOneSearchPathPattern(N,x))}),P=new Map;return C.forEach(k=>{const F=k.searchPath.toString(),x=P.get(F);x?k.pattern&&(x.pattern=x.pattern||{},x.pattern[k.pattern]=!0):P.set(F,{searchPath:k.searchPath,pattern:k.pattern?u(k.pattern):void 0})}),Array.from(P.values())}expandOneSearchPath(_){if(m.isAbsolute(_)){const C=this.workspaceContextService.getWorkspace().folders;return C[0]&&C[0].uri.scheme!==b.Schemas.file?[{searchPath:C[0].uri.with({path:_})}]:[{searchPath:p.URI.file(m.normalize(_))}]}if(this.workspaceContextService.getWorkbenchState()===2){const C=this.workspaceContextService.getWorkspace().folders[0].uri;if(_=s(_),_.startsWith("../")||_===".."){const k=m.posix.resolve(C.path,_);return[{searchPath:C.with({path:k})}]}const P=w(_);return[{searchPath:C,pattern:P}]}else{if(_==="./"||_===".\\")return[];{const C=_.replace(/^\.[\/\\]/,""),k=this.workspaceContextService.getWorkspace().folders.map(F=>{const x=C.match(new RegExp(`^${T.escapeRegExpCharacters(F.name)}(?:/(.*)|$)`));return x?{match:x,folder:F}:null}).filter(I.isDefined);if(k.length)return k.map(F=>{const x=F.match[1];return{searchPath:F.folder.uri,pattern:x&&w(x)}});{const F=_.match(/\.[\/\\](.+)[\/\\]?/),x=F?F[1]:_,z=E.localize(0,null,x);throw new Error(z)}}}}resolveOneSearchPathPattern(_,C){const P=_.pattern&&C?`${_.pattern}/${C}`:_.pattern||C,k=[{searchPath:_.searchPath,pattern:P}];return P&&!P.endsWith("**")&&k.push({searchPath:_.searchPath,pattern:P+"/**"}),k}getFolderQueryForSearchPath(_,C,P){const k=this.getFolderQueryForRoot((0,a.toWorkspaceFolder)(_.searchPath),C,P,!1);return k?{...k,includePattern:_.pattern}:null}getFolderQueryForRoot(_,C,P,k){let F;const x=p.URI.isUri(_)?_:_.uri;if(P.searchPaths){const X=P.searchPaths.filter(te=>(0,y.isEqual)(te.searchPath,x))[0];if(X&&!X.pattern)return null;X&&(F=X.pattern)}const z=this.configurationService.getValue({resource:x}),M={...this.getExcludesForFolder(z,C)||{},...F||{}},W=p.URI.isUri(_)?(0,y.basename)(_):_.name;return{folder:x,folderName:k?W:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof C.disregardIgnoreFiles=="boolean"?C.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof C.disregardGlobalIgnoreFiles=="boolean"?C.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof C.disregardParentIgnoreFiles=="boolean"?C.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof C.ignoreSymlinks=="boolean"?C.ignoreSymlinks:!z.search.followSymlinks}}};e.QueryBuilder=o,e.QueryBuilder=o=Ge([Ue(0,d.IConfigurationService),Ue(1,a.IWorkspaceContextService),Ue(2,i.IEditorGroupsService),Ue(3,f.ILogService),Ue(4,n.IPathService)],o);function t(v){const _=v.match(/[\*\{\}\(\)\[\]\?]/);if(_){const C=_.index,P=v.substr(0,C).match(/[/|\\][^/\\]*$/);if(P){let k=v.substr(0,P.index);return k.match(/[/\\]/)||(k+="/"),{pathPortion:k,globPortion:v.substr((P.index||0)+1)}}}return{pathPortion:v}}function u(...v){return v.length?v.reduce((_,C)=>(_[C]=!0,_),Object.create(null)):void 0}function r(v){return L.splitGlobAware(v,",").map(_=>_.trim()).filter(_=>!!_.length)}function c(v){return[`**/${v}/**`,`**/${v}`].map(C=>C.replace(/\*\*\/\*\*/g,"**"))}function s(v){return v.replace(/\\/g,"/")}function w(v){return s(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(v){return v.replace(/([?*[\]])/g,"[$1]")}function D(v,_){v=h.distinct(v,k=>k.toString());const C=[],P=_.getWorkspace();return v&&v.forEach(k=>{let F;if(_.getWorkbenchState()===2)F=(0,y.relativePath)(P.folders[0].uri,k),F&&F!=="."&&(F="./"+F);else{const x=_.getWorkspaceFolder(k);if(x){const z=x.name;if(P.folders.filter(M=>M.name===z).length===1){const M=(0,y.relativePath)(x.uri,k);M===""?F=`./${x.name}`:F=`./${x.name}/${M}`}else F=k.fsPath}}F&&C.push(g(F))}),C}}),define(_e[378],Ce([1,0,23,2,22,13,5,377,37,42,7]),function(ue,e,h,O,L,A,R,b,m,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkActivateWorkspaceContainsExtension=p,e.checkGlobFileExists=d;const I=7e3;function p(f,a){const i=a.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],l=[];for(const s of i)if(/^workspaceContains:/.test(s)){const w=s.substr(18);w.indexOf("*")>=0||w.indexOf("?")>=0||f.forceUsingSearch?l.push(w):n.push(w)}if(n.length===0&&l.length===0)return Promise.resolve(void 0);const{promise:o,resolve:t}=(0,T.promiseWithResolvers)(),u=s=>t({activationEvent:s}),r=Promise.all(n.map(s=>S(f,s,u))).then(()=>{}),c=E(f,a.identifier,l,u);return Promise.all([r,c]).then(()=>{t(void 0)}),o}async function S(f,a,i){for(const n of f.folders)if(await f.exists(h.joinPath(O.URI.revive(n),a))){i(`workspaceContains:${a}`);return}}async function E(f,a,i,n){if(i.length===0)return Promise.resolve(void 0);const l=new L.CancellationTokenSource,o=f.checkExists(f.folders,i,l.token),t=setTimeout(async()=>{l.cancel(),f.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},I);let u=!1;try{u=await o}catch(r){A.isCancellationError(r)||A.onUnexpectedError(r)}l.dispose(),clearTimeout(t),u&&n(`workspaceContains:${i.join(",")}`)}function d(f,a,i,n){const l=f.get(R.IInstantiationService),o=f.get(m.ISearchService),u=l.createInstance(b.QueryBuilder).file(a.map(r=>(0,y.toWorkspaceFolder)(O.URI.revive(r))),{_reason:"checkExists",includePattern:i,exists:!0});return o.fileSearch(u,n).then(r=>!!r.limitHit,r=>A.isCancellationError(r)?!1:Promise.reject(r))}}),define(_e[49],Ce([1,0,225,17,59,23,7,3,78,2,11,6,45,310,119,44,26,149,13,25,21,287,8,67,5,28,93,20,107,71,43,122,4,378,118,289,15,116,40,12,117]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i,n,l,o,t,u,r,c,s,w,g,D,v,_,C,P,k,F,x,z,N,M,W){"use strict";var X;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let te=X=class extends b.Disposable{constructor(B,ee,ve,Pe,oe,se,re,j,ie,me,be,Ae,fe){super(),this._extHostManagedSockets=Ae,this._extHostLanguageModels=fe,this._onDidChangeRemoteConnectionData=this._register(new C.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._realPathCache=new Map,this._isTerminating=!1,this._hostUtils=ee,this._extHostContext=ve,this._initData=re,this._extHostWorkspace=Pe,this._extHostConfiguration=oe,this._logService=se,this._extHostTunnelService=ie,this._extHostTerminalService=me,this._extHostLocalizationService=be,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._activationEventsReader=new we(this._initData.extensions.activationEvents),this._globalRegistry=new a.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const De=new n.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new a.ExtensionDescriptionRegistry(this._activationEventsReader,pe(this._globalRegistry,De)),M.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${Y(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${Y(this._myRegistry)}`)),this._storage=new E.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new k.ExtHostSecretState(this._extHostContext),this._storagePath=j,this._instaService=B.createChild(new g.ServiceCollection([E.IExtHostStorage,this._storage],[k.IExtHostSecretState,this._secretState])),this._activator=this._register(new S.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(Te,ze,U)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Te,i.transformErrorForSerialization(ze),U)},actualActivateExtension:async(Te,ze)=>{if(a.ExtensionDescriptionRegistry.isHostExtension(Te,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(Te,ze),new S.HostExtension;const U=this._myRegistry.getExtensionDescription(Te);return this._activateExtension(U,ze)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),L.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(B){i.onUnexpectedError(B)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let B=[];try{B=this._myRegistry.getAllExtensionDescriptions().map(oe=>oe.identifier).filter(oe=>this.isActivated(oe)).map(oe=>this._deactivate(oe))}catch{}await Promise.all(B)}terminate(B,ee=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${B}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),i.setUnexpectedErrorHandler(Pe=>{this._logService.error(Pe)}),this._extHostContext.dispose();const ve=this._deactivateAll();Promise.race([(0,R.timeout)(5e3),ve]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${ee}`):this._logService.info(`Extension host exiting with code ${ee}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(ee)})}isActivated(B){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(B):!1}async getExtension(B){const ee=await this._mainThreadExtensionsProxy.$getExtension(B);return ee&&{...ee,identifier:new n.ExtensionIdentifier(ee.identifier.value),extensionLocation:y.URI.revive(ee.extensionLocation)}}_activateByEvent(B,ee){return this._activator.activateByEvent(B,ee)}_activateById(B,ee){return this._activator.activateById(B,ee)}activateByIdWithErrors(B,ee){return this._activateById(B,ee).then(()=>{const ve=this._activator.getActivatedExtension(B);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(B=>this._myRegistry)}getExtensionExports(B){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(B).exports;try{return this._activator.getActivatedExtension(B).exports}catch{return null}}async _realPathExtensionUri(B){if(B.scheme===x.Schemas.file&&this._hostUtils.fsRealpath){const ee=B.fsPath;this._realPathCache.has(ee)||this._realPathCache.set(ee,this._hostUtils.fsRealpath(ee));const ve=await this._realPathCache.get(ee);return y.URI.file(ve)}return B}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(B=>new le(B))),this._extensionPathIndex}async _createExtensionPathIndex(B){const ee=m.TernarySearchTree.forUris(ve=>A.extUriBiasedIgnorePathCase.ignorePathCasing(ve));return await Promise.all(B.map(async ve=>{if(this._getEntryPoint(ve)){const Pe=await this._realPathExtensionUri(ve.extensionLocation);ee.set(Pe,ve)}})),ee}_deactivate(B){let ee=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(B))return ee;const ve=this._activator.getActivatedExtension(B);if(!ve)return ee;try{typeof ve.module.deactivate=="function"&&(ee=Promise.resolve(ve.module.deactivate()).then(void 0,Pe=>(this._logService.error(Pe),Promise.resolve(void 0))))}catch(Pe){this._logService.error(`An error occurred when deactivating the extension '${B.value}':`),this._logService.error(Pe)}try{(0,b.dispose)(ve.subscriptions)}catch(Pe){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${B.value}':`),this._logService.error(Pe)}return ee}async _activateExtension(B,ee){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(B.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(B.identifier),this._doActivateExtension(B,ee).then(ve=>{const Pe=ve.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(B.identifier,Pe.codeLoadingTime,Pe.activateCallTime,Pe.activateResolvedTime,ee),this._logExtensionActivationTimes(B,ee,"success",Pe),ve},ve=>{throw this._logExtensionActivationTimes(B,ee,"failure"),ve})}_logExtensionActivationTimes(B,ee,ve,Pe){const oe=G(B,ee);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...oe,...Pe||{},outcome:ve})}_doActivateExtension(B,ee){const ve=G(B,ee);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ve);const Pe=this._getEntryPoint(B);if(!Pe)return Promise.resolve(new S.EmptyExtension(S.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${B.identifier.value}, startup: ${ee.startup}, activationEvent: '${ee.activationEvent}'${B.identifier.value!==ee.extensionId.value?`, root cause: ${ee.extensionId.value}`:""}`),this._logService.flush();const oe=new S.ExtensionActivationTimesBuilder(ee.startup);return Promise.all([this._loadCommonJSModule(B,(0,A.joinPath)(B.extensionLocation,Pe),oe),this._loadExtensionContext(B)]).then(se=>(L.mark(`code/extHost/willActivateExtension/${B.identifier.value}`),X._callActivate(this._logService,B.identifier,se[0],se[1],oe))).then(se=>(L.mark(`code/extHost/didActivateExtension/${B.identifier.value}`),se))}_loadExtensionContext(B){const ee=this._extHostLanguageModels.createLanguageModelAccessInformation(B),ve=new o.ExtensionGlobalMemento(B,this._storage),Pe=new o.ExtensionMemento(B.identifier.value,!1,this._storage),oe=new F.ExtensionSecrets(B,this._secretState),se=B.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,re=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${B.identifier.value}`),Promise.all([ve.whenReady,Pe.whenReady,this._storagePath.whenReady]).then(()=>{const j=this;let ie,me;const be=(0,f.isProposedApiEnabled)(B,"ipc")?this._initData.messagePorts?.get(n.ExtensionIdentifier.toKey(B.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:Pe,secrets:oe,subscriptions:[],get languageModelAccessInformation(){return ee},get extensionUri(){return B.extensionLocation},get extensionPath(){return B.extensionLocation.fsPath},asAbsolutePath(Ae){return O.join(B.extensionLocation.fsPath,Ae)},get storagePath(){return j._storagePath.workspaceValue(B)?.fsPath},get globalStoragePath(){return j._storagePath.globalValue(B).fsPath},get logPath(){return O.join(j._initData.logsLocation.fsPath,B.identifier.value)},get logUri(){return y.URI.joinPath(j._initData.logsLocation,B.identifier.value)},get storageUri(){return j._storagePath.workspaceValue(B)},get globalStorageUri(){return j._storagePath.globalValue(B)},get extensionMode(){return se},get extension(){return ie===void 0&&(ie=new ne(j,B.identifier,B,re,!1)),ie},get extensionRuntime(){return(0,f.checkProposedApiEnabled)(B,"extensionRuntime"),j.extensionRuntime},get environmentVariableCollection(){return j._extHostTerminalService.getEnvironmentVariableCollection(B)},get messagePassingProtocol(){if(!me){if(!be)return;const Ae=C.Event.buffer(C.Event.fromDOMEventEmitter(be,"message",fe=>fe.data));be.start(),me={onDidReceiveMessage:Ae,postMessage:be.postMessage.bind(be)}}return me}})})}static _callActivate(B,ee,ve,Pe,oe){return ve=ve||{activate:void 0,deactivate:void 0},this._callActivateOptional(B,ee,ve,Pe,oe).then(se=>new S.ActivatedExtension(!1,null,oe.build(),ve,se,Pe.subscriptions))}static _callActivateOptional(B,ee,ve,Pe,oe){if(typeof ve.activate=="function")try{oe.activateCallStart(),B.trace(`ExtensionService#_callActivateOptional ${ee.value}`);const se=typeof global=="object"?global:self,re=ve.activate.apply(se,[Pe]);return oe.activateCallStop(),oe.activateResolveStart(),Promise.resolve(re).then(j=>(oe.activateResolveStop(),j))}catch(se){return Promise.reject(se)}else return Promise.resolve(ve)}_activateOneStartupFinished(B,ee){this._activateById(B.identifier,{startup:!1,extensionId:B.identifier,activationEvent:ee}).then(void 0,ve=>{this._logService.error(ve)})}_activateAllStartupFinishedDeferred(B,ee=0){const Pe=Date.now();(0,M.setTimeout0)(()=>{for(let oe=ee;oe<B.length;oe+=1){const se=B[oe];for(const re of se.activationEvents??[])if(re==="onStartupFinished")if(Date.now()-Pe>50){this._activateAllStartupFinishedDeferred(B,oe);break}else this._activateOneStartupFinished(se,re)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(L.getMarks()),this._extHostConfiguration.getConfigProvider().then(B=>{const ee=B.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ve=this._myRegistry.getAllExtensionDescriptions();if(ee)this._activateAllStartupFinishedDeferred(ve);else for(const Pe of ve)if(Pe.activationEvents)for(const oe of Pe.activationEvents)oe==="onStartupFinished"&&this._activateOneStartupFinished(Pe,oe)})}_handleEagerExtensions(){const B=this._activateByEvent("*",!0).then(void 0,se=>{this._logService.error(se)});this._register(this._extHostWorkspace.onDidChangeWorkspace(se=>this._handleWorkspaceContainsEagerExtensions(se.added)));const ee=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ve=this._handleWorkspaceContainsEagerExtensions(ee),Pe=this._handleRemoteResolverEagerExtensions(),oe=Promise.all([Pe,B,ve]).then(()=>{});return Promise.race([oe,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),oe}_handleWorkspaceContainsEagerExtensions(B){return B.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(ee=>this._handleWorkspaceContainsEagerExtension(B,ee))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(B,ee){if(this.isActivated(ee.identifier))return;const ve=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Pe={logService:this._logService,folders:B.map(se=>se.uri),forceUsingSearch:ve||!this._hostUtils.fsExists,exists:se=>this._hostUtils.fsExists(se.fsPath),checkExists:(se,re,j)=>this._mainThreadWorkspaceProxy.$checkExists(se,re,j)},oe=await(0,P.checkActivateWorkspaceContainsExtension)(Pe,ee);if(oe)return this._activateById(ee.identifier,{startup:!0,extensionId:ee.identifier,activationEvent:oe.activationEvent}).then(void 0,se=>this._logService.error(se))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(B){throw console.error(B),B}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:B,extensionTestsLocationURI:ee}=this._initData.environment;if(!B||!ee)throw new Error(h.localize(0,null));const ve=await this._loadCommonJSModule(null,ee,new S.ExtensionActivationTimesBuilder(!1));if(!ve||typeof ve.run!="function")throw new Error(h.localize(1,null,ee.toString()));return new Promise((Pe,oe)=>{const se=(ie,me)=>{ie?(M.isCI&&this._logService.error("Test runner called back with error",ie),oe(ie)):(M.isCI&&(me?this._logService.info(`Test runner called back with ${me} failures.`):this._logService.info("Test runner called back with successful outcome.")),Pe(typeof me=="number"&&me>0?1:0))},re=(0,A.originalFSPath)(ee),j=ve.run(re,se);j&&j.then&&j.then(()=>{M.isCI&&this._logService.info("Test runner finished successfully."),Pe(0)}).catch(ie=>{M.isCI&&this._logService.error("Test runner finished with error",ie),oe(ie instanceof Error&&ie.stack?ie.stack:String(ie))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,R.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(B,ee){return this._resolvers[B]=ee,(0,b.toDisposable)(()=>{delete this._resolvers[B]})}async getRemoteExecServer(B){const{resolver:ee}=await this._activateAndGetResolver(B);return ee?.resolveExecServer?.(B,{resolveAttempt:0})}async _activateAndGetResolver(B){const ee=B.indexOf("+");if(ee===-1)throw new t.RemoteAuthorityResolverError("Not an authority that can be resolved!",u.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ve=B.substr(0,ee);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this._resolvers[ve]}}async $resolveAuthority(B,ee){const ve=N.StopWatch.create(!1),Pe=()=>`[resolveAuthority(${(0,u.getRemoteAuthorityPrefix)(B)},${ee})][${ve.elapsed()}ms] `,oe=$=>this._logService.info(`${Pe()}${$}`),se=$=>this._logService.warn(`${Pe()}${$}`),re=($,K=void 0)=>this._logService.error(`${Pe()}${$}`,K),j=$=>{if($ instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:$._code,message:$._message,detail:$._detail}};throw $},ie=async $=>{oe(`activating resolver for ${$}...`);const{resolver:K,authorityPrefix:Q}=await this._activateAndGetResolver($);if(!K)throw re(`no resolver for ${Q}`),new t.RemoteAuthorityResolverError(`No remote extension installed to resolve ${Q}.`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:Q,remoteAuthority:$}},me=B.split(/@|%40/g).reverse();oe(`activating remote resolvers ${me.join(" -> ")}`);let be;try{be=await Promise.all(me.map(ie)).catch(async $=>{if(!($ instanceof t.RemoteAuthorityResolverError)||$._code!==u.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw $;return se(`resolving nested authorities failed: ${$.message}`),[await ie(B)]})}catch($){return j($)}const Ae=new R.IntervalTimer;Ae.cancelAndSet(()=>oe("waiting..."),1e3);let fe,De;for(const[$,{authorityPrefix:K,resolver:Q,remoteAuthority:de}]of be.entries())try{if($===be.length-1)oe("invoking final resolve()..."),L.mark(`code/extHost/willResolveAuthority/${K}`),fe=await Q.resolve(de,{resolveAttempt:ee,execServer:De}),L.mark(`code/extHost/didResolveAuthorityOK/${K}`),oe("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(Q,t.ManagedResolvedAuthority.isManagedResolvedAuthority(fe)?fe:void 0));else{if(oe(`invoking resolveExecServer() for ${de}`),L.mark(`code/extHost/willResolveExecServer/${K}`),De=await Q.resolveExecServer?.(de,{resolveAttempt:ee,execServer:De}),!De)throw new t.RemoteAuthorityResolverError(`Exec server was not available for ${de}`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);L.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(Ee){return L.mark(`code/extHost/didResolveAuthorityError/${K}`),re("returned an error",Ee),Ae.dispose(),j(Ee)}Ae.dispose();const Te={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures?{elevation:fe.tunnelFeatures.elevation,privacyOptions:fe.tunnelFeatures.privacyOptions,protocol:fe.tunnelFeatures.protocol===void 0?!0:fe.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};oe(`returned ${t.ManagedResolvedAuthority.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let U;if(t.ManagedResolvedAuthority.isManagedResolvedAuthority(fe)){const $=ee;this._extHostManagedSockets.setFactory($,fe.makeConnection),U={authority:B,connectTo:new u.ManagedRemoteConnection($),connectionToken:fe.connectionToken}}else U={authority:B,connectTo:new u.WebSocketRemoteConnection(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:U,options:ze,tunnelInformation:Te}}}async $getCanonicalURI(B,ee){this._logService.info(`$getCanonicalURI invoked for authority (${(0,u.getRemoteAuthorityPrefix)(B)})`);const{resolver:ve}=await this._activateAndGetResolver(B);if(!ve)return null;const Pe=y.URI.revive(ee);if(typeof ve.getCanonicalURI>"u")return Pe;const oe=await(0,R.asPromise)(()=>ve.getCanonicalURI(Pe));return oe||Pe}async $startExtensionHost(B){B.toAdd.forEach(se=>se.extensionLocation=y.URI.revive(se.extensionLocation));const{globalRegistry:ee,myExtensions:ve}=H(this._activationEventsReader,this._globalRegistry,this._myRegistry,B),Pe=await this._createExtensionPathIndex(ve);return(await this.getExtensionPathIndex()).setSearchTree(Pe),this._globalRegistry.set(ee.getAllExtensionDescriptions()),this._myRegistry.set(ve),M.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${Y(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${Y(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(B,ee){return ee===1?this._almostReadyToRunExtensions.wait().then(ve=>this._activateByEvent(B,!1)):this._readyToRunExtensions.wait().then(ve=>this._activateByEvent(B,!1))}async $activate(B,ee){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(B)?(await this._activateById(B,ee),!0):!1}async $deltaExtensions(B){B.toAdd.forEach(se=>se.extensionLocation=y.URI.revive(se.extensionLocation));const{globalRegistry:ee,myExtensions:ve}=H(this._activationEventsReader,this._globalRegistry,this._myRegistry,B),Pe=await this._createExtensionPathIndex(ve);return(await this.getExtensionPathIndex()).setSearchTree(Pe),this._globalRegistry.set(ee.getAllExtensionDescriptions()),this._myRegistry.set(ve),M.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${Y(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${Y(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(B){return B}async $test_up(B){return B.byteLength}async $test_down(B){const ee=l.VSBuffer.alloc(B),ve=Math.random()%256;for(let Pe=0;Pe<B;Pe++)ee.writeUInt8(ve,Pe);return ee}async $updateRemoteConnectionData(B){this._remoteConnectionData=B,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=te,e.AbstractExtHostExtensionService=te=X=Ge([Ue(0,r.IInstantiationService),Ue(1,e.IHostUtils),Ue(2,w.IExtHostRpcService),Ue(3,d.IExtHostWorkspace),Ue(4,p.IExtHostConfiguration),Ue(5,T.ILogService),Ue(6,c.IExtHostInitDataService),Ue(7,s.IExtensionStoragePaths),Ue(8,D.IExtHostTunnelService),Ue(9,v.IExtHostTerminalService),Ue(10,z.IExtHostLocalizationService),Ue(11,W.IExtHostManagedSockets),Ue(12,_.IExtHostLanguageModels)],te);function H(Z,B,ee,ve){Z.addActivationEvents(ve.addActivationEvents);const Pe=new a.ExtensionDescriptionRegistry(Z,B.getAllExtensionDescriptions());Pe.deltaExtensions(ve.toAdd,ve.toRemove);const oe=new n.ExtensionIdentifierSet(ee.getAllExtensionDescriptions().map(re=>re.identifier));for(const re of ve.myToRemove)oe.delete(re);for(const re of ve.myToAdd)oe.add(re);const se=pe(Pe,oe);return{globalRegistry:Pe,myExtensions:se}}function G(Z,B){return{id:Z.identifier.value,name:Z.name,extensionVersion:Z.version,publisherDisplayName:Z.publisher,activationEvents:Z.activationEvents?Z.activationEvents.join(","):null,isBuiltin:Z.isBuiltin,reason:B.activationEvent,reasonId:B.extensionId.value}}function Y(Z){return Z.getAllExtensionDescriptions().map(B=>B.identifier.value).join(",")}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class ne{#e;#t;#i;constructor(B,ee,ve,Pe,oe){this.#e=B,this.#t=ee,this.#i=ve.identifier,this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=O.normalize((0,A.originalFSPath)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=Pe,this.isFromDifferentExtensionHost=oe}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=ne;function pe(Z,B){return Z.getAllExtensionDescriptions().filter(ee=>B.has(ee.identifier))}class le{constructor(B){this._searchTree=B}setSearchTree(B){this._searchTree=B}findSubstr(B){return this._searchTree.findSubstr(B)}forEach(B){return this._searchTree.forEach(B)}}e.ExtensionPaths=le;class we{constructor(B){this._map=new n.ExtensionIdentifierMap,this.addActivationEvents(B)}readActivationEvents(B){return this._map.get(B.identifier)??[]}addActivationEvents(B){for(const ee of Object.keys(B))this._map.set(ee,B[ee])}}}),define(_e[379],Ce([1,0,59,2,6,45,26,25,20,28,5,49,11,14]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(l,o,t,u,r,c,s){this._apiFactory=l,this._extensionRegistry=o,this._instaService=t,this._extHostConfiguration=u,this._extHostExtensionService=r,this._initData=c,this._logService=s,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),h.mark("code/extHost/willWaitForConfig");const l=await this._extHostConfiguration.getConfigProvider();h.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new a(this._apiFactory,o,this._extensionRegistry,l,this._logService)),this.register(this._instaService.createInstance(f)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(i,o,this._initData.environment.appUriScheme))}register(l){if("nodeModuleName"in l)if(Array.isArray(l.nodeModuleName))for(const o of l.nodeModuleName)this._factories.set(o,l);else this._factories.set(l.nodeModuleName,l);typeof l.alternativeModuleName=="function"&&this._alternatives.push(o=>l.alternativeModuleName(o))}};e.RequireInterceptor=d,e.RequireInterceptor=d=Ge([Ue(2,T.IInstantiationService),Ue(3,A.IExtHostConfiguration),Ue(4,I.IExtHostExtensionService),Ue(5,y.IExtHostInitDataService),Ue(6,p.ILogService)],d);let f=class{static{E=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(l){if(l.environment.appRoot&&E.aliased.size){const o=(0,S.escapeRegExpCharacters)(this.forceForwardSlashes(l.environment.appRoot.fsPath)),t="[a-z0-9_.-]",u=`@${t}+\\/${t}+|${t}+`,r="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${o}/${r}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(l){if(!this.re)return;const o=this.re.exec(this.forceForwardSlashes(l));if(!o)return;const[,t,u,r]=o,c=E.aliased.get(u);if(c!==void 0)return console.warn(`${u} as been renamed to ${c}, please update your imports`),t+c+r}forceForwardSlashes(l){return l.replace(/\\/g,"/")}};f=E=Ge([Ue(0,y.IExtHostInitDataService)],f);class a{constructor(l,o,t,u,r){this._apiFactory=l,this._extensionPaths=o,this._extensionRegistry=t,this._configProvider=u,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new b.ExtensionIdentifierMap}load(l,o){const t=this._extensionPaths.findSubstr(o);if(t){let u=this._extApiImpl.get(t.identifier);return u||(u=this._apiFactory(t,this._extensionRegistry,this._configProvider),this._extApiImpl.set(t.identifier,u)),u}if(!this._defaultApiImpl){let u="";this._extensionPaths.forEach((r,c)=>u+=`	${c} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${u}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let i=class{constructor(l,o,t){this._extensionPaths=l,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=t.getProxy(L.MainContext.MainThreadTelemetry);const u=t.getProxy(L.MainContext.MainThreadWindow);this._impl=(r,c)=>{const s=O.URI.parse(r);return c?this.callOriginal(r,c):s.scheme==="http"||s.scheme==="https"?u.$openUri(s,r,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this._appUriScheme?u.$openUri(s,r,{}):this.callOriginal(r,c)}}load(l,o,t){const u=this._extensionPaths.findSubstr(o);return u&&(this._extensionId=u.identifier.value,this.sendShimmingTelemetry()),this._original=t(l),this._impl}callOriginal(l,o){return this.sendNoForwardTelemetry(),this._original(l,o)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};i=Ge([Ue(2,m.IExtHostRpcService)],i)}),define(_e[61],Ce([1,0,46,3,17,52,5,73,72,49,8,44,307,45]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,R.createDecorator)("IExtHostVariableResolverProvider");class E extends p.AbstractVariableResolverService{constructor(a,i,n,l,o,t,u){function r(){if(n){const c=n.activeEditor();if(c)return c.document.uri;const s=l.tabGroups.all.find(w=>w.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof T.TextDiffTabInput||s.input instanceof T.NotebookDiffEditorTabInput)return s.input.modified;if(s.input instanceof T.TextTabInput||s.input instanceof T.NotebookEditorTabInput||s.input instanceof T.CustomEditorTabInput)return s.input.uri}}}super({getFolderUri:c=>{const s=t.folders.filter(w=>w.name===c);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(c,s)=>o.getConfiguration(void 0,c).get(s),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=r();if(c)return L.normalize(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const c=r();if(c){const s=i.getWorkspaceFolder(c);if(s)return L.normalize(s.uri.fsPath)}}},getSelectedText:()=>{if(n){const c=n.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(n){const c=n.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>a.getExtension(c)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(A.env))}}let d=class extends O.Disposable{constructor(a,i,n,l,o){super(),this.extensionService=a,this.workspaceService=i,this.editorService=n,this.configurationService=l,this.editorTabs=o,this._resolver=new h.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),r={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async c=>{r.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new E(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,r,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=d,e.ExtHostVariableResolverProviderService=d=Ge([Ue(0,y.IExtHostExtensionService),Ue(1,I.IExtHostWorkspace),Ue(2,b.IExtHostDocumentsAndEditors),Ue(3,S.IExtHostConfiguration),Ue(4,m.IExtHostEditorTabs)],d)}),define(_e[96],Ce([1,0,7,4,2,25,5,6,72,49,20,8,44,144,299,45,61,3,50,34,16]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i,n,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,R.createDecorator)("IExtHostDebugService");let o=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession?.api}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(g,D,v,_,C,P,k){this._workspaceService=D,this._extensionService=v,this._configurationService=_,this._editorTabs=C,this._variableResolver=P,this._commands=k,this._debugSessions=new Map,this._debugVisualizationTreeItemIdsCounter=0,this._debugVisualizationProviders=new Map,this._debugVisualizationTrees=new Map,this._debugVisualizationTreeItemIds=new WeakMap,this._debugVisualizationElements=new Map,this._visualizers=new Map,this._visualizerIdCounter=0,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new O.Emitter,this._onDidTerminateDebugSession=new O.Emitter,this._onDidChangeActiveDebugSession=new O.Emitter,this._onDidReceiveDebugSessionCustomEvent=new O.Emitter,this._debugServiceProxy=g.getProxy(b.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new O.Emitter,this._onDidChangeActiveStackItem=new O.Emitter,this._activeDebugConsole=new u(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(F=>{F.onDidChange(x=>{this.registerAllDebugTypes(F)}),this.registerAllDebugTypes(F)})}async $getVisualizerTreeItem(g,D){const v=this.hydrateVisualizationContext(D);if(!v)return;const _=await this._debugVisualizationTrees.get(g)?.getTreeItem?.(v);return _?this.convertVisualizerTreeItem(g,_):void 0}registerDebugVisualizationTree(g,D,v){const _=A.ExtensionIdentifier.toKey(g.identifier),C=this.extensionVisKey(_,D);if(this._debugVisualizationProviders.has(C))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this._debugVisualizationTrees.set(C,v),this._debugServiceProxy.$registerDebugVisualizerTree(C,!!v.editItem),(0,a.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizerTree(C),this._debugVisualizationTrees.delete(D)})}async $getVisualizerTreeItemChildren(g,D){const v=this._debugVisualizationElements.get(D)?.item;return v?(await this._debugVisualizationTrees.get(g)?.getChildren?.(v))?.map(C=>this.convertVisualizerTreeItem(g,C))||[]:[]}async $editVisualizerTreeItem(g,D){const v=this._debugVisualizationElements.get(g);if(!v)return;const _=await this._debugVisualizationTrees.get(v.provider)?.editItem?.(v.item,D);return this.convertVisualizerTreeItem(v.provider,_||v.item)}$disposeVisualizedTree(g){const D=this._debugVisualizationElements.get(g);if(!D)return;const v=[D.children];for(const _ of v)if(_)for(const C of _)v.push(this._debugVisualizationElements.get(C)?.children),this._debugVisualizationElements.delete(C)}convertVisualizerTreeItem(g,D){let v=this._debugVisualizationTreeItemIds.get(D);return v||(v=this._debugVisualizationTreeItemIdsCounter++,this._debugVisualizationTreeItemIds.set(D,v),this._debugVisualizationElements.set(v,{provider:g,item:D})),l.DebugTreeItem.from(D,v)}asDebugSourceUri(g,D){const v=g;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let _=`debug:${encodeURIComponent(v.path||"")}`,C="?";return D&&(_+=`${C}session=${encodeURIComponent(D.id)}`,C="&"),_+=`${C}ref=${v.sourceReference}`,L.URI.parse(_)}else{if(v.path)return L.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(g){const D=[];for(const v of g.getAllExtensionDescriptions())if(v.contributes){const _=v.contributes.debuggers;if(_&&_.length>0)for(const C of _)(0,E.isDebuggerMainContribution)(C)&&D.push(C.type)}this._debugServiceProxy.$registerDebugTypes(D)}get activeStackItem(){return this._activeStackItem}get onDidChangeActiveStackItem(){return this._onDidChangeActiveStackItem.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const g=[];return this._breakpoints.forEach(D=>g.push(D)),g}async $resolveDebugVisualizer(g,D){const v=this._visualizers.get(g);if(!v)throw new Error(`No debug visualizer found with id '${g}'`);let{v:_,provider:C,extensionId:P}=v;if(_.visualization||(_=await C.resolveDebugVisualization?.(_,D)||_,v.v=_),!_.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${C}'`);return this.serializeVisualization(P,_.visualization)}async $executeDebugVisualizerCommand(g){const D=this._visualizers.get(g);if(!D)throw new Error(`No debug visualizer found with id '${g}'`);const v=D.v.visualization;v&&"command"in v&&this._commands.executeCommand(v.command,...v.arguments||[])}hydrateVisualizationContext(g){const D=this._debugSessions.get(g.sessionId);return D&&{session:D.api,variable:g.variable,containerId:g.containerId,frameId:g.frameId,threadId:g.threadId}}async $provideDebugVisualizers(g,D,v,_){const C=this.hydrateVisualizationContext(v),P=this.extensionVisKey(g,D),k=this._debugVisualizationProviders.get(P);if(!C||!k)return[];const F=await k.provideDebugVisualization(C,_);return F?F.map(x=>{const z=++this._visualizerIdCounter;this._visualizers.set(z,{v:x,provider:k,extensionId:g});const N=x.iconPath?this.getIconPathOrClass(x.iconPath):void 0;return{id:z,name:x.name,iconClass:N?.iconClass,iconPath:N?.iconPath,visualization:this.serializeVisualization(g,x.visualization)}}):[]}$disposeDebugVisualizers(g){for(const D of g)this._visualizers.delete(D)}registerDebugVisualizationProvider(g,D,v){if(!g.contributes?.debugVisualizers?.some(P=>P.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const _=A.ExtensionIdentifier.toKey(g.identifier),C=this.extensionVisKey(_,D);if(this._debugVisualizationProviders.has(C))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this._debugVisualizationProviders.set(C,v),this._debugServiceProxy.$registerDebugVisualizer(_,D),(0,a.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizer(_,D),this._debugVisualizationProviders.delete(D)})}addBreakpoints(g){const D=g.filter(C=>{const P=C.id;return this._breakpoints.has(P)?!1:(this._breakpoints.set(P,C),!0)});this.fireBreakpointChanges(D,[],[]);const v=[],_=new Map;for(const C of D)if(C instanceof I.SourceBreakpoint){let P=_.get(C.location.uri.toString());P||(P={type:"sourceMulti",uri:C.location.uri,lines:[]},_.set(C.location.uri.toString(),P),v.push(P)),P.lines.push({id:C.id,enabled:C.enabled,condition:C.condition,hitCondition:C.hitCondition,logMessage:C.logMessage,line:C.location.range.start.line,character:C.location.range.start.character,mode:C.mode})}else C instanceof I.FunctionBreakpoint&&v.push({type:"function",id:C.id,enabled:C.enabled,hitCondition:C.hitCondition,logMessage:C.logMessage,condition:C.condition,functionName:C.functionName,mode:C.mode});return this._debugServiceProxy.$registerBreakpoints(v)}removeBreakpoints(g){const D=g.filter(P=>this._breakpoints.delete(P.id));this.fireBreakpointChanges([],D,[]);const v=D.filter(P=>P instanceof I.SourceBreakpoint).map(P=>P.id),_=D.filter(P=>P instanceof I.FunctionBreakpoint).map(P=>P.id),C=D.filter(P=>P instanceof I.DataBreakpoint).map(P=>P.id);return this._debugServiceProxy.$unregisterBreakpoints(v,_,C)}startDebugging(g,D,v){return this._debugServiceProxy.$startDebugging(g?g.uri:void 0,D,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,suppressSaveBeforeStart:v.suppressSaveBeforeStart,suppressDebugStatusbar:v.suppressDebugStatusbar??v.debugUI?.simple,suppressDebugToolbar:v.suppressDebugToolbar??v.debugUI?.simple,suppressDebugView:v.suppressDebugView??v.debugUI?.simple})}stopDebugging(g){return this._debugServiceProxy.$stopDebugging(g?g.id:void 0)}registerDebugConfigurationProvider(g,D,v){if(!D)return new I.Disposable(()=>{});const _=this._configProviderHandleCounter++;return this._configProviders.push({type:g,handle:_,provider:D}),this._debugServiceProxy.$registerDebugConfigurationProvider(g,v,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,_),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(C=>C.provider!==D),this._debugServiceProxy.$unregisterDebugConfigurationProvider(_)})}registerDebugAdapterDescriptorFactory(g,D,v){if(!v)return new I.Disposable(()=>{});if(!this.definesDebugType(g,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.getAdapterDescriptorFactoryByType(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const _=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:D,handle:_,factory:v}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(D,_),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(C=>C.factory!==v),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(_)})}registerDebugAdapterTrackerFactory(g,D){if(!D)return new I.Disposable(()=>{});const v=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:g,handle:v,factory:D}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(_=>_.factory!==D)})}async $runInTerminal(g,D){return Promise.resolve(void 0)}async $substituteVariables(g,D){let v;const _=await this.getFolder(g);return _&&(v={uri:_.uri,name:_.name,index:_.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(v,D)}createDebugAdapter(g,D){if(g.type==="implementation")return new c(g.implementation)}createSignService(){}async $startDASession(g,D){const v=this,_=await this.getSession(D);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(_.type),_).then(C=>{if(!C)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}' (extension might have failed to activate)`);const P=this.convertToDto(C),k=this.createDebugAdapter(P,_);if(!k)throw new Error(`Couldn't create a debug adapter for type '${_.type}'.`);const F=k;return this._debugAdapters.set(g,F),this.getDebugAdapterTrackers(_).then(x=>(x&&this._debugAdaptersTrackers.set(g,x),F.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const N=z,M={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const W=await this._signService.sign(N.arguments.value);M.body={signature:W},F.sendResponse(M)}else throw new Error("no signer")}catch(W){M.success=!1,M.message=W.message,F.sendResponse(M)}}else x&&x.onDidSendMessage&&x.onDidSendMessage(z),z=(0,E.convertToVSCPaths)(z,!0),v._debugServiceProxy.$acceptDAMessage(g,z)}),F.onError(z=>{x&&x.onError&&x.onError(z),this._debugServiceProxy.$acceptDAError(g,z.name,z.message,z.stack)}),F.onExit(z=>{x&&x.onExit&&x.onExit(z??void 0,void 0),this._debugServiceProxy.$acceptDAExit(g,z??void 0,void 0)}),x&&x.onWillStartSession&&x.onWillStartSession(),F.startSession()))})}$sendDAMessage(g,D){D=(0,E.convertToDAPaths)(D,!1);const v=this._debugAdaptersTrackers.get(g);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(D),this._debugAdapters.get(g)?.sendMessage(D)}$stopDASession(g){const D=this._debugAdaptersTrackers.get(g);this._debugAdaptersTrackers.delete(g),D&&D.onWillStopSession&&D.onWillStopSession();const v=this._debugAdapters.get(g);return this._debugAdapters.delete(g),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(g){const D=[],v=[],_=[];if(g.added)for(const C of g.added){const P=C.id;if(P&&!this._breakpoints.has(P)){let k;if(C.type==="function")k=new I.FunctionBreakpoint(C.functionName,C.enabled,C.condition,C.hitCondition,C.logMessage,C.mode);else if(C.type==="data")k=new I.DataBreakpoint(C.label,C.dataId,C.canPersist,C.enabled,C.hitCondition,C.condition,C.logMessage,C.mode);else{const F=L.URI.revive(C.uri);k=new I.SourceBreakpoint(new I.Location(F,new I.Position(C.line,C.character)),C.enabled,C.condition,C.hitCondition,C.logMessage,C.mode)}(0,I.setBreakpointId)(k,P),this._breakpoints.set(P,k),D.push(k)}}if(g.removed)for(const C of g.removed){const P=this._breakpoints.get(C);P&&(this._breakpoints.delete(C),v.push(P))}if(g.changed){for(const C of g.changed)if(C.id){const P=this._breakpoints.get(C.id);if(P){if(P instanceof I.FunctionBreakpoint&&C.type==="function"){const k=P;k.enabled=C.enabled,k.condition=C.condition,k.hitCondition=C.hitCondition,k.logMessage=C.logMessage,k.functionName=C.functionName}else if(P instanceof I.SourceBreakpoint&&C.type==="source"){const k=P;k.enabled=C.enabled,k.condition=C.condition,k.hitCondition=C.hitCondition,k.logMessage=C.logMessage,k.location=new I.Location(L.URI.revive(C.uri),new I.Position(C.line,C.character))}_.push(P)}}}this.fireBreakpointChanges(D,v,_)}async $acceptStackFrameFocus(g){let D;if(g){const v=await this.getSession(g.sessionId);g.kind==="thread"?D=new I.DebugThread(v.api,g.threadId):D=new I.DebugStackFrame(v.api,g.threadId,g.frameId)}this._activeStackItem=D,this._onDidChangeActiveStackItem.fire(this._activeStackItem)}$provideDebugConfigurations(g,D,v){return(0,h.asPromise)(async()=>{const _=this.getConfigProviderByHandle(g);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const C=await this.getFolder(D);return _.provideDebugConfigurations(C,v)}).then(_=>{if(!_)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return _})}$resolveDebugConfiguration(g,D,v,_){return(0,h.asPromise)(async()=>{const C=this.getConfigProviderByHandle(g);if(!C)throw new Error("no DebugConfigurationProvider found");if(!C.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.getFolder(D);return C.resolveDebugConfiguration(P,v,_)})}$resolveDebugConfigurationWithSubstitutedVariables(g,D,v,_){return(0,h.asPromise)(async()=>{const C=this.getConfigProviderByHandle(g);if(!C)throw new Error("no DebugConfigurationProvider found");if(!C.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.getFolder(D);return C.resolveDebugConfigurationWithSubstitutedVariables(P,v,_)})}async $provideDebugAdapter(g,D){const v=this.getAdapterDescriptorFactoryByHandle(g);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const _=await this.getSession(D);return this.getAdapterDescriptor(v,_).then(C=>{if(!C)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}'`);return this.convertToDto(C)})}async $acceptDebugSessionStarted(g){const D=await this.getSession(g);this._onDidStartDebugSession.fire(D.api)}async $acceptDebugSessionTerminated(g){const D=await this.getSession(g);D&&(this._onDidTerminateDebugSession.fire(D.api),this._debugSessions.delete(D.id))}async $acceptDebugSessionActiveChanged(g){this._activeDebugSession=g?await this.getSession(g):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession?.api)}async $acceptDebugSessionNameChanged(g,D){(await this.getSession(g))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(g,D){const _={session:(await this.getSession(g)).api,event:D.event,body:D.body};this._onDidReceiveDebugSessionCustomEvent.fire(_)}convertToDto(g){if(g instanceof I.DebugAdapterExecutable)return{type:"executable",command:g.command,args:g.args,options:g.options};if(g instanceof I.DebugAdapterServer)return{type:"server",port:g.port,host:g.host};if(g instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:g.path};if(g instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:g.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(g){const D=this._adapterFactories.filter(v=>v.type===g);if(D.length>0)return D[0].factory}getAdapterDescriptorFactoryByHandle(g){const D=this._adapterFactories.filter(v=>v.handle===g);if(D.length>0)return D[0].factory}getConfigProviderByHandle(g){const D=this._configProviders.filter(v=>v.handle===g);if(D.length>0)return D[0].provider}definesDebugType(g,D){if(g.contributes){const v=g.contributes.debuggers;if(v&&v.length>0){for(const _ of v)if(_.label&&_.type&&_.type===D)return!0}}return!1}getDebugAdapterTrackers(g){const v=g.configuration.type,_=this._trackerFactories.filter(C=>C.type===v||C.type==="*").map(C=>(0,h.asPromise)(()=>C.factory.createDebugAdapterTracker(g.api)).then(P=>P,P=>null));return Promise.race([Promise.all(_).then(C=>{const P=C.filter(k=>!!k);if(P.length>0)return new r(P)}),new Promise(C=>setTimeout(()=>C(void 0),1e3))]).catch(C=>{})}async getAdapterDescriptor(g,D){const v=D.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new I.DebugAdapterServer(v));if(g){const C=await this._extensionService.getExtensionRegistry();return(0,h.asPromise)(()=>g.createDebugAdapterDescriptor(D.api,this.daExecutableFromPackage(D,C))).then(P=>{if(P)return P})}const _=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(D,_))}daExecutableFromPackage(g,D){}fireBreakpointChanges(g,D,v){(g.length>0||D.length>0||v.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:g,removed:D,changed:v}))}async getSession(g){if(g)if(typeof g=="string"){const D=this._debugSessions.get(g);if(D)return D}else{let D=this._debugSessions.get(g.id);if(!D){const v=await this.getFolder(g.folderUri),_=g.parent?this._debugSessions.get(g.parent):void 0;D=new t(this._debugServiceProxy,g.id,g.type,g.name,v,g.configuration,_?.api),this._debugSessions.set(D.id,D),this._debugServiceProxy.$sessionCached(D.id)}return D}throw new Error("cannot find session")}getFolder(g){if(g){const D=L.URI.revive(g);return this._workspaceService.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}extensionVisKey(g,D){return`${g}\0${D}`}serializeVisualization(g,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${g}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}getIconPathOrClass(g){const D=this.getIconUris(g);let v,_;return"id"in D?_=i.ThemeIcon.asClassName(D):v=D,{iconPath:v,iconClass:_}}getIconUris(g){if(g instanceof I.ThemeIcon)return{id:g.id};const D=typeof g=="object"&&"dark"in g?g.dark:g,v=typeof g=="object"&&"light"in g?g.light:g;return{dark:typeof D=="string"?L.URI.file(D):D,light:typeof v=="string"?L.URI.file(v):v}}};e.ExtHostDebugServiceBase=o,e.ExtHostDebugServiceBase=o=Ge([Ue(0,T.IExtHostRpcService),Ue(1,p.IExtHostWorkspace),Ue(2,y.IExtHostExtensionService),Ue(3,d.IExtHostConfiguration),Ue(4,m.IExtHostEditorTabs),Ue(5,f.IExtHostVariableResolverProvider),Ue(6,n.IExtHostCommands)],o);class t{constructor(g,D,v,_,C,P,k){this._debugServiceProxy=g,this._id=D,this._type=v,this._name=_,this._workspaceFolder=C,this._configuration=P,this._parentSession=k}get api(){const g=this;return this.apiSession??=Object.freeze({id:g._id,type:g._type,get name(){return g._name},set name(D){g._name=D,g._debugServiceProxy.$setDebugSessionName(g._id,D)},parentSession:g._parentSession,workspaceFolder:g._workspaceFolder,configuration:g._configuration,customRequest(D,v){return g._debugServiceProxy.$customDebugAdapterRequest(g._id,D,v)},getDebugProtocolBreakpoint(D){return g._debugServiceProxy.$getDebugProtocolBreakpoint(g._id,D.id)}})}get id(){return this._id}get type(){return this._type}_acceptNameChanged(g){this._name=g}get configuration(){return this._configuration}}e.ExtHostDebugSession=t;class u{constructor(g){this.value=Object.freeze({append(D){g.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.ExtHostDebugConsole=u;class r{constructor(g){this.trackers=g}onWillStartSession(){this.trackers.forEach(g=>g.onWillStartSession?g.onWillStartSession():void 0)}onWillReceiveMessage(g){this.trackers.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(g):void 0)}onDidSendMessage(g){this.trackers.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(g):void 0)}onWillStopSession(){this.trackers.forEach(g=>g.onWillStopSession?g.onWillStopSession():void 0)}onError(g){this.trackers.forEach(D=>D.onError?D.onError(g):void 0)}onExit(g,D){this.trackers.forEach(v=>v.onExit?v.onExit(g,D):void 0)}}class c extends S.AbstractDebugAdapter{constructor(g){super(),this.implementation=g,g.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(g){this.implementation.handleMessage(g)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends o{constructor(g,D,v,_,C,P,k){super(g,D,v,_,C,P,k)}};e.WorkerExtHostDebugService=s,e.WorkerExtHostDebugService=s=Ge([Ue(0,T.IExtHostRpcService),Ue(1,p.IExtHostWorkspace),Ue(2,y.IExtHostExtensionService),Ue(3,d.IExtHostConfiguration),Ue(4,m.IExtHostEditorTabs),Ue(5,f.IExtHostVariableResolverProvider),Ue(6,n.IExtHostCommands)],s)}),define(_e[380],Ce([1,0,13,59,2,6,327,11,85,107,28,263,20,68,49,90]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class f{static async installEarlyHandler(n){Error.stackTraceLimit=100;const l=n.get(b.ILogService),t=n.get(p.IExtHostRpcService).getProxy(A.MainContext.MainThreadErrors);h.setUnexpectedErrorHandler(u=>{l.error(u);const r=h.transformErrorForSerialization(u);t.$onUnexpectedError(r)})}static async installFullHandler(n){const l=n.get(b.ILogService),o=n.get(p.IExtHostRpcService),t=n.get(E.IExtHostExtensionService),u=n.get(d.IExtHostTelemetry),r=o.getProxy(A.MainContext.MainThreadExtensionService),c=o.getProxy(A.MainContext.MainThreadErrors),s=await t.getExtensionPathIndex(),w=new WeakMap;function g(_,C){if(w.has(_))return w.get(_).stack;let P="",k,F;for(const z of C)P+=`
	at ${z.toString()}`,F=z.getFileName(),!k&&F&&(k=s.findSubstr(L.URI.file(F)));const x=`${_.name||"Error"}: ${_.message||""}${P}`;return w.set(_,{extensionIdentifier:k?.identifier,stack:x}),x}const D=Symbol("prepareStackTrace wrapped");let v=g;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(_){if(_===g||!_||_[D]){v=_||g;return}v=function(C,P){return g(C,P),_.call(Error,C,P)},Object.assign(v,{[D]:!0})}}),h.setUnexpectedErrorHandler(_=>{l.error(_);const C=h.transformErrorForSerialization(_),P=w.get(_);if(!P?.extensionIdentifier){c.$onUnexpectedError(C);return}r.$onExtensionRuntimeError(P.extensionIdentifier,C);const k=u.onExtensionError(P.extensionIdentifier,_);l.trace("forwarded error to extension?",k,P)})}}e.ErrorHandler=f;class a{constructor(n,l,o,t,u){this._hostUtils=o,this._rpcProtocol=new R.RPCProtocol(n,null,t),l=a._transform(l,this._rpcProtocol);const r=new y.ServiceCollection(...(0,m.getSingletonServiceDescriptors)());r.set(T.IExtHostInitDataService,{_serviceBrand:void 0,...l,messagePorts:u}),r.set(p.IExtHostRpcService,new p.ExtHostRpcService(this._rpcProtocol)),r.set(S.IURITransformerService,new S.URITransformerService(t)),r.set(E.IHostUtils,o);const c=new I.InstantiationService(r,!0);c.invokeFunction(f.installEarlyHandler),this._logService=c.invokeFunction(s=>s.get(b.ILogService)),O.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",l),this._extensionService=c.invokeFunction(s=>s.get(E.IExtHostExtensionService)),this._extensionService.initialize(),c.invokeFunction(f.installFullHandler)}async asBrowserUri(n){const l=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService);return L.URI.revive(await l.$asBrowserUri(n))}terminate(n){this._extensionService.terminate(n)}static _transform(n,l){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=L.URI.revive(l.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=L.URI.revive(l.transformIncomingURIs(n.environment.appRoot));const o=n.environment.extensionDevelopmentLocationURI;return o&&(n.environment.extensionDevelopmentLocationURI=o.map(t=>L.URI.revive(l.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=L.URI.revive(l.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=L.URI.revive(l.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=L.URI.revive(l.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=L.URI.revive(l.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=L.URI.revive(l.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=L.URI.revive(l.transformIncomingURIs(n.logsLocation)),n.workspace=l.transformIncomingURIs(n.workspace),n}}e.ExtensionHostMain=a}),define(_e[381],Ce([1,0,7,12,236,256,141,96,72,49,20,43,8,61,44,300,301,45,34]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let n=class extends b.ExtHostDebugServiceBase{constructor(r,c,s,w,g,D,v,_){super(r,c,s,w,D,v,_),this._terminalService=g,this._integratedTerminalInstances=new t}createDebugAdapter(r,c){switch(r.type){case"server":return new d.SocketDebugAdapter(r);case"pipeServer":return new d.NamedPipeDebugAdapter(r);case"executable":return new d.ExecutableDebugAdapter(r,c.type)}return super.createDebugAdapter(r,c)}daExecutableFromPackage(r,c){const s=d.ExecutableDebugAdapter.platformAdapterExecutable(c.getAllExtensionDescriptions(),r.type);if(s)return new p.DebugAdapterExecutable(s.command,s.args,s.options)}createSignService(){return new R.SignService}async $runInTerminal(r,c){if(r.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(z=>{this._integratedTerminalInstances.onTerminalClosed(z)}));const s=await this._configurationService.getConfigProvider(),w=this._terminalService.getDefaultShell(!0),g=this._terminalService.getDefaultShellArgs(!0),D=r.title||L.localize(0,null),v=JSON.stringify({shell:w,shellArgs:g});let _=await this._integratedTerminalInstances.checkout(v,D),C,P=!1;if(_)C=r.cwd;else{const z={shellPath:w,shellArgs:g,cwd:r.cwd,name:D,iconPath:new p.ThemeIcon("debug")};P=!0,_=this._terminalService.createTerminalFromOptions(z,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(_,v)}_.show(!0);const k=await _.processId;P?await new Promise(z=>setTimeout(z,1e3)):(_.state.isInteractedWith&&_.sendText(""),s.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(w.indexOf("powershell")>=0||w.indexOf("pwsh")>=0||w.indexOf("cmd.exe")>=0?_.sendText("cls"):w.indexOf("bash")>=0?_.sendText("clear"):O.isWindows?_.sendText("cls"):_.sendText("clear")));const F=(0,f.prepareCommand)(w,r.args,!!r.argsCanBeInterpretedByShell,C,r.env);_.sendText(F);const x=this.onDidTerminateDebugSession(z=>{z.id===c&&(this._integratedTerminalInstances.free(_),x.dispose())});return k}else if(r.kind==="external")return o(r,await this._configurationService.getConfigProvider());return super.$runInTerminal(r,c)}};e.ExtHostDebugService=n,e.ExtHostDebugService=n=Ge([Ue(0,T.IExtHostRpcService),Ue(1,E.IExtHostWorkspace),Ue(2,y.IExtHostExtensionService),Ue(3,a.IExtHostConfiguration),Ue(4,I.IExtHostTerminalService),Ue(5,m.IExtHostEditorTabs),Ue(6,S.IExtHostVariableResolverProvider),Ue(7,i.IExtHostCommands)],n);let l;function o(u,r){if(!l)if(O.isWindows)l=new A.WindowsExternalTerminalService;else if(O.isMacintosh)l=new A.MacExternalTerminalService;else if(O.isLinux)l=new A.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const c=r.getConfiguration("terminal");return l.runInTerminal(u.title,u.cwd,u.args,u.env||{},c.external||{})}class t{constructor(){this._terminalInstances=new Map}static{this.minUseDelay=1e3}async checkout(r,c,s=!1){const g=[...this._terminalInstances.entries()].map(([D,v])=>(0,h.createCancelablePromise)(async _=>{if(D.name!==c||v.lastUsedAt!==-1&&await(0,f.hasChildProcesses)(await D.processId))return null;const C=Date.now();return v.lastUsedAt+t.minUseDelay>C||_.isCancellationRequested?null:v.config!==r?(s&&D.dispose(),null):(v.lastUsedAt=C,D)}));return await(0,h.firstParallel)(g,D=>!!D)}insert(r,c){this._terminalInstances.set(r,{lastUsedAt:Date.now(),config:c})}free(r){const c=this._terminalInstances.get(r);c&&(c.lastUsedAt=-1)}onTerminalClosed(r){this._terminalInstances.delete(r)}}}),define(_e[382],Ce([1,0,17,2,105,44,73,45,42,43,20,28,95,15,11,91,23,64,61]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let n=class extends p.ExtHostTaskBase{constructor(o,t,u,r,c,s,w,g,D){super(o,t,u,r,c,s,w,g),this.workspaceService=u,this.variableResolver=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(S.Schemas.vscodeRemote,{scheme:S.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(S.Schemas.file,{scheme:S.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(o,t){const u=t;if(!t.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const r=p.TaskHandleDTO.from(u,this.workspaceService),c=await this._proxy.$getTaskExecution(r);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.getTaskExecution(c,t);return this._proxy.$executeTask(r).catch(()=>{}),s}else{const r=p.TaskDTO.from(t,o);if(r===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(r.execution)&&await this.addCustomExecution(r,t,!1);const c=await this.getTaskExecution(await this._proxy.$getTaskExecution(r),t);return this._proxy.$executeTask(r).catch(()=>{}),c}}provideTasksInternal(o,t,u,r){const c=[];if(r)for(const s of r){this.checkDeprecation(s,u),(!s.definition||!o[s.definition.type])&&this._logService.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const w=p.TaskDTO.from(s,u.extension);w&&(c.push(w),p.CustomExecutionDTO.is(w.execution)&&t.push(this.addCustomExecution(w,s,!0)))}return{tasks:c,extension:u.extension}}async resolveTaskInternal(o){return o}async getAFolder(o){let t=o&&o.length>0?o[0]:void 0;if(!t){const u=O.URI.file((0,a.homedir)());t=new m.WorkspaceFolder({uri:u,name:f.basename(u),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(o,t){const u=O.URI.revive(o),r={process:void 0,variables:Object.create(null)},c=await this._workspaceProvider.resolveWorkspaceFolder(u),s=await this._workspaceProvider.getWorkspaceFolders2()??[],w=await this.variableResolver.getResolver(),g=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(s);for(const D of t.variables)r.variables[D]=await w.resolveAsync(g,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(h.delimiter);for(let v=0;v<D.length;v++)D[v]=await w.resolveAsync(g,D[v])}r.process=await L.win32.findExecutable(await w.resolveAsync(g,t.process.name),t.process.cwd!==void 0?await w.resolveAsync(g,t.process.cwd):void 0,D)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(o,t,u){return L.win32.findExecutable(o,t,u)}};e.ExtHostTask=n,e.ExtHostTask=n=Ge([Ue(0,T.IExtHostRpcService),Ue(1,I.IExtHostInitDataService),Ue(2,A.IExtHostWorkspace),Ue(3,R.IExtHostDocumentsAndEditors),Ue(4,b.IExtHostConfiguration),Ue(5,y.IExtHostTerminalService),Ue(6,E.ILogService),Ue(7,d.IExtHostApiDeprecationService),Ue(8,i.IExtHostVariableResolverProvider)],n)}),define(_e[383],Ce([1,0,64,61]),function(ue,e,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class L extends O.ExtHostVariableResolverProviderService{homeDir(){return(0,h.homedir)()}}e.NodeExtHostVariableResolverProviderService=L}),define(_e[160],Ce([1,0,19,7,22,47,15,17,23,2,37]),function(ue,e,h,O,L,A,R,b,m,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.TextSearchResultsCollector=e.TextSearchManager=void 0,e.extensionResultIsMatch=d;class I{constructor(i,n,l){this.queryProviderPair=i,this.fileUtils=n,this.processType=l,this.collector=null,this.isLimitHit=!1,this.resultCount=0}get query(){return this.queryProviderPair.query}search(i,n){const l=this.query.folderQueries||[],o=new L.CancellationTokenSource(n);return new Promise((t,u)=>{this.collector=new S(i);let r=!1;const c=(s,w)=>{if(!r&&!this.isLimitHit){const g=this.resultSize(s);d(s)&&typeof this.query.maxResults=="number"&&this.resultCount+g>this.query.maxResults&&(this.isLimitHit=!0,r=!0,o.cancel(),s=this.trimResultToSize(s,this.query.maxResults-this.resultCount));const D=this.resultSize(s);this.resultCount+=D,(D>0||!d(s))&&this.collector.add(s,w)}};Promise.all(l.map((s,w)=>this.searchInFolder(s,g=>c(g,w),o.token))).then(s=>{o.dispose(),this.collector.flush();const w=s.some(g=>!!g&&!!g.limitHit);t({limitHit:this.isLimitHit||w,messages:(0,h.flatten)(s.map(g=>g?.message?Array.isArray(g.message)?g.message:[g.message]:[])),stats:{type:this.processType}})},s=>{o.dispose();const w=(0,A.toErrorMessage)(s);u(new Error(w))})})}resultSize(i){return d(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}trimResultToSize(i,n){const l=Array.isArray(i.ranges)?i.ranges:[i.ranges],o=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:l.slice(0,n),preview:{matches:o.slice(0,n),text:i.preview.text},uri:i.uri}}async searchInFolder(i,n,l){const o=new T.QueryGlobTester(this.query,i),t=[],u={report:s=>{if(!this.validateProviderResult(s))return;const w=i.folder.scheme===R.Schemas.file?(0,T.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(m.dirname(s.uri))):void 0,g=m.relativePath(i.folder,s.uri);if(g){const D=o.includedInQuery(g,b.basename(g),w);(0,O.isThenable)(D)?t.push(D.then(v=>{v&&n(s)})):D&&n(s)}}},r=this.getSearchOptionsForFolder(i);let c;return this.queryProviderPair.query.type===3?c=await this.queryProviderPair.provider.provideAITextSearchResults(this.queryProviderPair.query.contentPattern,r,u,l):c=await this.queryProviderPair.provider.provideTextSearchResults(p(this.queryProviderPair.query.contentPattern),r,u,l),t.length&&await Promise.all(t),c}validateProviderResult(i){if(d(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(i){const n=(0,T.resolvePatternsForProvider)(this.query.includePattern,i.includePattern),l=(0,T.resolvePatternsForProvider)(this.query.excludePattern,i.excludePattern),o={folder:y.URI.from(i.folder),excludes:l,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.fileUtils.toCanonicalName(i.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return"usePCRE2"in this.query&&(o.usePCRE2=this.query.usePCRE2),o}}e.TextSearchManager=I;function p(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class S{constructor(i){this._onResult=i,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new f(512,n=>this.sendItems(n))}add(i,n){this._currentFileMatch&&(this._currentFolderIdx!==n||!m.isEqual(this._currentUri,i.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=n,this._currentFileMatch={resource:i.uri,results:[]}),this._currentFileMatch.results.push(E(i))}pushToCollector(){const i=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,i)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(i){this._onResult(i)}}e.TextSearchResultsCollector=S;function E(a){return d(a)?{preview:{matches:(0,h.mapArrayOrNot)(a.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:a.preview.text},ranges:(0,h.mapArrayOrNot)(a.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function d(a){return!!a.preview}class f{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(i,n){this.maxBatchSize=i,this.cb=n,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(i,n){i&&this.addItemToBatch(i,n)}addItems(i,n){i&&this.addItemsToBatch(i,n)}addItemToBatch(i,n){this.batch.push(i),this.batchSize+=n,this.onUpdate()}addItemsToBatch(i,n){this.batch=this.batch.concat(i),this.batchSize+=n,this.onUpdate()}onUpdate(){this.totalNumberCompleted<f.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},f.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=f}),define(_e[97],Ce([1,0,3,6,5,376,20,68,11,2,160]),function(ue,e,h,O,L,A,R,b,m,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSearch=e.IExtHostSearch=void 0,e.reviveQuery=p,e.IExtHostSearch=(0,L.createDecorator)("IExtHostSearch");let I=class{constructor(d,f,a){this.extHostRpc=d,this._uriTransformer=f,this._logService=a,this._proxy=this.extHostRpc.getProxy(O.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._aiTextSearchProvider=new Map,this._aiTextSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,f){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const a=this._handlePool++;return this._textSearchProvider.set(a,f),this._proxy.$registerTextSearchProvider(a,this._transformScheme(d)),(0,h.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(a),this._proxy.$unregisterProvider(a)})}registerAITextSearchProvider(d,f){if(this._aiTextSearchUsedSchemes.has(d))throw new Error(`an AI text search provider for the scheme '${d}'is already registered`);this._aiTextSearchUsedSchemes.add(d);const a=this._handlePool++;return this._aiTextSearchProvider.set(a,f),this._proxy.$registerAITextSearchProvider(a,this._transformScheme(d)),(0,h.toDisposable)(()=>{this._aiTextSearchUsedSchemes.delete(d),this._aiTextSearchProvider.delete(a),this._proxy.$unregisterProvider(a)})}registerFileSearchProvider(d,f){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const a=this._handlePool++;return this._fileSearchProvider.set(a,f),this._proxy.$registerFileSearchProvider(a,this._transformScheme(d)),(0,h.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(a),this._proxy.$unregisterProvider(a)})}$provideFileSearchResults(d,f,a,i){const n=p(a),l=this._fileSearchProvider.get(d);if(l)return this._fileSearchManager.fileSearch(n,l,o=>{this._proxy.$handleFileMatch(d,f,o.map(t=>t.resource))},i);throw new Error("3 unknown provider: "+d)}async doInternalFileSearchWithCustomCallback(d,f,a){return{messages:[]}}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,f,a,i){const n=this._textSearchProvider.get(d);if(!n||!n.provideTextSearchResults)throw new Error(`2 Unknown provider ${d}`);const l=p(a);return this.createTextSearchManager(l,n).search(t=>this._proxy.$handleTextMatch(d,f,t),i)}$provideAITextSearchResults(d,f,a,i){const n=this._aiTextSearchProvider.get(d);if(!n||!n.provideAITextSearchResults)throw new Error(`1 Unknown provider ${d}`);const l=p(a);return this.createAITextSearchManager(l,n).search(t=>this._proxy.$handleTextMatch(d,f,t),i)}$enableExtensionHostSearch(){}createTextSearchManager(d,f){return new T.TextSearchManager({query:d,provider:f},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}createAITextSearchManager(d,f){return new T.TextSearchManager({query:d,provider:f},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"aiTextSearchProvider")}};e.ExtHostSearch=I,e.ExtHostSearch=I=Ge([Ue(0,R.IExtHostRpcService),Ue(1,b.IURITransformerService),Ue(2,m.ILogService)],I);function p(E){return{...E,folderQueries:E.folderQueries&&E.folderQueries.map(S),extraFileResources:E.extraFileResources&&E.extraFileResources.map(d=>y.URI.revive(d))}}function S(E){return{...E,folder:y.URI.revive(E.folder)}}}),define(_e[384],Ce([1,0,22,13,4,3,15,41,2,136,203,184,80,25,33,11,86,87,283,6,329,355,91,121,333,334,335,316,305,34,336,45,337,96,152,338,318,330,339,340,73,72,331,49,341,70,342,60,28,356,357,319,343,122,344,116,117,320,375,346,288,347,358,348,158,321,349,350,351,20,352,97,118,353,322,354,119,93,95,90,43,156,359,360,332,361,362,71,16,8,323,68,324,92,363,364,151,44,298,115,26,94]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i,n,l,o,t,u,r,c,s,w,g,D,v,_,C,P,k,F,x,z,N,M,W,X,te,H,G,Y,ne,pe,le,we,Z,B,ee,ve,Pe,oe,se,re,j,ie,me,be,Ae,fe,De,Te,ze,U,$,K,Q,de,Ee,Fe,He,Ke,rt,tt,it,st,Ie,Be,qe,Oe,Qe,ae,ce,ke,je,Le,ot,lt,wt,At,Wt,ti,Xt,_t,Qt,Yt,et,oi){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=jt;function jt(ft){const pt=ft.get(le.IExtHostInitDataService),Jt=ft.get(pe.IExtHostFileSystemInfo),Gt=ft.get(Y.IExtHostConsumerFileSystem),Ft=ft.get(H.IExtHostExtensionService),gt=ft.get(_t.IExtHostWorkspace),Ut=ft.get(st.IExtHostTelemetry),Zt=ft.get(_.IExtHostConfiguration),$t=ft.get(lt.IURITransformerService),Je=ft.get(K.IExtHostRpcService),li=ft.get(rt.IExtHostStorage),Kt=ft.get(tt.IExtensionStoragePaths),Ht=ft.get(d.ILoggerService),vt=ft.get(d.ILogService),xt=ft.get(ke.IExtHostTunnelService),Rt=ft.get(t.IExtHostApiDeprecationService),Ot=ft.get(Xt.IExtHostWindow),ii=ft.get(Ee.IExtHostSecretState),Vt=ft.get(X.IExtHostEditorTabs),ni=ft.get(se.IExtHostManagedSockets),kt=ft.get(u.IExtHostAuthentication),Nt=ft.get(ve.IExtHostLanguageModels);Je.set(n.ExtHostContext.ExtHostFileSystemInfo,Jt),Je.set(n.ExtHostContext.ExtHostLogLevelServiceShape,Ht),Je.set(n.ExtHostContext.ExtHostWorkspace,gt),Je.set(n.ExtHostContext.ExtHostConfiguration,Zt),Je.set(n.ExtHostContext.ExtHostExtensionService,Ft),Je.set(n.ExtHostContext.ExtHostStorage,li),Je.set(n.ExtHostContext.ExtHostTunnelService,xt),Je.set(n.ExtHostContext.ExtHostWindow,Ot),Je.set(n.ExtHostContext.ExtHostSecretState,ii),Je.set(n.ExtHostContext.ExtHostTelemetry,Ut),Je.set(n.ExtHostContext.ExtHostEditorTabs,Vt),Je.set(n.ExtHostContext.ExtHostManagedSockets,ni),Je.set(n.ExtHostContext.ExtHostAuthentication,kt),Je.set(n.ExtHostContext.ExtHostChatProvider,Nt);const Lt=Je.set(n.ExtHostContext.ExtHostDecorations,ft.get(k.IExtHostDecorations)),Pt=Je.set(n.ExtHostContext.ExtHostDocumentsAndEditors,ft.get(W.IExtHostDocumentsAndEditors)),mt=Je.set(n.ExtHostContext.ExtHostCommands,ft.get(D.IExtHostCommands)),Ct=Je.set(n.ExtHostContext.ExtHostTerminalService,ft.get(Ie.IExtHostTerminalService)),ai=Je.set(n.ExtHostContext.ExtHostTerminalShellIntegration,ft.get(Be.IExtHostTerminalShellIntegration)),Dt=Je.set(n.ExtHostContext.ExtHostDebugService,ft.get(P.IExtHostDebugService)),fi=Je.set(n.ExtHostContext.ExtHostSearch,ft.get(de.IExtHostSearch)),ri=Je.set(n.ExtHostContext.ExtHostTask,ft.get(it.IExtHostTask)),pi=Je.set(n.ExtHostContext.ExtHostOutputService,ft.get(De.IExtHostOutputService)),ui=Je.set(n.ExtHostContext.ExtHostLocalization,ft.get(oe.IExtHostLocalizationService)),bi=Je.set(n.ExtHostContext.ExtHostUrls,new wt.ExtHostUrls(Je)),It=Je.set(n.ExtHostContext.ExtHostDocuments,new M.ExtHostDocuments(Je,Pt)),wi=Je.set(n.ExtHostContext.ExtHostDocumentContentProviders,new z.ExtHostDocumentContentProvider(Je,Pt,vt)),si=Je.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new N.ExtHostDocumentSaveParticipant(vt,It,Je.getProxy(n.MainContext.MainThreadBulkEdits))),Re=Je.set(n.ExtHostContext.ExtHostNotebook,new j.ExtHostNotebookController(Je,mt,Pt,It,Gt,fi)),xe=Je.set(n.ExtHostContext.ExtHostNotebookDocuments,new me.ExtHostNotebookDocuments(Re)),Se=Je.set(n.ExtHostContext.ExtHostNotebookEditors,new be.ExtHostNotebookEditors(vt,Re)),J=Je.set(n.ExtHostContext.ExtHostNotebookKernels,new Ae.ExtHostNotebookKernels(Je,pt,Re,mt,vt)),Me=Je.set(n.ExtHostContext.ExtHostNotebookRenderers,new fe.ExtHostNotebookRenderers(Je,Re)),Ve=Je.set(n.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new ie.ExtHostNotebookDocumentSaveParticipant(vt,Re,Je.getProxy(n.MainContext.MainThreadBulkEdits))),Ze=Je.set(n.ExtHostContext.ExtHostEditors,new Oe.ExtHostEditors(Je,Pt)),Xe=Je.set(n.ExtHostContext.ExtHostTreeViews,new ce.ExtHostTreeViews(Je.getProxy(n.MainContext.MainThreadTreeViews),mt,vt)),dt=Je.set(n.ExtHostContext.ExtHostEditorInsets,new g.ExtHostEditorInsets(Je.getProxy(n.MainContext.MainThreadEditorInsets),Ze,pt.remote)),yt=Je.set(n.ExtHostContext.ExtHostDiagnostics,new F.ExtHostDiagnostics(Je,vt,Jt,Pt)),zt=Je.set(n.ExtHostContext.ExtHostLanguages,new Pe.ExtHostLanguages(Je,It,mt.converter,$t)),ut=Je.set(n.ExtHostContext.ExtHostLanguageFeatures,new ee.ExtHostLanguageFeatures(Je,$t,It,mt,yt,vt,Rt,Ut)),Mt=Je.set(n.ExtHostContext.ExtHostFileSystem,new G.ExtHostFileSystem(Je,ut)),Bt=Je.set(n.ExtHostContext.ExtHostFileSystemEventService,new ne.ExtHostFileSystemEventService(Je,vt,Pt)),Si=Je.set(n.ExtHostContext.ExtHostQuickOpen,(0,$.createExtHostQuickOpen)(Je,gt,mt)),Ci=Je.set(n.ExtHostContext.ExtHostSCM,new Q.ExtHostSCM(Je,mt,It,vt)),ji=Je.set(n.ExtHostContext.ExtHostQuickDiff,new U.ExtHostQuickDiff(Je,$t)),Li=Je.set(n.ExtHostContext.ExtHostShare,new Fe.ExtHostShare(Je,$t)),Oi=Je.set(n.ExtHostContext.ExtHostComments,(0,v.createExtHostComments)(Je,mt,It)),Di=Je.set(n.ExtHostContext.ExtHostProgress,new ze.ExtHostProgress(Je.getProxy(n.MainContext.MainThreadProgress))),Ni=Je.set(n.ExtHostContext.ExtHostLabelService,new B.ExtHostLabelService(Je)),Mi=Je.set(n.ExtHostContext.ExtHostTheming,new Qe.ExtHostTheming(Je)),Gi=Je.set(n.ExtHostContext.ExtHostTimeline,new ae.ExtHostTimeline(Je,mt)),Fi=Je.set(n.ExtHostContext.ExtHostWebviews,new At.ExtHostWebviews(Je,pt.remote,gt,vt,Rt)),Ii=Je.set(n.ExtHostContext.ExtHostWebviewPanels,new Wt.ExtHostWebviewPanels(Je,Fi,gt)),xi=Je.set(n.ExtHostContext.ExtHostCustomEditors,new C.ExtHostCustomEditors(Je,It,Kt,Fi,Ii)),zi=Je.set(n.ExtHostContext.ExtHostWebviewViews,new ti.ExtHostWebviewViews(Je,Fi)),Ei=Je.set(n.ExtHostContext.ExtHostTesting,new qe.ExtHostTesting(Je,vt,mt,Pt)),Ki=Je.set(n.ExtHostContext.ExtHostUriOpeners,new ot.ExtHostUriOpeners(Je)),Xi=Je.set(n.ExtHostContext.ExtHostProfileContentHandlers,new Te.ExtHostProfileContentHandlers(Je));Je.set(n.ExtHostContext.ExtHostInteractive,new Z.ExtHostInteractive(Je,Re,Pt,mt,vt));const Qi=Je.set(n.ExtHostContext.ExtHostInlineChat,new we.ExtHostInteractiveEditor(Je,mt,It,vt)),Pi=Je.set(n.ExtHostContext.ExtHostChatAgents2,new c.ExtHostChatAgents2(Je,vt,mt)),Yi=Je.set(n.ExtHostContext.ExtHostChatVariables,new s.ExtHostChatVariables(Je)),Ji=Je.set(n.ExtHostContext.ExtHostAiRelatedInformation,new l.ExtHostRelatedInformation(Je)),hn=Je.set(n.ExtHostContext.ExtHostAiEmbeddingVector,new te.ExtHostAiEmbeddingVector(Je)),ki=Je.set(n.ExtHostContext.ExtHostStatusBar,new Ke.ExtHostStatusBar(Je,mt.converter)),Bi=Je.set(n.ExtHostContext.ExtHostSpeech,new He.ExtHostSpeech(Je)),fn=Object.values(n.ExtHostContext);Je.assertRegistered(fn);const gn=new r.ExtHostBulkEdits(Je,Pt),Zi=new w.ExtHostClipboard(Je),Wi=new re.ExtHostMessageService(Je,vt),Ti=new x.ExtHostDialogs(Je);return o.ExtHostApiCommands.register(mt),function($e,di,$i){function at(he){return(ye,We,ct)=>{const St=he(Tt=>{try{ye.call(We,Tt)}catch(_i){O.onUnexpectedExternalError(new Error(`[ExtensionListenerError] Extension '${$e.identifier.value}' FAILED to handle event: ${_i.toString()}`,{cause:_i})),Ut.onExtensionError($e.identifier,_i)}});return ct?.push(St),St}}const Et=function(){let he=!$e.isUnderDevelopment;function ye(){he||(vt.info(`Extension '${$e.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),he=!0)}return function We(ct){if(Array.isArray(ct))ct.forEach(We);else if(typeof ct=="string")ye();else{const St=ct;typeof St.scheme>"u"&&ye(),typeof St.exclusive=="boolean"&&(0,et.checkProposedApiEnabled)($e,"documentFiltersExclusive")}return ct}}(),en={getSession(he,ye,We){return typeof We?.forceNewSession=="object"&&We.forceNewSession.learnMore&&(0,et.checkProposedApiEnabled)($e,"authLearnMore"),kt.getSession($e,he,ye,We)},getSessions(he,ye){return(0,et.checkProposedApiEnabled)($e,"authGetSessions"),kt.getSessions($e,he,ye)},async hasSession(he,ye){return(0,et.checkProposedApiEnabled)($e,"authSession"),!!await kt.getSession($e,he,ye,{silent:!0})},get onDidChangeSessions(){return at(kt.onDidChangeSessions)},registerAuthenticationProvider(he,ye,We,ct){return kt.registerAuthenticationProvider(he,ye,We,ct)}},gi={registerCommand(he,ye,We){return mt.registerCommand(!0,he,ye,We,void 0,$e)},registerTextEditorCommand(he,ye,We){return mt.registerCommand(!0,he,(...ct)=>{const St=Ze.getActiveTextEditor();if(!St){vt.warn("Cannot execute "+he+" because there is no active text editor.");return}return St.edit(Tt=>{ye.apply(We,[St,Tt,...ct])}).then(Tt=>{Tt||vt.warn("Edits from command "+he+" were not applied.")},Tt=>{vt.warn("An error occurred while running command "+he,Tt)})},void 0,void 0,$e)},registerDiffInformationCommand:(he,ye,We)=>((0,et.checkProposedApiEnabled)($e,"diffCommand"),mt.registerCommand(!0,he,async(...ct)=>{const St=Pt.activeEditor(!0);if(!St){vt.warn("Cannot execute "+he+" because there is no active text editor.");return}const Tt=await Ze.getDiffInformation(St.id);ye.apply(We,[Tt,...ct])},void 0,void 0,$e)),executeCommand(he,...ye){return mt.executeCommand(he,...ye)},getCommands(he=!1){return mt.getCommands(he)}},yi={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return Zi.value},get shell(){return Ct.getDefaultShell(!1)},get onDidChangeShell(){return at(Ct.onDidChangeShell)},get isTelemetryEnabled(){return Ut.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return at(Ut.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.checkProposedApiEnabled)($e,"telemetry"),Ut.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.checkProposedApiEnabled)($e,"telemetry"),at(Ut.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,st.isNewAppInstall)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(he,ye){return st.ExtHostTelemetryLogger.validateSender(he),Ut.instantiateLogger($e,he,ye)},openExternal(he,ye){return Ot.openUri(he,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:ye?.allowContributedOpeners})},async asExternalUri(he){if(he.scheme===pt.environment.appUriScheme)return bi.createAppUri(he);try{return await Ot.asExternalUri(he,{allowTunneling:!!pt.remote.authority})}catch(ye){if((0,R.matchesScheme)(he,R.Schemas.http)||(0,R.matchesScheme)(he,R.Schemas.https))return he;throw ye}},get remoteName(){return(0,f.getRemoteName)(pt.remote.authority)},get remoteAuthority(){return(0,et.checkProposedApiEnabled)($e,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return vt.getLevel()},get onDidChangeLogLevel(){return at(vt.onDidChangeLogLevel)},get appQuality(){return(0,et.checkProposedApiEnabled)($e,"resolvers"),pt.quality},get appCommit(){return(0,et.checkProposedApiEnabled)($e,"resolvers"),pt.commit}};pt.environment.extensionTestsLocationURI||Object.freeze(yi);const mn={createTestController(he,ye,We){return Ei.createTestController($e,he,ye,We)},createTestObserver(){return(0,et.checkProposedApiEnabled)($e,"testObserver"),Ei.createTestObserver()},runTests(he){return(0,et.checkProposedApiEnabled)($e,"testObserver"),Ei.runTests(he)},get onDidChangeTestResults(){return(0,et.checkProposedApiEnabled)($e,"testObserver"),at(Ei.onResultsChanged)},get testResults(){return(0,et.checkProposedApiEnabled)($e,"testObserver"),Ei.results}},ei=pt.remote.isRemote?Le.ExtensionKind.Workspace:Le.ExtensionKind.UI,Ai={getExtension(he,ye){(0,et.isProposedApiEnabled)($e,"extensionsAny")||(ye=!1);const We=di.mine.getExtensionDescription(he);if(We)return new H.Extension(Ft,$e.identifier,We,ei,!1);if(ye){const ct=di.all.getExtensionDescription(he);if(ct)return new H.Extension(Ft,$e.identifier,ct,ei,!0)}},get all(){const he=[];for(const ye of di.mine.getAllExtensionDescriptions())he.push(new H.Extension(Ft,$e.identifier,ye,ei,!1));return he},get allAcrossExtensionHosts(){(0,et.checkProposedApiEnabled)($e,"extensionsAny");const he=new S.ExtensionIdentifierSet(di.mine.getAllExtensionDescriptions().map(We=>We.identifier)),ye=[];for(const We of di.all.getAllExtensionDescriptions()){const ct=!he.has(We.identifier);ye.push(new H.Extension(Ft,$e.identifier,We,ei,ct))}return ye},get onDidChange(){return(0,et.isProposedApiEnabled)($e,"extensionsAny")?at(L.Event.any(di.mine.onDidChange,di.all.onDidChange)):at(di.mine.onDidChange)}},tn={createDiagnosticCollection(he){return yt.createDiagnosticCollection($e.identifier,he)},get onDidChangeDiagnostics(){return at(yt.onDidChangeDiagnostics)},getDiagnostics:he=>yt.getDiagnostics(he),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(he,ye){return zt.changeLanguage(he.uri,ye)},match(he,ye){const We=je.LanguageSelector.from(he);let ct;return(0,T.targetsNotebooks)(We)&&(ct=Re.notebookDocuments.find(St=>St.apiNotebook.getCells().find(Tt=>Tt.document===ye))?.apiNotebook),(0,T.score)(We,ye.uri,ye.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(he,ye,We){return ut.registerCodeActionProvider($e,Et(he),ye,We)},registerDocumentPasteEditProvider(he,ye,We){return(0,et.checkProposedApiEnabled)($e,"documentPaste"),ut.registerDocumentPasteEditProvider($e,Et(he),ye,We)},registerCodeLensProvider(he,ye){return ut.registerCodeLensProvider($e,Et(he),ye)},registerDefinitionProvider(he,ye){return ut.registerDefinitionProvider($e,Et(he),ye)},registerDeclarationProvider(he,ye){return ut.registerDeclarationProvider($e,Et(he),ye)},registerImplementationProvider(he,ye){return ut.registerImplementationProvider($e,Et(he),ye)},registerTypeDefinitionProvider(he,ye){return ut.registerTypeDefinitionProvider($e,Et(he),ye)},registerHoverProvider(he,ye){return ut.registerHoverProvider($e,Et(he),ye,$e.identifier)},registerEvaluatableExpressionProvider(he,ye){return ut.registerEvaluatableExpressionProvider($e,Et(he),ye,$e.identifier)},registerInlineValuesProvider(he,ye){return ut.registerInlineValuesProvider($e,Et(he),ye,$e.identifier)},registerDocumentHighlightProvider(he,ye){return ut.registerDocumentHighlightProvider($e,Et(he),ye)},registerMultiDocumentHighlightProvider(he,ye){return ut.registerMultiDocumentHighlightProvider($e,Et(he),ye)},registerLinkedEditingRangeProvider(he,ye){return ut.registerLinkedEditingRangeProvider($e,Et(he),ye)},registerReferenceProvider(he,ye){return ut.registerReferenceProvider($e,Et(he),ye)},registerRenameProvider(he,ye){return ut.registerRenameProvider($e,Et(he),ye)},registerNewSymbolNamesProvider(he,ye){return(0,et.checkProposedApiEnabled)($e,"newSymbolNamesProvider"),ut.registerNewSymbolNamesProvider($e,Et(he),ye)},registerDocumentSymbolProvider(he,ye,We){return ut.registerDocumentSymbolProvider($e,Et(he),ye,We)},registerWorkspaceSymbolProvider(he){return ut.registerWorkspaceSymbolProvider($e,he)},registerDocumentFormattingEditProvider(he,ye){return ut.registerDocumentFormattingEditProvider($e,Et(he),ye)},registerDocumentRangeFormattingEditProvider(he,ye){return ut.registerDocumentRangeFormattingEditProvider($e,Et(he),ye)},registerOnTypeFormattingEditProvider(he,ye,We,...ct){return ut.registerOnTypeFormattingEditProvider($e,Et(he),ye,[We].concat(ct))},registerDocumentSemanticTokensProvider(he,ye,We){return ut.registerDocumentSemanticTokensProvider($e,Et(he),ye,We)},registerDocumentRangeSemanticTokensProvider(he,ye,We){return ut.registerDocumentRangeSemanticTokensProvider($e,Et(he),ye,We)},registerSignatureHelpProvider(he,ye,We,...ct){return typeof We=="object"?ut.registerSignatureHelpProvider($e,Et(he),ye,We):ut.registerSignatureHelpProvider($e,Et(he),ye,typeof We>"u"?[]:[We,...ct])},registerCompletionItemProvider(he,ye,...We){return ut.registerCompletionItemProvider($e,Et(he),ye,We)},registerInlineCompletionItemProvider(he,ye,We){return ye.handleDidShowCompletionItem&&(0,et.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),ye.handleDidPartiallyAcceptCompletionItem&&(0,et.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),We&&(0,et.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider($e,Et(he),ye,We)},registerInlineEditProvider(he,ye){return(0,et.checkProposedApiEnabled)($e,"inlineEdit"),ut.registerInlineEditProvider($e,Et(he),ye)},registerDocumentLinkProvider(he,ye){return ut.registerDocumentLinkProvider($e,Et(he),ye)},registerColorProvider(he,ye){return ut.registerColorProvider($e,Et(he),ye)},registerFoldingRangeProvider(he,ye){return ut.registerFoldingRangeProvider($e,Et(he),ye)},registerSelectionRangeProvider(he,ye){return ut.registerSelectionRangeProvider($e,he,ye)},registerCallHierarchyProvider(he,ye){return ut.registerCallHierarchyProvider($e,he,ye)},registerTypeHierarchyProvider(he,ye){return ut.registerTypeHierarchyProvider($e,he,ye)},setLanguageConfiguration:(he,ye)=>ut.setLanguageConfiguration($e,he,ye),getTokenInformationAtPosition(he,ye){return(0,et.checkProposedApiEnabled)($e,"tokenInformation"),zt.tokenAtPosition(he,ye)},registerInlayHintsProvider(he,ye){return ut.registerInlayHintsProvider($e,he,ye)},createLanguageStatusItem(he,ye){return zt.createLanguageStatusItem($e,he,ye)},registerDocumentDropEditProvider(he,ye,We){return ut.registerDocumentOnDropEditProvider($e,he,ye,(0,et.isProposedApiEnabled)($e,"documentPaste")?We:void 0)}},nn={get activeTextEditor(){return Ze.getActiveTextEditor()},get visibleTextEditors(){return Ze.getVisibleTextEditors()},get activeTerminal(){return Ct.activeTerminal},get terminals(){return Ct.terminals},async showTextDocument(he,ye,We){m.URI.isUri(he)&&he.scheme===R.Schemas.vscodeRemote&&!he.authority&&Rt.report("workspace.showTextDocument",$e,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await(m.URI.isUri(he)?Promise.resolve(Ui.openTextDocument(he)):Promise.resolve(he));return Ze.showTextDocument(ct,ye,We)},createTextEditorDecorationType(he){return Ze.createTextEditorDecorationType($e,he)},onDidChangeActiveTextEditor(he,ye,We){return at(Ze.onDidChangeActiveTextEditor)(he,ye,We)},onDidChangeVisibleTextEditors(he,ye,We){return at(Ze.onDidChangeVisibleTextEditors)(he,ye,We)},onDidChangeTextEditorSelection(he,ye,We){return at(Ze.onDidChangeTextEditorSelection)(he,ye,We)},onDidChangeTextEditorOptions(he,ye,We){return at(Ze.onDidChangeTextEditorOptions)(he,ye,We)},onDidChangeTextEditorVisibleRanges(he,ye,We){return at(Ze.onDidChangeTextEditorVisibleRanges)(he,ye,We)},onDidChangeTextEditorViewColumn(he,ye,We){return at(Ze.onDidChangeTextEditorViewColumn)(he,ye,We)},onDidCloseTerminal(he,ye,We){return at(Ct.onDidCloseTerminal)(he,ye,We)},onDidOpenTerminal(he,ye,We){return at(Ct.onDidOpenTerminal)(he,ye,We)},onDidChangeActiveTerminal(he,ye,We){return at(Ct.onDidChangeActiveTerminal)(he,ye,We)},onDidChangeTerminalDimensions(he,ye,We){return(0,et.checkProposedApiEnabled)($e,"terminalDimensions"),at(Ct.onDidChangeTerminalDimensions)(he,ye,We)},onDidChangeTerminalState(he,ye,We){return at(Ct.onDidChangeTerminalState)(he,ye,We)},onDidWriteTerminalData(he,ye,We){return(0,et.checkProposedApiEnabled)($e,"terminalDataWriteEvent"),at(Ct.onDidWriteTerminalData)(he,ye,We)},onDidExecuteTerminalCommand(he,ye,We){return(0,et.checkProposedApiEnabled)($e,"terminalExecuteCommandEvent"),at(Ct.onDidExecuteTerminalCommand)(he,ye,We)},onDidChangeTerminalShellIntegration(he,ye,We){return(0,et.checkProposedApiEnabled)($e,"terminalShellIntegration"),at(ai.onDidChangeTerminalShellIntegration)(he,ye,We)},onDidStartTerminalShellExecution(he,ye,We){return(0,et.checkProposedApiEnabled)($e,"terminalShellIntegration"),at(ai.onDidStartTerminalShellExecution)(he,ye,We)},onDidEndTerminalShellExecution(he,ye,We){return(0,et.checkProposedApiEnabled)($e,"terminalShellIntegration"),at(ai.onDidEndTerminalShellExecution)(he,ye,We)},get state(){return Ot.getState()},onDidChangeWindowState(he,ye,We){return at(Ot.onDidChangeWindowState)(he,ye,We)},showInformationMessage(he,...ye){return Wi.showMessage($e,b.default.Info,he,ye[0],ye.slice(1))},showWarningMessage(he,...ye){return Wi.showMessage($e,b.default.Warning,he,ye[0],ye.slice(1))},showErrorMessage(he,...ye){return Wi.showMessage($e,b.default.Error,he,ye[0],ye.slice(1))},showQuickPick(he,ye,We){return Si.showQuickPick($e,he,ye,We)},showWorkspaceFolderPick(he){return Si.showWorkspaceFolderPick(he)},showInputBox(he,ye){return Si.showInput(he,ye)},showOpenDialog(he){return Ti.showOpenDialog($e,he)},showSaveDialog(he){return Ti.showSaveDialog(he)},createStatusBarItem(he,ye,We){let ct,St,Tt;return typeof he=="string"?(ct=he,St=ye,Tt=We):(St=he,Tt=ye),ki.createStatusBarEntry($e,ct,St,Tt)},setStatusBarMessage(he,ye){return ki.setStatusBarMessage(he,ye)},withScmProgress(he){return Rt.report("window.withScmProgress",$e,"Use 'withProgress' instead."),Di.withProgress($e,{location:Le.ProgressLocation.SourceControl},(ye,We)=>he({report(ct){}}))},withProgress(he,ye){return Di.withProgress($e,he,ye)},createOutputChannel(he,ye){return pi.createOutputChannel(he,ye,$e)},createWebviewPanel(he,ye,We,ct){return Ii.createWebviewPanel($e,he,ye,We,ct)},createWebviewTextEditorInset(he,ye,We,ct){return(0,et.checkProposedApiEnabled)($e,"editorInsets"),dt.createWebviewEditorInset(he,ye,We,ct,$e)},createTerminal(he,ye,We){return typeof he=="object"?"pty"in he?Ct.createExtensionTerminal(he):Ct.createTerminalFromOptions(he):Ct.createTerminal(he,ye,We)},registerTerminalLinkProvider(he){return Ct.registerLinkProvider(he)},registerTerminalProfileProvider(he,ye){return Ct.registerProfileProvider($e,he,ye)},registerTerminalQuickFixProvider(he,ye){return(0,et.checkProposedApiEnabled)($e,"terminalQuickFixProvider"),Ct.registerTerminalQuickFixProvider(he,$e.identifier.value,ye)},registerTreeDataProvider(he,ye){return Xe.registerTreeDataProvider(he,ye,$e)},createTreeView(he,ye){return Xe.createTreeView(he,ye,$e)},registerWebviewPanelSerializer:(he,ye)=>Ii.registerWebviewPanelSerializer($e,he,ye),registerCustomEditorProvider:(he,ye,We={})=>xi.registerCustomEditorProvider($e,he,ye,We),registerFileDecorationProvider(he){return Lt.registerFileDecorationProvider(he,$e)},registerUriHandler(he){return bi.registerUriHandler($e,he)},createQuickPick(){return Si.createQuickPick($e)},createInputBox(){return Si.createInputBox($e)},get activeColorTheme(){return Mi.activeColorTheme},onDidChangeActiveColorTheme(he,ye,We){return at(Mi.onDidChangeActiveColorTheme)(he,ye,We)},registerWebviewViewProvider(he,ye,We){return zi.registerWebviewViewProvider($e,he,ye,We?.webviewOptions)},get activeNotebookEditor(){return Re.activeNotebookEditor},onDidChangeActiveNotebookEditor(he,ye,We){return at(Re.onDidChangeActiveNotebookEditor)(he,ye,We)},get visibleNotebookEditors(){return Re.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return at(Re.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(he,ye,We){return at(Se.onDidChangeNotebookEditorSelection)(he,ye,We)},onDidChangeNotebookEditorVisibleRanges(he,ye,We){return at(Se.onDidChangeNotebookEditorVisibleRanges)(he,ye,We)},showNotebookDocument(he,ye){return Re.showNotebookDocument(he,ye)},registerExternalUriOpener(he,ye,We){return(0,et.checkProposedApiEnabled)($e,"externalUriOpener"),Ki.registerExternalUriOpener($e.identifier,he,ye,We)},registerProfileContentHandler(he,ye){return(0,et.checkProposedApiEnabled)($e,"profileContentHandlers"),Xi.registerProfileContentHandler($e,he,ye)},registerQuickDiffProvider(he,ye,We,ct){return(0,et.checkProposedApiEnabled)($e,"quickDiffProvider"),ji.registerQuickDiffProvider(Et(he),ye,We,ct)},get tabGroups(){return Vt.tabGroups},registerShareProvider(he,ye){return(0,et.checkProposedApiEnabled)($e,"shareProvider"),Li.registerShareProvider(Et(he),ye)}},Ui={get rootPath(){return Rt.report("workspace.rootPath",$e,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(he){throw new O.ReadonlyError("rootPath")},getWorkspaceFolder(he){return gt.getWorkspaceFolder(he)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(he){throw new O.ReadonlyError("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(he){throw new O.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(he,ye,...We)=>gt.updateWorkspaceFolders($e,he,ye||0,...We),onDidChangeWorkspaceFolders:function(he,ye,We){return at(gt.onDidChangeWorkspace)(he,ye,We)},asRelativePath:(he,ye)=>gt.getRelativePath(he,ye),findFiles:(he,ye,We,ct)=>gt.findFiles(he,ye,We,$e.identifier,ct),findFiles2:(he,ye,We)=>((0,et.checkProposedApiEnabled)($e,"findFiles2"),gt.findFiles2(he,ye,$e.identifier,We)),findTextInFiles:(he,ye,We,ct)=>{(0,et.checkProposedApiEnabled)($e,"findTextInFiles");let St,Tt;return typeof ye=="object"?(St=ye,Tt=We):(St={},Tt=ye,ct=We),gt.findTextInFiles(he,St||{},Tt,$e.identifier,ct)},save:he=>gt.save(he),saveAs:he=>gt.saveAs(he),saveAll:he=>gt.saveAll(he),applyEdit(he,ye){return gn.applyWorkspaceEdit(he,$e,ye)},createFileSystemWatcher:(he,ye,We,ct)=>{let St;return typeof ye=="boolean"?St={ignoreCreateEvents:!!ye,ignoreChangeEvents:!!We,ignoreDeleteEvents:!!ct,correlate:!1}:ye&&((0,et.checkProposedApiEnabled)($e,"createFileSystemWatcher"),St={...ye,correlate:!0}),Bt.createFileSystemWatcher(gt,$e,he,St)},get textDocuments(){return It.getAllDocumentData().map(he=>he.document)},set textDocuments(he){throw new O.ReadonlyError("textDocuments")},openTextDocument(he){let ye;const We=he;if(typeof he=="string")ye=Promise.resolve(m.URI.file(he));else if(m.URI.isUri(he))ye=Promise.resolve(he);else if(!We||typeof We=="object")ye=It.createDocumentData(We);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ye.then(ct=>(ct.scheme===R.Schemas.vscodeRemote&&!ct.authority&&Rt.report("workspace.openTextDocument",$e,"A URI of 'vscode-remote' scheme requires an authority."),It.ensureDocumentData(ct).then(St=>St.document)))},onDidOpenTextDocument:(he,ye,We)=>at(It.onDidAddDocument)(he,ye,We),onDidCloseTextDocument:(he,ye,We)=>at(It.onDidRemoveDocument)(he,ye,We),onDidChangeTextDocument:(he,ye,We)=>at(It.onDidChangeDocument)(he,ye,We),onDidSaveTextDocument:(he,ye,We)=>at(It.onDidSaveDocument)(he,ye,We),onWillSaveTextDocument:(he,ye,We)=>at(si.getOnWillSaveTextDocumentEvent($e))(he,ye,We),get notebookDocuments(){return Re.notebookDocuments.map(he=>he.apiNotebook)},async openNotebookDocument(he,ye){let We;if(m.URI.isUri(he))We=he,await Re.openNotebookDocument(he);else if(typeof he=="string")We=m.URI.revive(await Re.createNotebookDocument({viewType:he,content:ye}));else throw new Error("Invalid arguments");return Re.getNotebookDocument(We).apiNotebook},onDidSaveNotebookDocument(he,ye,We){return at(xe.onDidSaveNotebookDocument)(he,ye,We)},onDidChangeNotebookDocument(he,ye,We){return at(xe.onDidChangeNotebookDocument)(he,ye,We)},onWillSaveNotebookDocument(he,ye,We){return at(Ve.getOnWillSaveNotebookDocumentEvent($e))(he,ye,We)},get onDidOpenNotebookDocument(){return at(Re.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return at(Re.onDidCloseNotebookDocument)},registerNotebookSerializer(he,ye,We,ct){return Re.registerNotebookSerializer($e,he,ye,We,(0,et.isProposedApiEnabled)($e,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(he,ye,We)=>at($i.onDidChangeConfiguration)(he,ye,We),getConfiguration(he,ye){return ye=arguments.length===1?void 0:ye,$i.getConfiguration(he,ye,$e)},registerTextDocumentContentProvider(he,ye){return wi.registerTextDocumentContentProvider(he,ye)},registerTaskProvider:(he,ye)=>(Rt.report("window.registerTaskProvider",$e,"Use the corresponding function on the 'tasks' namespace instead"),ri.registerTaskProvider($e,he,ye)),registerFileSystemProvider(he,ye,We){return(0,A.combinedDisposable)(Mt.registerFileSystemProvider($e,he,ye,We),Gt.addFileSystemProvider(he,ye,We))},get fs(){return Gt.value},registerFileSearchProvider:(he,ye)=>((0,et.checkProposedApiEnabled)($e,"fileSearchProvider"),fi.registerFileSearchProvider(he,ye)),registerTextSearchProvider:(he,ye)=>((0,et.checkProposedApiEnabled)($e,"textSearchProvider"),fi.registerTextSearchProvider(he,ye)),registerAITextSearchProvider:(he,ye)=>((0,et.checkProposedApiEnabled)($e,"aiTextSearchProvider"),(0,et.checkProposedApiEnabled)($e,"textSearchProvider"),fi.registerAITextSearchProvider(he,ye)),registerRemoteAuthorityResolver:(he,ye)=>((0,et.checkProposedApiEnabled)($e,"resolvers"),Ft.registerRemoteAuthorityResolver(he,ye)),registerResourceLabelFormatter:he=>((0,et.checkProposedApiEnabled)($e,"resolvers"),Ni.$registerResourceLabelFormatter(he)),getRemoteExecServer:he=>((0,et.checkProposedApiEnabled)($e,"resolvers"),Ft.getRemoteExecServer(he)),onDidCreateFiles:(he,ye,We)=>at(Bt.onDidCreateFile)(he,ye,We),onDidDeleteFiles:(he,ye,We)=>at(Bt.onDidDeleteFile)(he,ye,We),onDidRenameFiles:(he,ye,We)=>at(Bt.onDidRenameFile)(he,ye,We),onWillCreateFiles:(he,ye,We)=>at(Bt.getOnWillCreateFileEvent($e))(he,ye,We),onWillDeleteFiles:(he,ye,We)=>at(Bt.getOnWillDeleteFileEvent($e))(he,ye,We),onWillRenameFiles:(he,ye,We)=>at(Bt.getOnWillRenameFileEvent($e))(he,ye,We),openTunnel:he=>((0,et.checkProposedApiEnabled)($e,"tunnels"),xt.openTunnel($e,he).then(ye=>{if(!ye)throw new Error("cannot open tunnel");return ye})),get tunnels(){return(0,et.checkProposedApiEnabled)($e,"tunnels"),xt.getTunnels()},onDidChangeTunnels:(he,ye,We)=>((0,et.checkProposedApiEnabled)($e,"tunnels"),at(xt.onDidChangeTunnels)(he,ye,We)),registerPortAttributesProvider:(he,ye)=>((0,et.checkProposedApiEnabled)($e,"portsAttributes"),xt.registerPortsAttributesProvider(he,ye)),registerTunnelProvider:(he,ye)=>((0,et.checkProposedApiEnabled)($e,"tunnelFactory"),xt.registerTunnelProvider(he,ye)),registerTimelineProvider:(he,ye)=>((0,et.checkProposedApiEnabled)($e,"timeline"),Gi.registerTimelineProvider(he,ye,$e.identifier,mt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:he=>((0,et.checkProposedApiEnabled)($e,"workspaceTrust"),gt.requestWorkspaceTrust(he)),onDidGrantWorkspaceTrust:(he,ye,We)=>at(gt.onDidGrantWorkspaceTrust)(he,ye,We),registerEditSessionIdentityProvider:(he,ye)=>((0,et.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(he,ye)),onWillCreateEditSessionIdentity:(he,ye,We)=>((0,et.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),at(gt.getOnWillCreateEditSessionIdentityEvent($e))(he,ye,We)),registerCanonicalUriProvider:(he,ye)=>((0,et.checkProposedApiEnabled)($e,"canonicalUriProvider"),gt.registerCanonicalUriProvider(he,ye)),getCanonicalUri:(he,ye,We)=>((0,et.checkProposedApiEnabled)($e,"canonicalUriProvider"),gt.provideCanonicalUri(he,ye,We))},rn={get inputBox(){return Rt.report("scm.inputBox",$e,"Use 'SourceControl.inputBox' instead"),Ci.getLastInputBox($e)},createSourceControl(he,ye,We){return Ci.createSourceControl($e,he,ye,We)}},pn={createCommentController(he,ye){return Oi.createCommentController($e,he,ye)}},sn={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){if((0,et.isProposedApiEnabled)($e,"debugFocus"))return Dt.activeStackItem},registerDebugVisualizationProvider(he,ye){return(0,et.checkProposedApiEnabled)($e,"debugVisualization"),Dt.registerDebugVisualizationProvider($e,he,ye)},registerDebugVisualizationTreeProvider(he,ye){return(0,et.checkProposedApiEnabled)($e,"debugVisualization"),Dt.registerDebugVisualizationTree($e,he,ye)},onDidStartDebugSession(he,ye,We){return at(Dt.onDidStartDebugSession)(he,ye,We)},onDidTerminateDebugSession(he,ye,We){return at(Dt.onDidTerminateDebugSession)(he,ye,We)},onDidChangeActiveDebugSession(he,ye,We){return at(Dt.onDidChangeActiveDebugSession)(he,ye,We)},onDidReceiveDebugSessionCustomEvent(he,ye,We){return at(Dt.onDidReceiveDebugSessionCustomEvent)(he,ye,We)},onDidChangeBreakpoints(he,ye,We){return at(Dt.onDidChangeBreakpoints)(he,ye,We)},onDidChangeActiveStackItem(he,ye,We){return(0,et.checkProposedApiEnabled)($e,"debugFocus"),at(Dt.onDidChangeActiveStackItem)(he,ye,We)},registerDebugConfigurationProvider(he,ye,We){return Dt.registerDebugConfigurationProvider(he,ye,We||Qt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(he,ye){return Dt.registerDebugAdapterDescriptorFactory($e,he,ye)},registerDebugAdapterTrackerFactory(he,ye){return Dt.registerDebugAdapterTrackerFactory(he,ye)},startDebugging(he,ye,We){return!We||typeof We=="object"&&"configuration"in We?Dt.startDebugging(he,ye,{parentSession:We}):Dt.startDebugging(he,ye,We||{})},stopDebugging(he){return Dt.stopDebugging(he)},addBreakpoints(he){return Dt.addBreakpoints(he)},removeBreakpoints(he){return Dt.removeBreakpoints(he)},asDebugSourceUri(he,ye){return Dt.asDebugSourceUri(he,ye)}},on={registerTaskProvider:(he,ye)=>ri.registerTaskProvider($e,he,ye),fetchTasks:he=>ri.fetchTasks(he),executeTask:he=>ri.executeTask($e,he),get taskExecutions(){return ri.taskExecutions},onDidStartTask:(he,ye,We)=>at(ri.onDidStartTask)(he,ye,We),onDidEndTask:(he,ye,We)=>at(ri.onDidEndTask)(he,ye,We),onDidStartTaskProcess:(he,ye,We)=>at(ri.onDidStartTaskProcess)(he,ye,We),onDidEndTaskProcess:(he,ye,We)=>at(ri.onDidEndTaskProcess)(he,ye,We)},vn={createNotebookController(he,ye,We,ct,St){return J.createNotebookController($e,he,ye,We,ct,(0,et.isProposedApiEnabled)($e,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(he,ye)=>Re.registerNotebookCellStatusBarItemProvider($e,he,ye),createRendererMessaging(he){return Me.createRendererMessaging($e,he)},createNotebookControllerDetectionTask(he){return(0,et.checkProposedApiEnabled)($e,"notebookKernelSource"),J.createNotebookControllerDetectionTask($e,he)},registerKernelSourceActionProvider(he,ye){return(0,et.checkProposedApiEnabled)($e,"notebookKernelSource"),J.registerKernelSourceActionProvider($e,he,ye)},onDidChangeNotebookCellExecutionState(he,ye,We){return(0,et.checkProposedApiEnabled)($e,"notebookCellExecutionState"),at(J.onDidChangeNotebookCellExecutionState)(he,ye,We)}},bn={t(...he){if(typeof he[0]=="string"){const ye=he.shift(),We=!he||typeof he[0]!="object"?he:he[0];return ui.getMessage($e.identifier.value,{message:ye,args:We})}return ui.getMessage($e.identifier.value,he[0])},get bundle(){return ui.getBundle($e.identifier.value)},get uri(){return ui.getBundleUri($e.identifier.value)}},an={_version:1,registerInteractiveEditorSessionProvider(he,ye){return(0,et.checkProposedApiEnabled)($e,"interactive"),Qi.registerProvider($e,he,ye)},transferActiveChat(he){return(0,et.checkProposedApiEnabled)($e,"interactive"),Pi.transferActiveChat(he)}},Hi={getRelatedInformation(he,ye){return(0,et.checkProposedApiEnabled)($e,"aiRelatedInformation"),Ji.getRelatedInformation($e,he,ye)},registerRelatedInformationProvider(he,ye){return(0,et.checkProposedApiEnabled)($e,"aiRelatedInformation"),Ji.registerRelatedInformationProvider($e,he,ye)},registerEmbeddingVectorProvider(he,ye){return(0,et.checkProposedApiEnabled)($e,"aiRelatedInformation"),hn.registerEmbeddingVectorProvider($e,he,ye)}},cn={registerChatResponseProvider(he,ye,We){return(0,et.checkProposedApiEnabled)($e,"chatProvider"),Nt.registerLanguageModel($e,he,ye,We)},registerChatVariableResolver(he,ye,We){return(0,et.checkProposedApiEnabled)($e,"chatVariableResolver"),Yi.registerVariableResolver($e,he,ye,We)},registerMappedEditsProvider(he,ye){return(0,et.checkProposedApiEnabled)($e,"mappedEditsProvider"),ut.registerMappedEditsProvider($e,he,ye)},createChatParticipant(he,ye){return(0,et.checkProposedApiEnabled)($e,"chatParticipant"),Pi.createChatAgent($e,he,ye)},createDynamicChatParticipant(he,ye,We,ct){return(0,et.checkProposedApiEnabled)($e,"chatParticipantAdditions"),Pi.createDynamicChatAgent($e,he,ye,We,ct)}},ln={get languageModels(){return(0,et.checkProposedApiEnabled)($e,"languageModels"),Nt.getLanguageModelIds()},onDidChangeLanguageModels:(he,ye,We)=>((0,et.checkProposedApiEnabled)($e,"languageModels"),Nt.onDidChangeProviders(he,ye,We)),sendChatRequest(he,ye,We,ct){return(0,et.checkProposedApiEnabled)($e,"languageModels"),Nt.sendChatRequest($e,he,ye,We,ct)},computeTokenLength(he,ye,We){return(0,et.checkProposedApiEnabled)($e,"languageModels"),We??=h.CancellationToken.None,Nt.computeTokenLength(he,ye,We)},getLanguageModelInformation(he){return(0,et.checkProposedApiEnabled)($e,"languageModels"),Nt.getLanguageModelInfo(he)}},un={registerSpeechProvider(he,ye){return(0,et.checkProposedApiEnabled)($e,"speech"),Bi.registerProvider($e.identifier,he,ye)}};return{version:pt.version,ai:Hi,authentication:en,commands:gi,comments:pn,chat:cn,debug:sn,env:yi,extensions:Ai,interactive:an,l10n:bn,languages:tn,lm:ln,notebooks:vn,scm:rn,speech:un,tasks:on,tests:mn,window:nn,workspace:Ui,Breakpoint:Le.Breakpoint,TerminalOutputAnchor:Le.TerminalOutputAnchor,ChatResultFeedbackKind:Le.ChatResultFeedbackKind,ChatVariableLevel:Le.ChatVariableLevel,ChatCompletionItem:Le.ChatCompletionItem,CallHierarchyIncomingCall:Le.CallHierarchyIncomingCall,CallHierarchyItem:Le.CallHierarchyItem,CallHierarchyOutgoingCall:Le.CallHierarchyOutgoingCall,CancellationError:O.CancellationError,CancellationTokenSource:h.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:Le.CodeAction,CodeActionKind:Le.CodeActionKind,CodeActionTriggerKind:Le.CodeActionTriggerKind,CodeLens:Le.CodeLens,Color:Le.Color,ColorInformation:Le.ColorInformation,ColorPresentation:Le.ColorPresentation,ColorThemeKind:Le.ColorThemeKind,CommentMode:Le.CommentMode,CommentState:Le.CommentState,CommentThreadCollapsibleState:Le.CommentThreadCollapsibleState,CommentThreadState:Le.CommentThreadState,CommentThreadApplicability:Le.CommentThreadApplicability,CompletionItem:Le.CompletionItem,CompletionItemKind:Le.CompletionItemKind,CompletionItemTag:Le.CompletionItemTag,CompletionList:Le.CompletionList,CompletionTriggerKind:Le.CompletionTriggerKind,ConfigurationTarget:Le.ConfigurationTarget,CustomExecution:Le.CustomExecution,DebugAdapterExecutable:Le.DebugAdapterExecutable,DebugAdapterInlineImplementation:Le.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:Le.DebugAdapterNamedPipeServer,DebugAdapterServer:Le.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Qt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Le.DebugConsoleMode,DebugVisualization:Le.DebugVisualization,DecorationRangeBehavior:Le.DecorationRangeBehavior,Diagnostic:Le.Diagnostic,DiagnosticRelatedInformation:Le.DiagnosticRelatedInformation,DiagnosticSeverity:Le.DiagnosticSeverity,DiagnosticTag:Le.DiagnosticTag,Disposable:Le.Disposable,DocumentHighlight:Le.DocumentHighlight,DocumentHighlightKind:Le.DocumentHighlightKind,MultiDocumentHighlight:Le.MultiDocumentHighlight,DocumentLink:Le.DocumentLink,DocumentSymbol:Le.DocumentSymbol,EndOfLine:Le.EndOfLine,EnvironmentVariableMutatorType:Le.EnvironmentVariableMutatorType,EvaluatableExpression:Le.EvaluatableExpression,InlineValueText:Le.InlineValueText,InlineValueVariableLookup:Le.InlineValueVariableLookup,InlineValueEvaluatableExpression:Le.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:Le.InlineCompletionTriggerKind,EventEmitter:L.Emitter,ExtensionKind:Le.ExtensionKind,ExtensionMode:Le.ExtensionMode,ExternalUriOpenerPriority:Le.ExternalUriOpenerPriority,FileChangeType:Le.FileChangeType,FileDecoration:Le.FileDecoration,FileDecoration2:Le.FileDecoration,FileSystemError:Le.FileSystemError,FileType:E.FileType,FilePermission:E.FilePermission,FoldingRange:Le.FoldingRange,FoldingRangeKind:Le.FoldingRangeKind,FunctionBreakpoint:Le.FunctionBreakpoint,InlineCompletionItem:Le.InlineSuggestion,InlineCompletionList:Le.InlineSuggestionList,Hover:Le.Hover,VerboseHover:Le.VerboseHover,HoverVerbosityAction:Le.HoverVerbosityAction,IndentAction:I.IndentAction,Location:Le.Location,MarkdownString:Le.MarkdownString,OverviewRulerLane:p.OverviewRulerLane,ParameterInformation:Le.ParameterInformation,PortAutoForwardAction:Le.PortAutoForwardAction,Position:Le.Position,ProcessExecution:Le.ProcessExecution,ProgressLocation:Le.ProgressLocation,QuickInputButtons:Le.QuickInputButtons,Range:Le.Range,RelativePattern:Le.RelativePattern,Selection:Le.Selection,SelectionRange:Le.SelectionRange,SemanticTokens:Le.SemanticTokens,SemanticTokensBuilder:Le.SemanticTokensBuilder,SemanticTokensEdit:Le.SemanticTokensEdit,SemanticTokensEdits:Le.SemanticTokensEdits,SemanticTokensLegend:Le.SemanticTokensLegend,ShellExecution:Le.ShellExecution,ShellQuoting:Le.ShellQuoting,SignatureHelp:Le.SignatureHelp,SignatureHelpTriggerKind:Le.SignatureHelpTriggerKind,SignatureInformation:Le.SignatureInformation,SnippetString:Le.SnippetString,SourceBreakpoint:Le.SourceBreakpoint,StandardTokenType:Le.StandardTokenType,StatusBarAlignment:Le.StatusBarAlignment,SymbolInformation:Le.SymbolInformation,SymbolKind:Le.SymbolKind,SymbolTag:Le.SymbolTag,Task:Le.Task,TaskGroup:Le.TaskGroup,TaskPanelKind:Le.TaskPanelKind,TaskRevealKind:Le.TaskRevealKind,TaskScope:Le.TaskScope,TerminalLink:Le.TerminalLink,TerminalQuickFixTerminalCommand:Le.TerminalQuickFixCommand,TerminalQuickFixOpener:Le.TerminalQuickFixOpener,TerminalLocation:Le.TerminalLocation,TerminalProfile:Le.TerminalProfile,TerminalExitReason:Le.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Le.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Le.TextDocumentSaveReason,TextEdit:Le.TextEdit,SnippetTextEdit:Le.SnippetTextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:Le.TextEditorLineNumbersStyle,TextEditorRevealType:Le.TextEditorRevealType,TextEditorSelectionChangeKind:Le.TextEditorSelectionChangeKind,SyntaxTokenType:Le.SyntaxTokenType,TextDocumentChangeReason:Le.TextDocumentChangeReason,ThemeColor:Le.ThemeColor,ThemeIcon:Le.ThemeIcon,TreeItem:Le.TreeItem,TreeItemCheckboxState:Le.TreeItemCheckboxState,TreeItemCollapsibleState:Le.TreeItemCollapsibleState,TypeHierarchyItem:Le.TypeHierarchyItem,UIKind:Yt.UIKind,Uri:m.URI,ViewColumn:Le.ViewColumn,WorkspaceEdit:Le.WorkspaceEdit,DocumentPasteTriggerKind:Le.DocumentPasteTriggerKind,DocumentDropEdit:Le.DocumentDropEdit,DocumentDropOrPasteEditKind:Le.DocumentDropOrPasteEditKind,DocumentPasteEdit:Le.DocumentPasteEdit,InlayHint:Le.InlayHint,InlayHintLabelPart:Le.InlayHintLabelPart,InlayHintKind:Le.InlayHintKind,RemoteAuthorityResolverError:Le.RemoteAuthorityResolverError,ResolvedAuthority:Le.ResolvedAuthority,ManagedResolvedAuthority:Le.ManagedResolvedAuthority,SourceControlInputBoxValidationType:Le.SourceControlInputBoxValidationType,ExtensionRuntime:Le.ExtensionRuntime,TimelineItem:Le.TimelineItem,NotebookRange:Le.NotebookRange,NotebookCellKind:Le.NotebookCellKind,NotebookCellExecutionState:Le.NotebookCellExecutionState,NotebookCellData:Le.NotebookCellData,NotebookData:Le.NotebookData,NotebookRendererScript:Le.NotebookRendererScript,NotebookCellStatusBarAlignment:Le.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Le.NotebookEditorRevealType,NotebookCellOutput:Le.NotebookCellOutput,NotebookCellOutputItem:Le.NotebookCellOutputItem,NotebookCellStatusBarItem:Le.NotebookCellStatusBarItem,NotebookControllerAffinity:Le.NotebookControllerAffinity,NotebookControllerAffinity2:Le.NotebookControllerAffinity2,NotebookEdit:Le.NotebookEdit,NotebookKernelSourceAction:Le.NotebookKernelSourceAction,NotebookVariablesRequestKind:Le.NotebookVariablesRequestKind,PortAttributes:Le.PortAttributes,LinkedEditingRanges:Le.LinkedEditingRanges,TestResultState:Le.TestResultState,TestRunRequest:Le.TestRunRequest,TestRunRequest2:Le.TestRunRequest,TestMessage:Le.TestMessage,TestTag:Le.TestTag,TestRunProfileKind:Le.TestRunProfileKind,TextSearchCompleteMessageType:oi.TextSearchCompleteMessageType,DataTransfer:Le.DataTransfer,DataTransferItem:Le.DataTransferItem,TestCoverageCount:Le.TestCoverageCount,FileCoverage:Le.FileCoverage,StatementCoverage:Le.StatementCoverage,BranchCoverage:Le.BranchCoverage,DeclarationCoverage:Le.DeclarationCoverage,WorkspaceTrustState:Le.WorkspaceTrustState,LanguageStatusSeverity:Le.LanguageStatusSeverity,QuickPickItemKind:Le.QuickPickItemKind,InputBoxValidationSeverity:Le.InputBoxValidationSeverity,TabInputText:Le.TextTabInput,TabInputTextDiff:Le.TextDiffTabInput,TabInputTextMerge:Le.TextMergeTabInput,TabInputCustom:Le.CustomEditorTabInput,TabInputNotebook:Le.NotebookEditorTabInput,TabInputNotebookDiff:Le.NotebookDiffEditorTabInput,TabInputWebview:Le.WebviewEditorTabInput,TabInputTerminal:Le.TerminalEditorTabInput,TabInputInteractiveWindow:Le.InteractiveWindowInput,TabInputChat:Le.ChatEditorTabInput,TabInputTextMultiDiff:Le.TextMultiDiffTabInput,TelemetryTrustedValue:a.TelemetryTrustedValue,LogLevel:d.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Le.InteractiveSessionVoteDirection,ChatCopyKind:Le.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Le.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Le.DebugStackFrame,DebugThread:Le.DebugThread,RelatedInformationType:Le.RelatedInformationType,SpeechToTextStatus:Le.SpeechToTextStatus,PartialAcceptTriggerKind:Le.PartialAcceptTriggerKind,KeywordRecognitionStatus:Le.KeywordRecognitionStatus,ChatResponseMarkdownPart:Le.ChatResponseMarkdownPart,ChatResponseFileTreePart:Le.ChatResponseFileTreePart,ChatResponseAnchorPart:Le.ChatResponseAnchorPart,ChatResponseProgressPart:Le.ChatResponseProgressPart,ChatResponseReferencePart:Le.ChatResponseReferencePart,ChatResponseTextEditPart:Le.ChatResponseTextEditPart,ChatResponseMarkdownWithVulnerabilitiesPart:Le.ChatResponseMarkdownWithVulnerabilitiesPart,ChatResponseCommandButtonPart:Le.ChatResponseCommandButtonPart,ChatResponseDetectedParticipantPart:Le.ChatResponseDetectedParticipantPart,ChatRequestTurn:Le.ChatRequestTurn,ChatResponseTurn:Le.ChatResponseTurn,ChatLocation:Le.ChatLocation,LanguageModelChatSystemMessage:Le.LanguageModelChatSystemMessage,LanguageModelChatUserMessage:Le.LanguageModelChatUserMessage,LanguageModelChatAssistantMessage:Le.LanguageModelChatAssistantMessage,LanguageModelSystemMessage:Le.LanguageModelChatSystemMessage,LanguageModelUserMessage:Le.LanguageModelChatUserMessage,LanguageModelAssistantMessage:Le.LanguageModelChatAssistantMessage,LanguageModelError:Le.LanguageModelError,NewSymbolName:Le.NewSymbolName,NewSymbolNameTag:Le.NewSymbolNameTag,NewSymbolNameTriggerKind:Le.NewSymbolNameTriggerKind,InlineEdit:Le.InlineEdit,InlineEditTriggerKind:Le.InlineEditTriggerKind}}}}),define(_e[385],Ce([1,0,85,158,44,152,45,34,73,43,95,96,97,119,71,91,151,70,60,118,90,72,150,11,61,116,117,121,122,156]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i,n,l,o,t,u,r,c,s,w,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,1),(0,h.registerSingleton)(u.ILoggerService,t.ExtHostLoggerService,1),(0,h.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService,1),(0,h.registerSingleton)(b.IExtHostCommands,b.ExtHostCommands,0),(0,h.registerSingleton)(w.IExtHostAuthentication,w.ExtHostAuthentication,0),(0,h.registerSingleton)(g.IExtHostLanguageModels,g.ExtHostLanguageModels,0),(0,h.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration,0),(0,h.registerSingleton)(a.IExtHostConsumerFileSystem,a.ExtHostConsumerFileSystem,0),(0,h.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService,0),(0,h.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations,0),(0,h.registerSingleton)(m.IExtHostDocumentsAndEditors,m.ExtHostDocumentsAndEditors,0),(0,h.registerSingleton)(s.IExtHostManagedSockets,s.ExtHostManagedSockets,0),(0,h.registerSingleton)(i.IExtHostFileSystemInfo,i.ExtHostFileSystemInfo,0),(0,h.registerSingleton)(O.IExtHostOutputService,O.ExtHostOutputService,1),(0,h.registerSingleton)(p.IExtHostSearch,p.ExtHostSearch,0),(0,h.registerSingleton)(S.IExtHostStorage,S.ExtHostStorage,0),(0,h.registerSingleton)(T.IExtHostTask,T.WorkerExtHostTask,0),(0,h.registerSingleton)(y.IExtHostTerminalService,y.WorkerExtHostTerminalService,0),(0,h.registerSingleton)(D.IExtHostTerminalShellIntegration,D.ExtHostTerminalShellIntegration,0),(0,h.registerSingleton)(E.IExtHostTunnelService,E.ExtHostTunnelService,0),(0,h.registerSingleton)(f.IExtHostWindow,f.ExtHostWindow,0),(0,h.registerSingleton)(L.IExtHostWorkspace,L.ExtHostWorkspace,0),(0,h.registerSingleton)(n.IExtHostSecretState,n.ExtHostSecretState,0),(0,h.registerSingleton)(l.IExtHostTelemetry,l.ExtHostTelemetry,0),(0,h.registerSingleton)(o.IExtHostEditorTabs,o.ExtHostEditorTabs,0),(0,h.registerSingleton)(r.IExtHostVariableResolverProvider,r.ExtHostVariableResolverProviderService,0)}),define(_e[123],Ce([1,0,19,11,37,94]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=void 0,e.anchorGlob=R,e.createTextSearchResult=b;function R(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}function b(I,p,S,E){const d=(0,h.mapArrayOrNot)(S,m),f=new L.TextSearchMatch(p,d,E),a=f.preview.matches;return{ranges:(0,h.mapArrayOrNot)(d,y),uri:I,preview:{text:f.preview.text,matches:(0,h.mapArrayOrNot)(a,y)}}}function m(I){return new L.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function y(I){return new A.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let T=class{constructor(p,S){this.prefix=p,this.logService=S}appendLine(p){this.logService.debug(`${this.prefix}#search`,p)}};e.OutputChannel=T,e.OutputChannel=T=Ge([Ue(1,O.ILogService)],T)}),define(_e[386],Ce([1,0,54,17,77,31,12,14,123,387]),function(ue,e,h,O,L,A,R,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spawnRipgrepCmd=I,e.getAbsoluteGlob=f,e.fixDriveC=i;const T=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(n,l,o,t){const u=p(n,l,o,t),r=l.folder.fsPath;return{cmd:h.spawn(T,u.args,{cwd:r}),rgDiskPath:T,siblingClauses:u.siblingClauses,rgArgs:u,cwd:r}}function p(n,l,o,t){const u=["--files","--hidden","--case-sensitive","--no-require-git"];E([l],o,!1).forEach(c=>{const s=(0,m.anchorGlob)(c);if(u.push("-g",s),R.isMacintosh){const w=(0,L.normalizeNFD)(s);w!==s&&u.push("-g",w)}});const r=S([l],t,void 0,!1);return r.globArgs.forEach(c=>{const s=`!${(0,m.anchorGlob)(c)}`;if(u.push("-g",s),R.isMacintosh){const w=(0,L.normalizeNFD)(s);w!==s&&u.push("-g",w)}}),l.disregardIgnoreFiles!==!1?u.push("--no-ignore"):l.disregardParentIgnoreFiles!==!1&&u.push("--no-ignore-parent"),l.ignoreSymlinks||u.push("--follow"),n.exists&&u.push("--quiet"),u.push("--no-config"),l.disregardGlobalIgnoreFiles&&u.push("--no-ignore-global"),{args:u,siblingClauses:r.siblingClauses}}function S(n,l,o,t=!0){const u=[];let r={};return n.forEach(c=>{const s=Object.assign({},c.excludePattern||{},l||{}),w=d(s,t?c.folder.fsPath:void 0,o);u.push(...w.globArgs),w.siblingClauses&&(r=Object.assign(r,w.siblingClauses))}),{globArgs:u,siblingClauses:r}}function E(n,l,o=!0){const t=[];return n.forEach(u=>{const r=Object.assign({},l||{},u.includePattern||{}),c=d(r,o?u.folder.fsPath:void 0);t.push(...c.globArgs)}),t}function d(n,l,o){const t=[],u={};return Object.keys(n).forEach(r=>{if(o&&o.has(r)||!r)return;const c=n[r];r=a(l?f(l,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof c=="boolean"&&c?(r.startsWith("\\\\")&&(r+="**"),t.push(i(r))):c&&c.when&&(u[r]=c)}),{globArgs:t,siblingClauses:u}}function f(n,l){return O.isAbsolute(l)?l:O.join(n,l)}function a(n){return n=b.rtrim(n,"\\"),b.rtrim(n,"/")}function i(n){return A.getRoot(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}}),define(_e[388],Ce([1,0,54,53,17,389,19,47,35,77,31,12,40,14,18,32,37,386,133]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const n=new Set;process.on("exit",()=>{n.forEach(r=>r())});class l{constructor(c){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=c,this.filePattern=c.filePattern||"",this.includePattern=c.includePattern&&m.parse(c.includePattern),this.maxResults=c.maxResults||null,this.exists=!!c.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=c.shouldGlobMatchFilePattern?null:(0,i.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=c.excludePattern&&m.parse(c.excludePattern),this.folderExcludePatterns=new Map,c.folderQueries.forEach(s=>{const w=Object.assign({},s.excludePattern||{},this.config.excludePattern||{}),g=s.folder.fsPath;c.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==g).forEach(D=>{(0,T.isEqualOrParent)(D,g)&&(w[L.relative(g,D)]=!0)}),this.folderExcludePatterns.set(g,new t(w,g))})}cancel(){this.isCanceled=!0,n.forEach(c=>c())}walk(c,s,w,g,D){if(this.fileWalkSW=p.StopWatch.create(!1),this.isCanceled)return D(null,this.isLimitHit);s.forEach(v=>{const _=L.basename(v.fsPath);this.globalExcludePattern&&this.globalExcludePattern(v.fsPath,_)||this.matchFile(w,{relativePath:v.fsPath,searchPath:void 0})}),this.cmdSW=p.StopWatch.create(!1),this.parallel(c,(v,_)=>{this.call(this.cmdTraversal,this,v,w,g,C=>{if(C){const P=(0,b.toErrorMessage)(C);console.error(P),this.errors.push(P),_(C,void 0)}else _(null,void 0)})},(v,_)=>{this.fileWalkSW.stop();const C=v?R.coalesce(v)[0]:null;D(C,this.isLimitHit)})}parallel(c,s,w){const g=new Array(c.length),D=new Array(c.length);let v=!1,_=0;if(c.length===0)return w(null,[]);c.forEach((C,P)=>{s(C,(k,F)=>{if(k?(v=!0,g[P]=null,D[P]=k):(g[P]=F,D[P]=null),++_===c.length)return w(v?D:null,g)})})}call(c,s,...w){try{c.apply(s,w)}catch(g){w[w.length-1](g)}}cmdTraversal(c,s,w,g){const D=c.folder.fsPath,v=I.isMacintosh,_=()=>x&&x.kill();n.add(_);let C=W=>{n.delete(_),C=()=>{},g(W)},P="";const k=this.initDirectoryTree(),F=(0,a.spawnRipgrepCmd)(this.config,c,this.config.includePattern,this.folderExcludePatterns.get(c.folder.fsPath).expression),x=F.cmd,z=!Object.keys(F.siblingClauses).length,N=F.rgArgs.args.map(W=>W.match(/^-/)?W:`'${W}'`).join(" ");let M=`${F.rgDiskPath} ${N}
 - cwd: ${F.cwd}`;F.rgArgs.siblingClauses&&(M+=`
 - Sibling clauses: ${JSON.stringify(F.rgArgs.siblingClauses)}`),w({message:M}),this.cmdResultCount=0,this.collectStdout(x,"utf8",w,(W,X,te)=>{if(W){C(W);return}if(this.isLimitHit){C();return}const G=(P+(v?y.normalizeNFC(X||""):X)).split(`
`);if(te){const Y=G.length;G[Y-1]=G[Y-1].trim(),G[Y-1]||G.pop()}else P=G.pop()||"";if(G.length&&G[0].indexOf(`
`)!==-1){C(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=G.length,z){for(const Y of G)if(this.matchFile(s,{base:D,relativePath:Y,searchPath:this.getSearchPath(c,Y)}),this.isLimitHit){_();break}(te||this.isLimitHit)&&C();return}this.addDirectoryEntries(c,k,D,G,s),te&&(this.matchDirectoryTree(k,D,s),C())})}spawnFindCmd(c){const s=this.folderExcludePatterns.get(c.folder.fsPath),w=s.getBasenameTerms(),g=s.getPathTerms(),D=["-L","."];if(w.length||g.length){D.push("-not","(","(");for(const v of w)D.push("-name",v),D.push("-o");for(const v of g)D.push("-path",v),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),h.spawn("find",D,{cwd:c.folder.fsPath})}readStdout(c,s,w){let g="";this.collectStdout(c,s,()=>{},(D,v,_)=>{if(D){w(D);return}g+=v,_&&w(null,g)})}collectStdout(c,s,w,g){let D=(C,P,k)=>{(C||k)&&(D=()=>{},this.cmdSW?.stop()),g(C,P,k)},v=!1;c.stdout?(this.forwardData(c.stdout,s,D),c.stdout.once("data",()=>v=!0)):w({message:"stdout is null"});let _;c.stderr?_=this.collectData(c.stderr):w({message:"stderr is null"}),c.on("error",C=>{D(C)}),c.on("close",C=>{let P;!v&&(P=this.decodeData(_,s))&&u(P)?D(new Error(`command failed with error code ${C}: ${this.decodeData(_,s)}`)):(this.exists&&C===0&&(this.isLimitHit=!0),D(null,"",!0))})}forwardData(c,s,w){const g=new A.StringDecoder(s);return c.on("data",D=>{w(null,g.write(D))}),g}collectData(c){const s=[];return c.on("data",w=>{s.push(w)}),s}decodeData(c,s){const w=new A.StringDecoder(s);return c.map(g=>w.write(g)).join("")}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries(c,{pathToEntries:s},w,g,D){g.indexOf(this.filePattern)!==-1&&this.matchFile(D,{base:w,relativePath:this.filePattern,searchPath:this.getSearchPath(c,this.filePattern)});const v=_=>{const C=L.basename(_),P=L.dirname(_);let k=s[P];k||(k=s[P]=[],v(P)),k.push({base:w,relativePath:_,basename:C,searchPath:this.getSearchPath(c,_)})};g.forEach(v)}matchDirectoryTree({rootEntries:c,pathToEntries:s},w,g){const D=this,v=this.folderExcludePatterns.get(w),_=this.filePattern;function C(P){D.directoriesWalked++;const k=(0,f.hasSiblingFn)(()=>P.map(F=>F.basename));for(let F=0,x=P.length;F<x;F++){const z=P[F],{relativePath:N,basename:M}=z;if(v.test(N,M,_!==M?k:void 0))continue;const W=s[N];if(W)C(W);else{if(D.filesWalked++,N===_)continue;D.matchFile(g,z)}if(D.isLimitHit)break}}C(c)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(c,s,w,g,D){const v=c.folder,_=(0,f.hasSiblingFn)(()=>w);this.parallel(w,(C,P)=>{if(this.isCanceled||this.isLimitHit)return P(null);const k=s?[s,C].join(L.sep):C;if(this.folderExcludePatterns.get(c.folder.fsPath).test(k,C,this.config.filePattern!==C?_:void 0))return P(null);const F=[v.fsPath,k].join(L.sep);O.lstat(F,(x,z)=>{if(x||this.isCanceled||this.isLimitHit)return P(null);this.statLinkIfNeeded(F,z,(N,M)=>N||this.isCanceled||this.isLimitHit?P(null):M.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(F,z,(W,X)=>W||this.isCanceled||this.isLimitHit||(X=X||"",this.walkedPaths[X])?P(null):(this.walkedPaths[X]=!0,d.Promises.readdir(F).then(te=>{if(this.isCanceled||this.isLimitHit)return P(null);this.doWalk(c,k,te,g,H=>P(H||null))},te=>{P(null)})))):(this.filesWalked++,k===this.filePattern||this.maxFilesize&&E.isNumber(M.size)&&M.size>this.maxFilesize||this.matchFile(g,{base:v.fsPath,relativePath:k,searchPath:this.getSearchPath(c,k)}),P(null,void 0)))})},C=>{const P=C&&R.coalesce(C);return D(P&&P.length>0?P[0]:void 0)})}matchFile(c,s){this.isFileMatch(s)&&(!this.includePattern||this.includePattern(s.relativePath,L.basename(s.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||c(s))}isFileMatch(c){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,f.isFilePatternMatch)(c,this.normalizedFilePatternLowercase);if(this.filePattern)return(0,f.isFilePatternMatch)(c,this.filePattern,!1)}return!0}statLinkIfNeeded(c,s,w){return s.isSymbolicLink()?O.stat(c,w):w(null,s)}realPathIfNeeded(c,s,w){return s.isSymbolicLink()?O.realpath(c,(g,D)=>g?w(g):w(null,D)):w(null,c)}getSearchPath(c,s){return c.folderName?L.join(c.folderName,s):s}}e.FileWalker=l;class o{constructor(c){this.folderQueries=c.folderQueries,this.extraFiles=c.extraFileResources||[],this.walker=new l(c)}search(c,s,w){this.walker.walk(this.folderQueries,this.extraFiles,c,s,(g,D)=>{w(g,{limitHit:D,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=o;class t{constructor(c,s){this.expression=c,this.root=s,this.init(c)}init(c){let s,w;Object.keys(c).filter(g=>c[g]).forEach(g=>{L.isAbsolute(g)?(s=s||m.getEmptyExpression(),s[g]=c[g]):(w=w||m.getEmptyExpression(),w[g]=c[g])}),this.absoluteParsedExpr=s&&m.parse(s,{trimForExclusions:!0}),this.relativeParsedExpr=w&&m.parse(w,{trimForExclusions:!0})}test(c,s,w){return this.relativeParsedExpr&&this.relativeParsedExpr(c,s,w)||this.absoluteParsedExpr&&this.absoluteParsedExpr(L.join(this.root,c),s,w)}getBasenameTerms(){const c=[];return this.absoluteParsedExpr&&c.push(...m.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&c.push(...m.getBasenameTerms(this.relativeParsedExpr)),c}getPathTerms(){const c=[];return this.absoluteParsedExpr&&c.push(...m.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&c.push(...m.getPathTerms(this.relativeParsedExpr)),c}}function u(r){const c=r.trim().split(`
`),s=c[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return S.uppercaseFirstLetter(c[c.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}}),define(_e[390],Ce([1,0,98,21,198,22]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.isUTFEncoding=R,e.toDecodeStream=E,e.toEncodeReadable=d,e.encodingExists=f,e.toNodeEncoding=a,e.detectEncodingByBOMFromBuffer=i,e.toCanonicalName=r,e.detectEncodingFromBuffer=c,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function R(s){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(w=>w===s)}e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const b=512,m=512,y=512*8,T=512*128;var I;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class p extends Error{constructor(w,g){super(w),this.decodeStreamErrorKind=g}}e.DecodeStreamError=p;class S{static async create(w){let g;if(w!==e.UTF8)g=(await(0,L.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(a(w));else{const D=new TextDecoder;g={write(v){return D.decode(v,{stream:!0})},end(){return D.decode()}}}return new S(g)}constructor(w){this.iconvLiteDecoder=w}write(w){return this.iconvLiteDecoder.write(w)}end(){return this.iconvLiteDecoder.end()}}function E(s,w){const g=w.minBytesRequiredForDetection??w.guessEncoding?y:m;return new Promise((D,v)=>{const _=(0,h.newWriteableStream)(z=>z.join("")),C=[];let P=0,k;const F=new A.CancellationTokenSource,x=async()=>{try{const z=await c({buffer:O.VSBuffer.concat(C),bytesRead:P},w.guessEncoding);if(z.seemsBinary&&w.acceptTextOnly)throw new p("Stream is binary but only text is accepted for decoding",1);z.encoding=await w.overwriteEncoding(z.encoding),k=await S.create(z.encoding);const N=k.write(O.VSBuffer.concat(C).buffer);_.write(N),C.length=0,P=0,D({stream:_,detected:z})}catch(z){F.cancel(),_.destroy(),v(z)}};(0,h.listenStream)(s,{onData:async z=>{k?_.write(k.write(z.buffer)):(C.push(z),P+=z.byteLength,P>=g&&(s.pause(),await x(),setTimeout(()=>s.resume())))},onError:z=>_.error(z),onEnd:async()=>{k||await x(),_.end(k?.end())}},F.token)})}async function d(s,w,g){const v=(await(0,L.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(a(w),g);let _=!1,C=!1;return{read(){if(C)return null;const P=s.read();if(typeof P!="string"){if(C=!0,!_&&g?.addBOM)switch(w){case e.UTF8:case e.UTF8_with_bom:return O.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return O.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return O.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const k=v.end();return k&&k.length>0?(_=!0,O.VSBuffer.wrap(k)):null}return _=!0,O.VSBuffer.wrap(v.write(P))}}}async function f(s){return(await(0,L.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(a(s))}function a(s){return s===e.UTF8_with_bom||s===null?e.UTF8:s}function i(s,w){if(!s||w<e.UTF16be_BOM.length)return null;const g=s.readUInt8(0),D=s.readUInt8(1);if(g===e.UTF16be_BOM[0]&&D===e.UTF16be_BOM[1])return e.UTF16be;if(g===e.UTF16le_BOM[0]&&D===e.UTF16le_BOM[1])return e.UTF16le;if(w<e.UTF8_BOM.length)return null;const v=s.readUInt8(2);return g===e.UTF8_BOM[0]&&D===e.UTF8_BOM[1]&&v===e.UTF8_BOM[2]?e.UTF8_with_bom:null}const n=["ascii","utf-16","utf-32"];async function l(s){const w=await(0,L.importAMDNodeModule)("jschardet","dist/jschardet.min.js"),g=s.slice(0,T),D=u(g.buffer),v=w.detect(D);if(!v||!v.encoding)return null;const _=v.encoding.toLowerCase();return 0<=n.indexOf(_)?null:t(v.encoding)}const o={ibm866:"cp866",big5:"cp950"};function t(s){const w=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return o[w]||w}function u(s){let w="";for(let g=0;g<s.length;g++)w+=String.fromCharCode(s[g]);return w}function r(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const w=s.match(/windows(\d+)/);return w?"windows-"+w[1]:s}}}function c({buffer:s,bytesRead:w},g){let D=i(s,w),v=!1;if(D!==e.UTF16be&&D!==e.UTF16le&&s){let _=!0,C=!0,P=!1;for(let k=0;k<w&&k<b;k++){const F=k%2===1,x=s.readUInt8(k)===0;if(x&&(P=!0),_&&(F&&!x||!F&&x)&&(_=!1),C&&(F&&x||!F&&!x)&&(C=!1),x&&!_&&!C)break}P&&(_?D=e.UTF16le:C?D=e.UTF16be:v=!0)}return g&&!v&&!D&&s?l(s.slice(0,w)).then(_=>({seemsBinary:!1,encoding:_})):{seemsBinary:v,encoding:D}}e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(_e[161],Ce([1,0,390,32,160]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends L.TextSearchManager{constructor(b,m,y=O,T="searchProcess"){super({query:b,provider:m},{readdir:I=>y.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,h.toCanonicalName)(I)},T)}}e.NativeTextSearchManager=A}),define(_e[162],Ce([1,0,54,406,389,19,74,35,14,2,37,94,407,387,123]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepParser=e.RipgrepTextSearchEngine=void 0,e.getRgArgs=t,e.unicodeEscapesToPCRE2=r,e.fixRegexNewline=s,e.fixNewline=w,e.performBraceExpansionForRipgrep=D;const d=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(_){this.outputChannel=_}provideTextSearchResults(_,C,P,k){return this.outputChannel.appendLine(`provideTextSearchResults ${_.pattern}, ${JSON.stringify({...C,folder:C.folder.toString()})}`),new Promise((F,x)=>{k.onCancellationRequested(()=>G());const z=t(_,C),N=C.folder.fsPath,M=z.map(we=>we.match(/^-/)?we:`'${we}'`).join(" ");this.outputChannel.appendLine(`${d} ${M}
 - cwd: ${N}`);let W=h.spawn(d,z,{cwd:N});W.on("error",we=>{console.error(we),this.outputChannel.appendLine("Error: "+(we&&we.message)),x((0,T.serializeSearchError)(new T.SearchError(we&&we.message,T.SearchErrorCode.rgProcessError)))});let X=!1;const te=new n(C.maxResults,C.folder,C.previewOptions);te.on("result",we=>{X=!0,ne="",P.report(we)});let H=!1;const G=()=>{H=!0,W?.kill(),te?.cancel()};let Y=!1;te.on("hitLimit",()=>{Y=!0,G()});let ne="";W.stdout.on("data",we=>{te.handleData(we),X||(ne+=we)});let pe=!1;W.stdout.once("data",()=>pe=!0);let le="";W.stderr.on("data",we=>{const Z=we.toString();this.outputChannel.appendLine(Z),le.length+Z.length<1e6&&(le+=Z)}),W.on("close",()=>{if(this.outputChannel.appendLine(pe?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(X?"Got result from parser":"No result from parser"),ne&&this.outputChannel.appendLine(`Got data without result: ${ne}`),this.outputChannel.appendLine(""),H)F({limitHit:Y});else{te.flush(),W=null;let we;le&&!pe&&(we=a(le))?x((0,T.serializeSearchError)(new T.SearchError(we.message,we.code))):F({limitHit:Y})}})})}}e.RipgrepTextSearchEngine=f;function a(v){const _=v.split(`
`),C=_[0].trim();if(_.some(k=>k.startsWith("regex parse error")))return new T.SearchError(i(_),T.SearchErrorCode.regexParseError);const P=C.match(/grep config error: unknown encoding: (.*)/);if(P)return new T.SearchError(`Unknown encoding: ${P[1]}`,T.SearchErrorCode.unknownEncoding);if(C.startsWith("error parsing glob"))return new T.SearchError(C.charAt(0).toUpperCase()+C.substr(1),T.SearchErrorCode.globParseError);if(C.startsWith("the literal"))return new T.SearchError(C.charAt(0).toUpperCase()+C.substr(1),T.SearchErrorCode.invalidLiteral);if(C.startsWith("PCRE2: error compiling pattern"))return new T.SearchError(C,T.SearchErrorCode.regexParseError)}function i(v){const _=["Regex parse error"],C=v.filter(P=>P.startsWith("PCRE2:"));if(C.length>=1){const P=C[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const k=P.split(":")[1];_.push(":"+k)}}return _.join("")}class n extends O.EventEmitter{constructor(_,C,P){super(),this.maxResults=_,this.root=C,this.previewOptions=P,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new L.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(_,C){return super.on(_,C),this}handleData(_){if(this.isDone)return;const C=typeof _=="string"?_:this.stringDecoder.write(_);this.handleDecodedData(C)}handleDecodedData(_){let C=_.indexOf(`
`);const P=this.remainder+_;if(C>=0)C+=this.remainder.length;else{this.remainder=P;return}let k=0;for(;C>=0;)this.handleLine(P.substring(k,C).trim()),k=C+1,C=P.indexOf(`
`,k);this.remainder=P.substring(k)}handleLine(_){if(this.isDone||!_)return;let C;try{C=JSON.parse(_)}catch{throw new Error(`malformed line from rg: ${_}`)}if(C.type==="match"){const P=l(C.data.path),k=y.URI.joinPath(this.root,P),F=this.createTextSearchMatch(C.data,k);this.onResult(F),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(C.type==="context"){const P=l(C.data.path),k=y.URI.joinPath(this.root,P);this.createTextSearchContext(C.data,k).forEach(x=>this.onResult(x))}}createTextSearchMatch(_,C){const P=_.line_number-1,k=l(_.lines),F=Buffer.from(k);let x=0,z=0,N=P;_.submatches.length===0&&_.submatches.push(k.length?{start:0,end:1,match:{text:k[0]}}:{start:0,end:0,match:{text:""}});const M=(0,A.coalesce)(_.submatches.map((W,X)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const te=l(W.match),H=F.slice(x,W.start).toString(),G=o(H),Y=G.numLines>0?G.lastLineLength:G.lastLineLength+z,ne=o(te),pe=G.numLines+N,le=ne.numLines+pe,we=ne.numLines>0?ne.lastLineLength:ne.lastLineLength+Y;return x=W.end,z=we,N=le,new I.Range(pe,Y,le,we)}));return(0,E.createTextSearchResult)(C,k,M,this.previewOptions)}createTextSearchContext(_,C){const P=l(_.lines),k=_.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((F,x)=>({text:F,uri:C,lineNumber:k+x}))}onResult(_){this.emit("result",_)}}e.RipgrepParser=n;function l(v){return v.bytes?Buffer.from(v.bytes,"base64").toString():v.text}function o(v){const _=/\n/g;let C=0,P=-1,k;for(;k=_.exec(v);)C++,P=k.index;const F=P>=0?v.length-P-1:v.length;return{numLines:C,lastLineLength:F}}function t(v,_){const C=["--hidden","--no-require-git"];C.push(v.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:k}=(0,R.groupBy)(_.includes,x=>x.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(k&&k.length){const x=new Set;k.forEach(z=>{x.add(z)}),C.push("-g","!*"),x.forEach(z=>{u(z).map(E.anchorGlob).forEach(N=>{C.push("-g",N)})})}P&&P.length&&P.forEach(x=>{C.push("-g",x)}),_.excludes.map(E.anchorGlob).forEach(x=>C.push("-g",`!${x}`)),_.maxFileSize&&C.push("--max-filesize",_.maxFileSize+""),_.useIgnoreFiles?_.useParentIgnoreFiles||C.push("--no-ignore-parent"):C.push("--no-ignore"),_.followSymlinks&&C.push("--follow"),_.encoding&&_.encoding!=="utf8"&&C.push("--encoding",_.encoding),v.pattern==="--"&&(v.isRegExp=!0,v.pattern="\\-\\-"),v.isMultiline&&!v.isRegExp&&(v.pattern=(0,m.escapeRegExpCharacters)(v.pattern),v.isRegExp=!0),_.usePCRE2&&C.push("--pcre2"),C.push("--crlf"),v.isRegExp&&(v.pattern=r(v.pattern),C.push("--engine","auto"));let F;if(v.isWordMatch){const z=(0,m.createRegExp)(v.pattern,!!v.isRegExp,{wholeWord:v.isWordMatch}).source.replace(/\\\//g,"/");C.push("--regexp",z)}else if(v.isRegExp){let x=s(v.pattern);x=w(x),C.push("--regexp",x)}else F=v.pattern,C.push("--fixed-strings");return C.push("--no-config"),_.useGlobalIgnoreFiles||C.push("--no-ignore-global"),C.push("--json"),v.isMultiline&&C.push("--multiline"),_.beforeContext&&C.push("--before-context",_.beforeContext+""),_.afterContext&&C.push("--after-context",_.afterContext+""),C.push("--"),F&&C.push(F),C.push("."),C}function u(v){return D(v).flatMap(C=>{const P=(0,b.splitGlobAware)(C,"/");return P.map((k,F)=>P.slice(0,F+1).join("/"))})}function r(v){const _=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;v.match(_);)v=v.replace(_,"$1\\x{$2}");const C=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;v.match(C);)v=v.replace(C,"$1\\x{$2}");return v}const c=v=>v.type==="Assertion"&&v.kind==="lookbehind";function s(v){let _;try{_=new p.RegExpParser().parsePattern(v)}catch{return v}let C="",P=0;const k=(z,N,M)=>{C+=v.slice(P,z)+M,P=N},F=[];return new p.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const N=F[0];if(!N)k(z.start,z.end,"\\r?\\n");else if(!F.some(c))if(N.type==="CharacterClass")if(N.negate){const M=v.slice(N.start+2,z.start)+v.slice(z.end,N.end-1);N.parent?.type==="Quantifier"?k(N.start,N.end,M?`[^${M}]`:"."):k(N.start,N.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=v.slice(N.start+1,z.start)+v.slice(z.end,N.end-1);k(N.start,N.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else N.type==="Quantifier"&&k(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){F.unshift(z)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(z){F.unshift(z)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(z){F.unshift(z)},onCharacterClassLeave(){F.shift()},onAssertionEnter(z){c(z)&&F.push(z)},onAssertionLeave(z){F[0]===z&&F.shift()}}).visit(_),C+=v.slice(P),C}function w(v){return v.replace(/\n/g,"\\r?\\n")}function g(v){let _=!1,C=!1,P="",k="";for(let F=0;F<v.length;F++){const x=v[F];switch(x){case"\\":C?(_?k+="\\"+x:P+="\\"+x,C=!1):C=!0;break;case"{":if(C)_?k+=x:P+=x,C=!1;else{if(_)return{strInBraces:P+"{"+k+"{"+v.substring(F+1)};_=!0}break;case"}":if(C)_?k+=x:P+=x,C=!1;else{if(_)return{fixedStart:P,strInBraces:k,fixedEnd:v.substring(F+1)};P+=x}break;default:_?k+=(C?"\\":"")+x:P+=(C?"\\":"")+x,C=!1;break}}return{strInBraces:P+(_?"{"+k:"")}}function D(v){const{fixedStart:_,strInBraces:C,fixedEnd:P}=g(v);if(_===void 0||P===void 0)return[C];let k=(0,b.splitGlobAware)(C,",");k.length||(k=[""]);const F=D(P);return k.flatMap(x=>{const z=_+x;return F.map(N=>z+N)})}}),define(_e[391],Ce([1,0,22,162,109,15]),function(ue,e,h,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class R{constructor(y){this.outputChannel=y,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(y,T,I,p){const S=new O.RipgrepTextSearchEngine(this.outputChannel);if(T.folder.scheme===A.Schemas.vscodeUserData){const E={...T,folder:T.folder.with({scheme:A.Schemas.file})},d=new L.Progress(f=>I.report({...f,uri:f.uri.with({scheme:T.folder.scheme})}));return this.withToken(p,f=>S.provideTextSearchResults(y,E,d,f))}else return this.withToken(p,E=>S.provideTextSearchResults(y,T,I,E))}async withToken(y,T){const I=b(y);this.inProgress.add(I);const p=await T(I.token);return this.inProgress.delete(I),p}dispose(){this.inProgress.forEach(y=>y.cancel())}}e.RipgrepSearchProvider=R;function b(m){const y=new h.CancellationTokenSource;return m.onCancellationRequested(()=>y.cancel()),y}}),define(_e[392],Ce([1,0,32,162,161]),function(ue,e,h,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(m){this.query=m}search(m,y,T){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(S){T({message:S})}},p=new L.NativeTextSearchManager(this.query,new O.RipgrepTextSearchEngine(I),h);return new Promise((S,E)=>p.search(d=>{y(d.map(R))},m).then(d=>S({limitHit:d.limitHit,type:"success",stats:d.stats}),E))}}e.TextSearchEngineAdapter=A;function R(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce((m,y)=>{if(y.ranges){const T=y;return m+(Array.isArray(T.ranges)?T.ranges.length:1)}else return m+1},0)}}}),define(_e[393],Ce([1,0,19,7,13,4,133,17,40,2,33,37,388,392]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class E{static{this.BATCH_SIZE=512}constructor(l="searchProcess"){this.processType=l,this.caches=Object.create(null)}fileSearch(l){let o;const t=a(l),u=new A.Emitter({onDidAddFirstListener:()=>{o=(0,O.createCancelablePromise)(r=>this.doFileSearchWithEngine(p.Engine,t,c=>u.fire(c),r)),o.then(r=>u.fire(r),r=>u.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return u.event}textSearch(l){let o;const t=a(l),u=new A.Emitter({onDidAddFirstListener:()=>{o=(0,O.createCancelablePromise)(r=>this.ripgrepTextSearch(t,c=>u.fire(c),r)),o.then(r=>u.fire(r),r=>u.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return u.event}ripgrepTextSearch(l,o,t){return l.maxFileSize=this.getPlatformFileLimits().maxFileSize,new S.TextSearchEngineAdapter(l).search(t,o,o)}getPlatformFileLimits(){return{maxFileSize:16*T.ByteSize.GB}}doFileSearch(l,o,t){return this.doFileSearchWithEngine(p.Engine,l,o,t)}doFileSearchWithEngine(l,o,t,u,r=E.BATCH_SIZE){let c=0;const s=g=>{Array.isArray(g)?(c+=g.length,t(g.map(D=>this.rawMatchToSearchItem(D)))):g.relativePath?(c++,t(this.rawMatchToSearchItem(g))):t(g)};if(o.sortByScore){let g=this.trySortedSearchFromCache(o,s,u);if(!g){const D=o.maxResults?Object.assign({},o,{maxResults:null}):o,v=new l(D);g=this.doSortedSearch(v,o,t,s,u)}return new Promise((D,v)=>{g.then(([_,C])=>{const P=C.map(k=>this.rawMatchToSearchItem(k));this.sendProgress(P,t,r),D(_)},v)})}const w=new l(o);return this.doSearch(w,s,r,u).then(g=>({limitHit:g.limitHit,type:"success",stats:{detailStats:g.stats,type:this.processType,fromCache:!1,resultCount:c,sortingTime:void 0}}))}rawMatchToSearchItem(l){return{path:l.base?(0,b.join)(l.base,l.relativePath):l.relativePath}}doSortedSearch(l,o,t,u,r){const c=new A.Emitter;let s=(0,O.createCancelablePromise)(g=>{let D=[];const v=_=>{Array.isArray(_)?D=_:(u(_),c.fire(_))};return this.doSearch(l,v,-1,g).then(_=>[_,D])}),w;if(o.cacheKey){w=this.getOrCreateCache(o.cacheKey);const g={promise:s,event:c.event,resolved:!1};w.resultsToSearchCache[o.filePattern||""]=g,s.then(()=>{g.resolved=!0},D=>{delete w.resultsToSearchCache[o.filePattern||""]}),s=this.preventCancellation(s)}return s.then(([g,D])=>{const v=w?w.scorerCache:Object.create(null),_=(typeof o.maxResults!="number"||o.maxResults>0)&&m.StopWatch.create(!1);return this.sortResults(o,D,v,r).then(C=>{const P=_?_.elapsed():-1;return[{type:"success",stats:{detailStats:g.stats,sortingTime:P,fromCache:!1,type:this.processType,workspaceFolderCount:o.folderQueries.length,resultCount:C.length},messages:g.messages,limitHit:g.limitHit||typeof o.maxResults=="number"&&D.length>o.maxResults},C]})})}getOrCreateCache(l){const o=this.caches[l];return o||(this.caches[l]=new d)}trySortedSearchFromCache(l,o,t){const u=l.cacheKey&&this.caches[l.cacheKey];if(!u)return;const r=this.getResultsFromCache(u,l.filePattern||"",o,t);if(r)return r.then(([c,s,w])=>{const g=m.StopWatch.create(!1);return this.sortResults(l,s,u.scorerCache,t).then(D=>{const v=g.elapsed(),_={fromCache:!0,detailStats:w,type:this.processType,resultCount:s.length,sortingTime:v};return[{type:"success",limitHit:c.limitHit||typeof l.maxResults=="number"&&s.length>l.maxResults,stats:_},D]})})}sortResults(l,o,t,u){const r=(0,R.prepareQuery)(l.filePattern||""),c=(w,g)=>(0,R.compareItemsByFuzzyScore)(w,g,r,!0,f,t),s=typeof l.maxResults=="number"?l.maxResults:Number.MAX_VALUE;return h.topAsync(o,c,s,1e4,u)}sendProgress(l,o,t){if(t&&t>0)for(let u=0;u<l.length;u+=t)o(l.slice(u,u+t));else o(l)}getResultsFromCache(l,o,t,u){const r=m.StopWatch.create(!1),c=o.indexOf(b.sep)>=0;let s;for(const v in l.resultsToSearchCache)if(o.startsWith(v)){if(c&&v.indexOf(b.sep)<0&&v!=="")continue;const _=l.resultsToSearchCache[v];s={promise:this.preventCancellation(_.promise),event:_.event,resolved:_.resolved};break}if(!s)return null;const w=r.elapsed(),g=m.StopWatch.create(!1),D=s.event(t);return u&&u.onCancellationRequested(()=>{D.dispose()}),s.promise.then(([v,_])=>{if(u&&u.isCancellationRequested)throw(0,L.canceled)();const C=[],P=(0,R.prepareQuery)(o).normalizedLowercase;for(const k of _)(0,I.isFilePatternMatch)(k,P)&&C.push(k);return[v,C,{cacheWasResolved:s.resolved,cacheLookupTime:w,cacheFilterTime:g.elapsed(),cacheEntryCount:_.length}]})}doSearch(l,o,t,u){return new Promise((r,c)=>{let s=[];u?.onCancellationRequested(()=>l.cancel()),l.search(w=>{w&&(t?(s.push(w),t>0&&s.length>=t&&(o(s),s=[])):o(w))},w=>{o(w)},(w,g)=>{s.length&&o(s),w?(o({message:"Search finished. Error: "+w.message}),c(w)):(o({message:"Search finished. Stats: "+JSON.stringify(g.stats)}),r(g))})})}clearCache(l){return delete this.caches[l],Promise.resolve(void 0)}preventCancellation(l){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(o,t){return l.then(o,t)}catch(o){return this.then(void 0,o)}finally(o){return l.finally(o)}}}}e.SearchService=E;class d{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const f=new class{getItemLabel(n){return(0,b.basename)(n.relativePath)}getItemDescription(n){return(0,b.dirname)(n.relativePath)}getItemPath(n){return n.relativePath}};function a(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(l=>y.URI.revive(l))}}function i(n){return{...n,folder:y.URI.revive(n.folder)}}}),define(_e[394],Ce([1,0,3,15,2,32,11,28,20,97,68,37,393,391,123,161]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let f=class extends y.ExtHostSearch{constructor(i,n,l,o){super(i,l,o),this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1,this._disposables=new h.DisposableStore;const t=new E.OutputChannel("RipgrepSearchUD",this._logService);this._disposables.add(this.registerTextSearchProvider(O.Schemas.vscodeUserData,new S.RipgrepSearchProvider(t))),n.remote.isRemote&&n.remote.authority&&this._registerEHSearchProviders()}dispose(){this._disposables.dispose()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const i=new E.OutputChannel("RipgrepSearchEH",this._logService);this._disposables.add(this.registerTextSearchProvider(O.Schemas.file,new S.RipgrepSearchProvider(i))),this._disposables.add(this.registerInternalFileSearchProvider(O.Schemas.file,new p.SearchService("fileSearchProvider")))}registerInternalFileSearchProvider(i,n){const l=this._handlePool++;return this._internalFileSearchProvider=n,this._internalFileSearchHandle=l,this._proxy.$registerFileSearchProvider(l,this._transformScheme(i)),(0,h.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(l)})}$provideFileSearchResults(i,n,l,o){const t=(0,y.reviveQuery)(l);if(i===this._internalFileSearchHandle){const u=Date.now();return this.doInternalFileSearch(i,n,t,o).then(r=>{const c=Date.now()-u;return this._logService.debug(`Ext host file search time: ${c}ms`),r})}return super.$provideFileSearchResults(i,n,l,o)}doInternalFileSearchWithCustomCallback(i,n,l){const o=t=>{if((0,I.isSerializedFileMatch)(t)&&(t=[t]),Array.isArray(t)){l(t.map(u=>L.URI.file(u.path)));return}t.message&&this._logService.debug("ExtHostSearch",t.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(i,o,n)}async doInternalFileSearch(i,n,l,o){return this.doInternalFileSearchWithCustomCallback(l,o,t=>{this._proxy.$handleFileMatch(i,n,t)})}$clearCache(i){return this._internalFileSearchProvider?.clearCache(i),super.$clearCache(i)}createTextSearchManager(i,n){return new d.NativeTextSearchManager(i,n,void 0,"textSearchProvider")}};e.NativeExtHostSearch=f,e.NativeExtHostSearch=f=Ge([Ue(0,m.IExtHostRpcService),Ue(1,b.IExtHostInitDataService),Ue(2,T.IURITransformerService),Ue(3,R.ILogService)],f)}),define(_e[124],Ce([1,0,408,63,64,409,21,13,4,3,17,12,30,82,83]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0,e.createRandomIPCHandle=r,e.createStaticIPCHandle=c,e.serve=g,e.connect=D;class d{traceSocketEvent(_,C){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,_,C)}constructor(_,C=""){this._canWrite=!0,this.debugLabel=C,this.socket=_,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,b.onUnexpectedError)(P)}},this.socket.on("error",this._errorListener),this._closeListener=P=>{this.traceSocketEvent("close",{hadError:P}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(_){const C=P=>{this.traceSocketEvent("read",P),_(R.VSBuffer.wrap(P))};return this.socket.on("data",C),{dispose:()=>this.socket.off("data",C)}}onClose(_){const C=P=>{_({type:0,hadError:P,error:void 0})};return this.socket.on("close",C),{dispose:()=>this.socket.off("close",C)}}onEnd(_){const C=()=>{_()};return this.socket.on("end",C),{dispose:()=>this.socket.off("end",C)}}write(_){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",_),this.socket.write(_.buffer,C=>{if(C){if(C.code==="EPIPE")return;(0,b.onUnexpectedError)(C)}})}catch(C){if(C.code==="EPIPE")return;(0,b.onUnexpectedError)(C)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((_,C)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),_();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),_()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.NodeSocket=d;var f;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize",v[v.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var a;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(a||(a={}));class i extends y.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(_,C){this.socket.traceSocketEvent(_,C)}constructor(_,C,P,k){super(),this._onData=this._register(new m.Emitter),this._onClose=this._register(new m.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=_,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:C,inflateBytesLength:P?.byteLength||0,recordInflateBytes:k}),this._flowManager=this._register(new n(this,C,P,k,this._onData,(F,x)=>this._write(F,x))),this._register(this._flowManager.onError(F=>{console.error(F),(0,b.onUnexpectedError)(F),this._onClose.fire({type:0,hadError:!0,error:F})})),this._incomingData=new E.ChunkStream,this._register(this.socket.onData(F=>this._acceptChunk(F))),this._register(this.socket.onClose(async F=>{this._flowManager.isProcessingReadQueue()&&await m.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(F)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(_){return this._onData.event(_)}onClose(_){return this._onClose.event(_)}onEnd(_){return this.socket.onEnd(_)}write(_){let C=0;for(;C<_.byteLength;)this._flowManager.writeMessage(_.slice(C,Math.min(C+262144,_.byteLength)),{compressed:!0,opcode:2}),C+=262144}_write(_,{compressed:C,opcode:P}){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",_);let k=2;_.byteLength<126?k+=0:_.byteLength<2**16?k+=2:k+=8;const F=R.VSBuffer.alloc(k),x=C?64:0,z=P&15;if(F.writeUInt8(128|x|z,0),_.byteLength<126)F.writeUInt8(_.byteLength,1);else if(_.byteLength<2**16){F.writeUInt8(126,1);let N=1;F.writeUInt8(_.byteLength>>>8&255,++N),F.writeUInt8(_.byteLength>>>0&255,++N)}else{F.writeUInt8(127,1);let N=1;F.writeUInt8(0,++N),F.writeUInt8(0,++N),F.writeUInt8(0,++N),F.writeUInt8(0,++N),F.writeUInt8(_.byteLength>>>24&255,++N),F.writeUInt8(_.byteLength>>>16&255,++N),F.writeUInt8(_.byteLength>>>8&255,++N),F.writeUInt8(_.byteLength>>>0&255,++N)}this.socket.write(R.VSBuffer.concat([F,_]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(_){if(_.byteLength!==0){for(this._incomingData.acceptChunk(_);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const C=this._incomingData.peek(this._state.readLen),P=C.readUInt8(0),k=(P&128)>>>7,F=(P&64)>>>6,x=P&15,z=C.readUInt8(1),N=(z&128)>>>7,M=z&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(M===126?2:0)+(M===127?8:0),this._state.fin=k,this._state.firstFrameOfMessage&&(this._state.compressed=!!F),this._state.firstFrameOfMessage=!!k,this._state.mask=0,this._state.opcode=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===2){const C=this._incomingData.read(this._state.readLen),P=C.readUInt8(1),k=(P&128)>>>7;let F=P&127,x=1;F===126?F=C.readUInt8(++x)*2**8+C.readUInt8(++x):F===127&&(F=C.readUInt8(++x)*0+C.readUInt8(++x)*0+C.readUInt8(++x)*0+C.readUInt8(++x)*0+C.readUInt8(++x)*2**24+C.readUInt8(++x)*2**16+C.readUInt8(++x)*2**8+C.readUInt8(++x));let z=0;k&&(z=C.readUInt8(++x)*2**24+C.readUInt8(++x)*2**16+C.readUInt8(++x)*2**8+C.readUInt8(++x)),this._state.state=3,this._state.readLen=F,this._state.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===3){const C=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",C),t(C,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",C),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(C,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(C,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await m.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=i;class n extends y.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:R.VSBuffer.alloc(0)}constructor(_,C,P,k,F,x){super(),this._tracer=_,this._onData=F,this._writeFn=x,this._onError=this._register(new m.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new m.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new m.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,C?(this._zlibInflateStream=this._register(new l(this._tracer,k,P,{windowBits:15})),this._zlibDeflateStream=this._register(new o(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(z=>this._onError.fire(z))),this._register(this._zlibDeflateStream.onError(z=>this._onError.fire(z)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(_,C){this._writeQueue.push({data:_,options:C}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:_,options:C}=this._writeQueue.shift();if(this._zlibDeflateStream&&C.compressed){const P=await this._deflateMessage(this._zlibDeflateStream,_);this._writeFn(P,C)}else this._writeFn(_,{...C,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(_,C){return new Promise((P,k)=>{_.write(C),_.flush(F=>P(F))})}acceptFrame(_,C,P){this._readQueue.push({data:_,isCompressed:C,isLastFrameOfMessage:P}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const _=this._readQueue.shift();if(this._zlibInflateStream&&_.isCompressed){const C=await this._inflateFrame(this._zlibInflateStream,_.data,_.isLastFrameOfMessage);this._onData.fire(C)}else this._onData.fire(_.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(_,C,P){return new Promise((k,F)=>{_.write(C),P&&_.write(R.VSBuffer.fromByteArray([0,0,255,255])),_.flush(x=>k(x))})}}class l extends y.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?R.VSBuffer.concat(this._recordedInflateBytes):R.VSBuffer.alloc(0)}constructor(_,C,P,k){super(),this._tracer=_,this._recordInflateBytes=C,this._onError=this._register(new m.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,A.createInflateRaw)(k),this._zlibInflate.on("error",F=>{this._tracer.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibInflate.on("data",F=>{this._tracer.traceSocketEvent("zlibInflateData",F),this._pendingInflateData.push(R.VSBuffer.wrap(F))}),P&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this._zlibInflate.write(P.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(_){this._recordInflateBytes&&this._recordedInflateBytes.push(_.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",_),this._zlibInflate.write(_.buffer)}flush(_){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const C=R.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,_(C)})}}class o extends y.Disposable{constructor(_,C){super(),this._tracer=_,this._onError=this._register(new m.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,A.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",P=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this._onError.fire(P)}),this._zlibDeflate.on("data",P=>{this._tracer.traceSocketEvent("zlibDeflateData",P),this._pendingDeflateData.push(R.VSBuffer.wrap(P))})}write(_){this._tracer.traceSocketEvent("zlibDeflateWrite",_.buffer),this._zlibDeflate.write(_.buffer)}flush(_){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let C=R.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,C=C.slice(0,C.byteLength-4),_(C)})}}function t(v,_){if(_===0)return;const C=v.byteLength>>>2;for(let N=0;N<C;N++){const M=v.readUInt32BE(N*4);v.writeUInt32BE(M^_,N*4)}const P=C*4,k=v.byteLength-P,F=_>>>24&255,x=_>>>16&255,z=_>>>8&255;k>=1&&v.writeUInt8(v.readUInt8(P)^F,P),k>=2&&v.writeUInt8(v.readUInt8(P+1)^x,P+1),k>=3&&v.writeUInt8(v.readUInt8(P+2)^z,P+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const u={2:107,1:103};function r(){const v=(0,p.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;const _=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,L.tmpdir)(),C=(0,T.join)(_,`vscode-ipc-${v}.sock`);return s(C),C}function c(v,_,C){const k=(0,h.createHash)("sha256").update(v).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${k}-${C}-${_}-sock`;const F=C.substr(0,4),x=_.substr(0,6);let z;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?z=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${k}-${F}-${x}.sock`):z=(0,T.join)(v,`${F}-${x}.sock`),s(z),z}function s(v){const _=u[I.platform];typeof _=="number"&&v.length>=_&&console.warn(`WARNING: IPC handle "${v}" is longer than ${_} chars, try a shorter --user-data-dir`)}class w extends S.IPCServer{static toClientConnectionEvent(_){const C=m.Event.fromNodeEventEmitter(_,"connection");return m.Event.map(C,P=>({protocol:new E.Protocol(new d(P,"ipc-server-connection")),onDidClientDisconnect:m.Event.once(m.Event.fromNodeEventEmitter(P,"close"))}))}constructor(_){super(w.toClientConnectionEvent(_)),this.server=_}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=w;function g(v){return new Promise((_,C)=>{const P=(0,O.createServer)();P.on("error",C),P.listen(v,()=>{P.removeListener("error",C),_(new w(P))})})}function D(v,_){return new Promise((C,P)=>{const k=(0,O.createConnection)(v,()=>{k.removeListener("error",P),C(E.Client.fromSocket(new d(k,`ipc-client${_}`),_))});k.once("error",P)})}}),define(_e[395],Ce([1,0,63,64,178,124,7,3,12,55,11,108,272,273,111,88,21]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function a(t,u,r,c,s){let w;for(let g=3;g&&(w?.dispose(),w=await new i(t,u,r,c,s).waitForReady(),!(s&&L.BROWSER_RESTRICTED_PORTS[s]||!L.BROWSER_RESTRICTED_PORTS[w.tunnelLocalPort]));g--);return w}class i extends b.Disposable{constructor(u,r,c,s,w){super(),this.defaultTunnelHost=r,this.suggestedLocalPort=w,this.privacy=d.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=u,this._server=h.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=g=>this._onConnection(g),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=s,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(r=>{r()})}async waitForReady(){const u=this.suggestedLocalPort??this.tunnelRemotePort,r=(0,d.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let c=await(0,L.findFreePortFaster)(u,2,1e3,r),s=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),s=this._server.address(),s||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),s=this._server.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async _onConnection(u){u.pause();const r=(0,d.isLocalhost)(this.tunnelRemoteHost)||(0,d.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,p.connectRemoteAgentTunnel)(this._options,r,this.tunnelRemotePort),s=c.getSocket(),w=c.readEntireBuffer();c.dispose(),w.byteLength>0&&u.write(w.buffer),u.on("end",()=>{u.localAddress&&this._socketsDispose.delete(u.localAddress),s.end()}),u.on("close",()=>s.end()),u.on("error",()=>{u.localAddress&&this._socketsDispose.delete(u.localAddress),s instanceof A.NodeSocket?s.socket.destroy():s.end()}),s instanceof A.NodeSocket?this._mirrorNodeSocket(u,s):this._mirrorGenericSocket(u,s),u.localAddress&&this._socketsDispose.set(u.localAddress,()=>{u.end(),s.end()})}_mirrorGenericSocket(u,r){r.onClose(()=>u.destroy()),r.onEnd(()=>u.end()),r.onData(c=>u.write(c.buffer)),u.on("data",c=>r.write(f.VSBuffer.wrap(c))),u.resume()}_mirrorNodeSocket(u,r){const c=r.socket;c.on("end",()=>u.end()),c.on("close",()=>u.end()),c.on("error",()=>{u.destroy()}),c.pipe(u),u.pipe(c)}}e.NodeRemoteTunnel=i;let n=class extends d.AbstractTunnelService{constructor(u,r,c,s,w){super(r,w),this.remoteSocketFactoryService=u,this.signService=c,this.productService=s}isPortPrivileged(u){return(0,d.isPortPrivileged)(u,this.defaultTunnelHost,m.OS,O.release())}retainOrCreateTunnel(u,r,c,s,w,g,D,v){const _=this.getTunnelFromMap(r,c);if(_)return++_.refcount,_.value;if((0,d.isTunnelProvider)(u))return this.createWithProvider(u,r,c,w,g,D,v);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${c} on local port ${w}.`);const C={commit:this.productService.commit,quality:this.productService.quality,addressProvider:u,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},P=a(C,s,r,c,w);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(r,c,P),P}}};e.BaseTunnelService=n,e.BaseTunnelService=n=Ge([Ue(0,S.IRemoteSocketFactoryService),Ue(1,T.ILogService),Ue(2,E.ISignService),Ue(3,I.IProductService),Ue(4,y.IConfigurationService)],n);let l=class extends n{constructor(u,r,c,s,w){super(u,r,c,s,w)}};e.TunnelService=l,e.TunnelService=l=Ge([Ue(0,S.IRemoteSocketFactoryService),Ue(1,T.ILogService),Ue(2,E.ISignService),Ue(3,I.IProductService),Ue(4,y.IConfigurationService)],l);let o=class extends b.Disposable{constructor(u,r,c,s,w){super(),this.remoteSocketFactoryService=u,this.logService=r,this.productService=c,this.signService=s,this.configurationService=w,this._tunnelServices=new Map}async openTunnel(u,r,c,s,w,g,D,v,_){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${s} on local port ${g}.`),!this._tunnelServices.has(u)){const C=new l(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(C),this._tunnelServices.set(u,C),C.onTunnelClosed(async()=>{(await C.tunnels).length===0&&(C.dispose(),this._tunnelServices.delete(u))})}return this._tunnelServices.get(u).openTunnel(r,c,s,w,g,D,v,_)}};e.SharedTunnelsService=o,e.SharedTunnelsService=o=Ge([Ue(0,S.IRemoteSocketFactoryService),Ue(1,T.ILogService),Ue(2,I.IProductService),Ue(3,E.ISignService),Ue(4,y.IConfigurationService)],o)}),define(_e[396],Ce([1,0,124,292,53,34,2,11,42]),function(ue,e,h,O,L,A,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class y{constructor(p,S,E){this._commands=p,this.logService=S,this._ipcHandlePath=E,this._server=O.createServer((d,f)=>this.onRequest(d,f)),this.setup().catch(d=>(S.error(d),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",p=>this.logService.error(p))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(p,S){const E=(f,a)=>{S.writeHead(f,{"content-type":"application/json"}),S.end(JSON.stringify(a||null),i=>i&&this.logService.error(i))},d=[];p.setEncoding("utf8"),p.on("data",f=>d.push(f)),p.on("end",async()=>{try{const f=JSON.parse(d.join(""));let a;switch(f.type){case"open":a=await this.open(f);break;case"openExternal":a=await this.openExternal(f);break;case"status":a=await this.getStatus(f);break;case"extensionManagement":a=await this.manageExtensions(f);break;default:E(404,`Unknown message type: ${f.type}`);break}E(200,a)}catch(f){const a=f instanceof Error?f.message:JSON.stringify(f);E(500,a),this.logService.error("Error while processing pipe request",f)}})}async open(p){const{fileURIs:S,folderURIs:E,forceNewWindow:d,diffMode:f,mergeMode:a,addMode:i,forceReuseWindow:n,gotoLineMode:l,waitMarkerFilePath:o,remoteAuthority:t}=p,u=[];if(Array.isArray(E))for(const w of E)try{u.push({folderUri:R.URI.parse(w)})}catch{}if(Array.isArray(S))for(const w of S)try{(0,m.hasWorkspaceFileExtension)(w)?u.push({workspaceUri:R.URI.parse(w)}):u.push({fileUri:R.URI.parse(w)})}catch{}const r=o?R.URI.file(o):void 0,s={forceNewWindow:d,diffMode:f,mergeMode:a,addMode:i,gotoLineMode:l,forceReuseWindow:n,preferNewWindow:!n&&!r&&!i,waitMarkerFileURI:r,remoteAuthority:t};this._commands.executeCommand("_remoteCLI.windowOpen",u,s)}async openExternal(p){for(const S of p.uris){const E=R.URI.parse(S),d=E.scheme==="file"?E:S;await this._commands.executeCommand("_remoteCLI.openExternal",d)}}async manageExtensions(p){const S=d=>d?.map(f=>/\.vsix$/i.test(f)?R.URI.parse(f):f),E={list:p.list,install:S(p.install),uninstall:S(p.uninstall),force:p.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",E)}async getStatus(p){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&L.existsSync(this._ipcHandlePath)&&L.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=y;let T=class extends y{constructor(p,S){super(p,S,(0,h.createRandomIPCHandle)())}};e.CLIServer=T,e.CLIServer=T=Ge([Ue(0,A.IExtHostCommands),Ue(1,b.ILogService)],T)}),define(_e[397],Ce([1,0,59,384,379,291,49,366,2,15,8,396,104,325,365]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class d extends L.RequireInterceptor{_installInterceptor(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,l=n._load;n._load=function(r,c,s){return r=t(r),i._factories.has(r)?i._factories.get(r).load(r,m.URI.file((0,p.realpathSync)(c.filename)),w=>l.apply(this,[w,c,s])):l.apply(this,arguments)};const o=n._resolveLookupPaths;n._resolveLookupPaths=(u,r)=>o.call(this,t(u),r);const t=u=>{for(const r of i._alternatives){const c=r(u);if(c){u=c;break}}return u}}}class f extends R.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=T.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(S.ExtHostConsoleForwarder);const i=this._instaService.invokeFunction(O.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(b.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const o=this._instaService.createInstance(I.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}this._instaService.createInstance(E.ExtHostDiskFileSystemProvider),await this._instaService.createInstance(d,i,{mine:this._myRegistry,all:this._globalRegistry}).install(),h.mark("code/extHost/didInitAPI");const l=await this._extHostConfiguration.getConfigProvider();await(0,A.connectProxyResolver)(this._extHostWorkspace,l,this,this._logService,this._mainThreadTelemetryProxy,this._initData),h.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(i){return i.main}async _loadCommonJSModule(i,n,l){if(n.scheme!==y.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let o=null;l.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this._logService.flush();const t=i?.identifier.value;i&&await this._extHostLocalizationService.initializeLocalizedMessages(i);try{t&&h.mark(`code/extHost/willLoadExtensionCode/${t}`),o=ue.__$__nodeRequire(n.fsPath)}finally{t&&h.mark(`code/extHost/didLoadExtensionCode/${t}`),l.codeLoadingStop()}return o}async $setRemoteEnvironment(i){if(this._initData.remote.isRemote)for(const n in i){const l=i[n];l===null?delete process.env[n]:process.env[n]=l}}}e.ExtHostExtensionService=f}),define(_e[398],Ce([1,0,54,21,4,3,126,12,23,2,32,11,271,67,111,88,395,28,20,71,373]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i,n,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostTunnelService=void 0,e.getSockets=o,e.loadListeningPorts=t,e.parseIpAddress=u,e.loadConnectionTable=r,e.getRootProcesses=s,e.findPorts=w,e.tryFindRootPorts=g;function o(_){const C=_.trim().split(`
`),P=[];return C.forEach(F=>{const x=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(F);x&&x.length>=3&&P.push({pid:parseInt(x[1],10),socket:parseInt(x[2],10)})}),P.reduce((F,x)=>(F[x.socket]=x,F),{})}function t(..._){const C=[].concat(..._.map(r));return[...new Map(C.filter(P=>P.st==="0A").map(P=>{const k=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:u(k[0]),port:parseInt(k[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}function u(_){let C="";if(_.length===8)for(let P=_.length-2;P>=0;P-=2)C+=parseInt(_.substr(P,2),16),P!==0&&(C+=".");else for(let P=0;P<_.length;P+=8){const k=_.substring(P,P+8);let F="";for(let x=8;x>=2;x-=2)F+=k.substring(x-2,x),(x===6||x===2)&&(F=parseInt(F,16).toString(16),C+=`${F}`,F="",P+x!==_.length-6&&(C+=":"))}return C}function r(_){const C=_.trim().split(`
`),P=C.shift().trim().split(/\s+/).filter(F=>F!=="rx_queue"&&F!=="tm->when");return C.map(F=>F.trim().split(/\s+/).reduce((x,z,N)=>(x[P[N]||N]=z,x),{}))}function c(_){return!!_.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||_.indexOf("out/server-main.js")!==-1||_.indexOf("_productName=VSCode")!==-1}function s(_){const C=_.trim().split(`
`),P=[];return C.forEach(k=>{const F=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(k);F&&F.length>=4&&P.push({pid:parseInt(F[1],10),ppid:parseInt(F[2]),cmd:F[3]})}),P}async function w(_,C,P){const k=P.reduce((x,z)=>(x[z.pid]=z,x),{}),F=[];return _.forEach(({socket:x,ip:z,port:N})=>{const M=C[x]?C[x].pid:void 0,W=M?k[M]?.cmd:void 0;M&&W&&!c(W)&&F.push({host:z,port:N,detail:W,pid:M})}),F}function g(_,C,P){const k=new Map,F=s(C);for(const x of _){const z=P.get(x.port);if(z){k.set(x.port,z);continue}const N=F.find(M=>M.cmd.includes(`${x.port}`));if(N){let M=N,W;do W=F.find(X=>X.ppid===M.pid),W&&(M=W);while(W);k.set(x.port,{host:x.ip,port:x.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else k.set(x.port,{host:x.ip,port:x.port,ppid:Number.MAX_VALUE})}return k}let D=class extends n.ExtHostTunnelService{constructor(C,P,k,F){super(C,P,k),this.initData=P,this.signService=F,this._initialCandidates=void 0,this._foundRootPorts=new Map,this._candidateFindingEnabled=!1,b.isLinux&&P.remote.isRemote&&P.remote.authority&&(this._proxy.$setRemoteTunnelService(process.pid),this.setInitialCandidates())}async $registerCandidateFinder(C){if(C&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=C;let P;this._initialCandidates&&(P=this._initialCandidates,await this._proxy.$onFoundNewCandidates(this._initialCandidates));const k=new R.MovingAverage;let F=0;for(;this._candidateFindingEnabled;){const x=new Date().getTime(),z=(await this.findCandidatePorts()).filter(W=>(0,d.isLocalhost)(W.host)||(0,d.isAllInterfaces)(W.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(W=>W.port).join(", ")}`);const N=new Date().getTime()-x;this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${N} ms.`),F++>3&&k.update(N),(!P||JSON.stringify(P)!==JSON.stringify(z))&&(P=z,await this._proxy.$onFoundNewCandidates(P));const M=this.calculateDelay(k.value);this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${M} ms.`),await new Promise(W=>setTimeout(()=>W(),M))}}calculateDelay(C){return Math.max(C*20,2e3)}async setInitialCandidates(){this._initialCandidates=await this.findCandidatePorts(),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this._initialCandidates.map(C=>C.port).join(", ")}`)}async findCandidatePorts(){let C="",P="";try{C=await T.Promises.readFile("/proc/net/tcp","utf8"),P=await T.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const k=t(C,P),F=await new Promise(H=>{(0,h.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(G,Y,ne)=>{H(Y)})}),x=o(F),z=await T.Promises.readdir("/proc"),N=[];for(const H of z)try{const G=Number(H),Y=m.joinPath(y.URI.file("/proc"),H);if((await T.Promises.stat(Y.fsPath)).isDirectory()&&!isNaN(G)){const pe=await T.Promises.readlink(m.joinPath(Y,"cwd").fsPath),le=await T.Promises.readFile(m.joinPath(Y,"cmdline").fsPath,"utf8");N.push({pid:G,cwd:pe,cmd:le})}}catch{}const M=[],W=k.filter(H=>{const G=x[H.socket];return G||M.push(H),G}),X=w(W,x,N);let te;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const H=await new Promise(G=>{(0,h.exec)("ps -F -A -l | grep root",(Y,ne,pe)=>{G(ne)})});this._foundRootPorts=g(M,H,this._foundRootPorts),te=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${te.map(G=>G.port).join(", ")}`)}return X.then(H=>te?H.concat(te):H)}makeManagedTunnelFactory(C){return async P=>{const k=new f.NodeRemoteTunnel({commit:this.initData.commit,quality:this.initData.quality,logService:this.logService,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(x,z,N,M){const W=await C.makeConnection();return v.connect(W,z,N,M)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new S.ManagedRemoteConnection(0),connectionToken:C.connectionToken})}},signService:this.signService},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await k.waitForReady();const F=new L.Emitter;return{localAddress:(0,l.parseAddress)(k.localAddress)??k.localAddress,remoteAddress:{port:k.tunnelRemotePort,host:k.tunnelRemoteHost},onDidDispose:F.event,dispose:()=>{k.dispose(),F.fire(),F.dispose()}}}}};e.NodeExtHostTunnelService=D,e.NodeExtHostTunnelService=D=Ge([Ue(0,i.IExtHostRpcService),Ue(1,a.IExtHostInitDataService),Ue(2,I.ILogService),Ue(3,E.ISignService)],D);class v extends p.ManagedSocket{static connect(C,P,k,F){const x=new A.DisposableStore,z={onClose:x.add(new L.Emitter),onData:x.add(new L.Emitter),onEnd:x.add(new L.Emitter)};x.add(C.onDidReceiveMessage(M=>z.onData.fire(O.VSBuffer.wrap(M)))),x.add(C.onDidEnd(()=>z.onEnd.fire())),x.add(C.onDidClose(M=>z.onClose.fire({type:0,error:M,hadError:!!M})));const N=new v(C,F,z);return N._register(x),(0,p.connectManagedSocket)(N,P,k,F,z)}constructor(C,P,k){super(P,k),this.passing=C}write(C){this.passing.send(C.buffer)}closeRemote(){this.passing.end()}async drain(){await this.passing.drain?.()}}}),define(_e[399],Ce([1,0,85,368,382,381,394,397,398,96,49,97,95,43,71,93,367,326,11,383,61,286,106,111,141]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a,i,n,l,o,t,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(T.IExtHostExtensionService,b.ExtHostExtensionService,0),(0,h.registerSingleton)(i.ILoggerService,a.ExtHostLoggerService,1),(0,h.registerSingleton)(i.ILogService,new t.SyncDescriptor(o.ExtHostLogService,[!1],!0)),(0,h.registerSingleton)(u.ISignService,r.SignService,1),(0,h.registerSingleton)(d.IExtensionStoragePaths,f.ExtensionStoragePaths,0),(0,h.registerSingleton)(y.IExtHostDebugService,A.ExtHostDebugService,0),(0,h.registerSingleton)(I.IExtHostSearch,R.NativeExtHostSearch,0),(0,h.registerSingleton)(p.IExtHostTask,L.ExtHostTask,0),(0,h.registerSingleton)(S.IExtHostTerminalService,O.ExtHostTerminalService,0),(0,h.registerSingleton)(E.IExtHostTunnelService,m.NodeExtHostTunnelService,0),(0,h.registerSingleton)(l.IExtHostVariableResolverProvider,n.NodeExtHostVariableResolverProviderService,0)}),define(_e[410],Ce([1,0,63,411,59,13,83,124,269,115,380,21,32,104,7,136,293,309,385,399]),function(ue,e,h,O,L,A,R,b,m,y,T,I,p,S,E,d,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let g=0;g<process.execArgv.length;g++)process.execArgv[g]==="--inspect-port=0"&&(process.execArgv.splice(g,1),g--)}();const i=O(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const w=globalThis._VSCODE_NODE_MODULES.module,g=w._load;w._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return g.apply(this,arguments)}})();const n=process.exit.bind(process),l=process.on.bind(process);function o(w){process.exit=function(g){if(w)n(g);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const g=new Error("An extension called process.crash() and this was prevented.");console.warn(g.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(g,D){g==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),l(g,D)}}let t=function(w){n()};function u(){const w=(0,a.readExtHostConnection)(process.env);if(w.type===3)return new Promise((g,D)=>{const v=_=>{const C=_[0],P=new R.BufferedEmitter;C.on("message",k=>P.fire(I.VSBuffer.wrap(k.data))),C.on("close",()=>{t("renderer closed the MessagePort")}),C.start(),g({onMessage:P.event,send:k=>C.postMessage(k.buffer)})};process.parentPort.on("message",_=>v(_.ports))});if(w.type===2)return new Promise((g,D)=>{let v=null;const _=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),C=108e5,P=3e5,k=new E.ProcessTimeRunOnceScheduler(()=>t("renderer disconnected for too long (1)"),C),F=new E.ProcessTimeRunOnceScheduler(()=>t("renderer disconnected for too long (2)"),P);process.on("message",(z,N)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){N.setNoDelay(!0);const M=I.VSBuffer.wrap(Buffer.from(z.initialDataChunk,"base64"));let W;if(z.skipWebSocketFrames)W=new b.NodeSocket(N,"extHost-socket");else{const X=I.VSBuffer.wrap(Buffer.from(z.inflateBytes,"base64"));W=new b.WebSocketNodeSocket(new b.NodeSocket(N,"extHost-socket"),z.permessageDeflate,X,!1)}v?(k.cancel(),F.cancel(),v.beginAcceptReconnection(W,M),v.endAcceptReconnection(),v.sendResume()):(clearTimeout(_),v=new R.PersistentProtocol({socket:W,initialChunk:M}),v.sendResume(),v.onDidDispose(()=>t("renderer disconnected")),g(v),v.onSocketClose(()=>{k.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(F.isScheduled())return;k.isScheduled()&&F.schedule()}});const x={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(x)});{const g=w.pipeName;return new Promise((D,v)=>{const _=h.createConnection(g,()=>{_.removeListener("error",v);const C=new R.PersistentProtocol({socket:new b.NodeSocket(_,"extHost-renderer")});C.sendResume(),D(C)});_.once("error",v),_.on("close",()=>{t("renderer closed the socket")})})}}async function r(){const w=await u();return new class{constructor(){this._onMessage=new R.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,w.onMessage(g=>{(0,y.isMessageOfType)(g,2)?(this._terminating=!0,t("received terminate message from renderer")):this._onMessage.fire(g)})}send(g){this._terminating||w.send(g)}async drain(){if(w.drain)return w.drain()}}}function c(w){return new Promise(g=>{const D=w.onMessage(v=>{D.dispose();const _=JSON.parse(v.toString()),C=_.commit,P=m.default.commit;if(C&&P&&C!==P&&n(55),_.parentPid){let k=0;setInterval(function(){try{process.kill(_.parentPid,0),k=0}catch(x){x&&x.code==="EPERM"?(k++,k>=3&&t(`parent process ${_.parentPid} does not exist anymore (3 x EPERM): ${x.message} (code: ${x.code}) (errno: ${x.errno})`)):t(`parent process ${_.parentPid} does not exist anymore: ${x.message} (code: ${x.code}) (errno: ${x.errno})`)}},1e3);let F;try{F=globalThis._VSCODE_NODE_MODULES["native-watchdog"],F.start(_.parentPid)}catch(x){(0,A.onUnexpectedError)(x)}}w.send((0,y.createMessageOfType)(0)),g({protocol:w,initData:_})});w.send((0,y.createMessageOfType)(1))})}async function s(){const w=[];process.on("unhandledRejection",(k,F)=>{w.push(F),setTimeout(()=>{const x=w.indexOf(F);x>=0&&F.catch(z=>{w.splice(x,1),(0,A.isCancellationError)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),k&&(0,A.onUnexpectedError)(k))})},1e3)}),process.on("rejectionHandled",k=>{const F=w.indexOf(k);F>=0&&w.splice(F,1)}),process.on("uncaughtException",function(k){(0,A.isSigPipeError)(k)||(0,A.onUnexpectedError)(k)}),L.mark("code/extHost/willConnectToRenderer");const g=await r();L.mark("code/extHost/didConnectToRenderer");const D=await c(g);L.mark("code/extHost/didWaitForInitData");const{initData:v}=D;o(!!v.environment.extensionTestsLocationURI),v.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,v.environment.skipWorkspaceStorageLock=(0,d.boolean)(i.skipWorkspaceStorageLock,!1);const _=new class{constructor(){this.pid=process.pid}exit(F){n(F)}fsExists(F){return p.Promises.exists(F)}fsRealpath(F){return(0,S.realpath)(F)}};let C=null;v.remote.authority&&i.transformURIs&&(C=(0,f.createURITransformer)(v.remote.authority));const P=new T.ExtensionHostMain(D.protocol,v,_,C);t=k=>P.terminate(k)}s().catch(w=>console.log(w))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a045dcfceda27f896936bfd8cbf524f6a93a2f46/core/vs/workbench/api/node/extensionHostProcess.js.map
